/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/uri","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/path","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/errors","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/platform/log/common/log","vs/base/common/resources","vs/base/common/types","vs/base/common/network","vs/base/common/arrays","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/common/buffer","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagement","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/base/common/json","vs/base/common/process","os","vs/base/parts/ipc/common/ipc","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/base/common/extpath","vs/base/common/map","child_process","vs/platform/request/common/request","vs/base/common/jsonEdit","vs/platform/product/common/product","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/codicons","vs/base/common/stream","fs","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/userDataSync/common/content","vs/base/common/iterator","vs/base/common/date","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/native/electron-sandbox/native","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/normalization","vs/base/common/glob","vs/base/node/decoder","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/extensions/common/extensionValidator","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensions","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/files/common/io","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/console","vs/base/common/marshalling","vs/base/common/mime","vs/base/common/uriIpc","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/common/environmentService","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/checksum/node/checksumService","crypto","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","string_decoder","util","minimist","assert","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain","graceful-fs"],ne=function(K){for(var e=[],D=0,L=K.length;D<L;D++)e[D]=te[K[D]];return e};define(te[90],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function D(L,R){if(!L)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=D}),define(te[63],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const D=Object.prototype.hasOwnProperty;function L(i){const C=[];for(let h in i)D.call(i,h)&&C.push(i[h]);return C}e.values=L;function R(i,C){for(let h in i)if(D.call(i,h)&&C({key:h,value:i[h]},function(){delete i[h]})===!1)return}e.forEach=R;function A(i,C){const h=Object.create(null);for(const v of i){const c=C(v);let S=h[c];S||(S=h[c]=[]),S.push(v)}return h}e.groupBy=A;function k(i){const C=Object.create(null);return i&&i.forEach((h,v)=>{C[v]=h}),C}e.fromMap=k;function P(i,C){const h=[],v=[];for(let c of i)C.has(c)||h.push(c);for(let c of C)i.has(c)||v.push(c);return{removed:h,added:v}}e.diffSets=P;function m(i,C){const h=[],v=[];for(let[c,S]of i)C.has(c)||h.push(S);for(let[c,S]of C)i.has(c)||v.push(S);return{removed:h,added:v}}e.diffMaps=m;class E{constructor(){this.map=new Map}add(C,h){let v=this.map.get(C);v||(v=new Set,this.map.set(C,v)),v.add(h)}delete(C,h){const v=this.map.get(C);!v||(v.delete(h),v.size===0&&this.map.delete(C))}forEach(C,h){const v=this.map.get(C);!v||v.forEach(h)}}e.SetMap=E}),define(te[64],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function D(k){return(P,m,E)=>{let i=null,C=null;if(typeof E.value=="function"?(i="value",C=E.value):typeof E.get=="function"&&(i="get",C=E.get),!C)throw new Error("not supported");E[i]=k(C,m)}}e.createDecorator=D;function L(k,P,m){let E=null,i=null;if(typeof m.value=="function"?(E="value",i=m.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(E="get",i=m.get),!i)throw new Error("not supported");const C=`$memoize$${P}`;m[E]=function(...h){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,h)}),this[C]}}e.memoize=L;function R(k,P,m){return D((E,i)=>{const C=`$debounce$${i}`,h=`$debounce$result$${i}`;return function(...v){this[h]||(this[h]=m?m():void 0),clearTimeout(this[C]),P&&(this[h]=P(this[h],...v),v=[this[h]]),this[C]=setTimeout(()=>{E.apply(this,v),this[h]=m?m():void 0},k)}})}e.debounce=R;function A(k,P,m){return D((E,i)=>{const C=`$throttle$timer$${i}`,h=`$throttle$result$${i}`,v=`$throttle$lastRun$${i}`,c=`$throttle$pending$${i}`;return function(...S){if(this[h]||(this[h]=m?m():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),P&&(this[h]=P(this[h],...S)),this[c])return;const b=this[v]+k;b<=Date.now()?(this[v]=Date.now(),E.apply(this,[this[h]]),this[h]=m?m():void 0):(this[c]=!0,this[C]=setTimeout(()=>{this[c]=!1,this[v]=Date.now(),E.apply(this,[this[h]]),this[h]=m?m():void 0},b-Date.now()))}})}e.throttle=A}),define(te[11],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class D{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(s=>{s(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=D,e.errorHandler=new D;function L(a){e.errorHandler.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=L;function R(a){m(a)||e.errorHandler.onUnexpectedError(a)}e.onUnexpectedError=R;function A(a){m(a)||e.errorHandler.onUnexpectedExternalError(a)}e.onUnexpectedExternalError=A;function k(a){if(a instanceof Error){let{name:t,message:s}=a;const n=a.stacktrace||a.stack;return{$isError:!0,name:t,message:s,stack:n}}return a}e.transformErrorForSerialization=k;const P="Canceled";function m(a){return a instanceof Error&&a.name===P&&a.message===P}e.isPromiseCanceledError=m;class E extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=E;function i(){const a=new Error(P);return a.name=a.message,a}e.canceled=i;function C(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.illegalArgument=C;function h(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.illegalState=h;function v(a){return a?new Error(`readonly property '${a} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=v;function c(a){const t=new Error(`${a} has been disposed`);return t.name="DISPOSED",t}e.disposed=c;function S(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.getErrorMessage=S;class b extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=b;class g extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=g;class I extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=I;function p(a){const t=a;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=p;function o(a,t=Object.create(null)){const s=new Error(a);return t.actions&&(s.actions=t.actions),s}e.createErrorWithActions=o}),define(te[18],ne([0,1,11]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(_,J=0){return _[_.length-(1+J)]}e.tail=L;function R(_){if(_.length===0)throw new Error("Invalid tail call");return[_.slice(0,_.length-1),_[_.length-1]]}e.tail2=R;function A(_,J,Y=(H,W)=>H===W){if(_===J)return!0;if(!_||!J||_.length!==J.length)return!1;for(let H=0,W=_.length;H<W;H++)if(!Y(_[H],J[H]))return!1;return!0}e.equals=A;function k(_,J,Y){let H=0,W=_.length-1;for(;H<=W;){const Z=(H+W)/2|0,X=Y(_[Z],J);if(X<0)H=Z+1;else if(X>0)W=Z-1;else return Z}return-(H+1)}e.binarySearch=k;function P(_,J){let Y=0,H=_.length;if(H===0)return 0;for(;Y<H;){const W=Math.floor((Y+H)/2);J(_[W])?H=W:Y=W+1}return Y}e.findFirstInSorted=P;function m(_,J,Y){if(_=_|0,_>=J.length)throw new TypeError("invalid index");let H=J[Math.floor(J.length*Math.random())],W=[],Z=[],X=[];for(let re of J){const oe=Y(re,H);oe<0?W.push(re):oe>0?Z.push(re):X.push(re)}return _<W.length?m(_,W,Y):_<W.length+X.length?X[0]:m(_-(W.length+X.length),Z,Y)}e.quickSelect=m;function E(_,J){const Y=[];let H;for(const W of _.slice(0).sort(J))!H||J(H[0],W)!==0?(H=[W],Y.push(H)):H.push(W);return Y}e.groupBy=E;function i(_,J,Y){const H=[];function W(re,oe,ue){if(oe===0&&ue.length===0)return;const le=H[H.length-1];le&&le.start+le.deleteCount===re?(le.deleteCount+=oe,le.toInsert.push(...ue)):H.push({start:re,deleteCount:oe,toInsert:ue})}let Z=0,X=0;for(;;){if(Z===_.length){W(Z,0,J.slice(X));break}if(X===J.length){W(Z,_.length-Z,[]);break}const re=_[Z],oe=J[X],ue=Y(re,oe);ue===0?(Z+=1,X+=1):ue<0?(W(Z,1,[]),Z+=1):ue>0&&(W(Z,0,[oe]),X+=1)}return H}e.sortedDiff=i;function C(_,J,Y){const H=i(_,J,Y),W=[],Z=[];for(const X of H)W.push(..._.slice(X.start,X.start+X.deleteCount)),Z.push(...X.toInsert);return{removed:W,added:Z}}e.delta=C;function h(_,J,Y){if(Y===0)return[];const H=_.slice(0,Y).sort(J);return c(_,J,H,Y,_.length),H}e.top=h;function v(_,J,Y,H,W){return Y===0?Promise.resolve([]):new Promise((Z,X)=>{(async()=>{const re=_.length,oe=_.slice(0,Y).sort(J);for(let ue=Y,le=Math.min(Y+H,re);ue<re;ue=le,le=Math.min(le+H,re)){if(ue>Y&&await new Promise(Se=>setTimeout(Se)),W&&W.isCancellationRequested)throw(0,D.canceled)();c(_,J,oe,ue,le)}return oe})().then(Z,X)})}e.topAsync=v;function c(_,J,Y,H,W){for(const Z=Y.length;H<W;H++){const X=_[H];if(J(X,Y[Z-1])<0){Y.pop();const re=P(Y,oe=>J(X,oe)<0);Y.splice(re,0,X)}}}function S(_){return _.filter(J=>!!J)}e.coalesce=S;function b(_){let J=0;for(let Y=0;Y<_.length;Y++)_[Y]&&(_[J]=_[Y],J+=1);_.length=J}e.coalesceInPlace=b;function g(_,J,Y){_.splice(Y,0,_.splice(J,1)[0])}e.move=g;function I(_){return!Array.isArray(_)||_.length===0}e.isFalsyOrEmpty=I;function p(_){return Array.isArray(_)&&_.length>0}e.isNonEmptyArray=p;function o(_,J){if(!J)return _.filter((H,W)=>_.indexOf(H)===W);const Y=Object.create(null);return _.filter(H=>{const W=J(H);return Y[W]?!1:(Y[W]=!0,!0)})}e.distinct=o;function a(_){const J=new Set;return _.filter(Y=>J.has(Y)?!1:(J.add(Y),!0))}e.distinctES6=a;function t(_){const J=Object.create(null);return Y=>{const H=_(Y);return J[H]?!1:(J[H]=!0,!0)}}e.uniqueFilter=t;function s(_,J){for(let Y=_.length-1;Y>=0;Y--){const H=_[Y];if(J(H))return Y}return-1}e.lastIndex=s;function n(_,J){return _.length>0?_[0]:J}e.firstOrDefault=n;function r(_,J,Y=(H,W)=>H===W){let H=0;for(let W=0,Z=Math.min(_.length,J.length);W<Z&&Y(_[W],J[W]);W++)H++;return H}e.commonPrefixLength=r;function u(_){return[].concat(..._)}e.flatten=u;function l(_,J){let Y=typeof J=="number"?_:0;typeof J=="number"?Y=_:(Y=0,J=_);const H=[];if(Y<=J)for(let W=Y;W<J;W++)H.push(W);else for(let W=Y;W>J;W--)H.push(W);return H}e.range=l;function f(_,J,Y){return _.reduce((H,W)=>(H[J(W)]=Y?Y(W):W,H),Object.create(null))}e.index=f;function d(_,J){return _.push(J),()=>w(_,J)}e.insert=d;function w(_,J){const Y=_.indexOf(J);if(Y>-1)return _.splice(Y,1),J}e.remove=w;function T(_,J,Y){const H=_.slice(0,J),W=_.slice(J);return H.concat(Y,W)}e.arrayInsert=T;function O(_,J){let Y;if(typeof J=="number"){let H=J;Y=()=>{const W=Math.sin(H++)*179426549;return W-Math.floor(W)}}else Y=Math.random;for(let H=_.length-1;H>0;H-=1){const W=Math.floor(Y()*(H+1)),Z=_[H];_[H]=_[W],_[W]=Z}}e.shuffle=O;function y(_,J){const Y=_.indexOf(J);Y>-1&&(_.splice(Y,1),_.unshift(J))}e.pushToStart=y;function M(_,J){const Y=_.indexOf(J);Y>-1&&(_.splice(Y,1),_.push(J))}e.pushToEnd=M;function F(_,J){return Array.isArray(_)?_.map(J):J(_)}e.mapArrayOrNot=F;function q(_){return Array.isArray(_)?_:[_]}e.asArray=q;function x(_){return _[Math.floor(Math.random()*_.length)]}e.getRandomElement=x;function U(_,J){for(const Y of _){const H=J(Y);if(H!==void 0)return H}}e.mapFind=U;function $(_,J,Y){const H=z(_,J),W=_.length,Z=Y.length;_.length=W+Z;for(let X=W-1;X>=H;X--)_[X+Z]=_[X];for(let X=0;X<Z;X++)_[X+H]=Y[X]}e.insertInto=$;function B(_,J,Y,H){const W=z(_,J),Z=_.splice(W,Y);return $(_,W,H),Z}e.splice=B;function z(_,J){return J<0?Math.max(J+_.length,0):Math.min(J,_.length)}function j(_,J){let Y=Number.MAX_SAFE_INTEGER,H=0;return _.forEach((W,Z)=>{const X=J(W);X<Y&&(Y=X,H=Z)}),H}e.minIndex=j;function N(_,J){let Y=Number.MIN_SAFE_INTEGER,H=0;return _.forEach((W,Z)=>{const X=J(W);X>Y&&(Y=X,H=Z)}),H}e.maxIndex=N;class G{constructor(J){this.items=J,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(J){let Y=this.firstIdx;for(;Y<this.items.length&&J(this.items[Y]);)Y++;const H=Y===this.firstIdx?null:this.items.slice(this.firstIdx,Y);return this.firstIdx=Y,H}takeFromEndWhile(J){let Y=this.lastIdx;for(;Y>=0&&J(this.items[Y]);)Y--;const H=Y===this.lastIdx?null:this.items.slice(Y+1,this.lastIdx+1);return this.lastIdx=Y,H}}e.ArrayQueue=G}),define(te[65],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function D(L){const R=this;let A=!1,k;return function(){return A||(A=!0,k=L.apply(R,arguments)),k}}e.once=D}),define(te[55],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(L){function R(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}L.is=R;const A=Object.freeze([]);function k(){return A}L.empty=k;function*P(a){yield a}L.single=P;function m(a){return a||A}L.from=m;function E(a){return!a||a[Symbol.iterator]().next().done===!0}L.isEmpty=E;function i(a){return a[Symbol.iterator]().next().value}L.first=i;function C(a,t){for(const s of a)if(t(s))return!0;return!1}L.some=C;function h(a,t){for(const s of a)if(t(s))return s}L.find=h;function*v(a,t){for(const s of a)t(s)&&(yield s)}L.filter=v;function*c(a,t){let s=0;for(const n of a)yield t(n,s++)}L.map=c;function*S(...a){for(const t of a)for(const s of t)yield s}L.concat=S;function*b(a){for(const t of a)for(const s of t)yield s}L.concatNested=b;function g(a,t,s){let n=s;for(const r of a)n=t(n,r);return n}L.reduce=g;function*I(a,t,s=a.length){for(t<0&&(t+=a.length),s<0?s+=a.length:s>a.length&&(s=a.length);t<s;t++)yield a[t]}L.slice=I;function p(a,t=Number.POSITIVE_INFINITY){const s=[];if(t===0)return[s,a];const n=a[Symbol.iterator]();for(let r=0;r<t;r++){const u=n.next();if(u.done)return[s,L.empty()];s.push(u.value)}return[s,{[Symbol.iterator](){return n}}]}L.consume=p;function o(a,t,s=(n,r)=>n===r){const n=a[Symbol.iterator](),r=t[Symbol.iterator]();for(;;){const u=n.next(),l=r.next();if(u.done!==l.done)return!1;if(u.done)return!0;if(!s(u.value,l.value))return!1}}L.equals=o})(D=e.Iterable||(e.Iterable={}))}),define(te[33],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function k(t,s=!1){let n=0,r=t.length,u="",l=0,f=16,d=0;function w(x){let U=0,$=0;for(;U<x;){const B=t.charCodeAt(n);if(B>=48&&B<=57)$=$*16+B-48;else if(B>=65&&B<=70)$=$*16+B-65+10;else if(B>=97&&B<=102)$=$*16+B-97+10;else break;n++,U++}return U<x&&($=-1),$}function T(x){n=x,u="",l=0,f=16,d=0}function O(){const x=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&E(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&E(t.charCodeAt(n)))for(n++;n<t.length&&E(t.charCodeAt(n));)n++;else return d=3,t.substring(x,n);let U=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&E(t.charCodeAt(n))){for(n++;n<t.length&&E(t.charCodeAt(n));)n++;U=n}else d=3;return t.substring(x,U)}function y(){let x="",U=n;for(;;){if(n>=r){x+=t.substring(U,n),d=2;break}const $=t.charCodeAt(n);if($===34){x+=t.substring(U,n),n++;break}if($===92){if(x+=t.substring(U,n),n++,n>=r){d=2;break}switch(t.charCodeAt(n++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:const z=w(4);z>=0?x+=String.fromCharCode(z):d=4;break;default:d=5}U=n;continue}if($>=0&&$<=31)if(m($)){x+=t.substring(U,n),d=2;break}else d=6;n++}return x}function M(){if(u="",d=0,l=n,n>=r)return l=r,f=17;let x=t.charCodeAt(n);if(P(x)){do n++,u+=String.fromCharCode(x),x=t.charCodeAt(n);while(P(x));return f=15}if(m(x))return n++,u+=String.fromCharCode(x),x===13&&t.charCodeAt(n)===10&&(n++,u+=`
`),f=14;switch(x){case 123:return n++,f=1;case 125:return n++,f=2;case 91:return n++,f=3;case 93:return n++,f=4;case 58:return n++,f=6;case 44:return n++,f=5;case 34:return n++,u=y(),f=10;case 47:const U=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<r&&!m(t.charCodeAt(n));)n++;return u=t.substring(U,n),f=12}if(t.charCodeAt(n+1)===42){n+=2;const $=r-1;let B=!1;for(;n<$;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,B=!0;break}n++}return B||(n++,d=1),u=t.substring(U,n),f=13}return u+=String.fromCharCode(x),n++,f=16;case 45:if(u+=String.fromCharCode(x),n++,n===r||!E(t.charCodeAt(n)))return f=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=O(),f=11;default:for(;n<r&&F(x);)n++,x=t.charCodeAt(n);if(l!==n){switch(u=t.substring(l,n),u){case"true":return f=8;case"false":return f=9;case"null":return f=7}return f=16}return u+=String.fromCharCode(x),n++,f=16}}function F(x){if(P(x)||m(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function q(){let x;do x=M();while(x>=12&&x<=15);return x}return{setPosition:T,getPosition:()=>n,scan:s?q:M,getToken:()=>f,getTokenValue:()=>u,getTokenOffset:()=>l,getTokenLength:()=>n-l,getTokenError:()=>d}}e.createScanner=k;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function m(t){return t===10||t===13||t===8232||t===8233}function E(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function C(t,s){const n=[],r=new Object;let u;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let f=!1;function d(w,T,O,y){l.value=w,l.offset=T,l.length=O,l.type=y,l.colonOffset=void 0,u=l}try{p(t,{onObjectBegin:(w,T)=>{if(s<=w)throw r;u=void 0,f=s>w,n.push("")},onObjectProperty:(w,T,O)=>{if(s<T||(d(w,T,O,"property"),n[n.length-1]=w,s<=T+O))throw r},onObjectEnd:(w,T)=>{if(s<=w)throw r;u=void 0,n.pop()},onArrayBegin:(w,T)=>{if(s<=w)throw r;u=void 0,n.push(0)},onArrayEnd:(w,T)=>{if(s<=w)throw r;u=void 0,n.pop()},onLiteralValue:(w,T,O)=>{if(s<T||(d(w,T,O,a(w)),s<=T+O))throw r},onSeparator:(w,T,O)=>{if(s<=T)throw r;if(w===":"&&u&&u.type==="property")u.colonOffset=T,f=!1,u=void 0;else if(w===","){const y=n[n.length-1];typeof y=="number"?n[n.length-1]=y+1:(f=!0,n[n.length-1]=""),u=void 0}}})}catch(w){if(w!==r)throw w}return{path:n,previousNode:u,isAtPropertyKey:f,matches:w=>{let T=0;for(let O=0;T<w.length&&O<n.length;O++)if(w[T]===n[O]||w[T]==="*")T++;else if(w[T]!=="**")return!1;return T===w.length}}}e.getLocation=C;function h(t,s=[],n=A.DEFAULT){let r=null,u=[];const l=[];function f(w){Array.isArray(u)?u.push(w):r!==null&&(u[r]=w)}return p(t,{onObjectBegin:()=>{const w={};f(w),l.push(u),u=w,r=null},onObjectProperty:w=>{r=w},onObjectEnd:()=>{u=l.pop()},onArrayBegin:()=>{const w=[];f(w),l.push(u),u=w,r=null},onArrayEnd:()=>{u=l.pop()},onLiteralValue:f,onError:(w,T,O)=>{s.push({error:w,offset:T,length:O})}},n),u[0]}e.parse=h;function v(t,s=[],n=A.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(w){r.type==="property"&&(r.length=w-r.offset,r=r.parent)}function l(w){return r.children.push(w),w}p(t,{onObjectBegin:w=>{r=l({type:"object",offset:w,length:-1,parent:r,children:[]})},onObjectProperty:(w,T,O)=>{r=l({type:"property",offset:T,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:w,offset:T,length:O,parent:r})},onObjectEnd:(w,T)=>{r.length=w+T-r.offset,r=r.parent,u(w+T)},onArrayBegin:(w,T)=>{r=l({type:"array",offset:w,length:-1,parent:r,children:[]})},onArrayEnd:(w,T)=>{r.length=w+T-r.offset,r=r.parent,u(w+T)},onLiteralValue:(w,T,O)=>{l({type:a(w),offset:T,length:O,parent:r,value:w}),u(T+O)},onSeparator:(w,T,O)=>{r.type==="property"&&(w===":"?r.colonOffset=T:w===","&&u(T))},onError:(w,T,O)=>{s.push({error:w,offset:T,length:O})}},n);const d=r.children[0];return d&&delete d.parent,d}e.parseTree=v;function c(t,s){if(!t)return;let n=t;for(let r of s)if(typeof r=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let u=!1;for(const l of n.children)if(Array.isArray(l.children)&&l.children[0].value===r){n=l.children[1],u=!0;break}if(!u)return}else{const u=r;if(n.type!=="array"||u<0||!Array.isArray(n.children)||u>=n.children.length)return;n=n.children[u]}return n}e.findNodeAtLocation=c;function S(t){if(!t.parent||!t.parent.children)return[];const s=S(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;s.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&s.push(n)}return s}e.getNodePath=S;function b(t){switch(t.type){case"array":return t.children.map(b);case"object":const s=Object.create(null);for(let n of t.children){const r=n.children[1];r&&(s[n.children[0].value]=b(r))}return s;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=b;function g(t,s,n=!1){return s>=t.offset&&s<t.offset+t.length||n&&s===t.offset+t.length}e.contains=g;function I(t,s,n=!1){if(g(t,s,n)){const r=t.children;if(Array.isArray(r))for(let u=0;u<r.length&&r[u].offset<=s;u++){const l=I(r[u],s,n);if(l)return l}return t}}e.findNodeAtOffset=I;function p(t,s,n=A.DEFAULT){const r=k(t,!1);function u(Y){return Y?()=>Y(r.getTokenOffset(),r.getTokenLength()):()=>!0}function l(Y){return Y?H=>Y(H,r.getTokenOffset(),r.getTokenLength()):()=>!0}const f=u(s.onObjectBegin),d=l(s.onObjectProperty),w=u(s.onObjectEnd),T=u(s.onArrayBegin),O=u(s.onArrayEnd),y=l(s.onLiteralValue),M=l(s.onSeparator),F=u(s.onComment),q=l(s.onError),x=n&&n.disallowComments,U=n&&n.allowTrailingComma;function $(){for(;;){const Y=r.scan();switch(r.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:x||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(Y){case 12:case 13:x?B(10):F();break;case 16:B(1);break;case 15:case 14:break;default:return Y}}}function B(Y,H=[],W=[]){if(q(Y),H.length+W.length>0){let Z=r.getToken();for(;Z!==17;){if(H.indexOf(Z)!==-1){$();break}else if(W.indexOf(Z)!==-1)break;Z=$()}}}function z(Y){const H=r.getTokenValue();return Y?y(H):d(H),$(),!0}function j(){switch(r.getToken()){case 11:let Y=0;try{Y=JSON.parse(r.getTokenValue()),typeof Y!="number"&&(B(2),Y=0)}catch(H){B(2)}y(Y);break;case 7:y(null);break;case 8:y(!0);break;case 9:y(!1);break;default:return!1}return $(),!0}function N(){return r.getToken()!==10?(B(3,[],[2,5]),!1):(z(!1),r.getToken()===6?(M(":"),$(),J()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function G(){f(),$();let Y=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(Y||B(4,[],[]),M(","),$(),r.getToken()===2&&U)break}else Y&&B(6,[],[]);N()||B(4,[],[2,5]),Y=!0}return w(),r.getToken()!==2?B(7,[2],[]):$(),!0}function _(){T(),$();let Y=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(Y||B(4,[],[]),M(","),$(),r.getToken()===4&&U)break}else Y&&B(6,[],[]);J()||B(4,[],[4,5]),Y=!0}return O(),r.getToken()!==4?B(8,[4],[]):$(),!0}function J(){switch(r.getToken()){case 3:return _();case 1:return G();case 10:return z(!0);default:return j()}}return $(),r.getToken()===17?n.allowEmptyContent?!0:(B(4,[],[]),!1):J()?(r.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}e.visit=p;function o(t,s){let n=k(t),r=[],u,l=0,f;do switch(f=n.getPosition(),u=n.scan(),u){case 12:case 13:case 17:l!==f&&r.push(t.substring(l,f)),s!==void 0&&r.push(n.getTokenValue().replace(/[^\r\n]/g,s)),l=n.getPosition();break}while(u!==17);return r.join("")}e.stripComments=o;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=a}),define(te[48],ne([0,1,33]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(m,E,i){let C,h,v,c,S;if(E){for(c=E.offset,S=c+E.length,v=c;v>0&&!P(m,v-1);)v--;let l=S;for(;l<m.length&&!P(m,l);)l++;h=m.substring(v,l),C=A(h,i)}else h=m,C=0,v=0,c=0,S=m.length;const b=k(i,m);let g=!1,I=0,p;i.insertSpaces?p=R(" ",i.tabSize||4):p="	";const o=(0,D.createScanner)(h,!1);let a=!1;function t(){return b+R(p,C+I)}function s(){let l=o.scan();for(g=!1;l===15||l===14;)g=g||l===14,l=o.scan();return a=l===16||o.getTokenError()!==0,l}const n=[];function r(l,f,d){!a&&f<S&&d>c&&m.substring(f,d)!==l&&n.push({offset:f,length:d-f,content:l})}let u=s();if(u!==17){const l=o.getTokenOffset()+v,f=R(p,C);r(f,v,l)}for(;u!==17;){let l=o.getTokenOffset()+o.getTokenLength()+v,f=s(),d="";for(;!g&&(f===12||f===13);){const T=o.getTokenOffset()+v;r(" ",l,T),l=o.getTokenOffset()+o.getTokenLength()+v,d=f===12?t():"",f=s()}if(f===2)u!==1&&(I--,d=t());else if(f===4)u!==3&&(I--,d=t());else{switch(u){case 3:case 1:I++,d=t();break;case 5:case 12:d=t();break;case 13:g?d=t():d=" ";break;case 6:d=" ";break;case 10:if(f===6){d="";break}case 7:case 8:case 9:case 11:case 2:case 4:f===12||f===13?d=" ":f!==5&&f!==17&&(a=!0);break;case 16:a=!0;break}g&&(f===12||f===13)&&(d=t())}const w=o.getTokenOffset()+v;r(d,l,w),u=f}return n}e.format=L;function R(m,E){let i="";for(let C=0;C<E;C++)i+=m;return i}function A(m,E){let i=0,C=0;const h=E.tabSize||4;for(;i<m.length;){const v=m.charAt(i);if(v===" ")C++;else if(v==="	")C+=h;else break;i++}return Math.floor(C/h)}function k(m,E){for(let i=0;i<E.length;i++){const C=E.charAt(i);if(C==="\r")return i+1<E.length&&E.charAt(i+1)===`
`?`\r
`:"\r";if(C===`
`)return`
`}return m&&m.eol||`
`}e.getEOL=k;function P(m,E){return`\r
`.indexOf(m.charAt(E))!==-1}e.isEOL=P}),define(te[43],ne([0,1,33,48]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function R(E,i,C){return A(E,i,void 0,C)}e.removeProperty=R;function A(E,i,C,h,v){const c=i.slice(),S=[],b=(0,D.parseTree)(E,S);let g,I;for(;c.length>0&&(I=c.pop(),g=(0,D.findNodeAtLocation)(b,c),g===void 0&&C!==void 0);)typeof I=="string"?C={[I]:C}:C=[C];if(g)if(g.type==="object"&&typeof I=="string"&&Array.isArray(g.children)){const p=(0,D.findNodeAtLocation)(g,[I]);if(p!==void 0)if(C===void 0){if(!p.parent)throw new Error("Malformed AST");const o=g.children.indexOf(p.parent);let a,t=p.parent.offset+p.parent.length;if(o>0){const s=g.children[o-1];a=s.offset+s.length}else a=g.offset+1,g.children.length>1&&(t=g.children[1].offset);return k(E,{offset:a,length:t-a,content:""},h)}else return k(E,{offset:p.offset,length:p.length,content:JSON.stringify(C)},h);else{if(C===void 0)return[];const o=`${JSON.stringify(I)}: ${JSON.stringify(C)}`,a=v?v(g.children.map(s=>s.children[0].value)):g.children.length;let t;if(a>0){const s=g.children[a-1];t={offset:s.offset+s.length,length:0,content:","+o}}else g.children.length===0?t={offset:g.offset+1,length:0,content:o}:t={offset:g.offset+1,length:0,content:o+","};return k(E,t,h)}}else if(g.type==="array"&&typeof I=="number"&&Array.isArray(g.children))if(C!==void 0){const p=`${JSON.stringify(C)}`;let o;if(g.children.length===0||I===0)o={offset:g.offset+1,length:0,content:g.children.length===0?p:p+","};else{const a=I===-1||I>g.children.length?g.children.length:I,t=g.children[a-1];o={offset:t.offset+t.length,length:0,content:","+p}}return k(E,o,h)}else{const p=I,o=g.children[p];let a;if(g.children.length===1)a={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===p){const t=g.children[p-1],s=t.offset+t.length,n=g.offset+g.length;a={offset:s,length:n-2-s,content:""}}else a={offset:o.offset,length:g.children[p+1].offset-o.offset,content:""};return k(E,a,h)}else throw new Error(`Can not add ${typeof I!="number"?"index":"property"} to parent of type ${g.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return k(E,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(C)},h)}}e.setProperty=A;function k(E,i,C){let h=P(E,i),v=i.offset,c=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;v>0&&!(0,L.isEOL)(h,v-1);)v--;for(;c<h.length&&!(0,L.isEOL)(h,c);)c++}const S=(0,L.format)(h,{offset:v,length:c-v},C);for(let g=S.length-1;g>=0;g--){const I=S[g];h=P(h,I),v=Math.min(v,I.offset),c=Math.max(c,I.offset+I.length),c+=I.content.length-I.length}const b=E.length-(h.length-c)-v;return[{offset:v,length:b,content:h.substring(v,c)}]}e.withFormatting=k;function P(E,i){return E.substring(0,i.offset)+i.content+E.substring(i.offset+i.length)}e.applyEdit=P;function m(E,i){let C=i.slice(0).sort((v,c)=>{const S=v.offset-c.offset;return S===0?v.length-c.length:S}),h=E.length;for(let v=C.length-1;v>=0;v--){let c=C[v];if(c.offset+c.length<=h)E=P(E,c);else throw new Error("Overlapping edit");h=c.offset}return E}e.applyEdits=m}),define(te[2],ne([0,1,65,55]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const R=!1;let A=null;function k(n){A=n}if(e.setDisposableTracker=k,R){const n="__is_disposable_tracked__";k(new class{trackDisposable(r){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[n]||console.log(u)},3e3)}setParent(r,u){if(r&&r!==I.None)try{r[n]=!0}catch{}}markAsDisposed(r){if(r&&r!==I.None)try{r[n]=!0}catch{}}markAsSingleton(r){}})}function P(n){return A?.trackDisposable(n),n}function m(n){A?.markAsDisposed(n)}function E(n,r){A?.setParent(n,r)}function i(n,r){if(!!A)for(const u of n)A.setParent(u,r)}function C(n){return A?.markAsSingleton(n),n}e.markAsSingleton=C;class h extends Error{constructor(r){super(`Encountered errors while disposing of store. Errors: [${r.join(", ")}]`);this.errors=r}}e.MultiDisposeError=h;function v(n){return typeof n.dispose=="function"&&n.dispose.length===0}e.isDisposable=v;function c(n){if(L.Iterable.is(n)){let r=[];for(const u of n)if(u)try{u.dispose()}catch(l){r.push(l)}if(r.length===1)throw r[0];if(r.length>1)throw new h(r);return Array.isArray(n)?[]:n}else if(n)return n.dispose(),n}e.dispose=c;function S(...n){const r=b(()=>c(n));return i(n,r),r}e.combinedDisposable=S;function b(n){const r=P({dispose:(0,D.once)(()=>{m(r),n()})});return r}e.toDisposable=b;class g{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(m(this),this._isDisposed=!0,this.clear())}clear(){try{c(this._toDispose.values())}finally{this._toDispose.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return E(r,this),this._isDisposed?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(r),r}}e.DisposableStore=g,g.DISABLE_DISPOSED_WARNING=!1;class I{constructor(){this._store=new g,P(this),E(this._store,this)}dispose(){m(this),this._store.dispose()}_register(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(r)}}e.Disposable=I,I.None=Object.freeze({dispose(){}});class p{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(r){this._isDisposed||r===this._value||(this._value?.dispose(),r&&E(r,this),this._value=r)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,m(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const r=this._value;return this._value=void 0,r&&E(r,null),r}}e.MutableDisposable=p;class o{constructor(r){this._disposable=r,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=o;class a{constructor(){this.references=new Map}acquire(r,...u){let l=this.references.get(r);l||(l={counter:0,object:this.createReferencedObject(r,...u)},this.references.set(r,l));const{object:f}=l,d=(0,D.once)(()=>{--l.counter==0&&(this.destroyReferencedObject(r,l.object),this.references.delete(r))});return l.counter++,{object:f,dispose:d}}}e.ReferenceCollection=a;class t{constructor(r){this.referenceCollection=r}async acquire(r,...u){const l=this.referenceCollection.acquire(r,...u);try{return{object:await l.object,dispose:()=>l.dispose()}}catch(f){throw l.dispose(),f}}}e.AsyncReferenceCollection=t;class s{constructor(r){this.object=r}dispose(){}}e.ImmortalReference=s}),define(te[91],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class D{constructor(A){this.element=A,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class L{constructor(){this._first=D.Undefined,this._last=D.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===D.Undefined}clear(){let A=this._first;for(;A!==D.Undefined;){const k=A.next;A.prev=D.Undefined,A.next=D.Undefined,A=k}this._first=D.Undefined,this._last=D.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,k){const P=new D(A);if(this._first===D.Undefined)this._first=P,this._last=P;else if(k){const E=this._last;this._last=P,P.prev=E,E.next=P}else{const E=this._first;this._first=P,P.next=E,E.prev=P}this._size+=1;let m=!1;return()=>{m||(m=!0,this._remove(P))}}shift(){if(this._first!==D.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==D.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==D.Undefined&&A.next!==D.Undefined){const k=A.prev;k.next=A.next,A.next.prev=k}else A.prev===D.Undefined&&A.next===D.Undefined?(this._first=D.Undefined,this._last=D.Undefined):A.next===D.Undefined?(this._last=this._last.prev,this._last.next=D.Undefined):A.prev===D.Undefined&&(this._first=this._first.next,this._first.prev=D.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==D.Undefined;)yield A.element,A=A.next}}e.LinkedList=L}),function(){function K(R){const A=[];typeof R=="number"&&A.push("code/timeOrigin",R);function k(m){A.push(m,Date.now())}function P(){const m=[];for(let E=0;E<A.length;E+=2)m.push({name:A[E],startTime:A[E+1]});return m}return{mark:k,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const k of performance.getEntriesByType("mark"))A.push({name:k.name,startTime:Math.round(R+k.startTime)});return A}};if(typeof process=="object"){const R=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function D(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=D(L))}(),define(te[4],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const D="en";let L=!1,R=!1,A=!1,k=!1,P=!1,m=!1,E=!1,i,C=D,h,v;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let c;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?c=e.globals.vscode.process:typeof process!="undefined"&&(c=process);const S=typeof c?.versions?.electron=="string"&&c.type==="renderer";if(e.isElectronSandboxed=S&&c?.sandboxed,typeof navigator=="object"&&!S)v=navigator.userAgent,L=v.indexOf("Windows")>=0,R=v.indexOf("Macintosh")>=0,E=(v.indexOf("Macintosh")>=0||v.indexOf("iPad")>=0||v.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=v.indexOf("Linux")>=0,m=!0,i=navigator.language,C=i;else if(typeof c=="object"){L=c.platform==="win32",R=c.platform==="darwin",A=c.platform==="linux",k=A&&!!c.env.SNAP&&!!c.env.SNAP_REVISION,i=D,C=D;const n=c.env.VSCODE_NLS_CONFIG;if(n)try{const r=JSON.parse(n),u=r.availableLanguages["*"];i=r.locale,C=u||D,h=r._translationsConfigFile}catch(r){}P=!0}else console.error("Unable to resolve platform.");var b;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(b=e.Platform||(e.Platform={}));function g(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=g;let I=0;R?I=1:L?I=3:A&&(I=2),e.isWindows=L,e.isMacintosh=R,e.isLinux=A,e.isLinuxSnap=k,e.isNative=P,e.isWeb=m,e.isIOS=E,e.platform=I,e.userAgent=v,e.language=C;var p;(function(n){function r(){return e.language}n.value=r;function u(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=u;function l(){return e.language==="en"}n.isDefault=l})(p=e.Language||(e.Language={})),e.locale=i,e.translationsConfigFile=h,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let u=[];e.globals.addEventListener("message",f=>{if(f.data&&f.data.vscodeSetImmediateId)for(let d=0,w=u.length;d<w;d++){const T=u[d];if(T.id===f.data.vscodeSetImmediateId){u.splice(d,1),T.callback();return}}});let l=0;return f=>{const d=++l;u.push({id:d,callback:f}),e.globals.postMessage({vscodeSetImmediateId:d},"*")}}if(typeof c?.nextTick=="function")return c.nextTick.bind(c);const r=Promise.resolve();return u=>r.then(u)}();var o;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||E?2:L?1:3;let a=!0,t=!1;function s(){if(!t){t=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,a=new Uint16Array(n.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=s}),define(te[34],ne([0,1,4]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof D.globals.vscode!="undefined"&&typeof D.globals.vscode.process!="undefined"){const R=D.globals.vscode.process;L={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()},nextTick(A){return(0,D.setImmediate)(A)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(R){return process.nextTick(R)}}:L={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},nextTick(R){return(0,D.setImmediate)(R)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick,e.arch=L.arch}),define(te[8],ne([0,1,34]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,R=97,A=90,k=122,P=46,m=47,E=92,i=58,C=63;class h extends Error{constructor(o,a,t){let s;typeof a=="string"&&a.indexOf("not ")===0?(s="must not be",a=a.replace(/^not /,"")):s="must be";const n=o.indexOf(".")!==-1?"property":"argument";let r=`The "${o}" ${n} ${s} of type ${a}`;r+=`. Received type ${typeof t}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function v(p,o){if(typeof p!="string")throw new h(o,"string",p)}function c(p){return p===m||p===E}function S(p){return p===m}function b(p){return p>=L&&p<=A||p>=R&&p<=k}function g(p,o,a,t){let s="",n=0,r=-1,u=0,l=0;for(let f=0;f<=p.length;++f){if(f<p.length)l=p.charCodeAt(f);else{if(t(l))break;l=m}if(t(l)){if(!(r===f-1||u===1))if(u===2){if(s.length<2||n!==2||s.charCodeAt(s.length-1)!==P||s.charCodeAt(s.length-2)!==P){if(s.length>2){const d=s.lastIndexOf(a);d===-1?(s="",n=0):(s=s.slice(0,d),n=s.length-1-s.lastIndexOf(a)),r=f,u=0;continue}else if(s.length!==0){s="",n=0,r=f,u=0;continue}}o&&(s+=s.length>0?`${a}..`:"..",n=2)}else s.length>0?s+=`${a}${p.slice(r+1,f)}`:s=p.slice(r+1,f),n=f-r-1;r=f,u=0}else l===P&&u!==-1?++u:u=-1}return s}function I(p,o){if(o===null||typeof o!="object")throw new h("pathObject","Object",o);const a=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return a?a===o.root?`${a}${t}`:`${a}${p}${t}`:t}e.win32={resolve(...p){let o="",a="",t=!1;for(let s=p.length-1;s>=-1;s--){let n;if(s>=0){if(n=p[s],v(n,"path"),n.length===0)continue}else o.length===0?n=D.cwd():(n=D.env[`=${o}`]||D.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==o.toLowerCase()&&n.charCodeAt(2)===E)&&(n=`${o}\\`));const r=n.length;let u=0,l="",f=!1;const d=n.charCodeAt(0);if(r===1)c(d)&&(u=1,f=!0);else if(c(d))if(f=!0,c(n.charCodeAt(1))){let w=2,T=w;for(;w<r&&!c(n.charCodeAt(w));)w++;if(w<r&&w!==T){const O=n.slice(T,w);for(T=w;w<r&&c(n.charCodeAt(w));)w++;if(w<r&&w!==T){for(T=w;w<r&&!c(n.charCodeAt(w));)w++;(w===r||w!==T)&&(l=`\\\\${O}\\${n.slice(T,w)}`,u=w)}}}else u=1;else b(d)&&n.charCodeAt(1)===i&&(l=n.slice(0,2),u=2,r>2&&c(n.charCodeAt(2))&&(f=!0,u=3));if(l.length>0)if(o.length>0){if(l.toLowerCase()!==o.toLowerCase())continue}else o=l;if(t){if(o.length>0)break}else if(a=`${n.slice(u)}\\${a}`,t=f,f&&o.length>0)break}return a=g(a,!t,"\\",c),t?`${o}\\${a}`:`${o}${a}`||"."},normalize(p){v(p,"path");const o=p.length;if(o===0)return".";let a=0,t,s=!1;const n=p.charCodeAt(0);if(o===1)return S(n)?"\\":p;if(c(n))if(s=!0,c(p.charCodeAt(1))){let u=2,l=u;for(;u<o&&!c(p.charCodeAt(u));)u++;if(u<o&&u!==l){const f=p.slice(l,u);for(l=u;u<o&&c(p.charCodeAt(u));)u++;if(u<o&&u!==l){for(l=u;u<o&&!c(p.charCodeAt(u));)u++;if(u===o)return`\\\\${f}\\${p.slice(l)}\\`;u!==l&&(t=`\\\\${f}\\${p.slice(l,u)}`,a=u)}}}else a=1;else b(n)&&p.charCodeAt(1)===i&&(t=p.slice(0,2),a=2,o>2&&c(p.charCodeAt(2))&&(s=!0,a=3));let r=a<o?g(p.slice(a),!s,"\\",c):"";return r.length===0&&!s&&(r="."),r.length>0&&c(p.charCodeAt(o-1))&&(r+="\\"),t===void 0?s?`\\${r}`:r:s?`${t}\\${r}`:`${t}${r}`},isAbsolute(p){v(p,"path");const o=p.length;if(o===0)return!1;const a=p.charCodeAt(0);return c(a)||o>2&&b(a)&&p.charCodeAt(1)===i&&c(p.charCodeAt(2))},join(...p){if(p.length===0)return".";let o,a;for(let n=0;n<p.length;++n){const r=p[n];v(r,"path"),r.length>0&&(o===void 0?o=a=r:o+=`\\${r}`)}if(o===void 0)return".";let t=!0,s=0;if(typeof a=="string"&&c(a.charCodeAt(0))){++s;const n=a.length;n>1&&c(a.charCodeAt(1))&&(++s,n>2&&(c(a.charCodeAt(2))?++s:t=!1))}if(t){for(;s<o.length&&c(o.charCodeAt(s));)s++;s>=2&&(o=`\\${o.slice(s)}`)}return e.win32.normalize(o)},relative(p,o){if(v(p,"from"),v(o,"to"),p===o)return"";const a=e.win32.resolve(p),t=e.win32.resolve(o);if(a===t||(p=a.toLowerCase(),o=t.toLowerCase(),p===o))return"";let s=0;for(;s<p.length&&p.charCodeAt(s)===E;)s++;let n=p.length;for(;n-1>s&&p.charCodeAt(n-1)===E;)n--;const r=n-s;let u=0;for(;u<o.length&&o.charCodeAt(u)===E;)u++;let l=o.length;for(;l-1>u&&o.charCodeAt(l-1)===E;)l--;const f=l-u,d=r<f?r:f;let w=-1,T=0;for(;T<d;T++){const y=p.charCodeAt(s+T);if(y!==o.charCodeAt(u+T))break;y===E&&(w=T)}if(T!==d){if(w===-1)return t}else{if(f>d){if(o.charCodeAt(u+T)===E)return t.slice(u+T+1);if(T===2)return t.slice(u+T)}r>d&&(p.charCodeAt(s+T)===E?w=T:T===2&&(w=3)),w===-1&&(w=0)}let O="";for(T=s+w+1;T<=n;++T)(T===n||p.charCodeAt(T)===E)&&(O+=O.length===0?"..":"\\..");return u+=w,O.length>0?`${O}${t.slice(u,l)}`:(t.charCodeAt(u)===E&&++u,t.slice(u,l))},toNamespacedPath(p){if(typeof p!="string")return p;if(p.length===0)return"";const o=e.win32.resolve(p);if(o.length<=2)return p;if(o.charCodeAt(0)===E){if(o.charCodeAt(1)===E){const a=o.charCodeAt(2);if(a!==C&&a!==P)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(b(o.charCodeAt(0))&&o.charCodeAt(1)===i&&o.charCodeAt(2)===E)return`\\\\?\\${o}`;return p},dirname(p){v(p,"path");const o=p.length;if(o===0)return".";let a=-1,t=0;const s=p.charCodeAt(0);if(o===1)return c(s)?p:".";if(c(s)){if(a=t=1,c(p.charCodeAt(1))){let u=2,l=u;for(;u<o&&!c(p.charCodeAt(u));)u++;if(u<o&&u!==l){for(l=u;u<o&&c(p.charCodeAt(u));)u++;if(u<o&&u!==l){for(l=u;u<o&&!c(p.charCodeAt(u));)u++;if(u===o)return p;u!==l&&(a=t=u+1)}}}}else b(s)&&p.charCodeAt(1)===i&&(a=o>2&&c(p.charCodeAt(2))?3:2,t=a);let n=-1,r=!0;for(let u=o-1;u>=t;--u)if(c(p.charCodeAt(u))){if(!r){n=u;break}}else r=!1;if(n===-1){if(a===-1)return".";n=a}return p.slice(0,n)},basename(p,o){o!==void 0&&v(o,"ext"),v(p,"path");let a=0,t=-1,s=!0,n;if(p.length>=2&&b(p.charCodeAt(0))&&p.charCodeAt(1)===i&&(a=2),o!==void 0&&o.length>0&&o.length<=p.length){if(o===p)return"";let r=o.length-1,u=-1;for(n=p.length-1;n>=a;--n){const l=p.charCodeAt(n);if(c(l)){if(!s){a=n+1;break}}else u===-1&&(s=!1,u=n+1),r>=0&&(l===o.charCodeAt(r)?--r==-1&&(t=n):(r=-1,t=u))}return a===t?t=u:t===-1&&(t=p.length),p.slice(a,t)}for(n=p.length-1;n>=a;--n)if(c(p.charCodeAt(n))){if(!s){a=n+1;break}}else t===-1&&(s=!1,t=n+1);return t===-1?"":p.slice(a,t)},extname(p){v(p,"path");let o=0,a=-1,t=0,s=-1,n=!0,r=0;p.length>=2&&p.charCodeAt(1)===i&&b(p.charCodeAt(0))&&(o=t=2);for(let u=p.length-1;u>=o;--u){const l=p.charCodeAt(u);if(c(l)){if(!n){t=u+1;break}continue}s===-1&&(n=!1,s=u+1),l===P?a===-1?a=u:r!==1&&(r=1):a!==-1&&(r=-1)}return a===-1||s===-1||r===0||r===1&&a===s-1&&a===t+1?"":p.slice(a,s)},format:I.bind(null,"\\"),parse(p){v(p,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(p.length===0)return o;const a=p.length;let t=0,s=p.charCodeAt(0);if(a===1)return c(s)?(o.root=o.dir=p,o):(o.base=o.name=p,o);if(c(s)){if(t=1,c(p.charCodeAt(1))){let w=2,T=w;for(;w<a&&!c(p.charCodeAt(w));)w++;if(w<a&&w!==T){for(T=w;w<a&&c(p.charCodeAt(w));)w++;if(w<a&&w!==T){for(T=w;w<a&&!c(p.charCodeAt(w));)w++;w===a?t=w:w!==T&&(t=w+1)}}}}else if(b(s)&&p.charCodeAt(1)===i){if(a<=2)return o.root=o.dir=p,o;if(t=2,c(p.charCodeAt(2))){if(a===3)return o.root=o.dir=p,o;t=3}}t>0&&(o.root=p.slice(0,t));let n=-1,r=t,u=-1,l=!0,f=p.length-1,d=0;for(;f>=t;--f){if(s=p.charCodeAt(f),c(s)){if(!l){r=f+1;break}continue}u===-1&&(l=!1,u=f+1),s===P?n===-1?n=f:d!==1&&(d=1):n!==-1&&(d=-1)}return u!==-1&&(n===-1||d===0||d===1&&n===u-1&&n===r+1?o.base=o.name=p.slice(r,u):(o.name=p.slice(r,n),o.base=p.slice(r,u),o.ext=p.slice(n,u))),r>0&&r!==t?o.dir=p.slice(0,r-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...p){let o="",a=!1;for(let t=p.length-1;t>=-1&&!a;t--){const s=t>=0?p[t]:D.cwd();v(s,"path"),s.length!==0&&(o=`${s}/${o}`,a=s.charCodeAt(0)===m)}return o=g(o,!a,"/",S),a?`/${o}`:o.length>0?o:"."},normalize(p){if(v(p,"path"),p.length===0)return".";const o=p.charCodeAt(0)===m,a=p.charCodeAt(p.length-1)===m;return p=g(p,!o,"/",S),p.length===0?o?"/":a?"./":".":(a&&(p+="/"),o?`/${p}`:p)},isAbsolute(p){return v(p,"path"),p.length>0&&p.charCodeAt(0)===m},join(...p){if(p.length===0)return".";let o;for(let a=0;a<p.length;++a){const t=p[a];v(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.posix.normalize(o)},relative(p,o){if(v(p,"from"),v(o,"to"),p===o||(p=e.posix.resolve(p),o=e.posix.resolve(o),p===o))return"";const a=1,t=p.length,s=t-a,n=1,r=o.length-n,u=s<r?s:r;let l=-1,f=0;for(;f<u;f++){const w=p.charCodeAt(a+f);if(w!==o.charCodeAt(n+f))break;w===m&&(l=f)}if(f===u)if(r>u){if(o.charCodeAt(n+f)===m)return o.slice(n+f+1);if(f===0)return o.slice(n+f)}else s>u&&(p.charCodeAt(a+f)===m?l=f:f===0&&(l=0));let d="";for(f=a+l+1;f<=t;++f)(f===t||p.charCodeAt(f)===m)&&(d+=d.length===0?"..":"/..");return`${d}${o.slice(n+l)}`},toNamespacedPath(p){return p},dirname(p){if(v(p,"path"),p.length===0)return".";const o=p.charCodeAt(0)===m;let a=-1,t=!0;for(let s=p.length-1;s>=1;--s)if(p.charCodeAt(s)===m){if(!t){a=s;break}}else t=!1;return a===-1?o?"/":".":o&&a===1?"//":p.slice(0,a)},basename(p,o){o!==void 0&&v(o,"ext"),v(p,"path");let a=0,t=-1,s=!0,n;if(o!==void 0&&o.length>0&&o.length<=p.length){if(o===p)return"";let r=o.length-1,u=-1;for(n=p.length-1;n>=0;--n){const l=p.charCodeAt(n);if(l===m){if(!s){a=n+1;break}}else u===-1&&(s=!1,u=n+1),r>=0&&(l===o.charCodeAt(r)?--r==-1&&(t=n):(r=-1,t=u))}return a===t?t=u:t===-1&&(t=p.length),p.slice(a,t)}for(n=p.length-1;n>=0;--n)if(p.charCodeAt(n)===m){if(!s){a=n+1;break}}else t===-1&&(s=!1,t=n+1);return t===-1?"":p.slice(a,t)},extname(p){v(p,"path");let o=-1,a=0,t=-1,s=!0,n=0;for(let r=p.length-1;r>=0;--r){const u=p.charCodeAt(r);if(u===m){if(!s){a=r+1;break}continue}t===-1&&(s=!1,t=r+1),u===P?o===-1?o=r:n!==1&&(n=1):o!==-1&&(n=-1)}return o===-1||t===-1||n===0||n===1&&o===t-1&&o===a+1?"":p.slice(o,t)},format:I.bind(null,"/"),parse(p){v(p,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(p.length===0)return o;const a=p.charCodeAt(0)===m;let t;a?(o.root="/",t=1):t=0;let s=-1,n=0,r=-1,u=!0,l=p.length-1,f=0;for(;l>=t;--l){const d=p.charCodeAt(l);if(d===m){if(!u){n=l+1;break}continue}r===-1&&(u=!1,r=l+1),d===P?s===-1?s=l:f!==1&&(f=1):s!==-1&&(f=-1)}if(r!==-1){const d=n===0&&a?1:n;s===-1||f===0||f===1&&s===r-1&&s===n+1?o.base=o.name=p.slice(d,r):(o.name=p.slice(d,s),o.base=p.slice(d,r),o.ext=p.slice(s,r))}return n>0?o.dir=p.slice(0,n-1):a&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=D.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=D.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=D.platform==="win32"?e.win32.join:e.posix.join,e.resolve=D.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=D.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=D.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=D.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=D.platform==="win32"?e.win32.extname:e.posix.extname,e.format=D.platform==="win32"?e.win32.format:e.posix.format,e.parse=D.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=D.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=D.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=D.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),function(K,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var L in D)(typeof exports=="object"?exports:K)[L]=D[L]}}(typeof self!="undefined"?self:this,function(){return function(K){var e={};function D(L){if(e[L])return e[L].exports;var R=e[L]={i:L,l:!1,exports:{}};return K[L].call(R.exports,R,R.exports,D),R.l=!0,R.exports}return D.m=K,D.c=e,D.d=function(L,R,A){D.o(L,R)||Object.defineProperty(L,R,{enumerable:!0,get:A})},D.r=function(L){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},D.t=function(L,R){if(1&R&&(L=D(L)),8&R||4&R&&typeof L=="object"&&L&&L.__esModule)return L;var A=Object.create(null);if(D.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:L}),2&R&&typeof L!="string")for(var k in L)D.d(A,k,function(P){return L[P]}.bind(null,k));return A},D.n=function(L){var R=L&&L.__esModule?function(){return L.default}:function(){return L};return D.d(R,"a",R),R},D.o=function(L,R){return Object.prototype.hasOwnProperty.call(L,R)},D.p="",D(D.s=0)}([function(K,e,D){(function(L){var R;e=K.exports=W,R=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var ee=Array.prototype.slice.call(arguments,0);ee.unshift("SEMVER"),console.log.apply(console,ee)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],m=e.src=[],E=0,i=E++;m[i]="0|[1-9]\\d*";var C=E++;m[C]="[0-9]+";var h=E++;m[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=E++;m[v]="("+m[i]+")\\.("+m[i]+")\\.("+m[i]+")";var c=E++;m[c]="("+m[C]+")\\.("+m[C]+")\\.("+m[C]+")";var S=E++;m[S]="(?:"+m[i]+"|"+m[h]+")";var b=E++;m[b]="(?:"+m[C]+"|"+m[h]+")";var g=E++;m[g]="(?:-("+m[S]+"(?:\\."+m[S]+")*))";var I=E++;m[I]="(?:-?("+m[b]+"(?:\\."+m[b]+")*))";var p=E++;m[p]="[0-9A-Za-z-]+";var o=E++;m[o]="(?:\\+("+m[p]+"(?:\\."+m[p]+")*))";var a=E++,t="v?"+m[v]+m[g]+"?"+m[o]+"?";m[a]="^"+t+"$";var s="[v=\\s]*"+m[c]+m[I]+"?"+m[o]+"?",n=E++;m[n]="^"+s+"$";var r=E++;m[r]="((?:<|>)?=?)";var u=E++;m[u]=m[C]+"|x|X|\\*";var l=E++;m[l]=m[i]+"|x|X|\\*";var f=E++;m[f]="[v=\\s]*("+m[l]+")(?:\\.("+m[l]+")(?:\\.("+m[l]+")(?:"+m[g]+")?"+m[o]+"?)?)?";var d=E++;m[d]="[v=\\s]*("+m[u]+")(?:\\.("+m[u]+")(?:\\.("+m[u]+")(?:"+m[I]+")?"+m[o]+"?)?)?";var w=E++;m[w]="^"+m[r]+"\\s*"+m[f]+"$";var T=E++;m[T]="^"+m[r]+"\\s*"+m[d]+"$";var O=E++;m[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var y=E++;m[y]="(?:~>?)";var M=E++;m[M]="(\\s*)"+m[y]+"\\s+",P[M]=new RegExp(m[M],"g");var F=E++;m[F]="^"+m[y]+m[f]+"$";var q=E++;m[q]="^"+m[y]+m[d]+"$";var x=E++;m[x]="(?:\\^)";var U=E++;m[U]="(\\s*)"+m[x]+"\\s+",P[U]=new RegExp(m[U],"g");var $=E++;m[$]="^"+m[x]+m[f]+"$";var B=E++;m[B]="^"+m[x]+m[d]+"$";var z=E++;m[z]="^"+m[r]+"\\s*("+s+")$|^$";var j=E++;m[j]="^"+m[r]+"\\s*("+t+")$|^$";var N=E++;m[N]="(\\s*)"+m[r]+"\\s*("+s+"|"+m[f]+")",P[N]=new RegExp(m[N],"g");var G=E++;m[G]="^\\s*("+m[f]+")\\s+-\\s+("+m[f]+")\\s*$";var _=E++;m[_]="^\\s*("+m[d]+")\\s+-\\s+("+m[d]+")\\s*$";var J=E++;m[J]="(<|>)?=?\\s*\\*";for(var Y=0;Y<35;Y++)R(Y,m[Y]),P[Y]||(P[Y]=new RegExp(m[Y]));function H(ee,se){if(ee instanceof W)return ee;if(typeof ee!="string"||ee.length>A||!(se?P[n]:P[a]).test(ee))return null;try{return new W(ee,se)}catch(ae){return null}}function W(ee,se){if(ee instanceof W){if(ee.loose===se)return ee;ee=ee.version}else if(typeof ee!="string")throw new TypeError("Invalid Version: "+ee);if(ee.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof W))return new W(ee,se);R("SemVer",ee,se),this.loose=se;var ae=ee.trim().match(se?P[n]:P[a]);if(!ae)throw new TypeError("Invalid Version: "+ee);if(this.raw=ee,this.major=+ae[1],this.minor=+ae[2],this.patch=+ae[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");ae[4]?this.prerelease=ae[4].split(".").map(function(ye){if(/^[0-9]+$/.test(ye)){var pe=+ye;if(pe>=0&&pe<k)return pe}return ye}):this.prerelease=[],this.build=ae[5]?ae[5].split("."):[],this.format()}e.parse=H,e.valid=function(ee,se){var ae=H(ee,se);return ae?ae.version:null},e.clean=function(ee,se){var ae=H(ee.trim().replace(/^[=v]+/,""),se);return ae?ae.version:null},e.SemVer=W,W.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},W.prototype.toString=function(){return this.version},W.prototype.compare=function(ee){return R("SemVer.compare",this.version,this.loose,ee),ee instanceof W||(ee=new W(ee,this.loose)),this.compareMain(ee)||this.comparePre(ee)},W.prototype.compareMain=function(ee){return ee instanceof W||(ee=new W(ee,this.loose)),X(this.major,ee.major)||X(this.minor,ee.minor)||X(this.patch,ee.patch)},W.prototype.comparePre=function(ee){if(ee instanceof W||(ee=new W(ee,this.loose)),this.prerelease.length&&!ee.prerelease.length)return-1;if(!this.prerelease.length&&ee.prerelease.length)return 1;if(!this.prerelease.length&&!ee.prerelease.length)return 0;var se=0;do{var ae=this.prerelease[se],ye=ee.prerelease[se];if(R("prerelease compare",se,ae,ye),ae===void 0&&ye===void 0)return 0;if(ye===void 0)return 1;if(ae===void 0)return-1;if(ae!==ye)return X(ae,ye)}while(++se)},W.prototype.inc=function(ee,se){switch(ee){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",se);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",se);break;case"prepatch":this.prerelease.length=0,this.inc("patch",se),this.inc("pre",se);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",se),this.inc("pre",se);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ae=this.prerelease.length;--ae>=0;)typeof this.prerelease[ae]=="number"&&(this.prerelease[ae]++,ae=-2);ae===-1&&this.prerelease.push(0)}se&&(this.prerelease[0]===se?isNaN(this.prerelease[1])&&(this.prerelease=[se,0]):this.prerelease=[se,0]);break;default:throw new Error("invalid increment argument: "+ee)}return this.format(),this.raw=this.version,this},e.inc=function(ee,se,ae,ye){typeof ae=="string"&&(ye=ae,ae=void 0);try{return new W(ee,ae).inc(se,ye).version}catch(pe){return null}},e.diff=function(ee,se){if(le(ee,se))return null;var ae=H(ee),ye=H(se);if(ae.prerelease.length||ye.prerelease.length){for(var pe in ae)if((pe==="major"||pe==="minor"||pe==="patch")&&ae[pe]!==ye[pe])return"pre"+pe;return"prerelease"}for(var pe in ae)if((pe==="major"||pe==="minor"||pe==="patch")&&ae[pe]!==ye[pe])return pe},e.compareIdentifiers=X;var Z=/^[0-9]+$/;function X(ee,se){var ae=Z.test(ee),ye=Z.test(se);return ae&&ye&&(ee=+ee,se=+se),ae&&!ye?-1:ye&&!ae?1:ee<se?-1:ee>se?1:0}function re(ee,se,ae){return new W(ee,ae).compare(new W(se,ae))}function oe(ee,se,ae){return re(ee,se,ae)>0}function ue(ee,se,ae){return re(ee,se,ae)<0}function le(ee,se,ae){return re(ee,se,ae)===0}function Se(ee,se,ae){return re(ee,se,ae)!==0}function Ee(ee,se,ae){return re(ee,se,ae)>=0}function be(ee,se,ae){return re(ee,se,ae)<=0}function Le(ee,se,ae,ye){var pe;switch(se){case"===":typeof ee=="object"&&(ee=ee.version),typeof ae=="object"&&(ae=ae.version),pe=ee===ae;break;case"!==":typeof ee=="object"&&(ee=ee.version),typeof ae=="object"&&(ae=ae.version),pe=ee!==ae;break;case"":case"=":case"==":pe=le(ee,ae,ye);break;case"!=":pe=Se(ee,ae,ye);break;case">":pe=oe(ee,ae,ye);break;case">=":pe=Ee(ee,ae,ye);break;case"<":pe=ue(ee,ae,ye);break;case"<=":pe=be(ee,ae,ye);break;default:throw new TypeError("Invalid operator: "+se)}return pe}function De(ee,se){if(ee instanceof De){if(ee.loose===se)return ee;ee=ee.value}if(!(this instanceof De))return new De(ee,se);R("comparator",ee,se),this.loose=se,this.parse(ee),this.semver===Fe?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(ee,se){return X(se,ee)},e.major=function(ee,se){return new W(ee,se).major},e.minor=function(ee,se){return new W(ee,se).minor},e.patch=function(ee,se){return new W(ee,se).patch},e.compare=re,e.compareLoose=function(ee,se){return re(ee,se,!0)},e.rcompare=function(ee,se,ae){return re(se,ee,ae)},e.sort=function(ee,se){return ee.sort(function(ae,ye){return e.compare(ae,ye,se)})},e.rsort=function(ee,se){return ee.sort(function(ae,ye){return e.rcompare(ae,ye,se)})},e.gt=oe,e.lt=ue,e.eq=le,e.neq=Se,e.gte=Ee,e.lte=be,e.cmp=Le,e.Comparator=De;var Fe={};function Re(ee,se){if(ee instanceof Re)return ee.loose===se?ee:new Re(ee.raw,se);if(ee instanceof De)return new Re(ee.value,se);if(!(this instanceof Re))return new Re(ee,se);if(this.loose=se,this.raw=ee,this.set=ee.split(/\s*\|\|\s*/).map(function(ae){return this.parseRange(ae.trim())},this).filter(function(ae){return ae.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ee);this.format()}function Ae(ee){return!ee||ee.toLowerCase()==="x"||ee==="*"}function We(ee,se,ae,ye,pe,Te,Pe,Oe,ke,V,ie,ce,he){return((se=Ae(ae)?"":Ae(ye)?">="+ae+".0.0":Ae(pe)?">="+ae+"."+ye+".0":">="+se)+" "+(Oe=Ae(ke)?"":Ae(V)?"<"+(+ke+1)+".0.0":Ae(ie)?"<"+ke+"."+(+V+1)+".0":ce?"<="+ke+"."+V+"."+ie+"-"+ce:"<="+Oe)).trim()}function Be(ee,se){for(var ae=0;ae<ee.length;ae++)if(!ee[ae].test(se))return!1;if(se.prerelease.length){for(ae=0;ae<ee.length;ae++)if(R(ee[ae].semver),ee[ae].semver!==Fe&&ee[ae].semver.prerelease.length>0){var ye=ee[ae].semver;if(ye.major===se.major&&ye.minor===se.minor&&ye.patch===se.patch)return!0}return!1}return!0}function xe(ee,se,ae){try{se=new Re(se,ae)}catch(ye){return!1}return se.test(ee)}function qe(ee,se,ae,ye){var pe,Te,Pe,Oe,ke;switch(ee=new W(ee,ye),se=new Re(se,ye),ae){case">":pe=oe,Te=be,Pe=ue,Oe=">",ke=">=";break;case"<":pe=ue,Te=Ee,Pe=oe,Oe="<",ke="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(xe(ee,se,ye))return!1;for(var V=0;V<se.set.length;++V){var ie=se.set[V],ce=null,he=null;if(ie.forEach(function(ge){ge.semver===Fe&&(ge=new De(">=0.0.0")),ce=ce||ge,he=he||ge,pe(ge.semver,ce.semver,ye)?ce=ge:Pe(ge.semver,he.semver,ye)&&(he=ge)}),ce.operator===Oe||ce.operator===ke||(!he.operator||he.operator===Oe)&&Te(ee,he.semver)||he.operator===ke&&Pe(ee,he.semver))return!1}return!0}De.prototype.parse=function(ee){var se=this.loose?P[z]:P[j],ae=ee.match(se);if(!ae)throw new TypeError("Invalid comparator: "+ee);this.operator=ae[1],this.operator==="="&&(this.operator=""),ae[2]?this.semver=new W(ae[2],this.loose):this.semver=Fe},De.prototype.toString=function(){return this.value},De.prototype.test=function(ee){return R("Comparator.test",ee,this.loose),this.semver===Fe||(typeof ee=="string"&&(ee=new W(ee,this.loose)),Le(ee,this.operator,this.semver,this.loose))},De.prototype.intersects=function(ee,se){if(!(ee instanceof De))throw new TypeError("a Comparator is required");var ae;if(this.operator==="")return ae=new Re(ee.value,se),xe(this.value,ae,se);if(ee.operator==="")return ae=new Re(this.value,se),xe(ee.semver,ae,se);var ye=!(this.operator!==">="&&this.operator!==">"||ee.operator!==">="&&ee.operator!==">"),pe=!(this.operator!=="<="&&this.operator!=="<"||ee.operator!=="<="&&ee.operator!=="<"),Te=this.semver.version===ee.semver.version,Pe=!(this.operator!==">="&&this.operator!=="<="||ee.operator!==">="&&ee.operator!=="<="),Oe=Le(this.semver,"<",ee.semver,se)&&(this.operator===">="||this.operator===">")&&(ee.operator==="<="||ee.operator==="<"),ke=Le(this.semver,">",ee.semver,se)&&(this.operator==="<="||this.operator==="<")&&(ee.operator===">="||ee.operator===">");return ye||pe||Te&&Pe||Oe||ke},e.Range=Re,Re.prototype.format=function(){return this.range=this.set.map(function(ee){return ee.join(" ").trim()}).join("||").trim(),this.range},Re.prototype.toString=function(){return this.range},Re.prototype.parseRange=function(ee){var se=this.loose;ee=ee.trim(),R("range",ee,se);var ae=se?P[_]:P[G];ee=ee.replace(ae,We),R("hyphen replace",ee),ee=ee.replace(P[N],"$1$2$3"),R("comparator trim",ee,P[N]),ee=(ee=(ee=ee.replace(P[M],"$1~")).replace(P[U],"$1^")).split(/\s+/).join(" ");var ye=se?P[z]:P[j],pe=ee.split(" ").map(function(Te){return function(Pe,Oe){return R("comp",Pe),Pe=function(ke,V){return ke.trim().split(/\s+/).map(function(ie){return function(ce,he){R("caret",ce,he);var ge=he?P[B]:P[$];return ce.replace(ge,function(we,me,ve,Ie,Ce){var fe;return R("caret",ce,we,me,ve,Ie,Ce),Ae(me)?fe="":Ae(ve)?fe=">="+me+".0.0 <"+(+me+1)+".0.0":Ae(Ie)?fe=me==="0"?">="+me+"."+ve+".0 <"+me+"."+(+ve+1)+".0":">="+me+"."+ve+".0 <"+(+me+1)+".0.0":Ce?(R("replaceCaret pr",Ce),Ce.charAt(0)!=="-"&&(Ce="-"+Ce),fe=me==="0"?ve==="0"?">="+me+"."+ve+"."+Ie+Ce+" <"+me+"."+ve+"."+(+Ie+1):">="+me+"."+ve+"."+Ie+Ce+" <"+me+"."+(+ve+1)+".0":">="+me+"."+ve+"."+Ie+Ce+" <"+(+me+1)+".0.0"):(R("no pr"),fe=me==="0"?ve==="0"?">="+me+"."+ve+"."+Ie+" <"+me+"."+ve+"."+(+Ie+1):">="+me+"."+ve+"."+Ie+" <"+me+"."+(+ve+1)+".0":">="+me+"."+ve+"."+Ie+" <"+(+me+1)+".0.0"),R("caret return",fe),fe})}(ie,V)}).join(" ")}(Pe,Oe),R("caret",Pe),Pe=function(ke,V){return ke.trim().split(/\s+/).map(function(ie){return function(ce,he){var ge=he?P[q]:P[F];return ce.replace(ge,function(we,me,ve,Ie,Ce){var fe;return R("tilde",ce,we,me,ve,Ie,Ce),Ae(me)?fe="":Ae(ve)?fe=">="+me+".0.0 <"+(+me+1)+".0.0":Ae(Ie)?fe=">="+me+"."+ve+".0 <"+me+"."+(+ve+1)+".0":Ce?(R("replaceTilde pr",Ce),Ce.charAt(0)!=="-"&&(Ce="-"+Ce),fe=">="+me+"."+ve+"."+Ie+Ce+" <"+me+"."+(+ve+1)+".0"):fe=">="+me+"."+ve+"."+Ie+" <"+me+"."+(+ve+1)+".0",R("tilde return",fe),fe})}(ie,V)}).join(" ")}(Pe,Oe),R("tildes",Pe),Pe=function(ke,V){return R("replaceXRanges",ke,V),ke.split(/\s+/).map(function(ie){return function(ce,he){ce=ce.trim();var ge=he?P[T]:P[w];return ce.replace(ge,function(we,me,ve,Ie,Ce,fe){R("xRange",ce,we,me,ve,Ie,Ce,fe);var Ue=Ae(ve),Me=Ue||Ae(Ie),Ne=Me||Ae(Ce);return me==="="&&Ne&&(me=""),Ue?we=me===">"||me==="<"?"<0.0.0":"*":me&&Ne?(Me&&(Ie=0),Ne&&(Ce=0),me===">"?(me=">=",Me?(ve=+ve+1,Ie=0,Ce=0):Ne&&(Ie=+Ie+1,Ce=0)):me==="<="&&(me="<",Me?ve=+ve+1:Ie=+Ie+1),we=me+ve+"."+Ie+"."+Ce):Me?we=">="+ve+".0.0 <"+(+ve+1)+".0.0":Ne&&(we=">="+ve+"."+Ie+".0 <"+ve+"."+(+Ie+1)+".0"),R("xRange return",we),we})}(ie,V)}).join(" ")}(Pe,Oe),R("xrange",Pe),Pe=function(ke,V){return R("replaceStars",ke,V),ke.trim().replace(P[J],"")}(Pe,Oe),R("stars",Pe),Pe}(Te,se)}).join(" ").split(/\s+/);return this.loose&&(pe=pe.filter(function(Te){return!!Te.match(ye)})),pe=pe.map(function(Te){return new De(Te,se)})},Re.prototype.intersects=function(ee,se){if(!(ee instanceof Re))throw new TypeError("a Range is required");return this.set.some(function(ae){return ae.every(function(ye){return ee.set.some(function(pe){return pe.every(function(Te){return ye.intersects(Te,se)})})})})},e.toComparators=function(ee,se){return new Re(ee,se).set.map(function(ae){return ae.map(function(ye){return ye.value}).join(" ").trim().split(" ")})},Re.prototype.test=function(ee){if(!ee)return!1;typeof ee=="string"&&(ee=new W(ee,this.loose));for(var se=0;se<this.set.length;se++)if(Be(this.set[se],ee))return!0;return!1},e.satisfies=xe,e.maxSatisfying=function(ee,se,ae){var ye=null,pe=null;try{var Te=new Re(se,ae)}catch(Pe){return null}return ee.forEach(function(Pe){Te.test(Pe)&&(ye&&pe.compare(Pe)!==-1||(pe=new W(ye=Pe,ae)))}),ye},e.minSatisfying=function(ee,se,ae){var ye=null,pe=null;try{var Te=new Re(se,ae)}catch(Pe){return null}return ee.forEach(function(Pe){Te.test(Pe)&&(ye&&pe.compare(Pe)!==1||(pe=new W(ye=Pe,ae)))}),ye},e.validRange=function(ee,se){try{return new Re(ee,se).range||"*"}catch(ae){return null}},e.ltr=function(ee,se,ae){return qe(ee,se,"<",ae)},e.gtr=function(ee,se,ae){return qe(ee,se,">",ae)},e.outside=qe,e.prerelease=function(ee,se){var ae=H(ee,se);return ae&&ae.prerelease.length?ae.prerelease:null},e.intersects=function(ee,se,ae){return ee=new Re(ee,ae),se=new Re(se,ae),ee.intersects(se)},e.coerce=function(ee){if(ee instanceof W)return ee;if(typeof ee!="string")return null;var se=ee.match(P[O]);return se==null?null:H((se[1]||"0")+"."+(se[2]||"0")+"."+(se[3]||"0"))}}).call(this,D(1))},function(K,e){var D,L,R=K.exports={};function A(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function P(b){if(D===setTimeout)return setTimeout(b,0);if((D===A||!D)&&setTimeout)return D=setTimeout,setTimeout(b,0);try{return D(b,0)}catch(g){try{return D.call(null,b,0)}catch(I){return D.call(this,b,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:A}catch(b){D=A}try{L=typeof clearTimeout=="function"?clearTimeout:k}catch(b){L=k}})();var m,E=[],i=!1,C=-1;function h(){i&&m&&(i=!1,m.length?E=m.concat(E):C=-1,E.length&&v())}function v(){if(!i){var b=P(h);i=!0;for(var g=E.length;g;){for(m=E,E=[];++C<g;)m&&m[C].run();C=-1,g=E.length}m=null,i=!1,function(I){if(L===clearTimeout)return clearTimeout(I);if((L===k||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(I);try{L(I)}catch(p){try{return L.call(null,I)}catch(o){return L.call(this,I)}}}(b)}}function c(b,g){this.fun=b,this.array=g}function S(){}R.nextTick=function(b){var g=new Array(arguments.length-1);if(arguments.length>1)for(var I=1;I<arguments.length;I++)g[I-1]=arguments[I];E.push(new c(b,g)),E.length!==1||i||P(v)},c.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=S,R.addListener=S,R.once=S,R.off=S,R.removeListener=S,R.removeAllListeners=S,R.emit=S,R.prependListener=S,R.prependOnceListener=S,R.listeners=function(b){return[]},R.binding=function(b){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(b){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(te[92],ne([0,1,4]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=D.globals.performance&&typeof D.globals.performance.now=="function";class R{constructor(k){this._highResolution=L&&k,this._startTime=this._now(),this._stopTime=-1}static create(k=!0){return new R(k)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?D.globals.performance.now():Date.now()}}e.StopWatch=R}),define(te[3],ne([0,1,11,65,2,91,92]),function(K,e,D,L,R,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(p){p.None=()=>R.Disposable.None;function o(x){return(U,$=null,B)=>{let z=!1,j;return j=x(N=>{if(!z)return j?j.dispose():z=!0,U.call($,N)},null,B),z&&j.dispose(),j}}p.once=o;function a(x,U){return l(($,B=null,z)=>x(j=>$.call(B,U(j)),null,z))}p.map=a;function t(x,U){return l(($,B=null,z)=>x(j=>{U(j),$.call(B,j)},null,z))}p.forEach=t;function s(x,U){return l(($,B=null,z)=>x(j=>U(j)&&$.call(B,j),null,z))}p.filter=s;function n(x){return x}p.signal=n;function r(...x){return(U,$=null,B)=>(0,R.combinedDisposable)(...x.map(z=>z(j=>U.call($,j),null,B)))}p.any=r;function u(x,U,$){let B=$;return a(x,z=>(B=U(B,z),B))}p.reduce=u;function l(x){let U;const $=new h({onFirstListenerAdd(){U=x($.fire,$)},onLastListenerRemove(){U.dispose()}});return $.event}function f(x,U,$=100,B=!1,z){let j,N,G,_=0;const J=new h({leakWarningThreshold:z,onFirstListenerAdd(){j=x(Y=>{_++,N=U(N,Y),B&&!G&&(J.fire(N),N=void 0),clearTimeout(G),G=setTimeout(()=>{const H=N;N=void 0,G=void 0,(!B||_>1)&&J.fire(H),_=0},$)})},onLastListenerRemove(){j.dispose()}});return J.event}p.debounce=f;function d(x,U=($,B)=>$===B){let $=!0,B;return s(x,z=>{const j=$||!U(z,B);return $=!1,B=z,j})}p.latch=d;function w(x,U){return[p.filter(x,U),p.filter(x,$=>!U($))]}p.split=w;function T(x,U=!1,$=[]){let B=$.slice(),z=x(G=>{B?B.push(G):N.fire(G)});const j=()=>{B&&B.forEach(G=>N.fire(G)),B=null},N=new h({onFirstListenerAdd(){z||(z=x(G=>N.fire(G)))},onFirstListenerDidAdd(){B&&(U?setTimeout(j):j())},onLastListenerRemove(){z&&z.dispose(),z=null}});return N.event}p.buffer=T;class O{constructor(U){this.event=U}map(U){return new O(a(this.event,U))}forEach(U){return new O(t(this.event,U))}filter(U){return new O(s(this.event,U))}reduce(U,$){return new O(u(this.event,U,$))}latch(){return new O(d(this.event))}debounce(U,$=100,B=!1,z){return new O(f(this.event,U,$,B,z))}on(U,$,B){return this.event(U,$,B)}once(U,$,B){return o(this.event)(U,$,B)}}function y(x){return new O(x)}p.chain=y;function M(x,U,$=B=>B){const B=(...G)=>N.fire($(...G)),z=()=>x.on(U,B),j=()=>x.removeListener(U,B),N=new h({onFirstListenerAdd:z,onLastListenerRemove:j});return N.event}p.fromNodeEventEmitter=M;function F(x,U,$=B=>B){const B=(...G)=>N.fire($(...G)),z=()=>x.addEventListener(U,B),j=()=>x.removeEventListener(U,B),N=new h({onFirstListenerAdd:z,onLastListenerRemove:j});return N.event}p.fromDOMEventEmitter=F;function q(x){return new Promise(U=>o(x)(U))}p.toPromise=q})(P=e.Event||(e.Event={}));class m{constructor(o){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${o}_${m._idPool++}`}start(o){this._stopWatch=new k.StopWatch(!0),this._listenerCount=o}stop(){if(this._stopWatch){const o=this._stopWatch.elapsed();this._elapsedOverall+=o,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${o.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}m._idPool=0;let E=-1;function i(p){const o=E;return E=p,{dispose(){E=o}}}e.setGlobalLeakWarningThreshold=i;class C{constructor(o,a=Math.random().toString(18).slice(2,5)){this.customThreshold=o,this.name=a,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(o){let a=E;if(typeof this.customThreshold=="number"&&(a=this.customThreshold),a<=0||o<a)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(t)||0;if(this._stacks.set(t,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=a*.5;let n,r=0;for(const[u,l]of this._stacks)(!n||r<l)&&(n=u,r=l);console.warn(`[${this.name}] potential listener LEAK detected, having ${o} listeners already. MOST frequent listener (${r}):`),console.warn(n)}return()=>{const n=this._stacks.get(t)||0;this._stacks.set(t,n-1)}}}class h{constructor(o){this._disposed=!1,this._options=o,this._leakageMon=E>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new m(this._options._profName):void 0}get event(){return this._event||(this._event=(o,a,t)=>{this._listeners||(this._listeners=new A.LinkedList);const s=this._listeners.isEmpty();s&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(a?[o,a]:o);s&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,o,a);const r=this._leakageMon?.check(this._listeners.size),u=(0,R.toDisposable)(()=>{r&&r(),this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof R.DisposableStore?t.add(u):Array.isArray(t)&&t.push(u),u}),this._event}fire(o){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new A.LinkedList);for(let a of this._listeners)this._deliveryQueue.push([a,o]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[a,t]=this._deliveryQueue.shift();try{typeof a=="function"?a.call(void 0,t):a[0].call(a[1],t)}catch(s){(0,D.onUnexpectedError)(s)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=h;class v extends h{async fireAsync(o,a,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList);for(const s of this._listeners)this._asyncDeliveryQueue.push([s,o]);for(;this._asyncDeliveryQueue.size>0&&!a.isCancellationRequested;){const[s,n]=this._asyncDeliveryQueue.shift(),r=[],u={...n,waitUntil:l=>{if(Object.isFrozen(r))throw new Error("waitUntil can NOT be called asynchronous");t&&(l=t(l,typeof s=="function"?s:s[0])),r.push(l)}};try{typeof s=="function"?s.call(void 0,u):s[0].call(s[1],u)}catch(l){(0,D.onUnexpectedError)(l);continue}Object.freeze(r),await Promise.allSettled(r).then(l=>{for(const f of l)f.status==="rejected"&&(0,D.onUnexpectedError)(f.reason)})}}}}e.AsyncEmitter=v;class c extends h{constructor(o){super(o);this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=o?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const o=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(o))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(o){this._listeners&&(this._isPaused!==0?this._eventQueue.push(o):super.fire(o))}}e.PauseableEmitter=c;class S extends c{constructor(o){super(o);this._delay=o.delay??100}fire(o){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(o)}}e.DebounceEmitter=S;class b{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new h({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(o){const a={event:o,listener:null};this.events.push(a),this.hasListeners&&this.hook(a);const t=()=>{this.hasListeners&&this.unhook(a);const s=this.events.indexOf(a);this.events.splice(s,1)};return(0,R.toDisposable)((0,L.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(o=>this.hook(o))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(o=>this.unhook(o))}hook(o){o.listener=o.event(a=>this.emitter.fire(a))}unhook(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=b;class g{constructor(){this.buffers=[]}wrapEvent(o){return(a,t,s)=>o(n=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>a.call(t,n)):a.call(t,n)},void 0,s)}bufferEvents(o){const a=[];this.buffers.push(a);const t=o();return this.buffers.pop(),a.forEach(s=>s()),t}}e.EventBufferer=g;class I{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=R.Disposable.None,this.emitter=new h({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(o){this.inputEvent=o,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=o(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=I}),define(te[29],ne([0,1,3]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(P,m){const E=setTimeout(P.bind(m),0);return{dispose(){clearTimeout(E)}}});var R;(function(P){function m(E){return E===P.None||E===P.Cancelled||E instanceof A?!0:!E||typeof E!="object"?!1:typeof E.isCancellationRequested=="boolean"&&typeof E.onCancellationRequested=="function"}P.isCancellationToken=m,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(R=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new D.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(m){this._token=void 0,this._parentListener=void 0,this._parentListener=m&&m.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=R.Cancelled}dispose(m=!1){m&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=R.None}}e.CancellationTokenSource=k}),define(te[49],ne([0,1,3]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new D.Emitter}add(C){const h=this._icons.get(C.id);h?C.description?h.description=C.description:console.error(`Duplicate registration of codicon ${C.id}`):(this._icons.set(C.id,C),this._onDidRegister.fire(C))}get(C){return this._icons.get(C)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const R=new L;e.iconRegistry=R;function A(i,C){return new P(i,C)}e.registerCodicon=A;function k(i){return i?i.replace(/\$\((.*?)\)/g,(C,h)=>` ${h} `).trim():""}e.getCodiconAriaLabel=k;class P{constructor(C,h,v){this.id=C,this.definition=h,this.description=v,R.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=P;function m(i,C){const h=["codicon","codicon-"+i];return C&&h.push("codicon-modifier-"+C),h}e.getClassNamesArray=m;var E;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const C=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function h(S){if(S instanceof P)return["codicon","codicon-"+S.id];const b=C.exec(S.id);if(!b)return h(P.error);let[,g,I]=b;const p=["codicon","codicon-"+g];return I&&p.push("codicon-modifier-"+I.substr(1)),p}i.asClassNameArray=h;function v(S){return h(S).join(" ")}i.asClassName=v;function c(S){return"."+h(S).join(".")}i.asCSSSelector=c})(E=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(P=e.Codicon||(e.Codicon={}))}),define(te[50],ne([0,1,11,2]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function R(p){const o=p;return o?[o.on,o.pause,o.resume,o.destroy].every(a=>typeof a=="function"):!1}e.isReadableStream=R;function A(p){const o=p;return o?R(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=A;function k(p,o){return new P(p,o)}e.newWriteableStream=k;class P{constructor(o,a){this.reducer=o,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(a=>this.pendingWritePromises.push(a))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(a=>a(o))}emitError(o){this.listeners.error.length===0?(0,D.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(a=>a(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,a){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(o,a){if(this.state.destroyed)return;let t;switch(o){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const s=t.indexOf(a);s>=0&&t.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function m(p,o){const a=[];let t;for(;(t=p.read())!==null;)a.push(t);return o(a)}e.consumeReadable=m;function E(p,o,a){const t=[];let s;for(;(s=p.read())!==null&&t.length<a;)t.push(s);return s===null&&t.length>0?o(t):{read:()=>{if(t.length>0)return t.shift();if(typeof s!="undefined"){const n=s;return s=void 0,n}return p.read()}}}e.peekReadable=E;function i(p,o){return new Promise((a,t)=>{const s=[];C(p,{onData:n=>{o&&s.push(n)},onError:n=>{o?t(n):a(void 0)},onEnd:()=>{a(o?o(s):void 0)}})})}e.consumeStream=i;function C(p,o){p.on("error",a=>o.onError(a)),p.on("end",()=>o.onEnd()),p.on("data",a=>o.onData(a))}e.listenStream=C;function h(p,o){return new Promise((a,t)=>{const s=new L.DisposableStore,n=[],r=f=>{if(n.push(f),n.length>o)return s.dispose(),p.pause(),a({stream:p,buffer:n,ended:!1})},u=f=>t(f),l=()=>a({stream:p,buffer:n,ended:!0});s.add((0,L.toDisposable)(()=>p.removeListener("error",u))),p.on("error",u),s.add((0,L.toDisposable)(()=>p.removeListener("end",l))),p.on("end",l),s.add((0,L.toDisposable)(()=>p.removeListener("data",r))),p.on("data",r)})}e.peekStream=h;function v(p,o){const a=k(o);return a.end(p),a}e.toStream=v;function c(){const p=k(()=>{throw new Error("not supported")});return p.end(),p}e.emptyStream=c;function S(p){let o=!1;return{read:()=>o?null:(o=!0,p)}}e.toReadable=S;function b(p,o,a){const t=k(a);return C(p,{onData:s=>t.write(o.data(s)),onError:s=>t.error(o.error?o.error(s):s),onEnd:()=>t.end()}),t}e.transform=b;function g(p,o,a){let t=!1;return{read:()=>{const s=o.read();return t?s:(t=!0,s!==null?a([p,s]):p)}}}e.prefixedReadable=g;function I(p,o,a){let t=!1;const s=k(a);return C(o,{onData:n=>t?s.write(n):(t=!0,s.write(a([p,n]))),onError:n=>s.error(n),onEnd:()=>{t||(t=!0,s.write(p)),s.end()}}),s}e.prefixedStream=I}),define(te[25],ne([0,1,50]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let R,A;class k{constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}static alloc(r){return L?new k(Buffer.allocUnsafe(r)):new k(new Uint8Array(r))}static wrap(r){return L&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new k(r)}static fromString(r,u){return!(u?.dontUseNodeBuffer||!1)&&L?new k(Buffer.from(r)):(R||(R=new TextEncoder),new k(R.encode(r)))}static concat(r,u){if(typeof u=="undefined"){u=0;for(let d=0,w=r.length;d<w;d++)u+=r[d].byteLength}const l=k.alloc(u);let f=0;for(let d=0,w=r.length;d<w;d++){const T=r[d];l.set(T,f),f+=T.byteLength}return l}toString(){return L?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(r,u){return new k(this.buffer.subarray(r,u))}set(r,u){r instanceof k?this.buffer.set(r.buffer,u):this.buffer.set(r,u)}readUInt32BE(r){return E(this.buffer,r)}writeUInt32BE(r,u){i(this.buffer,r,u)}readUInt32LE(r){return C(this.buffer,r)}writeUInt32LE(r,u){h(this.buffer,r,u)}readUInt8(r){return v(this.buffer,r)}writeUInt8(r,u){c(this.buffer,r,u)}}e.VSBuffer=k;function P(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0}e.readUInt16LE=P;function m(n,r,u){n[u+0]=r&255,r=r>>>8,n[u+1]=r&255}e.writeUInt16LE=m;function E(n,r){return n[r]*2**24+n[r+1]*2**16+n[r+2]*2**8+n[r+3]}e.readUInt32BE=E;function i(n,r,u){n[u+3]=r,r=r>>>8,n[u+2]=r,r=r>>>8,n[u+1]=r,r=r>>>8,n[u]=r}e.writeUInt32BE=i;function C(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0|n[r+2]<<16>>>0|n[r+3]<<24>>>0}e.readUInt32LE=C;function h(n,r,u){n[u+0]=r&255,r=r>>>8,n[u+1]=r&255,r=r>>>8,n[u+2]=r&255,r=r>>>8,n[u+3]=r&255}e.writeUInt32LE=h;function v(n,r){return n[r]}e.readUInt8=v;function c(n,r,u){n[u]=r}e.writeUInt8=c;function S(n){return D.consumeReadable(n,r=>k.concat(r))}e.readableToBuffer=S;function b(n){return D.toReadable(n)}e.bufferToReadable=b;function g(n){return D.consumeStream(n,r=>k.concat(r))}e.streamToBuffer=g;async function I(n){return n.ended?k.concat(n.buffer):k.concat([...n.buffer,await g(n.stream)])}e.bufferedStreamToBuffer=I;function p(n){return D.toStream(n,r=>k.concat(r))}e.bufferToStream=p;function o(n){return D.transform(n,{data:r=>typeof r=="string"?k.fromString(r):k.wrap(r)},r=>k.concat(r))}e.streamToBufferReadableStream=o;function a(n){return D.newWriteableStream(r=>k.concat(r),n)}e.newWriteableBufferStream=a;function t(n,r){return D.prefixedReadable(n,r,u=>k.concat(u))}e.prefixedBufferReadable=t;function s(n,r){return D.prefixedStream(n,r,u=>k.concat(u))}e.prefixedBufferStream=s}),define(te[24],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function D(V){return!V||typeof V!="string"?!0:V.trim().length===0}e.isFalsyOrWhitespace=D;const L=/{(\d+)}/g;function R(V,...ie){return ie.length===0?V:V.replace(L,function(ce,he){const ge=parseInt(he,10);return isNaN(ge)||ge<0||ge>=ie.length?ce:ie[ge]})}e.format=R;const A=/{([^}]+)}/g;function k(V,ie){return V.replace(A,(ce,he)=>ie[he]??ce)}e.format2=k;function P(V){return V.replace(/[<>&]/g,function(ie){switch(ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ie}})}e.escape=P;function m(V){return V.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=m;function E(V,ie){let ce=0;const he=ie.charCodeAt(0);for(let ge=V.length-1;ge>=0;ge--)V.charCodeAt(ge)===he&&ce++;return ce}e.count=E;function i(V,ie,ce="\u2026"){return V.length<=ie?V:`${V.substr(0,ie)}${ce}`}e.truncate=i;function C(V,ie=" "){const ce=h(V,ie);return v(ce,ie)}e.trim=C;function h(V,ie){if(!V||!ie)return V;const ce=ie.length;if(ce===0||V.length===0)return V;let he=0;for(;V.indexOf(ie,he)===he;)he=he+ce;return V.substring(he)}e.ltrim=h;function v(V,ie){if(!V||!ie)return V;const ce=ie.length,he=V.length;if(ce===0||he===0)return V;let ge=he,we=-1;for(;we=V.lastIndexOf(ie,ge-1),!(we===-1||we+ce!==ge);){if(we===0)return"";ge=we}return V.substring(0,ge)}e.rtrim=v;function c(V){return V.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=c;function S(V){return V.replace(/\*/g,"")}e.stripWildcards=S;function b(V,ie,ce={}){if(!V)throw new Error("Cannot create regex from empty string");ie||(V=m(V)),ce.wholeWord&&(/\B/.test(V.charAt(0))||(V="\\b"+V),/\B/.test(V.charAt(V.length-1))||(V=V+"\\b"));let he="";return ce.global&&(he+="g"),ce.matchCase||(he+="i"),ce.multiline&&(he+="m"),ce.unicode&&(he+="u"),new RegExp(V,he)}e.createRegExp=b;function g(V){return V.source==="^"||V.source==="^$"||V.source==="$"||V.source==="^\\s*$"?!1:!!(V.exec("")&&V.lastIndex===0)}e.regExpLeadsToEndlessLoop=g;function I(V){return!!V.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=I;function p(V){return(V.global?"g":"")+(V.ignoreCase?"i":"")+(V.multiline?"m":"")+(V.unicode?"u":"")}e.regExpFlags=p;function o(V){return V.split(/\r\n|\r|\n/)}e.splitLines=o;function a(V){for(let ie=0,ce=V.length;ie<ce;ie++){const he=V.charCodeAt(ie);if(he!==32&&he!==9)return ie}return-1}e.firstNonWhitespaceIndex=a;function t(V,ie=0,ce=V.length){for(let he=ie;he<ce;he++){const ge=V.charCodeAt(he);if(ge!==32&&ge!==9)return V.substring(ie,he)}return V.substring(ie,ce)}e.getLeadingWhitespace=t;function s(V,ie=V.length-1){for(let ce=ie;ce>=0;ce--){const he=V.charCodeAt(ce);if(he!==32&&he!==9)return ce}return-1}e.lastNonWhitespaceIndex=s;function n(V,ie){return V<ie?-1:V>ie?1:0}e.compare=n;function r(V,ie,ce=0,he=V.length,ge=0,we=ie.length){for(;ce<he&&ge<we;ce++,ge++){let Ie=V.charCodeAt(ce),Ce=ie.charCodeAt(ge);if(Ie<Ce)return-1;if(Ie>Ce)return 1}const me=he-ce,ve=we-ge;return me<ve?-1:me>ve?1:0}e.compareSubstring=r;function u(V,ie){return l(V,ie,0,V.length,0,ie.length)}e.compareIgnoreCase=u;function l(V,ie,ce=0,he=V.length,ge=0,we=ie.length){for(;ce<he&&ge<we;ce++,ge++){let Ie=V.charCodeAt(ce),Ce=ie.charCodeAt(ge);if(Ie===Ce)continue;const fe=Ie-Ce;if(!(fe===32&&d(Ce))&&!(fe===-32&&d(Ie)))return f(Ie)&&f(Ce)?fe:r(V.toLowerCase(),ie.toLowerCase(),ce,he,ge,we)}const me=he-ce,ve=we-ge;return me<ve?-1:me>ve?1:0}e.compareSubstringIgnoreCase=l;function f(V){return V>=97&&V<=122}e.isLowerAsciiLetter=f;function d(V){return V>=65&&V<=90}e.isUpperAsciiLetter=d;function w(V){return f(V)||d(V)}function T(V,ie){return V.length===ie.length&&O(V,ie)}e.equalsIgnoreCase=T;function O(V,ie,ce=V.length){for(let he=0;he<ce;he++){const ge=V.charCodeAt(he),we=ie.charCodeAt(he);if(ge!==we){if(w(ge)&&w(we)){const me=Math.abs(ge-we);if(me!==0&&me!==32)return!1}else if(String.fromCharCode(ge).toLowerCase()!==String.fromCharCode(we).toLowerCase())return!1}}return!0}function y(V,ie){const ce=ie.length;return ie.length>V.length?!1:O(V,ie,ce)}e.startsWithIgnoreCase=y;function M(V,ie){let ce,he=Math.min(V.length,ie.length);for(ce=0;ce<he;ce++)if(V.charCodeAt(ce)!==ie.charCodeAt(ce))return ce;return he}e.commonPrefixLength=M;function F(V,ie){let ce,he=Math.min(V.length,ie.length);const ge=V.length-1,we=ie.length-1;for(ce=0;ce<he;ce++)if(V.charCodeAt(ge-ce)!==ie.charCodeAt(we-ce))return ce;return he}e.commonSuffixLength=F;function q(V){return 55296<=V&&V<=56319}e.isHighSurrogate=q;function x(V){return 56320<=V&&V<=57343}e.isLowSurrogate=x;function U(V,ie){return(V-55296<<10)+(ie-56320)+65536}e.computeCodePoint=U;function $(V,ie,ce){const he=V.charCodeAt(ce);if(q(he)&&ce+1<ie){const ge=V.charCodeAt(ce+1);if(x(ge))return U(he,ge)}return he}e.getNextCodePoint=$;function B(V,ie){const ce=V.charCodeAt(ie-1);if(x(ce)&&ie>1){const he=V.charCodeAt(ie-2);if(q(he))return U(he,ce)}return ce}function z(V,ie){const ce=ae.getInstance(),he=ie,ge=V.length,we=$(V,ge,ie);ie+=we>=65536?2:1;let me=ce.getGraphemeBreakType(we);for(;ie<ge;){const ve=$(V,ge,ie),Ie=ce.getGraphemeBreakType(ve);if(ee(me,Ie))break;ie+=ve>=65536?2:1,me=Ie}return ie-he}e.nextCharLength=z;function j(V,ie){const ce=ae.getInstance(),he=ie,ge=B(V,ie);ie-=ge>=65536?2:1;let we=ce.getGraphemeBreakType(ge);for(;ie>0;){const me=B(V,ie),ve=ce.getGraphemeBreakType(me);if(ee(ve,we))break;ie-=me>=65536?2:1,we=ve}return he-ie}e.prevCharLength=j;function N(V,ie){const ce=ae.getInstance(),he=V.length,ge=ie,we=$(V,he,ie),me=ce.getGraphemeBreakType(we);ie+=we>=65536?2:1;let ve=me;for(;ie<he;){const Ce=$(V,he,ie),fe=ce.getGraphemeBreakType(Ce);if(ee(ve,fe))break;ie+=Ce>=65536?2:1,ve=fe}const Ie=ie;for(ie=ge,ve=me;ie>0;){const Ce=B(V,ie),fe=ce.getGraphemeBreakType(Ce);if(ee(fe,ve))break;ie-=Ce>=65536?2:1,ve=fe}return[ie,Ie]}function G(V,ie){return ie>0&&x(V.charCodeAt(ie))?N(V,ie-1):N(V,ie)}e.getCharContainingOffset=G;const _=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function J(V){return _.test(V)}e.containsRTL=J;const Y=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function H(V){return Y.test(V)}e.containsEmoji=H;const W=/^[\t\n\r\x20-\x7E]*$/;function Z(V){return W.test(V)}e.isBasicASCII=Z,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function X(V){return e.UNUSUAL_LINE_TERMINATORS.test(V)}e.containsUnusualLineTerminators=X;function re(V){for(let ie=0,ce=V.length;ie<ce;ie++)if(oe(V.charCodeAt(ie)))return!0;return!1}e.containsFullWidthCharacter=re;function oe(V){return V=+V,V>=11904&&V<=55215||V>=63744&&V<=64255||V>=65281&&V<=65374}e.isFullWidthCharacter=oe;function ue(V){return V>=127462&&V<=127487||V===8986||V===8987||V===9200||V===9203||V>=9728&&V<=10175||V===11088||V===11093||V>=127744&&V<=128591||V>=128640&&V<=128764||V>=128992&&V<=129003||V>=129280&&V<=129535||V>=129648&&V<=129750}e.isEmojiImprecise=ue;function le(V,ie){if(V.length<ie)return V;const ce=/\b/g;let he=0;for(;ce.test(V)&&!(V.length-ce.lastIndex<ie);)he=ce.lastIndex,ce.lastIndex+=1;return V.substring(he).replace(/^\s/,"")}e.lcut=le;const Se=/\x1B\x5B[12]?K/g,Ee=/\x1b\[\d+m/g,be=/\x1b\[0?m/g;function Le(V){return V&&(V=V.replace(Se,""),V=V.replace(Ee,""),V=V.replace(be,"")),V}e.removeAnsiEscapeCodes=Le,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function De(V){return!!(V&&V.length>0&&V.charCodeAt(0)===65279)}e.startsWithUTF8BOM=De;function Fe(V){return De(V)?V.substr(1):V}e.stripUTF8BOM=Fe;function Re(V,ie){if(!V||!ie||V.length<ie.length)return!1;const ce=ie.length,he=V.toLowerCase();let ge=0,we=-1;for(;ge<ce;){const me=he.indexOf(ie[ge],we+1);if(me<0)return!1;we=me,ge++}return!0}e.fuzzyContains=Re;function Ae(V,ie=!1){return V?(ie&&(V=V.replace(/\\./g,"")),V.toLowerCase()!==V):!1}e.containsUppercaseCharacter=Ae;function We(V){return V.charAt(0).toUpperCase()+V.slice(1)}e.uppercaseFirstLetter=We;function Be(V,ie=1){if(ie===0)return"";let ce=-1;do ce=V.indexOf(`
`,ce+1),ie--;while(ie>0&&ce>=0);return ce===-1?V:(V[ce-1]==="\r"&&ce--,V.substr(0,ce))}e.getNLines=Be;function xe(V){const ie=90-65+1;return V=V%(2*ie),V<ie?String.fromCharCode(97+V):String.fromCharCode(65+V-ie)}e.singleLetterHash=xe;function qe(V){return ae.getInstance().getGraphemeBreakType(V)}e.getGraphemeBreakType=qe;function ee(V,ie){return V===0?ie!==5&&ie!==7:V===2&&ie===3?!1:V===4||V===2||V===3||ie===4||ie===2||ie===3?!0:!(V===8&&(ie===8||ie===9||ie===11||ie===12)||(V===11||V===9)&&(ie===9||ie===10)||(V===12||V===10)&&ie===10||ie===5||ie===13||ie===7||V===1||V===13&&ie===14||V===6&&ie===6)}e.breakBetweenGraphemeBreakType=ee;var se;(function(V){V[V.Other=0]="Other",V[V.Prepend=1]="Prepend",V[V.CR=2]="CR",V[V.LF=3]="LF",V[V.Control=4]="Control",V[V.Extend=5]="Extend",V[V.Regional_Indicator=6]="Regional_Indicator",V[V.SpacingMark=7]="SpacingMark",V[V.L=8]="L",V[V.V=9]="V",V[V.T=10]="T",V[V.LV=11]="LV",V[V.LVT=12]="LVT",V[V.ZWJ=13]="ZWJ",V[V.Extended_Pictographic=14]="Extended_Pictographic"})(se=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ae{constructor(){this._data=ye()}static getInstance(){return ae._INSTANCE||(ae._INSTANCE=new ae),ae._INSTANCE}getGraphemeBreakType(ie){if(ie<32)return ie===10?3:ie===13?2:4;if(ie<127)return 0;const ce=this._data,he=ce.length/3;let ge=1;for(;ge<=he;)if(ie<ce[3*ge])ge=2*ge;else if(ie>ce[3*ge+1])ge=2*ge+1;else return ce[3*ge+2];return 0}}ae._INSTANCE=null;function ye(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function pe(V,ie){if(V===0)return 0;const ce=Te(V,ie);if(ce!==void 0)return ce;const he=B(ie,V);return V-=Pe(he),V}e.getLeftDeleteOffset=pe;function Te(V,ie){let ce=B(ie,V);for(V-=Pe(ce);Oe(ce)||ce===65039||ce===8419;){if(V===0)return;ce=B(ie,V),V-=Pe(ce)}if(!!ue(ce)){if(V>=0){const he=B(ie,V);he===8205&&(V-=Pe(he))}return V}}function Pe(V){return V>=65536?2:1}function Oe(V){return 127995<=V&&V<=127999}var ke;(function(V){V[V.zwj=8205]="zwj",V[V.emojiVariantSelector=65039]="emojiVariantSelector",V[V.enclosingKeyCap=8419]="enclosingKeyCap"})(ke||(ke={}))}),define(te[16],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function D(d){return Array.isArray(d)}e.isArray=D;function L(d){return typeof d=="string"}e.isString=L;function R(d){return Array.isArray(d)&&d.every(w=>L(w))}e.isStringArray=R;function A(d){return typeof d=="object"&&d!==null&&!Array.isArray(d)&&!(d instanceof RegExp)&&!(d instanceof Date)}e.isObject=A;function k(d){return typeof d=="number"&&!isNaN(d)}e.isNumber=k;function P(d){return!!d&&typeof d[Symbol.iterator]=="function"}e.isIterable=P;function m(d){return d===!0||d===!1}e.isBoolean=m;function E(d){return typeof d=="undefined"}e.isUndefined=E;function i(d){return!C(d)}e.isDefined=i;function C(d){return E(d)||d===null}e.isUndefinedOrNull=C;function h(d,w){if(!d)throw new Error(w?`Unexpected type, expected '${w}'`:"Unexpected type")}e.assertType=h;function v(d){if(C(d))throw new Error("Assertion Failed: argument is undefined or null");return d}e.assertIsDefined=v;function c(...d){const w=[];for(let T=0;T<d.length;T++){const O=d[T];if(C(O))throw new Error(`Assertion Failed: argument at index ${T} is undefined or null`);w.push(O)}return w}e.assertAllDefined=c;const S=Object.prototype.hasOwnProperty;function b(d){if(!A(d))return!1;for(let w in d)if(S.call(d,w))return!1;return!0}e.isEmptyObject=b;function g(d){return typeof d=="function"}e.isFunction=g;function I(...d){return d.length>0&&d.every(g)}e.areFunctions=I;function p(d,w){const T=Math.min(d.length,w.length);for(let O=0;O<T;O++)o(d[O],w[O])}e.validateConstraints=p;function o(d,w){if(L(w)){if(typeof d!==w)throw new Error(`argument does not match constraint: typeof ${w}`)}else if(g(w)){try{if(d instanceof w)return}catch{}if(!C(d)&&d.constructor===w||w.length===1&&w.call(void 0,d)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function a(d){let w=[],T=Object.getPrototypeOf(d);for(;Object.prototype!==T;)w=w.concat(Object.getOwnPropertyNames(T)),T=Object.getPrototypeOf(T);return w}e.getAllPropertyNames=a;function t(d){const w=[];for(const T of a(d))typeof d[T]=="function"&&w.push(T);return w}e.getAllMethodNames=t;function s(d,w){const T=y=>function(){const M=Array.prototype.slice.call(arguments,0);return w(y,M)};let O={};for(const y of d)O[y]=T(y);return O}e.createProxyObject=s;function n(d){return d===null?void 0:d}e.withNullAsUndefined=n;function r(d){return typeof d=="undefined"?null:d}e.withUndefinedAsNull=r;function u(d){return class{constructor(){return new Proxy({},{get(w,T){if(w[T])return w[T];throw new Error(`Not Implemented: ${d}->${String(T)}`)}})}}}e.NotImplementedProxy=u;function l(d,w="Unreachable"){throw new Error(w)}e.assertNever=l;function f(d){return!!d&&typeof d.then=="function"&&typeof d.catch=="function"}e.isPromise=f}),define(te[39],ne([0,1,8,4,24,16]),function(K,e,D,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(n){return n===47||n===92}e.isPathSeparator=k;function P(n){return n.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=P;function m(n){return n.indexOf("/")===-1&&(n=P(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=m;function E(n,r=D.posix.sep){if(!n)return"";const u=n.length,l=n.charCodeAt(0);if(k(l)){if(k(n.charCodeAt(1))&&!k(n.charCodeAt(2))){let d=3;const w=d;for(;d<u&&!k(n.charCodeAt(d));d++);if(w!==d&&!k(n.charCodeAt(d+1))){for(d+=1;d<u;d++)if(k(n.charCodeAt(d)))return n.slice(0,d+1).replace(/[\\/]/g,r)}}return r}else if(g(l)&&n.charCodeAt(1)===58)return k(n.charCodeAt(2))?n.slice(0,2)+r:n.slice(0,2);let f=n.indexOf("://");if(f!==-1){for(f+=3;f<u;f++)if(k(n.charCodeAt(f)))return n.slice(0,f+1)}return""}e.getRoot=E;function i(n){if(!L.isWindows||!n||n.length<5)return!1;let r=n.charCodeAt(0);if(r!==92||(r=n.charCodeAt(1),r!==92))return!1;let u=2;const l=u;for(;u<n.length&&(r=n.charCodeAt(u),r!==92);u++);return!(l===u||(r=n.charCodeAt(u+1),isNaN(r)||r===92))}e.isUNC=i;const C=/[\\/:\*\?"<>\|]/g,h=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(n,r=L.isWindows){const u=r?C:h;return!(!n||n.length===0||/^\s+$/.test(n)||(u.lastIndex=0,u.test(n))||r&&v.test(n)||n==="."||n===".."||r&&n[n.length-1]==="."||r&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=c;function S(n,r,u){const l=n===r;return!u||l?l:!n||!r?!1:(0,R.equalsIgnoreCase)(n,r)}e.isEqual=S;function b(n,r,u,l=D.sep){if(n===r)return!0;if(!n||!r||r.length>n.length)return!1;if(u){if(!(0,R.startsWithIgnoreCase)(n,r))return!1;if(r.length===n.length)return!0;let d=r.length;return r.charAt(r.length-1)===l&&d--,n.charAt(d)===l}return r.charAt(r.length-1)!==l&&(r+=l),n.indexOf(r)===0}e.isEqualOrParent=b;function g(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=g;function I(n,r){return L.isWindows&&n.endsWith(":")&&(n+=D.sep),(0,D.isAbsolute)(n)||(n=(0,D.join)(r,n)),n=(0,D.normalize)(n),L.isWindows?(n=(0,R.rtrim)(n,D.sep),n.endsWith(":")&&(n+=D.sep)):(n=(0,R.rtrim)(n,D.sep),n||(n=D.sep)),n}e.sanitizeFilePath=I;function p(n){const r=(0,D.normalize)(n);return L.isWindows?n.length>3?!1:o(r)&&(n.length===2||r.charCodeAt(2)===92):r===D.posix.sep}e.isRootOrDriveLetter=p;function o(n){return L.isWindows?g(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=o;function a(n){return o(n)?n[0]:void 0}e.getDriveLetter=a;function t(n,r,u){return r.length>n.length?-1:n===r?0:(u&&(n=n.toLowerCase(),r=r.toLowerCase()),n.indexOf(r))}e.indexOfPath=t;function s(n){const r=n.split(":");let u,l,f;if(r.forEach(d=>{const w=Number(d);(0,A.isNumber)(w)?l===void 0?l=w:f===void 0&&(f=w):u=u?[u,d].join(":"):d}),!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:l!==void 0?l:void 0,column:f!==void 0?f:l!==void 0?1:void 0}}e.parseLineAndColumnAware=s}),define(te[26],ne([0,1,16]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(S){if(!S||typeof S!="object"||S instanceof RegExp)return S;const b=Array.isArray(S)?[]:{};return Object.keys(S).forEach(g=>{S[g]&&typeof S[g]=="object"?b[g]=L(S[g]):b[g]=S[g]}),b}e.deepClone=L;function R(S){if(!S||typeof S!="object")return S;const b=[S];for(;b.length>0;){const g=b.shift();Object.freeze(g);for(const I in g)if(A.call(g,I)){const p=g[I];typeof p=="object"&&!Object.isFrozen(p)&&b.push(p)}}return S}e.deepFreeze=R;const A=Object.prototype.hasOwnProperty;function k(S,b){return P(S,b,new Set)}e.cloneAndChange=k;function P(S,b,g){if((0,D.isUndefinedOrNull)(S))return S;const I=b(S);if(typeof I!="undefined")return I;if((0,D.isArray)(S)){const p=[];for(const o of S)p.push(P(o,b,g));return p}if((0,D.isObject)(S)){if(g.has(S))throw new Error("Cannot clone recursive data-structure");g.add(S);const p={};for(let o in S)A.call(S,o)&&(p[o]=P(S[o],b,g));return g.delete(S),p}return S}function m(S,b,g=!0){return(0,D.isObject)(S)?((0,D.isObject)(b)&&Object.keys(b).forEach(I=>{I in S?g&&((0,D.isObject)(S[I])&&(0,D.isObject)(b[I])?m(S[I],b[I],g):S[I]=b[I]):S[I]=b[I]}),S):b}e.mixin=m;function E(S,b){if(S===b)return!0;if(S==null||b===null||b===void 0||typeof S!=typeof b||typeof S!="object"||Array.isArray(S)!==Array.isArray(b))return!1;let g,I;if(Array.isArray(S)){if(S.length!==b.length)return!1;for(g=0;g<S.length;g++)if(!E(S[g],b[g]))return!1}else{const p=[];for(I in S)p.push(I);p.sort();const o=[];for(I in b)o.push(I);if(o.sort(),!E(p,o))return!1;for(g=0;g<p.length;g++)if(!E(S[p[g]],b[p[g]]))return!1}return!0}e.equals=E;function i(S){const b=new Set;return JSON.stringify(S,(g,I)=>{if((0,D.isObject)(I)||Array.isArray(I)){if(b.has(I))return"[Circular]";b.add(I)}return I})}e.safeStringify=i;function C(S,b,g){const I=b(S);return typeof I=="undefined"?g:I}e.getOrDefault=C;function h(S,b){const g=Object.create(null);return!S||!b||Object.keys(b).forEach(p=>{const o=S[p],a=b[p];E(o,a)||(g[p]=a)}),g}e.distinct=h;function v(S,b){const g=b.toLowerCase(),I=Object.keys(S).find(p=>p.toLowerCase()===g);return I?S[I]:S[b]}e.getCaseInsensitive=v;function c(S,b){const g=Object.create(null);for(const I of Object.keys(S))b(I,S[I])&&(g[I]=S[I]);return g}e.filter=c}),define(te[5],ne([0,1,8,4]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const R=/^\w[\w\d+.-]*$/,A=/^\//,k=/^\/\//;function P(n,r){if(!n.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!R.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!A.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function m(n,r){return!n&&!r?"file":n}function E(n,r){switch(n){case"https":case"http":case"file":r?r[0]!==C&&(r=C+r):r=C;break}return r}const i="",C="/",h=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{constructor(r,u,l,f,d,w=!1){typeof r=="object"?(this.scheme=r.scheme||i,this.authority=r.authority||i,this.path=r.path||i,this.query=r.query||i,this.fragment=r.fragment||i):(this.scheme=m(r,w),this.authority=u||i,this.path=E(this.scheme,l||i),this.query=f||i,this.fragment=d||i,P(this,w))}static isUri(r){return r instanceof v?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return p(this,!1)}with(r){if(!r)return this;let{scheme:u,authority:l,path:f,query:d,fragment:w}=r;return u===void 0?u=this.scheme:u===null&&(u=i),l===void 0?l=this.authority:l===null&&(l=i),f===void 0?f=this.path:f===null&&(f=i),d===void 0?d=this.query:d===null&&(d=i),w===void 0?w=this.fragment:w===null&&(w=i),u===this.scheme&&l===this.authority&&f===this.path&&d===this.query&&w===this.fragment?this:new S(u,l,f,d,w)}static parse(r,u=!1){const l=h.exec(r);return l?new S(l[2]||i,s(l[4]||i),s(l[5]||i),s(l[7]||i),s(l[9]||i),u):new S(i,i,i,i,i)}static file(r){let u=i;if(L.isWindows&&(r=r.replace(/\\/g,C)),r[0]===C&&r[1]===C){const l=r.indexOf(C,2);l===-1?(u=r.substring(2),r=C):(u=r.substring(2,l),r=r.substring(l)||C)}return new S("file",u,r,i,i)}static from(r){const u=new S(r.scheme,r.authority,r.path,r.query,r.fragment);return P(u,!0),u}static joinPath(r,...u){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return L.isWindows&&r.scheme==="file"?l=v.file(D.win32.join(p(r,!0),...u)).path:l=D.posix.join(r.path,...u),r.with({path:l})}toString(r=!1){return o(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof v)return r;{const u=new S(r);return u._formatted=r.external,u._fsPath=r._sep===c?r.fsPath:null,u}}else return r}}e.URI=v;const c=L.isWindows?1:void 0;class S extends v{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=p(this,!1)),this._fsPath}toString(r=!1){return r?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=c),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function g(n,r){let u,l=-1;for(let f=0;f<n.length;f++){const d=n.charCodeAt(f);if(d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57||d===45||d===46||d===95||d===126||r&&d===47)l!==-1&&(u+=encodeURIComponent(n.substring(l,f)),l=-1),u!==void 0&&(u+=n.charAt(f));else{u===void 0&&(u=n.substr(0,f));const w=b[d];w!==void 0?(l!==-1&&(u+=encodeURIComponent(n.substring(l,f)),l=-1),u+=w):l===-1&&(l=f)}}return l!==-1&&(u+=encodeURIComponent(n.substring(l))),u!==void 0?u:n}function I(n){let r;for(let u=0;u<n.length;u++){const l=n.charCodeAt(u);l===35||l===63?(r===void 0&&(r=n.substr(0,u)),r+=b[l]):r!==void 0&&(r+=n[u])}return r!==void 0?r:n}function p(n,r){let u;return n.authority&&n.path.length>1&&n.scheme==="file"?u=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?r?u=n.path.substr(1):u=n.path[1].toLowerCase()+n.path.substr(2):u=n.path,L.isWindows&&(u=u.replace(/\//g,"\\")),u}e.uriToFsPath=p;function o(n,r){const u=r?I:g;let l="",{scheme:f,authority:d,path:w,query:T,fragment:O}=n;if(f&&(l+=f,l+=":"),(d||f==="file")&&(l+=C,l+=C),d){let y=d.indexOf("@");if(y!==-1){const M=d.substr(0,y);d=d.substr(y+1),y=M.indexOf(":"),y===-1?l+=u(M,!1):(l+=u(M.substr(0,y),!1),l+=":",l+=u(M.substr(y+1),!1)),l+="@"}d=d.toLowerCase(),y=d.indexOf(":"),y===-1?l+=u(d,!1):(l+=u(d.substr(0,y),!1),l+=d.substr(y))}if(w){if(w.length>=3&&w.charCodeAt(0)===47&&w.charCodeAt(2)===58){const y=w.charCodeAt(1);y>=65&&y<=90&&(w=`/${String.fromCharCode(y+32)}:${w.substr(3)}`)}else if(w.length>=2&&w.charCodeAt(1)===58){const y=w.charCodeAt(0);y>=65&&y<=90&&(w=`${String.fromCharCode(y+32)}:${w.substr(2)}`)}l+=u(w,!0)}return T&&(l+="?",l+=u(T,!1)),O&&(l+="#",l+=r?O:g(O,!1)),l}function a(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+a(n.substr(3)):n}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(n){return n.match(t)?n.replace(t,r=>a(r)):n}}),define(te[93],ne([0,1,5]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(E){const i=E;return i&&typeof i.type=="string"&&typeof i.severity=="string"}e.isRemoteConsoleLog=L;function R(E){const i=[];let C;try{const h=JSON.parse(E.arguments),v=h[h.length-1];v&&v.__$stack&&(h.pop(),C=v.__$stack),i.push(...h)}catch(h){i.push("Unable to log remote console arguments",E.arguments)}return{args:i,stack:C}}e.parse=R;function A(E){if(typeof E!="string")return A(R(E).stack);const i=E;if(i){const C=k(i),h=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(h&&h.length===4)return{uri:D.URI.file(h[1]),line:Number(h[2]),column:Number(h[3])}}}e.getFirstFrame=A;function k(E){if(!E)return E;const i=E.indexOf(`
`);return i===-1?E:E.substring(0,i)}function P(E,i){const{args:C,stack:h}=R(E),v=typeof C[0]=="string"&&C.length===1;let c=k(h);c&&(c=`(${c.trim()})`);let S=[];if(typeof C[0]=="string"?c&&v?S=[`%c[${i}] %c${C[0]} %c${c}`,m("blue"),m(""),m("grey")]:S=[`%c[${i}] %c${C[0]}`,m("blue"),m(""),...C.slice(1)]:S=[`%c[${i}]%`,m("blue"),...C],c&&!v&&S.push(c),typeof console[E.severity]!="function")throw new Error("Unknown console method");console[E.severity].apply(console,S)}e.log=P;function m(E){return`color: ${E}`}});var ht=this&&this.__classPrivateFieldSet||function(K,e,D,L,R){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!R)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!R:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?R.call(K,D):R?R.value=D:e.set(K,D),D},ze=this&&this.__classPrivateFieldGet||function(K,e,D,L){if(D==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!L:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?L:D==="a"?L.call(K):L?L.value:e.get(K)};define(te[40],ne([0,1,18,24,5]),function(K,e,D,L,R){"use strict";var A,k,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function m(s,n,r){let u=s.get(n);return u===void 0&&(u=r,s.set(n,u)),u}e.getOrSet=m;function E(s){const n=[];return s.forEach((r,u)=>{n.push(`${u} => ${r}`)}),`Map(${s.size}) {${n.join(", ")}}`}e.mapToString=E;function i(s){const n=[];return s.forEach(r=>{n.push(r)}),`Set(${s.size}) {${n.join(", ")}}`}e.setToString=i;class C{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const r=n.charCodeAt(0),u=this._value.charCodeAt(this._pos);return r-u}value(){return this._value[this._pos]}}e.StringIterator=C;class h{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,L.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=h;class v{constructor(n=!0,r=!0){this._splitOnBackslash=n,this._caseSensitive=r}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,L.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=v;var c;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(c||(c={}));class S{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new v(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,L.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=S;class b{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class g{constructor(n){this._iter=n}static forUris(n=()=>!1){return new g(new S(n))}static forPaths(){return new g(new v)}static forStrings(){return new g(new C)}static forConfigKeys(){return new g(new h)}clear(){this._root=void 0}set(n,r){const u=this._iter.reset(n);let l;for(this._root||(this._root=new b,this._root.segment=u.value()),l=this._root;;){const d=u.cmp(l.segment);if(d>0)l.left||(l.left=new b,l.left.segment=u.value()),l=l.left;else if(d<0)l.right||(l.right=new b,l.right.segment=u.value()),l=l.right;else if(u.hasNext())u.next(),l.mid||(l.mid=new b,l.mid.segment=u.value()),l=l.mid;else break}const f=l.value;return l.value=r,l.key=n,f}fill(n,r){const u=r.slice(0);(0,D.shuffle)(u);for(let l of u)this.set(l,n)}get(n){return this._getNode(n)?.value}_getNode(n){const r=this._iter.reset(n);let u=this._root;for(;u;){const l=r.cmp(u.segment);if(l>0)u=u.left;else if(l<0)u=u.right;else if(r.hasNext())r.next(),u=u.mid;else break}return u}has(n){const r=this._getNode(n);return!(r?.value===void 0&&r?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,r){const u=this._iter.reset(n),l=[];let f=this._root;for(;f;){const d=u.cmp(f.segment);if(d>0)l.push([1,f]),f=f.left;else if(d<0)l.push([-1,f]),f=f.right;else if(u.hasNext())u.next(),l.push([0,f]),f=f.mid;else{for(r?(f.left=void 0,f.mid=void 0,f.right=void 0):f.value=void 0;l.length>0&&f.isEmpty();){let[w,T]=l.pop();switch(w){case 1:T.left=void 0;break;case 0:T.mid=void 0;break;case-1:T.right=void 0;break}f=T}break}}}findSubstr(n){const r=this._iter.reset(n);let u=this._root,l;for(;u;){const f=r.cmp(u.segment);if(f>0)u=u.left;else if(f<0)u=u.right;else if(r.hasNext())r.next(),l=u.value||l,u=u.mid;else break}return u&&u.value||l}findSuperstr(n){const r=this._iter.reset(n);let u=this._root;for(;u;){const l=r.cmp(u.segment);if(l>0)u=u.left;else if(l<0)u=u.right;else if(r.hasNext())r.next(),u=u.mid;else return u.mid?this._entries(u.mid):void 0}}forEach(n){for(const[r,u]of this)n(u,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){if(!n)return;const r=[n];for(;r.length>0;){const u=r.pop();u&&(u.value&&(yield[u.key,u.value]),u.left&&r.push(u.left),u.mid&&r.push(u.mid),u.right&&r.push(u.right))}}}e.TernarySearchTree=g;class I{constructor(n,r){this[A]="ResourceMap",n instanceof I?(this.map=new Map(n.map),this.toKey=r??I.defaultToKey):(this.map=new Map,this.toKey=n??I.defaultToKey)}set(n,r){return this.map.set(this.toKey(n),r),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,r){typeof r!="undefined"&&(n=n.bind(r));for(let[u,l]of this.map)n(l,R.URI.parse(u),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield R.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[R.URI.parse(n[0]),n[1]]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[R.URI.parse(n[0]),n[1]]}}e.ResourceMap=I,I.defaultToKey=s=>s.toString();var p;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(p=e.Touch||(e.Touch={}));class o{constructor(){this[k]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,r=0){const u=this._map.get(n);if(!!u)return r!==0&&this.touch(u,r),u.value}set(n,r,u=0){let l=this._map.get(n);if(l)l.value=r,u!==0&&this.touch(l,u);else{switch(l={key:n,value:r,next:void 0,previous:void 0},u){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(n,l),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const r=this._map.get(n);if(!!r)return this._map.delete(n),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,r){const u=this._state;let l=this._head;for(;l;){if(r?n.bind(r)(l.value,l.key,this):n(l.value,l.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const n=this,r=this._state;let u=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(u){const f={value:u.key,done:!1};return u=u.next,f}else return{value:void 0,done:!0}}};return l}values(){const n=this,r=this._state;let u=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(u){const f={value:u.value,done:!1};return u=u.next,f}else return{value:void 0,done:!0}}};return l}entries(){const n=this,r=this._state;let u=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(u){const f={value:[u.key,u.value],done:!1};return u=u.next,f}else return{value:void 0,done:!0}}};return l}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let r=this._head,u=this.size;for(;r&&u>n;)this._map.delete(r.key),r=r.next,u--;this._head=r,this._size=u,r&&(r.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const r=n.next,u=n.previous;if(!r||!u)throw new Error("Invalid list");r.previous=u,u.next=r}n.next=void 0,n.previous=void 0,this._state++}touch(n,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(n===this._head)return;const u=n.next,l=n.previous;n===this._tail?(l.next=void 0,this._tail=l):(u.previous=l,l.next=u),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(r===2){if(n===this._tail)return;const u=n.next,l=n.previous;n===this._head?(u.previous=void 0,this._head=u):(u.previous=l,l.next=u),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((r,u)=>{n.push([u,r])}),n}fromJSON(n){this.clear();for(const[r,u]of n)this.set(r,u)}}e.LinkedMap=o;class a extends o{constructor(n,r=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,r=2){return super.get(n,r)}peek(n){return super.get(n,0)}set(n,r){return super.set(n,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a;class t{constructor(n){P.set(this,void 0),ht(this,P,n,"f")}get size(){return ze(this,P,"f").size}forEach(n,r){ze(this,P,"f").forEach(n,r)}get(n){return ze(this,P,"f").get(n)}has(n){return ze(this,P,"f").has(n)}entries(){return ze(this,P,"f").entries()}keys(){return ze(this,P,"f").keys()}values(){return ze(this,P,"f").values()}[(P=new WeakMap,Symbol.iterator)](){return ze(this,P,"f").entries()}}e.ReadonlyMapView=t}),define(te[94],ne([0,1,25,24,5]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function A(i){return JSON.stringify(i,m)}e.stringify=A;function k(i){let C=JSON.parse(i);return C=E(C),C}e.parse=k;var P;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadReply=8]="CommentThreadReply",i[i.CommentNode=9]="CommentNode",i[i.CommentThreadNode=10]="CommentThreadNode",i[i.TimelineActionContext=11]="TimelineActionContext",i[i.NotebookCellActionContext=12]="NotebookCellActionContext",i[i.TestItemContext=13]="TestItemContext"})(P=e.MarshalledId||(e.MarshalledId={}));function m(i,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,L.regExpFlags)(C)}:C}function E(i,C=0){if(!i||C>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return R.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof D.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let h=0;h<i.length;++h)i[h]=E(i[h],C+1);else for(const h in i)Object.hasOwnProperty.call(i,h)&&(i[h]=E(i[h],C+1))}return i}e.revive=E}),define(te[17],ne([0,1,4,5]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var R;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp"})(R=e.Schemas||(e.Schemas={}));class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(m){this._preferredWebSchema=m}setDelegate(m){this._delegate=m}set(m,E,i){this._hosts[m]=E,this._ports[m]=i}setConnectionToken(m,E){this._connectionTokens[m]=E}rewrite(m){if(this._delegate)return this._delegate(m);const E=m.authority;let i=this._hosts[E];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const C=this._ports[E],h=this._connectionTokens[E];let v=`path=${encodeURIComponent(m.path)}`;return typeof h=="string"&&(v+=`&tkn=${encodeURIComponent(h)}`),L.URI.from({scheme:D.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${i}:${C}`,path:"/vscode-remote-resource",query:v})}}e.RemoteAuthorities=new A;class k{asBrowserUri(m,E){const i=this.toUri(m,E);return i.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(i):i.scheme===R.file&&(D.isNative||typeof D.globals.importScripts=="function"&&D.globals.origin===`${R.vscodeFileResource}://${k.FALLBACK_AUTHORITY}`)?i.with({scheme:R.vscodeFileResource,authority:i.authority||k.FALLBACK_AUTHORITY,query:null,fragment:null}):i}asFileUri(m,E){const i=this.toUri(m,E);return i.scheme===R.vscodeFileResource?i.with({scheme:R.file,authority:i.authority!==k.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(m,E){return L.URI.isUri(m)?m:L.URI.parse(E.toUrl(m))}}k.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new k}),define(te[66],ne([0,1,40]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new D.LRUCache(1e4);function R(E){return m(E,"NFC",L)}e.normalizeNFC=R;const A=new D.LRUCache(1e4);function k(E){return m(E,"NFD",A)}e.normalizeNFD=k;const P=/[^\u0000-\u0080]/;function m(E,i,C){if(!E)return E;const h=C.get(E);if(h)return h;let v;return P.test(E)?v=E.normalize(i):v=E,C.set(E,v),v}e.removeAccents=function(){const E=/[\u0300-\u036f]/g;return function(i){return k(i).replace(E,"")}}()}),define(te[15],ne([0,1,39,17,8,4,24,5]),function(K,e,D,L,R,A,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function m(v){return(0,P.uriToFsPath)(v,!0)}e.originalFSPath=m;class E{constructor(c){this._ignorePathCasing=c}compare(c,S,b=!1){return c===S?0:(0,k.compare)(this.getComparisonKey(c,b),this.getComparisonKey(S,b))}isEqual(c,S,b=!1){return c===S?!0:!c||!S?!1:this.getComparisonKey(c,b)===this.getComparisonKey(S,b)}getComparisonKey(c,S=!1){return c.with({path:this._ignorePathCasing(c)?c.path.toLowerCase():void 0,fragment:S?null:void 0}).toString()}ignorePathCasing(c){return this._ignorePathCasing(c)}isEqualOrParent(c,S,b=!1){if(c.scheme===S.scheme){if(c.scheme===L.Schemas.file)return D.isEqualOrParent(m(c),m(S),this._ignorePathCasing(c))&&c.query===S.query&&(b||c.fragment===S.fragment);if((0,e.isEqualAuthority)(c.authority,S.authority))return D.isEqualOrParent(c.path,S.path,this._ignorePathCasing(c),"/")&&c.query===S.query&&(b||c.fragment===S.fragment)}return!1}joinPath(c,...S){return P.URI.joinPath(c,...S)}basenameOrAuthority(c){return(0,e.basename)(c)||c.authority}basename(c){return R.posix.basename(c.path)}extname(c){return R.posix.extname(c.path)}dirname(c){if(c.path.length===0)return c;let S;return c.scheme===L.Schemas.file?S=P.URI.file(R.dirname(m(c))).path:(S=R.posix.dirname(c.path),c.authority&&S.length&&S.charCodeAt(0)!==47&&(console.error(`dirname("${c.toString})) resulted in a relative path`),S="/")),c.with({path:S})}normalizePath(c){if(!c.path.length)return c;let S;return c.scheme===L.Schemas.file?S=P.URI.file(R.normalize(m(c))).path:S=R.posix.normalize(c.path),c.with({path:S})}relativePath(c,S){if(c.scheme!==S.scheme||!(0,e.isEqualAuthority)(c.authority,S.authority))return;if(c.scheme===L.Schemas.file){const I=R.relative(m(c),m(S));return A.isWindows?D.toSlashes(I):I}let b=c.path||"/",g=S.path||"/";if(this._ignorePathCasing(c)){let I=0;for(const p=Math.min(b.length,g.length);I<p&&!(b.charCodeAt(I)!==g.charCodeAt(I)&&b.charAt(I).toLowerCase()!==g.charAt(I).toLowerCase());I++);b=g.substr(0,I)+b.substr(I)}return R.posix.relative(b,g)}resolvePath(c,S){if(c.scheme===L.Schemas.file){const b=P.URI.file(R.resolve(m(c),S));return c.with({authority:b.authority,path:b.path})}return S=D.toPosixPath(S),c.with({path:R.posix.resolve(c.path,S)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,S){return c===S||(0,k.equalsIgnoreCase)(c,S)}hasTrailingPathSeparator(c,S=R.sep){if(c.scheme===L.Schemas.file){const b=m(c);return b.length>D.getRoot(b).length&&b[b.length-1]===S}else{const b=c.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,S=R.sep){return(0,e.hasTrailingPathSeparator)(c,S)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,S=R.sep){let b=!1;if(c.scheme===L.Schemas.file){const g=m(c);b=g!==void 0&&g.length===D.getRoot(g).length&&g[g.length-1]===S}else{S="/";const g=c.path;b=g.length===1&&g.charCodeAt(g.length-1)===47}return!b&&!(0,e.hasTrailingPathSeparator)(c,S)?c.with({path:c.path+"/"}):c}}e.ExtUri=E,e.extUri=new E(()=>!1),e.extUriBiasedIgnorePathCase=new E(v=>v.scheme===L.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new E(v=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(v,c){const S=[];for(let b=0;b<v.length;b++){const g=c(v[b]);v.some((I,p)=>p===b?!1:(0,e.isEqualOrParent)(g,c(I)))||S.push(v[b])}return S}e.distinctParents=i;var C;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function c(S){const b=new Map;S.path.substring(S.path.indexOf(";")+1,S.path.lastIndexOf(";")).split(";").forEach(p=>{const[o,a]=p.split(":");o&&a&&b.set(o,a)});const I=S.path.substring(0,S.path.indexOf(";"));return I&&b.set(v.META_DATA_MIME,I),b}v.parseMetaData=c})(C=e.DataUri||(e.DataUri={}));function h(v,c,S){if(c){let b=v.path;return b&&b[0]!==R.posix.sep&&(b=R.posix.sep+b),v.with({scheme:S,authority:c,path:b})}return v.with({scheme:S})}e.toLocalResource=h}),define(te[6],ne([0,1,29,11,3,2,15]),function(K,e,D,L,R,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function P(B){return!!B&&typeof B.then=="function"}e.isThenable=P;function m(B){const z=new D.CancellationTokenSource,j=B(z.token),N=new Promise((G,_)=>{const J=z.token.onCancellationRequested(()=>{J.dispose(),z.dispose(),_((0,L.canceled)())});Promise.resolve(j).then(Y=>{J.dispose(),z.dispose(),G(Y)},Y=>{J.dispose(),z.dispose(),_(Y)})});return new class{cancel(){z.cancel()}then(G,_){return N.then(G,_)}catch(G){return this.then(void 0,G)}finally(G){return N.finally(G)}}}e.createCancelablePromise=m;function E(B,z,j){return Promise.race([B,new Promise(N=>z.onCancellationRequested(()=>N(j)))])}e.raceCancellation=E;async function i(B){let z=-1;const j=B.map((G,_)=>G.then(J=>(z=_,J))),N=await Promise.race(j);return B.forEach((G,_)=>{_!==z&&G.cancel()}),N}e.raceCancellablePromises=i;function C(B,z,j){let N;const G=setTimeout(()=>{N?.(void 0),j?.()},z);return Promise.race([B.finally(()=>clearTimeout(G)),new Promise(_=>N=_)])}e.raceTimeout=C;function h(B){return new Promise((z,j)=>{const N=B();P(N)?N.then(z,j):z(N)})}e.asPromise=h;class v{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(z){if(this.activePromise){if(this.queuedPromiseFactory=z,!this.queuedPromise){const j=()=>{this.queuedPromise=null;const N=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,N};this.queuedPromise=new Promise(N=>{this.activePromise.then(j,j).then(N)})}return new Promise((j,N)=>{this.queuedPromise.then(j,N)})}return this.activePromise=z(),new Promise((j,N)=>{this.activePromise.then(G=>{this.activePromise=null,j(G)},G=>{this.activePromise=null,N(G)})})}}e.Throttler=v;class c{constructor(){this.current=Promise.resolve(null)}queue(z){return this.current=this.current.then(()=>z(),()=>z())}}e.Sequencer=c;class S{constructor(){this.promiseMap=new Map}queue(z,j){const G=(this.promiseMap.get(z)??Promise.resolve()).catch(()=>{}).then(j).finally(()=>{this.promiseMap.get(z)===G&&this.promiseMap.delete(z)});return this.promiseMap.set(z,G),G}}e.SequencerByKey=S;class b{constructor(z){this.defaultDelay=z,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(z,j=this.defaultDelay){return this.task=z,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((N,G)=>{this.doResolve=N,this.doReject=G}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const N=this.task;return this.task=null,N()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},j),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=b;class g{constructor(z){this.delayer=new b(z),this.throttler=new v}trigger(z,j){return this.delayer.trigger(()=>this.throttler.queue(z),j)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=g;class I{constructor(){this._isOpen=!1,this._promise=new Promise((z,j)=>{this._completePromise=z})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=I;class p extends I{constructor(z){super();this._timeout=setTimeout(()=>this.open(),z)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=p;function o(B,z){return z?new Promise((j,N)=>{const G=setTimeout(()=>{_.dispose(),j()},B),_=z.onCancellationRequested(()=>{clearTimeout(G),_.dispose(),N((0,L.canceled)())})}):m(j=>o(B,j))}e.timeout=o;function a(B,z=0){const j=setTimeout(B,z);return(0,A.toDisposable)(()=>clearTimeout(j))}e.disposableTimeout=a;function t(B){const z=[];let j=0;const N=B.length;function G(){return j<N?B[j++]():null}function _(J){J!=null&&z.push(J);const Y=G();return Y?Y.then(_):Promise.resolve(z)}return Promise.resolve(null).then(_)}e.sequence=t;function s(B,z=N=>!!N,j=null){let N=0;const G=B.length,_=()=>{if(N>=G)return Promise.resolve(j);const J=B[N++];return Promise.resolve(J()).then(H=>z(H)?Promise.resolve(H):_())};return _()}e.first=s;function n(B,z=N=>!!N,j=null){if(B.length===0)return Promise.resolve(j);let N=B.length;const G=()=>{N=-1;for(const _ of B)_.cancel?.()};return new Promise((_,J)=>{for(const Y of B)Y.then(H=>{--N>=0&&z(H)?(G(),_(H)):N===0&&_(j)}).catch(H=>{--N>=0&&(G(),J(H))})})}e.firstParallel=n;class r{constructor(z){this._size=0,this.maxDegreeOfParalellism=z,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new R.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(z){return this._size++,new Promise((j,N)=>{this.outstandingPromises.push({factory:z,c:j,e:N}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const z=this.outstandingPromises.shift();this.runningPromises++;const j=z.factory();j.then(z.c,z.e),j.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=r;class u extends r{constructor(){super(1)}}e.Queue=u;class l{constructor(){this.queues=new Map}queueFor(z,j=k.extUri){const N=j.getComparisonKey(z);let G=this.queues.get(N);return G||(G=new u,R.Event.once(G.onFinished)(()=>{G?.dispose(),this.queues.delete(N)}),this.queues.set(N,G)),G}dispose(){this.queues.forEach(z=>z.dispose()),this.queues.clear()}}e.ResourceQueue=l;class f{constructor(z,j){this._token=-1,typeof z=="function"&&typeof j=="number"&&this.setIfNotSet(z,j)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(z,j){this.cancel(),this._token=setTimeout(()=>{this._token=-1,z()},j)}setIfNotSet(z,j){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,z()},j))}}e.TimeoutTimer=f;class d{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(z,j){this.cancel(),this._token=setInterval(()=>{z()},j)}}e.IntervalTimer=d;class w{constructor(z,j){this.timeoutToken=-1,this.runner=z,this.timeout=j,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(z=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,z)}get delay(){return this.timeout}set delay(z){this.timeout=z}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=w;class T{constructor(z,j){j%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${j}ms is not a multiple of 1000ms.`),this.runner=z,this.timeout=j,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(z=this.timeout){z%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${z}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(z/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=T;class O extends w{constructor(z,j){super(z,j);this.units=[]}work(z){this.units.push(z),this.isScheduled()||this.schedule()}doRun(){const z=this.units;this.units=[],this.runner&&this.runner(z)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=O;class y extends A.Disposable{constructor(z,j,N,G){super();this.maxWorkChunkSize=z,this.maxPendingWork=j,this.throttleDelay=N,this.handler=G,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(z){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+z.length>this.maxPendingWork)return!1}else if(this.pending+z.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...z),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new w(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=y,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const B=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=z=>{const j=setTimeout(()=>z(B));let N=!1;return{dispose(){N||(N=!0,clearTimeout(j))}}}}else e.runWhenIdle=(B,z)=>{const j=requestIdleCallback(B,typeof z=="number"?{timeout:z}:void 0);let N=!1;return{dispose(){N||(N=!0,cancelIdleCallback(j))}}}}();class M{constructor(z){this._didRun=!1,this._executor=()=>{try{this._value=z()}catch(j){this._error=j}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=M;async function F(B,z,j){let N;for(let G=0;G<j;G++)try{return await B()}catch(_){N=_,await o(z)}throw N}e.retry=F;class q{hasPending(z){return this._pending?typeof z=="number"?this._pending.taskId===z:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(z,j,N){return this._pending={taskId:z,cancel:()=>N?.(),promise:j},j.then(()=>this.donePending(z),()=>this.donePending(z)),j}donePending(z){this._pending&&z===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const z=this._next;this._next=void 0,z.run().then(z.promiseResolve,z.promiseReject)}}setNext(z){if(this._next)this._next.run=z;else{let j,N;const G=new Promise((_,J)=>{j=_,N=J});this._next={run:z,promise:G,promiseResolve:j,promiseReject:N}}return this._next.promise}}e.TaskSequentializer=q;class x{constructor(z){this.interval=z,this.lastIncrementTime=0,this.value=0}increment(){const z=Date.now();return z-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=z,this.value=0),this.value++,this.value}}e.IntervalCounter=x;class U{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((z,j)=>{this.completeCallback=z,this.errorCallback=j})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(z){return new Promise(j=>{this.completeCallback(z),this.resolved=!0,j()})}error(z){return new Promise(j=>{this.errorCallback(z),this.rejected=!0,j()})}cancel(){new Promise(z=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,z()})}}e.DeferredPromise=U;var $;(function(B){async function z(j){let N;const G=await Promise.all(j.map(_=>_.then(J=>J,J=>{N||(N=J)})));if(typeof N!="undefined")throw N;return G}B.settled=z})($=e.Promises||(e.Promises={}))}),define(te[67],ne([0,1,6,39,40,8,24]),function(K,e,D,L,R,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const m="**",E="/",i="[/\\\\]",C="[^/\\\\]",h=/\//g;function v(N){switch(N){case 0:return"";case 1:return`${C}*?`;default:return`(?:${i}|${C}+${i}|${i}${C}+)*?`}}function c(N,G){if(!N)return[];const _=[];let J=!1,Y=!1,H="";for(const W of N){switch(W){case G:if(!J&&!Y){_.push(H),H="";continue}break;case"{":J=!0;break;case"}":J=!1;break;case"[":Y=!0;break;case"]":Y=!1;break}H+=W}return H&&_.push(H),_}e.splitGlobAware=c;function S(N){if(!N)return"";let G="";const _=c(N,E);if(_.every(J=>J===m))G=".*";else{let J=!1;_.forEach((Y,H)=>{if(Y===m){J||(G+=v(2),J=!0);return}let W=!1,Z="",X=!1,re="";for(const oe of Y){if(oe!=="}"&&W){Z+=oe;continue}if(X&&(oe!=="]"||!re)){let ue;oe==="-"?ue=oe:(oe==="^"||oe==="!")&&!re?ue="^":oe===E?ue="":ue=k.escapeRegExpCharacters(oe),re+=ue;continue}switch(oe){case"{":W=!0;continue;case"[":X=!0;continue;case"}":G+=`(?:${c(Z,",").map(Se=>S(Se)).join("|")})`,W=!1,Z="";break;case"]":G+="["+re+"]",X=!1,re="";break;case"?":G+=C;continue;case"*":G+=v(1);continue;default:G+=k.escapeRegExpCharacters(oe)}}H<_.length-1&&(_[H+1]!==m||H+2<_.length)&&(G+=i),J=!1})}return G}const b=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,I=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,p=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.LRUCache(1e4),s=function(){return!1},n=function(){return null};function r(N,G){if(!N)return n;let _;typeof N!="string"?_=N.pattern:_=N,_=_.trim();const J=`${_}_${!!G.trimForExclusions}`;let Y=t.get(J);if(Y)return u(Y,N);let H;if(b.test(_)){const W=_.substr(4);Y=function(Z,X){return typeof Z=="string"&&Z.endsWith(W)?_:null}}else(H=g.exec(l(_,G)))?Y=f(H[1],_):(G.trimForExclusions?p:I).test(_)?Y=d(_,G):(H=o.exec(l(_,G)))?Y=w(H[1].substr(1),_,!0):(H=a.exec(l(_,G)))?Y=w(H[1],_,!1):Y=T(_);return t.set(J,Y),u(Y,N)}function u(N,G){return typeof G=="string"?N:function(_,J){return L.isEqualOrParent(_,G.base)?N(A.relative(G.base,_),J):null}}function l(N,G){return G.trimForExclusions&&N.endsWith("/**")?N.substr(0,N.length-2):N}function f(N,G){const _=`/${N}`,J=`\\${N}`,Y=function(W,Z){return typeof W!="string"?null:Z?Z===N?G:null:W===N||W.endsWith(_)||W.endsWith(J)?G:null},H=[N];return Y.basenames=H,Y.patterns=[G],Y.allBasenames=H,Y}function d(N,G){const _=j(N.slice(1,-1).split(",").map(Z=>r(Z,G)).filter(Z=>Z!==n),N),J=_.length;if(!J)return n;if(J===1)return _[0];const Y=function(Z,X){for(let re=0,oe=_.length;re<oe;re++)if(_[re](Z,X))return N;return null},H=_.find(Z=>!!Z.allBasenames);H&&(Y.allBasenames=H.allBasenames);const W=_.reduce((Z,X)=>X.allPaths?Z.concat(X.allPaths):Z,[]);return W.length&&(Y.allPaths=W),Y}function w(N,G,_){const J=A.sep===A.posix.sep,Y=J?N:N.replace(h,A.sep),H=A.sep+Y,W=A.posix.sep+N,Z=_?function(X,re){return typeof X=="string"&&(X===Y||X.endsWith(H)||!J&&(X===N||X.endsWith(W)))?G:null}:function(X,re){return typeof X=="string"&&(X===Y||!J&&X===N)?G:null};return Z.allPaths=[(_?"*/":"./")+N],Z}function T(N){try{const G=new RegExp(`^${S(N)}$`);return function(_){return G.lastIndex=0,typeof _=="string"&&G.test(_)?N:null}}catch(G){return n}}function O(N,G,_){return!N||typeof G!="string"?!1:y(N)(G,void 0,_)}e.match=O;function y(N,G={}){if(!N)return s;if(typeof N=="string"||x(N)){const _=r(N,G);if(_===n)return s;const J=function(Y,H){return!!_(Y,H)};return _.allBasenames&&(J.allBasenames=_.allBasenames),_.allPaths&&(J.allPaths=_.allPaths),J}return B(N,G)}e.parse=y;function M(N){if(!N)return;let G;return _=>(G||(G=(N()||Promise.resolve([])).then(J=>J?q(J):{})),G.then(J=>!!J[_]))}e.hasSiblingPromiseFn=M;function F(N){if(!N)return;let G;return _=>{if(!G){const J=N();G=J?q(J):{}}return!!G[_]}}e.hasSiblingFn=F;function q(N){const G={};for(const _ of N)G[_]=!0;return G}function x(N){const G=N;return G&&typeof G.base=="string"&&typeof G.pattern=="string"}e.isRelativePattern=x;function U(N){return N.allBasenames||[]}e.getBasenameTerms=U;function $(N){return N.allPaths||[]}e.getPathTerms=$;function B(N,G){const _=j(Object.getOwnPropertyNames(N).map(Z=>z(Z,N[Z],G)).filter(Z=>Z!==n)),J=_.length;if(!J)return n;if(!_.some(Z=>!!Z.requiresSiblings)){if(J===1)return _[0];const Z=function(oe,ue){for(let le=0,Se=_.length;le<Se;le++){const Ee=_[le](oe,ue);if(Ee)return Ee}return null},X=_.find(oe=>!!oe.allBasenames);X&&(Z.allBasenames=X.allBasenames);const re=_.reduce((oe,ue)=>ue.allPaths?oe.concat(ue.allPaths):oe,[]);return re.length&&(Z.allPaths=re),Z}const Y=function(Z,X,re){let oe;for(let ue=0,le=_.length;ue<le;ue++){const Se=_[ue];Se.requiresSiblings&&re&&(X||(X=A.basename(Z)),oe||(oe=X.substr(0,X.length-A.extname(Z).length)));const Ee=Se(Z,X,oe,re);if(Ee)return Ee}return null},H=_.find(Z=>!!Z.allBasenames);H&&(Y.allBasenames=H.allBasenames);const W=_.reduce((Z,X)=>X.allPaths?Z.concat(X.allPaths):Z,[]);return W.length&&(Y.allPaths=W),Y}function z(N,G,_){if(G===!1)return n;const J=r(N,_);if(J===n)return n;if(typeof G=="boolean")return J;if(G){const Y=G.when;if(typeof Y=="string"){const H=(W,Z,X,re)=>{if(!re||!J(W,Z))return null;const oe=Y.replace("$(basename)",X),ue=re(oe);return(0,D.isThenable)(ue)?ue.then(le=>le?N:null):ue?N:null};return H.requiresSiblings=!0,H}}return J}function j(N,G){const _=N.filter(Z=>!!Z.basenames);if(_.length<2)return N;const J=_.reduce((Z,X)=>{const re=X.basenames;return re?Z.concat(re):Z},[]);let Y;if(G){Y=[];for(let Z=0,X=J.length;Z<X;Z++)Y.push(G)}else Y=_.reduce((Z,X)=>{const re=X.patterns;return re?Z.concat(re):Z},[]);const H=function(Z,X){if(typeof Z!="string")return null;if(!X){let oe;for(oe=Z.length;oe>0;oe--){const ue=Z.charCodeAt(oe-1);if(ue===47||ue===92)break}X=Z.substr(oe)}const re=J.indexOf(X);return re!==-1?Y[re]:null};H.basenames=J,H.patterns=Y,H.allBasenames=J;const W=N.filter(Z=>!Z.basenames);return W.push(H),W}}),define(te[95],ne([0,1,67,17,8,15,24]),function(K,e,D,L,R,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var P;(function(r){r.text="text/plain",r.binary="application/octet-stream",r.unknown="application/unknown",r.markdown="text/markdown"})(P=e.Mimes||(e.Mimes={}));let m=[],E=[],i=[];function C(r,u=!1){const l=h(r);m.push(l),l.userConfigured?i.push(l):E.push(l),u&&!l.userConfigured&&m.forEach(f=>{f.mime===l.mime||f.userConfigured||(l.extension&&f.extension===l.extension&&console.warn(`Overwriting extension <<${l.extension}>> to now point to mime <<${l.mime}>>`),l.filename&&f.filename===l.filename&&console.warn(`Overwriting filename <<${l.filename}>> to now point to mime <<${l.mime}>>`),l.filepattern&&f.filepattern===l.filepattern&&console.warn(`Overwriting filepattern <<${l.filepattern}>> to now point to mime <<${l.mime}>>`),l.firstline&&f.firstline===l.firstline&&console.warn(`Overwriting firstline <<${l.firstline}>> to now point to mime <<${l.mime}>>`))})}e.registerTextMime=C;function h(r){return{id:r.id,mime:r.mime,filename:r.filename,extension:r.extension,filepattern:r.filepattern,firstline:r.firstline,userConfigured:r.userConfigured,filenameLowercase:r.filename?r.filename.toLowerCase():void 0,extensionLowercase:r.extension?r.extension.toLowerCase():void 0,filepatternLowercase:r.filepattern?(0,D.parse)(r.filepattern.toLowerCase()):void 0,filepatternOnPath:r.filepattern?r.filepattern.indexOf(R.posix.sep)>=0:!1}}function v(r){r?(m=m.filter(u=>!u.userConfigured),i=[]):(m=[],E=[],i=[])}e.clearTextMimes=v;function c(r,u){let l;if(r)switch(r.scheme){case L.Schemas.file:l=r.fsPath;break;case L.Schemas.data:l=A.DataUri.parseMetaData(r).get(A.DataUri.META_DATA_LABEL);break;default:l=r.path}if(!l)return[P.unknown];l=l.toLowerCase();const f=(0,R.basename)(l),d=S(l,f,i);if(d)return[d,P.text];const w=S(l,f,E);if(w)return[w,P.text];if(u){const T=b(u);if(T)return[T,P.text]}return[P.unknown]}e.guessMimeTypes=c;function S(r,u,l){let f=null,d=null,w=null;for(let T=l.length-1;T>=0;T--){const O=l[T];if(u===O.filenameLowercase){f=O;break}if(O.filepattern&&(!d||O.filepattern.length>d.filepattern.length)){const y=O.filepatternOnPath?r:u;O.filepatternLowercase?.(y)&&(d=O)}O.extension&&(!w||O.extension.length>w.extension.length)&&u.endsWith(O.extensionLowercase)&&(w=O)}return f?f.mime:d?d.mime:w?w.mime:null}function b(r){if((0,k.startsWithUTF8BOM)(r)&&(r=r.substr(1)),r.length>0)for(let u=m.length-1;u>=0;u--){const l=m[u];if(!l.firstline)continue;const f=r.match(l.firstline);if(f&&f.length>0)return l.mime}return null}function g(r){return r?typeof r=="string"?r===P.binary||r===P.text||r===P.unknown:r.length===1&&g(r[0]):!0}e.isUnspecific=g;const I={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},p={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function o(r){const u=(0,R.extname)(r),l=I[u.toLowerCase()];return l!==void 0?l:a(r)}e.getMediaOrTextMime=o;function a(r){const u=(0,R.extname)(r);return p[u.toLowerCase()]}e.getMediaMime=a;function t(r){for(const u in p)if(p[u]===r)return u}e.getExtensionForMimeType=t;const s=/^(.+)\/(.+?)(;.+)?$/;function n(r,u){const l=s.exec(r);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:u?void 0:r}e.normalizeMimeType=n}),define(te[96],ne([0,1,5]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(i){return i.toJSON()}class R{constructor(C){this._uriTransformer=C}transformIncoming(C){const h=this._uriTransformer.transformIncoming(C);return h===C?C:L(D.URI.from(h))}transformOutgoing(C){const h=this._uriTransformer.transformOutgoing(C);return h===C?C:L(D.URI.from(h))}transformOutgoingURI(C){const h=this._uriTransformer.transformOutgoing(C);return h===C?C:D.URI.from(h)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function A(i,C,h){if(!i||h>200)return null;if(typeof i=="object"){if(i instanceof D.URI)return C.transformOutgoing(i);for(let v in i)if(Object.hasOwnProperty.call(i,v)){const c=A(i[v],C,h+1);c!==null&&(i[v]=c)}}return null}function k(i,C){const h=A(i,C,0);return h===null?i:h}e.transformOutgoingURIs=k;function P(i,C,h,v){if(!i||v>200)return null;if(typeof i=="object"){if(i.$mid===1)return h?D.URI.revive(C.transformIncoming(i)):C.transformIncoming(i);for(let c in i)if(Object.hasOwnProperty.call(i,c)){const S=P(i[c],C,h,v+1);S!==null&&(i[c]=S)}}return null}function m(i,C){const h=P(i,C,!1,0);return h===null?i:h}e.transformIncomingURIs=m;function E(i,C){const h=P(i,C,!0,0);return h===null?i:h}e.transformAndReviveIncomingURIs=E}),define(te[30],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(m){return D.test(m)}e.isUUID=L;const R=new Uint8Array(16),A=[];for(let m=0;m<256;m++)A.push(m.toString(16).padStart(2,"0"));let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(m){for(let E=0;E<m.length;E++)m[E]=Math.floor(Math.random()*256);return m};function P(){k(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let m=0,E="";return E+=A[R[m++]],E+=A[R[m++]],E+=A[R[m++]],E+=A[R[m++]],E+="-",E+=A[R[m++]],E+=A[R[m++]],E+="-",E+=A[R[m++]],E+=A[R[m++]],E+="-",E+=A[R[m++]],E+=A[R[m++]],E+="-",E+=A[R[m++]],E+=A[R[m++]],E+=A[R[m++]],E+=A[R[m++]],E+=A[R[m++]],E+=A[R[m++]],E}e.generateUuid=P}),define(te[68],ne([0,1,218]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(A="utf8"){this.stringDecoder=new D.StringDecoder(A),this.remaining=null}write(A){const k=[],P=this.remaining?this.remaining+this.stringDecoder.write(A):this.stringDecoder.write(A);if(P.length<1)return k;let m=0,E,i=m;for(;i<P.length;)if(E=P.charCodeAt(i),E===13||E===10){if(k.push(P.substring(m,i)),i++,i<P.length){const C=E;E=P.charCodeAt(i),(C===13&&E===10||C===10&&E===13)&&i++}m=i}else i++;return this.remaining=m<P.length?P.substr(m):null,k}end(){return this.remaining}}e.LineDecoder=L}),define(te[97],ne([0,1,35]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(P){const m=P.replace(/\-/g,":").toLowerCase();return!L.has(m)}function A(){return new Promise(async(P,m)=>{const E=setTimeout(()=>m("Unable to retrieve mac address (timeout after 10s)"),1e4);try{P(await k())}catch(i){m(i)}finally{clearTimeout(E)}})}e.getMac=A;function k(){return new Promise((P,m)=>{try{const E=(0,D.networkInterfaces)();for(let i in E){const C=E[i];if(C){for(const{mac:h}of C)if(R(h))return P(h)}}m("Unable to retrieve mac address (unexpected format)")}catch(E){m(E)}})}}),define(te[98],ne([0,1,35,11,40,30,97]),function(K,e,D,L,R,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(i){return this._virtualMachineOUIs||(this._virtualMachineOUIs=R.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(i)}value(){if(this._value===void 0){let i=0,C=0;const h=(0,D.networkInterfaces)();for(let v in h){const c=h[v];if(c)for(const{mac:S,internal:b}of c)b||(C+=1,this._isVirtualMachineMacAddress(S.toUpperCase())&&(i+=1))}this._value=C>0?i/C:0}return this._value}};let P;async function m(){return P||(P=(async()=>await E()||A.generateUuid())()),P}e.getMachineId=m;async function E(){try{const i=await new Promise((h,v)=>{K(["crypto"],h,v)}),C=await(0,k.getMac)();return i.createHash("sha256").update(C,"utf8").digest("hex")}catch(i){L.onUnexpectedError(i);return}}}),define(te[19],ne([0,1,51,35,219,6,39,66,8,4,15,5,30]),function(K,e,D,L,R,A,k,P,m,E,i,C,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(v=e.RimRafMode||(e.RimRafMode={}));async function c(U,$=v.UNLINK){if((0,k.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");return $===v.UNLINK?b(U):S(U)}async function S(U){try{const $=(0,m.join)((0,L.tmpdir)(),(0,h.generateUuid)());try{await e.Promises.rename(U,$)}catch(B){return b(U)}b($).catch(B=>{})}catch($){if($.code!=="ENOENT")throw $}}async function b(U){return e.Promises.rmdir(U,{recursive:!0,maxRetries:3})}function g(U){if((0,k.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");D.rmdirSync(U,{recursive:!0})}e.rimrafSync=g;async function I(U,$){return a(await($?p(U):(0,R.promisify)(D.readdir)(U)))}async function p(U){try{return await(0,R.promisify)(D.readdir)(U,{withFileTypes:!0})}catch(z){console.warn("[node.js fs] readdir with filetypes failed with error: ",z)}const $=[],B=await I(U);for(const z of B){let j=!1,N=!1,G=!1;try{const _=await e.Promises.lstat((0,m.join)(U,z));j=_.isFile(),N=_.isDirectory(),G=_.isSymbolicLink()}catch(_){console.warn("[node.js fs] unexpected error from lstat after readdir: ",_)}$.push({name:z,isFile:()=>j,isDirectory:()=>N,isSymbolicLink:()=>G})}return $}function o(U){return a(D.readdirSync(U))}e.readdirSync=o;function a(U){return U.map($=>typeof $=="string"?E.isMacintosh?(0,P.normalizeNFC)($):$:($.name=E.isMacintosh?(0,P.normalizeNFC)($.name):$.name,$))}async function t(U){const $=await I(U),B=[];for(const z of $)await n.existsDirectory((0,m.join)(U,z))&&B.push(z);return B}function s(U,$=1e3){return new Promise(B=>{let z=!1;const j=setInterval(()=>{z||(z=!0,D.access(U,N=>{z=!1,N&&(clearInterval(j),B(void 0))}))},$)})}e.whenDeleted=s;var n;(function(U){async function $(j){let N;try{if(N=await e.Promises.lstat(j),!N.isSymbolicLink())return{stat:N}}catch(G){}try{return{stat:await e.Promises.stat(j),symbolicLink:N?.isSymbolicLink()?{dangling:!1}:void 0}}catch(G){if(G.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};if(E.isWindows&&G.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(j)),symbolicLink:{dangling:!1}}}catch(_){if(_.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};throw _}throw G}}U.stat=$;async function B(j){try{const{stat:N,symbolicLink:G}=await U.stat(j);return N.isFile()&&G?.dangling!==!0}catch(N){}return!1}U.existsFile=B;async function z(j){try{const{stat:N,symbolicLink:G}=await U.stat(j);return N.isDirectory()&&G?.dangling!==!0}catch(N){}return!1}U.existsDirectory=z})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new A.ResourceQueue;function u(U,$,B){return r.queueFor(C.URI.file(U),i.extUriBiasedIgnorePathCase).queue(()=>{const z=w(B);return new Promise((j,N)=>f(U,$,z,G=>G?N(G):j()))})}let l=!0;function f(U,$,B,z){if(!l)return D.writeFile(U,$,{mode:B.mode,flag:B.flag},z);D.open(U,B.flag,B.mode,(j,N)=>{if(j)return z(j);D.writeFile(N,$,G=>{if(G)return D.close(N,()=>z(G));D.fdatasync(N,_=>(_&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",_),l=!1),D.close(N,J=>z(J))))})})}function d(U,$,B){const z=w(B);if(!l)return D.writeFileSync(U,$,{mode:z.mode,flag:z.flag});const j=D.openSync(U,z.flag,z.mode);try{D.writeFileSync(j,$);try{D.fdatasyncSync(j)}catch(N){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",N),l=!1}}finally{D.closeSync(j)}}e.writeFileSync=d;function w(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function T(U,$){if(U===$)return;async function B(z){try{const j=await e.Promises.lstat(z);if(j.isDirectory()||j.isSymbolicLink())return;await e.Promises.utimes(z,j.atime,new Date)}catch(j){}}try{await e.Promises.rename(U,$),await B($)}catch(z){if(U.toLowerCase()!==$.toLowerCase()&&z.code==="EXDEV"||U.endsWith("."))await O(U,$,{preserveSymlinks:!1}),await c(U,v.MOVE),await B($);else throw z}}async function O(U,$,B){return M(U,$,{root:{source:U,target:$},options:B,handledSourcePaths:new Set})}const y=511;async function M(U,$,B){if(B.handledSourcePaths.has(U))return;B.handledSourcePaths.add(U);const{stat:z,symbolicLink:j}=await n.stat(U);if(j){if(B.options.preserveSymlinks)try{return await x(U,$,B)}catch(N){console.warn("[node.js fs] copy of symlink failed: ",N)}if(j.dangling)return}return z.isDirectory()?F(U,$,z.mode&y,B):q(U,$,z.mode&y)}async function F(U,$,B,z){await e.Promises.mkdir($,{recursive:!0,mode:B});const j=await I(U);for(const N of j)await M((0,m.join)(U,N),(0,m.join)($,N),z)}async function q(U,$,B){await e.Promises.copyFile(U,$),await e.Promises.chmod($,B)}async function x(U,$,B){let z=await e.Promises.readlink(U);(0,k.isEqualOrParent)(z,B.root.source,!E.isLinux)&&(z=(0,m.join)(B.root.target,z.substr(B.root.source.length+1))),await e.Promises.symlink(z,$)}e.Promises=new class{get access(){return(0,R.promisify)(D.access)}get stat(){return(0,R.promisify)(D.stat)}get lstat(){return(0,R.promisify)(D.lstat)}get utimes(){return(0,R.promisify)(D.utimes)}get read(){return(0,R.promisify)(D.read)}get readFile(){return(0,R.promisify)(D.readFile)}get write(){return(0,R.promisify)(D.write)}get appendFile(){return(0,R.promisify)(D.appendFile)}get fdatasync(){return(0,R.promisify)(D.fdatasync)}get truncate(){return(0,R.promisify)(D.truncate)}get rename(){return(0,R.promisify)(D.rename)}get copyFile(){return(0,R.promisify)(D.copyFile)}get open(){return(0,R.promisify)(D.open)}get close(){return(0,R.promisify)(D.close)}get symlink(){return(0,R.promisify)(D.symlink)}get readlink(){return(0,R.promisify)(D.readlink)}get chmod(){return(0,R.promisify)(D.chmod)}get mkdir(){return(0,R.promisify)(D.mkdir)}get unlink(){return(0,R.promisify)(D.unlink)}get rmdir(){return(0,R.promisify)(D.rmdir)}get realpath(){return(0,R.promisify)(D.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return I}get readDirsInDir(){return t}get writeFile(){return u}get rm(){return c}get move(){return T}get copy(){return O}}}),define(te[99],ne([0,1,51,8,24,19]),function(K,e,D,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function k(i){const C=(0,L.dirname)(i);if(i===C)return i;const h=((0,L.basename)(i)||i).toLowerCase();try{const c=(0,A.readdirSync)(C).filter(S=>S.toLowerCase()===h);if(c.length===1){const S=k(C);if(S)return(0,L.join)(S,c[0])}else if(c.length>1){const S=c.indexOf(h);if(S>=0){const b=k(C);if(b)return(0,L.join)(b,c[S])}}}catch(v){}return null}e.realcaseSync=k;async function P(i){try{return await A.Promises.realpath(i)}catch(C){const h=E(i);return await A.Promises.access(h,D.constants.R_OK),h}}e.realpath=P;function m(i){try{return D.realpathSync(i)}catch(C){const h=E(i);return D.accessSync(h,D.constants.R_OK),h}}e.realpathSync=m;function E(i){return(0,R.rtrim)((0,L.normalize)(i),L.sep)}}),define(te[69],ne([0,1,35,8,19]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,k=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var m;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(m||(m={}));let E;switch(process.arch){case"ia32":case"x32":E=1;break;case"arm":case"arm64":E=2;break;default:E=0;break}let i;process.env.PROCESSOR_ARCHITEW6432?i=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?i=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?i=1:i=0;class C{constructor(a,t,s){this.exePath=a,this.displayName=t,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await R.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function h({useAlternateBitness:o=!1}={}){return o?E===0?process.env["ProgramFiles(x86)"]||null:i===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function v({useAlternateBitness:o=!1,findPreview:a=!1}={}){const t=h({useAlternateBitness:o});if(!t)return null;const s=L.join(t,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(s))return null;let n=-1,r=null;for(const f of await R.Promises.readdir(s)){let d=-1;if(a){const T=f.indexOf("-");if(T<0)continue;const O=f.substring(0,T);if(!A.test(O)||f.substring(T+1)!=="preview")continue;d=parseInt(O,10)}else{if(!A.test(f))continue;d=parseInt(f,10)}if(d<=n)continue;const w=L.join(s,f,"pwsh.exe");!await R.SymlinkSupport.existsFile(w)||(r=w,n=d)}if(!r)return null;const u=t.includes("x86")?" (x86)":"",l=a?" Preview":"";return new C(r,`PowerShell${l}${u}`,!0)}async function c({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const a=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:t,pwshMsixName:s}=o?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const n of await R.Promises.readdir(a))if(t.test(n)){const r=L.join(a,n,"pwsh.exe");return new C(r,s)}return null}function S(){const o=L.join(D.homedir(),".dotnet","tools","pwsh.exe");return new C(o,".NET Core PowerShell Global Tool")}function b(){const o=L.join(process.env.windir,E===1&&i!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(o,"Windows PowerShell",!0)}async function*g(){let o=await v();o&&(yield o),o=await v({useAlternateBitness:!0}),o&&(yield o),o=await c(),o&&(yield o),o=S(),o&&(yield o),o=await v({findPreview:!0}),o&&(yield o),o=await c({findPreview:!0}),o&&(yield o),o=await v({useAlternateBitness:!0,findPreview:!0}),o&&(yield o),o=b(),o&&(yield o)}async function*I(){for await(const o of g())await o.exists()&&(yield o)}e.enumeratePowerShellInstallations=I;async function p(){for await(const o of I())return o;return null}e.getFirstAvailablePowerShellInstallation=p}),define(te[100],ne([0,1,41,17]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function R(k){return new Promise((P,m)=>{let E;const i=new Map;function C(v,c,S,b,g){const I=i.get(c);if(v===k||I){const p={name:h(S),cmd:S,pid:v,ppid:c,load:b,mem:g};i.set(v,p),v===k&&(E=p),I&&(I.children||(I.children=[]),I.children.push(p),I.children.length>1&&(I.children=I.children.sort((o,a)=>o.pid-a.pid)))}}function h(v){const c=/--disable-blink-features=Auxclick/,S=/\\watcher\\win32\\CodeHelper\.exe/,b=/--crashes-directory/,g=/\\pipe\\winpty-control/,I=/conhost\.exe/,p=/--type=([a-zA-Z-]+)/;if(S.exec(v))return"watcherService ";if(b.exec(v))return"electron-crash-reporter";if(g.exec(v))return"winpty-process";if(I.exec(v))return"console-window-host (Windows internal process)";let o=p.exec(v);if(o&&o.length===2)return o[1]==="renderer"?c.exec(v)?"shared-process":"window":o[1];const a=/[a-zA-Z-]+\.js/g;let t="";do o=a.exec(v),o&&(t+=o+" ");while(o);return t&&v.indexOf("node ")<0&&v.indexOf("node.exe")<0?`electron_node ${t}`:v}if(process.platform==="win32"){const v=c=>c.indexOf("\\\\?\\")===0||c.indexOf("\\??\\")===0?c.substr(4):c.indexOf('"\\\\?\\')===0||c.indexOf('"\\??\\')===0?'"'+c.substr(5):c;new Promise((c,S)=>{K(["windows-process-tree"],c,S)}).then(c=>{c.getProcessList(k,S=>{c.getProcessCpuUsage(S,b=>{const g=new Map;b.forEach(I=>{const p=v(I.commandLine||"");g.set(I.pid,{name:h(p),cmd:p,pid:I.pid,ppid:I.ppid,load:I.cpu||0,mem:I.memory||0})}),E=g.get(k),E?(g.forEach(I=>{const p=g.get(I.ppid);p&&(p.children||(p.children=[]),p.children.push(I))}),g.forEach(I=>{I.children&&(I.children=I.children.sort((p,o)=>p.pid-o.pid))}),P(E)):m(new Error(`Root process ${k} not found`))})},c.ProcessDataFlag.CommandLine|c.ProcessDataFlag.Memory)})}else{let v=function(){let c=[E];const S=[];for(;c.length;){const g=c.shift();g&&(S.push(g.pid),g.children&&(c=c.concat(g.children)))}let b=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",K).fsPath);b+=" "+S.join(" "),(0,D.exec)(b,{},(g,I,p)=>{if(g||p)m(g||new Error(p.toString()));else{const o=I.toString().split(`
`);for(let a=0;a<S.length;a++){const t=i.get(S[a]);t.load=parseFloat(o[a])}if(!E){m(new Error(`Root process ${k} not found`));return}P(E)}})};(0,D.exec)("which ps",{},(c,S,b)=>{if(c||b)if(process.platform!=="linux")m(c||new Error(b.toString()));else{const g=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",K).fsPath);(0,D.exec)(g,{},(I,p,o)=>{I||o?m(I||new Error(o.toString())):(A(p,C),v())})}else{const g=S.toString().trim(),I="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${g} ${I}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(p,o,a)=>{p||a&&!a.includes("screen size is bogus")?m(p||new Error(a.toString())):(A(o,C),process.platform==="linux"?v():E?P(E):m(new Error(`Root process ${k} not found`)))})}})}})}e.listProcesses=R;function A(k,P){const m=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,E=k.toString().split(`
`);for(const i of E){const C=m.exec(i.trim());C&&C.length===6&&P(parseInt(C[1]),parseInt(C[2]),C[5],parseFloat(C[3]),parseFloat(C[4]))}}}),define(te[101],ne([0,1,51,39,2,66,8,4,19]),function(K,e,D,L,R,A,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function E(h,v,c){return C({path:h,isDirectory:!1},v,c)}e.watchFile=E;function i(h,v,c){return C({path:h,isDirectory:!0},v,c)}e.watchFolder=i,e.CHANGE_BUFFER_DELAY=100;function C(h,v,c){if(P.isMacintosh&&(0,L.isEqualOrParent)(h.path,"/Volumes/"))return c(`Refusing to watch ${h.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.Disposable.None;const S=(0,k.basename)(h.path),b=new Map;let g=!1,I=[(0,R.toDisposable)(()=>{b.forEach(p=>(0,R.dispose)(p)),b.clear()})];try{const p=(0,D.watch)(h.path);I.push((0,R.toDisposable)(()=>{p.removeAllListeners(),p.close()}));const o=new Set;h.isDirectory&&m.Promises.readdir(h.path).then(a=>a.forEach(t=>o.add(t))),p.on("error",(a,t)=>{g||c(`Failed to watch ${h.path} for changes using fs.watch() (${a}, ${t})`)}),p.on("change",(a,t)=>{if(g)return;let s="";if(t&&(s=t.toString(),P.isMacintosh&&(s=(0,A.normalizeNFC)(s))),!s||a!=="change"&&a!=="rename")return;const n=h.isDirectory?(0,k.join)(h.path,s):h.path;if(h.isDirectory)if(a==="rename"){const r=b.get(n);r&&(0,R.dispose)(r);const u=setTimeout(async()=>{b.delete(n);const l=await m.Promises.exists(n);if(g)return;let f;l?o.has(s)?f="changed":(f="added",o.add(s)):(o.delete(s),f="deleted"),v(f,n)},e.CHANGE_BUFFER_DELAY);b.set(n,(0,R.toDisposable)(()=>clearTimeout(u)))}else{let r;o.has(s)?r="changed":(r="added",o.add(s)),v(r,n)}else if(a==="rename"||s!==S){const r=setTimeout(async()=>{const u=await m.Promises.exists(n);g||(u?(v("changed",n),I=[C(h,v,c)]):v("deleted",n))},e.CHANGE_BUFFER_DELAY);(0,R.dispose)(I),I=[(0,R.toDisposable)(()=>clearTimeout(r))]}else v("changed",n)})}catch(p){m.Promises.exists(h.path).then(o=>{o&&!g&&c(`Failed to watch ${h.path} for changes using fs.watch() (${p.toString()})`)})}return(0,R.toDisposable)(()=>{g=!0,I=(0,R.dispose)(I)})}});var de=this&&this.__decorate||function(K,e,D,L){var R=arguments.length,A=R<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,D):L,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(K,e,D,L);else for(var P=K.length-1;P>=0;P--)(k=K[P])&&(A=(R<3?k(A):R>3?k(e,D,A):k(e,D))||A);return R>3&&A&&Object.defineProperty(e,D,A),A};define(te[36],ne([0,1,18,6,25,29,64,11,3,2,94,24,16]),function(K,e,D,L,R,A,k,P,m,E,i,C,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var v;(function(j){j[j.Promise=100]="Promise",j[j.PromiseCancel=101]="PromiseCancel",j[j.EventListen=102]="EventListen",j[j.EventDispose=103]="EventDispose"})(v=e.RequestType||(e.RequestType={}));function c(j){switch(j){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var S;(function(j){j[j.Initialize=200]="Initialize",j[j.PromiseSuccess=201]="PromiseSuccess",j[j.PromiseError=202]="PromiseError",j[j.PromiseErrorObj=203]="PromiseErrorObj",j[j.EventFire=204]="EventFire"})(S=e.ResponseType||(e.ResponseType={}));function b(j){switch(j){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(j){j[j.Uninitialized=0]="Uninitialized",j[j.Idle=1]="Idle"})(g||(g={}));class I{constructor(N){this.buffer=N,this.pos=0}read(N){const G=this.buffer.slice(this.pos,this.pos+N);return this.pos+=G.byteLength,G}}class p{constructor(){this.buffers=[]}get buffer(){return R.VSBuffer.concat(this.buffers)}write(N){this.buffers.push(N)}}var o;(function(j){j[j.Undefined=0]="Undefined",j[j.String=1]="String",j[j.Buffer=2]="Buffer",j[j.VSBuffer=3]="VSBuffer",j[j.Array=4]="Array",j[j.Object=5]="Object"})(o||(o={}));function a(j){const N=R.VSBuffer.alloc(4);return N.writeUInt32BE(j,0),N}function t(j){return j.read(4).readUInt32BE(0)}function s(j){const N=R.VSBuffer.alloc(1);return N.writeUInt8(j,0),N}const n={Undefined:s(o.Undefined),String:s(o.String),Buffer:s(o.Buffer),VSBuffer:s(o.VSBuffer),Array:s(o.Array),Object:s(o.Object)},r=typeof Buffer!="undefined";function u(j,N){if(typeof N=="undefined")j.write(n.Undefined);else if(typeof N=="string"){const G=R.VSBuffer.fromString(N);j.write(n.String),j.write(a(G.byteLength)),j.write(G)}else if(r&&Buffer.isBuffer(N)){const G=R.VSBuffer.wrap(N);j.write(n.Buffer),j.write(a(G.byteLength)),j.write(G)}else if(N instanceof R.VSBuffer)j.write(n.VSBuffer),j.write(a(N.byteLength)),j.write(N);else if(Array.isArray(N)){j.write(n.Array),j.write(a(N.length));for(const G of N)u(j,G)}else{const G=R.VSBuffer.fromString(JSON.stringify(N));j.write(n.Object),j.write(a(G.byteLength)),j.write(G)}}function l(j){switch(j.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return j.read(t(j)).toString();case o.Buffer:return j.read(t(j)).buffer;case o.VSBuffer:return j.read(t(j));case o.Array:{const G=t(j),_=[];for(let J=0;J<G;J++)_.push(l(j));return _}case o.Object:return JSON.parse(j.read(t(j)).toString())}}class f{constructor(N,G,_=null,J=1e3){this.protocol=N,this.ctx=G,this.logger=_,this.timeoutDelay=J,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Y=>this.onRawMessage(Y)),this.sendResponse({type:200})}registerChannel(N,G){this.channels.set(N,G),setTimeout(()=>this.flushPendingRequests(N),0)}sendResponse(N){switch(N.type){case 200:{const G=this.send([N.type]);this.logger&&this.logger.logOutgoing(G,0,1,b(N.type));return}case 201:case 202:case 204:case 203:{const G=this.send([N.type,N.id],N.data);this.logger&&this.logger.logOutgoing(G,N.id,1,b(N.type),N.data);return}}}send(N,G=void 0){const _=new p;return u(_,N),u(_,G),this.sendBuffer(_.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(G){return 0}}onRawMessage(N){const G=new I(N),_=l(G),J=l(G),Y=_[0];switch(Y){case 100:return this.logger&&this.logger.logIncoming(N.byteLength,_[1],1,`${c(Y)}: ${_[2]}.${_[3]}`,J),this.onPromise({type:Y,id:_[1],channelName:_[2],name:_[3],arg:J});case 102:return this.logger&&this.logger.logIncoming(N.byteLength,_[1],1,`${c(Y)}: ${_[2]}.${_[3]}`,J),this.onEventListen({type:Y,id:_[1],channelName:_[2],name:_[3],arg:J});case 101:return this.logger&&this.logger.logIncoming(N.byteLength,_[1],1,`${c(Y)}`),this.disposeActiveRequest({type:Y,id:_[1]});case 103:return this.logger&&this.logger.logIncoming(N.byteLength,_[1],1,`${c(Y)}`),this.disposeActiveRequest({type:Y,id:_[1]})}}onPromise(N){const G=this.channels.get(N.channelName);if(!G){this.collectPendingRequest(N);return}const _=new A.CancellationTokenSource;let J;try{J=G.call(this.ctx,N.name,N.arg,_.token)}catch(W){J=Promise.reject(W)}const Y=N.id;J.then(W=>{this.sendResponse({id:Y,data:W,type:201}),this.activeRequests.delete(N.id)},W=>{W instanceof Error?this.sendResponse({id:Y,data:{message:W.message,name:W.name,stack:W.stack?W.stack.split?W.stack.split(`
`):W.stack:void 0},type:202}):this.sendResponse({id:Y,data:W,type:203}),this.activeRequests.delete(N.id)});const H=(0,E.toDisposable)(()=>_.cancel());this.activeRequests.set(N.id,H)}onEventListen(N){const G=this.channels.get(N.channelName);if(!G){this.collectPendingRequest(N);return}const _=N.id,Y=G.listen(this.ctx,N.name,N.arg)(H=>this.sendResponse({id:_,data:H,type:204}));this.activeRequests.set(N.id,Y)}disposeActiveRequest(N){const G=this.activeRequests.get(N.id);G&&(G.dispose(),this.activeRequests.delete(N.id))}collectPendingRequest(N){let G=this.pendingRequests.get(N.channelName);G||(G=[],this.pendingRequests.set(N.channelName,G));const _=setTimeout(()=>{console.error(`Unknown channel: ${N.channelName}`),N.type===100&&this.sendResponse({id:N.id,data:{name:"Unknown channel",message:`Channel name '${N.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);G.push({request:N,timeoutTimer:_})}flushPendingRequests(N){const G=this.pendingRequests.get(N);if(G){for(const _ of G)switch(clearTimeout(_.timeoutTimer),_.request.type){case 100:this.onPromise(_.request);break;case 102:this.onEventListen(_.request);break}this.pendingRequests.delete(N)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}e.ChannelServer=f;var d;(function(j){j[j.LocalSide=0]="LocalSide",j[j.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));class w{constructor(N,G=null){this.protocol=N,this.isDisposed=!1,this.state=g.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new m.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(_=>this.onBuffer(_)),this.logger=G}getChannel(N){const G=this;return{call(_,J,Y){return G.isDisposed?Promise.reject(P.canceled()):G.requestPromise(N,_,J,Y)},listen(_,J){return G.isDisposed?Promise.reject(P.canceled()):G.requestEvent(N,_,J)}}}requestPromise(N,G,_,J=A.CancellationToken.None){const Y=this.lastRequestId++,W={id:Y,type:100,channelName:N,name:G,arg:_};if(J.isCancellationRequested)return Promise.reject(P.canceled());let Z;return new Promise((re,oe)=>{if(J.isCancellationRequested)return oe(P.canceled());const ue=()=>{const be=Le=>{switch(Le.type){case 201:this.handlers.delete(Y),re(Le.data);break;case 202:this.handlers.delete(Y);const De=new Error(Le.data.message);De.stack=Le.data.stack,De.name=Le.data.name,oe(De);break;case 203:this.handlers.delete(Y),oe(Le.data);break}};this.handlers.set(Y,be),this.sendRequest(W)};let le=null;this.state===g.Idle?ue():(le=(0,L.createCancelablePromise)(be=>this.whenInitialized()),le.then(()=>{le=null,ue()}));const Se=()=>{le?(le.cancel(),le=null):this.sendRequest({id:Y,type:101}),oe(P.canceled())},Ee=J.onCancellationRequested(Se);Z=(0,E.combinedDisposable)((0,E.toDisposable)(Se),Ee),this.activeRequests.add(Z)}).finally(()=>{this.activeRequests.delete(Z)})}requestEvent(N,G,_){const J=this.lastRequestId++,H={id:J,type:102,channelName:N,name:G,arg:_};let W=null;const Z=new m.Emitter({onFirstListenerAdd:()=>{W=(0,L.createCancelablePromise)(re=>this.whenInitialized()),W.then(()=>{W=null,this.activeRequests.add(Z),this.sendRequest(H)})},onLastListenerRemove:()=>{W?(W.cancel(),W=null):(this.activeRequests.delete(Z),this.sendRequest({id:J,type:103}))}}),X=re=>Z.fire(re.data);return this.handlers.set(J,X),Z.event}sendRequest(N){switch(N.type){case 100:case 102:{const G=this.send([N.type,N.id,N.channelName,N.name],N.arg);this.logger&&this.logger.logOutgoing(G,N.id,0,`${c(N.type)}: ${N.channelName}.${N.name}`,N.arg);return}case 101:case 103:{const G=this.send([N.type,N.id]);this.logger&&this.logger.logOutgoing(G,N.id,0,c(N.type));return}}}send(N,G=void 0){const _=new p;return u(_,N),u(_,G),this.sendBuffer(_.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(G){return 0}}onBuffer(N){const G=new I(N),_=l(G),J=l(G),Y=_[0];switch(Y){case 200:return this.logger&&this.logger.logIncoming(N.byteLength,0,0,b(Y)),this.onResponse({type:_[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(N.byteLength,_[1],0,b(Y),J),this.onResponse({type:_[0],id:_[1],data:J})}}onResponse(N){if(N.type===200){this.state=g.Idle,this._onDidInitialize.fire();return}const G=this.handlers.get(N.id);G&&G(N)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}de([k.memoize],w.prototype,"onDidInitializePromise",null),e.ChannelClient=w;class T{constructor(N){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new m.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new m.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,N(({protocol:G,onDidClientDisconnect:_})=>{m.Event.once(G.onMessage)(Y=>{const H=new I(Y),W=l(H),Z=new f(G,W),X=new w(G);this.channels.forEach((oe,ue)=>Z.registerChannel(ue,oe));const re={channelServer:Z,channelClient:X,ctx:W};this._connections.add(re),this._onDidAddConnection.fire(re),_(()=>{Z.dispose(),X.dispose(),this._connections.delete(re),this._onDidRemoveConnection.fire(re)})})})}get connections(){const N=[];return this._connections.forEach(G=>N.push(G)),N}getChannel(N,G){const _=this;return{call(J,Y,H){let W;if((0,h.isFunction)(G)){let X=(0,D.getRandomElement)(_.connections.filter(G));W=X?Promise.resolve(X):m.Event.toPromise(m.Event.filter(_.onDidAddConnection,G))}else W=G.routeCall(_,J,Y);const Z=W.then(X=>X.channelClient.getChannel(N));return y(Z).call(J,Y,H)},listen(J,Y){if((0,h.isFunction)(G))return _.getMulticastEvent(N,G,J,Y);const H=G.routeEvent(_,J,Y).then(W=>W.channelClient.getChannel(N));return y(H).listen(J,Y)}}}getMulticastEvent(N,G,_,J){const Y=this;let H=new E.DisposableStore;const W=new m.Emitter({onFirstListenerAdd:()=>{H=new E.DisposableStore;const Z=new m.EventMultiplexer,X=new Map,re=ue=>{const Se=ue.channelClient.getChannel(N).listen(_,J),Ee=Z.add(Se);X.set(ue,Ee)},oe=ue=>{const le=X.get(ue);!le||(le.dispose(),X.delete(ue))};Y.connections.filter(G).forEach(re),m.Event.filter(Y.onDidAddConnection,G)(re,void 0,H),Y.onDidRemoveConnection(oe,void 0,H),Z.event(W.fire,W,H),H.add(Z)},onLastListenerRemove:()=>{H.dispose()}});return W.event}registerChannel(N,G){this.channels.set(N,G),this._connections.forEach(_=>{_.channelServer.registerChannel(N,G)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=T;class O{constructor(N,G,_=null){const J=new p;u(J,G),N.send(J.buffer),this.channelClient=new w(N,_),this.channelServer=new f(N,G,_)}getChannel(N){return this.channelClient.getChannel(N)}registerChannel(N,G){this.channelServer.registerChannel(N,G)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=O;function y(j){return{call(N,G,_){return j.then(J=>J.call(N,G,_))},listen(N,G){const _=new m.Relay;return j.then(J=>_.input=J.listen(N,G)),_.event}}}e.getDelayedChannel=y;function M(j){let N=!1;return{call(G,_,J){return N?j.call(G,_,J):(0,L.timeout)(0).then(()=>N=!0).then(()=>j.call(G,_,J))},listen(G,_){if(N)return j.listen(G,_);const J=new m.Relay;return(0,L.timeout)(0).then(()=>N=!0).then(()=>J.input=j.listen(G,_)),J.event}}}e.getNextTickChannel=M;class F{constructor(N){this.fn=N}routeCall(N){return this.route(N)}routeEvent(N){return this.route(N)}async route(N){for(const G of N.connections)if(await Promise.resolve(this.fn(G.ctx)))return Promise.resolve(G);return await m.Event.toPromise(N.onDidAddConnection),await this.route(N)}}e.StaticRouter=F;var q;(function(j){function N(J,Y){const H=J,W=Y&&Y.disableMarshalling,Z=new Map;for(const X in H)_(X)&&Z.set(X,m.Event.buffer(H[X],!0));return new class{listen(X,re){const oe=Z.get(re);if(oe)return oe;throw new Error(`Event not found: ${re}`)}call(X,re,oe){const ue=H[re];if(typeof ue=="function"){if(!W&&Array.isArray(oe))for(let le=0;le<oe.length;le++)oe[le]=(0,i.revive)(oe[le]);return ue.apply(H,oe)}throw new Error(`Method not found: ${re}`)}}}j.fromService=N;function G(J,Y){const H=Y&&Y.disableMarshalling;return new Proxy({},{get(W,Z){if(typeof Z=="string")return Y?.properties?.has(Z)?Y.properties.get(Z):_(Z)?J.listen(Z):async function(...X){let re;Y&&!(0,h.isUndefinedOrNull)(Y.context)?re=[Y.context,...X]:re=X;const oe=await J.call(Z,re);return H?oe:(0,i.revive)(oe)};throw new Error(`Property not found: ${String(Z)}`)}})}j.toService=G;function _(J){return J[0]==="o"&&J[1]==="n"&&C.isUpperAsciiLetter(J.charCodeAt(2))}})(q=e.ProxyChannel||(e.ProxyChannel={}));const x=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(j){if(Array.isArray(j))return j;if(j&&typeof j=="object"&&typeof j.toString=="function"){let N=j.toString();if(N!=="[object Object]")return N}return j}function $(j){return Array.isArray(j)?j.map(U):U(j)}function B(j,N,G,_,J,Y,H){H=$(H);const W=x[J],Z=W[_%W.length];let X=[`%c[${j}]%c[${String(N).padStart(7," ")}]%c[len: ${String(G).padStart(5," ")}]%c${String(_).padStart(5," ")} - ${Y}`,"color: darkgreen","color: grey","color: grey",`color: ${Z}`];/\($/.test(Y)?(X=X.concat(H),X.push(")")):X.push(H),console.log.apply(console,X)}e.logWithColors=B;class z{constructor(N,G){this._outgoingPrefix=N,this._incomingPrefix=G,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(N,G,_,J,Y){this._totalOutgoing+=N,B(this._outgoingPrefix,this._totalOutgoing,N,G,_,J,Y)}logIncoming(N,G,_,J,Y){this._totalIncoming+=N,B(this._incomingPrefix,this._totalIncoming,N,G,_,J,Y)}}e.IPCLogger=z}),define(te[102],ne([0,1,25,3,36]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class A{constructor(m){this.port=m,this.onMessage=L.Event.fromDOMEventEmitter(this.port,"message",E=>D.VSBuffer.wrap(E.data)),m.start()}send(m){this.port.postMessage(m.buffer)}disconnect(){this.port.close()}}e.Protocol=A;class k extends R.IPCClient{constructor(m,E){const i=new A(m);super(i,E);this.protocol=i}dispose(){this.protocol.disconnect()}}e.Client=k}),define(te[103],ne([0,1,104,3,36,102]),function(K,e,D,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class k extends R.IPCServer{static getOnDidClientConnect(){const m=L.Event.fromNodeEventEmitter(D.ipcRenderer,"vscode:createMessageChannel",(E,i)=>i);return L.Event.map(m,E=>{const{port1:i,port2:C}=new MessageChannel,v={protocol:new A.Protocol(i),onDidClientDisconnect:L.Event.fromDOMEventEmitter(i,"close")};return D.ipcRenderer.postMessage("vscode:createMessageChannelResult",E,[C]),v})}constructor(){super(k.getOnDidClientConnect())}}e.Server=k}),define(te[105],ne([0,1,25,11]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function R(P,m){P.proxyAuthorization&&(P.headers={...P.headers||{},"Proxy-Authorization":P.proxyAuthorization});const E=new XMLHttpRequest;return new Promise((i,C)=>{E.open(P.type||"GET",P.url||"",!0,P.user,P.password),A(E,P),E.responseType="arraybuffer",E.onerror=h=>C(new Error(E.statusText&&"XHR failed: "+E.statusText||"XHR failed")),E.onload=h=>{i({res:{statusCode:E.status,headers:k(E)},stream:(0,D.bufferToStream)(D.VSBuffer.wrap(new Uint8Array(E.response)))})},E.ontimeout=h=>C(new Error(`XHR timeout: ${P.timeout}ms`)),P.timeout&&(E.timeout=P.timeout),E.send(P.data),m.onCancellationRequested(()=>{E.abort(),C((0,L.canceled)())})})}e.request=R;function A(P,m){if(m.headers){e:for(let E in m.headers){switch(E){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}P.setRequestHeader(E,m.headers[E])}}}function k(P){const m=Object.create(null);for(const E of P.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(E){const i=E.indexOf(":");m[E.substr(0,i).trim().toLowerCase()]=E.substr(i+1).trim()}return m}}),define(te[70],ne([0,1,6,3,2,16]),function(K,e,D,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var k;(function(C){C[C.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(k=e.StorageHint||(e.StorageHint={}));function P(C){const h=C;return h?.changed instanceof Map||h?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var m;(function(C){C[C.None=0]="None",C[C.Initialized=1]="Initialized",C[C.Closed=2]="Closed"})(m||(m={}));class E extends R.Disposable{constructor(h,v=Object.create(null)){super();this.database=h,this.options=v,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=m.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(E.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(h=>this.onDidChangeItemsExternal(h)))}onDidChangeItemsExternal(h){h.changed?.forEach((v,c)=>this.accept(c,v)),h.deleted?.forEach(v=>this.accept(v,void 0))}accept(h,v){if(this.state===m.Closed)return;let c=!1;(0,A.isUndefinedOrNull)(v)?c=this.cache.delete(h):this.cache.get(h)!==v&&(this.cache.set(h,v),c=!0),c&&this._onDidChangeStorage.fire(h)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===m.None&&(this.state=m.Initialized,this.options.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(h,v){const c=this.cache.get(h);return(0,A.isUndefinedOrNull)(c)?v:c}getBoolean(h,v){const c=this.get(h);return(0,A.isUndefinedOrNull)(c)?v:c==="true"}getNumber(h,v){const c=this.get(h);return(0,A.isUndefinedOrNull)(c)?v:parseInt(c,10)}async set(h,v){if(this.state===m.Closed)return;if((0,A.isUndefinedOrNull)(v))return this.delete(h);const c=String(v);if(this.cache.get(h)!==c)return this.cache.set(h,c),this.pendingInserts.set(h,c),this.pendingDeletes.delete(h),this._onDidChangeStorage.fire(h),this.flushDelayer.trigger(()=>this.flushPending())}async delete(h){if(!(this.state===m.Closed||!this.cache.delete(h)))return this.pendingDeletes.has(h)||this.pendingDeletes.add(h),this.pendingInserts.delete(h),this._onDidChangeStorage.fire(h),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=m.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(h){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const h={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(h).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(h=>this.whenFlushedCallbacks.push(h))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=E,E.DEFAULT_FLUSH_DELAY=100;class i{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(h){h.insert&&h.insert.forEach((v,c)=>this.items.set(c,v)),h.delete&&h.delete.forEach(v=>this.items.delete(v))}async close(){}}e.InMemoryStorageDatabase=i}),define(te[106],ne([9,10]),function(K,e){return K.create("vs/base/common/date",e)}),define(te[56],ne([0,1,106]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,R=L*60,A=R*24,k=A*7,P=A*30,m=A*365;function E(C,h){typeof C!="number"&&(C=C.getTime());const v=Math.round((new Date().getTime()-C)/1e3);if(v<-30)return(0,D.localize)(0,null,E(new Date().getTime()+v*1e3,!1));if(v<30)return(0,D.localize)(1,null);let c;return v<L?(c=v,h?c===1?(0,D.localize)(2,null,c):(0,D.localize)(3,null,c):c===1?(0,D.localize)(4,null,c):(0,D.localize)(5,null,c)):v<R?(c=Math.floor(v/L),h?c===1?(0,D.localize)(6,null,c):(0,D.localize)(7,null,c):c===1?(0,D.localize)(8,null,c):(0,D.localize)(9,null,c)):v<A?(c=Math.floor(v/R),h?c===1?(0,D.localize)(10,null,c):(0,D.localize)(11,null,c):c===1?(0,D.localize)(12,null,c):(0,D.localize)(13,null,c)):v<k?(c=Math.floor(v/A),h?c===1?(0,D.localize)(14,null,c):(0,D.localize)(15,null,c):c===1?(0,D.localize)(16,null,c):(0,D.localize)(17,null,c)):v<P?(c=Math.floor(v/k),h?c===1?(0,D.localize)(18,null,c):(0,D.localize)(19,null,c):c===1?(0,D.localize)(20,null,c):(0,D.localize)(21,null,c)):v<m?(c=Math.floor(v/P),h?c===1?(0,D.localize)(22,null,c):(0,D.localize)(23,null,c):c===1?(0,D.localize)(24,null,c):(0,D.localize)(25,null,c)):(c=Math.floor(v/m),h?c===1?(0,D.localize)(26,null,c):(0,D.localize)(27,null,c):c===1?(0,D.localize)(28,null,c):(0,D.localize)(29,null,c))}e.fromNow=E;function i(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(te[107],ne([9,10]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(te[37],ne([0,1,18,16,107]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(E,i){return i&&(E.stack||E.stacktrace)?R.localize(0,null,P(E),k(E.stack)||k(E.stacktrace)):P(E)}function k(E){return Array.isArray(E)?E.join(`
`):E}function P(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?R.localize(1,null,E.message):E.message||R.localize(2,null)}function m(E=null,i=!1){if(!E)return R.localize(3,null);if(Array.isArray(E)){const C=D.coalesce(E),h=m(C[0],i);return C.length>1?R.localize(4,null,h,C.length):h}if(L.isString(E))return E;if(E.detail){const C=E.detail;if(C.error)return A(C.error,i);if(C.exception)return A(C.exception,i)}return E.stack?A(E,i):E.message?E.message:R.localize(5,null)}e.toErrorMessage=m}),define(te[108],ne([9,10]),function(K,e){return K.create("vs/base/node/processes",e)}),define(te[71],ne([0,1,41,39,17,26,8,4,34,16,68,19,108]),function(K,e,D,L,R,A,k,P,m,E,i,C,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function v(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function c(o,a){if(P.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};a&&(t.cwd=a);const s=D.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],t);return new Promise(n=>{s.once("error",r=>{n({success:!1,error:r})}),s.once("exit",(r,u)=>{n(r===0?{success:!0}:{success:!1,code:r!==null?r:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?v(t.status):1})}else if(P.isLinux||P.isMacintosh)try{const t=R.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",K).fsPath;return new Promise(s=>{D.execFile(t,[o.pid.toString()],{encoding:"utf8",shell:!0},(n,r,u)=>{s(n?{success:!1,error:n}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function S(o=m.env){return o.comspec||"cmd.exe"}e.getWindowsShell=S;class b{constructor(a,t,s,n){if(t!==void 0&&s!==void 0&&n!==void 0)this.cmd=a,this.args=t,this.shell=s,this.options=n;else{const r=a;this.cmd=r.command,this.shell=r.isShellCommand,this.args=r.args.slice(0),this.options=r.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const r=Object.create(null);Object.keys(m.env).forEach(u=>{r[u]=m.env[u]}),Object.keys(this.options.env).forEach(u=>{r[u]=this.options.env[u]}),this.options.env=r}}getSanitizedCommand(){let a=this.cmd.toLowerCase();const t=a.lastIndexOf(k.sep);return t!==-1&&(a=a.substring(t+1)),b.WellKnowCommands[a]?a:"other"}start(a){return P.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(m.cwd()))?Promise.reject(new Error(h.localize(0,null))):this.useExec().then(t=>{let s,n;const r=new Promise((u,l)=>{s=u,n=l});if(t){let u=this.cmd;this.args&&(u=u+" "+this.args.join(" ")),this.childProcess=D.exec(u,this.options,(l,f,d)=>{this.childProcess=null;const w=l;w&&w.killed?n({killed:this.terminateRequested,stdout:f.toString(),stderr:d.toString()}):this.handleExec(s,a,l,f,d)})}else{let u=null;const l=f=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(f,s,a,n);const d={terminated:this.terminateRequested};E.isNumber(f)&&(d.cmdCode=f),s(d)};if(this.shell&&P.isWindows){const f=A.deepClone(this.options);f.windowsVerbatimArguments=!0,f.detached=!1;let d=!1,w=!1;const T=[];let O=this.ensureQuotes(this.cmd);T.push(O.value),d=O.quoted,this.args&&this.args.forEach(M=>{O=this.ensureQuotes(M),T.push(O.value),w=w&&O.quoted});const y=["/s","/c"];d?w?y.push('"'+T.join(" ")+'"'):T.length>1?y.push('"'+T[0]+'" '+T.slice(1).join(" ")):y.push('"'+T[0]+'"'):y.push(T.join(" ")),u=D.spawn(S(),y,f)}else this.cmd&&(u=D.spawn(this.cmd,this.args,this.options));u&&(this.childProcess=u,this.childProcessPromise=Promise.resolve(u),this.pidResolve&&(this.pidResolve(E.isNumber(u.pid)?u.pid:-1),this.pidResolve=void 0),u.on("error",f=>{this.childProcess=null,n({terminated:this.terminateRequested,error:f})}),u.pid&&(this.childProcess.on("close",l),this.handleSpawn(u,s,a,n,!0)))}return r})}handleClose(a,t,s,n){}ensureQuotes(a){return b.regexp.test(a)?{value:'"'+a+'"',quoted:!0}:{value:a,quoted:a.length>0&&a[0]==='"'&&a[a.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(a=>a.pid,a=>-1):new Promise(a=>{this.pidResolve=a})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(a=>(this.terminateRequested=!0,c(a,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),a=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(a=>{if(!this.shell||!P.isWindows)return a(!1);const t=D.spawn(S(),["/s","/c"]);t.on("error",s=>a(!0)),t.on("exit",s=>a(!1))})}}e.AbstractProcess=b,b.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},b.regexp=/^[^"].* .*[^"]/;class g extends b{constructor(a,t,s,n){super(a,t,s,n);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(a,t,s,n,r){[n,r].forEach((u,l)=>{const f=new i.LineDecoder;f.write(u).forEach(T=>{t({line:T,source:l===0?0:1})});const w=f.end();w&&t({line:w,source:l===0?0:1})}),a({terminated:this.terminateRequested,error:s})}handleSpawn(a,t,s,n,r){const u=new i.LineDecoder,l=new i.LineDecoder;a.stdout.on("data",f=>{u.write(f).forEach(w=>s({line:w,source:0}))}),a.stderr.on("data",f=>{l.write(f).forEach(w=>s({line:w,source:1}))}),this.stdoutLineDecoder=u,this.stderrLineDecoder=l}handleClose(a,t,s,n){const r=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;r&&s({line:r,source:0});const u=this.stderrLineDecoder?this.stderrLineDecoder.end():null;u&&s({line:u,source:1})}}e.LineProcess=g;function I(o){let a=[],t=!1;const s=function(n){if(t){a.push(n);return}(!o.send(n,u=>{if(u&&console.error(u),t=!1,a.length>0){const l=a.slice(0);a=[],l.forEach(f=>s(f))}})||P.isWindows)&&(t=!0)};return{send:s}}e.createQueuedSender=I;var p;(function(o){async function a(t,s,n){if(k.isAbsolute(t))return t;if(s===void 0&&(s=m.cwd()),k.dirname(t)!=="."||(n===void 0&&E.isString(m.env.PATH)&&(n=m.env.PATH.split(k.delimiter)),n===void 0||n.length===0))return k.join(s,t);async function u(l){if(await C.Promises.exists(l)){let f;try{f=await C.Promises.stat(l)}catch(d){d.message.startsWith("EACCES")&&(f=await C.Promises.lstat(l))}return f?!f.isDirectory():!1}return!1}for(let l of n){let f;if(k.isAbsolute(l)?f=k.join(l,t):f=k.join(s,l,t),await u(f))return f;let d=f+".com";if(await u(d)||(d=f+".exe",await u(d)))return d}return k.join(s,t)}o.findExecutable=a})(p=e.win32||(e.win32={}))}),define(te[109],ne([0,1,35,4,69,71]),function(K,e,D,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function k(v,c){return v===1?L.isWindows?C():A.getWindowsShell(c):E(v,c)}e.getSystemShell=k;function P(v,c){return v===1?L.isWindows?h(c):A.getWindowsShell(c):E(v,c)}e.getSystemShellSync=P;let m=null;function E(v,c){if(L.isLinux&&v===2||L.isMacintosh&&v===3)return"/bin/bash";if(!m){let S;if(L.isWindows)S="/bin/bash";else{if(S=c.SHELL,!S)try{S=(0,D.userInfo)().shell}catch(b){}S||(S="sh"),S==="/bin/false"&&(S="/bin/bash")}m=S}return m}let i=null;async function C(){return i||(i=(await(0,R.getFirstAvailablePowerShellInstallation)()).exePath),i}function h(v){if(i)return i;const c=L.isWindows&&parseFloat((0,D.release)())>=10,S=v.hasOwnProperty("PROCESSOR_ARCHITEW6432"),b=`${v.windir}\\${S?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return c?b:A.getWindowsShell(v)}}),define(te[52],ne([0,1,41,6,25,29,93,11,3,2,26,4,71,36]),function(K,e,D,L,R,A,k,P,m,E,i,C,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class c extends v.ChannelServer{constructor(g){super({send:I=>{try{process.send&&process.send(I.buffer.toString("base64"))}catch(p){}},onMessage:m.Event.fromNodeEventEmitter(process,"message",I=>R.VSBuffer.wrap(Buffer.from(I,"base64")))},g);process.once("disconnect",()=>this.dispose())}}e.Server=c;class S{constructor(g,I){this.modulePath=g,this.options=I,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new m.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const p=I&&I.timeout?I.timeout:6e4;this.disposeDelayer=new L.Delayer(p),this.child=null,this._client=null}getChannel(g){const I=this;return{call(p,o,a){return I.requestPromise(g,p,o,a)},listen(p,o){return I.requestEvent(g,p,o)}}}requestPromise(g,I,p,o=A.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const a=this.getCachedChannel(g),t=(0,L.createCancelablePromise)(r=>a.call(I,p,r)),s=o.onCancellationRequested(()=>t.cancel()),n=(0,E.toDisposable)(()=>t.cancel());return this.activeRequests.add(n),t.finally(()=>{s.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(g,I,p){if(!this.disposeDelayer)return m.Event.None;this.disposeDelayer.cancel();let o;const a=new m.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(g).listen(I,p)(a.fire,a),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return a.event}get client(){if(!this._client){const g=this.options&&this.options.args?this.options.args:[],I=Object.create(null);I.env={...(0,i.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(I.env={...I.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(I.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(I.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(I.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),I.execArgv===void 0&&(I.execArgv=process.execArgv.filter(u=>!/^--inspect(-brk)?=/.test(u))),C.isMacintosh&&I.env&&delete I.env.DYLD_LIBRARY_PATH,this.child=(0,D.fork)(this.modulePath,g,I);const p=new m.Emitter;m.Event.fromNodeEventEmitter(this.child,"message",u=>u)(u=>{if((0,k.isRemoteConsoleLog)(u)){(0,k.log)(u,`IPC Library: ${this.options.serverName}`);return}p.fire(R.VSBuffer.wrap(Buffer.from(u,"base64")))});const a=this.options.useQueue?(0,h.createQueuedSender)(this.child):this.child,t=u=>this.child&&this.child.connected&&a.send(u.buffer.toString("base64")),s=p.event,n={send:t,onMessage:s};this._client=new v.ChannelClient(n);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",u=>console.warn('IPC "'+this.options.serverName+'" errored with '+u)),this.child.on("exit",(u,l)=>{process.removeListener("exit",r),this.activeRequests.forEach(f=>(0,E.dispose)(f)),this.activeRequests.clear(),u!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+u+" and signal "+l),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:u,signal:l})})}return this._client}getCachedChannel(g){let I=this.channels.get(g);return I||(I=this.client.getChannel(g),this.channels.set(g,I)),I}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=S}),define(te[110],ne([9,10]),function(K,e){return K.create("vs/base/node/zip",e)}),define(te[111],ne([9,10]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[112],ne([9,10]),function(K,e){return K.create("vs/platform/environment/node/argv",e)}),define(te[113],ne([9,10]),function(K,e){return K.create("vs/platform/environment/node/argvHelper",e)}),define(te[114],ne([9,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(te[115],ne([9,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[116],ne([9,10]),function(K,e){return K.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(te[117],ne([9,10]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(te[118],ne([9,10]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(te[119],ne([9,10]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(te[120],ne([9,10]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[121],ne([9,10]),function(K,e){return K.create("vs/platform/files/common/fileService",e)}),define(te[122],ne([9,10]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(te[123],ne([9,10]),function(K,e){return K.create("vs/platform/files/common/io",e)}),define(te[124],ne([9,10]),function(K,e){return K.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[125],ne([9,10]),function(K,e){return K.create("vs/platform/request/common/request",e)}),define(te[126],ne([9,10]),function(K,e){return K.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[127],ne([9,10]),function(K,e){return K.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[128],ne([9,10]),function(K,e){return K.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(te[129],ne([9,10]),function(K,e){return K.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(te[130],ne([9,10]),function(K,e){return K.create("vs/platform/userDataSync/common/settingsSync",e)}),define(te[131],ne([9,10]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(te[132],ne([9,10]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSync",e)}),define(te[133],ne([9,10]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(te[134],ne([0,1,56,64,17,8,34,15,5]),function(K,e,D,L,R,A,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class E{constructor(c,S,b){this._args=c,this.paths=S,this.productService=b}get appRoot(){return(0,A.dirname)(R.FileAccess.asFileUri("",K).fsPath)}get userHome(){return m.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return m.URI.file((0,A.join)(this.userDataPath,"User"))}get tmpDir(){return m.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const c=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.join)(this.userDataPath,"logs",c)}return this.args.logsPath}get userDataSyncLogResource(){return m.URI.file((0,A.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(m.URI.file((0,A.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return m.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return m.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const c=k.env.VSCODE_PORTABLE;return c?m.URI.file((0,A.join)(c,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,P.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return m.URI.file((0,A.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,A.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const c=this.args["builtin-extensions-dir"];return c?(0,A.resolve)(c):(0,A.normalize)((0,A.join)(R.FileAccess.asFileUri("",K).fsPath,"..","extensions"))}get extensionsDownloadPath(){const c=this.args["extensions-download-dir"];return c?(0,A.resolve)(c):(0,A.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const c=this.args["extensions-dir"];if(c)return(0,A.resolve)(c);const S=k.env.VSCODE_EXTENSIONS;if(S)return S;const b=k.env.VSCODE_PORTABLE;return b?(0,A.join)(b,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const c=this.args.extensionDevelopmentPath;if(Array.isArray(c))return c.map(S=>/^[^:/?#]+?:\/\//.test(S)?m.URI.parse(S):m.URI.file((0,A.normalize)(S)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(c=>c==="ui"||c==="workspace"||c==="web"?c:"workspace")}get extensionTestsLocationURI(){const c=this.args.extensionTestsPath;if(c)return/^[^:/?#]+?:\/\//.test(c)?m.URI.parse(c):m.URI.file((0,A.normalize)(c))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const c=this.args["disable-extension"];if(c){if(typeof c=="string")return[c];if(Array.isArray(c)&&c.length>0)return c}return!1}get debugExtensionHost(){return i(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,P.joinPath)(m.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return m.URI.file((0,A.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([L.memoize],E.prototype,"appRoot",null),de([L.memoize],E.prototype,"userHome",null),de([L.memoize],E.prototype,"userDataPath",null),de([L.memoize],E.prototype,"appSettingsHome",null),de([L.memoize],E.prototype,"tmpDir",null),de([L.memoize],E.prototype,"userRoamingDataHome",null),de([L.memoize],E.prototype,"settingsResource",null),de([L.memoize],E.prototype,"userDataSyncHome",null),de([L.memoize],E.prototype,"userDataSyncLogResource",null),de([L.memoize],E.prototype,"sync",null),de([L.memoize],E.prototype,"machineSettingsResource",null),de([L.memoize],E.prototype,"globalStorageHome",null),de([L.memoize],E.prototype,"workspaceStorageHome",null),de([L.memoize],E.prototype,"keybindingsResource",null),de([L.memoize],E.prototype,"keyboardLayoutResource",null),de([L.memoize],E.prototype,"argvResource",null),de([L.memoize],E.prototype,"snippetsHome",null),de([L.memoize],E.prototype,"isExtensionDevelopment",null),de([L.memoize],E.prototype,"untitledWorkspacesHome",null),de([L.memoize],E.prototype,"installSourcePath",null),de([L.memoize],E.prototype,"builtinExtensionsPath",null),de([L.memoize],E.prototype,"extensionsPath",null),de([L.memoize],E.prototype,"extensionDevelopmentLocationURI",null),de([L.memoize],E.prototype,"extensionDevelopmentKind",null),de([L.memoize],E.prototype,"extensionTestsLocationURI",null),de([L.memoize],E.prototype,"debugExtensionHost",null),de([L.memoize],E.prototype,"serviceMachineIdResource",null),de([L.memoize],E.prototype,"telemetryLogResource",null),de([L.memoize],E.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=E;function i(v,c){return h(v["inspect-extensions"],v["inspect-brk-extensions"],5870,c,v.debugId)}e.parseExtensionHostPort=i;function C(v,c){return h(v["inspect-search"],v["inspect-brk-search"],5876,c)}e.parseSearchPort=C;function h(v,c,S,b,g){const p=Number(c||v)||(b?null:S),o=p?Boolean(!!c):!1;return{port:p,break:o,debugId:g}}}),define(te[135],ne([0,1,220,4,112]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const A={o:(0,R.localize)(0,null),e:(0,R.localize)(1,null),t:(0,R.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,R.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,R.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,R.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,R.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,R.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,R.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,R.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,R.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,R.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,R.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,R.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,R.localize)(14,null)},category:{type:"string",cat:"e",description:(0,R.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,R.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,R.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,R.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,R.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,R.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,R.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,R.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,R.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,R.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,R.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,R.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,R.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,R.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,R.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,R.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,R.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const k={onUnknownOption:()=>{},onMultipleValues:()=>{}};function P(c,S,b=k){const g={},I=[],p=[];for(let s in S){const n=S[s];n.alias&&(g[s]=n.alias),n.type==="string"||n.type==="string[]"?(I.push(s),n.deprecates&&I.push(n.deprecates)):n.type==="boolean"&&(p.push(s),n.deprecates&&p.push(n.deprecates))}const o=D(c,{string:I,boolean:p,alias:g}),a={},t=o;a._=o._.map(s=>String(s)).filter(s=>s.length>0),delete t._;for(let s in S){const n=S[s];n.alias&&delete t[n.alias];let r=t[s];n.deprecates&&t.hasOwnProperty(n.deprecates)&&(r||(r=t[n.deprecates]),delete t[n.deprecates]),typeof r!="undefined"&&(n.type==="string[]"?r&&!Array.isArray(r)&&(r=[r]):n.type==="string"&&Array.isArray(r)&&(r=r.pop(),b.onMultipleValues(s,r)),a[s]=r),delete t[s]}for(let s in t)b.onUnknownOption(s);return a}e.parseArgs=P;function m(c,S){let b="";return S.args&&(Array.isArray(S.args)?b=` <${S.args.join("> <")}>`:b=` <${S.args}>`),S.alias?`-${S.alias} --${c}${b}`:`--${c}${b}`}function E(c,S){let b=0,g=[];for(const a in c){const t=c[a],s=m(a,t);b=Math.max(b,s.length),g.push([s,t.description])}let I=b+2+1;if(S-I<25)return g.reduce((a,t)=>a.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let p=S-I-1,o=[];for(const a of g){let t=a[0],s=C(a[1],p),n=i(I-t.length-2);o.push("  "+t+n+s[0]);for(let r=1;r<s.length;r++)o.push(i(I)+s[r])}return o}e.formatOptions=E;function i(c){return" ".repeat(c)}function C(c,S){let b=[];for(;c.length;){let g=c.length<S?c.length:c.lastIndexOf(" ",S),I=c.slice(0,g).trim();c=c.slice(g),b.push(I)}return b}function h(c,S,b,g,I=!0){const p=process.stdout.isTTY&&process.stdout.columns||80;let o=[`${c} ${b}`];o.push(""),o.push(`${(0,R.localize)(32,null)}: ${S} [${(0,R.localize)(33,null)}][${(0,R.localize)(34,null)}...]`),o.push(""),I&&(L.isWindows?o.push((0,R.localize)(35,null,S)):o.push((0,R.localize)(36,null,S)),o.push(""));const a={};for(const t in g){const s=g[t];if(s.description&&s.cat){let n=a[s.cat];n||(a[s.cat]=n={}),n[t]=s}}for(let t in a){const s=t;let n=a[s];n&&(o.push(A[s]),o.push(...E(n,p)),o.push(""))}return o.join(`
`)}e.buildHelpMessage=h;function v(c,S){return`${c||(0,R.localize)(37,null)}
${S||(0,R.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=v}),function(){"use strict";function K(e,D,L,R){function A(P){const m=k(P),E=[m];return e.isAbsolute(m)||E.unshift(R),e.resolve(...E)}function k(P){const m=process.env.VSCODE_PORTABLE;if(m)return e.join(m,"user-data");let E=process.env.VSCODE_APPDATA;if(E)return e.join(E,L);const i=P["user-data-dir"];if(i)return i;switch(process.platform){case"win32":if(E=process.env.APPDATA,!E){const C=process.env.USERPROFILE;if(typeof C!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");E=e.join(C,"AppData","Roaming")}break;case"darwin":E=e.join(D.homedir(),"Library","Application Support");break;case"linux":E=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(E,L)}return{getUserDataPath:A}}if(typeof define=="function")define(te[136],ne([0,137,35,17,15,34]),function(e,D,L,R,A,k){const P=A.dirname(R.FileAccess.asFileUri("",e)),m=e.__$__nodeRequire(A.joinPath(P,"package.json").fsPath);return K(D,L,m.name,k.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),D=require("path"),L=require("os");module.exports=K(D,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[138],ne([0,1,35,134,136]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class A extends L.AbstractNativeEnvironmentService{constructor(P,m){super(P,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,R.getUserDataPath)(P)},m)}}e.NativeEnvironmentService=A}),define(te[139],ne([0,1,5]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const L=/^([^@:]+@)?([^:]+):/,R=/^([^@:]+@)?([^:]+):(.+)$/,A=/^([^@]+@)?([^:]+)(:\d+)?$/,k=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,m=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function E(b){const g=b.match(k);return g?g[1]:null}function i(b){if(b.indexOf("://")===-1){const g=b.match(L);return g?E(g[2]):null}try{const g=D.URI.parse(b);if(g.authority)return E(g.authority)}catch(g){}return null}function C(b,g){const I=new Set;let p;for(;p=P.exec(b);){const a=i(p[1]);a&&I.add(a)}const o=new Set(g);return Array.from(I).map(a=>o.has(a)?a:a.replace(m,"a"))}e.getDomainsOfRemotes=C;function h(b){const g=b.match(A);return g?g[2]:null}function v(b,g,I){return b&&g?(I&&g.endsWith(".git")&&(g=g.substr(0,g.length-4)),g.indexOf("/")===0?`${b}${g}`:`${b}/${g}`):null}function c(b,g){if(b.indexOf("://")===-1){const I=b.match(R);if(I)return v(I[2],I[3],g)}try{const I=D.URI.parse(b);if(I.authority)return v(h(I.authority),I.path,g)}catch(I){}return null}function S(b,g=!1){const I=[];let p;for(;p=P.exec(b);){const o=c(p[1],g);o&&I.push(o)}return I}e.getRemotes=S}),define(te[140],ne([0,1,3,2,26,5,96]),function(K,e,D,L,R,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function P(c,S){return A.URI.revive(S?S.transformIncoming(c):c)}function m(c,S){return S?S.transformOutgoingURI(c):c}function E(c,S){S=S||k.DefaultURITransformer;const b=c.manifest;return{...(0,k.transformAndReviveIncomingURIs)({...c,manifest:void 0},S),manifest:b}}function i(c,S){return S?(0,R.cloneAndChange)(c,b=>b instanceof A.URI?S.transformOutgoingURI(b):void 0):c}class C{constructor(S,b){this.service=S,this.getUriTransformer=b,this.onInstallExtension=D.Event.buffer(S.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(S.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(S.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(S.onDidUninstallExtension,!0)}listen(S,b){const g=this.getUriTransformer(S);switch(b){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,I=>I.map(p=>({...p,local:p.local?i(p.local,g):p.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(S,b,g){const I=this.getUriTransformer(S);switch(b){case"zip":return this.service.zip(E(g[0],I)).then(p=>m(p,I));case"unzip":return this.service.unzip(P(g[0],I));case"install":return this.service.install(P(g[0],I),g[1]);case"getManifest":return this.service.getManifest(P(g[0],I));case"canInstall":return this.service.canInstall(g[0]);case"installFromGallery":return this.service.installFromGallery(g[0],g[1]);case"uninstall":return this.service.uninstall(E(g[0],I),g[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(E(g[0],I));case"getInstalled":return this.service.getInstalled(g[0]).then(p=>p.map(o=>i(o,I)));case"updateMetadata":return this.service.updateMetadata(E(g[0],I),g[1]).then(p=>i(p,I));case"updateExtensionScope":return this.service.updateExtensionScope(E(g[0],I),g[1]).then(p=>i(p,I));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=C;class h extends L.Disposable{constructor(S){super();this.channel=S,this._onInstallExtension=this._register(new D.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new D.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new D.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new D.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(b=>this._onInstallExtension.fire({identifier:b.identifier,source:this.isUriComponents(b.source)?A.URI.revive(b.source):b.source}))),this._register(this.channel.listen("onDidInstallExtensions")(b=>this._onDidInstallExtensions.fire(b.map(g=>({...g,local:g.local?E(g.local,null):g.local,source:this.isUriComponents(g.source)?A.URI.revive(g.source):g.source}))))),this._register(this.channel.listen("onUninstallExtension")(b=>this._onUninstallExtension.fire(b))),this._register(this.channel.listen("onDidUninstallExtension")(b=>this._onDidUninstallExtension.fire(b)))}isUriComponents(S){return S?typeof S.path=="string"&&typeof S.scheme=="string":!1}zip(S){return Promise.resolve(this.channel.call("zip",[S]).then(b=>A.URI.revive(b)))}unzip(S){return Promise.resolve(this.channel.call("unzip",[S]))}install(S,b){return Promise.resolve(this.channel.call("install",[S,b])).then(g=>E(g,null))}getManifest(S){return Promise.resolve(this.channel.call("getManifest",[S]))}async canInstall(S){return!0}installFromGallery(S,b){return Promise.resolve(this.channel.call("installFromGallery",[S,b])).then(g=>E(g,null))}uninstall(S,b){return Promise.resolve(this.channel.call("uninstall",[S,b]))}reinstallFromGallery(S){return Promise.resolve(this.channel.call("reinstallFromGallery",[S]))}getInstalled(S=null){return Promise.resolve(this.channel.call("getInstalled",[S])).then(b=>b.map(g=>E(g,null)))}updateMetadata(S,b){return Promise.resolve(this.channel.call("updateMetadata",[S,b])).then(g=>E(g,null))}updateExtensionScope(S,b){return Promise.resolve(this.channel.call("updateExtensionScope",[S,b])).then(g=>E(g,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=h;class v{constructor(S){this.service=S}listen(S,b){throw new Error("Invalid listen")}call(S,b,g){switch(b){case"getConfigBasedTips":return this.service.getConfigBasedTips(A.URI.revive(g[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=v}),define(te[141],ne([0,1,26]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const L=/^%([\w\d.-]+)%$/i;function R(A,k){const P=m=>{if(typeof m!="string")return;const E=L.exec(m);if(!E)return;const i=k[E[1]]??m;return typeof i=="string"?i:typeof i.message=="string"?i.message:m};return(0,D.cloneAndChange)(A,P)}e.localizeManifest=R}),define(te[142],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class D{constructor(A){this.channel=A}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(A,k,P,m){return this.channel.call("promptImportantExtensionsInstallNotification",[A,k,P,m])}promptWorkspaceRecommendations(A){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=D;class L{constructor(A){this.service=A}listen(A,k){throw new Error(`Event not found: ${k}`)}call(A,k,P){switch(k){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${k}`)}}e.ExtensionRecommendationNotificationServiceChannel=L}),define(te[72],ne([0,1,120]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function A(h){return h=h.trim(),h==="*"||L.test(h)}e.isValidVersionStr=A;function k(h){if(!A(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let v=h.match(L);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=k;function P(h){if(!h)return null;let v=h.majorBase,c=h.majorMustEqual,S=h.minorBase,b=h.minorMustEqual,g=h.patchBase,I=h.patchMustEqual;h.hasCaret&&(v===0||(b=!1),I=!1);let p=0;if(h.preRelease){const o=R.exec(h.preRelease);if(o){const[,a,t,s]=o;p=Date.UTC(Number(a),Number(t)-1,Number(s))}}return{majorBase:v,majorMustEqual:c,minorBase:S,minorMustEqual:b,patchBase:g,patchMustEqual:I,isMinimum:h.hasGreaterEquals,notBefore:p}}e.normalizeVersion=P;function m(h,v,c){let S;typeof h=="string"?S=P(k(h)):S=h;let b;v instanceof Date?b=v.getTime():typeof v=="string"&&(b=new Date(v).getTime());let g;if(typeof c=="string"?g=P(k(c)):g=c,!S||!g)return!1;let I=S.majorBase,p=S.minorBase,o=S.patchBase,a=g.majorBase,t=g.minorBase,s=g.patchBase,n=g.notBefore,r=g.majorMustEqual,u=g.minorMustEqual,l=g.patchMustEqual;return g.isMinimum?I>a?!0:I<a?!1:p>t?!0:p<t||b&&b<n?!1:o>=s:(I===1&&a===0&&(!r||!u||!l)&&(a=1,t=0,s=0,r=!0,u=!1,l=!1),I<a?!1:I>a?!r:p<t?!1:p>t?!u:o<s?!1:o>s?!l:!(b&&b<n))}e.isValidVersion=m;function E(h,v,c,S){return c.isBuiltin||typeof c.main=="undefined"?!0:C(h,v,c.engines.vscode,S)}e.isValidExtensionVersion=E;function i(h,v,c){return h==="*"||C(v,c,h)}e.isEngineValid=i;function C(h,v,c,S=[]){let b=P(k(c));if(!b)return S.push(D.localize(0,null,c)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return S.push(D.localize(1,null,c)),!1}else if(!b.majorMustEqual)return S.push(D.localize(2,null,c)),!1;return m(h,v,b)?!0:(S.push(D.localize(3,null,h,c)),!1)}}),define(te[143],ne([0,1,2,17,36,52]),function(K,e,D,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k extends D.Disposable{constructor(m,E,i,C){super();this.folders=m,this.onDidFilesChange=E,this.onLogMessage=i,this.verboseLogging=C,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const m=this._register(new A.Client(L.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(m.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=k.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=R.ProxyChannel.toService((0,R.getNextTickChannel)(m.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(E=>!this.isDisposed&&this.onDidFilesChange(E))),this._register(this.service.onDidLogMessage(E=>this.onLogMessage(E))),this.setFolders(this.folders)}setVerboseLogging(m){this.verboseLogging=m,!this.isDisposed&&this.service&&this.service.setVerboseLogging(m)}error(m){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${m}`})}setFolders(m){this.folders=m,this.service&&this.service.setRoots(m)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=k,k.MAX_RESTARTS=5}),define(te[144],ne([0,1,2,17,36,52]),function(K,e,D,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k extends D.Disposable{constructor(m,E,i,C,h={}){super();this.folders=m,this.onDidFilesChange=E,this.onLogMessage=i,this.verboseLogging=C,this.watcherOptions=h,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const m=this._register(new A.Client(L.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(m.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=k.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=R.ProxyChannel.toService((0,R.getNextTickChannel)(m.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(E=>!this.isDisposed&&this.onDidFilesChange(E))),this._register(this.service.onDidLogMessage(E=>this.onLogMessage(E))),this.service.setRoots(this.folders)}error(m){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${m}`})}setVerboseLogging(m){this.verboseLogging=m,this.service&&this.service.setVerboseLogging(m)}setFolders(m){this.folders=m,this.service&&this.service.setRoots(m)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=k,k.MAX_RESTARTS=5}),define(te[145],ne([0,1,41,67,17,68]),function(K,e,D,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class k{constructor(m,E,i,C,h){this.watchedFolder=m,this.eventCallback=i,this.logCallback=C,this.verboseLogging=h,this.restartCounter=0,Array.isArray(E)?this.ignored=E.map(v=>(0,L.parse)(v)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${m}, excludes: ${E.join(",")}`),this.startWatcher()}startWatcher(){const m=[this.watchedFolder];this.verboseLogging&&m.push("-verbose"),this.handle=(0,D.spawn)(R.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",K).fsPath,m);const E=new A.LineDecoder;this.handle.stdout.on("data",i=>{const C=[];for(const h of E.write(i)){const v=h.split("|");if(v.length===2){const c=Number(v[0]),S=v[1];if(c>=0&&c<3){if(this.ignored&&this.ignored.some(b=>b(S))){this.verboseLogging&&this.log(S);continue}C.push({type:k.changeTypeMap[c],path:S})}else this.log(v[1])}}C.length>0&&this.eventCallback(C)}),this.handle.on("error",i=>this.onError(i)),this.handle.stderr.on("data",i=>this.onError(i)),this.handle.on("exit",(i,C)=>this.onExit(i,C))}onError(m){this.error("process error: "+m.toString())}onExit(m,E){this.handle&&(this.error(`terminated unexpectedly (code: ${m}, signal: ${E})`),this.restartCounter<=k.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(m){this.logCallback({type:"error",message:`[File Watcher (C#)] ${m}`})}log(m){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${m}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=k,k.MAX_RESTARTS=5,k.changeTypeMap=[0,1,2]}),define(te[146],ne([0,1,8,24,145]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class A{constructor(P,m,E,i){this.onDidFilesChange=m,this.onLogMessage=E,this.verboseLogging=i,this.service=void 0,this.folder=P[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(D.posix.sep)&&(this.folder.path=(0,L.rtrim)(this.folder.path,D.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new R.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,P=>this.onFileEvents(P),P=>this.onLogMessage(P),this.verboseLogging)}setVerboseLogging(P){this.verboseLogging=P,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(P){this.isDisposed||P.length>0&&this.onDidFilesChange(P)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=A}),define(te[53],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class D{constructor(R,A=[],k=!1){this.ctor=R,this.staticArguments=A,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=D}),define(te[147],ne([0,1,53]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function R(k,P,m){P instanceof D.SyncDescriptor||(P=new D.SyncDescriptor(P,[],m)),L.push([k,P])}e.registerSingleton=R;function A(){return L}e.getSingletonServiceDescriptors=A}),define(te[148],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class D{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=D;class L{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let k of this._nodes.values())k.outgoing.size===0&&A.push(k);return A}insertEdge(A,k){const P=this.lookupOrInsertNode(A),m=this.lookupOrInsertNode(k);P.outgoing.set(this._hashFn(k),m),m.incoming.set(this._hashFn(A),P)}removeNode(A){const k=this._hashFn(A);this._nodes.delete(k);for(let P of this._nodes.values())P.outgoing.delete(k),P.incoming.delete(k)}lookupOrInsertNode(A){const k=this._hashFn(A);let P=this._nodes.get(k);return P||(P=new D(A),this._nodes.set(k,P)),P}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[k,P]of this._nodes)A.push(`${k}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,k]of this._nodes){const P=new Set([A]),m=this._findCycle(k,P);if(m)return m}}_findCycle(A,k){for(let[P,m]of A.outgoing){if(k.has(P))return[...k,P].join(" -> ");k.add(P);const E=this._findCycle(m,k);if(E)return E;k.delete(P)}}}e.Graph=L}),define(te[7],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var D;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function m(E){return E[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=m})(D=e._util||(e._util={})),e.IInstantiationService=R("instantiationService");function L(P,m,E,i){m[D.DI_TARGET]===m?m[D.DI_DEPENDENCIES].push({id:P,index:E,optional:i}):(m[D.DI_DEPENDENCIES]=[{id:P,index:E,optional:i}],m[D.DI_TARGET]=m)}function R(P){if(D.serviceIds.has(P))return D.serviceIds.get(P);const m=function(E,i,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(m,E,C,!1)};return m.toString=()=>P,D.serviceIds.set(P,m),m}e.createDecorator=R;function A(P){return P}e.refineServiceDecorator=A;function k(P){return function(m,E,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(P,m,i,!0)}}e.optional=k}),define(te[149],ne([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,D.createDecorator)("checksumService")}),define(te[150],ne([0,1,4,24,7]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let A=D.userAgent||"";const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",D.isMacintosh),k.set("isLinux",D.isLinux),k.set("isWindows",D.isWindows),k.set("isWeb",D.isWeb),k.set("isMacNative",D.isMacintosh&&!D.isWeb),k.set("isEdge",A.indexOf("Edg/")>=0),k.set("isFirefox",A.indexOf("Firefox")>=0),k.set("isChrome",A.indexOf("Chrome")>=0),k.set("isSafari",A.indexOf("Safari")>=0);const P=Object.prototype.hasOwnProperty;var m;(function(O){O[O.False=0]="False",O[O.True=1]="True",O[O.Defined=2]="Defined",O[O.Not=3]="Not",O[O.Equals=4]="Equals",O[O.NotEquals=5]="NotEquals",O[O.And=6]="And",O[O.Regex=7]="Regex",O[O.NotRegex=8]="NotRegex",O[O.Or=9]="Or",O[O.In=10]="In",O[O.NotIn=11]="NotIn",O[O.Greater=12]="Greater",O[O.GreaterEquals=13]="GreaterEquals",O[O.Smaller=14]="Smaller",O[O.SmallerEquals=15]="SmallerEquals"})(m=e.ContextKeyExprType||(e.ContextKeyExprType={}));class E{static false(){return C.INSTANCE}static true(){return h.INSTANCE}static has(y){return v.create(y)}static equals(y,M){return c.create(y,M)}static notEquals(y,M){return g.create(y,M)}static regex(y,M){return s.create(y,M)}static in(y,M){return S.create(y,M)}static not(y){return I.create(y)}static and(...y){return r.create(y,null)}static or(...y){return u.create(y,null,!0)}static greater(y,M){return p.create(y,M)}static less(y,M){return a.create(y,M)}static deserialize(y,M=!1){if(!!y)return this._deserializeOrExpression(y,M)}static _deserializeOrExpression(y,M){let F=y.split("||");return u.create(F.map(q=>this._deserializeAndExpression(q,M)),null,!0)}static _deserializeAndExpression(y,M){let F=y.split("&&");return r.create(F.map(q=>this._deserializeOne(q,M)),null)}static _deserializeOne(y,M){if(y=y.trim(),y.indexOf("!=")>=0){let F=y.split("!=");return g.create(F[0].trim(),this._deserializeValue(F[1],M))}if(y.indexOf("==")>=0){let F=y.split("==");return c.create(F[0].trim(),this._deserializeValue(F[1],M))}if(y.indexOf("=~")>=0){let F=y.split("=~");return s.create(F[0].trim(),this._deserializeRegexValue(F[1],M))}if(y.indexOf(" in ")>=0){let F=y.split(" in ");return S.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(y)){const F=y.split(">=");return o.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(y)){const F=y.split(">");return p.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(y)){const F=y.split("<=");return t.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(y)){const F=y.split("<");return a.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(y)?I.create(y.substr(1).trim()):v.create(y)}static _deserializeValue(y,M){if(y=y.trim(),y==="true")return!0;if(y==="false")return!1;let F=/^'([^']*)'$/.exec(y);return F?F[1].trim():y}static _deserializeRegexValue(y,M){if((0,L.isFalsyOrWhitespace)(y)){if(M)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let F=y.indexOf("/"),q=y.lastIndexOf("/");if(F===q||F<0){if(M)throw new Error(`bad regexp-value '${y}', missing /-enclosure`);return console.warn(`bad regexp-value '${y}', missing /-enclosure`),null}let x=y.slice(F+1,q),U=y[q+1]==="i"?"i":"";try{return new RegExp(x,U)}catch($){if(M)throw new Error(`bad regexp-value '${y}', parse error: ${$}`);return console.warn(`bad regexp-value '${y}', parse error: ${$}`),null}}}e.ContextKeyExpr=E;function i(O,y){return O.cmp(y)}class C{constructor(){this.type=0}cmp(y){return this.type-y.type}equals(y){return y.type===this.type}evaluate(y){return!1}serialize(){return"false"}keys(){return[]}map(y){return this}negate(){return h.INSTANCE}}e.ContextKeyFalseExpr=C,C.INSTANCE=new C;class h{constructor(){this.type=1}cmp(y){return this.type-y.type}equals(y){return y.type===this.type}evaluate(y){return!0}serialize(){return"true"}keys(){return[]}map(y){return this}negate(){return C.INSTANCE}}e.ContextKeyTrueExpr=h,h.INSTANCE=new h;class v{constructor(y,M){this.key=y,this.negated=M,this.type=2}static create(y,M=null){const F=k.get(y);return typeof F=="boolean"?F?h.INSTANCE:C.INSTANCE:new v(y,M)}cmp(y){return y.type!==this.type?this.type-y.type:f(this.key,y.key)}equals(y){return y.type===this.type?this.key===y.key:!1}evaluate(y){return!!y.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(y){return y.mapDefined(this.key)}negate(){return this.negated||(this.negated=I.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=v;class c{constructor(y,M,F){this.key=y,this.value=M,this.negated=F,this.type=4}static create(y,M,F=null){if(typeof M=="boolean")return M?v.create(y,F):I.create(y,F);const q=k.get(y);return typeof q=="boolean"?M===(q?"true":"false")?h.INSTANCE:C.INSTANCE:new c(y,M,F)}cmp(y){return y.type!==this.type?this.type-y.type:d(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}evaluate(y){return y.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(y){return y.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=c;class S{constructor(y,M){this.key=y,this.valueKey=M,this.type=10,this.negated=null}static create(y,M){return new S(y,M)}cmp(y){return y.type!==this.type?this.type-y.type:d(this.key,this.valueKey,y.key,y.valueKey)}equals(y){return y.type===this.type?this.key===y.key&&this.valueKey===y.valueKey:!1}evaluate(y){const M=y.getValue(this.valueKey),F=y.getValue(this.key);return Array.isArray(M)?M.indexOf(F)>=0:typeof F=="string"&&typeof M=="object"&&M!==null?P.call(M,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(y){return y.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=b.create(this)),this.negated}}e.ContextKeyInExpr=S;class b{constructor(y){this._actual=y,this.type=11}static create(y){return new b(y)}cmp(y){return y.type!==this.type?this.type-y.type:this._actual.cmp(y._actual)}equals(y){return y.type===this.type?this._actual.equals(y._actual):!1}evaluate(y){return!this._actual.evaluate(y)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(y){return new b(this._actual.map(y))}negate(){return this._actual}}e.ContextKeyNotInExpr=b;class g{constructor(y,M,F){this.key=y,this.value=M,this.negated=F,this.type=5}static create(y,M,F=null){if(typeof M=="boolean")return M?I.create(y,F):v.create(y,F);const q=k.get(y);return typeof q=="boolean"?M===(q?"true":"false")?C.INSTANCE:h.INSTANCE:new g(y,M,F)}cmp(y){return y.type!==this.type?this.type-y.type:d(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}evaluate(y){return y.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(y){return y.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=g;class I{constructor(y,M){this.key=y,this.negated=M,this.type=3}static create(y,M=null){const F=k.get(y);return typeof F=="boolean"?F?C.INSTANCE:h.INSTANCE:new I(y,M)}cmp(y){return y.type!==this.type?this.type-y.type:f(this.key,y.key)}equals(y){return y.type===this.type?this.key===y.key:!1}evaluate(y){return!y.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(y){return y.mapNot(this.key)}negate(){return this.negated||(this.negated=v.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=I;class p{constructor(y,M,F){this.key=y,this.value=M,this.negated=F,this.type=12}static create(y,M,F=null){return new p(y,M,F)}cmp(y){return y.type!==this.type?this.type-y.type:d(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}evaluate(y){return parseFloat(y.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(y){return y.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=t.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=p;class o{constructor(y,M,F){this.key=y,this.value=M,this.negated=F,this.type=13}static create(y,M,F=null){return new o(y,M,F)}cmp(y){return y.type!==this.type?this.type-y.type:d(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}evaluate(y){return parseFloat(y.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(y){return y.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=o;class a{constructor(y,M,F){this.key=y,this.value=M,this.negated=F,this.type=14}static create(y,M,F=null){return new a(y,M,F)}cmp(y){return y.type!==this.type?this.type-y.type:d(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}evaluate(y){return parseFloat(y.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(y){return y.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=a;class t{constructor(y,M,F){this.key=y,this.value=M,this.negated=F,this.type=15}static create(y,M,F=null){return new t(y,M,F)}cmp(y){return y.type!==this.type?this.type-y.type:d(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}evaluate(y){return parseFloat(y.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(y){return y.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=t;class s{constructor(y,M){this.key=y,this.regexp=M,this.type=7,this.negated=null}static create(y,M){return new s(y,M)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.key<y.key)return-1;if(this.key>y.key)return 1;const M=this.regexp?this.regexp.source:"",F=y.regexp?y.regexp.source:"";return M<F?-1:M>F?1:0}equals(y){if(y.type===this.type){const M=this.regexp?this.regexp.source:"",F=y.regexp?y.regexp.source:"";return this.key===y.key&&M===F}return!1}evaluate(y){let M=y.getValue(this.key);return this.regexp?this.regexp.test(M):!1}serialize(){const y=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${y}`}keys(){return[this.key]}map(y){return y.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=n.create(this)),this.negated}}e.ContextKeyRegexExpr=s;class n{constructor(y){this._actual=y,this.type=8}static create(y){return new n(y)}cmp(y){return y.type!==this.type?this.type-y.type:this._actual.cmp(y._actual)}equals(y){return y.type===this.type?this._actual.equals(y._actual):!1}evaluate(y){return!this._actual.evaluate(y)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(y){return new n(this._actual.map(y))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;class r{constructor(y,M){this.expr=y,this.negated=M,this.type=6}static create(y,M){return r._normalizeArr(y,M)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.expr.length<y.expr.length)return-1;if(this.expr.length>y.expr.length)return 1;for(let M=0,F=this.expr.length;M<F;M++){const q=i(this.expr[M],y.expr[M]);if(q!==0)return q}return 0}equals(y){if(y.type===this.type){if(this.expr.length!==y.expr.length)return!1;for(let M=0,F=this.expr.length;M<F;M++)if(!this.expr[M].equals(y.expr[M]))return!1;return!0}return!1}evaluate(y){for(let M=0,F=this.expr.length;M<F;M++)if(!this.expr[M].evaluate(y))return!1;return!0}static _normalizeArr(y,M){const F=[];let q=!1;for(const x of y)if(!!x){if(x.type===1){q=!0;continue}if(x.type===0)return C.INSTANCE;if(x.type===6){F.push(...x.expr);continue}F.push(x)}if(F.length===0&&q)return h.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];F.sort(i);for(let x=1;x<F.length;x++)F[x-1].equals(F[x])&&(F.splice(x,1),x--);if(F.length===1)return F[0];for(;F.length>1;){const x=F[F.length-1];if(x.type!==9)break;F.pop();const U=F.pop(),$=F.length===0,B=u.create(x.expr.map(z=>r.create([z,U],null)),null,$);B&&(F.push(B),F.sort(i))}return F.length===1?F[0]:new r(F,M)}}serialize(){return this.expr.map(y=>y.serialize()).join(" && ")}keys(){const y=[];for(let M of this.expr)y.push(...M.keys());return y}map(y){return new r(this.expr.map(M=>M.map(y)),null)}negate(){if(!this.negated){const y=[];for(let M of this.expr)y.push(M.negate());this.negated=u.create(y,this,!0)}return this.negated}}class u{constructor(y,M){this.expr=y,this.negated=M,this.type=9}static create(y,M,F){return u._normalizeArr(y,M,F)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.expr.length<y.expr.length)return-1;if(this.expr.length>y.expr.length)return 1;for(let M=0,F=this.expr.length;M<F;M++){const q=i(this.expr[M],y.expr[M]);if(q!==0)return q}return 0}equals(y){if(y.type===this.type){if(this.expr.length!==y.expr.length)return!1;for(let M=0,F=this.expr.length;M<F;M++)if(!this.expr[M].equals(y.expr[M]))return!1;return!0}return!1}evaluate(y){for(let M=0,F=this.expr.length;M<F;M++)if(this.expr[M].evaluate(y))return!0;return!1}static _normalizeArr(y,M,F){let q=[],x=!1;if(y){for(let U=0,$=y.length;U<$;U++){const B=y[U];if(!!B){if(B.type===0){x=!0;continue}if(B.type===1)return h.INSTANCE;if(B.type===9){q=q.concat(B.expr);continue}q.push(B)}}if(q.length===0&&x)return C.INSTANCE;q.sort(i)}if(q.length!==0){if(q.length===1)return q[0];for(let U=1;U<q.length;U++)q[U-1].equals(q[U])&&(q.splice(U,1),U--);if(q.length===1)return q[0];if(F){for(let U=0;U<q.length;U++)for(let $=U+1;$<q.length;$++)w(q[U],q[$])&&(q.splice($,1),$--);if(q.length===1)return q[0]}return new u(q,M)}}serialize(){return this.expr.map(y=>y.serialize()).join(" || ")}keys(){const y=[];for(let M of this.expr)y.push(...M.keys());return y}map(y){return new u(this.expr.map(M=>M.map(y)),null)}negate(){if(!this.negated){let y=[];for(let M of this.expr)y.push(M.negate());for(;y.length>1;){const M=y.shift(),F=y.shift(),q=[];for(const U of T(M))for(const $ of T(F))q.push(r.create([U,$],null));const x=y.length===0;y.unshift(u.create(q,null,x))}this.negated=y[0]}return this.negated}}class l extends v{constructor(y,M,F){super(y,null);this._defaultValue=M,typeof F=="object"?l._info.push({...F,key:y}):F!==!0&&l._info.push({key:y,description:F,type:M!=null?typeof M:void 0})}static all(){return l._info.values()}bindTo(y){return y.createKey(this.key,this._defaultValue)}getValue(y){return y.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(y){return c.create(this.key,y)}notEqualsTo(y){return g.create(this.key,y)}}e.RawContextKey=l,l._info=[],e.IContextKeyService=(0,R.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function f(O,y){return O<y?-1:O>y?1:0}function d(O,y,M,F){return O<M?-1:O>M?1:y<F?-1:y>F?1:0}function w(O,y){if(y.type===6&&O.type!==9&&O.type!==6){for(const q of y.expr)if(O.equals(q))return!0}const M=O.negate(),F=T(M).concat(T(y));F.sort(i);for(let q=0;q<F.length;q++){const U=F[q].negate();for(let $=q+1;$<F.length;$++){const B=F[$];if(U.equals(B))return!0}}return!1}e.implies=w;function T(O){return O.type===9?O.expr:[O]}}),define(te[73],ne([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,D.createDecorator)(e.ID);function L(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=L}),define(te[74],ne([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,D.createDecorator)("downloadService")}),define(te[12],ne([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,D.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,D.refineServiceDecorator)(e.IEnvironmentService)}),define(te[27],ne([0,1,17,4,34,115,7]),function(K,e,D,L,R,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.CURRENT_TARGET_PLATFORM=e.getTargetPlatform=e.getTargetPlatformFromOS=e.toTargetPlatform=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var P;(function(g){g.WIN32_X64="win32-x64",g.WIN32_IA32="win32-ia32",g.WIN32_ARM64="win32-arm64",g.LINUX_X64="linux-x64",g.LINUX_ARM64="linux-arm64",g.LINUX_ARMHF="linux-armhf",g.DARWIN_X64="darwin-x64",g.DARWIN_ARM64="darwin-arm64",g.WEB="web",g.UNIVERSAL="universal",g.UNKNOWN="unknown",g.UNDEFINED="undefined"})(P=e.TargetPlatform||(e.TargetPlatform={}));function m(g){switch(g){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=m;function E(g,I){let p;switch(g){case 1:p=3;break;case 3:p=2;break;case 2:p=1;break}return i(p,I)}e.getTargetPlatformFromOS=E;function i(g,I){switch(g){case 3:return I==="x64"?"win32-x64":I==="ia32"?"win32-ia32":I==="arm64"?"win32-arm64":"unknown";case 2:return I==="x64"?"linux-x64":I==="arm64"?"linux-arm64":I==="arm"?"linux-armhf":"unknown";case 1:return I==="x64"?"darwin-x64":I==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=i,e.CURRENT_TARGET_PLATFORM=L.isWeb?"web":i(L.platform,R.arch);function C(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=C;var h;(function(g){g[g.NoneOrRelevance=0]="NoneOrRelevance",g[g.LastUpdatedDate=1]="LastUpdatedDate",g[g.Title=2]="Title",g[g.PublisherName=3]="PublisherName",g[g.InstallCount=4]="InstallCount",g[g.PublishedDate=5]="PublishedDate",g[g.AverageRating=6]="AverageRating",g[g.WeightedRating=12]="WeightedRating"})(h=e.SortBy||(e.SortBy={}));var v;(function(g){g[g.Default=0]="Default",g[g.Ascending=1]="Ascending",g[g.Descending=2]="Descending"})(v=e.SortOrder||(e.SortOrder={}));var c;(function(g){g.Install="install",g.Uninstall="uninstall"})(c=e.StatisticType||(e.StatisticType={}));var S;(function(g){g[g.None=0]="None",g[g.Install=1]="Install",g[g.Update=2]="Update"})(S=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,k.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class b extends Error{constructor(I,p){super(I);this.code=p,this.name=p}}e.ExtensionManagementError=b,e.IExtensionManagementService=(0,k.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,k.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,k.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=D.FileAccess.asBrowserUri("./media/defaultIcon.png",K).toString(!0),e.ExtensionsLabel=(0,A.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,A.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,k.createDecorator)("IExtensionManagementCLIService")});var Q=this&&this.__param||function(K,e){return function(D,L){e(D,L,K)}};define(te[151],ne([0,1,2,27]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let R=class extends D.Disposable{constructor(k){super();this.extensionManagementService=k,this._register(k),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};R=de([Q(0,L.IExtensionManagementService)],R),e.DeprecatedExtensionsCleaner=R}),define(te[75],ne([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var L;(function(k){k[k.FILE=1]="FILE",k[k.WORKSPACE=2]="WORKSPACE",k[k.EXE=3]="EXE"})(L=e.RecommendationSource||(e.RecommendationSource={}));function R(k){switch(k){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=R;var A;(function(k){k.Ignored="ignored",k.Cancelled="cancelled",k.TooMany="toomany",k.IncompatibleWindow="incompatibleWindow",k.Accepted="reacted"})(A=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,D.createDecorator)("IExtensionRecommendationNotificationService")}),define(te[76],ne([0,1,24,7]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.getWorkspaceSupportTypeMessage=R;function A(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));class P{constructor(C){this.value=C,this._lower=C.toLowerCase()}static equals(C,h){if(typeof C=="undefined"||C===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof C=="string"||typeof h=="string"){let v=typeof C=="string"?C:C.value,c=typeof h=="string"?h:h.value;return D.equalsIgnoreCase(v,c)}return C._lower===h._lower}static toKey(C){return typeof C=="string"?C.toLowerCase():C._lower}}e.ExtensionIdentifier=P;function m(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=m;function E(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=E,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[31],ne([0,1,24,76]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function R(c,S){return c.uuid&&S.uuid?c.uuid===S.uuid:c.id===S.id?!0:(0,D.compareIgnoreCase)(c.id,S.id)===0}e.areSameExtensions=R;class A{constructor(S,b){this.version=b,this.id=S.id,this.uuid=S.uuid}key(){return`${this.id}-${this.version}`}equals(S){return S instanceof A?R(this,S)&&this.version===S.version:!1}}e.ExtensionIdentifierWithVersion=A;function k(c,S){return`${c}.${S}`}e.getExtensionId=k;function P(c){return c.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function m(c,S){return P(k(c,S))}e.getGalleryExtensionId=m;function E(c,S){const b=[],g=I=>{for(const p of b)if(p.some(o=>R(S(o),S(I))))return p;return null};for(const I of c){const p=g(I);p?p.push(I):b.push([I])}return b}e.groupByExtension=E;function i(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function C(c){return{id:c.identifier.id,name:c.name,galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),...c.telemetryData}}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function h(c){const S=new Set;for(const b of c)b.malicious&&S.add(b.id.id);return S}e.getMaliciousExtensionsSet=h;function v(c,S){const b=[],g=S.manifest.extensionDependencies?.slice(0)??[];for(;g.length;){const I=g.shift();if(I&&b.every(p=>!R(p.identifier,{id:I}))){const p=c.filter(o=>R(o.identifier,{id:I}));p.length===1&&(b.push(p[0]),g.push(...p[0].manifest.extensionDependencies?.slice(0)??[]))}}return b}e.getExtensionDependencies=v}),define(te[152],ne([0,1,2,8,19,76]),function(K,e,D,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class k extends D.Disposable{constructor(m,E){super();this.environmentService=m,this.extensionsManifestCache=(0,L.join)(this.environmentService.userDataPath,A.MANIFEST_CACHE_FOLDER,A.USER_MANIFEST_CACHE_FILE),this._register(E.onDidInstallExtensions(i=>this.onDidInstallExtensions(i))),this._register(E.onDidUninstallExtension(i=>this.onDidUnInstallExtension(i)))}onDidInstallExtensions(m){m.some(E=>!!E.local)&&this.invalidate()}onDidUnInstallExtension(m){m.error||this.invalidate()}invalidate(){R.Promises.rm(this.extensionsManifestCache,R.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=k}),define(te[13],ne([0,1,40,8,24,16,5,122,7]),function(K,e,D,L,R,A,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,m.createDecorator)("fileService");function E(U){return U.create===!0}e.isFileOpenForWriteOptions=E;var i;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var C;(function(U){U[U.Readonly=1]="Readonly"})(C=e.FilePermission||(e.FilePermission={}));var h;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock"})(h=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function v(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=v;function c(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=c;function S(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=S;function b(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=b;var g;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(g=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class I extends Error{constructor($,B){super($);this.code=B}}e.FileSystemProviderError=I;function p(U,$){const B=new I(U.toString(),$);return a(B,$),B}e.createFileSystemProviderError=p;function o(U){return U||p((0,P.localize)(0,null),g.Unknown)}e.ensureFileSystemProviderError=o;function a(U,$){return U.name=$?`${$} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=a;function t(U){if(!U)return g.Unknown;if(U instanceof I)return U.code;const $=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!$)return g.Unknown;switch($[1]){case g.FileExists:return g.FileExists;case g.FileIsADirectory:return g.FileIsADirectory;case g.FileNotADirectory:return g.FileNotADirectory;case g.FileNotFound:return g.FileNotFound;case g.FileExceedsMemoryLimit:return g.FileExceedsMemoryLimit;case g.FileTooLarge:return g.FileTooLarge;case g.FileWriteLocked:return g.FileWriteLocked;case g.NoPermissions:return g.NoPermissions;case g.Unavailable:return g.Unavailable}return g.Unknown}e.toFileSystemProviderErrorCode=t;function s(U){if(U instanceof d)return U.fileOperationResult;switch(t(U)){case g.FileNotFound:return 1;case g.FileIsADirectory:return 0;case g.FileNotADirectory:return 10;case g.FileWriteLocked:return 5;case g.NoPermissions:return 6;case g.FileExists:return 4;case g.FileExceedsMemoryLimit:return 9;case g.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var n;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class r{constructor($,B,z){this.resource=$,this.operation=B,this.target=z}isOperation($){return this.operation===$}}e.FileOperationEvent=r;var u;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class l{constructor($,B){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const z of $)switch(z.type){case 1:this.added||(this.added=D.TernarySearchTree.forUris(()=>B)),this.added.set(z.resource,z);break;case 0:this.updated||(this.updated=D.TernarySearchTree.forUris(()=>B)),this.updated.set(z.resource,z);break;case 2:this.deleted||(this.deleted=D.TernarySearchTree.forUris(()=>B)),this.deleted.set(z.resource,z);break}}contains($,...B){return this.doContains($,{includeChildren:!1},...B)}affects($,...B){return this.doContains($,{includeChildren:!0},...B)}doContains($,B,...z){if(!$)return!1;const j=z.length>0;return!!((!j||z.includes(1))&&(this.added?.get($)||B.includeChildren&&this.added?.findSuperstr($))||(!j||z.includes(0))&&(this.updated?.get($)||B.includeChildren&&this.updated?.findSuperstr($))||(!j||z.includes(2))&&(this.deleted?.findSubstr($)||B.includeChildren&&this.deleted?.findSuperstr($)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=l;function f(U,$,B){return!U||!$||U===$||$.length>U.length?!1:($.charAt($.length-1)!==L.sep&&($+=L.sep),B?(0,R.startsWithIgnoreCase)(U,$):U.indexOf($)===0)}e.isParent=f;class d extends Error{constructor($,B,z){super($);this.fileOperationResult=B,this.options=z}}e.FileOperationError=d;class w extends d{constructor($,B,z){super($,2,z);this.stat=B}}e.NotModifiedSinceFileOperationError=w;var T;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(T=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var O;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(O=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function y(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=y;async function M(U,$){if(!$.canHandleResource(k.URI.from({scheme:U.scheme})))return new Promise(B=>{const z=$.onDidChangeFileSystemProviderRegistrations(j=>{j.scheme===U.scheme&&j.added&&(z.dispose(),B())})})}e.whenProviderRegistered=M,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class F{static formatSize($){return(0,A.isNumber)($)||($=0),$<F.KB?(0,P.localize)(1,null,$.toFixed(0)):$<F.MB?(0,P.localize)(2,null,($/F.KB).toFixed(2)):$<F.GB?(0,P.localize)(3,null,($/F.MB).toFixed(2)):$<F.TB?(0,P.localize)(4,null,($/F.GB).toFixed(2)):(0,P.localize)(5,null,($/F.TB).toFixed(2))}}e.ByteSize=F,F.KB=1024,F.MB=F.KB*F.KB,F.GB=F.MB*F.KB,F.TB=F.GB*F.KB;var q;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(q=e.Arch||(e.Arch={}));function x(U){return{maxFileSize:U===0?300*F.MB:16*F.GB,maxHeapSize:U===0?700*F.MB:2*700*F.MB}}e.getPlatformLimits=x}),define(te[153],ne([0,1,154,50,13]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let A=class{constructor(P){this.fileService=P}checksum(P){return new Promise(async(m,E)=>{const i=(0,D.createHash)("md5"),C=(await this.fileService.readFileStream(P)).value;(0,L.listenStream)(C,{onData:h=>i.update(h.buffer),onError:h=>E(h),onEnd:()=>m(i.digest("base64").replace(/=+$/,""))})})}};A=de([Q(0,R.IFileService)],A),e.ChecksumService=A}),define(te[155],ne([0,1,221,113,135,13]),function(K,e,D,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function k(h,v){const c={onUnknownOption:b=>{console.warn((0,L.localize)(0,null,b))},onMultipleValues:(b,g)=>{console.warn((0,L.localize)(1,null,b,g))}},S=(0,R.parseArgs)(h,R.OPTIONS,v?c:void 0);return S.goto&&S._.forEach(b=>D(/^(\w:)?[^:]+(:\d*){0,2}$/.test(b),(0,L.localize)(2,null))),S["max-memory"]&&D(parseInt(S["max-memory"])>=A.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${A.MIN_MAX_MEMORY_SIZE_MB} MB.`),S}function P(h){const v=h.findIndex(c=>!/^-/.test(c));if(v>-1)return[...h.slice(0,v),...h.slice(v+1)]}function m(h){let[,...v]=h;process.env.VSCODE_DEV&&(v=P(v)||[]);const c=!C(process.env);return k(v,c)}e.parseMainProcessArgv=m;function E(h){const[,,...v]=h;return k(v,!0)}e.parseCLIProcessArgv=E;function i(h,...v){const c=h.indexOf("--");return c===-1?h.push(...v):h.splice(c,0,...v),h}e.addArg=i;function C(h){return h.VSCODE_CLI==="1"}e.isLaunchedFromCli=C}),define(te[156],ne([0,1,41,137,29,37,11,4,30,109,155]),function(K,e,D,L,R,A,k,P,m,E,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function C(c,S,b){return S["force-disable-user-env"]?(c.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):P.isWindows?(c.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,i.isLaunchedFromCli)(b)&&!S["force-user-env"]?(c.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,i.isLaunchedFromCli)(b)?c.trace("resolveShellEnv(): running (--force-user-env)"):c.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=new Promise(async g=>{const I=new R.CancellationTokenSource,p=setTimeout(()=>{c.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),I.dispose(!0),g({})},1e4);try{const o=await v(c,I.token);g(o)}catch(o){(0,k.isPromiseCanceledError)(o)||c.error(`[resolve shell env] Unable to resolve shell environment (${o}). Proceeding without shell environment...`),g({})}finally{clearTimeout(p),I.dispose()}})),h)}e.resolveShellEnv=C;let h;async function v(c,S){const b=new Promise(async(g,I)=>{const p=process.env.ELECTRON_RUN_AS_NODE;c.trace("getUnixShellEnvironment#runAsNode",p);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;c.trace("getUnixShellEnvironment#noAttach",o);const a=(0,m.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(a+"(.*)"+a),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};c.trace("getUnixShellEnvironment#env",s);const n=await(0,E.getSystemShell)(P.OS,s);if(c.trace("getUnixShellEnvironment#shell",n),S.isCancellationRequested)return I(k.canceled);const r=L.basename(n);let u,l;/^pwsh(-preview)?$/.test(r)?(u=`& '${process.execPath}' -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,l=["-Login","-Command"]):(u=`'${process.execPath}' -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,l=["-ilc"]),c.trace("getUnixShellEnvironment#spawn",JSON.stringify(l),u);const f=(0,D.spawn)(n,[...l,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});S.onCancellationRequested(()=>(f.kill(),I(k.canceled))),f.on("error",T=>{c.error("getUnixShellEnvironment#errorChildProcess",(0,A.toErrorMessage)(T)),g({})});const d=[];f.stdout.on("data",T=>d.push(T));const w=[];f.stderr.on("data",T=>w.push(T)),f.on("close",(T,O)=>{const y=Buffer.concat(d).toString("utf8");c.trace("getUnixShellEnvironment#raw",y);const M=Buffer.concat(w).toString("utf8");if(M.trim()&&c.trace("getUnixShellEnvironment#stderr",M),T||O)return I(new Error(`Failed to get environment (code ${T}, signal ${O})`));const F=t.exec(y),q=F?F[1]:"{}";try{const x=JSON.parse(q);p?x.ELECTRON_RUN_AS_NODE=p:delete x.ELECTRON_RUN_AS_NODE,o?x.ELECTRON_NO_ATTACH_CONSOLE=o:delete x.ELECTRON_NO_ATTACH_CONSOLE,delete x.XDG_RUNTIME_DIR,c.trace("getUnixShellEnvironment#result",x),g(x)}catch(x){c.error("getUnixShellEnvironment#errorCaught",(0,A.toErrorMessage)(x)),I(x)}})});try{return await b}catch(g){return c.error("getUnixShellEnvironment#error",(0,A.toErrorMessage)(g)),{}}}}),define(te[77],ne([0,1,4,5,13]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function A(m){return m.map(E=>({type:E.type,resource:L.URI.file(E.path)}))}e.toFileChanges=A;function k(m){const E=new P;for(const i of m)E.processEvent(i);return E.normalize()}e.normalizeFileChanges=k;class P{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(E){const i=this.mapPathToChange.get(E.path);if(i){const C=i.type,h=E.type;C===1&&h===2?(this.mapPathToChange.delete(E.path),this.normalized.splice(this.normalized.indexOf(i),1)):C===2&&h===1?i.type=0:C===1&&h===0||(i.type=h)}else this.normalized.push(E),this.mapPathToChange.set(E.path,E)}normalize(){const E=[],i=[];return this.normalized.filter(C=>C.type!==2?(E.push(C),!1):!0).sort((C,h)=>C.path.length-h.path.length).filter(C=>i.some(h=>(0,R.isParent)(C.path,h,!D.isLinux))?!1:(i.push(C.path),!0)).concat(E)}}}),define(te[157],ne([0,1,6,2,8,99,19,101,77]),function(K,e,D,L,R,A,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class E extends L.Disposable{constructor(C,h,v,c){super();this.path=C,this.onDidFilesChange=h,this.onLogMessage=v,this.verboseLogging=c,this.fileChangesDelayer=this._register(new D.ThrottledDelayer(P.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(C){this.verboseLogging=C}async startWatching(){try{const{stat:C,symbolicLink:h}=await k.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let v=this.path;if(h)try{v=await(0,A.realpath)(v)}catch(c){if(this.onError(c),h.dangling)return}C.isDirectory()?this._register((0,P.watchFolder)(v,(c,S)=>{this.onFileChange({type:c==="changed"?0:c==="added"?1:2,path:(0,R.join)(this.path,(0,R.basename)(S))})},c=>this.onError(c))):this._register((0,P.watchFile)(v,c=>{this.onFileChange({type:c==="changed"?0:2,path:this.path})},c=>this.onError(c)))}catch(C){C.code!=="ENOENT"&&this.onError(C)}}onFileChange(C){this.fileChangesBuffer.push(C),this.verboseLogging&&this.onVerbose(`${C.type===1?"[ADDED]":C.type===2?"[DELETED]":"[CHANGED]"} ${C.path}`),this.fileChangesDelayer.trigger(async()=>{const h=this.fileChangesBuffer;this.fileChangesBuffer=[];const v=(0,m.normalizeFileChanges)(h);if(this.verboseLogging)for(const c of v)this.onVerbose(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`);v.length>0&&this.onDidFilesChange(v)})}onError(C){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${C}`})}onVerbose(C){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${C}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=E}),define(te[78],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class D{constructor(...R){this._entries=new Map;for(let[A,k]of R)this.set(A,k)}set(R,A){const k=this._entries.get(R);return this._entries.set(R,A),k}has(R){return this._entries.has(R)}get(R){return this._entries.get(R)}}e.ServiceCollection=D}),define(te[158],ne([0,1,6,11,53,148,7,78]),function(K,e,D,L,R,A,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const m=!1;class E extends Error{constructor(c){super("cyclic dependency between services");this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class i{constructor(c=new P.ServiceCollection,S=!1,b){this._activeInstantiations=new Set,this._services=c,this._strict=S,this._parent=b,this._services.set(k.IInstantiationService,this)}createChild(c){return new i(c,this._strict,this)}invokeFunction(c,...S){let b=h.traceInvocation(c),g=!1;try{return c({get:(p,o)=>{if(g)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(p,b);if(!a&&o!==k.optional)throw new Error(`[invokeFunction] unknown service '${p}'`);return a}},...S)}finally{g=!0,b.stop()}}createInstance(c,...S){let b,g;return c instanceof R.SyncDescriptor?(b=h.traceCreation(c.ctor),g=this._createInstance(c.ctor,c.staticArguments.concat(S),b)):(b=h.traceCreation(c),g=this._createInstance(c,S,b)),b.stop(),g}_createInstance(c,S=[],b){let g=k._util.getServiceDependencies(c).sort((o,a)=>o.index-a.index),I=[];for(const o of g){let a=this._getOrCreateServiceInstance(o.id,b);if(!a&&this._strict&&!o.optional)throw new Error(`[createInstance] ${c.name} depends on UNKNOWN service ${o.id}.`);I.push(a)}let p=g.length>0?g[0].index:S.length;if(S.length!==p){console.warn(`[createInstance] First service dependency of ${c.name} at position ${p+1} conflicts with ${S.length} static arguments`);let o=p-S.length;o>0?S=S.concat(new Array(o)):S=S.slice(0,p)}return new c(...[...S,...I])}_setServiceInstance(c,S){if(this._services.get(c)instanceof R.SyncDescriptor)this._services.set(c,S);else if(this._parent)this._parent._setServiceInstance(c,S);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(c){let S=this._services.get(c);return!S&&this._parent?this._parent._getServiceInstanceOrDescriptor(c):S}_getOrCreateServiceInstance(c,S){let b=this._getServiceInstanceOrDescriptor(c);return b instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(c,b,S.branch(c,!0)):(S.branch(c,!1),b)}_safeCreateAndCacheServiceInstance(c,S,b){if(this._activeInstantiations.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this._activeInstantiations.add(c);try{return this._createAndCacheServiceInstance(c,S,b)}finally{this._activeInstantiations.delete(c)}}_createAndCacheServiceInstance(c,S,b){const g=new A.Graph(o=>o.id.toString());let I=0;const p=[{id:c,desc:S,_trace:b}];for(;p.length;){const o=p.pop();if(g.lookupOrInsertNode(o),I++>1e3)throw new E(g);for(let a of k._util.getServiceDependencies(o.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(a.id);if(!t&&!a.optional&&console.warn(`[createInstance] ${c} depends on ${a.id} which is NOT registered.`),t instanceof R.SyncDescriptor){const s={id:a.id,desc:t,_trace:o._trace.branch(a.id,!0)};g.insertEdge(o,s),p.push(s)}}}for(;;){const o=g.roots();if(o.length===0){if(!g.isEmpty())throw new E(g);break}for(const{data:a}of o){if(this._getServiceInstanceOrDescriptor(a.id)instanceof R.SyncDescriptor){const s=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,s)}g.removeNode(a)}}return this._getServiceInstanceOrDescriptor(c)}_createServiceInstanceWithOwner(c,S,b=[],g,I){if(this._services.get(c)instanceof R.SyncDescriptor)return this._createServiceInstance(S,b,g,I);if(this._parent)return this._parent._createServiceInstanceWithOwner(c,S,b,g,I);throw new Error(`illegalState - creating UNKNOWN service instance ${S.name}`)}_createServiceInstance(c,S=[],b,g){if(b){const I=new D.IdleValue(()=>this._createInstance(c,S,g));return new Proxy(Object.create(null),{get(p,o){if(o in p)return p[o];let a=I.value,t=a[o];return typeof t!="function"||(t=t.bind(a),p[o]=t),t},set(p,o,a){return I.value[o]=a,!0}})}else return this._createInstance(c,S,g)}}e.InstantiationService=i;var C;(function(v){v[v.Creation=0]="Creation",v[v.Invocation=1]="Invocation",v[v.Branch=2]="Branch"})(C||(C={}));class h{constructor(c,S){this.type=c,this.name=S,this._start=Date.now(),this._dep=[]}static traceInvocation(c){return m?new h(1,c.name||c.toString().substring(0,42).replace(/\n/g,"")):h._None}static traceCreation(c){return m?new h(0,c.name):h._None}branch(c,S){let b=new h(2,c.toString());return this._dep.push([c,S,b]),b}stop(){let c=Date.now()-this._start;h._totals+=c;let S=!1;function b(I,p){let o=[],a=new Array(I+1).join("	");for(const[t,s,n]of p._dep)if(s&&n){S=!0,o.push(`${a}CREATES -> ${t}`);let r=b(I+1,n);r&&o.push(r)}else o.push(`${a}uses -> ${t}`);return o.join(`
`)}let g=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${h._totals.toFixed(2)}ms)`];(c>2||S)&&console.log(g.join(`
`))}}h._None=new class extends h{constructor(){super(-1,null)}stop(){}branch(){return this}},h._totals=0}),define(te[159],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class D{constructor(R,A){this.server=R,this.router=A}getChannel(R){return this.server.getChannel(R,this.router)}registerChannel(R,A){this.server.registerChannel(R,A)}}e.MessagePortMainProcessService=D}),define(te[160],ne([0,1,36,53,147,7]),function(K,e,D,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class k{constructor(v,c,S){const b=S.getChannel(v);return P(c)?new c.channelClientCtor(b):D.ProxyChannel.toService(b,c?.proxyOptions)}}function P(h){return!!h?.channelClientCtor}e.IMainProcessService=(0,A.createDecorator)("mainProcessService");let m=class extends k{constructor(v,c,S){super(v,c,S)}};m=de([Q(2,e.IMainProcessService)],m);function E(h,v,c){(0,R.registerSingleton)(h,new L.SyncDescriptor(m,[v,c],c?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=E,e.ISharedProcessService=(0,A.createDecorator)("sharedProcessService");let i=class extends k{constructor(v,c,S){super(v,c,S)}};i=de([Q(2,e.ISharedProcessService)],i);function C(h,v,c){(0,R.registerSingleton)(h,new L.SyncDescriptor(i,[v,c],c?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=C}),define(te[57],ne([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,D.createDecorator)("localizationsService");function L(R){if(typeof R.languageId!="string"||!Array.isArray(R.translations)||R.translations.length===0)return!1;for(const A of R.translations)if(typeof A.id!="string"||typeof A.path!="string")return!1;return!(R.languageName&&typeof R.languageName!="string"||R.localizedLanguageName&&typeof R.localizedLanguageName!="string")}e.isValidLocalization=L}),define(te[161],ne([0,1,2,57]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let R=class extends D.Disposable{constructor(k){super();this.localizationsService=k,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};R=de([Q(0,L.ILocalizationsService)],R),e.LocalizationsUpdater=R}),define(te[14],ne([0,1,37,3,2,4,7]),function(K,e,D,L,R,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,k.createDecorator)("logService"),e.ILoggerService=(0,k.createDecorator)("loggerService");function P(){return new Date().toISOString()}var m;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(m=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=m.Info;class E extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=E;class i extends E{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...s){this.checkLogLevel(m.Trace)&&this.log(m.Trace,this.format([t,...s]))}debug(t,...s){this.checkLogLevel(m.Debug)&&this.log(m.Debug,this.format([t,...s]))}info(t,...s){this.checkLogLevel(m.Info)&&this.log(m.Info,this.format([t,...s]))}warn(t,...s){this.checkLogLevel(m.Warning)&&this.log(m.Warning,this.format([t,...s]))}error(t,...s){if(this.checkLogLevel(m.Error))if(t instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=t.stack,this.log(m.Error,this.format(n))}else this.log(m.Error,this.format([t,...s]))}critical(t,...s){this.checkLogLevel(m.Critical)&&this.log(m.Critical,this.format([t,...s]))}flush(){}format(t){let s="";for(let n=0;n<t.length;n++){let r=t[n];if(typeof r=="object")try{r=JSON.stringify(r)}catch(u){}s+=(n>0?" ":"")+r}return s}}e.AbstractMessageLogger=i;class C extends E{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!A.isWindows}trace(t,...s){this.getLevel()<=m.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...s):console.log(`[main ${P()}]`,t,...s))}debug(t,...s){this.getLevel()<=m.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...s):console.log(`[main ${P()}]`,t,...s))}info(t,...s){this.getLevel()<=m.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...s):console.log(`[main ${P()}]`,t,...s))}warn(t,...s){this.getLevel()<=m.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,t,...s):console.warn(`[main ${P()}]`,t,...s))}error(t,...s){this.getLevel()<=m.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,t,...s):console.error(`[main ${P()}]`,t,...s))}critical(t,...s){this.getLevel()<=m.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,t,...s):console.error(`[main ${P()}]`,t,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=C;class h extends E{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...s){this.getLevel()<=m.Trace&&console.log("%cTRACE","color: #888",t,...s)}debug(t,...s){this.getLevel()<=m.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...s)}info(t,...s){this.getLevel()<=m.Info&&console.log("%c INFO","color: #33f",t,...s)}warn(t,...s){this.getLevel()<=m.Warning&&console.log("%c WARN","color: #993",t,...s)}error(t,...s){this.getLevel()<=m.Error&&console.log("%c  ERR","color: #f33",t,...s)}critical(t,...s){this.getLevel()<=m.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...s)}dispose(){}flush(){}}e.ConsoleLogger=h;class v extends E{constructor(t,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(s)}trace(t,...s){this.getLevel()<=m.Trace&&this.adapter.log(m.Trace,[this.extractMessage(t),...s])}debug(t,...s){this.getLevel()<=m.Debug&&this.adapter.log(m.Debug,[this.extractMessage(t),...s])}info(t,...s){this.getLevel()<=m.Info&&this.adapter.log(m.Info,[this.extractMessage(t),...s])}warn(t,...s){this.getLevel()<=m.Warning&&this.adapter.log(m.Warning,[this.extractMessage(t),...s])}error(t,...s){this.getLevel()<=m.Error&&this.adapter.log(m.Error,[this.extractMessage(t),...s])}critical(t,...s){this.getLevel()<=m.Critical&&this.adapter.log(m.Critical,[this.extractMessage(t),...s])}extractMessage(t){return typeof t=="string"?t:(0,D.toErrorMessage)(t,this.getLevel()<=m.Trace)}dispose(){}flush(){}}e.AdapterLogger=v;class c extends E{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const s of this.logServices)s.setLevel(t);super.setLevel(t)}trace(t,...s){for(const n of this.logServices)n.trace(t,...s)}debug(t,...s){for(const n of this.logServices)n.debug(t,...s)}info(t,...s){for(const n of this.logServices)n.info(t,...s)}warn(t,...s){for(const n of this.logServices)n.warn(t,...s)}error(t,...s){for(const n of this.logServices)n.error(t,...s)}critical(t,...s){for(const n of this.logServices)n.critical(t,...s)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=c;class S extends R.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...s){this.logger.trace(t,...s)}debug(t,...s){this.logger.debug(t,...s)}info(t,...s){this.logger.info(t,...s)}warn(t,...s){this.logger.warn(t,...s)}error(t,...s){this.logger.error(t,...s)}critical(t,...s){this.logger.critical(t,...s)}flush(){this.logger.flush()}}e.LogService=S;class b extends R.Disposable{constructor(t,s){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(n))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,s){let n=this.loggers.get(t.toString());return n||(n=this.doCreateLogger(t,s?.always?m.Trace:this.logLevel,s),this.loggers.set(t.toString(),n),s?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=b;class g{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(t){}getLevel(){return m.Info}trace(t,...s){}debug(t,...s){}info(t,...s){}warn(t,...s){}error(t,...s){}critical(t,...s){}dispose(){}flush(){}}e.NullLogService=g;function I(a){if(a.verbose)return m.Trace;if(typeof a.logLevel=="string"){const t=p(a.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=I;function p(a){switch(a){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Critical;case"off":return m.Off}}e.parseLogLevel=p;function o(a){switch(a){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Critical:return"critical";case m.Off:return"off"}}e.LogLevelToString=o}),define(te[162],ne([0,1,6,11,2,8,19,12,14]),function(K,e,D,L,R,A,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let E=class extends R.Disposable{constructor(C,h){super();this.environmentService=C,this.logService=h,this._register(new D.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.info("[logs cleanup]: Starting to clean up old logs.");try{const C=(0,A.basename)(this.environmentService.logsPath),h=(0,A.dirname)(this.environmentService.logsPath),S=(await k.Promises.readdir(h)).filter(g=>/^\d{8}T\d{6}$/.test(g)).sort().filter(g=>g!==C),b=S.slice(0,Math.max(0,S.length-9));b.length>0&&(this.logService.info(`[logs cleanup]: Removing log folders '${b.join(", ")}'`),await Promise.all(b.map(g=>k.Promises.rm((0,A.join)(h,g)))))}catch(C){(0,L.onUnexpectedError)(C)}}};E=de([Q(0,P.IEnvironmentService),Q(1,m.ILogService)],E),e.LogsDataCleaner=E}),define(te[163],ne([0,1,6,11,2,8,19,12,14]),function(K,e,D,L,R,A,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let E=class ut extends R.Disposable{constructor(C,h,v){super();this.backupWorkspacesPath=C,this.environmentService=h,this.logService=v,this._register(new D.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.info("[storage cleanup]: Starting to clean up storage folders.");try{const C=await k.Promises.readFile(this.backupWorkspacesPath,"utf8"),v=JSON.parse(C).emptyWorkspaceInfos.map(S=>S.backupFolder),c=await k.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(c.map(async S=>{S.length!==ut.NON_EMPTY_WORKSPACE_ID_LENGTH&&v.indexOf(S)===-1&&(this.logService.info(`[storage cleanup]: Deleting storage folder ${S}.`),await k.Promises.rm((0,A.join)(this.environmentService.workspaceStorageHome.fsPath,S)))}))}catch(C){(0,L.onUnexpectedError)(C)}}};E.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,E=de([Q(1,P.INativeEnvironmentService),Q(2,m.ILogService)],E),e.StorageDataCleaner=E}),define(te[164],ne([0,1,6,11,2,4,15,58,5,30,19,12,27,31,13,14]),function(K,e,D,L,R,A,k,P,m,E,i,C,h,v,c,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let g=class extends R.Disposable{constructor(p,o,a,t){super();this.fileService=o,this.extensionGalleryService=a,this.logService=t,this.extensionsDownloadDir=m.URI.file(p.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(p,o){await this.cleanUpPromise;const a=this.getName(p),t=(0,k.joinPath)(this.extensionsDownloadDir,a);if(!await this.fileService.exists(t)){const s=(0,k.joinPath)(this.extensionsDownloadDir,`.${(0,E.generateUuid)()}`);await this.fileService.exists(s)||await this.extensionGalleryService.download(p,s,o);try{await this.rename(s,t,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(s)}catch(r){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",p.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,L.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,s.path),n}}return t}async delete(p){}async rename(p,o,a){try{await i.Promises.rename(p.fsPath,o.fsPath)}catch(t){if(A.isWindows&&t&&t.code==="EPERM"&&Date.now()<a)return this.logService.info(`Failed renaming ${p} to ${o} with 'EPERM' error. Trying again...`),this.rename(p,o,a);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const p=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(p.children){const o=[],a=[];for(const n of p.children){const r=this.parse(n.name);r&&a.push([r,n])}const t=(0,v.groupByExtension)(a,([n])=>n),s=[];for(const n of t)n.sort((r,u)=>P.rcompare(r[0].version,u[0].version)),o.push(...n.slice(1).map(r=>r[1].resource)),s.push(n[0][1]);s.sort((n,r)=>n.mtime-r.mtime),o.push(...s.slice(0,Math.max(0,s.length-this.cache)).map(n=>n.resource)),await D.Promises.settled(o.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(p){this.logService.error(p)}}getName(p){return this.cache?`${new v.ExtensionIdentifierWithVersion(p.identifier,p.version).key().toLowerCase()}${p.properties.targetPlatform!=="undefined"?`-${p.properties.targetPlatform}`:""}`:(0,E.generateUuid)()}parse(p){const o=b.exec(p);return o&&o[1]&&o[2]?new v.ExtensionIdentifierWithVersion({id:o[1]},o[2]):null}};g=de([Q(0,C.INativeEnvironmentService),Q(1,c.IFileService),Q(2,h.IExtensionGalleryService),Q(3,S.ILogService)],g),e.ExtensionsDownloader=g}),define(te[165],ne([0,1,41,6,37,3,2,17,8,19,12,14]),function(K,e,D,L,R,A,k,P,m,E,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let h=class extends k.Disposable{constructor(c,S){super();this.environmentService=c,this.logService=S,this.processesLimiter=new L.Limiter(5)}async postUninstall(c){const S=this.parseScript(c,"uninstall");return S&&(this.logService.info(c.identifier.id,c.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(S.script,"uninstall",S.args,!0,c).then(()=>this.logService.info(c.identifier.id,c.manifest.version,"Finished running post uninstall script"),b=>this.logService.error(c.identifier.id,c.manifest.version,`Failed to run post uninstall script: ${b}`)))),E.Promises.rm(this.getExtensionStoragePath(c)).then(void 0,b=>this.logService.error("Error while removing extension storage path",b))}parseScript(c,S){const b=`vscode:${S}`;if(c.location.scheme===P.Schemas.file&&c.manifest&&c.manifest.scripts&&typeof c.manifest.scripts[b]=="string"){const g=c.manifest.scripts[b].split(" ");return g.length<2||g[0]!=="node"||!g[1]?(this.logService.warn(c.identifier.id,c.manifest.version,`${b} should be a node script`),null):{script:(0,m.join)(c.location.fsPath,g[1]),args:g.slice(2)||[]}}return null}runLifecycleHook(c,S,b,g,I){return new Promise((p,o)=>{const a=this.start(c,S,b,I);let t;const s=n=>{t&&(clearTimeout(t),t=null),n?o(n):p(void 0)};a.on("error",n=>{s((0,R.toErrorMessage)(n)||"Unknown")}),a.on("exit",(n,r)=>{s(n?`post-${S} process exited with code ${n}`:void 0)}),g&&(t=setTimeout(()=>{t=null,a.kill(),o("timed out")},5e3))})}start(c,S,b,g){const I={silent:!0,execArgv:void 0},p=(0,D.fork)(c,[`--type=extension-post-${S}`,...b],I);p.stdout.setEncoding("utf8"),p.stderr.setEncoding("utf8");const o=A.Event.fromNodeEventEmitter(p.stdout,"data"),a=A.Event.fromNodeEventEmitter(p.stderr,"data");o(n=>this.logService.info(g.identifier.id,g.manifest.version,`post-${S}`,n)),a(n=>this.logService.error(g.identifier.id,g.manifest.version,`post-${S}`,n));const t=A.Event.any(A.Event.map(o,n=>({data:`%c${n}`,format:[""]})),A.Event.map(a,n=>({data:`%c${n}`,format:["color: red"]})));return A.Event.debounce(t,(n,r)=>n?{data:n.data+r.data,format:[...n.format,...r.format]}:{data:r.data,format:r.format},100)(n=>{console.group(g.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),p}getExtensionStoragePath(c){return(0,m.join)(this.environmentService.globalStorageHome.fsPath,c.identifier.id.toLowerCase())}};h=de([Q(0,i.IEnvironmentService),Q(1,C.ILogService)],h),e.ExtensionsLifecycle=h}),define(te[166],ne([0,1,3,2,15,5,12,31,13,14]),function(K,e,D,L,R,A,k,P,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let i=class extends L.Disposable{constructor(h,v,c,S){super();this.extensionsManagementService=h,this.logService=S,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(I=>{this.installedExtensions=I.map(p=>p.identifier),this.startTimestamp=Date.now()}),this._register(h.onInstallExtension(I=>this.onInstallExtension(I))),this._register(h.onDidInstallExtensions(I=>this.onDidInstallExtensions(I))),this._register(h.onDidUninstallExtension(I=>this.onDidUninstallExtension(I)));const b=A.URI.file(c.extensionsPath),g=new R.ExtUri(I=>!v.hasCapability(I,1024));this._register(v.watch(b)),this._register(D.Event.filter(v.onDidChangeFilesRaw,I=>I.changes.some(p=>this.doesChangeAffects(p,b,g)))(()=>this.onDidChange()))}doesChangeAffects(h,v,c){return c.isEqual(c.dirname(h.resource),v)?c.isEqual(h.resource,c.joinPath(v,".obsolete"))?!0:!(h.type!==1&&h.type!==2||c.basename(h.resource).startsWith(".")):!1}onInstallExtension(h){this.addInstallingExtension(h.identifier)}onDidInstallExtensions(h){for(const v of h)this.removeInstallingExtension(v.identifier),v.local&&this.addInstalledExtension(v.identifier)}onDidUninstallExtension(h){h.error||this.removeInstalledExtension(h.identifier)}addInstallingExtension(h){this.removeInstallingExtension(h),this.installingExtensions.push(h)}removeInstallingExtension(h){this.installingExtensions=this.installingExtensions.filter(v=>!(0,P.areSameExtensions)(v,h))}addInstalledExtension(h){this.installedExtensions&&(this.removeInstalledExtension(h),this.installedExtensions.push(h))}removeInstalledExtension(h){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(v=>!(0,P.areSameExtensions)(v,h)))}async onDidChange(){if(this.installedExtensions){const h=await this.extensionsManagementService.getInstalled(1),v=h.filter(S=>[...this.installingExtensions,...this.installedExtensions].some(b=>(0,P.areSameExtensions)(b,S.identifier))?!1:S.installedTimestamp&&S.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",S.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",S.identifier.id),!1)),c=this.installedExtensions.filter(S=>this.installingExtensions.some(b=>(0,P.areSameExtensions)(b,S))?!1:h.every(b=>!(0,P.areSameExtensions)(b.identifier,S))?(this.logService.info("Detected extension removed from another source",S.id),!0):!1);this.installedExtensions=h.map(S=>S.identifier),(v.length||c.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:v,removed:c})}}};i=de([Q(1,m.IFileService),Q(2,k.INativeEnvironmentService),Q(3,E.ILogService)],i),e.ExtensionsWatcher=i}),define(te[167],ne([0,1,154,18,6,2,17,8,19,12,27,31,57,14]),function(K,e,D,L,R,A,k,P,m,E,i,C,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let c=class extends A.Disposable{constructor(g,I,p){super();this.extensionManagementService=g,this.logService=p,this.cache=this._register(new S(I,p)),this.extensionManagementService.registerParticipant({postInstall:async o=>this.postInstallExtension(o),postUninstall:async o=>this.postUninstallExtension(o)})}async getLanguageIds(){const g=await this.cache.getLanguagePacks(),I=["en",...Object.keys(g)];return(0,L.distinct)(I)}async postInstallExtension(g){g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",g.identifier.id),await this.update())}async postUninstallExtension(g){const I=await this.cache.getLanguagePacks();Object.keys(I).some(p=>I[p]&&I[p].extensions.some(o=>(0,C.areSameExtensions)(o.extensionIdentifier,g.identifier)))&&(this.logService.info("Removing language packs from the extension",g.identifier.id),await this.update())}async update(){const[g,I]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),p=await this.cache.update(I);return!(0,L.equals)(Object.keys(g),Object.keys(p))}};c=de([Q(0,i.IExtensionManagementService),Q(1,E.INativeEnvironmentService),Q(2,v.ILogService)],c),e.LocalizationsService=c;let S=class extends A.Disposable{constructor(g,I){super();this.logService=I,this.languagePacks={},this.languagePacksFilePath=(0,P.join)(g.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new R.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(g){return this.withLanguagePacks(I=>{Object.keys(I).forEach(p=>delete I[p]),this.createLanguagePacksFromExtensions(I,...g)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(g,...I){for(const p of I)p&&p.manifest&&p.manifest.contributes&&p.manifest.contributes.localizations&&p.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(g,p);Object.keys(g).forEach(p=>this.updateHash(g[p]))}createLanguagePacksFromExtension(g,I){const p=I.identifier,o=I.manifest.contributes&&I.manifest.contributes.localizations?I.manifest.contributes.localizations:[];for(const a of o)if(I.location.scheme===k.Schemas.file&&(0,h.isValidLocalization)(a)){let t=g[a.languageId];t||(t={hash:"",extensions:[],translations:{}},g[a.languageId]=t);let s=t.extensions.filter(n=>(0,C.areSameExtensions)(n.extensionIdentifier,p))[0];s?s.version=I.manifest.version:t.extensions.push({extensionIdentifier:p,version:I.manifest.version});for(const n of a.translations)t.translations[n.id]=(0,P.join)(I.location.fsPath,n.path)}}updateHash(g){if(g){const I=(0,D.createHash)("md5");for(const p of g.extensions)I.update(p.extensionIdentifier.uuid||p.extensionIdentifier.id).update(p.version);g.hash=I.digest("hex")}}withLanguagePacks(g=()=>null){return this.languagePacksFileLimiter.queue(()=>{let I=null;return m.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,p=>p.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(p)).then(p=>{try{return JSON.parse(p)}catch(o){return{}}}).then(p=>(I=g(p),p)).then(p=>{for(const a of Object.keys(p))p[a]||delete p[a];this.languagePacks=p,this.initializedCache=!0;const o=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",o),m.Promises.writeFile(this.languagePacksFilePath,o)}).then(()=>I,p=>this.logService.error(p))})}};S=de([Q(0,E.INativeEnvironmentService),Q(1,v.ILogService)],S)}),define(te[79],ne([0,1,3,5,14]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class A{constructor(h){this.service=h,this.onDidChangeLogLevel=D.Event.buffer(h.onDidChangeLogLevel,!0)}listen(h,v){switch(v){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${v}`)}async call(h,v,c){switch(v){case"setLevel":return this.service.setLevel(c)}throw new Error(`Call not found: ${v}`)}}e.LogLevelChannel=A;class k{constructor(h){this.channel=h}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(h){k.setLevel(this.channel,h)}static setLevel(h,v){return h.call("setLevel",v)}}e.LogLevelChannelClient=k;class P{constructor(h){this.loggerService=h,this.loggers=new Map}listen(h,v){throw new Error(`Event not found: ${v}`)}async call(h,v,c){switch(v){case"createLogger":this.createLogger(L.URI.revive(c[0]),c[1]);return;case"log":return this.log(L.URI.revive(c[0]),c[1]);case"consoleLog":return this.consoleLog(c[0],c[1])}throw new Error(`Call not found: ${v}`)}createLogger(h,v){this.loggers.set(h.toString(),this.loggerService.createLogger(h,v))}consoleLog(h,v){let c=console.log;switch(h){case R.LogLevel.Error:c=console.error;break;case R.LogLevel.Warning:c=console.warn;break;case R.LogLevel.Info:c=console.info;break}c.call(console,...v)}log(h,v){const c=this.loggers.get(h.toString());if(!c)throw new Error("Create the logger before logging");for(const[S,b]of v)switch(S){case R.LogLevel.Trace:c.trace(b);break;case R.LogLevel.Debug:c.debug(b);break;case R.LogLevel.Info:c.info(b);break;case R.LogLevel.Warning:c.warn(b);break;case R.LogLevel.Error:c.error(b);break;case R.LogLevel.Critical:c.critical(b);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=P;class m extends R.AbstractLoggerService{constructor(h,v,c){super(h,v);this.channel=c}createConsoleMainLogger(){return new R.AdapterLogger({log:(h,v)=>{this.channel.call("consoleLog",[h,v])}})}doCreateLogger(h,v,c){return new E(this.channel,h,v,c)}}e.LoggerChannelClient=m;class E extends R.AbstractMessageLogger{constructor(h,v,c,S){super(S?.always);this.channel=h,this.file=v,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(c),this.channel.call("createLogger",[v,S]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(h,v){const c=[[h,v]];this.isLoggerCreated?this.doLog(c):this.buffer.push(...c)}doLog(h){this.channel.call("log",[this.file,h])}}class i extends R.LogService{constructor(h,v){super(v);this.parent=h,this._register(h.onDidChangeLogLevel(c=>v.setLevel(c)))}setLevel(h){super.setLevel(h),this.parent.setLevel(h)}}e.FollowerLogService=i}),define(te[59],ne([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,D.createDecorator)("nativeHostService")}),define(te[44],ne([0,1,17,4,34,15]),function(K,e,D,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const P=L.globals.vscode.context.configuration();if(P)k=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof K?.__$__nodeRequire=="function"){const P=(0,A.dirname)(D.FileAccess.asFileUri("",K));k=K.__$__nodeRequire((0,A.joinPath)(P,"product.json").fsPath);const m=K.__$__nodeRequire((0,A.joinPath)(P,"package.json").fsPath);R.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`}),Object.assign(k,{version:m.version})}else k={},Object.keys(k).length===0&&Object.assign(k,{version:"1.61.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=k}),define(te[80],ne([0,1,25,11,123,13,44]),function(K,e,D,L,R,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function P(C,h,v,c,S,b){let g;try{await m(C,h,v,c,S,b)}catch(I){g=I}finally{g&&S.errorTransformer&&(g=S.errorTransformer(g)),typeof g!="undefined"&&v.error(g),v.end()}}e.readFileIntoStream=P;async function m(C,h,v,c,S,b){E(b);const g=await C.open(h,{create:!1});try{E(b);let I=0,p=0,o=S&&typeof S.length=="number"?S.length:void 0,a=D.VSBuffer.alloc(Math.min(S.bufferSize,typeof o=="number"?o:S.bufferSize)),t=S&&typeof S.position=="number"?S.position:0,s=0;do p=await C.read(g,t,a.buffer,s,a.byteLength-s),t+=p,s+=p,I+=p,typeof o=="number"&&(o-=p),s===a.byteLength&&(await v.write(c(a)),a=D.VSBuffer.alloc(Math.min(S.bufferSize,typeof o=="number"?o:S.bufferSize)),s=0);while(p>0&&(typeof o!="number"||o>0)&&E(b)&&i(I,S));if(s>0){let n=s;typeof o=="number"&&(n=Math.min(s,o)),v.write(c(a.slice(0,n)))}}catch(I){throw(0,A.ensureFileSystemProviderError)(I)}finally{await C.close(g)}}function E(C){if(C.isCancellationRequested)throw(0,L.canceled)();return!0}function i(C,h){if(h?.limits){if(typeof h.limits.memory=="number"&&C>h.limits.memory)throw(0,A.createFileSystemProviderError)((0,R.localize)(0,null,k.default.nameShort),A.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof h.limits.size=="number"&&C>h.limits.size)throw(0,A.createFileSystemProviderError)((0,R.localize)(1,null),A.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(te[168],ne([0,1,18,6,25,29,3,55,2,40,17,169,15,50,121,13,80,14]),function(K,e,D,L,R,A,k,P,m,E,i,C,h,v,c,S,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let I=class je extends m.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new k.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new L.ThrottledWorker(je.FILE_EVENTS_THROTTLING.maxChangesChunkSize,je.FILE_EVENTS_THROTTLING.maxChangesBufferSize,je.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new S.FileChangesEvent(a,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new L.ThrottledWorker(je.FILE_EVENTS_THROTTLING.maxChangesChunkSize,je.FILE_EVENTS_THROTTLING.maxChangesBufferSize,je.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new S.FileChangesEvent(a,!0)))),this.watchedResources=E.TernarySearchTree.forUris(a=>{const t=this.getProvider(a.scheme);return t?!this.isPathCaseSensitive(t):!1}),this.writeQueue=this._register(new L.ResourceQueue)}registerProvider(o,a){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,C.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,a),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:a});const t=new m.DisposableStore;return t.add(a.onDidChangeFile(s=>this.onDidChangeFile(s,this.isPathCaseSensitive(a)))),t.add(a.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:a,scheme:o}))),typeof a.onDidErrorOccur=="function"&&t.add(a.onDidErrorOccur(s=>this._onError.fire(new Error(s)))),(0,m.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:a}),this.provider.delete(o),(0,m.dispose)(t)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const a=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(t){a.push(t)}}),!this.provider.has(o)&&await L.Promises.settled(a)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,a){const t=this.provider.get(o.scheme);return!!(t&&t.capabilities&a)}listCapabilities(){return P.Iterable.map(this.provider,([o,a])=>({scheme:o,capabilities:a.capabilities}))}async withProvider(o){if(!(0,h.isAbsolutePath)(o))throw new S.FileOperationError((0,c.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const a=this.provider.get(o.scheme);if(!a){const t=new Error;throw t.name="ENOPRO",t.message=(0,c.localize)(1,null,o.toString()),t}return a}async withReadProvider(o){const a=await this.withProvider(o);if((0,S.hasOpenReadWriteCloseCapability)(a)||(0,S.hasReadWriteCapability)(a)||(0,S.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const a=await this.withProvider(o);if((0,S.hasOpenReadWriteCloseCapability)(a)||(0,S.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,a){try{return await this.doResolveFile(o,a)}catch(t){throw(0,S.toFileSystemProviderErrorCode)(t)===S.FileSystemProviderErrorCode.FileNotFound?new S.FileOperationError((0,c.localize)(2,null,this.resourceForError(o)),1):(0,S.ensureFileSystemProviderError)(t)}}async doResolveFile(o,a){const t=await this.withProvider(o),s=this.isPathCaseSensitive(t),n=a?.resolveTo,r=a?.resolveSingleChildDescendants,u=a?.resolveMetadata,l=await t.stat(o);let f;return this.toFileStat(t,o,l,void 0,!!u,(d,w)=>{if(!f&&(f=E.TernarySearchTree.forUris(()=>!s),f.set(o,!0),n))for(const T of n)f.set(T,!0);return f.get(d.resource)||f.findSuperstr(d.resource.with({query:null,fragment:null}))?!0:d.isDirectory&&r?w===1:!1})}async toFileStat(o,a,t,s,n,r){const{providerExtUri:u}=this.getExtUri(o),l={resource:a,name:u.basename(a),isFile:(t.type&S.FileType.File)!=0,isDirectory:(t.type&S.FileType.Directory)!=0,isSymbolicLink:(t.type&S.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&S.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,S.etag)({mtime:t.mtime,size:t.size})};if(l.isDirectory&&r(l,s)){try{const f=await o.readdir(a),d=await L.Promises.settled(f.map(async([w,T])=>{try{const O=u.joinPath(a,w),y=n?await o.stat(O):{type:T};return await this.toFileStat(o,O,y,f.length,n,r)}catch(O){return this.logService.trace(O),null}}));l.children=(0,D.coalesce)(d)}catch(f){this.logService.trace(f),l.children=[]}return l}return l}async resolveAll(o){return L.Promises.settled(o.map(async a=>{try{return{stat:await this.doResolveFile(a.resource,a.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(o){const a=await this.withProvider(o);try{return!!await a.stat(o)}catch(t){return!1}}async canCreateFile(o,a){try{await this.doValidateCreateFile(o,a)}catch(t){return t}return!0}async doValidateCreateFile(o,a){if(!a?.overwrite&&await this.exists(o))throw new S.FileOperationError((0,c.localize)(3,null,this.resourceForError(o)),3,a)}async createFile(o,a=R.VSBuffer.fromString(""),t){await this.doValidateCreateFile(o,t);const s=await this.writeFile(o,a);return this._onDidRunOperation.fire(new S.FileOperationEvent(o,0,s)),s}async writeFile(o,a,t){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:n}=this.getExtUri(s);try{await this.validateWriteFile(s,o,t)||await this.mkdirp(s,n.dirname(o));let u;if((0,S.hasReadWriteCapability)(s)&&!(a instanceof R.VSBuffer))if((0,v.isReadableStream)(a)){const l=await(0,v.peekStream)(a,3);l.ended?u=R.VSBuffer.concat(l.buffer):u=l}else u=(0,v.peekReadable)(a,l=>R.VSBuffer.concat(l),3);else u=a;!(0,S.hasOpenReadWriteCloseCapability)(s)||(0,S.hasReadWriteCapability)(s)&&u instanceof R.VSBuffer?await this.doWriteUnbuffered(s,o,t,u):await this.doWriteBuffered(s,o,t,u instanceof R.VSBuffer?(0,R.bufferToReadable)(u):u)}catch(r){throw new S.FileOperationError((0,c.localize)(4,null,this.resourceForError(o),(0,S.ensureFileSystemProviderError)(r).toString()),(0,S.toFileOperationResult)(r),t)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,a,t){if(!!t?.unlock&&!(o.capabilities&8192))throw new Error((0,c.localize)(5,null,this.resourceForError(a)));let n;try{n=await o.stat(a)}catch(r){return}if((n.type&S.FileType.Directory)!=0)throw new S.FileOperationError((0,c.localize)(6,null,this.resourceForError(a)),0,t);if(this.throwIfFileIsReadonly(a,n),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==S.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&t.mtime<n.mtime&&t.etag!==(0,S.etag)({mtime:t.mtime,size:n.size}))throw new S.FileOperationError((0,c.localize)(7,null),3,t);return n}async readFile(o,a){const t=await this.withReadProvider(o);return a?.atomic?this.doReadFileAtomic(t,o,a):this.doReadFile(t,o,a)}async doReadFileAtomic(o,a,t){return new Promise((s,n)=>{this.writeQueue.queueFor(a,this.getExtUri(o).providerExtUri).queue(async()=>{try{const r=await this.doReadFile(o,a,t);s(r)}catch(r){n(r)}})})}async doReadFile(o,a,t){const s=await this.doReadFileStream(o,a,{...t,preferUnbuffered:!0});return{...s,value:await(0,R.streamToBuffer)(s.value)}}async readFileStream(o,a){const t=await this.withReadProvider(o);return this.doReadFileStream(t,o,a)}async doReadFileStream(o,a,t){const s=new A.CancellationTokenSource,n=this.validateReadFile(a,t).then(u=>u,u=>{throw s.cancel(),u});let r;try{return typeof t?.etag=="string"&&t.etag!==S.ETAG_DISABLED&&await n,!((0,S.hasOpenReadWriteCloseCapability)(o)||(0,S.hasFileReadStreamCapability)(o))||(0,S.hasReadWriteCapability)(o)&&t?.preferUnbuffered?r=this.readFileUnbuffered(o,a,t):(0,S.hasFileReadStreamCapability)(o)?r=this.readFileStreamed(o,a,s.token,t):r=this.readFileBuffered(o,a,s.token,t),{...await n,value:r}}catch(u){r&&await(0,v.consumeStream)(r);const l=(0,c.localize)(8,null,this.resourceForError(a),(0,S.ensureFileSystemProviderError)(u).toString());throw u instanceof S.NotModifiedSinceFileOperationError?new S.NotModifiedSinceFileOperationError(l,u.stat,t):new S.FileOperationError(l,(0,S.toFileOperationResult)(u),t)}}readFileStreamed(o,a,t,s=Object.create(null)){const n=o.readFileStream(a,s,t);return(0,v.transform)(n,{data:r=>r instanceof R.VSBuffer?r:R.VSBuffer.wrap(r),error:r=>new S.FileOperationError((0,c.localize)(9,null,this.resourceForError(a),(0,S.ensureFileSystemProviderError)(r).toString()),(0,S.toFileOperationResult)(r),s)},r=>R.VSBuffer.concat(r))}readFileBuffered(o,a,t,s=Object.create(null)){const n=(0,R.newWriteableBufferStream)();return(0,b.readFileIntoStream)(o,a,n,r=>r,{...s,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new S.FileOperationError((0,c.localize)(10,null,this.resourceForError(a),(0,S.ensureFileSystemProviderError)(r).toString()),(0,S.toFileOperationResult)(r),s)},t),n}readFileUnbuffered(o,a,t){const s=(0,v.newWriteableStream)(n=>R.VSBuffer.concat(n));return(async()=>{try{let n=await o.readFile(a);typeof t?.position=="number"&&(n=n.slice(t.position)),typeof t?.length=="number"&&(n=n.slice(0,t.length)),this.validateReadFileLimits(a,n.byteLength,t),s.end(R.VSBuffer.wrap(n))}catch(n){s.error(n),s.end()}})(),s}async validateReadFile(o,a){const t=await this.resolve(o,{resolveMetadata:!0});if(t.isDirectory)throw new S.FileOperationError((0,c.localize)(11,null,this.resourceForError(o)),0,a);if(typeof a?.etag=="string"&&a.etag!==S.ETAG_DISABLED&&a.etag===t.etag)throw new S.NotModifiedSinceFileOperationError((0,c.localize)(12,null),t,a);return this.validateReadFileLimits(o,t.size,a),t}validateReadFileLimits(o,a,t){if(t?.limits){let s;if(typeof t.limits.memory=="number"&&a>t.limits.memory&&(s=9),typeof t.limits.size=="number"&&a>t.limits.size&&(s=7),typeof s=="number")throw new S.FileOperationError((0,c.localize)(13,null,this.resourceForError(o)),s)}}async canMove(o,a,t){return this.doCanMoveCopy(o,a,"move",t)}async canCopy(o,a,t){return this.doCanMoveCopy(o,a,"copy",t)}async doCanMoveCopy(o,a,t,s){if(o.toString()!==a.toString())try{const n=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);await this.doValidateMoveCopy(n,o,r,a,t,s)}catch(n){return n}return!0}async move(o,a,t){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),r=await this.doMoveCopy(s,o,n,a,"move",!!t),u=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(o,r==="move"?2:3,u)),u}async copy(o,a,t){const s=await this.withReadProvider(o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),r=await this.doMoveCopy(s,o,n,a,"copy",!!t),u=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(o,r==="copy"?3:2,u)),u}async doMoveCopy(o,a,t,s,n,r){if(a.toString()===s.toString())return n;const{exists:u,isSameResourceWithDifferentPathCase:l}=await this.doValidateMoveCopy(o,a,t,s,n,r);if(u&&!l&&r&&await this.del(s,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(s)),n==="copy"){if(o===t&&(0,S.hasFileFolderCopyCapability)(o))await o.copy(a,s,{overwrite:r});else{const f=await this.resolve(a);f.isDirectory?await this.doCopyFolder(o,f,t,s):await this.doCopyFile(o,a,t,s)}return n}else return o===t?(await o.rename(a,s,{overwrite:r}),n):(await this.doMoveCopy(o,a,t,s,"copy",r),await this.del(a,{recursive:!0}),"copy")}async doCopyFile(o,a,t,s){if((0,S.hasOpenReadWriteCloseCapability)(o)&&(0,S.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(o,a,t,s);if((0,S.hasOpenReadWriteCloseCapability)(o)&&(0,S.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(o,a,t,s);if((0,S.hasReadWriteCapability)(o)&&(0,S.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(o,a,t,s);if((0,S.hasReadWriteCapability)(o)&&(0,S.hasReadWriteCapability)(t))return this.doPipeUnbuffered(o,a,t,s)}async doCopyFolder(o,a,t,s){await t.mkdir(s),Array.isArray(a.children)&&await L.Promises.settled(a.children.map(async n=>{const r=this.getExtUri(t).providerExtUri.joinPath(s,n.name);return n.isDirectory?this.doCopyFolder(o,await this.resolve(n.resource),t,r):this.doCopyFile(o,n.resource,t,r)}))}async doValidateMoveCopy(o,a,t,s,n,r){let u=!1;if(o===t){const{providerExtUri:f,isPathCaseSensitive:d}=this.getExtUri(o);if(d||(u=f.isEqual(a,s)),u&&n==="copy")throw new Error((0,c.localize)(14,null,this.resourceForError(a),this.resourceForError(s)));if(!u&&f.isEqualOrParent(s,a))throw new Error((0,c.localize)(15,null,this.resourceForError(a),this.resourceForError(s)))}const l=await this.exists(s);if(l&&!u){if(!r)throw new S.FileOperationError((0,c.localize)(16,null,this.resourceForError(a),this.resourceForError(s)),4);if(o===t){const{providerExtUri:f}=this.getExtUri(o);if(f.isEqualOrParent(a,s))throw new Error((0,c.localize)(17,null,this.resourceForError(a),this.resourceForError(s)))}}return{exists:l,isSameResourceWithDifferentPathCase:u}}getExtUri(o){const a=this.isPathCaseSensitive(o);return{providerExtUri:a?h.extUri:h.extUriIgnorePathCase,isPathCaseSensitive:a}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(a,o);const t=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(o,0,t)),t}async mkdirp(o,a){const t=[],{providerExtUri:s}=this.getExtUri(o);for(;!s.isEqual(a,s.dirname(a));)try{if(((await o.stat(a)).type&S.FileType.Directory)==0)throw new Error((0,c.localize)(18,null,this.resourceForError(a)));break}catch(n){if((0,S.toFileSystemProviderErrorCode)(n)!==S.FileSystemProviderErrorCode.FileNotFound)throw n;t.push(s.basename(a)),a=s.dirname(a)}for(let n=t.length-1;n>=0;n--){a=s.joinPath(a,t[n]);try{await o.mkdir(a)}catch(r){if((0,S.toFileSystemProviderErrorCode)(r)!==S.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(o,a){try{await this.doValidateDelete(o,a)}catch(t){return t}return!0}async doValidateDelete(o,a){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!a?.useTrash&&!(t.capabilities&4096))throw new Error((0,c.localize)(19,null,this.resourceForError(o)));let n;try{n=await t.stat(o)}catch(u){}if(n)this.throwIfFileIsReadonly(o,n);else throw new S.FileOperationError((0,c.localize)(20,null,this.resourceForError(o)),1);if(!!!a?.recursive){const u=await this.resolve(o);if(u.isDirectory&&Array.isArray(u.children)&&u.children.length>0)throw new Error((0,c.localize)(21,null,this.resourceForError(o)))}return t}async del(o,a){const t=await this.doValidateDelete(o,a),s=!!a?.useTrash,n=!!a?.recursive;await t.delete(o,{recursive:n,useTrash:s}),this._onDidRunOperation.fire(new S.FileOperationEvent(o,1))}onDidChangeFile(o,a){this._onDidChangeFilesRaw.fire({changes:o});let t,s;{for(const n of o)this.watchedResources.has(n.resource)?(t||(t=[]),t.push(n)):(s||(s=[]),s.push(n));t&&this._onDidFilesChange.fire(new S.FileChangesEvent(t,!a))}if(s){const n=a?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(s)&&je.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,a={recursive:!1,excludes:[]}){const t=new m.DisposableStore;{let s=!1,n=()=>{s=!0};t.add((0,m.toDisposable)(()=>n())),this.doWatch(o,a).then(r=>{s?(0,m.dispose)(r):n=()=>(0,m.dispose)(r)},r=>this.logService.error(r))}return a.recursive||(this.watchedResources.set(o,(this.watchedResources.get(o)??0)+1),t.add((0,m.toDisposable)(()=>{const s=this.watchedResources.get(o);typeof s=="number"&&(s<=1?this.watchedResources.delete(o):this.watchedResources.set(o,s-1))}))),t}async doWatch(o,a){const t=await this.withProvider(o),s=this.toWatchKey(t,o,a),n=this.activeWatchers.get(s)||{count:0,disposable:t.watch(o,a)};return this.activeWatchers.has(s)||this.activeWatchers.set(s,n),n.count+=1,(0,m.toDisposable)(()=>{n.count--,n.count===0&&((0,m.dispose)(n.disposable),this.activeWatchers.delete(s))})}toWatchKey(o,a,t){const{providerExtUri:s}=this.getExtUri(o);return[s.getComparisonKey(a),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,m.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,a,t,s){return this.writeQueue.queueFor(a,this.getExtUri(o).providerExtUri).queue(async()=>{const n=await o.open(a,{create:!0,unlock:t?.unlock??!1});try{(0,v.isReadableStream)(s)||(0,v.isReadableBufferedStream)(s)?await this.doWriteStreamBufferedQueued(o,n,s):await this.doWriteReadableBufferedQueued(o,n,s)}catch(r){throw(0,S.ensureFileSystemProviderError)(r)}finally{await o.close(n)}})}async doWriteStreamBufferedQueued(o,a,t){let s=0,n;if((0,v.isReadableBufferedStream)(t)){if(t.buffer.length>0){const r=R.VSBuffer.concat(t.buffer);await this.doWriteBuffer(o,a,r,r.byteLength,s,0),s+=r.byteLength}if(t.ended)return;n=t.stream}else n=t;return new Promise(async(r,u)=>{(0,v.listenStream)(n,{onData:async l=>{n.pause();try{await this.doWriteBuffer(o,a,l,l.byteLength,s,0)}catch(f){return u(f)}s+=l.byteLength,setTimeout(()=>n.resume())},onError:l=>u(l),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(o,a,t){let s=0,n;for(;(n=t.read())!==null;)await this.doWriteBuffer(o,a,n,n.byteLength,s,0),s+=n.byteLength}async doWriteBuffer(o,a,t,s,n,r){let u=0;for(;u<s;)u+=await o.write(a,n+u,t.buffer,r+u,s-u)}async doWriteUnbuffered(o,a,t,s){return this.writeQueue.queueFor(a,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,a,t,s))}async doWriteUnbufferedQueued(o,a,t,s){let n;s instanceof R.VSBuffer?n=s:(0,v.isReadableStream)(s)?n=await(0,R.streamToBuffer)(s):(0,v.isReadableBufferedStream)(s)?n=await(0,R.bufferedStreamToBuffer)(s):n=(0,R.readableToBuffer)(s),await o.writeFile(a,n.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async doPipeBuffered(o,a,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,a,t,s))}async doPipeBufferedQueued(o,a,t,s){let n,r;try{n=await o.open(a,{create:!1}),r=await t.open(s,{create:!0,unlock:!1});const u=R.VSBuffer.alloc(this.BUFFER_SIZE);let l=0,f=0,d=0;do d=await o.read(n,l,u.buffer,f,u.byteLength-f),await this.doWriteBuffer(t,r,u,d,l,f),l+=d,f+=d,f===u.byteLength&&(f=0);while(d>0)}catch(u){throw(0,S.ensureFileSystemProviderError)(u)}finally{await L.Promises.settled([typeof n=="number"?o.close(n):Promise.resolve(),typeof r=="number"?t.close(r):Promise.resolve()])}}async doPipeUnbuffered(o,a,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,a,t,s))}async doPipeUnbufferedQueued(o,a,t,s){return t.writeFile(s,await o.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,a,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,a,t,s))}async doPipeUnbufferedToBufferedQueued(o,a,t,s){const n=await t.open(s,{create:!0,unlock:!1});try{const r=await o.readFile(a);await this.doWriteBuffer(t,n,R.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,S.ensureFileSystemProviderError)(r)}finally{await t.close(n)}}async doPipeBufferedToUnbuffered(o,a,t,s){const n=await(0,R.streamToBuffer)(this.readFileBuffered(o,a,A.CancellationToken.None));await this.doWriteUnbuffered(t,s,void 0,n)}throwIfFileSystemIsReadonly(o,a){if(o.capabilities&2048)throw new S.FileOperationError((0,c.localize)(22,null,this.resourceForError(a)),6);return o}throwIfFileIsReadonly(o,a){if((a.permissions??0)&S.FilePermission.Readonly)throw new S.FileOperationError((0,c.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===i.Schemas.file?o.fsPath:o.toString(!0)}};I.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},I=de([Q(0,g.ILogService)],I),e.FileService=I}),define(te[170],ne([0,1,18,6,25,3,39,2,8,4,15,50,19,124,13,80,157,143,144,77,146,14]),function(K,e,D,L,R,A,k,P,m,E,i,C,h,v,c,S,b,g,I,p,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class t extends P.Disposable{constructor(n,r){super();this.logService=n,this.options=r,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=A.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new A.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,E.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:r,symbolicLink:u}=await h.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(r,u),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.toFileSystemProviderError(r)}}async readdir(n){try{const r=await h.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),u=[];return await Promise.all(r.map(async l=>{try{let f;l.isSymbolicLink()?f=(await this.stat((0,i.joinPath)(n,l.name))).type:f=this.toType(l),u.push([l.name,f])}catch(f){this.logService.trace(f)}})),u}catch(r){throw this.toFileSystemProviderError(r)}}toType(n,r){let u;return r?.dangling?u=c.FileType.Unknown:n.isFile()?u=c.FileType.File:n.isDirectory()?u=c.FileType.Directory:u=c.FileType.Unknown,r&&(u|=c.FileType.SymbolicLink),u}async readFile(n){try{const r=this.toFilePath(n);return await h.Promises.readFile(r)}catch(r){throw this.toFileSystemProviderError(r)}}readFileStream(n,r,u){const l=(0,C.newWriteableStream)(f=>R.VSBuffer.concat(f.map(d=>R.VSBuffer.wrap(d))).buffer);return(0,S.readFileIntoStream)(this,n,l,f=>f.buffer,{...r,bufferSize:this.BUFFER_SIZE},u),l}async writeFile(n,r,u){let l;try{const f=this.toFilePath(n);if(!u.create||!u.overwrite){if(await h.Promises.exists(f)){if(!u.overwrite)throw(0,c.createFileSystemProviderError)((0,v.localize)(0,null),c.FileSystemProviderErrorCode.FileExists)}else if(!u.create)throw(0,c.createFileSystemProviderError)((0,v.localize)(1,null),c.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(n,{create:!0,unlock:u.unlock}),await this.write(l,0,r,0,r.byteLength)}catch(f){throw await this.toFileSystemProviderWriteError(n,f)}finally{typeof l=="number"&&await this.close(l)}}async open(n,r){try{const u=this.toFilePath(n);if((0,c.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:d}=await h.SymlinkSupport.stat(u);d.mode&128||await h.Promises.chmod(u,d.mode|128)}catch(d){this.logService.trace(d)}let l;if((0,c.isFileOpenForWriteOptions)(r)){if(E.isWindows)try{await h.Promises.truncate(u,0),l="r+"}catch(d){d.code!=="ENOENT"&&this.logService.trace(d)}l||(l="w")}else l="r";const f=await h.Promises.open(u,l);return this.mapHandleToPos.set(f,0),(0,c.isFileOpenForWriteOptions)(r)&&this.writeHandles.set(f,n),f}catch(u){throw(0,c.isFileOpenForWriteOptions)(r)?await this.toFileSystemProviderWriteError(n,u):this.toFileSystemProviderError(u)}}async close(n){try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&this.canFlush)try{await h.Promises.fdatasync(n)}catch(r){this.canFlush=!1,this.logService.error(r)}return await h.Promises.close(n)}catch(r){throw this.toFileSystemProviderError(r)}}async read(n,r,u,l,f){const d=this.normalizePos(n,r);let w=null;try{const T=await h.Promises.read(n,u,l,f,d);return typeof T=="number"?w=T:w=T.bytesRead,w}catch(T){throw this.toFileSystemProviderError(T)}finally{this.updatePos(n,d,w)}}normalizePos(n,r){return r===this.mapHandleToPos.get(n)?null:r}updatePos(n,r,u){const l=this.mapHandleToPos.get(n);typeof l=="number"&&(typeof r=="number"||(typeof u=="number"?this.mapHandleToPos.set(n,l+u):this.mapHandleToPos.delete(n)))}async write(n,r,u,l,f){return(0,L.retry)(()=>this.doWrite(n,r,u,l,f),100,3)}async doWrite(n,r,u,l,f){const d=this.normalizePos(n,r);let w=null;try{const T=await h.Promises.write(n,u,l,f,d);return typeof T=="number"?w=T:w=T.bytesWritten,w}catch(T){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),T)}finally{this.updatePos(n,d,w)}}async mkdir(n){try{await h.Promises.mkdir(this.toFilePath(n))}catch(r){throw this.toFileSystemProviderError(r)}}async delete(n,r){try{const u=this.toFilePath(n);await this.doDelete(u,r)}catch(u){throw this.toFileSystemProviderError(u)}}async doDelete(n,r){r.recursive?await h.Promises.rm(n,h.RimRafMode.MOVE):await h.Promises.unlink(n)}async rename(n,r,u){const l=this.toFilePath(n),f=this.toFilePath(r);if(l!==f)try{await this.validateTargetDeleted(n,r,"move",u.overwrite),await h.Promises.move(l,f)}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,v.localize)(2,null,(0,m.basename)(l),(0,m.basename)((0,m.dirname)(f)),d.toString()))),this.toFileSystemProviderError(d)}}async copy(n,r,u){const l=this.toFilePath(n),f=this.toFilePath(r);if(l!==f)try{await this.validateTargetDeleted(n,r,"copy",u.overwrite),await h.Promises.copy(l,f,{preserveSymlinks:!0})}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,v.localize)(3,null,(0,m.basename)(l),(0,m.basename)((0,m.dirname)(f)),d.toString()))),this.toFileSystemProviderError(d)}}async validateTargetDeleted(n,r,u,l){const f=this.toFilePath(n),d=this.toFilePath(r);let w=!1;if(!!(this.capabilities&1024)||(w=(0,k.isEqual)(f,d,!0)),w&&u==="copy")throw(0,c.createFileSystemProviderError)((0,v.localize)(4,null),c.FileSystemProviderErrorCode.FileExists);if(!w&&await h.Promises.exists(d)){if(!l)throw(0,c.createFileSystemProviderError)((0,v.localize)(5,null),c.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}watch(n,r){return r.recursive?this.watchRecursive(n,r.excludes):this.watchNonRecursive(n)}watchRecursive(n,r){const u={path:this.toFilePath(n),excludes:r},l=(0,D.insert)(this.recursiveFoldersToWatch,u);return this.refreshRecursiveWatchers(),(0,P.toDisposable)(()=>{l(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof g.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,P.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let n,r;this.options?.watcher?.usePolling?(n=I.FileWatcher,r=this.options?.watcher):this.recursiveFoldersToWatch.length===1?E.isWindows?n=o.FileWatcher:n=I.FileWatcher:n=g.FileWatcher,this.recursiveWatcher=new n(this.recursiveFoldersToWatch,u=>this._onDidChangeFile.fire((0,p.toFileChanges)(u)),u=>{u.type==="error"&&this._onDidWatchErrorOccur.fire(u.message),this.logService[u.type](u.message)},this.logService.getLevel()===a.LogLevel.Trace,r),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===a.LogLevel.Trace)}))}}watchNonRecursive(n){const r=new b.FileWatcher(this.toFilePath(n),l=>this._onDidChangeFile.fire((0,p.toFileChanges)(l)),l=>{l.type==="error"&&this._onDidWatchErrorOccur.fire(l.message),this.logService[l.type](l.message)},this.logService.getLevel()===a.LogLevel.Trace),u=this.logService.onDidChangeLogLevel(()=>{r.setVerboseLogging(this.logService.getLevel()===a.LogLevel.Trace)});return(0,P.combinedDisposable)(r,u)}toFilePath(n){return(0,m.normalize)(n.fsPath)}toFileSystemProviderError(n){if(n instanceof c.FileSystemProviderError)return n;let r;switch(n.code){case"ENOENT":r=c.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=c.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=c.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=c.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=c.FileSystemProviderErrorCode.NoPermissions;break;default:r=c.FileSystemProviderErrorCode.Unknown}return(0,c.createFileSystemProviderError)(n,r)}async toFileSystemProviderWriteError(n,r){let u=this.toFileSystemProviderError(r);if(n&&u.code===c.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await h.SymlinkSupport.stat(this.toFilePath(n));l.mode&128||(u=(0,c.createFileSystemProviderError)(r,c.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.logService.trace(l)}return u}dispose(){super.dispose(),(0,P.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,P.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=t}),define(te[28],ne([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,D.createDecorator)("productService")}),define(te[171],ne([0,1,6,11,2,8,19,14,28]),function(K,e,D,L,R,A,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let E=class extends R.Disposable{constructor(C,h,v){super();this.productService=h,this.logService=v,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,C&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpCodeCaches(C)},30*1e3)).schedule()}async cleanUpCodeCaches(C){this.logService.info("[code cache cleanup]: Starting to clean up old code cache folders.");try{const h=Date.now(),v=(0,A.dirname)(C),c=(0,A.basename)(C),S=await k.Promises.readdir(v);await Promise.all(S.map(async b=>{if(b===c)return;const g=(0,A.join)(v,b),I=await k.Promises.stat(g);if(I.isDirectory()&&h-I.mtime.getTime()>this._DataMaxAge)return this.logService.info(`[code cache cleanup]: Removing code cache folder ${b}.`),k.Promises.rm(g)}))}catch(h){(0,L.onUnexpectedError)(h)}}};E=de([Q(1,m.IProductService),Q(2,P.ILogService)],E),e.CodeCacheCleaner=E}),define(te[172],ne([0,1,6,11,2,8,19,12,14,28]),function(K,e,D,L,R,A,k,P,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let i=class extends R.Disposable{constructor(h,v,c){super();this.environmentService=h,this.logService=v,this.productService=c,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.info("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const h=Object.create(null),v=JSON.parse(await k.Promises.readFile((0,A.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let I of Object.keys(v)){const p=v[I];h[`${p.hash}.${I}`]=!0}const c=(0,A.join)(this.environmentService.userDataPath,"clp");if(!await k.Promises.exists(c))return;const b=await k.Promises.readdir(c);for(const I of b){if(h[I]){this.logService.info(`[language pack cache cleanup]: Skipping folder ${I}. Language pack still in use.`);continue}this.logService.info(`[language pack cache cleanup]: Removing unused language pack: ${I}`),await k.Promises.rm((0,A.join)(c,I))}const g=Date.now();for(const I of Object.keys(h)){const p=(0,A.join)(c,I),o=await k.Promises.readdir(p);for(const a of o){if(a==="tcf.json")continue;const t=(0,A.join)(p,a),s=await k.Promises.stat(t);s.isDirectory()&&g-s.mtime.getTime()>this._DataMaxAge&&(this.logService.info(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,A.join)(I,a)}`),await k.Promises.rm(t))}}}catch(h){(0,L.onUnexpectedError)(h)}}};i=de([Q(0,P.INativeEnvironmentService),Q(1,m.ILogService),Q(2,E.IProductService)],i),e.LanguagePackCachedDataCleaner=i}),define(te[32],ne([0,1,90,16]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.data=new Map}add(k,P){D.ok(L.isString(k)),D.ok(L.isObject(P)),D.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,P)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new R}),define(te[81],ne([0,1,3,32]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class A{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(m,E){this.schemasById[R(m)]=E,this._onDidChangeSchema.fire(m)}notifySchemaChanged(m){this._onDidChangeSchema.fire(m)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new A;L.Registry.add(e.Extensions.JSONContribution,k)}),define(te[38],ne([0,1,3,16,111,81,32]),function(K,e,D,L,R,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var P;(function(g){g.Multiline="multilineText",g.Singleline="singlelineText"})(P=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var m;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.MACHINE=2]="MACHINE",g[g.WINDOW=3]="WINDOW",g[g.RESOURCE=4]="RESOURCE",g[g.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",g[g.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(m=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const E=k.Registry.as(A.Extensions.JSONContribution);class i{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new D.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new D.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(I,p=!0){this.registerConfigurations([I],p)}registerConfigurations(I,p=!0){const o=[];I.forEach(a=>{o.push(...this.validateAndRegisterProperties(a,p,a.extensionInfo)),this.configurationContributors.push(a),this.registerJSONConfiguration(a)}),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterConfigurations(I){const p=[],o=a=>{if(a.properties)for(const t in a.properties)p.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,a.properties[t]);a.allOf&&a.allOf.forEach(t=>o(t))};for(const a of I){o(a);const t=this.configurationContributors.indexOf(a);t!==-1&&this.configurationContributors.splice(t,1)}E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(p)}registerDefaultConfigurations(I){const p=[],o=[];for(const a of I)for(const t in a)if(p.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...a[t]};const s={type:"object",default:this.defaultValues[t],description:R.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};o.push(h(t)),this.configurationProperties[t]=s,this.defaultLanguageConfigurationOverridesNode.properties[t]=s}else{this.defaultValues[t]=a[t];const s=this.configurationProperties[t];s&&(this.updatePropertyDefaultValue(t,s),this.updateSchema(t,s))}this.registerOverrideIdentifiers(o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(p)}deregisterDefaultConfigurations(I){const p=[];for(const o of I)for(const a in o)if(p.push(a),delete this.defaultValues[a],e.OVERRIDE_PROPERTY_PATTERN.test(a))delete this.configurationProperties[a],delete this.defaultLanguageConfigurationOverridesNode.properties[a];else{const t=this.configurationProperties[a];t&&(this.updatePropertyDefaultValue(a,t),this.updateSchema(a,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(p)}notifyConfigurationSchemaUpdated(...I){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(I){for(const p of I)this.overrideIdentifiers.add(p);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(I,p=!0,o,a=3){a=L.isUndefinedOrNull(I.scope)?a:I.scope;let t=[],s=I.properties;if(s)for(let r in s){if(p&&S(r)){delete s[r];continue}const u=s[r];if(this.updatePropertyDefaultValue(r,u),e.OVERRIDE_PROPERTY_PATTERN.test(r)?u.scope=void 0:(u.scope=L.isUndefinedOrNull(u.scope)?a:u.scope,u.restricted=L.isUndefinedOrNull(u.restricted)?!!o?.restrictedConfigurations?.includes(r):u.restricted),s[r].hasOwnProperty("included")&&!s[r].included){this.excludedConfigurationProperties[r]=s[r],delete s[r];continue}else this.configurationProperties[r]=s[r];!s[r].deprecationMessage&&s[r].markdownDeprecationMessage&&(s[r].deprecationMessage=s[r].markdownDeprecationMessage),t.push(r)}let n=I.allOf;if(n)for(let r of n)t.push(...this.validateAndRegisterProperties(r,p,o,a));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(I){const p=o=>{let a=o.properties;if(a)for(const s in a)this.updateSchema(s,a[s]);let t=o.allOf;t&&t.forEach(p)};p(I)}updateSchema(I,p){switch(e.allSettings.properties[I]=p,p.scope){case 1:e.applicationSettings.properties[I]=p;break;case 2:e.machineSettings.properties[I]=p;break;case 6:e.machineOverridableSettings.properties[I]=p;break;case 3:e.windowSettings.properties[I]=p;break;case 4:e.resourceSettings.properties[I]=p;break;case 5:e.resourceSettings.properties[I]=p,this.resourceLanguageSettingsSchema.properties[I]=p;break}}removeFromSchema(I,p){switch(delete e.allSettings.properties[I],p.scope){case 1:delete e.applicationSettings.properties[I];break;case 2:delete e.machineSettings.properties[I];break;case 6:delete e.machineOverridableSettings.properties[I];break;case 3:delete e.windowSettings.properties[I];break;case 4:case 5:delete e.resourceSettings.properties[I];break}}updateOverridePropertyPatternKey(){for(const I of this.overrideIdentifiers.values()){const p=`[${I}]`,o={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(p,o),e.allSettings.properties[p]=o,e.applicationSettings.properties[p]=o,e.machineSettings.properties[p]=o,e.machineOverridableSettings.properties[p]=o,e.windowSettings.properties[p]=o,e.resourceSettings.properties[p]=o}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(I,p){let o=this.defaultValues[I];L.isUndefined(o)&&(o=p.default),L.isUndefined(o)&&(o=v(p.type)),p.default=o}}const C="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(C);function h(g){return g.substring(1,g.length-1)}e.overrideIdentifierFromKey=h;function v(g){switch(Array.isArray(g)?g[0]:g){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=v;const c=new i;k.Registry.add(e.Extensions.Configuration,c);function S(g){return g.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(g)?R.localize(5,null,g):c.getConfigurationProperties()[g]!==void 0?R.localize(6,null,g):null:R.localize(4,null)}e.validateProperty=S;function b(){const g=[],I=c.getConfigurationProperties();for(const p of Object.keys(I))g.push([p,I[p].scope]);return g.push(["launch",4]),g.push(["task",4]),g}e.getScopes=b}),define(te[20],ne([0,1,26,16,5,38,7,32]),function(K,e,D,L,R,A,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function m(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof R.URI)}e.isConfigurationOverrides=m;var E;(function(s){s[s.USER=1]="USER",s[s.USER_LOCAL=2]="USER_LOCAL",s[s.USER_REMOTE=3]="USER_REMOTE",s[s.WORKSPACE=4]="WORKSPACE",s[s.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",s[s.DEFAULT=6]="DEFAULT",s[s.MEMORY=7]="MEMORY"})(E=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(s){switch(s){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function C(s,n){const r=n?s?n.keys.filter(O=>s.keys.indexOf(O)===-1):[...n.keys]:[],u=s?n?s.keys.filter(O=>n.keys.indexOf(O)===-1):[...s.keys]:[],l=[];if(n&&s){for(const O of s.keys)if(n.keys.indexOf(O)!==-1){const y=g(s.contents,O),M=g(n.contents,O);D.equals(y,M)||l.push(O)}}const f=[],d=O=>{const y={};for(const M of O)for(const F of M.identifiers)y[a(F)]=M;return y},w=n?d(n.overrides):{},T=s?d(s.overrides):{};if(Object.keys(w).length)for(const O of r){const y=w[O];y&&f.push([(0,A.overrideIdentifierFromKey)(O),y.keys])}if(Object.keys(T).length)for(const O of u){const y=T[O];y&&f.push([(0,A.overrideIdentifierFromKey)(O),y.keys])}if(Object.keys(w).length&&Object.keys(T).length)for(const O of l){const y=T[O],M=w[O];if(y&&M){const F=C({contents:y.contents,keys:y.keys,overrides:[]},{contents:M.contents,keys:M.keys,overrides:[]});f.push([(0,A.overrideIdentifierFromKey)(O),[...F.added,...F.removed,...F.updated]])}}return{added:r,removed:u,updated:l,overrides:f}}e.compare=C;function h(s,n){const r=[];for(const u of Object.keys(s))if(A.OVERRIDE_PROPERTY_PATTERN.test(u)){const l={};for(const f in s[u])l[f]=s[u][f];r.push({identifiers:[(0,A.overrideIdentifierFromKey)(u).trim()],keys:Object.keys(l),contents:v(l,n)})}return r}e.toOverrides=h;function v(s,n){const r=Object.create(null);for(let u in s)c(r,u,s[u],n);return r}e.toValuesTree=v;function c(s,n,r,u){const l=n.split("."),f=l.pop();let d=s;for(let w=0;w<l.length;w++){let T=l[w],O=d[T];switch(typeof O){case"undefined":O=d[T]=Object.create(null);break;case"object":break;default:u(`Ignoring ${n} as ${l.slice(0,w+1).join(".")} is ${JSON.stringify(O)}`);return}d=O}if(typeof d=="object"&&d!==null)try{d[f]=r}catch(w){u(`Ignoring ${n} as ${l.join(".")} is ${JSON.stringify(d)}`)}else u(`Ignoring ${n} as ${l.join(".")} is ${JSON.stringify(d)}`)}e.addToValueTree=c;function S(s,n){const r=n.split(".");b(s,r)}e.removeFromValueTree=S;function b(s,n){const r=n.shift();if(n.length===0){delete s[r];return}if(Object.keys(s).indexOf(r)!==-1){const u=s[r];typeof u=="object"&&!Array.isArray(u)&&(b(u,n),Object.keys(u).length===0&&delete s[r])}}function g(s,n,r){function u(d,w){let T=d;for(const O of w){if(typeof T!="object"||T===null)return;T=T[O]}return T}const l=n.split("."),f=u(s,l);return typeof f=="undefined"?r:f}e.getConfigurationValue=g;function I(s,n,r){Object.keys(n).forEach(u=>{u!=="__proto__"&&(u in s?L.isObject(s[u])&&L.isObject(n[u])?I(s[u],n[u],r):r&&(s[u]=n[u]):s[u]=n[u])})}e.merge=I;function p(){const s=P.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(s)}e.getConfigurationKeys=p;function o(){const s=Object.create(null),n=P.Registry.as(A.Extensions.Configuration).getConfigurationProperties();for(let r in n){let u=n[r].default;c(s,r,u,l=>console.error(`Conflict in default settings: ${l}`))}return s}e.getDefaultValues=o;function a(s){return`[${s}]`}e.keyFromOverrideIdentifier=a;function t(s,n,r){const u=s.inspect(n),l=s.inspect(r);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:u.defaultValue}e.getMigratedSettingValue=t}),define(te[173],ne([0,1,18,3,33,2,40,26,16,5,20,38,32]),function(K,e,D,L,R,A,k,P,m,E,i,C,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class v{constructor(t={},s=[],n=[]){this._contents=t,this._keys=s,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,i.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,s){const n=this.getContentsForOverrideIdentifer(s);return n?t?(0,i.getConfigurationValue)(n,t):n:void 0}getKeysForOverrideIdentifier(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.keys;return[]}override(t){const s=this.getContentsForOverrideIdentifer(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;let n={};for(const r of D.distinct([...Object.keys(this.contents),...Object.keys(s)])){let u=this.contents[r],l=s[r];l&&(typeof u=="object"&&typeof l=="object"?(u=P.deepClone(u),this.mergeContents(u,l)):u=l),n[r]=u}return new v(n,this.keys,this.overrides)}merge(...t){const s=P.deepClone(this.contents),n=P.deepClone(this.overrides),r=[...this.keys];for(const u of t){this.mergeContents(s,u.contents);for(const l of u.overrides){const[f]=n.filter(d=>D.equals(d.identifiers,l.identifiers));f?this.mergeContents(f.contents,l.contents):n.push(P.deepClone(l))}for(const l of u.keys)r.indexOf(l)===-1&&r.push(l)}return new v(s,r,n)}freeze(){return this.isFrozen=!0,this}mergeContents(t,s){for(const n of Object.keys(s)){if(n in t&&m.isObject(t[n])&&m.isObject(s[n])){this.mergeContents(t[n],s[n]);continue}t[n]=P.deepClone(s[n])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?P.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,s){this.addKey(t),(0,i.addToValueTree)(this.contents,t,s,n=>{throw new Error(n)})}removeValue(t){this.removeKey(t)&&(0,i.removeFromValueTree)(this.contents,t)}addKey(t){let s=this.keys.length;for(let n=0;n<s;n++)t.indexOf(this.keys[n])===0&&(s=n);this.keys.splice(s,1,t)}removeKey(t){let s=this.keys.indexOf(t);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=v;class c extends v{constructor(){const t=(0,i.getDefaultValues)(),s=(0,i.getConfigurationKeys)(),n=[];for(const r of Object.keys(t))C.OVERRIDE_PROPERTY_PATTERN.test(r)&&n.push({identifiers:[(0,C.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(t[r]),contents:(0,i.toValuesTree)(t[r],u=>console.error(`Conflict in default settings file: ${u}`))});super(t,s,n)}}e.DefaultConfigurationModel=c;class S{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new v}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,s){if(!m.isUndefinedOrNull(t)){const n=this.doParseContent(t);this.parseRaw(n,s)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,s){this._raw=t;const{contents:n,keys:r,overrides:u,restricted:l}=this.doParseRaw(t,s);this._configurationModel=new v(n,r,u),this._restrictedConfigurations=l||[]}doParseContent(t){let s={},n=null,r=[],u=[],l=[];function f(w){Array.isArray(r)?r.push(w):n!==null&&(r[n]=w)}let d={onObjectBegin:()=>{let w={};f(w),u.push(r),r=w,n=null},onObjectProperty:w=>{n=w},onObjectEnd:()=>{r=u.pop()},onArrayBegin:()=>{let w=[];f(w),u.push(r),r=w,n=null},onArrayEnd:()=>{r=u.pop()},onLiteralValue:f,onError:(w,T,O)=>{l.push({error:w,offset:T,length:O})}};if(t)try{R.visit(t,d),s=r[0]||{}}catch(w){console.error(`Error while parsing settings file ${this._name}: ${w}`),this._parseErrors=[w]}return s}doParseRaw(t,s){const n=h.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),r=this.filter(t,n,!0,s);t=r.raw;const u=(0,i.toValuesTree)(t,d=>console.error(`Conflict in settings file ${this._name}: ${d}`)),l=Object.keys(t),f=(0,i.toOverrides)(t,d=>console.error(`Conflict in settings file ${this._name}: ${d}`));return{contents:u,keys:l,overrides:f,restricted:r.restricted}}filter(t,s,n,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:t,restricted:[]};const u={},l=[];for(let f in t)if(C.OVERRIDE_PROPERTY_PATTERN.test(f)&&n){const d=this.filter(t[f],s,!1,r);u[f]=d.raw,l.push(...d.restricted)}else{const d=s[f],w=d?typeof d.scope!="undefined"?d.scope:3:void 0;d?.restricted&&l.push(f),(w===void 0||r.scopes===void 0||r.scopes.includes(w))&&(r.skipRestricted&&d?.restricted||(u[f]=t[f]))}return{raw:u,restricted:l}}}e.ConfigurationModelParser=S;class b extends A.Disposable{constructor(t,s,n,r){super();this.userSettingsResource=t,this.scopes=s,this.fileService=r,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new S(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new v}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=b;class g{constructor(t,s,n=new v,r=new v,u=new k.ResourceMap,l=new v,f=new k.ResourceMap,d=!0){this._defaultConfiguration=t,this._localUserConfiguration=s,this._remoteUserConfiguration=n,this._workspaceConfiguration=r,this._folderConfigurations=u,this._memoryConfiguration=l,this._memoryConfigurationByResource=f,this._freeze=d,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(t,s,n){return this.getConsolidateConfigurationModel(s,n).getValue(t)}updateValue(t,s,n={}){let r;n.resource?(r=this._memoryConfigurationByResource.get(n.resource),r||(r=new v,this._memoryConfigurationByResource.set(n.resource,r))):r=this._memoryConfiguration,s===void 0?r.removeValue(t):r.setValue(t,s),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,s,n){const r=this.getConsolidateConfigurationModel(s,n),u=this.getFolderConfigurationModelForResource(s.resource,n),l=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,f=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),d=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),w=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),T=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),O=n?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,y=u?s.overrideIdentifier?u.freeze().override(s.overrideIdentifier).getValue(t):u.freeze().getValue(t):void 0,M=s.overrideIdentifier?l.override(s.overrideIdentifier).getValue(t):l.getValue(t),F=r.getValue(t),q=D.distinct(D.flatten(r.overrides.map(x=>x.identifiers))).filter(x=>r.getOverrideValue(t,x)!==void 0);return{defaultValue:f,userValue:d,userLocalValue:w,userRemoteValue:T,workspaceValue:O,workspaceFolderValue:y,memoryValue:M,value:F,default:f!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,user:d!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userLocal:w!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userRemote:T!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspace:O!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspaceFolder:y!==void 0?{value:u?.freeze().getValue(t),override:s.overrideIdentifier?u?.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,memory:M!==void 0?{value:l.getValue(t),override:s.overrideIdentifier?l.getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:q.length?q:void 0}}keys(t){const s=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,s){this._folderConfigurations.set(t,s),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const n=s.filter(r=>C.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const u=(0,C.overrideIdentifierFromKey)(r),l=this._defaultConfiguration.getKeysForOverrideIdentifier(u),f=t.getKeysForOverrideIdentifier(u),d=[...f.filter(w=>l.indexOf(w)===-1),...l.filter(w=>f.indexOf(w)===-1),...l.filter(w=>!P.equals(this._defaultConfiguration.override(u).getValue(w),t.override(u).getValue(w)))];return[u,d]});return this.updateDefaultConfiguration(t),{keys:s,overrides:n}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:n,removed:r,overrides:u}=(0,i.compare)(this.localUserConfiguration,t),l=[...s,...n,...r];return l.length&&this.updateLocalUserConfiguration(t),{keys:l,overrides:u}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:n,removed:r,overrides:u}=(0,i.compare)(this.remoteUserConfiguration,t);let l=[...s,...n,...r];return l.length&&this.updateRemoteUserConfiguration(t),{keys:l,overrides:u}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:n,removed:r,overrides:u}=(0,i.compare)(this.workspaceConfiguration,t);let l=[...s,...n,...r];return l.length&&this.updateWorkspaceConfiguration(t),{keys:l,overrides:u}}compareAndUpdateFolderConfiguration(t,s){const n=this.folderConfigurations.get(t),{added:r,updated:u,removed:l,overrides:f}=(0,i.compare)(n,s);let d=[...r,...u,...l];return(d.length||!n)&&this.updateFolderConfiguration(t,s),{keys:d,overrides:f}}compareAndDeleteFolderConfiguration(t){const s=this.folderConfigurations.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:n,updated:r,removed:u,overrides:l}=(0,i.compare)(s,void 0);return{keys:[...n,...r,...u],overrides:l}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,s){let n=this.getConsolidatedConfigurationModelForResource(t,s);return t.overrideIdentifier?n.override(t.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:t},s){let n=this.getWorkspaceConsolidatedConfiguration();if(s&&t){const r=s.getFolder(t);r&&(n=this.getFolderConsolidatedConfiguration(r.uri)||n);const u=this._memoryConfigurationByResource.get(t);u&&(n=n.merge(u))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let s=this._foldersConsolidatedConfigurations.get(t);if(!s){const n=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(t);r?(s=n.merge(r),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(t,s)):s=n}return s}getFolderConfigurationModelForResource(t,s){if(s&&t){const n=s.getFolder(t);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,s)=>{const{contents:n,overrides:r,keys:u}=this._folderConfigurations.get(s);return t.push([s,{contents:n,overrides:r,keys:u}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>t.add(s)),this.userConfiguration.freeze().keys.forEach(s=>t.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(n=>t.add(n))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>s.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>s.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>s.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r))),[...s.values()]}static parse(t){const s=this.parseConfigurationModel(t.defaults),n=this.parseConfigurationModel(t.user),r=this.parseConfigurationModel(t.workspace),u=t.folders.reduce((l,f)=>(l.set(E.URI.revive(f[0]),this.parseConfigurationModel(f[1])),l),new k.ResourceMap);return new g(s,n,new v,r,u,new v,new k.ResourceMap,!1)}static parseConfigurationModel(t){return new v(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=g;function I(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const t=new Set,s=new Map;for(const r of a)r.keys.forEach(u=>t.add(u)),r.overrides.forEach(([u,l])=>{const f=(0,k.getOrSet)(s,u,new Set);l.forEach(d=>f.add(d))});const n=[];return s.forEach((r,u)=>n.push([u,[...r.values()]])),{keys:[...t.values()],overrides:n}}e.mergeChanges=I;class p{constructor(t,s,n,r){this.change=t,this.previous=s,this.currentConfiguraiton=n,this.currentWorkspace=r,this._previousConfiguration=void 0;const u=new Set;t.keys.forEach(f=>u.add(f)),t.overrides.forEach(([,f])=>f.forEach(d=>u.add(d))),this.affectedKeys=[...u.values()];const l=new v;this.affectedKeys.forEach(f=>l.setValue(f,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=g.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(s){const n=this.previousConfiguration?this.previousConfiguration.getValue(t,s,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(t,s,this.currentWorkspace);return!P.equals(n,r)}return!0}return!1}doesAffectedKeysTreeContains(t,s){let n=(0,i.toValuesTree)({[s]:!0},()=>{}),r;for(;typeof n=="object"&&(r=Object.keys(n)[0]);){if(t=t[r],!t)return!1;n=n[r]}return!0}}e.ConfigurationChangeEvent=p;class o extends p{constructor(t,s,n,r){super({keys:t.allKeys(),overrides:[]},void 0,t,s);this.source=n,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=o}),define(te[174],ne([0,1,6,3,2,15,20,173,38,32]),function(K,e,D,L,R,A,k,P,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class i extends R.Disposable{constructor(h,v){super();this.settingsResource=h,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,A.extUriBiasedIgnorePathCase,v)),this.configuration=new P.Configuration(new P.DefaultConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(E.Registry.as(m.Extensions.Configuration).onDidUpdateConfiguration(c=>this.onDidDefaultConfigurationChange(c))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const h=await this.userConfiguration.loadConfiguration();this.configuration=new P.Configuration(new P.DefaultConfigurationModel,h)}getConfigurationData(){return this.configuration.toData()}getValue(h,v){const c=typeof h=="string"?h:void 0,S=(0,k.isConfigurationOverrides)(h)?h:(0,k.isConfigurationOverrides)(v)?v:{};return this.configuration.getValue(c,S,void 0)}updateValue(h,v,c,S){return Promise.reject(new Error("not supported"))}inspect(h){return this.configuration.inspect(h,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const h=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(h)}onDidChangeUserConfiguration(h){const v=this.configuration.toData(),c=this.configuration.compareAndUpdateLocalUserConfiguration(h);this.trigger(c,v,1)}onDidDefaultConfigurationChange(h){const v=this.configuration.toData(),c=this.configuration.compareAndUpdateDefaultConfiguration(new P.DefaultConfigurationModel,h);this.trigger(c,v,6)}trigger(h,v,c){const S=new P.ConfigurationChangeEvent(h,{data:v},this.configuration);S.source=c,S.sourceConfig=this.getTargetConfiguration(c),this._onDidChangeConfiguration.fire(S)}getTargetConfiguration(h){switch(h){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=i}),define(te[175],ne([0,1,105,20,14]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let A=class{constructor(P,m){this.configurationService=P,this.logService=m}request(P,m){return this.logService.trace("RequestService#request",P.url),P.proxyAuthorization||(P.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,D.request)(P,m)}async resolveProxy(P){}};A=de([Q(0,L.IConfigurationService),Q(1,R.ILogService)],A),e.RequestService=A}),define(te[42],ne([0,1,25,125,38,7,32]),function(K,e,D,L,R,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,A.createDecorator)("requestService");function P(c){return c.res.statusCode&&c.res.statusCode>=200&&c.res.statusCode<300||c.res.statusCode===1223}e.isSuccess=P;function m(c){return c.res.statusCode===204}async function E(c){if(!P(c))throw new Error("Server returned "+c.res.statusCode);return m(c)?null:(await(0,D.streamToBuffer)(c.stream)).toString()}e.asText=E;async function i(c){if(!P(c))throw new Error("Server returned "+c.res.statusCode);if(m(c))return null;const b=(await(0,D.streamToBuffer)(c.stream)).toString();try{return JSON.parse(b)}catch(g){throw g.message+=`:
`+b,g}}e.asJson=i;function C(c){v(c)}e.updateProxyConfigurationsScope=C;let h;function v(c){const S=k.Registry.as(R.Extensions.Configuration);h&&S.deregisterConfigurations([h]),h={id:"http",order:15,title:(0,L.localize)(0,null),type:"object",scope:c,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(4,null),(0,L.localize)(5,null),(0,L.localize)(6,null),(0,L.localize)(7,null)],default:"override",description:(0,L.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(9,null),restricted:!0}}},S.registerConfiguration(h)}v(2)}),define(te[176],ne([0,1,29,17,13,42]),function(K,e,D,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let k=class{constructor(m,E){this.requestService=m,this.fileService=E}async download(m,E,i=D.CancellationToken.None){if(m.scheme===L.Schemas.file||m.scheme===L.Schemas.vscodeRemote){await this.fileService.copy(m,E);return}const C={type:"GET",url:m.toString()},h=await this.requestService.request(C,i);if(h.res.statusCode===200)await this.fileService.writeFile(E,h.stream);else{const v=await(0,A.asText)(h);throw new Error(`Expected 200, got back ${h.res.statusCode} instead.

${v}`)}}};k=de([Q(0,A.IRequestService),Q(1,R.IFileService)],k),e.DownloadService=k}),define(te[177],ne([0,1,18,29,63,2,15,139,13,14,28,42]),function(K,e,D,L,R,A,k,P,m,E,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let h=class extends A.Disposable{constructor(c,S,b,g){super();this.fileService=c,this.productService=S,this.requestService=b,this.logService=g,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,R.forEach)(this.productService.configBasedExtensionTips,({value:I})=>this.allConfigBasedTips.set(I.configPath,I))}getConfigBasedTips(c){return this.getValidConfigBasedTips(c)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(c){const S=[];for(const[b,g]of this.allConfigBasedTips)try{const I=await this.fileService.readFile((0,k.joinPath)(c,b)),p=new Map;(0,R.forEach)(g.recommendations,({key:a,value:t})=>{if((0,D.isNonEmptyArray)(t.remotes))for(const s of t.remotes)p.set(s,{extensionId:a,extensionName:t.name,configName:g.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack});else S.push({extensionId:a,extensionName:t.name,configName:g.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack})});const o=(0,P.getDomainsOfRemotes)(I.value.toString(),[...p.keys()]);for(const a of o){const t=p.get(a);t&&S.push(t)}}catch(I){}return S}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const c=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},L.CancellationToken.None);if(c.res.statusCode!==200)return[];const S=await(0,C.asJson)(c);return S?S.workspaceRecommendations||[]:[]}catch(c){return this.logService.error(c),[]}}};h=de([Q(0,m.IFileService),Q(1,i.IProductService),Q(2,C.IRequestService),Q(3,E.ILogService)],h),e.ExtensionTipsService=h}),define(te[45],ne([0,1,25,30]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function R(A,k,P){let m=P&&P.get("storage.serviceMachineId",0)||null;if(m)return m;try{const i=(await k.readFile(A.serviceMachineIdResource)).value.toString();m=(0,L.isUUID)(i)?i:null}catch(E){m=null}if(!m){m=(0,L.generateUuid)();try{await k.writeFile(A.serviceMachineIdResource,D.VSBuffer.fromString(m))}catch(E){}}return P&&P.store("storage.serviceMachineId",m,0,1),m}e.getServiceMachineId=R}),define(te[21],ne([0,1,6,3,2,16,70,7]),function(K,e,D,L,R,A,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const m="__$__targetStorageMarker";e.IStorageService=(0,P.createDecorator)("storageService");var E;(function(S){S[S.NONE=0]="NONE",S[S.SHUTDOWN=1]="SHUTDOWN"})(E=e.WillSaveStateReason||(e.WillSaveStateReason={}));var i;(function(S){S[S.GLOBAL=0]="GLOBAL",S[S.WORKSPACE=1]="WORKSPACE"})(i=e.StorageScope||(e.StorageScope={}));var C;(function(S){S[S.USER=0]="USER",S[S.MACHINE=1]="MACHINE"})(C=e.StorageTarget||(e.StorageTarget={}));class h extends R.Disposable{constructor(b={flushInterval:h.DEFAULT_FLUSH_INTERVAL}){super();this.options=b,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new R.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,R.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(b,g){g===m?(b===0?this._globalKeyTargets=void 0:b===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:b})):this._onDidChangeValue.fire({scope:b,key:g,target:this.getKeyTargets(b)[g]})}emitWillSaveState(b){this._onWillSaveState.fire({reason:b})}get(b,g,I){return this.getStorage(g)?.get(b,I)}getBoolean(b,g,I){return this.getStorage(g)?.getBoolean(b,I)}getNumber(b,g,I){return this.getStorage(g)?.getNumber(b,I)}store(b,g,I,p){if((0,A.isUndefinedOrNull)(g)){this.remove(b,I);return}this.withPausedEmitters(()=>{this.updateKeyTarget(b,I,p),this.getStorage(I)?.set(b,g)})}remove(b,g){this.withPausedEmitters(()=>{this.updateKeyTarget(b,g,void 0),this.getStorage(g)?.delete(b)})}withPausedEmitters(b){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{b()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(b,g){const I=[],p=this.getKeyTargets(b);for(const o of Object.keys(p))p[o]===g&&I.push(o);return I}updateKeyTarget(b,g,I){const p=this.getKeyTargets(g);typeof I=="number"?p[b]!==I&&(p[b]=I,this.getStorage(g)?.set(m,JSON.stringify(p))):typeof p[b]=="number"&&(delete p[b],this.getStorage(g)?.set(m,JSON.stringify(p)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(b){return b===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(b){const g=this.get(m,b);if(g)try{return JSON.parse(g)}catch(I){}return Object.create(null)}isNew(b){return this.getBoolean(e.IS_NEW_KEY,b)===!0}async flush(b=E.NONE){this._onWillSaveState.fire({reason:b}),await D.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const b=this.getStorage(0)?.items??new Map,g=this.getStorage(1)?.items??new Map;return c(b,g,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=h,h.DEFAULT_FLUSH_INTERVAL=60*1e3;class v extends h{constructor(){super();this.globalStorage=this._register(new k.Storage(new k.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new k.Storage(new k.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(b=>this.emitDidChangeValue(1,b))),this._register(this.globalStorage.onDidChangeStorage(b=>this.emitDidChangeValue(0,b)))}getStorage(b){return b===0?this.globalStorage:this.workspaceStorage}getLogDetails(b){return b===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(b){}}e.InMemoryStorageService=v;async function c(S,b,g,I){const p=u=>{try{return JSON.parse(u)}catch(l){return u}},o=new Map,a=new Map;S.forEach((u,l)=>{o.set(l,u),a.set(l,p(u))});const t=new Map,s=new Map;b.forEach((u,l)=>{t.set(l,u),s.set(l,p(u))}),console.group(`Storage: Global (path: ${g})`);let n=[];o.forEach((u,l)=>{n.push({key:l,value:u})}),console.table(n),console.groupEnd(),console.log(a),console.group(`Storage: Workspace (path: ${I})`);let r=[];t.forEach((u,l)=>{r.push({key:l,value:u})}),console.table(r),console.groupEnd(),console.log(s)}e.logStorage=c}),define(te[178],ne([0,1,3,2,16,27,31,21]),function(K,e,D,L,R,A,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let m=class extends L.Disposable{constructor(C){super();this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new E(C)),this._register(this.storageManger.onDidChange(h=>this._onDidChangeEnablement.fire({extensions:h,source:"storage"})))}async enableExtension(C,h){return this._removeFromDisabledExtensions(C)?(this._onDidChangeEnablement.fire({extensions:[C],source:h}),!0):!1}async disableExtension(C,h){return this._addToDisabledExtensions(C)?(this._onDidChangeEnablement.fire({extensions:[C],source:h}),!0):!1}getDisabledExtensions(){return this._getExtensions(A.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(C){let h=this.getDisabledExtensions();return h.every(v=>!(0,k.areSameExtensions)(v,C))?(h.push(C),this._setDisabledExtensions(h),!0):!1}_removeFromDisabledExtensions(C){let h=this.getDisabledExtensions();for(let v=0;v<h.length;v++){const c=h[v];if((0,k.areSameExtensions)(c,C))return h.splice(v,1),this._setDisabledExtensions(h),!0}return!1}_setDisabledExtensions(C){this._setExtensions(A.DISABLED_EXTENSIONS_STORAGE_PATH,C)}_getExtensions(C){return this.storageManger.get(C,0)}_setExtensions(C,h){this.storageManger.set(C,h,0)}};m=de([Q(0,P.IStorageService)],m),e.GlobalExtensionEnablementService=m;class E extends L.Disposable{constructor(C){super();this.storageService=C,this.storage=Object.create(null),this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this._register(C.onDidChangeValue(h=>this.onDidStorageChange(h)))}get(C,h){let v;return h===0?((0,R.isUndefinedOrNull)(this.storage[C])&&(this.storage[C]=this._get(C,h)),v=this.storage[C]):v=this._get(C,h),JSON.parse(v)}set(C,h,v){let c=JSON.stringify(h.map(({id:b,uuid:g})=>({id:b,uuid:g})));this._get(C,v)!==c&&(v===0&&(h.length?this.storage[C]=c:delete this.storage[C]),this._set(C,h.length?c:void 0,v))}onDidStorageChange(C){if(C.scope===0&&!(0,R.isUndefinedOrNull)(this.storage[C.key])&&this._get(C.key,C.scope)!==this.storage[C.key]){const v=this.get(C.key,C.scope);delete this.storage[C.key];const c=this.get(C.key,C.scope),S=v.filter(g=>!c.some(I=>(0,k.areSameExtensions)(g,I))),b=c.filter(g=>!v.some(I=>(0,k.areSameExtensions)(I,g)));(S.length||b.length)&&this._onDidChange.fire([...S,...b])}}_get(C,h){return this.storageService.get(C,h,"[]")}_set(C,h,v){h?this.storageService.store(C,h,v,1):this.storageService.remove(C,v)}}e.StorageManager=E}),define(te[179],ne([0,1,3,2]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class R extends L.Disposable{constructor(E,i){super();this.channel=E,this.workspace=i}async getItems(){const E={workspace:this.workspace},i=await this.channel.call("getItems",E);return new Map(i)}updateItems(E){const i={workspace:this.workspace};return E.insert&&(i.insert=Array.from(E.insert.entries())),E.delete&&(i.delete=Array.from(E.delete.values())),this.channel.call("updateItems",i)}}class A extends R{constructor(E){super(E,void 0);this._onDidChangeItemsExternal=this._register(new D.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(E=>this.onDidChangeGlobalStorage(E)))}onDidChangeGlobalStorage(E){(Array.isArray(E.changed)||Array.isArray(E.deleted))&&this._onDidChangeItemsExternal.fire({changed:E.changed?new Map(E.changed):void 0,deleted:E.deleted?new Set(E.deleted):void 0})}async close(){this.dispose()}}class k extends R{constructor(E,i){super(E,i);this.onDidChangeItemsExternal=D.Event.None}async close(){const E={workspace:this.workspace};return this.channel.call("close",E)}}class P extends L.Disposable{constructor(E,i){super();this.channel=E,this.workspace=i,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new A(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new k(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=P}),define(te[180],ne([0,1,6,2,169,15,70,21,179]),function(K,e,D,L,R,A,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class E extends P.AbstractStorageService{constructor(C,h,v){super();this.mainProcessService=h,this.environmentService=v,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new L.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(C)}createGlobalStorage(){const C=new m.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),h=new k.Storage(C.globalStorage);return this._register(h.onDidChangeStorage(v=>this.emitDidChangeValue(0,v))),h}createWorkspaceStorage(C){const h=new m.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),C);if(h.workspaceStorage){const v=new k.Storage(h.workspaceStorage);return this.workspaceStorageDisposable.value=v.onDidChangeStorage(c=>this.emitDidChangeValue(1,c)),this.workspaceStorageId=C?.id,v}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){(0,R.mark)("code/willInitStorage");try{await D.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}finally{(0,R.mark)("code/didInitStorage")}}getStorage(C){return C===0?this.globalStorage:this.workspaceStorage}getLogDetails(C){return C===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,A.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(P.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(C){const h=this.workspaceStorage,v=h?.items??new Map;h&&(await h.close(),h.dispose()),this.workspaceStorage=this.createWorkspaceStorage(C),await this.workspaceStorage.init();for(const[c,S]of v)this.workspaceStorage.set(c,S)}}e.NativeStorageService=E}),define(te[181],ne([0,1,4,34,5,30]),function(K,e,D,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function k(E){if(D.platform===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}async function P(E,i,C,h,v,c,S,b,g,I){const p=Object.create(null);p["common.machineId"]=S,p.sessionID=(0,A.generateUuid)()+Date.now(),p.commitHash=v,p.version=c,p["common.platformVersion"]=(i||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),p["common.platform"]=(0,D.PlatformToString)(D.platform),p["common.nodePlatform"]=L.platform,p["common.nodeArch"]=h,p["common.product"]=I||"desktop";const o=m(b||[]);o&&(p["common.msftInternal"]=o);let a=0;const t=Date.now();Object.defineProperties(p,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>a++,enumerable:!0}}),D.isLinuxSnap&&(p["common.snap"]="true");const s=k(C);s&&(p["common.platformDetail"]=s);try{const n=await E.readFile(R.URI.file(g));p["common.source"]=n.value.toString().slice(0,30)}catch(n){}return p}e.resolveCommonProperties=P;function m(E){const i=L.env.USERDNSDOMAIN;if(!i)return!1;const C=i.toLowerCase();return E.some(h=>C===h)}e.verifyMicrosoftInternalDomain=m}),define(te[22],ne([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,D.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(te[182],ne([0,1,35,55,33,17,8,4,5,98,19,100,73,13,28,22]),function(K,e,D,L,R,A,k,P,m,E,i,C,h,v,c,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function b(a,t){const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],n=new Map,r=new Map,u=2e4;function l(w,T,O,y){const M=T.substring(w.length+1);return new Promise(async F=>{let q;try{q=await i.Promises.readdir(T,{withFileTypes:!0})}catch($){F();return}if(y.count>=u){y.count+=q.length,y.maxReached=!0,F();return}let x=q.length;if(x===0){F();return}let U=q;y.count+q.length>u&&(y.maxReached=!0,x=u-y.count,U=q.slice(0,x)),y.count+=q.length;for(const $ of U)if($.isDirectory()){if(O.includes($.name)||await l(w,(0,k.join)(T,$.name),O,y),--x==0){F();return}}else{const B=$.name.lastIndexOf(".");if(B>=0){const z=$.name.substring(B+1);z&&n.set(z,(n.get(z)??0)+1)}for(const z of s)z.relativePathPattern?.test(M)!==!1&&z.filePattern.test($.name)&&r.set(z.tag,(r.get(z.tag)??0)+1);if(--x==0){F();return}}})}const f={count:0,maxReached:!1};await l(a,a,t,f);const d=await p(a);return{configFiles:g(r),fileTypes:g(n),fileCount:f.count,maxFilesReached:f.maxReached,launchConfigFiles:d}}e.collectWorkspaceStats=b;function g(a){return[...L.Iterable.map(a.entries(),([t,s])=>({name:t,count:s}))].sort((t,s)=>s.count-t.count)}function I(){const a={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/v.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/v.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(E.virtualMachineHint.value()*100)}%`},t=D.cpus();return t&&t.length>0&&(a.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),a}e.getMachineInfo=I;async function p(a){try{const t=new Map,s=(0,k.join)(a,".vscode","launch.json"),n=await i.Promises.readFile(s),r=[],u=(0,R.parse)(n.toString(),r);if(r.length)return console.log(`Unable to parse ${s}`),[];if((0,R.getNodeType)(u)==="object"&&u.configurations)for(const l of u.configurations){const f=l.type;f&&(t.has(f)?t.set(f,t.get(f)+1):t.set(f,1))}return g(t)}catch(t){return[]}}e.collectLaunchConfigs=p;let o=class{constructor(t,s){this.telemetryService=t,this.productService=s}formatMachineInfo(t){const s=[];return s.push(`OS Version:       ${t.os}`),s.push(`CPUs:             ${t.cpus}`),s.push(`Memory (System):  ${t.memory}`),s.push(`VM:               ${t.vmHint}`),s.join(`
`)}formatEnvironment(t){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const n=D.cpus();return n&&n.length>0&&s.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),s.push(`Memory (System):  ${(D.totalmem()/v.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/v.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||s.push(`Load (avg):       ${D.loadavg().map(r=>Math.round(r)).join(", ")}`),s.push(`VM:               ${Math.round(E.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${t.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(t,s){return Promise.all([(0,C.listProcesses)(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async n=>{let[r,u]=n,l=this.formatProcessList(t,r);return s.forEach(f=>{if((0,h.isRemoteDiagnosticError)(f))l+=`
${f.errorMessage}`,u+=`
${f.errorMessage}`;else if(l+=`

Remote: ${f.hostName}`,f.processes&&(l+=`
${this.formatProcessList(t,f.processes)}`),f.workspaceMetadata){u+=`
|  Remote: ${f.hostName}`;for(const d of Object.keys(f.workspaceMetadata)){const w=f.workspaceMetadata[d];let T=`${w.fileCount} files`;w.maxFilesReached&&(T=`more than ${T}`),u+=`|    Folder (${d}): ${T}`,u+=this.formatWorkspaceStats(w)}}}),{processInfo:l,workspaceInfo:u}})}async getSystemInfo(t,s){const{memory:n,vmHint:r,os:u,cpus:l}=I(),f={os:u,memory:n,cpus:l,vmHint:r,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:s};return P.isWindows||(f.load=`${D.loadavg().map(d=>Math.round(d)).join(", ")}`),P.isLinux&&(f.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(f)}async getDiagnostics(t,s){const n=[];return(0,C.listProcesses)(t.mainPID).then(async r=>(n.push(""),n.push(this.formatEnvironment(t)),n.push(""),n.push(this.formatProcessList(t,r)),t.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.formatWorkspaceMetadata(t))),s.forEach(u=>{if((0,h.isRemoteDiagnosticError)(u))n.push(`
${u.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${u.hostName}`),n.push(this.formatMachineInfo(u.machineInfo)),u.processes&&n.push(this.formatProcessList(t,u.processes)),u.workspaceMetadata)for(const l of Object.keys(u.workspaceMetadata)){const f=u.workspaceMetadata[l];let d=`${f.fileCount} files`;f.maxFilesReached&&(d=`more than ${d}`),n.push(`Folder (${l}): ${d}`),n.push(this.formatWorkspaceStats(f))}}),n.push(""),n.push(""),n.join(`
`)))}formatWorkspaceStats(t){const s=[],n=60;let r=0;const u=(w,T)=>{const O=` ${w}(${T})`;r+O.length>n?(s.push(l),l="|                 ",r=l.length):r+=O.length,l+=O};let l="|      File types:";const f=10;let d=t.fileTypes.length>f?f:t.fileTypes.length;for(let w=0;w<d;w++){const T=t.fileTypes[w];u(T.name,T.count)}if(s.push(l),t.configFiles.length>=0&&(l="|      Conf files:",r=0,t.configFiles.forEach(w=>{u(w.name,w.count)}),s.push(l)),t.launchConfigFiles.length>0){let w="|      Launch Configs:";t.launchConfigFiles.forEach(T=>{w+=T.count>1?` ${T.name}(${T.count})`:` ${T.name}`}),s.push(w)}return s.join(`
`)}expandGPUFeatures(t){const s=Math.max(...Object.keys(t).map(n=>n.length));return Object.keys(t).map(n=>`${n}:  ${" ".repeat(s-n.length)}  ${t[n]}`).join(`
                  `)}formatWorkspaceMetadata(t){const s=[],n=[];return t.windows.forEach(r=>{r.folderURIs.length===0||!!r.remoteAuthority||(s.push(`|  Window (${r.title})`),r.folderURIs.forEach(u=>{const l=m.URI.revive(u);if(l.scheme===A.Schemas.file){const f=l.fsPath;n.push(b(f,["node_modules",".git"]).then(d=>{let w=`${d.fileCount} files`;d.maxFilesReached&&(w=`more than ${w}`),s.push(`|    Folder (${(0,k.basename)(f)}): ${w}`),s.push(this.formatWorkspaceStats(d))}).catch(d=>{s.push(`|      Error: Unable to collect workspace stats for folder ${f} (${d.toString()})`)}))}else s.push(`|    Folder (${l.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(r=>s.join(`
`)).catch(r=>`Unable to collect workspace stats: ${r}`)}formatProcessList(t,s){const n=new Map;t.windows.forEach(u=>n.set(u.pid,u.title));const r=[];return r.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(t.mainPID,n,r,s,0),r.join(`
`)}formatProcessItem(t,s,n,r,u){const l=u===0;let f;l?f=r.pid===t?`${this.productService.applicationName} main`:"remote agent":(f=`${"  ".repeat(u)} ${r.name}`,r.name==="window"&&(f=`${f} (${s.get(r.pid)})`));const d=process.platform==="win32"?r.mem:D.totalmem()*(r.mem/100);n.push(`${r.load.toFixed(0).padStart(5," ")}	${(d/v.ByteSize.MB).toFixed(0).padStart(6," ")}	${r.pid.toFixed(0).padStart(6," ")}	${f}`),Array.isArray(r.children)&&r.children.forEach(w=>this.formatProcessItem(t,s,n,w,u+1))}async reportWorkspaceStats(t){for(const{uri:s}of t.folders){const n=m.URI.revive(s);if(n.scheme!==A.Schemas.file)continue;const r=n.fsPath;try{const u=await b(r,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),u.fileTypes.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:l.name,count:l.count})}),u.launchConfigFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:l.name,count:l.count})}),u.configFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:l.name,count:l.count})})}catch{}}}};o=de([Q(0,S.ITelemetryService),Q(1,c.IProductService)],o),e.DiagnosticsService=o}),define(te[183],ne([0,1,18,6,29,11,3,2,4,5,114,27,31,14,44,22]),function(K,e,D,L,R,A,k,P,m,E,i,C,h,v,c,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=e.INSTALL_ERROR_LOCAL=e.ERROR_UNKNOWN=e.INSTALL_ERROR_VALIDATING=void 0,e.INSTALL_ERROR_VALIDATING="validating",e.ERROR_UNKNOWN="unknown",e.INSTALL_ERROR_LOCAL="local";let b=class extends P.Disposable{constructor(a,t,s){super();this.galleryService=a,this.telemetryService=t,this.logService=s,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new k.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new k.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new k.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new k.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,P.toDisposable)(()=>{this.installingExtensions.forEach(n=>n.cancel()),this.uninstallingExtensions.forEach(n=>n.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async installFromGallery(a,t={}){if(!this.galleryService.isEnabled())throw new Error(i.localize(0,null));try{a=await this.checkAndGetCompatibleVersion(a,!t.installGivenVersion)}catch(n){throw this.logService.error((0,A.getErrorMessage)(n)),I(this.telemetryService,"extensionGallery:install",(0,h.getGalleryExtensionTelemetryData)(a),void 0,n),n}if(!await this.canInstall(a)){const n=new C.ExtensionManagementError("Not supported",e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Cannot install extension as it is not supported.",a.identifier.id,n.message),I(this.telemetryService,"extensionGallery:install",(0,h.getGalleryExtensionTelemetryData)(a),void 0,n),n}const s=await this.galleryService.getManifest(a,R.CancellationToken.None);if(s===null){const n=new C.ExtensionManagementError(`Missing manifest for extension ${a.identifier.id}`,e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",a.identifier.id,n.message),I(this.telemetryService,"extensionGallery:install",(0,h.getGalleryExtensionTelemetryData)(a),void 0,n),n}if(s.version!==a.version){const n=new C.ExtensionManagementError(`Cannot install '${a.identifier.id}' extension because of version mismatch in Marketplace`,e.INSTALL_ERROR_VALIDATING);throw this.logService.error(n.message),I(this.telemetryService,"extensionGallery:install",(0,h.getGalleryExtensionTelemetryData)(a),void 0,n),n}return this.installExtension(s,a,t)}async uninstall(a,t={}){return this.logService.trace("ExtensionManagementService#uninstall",a.identifier.id),this.unininstallExtension(a,t)}async reinstallFromGallery(a){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",a.identifier.id),!this.galleryService.isEnabled())throw new Error(i.localize(1,null));const t=await this.findGalleryExtension(a);if(!t)throw new Error(i.localize(2,null));await this.createUninstallExtensionTask(a,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(t)}getExtensionsReport(){const a=new Date().getTime();return(!this.reportedExtensions||a-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=a),this.reportedExtensions}registerParticipant(a){this.participants.push(a)}async installExtension(a,t,s){if(!E.URI.isUri(t)){let f=this.installingExtensions.get(new h.ExtensionIdentifierWithVersion(t.identifier,t.version).key());if(f)return this.logService.info("Extensions is already requested to install",t.identifier.id),f.waitUntilTaskIsFinished();s={...s,installOnlyNewlyAddedFromExtensionPack:!0}}const n=[],r=[],u=this.createInstallExtensionTask(a,t,s);E.URI.isUri(t)||this.installingExtensions.set(new h.ExtensionIdentifierWithVersion(u.identifier,a.version).key(),u),this._onInstallExtension.fire({identifier:u.identifier,source:t}),this.logService.info("Installing extension:",u.identifier.id),n.push({task:u,manifest:a});let l=!1;try{if(s.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",u.identifier.id);else try{const d=await this.getAllDepsAndPackExtensionsToInstall(u.identifier,a,!!s.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:w,manifest:T}of d)if(l=l||!!T.extensionDependencies?.some(O=>(0,h.areSameExtensions)({id:O},u.identifier)),this.installingExtensions.has(new h.ExtensionIdentifierWithVersion(w.identifier,w.version).key()))this.logService.info("Extension is already requested to install",w.identifier.id);else{const O=this.createInstallExtensionTask(T,w,{...s,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new h.ExtensionIdentifierWithVersion(O.identifier,T.version).key(),O),this._onInstallExtension.fire({identifier:O.identifier,source:w}),this.logService.info("Installing extension:",O.identifier.id),n.push({task:O,manifest:T})}}catch(d){if(E.URI.isUri(u.source))(0,D.isNonEmptyArray)(a.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",u.identifier.id,d.message),(0,D.isNonEmptyArray)(a.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",u.identifier.id,d.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",u.identifier.id),this.logService.error(d),d}const f=n.reduce((d,{task:w,manifest:T})=>(d.set(w.identifier.id.toLowerCase(),{task:w,manifest:T}),d),new Map);for(;f.size;){let d;const w=[...f.values()].filter(({manifest:T})=>!T.extensionDependencies?.some(O=>f.has(O.toLowerCase())));w.length?d=f.size===1?w:w.filter(({task:T})=>!(T===u&&!l)):(this.logService.info("Found extensions with circular dependencies",w.map(({task:T})=>T.identifier.id)),d=[...f.values()]),await this.joinAllSettled(d.map(async({task:T})=>{const O=new Date().getTime();try{const y=await T.run();if(await this.joinAllSettled(this.participants.map(M=>M.postInstall(y,T.source,s,R.CancellationToken.None))),!E.URI.isUri(T.source)&&(I(this.telemetryService,T.operation===2?"extensionGallery:update":"extensionGallery:install",(0,h.getGalleryExtensionTelemetryData)(T.source),new Date().getTime()-O,void 0),m.isWeb&&T.operation===1))try{await this.galleryService.reportStatistic(y.manifest.publisher,y.manifest.name,y.manifest.version,"install")}catch(M){}r.push({local:y,identifier:T.identifier,operation:T.operation,source:T.source})}catch(y){throw E.URI.isUri(T.source)||I(this.telemetryService,T.operation===2?"extensionGallery:update":"extensionGallery:install",(0,h.getGalleryExtensionTelemetryData)(T.source),new Date().getTime()-O,y),this.logService.error("Error while installing the extension:",T.identifier.id),this.logService.error(y),y}finally{f.delete(T.identifier.id.toLowerCase())}}))}return r.forEach(({identifier:d})=>this.logService.info("Extension installed successfully:",d.id)),this._onDidInstallExtensions.fire(r),r.filter(({identifier:d})=>(0,h.areSameExtensions)(d,u.identifier))[0].local}catch(f){if(n.forEach(({task:d})=>d.cancel()),r.length)try{const d=await Promise.allSettled(r.map(({local:w})=>this.createUninstallExtensionTask(w,{versionOnly:!0}).run()));for(let w=0;w<d.length;w++){const T=d[w],{identifier:O}=r[w];T.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",O.id):this.logService.warn("Rollback: Error while uninstalling extension",O.id,(0,A.getErrorMessage)(T.reason))}}catch(d){this.logService.warn("Error while rolling back extensions",(0,A.getErrorMessage)(d),r.map(({identifier:w})=>w.id))}throw this.logService.error("Failed to install extension:",u.identifier.id,(0,A.getErrorMessage)(f)),this._onDidInstallExtensions.fire(n.map(({task:d})=>({identifier:d.identifier,operation:1,source:d.source}))),f instanceof Error&&(f.name=f&&f.code?f.code:e.ERROR_UNKNOWN),f}finally{for(const{task:f,manifest:d}of n)if(!E.URI.isUri(f.source)){const w=new h.ExtensionIdentifierWithVersion(f.identifier,d.version).key();this.installingExtensions.delete(w)||this.logService.warn("Installation task is not found in the cache",w)}}}async joinAllSettled(a){const t=[],s=[],n=await Promise.allSettled(a);for(const r of n)r.status==="fulfilled"?t.push(r.value):s.push(r.reason);if(s.length)throw g(s);return t}async getAllDepsAndPackExtensionsToInstall(a,t,s){if(!this.galleryService.isEnabled())return[];let n=await this.getInstalled();const r=[a,...n.map(f=>f.identifier)],u=[],l=async(f,d)=>{const w=d.extensionDependencies||[],T=[...w];if(d.extensionPack){const O=s?n.find(y=>(0,h.areSameExtensions)(y.identifier,f)):void 0;for(const y of d.extensionPack)O&&O.manifest.extensionPack&&O.manifest.extensionPack.some(M=>(0,h.areSameExtensions)({id:M},{id:y}))||T.every(M=>!(0,h.areSameExtensions)({id:M},{id:y}))&&T.push(y)}if(T.length){const O=[...r,...u.map(M=>M.gallery.identifier)],y=T.filter(M=>O.every(F=>!(0,h.areSameExtensions)(F,{id:M})));if(y.length){const M=await this.galleryService.query({names:y,pageSize:T.length},R.CancellationToken.None);for(const F of M.firstPage){if(O.find($=>(0,h.areSameExtensions)($,F.identifier)))continue;if(!w.some($=>(0,h.areSameExtensions)({id:$},F.identifier))&&!await this.canInstall(F)){this.logService.info("Skipping the packed extension as it cannot be installed",F.identifier.id);continue}const x=await this.checkAndGetCompatibleVersion(F,!0),U=await this.galleryService.getManifest(x,R.CancellationToken.None);if(U===null)throw new C.ExtensionManagementError(`Missing manifest for extension ${x.identifier.id}`,e.INSTALL_ERROR_VALIDATING);u.push({gallery:x,manifest:U}),await l(x.identifier,U)}}}};return await l(a,t),n=await this.getInstalled(),u.filter(f=>!n.some(d=>(0,h.areSameExtensions)(d.identifier,f.gallery.identifier)))}async checkAndGetCompatibleVersion(a,t){if(await this.isMalicious(a))throw new C.ExtensionManagementError(i.localize(3,null,a.identifier.id),C.INSTALL_ERROR_MALICIOUS);let s=null;if(await this.galleryService.isExtensionCompatible(a,C.CURRENT_TARGET_PLATFORM)&&(s=a),!s&&t&&(s=await this.galleryService.getCompatibleExtension(a,C.CURRENT_TARGET_PLATFORM)),!s)throw new C.ExtensionManagementError(i.localize(4,null,a.identifier.id,c.default.version),C.INSTALL_ERROR_INCOMPATIBLE);return s}async isMalicious(a){const t=await this.getExtensionsReport();return(0,h.getMaliciousExtensionsSet)(t).has(a.identifier.id)}async unininstallExtension(a,t){const s=this.uninstallingExtensions.get(a.identifier.id.toLowerCase());if(s)return this.logService.info("Extensions is already requested to uninstall",a.identifier.id),s.waitUntilTaskIsFinished();const n=(f,d)=>{const w=this.createUninstallExtensionTask(f,d);return this.uninstallingExtensions.set(w.extension.identifier.id.toLowerCase(),w),this.logService.info("Uninstalling extension:",f.identifier.id),this._onUninstallExtension.fire(f.identifier),w},r=(f,d)=>{d?this.logService.error("Failed to uninstall extension:",f.identifier.id,d.message):this.logService.info("Successfully uninstalled extension:",f.identifier.id),I(this.telemetryService,"extensionGallery:uninstall",(0,h.getLocalExtensionTelemetryData)(f),void 0,d),this._onDidUninstallExtension.fire({identifier:f.identifier,error:d?.code})},u=[],l=[];try{u.push(n(a,{}));const f=await this.getInstalled(1);if(t.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",a.identifier.id);else{const d=this.getAllPackExtensionsToUninstall(a,f);for(const w of d)this.uninstallingExtensions.has(w.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",w.identifier.id):u.push(n(w,{}))}t.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",a.identifier.id):this.checkForDependents(u.map(d=>d.extension),f,a),await this.joinAllSettled(u.map(async d=>{try{if(await d.run(),await this.joinAllSettled(this.participants.map(w=>w.postUninstall(d.extension,t,R.CancellationToken.None))),d.extension.identifier.uuid)try{await this.galleryService.reportStatistic(d.extension.manifest.publisher,d.extension.manifest.name,d.extension.manifest.version,"uninstall")}catch(w){}r(d.extension)}catch(w){const T=w instanceof C.ExtensionManagementError?w:new C.ExtensionManagementError((0,A.getErrorMessage)(w),e.ERROR_UNKNOWN);throw r(d.extension,T),T}finally{l.push(d)}}))}catch(f){const d=f instanceof C.ExtensionManagementError?f:new C.ExtensionManagementError((0,A.getErrorMessage)(f),e.ERROR_UNKNOWN);for(const w of u){try{w.cancel()}catch(T){}l.includes(w)||r(w.extension,d)}throw d}finally{for(const f of u)this.uninstallingExtensions.delete(f.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",f.extension.identifier.id)}}checkForDependents(a,t,s){for(const n of a){const r=this.getDependents(n,t);if(r.length){const u=r.filter(l=>!a.some(f=>(0,h.areSameExtensions)(f.identifier,l.identifier)));if(u.length)throw new Error(this.getDependentsErrorMessage(n,u,s))}}}getDependentsErrorMessage(a,t,s){return s===a?t.length===1?i.localize(5,null,s.manifest.displayName||s.manifest.name,t[0].manifest.displayName||t[0].manifest.name):t.length===2?i.localize(6,null,s.manifest.displayName||s.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):i.localize(7,null,s.manifest.displayName||s.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):t.length===1?i.localize(8,null,s.manifest.displayName||s.manifest.name,a.manifest.displayName||a.manifest.name,t[0].manifest.displayName||t[0].manifest.name):t.length===2?i.localize(9,null,s.manifest.displayName||s.manifest.name,a.manifest.displayName||a.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):i.localize(10,null,s.manifest.displayName||s.manifest.name,a.manifest.displayName||a.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name)}getAllPackExtensionsToUninstall(a,t,s=[]){if(s.indexOf(a)!==-1)return[];s.push(a);const n=a.manifest.extensionPack?a.manifest.extensionPack:[];if(n.length){const r=t.filter(l=>!l.isBuiltin&&n.some(f=>(0,h.areSameExtensions)({id:f},l.identifier))),u=[];for(const l of r)u.push(...this.getAllPackExtensionsToUninstall(l,t,s));return[...r,...u]}return[]}getDependents(a,t){return t.filter(s=>s.manifest.extensionDependencies&&s.manifest.extensionDependencies.some(n=>(0,h.areSameExtensions)({id:n},a.identifier)))}async findGalleryExtension(a){if(a.identifier.uuid){const t=await this.findGalleryExtensionById(a.identifier.uuid);return t||this.findGalleryExtensionByName(a.identifier.id)}return this.findGalleryExtensionByName(a.identifier.id)}async findGalleryExtensionById(a){return(await this.galleryService.query({ids:[a],pageSize:1},R.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(a){return(await this.galleryService.query({names:[a],pageSize:1},R.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const a=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${a.length} reported extensions from service`),a}catch(a){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};b=de([Q(0,C.IExtensionGalleryService),Q(1,S.ITelemetryService),Q(2,v.ILogService)],b),e.AbstractExtensionManagementService=b;function g(o){const a=Array.isArray(o)?o:[o];return a.length===1?a[0]instanceof Error?a[0]:new Error(a[0]):a.reduce((t,s)=>new Error(`${t.message}${t.message?",":""}${s instanceof Error?s.message:s}`),new Error(""))}e.joinErrors=g;function I(o,a,t,s,n){const r=n?n instanceof C.ExtensionManagementError?n.code:e.ERROR_UNKNOWN:void 0;o.publicLogError(a,{...t,success:!n,duration:s,errorcode:r})}e.reportTelemetry=I;class p{constructor(){this.barrier=new L.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,L.createCancelablePromise)(a=>this.doRun(a))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,L.createCancelablePromise)(a=>new Promise((t,s)=>{const n=a.onCancellationRequested(()=>{n.dispose(),s((0,A.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=p}),define(te[184],ne([0,1,18,6,63,3,8,4,34,5,116,12,27,177,75,13,14,59,28,42,21,22]),function(K,e,D,L,R,A,k,P,m,E,i,C,h,v,c,S,b,g,I,p,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const t="extensionTips/promptedExecutableTips",s="extensionTips/lastPromptedMediumImpExeTime";let n=class extends v.ExtensionTipsService{constructor(u,l,f,d,w,T,O,y,M,F){super(O,y,M,F);this.environmentService=u,this.telemetryService=l,this.extensionManagementService=f,this.storageService=d,this.nativeHostService=w,this.extensionRecommendationNotificationService=T,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,y.exeBasedExtensionTips&&(0,R.forEach)(y.exeBasedExtensionTips,({key:q,value:x})=>{const U=[],$=[],B=[];(0,R.forEach)(x.recommendations,({key:z,value:j})=>{j.important?x.important?U.push({extensionId:z,extensionName:j.name,isExtensionPack:!!j.isExtensionPack}):$.push({extensionId:z,extensionName:j.name,isExtensionPack:!!j.isExtensionPack}):B.push({extensionId:z,extensionName:j.name,isExtensionPack:!!j.isExtensionPack})}),U.length&&this.highImportanceExecutableTips.set(q,{exeFriendlyName:x.friendlyName,windowsPath:x.windowsPath,recommendations:U}),$.length&&this.mediumImportanceExecutableTips.set(q,{exeFriendlyName:x.friendlyName,windowsPath:x.windowsPath,recommendations:$}),B.length&&this.allOtherExecutableTips.set(q,{exeFriendlyName:x.friendlyName,windowsPath:x.windowsPath,recommendations:B})}),(0,L.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const u=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...u,...l]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const u=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),f=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(u,f),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(l,f)}groupImportantTipsByExe(u,l){const f=new Map;u.forEach(y=>f.set(y.extensionId.toLowerCase(),y));const{installed:d,uninstalled:w}=this.groupByInstalled([...f.keys()],l);for(const y of d){const M=f.get(y);M&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:y,exeName:M.exeName})}for(const y of w){const M=f.get(y);M&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:y,exeName:M.exeName})}const T=this.getPromptedExecutableTips(),O=new Map;for(const y of w){const M=f.get(y);if(M&&(!T[M.exeName]||!T[M.exeName].includes(M.extensionId))){let F=O.get(M.exeName);F||(F=[],O.set(M.exeName,F)),F.push(M)}}return O}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[u,l]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(l).then(f=>{switch(f){case"reacted":this.addToRecommendedExecutables(l[0].exeName,l);break;case"ignored":this.highImportanceTipsByExe.delete(u);break;case"incompatibleWindow":const d=A.Event.once(A.Event.latch(A.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(d(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const w=this._register((0,L.disposableTimeout)(()=>{w.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const u=this.getLastPromptedMediumExeTime(),l=Date.now()-u,f=7*24*60*60*1e3;if(l<f){const T=this._register((0,L.disposableTimeout)(()=>{T.dispose(),this.promptMediumImportanceExeBasedTip()},f-l));return}const[d,w]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(w).then(T=>{switch(T){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(d),this.addToRecommendedExecutables(w[0].exeName,w);const O=this._register((0,L.disposableTimeout)(()=>{O.dispose(),this.promptMediumImportanceExeBasedTip()},f));break;case"ignored":this.mediumImportanceTipsByExe.delete(d),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const y=A.Event.once(A.Event.latch(A.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(y(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const M=this._register((0,L.disposableTimeout)(()=>{M.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}promptExeRecommendations(u){const l=u.map(({extensionId:d})=>d.toLowerCase()),f=(0,i.localize)(0,null,u[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(l,f,`@exe:"${u[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let u=this.storageService.getNumber(s,0);return u||(u=Date.now(),this.updateLastPromptedMediumExeTime(u)),u}updateLastPromptedMediumExeTime(u){this.storageService.store(s,u,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(t,0,"{}"))}addToRecommendedExecutables(u,l){const f=this.getPromptedExecutableTips();f[u]=l.map(({extensionId:d})=>d.toLowerCase()),this.storageService.store(t,JSON.stringify(f),0,0)}groupByInstalled(u,l){const f=[],d=[],w=l.reduce((T,O)=>(T.add(O.identifier.id.toLowerCase()),T),new Set);return u.forEach(T=>{w.has(T.toLowerCase())?f.push(T):d.push(T)}),{installed:f,uninstalled:d}}async getValidExecutableBasedExtensionTips(u){const l=[],f=new Map;for(const d of u.keys()){const w=u.get(d);if(!w||!(0,D.isNonEmptyArray)(w.recommendations))continue;const T=[];P.isWindows?w.windowsPath&&T.push(w.windowsPath.replace("%USERPROFILE%",m.env.USERPROFILE).replace("%ProgramFiles(x86)%",m.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",m.env.ProgramFiles).replace("%APPDATA%",m.env.APPDATA).replace("%WINDIR%",m.env.WINDIR)):(T.push((0,k.join)("/usr/local/bin",d)),T.push((0,k.join)("/usr/bin",d)),T.push((0,k.join)(this.environmentService.userHome.fsPath,d)));for(const O of T){let y=f.get(O);if(y===void 0&&(y=await this.fileService.exists(E.URI.file(O)),f.set(O,y)),y)for(const{extensionId:M,extensionName:F,isExtensionPack:q}of w.recommendations)l.push({extensionId:M,extensionName:F,isExtensionPack:q,exeName:d,exeFriendlyName:w.exeFriendlyName,windowsPath:w.windowsPath})}}return l}};n=de([Q(0,C.INativeEnvironmentService),Q(1,a.ITelemetryService),Q(2,h.IExtensionManagementService),Q(3,o.IStorageService),Q(4,g.INativeHostService),Q(5,c.IExtensionRecommendationNotificationService),Q(6,S.IFileService),Q(7,I.IProductService),Q(8,p.IRequestService),Q(9,b.ILogService)],n),e.ExtensionTipsService=n}),define(te[82],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class D{constructor(A){this.appender=A}listen(A,k){throw new Error(`Event not found: ${k}`)}call(A,k,{eventName:P,data:m}){return this.appender.log(P,m),Promise.resolve(null)}}e.TelemetryAppenderChannel=D;class L{constructor(A){this.channel=A}log(A,k){return this.channel.call("log",{eventName:A,data:k}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(te[83],ne([0,1,2,26,24,126,20,38,44,32]),function(K,e,D,L,R,A,k,P,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let i=class{constructor(v,c){this._configurationService=c,this._experimentProperties={},this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appender=v.appender,this._commonProperties=v.commonProperties||Promise.resolve({}),this._piiPaths=v.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!v.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let S of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,R.escapeRegExpCharacters)(S),"gi"));this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(S=>{const b=/^[a-f0-9]+$/i.test(S["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!b})})}setExperimentProperty(v,c){this._experimentProperties[v]=c}setEnabled(v){this._enabled=v}_updateUserOptIn(){const v=this._configurationService?.getValue(C);this._userOptIn=v?v.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const v=await this._commonProperties;let c=v.sessionID,S=v["common.instanceId"],b=v["common.machineId"],g=v["common.firstSessionDate"],I=v["common.msftInternal"];return{sessionId:c,instanceId:S,machineId:b,firstSessionDate:g,msftInternal:I}}dispose(){this._disposables.dispose()}publicLog(v,c,S){return this.isOptedIn?this._commonProperties.then(b=>{c=(0,L.mixin)(c,b),c=(0,L.mixin)(c,this._experimentProperties),c=(0,L.cloneAndChange)(c,g=>{if(typeof g=="string")return this._cleanupInfo(g,S)}),this._appender.log(v,c)},b=>{console.error(b)}):Promise.resolve(void 0)}publicLog2(v,c,S){return this.publicLog(v,c,S)}publicLogError(v,c){return this.sendErrorTelemetry?this.publicLog(v,c,!0):Promise.resolve(void 0)}publicLogError2(v,c){return this.publicLogError(v,c)}_cleanupInfo(v,c){let S=v;if(c){const b=[];for(let o of this._cleanupPatterns)for(;;){const a=o.exec(v);if(!a)break;b.push([a.index,o.lastIndex])}const g=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,I=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let p=0;for(S="";;){const o=I.exec(v);if(!o)break;!g.test(o[0])&&b.every(([a,t])=>o.index<a||o.index>=t)&&(S+=v.substring(p,o.index)+"<REDACTED: user-file-path>",p=I.lastIndex)}p<v.length&&(S+=v.substr(p))}for(let b of this._cleanupPatterns)S=S.replace(b,"");return S}};i.IDLE_START_EVENT_NAME="UserIdleStart",i.IDLE_STOP_EVENT_NAME="UserIdleStop",i=de([Q(1,k.IConfigurationService)],i),e.TelemetryService=i;const C="telemetry";E.Registry.as(P.Extensions.Configuration).registerConfiguration({id:C,order:110,type:"object",title:(0,A.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,A.localize)(2,null,m.default.nameLong,m.default.privacyStatementUrl):(0,A.localize)(1,null,m.default.nameLong),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[46],ne([0,1,6,26,16,20]),function(K,e,D,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.TelemetryLevel=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(b,g){return Promise.resolve(void 0)}publicLog2(b,g){return this.publicLog(b,g)}publicLogError(b,g){return Promise.resolve(void 0)}publicLogError2(b,g){return this.publicLogError(b,g)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class k{async publicLog(g,I,p){}async publicLogError(g,I,p){}}e.NullEndpointTelemetryService=k;function P(...b){return{log:(g,I)=>b.forEach(p=>p.log(g,I)),flush:()=>D.Promises.settled(b.map(g=>g.flush()))}}e.combinedAppender=P,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function m(b,g){return g.onDidChangeConfiguration(I=>{I.source!==6&&b.publicLog2("updateConfiguration",{configurationSource:(0,A.ConfigurationTargetToString)(I.source),configurationKeys:c(I.sourceConfig)})})}e.configurationTelemetry=m;var E;(function(b){b[b.NONE=0]="NONE",b[b.LOG=1]="LOG",b[b.USER=2]="USER"})(E=e.TelemetryLevel||(e.TelemetryLevel={}));function i(b,g){return g.disableTelemetry||!b.enableTelemetry?0:g.isBuilt?2:1}e.getTelemetryLevel=i;function C(b){const g=Object.create(null),I=Object.create(null),p=Object.create(null);v(b,p);for(let o in p){o=o.length>150?o.substr(o.length-149):o;const a=p[o];typeof a=="number"?I[o]=a:typeof a=="boolean"?I[o]=a?1:0:typeof a=="string"?g[o]=a.substring(0,1023):typeof a!="undefined"&&a!==null&&(g[o]=a)}return{properties:g,measurements:I}}e.validateTelemetryData=C;function h(b){if(!b)return"none";let g="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(p=>{b.indexOf(`${p}+`)===0&&(g=p)}),g}e.cleanRemoteAuthority=h;function v(b,g,I=0,p){if(!!b)for(let o of Object.getOwnPropertyNames(b)){const a=b[o],t=p?p+o:o;Array.isArray(a)?g[t]=(0,L.safeStringify)(a):a instanceof Date?g[t]=a.toISOString():(0,R.isObject)(a)?I<2?v(a,g,I+1,t+"."):g[t]=(0,L.safeStringify)(a):g[t]=a}}function c(b){if(!b)return[];const g=[];return S(g,"",b),g}function S(b,g,I){I&&typeof I=="object"&&!Array.isArray(I)?Object.keys(I).forEach(p=>S(b,g?`${g}.${p}`:p,I[p])):b.push(g)}}),define(te[185],ne([0,1,18,29,11,26,4,5,20,12,27,31,72,13,7,14,28,42,45,21,22,46]),function(K,e,D,L,R,A,k,P,m,E,i,C,h,v,c,S,b,g,I,p,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var t;(function(H){H[H.None=0]="None",H[H.IncludeVersions=1]="IncludeVersions",H[H.IncludeFiles=2]="IncludeFiles",H[H.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",H[H.IncludeSharedAccounts=8]="IncludeSharedAccounts",H[H.IncludeVersionProperties=16]="IncludeVersionProperties",H[H.ExcludeNonValidated=32]="ExcludeNonValidated",H[H.IncludeInstallationTargets=64]="IncludeInstallationTargets",H[H.IncludeAssetUri=128]="IncludeAssetUri",H[H.IncludeStatistics=256]="IncludeStatistics",H[H.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",H[H.Unpublished=4096]="Unpublished"})(t||(t={}));function s(...H){return String(H.reduce((W,Z)=>W|Z,0))}var n;(function(H){H[H.Tag=1]="Tag",H[H.ExtensionId=4]="ExtensionId",H[H.Category=5]="Category",H[H.ExtensionName=7]="ExtensionName",H[H.Target=8]="Target",H[H.Featured=9]="Featured",H[H.SearchText=10]="SearchText",H[H.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},u={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},f={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class d{constructor(W=f){this.state=W}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(W,Z=this.state.pageSize){return new d({...this.state,pageNumber:W,pageSize:Z})}withFilter(W,...Z){const X=[...this.state.criteria,...Z.length?Z.map(re=>({filterType:W,value:re})):[{filterType:W}]];return new d({...this.state,criteria:X})}withSortBy(W){return new d({...this.state,sortBy:W})}withSortOrder(W){return new d({...this.state,sortOrder:W})}withFlags(...W){return new d({...this.state,flags:W.reduce((Z,X)=>Z|X,0)})}withAssetTypes(...W){return new d({...this.state,assetTypes:W})}get raw(){const{criteria:W,pageNumber:Z,pageSize:X,sortBy:re,sortOrder:oe,flags:ue,assetTypes:le}=this.state;return{filters:[{criteria:W,pageNumber:Z,pageSize:X,sortBy:re,sortOrder:oe}],assetTypes:le,flags:ue}}get searchText(){const W=this.state.criteria.filter(Z=>Z.filterType===n.SearchText)[0];return W&&W.value?W.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(W=>String(W.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function w(H,W){const Z=(H||[]).filter(X=>X.statisticName===W)[0];return Z?Z.value:0}function T(H){const W="Microsoft.VisualStudio.Code.Translation.";return H.files.filter(X=>X.assetType.indexOf(W)===0).reduce((X,re)=>{const oe=F(H,re.assetType);return oe&&X.push([re.assetType.substring(W.length),oe]),X},[])}function O(H){if(H.properties){const W=H.properties.filter(re=>re.key===r.Repository),Z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),X=W.filter(re=>Z.test(re.value))[0];return X?{uri:X.value,fallbackUri:X.value}:null}return F(H,r.Repository)}function y(H){return{uri:`${H.fallbackAssetUri}/${r.VSIX}?redirect=true${H.targetPlatform?`&targetPlatform=${H.targetPlatform}`:""}`,fallbackUri:`${H.fallbackAssetUri}/${r.VSIX}${H.targetPlatform?`?targetPlatform=${H.targetPlatform}`:""}`}}function M(H){const W=F(H,r.Icon);if(W)return W;const Z=i.DefaultIconPath;return{uri:Z,fallbackUri:Z}}function F(H,W){return H.files.filter(X=>X.assetType===W)[0]?{uri:`${H.assetUri}/${W}`,fallbackUri:`${H.fallbackAssetUri}/${W}`}:null}function q(H,W){const Z=H.properties?H.properties.filter(re=>re.key===W):[],X=Z.length>0&&Z[0].value;return X?X.split(",").map(re=>(0,C.adoptToGalleryExtensionId)(re)):[]}function x(H){const W=H.properties?H.properties.filter(Z=>Z.key===u.Engine):[];return W.length>0&&W[0].value||""}function U(H){const W=H.properties?H.properties.filter(X=>X.key===u.LocalizedLanguages):[],Z=W.length>0&&W[0].value||"";return Z?Z.split(","):[]}function $(H){return H.indexOf("preview")!==-1}function B(H){return H.targetPlatform?(0,i.toTargetPlatform)(H.targetPlatform):"undefined"}function z(H){const W=(0,D.distinct)(H.versions.map(B)),Z=!!H.tags?.includes(i.WEB_EXTENSION_TAG),X=W.indexOf("web");return Z?X===-1&&W.push("web"):X!==-1&&W.splice(X,1),W}function j(H,W){return W==="web"&&!H.includes("web")}function N(H,W,Z){if(j(W,Z))return!1;if(H==="undefined"||H==="universal")return!0;if(H==="unknown")return!1;if(H===Z)return!0;switch(Z){case"win32-x64":return H==="win32-ia32";case"win32-arm64":return H==="win32-ia32";default:return!1}}function G(H,W,Z,X){const re=z(H);let oe=H.versions[0];return oe=H.versions.find(ue=>ue.version===oe.version&&N(B(ue),re,i.CURRENT_TARGET_PLATFORM))||oe,_(H,oe,re,W,Z,X)}function _(H,W,Z,X,re,oe){const ue={manifest:F(W,r.Manifest),readme:F(W,r.Details),changelog:F(W,r.Changelog),license:F(W,r.License),repository:O(W),download:y(W),icon:M(W),coreTranslations:T(W)};return{identifier:{id:(0,C.getGalleryExtensionId)(H.publisher.publisherName,H.extensionName),uuid:H.extensionId},name:H.extensionName,version:W.version,displayName:H.displayName,publisherId:H.publisher.publisherId,publisher:H.publisher.publisherName,publisherDisplayName:H.publisher.displayName,description:H.shortDescription||"",installCount:w(H.statistics,"install"),rating:w(H.statistics,"averagerating"),ratingCount:w(H.statistics,"ratingcount"),categories:H.categories||[],tags:H.tags||[],releaseDate:Date.parse(H.releaseDate),lastUpdated:Date.parse(H.lastUpdated),allTargetPlatforms:Z,assets:ue,properties:{dependencies:q(W,u.Dependency),extensionPack:q(W,u.ExtensionPack),engine:x(W),localizedLanguages:U(W),targetPlatform:B(W)},preview:$(H.flags),telemetryData:{index:(re.pageNumber-1)*re.pageSize+X,querySource:oe}}}let J=class{constructor(W,Z,X,re,oe,ue,le,Se){this.requestService=W,this.logService=Z,this.environmentService=X,this.telemetryService=re,this.fileService=oe,this.productService=ue,this.configurationService=le;const Ee=ue.extensionsGallery;this.extensionsGalleryUrl=Ee&&Ee.serviceUrl,this.extensionsControlUrl=Ee&&Ee.controlUrl,this.commonHeadersPromise=Y(ue.version,ue,this.environmentService,this.configurationService,this.fileService,Se)}api(W=""){return`${this.extensionsGalleryUrl}${W}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(W,Z){const X=[];let re=new d().withFlags(t.IncludeAssetUri,t.IncludeStatistics,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,W.length).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExtensionName,...W.map(({id:ue})=>ue.toLowerCase()));W.every(ue=>!ue.version)&&(re=re.withFlags(t.IncludeAssetUri,t.IncludeStatistics,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties,t.IncludeLatestVersionOnly));const{galleryExtensions:oe}=await this.queryGallery(re,L.CancellationToken.None);for(let ue=0;ue<oe.length;ue++){const le=oe[ue];if(!le.versions.length)continue;const Se=(0,C.getGalleryExtensionId)(le.publisher.publisherName,le.extensionName),Ee=W.find(be=>(0,C.areSameExtensions)(be,{id:Se}))?.version;if(Ee){const be=le.versions.find(Le=>Le.version===Ee);be&&X.push(_(le,be,z(le),ue,re))}else X.push(G(le,ue,re))}return X}async getCompatibleExtension(W,Z){const X=(0,i.isIExtensionIdentifier)(W)?null:W;if(X){if(j(X.allTargetPlatforms,Z))return null;if(await this.isExtensionCompatible(X,Z))return X}const{id:re,uuid:oe}=X?X.identifier:W;let ue=new d().withFlags(t.IncludeAssetUri,t.IncludeStatistics,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1).withFilter(n.Target,"Microsoft.VisualStudio.Code");oe?ue=ue.withFilter(n.ExtensionId,oe):ue=ue.withFilter(n.ExtensionName,re);const{galleryExtensions:le}=await this.queryGallery(ue,L.CancellationToken.None),[Se]=le;if(!Se||!Se.versions.length)return null;const Ee=z(Se);if(j(Ee,Z))return null;for(let be of Se.versions){if(!x(be)){const Le=await this.getEngine(be);be={...be,properties:[...be.properties||[],{key:u.Engine,value:Le}]}}if(await this.isRawExtensionVersionCompatible(be,Ee,Z))return _(Se,be,Ee,0,ue)}return null}async isExtensionCompatible(W,Z){if(!N(W.properties.targetPlatform,W.allTargetPlatforms,Z))return!1;let X=W.properties.engine;if(!X){const re=await this.getManifest(W,L.CancellationToken.None);if(!re)throw new Error("Manifest was not found");X=re.engines.vscode}return(0,h.isEngineValid)(X,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(W,Z,X){if(!N(B(W),Z,X))return!1;const re=await this.getEngine(W);return(0,h.isEngineValid)(re,this.productService.version,this.productService.date)}async query(W,Z){const X=L.CancellationToken.isCancellationToken(W)?{}:W,re=L.CancellationToken.isCancellationToken(W)?W:Z;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let oe=X.text||"";const ue=(0,A.getOrDefault)(X,De=>De.pageSize,50);let le=new d().withFlags(t.IncludeLatestVersionOnly,t.IncludeAssetUri,t.IncludeStatistics,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,ue).withFilter(n.Target,"Microsoft.VisualStudio.Code");oe?(oe=oe.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(De,Fe,Re)=>(le=le.withFilter(n.Category,Re||Fe),"")),oe=oe.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(De,Fe,Re)=>(le=le.withFilter(n.Tag,Re||Fe),"")),oe=oe.replace(/\bfeatured(\s+|\b|$)/g,()=>(le=le.withFilter(n.Featured),"")),oe=oe.trim(),oe&&(oe=oe.length<200?oe:oe.substring(0,200),le=le.withFilter(n.SearchText,oe)),le=le.withSortBy(0)):X.ids?le=le.withFilter(n.ExtensionId,...X.ids):X.names?le=le.withFilter(n.ExtensionName,...X.names):le=le.withSortBy(4),typeof X.sortBy=="number"&&(le=le.withSortBy(X.sortBy)),typeof X.sortOrder=="number"&&(le=le.withSortOrder(X.sortOrder));const{galleryExtensions:Se,total:Ee}=await this.queryGallery(le,re),be=Se.map((De,Fe)=>G(De,Fe,le,X.source)),Le=async(De,Fe)=>{if(Fe.isCancellationRequested)throw(0,R.canceled)();const Re=le.withPage(De+1),{galleryExtensions:Ae}=await this.queryGallery(Re,Fe);return Ae.map((We,Be)=>G(We,Be,Re,X.source))};return{firstPage:be,total:Ee,pageSize:le.pageSize,getPage:Le}}async queryGallery(W,Z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");W=W.withFlags(W.flags,t.ExcludeNonValidated).withFilter(n.ExcludeWithFlags,s(t.Unpublished));const X=await this.commonHeadersPromise,re=JSON.stringify(W.raw),oe={...X,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(re.length)},ue=new Date().getTime();let le,Se,Ee=0;try{if(le=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:re,headers:oe},Z),le.res.statusCode&&le.res.statusCode>=400&&le.res.statusCode<500)return{galleryExtensions:[],total:Ee};const be=await(0,g.asJson)(le);if(be){const Le=be.results[0],De=Le.extensions,Fe=Le.resultMetadata&&Le.resultMetadata.filter(Re=>Re.metadataType==="ResultCount")[0];return Ee=Fe&&Fe.metadataItems.filter(Re=>Re.name==="TotalCount")[0].count||0,{galleryExtensions:De,total:Ee}}return{galleryExtensions:[],total:Ee}}catch(be){throw Se=be,be}finally{this.telemetryService.publicLog2("galleryService:query",{...W.telemetryData,requestBodySize:String(re.length),duration:new Date().getTime()-ue,success:!!le&&(0,g.isSuccess)(le),responseBodySize:le?.res.headers["Content-Length"],statusCode:le?String(le.res.statusCode):void 0,errorCode:Se?(0,R.isPromiseCanceledError)(Se)?"canceled":(0,R.getErrorMessage)(Se).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Ee)})}}async reportStatistic(W,Z,X,re){if(!this.isEnabled())return;const oe=k.isWeb?this.api(`/itemName/${W}.${Z}/version/${X}/statType/${re==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${W}/extensions/${Z}/${X}/stats?statType=${re}`),ue=k.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Se={...await this.commonHeadersPromise,Accept:ue};try{await this.requestService.request({type:"POST",url:oe,headers:Se},L.CancellationToken.None)}catch(Ee){}}async download(W,Z,X){this.logService.trace("ExtensionGalleryService#download",W.identifier.id);const re=(0,C.getGalleryExtensionTelemetryData)(W),oe=new Date().getTime(),ue=be=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...re,duration:be}),le=X===1?"install":X===2?"update":"",Se=le?{uri:`${W.assets.download.uri}${P.URI.parse(W.assets.download.uri).query?"&":"?"}${le}=true`,fallbackUri:`${W.assets.download.fallbackUri}${P.URI.parse(W.assets.download.fallbackUri).query?"&":"?"}${le}=true`}:W.assets.download,Ee=await this.getAsset(Se);await this.fileService.writeFile(Z,Ee.stream),ue(new Date().getTime()-oe)}async getReadme(W,Z){if(W.assets.readme){const X=await this.getAsset(W.assets.readme,{},Z);return await(0,g.asText)(X)||""}return""}async getManifest(W,Z){if(W.assets.manifest){const X=await this.getAsset(W.assets.manifest,{},Z),re=await(0,g.asText)(X);return re?JSON.parse(re):null}return null}async getManifestFromRawExtensionVersion(W,Z){const X=F(W,r.Manifest);if(!X)throw new Error("Manifest was not found");const re={"Accept-Encoding":"gzip"},oe=await this.getAsset(X,{headers:re});return await(0,g.asJson)(oe)}async getCoreTranslation(W,Z){const X=W.assets.coreTranslations.filter(re=>re[0]===Z.toUpperCase())[0];if(X){const re=await this.getAsset(X[1]),oe=await(0,g.asText)(re);return oe?JSON.parse(oe):null}return null}async getChangelog(W,Z){if(W.assets.changelog){const X=await this.getAsset(W.assets.changelog,{},Z);return await(0,g.asText)(X)||""}return""}async getAllCompatibleVersions(W,Z){let X=new d().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1).withFilter(n.Target,"Microsoft.VisualStudio.Code");W.identifier.uuid?X=X.withFilter(n.ExtensionId,W.identifier.uuid):X=X.withFilter(n.ExtensionName,W.identifier.id);const{galleryExtensions:re}=await this.queryGallery(X,L.CancellationToken.None);if(!re.length)return[];const oe=z(re[0]);if(j(oe,Z))return[];const ue=[];for(const le of re[0].versions)try{await this.isRawExtensionVersionCompatible(le,oe,Z)&&ue.push({version:le.version,date:le.lastUpdated})}catch(Se){}return ue}async getAsset(W,Z={},X=L.CancellationToken.None){const re=await this.commonHeadersPromise,oe={type:"GET"},ue={...re,...Z.headers||{}};Z={...Z,...oe,headers:ue};const le=W.uri,Se=W.fallbackUri,Ee={...Z,url:le};try{const be=await this.requestService.request(Ee,X);if(be.res.statusCode===200)return be;const Le=await(0,g.asText)(be);throw new Error(`Expected 200, got back ${be.res.statusCode} instead.

${Le}`)}catch(be){if((0,R.isPromiseCanceledError)(be))throw be;const Le=(0,R.getErrorMessage)(be);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:le,message:Le});const De={...Z,url:Se};return this.requestService.request(De,X)}}async getEngine(W){let Z=x(W);if(!Z){const X=await this.getManifestFromRawExtensionVersion(W,L.CancellationToken.None);if(!X)throw new Error("Manifest was not found");Z=X.engines.vscode}return Z}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const W=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},L.CancellationToken.None);if(W.res.statusCode!==200)throw new Error("Could not get extensions report.");const Z=await(0,g.asJson)(W),X=new Map;if(Z)for(const re of Z.malicious){const oe=X.get(re)||{id:{id:re},malicious:!0,slow:!1};oe.malicious=!0,X.set(re,oe)}return[...X.values()]}};J=de([Q(0,g.IRequestService),Q(1,S.ILogService),Q(2,E.IEnvironmentService),Q(3,o.ITelemetryService),Q(4,v.IFileService),Q(5,b.IProductService),Q(6,m.IConfigurationService),Q(7,(0,c.optional)(p.IStorageService))],J),e.ExtensionGalleryService=J;async function Y(H,W,Z,X,re,oe){const ue={"X-Market-Client-Id":`VSCode ${H}`,"User-Agent":`VSCode ${H}`},le=await(0,I.getServiceMachineId)(Z,re,oe);return(0,a.getTelemetryLevel)(W,Z)>=2&&X.getValue("telemetry.enableTelemetry")===!0&&(ue["X-Market-User-Id"]=le),ue}e.resolveMarketplaceHeaders=Y}),define(te[84],ne([0,1,2,12,14,46]),function(K,e,D,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let k=class extends D.Disposable{constructor(m,E,i=""){super();this.prefix=i;const C=m.getLogger(E.telemetryLogResource);C?this.logger=this._register(C):(this.logger=this._register(m.createLogger(E.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(m,E){this.logger.trace(`${this.prefix}telemetry/${m}`,(0,A.validateTelemetryData)(E))}};k=de([Q(0,R.ILoggerService),Q(1,L.IEnvironmentService)],k),e.TelemetryLogAppender=k}),define(te[186],ne([0,1,11,26,46]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function A(P){const m=await new Promise((i,C)=>{K(["applicationinsights"],i,C)});let E;return m.defaultClient?(E=new m.TelemetryClient(P),E.channel.setUseDiskRetryCaching(!0)):(m.setup(P).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),E=m.defaultClient),P.indexOf("AIF-")===0&&(E.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),E}class k{constructor(m,E,i){this._eventPrefix=m,this._defaultData=E,this._defaultData||(this._defaultData=Object.create(null)),typeof i=="function"?this._aiClient=i():this._aiClient=i,this._asyncAIClient=null}_withAIClient(m){if(!!this._aiClient){if(typeof this._aiClient!="string"){m(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=A(this._aiClient)),this._asyncAIClient.then(E=>{m(E)},E=>{(0,D.onUnexpectedError)(E),console.error(E)})}}log(m,E){!this._aiClient||(E=(0,L.mixin)(E,this._defaultData),E=(0,R.validateTelemetryData)(E),this._withAIClient(i=>i.trackEvent({name:this._eventPrefix+"/"+m,properties:E.properties,measurements:E.measurements})))}flush(){return this._aiClient?new Promise(m=>{this._withAIClient(E=>{E.flush({callback:()=>{this._aiClient=void 0,m(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=k}),define(te[187],ne([0,1,17,52,20,12,14,22,82,84,83,46]),function(K,e,D,L,R,A,k,P,m,E,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let h=class{constructor(c,S,b,g){this.configurationService=c,this.telemetryService=S,this.loggerService=b,this.environmentService=g,this.customTelemetryServices=new Map}async getCustomTelemetryService(c){if(!this.customTelemetryServices.has(c.id)){const{machineId:S,sessionId:b}=await this.telemetryService.getTelemetryInfo(),g=Object.create(null);g["common.vscodemachineid"]=S,g["common.vscodesessionid"]=b;const I=[c.id,JSON.stringify(g),c.aiKey],o=new L.Client(D.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:I,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),a=(0,C.combinedAppender)(new m.TelemetryAppenderClient(o),new E.TelemetryLogAppender(this.loggerService,this.environmentService,`[${c.id}] `));this.customTelemetryServices.set(c.id,new i.TelemetryService({appender:a,sendErrorTelemetry:c.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(c.id)}async publicLog(c,S,b){await(await this.getCustomTelemetryService(c)).publicLog(S,b)}async publicLogError(c,S,b){await(await this.getCustomTelemetryService(c)).publicLogError(S,b)}};h=de([Q(0,R.IConfigurationService),Q(1,P.ITelemetryService),Q(2,k.ILoggerService),Q(3,A.IEnvironmentService)],h),e.CustomEndpointTelemetryService=h}),define(te[188],ne([0,1,6,29,3,2,14]),function(K,e,D,L,R,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends A.Disposable{constructor(E,i){super();this._logService=i,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new R.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=E===void 0?15e3:E}createRequest(E){return new Promise((i,C)=>{const h=++this._lastRequestId;this._pendingRequests.set(h,i),this._onCreateRequest.fire({requestId:h,...E});const v=new L.CancellationTokenSource;(0,D.timeout)(this._timeout,v.token).then(()=>C(`Request ${h} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(h,[(0,A.toDisposable)(()=>v.cancel())])})}acceptReply(E,i){const C=this._pendingRequests.get(E);C?(this._pendingRequests.delete(E),(0,A.dispose)(this._pendingRequestDisposables.get(E)||[]),this._pendingRequestDisposables.delete(E),C(i)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${E}`)}};P=de([Q(1,k.ILogService)],P),e.RequestStore=P}),define(te[85],ne([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var L;(function(c){c.Shell="terminal.integrated.shell.",c.ShellArgs="terminal.integrated.shellArgs.",c.DefaultProfile="terminal.integrated.defaultProfile.",c.Profiles="terminal.integrated.profiles."})(L=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var R;(function(c){c.ShellLinux="terminal.integrated.shell.linux",c.ShellMacOs="terminal.integrated.shell.osx",c.ShellWindows="terminal.integrated.shell.windows",c.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",c.AutomationShellLinux="terminal.integrated.automationShell.linux",c.AutomationShellMacOs="terminal.integrated.automationShell.osx",c.AutomationShellWindows="terminal.integrated.automationShell.windows",c.ShellArgsLinux="terminal.integrated.shellArgs.linux",c.ShellArgsMacOs="terminal.integrated.shellArgs.osx",c.ShellArgsWindows="terminal.integrated.shellArgs.windows",c.ProfilesWindows="terminal.integrated.profiles.windows",c.ProfilesMacOs="terminal.integrated.profiles.osx",c.ProfilesLinux="terminal.integrated.profiles.linux",c.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",c.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",c.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",c.UseWslProfiles="terminal.integrated.useWslProfiles",c.TabsEnabled="terminal.integrated.tabs.enabled",c.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",c.TabsHideCondition="terminal.integrated.tabs.hideCondition",c.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",c.TabsShowActions="terminal.integrated.tabs.showActions",c.TabsLocation="terminal.integrated.tabs.location",c.TabsFocusMode="terminal.integrated.tabs.focusMode",c.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",c.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",c.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",c.CopyOnSelection="terminal.integrated.copyOnSelection",c.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",c.FontFamily="terminal.integrated.fontFamily",c.FontSize="terminal.integrated.fontSize",c.LetterSpacing="terminal.integrated.letterSpacing",c.LineHeight="terminal.integrated.lineHeight",c.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",c.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",c.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",c.BellDuration="terminal.integrated.bellDuration",c.FontWeight="terminal.integrated.fontWeight",c.FontWeightBold="terminal.integrated.fontWeightBold",c.CursorBlinking="terminal.integrated.cursorBlinking",c.CursorStyle="terminal.integrated.cursorStyle",c.CursorWidth="terminal.integrated.cursorWidth",c.Scrollback="terminal.integrated.scrollback",c.DetectLocale="terminal.integrated.detectLocale",c.DefaultLocation="terminal.integrated.defaultLocation",c.GpuAcceleration="terminal.integrated.gpuAcceleration",c.RightClickBehavior="terminal.integrated.rightClickBehavior",c.Cwd="terminal.integrated.cwd",c.ConfirmOnExit="terminal.integrated.confirmOnExit",c.ConfirmOnKill="terminal.integrated.confirmOnKill",c.EnableBell="terminal.integrated.enableBell",c.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",c.AllowChords="terminal.integrated.allowChords",c.AllowMnemonics="terminal.integrated.allowMnemonics",c.EnvMacOs="terminal.integrated.env.osx",c.EnvLinux="terminal.integrated.env.linux",c.EnvWindows="terminal.integrated.env.windows",c.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",c.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",c.ShowExitAlert="terminal.integrated.showExitAlert",c.SplitCwd="terminal.integrated.splitCwd",c.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",c.WordSeparators="terminal.integrated.wordSeparators",c.TitleMode="terminal.integrated.titleMode",c.EnableFileLinks="terminal.integrated.enableFileLinks",c.UnicodeVersion="terminal.integrated.unicodeVersion",c.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",c.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",c.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",c.LocalEchoStyle="terminal.integrated.localEchoStyle",c.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",c.CustomGlyphs="terminal.integrated.customGlyphs",c.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",c.PersistentSessionExperimentalSerializer="terminal.integrated.persistentSessionExperimentalSerializer",c.InheritEnv="terminal.integrated.inheritEnv",c.ShowLinkHover="terminal.integrated.showLinkHover"})(R=e.TerminalSettingId||(e.TerminalSettingId={}));var A;(function(c){c.CommandPrompt="cmd",c.PowerShell="pwsh",c.Wsl="wsl",c.GitBash="gitbash"})(A=e.WindowsShellType||(e.WindowsShellType={}));var k;(function(c){c[c.Api=0]="Api",c[c.Process=1]="Process",c[c.Sequence=2]="Sequence"})(k=e.TitleEventSource||(e.TitleEventSource={}));var P;(function(c){c.LocalPty="localPty",c.PtyHost="ptyHost",c.Log="log",c.Heartbeat="heartbeat"})(P=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,D.createDecorator)("ptyService");var m;(function(c){c[c.BeatInterval=5e3]="BeatInterval",c[c.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",c[c.SecondWaitMultiplier=1]="SecondWaitMultiplier",c[c.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(m=e.HeartbeatConstants||(e.HeartbeatConstants={}));var E;(function(c){c[c.Panel=1]="Panel",c[c.Editor=2]="Editor"})(E=e.TerminalLocation||(e.TerminalLocation={}));var i;(function(c){c.TerminalView="view",c.Editor="editor"})(i=e.TerminalLocationString||(e.TerminalLocationString={}));var C;(function(c){c[c.GraceTime=6e4]="GraceTime",c[c.ShortGraceTime=6e3]="ShortGraceTime"})(C=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var h;(function(c){c[c.HighWatermarkChars=1e5]="HighWatermarkChars",c[c.LowWatermarkChars=5e3]="LowWatermarkChars",c[c.CharCountAckSize=5e3]="CharCountAckSize"})(h=e.FlowControlConstants||(e.FlowControlConstants={}));var v;(function(c){c.GitBash="Git Bash",c.Pwsh="PowerShell"})(v=e.ProfileSource||(e.ProfileSource={}))}),define(te[189],ne([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,D.createDecorator)("localPtyService")}),define(te[190],ne([0,1,35,26,8,4,34,16,19]),function(K,e,D,L,R,A,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function E(){const C=/(\d+)\.(\d+)\.(\d+)/g.exec(D.release());let h=0;return C&&C.length===4&&(h=parseInt(C[3])),h}e.getWindowsBuildNumber=E;async function i(C,h,v,c=k.env,S=m.Promises.exists){if(R.isAbsolute(C))return await S(C)?C:void 0;if(h===void 0&&(h=k.cwd()),R.dirname(C)!=="."){const p=R.join(h,C);return await S(p)?p:void 0}const g=(0,L.getCaseInsensitive)(c,"PATH");if(v===void 0&&(0,P.isString)(g)&&(v=g.split(R.delimiter)),v===void 0||v.length===0){const p=R.join(h,C);return await S(p)?p:void 0}for(let p of v){let o;if(R.isAbsolute(p)?o=R.join(p,C):o=R.join(h,p,C),await S(o))return o;if(A.isWindows){let a=o+".com";if(await S(a)||(a=o+".exe",await S(a)))return a}}const I=R.join(h,C);return await S(I)?I:void 0}e.findExecutable=i}),define(te[191],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var D;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(D=e.ColorScheme||(e.ColorScheme={}))}),define(te[86],ne([0,1,49,3,2,7,32,191]),function(K,e,D,L,R,A,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var m;(function(b){function g(I){return I&&typeof I=="object"&&typeof I.id=="string"}b.isThemeColor=g})(m=e.ThemeColor||(e.ThemeColor={}));function E(b){return{id:b}}e.themeColorFromId=E;var i;(function(b){function g(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||m.isThemeColor(s.color))}b.isThemeIcon=g;const I=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function p(s){const n=I.exec(s);if(!n)return;let[,r]=n;return{id:r}}b.fromString=p;function o(s,n){let r=s.id;const u=r.lastIndexOf("~");return u!==-1&&(r=r.substring(0,u)),n&&(r=`${r}~${n}`),{id:r}}b.modify=o;function a(s,n){return s.id===n.id&&s.color?.id===n.color?.id}b.isEqual=a;function t(s,n){return{id:s.id,color:n?E(n):void 0}}b.asThemeIcon=t,b.asClassNameArray=D.CSSIcon.asClassNameArray,b.asClassName=D.CSSIcon.asClassName,b.asCSSSelector=D.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function C(b){switch(b){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class h{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(g){return this.themingParticipants.push(g),this.onThemingParticipantAddedEmitter.fire(g),(0,R.toDisposable)(()=>{const I=this.themingParticipants.indexOf(g);this.themingParticipants.splice(I,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let v=new h;k.Registry.add(e.Extensions.ThemingContribution,v);function c(b){return v.onColorThemeChange(b)}e.registerThemingParticipant=c;class S extends R.Disposable{constructor(g){super();this.themeService=g,this.theme=g.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(I=>this.onThemeChange(I)))}onThemeChange(g){this.theme=g,this.updateStyles()}updateStyles(){}getColor(g,I){let p=this.theme.getColor(g);return p&&I&&(p=I(p,this.theme)),p?p.toString():null}}e.Themable=S}),define(te[192],ne([0,1,49,86]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProfileSchemaEnums=void 0;function R(P,m){const E=P.map(i=>({name:i.profileName,description:A(i)}));return m&&E.push(...m.map(i=>({name:i.title,description:k(i)}))),{values:E.map(i=>i.name),markdownDescriptions:E.map(i=>i.description)}}e.createProfileSchemaEnums=R;function A(P){let m=`$(${L.ThemeIcon.isThemeIcon(P.icon)?P.icon.id:P.icon?P.icon:D.Codicon.terminal.id}) ${P.profileName}
- path: ${P.path}`;return P.args&&(typeof P.args=="string"?m+=`
- args: "${P.args}"`:m+=`
- args: [${P.args.length===0?"":`'${P.args.join("','")}'`}]`),P.overrideName!==void 0&&(m+=`
- overrideName: ${P.overrideName}`),P.color&&(m+=`
- color: ${P.color}`),P.env&&(m+=`
- env: ${JSON.stringify(P.env)}`),m}function k(P){return`$(${L.ThemeIcon.isThemeIcon(P.icon)?P.icon.id:P.icon?P.icon:D.Codicon.terminal.id}) ${P.title}
- extensionIdenfifier: ${P.extensionIdentifier}`}}),define(te[193],ne([0,1,49,127,38,32,192]),function(K,e,D,L,R,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const P={args:{description:(0,L.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,L.localize)(1,null),type:"boolean"},icon:{description:(0,L.localize)(2,null),type:"string",enum:Array.from(D.iconRegistry.all,b=>b.id),markdownEnumDescriptions:Array.from(D.iconRegistry.all,b=>`$(${b.id})`)},color:{description:(0,L.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,L.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},m={type:"object",required:["path"],properties:{path:{description:(0,L.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},E=(0,L.localize)(6,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),i=(0,L.localize)(7,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),C=(0,L.localize)(8,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),h={id:"terminal",order:100,title:(0,L.localize)(9,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(10,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(11,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(12,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(13,null),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(14,null),type:["string","null"],default:null,markdownDeprecationMessage:i},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(15,null),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(16,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:E},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(17,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:i},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(18,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,L.localize)(19,null)}},{type:"string",markdownDescription:(0,L.localize)(20,null)}],default:[],markdownDeprecationMessage:C},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(21,null,"`source`","`path`","`args`."),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,L.localize)(22,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(23,null),type:"string"},id:{description:(0,L.localize)(24,null),type:"string"},title:{description:(0,L.localize)(25,null),type:"string"},...P}},{type:"null"},m]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(26,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(27,null),type:"string"},id:{description:(0,L.localize)(28,null),type:"string"},title:{description:(0,L.localize)(29,null),type:"string"},...P}},{type:"null"},m]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(30,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(31,null),type:"string"},id:{description:(0,L.localize)(32,null),type:"string"},title:{description:(0,L.localize)(33,null),type:"string"},...P}},{type:"null"},m]}},["terminal.integrated.useWslProfiles"]:{description:(0,L.localize)(34,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,L.localize)(35,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,L.localize)(36,null),type:"number",default:100},["terminal.integrated.persistentSessionExperimentalSerializer"]:{scope:1,description:(0,L.localize)(37,null),type:"boolean",default:!0},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,L.localize)(38,null),type:"boolean",default:!0}}};function v(){A.Registry.as(R.Extensions.Configuration).registerConfiguration(h),S()}e.registerTerminalPlatformConfiguration=v;let c;function S(b,g){const I=A.Registry.as(R.Extensions.Configuration);c&&I.deregisterConfigurations([c]);let p;b&&(p=(0,k.createProfileSchemaEnums)(b?.profiles,g)),c={id:"terminal",order:100,title:(0,L.localize)(39,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(40,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:b?.os===3?p?.values:void 0,markdownEnumDescriptions:b?.os===3?p?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(41,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:b?.os===2?p?.values:void 0,markdownEnumDescriptions:b?.os===2?p?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(42,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:b?.os===1?p?.values:void 0,markdownEnumDescriptions:b?.os===1?p?.markdownDescriptions:void 0}}},I.registerConfiguration(c)}e.registerTerminalDefaultProfileConfiguration=S}),define(te[194],ne([0,1,41,49,8,4,19,69,190,86]),function(K,e,D,L,R,A,k,P,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let i;function C(t,s,n,r,u=process.env,l,f,d,w){return l=l||{existsFile:k.SymlinkSupport.existsFile,readFile:k.Promises.readFile},A.isWindows?h(n,l,u,f,r.getValue("terminal.integrated.useWslProfiles")!==!1,t&&typeof t=="object"?{...t}:r.getValue("terminal.integrated.profiles.windows"),typeof s=="string"?s:r.getValue("terminal.integrated.defaultProfile.windows"),w,d):p(l,f,n,t&&typeof t=="object"?{...t}:r.getValue(A.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof s=="string"?s:r.getValue(A.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),w,d,u)}e.detectAvailableProfiles=C;async function h(t,s,n,r,u,l,f,d,w){const T=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),O=`${process.env.windir}\\${T?"Sysnative":"System32"}`;let y=!1;(0,m.getWindowsBuildNumber)()>=16299&&(y=!0),await S(d);const M=new Map;t&&(M.set("PowerShell",{source:"PowerShell",icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),M.set("Windows PowerShell",{path:`${O}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),M.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),M.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),M.set("Command Prompt",{path:`${O}\\cmd.exe`,icon:L.Codicon.terminalCmd,isAutoDetected:!0})),o(l,M);const F=await v(M.entries(),f,s,n,r,w);if(t||!t&&u)try{const q=await g(`${O}\\${y?"wsl":"bash"}.exe`,f);for(const x of q)(!l||!(x.profileName in l))&&F.push(x)}catch(q){r?.info("WSL is not installed, so could not detect WSL profiles")}return F}async function v(t,s,n,r=process.env,u,l){const f=[];for(const[d,w]of t){if(w===null)continue;let T,O,y;if("source"in w){const q=i?.get(w.source);if(!q)continue;T=q.paths,O=w.args||q.args,w.icon?y=c(w.icon):q.icon&&(y=q.icon)}else T=Array.isArray(w.path)?w.path:[w.path],O=A.isWindows||Array.isArray(w.args)?w.args:void 0,y=c(w.icon)||void 0;const M=await l?.(T)||T.slice(),F=await a(d,s,M,n,r,O,w.env,w.overrideName,w.isAutoDetected,u);F?(F.isAutoDetected=w.isAutoDetected,F.icon=y,F.color=w.color,f.push(F)):u?.trace("profile not validated",d,T)}return f}function c(t){return typeof t=="string"?{id:t}:t}async function S(t){i&&!t||(i=new Map,i.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),i.set("PowerShell",{profileName:"PowerShell",paths:t||await b(),icon:E.ThemeIcon.asThemeIcon(L.Codicon.terminalPowershell)}))}async function b(){const t=[];for await(const s of(0,P.enumeratePowerShellInstallations)())t.push(s.exePath);return t}async function g(t,s){const n=[],r=await new Promise((f,d)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le"},(w,T)=>{if(w)return d("Problem occurred when getting wsl distros");f(T)})});if(!r)return[];const u=new RegExp(/[\r?\n]/),l=r.split(u).filter(f=>f.trim().length>0&&f!=="");for(const f of l){if(f===""||f.startsWith("docker-desktop"))continue;const d=`${f} (WSL)`,w={profileName:d,path:t,args:["-d",`${f}`],isDefault:d===s,icon:I(f)};n.push(w)}return n}function I(t){return t.includes("Ubuntu")?E.ThemeIcon.asThemeIcon(L.Codicon.terminalUbuntu):t.includes("Debian")?E.ThemeIcon.asThemeIcon(L.Codicon.terminalDebian):E.ThemeIcon.asThemeIcon(L.Codicon.terminalLinux)}async function p(t,s,n,r,u,l,f,d){const w=new Map;if(n){const T=(await t.readFile("/etc/shells")).toString(),O=l||T.split(`
`).filter(M=>M.trim().indexOf("#")!==0&&M.trim().length>0),y=new Map;for(const M of O){let F=(0,R.basename)(M),q=y.get(F)||0;q++,q>1&&(F=`${F} (${q})`),y.set(F,q),w.set(F,{path:M,isAutoDetected:!0})}}return o(r,w),await v(w.entries(),u,t,d,s,f)}function o(t,s){if(!!t)for(const[n,r]of Object.entries(t))r===null||!("path"in r)&&!("source"in r)?s.delete(n):s.set(n,r)}async function a(t,s,n,r,u,l,f,d,w,T){if(n.length===0)return Promise.resolve(void 0);const O=n.shift();if(O==="")return a(t,s,n,r,u,l,f,d,w);const y={profileName:t,path:O,args:l,env:f,overrideName:d,isAutoDetected:w,isDefault:t===s};if((0,R.basename)(O)===O){const F=u.PATH?u.PATH.split(R.delimiter):void 0;return await(0,m.findExecutable)(O,void 0,F,void 0,r.existsFile)?y:a(t,s,n,r,u,l)}return await r.existsFile((0,R.normalize)(O))?y:a(t,s,n,r,u,l,f,d,w)}}),define(te[195],ne([0,1,3,2,17,4,36,52,20,156,14,79,22,188,85,193,194]),function(K,e,D,L,R,A,k,P,m,E,i,C,h,v,c,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var g;(function(o){o[o.MaxRestarts=5]="MaxRestarts"})(g||(g={}));let I=0,p=class extends L.Disposable{constructor(a,t,s,n){super();this._reconnectConstants=a,this._configurationService=t,this._logService=s,this._telemetryService=n,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new D.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new D.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new D.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new D.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new D.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new D.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new D.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new D.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new D.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new D.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new D.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new D.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new D.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new D.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new D.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onProcessDidChangeHasChildProcesses=this._register(new D.Emitter),this.onProcessDidChangeHasChildProcesses=this._onProcessDidChangeHasChildProcesses.event,(0,S.registerTerminalPlatformConfiguration)(),this._shellEnv=A.isWindows?Promise.resolve(process.env):(0,E.resolveShellEnv)(this._logService,{_:[]},process.env),this._register((0,L.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new v.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost()}_startPtyHost(){const a=new P.Client(R.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:I,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback,VSCODE_RECONNECT_EXPERIMENTAL_SERIALIZATION:this._reconnectConstants.useExperimentalSerialization?1:0}});this._onPtyHostStart.fire(),k.ProxyChannel.toService(a.getChannel(c.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(a.onDidProcessExit(r=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(r.code),this._isDisposed||(this._restartCount<=g.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${r.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${r.code}, giving up`))}));const s=a.getChannel(c.TerminalIpcChannels.Log);C.LogLevelChannelClient.setLevel(s,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{C.LogLevelChannelClient.setLevel(s,this._logService.getLevel())}));const n=k.ProxyChannel.toService(a.getChannel(c.TerminalIpcChannels.PtyHost));return this._register(n.onProcessData(r=>this._onProcessData.fire(r))),this._register(n.onProcessExit(r=>this._onProcessExit.fire(r))),this._register(n.onProcessReady(r=>this._onProcessReady.fire(r))),this._register(n.onProcessTitleChanged(r=>this._onProcessTitleChanged.fire(r))),this._register(n.onProcessShellTypeChanged(r=>this._onProcessShellTypeChanged.fire(r))),this._register(n.onProcessOverrideDimensions(r=>this._onProcessOverrideDimensions.fire(r))),this._register(n.onProcessResolvedShellLaunchConfig(r=>this._onProcessResolvedShellLaunchConfig.fire(r))),this._register(n.onProcessDidChangeHasChildProcesses(r=>this._onProcessDidChangeHasChildProcesses.fire(r))),this._register(n.onProcessReplay(r=>this._onProcessReplay.fire(r))),this._register(n.onProcessOrphanQuestion(r=>this._onProcessOrphanQuestion.fire(r))),this._register(n.onDidRequestDetach(r=>this._onDidRequestDetach.fire(r))),[a,n]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(a,t,s,n,r,u,l,f,d,w,T){const O=setTimeout(()=>this._handleUnresponsiveCreateProcess(),c.HeartbeatConstants.CreateProcessTimeout),y=await this._proxy.createProcess(a,t,s,n,r,u,l,f,d,w,T);return clearTimeout(O),I=Math.max(I,y),y}updateTitle(a,t,s){return this._proxy.updateTitle(a,t,s)}updateIcon(a,t,s){return this._proxy.updateIcon(a,t,s)}attachToProcess(a){return this._proxy.attachToProcess(a)}detachFromProcess(a){return this._proxy.detachFromProcess(a)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(a){return this._proxy.start(a)}shutdown(a,t){return this._proxy.shutdown(a,t)}input(a,t){return this._proxy.input(a,t)}processBinary(a,t){return this._proxy.processBinary(a,t)}resize(a,t,s){return this._proxy.resize(a,t,s)}acknowledgeDataEvent(a,t){return this._proxy.acknowledgeDataEvent(a,t)}setUnicodeVersion(a,t){return this._proxy.setUnicodeVersion(a,t)}getInitialCwd(a){return this._proxy.getInitialCwd(a)}getCwd(a){return this._proxy.getCwd(a)}getLatency(a){return this._proxy.getLatency(a)}orphanQuestionReply(a){return this._proxy.orphanQuestionReply(a)}getDefaultSystemShell(a){return this._proxy.getDefaultSystemShell(a)}async getProfiles(a,t,s,n=!1){const r=await this._shellEnv;return(0,b.detectAvailableProfiles)(t,s,n,this._configurationService,r,void 0,this._logService,this._resolveVariables.bind(this,a))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(a){return this._proxy.getWslPath(a)}setTerminalLayoutInfo(a){return this._proxy.setTerminalLayoutInfo(a)}async getTerminalLayoutInfo(a){return await this._proxy.getTerminalLayoutInfo(a)}async requestDetachInstance(a,t){return this._proxy.requestDetachInstance(a,t)}async acceptDetachInstanceReply(a,t){return this._proxy.acceptDetachInstanceReply(a,t)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll&&this._proxy.shutdownAll(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),c.HeartbeatConstants.BeatInterval*c.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${c.HeartbeatConstants.BeatInterval*c.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),c.HeartbeatConstants.BeatInterval*c.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(c.HeartbeatConstants.BeatInterval*c.HeartbeatConstants.FirstWaitMultiplier+c.HeartbeatConstants.BeatInterval*c.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${c.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(a,t){return this._resolveVariablesRequestStore.createRequest({workspaceId:a,originalText:t})}async acceptPtyHostResolvedVariables(a,t){this._resolveVariablesRequestStore.acceptReply(a,t)}};p=de([Q(1,m.IConfigurationService),Q(2,i.ILogService),Q(3,h.ITelemetryService)],p),e.PtyHostService=p}),define(te[54],ne([0,1,43]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function L(k,P,m,E){const i=(0,D.setProperty)(k,P,m,E)[0];return i&&(k=k.substring(0,i.offset)+i.content+k.substring(i.offset+i.length)),k}e.edit=L;function R(k,P,m){let E=m;for(;E>=0;){if(k.charAt(E)===P.charAt(P.length-1)&&P.length===1)return E+1;if(E--,P.length===2&&E>=0&&k.charAt(E)===P.charAt(0))return E+2}return 0}e.getLineStartOffset=R;function A(k,P,m){let E=m;for(;E>=0;)if(k.charAt(E)===P.charAt(P.length-1)&&P.length===1||(E++,P.length===2&&E>=0&&k.charAt(E)===P.charAt(1)))return E;return k.length-1}e.getLineEndOffset=A}),define(te[196],ne([0,1,26,58]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(C,h,v,c,S){const b=[],g=[],I=[];if(!h){const O=C.filter(({identifier:y})=>S.every(M=>M.toLowerCase()!==y.id.toLowerCase()));return{local:{added:b,removed:g,updated:I},remote:O.length>0?{added:O,updated:[],removed:[],all:O}:null}}C=C.map(E),h=h.map(E),v=v?v.map(E):null;const p=new Map,o=O=>{O.uuid&&p.set(O.id.toLowerCase(),O.uuid)};C.forEach(({identifier:O})=>o(O)),h.forEach(({identifier:O})=>o(O)),v&&v.forEach(({identifier:O})=>o(O));const a=O=>{const y=O.identifier.uuid||p.get(O.identifier.id.toLowerCase());return y?`uuid:${y}`:`id:${O.identifier.id.toLowerCase()}`},t=(O,y)=>(O.set(a(y),y),O),s=C.reduce(t,new Map),n=h.reduce(t,new Map),r=h.reduce((O,y)=>{const M=a(y);y=(0,D.deepClone)(y);const F=s.get(M);return F&&(F.installed&&(y.installed=!0),y.version||(y.version=F.version)),t(O,y)},new Map),u=v?v.reduce(t,new Map):null,l=c.reduce(t,new Map),f=S.reduce((O,y)=>{const M=p.get(y.toLowerCase());return O.add(M?`uuid:${M}`:`id:${y.toLowerCase()}`)},new Set),d=A(s,n,f);if(d.added.size>0||d.removed.size>0||d.updated.size>0){const O=A(u,s,f),y=A(u,n,f),M=(F,q)=>{const x=s.get(F);if(x){const U=n.get(F);return{...q?U:x,version:(U.version&&L.gt(U.version,x.version),x.version),state:k(x,U,u?.get(F))}}};for(const F of y.removed.values()){const q=s.get(F);q&&g.push(q.identifier)}for(const F of y.added.values())if(O.added.has(F)){if(d.updated.has(F)){const q=M(F,!0);q&&(I.push(i(q,F)),r.set(F,q))}}else{const q=n.get(F);q.installed&&b.push(i(q,F))}for(const F of y.updated.values()){const q=M(F,!0);q&&(I.push(i(q,F)),r.set(F,q))}for(const F of O.added.values())y.added.has(F)||r.set(F,s.get(F));for(const F of O.updated.values())if(!y.removed.has(F)&&!y.updated.has(F)){const q=M(F,!1);q&&(r.get(F)?.installed&&(q.installed=!0),r.set(F,q))}for(const F of O.removed.values())!l.has(F)&&!y.updated.has(F)&&u?.get(F)?.installed&&r.delete(F)}const w=[],T=A(n,r,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(T.added.size>0||T.updated.size>0||T.removed.size>0)&&r.forEach((O,y)=>w.push(i(O,y))),{local:{added:b,removed:g,updated:I},remote:w.length?{added:[...T.added].map(O=>r.get(O)),updated:[...T.updated].map(O=>r.get(O)),removed:[...T.removed].map(O=>n.get(O)),all:w}:null}}e.merge=R;function A(C,h,v,{checkInstalledProperty:c,checkVersionProperty:S}={checkInstalledProperty:!1,checkVersionProperty:!1}){const b=C?[...C.keys()].filter(a=>!v.has(a)):[],g=[...h.keys()].filter(a=>!v.has(a)),I=g.filter(a=>b.indexOf(a)===-1).reduce((a,t)=>(a.add(t),a),new Set),p=b.filter(a=>g.indexOf(a)===-1).reduce((a,t)=>(a.add(t),a),new Set),o=new Set;for(const a of b){if(p.has(a))continue;const t=C.get(a),s=h.get(a);(!s||t.disabled!==s.disabled||!m(t.state,s.state)||S&&t.version!==s.version||c&&t.installed!==s.installed)&&o.add(a)}return{added:I,removed:p,updated:o}}function k(C,h,v){const c=C.state,S=h.state,b=v?.state;if(!h.version||c&&L.gt(C.version,h.version))return c;if(S&&L.gt(h.version,C.version)||!c)return S;if(!S)return c;const g=(0,D.deepClone)(c),I=b?P(b,S):{added:Object.keys(S).reduce((o,a)=>(o.add(a),o),new Set),removed:new Set,updated:new Set},p=b?P(b,c):{added:Object.keys(c).reduce((o,a)=>(o.add(a),o),new Set),removed:new Set,updated:new Set};for(const o of[...I.added.values(),...I.updated.values()])g[o]=S[o];for(const o of I.removed.values())p.updated.has(o)||delete g[o];return g}function P(C,h){const v=Object.keys(C),c=Object.keys(h),S=c.filter(I=>v.indexOf(I)===-1).reduce((I,p)=>(I.add(p),I),new Set),b=v.filter(I=>c.indexOf(I)===-1).reduce((I,p)=>(I.add(p),I),new Set),g=new Set;for(const I of v){if(b.has(I))continue;const p=C[I],o=h[I];(0,D.equals)(p,o)||g.add(I)}return{added:S,removed:b,updated:g}}function m(C={},h={}){const{added:v,removed:c,updated:S}=P(C,h);return v.size===0&&c.size===0&&S.size===0}function E(C){return{...C,disabled:!!C.disabled,installed:!!C.installed}}function i(C,h){const v={identifier:{id:C.identifier.id,uuid:h.startsWith("uuid:")?h.substring("uuid:".length):void 0}};return C.version&&(v.version=C.version),C.disabled&&(v.disabled=!0),C.installed&&(v.installed=!0),C.state&&(v.state=C.state),v}}),define(te[87],ne([0,1,18,3,2,31,7,28,21]),function(K,e,D,L,R,A,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,k.createDecorator)("IExtensionsStorageSyncService");const E=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let i=class Ze extends R.Disposable{constructor(h,v){super();this.storageService=h,this.productService=v,this._onDidChangeExtensionsStorage=this._register(new L.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(c=>this.onDidChangeStorageValue(c)))}static toKey(h){return`extensionKeys/${(0,A.adoptToGalleryExtensionId)(h.id)}@${h.version}`}static fromKey(h){const v=E.exec(h);if(v&&v[1])return{id:v[1],version:v[2]}}initialize(){const h=this.storageService.keys(0,1);for(const v of h){const c=Ze.fromKey(v);c&&this.extensionsWithKeysForSync.add(c.id.toLowerCase())}}onDidChangeStorageValue(h){if(h.scope!==0)return;if(this.extensionsWithKeysForSync.has(h.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const v=Ze.fromKey(h.key);if(v){this.extensionsWithKeysForSync.add(v.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(h,v){this.storageService.store(Ze.toKey(h),JSON.stringify(v),0,1)}getKeysForSync(h){const v=this.productService.extensionSyncedKeys?.[h.id.toLowerCase()],c=this.storageService.get(Ze.toKey(h),0),S=c?JSON.parse(c):void 0;return S&&v?(0,D.distinct)([...S,...v]):S||v}};i=de([Q(0,m.IStorageService),Q(1,P.IProductService)],i),e.ExtensionsStorageSyncService=i}),define(te[88],ne([0,1,18,20,7]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,R.createDecorator)("IIgnoredExtensionsManagementService");let A=class{constructor(P){this.configurationService=P}hasToNeverSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,m){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(i=>i.toLowerCase());return E=E.filter(i=>i!==P&&i!==`-${P}`),m&&E.push(P.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,1)}updateSynchronizedExtensions(P,m){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(i=>i.toLowerCase());return E=E.filter(i=>i!==P&&i!==`-${P}`),m&&E.push(`-${P.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,1)}getIgnoredExtensions(P){const m=P.filter(h=>h.isMachineScoped).map(h=>h.identifier.id.toLowerCase()),E=this.getConfiguredIgnoredExtensions().map(h=>h.toLowerCase()),i=[],C=[];if(Array.isArray(E))for(const h of E)h.startsWith("-")?C.push(h.substring(1)):i.push(h);return(0,D.distinct)([...m,...i].filter(h=>C.indexOf(h)===-1))}getConfiguredIgnoredExtensions(){let P=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.configurationService.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(m=>m.toLowerCase())}};A=de([Q(0,L.IConfigurationService)],A),e.IgnoredExtensionsManagementService=A}),define(te[197],ne([0,1,18,33,26,150,54]),function(K,e,D,L,R,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function P(o){return(0,L.parse)(o)||[]}e.parseKeybindings=P;async function m(o,a,t,s,n){const r=P(o),u=P(a),l=t?P(t):null,f=[...r,...u,...l||[]].map($=>$.key),d=await n.resolveUserBindings(f);let w=i(r,u,l,d);if(!w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:o,hasChanges:!1,hasConflicts:!1};if(!w.hasLocalForwarded&&w.hasRemoteForwarded)return{mergeContent:a,hasChanges:!0,hasConflicts:!1};if(w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:o,hasChanges:!0,hasConflicts:!1};const T=h(r),O=h(u),y=l?h(l):null,M=c(T,O,d),F=y?c(y,T,d):{added:[...T.keys()].reduce(($,B)=>($.add(B),$),new Set),removed:new Set,updated:new Set},q=y?c(y,O,d):{added:[...O.keys()].reduce(($,B)=>($.add(B),$),new Set),removed:new Set,updated:new Set},x=E(M,F,q);let U=o;for(const $ of x.removed.values())x.conflicts.has($)||(U=I(U,$,s));for(const $ of x.added.values()){if(x.conflicts.has($))continue;const B=O.get($);if(B.some(z=>z.command!==`-${$}`&&w.conflicts.has(d[z.key]))){x.conflicts.add($);continue}U=g(U,B,s)}for(const $ of x.updated.values()){if(x.conflicts.has($))continue;const B=O.get($);if(B.some(z=>z.command!==`-${$}`&&w.conflicts.has(d[z.key]))){x.conflicts.add($);continue}U=p(U,$,B,s)}return{mergeContent:U,hasChanges:!0,hasConflicts:x.conflicts.size>0}}e.merge=m;function E(o,a,t){const s=new Set,n=new Set,r=new Set,u=new Set;for(const l of a.removed.values())t.updated.has(l)&&u.add(l);for(const l of t.removed.values())u.has(l)||(a.updated.has(l)?u.add(l):n.add(l));for(const l of a.added.values())u.has(l)||t.added.has(l)&&o.updated.has(l)&&u.add(l);for(const l of t.added.values())u.has(l)||(a.added.has(l)?o.updated.has(l)&&u.add(l):s.add(l));for(const l of a.updated.values())u.has(l)||t.updated.has(l)&&o.updated.has(l)&&u.add(l);for(const l of t.updated.values())u.has(l)||(a.updated.has(l)?o.updated.has(l)&&u.add(l):r.add(l));return{added:s,removed:n,updated:r,conflicts:u}}function i(o,a,t,s){const n=new Set,r=C(o,s),u=C(a,s),l=t?C(t,s):null,f=v(r,u);if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const d=l?v(l,r):{added:[...r.keys()].reduce((F,q)=>(F.add(q),F),new Set),removed:new Set,updated:new Set};if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const w=l?v(l,u):{added:[...u.keys()].reduce((F,q)=>(F.add(q),F),new Set),removed:new Set,updated:new Set};if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:T,removed:O,updated:y,conflicts:M}=E(f,d,w);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:T,removed:O,updated:y,conflicts:M}}function C(o,a){const t=new Map;for(const s of o){const n=a[s.key];let r=t.get(n);r||(r=[],t.set(n,r)),r.push(s)}return t}function h(o){const a=new Map;for(const t of o){const s=t.command[0]==="-"?t.command.substring(1):t.command;let n=a.get(s);n||(n=[],a.set(s,n)),n.push(t)}return a}function v(o,a){const t=[...o.keys()],s=[...a.keys()],n=s.filter(l=>t.indexOf(l)===-1).reduce((l,f)=>(l.add(f),l),new Set),r=t.filter(l=>s.indexOf(l)===-1).reduce((l,f)=>(l.add(f),l),new Set),u=new Set;for(const l of t){if(r.has(l))continue;const f=o.get(l).map(w=>({...w,key:l})),d=a.get(l).map(w=>({...w,key:l}));(0,D.equals)(f,d,(w,T)=>b(w,T))||u.add(l)}return{added:n,removed:r,updated:u}}function c(o,a,t){const s=[...o.keys()],n=[...a.keys()],r=n.filter(f=>s.indexOf(f)===-1).reduce((f,d)=>(f.add(d),f),new Set),u=s.filter(f=>n.indexOf(f)===-1).reduce((f,d)=>(f.add(d),f),new Set),l=new Set;for(const f of s){if(u.has(f))continue;const d=o.get(f).map(T=>({...T,key:t[T.key]})),w=a.get(f).map(T=>({...T,key:t[T.key]}));S(d,w)||l.add(f)}return{added:r,removed:u,updated:l}}function S(o,a){return!(!(0,D.equals)(o.filter(({command:t})=>t[0]!=="-"),a.filter(({command:t})=>t[0]!=="-"),(t,s)=>b(t,s))||!(0,D.equals)(o.filter(({command:t})=>t[0]==="-"),a.filter(({command:t})=>t[0]==="-"),(t,s)=>b(t,s)))}function b(o,a){if(o.command!==a.command||o.key!==a.key)return!1;const t=A.ContextKeyExpr.deserialize(o.when),s=A.ContextKeyExpr.deserialize(a.when);return!(t&&!s||!t&&s||t&&s&&!t.equals(s)||!R.equals(o.args,a.args))}function g(o,a,t){for(const s of a)o=k.edit(o,[-1],s,t);return o}function I(o,a,t){const s=P(o);for(let n=s.length-1;n>=0;n--)(s[n].command===a||s[n].command===`-${a}`)&&(o=k.edit(o,[n],void 0,t));return o}function p(o,a,t,s){const n=P(o),r=n.findIndex(u=>u.command===a||u.command===`-${a}`);for(let u=n.length-1;u>=0;u--)(n[u].command===a||n[u].command===`-${a}`)&&(o=k.edit(o,[u],void 0,s));for(let u=t.length-1;u>=0;u--)o=k.edit(o,[r],t[u],s);return o}}),define(te[198],ne([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function D(A,k,P){const m={},E={},i=new Set;if(!k)return{local:{added:m,updated:E,removed:[...i.values()]},remote:{added:A,updated:{},removed:[]},conflicts:[]};const C=L(A,k);if(C.added.size===0&&C.removed.size===0&&C.updated.size===0)return{local:{added:m,updated:E,removed:[...i.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const h=L(P,A),v=L(P,k),c={},S={},b=new Set,g=new Set;for(const I of h.removed.values())v.updated.has(I)?m[I]=k[I]:b.add(I);for(const I of v.removed.values())g.has(I)||(h.updated.has(I)?g.add(I):i.add(I));for(const I of h.updated.values())g.has(I)||(v.updated.has(I)?C.updated.has(I)&&g.add(I):S[I]=A[I]);for(const I of v.updated.values())g.has(I)||(h.updated.has(I)?C.updated.has(I)&&g.add(I):A[I]!==void 0&&(E[I]=k[I]));for(const I of h.added.values())g.has(I)||(v.added.has(I)?C.updated.has(I)&&g.add(I):c[I]=A[I]);for(const I of v.added.values())g.has(I)||(h.added.has(I)?C.updated.has(I)&&g.add(I):m[I]=k[I]);return{local:{added:m,removed:[...i.values()],updated:E},remote:{added:c,removed:[...b.values()],updated:S},conflicts:[...g.values()]}}e.merge=D;function L(A,k){const P=A?Object.keys(A):[],m=k?Object.keys(k):[],E=m.filter(h=>P.indexOf(h)===-1).reduce((h,v)=>(h.add(v),h),new Set),i=P.filter(h=>m.indexOf(h)===-1).reduce((h,v)=>(h.add(v),h),new Set),C=new Set;for(const h of P){if(i.has(h))continue;const v=A[h],c=k[h];v!==c&&C.add(h)}return{added:E,removed:i,updated:C}}function R(A,k){const{added:P,removed:m,updated:E}=L(A,k);return P.size===0&&m.size===0&&E.size===0}e.areSame=R}),define(te[23],ne([0,1,18,15,16,132,38,27,7,81,32]),function(K,e,D,L,R,A,k,P,m,E,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function C(){const l=i.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(l).filter(f=>!!l[f].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=C;function h(){const l=i.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),f=Object.keys(l).filter(T=>!!l[T].ignoreSync),d=Object.keys(l).filter(T=>l[T].scope===2||l[T].scope===6),w=C();return(0,D.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...f,...d,...w])}e.getDefaultIgnoredSettings=h;function v(){const l="vscode://schemas/ignoredSettings",f=i.Registry.as(k.Extensions.Configuration);f.registerConfiguration({id:"settingsSync",order:30,title:(0,A.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,A.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,A.localize)(2,null),items:[{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,A.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,A.localize)(4,null),default:[],scope:1,$ref:l,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const d=i.Registry.as(E.Extensions.JSONContribution),w=()=>{const T=C(),O=h().filter(q=>q!==e.CONFIGURATION_SYNC_STORE_KEY),y=Object.keys(k.allSettings.properties).filter(q=>O.indexOf(q)===-1),M=O.filter(q=>T.indexOf(q)===-1),F={items:{type:"string",enum:[...y,...M.map(q=>`-${q}`)]}};d.registerSchema(l,F)};return f.onDidUpdateConfiguration(()=>w())}e.registerConfiguration=v;function c(l){return l&&(0,R.isObject)(l)&&(0,R.isString)(l.id)&&(0,R.isArray)(l.scopes)}e.isAuthenticationProvider=c;var S;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Extensions="extensions",l.GlobalState="globalState"})(S=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function b(l,f,d){return d.joinPath(f.userDataSyncHome,l,`lastSync${l}.json`)}e.getLastSyncResourceUri=b,e.IUserDataSyncStoreManagementService=(0,m.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,m.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,m.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function g(l){const f={};return f[e.HEADER_EXECUTION_ID]=l,f}e.createSyncHeaders=g;var I;(function(l){l.Unauthorized="Unauthorized",l.Conflict="Conflict",l.Gone="Gone",l.PreconditionFailed="PreconditionFailed",l.TooLarge="TooLarge",l.UpgradeRequired="UpgradeRequired",l.PreconditionRequired="PreconditionRequired",l.TooManyRequests="RemoteTooManyRequests",l.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",l.RequestFailed="RequestFailed",l.RequestCanceled="RequestCanceled",l.RequestTimeout="RequestTimeout",l.RequestProtocolNotSupported="RequestProtocolNotSupported",l.RequestPathNotEscaped="RequestPathNotEscaped",l.RequestHeadersNotObject="RequestHeadersNotObject",l.NoRef="NoRef",l.EmptyResponse="EmptyResponse",l.TurnedOff="TurnedOff",l.SessionExpired="SessionExpired",l.ServiceChanged="ServiceChanged",l.DefaultServiceChanged="DefaultServiceChanged",l.LocalTooManyRequests="LocalTooManyRequests",l.LocalPreconditionFailed="LocalPreconditionFailed",l.LocalInvalidContent="LocalInvalidContent",l.LocalError="LocalError",l.IncompatibleLocalContent="IncompatibleLocalContent",l.IncompatibleRemoteContent="IncompatibleRemoteContent",l.UnresolvedConflicts="UnresolvedConflicts",l.Unknown="Unknown"})(I=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class p extends Error{constructor(f,d,w,T){super(f);this.code=d,this.resource=w,this.operationId=T,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=p;class o extends p{constructor(f,d,w,T,O){super(f,w,void 0,O);this.url=d,this.serverCode=T}}e.UserDataSyncStoreError=o;class a extends p{constructor(f,d){super(f,d)}}e.UserDataAutoSyncError=a,function(l){function f(d){if(d instanceof l)return d;const w=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(d.name);if(w&&w[1]){const T=w[2]==="unknown"?void 0:w[2],O=w[3]==="unknown"?void 0:w[3];return new l(d.message,w[1],T,O)}return new l(d.message,"Unknown")}l.toUserDataSyncError=f}(p=e.UserDataSyncError||(e.UserDataSyncError={}));var t;(function(l){l.Uninitialized="uninitialized",l.Idle="idle",l.Syncing="syncing",l.HasConflicts="hasConflicts"})(t=e.SyncStatus||(e.SyncStatus={}));var s;(function(l){l[l.None=0]="None",l[l.Added=1]="Added",l[l.Modified=2]="Modified",l[l.Deleted=3]="Deleted"})(s=e.Change||(e.Change={}));var n;(function(l){l.Preview="preview",l.Conflict="conflict",l.Accepted="accepted"})(n=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function r(l){return`sync.enable.${l}`}e.getEnablementKey=r,e.IUserDataSyncResourceEnablementService=(0,m.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,m.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,m.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,m.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,m.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,m.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function u(l,f){if(l.scheme!==e.USER_DATA_SYNC_SCHEME)return l=l.with({scheme:f.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(d=>(0,L.isEqualOrParent)(l,(0,L.joinPath)(f.userDataSyncHome,d,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=u}),define(te[47],ne([0,1,18,6,25,29,3,33,2,15,24,16,5,128,20,12,13,45,21,22,23]),function(K,e,D,L,R,A,k,P,m,E,i,C,h,v,c,S,b,g,I,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function a(u){return!!(u&&u.version!==void 0&&typeof u.version=="number"&&u.content!==void 0&&typeof u.content=="string"&&(Object.keys(u).length===2||Object.keys(u).length===3&&u.machineId!==void 0&&typeof u.machineId=="string"))}e.isSyncData=a;let t=class extends m.Disposable{constructor(l,f,d,w,T,O,y,M,F,q){super();this.resource=l,this.fileService=f,this.environmentService=d,this.userDataSyncStoreService=T,this.userDataSyncBackupStoreService=O,this.userDataSyncResourceEnablementService=y,this.telemetryService=M,this.logService=F,this.configurationService=q,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new L.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new k.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,i.uppercaseFirstLetter)(this.resource),this.extUri=this.fileService.hasCapability(d.userDataSyncHome,1024)?E.extUri:E.extUriIgnorePathCase,this.syncFolder=this.extUri.joinPath(d.userDataSyncHome,l),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,o.PREVIEW_DIR_NAME),this.lastSyncResource=(0,o.getLastSyncResourceUri)(l,d,this.extUri),this.currentMachineIdPromise=(0,g.getServiceMachineId)(d,f,w)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const l=await this.syncPreviewPromise;this.syncPreviewPromise=null;const f=await this.performSync(l.remoteUserData,l.lastSyncUserData,!0);this.setStatus(f)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const l=await this.getLastSyncUserData();(l?(await this.doGenerateSyncResourcePreview(l,l,!0,A.CancellationToken.None)).resourcePreviews.some(({remoteChange:d})=>d!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(l){if(this._status!==l){const f=this._status;l==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),f==="hasConflicts"&&l==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=l,this._onDidChangStatus.fire(l)}}async sync(l,f={}){await this._sync(l,!0,f)}async preview(l,f={}){return this._sync(l,!1,f)}async apply(l,f={}){try{this.syncHeaders={...f};const d=await this.doApply(l);return this.setStatus(d),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(l,f,d){try{if(this.syncHeaders={...d},!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let w="idle";try{const T=await this.getLastSyncUserData(),O=await this.getLatestRemoteUserData(l,T);return w=await this.performSync(O,T,f),w==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):w==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(w)}}finally{this.syncHeaders={}}}async replace(l){const f=await this.resolveContent(l);if(!f)return!1;const d=this.parseSyncData(f);if(!d)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const w=await this.getLastSyncUserData(),T=await this.getLatestRemoteUserData(null,w),O=await this.isRemoteDataFromCurrentMachine(T),y=await this.generateSyncPreview({ref:T.ref,syncData:d},w,O,A.CancellationToken.None),M=[];for(const F of y){const q=await this.getAcceptResult(F,F.remoteResource,void 0,A.CancellationToken.None),{remoteChange:x}=await this.getAcceptResult(F,F.previewResource,F.remoteContent,A.CancellationToken.None);M.push([F,{...q,remoteChange:x!==0?x:2}])}await this.applyResult(T,w,M,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(l){const f=await this.currentMachineIdPromise;return!!l.syncData?.machineId&&l.syncData.machineId===f}async getLatestRemoteUserData(l,f){if(f){const d=l&&l.latest?l.latest[this.resource]:void 0;if(f.ref===d||d===void 0&&f.syncData===null)return f}return this.getRemoteUserData(f)}async performSync(l,f,d){if(l.syncData&&l.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new o.UserDataSyncError((0,v.localize)(0,null,this.resource,this.version,l.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(l,f,d)}catch(w){if(w instanceof o.UserDataSyncError)switch(w.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(l,f,d);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),l=await this.getRemoteUserData(null),f=await this.getLastSyncUserData(),this.performSync(l,f,d)}throw w}}async doSync(l,f,d){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,L.createCancelablePromise)(T=>this.doGenerateSyncResourcePreview(l,f,d,T)));const w=await this.syncPreviewPromise;return this.updateConflicts(w.resourcePreviews),w.resourcePreviews.some(({mergeState:T})=>T==="conflict")?"hasConflicts":d?await this.doApply(!1):"syncing"}catch(w){throw this.syncPreviewPromise=null,w}}async merge(l){return await this.updateSyncResourcePreview(l,async f=>{const d=await this.getMergeResult(f,A.CancellationToken.None);await this.fileService.writeFile(f.previewResource,R.VSBuffer.fromString(d?.content||""));const w=d&&!d.hasConflicts?await this.getAcceptResult(f,f.previewResource,void 0,A.CancellationToken.None):void 0;return f.acceptResult=w,f.mergeState=d.hasConflicts?"conflict":w?"accepted":"preview",f.localChange=w?w.localChange:d.localChange,f.remoteChange=w?w.remoteChange:d.remoteChange,f}),this.syncPreviewPromise}async accept(l,f){return await this.updateSyncResourcePreview(l,async d=>{const w=await this.getAcceptResult(d,l,f,A.CancellationToken.None);return d.acceptResult=w,d.mergeState="accepted",d.localChange=w.localChange,d.remoteChange=w.remoteChange,d}),this.syncPreviewPromise}async discard(l){return await this.updateSyncResourcePreview(l,async f=>{const d=await this.getMergeResult(f,A.CancellationToken.None);return await this.fileService.writeFile(f.previewResource,R.VSBuffer.fromString(d.content||"")),f.acceptResult=void 0,f.mergeState="preview",f.localChange=d.localChange,f.remoteChange=d.remoteChange,f}),this.syncPreviewPromise}async updateSyncResourcePreview(l,f){if(!this.syncPreviewPromise)return;let d=await this.syncPreviewPromise;const w=d.resourcePreviews.findIndex(({localResource:T,remoteResource:O,previewResource:y})=>this.extUri.isEqual(T,l)||this.extUri.isEqual(O,l)||this.extUri.isEqual(y,l));w!==-1&&(this.syncPreviewPromise=(0,L.createCancelablePromise)(async T=>{const O=[...d.resourcePreviews];return O[w]=await f(O[w]),{...d,resourcePreviews:O}}),d=await this.syncPreviewPromise,this.updateConflicts(d.resourcePreviews),d.resourcePreviews.some(({mergeState:T})=>T==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(l){if(!this.syncPreviewPromise)return"idle";const f=await this.syncPreviewPromise;return f.resourcePreviews.some(({mergeState:d})=>d==="conflict")?"hasConflicts":f.resourcePreviews.some(({mergeState:d})=>d!=="accepted")?"syncing":(await this.applyResult(f.remoteUserData,f.lastSyncUserData,f.resourcePreviews.map(d=>[d,d.acceptResult]),l),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(l){}}updateConflicts(l){const f=l.filter(({mergeState:d})=>d==="conflict");(0,D.equals)(this._conflicts,f,(d,w)=>this.extUri.isEqual(d.previewResource,w.previewResource))||(this._conflicts=f,this._onDidChangeConflicts.fire(f))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:f,ref:d})=>({created:f,uri:this.toRemoteBackupResource(d)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:f,ref:d})=>({created:f,uri:this.toLocalBackupResource(d)}))}toRemoteBackupResource(l){return h.URI.from({scheme:o.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${l}`})}toLocalBackupResource(l){return h.URI.from({scheme:o.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${l}`})}async getMachineId({uri:l}){const f=this.extUri.basename(l);if(this.extUri.isEqual(l,this.toRemoteBackupResource(f))){const{content:d}=await this.getUserData(f);if(d)return this.parseSyncData(d)?.machineId}}async resolveContent(l){const f=this.extUri.basename(l);if(this.extUri.isEqual(l,this.toRemoteBackupResource(f))){const{content:d}=await this.getUserData(f);return d}return this.extUri.isEqual(l,this.toLocalBackupResource(f))?this.userDataSyncBackupStoreService.resolveContent(this.resource,f):null}async resolvePreviewContent(l){const f=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(f)for(const d of f.resourcePreviews){if(this.extUri.isEqual(d.acceptedResource,l))return d.acceptResult?d.acceptResult.content:null;if(this.extUri.isEqual(d.remoteResource,l))return d.remoteContent;if(this.extUri.isEqual(d.localResource,l))return d.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(l){}}async doGenerateSyncResourcePreview(l,f,d,w){const T=await this.isRemoteDataFromCurrentMachine(l),O=await this.generateSyncPreview(l,f,T,w),y=[];for(const M of O){const F=M.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(M.localChange===0&&M.remoteChange===0)y.push({...M,acceptedResource:F,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const q=d?await this.getMergeResult(M,w):void 0;if(w.isCancellationRequested)break;await this.fileService.writeFile(M.previewResource,R.VSBuffer.fromString(q?.content||""));const x=q&&!q.hasConflicts?await this.getAcceptResult(M,M.previewResource,void 0,w):void 0;y.push({...M,acceptResult:x,mergeState:q?.hasConflicts?"conflict":x?"accepted":"preview",localChange:x?x.localChange:q?q.localChange:M.localChange,remoteChange:x?x.remoteChange:q?q.remoteChange:M.remoteChange})}}return{remoteUserData:l,lastSyncUserData:f,resourcePreviews:y,isLastSyncFromCurrentMachine:T}}async getLastSyncUserData(){try{const l=await this.fileService.readFile(this.lastSyncResource),f=JSON.parse(l.value.toString()),d=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=f.version&&d&&f.version!==d,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${f.version} is not compatible with current sync state version ${d}.`),await this.resetLocal(),null;const w=f;if(w.content===null)return{ref:f.ref,syncData:null};const T=JSON.parse(w.content);if(a(T))return{...f,syncData:T,content:void 0}}catch(l){l instanceof b.FileOperationError&&l.fileOperationResult===1||this.logService.error(l)}return null}async updateLastSyncUserData(l,f={}){if(f.ref||f.content||f.version)throw new Error("Cannot have core properties as additional");const d=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),w={ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null,version:d,...f};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify(w)))}async getRemoteUserData(l){const{ref:f,content:d}=await this.getUserData(l);let w=null;return d!==null&&(w=this.parseSyncData(d)),{ref:f,syncData:w}}parseSyncData(l){try{const f=JSON.parse(l);if(a(f))return f}catch(f){this.logService.error(f)}throw new o.UserDataSyncError((0,v.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(l){if((0,C.isString)(l)){const f=await this.userDataSyncStoreService.resolveContent(this.resource,l);return{ref:l,content:f}}else{const f=l?{ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,f,this.syncHeaders)}}async updateRemoteUserData(l,f){const d=await this.currentMachineIdPromise,w={version:this.version,machineId:d,content:l};return f=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(w),f,this.syncHeaders),{ref:f,syncData:w}}async backupLocal(l){const f={version:this.version,content:l};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(f))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}};t=de([Q(1,b.IFileService),Q(2,S.IEnvironmentService),Q(3,I.IStorageService),Q(4,o.IUserDataSyncStoreService),Q(5,o.IUserDataSyncBackupStoreService),Q(6,o.IUserDataSyncResourceEnablementService),Q(7,p.ITelemetryService),Q(8,o.IUserDataSyncLogService),Q(9,c.IConfigurationService)],t),e.AbstractSynchroniser=t;let s=class extends t{constructor(l,f,d,w,T,O,y,M,F,q,x){super(f,d,w,T,O,y,M,F,q,x);this.file=l,this._register(this.fileService.watch(this.extUri.dirname(l))),this._register(this.fileService.onDidFilesChange(U=>this.onFileChanges(U)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(l){return null}}async updateLocalFileContent(l,f,d){try{f?await this.fileService.writeFile(this.file,R.VSBuffer.fromString(l),d?void 0:f):await this.fileService.createFile(this.file,R.VSBuffer.fromString(l),{overwrite:d})}catch(w){throw w instanceof b.FileOperationError&&w.fileOperationResult===1||w instanceof b.FileOperationError&&w.fileOperationResult===3?new o.UserDataSyncError(w.message,"LocalPreconditionFailed"):w}}onFileChanges(l){!l.contains(this.file)||this.triggerLocalChange()}};s=de([Q(2,b.IFileService),Q(3,S.IEnvironmentService),Q(4,I.IStorageService),Q(5,o.IUserDataSyncStoreService),Q(6,o.IUserDataSyncBackupStoreService),Q(7,o.IUserDataSyncResourceEnablementService),Q(8,p.ITelemetryService),Q(9,o.IUserDataSyncLogService),Q(10,c.IConfigurationService)],s),e.AbstractFileSynchroniser=s;let n=class extends s{constructor(l,f,d,w,T,O,y,M,F,q,x,U){super(l,f,d,w,T,O,y,M,F,q,U);this.userDataSyncUtilService=x,this._formattingOptions=void 0}hasErrors(l){const f=[];return(0,P.parse)(l,f,{allowEmptyContent:!0,allowTrailingComma:!0}),f.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};n=de([Q(2,b.IFileService),Q(3,S.IEnvironmentService),Q(4,I.IStorageService),Q(5,o.IUserDataSyncStoreService),Q(6,o.IUserDataSyncBackupStoreService),Q(7,o.IUserDataSyncResourceEnablementService),Q(8,p.ITelemetryService),Q(9,o.IUserDataSyncLogService),Q(10,o.IUserDataSyncUtilService),Q(11,c.IConfigurationService)],n),e.AbstractJsonFileSynchroniser=n;let r=class{constructor(l,f,d,w){this.resource=l,this.environmentService=f,this.logService=d,this.fileService=w,this.extUri=this.fileService.hasCapability(f.userDataSyncHome,1024)?E.extUri:E.extUriIgnorePathCase,this.lastSyncResource=(0,o.getLastSyncResourceUri)(this.resource,f,E.extUri)}async initialize({ref:l,content:f}){if(!f){this.logService.info("Remote content does not exist.",this.resource);return}const d=this.parseSyncData(f);if(!d)return;if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:l,syncData:d})}catch(T){this.logService.error(T)}}parseSyncData(l){try{const f=JSON.parse(l);if(a(f))return f}catch(f){this.logService.error(f)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(l,f={}){const d={ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null,...f};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify(d)))}};r=de([Q(1,S.IEnvironmentService),Q(2,o.IUserDataSyncLogService),Q(3,b.IFileService)],r),e.AbstractInitializer=r}),define(te[199],ne([0,1,6,11,3,43,48,24,5,20,12,27,31,13,21,22,47,196,87,88,23]),function(K,e,D,L,R,A,k,P,m,E,i,C,h,v,c,S,b,g,I,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function a(u,l){const f=JSON.parse(u.content);if(u.version===1||u.version===2){const d=(await l.getInstalled(0)).filter(w=>w.isBuiltin);for(const w of f)u.version===1&&(w.enabled===!1&&(w.disabled=!0),delete w.enabled),u.version===2&&d.every(T=>!(0,h.areSameExtensions)(T.identifier,w.identifier))&&(w.installed=!0)}return f}function t(u,l,f){const d=f.get((0,h.getExtensionId)(u,l),0)||"{}";return JSON.parse(d)}e.getExtensionStorageState=t;function s(u,l,f,d){d.store((0,h.getExtensionId)(u,l),JSON.stringify(f),0,1)}e.storeExtensionStorageState=s;let n=class at extends b.AbstractSynchroniser{constructor(l,f,d,w,T,O,y,M,F,q,x,U,$,B){super("extensions",f,l,d,w,T,U,$,F,x);this.storageService=d,this.extensionManagementService=O,this.extensionEnablementService=y,this.ignoredExtensionsManagementService=M,this.extensionGalleryService=q,this.extensionsStorageSyncService=B,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(R.Event.debounce(R.Event.any(R.Event.filter(this.extensionManagementService.onDidInstallExtensions,z=>z.some(({local:j})=>!!j)),R.Event.filter(this.extensionManagementService.onDidUninstallExtension,z=>!z.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(l,f){const d=l.syncData?await a(l.syncData,this.extensionManagementService):null,w=f?.skippedExtensions||[],T=f?.syncData?await a(f.syncData,this.extensionManagementService):null,O=await this.extensionManagementService.getInstalled(),y=this.getLocalExtensions(O),M=this.ignoredExtensionsManagementService.getIgnoredExtensions(O);d?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:F,remote:q}=(0,g.merge)(y,d,T,w,M),x={local:F,remote:q,content:this.getPreviewContent(y,F.added,F.updated,F.removed),localChange:F.added.length>0||F.removed.length>0||F.updated.length>0?2:0,remoteChange:q!==null?2:0};return[{skippedExtensions:w,localResource:this.localResource,localContent:this.format(y),localExtensions:y,remoteResource:this.remoteResource,remoteContent:d?this.format(d):null,previewResource:this.previewResource,previewResult:x,localChange:x.localChange,remoteChange:x.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(l,f,d,w){const T=[...f,...d],O=new Set,y=M=>{O.add(M.id.toLowerCase()),M.uuid&&O.add(M.uuid)};T.forEach(({identifier:M})=>y(M)),w.forEach(y);for(const M of l)O.has(M.identifier.id.toLowerCase())||M.identifier.uuid&&O.has(M.identifier.uuid)||T.push(M);return this.format(T)}async getMergeResult(l,f){return{...l.previewResult,hasConflicts:!1}}async getAcceptResult(l,f,d,w){if(this.extUri.isEqual(f,this.localResource))return this.acceptLocal(l);if(this.extUri.isEqual(f,this.remoteResource))return this.acceptRemote(l);if(this.extUri.isEqual(f,this.previewResource))return l.previewResult;throw new Error(`Invalid Resource: ${f.toString()}`)}async acceptLocal(l){const f=await this.extensionManagementService.getInstalled(),d=this.ignoredExtensionsManagementService.getIgnoredExtensions(f),w=(0,g.merge)(l.localExtensions,null,null,l.skippedExtensions,d),{local:T,remote:O}=w;return{content:l.localContent,local:T,remote:O,localChange:T.added.length>0||T.removed.length>0||T.updated.length>0?2:0,remoteChange:O!==null?2:0}}async acceptRemote(l){const f=await this.extensionManagementService.getInstalled(),d=this.ignoredExtensionsManagementService.getIgnoredExtensions(f),w=l.remoteContent?JSON.parse(l.remoteContent):null;if(w!==null){const T=(0,g.merge)(l.localExtensions,w,l.localExtensions,[],d),{local:O,remote:y}=T;return{content:l.remoteContent,local:O,remote:y,localChange:O.added.length>0||O.removed.length>0||O.updated.length>0?2:0,remoteChange:y!==null?2:0}}else return{content:l.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(l,f,d,w){let{skippedExtensions:T,localExtensions:O}=d[0][0],{local:y,remote:M,localChange:F,remoteChange:q}=d[0][1];if(F===0&&q===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),F!==0&&(await this.backupLocal(JSON.stringify(O)),T=await this.updateLocalExtensions(y.added,y.removed,y.updated,T)),M){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const x=JSON.stringify(M.all);l=await this.updateRemoteUserData(x,w?null:l.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${M.added.length?` Added: ${JSON.stringify(M.added.map(U=>U.identifier.id))}.`:""}${M.updated.length?` Updated: ${JSON.stringify(M.updated.map(U=>U.identifier.id))}.`:""}${M.removed.length?` Removed: ${JSON.stringify(M.removed.map(U=>U.identifier.id))}.`:""}`)}f?.ref!==l.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(l,{skippedExtensions:T}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${T.length?` Skipped: ${JSON.stringify(T.map(x=>x.identifier.id))}.`:""}`))}async getAssociatedResources({uri:l}){return[{resource:this.extUri.joinPath(l,"extensions.json"),comparableResource:at.EXTENSIONS_DATA_URI}]}async resolveContent(l){if(this.extUri.isEqual(l,at.EXTENSIONS_DATA_URI)){const d=await this.extensionManagementService.getInstalled(),w=this.ignoredExtensionsManagementService.getIgnoredExtensions(d),T=this.getLocalExtensions(d).filter(O=>!w.some(y=>(0,h.areSameExtensions)({id:y},O.identifier)));return this.format(T)}if(this.extUri.isEqual(this.remoteResource,l)||this.extUri.isEqual(this.localResource,l)||this.extUri.isEqual(this.acceptedResource,l))return this.resolvePreviewContent(l);let f=await super.resolveContent(l);if(f)return f;if(f=await super.resolveContent(this.extUri.dirname(l)),f){const d=this.parseSyncData(f);if(d)switch(this.extUri.basename(l)){case"extensions.json":return this.format(this.parseExtensions(d))}}return null}format(l){l.sort((w,T)=>!w.identifier.uuid&&T.identifier.uuid?-1:w.identifier.uuid&&!T.identifier.uuid?1:(0,P.compare)(w.identifier.id,T.identifier.id));const f=JSON.stringify(l),d=(0,k.format)(f,void 0,{});return(0,A.applyEdits)(f,d)}async hasLocalData(){try{const l=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(l).some(d=>d.installed||d.disabled))return!0}catch(l){}return!1}async updateLocalExtensions(l,f,d,w){const T=[],O=[],y=await this.extensionManagementService.getInstalled();if(f.length){const F=y.filter(({identifier:q,isBuiltin:x})=>!x&&f.some(U=>(0,h.areSameExtensions)(q,U)));await D.Promises.settled(F.map(async q=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,q.identifier.id),await this.extensionManagementService.uninstall(q,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,q.identifier.id),T.push(q.identifier)}))}(l.length||d.length)&&await D.Promises.settled([...l,...d].map(async F=>{const q=y.find(U=>(0,h.areSameExtensions)(U.identifier,F.identifier));if(q&&q.isBuiltin){F.state&&q.manifest.version===F.version&&this.updateExtensionState(F.state,q.manifest.publisher,q.manifest.name,q.manifest.version),F.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,F.identifier.id),await this.extensionEnablementService.disableExtension(F.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,F.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,F.identifier.id),await this.extensionEnablementService.enableExtension(F.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,F.identifier.id)),T.push(F.identifier);return}const x=await this.extensionGalleryService.getCompatibleExtension(F.identifier,C.CURRENT_TARGET_PLATFORM);if(F.state&&(q?q.manifest.version===F.version:!!x)){const U=q?q.manifest.publisher:x.publisher,$=q?q.manifest.name:x.name;this.updateExtensionState(F.state,U,$,q?.manifest.version)}if(x)try{F.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,F.identifier.id,x.version),await this.extensionEnablementService.disableExtension(x.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,F.identifier.id,x.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,F.identifier.id,x.version),await this.extensionEnablementService.enableExtension(x.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,F.identifier.id,x.version)),q||(await this.extensionManagementService.canInstall(x)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,F.identifier.id,x.version),await this.extensionManagementService.installFromGallery(x,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,F.identifier.id,x.version),T.push(x.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,x.displayName||x.identifier.id),O.push(F)))}catch(U){O.push(F),this.logService.error(U),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,x.displayName||x.identifier.id)}else this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,F.identifier.id),O.push(F)}));const M=[];for(const F of w)T.some(q=>(0,h.areSameExtensions)(q,F.identifier))||M.push(F);for(const F of O)M.some(q=>(0,h.areSameExtensions)(q.identifier,F.identifier))||M.push(F);return M}updateExtensionState(l,f,d,w){const T=t(f,d,this.storageService),O=w?this.extensionsStorageSyncService.getKeysForSync({id:(0,h.getGalleryExtensionId)(f,d),version:w}):void 0;O?O.forEach(y=>{T[y]=l[y]}):Object.keys(l).forEach(y=>T[y]=l[y]),s(f,d,T,this.storageService)}parseExtensions(l){return JSON.parse(l.content)}getLocalExtensions(l){const f=this.extensionEnablementService.getDisabledExtensions();return l.map(({identifier:d,isBuiltin:w,manifest:T})=>{const O={identifier:d,version:T.version};f.some(y=>(0,h.areSameExtensions)(y,d))&&(O.disabled=!0),w||(O.installed=!0);try{const y=this.extensionsStorageSyncService.getKeysForSync({id:d.id,version:T.version});if(y){const M=t(T.publisher,T.name,this.storageService);O.state=Object.keys(M).reduce((F,q)=>(y.includes(q)&&(F[q]=M[q]),F),{})}}catch(y){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,L.getErrorMessage)(y))}return O})}};n.EXTENSIONS_DATA_URI=m.URI.from({scheme:o.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),n=de([Q(0,i.IEnvironmentService),Q(1,v.IFileService),Q(2,c.IStorageService),Q(3,o.IUserDataSyncStoreService),Q(4,o.IUserDataSyncBackupStoreService),Q(5,C.IExtensionManagementService),Q(6,C.IGlobalExtensionEnablementService),Q(7,p.IIgnoredExtensionsManagementService),Q(8,o.IUserDataSyncLogService),Q(9,C.IExtensionGalleryService),Q(10,E.IConfigurationService),Q(11,o.IUserDataSyncResourceEnablementService),Q(12,S.ITelemetryService),Q(13,I.IExtensionsStorageSyncService)],n),e.ExtensionsSynchroniser=n;let r=class extends b.AbstractInitializer{constructor(l,f,d,w,T){super("extensions",w,T,d);this.extensionManagementService=l,this.ignoredExtensionsManagementService=f}async parseExtensions(l){return l.syncData?await a(l.syncData,this.extensionManagementService):null}generatePreview(l,f){const d=[],w=[],T=[];for(const O of l){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(O.identifier.id))continue;const y=f.find(M=>(0,h.areSameExtensions)(M.identifier,O.identifier));y?(d.push(y),O.disabled&&T.push(O.identifier)):O.installed&&(w.push(O.identifier),O.disabled&&T.push(O.identifier))}return{installedExtensions:d,newExtensions:w,disabledExtensions:T,remoteExtensions:l}}};r=de([Q(0,C.IExtensionManagementService),Q(1,p.IIgnoredExtensionsManagementService),Q(2,v.IFileService),Q(3,i.IEnvironmentService),Q(4,o.IUserDataSyncLogService)],r),e.AbstractExtensionsInitializer=r}),define(te[200],ne([0,1,26,23]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(P,m,E,i,C){if(!m)return{remote:Object.keys(P).length>0?P:null,local:{added:{},removed:[],updated:{}}};const h=A(P,m);if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const v=E?A(E,m):{added:Object.keys(m).reduce((I,p)=>(I.add(p),I),new Set),removed:new Set,updated:new Set},c=E?A(E,P):{added:Object.keys(P).reduce((I,p)=>(I.add(p),I),new Set),removed:new Set,updated:new Set},S={added:{},removed:[],updated:{}},b=D.deepClone(m),g=!E;for(const I of c.added.values())I!==L.SYNC_SERVICE_URL_TYPE&&g&&v.added.has(I)||(b[I]=P[I]);for(const I of c.updated.values())b[I]=P[I];for(const I of c.removed.values())i.unregistered.includes(I)||delete b[I];for(const I of v.added.values()){const p=m[I];if(i.machine.includes(I)){C.info(`GlobalState: Skipped adding ${I} in local storage because it is declared as machine scoped.`);continue}if(E&&c.added.has(I))continue;const o=P[I];o&&o.value===p.value||I===L.SYNC_SERVICE_URL_TYPE&&g&&c.added.has(I)||(o?S.updated[I]=p:S.added[I]=p)}for(const I of v.updated.values()){const p=m[I];if(i.machine.includes(I)){C.info(`GlobalState: Skipped updating ${I} in local storage because it is declared as machine scoped.`);continue}if(c.updated.has(I)||c.removed.has(I))continue;const o=P[I];o&&o.value===p.value||(S.updated[I]=p)}for(const I of v.removed.values()){if(i.machine.includes(I)){C.trace(`GlobalState: Skipped removing ${I} in local storage because it is declared as machine scoped.`);continue}c.updated.has(I)||c.removed.has(I)||S.removed.push(I)}return{local:S,remote:k(b,m)?null:b}}e.merge=R;function A(P,m){const E=Object.keys(P),i=Object.keys(m),C=i.filter(c=>E.indexOf(c)===-1).reduce((c,S)=>(c.add(S),c),new Set),h=E.filter(c=>i.indexOf(c)===-1).reduce((c,S)=>(c.add(S),c),new Set),v=new Set;for(const c of E){if(h.has(c))continue;const S=P[c],b=m[c];D.equals(S,b)||v.add(c)}return{added:C,removed:h,updated:v}}function k(P,m){const{added:E,removed:i,updated:C}=A(P,m);return E.size===0&&i.size===0&&C.size===0}}),define(te[201],ne([0,1,25,3,33,43,48,4,5,30,20,12,13,14,45,21,22,47,54,200,23]),function(K,e,D,L,R,A,k,P,m,E,i,C,h,v,c,S,b,g,I,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const a="globalState.argv.",t=["locale"];function s(f){const d=f.storage?Object.keys(f.storage).sort():[],w={};d.forEach(y=>w[y]=f.storage[y]),f.storage=w;const T=JSON.stringify(f),O=(0,k.format)(T,void 0,{});return(0,A.applyEdits)(T,O)}const n=1;let r=class ot extends g.AbstractSynchroniser{constructor(d,w,T,O,y,M,F,q,x){super("globalState",d,y,x,w,T,M,F,O,q);this.storageService=x,this.version=n,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(d.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(L.Event.any(L.Event.filter(d.onDidFilesChange,U=>U.contains(this.environmentService.argvResource)),L.Event.filter(x.onDidChangeValue,U=>U.scope===0&&U.target!==void 0?U.target===0:x.keys(0,0).includes(U.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(d,w,T,O){const y=d.syncData?JSON.parse(d.syncData.content):null;w=w===null&&T?d:w;const M=w&&w.syncData?JSON.parse(w.syncData.content):null,F=await this.getLocalGlobalState();y?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const q=this.getStorageKeys(M),{local:x,remote:U}=(0,p.merge)(F.storage,y?y.storage:null,M?M.storage:null,q,this.logService),$={content:null,local:x,remote:U,localChange:Object.keys(x.added).length>0||Object.keys(x.updated).length>0||x.removed.length>0?2:0,remoteChange:U!==null?2:0};return[{localResource:this.localResource,localContent:s(F),localUserData:F,remoteResource:this.remoteResource,remoteContent:y?s(y):null,previewResource:this.previewResource,previewResult:$,localChange:$.localChange,remoteChange:$.remoteChange,acceptedResource:this.acceptedResource,storageKeys:q}]}async getMergeResult(d,w){return{...d.previewResult,hasConflicts:!1}}async getAcceptResult(d,w,T,O){if(this.extUri.isEqual(w,this.localResource))return this.acceptLocal(d);if(this.extUri.isEqual(w,this.remoteResource))return this.acceptRemote(d);if(this.extUri.isEqual(w,this.previewResource))return d.previewResult;throw new Error(`Invalid Resource: ${w.toString()}`)}async acceptLocal(d){return{content:d.localContent,local:{added:{},removed:[],updated:{}},remote:d.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(d){if(d.remoteContent!==null){const w=JSON.parse(d.remoteContent),{local:T,remote:O}=(0,p.merge)(d.localUserData.storage,w.storage,null,d.storageKeys,this.logService);return{content:d.remoteContent,local:T,remote:O,localChange:Object.keys(T.added).length>0||Object.keys(T.updated).length>0||T.removed.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:d.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(d,w,T,O){let{localUserData:y}=T[0][0],{local:M,remote:F,localChange:q,remoteChange:x}=T[0][1];if(q===0&&x===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),q!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(y)),await this.writeLocalGlobalState(M),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),x!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const U=JSON.stringify({storage:F});d=await this.updateRemoteUserData(U,O?null:d.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}w?.ref!==d.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(d),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:d}){return[{resource:this.extUri.joinPath(d,"globalState.json"),comparableResource:ot.GLOBAL_STATE_DATA_URI}]}async resolveContent(d){if(this.extUri.isEqual(d,ot.GLOBAL_STATE_DATA_URI)){const T=await this.getLocalGlobalState();return s(T)}if(this.extUri.isEqual(this.remoteResource,d)||this.extUri.isEqual(this.localResource,d)||this.extUri.isEqual(this.acceptedResource,d))return this.resolvePreviewContent(d);let w=await super.resolveContent(d);if(w)return w;if(w=await super.resolveContent(this.extUri.dirname(d)),w){const T=this.parseSyncData(w);if(T)switch(this.extUri.basename(d)){case"globalState.json":return s(JSON.parse(T.content))}}return null}async hasLocalData(){try{const{storage:d}=await this.getLocalGlobalState();if(Object.keys(d).length>1||d[`${a}.locale`]?.value!=="en")return!0}catch(d){}return!1}async getLocalGlobalState(){const d={},w=await this.getLocalArgvContent(),T=(0,R.parse)(w);for(const O of t)T[O]!==void 0&&(d[`${a}${O}`]={version:1,value:T[O]});for(const O of this.storageService.keys(0,0)){const y=this.storageService.get(O,0);y&&(d[O]={version:1,value:y})}return{storage:d}}async getLocalArgvContent(){try{return(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(d){}return"{}"}async writeLocalGlobalState({added:d,removed:w,updated:T}){const O={},y={},M=(q,x)=>{for(const U of q){if(U.startsWith(a)){O[U.substring(a.length)]=x?x[U].value:void 0;continue}if(x){const $=x[U];$.value!==String(this.storageService.get(U,0))&&(y[U]=$.value)}else this.storageService.get(U,0)!==void 0&&(y[U]=void 0)}};if(M(Object.keys(d),d),M(Object.keys(T),T),M(w),Object.keys(O).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(O),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(y).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const q of Object.keys(y))this.storageService.store(q,y[q],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(y))}}async updateArgv(d){const w=await this.getLocalArgvContent();let T=w;for(const O of Object.keys(d))T=(0,I.edit)(T,[O],d[O],{});w!==T&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(T)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(d){const w=this.storageService.keys(0,0),T=this.storageService.keys(0,1),O=[...w,...T],y=d?.storage?Object.keys(d.storage).filter(M=>!M.startsWith(a)&&!O.includes(M)&&this.storageService.get(M,0)!==void 0):[];if(!P.isWeb){const M=[...o.ALL_SYNC_RESOURCES.map(F=>(0,o.getEnablementKey)(F)),o.SYNC_SERVICE_URL_TYPE];y.push(...M),T.push(...M)}return{user:w,machine:T,unregistered:y}}};r.GLOBAL_STATE_DATA_URI=m.URI.from({scheme:o.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),r=de([Q(0,h.IFileService),Q(1,o.IUserDataSyncStoreService),Q(2,o.IUserDataSyncBackupStoreService),Q(3,o.IUserDataSyncLogService),Q(4,C.IEnvironmentService),Q(5,o.IUserDataSyncResourceEnablementService),Q(6,b.ITelemetryService),Q(7,i.IConfigurationService),Q(8,S.IStorageService)],r),e.GlobalStateSynchroniser=r;let u=class extends g.AbstractInitializer{constructor(d,w,T,O){super("globalState",T,O,w);this.storageService=d}async doInitialize(d){const w=d.syncData?JSON.parse(d.syncData.content):null;if(!w){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const T={},O={};for(const y of Object.keys(w.storage))y.startsWith(a)?T[y.substring(a.length)]=w.storage[y].value:this.storageService.get(y,0)===void 0&&(O[y]=w.storage[y].value);if(Object.keys(T).length){let y="{}";try{y=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(M){}for(const M of Object.keys(T))y=(0,I.edit)(y,[M],T[M],{});await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(y))}if(Object.keys(O).length)for(const y of Object.keys(O))this.storageService.store(y,O[y],0,0)}};u=de([Q(0,S.IStorageService),Q(1,h.IFileService),Q(2,C.IEnvironmentService),Q(3,o.IUserDataSyncLogService)],u),e.GlobalStateInitializer=u;let l=class{constructor(d,w,T,O,y){this.userDataSyncStoreClient=d,this.storageService=w,this.environmentService=T,this.fileService=O,this.logService=y}getSyncStoreType(d){return this.parseGlobalState(d)?.storage[o.SYNC_SERVICE_URL_TYPE]?.value}async sync(d){const w=(0,o.createSyncHeaders)((0,E.generateUuid)());try{return await this.doSync(d,w)}catch(T){if(T instanceof o.UserDataSyncError)switch(T.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(d,w)}throw T}}async doSync(d,w){const T=await this.userDataSyncStoreClient.read("globalState",null,w),O=this.parseGlobalState(T)||{storage:{}};O.storage[o.SYNC_SERVICE_URL_TYPE]={value:d,version:n};const y=await(0,c.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),M={version:n,machineId:y,content:s(O)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(M),T.ref,w)}parseGlobalState({content:d}){if(!d)return null;const w=JSON.parse(d);if((0,g.isSyncData)(w))return w?JSON.parse(w.content):null;throw new Error("Invalid remote data")}};l=de([Q(1,S.IStorageService),Q(2,C.IEnvironmentService),Q(3,h.IFileService),Q(4,v.ILogService)],l),e.UserDataSyncStoreTypeSynchronizer=l}),define(te[202],ne([0,1,18,25,3,33,4,16,129,20,12,13,21,22,47,197,23]),function(K,e,D,L,R,A,k,P,m,E,i,C,h,v,c,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function g(o,a){const t=JSON.parse(o);if(!a)return(0,P.isUndefined)(t.all)?null:t.all;switch(k.OS){case 2:return(0,P.isUndefined)(t.mac)?null:t.mac;case 3:return(0,P.isUndefined)(t.linux)?null:t.linux;case 1:return(0,P.isUndefined)(t.windows)?null:t.windows}}e.getKeybindingsContentFromSyncContent=g;let I=class extends c.AbstractJsonFileSynchroniser{constructor(a,t,s,n,r,u,l,f,d,w){super(l.keybindingsResource,"keybindings",u,l,f,a,t,r,w,s,d,n);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(R.Event.filter(n.onDidChangeConfiguration,T=>T.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(a,t,s,n){const r=a.syncData?this.getKeybindingsContentFromSyncContent(a.syncData.content):null;t=t===null&&s?a:t;const u=t?this.getKeybindingsContentFromLastSyncUserData(t):null,l=await this.getLocalFileContent(),f=await this.getFormattingOptions();let d=null,w=!1,T=!1,O=!1;if(r){let M=l?l.value.toString():"[]";if(M=M||"[]",this.hasErrors(M))throw new b.UserDataSyncError((0,m.localize)(0,null),"LocalInvalidContent",this.resource);if(!u||u!==M||u!==r){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const F=await(0,S.merge)(M,r,u,f,this.userDataSyncUtilService);F.hasChanges&&(d=F.mergeContent,O=F.hasConflicts,w=O||F.mergeContent!==M,T=O||F.mergeContent!==r)}}else l&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),d=l.value.toString(),T=!0);const y={content:d,localChange:w?l?2:1:0,remoteChange:T?2:0,hasConflicts:O};return[{fileContent:l,localResource:this.localResource,localContent:l?l.value.toString():null,localChange:y.localChange,remoteResource:this.remoteResource,remoteContent:r,remoteChange:y.remoteChange,previewResource:this.previewResource,previewResult:y,acceptedResource:this.acceptedResource}]}async getMergeResult(a,t){return a.previewResult}async getAcceptResult(a,t,s,n){if(this.extUri.isEqual(t,this.localResource))return{content:a.fileContent?a.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:a.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return s===void 0?{content:a.previewResult.content,localChange:a.previewResult.localChange,remoteChange:a.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(a,t,s,n){const{fileContent:r}=s[0][0];let{content:u,localChange:l,remoteChange:f}=s[0][1];if(l===0&&f===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),u!==null&&(u=u.trim(),u=u||"[]",this.hasErrors(u)))throw new b.UserDataSyncError((0,m.localize)(1,null),"LocalInvalidContent",this.resource);if(l!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),r&&await this.backupLocal(this.toSyncContent(r.value.toString())),await this.updateLocalFileContent(u||"[]",r,n),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),f!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const d=this.toSyncContent(u||"[]",a.syncData?.content);a=await this.updateRemoteUserData(d,n?null:a.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(d){}t?.ref!==a.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(a,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const a=await this.getLocalFileContent();if(a){const t=(0,A.parse)(a.value.toString());if((0,D.isNonEmptyArray)(t))return!0}}catch(a){if(a.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:a}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(a,"keybindings.json"),comparableResource:t}]}async resolveContent(a){if(this.extUri.isEqual(this.remoteResource,a)||this.extUri.isEqual(this.localResource,a)||this.extUri.isEqual(this.acceptedResource,a))return this.resolvePreviewContent(a);let t=await super.resolveContent(a);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(a)),t){const s=this.parseSyncData(t);if(s)switch(this.extUri.basename(a)){case"keybindings.json":return this.getKeybindingsContentFromSyncContent(s.content)}}return null}getKeybindingsContentFromLastSyncUserData(a){return!a.syncData||a.platformSpecific!==void 0&&a.platformSpecific!==this.syncKeybindingsPerPlatform()?null:this.getKeybindingsContentFromSyncContent(a.syncData.content)}getKeybindingsContentFromSyncContent(a){try{return g(a,this.syncKeybindingsPerPlatform())}catch(t){return this.logService.error(t),null}}toSyncContent(a,t){let s={};try{s=JSON.parse(t||"{}")}catch(n){this.logService.error(n)}switch(this.syncKeybindingsPerPlatform()?delete s.all:s.all=a,k.OS){case 2:s.mac=a;break;case 3:s.linux=a;break;case 1:s.windows=a;break}return JSON.stringify(s)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};I=de([Q(0,b.IUserDataSyncStoreService),Q(1,b.IUserDataSyncBackupStoreService),Q(2,b.IUserDataSyncLogService),Q(3,E.IConfigurationService),Q(4,b.IUserDataSyncResourceEnablementService),Q(5,C.IFileService),Q(6,i.IEnvironmentService),Q(7,h.IStorageService),Q(8,b.IUserDataSyncUtilService),Q(9,v.ITelemetryService)],I),e.KeybindingsSynchroniser=I;let p=class extends c.AbstractInitializer{constructor(a,t,s){super("keybindings",t,s,a)}async doInitialize(a){const t=a.syncData?this.getKeybindingsContentFromSyncContent(a.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,L.VSBuffer.fromString(t)),await this.updateLastSyncUserData(a)}async isEmpty(){try{const a=await this.fileService.readFile(this.environmentService.settingsResource),t=(0,A.parse)(a.value.toString());return!(0,D.isNonEmptyArray)(t)}catch(a){return a.fileOperationResult===1}}getKeybindingsContentFromSyncContent(a){try{return g(a,!0)}catch(t){return this.logService.error(t),null}}};p=de([Q(0,C.IFileService),Q(1,i.IEnvironmentService),Q(2,b.IUserDataSyncLogService)],p),e.KeybindingsInitializer=p}),define(te[203],ne([0,1,18,33,43,48,26,54,23]),function(K,e,D,L,R,A,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function E(l,f,d){let w=[];d?w=C(d):w=i(f);const T=[],O=[...(0,m.getDisallowedIgnoredSettings)()];if(Array.isArray(w))for(const y of w)y.startsWith("-")?O.push(y.substring(1)):T.push(y);return(0,D.distinct)([...l,...T].filter(y=>O.indexOf(y)===-1))}e.getIgnoredSettings=E;function i(l){let f=l.inspect("settingsSync.ignoredSettings").userValue;return f!==void 0||(f=l.inspect("sync.ignoredSettings").userValue,f!==void 0)?f:l.getValue("settingsSync.ignoredSettings")||[]}function C(l){const f=(0,L.parse)(l);return f?f["settingsSync.ignoredSettings"]||f["sync.ignoredSettings"]||[]:[]}function h(l,f,d,w){if(d.length){const T=u(f),O=(0,L.parse)(f),y=(0,L.parse)(l),M=[];for(const F of d){const q=O[F],x=y[F];q===void 0?l=P.edit(l,[F],void 0,w):x!==void 0?l=P.edit(l,[F],q,w):M.push(a(F,T))}M.sort((F,q)=>F.startOffset-q.startOffset),M.forEach(F=>l=g(F.setting.key,f,l,w))}return l}e.updateIgnoredSettings=h;function v(l,f,d,w,T,O){const y=h(l,f,w,O),M=d!==y,F=d!==f;if(!M&&!F)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(M&&!F)return{conflictsSettings:[],localContent:null,remoteContent:y,hasConflicts:!1};if(F&&!M)return{conflictsSettings:[],localContent:h(f,l,w,O),remoteContent:null,hasConflicts:!1};if(d===null&&S(l)){const X=c(l,f,w)?null:h(f,l,w,O);return{conflictsSettings:[],localContent:X,remoteContent:null,hasConflicts:!1}}let q=l,x=f;const U=(0,L.parse)(l),$=(0,L.parse)(f),B=d?(0,L.parse)(d):null,z=w.reduce((X,re)=>(X.add(re),X),new Set),j=b(U,$,z),N=b(B,U,z),G=b(B,$,z),_=new Map,J=new Set,Y=X=>{J.add(X);const re=T.filter(({key:oe})=>oe===X)[0];re?(q=P.edit(q,[X],re.value,O),x=P.edit(x,[X],re.value,O)):_.set(X,{key:X,localValue:U[X],remoteValue:$[X]})};for(const X of N.removed.values())G.updated.has(X)?Y(X):x=P.edit(x,[X],void 0,O);for(const X of G.removed.values())J.has(X)||(N.updated.has(X)?Y(X):q=P.edit(q,[X],void 0,O));for(const X of N.updated.values())J.has(X)||(G.updated.has(X)?j.updated.has(X)&&Y(X):x=P.edit(x,[X],U[X],O));for(const X of G.updated.values())J.has(X)||(N.updated.has(X)?j.updated.has(X)&&Y(X):q=P.edit(q,[X],$[X],O));for(const X of N.added.values())J.has(X)||(G.added.has(X)?j.updated.has(X)&&Y(X):x=g(X,q,x,O));for(const X of G.added.values())J.has(X)||(N.added.has(X)?j.updated.has(X)&&Y(X):q=g(X,x,q,O));const H=_.size>0||!c(q,x,w),W=H||!c(q,l,[]),Z=H||!c(x,f,[]);return{localContent:W?q:null,remoteContent:Z?x:null,conflictsSettings:[..._.values()],hasConflicts:H}}e.merge=v;function c(l,f,d){if(l===f)return!0;const w=(0,L.parse)(l),T=(0,L.parse)(f),O=d.reduce((F,q)=>(F.add(q),F),new Set),y=u(l).filter(F=>!(F.setting&&O.has(F.setting.key))),M=u(f).filter(F=>!(F.setting&&O.has(F.setting.key)));if(y.length!==M.length)return!1;for(let F=0;F<y.length;F++){const q=y[F],x=M[F];if(q.setting&&x.setting){if(q.setting.key!==x.setting.key||!k.equals(w[q.setting.key],T[q.setting.key]))return!1}else if(!q.setting&&!x.setting){if(q.value!==x.value)return!1}else return!1}return!0}e.areSame=c;function S(l){return l?u(l).length===0:!0}e.isEmpty=S;function b(l,f,d){const w=l?Object.keys(l).filter(F=>!d.has(F)):[],T=Object.keys(f).filter(F=>!d.has(F)),O=T.filter(F=>w.indexOf(F)===-1).reduce((F,q)=>(F.add(q),F),new Set),y=w.filter(F=>T.indexOf(F)===-1).reduce((F,q)=>(F.add(q),F),new Set),M=new Set;if(l)for(const F of w){if(y.has(F))continue;const q=l[F],x=f[F];k.equals(q,x)||M.add(F)}return{added:O,removed:y,updated:M}}function g(l,f,d,w){const T=(0,L.parse)(f),O=u(f),y=u(d),M=I(l,O,y);return p(d,l,T[l],M,y,w)}e.addSetting=g;function I(l,f,d){const w=f.findIndex(O=>O.setting?.key===l),T=f[w-1];if(T){if(T.setting){const y=a(T.setting.key,d);if(y)return{index:d.indexOf(y),insertAfter:!0}}else{const y=t(w,f);if(y){const M=a(y.setting.key,d);if(M){const F=s(d.indexOf(M),d),q=n(f,y,f[w]);if(F){const x=n(d,M,F),U=r(q,x);return U?{index:d.indexOf(U),insertAfter:!0}:{index:d.indexOf(F),insertAfter:!1}}else{const x=n(d,M,d[d.length-1]),U=r(q,x);return U?{index:d.indexOf(U),insertAfter:!0}:{index:d.length-1,insertAfter:!0}}}}}const O=f[w+1];if(O)if(O.setting){const y=a(O.setting.key,d);if(y)return{index:d.indexOf(y),insertAfter:!1}}else{const y=s(w,f);if(y){const M=a(y.setting.key,d);if(M){const F=t(d.indexOf(M),d),q=n(f,f[w],y);if(F){const x=n(d,F,M),U=r(q.reverse(),x.reverse());return U?{index:d.indexOf(U),insertAfter:!1}:{index:d.indexOf(F),insertAfter:!0}}else{const x=n(d,d[0],M),U=r(q.reverse(),x.reverse());return U?{index:d.indexOf(U),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:d.length-1,insertAfter:!0}}function p(l,f,d,w,T,O){let y;return w.index===-1?y=(0,R.setProperty)(l,[f],d,O):y=o(l,f,d,w,T,O).map(M=>(0,R.withFormatting)(l,M,O)[0]),(0,R.applyEdits)(l,y)}function o(l,f,d,w,T,O){const y=`${JSON.stringify(f)}: ${JSON.stringify(d)}`,M=(0,A.getEOL)(O,l),F=T[w.index];if(w.insertAfter){const q=[];if(F.setting)q.push({offset:F.endOffset,length:0,content:","+y});else{const x=s(w.index,T),U=t(w.index,T),$=U?.setting?.commaOffset;U&&$===void 0&&q.push({offset:U.endOffset,length:0,content:","});const B=$!==void 0&&$>F.endOffset;q.push({offset:B?$+1:F.endOffset,length:0,content:x?M+y+",":M+y})}return q}else{if(F.setting)return[{offset:F.startOffset,length:0,content:y+","}];const q=(T[w.index-1]&&!T[w.index-1].setting?M:"")+y+(s(w.index,T)?",":"")+M;return[{offset:F.startOffset,length:0,content:q}]}}function a(l,f){return f.filter(d=>d.setting?.key===l)[0]}function t(l,f){for(let d=l-1;d>=0;d--)if(f[d].setting)return f[d]}function s(l,f){for(let d=l+1;d<f.length;d++)if(f[d].setting)return f[d]}function n(l,f,d){const w=l.indexOf(f),T=l.indexOf(d);return l.filter((O,y)=>w<y&&y<T)}function r(l,f){if(l.length&&f.length){let d=0;for(;d<f.length&&d<l.length;d++)if(l[d].value!==f[d].value)return f[d-1];return f[d-1]}}function u(l){const f=[];let d=-1,w,T;const O={onObjectBegin:y=>{d++},onObjectProperty:(y,M,F)=>{d===0&&(w=M,T=y)},onObjectEnd:(y,M)=>{d--,d===0&&f.push({startOffset:w,endOffset:y+M,value:l.substring(w,y+M),setting:{key:T,commaOffset:void 0}})},onArrayBegin:(y,M)=>{d++},onArrayEnd:(y,M)=>{d--,d===0&&f.push({startOffset:w,endOffset:y+M,value:l.substring(w,y+M),setting:{key:T,commaOffset:void 0}})},onLiteralValue:(y,M,F)=>{d===0&&f.push({startOffset:w,endOffset:M+F,value:l.substring(w,M+F),setting:{key:T,commaOffset:void 0}})},onSeparator:(y,M,F)=>{if(d===0&&y===","){let q=f.length-1;for(;q>=0&&!f[q].setting;q--);const x=f[q];x&&f.splice(q,1,{startOffset:x.startOffset,endOffset:x.endOffset,value:x.value,setting:{key:x.setting.key,commaOffset:M}})}},onComment:(y,M)=>{d===0&&f.push({startOffset:y,endOffset:y+M,value:l.substring(y,y+M)})}};return(0,L.visit)(l,O),f}}),define(te[204],ne([0,1,25,3,43,130,20,12,27,13,21,22,47,54,203,23]),function(K,e,D,L,R,A,k,P,m,E,i,C,h,v,c,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function b(a){return a&&a.settings&&typeof a.settings=="string"&&Object.keys(a).length===1}function g(a){const t=JSON.parse(a);return b(t)?t:{settings:a}}e.parseSettingsSyncContent=g;let I=class extends h.AbstractJsonFileSynchroniser{constructor(t,s,n,r,u,l,f,d,w,T,O){super(s.settingsResource,"settings",t,s,n,r,u,w,T,l,f,d);this.extensionManagementService=O,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async generateSyncPreview(t,s,n,r){const u=await this.getLocalFileContent(),l=await this.getFormattingOptions(),f=this.getSettingsSyncContent(t);s=s===null&&n?t:s;const d=s?this.getSettingsSyncContent(s):null,w=await this.getIgnoredSettings();let T=null,O=!1,y=!1,M=!1;if(f){let q=u?u.value.toString().trim():"{}";q=q||"{}",this.validateContent(q),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const x=(0,c.merge)(q,f.settings,d?d.settings:null,w,[],l);T=x.localContent||x.remoteContent,O=x.localContent!==null,y=x.remoteContent!==null,M=x.hasConflicts}else u&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),T=u.value.toString(),y=!0);const F={content:T,localChange:O?2:0,remoteChange:y?2:0,hasConflicts:M};return[{fileContent:u,localResource:this.localResource,localContent:u?u.value.toString():null,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:f?f.settings:null,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async getMergeResult(t,s){const n=await this.getFormattingOptions(),r=await this.getIgnoredSettings();return{...t.previewResult,content:t.previewResult.content?(0,c.updateIgnoredSettings)(t.previewResult.content,"{}",r,n):null}}async getAcceptResult(t,s,n,r){const u=await this.getFormattingOptions(),l=await this.getIgnoredSettings();if(this.extUri.isEqual(s,this.localResource))return{content:t.fileContent?(0,c.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",l,u):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(s,this.remoteResource))return{content:t.remoteContent!==null?(0,c.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",l,u):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(s,this.previewResource))return n===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:n!==null?(0,c.updateIgnoredSettings)(n,t.fileContent?t.fileContent.value.toString():"{}",l,u):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${s.toString()}`)}async applyResult(t,s,n,r){const{fileContent:u}=n[0][0];let{content:l,localChange:f,remoteChange:d}=n[0][1];if(f===0&&d===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),l=l?l.trim():"{}",l=l||"{}",this.validateContent(l),f!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),u&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(u.value.toString()))),await this.updateLocalFileContent(l,u,r),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),d!==0){const w=await this.getFormattingOptions(),T=this.getSettingsSyncContent(t),O=await this.getIgnoredSettings(l);l=(0,c.updateIgnoredSettings)(l,T?T.settings:"{}",O,w),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(l)),r?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(w){}s?.ref!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const s=await this.getFormattingOptions(),n=(0,v.edit)(t.value.toString(),[S.CONFIGURATION_SYNC_STORE_KEY],void 0,s);return!(0,c.isEmpty)(n)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const s=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:s}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let s=await super.resolveContent(t);if(s)return s;if(s=await super.resolveContent(this.extUri.dirname(t)),s){const n=this.parseSyncData(s);if(n){const r=this.parseSettingsSyncContent(n.content);if(r)switch(this.extUri.basename(t)){case"settings.json":return r.settings}}}return null}async resolvePreviewContent(t){let s=await super.resolvePreviewContent(t);if(s){const n=await this.getFormattingOptions(),r=await this.getIgnoredSettings();s=(0,c.updateIgnoredSettings)(s,"{}",r,n)}return s}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return g(t)}catch(s){this.logService.error(s)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const n=L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtensions,r=>r.some(({local:u})=>!!u)),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,r=>!r.error))(()=>{n.dispose(),this._defaultIgnoredSettings=void 0})}const s=await this._defaultIgnoredSettings;return(0,c.getIgnoredSettings)(s,this.configurationService,t)}validateContent(t){if(this.hasErrors(t))throw new S.UserDataSyncError((0,A.localize)(0,null),"LocalInvalidContent",this.resource)}async recoverSettings(){try{const t=await this.getLocalFileContent();if(!t)return;const s=JSON.parse(t.value.toString());if(!o(s))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const n=this.parseSettingsSyncContent(s.content);if(!n||!n.settings)return;let r=n.settings;const u=await this.getFormattingOptions();for(const l in s)if(["version","content","machineId"].indexOf(l)===-1&&s[l]!==void 0){const f=(0,R.setProperty)(r,[l],s[l],u);f.length&&(r=(0,R.applyEdits)(r,f))}await this.fileService.writeFile(this.file,D.VSBuffer.fromString(r))}catch(t){}}};I=de([Q(0,E.IFileService),Q(1,P.IEnvironmentService),Q(2,i.IStorageService),Q(3,S.IUserDataSyncStoreService),Q(4,S.IUserDataSyncBackupStoreService),Q(5,S.IUserDataSyncLogService),Q(6,S.IUserDataSyncUtilService),Q(7,k.IConfigurationService),Q(8,S.IUserDataSyncResourceEnablementService),Q(9,C.ITelemetryService),Q(10,m.IExtensionManagementService)],I),e.SettingsSynchroniser=I;let p=class extends h.AbstractInitializer{constructor(t,s,n){super("settings",s,n,t)}async doInitialize(t){const s=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!s){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,D.VSBuffer.fromString(s.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return(0,c.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return g(t)}catch(s){this.logService.error(s)}return null}};p=de([Q(0,E.IFileService),Q(1,P.IEnvironmentService),Q(2,S.IUserDataSyncLogService)],p),e.SettingsInitializer=p;function o(a){return!!(a&&a.version!==void 0&&typeof a.version=="number"&&a.content!==void 0&&typeof a.content=="string"&&a.machineId!==void 0&&typeof a.machineId=="string")}}),define(te[205],ne([0,1,25,3,26,20,12,13,21,22,47,198,23]),function(K,e,D,L,R,A,k,P,m,E,i,C,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let v=class extends i.AbstractSynchroniser{constructor(b,g,I,p,o,a,t,s,n){super("snippets",g,b,I,p,o,s,n,a,t);this.version=1,this.snippetsFolder=b.snippetsHome,this._register(this.fileService.watch(b.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(L.Event.filter(this.fileService.onDidFilesChange,r=>r.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(b,g,I,p){const o=await this.getSnippetsFileContents(),a=this.toSnippetsContents(o),t=b.syncData?this.parseSnippets(b.syncData):null;g=g===null&&I?b:g;const s=g&&g.syncData?this.parseSnippets(g.syncData):null;t?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const n=(0,C.merge)(a,t,s);return this.getResourcePreviews(n,o,t||{})}async getMergeResult(b,g){return b.previewResult}async getAcceptResult(b,g,I,p){if(this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:b.fileContent?b.fileContent.value.toString():null,localChange:0,remoteChange:b.fileContent?b.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:b.remoteContent,localChange:b.remoteContent!==null?b.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(g,this.syncPreviewFolder))return I===void 0?{content:b.previewResult.content,localChange:b.previewResult.localChange,remoteChange:b.previewResult.remoteChange}:{content:I,localChange:I===null?b.fileContent!==null?3:0:2,remoteChange:I===null?b.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${g.toString()}`)}async applyResult(b,g,I,p){const o=I.map(([a,t])=>({...a,acceptResult:t}));o.every(({localChange:a,remoteChange:t})=>a===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),o.some(({localChange:a})=>a!==0)&&(await this.updateLocalBackup(o),await this.updateLocalSnippets(o,p)),o.some(({remoteChange:a})=>a!==0)&&(b=await this.updateRemoteSnippets(o,b,p)),g?.ref!==b.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(b),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:a}of o)try{await this.fileService.del(a)}catch(t){}}getResourcePreviews(b,g,I){const p=new Map;for(const o of Object.keys(b.local.added)){const a={content:b.local.added[o],hasConflicts:!1,localChange:1,remoteChange:0};p.set(o,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(b.local.updated)){const a={content:b.local.updated[o],hasConflicts:!1,localChange:2,remoteChange:0};p.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:g[o],localContent:g[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of b.local.removed){const a={content:null,hasConflicts:!1,localChange:3,remoteChange:0};p.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:g[o],localContent:g[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(b.remote.added)){const a={content:b.remote.added[o],hasConflicts:!1,localChange:0,remoteChange:1};p.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:g[o],localContent:g[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(b.remote.updated)){const a={content:b.remote.updated[o],hasConflicts:!1,localChange:0,remoteChange:2};p.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:g[o],localContent:g[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of b.remote.removed){const a={content:null,hasConflicts:!1,localChange:0,remoteChange:3};p.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of b.conflicts){const a={content:g[o]?g[o].value.toString():null,hasConflicts:!0,localChange:g[o]?2:1,remoteChange:I[o]?2:1};p.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:g[o]||null,localContent:g[o]?g[o].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[o]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(g))if(!p.has(o)){const a={content:g[o]?g[o].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};p.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:g[o]||null,localContent:g[o]?g[o].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[o]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...p.values()]}async getAssociatedResources({uri:b}){let g=await super.resolveContent(b);if(g){const I=this.parseSyncData(g);if(I){const p=this.parseSnippets(I),o=[];for(const a of Object.keys(p)){const t=this.extUri.joinPath(b,a),s=this.extUri.joinPath(this.snippetsFolder,a),n=await this.fileService.exists(s);o.push({resource:t,comparableResource:n?s:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"})})}return o}}return[]}async resolveContent(b){if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(b);let g=await super.resolveContent(b);if(g)return g;if(g=await super.resolveContent(this.extUri.dirname(b)),g){const I=this.parseSyncData(g);if(I)return this.parseSnippets(I)[this.extUri.basename(b)]||null}return null}async hasLocalData(){try{const b=await this.getSnippetsFileContents();if(Object.keys(b).length)return!0}catch(b){}return!1}async updateLocalBackup(b){const g={};for(const I of b)I.fileContent&&(g[this.extUri.basename(I.localResource)]=I.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(g)))}async updateLocalSnippets(b,g){for(const{fileContent:I,acceptResult:p,localResource:o,remoteResource:a,localChange:t}of b)if(t!==0){const s=a?this.extUri.basename(a):this.extUri.basename(o),n=this.extUri.joinPath(this.snippetsFolder,s);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(n)),await this.fileService.del(n),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(n))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(n)),await this.fileService.createFile(n,D.VSBuffer.fromString(p.content),{overwrite:g}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(n))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(n)),await this.fileService.writeFile(n,D.VSBuffer.fromString(p.content),g?void 0:I),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(n)))}}async updateRemoteSnippets(b,g,I){const p=g.syncData?this.parseSnippets(g.syncData):{},o=(0,R.deepClone)(p);for(const{acceptResult:a,localResource:t,remoteResource:s,remoteChange:n}of b)if(n!==0){const r=t?this.extUri.basename(t):this.extUri.basename(s);n===3?delete o[r]:o[r]=a.content}return(0,C.areSame)(p,o)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),g=await this.updateRemoteUserData(JSON.stringify(o),I?null:g.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),g}parseSnippets(b){return JSON.parse(b.content)}toSnippetsContents(b){const g={};for(const I of Object.keys(b))g[I]=b[I].value.toString();return g}async getSnippetsFileContents(){const b={};let g;try{g=await this.fileService.resolve(this.snippetsFolder)}catch(I){if(I instanceof P.FileOperationError&&I.fileOperationResult===1)return b;throw I}for(const I of g.children||[]){const p=I.resource,o=this.extUri.extname(p);if(o===".json"||o===".code-snippets"){const a=this.extUri.relativePath(this.snippetsFolder,p),t=await this.fileService.readFile(p);b[a]=t}}return b}};v=de([Q(0,k.IEnvironmentService),Q(1,P.IFileService),Q(2,m.IStorageService),Q(3,h.IUserDataSyncStoreService),Q(4,h.IUserDataSyncBackupStoreService),Q(5,h.IUserDataSyncLogService),Q(6,A.IConfigurationService),Q(7,h.IUserDataSyncResourceEnablementService),Q(8,E.ITelemetryService)],v),e.SnippetsSynchroniser=v;let c=class extends i.AbstractInitializer{constructor(b,g,I){super("snippets",g,I,b)}async doInitialize(b){const g=b.syncData?JSON.parse(b.syncData.content):null;if(!g){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const p of Object.keys(g)){const o=g[p];if(o){const a=this.extUri.joinPath(this.environmentService.snippetsHome,p);await this.fileService.createFile(a,D.VSBuffer.fromString(o)),this.logService.info("Created snippet",this.extUri.basename(a))}}await this.updateLastSyncUserData(b)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(b){return b.fileOperationResult===1}}};c=de([Q(0,P.IFileService),Q(1,k.IEnvironmentService),Q(2,h.IUserDataSyncLogService)],c),e.SnippetsInitializer=c}),define(te[60],ne([0,1,3,2,7,23]),function(K,e,D,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,R.createDecorator)("IUserDataSyncAccountService");let k=class extends L.Disposable{constructor(m){super();this.userDataSyncStoreService=m,this._onDidChangeAccount=this._register(new D.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new D.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(m.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(m.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(m){(m&&this._account?m.token!==this._account.token||m.authenticationProviderId!==this._account.authenticationProviderId:m!==this._account)&&(this._account=m,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(m))}};k=de([Q(0,A.IUserDataSyncStoreService)],k),e.UserDataSyncAccountService=k}),define(te[206],ne([0,1,6,25,56,2,15,20,12,13,23]),function(K,e,D,L,R,A,k,P,m,E,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let C=class extends A.Disposable{constructor(v,c,S,b){super();this.environmentService=v,this.fileService=c,this.configurationService=S,this.logService=b,i.ALL_SYNC_RESOURCES.forEach(g=>this.cleanUpBackup(g))}async getAllRefs(v){const c=(0,k.joinPath)(this.environmentService.userDataSyncHome,v),S=await this.fileService.resolve(c);return S.children?S.children.filter(g=>g.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(g.name)).sort().reverse().map(g=>({ref:g.name,created:this.getCreationTime(g)})):[]}async resolveContent(v,c){if(!c){const S=await this.getAllRefs(v);S.length&&(c=S[S.length-1].ref)}if(c){const S=(0,k.joinPath)(this.environmentService.userDataSyncHome,v,c);return(await this.fileService.readFile(S)).value.toString()}return null}async backup(v,c){const S=(0,k.joinPath)(this.environmentService.userDataSyncHome,v),b=(0,k.joinPath)(S,`${(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(b,L.VSBuffer.fromString(c))}catch(g){this.logService.error(g)}try{this.cleanUpBackup(v)}catch(g){}}async cleanUpBackup(v){const c=(0,k.joinPath)(this.environmentService.userDataSyncHome,v);try{try{if(!await this.fileService.exists(c))return}catch(b){return}const S=await this.fileService.resolve(c);if(S.children){const b=S.children.filter(o=>o.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(o.name)).sort(),g=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let I=b.filter(o=>Date.now()-this.getCreationTime(o)>g);const p=b.length-I.length;p<10&&(I=I.slice(10-p)),await D.Promises.settled(I.map(async o=>{this.logService.info("Deleting from backup",o.resource.path),await this.fileService.del(o.resource)}))}}catch(S){this.logService.error(S)}}getCreationTime(v){return v.ctime||new Date(parseInt(v.name.substring(0,4)),parseInt(v.name.substring(4,6))-1,parseInt(v.name.substring(6,8)),parseInt(v.name.substring(9,11)),parseInt(v.name.substring(11,13)),parseInt(v.name.substring(13,15))).getTime()}};C=de([Q(0,m.IEnvironmentService),Q(1,E.IFileService),Q(2,P.IConfigurationService),Q(3,i.IUserDataSyncLogService)],C),e.UserDataSyncBackupStoreService=C}),define(te[207],ne([0,1,2,5]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class R{constructor(h){this.service=h}listen(h,v){switch(v){case"onError":return this.service.onError}throw new Error(`Event not found: ${v}`)}call(h,v,c){switch(v){case"triggerSync":return this.service.triggerSync(c[0],c[1],c[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(c[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=R;class A{constructor(h){this.service=h}listen(h,v){throw new Error(`Event not found: ${v}`)}call(h,v,c){switch(v){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(c[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(L.URI.revive(c[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=A;class k{constructor(h){this.channel=h}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(h){return this.channel.call("resolveUserKeybindings",[h])}async resolveFormattingOptions(h){return this.channel.call("resolveFormattingOptions",[h])}}e.UserDataSyncUtilServiceClient=k;class P{constructor(h){this.service=h}listen(h,v){switch(v){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${v}`)}async call(h,v,c){switch(v){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(c[0],c[1]);case"setEnablement":return this.service.setEnablement(c[0],c[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class m{constructor(h){this.service=h}listen(h,v){switch(v){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${v}`)}call(h,v,c){switch(v){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(c)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=m;class E{constructor(h){this.service=h}listen(h,v){switch(v){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${v}`)}call(h,v,c){switch(v){case"switch":return this.service.switch(c[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=E;class i extends D.Disposable{constructor(h){super();this.channel=h,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(h){return this.channel.call("switch",[h])}async getPreviousUserDataSyncStore(){const h=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(h)}revive(h){return{url:L.URI.revive(h.url),type:h.type,defaultUrl:L.URI.revive(h.defaultUrl),insidersUrl:L.URI.revive(h.insidersUrl),stableUrl:L.URI.revive(h.stableUrl),canSwitch:h.canSwitch,authenticationProviders:h.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=i}),define(te[208],ne([0,1,12,14]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let R=class extends L.AbstractLogger{constructor(k,P){super();this.logger=this._register(k.createLogger(P.userDataSyncLogResource,{name:"settingssync"}))}trace(k,...P){this.logger.trace(k,...P)}debug(k,...P){this.logger.debug(k,...P)}info(k,...P){this.logger.info(k,...P)}warn(k,...P){this.logger.warn(k,...P)}error(k,...P){this.logger.error(k,...P)}critical(k,...P){this.logger.critical(k,...P)}flush(){this.logger.flush()}};R=de([Q(0,L.ILoggerService),Q(1,D.IEnvironmentService)],R),e.UserDataSyncLogService=R}),define(te[61],ne([0,1,3,2,4,24,133,12,13,7,28,45,21,23]),function(K,e,D,L,R,A,k,P,m,E,i,C,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,E.createDecorator)("IUserDataSyncMachinesService");const c="sync.currentMachineName";let S=class Je extends L.Disposable{constructor(g,I,p,o,a,t){super();this.storageService=p,this.userDataSyncStoreService=o,this.logService=a,this.productService=t,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,C.getServiceMachineId)(g,I,p)}async getMachines(g){const I=await this.currentMachineIdPromise;return(await this.readMachinesData(g)).machines.map(o=>({...o,isCurrent:o.id===I}))}async addCurrentMachine(g){const I=await this.currentMachineIdPromise,p=await this.readMachinesData(g);p.machines.some(({id:o})=>o===I)||(p.machines.push({id:I,name:this.computeCurrentMachineName(p.machines)}),await this.writeMachinesData(p))}async removeCurrentMachine(g){const I=await this.currentMachineIdPromise,p=await this.readMachinesData(g),o=p.machines.filter(({id:a})=>a!==I);o.length!==p.machines.length&&(p.machines=o,await this.writeMachinesData(p))}async renameMachine(g,I,p){const o=await this.currentMachineIdPromise,a=await this.readMachinesData(p),t=a.machines.find(({id:s})=>s===g);t&&(t.name=I,await this.writeMachinesData(a),a.machines.some(({id:s})=>s===o)&&this.storageService.store(c,I,0,1))}async setEnablement(g,I){const p=await this.readMachinesData(),o=p.machines.find(({id:a})=>a===g);o&&(o.disabled=I?void 0:!0,await this.writeMachinesData(p))}computeCurrentMachineName(g){const I=this.storageService.get(c,0);if(I)return I;const p=`${this.productService.nameLong} (${(0,R.PlatformToString)(R.isWeb?0:R.platform)})`,o=new RegExp(`${(0,A.escapeRegExpCharacters)(p)}\\s#(\\d+)`);let a=0;for(const t of g){const s=o.exec(t.name),n=s?parseInt(s[1]):0;a=n>a?n:a}return`${p} #${a+1}`}async readMachinesData(g){this.userData=await this.readUserData(g);const I=this.parse(this.userData);if(I.version!==Je.VERSION)throw new Error((0,k.localize)(0,null,this.productService.nameLong));return I}async writeMachinesData(g){const I=JSON.stringify(g),p=await this.userDataSyncStoreService.write(Je.RESOURCE,I,this.userData?.ref||null);this.userData={ref:p,content:I},this._onDidChange.fire()}async readUserData(g){if(this.userData){const I=g&&g.latest?g.latest[Je.RESOURCE]:void 0;if(this.userData.ref===I)return this.userData;if(I===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(Je.RESOURCE,this.userData)}parse(g){if(g.content!==null)try{return JSON.parse(g.content)}catch(I){this.logService.error(I)}return{version:Je.VERSION,machines:[]}}};S.VERSION=1,S.RESOURCE="machines",S=de([Q(0,P.IEnvironmentService),Q(1,m.IFileService),Q(2,h.IStorageService),Q(3,v.IUserDataSyncStoreService),Q(4,v.IUserDataSyncLogService),Q(5,i.IProductService)],S),e.UserDataSyncMachinesService=S}),define(te[89],ne([0,1,6,56,37,11,3,2,4,15,5,131,12,28,21,22,23,60,61]),function(K,e,D,L,R,A,k,P,m,E,i,C,h,v,c,S,b,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const p="sync.enable",o="sync.disableMachineEventually",a="sync.sessionId",t="sync.storeUrl",s="sync.productQuality";let n=class extends P.Disposable{constructor(f,d,w){super();this.storageService=f,this.environmentService=d,this.userDataSyncStoreManagementService=w,this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(f.onDidChangeValue(T=>this.onDidStorageChange(T)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(p,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(f){f&&!this.canToggleEnablement()||this.storageService.store(p,f,0,1)}onDidStorageChange(f){if(f.scope===0&&p===f.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};n=de([Q(0,c.IStorageService),Q(1,h.IEnvironmentService),Q(2,b.IUserDataSyncStoreManagementService)],n),e.UserDataAutoSyncEnablementService=n;let r=class extends P.Disposable{constructor(f,d,w,T,O,y,M,F,q,x,U){super();this.userDataSyncStoreManagementService=d,this.userDataSyncStoreService=w,this.userDataSyncResourceEnablementService=T,this.userDataSyncService=O,this.logService=y,this.userDataSyncAccountService=M,this.telemetryService=F,this.userDataSyncMachinesService=q,this.storageService=x,this.autoSync=this._register(new P.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=U,this.syncTriggerDelayer=this._register(new D.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=d.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=f.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(d.onDidChangeUserDataSyncStore(()=>{(0,E.isEqual)(this.syncUrl,d.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=d.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(M.onDidChangeAccount(()=>this.updateAutoSync())),this._register(w.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(k.Event.debounce(O.onDidChangeLocal,($,B)=>$?[...$,B]:[B],1e3)($=>this.triggerSync($,!1,!1))),this._register(k.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,$])=>$)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const f=this.storageService.get(t,0);return f?i.URI.parse(f):void 0}set syncUrl(f){f?this.storageService.store(t,f.toString(),0,1):this.storageService.remove(t,0)}get productQuality(){return this.storageService.get(s,0)}set productQuality(f){f?this.storageService.store(s,f,0,1):this.storageService.remove(s,0)}updateAutoSync(){const{enabled:f,message:d}=this.isAutoSyncEnabled();f?this.autoSync.value===void 0&&(this.autoSync.value=new u(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(w=>this.onDidFinishSync(w))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(d&&this.logService.info(d),this.autoSync.clear()):d&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(d))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,L.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(f,d,w){try{this.userDataSyncAccountService.account&&!w&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(a,0),f?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(T){if(d)this.logService.error(T),this.updateEnablement(!1);else throw T}}updateEnablement(f){this.userDataAutoSyncEnablementService.isEnabled()!==f&&(this.telemetryService.publicLog2(p,{enabled:f}),this.userDataAutoSyncEnablementService.setEnablement(f),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(f){if(!f){this.successiveFailures=0;return}const d=b.UserDataSyncError.toUserDataSyncError(f);d instanceof b.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:d.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),d.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):d.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):d.code==="LocalTooManyRequests"||d.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):d.code==="UpgradeRequired"||d.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):d.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${d.resource} content with newer version than of client. Requires client upgrade.`)):d.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${d.resource} content with older version than of client. Requires server reset.`)):d.code==="ServiceChanged"||d.code==="DefaultServiceChanged"?m.isWeb&&d.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(d),this.successiveFailures++),this._onError.fire(d)}async disableMachineEventually(){this.storageService.store(o,!0,0,1),await(0,D.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(o,0,!1)}stopDisableMachineEventually(){this.storageService.remove(o,0)}async triggerSync(f,d,w){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(d&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...f),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",w)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};r=de([Q(0,v.IProductService),Q(1,b.IUserDataSyncStoreManagementService),Q(2,b.IUserDataSyncStoreService),Q(3,b.IUserDataSyncResourceEnablementService),Q(4,b.IUserDataSyncService),Q(5,b.IUserDataSyncLogService),Q(6,g.IUserDataSyncAccountService),Q(7,S.ITelemetryService),Q(8,I.IUserDataSyncMachinesService),Q(9,c.IStorageService),Q(10,b.IUserDataAutoSyncEnablementService)],r),e.UserDataAutoSyncService=r;class u extends P.Disposable{constructor(f,d,w,T,O,y,M,F){super();this.lastSyncUrl=f,this.interval=d,this.userDataSyncStoreManagementService=w,this.userDataSyncStoreService=T,this.userDataSyncService=O,this.userDataSyncMachinesService=y,this.logService=M,this.storageService=F,this.intervalHandler=this._register(new P.MutableDisposable),this._onDidStartSync=this._register(new k.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new k.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,P.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(u.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,D.disposableTimeout)(()=>this.sync(u.INTERVAL_SYNCING,!1),this.interval)}sync(f,d){const w=(0,D.createCancelablePromise)(async T=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(O){if((0,A.isPromiseCanceledError)(O))return}return this.doSync(f,d,T)});return this.syncPromise=w,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,E.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const f=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),d=this.userDataSyncStoreManagementService.userDataSyncStore;return!!d&&!!f&&(!(0,E.isEqual)(d.defaultUrl,f.defaultUrl)||!(0,E.isEqual)(d.insidersUrl,f.insidersUrl)||!(0,E.isEqual)(d.stableUrl,f.stableUrl))}async doSync(f,d,w){this.logService.info(`Auto Sync: Triggered by ${f}`),this._onDidStartSync.fire();let T;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,d),w.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new b.UserDataAutoSyncError((0,C.localize)(0,null),"DefaultServiceChanged"):new b.UserDataAutoSyncError((0,C.localize)(1,null),"ServiceChanged"):new b.UserDataAutoSyncError((0,C.localize)(2,null),"TurnedOff");const O=this.storageService.get(a,0);if(O&&this.manifest&&O!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new b.UserDataAutoSyncError((0,C.localize)(3,null),"DefaultServiceChanged"):new b.UserDataAutoSyncError((0,C.localize)(4,null),"ServiceChanged"):new b.UserDataAutoSyncError((0,C.localize)(5,null),"SessionExpired");const y=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(w.isCancellationRequested)return;const M=y.find(F=>F.isCurrent);if(M?.disabled)throw new b.UserDataAutoSyncError((0,C.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(F){throw new b.UserDataAutoSyncError((0,R.toErrorMessage)(F),F instanceof b.UserDataSyncError?F.code:"Unknown")}if(this.manifest&&this.manifest.session!==O&&this.storageService.store(a,this.manifest.session,0,1),w.isCancellationRequested)return;M||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(O){this.logService.error(O),T=O}this._onDidFinishSync.fire(T)}register(f){return super._register(f)}}u.INTERVAL_SYNCING="Interval"}),define(te[209],ne([0,1,3,2,4,21,22,23]),function(K,e,D,L,R,A,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let m=class extends L.Disposable{constructor(i,C){super();this.storageService=i,this.telemetryService=C,this._onDidChangeResourceEnablement=new D.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(i.onDidChangeValue(h=>this.onDidStorageChange(h)))}isResourceEnabled(i){return this.storageService.getBoolean((0,P.getEnablementKey)(i),0,!0)}setResourceEnablement(i,C){if(this.isResourceEnabled(i)!==C){const h=(0,P.getEnablementKey)(i);this.telemetryService.publicLog2(h,{enabled:C}),this.storeResourceEnablement(h,C)}}getResourceSyncStateVersion(i){}storeResourceEnablement(i,C){this.storageService.store(i,C,0,R.isWeb?0:1)}onDidStorageChange(i){if(i.scope===0){const C=P.ALL_SYNC_RESOURCES.filter(h=>(0,P.getEnablementKey)(h)===i.key)[0];if(C){this._onDidChangeResourceEnablement.fire([C,this.isResourceEnabled(C)]);return}}}};m=de([Q(0,A.IStorageService),Q(1,k.ITelemetryService)],m),e.UserDataSyncResourceEnablementService=m}),define(te[210],ne([0,1,18,6,37,11,3,2,15,30,7,21,22,199,201,202,204,205,23]),function(K,e,D,L,R,A,k,P,m,E,i,C,h,v,c,S,b,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const p="sync.lastSyncTime";let o=class extends P.Disposable{constructor(n,r,u,l,f,d){super();this.userDataSyncStoreService=n,this.userDataSyncStoreManagementService=r,this.instantiationService=u,this.logService=l,this.telemetryService=f,this.storageService=d,this._status="uninitialized",this._onDidChangeStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new k.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new k.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new k.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new k.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(b.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(S.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(g.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(c.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(v.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(k.Event.any(...this.synchronisers.map(w=>k.Event.map(w.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(k.Event.any(...this.synchronisers.map(w=>k.Event.map(w.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(p,0,void 0),this.onDidChangeLocal=k.Event.any(...this.synchronisers.map(w=>k.Event.map(w.onDidChangeLocal,()=>w.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(n,r){await this.checkEnablement();const u=(0,E.generateUuid)();try{const w=(0,I.createSyncHeaders)(u);r&&(w["Cache-Control"]="no-cache"),n=await this.userDataSyncStoreService.manifest(n,w)}catch(w){const T=I.UserDataSyncError.toUserDataSyncError(w);throw this.reportUserDataSyncError(T,u),T}let l=!1;const f=this;let d;return{manifest:n,run(){if(l)throw new Error("Can run a task only once");return d=(0,L.createCancelablePromise)(w=>f.sync(n,u,w)),d.finally(()=>d=void 0)},async stop(){if(d&&d.cancel(),f.status!=="idle")return f.stop()}}}async createManualSyncTask(){await this.checkEnablement();const n=(0,E.generateUuid)(),r=(0,I.createSyncHeaders)(n);let u;try{u=await this.userDataSyncStoreService.manifest(null,r)}catch(l){const f=I.UserDataSyncError.toUserDataSyncError(l);throw this.reportUserDataSyncError(f,n),f}return new a(n,u,r,this.synchronisers,this.logService)}async sync(n,r,u){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),u.isCancellationRequested)return;const l=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const f=(0,I.createSyncHeaders)(r);for(const d of this.synchronisers){if(u.isCancellationRequested)return;try{await d.sync(n,f)}catch(w){let T=!1;if(w instanceof I.UserDataSyncError)switch(w.code){case"TooLarge":w=new I.UserDataSyncError(w.message,w.code,d.resource),T=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":T=!0;break}const O=I.UserDataSyncError.toUserDataSyncError(w);if(this.reportUserDataSyncError(O,r),T)throw O;this.logService.error(w),this.logService.error(`${d.resource}: ${(0,R.toErrorMessage)(w)}`),this._syncErrors.push([d.resource,O])}}this.logService.info(`Sync done. Took ${new Date().getTime()-l}ms`),this.updateLastSyncTime()}catch(f){const d=I.UserDataSyncError.toUserDataSyncError(f);throw this.reportUserDataSyncError(d,r),d}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}async stop(){if(this.status!=="idle")for(const n of this.synchronisers)try{n.status!=="idle"&&await n.stop()}catch(r){this.logService.error(r)}}async replace(n){await this.checkEnablement();for(const r of this.synchronisers)if(await r.replace(n))return}async accept(n,r,u,l){await this.checkEnablement();const f=this.getSynchroniser(n);await f.accept(r,u),l&&await f.apply(!1,(0,I.createSyncHeaders)((0,E.generateUuid)()))}async resolveContent(n){for(const r of this.synchronisers){const u=await r.resolveContent(n);if(u)return u}return null}getRemoteSyncResourceHandles(n){return this.getSynchroniser(n).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(n){return this.getSynchroniser(n).getLocalSyncResourceHandles()}getAssociatedResources(n,r){return this.getSynchroniser(n).getAssociatedResources(r)}getMachineId(n,r){return this.getSynchroniser(n).getMachineId(r)}async hasLocalData(){const n=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const r of n)if(await r.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(n){this.logService.error(n)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(p,0);for(const n of this.synchronisers)try{await n.resetLocal()}catch(r){this.logService.error(`${n.resource}: ${(0,R.toErrorMessage)(r)}`),this.logService.error(r)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const n of this.synchronisers)if(await n.hasPreviouslySynced())return!0;return!1}setStatus(n){const r=this._status;this._status!==n&&(this._status=n,this._onDidChangeStatus.fire(n),r==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const n=this.computeStatus();this.setStatus(n)}updateConflicts(){const n=this.computeConflicts();(0,D.equals)(this._conflicts,n,([r,u],[l,f])=>r===r&&(0,D.equals)(u,f,(d,w)=>(0,m.isEqual)(d.previewResource,w.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(n))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(n=>n.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(n=>n.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(p,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(n,r){this.telemetryService.publicLog2("sync/error",{code:n.code,serverCode:n instanceof I.UserDataSyncStoreError?String(n.serverCode):void 0,url:n instanceof I.UserDataSyncStoreError?n.url:void 0,resource:n.resource,executionId:r,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(n=>n.status==="hasConflicts").map(n=>[n.resource,n.conflicts.map(t)])}getSynchroniser(n){return this.synchronisers.find(r=>r.resource===n)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};o=de([Q(0,I.IUserDataSyncStoreService),Q(1,I.IUserDataSyncStoreManagementService),Q(2,i.IInstantiationService),Q(3,I.IUserDataSyncLogService),Q(4,h.ITelemetryService),Q(5,C.IStorageService)],o),e.UserDataSyncService=o;class a extends P.Disposable{constructor(n,r,u,l,f){super();this.id=n,this.manifest=r,this.syncHeaders=u,this.synchronisers=l,this.logService=f,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new k.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(n=>n.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(n=>n.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,L.createCancelablePromise)(n=>this.getPreviews(n))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(n){throw this.logService.error(n),n}}async accept(n,r){try{return await this.performAction(n,u=>u.accept(n,r))}catch(u){throw this.logService.error(u),u}}async merge(n){try{return n?await this.performAction(n,r=>r.merge(n)):await this.mergeAll()}catch(r){throw this.logService.error(r),r}}async discard(n){try{return await this.performAction(n,r=>r.discard(n))}catch(r){throw this.logService.error(r),r}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const n=[];for(const[,r]of this.previews)for(const u of r.resourcePreviews)u.mergeState==="conflict"&&n.push(u.previewResource);for(const r of n)await this.discard(r);return this.previews}catch(n){throw this.logService.error(n),n}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const n=[];for(const[r,u]of this.previews){this.synchronizingResources.push([r,u.resourcePreviews.map(d=>d.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(d=>d.resource===r);for(const d of u.resourcePreviews)(d.localChange!==0||d.remoteChange!==0)&&d.mergeState==="preview"&&await l.merge(d.previewResource);const f=await l.apply(!1,this.syncHeaders);f&&n.push(this.toSyncResourcePreview(l.resource,f)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(d=>d[0]===r),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=n,this.previews}catch(n){throw this.logService.error(n),n}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[n,r]of this.previews){this.synchronizingResources.push([n,r.resourcePreviews.map(l=>l.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(l=>l.resource===n);for(const l of r.resourcePreviews)await u.accept(l.remoteResource);await u.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(l=>l[0]===n),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(n){throw this.logService.error(n),n}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[n,r]of this.previews){this.synchronizingResources.push([n,r.resourcePreviews.map(l=>l.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(l=>l.resource===n);for(const l of r.resourcePreviews)await u.accept(l.localResource);await u.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(l=>l[0]===n),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(n){throw this.logService.error(n),n}}async stop(){for(const n of this.synchronisers)try{await n.stop()}catch(r){(0,A.isPromiseCanceledError)(r)||this.logService.error(r)}this.reset()}async performAction(n,r){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const u=this.previews.findIndex(([,M])=>M.resourcePreviews.some(({localResource:F,previewResource:q,remoteResource:x})=>(0,m.isEqual)(n,F)||(0,m.isEqual)(n,q)||(0,m.isEqual)(n,x)));if(u===-1)return this.previews;const[l,f]=this.previews[u],d=f.resourcePreviews.find(({localResource:M,remoteResource:F,previewResource:q})=>(0,m.isEqual)(M,n)||(0,m.isEqual)(F,n)||(0,m.isEqual)(q,n));if(!d)return this.previews;let w=this.synchronizingResources.find(M=>M[0]===l);w||(w=[l,[]],this.synchronizingResources.push(w)),w[1].some(M=>(0,m.isEqual)(M,d.localResource))||(w[1].push(d.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const T=this.synchronisers.find(M=>M.resource===this.previews[u][0]),O=await r(T);O?this.previews.splice(u,1,this.toSyncResourcePreview(T.resource,O)):this.previews.splice(u,1);const y=this.synchronizingResources.findIndex(M=>M[0]===l);return this.synchronizingResources[y][1].splice(w[1].findIndex(M=>(0,m.isEqual)(M,d.localResource)),1),w[1].length||(this.synchronizingResources.splice(y,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const n=[];for(const[r,u]of this.previews){this.synchronizingResources.push([r,u.resourcePreviews.map(d=>d.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(d=>d.resource===r);let f=u;for(const d of u.resourcePreviews)(d.localChange!==0||d.remoteChange!==0)&&d.mergeState==="preview"&&(f=await l.merge(d.previewResource));f&&n.push(this.toSyncResourcePreview(l.resource,f)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(d=>d[0]===r),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=n,this.previews}async getPreviews(n){const r=[];for(const u of this.synchronisers){if(n.isCancellationRequested)return[];const l=await u.preview(this.manifest,this.syncHeaders);l&&r.push(this.toSyncResourcePreview(u.resource,l))}return r}toSyncResourcePreview(n,r){return[n,{isLastSyncFromCurrentMachine:r.isLastSyncFromCurrentMachine,resourcePreviews:r.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function t(s){return{localResource:s.localResource,previewResource:s.previewResource,remoteResource:s.remoteResource,acceptedResource:s.acceptedResource,localChange:s.localChange,remoteChange:s.remoteChange,mergeState:s.mergeState}}}),define(te[211],ne([0,1,3,2,16,5,23]),function(K,e,D,L,R,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class P{constructor(C,h){this.service=C,this.logService=h,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new D.Emitter}listen(C,h){switch(h){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${h}`)}async call(C,h,v){try{return await this._call(C,h,v)}catch(c){throw this.logService.error(c),c}}async _call(C,h,v){switch(h){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(A.URI.revive(v[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(v[0],A.URI.revive(v[1]),v[2],v[3]);case"resolveContent":return this.service.resolveContent(A.URI.revive(v[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(v[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(v[0]);case"getAssociatedResources":return this.service.getAssociatedResources(v[0],{created:v[1].created,uri:A.URI.revive(v[1].uri)});case"getMachineId":return this.service.getMachineId(v[0],{created:v[1].created,uri:A.URI.revive(v[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(h.startsWith("manualSync/")){const c=h.substring("manualSync/".length),S=v[0],b=this.getManualSyncTask(S);switch(v=v.slice(1),c){case"preview":return b.preview();case"accept":return b.accept(A.URI.revive(v[0]),v[1]);case"merge":return b.merge(A.URI.revive(v[0]));case"discard":return b.discard(A.URI.revive(v[0]));case"discardConflicts":return b.discardConflicts();case"apply":return b.apply();case"pull":return b.pull();case"push":return b.push();case"stop":return b.stop();case"_getStatus":return b.status;case"dispose":return this.disposeManualSyncTask(b)}}throw new Error("Invalid call")}getManualSyncTask(C){const h=this.manualSyncTasks.get(this.createKey(C));if(!h)throw new Error(`Manual sync taks not found: ${C}`);return h.manualSyncTask}async createManualSyncTask(){const C=new L.DisposableStore,h=C.add(await this.service.createManualSyncTask());return C.add(h.onSynchronizeResources(v=>this.onManualSynchronizeResources.fire({manualSyncTaskId:h.id,data:v}))),this.manualSyncTasks.set(this.createKey(h.id),{manualSyncTask:h,disposables:C}),{id:h.id,manifest:h.manifest,status:h.status}}disposeManualSyncTask(C){C.dispose();const h=this.createKey(C.id);this.manualSyncTasks.get(h)?.disposables.dispose(),this.manualSyncTasks.delete(h)}createKey(C){return`manualSyncTask-${C}`}}e.UserDataSyncChannel=P;class m extends L.Disposable{constructor(C){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new D.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new D.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(h,v,c){return C.call(h,v,c).then(null,S=>{throw k.UserDataSyncError.toUserDataSyncError(S)})},listen(h,v){return C.listen(h,v)}},this.channel.call("_getInitialData").then(([h,v,c])=>{this.updateStatus(h),this.updateConflicts(v),c&&this.updateLastSyncTime(c),this._register(this.channel.listen("onDidChangeStatus")(S=>this.updateStatus(S))),this._register(this.channel.listen("onDidChangeLastSyncTime")(S=>this.updateLastSyncTime(S)))}),this._register(this.channel.listen("onDidChangeConflicts")(h=>this.updateConflicts(h))),this._register(this.channel.listen("onSyncErrors")(h=>this._onSyncErrors.fire(h.map(([v,c])=>[v,k.UserDataSyncError.toUserDataSyncError(c)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:C,manifest:h,status:v}=await this.channel.call("createManualSyncTask"),c=this,S=new E(C,h,v,{async call(b,g,I){return c.channel.call(`manualSync/${b}`,[C,...(0,R.isArray)(g)?g:[g]],I)},listen(b,g){return D.Event.map(D.Event.filter(c.channel.listen(`manualSync/${b}`,g),I=>!S.isDiposed()&&I.manualSyncTaskId===C),I=>I.data)}});return S}replace(C){return this.channel.call("replace",[C])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(C,h,v,c){return this.channel.call("accept",[C,h,v,c])}resolveContent(C){return this.channel.call("resolveContent",[C])}async getLocalSyncResourceHandles(C){return(await this.channel.call("getLocalSyncResourceHandles",[C])).map(({created:v,uri:c})=>({created:v,uri:A.URI.revive(c)}))}async getRemoteSyncResourceHandles(C){return(await this.channel.call("getRemoteSyncResourceHandles",[C])).map(({created:v,uri:c})=>({created:v,uri:A.URI.revive(c)}))}async getAssociatedResources(C,h){return(await this.channel.call("getAssociatedResources",[C,h])).map(({resource:c,comparableResource:S})=>({resource:A.URI.revive(c),comparableResource:A.URI.revive(S)}))}async getMachineId(C,h){return this.channel.call("getMachineId",[C,h])}async updateStatus(C){this._status=C,this._onDidChangeStatus.fire(C)}async updateConflicts(C){this._conflicts=C.map(([h,v])=>[h,v.map(c=>({...c,localResource:A.URI.revive(c.localResource),remoteResource:A.URI.revive(c.remoteResource),previewResource:A.URI.revive(c.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(C){this._lastSyncTime!==C&&(this._lastSyncTime=C,this._onDidChangeLastSyncTime.fire(C))}}e.UserDataSyncChannelClient=m;class E extends L.Disposable{constructor(C,h,v,c){super();this.id=C,this.manifest=h,this._disposed=!1,this._status=v;const S=this;this.channel={async call(b,g,I){try{const p=await c.call(b,g,I);return S.isDiposed()||(S._status=await c.call("_getStatus")),p}catch(p){throw k.UserDataSyncError.toUserDataSyncError(p)}},listen(b,g){return c.listen(b,g)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const C=await this.channel.call("preview");return this.deserializePreviews(C)}async accept(C,h){const v=await this.channel.call("accept",[C,h]);return this.deserializePreviews(v)}async merge(C){const h=await this.channel.call("merge",[C]);return this.deserializePreviews(h)}async discard(C){const h=await this.channel.call("discard",[C]);return this.deserializePreviews(h)}async discardConflicts(){const C=await this.channel.call("discardConflicts");return this.deserializePreviews(C)}async apply(){const C=await this.channel.call("apply");return this.deserializePreviews(C)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(C){return C.map(([h,v])=>[h,{isLastSyncFromCurrentMachine:v.isLastSyncFromCurrentMachine,resourcePreviews:v.resourcePreviews.map(c=>({...c,localResource:A.URI.revive(c.localResource),remoteResource:A.URI.revive(c.remoteResource),previewResource:A.URI.revive(c.previewResource),acceptedResource:A.URI.revive(c.acceptedResource)}))}])}}}),define(te[212],ne([0,1,6,29,11,3,2,95,4,15,16,5,30,20,12,13,28,42,45,21,23]),function(K,e,D,L,R,A,k,P,m,E,i,C,h,v,c,S,b,g,I,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const a="sync.previous.store",t="sync.donot-make-requests-until",s="sync.user-session-id",n="sync.machine-session-id",r=100,u=1e3*60*5;let l=class extends k.Disposable{constructor(y,M,F){super();this.productService=y,this.configurationService=M,this.storageService=F,this._onDidChangeUserDataSyncStore=this._register(new A.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(A.Event.filter(F.onDidChangeValue,q=>q.key===o.SYNC_SERVICE_URL_TYPE&&q.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(o.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(y){this.storageService.store(o.SYNC_SERVICE_URL_TYPE,y,0,m.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[o.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(o.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(y,M){y=m.isWeb&&y?.web?{...y,...y.web}:y;const F={...y||{},...M||{}};if(F&&(0,i.isString)(F.url)&&(0,i.isObject)(F.authenticationProviders)&&Object.keys(F.authenticationProviders).every(q=>(0,i.isArray)(F.authenticationProviders[q].scopes))){const q=F,x=!!q.canSwitch&&!M?.url,U=q.url===q.insidersUrl?"insiders":"stable",$=(x?this.userDataSyncStoreType:void 0)||U,B=M?.url||($==="insiders"?q.insidersUrl:$==="stable"?q.stableUrl:q.url);return{url:C.URI.parse(B),type:$,defaultType:U,defaultUrl:C.URI.parse(q.url),stableUrl:C.URI.parse(q.stableUrl),insidersUrl:C.URI.parse(q.insidersUrl),canSwitch:x,authenticationProviders:Object.keys(q.authenticationProviders).reduce((z,j)=>(z.push({id:j,scopes:q.authenticationProviders[j].scopes}),z),[])}}}};l=de([Q(0,b.IProductService),Q(1,v.IConfigurationService),Q(2,p.IStorageService)],l),e.AbstractUserDataSyncStoreManagementService=l;let f=class extends l{constructor(y,M,F){super(y,M,F);const q=this.storageService.get(a,0);q&&(this.previousConfigurationSyncStore=JSON.parse(q));const x=this.productService[o.CONFIGURATION_SYNC_STORE_KEY];x?this.storageService.store(a,JSON.stringify(x),0,1):this.storageService.remove(a,0)}async switch(y){y!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=y,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};f=de([Q(0,b.IProductService),Q(1,v.IConfigurationService),Q(2,p.IStorageService)],f),e.UserDataSyncStoreManagementService=f;let d=class extends k.Disposable{constructor(y,M,F,q,x,U,$){super();this.requestService=F,this.logService=q,this.storageService=$,this._onTokenFailed=this._register(new A.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new A.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new A.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(y),this.commonHeadersPromise=(0,I.getServiceMachineId)(x,U,$).then(B=>{const z={"X-Client-Name":`${M.applicationName}${m.isWeb?"-web":""}`,"X-Client-Version":M.version};return M.commit&&(z["X-Client-Commit"]=M.commit),z}),this.session=new T(r,u,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,k.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(y,M){this.authToken={token:y,type:M}}updateUserDataSyncStoreUrl(y){this.userDataSyncStoreUrl=y?(0,E.joinPath)(y,"v1"):void 0}initDonotMakeRequestsUntil(){const y=this.storageService.getNumber(t,0);y&&Date.now()<y&&this.setDonotMakeRequestsUntil(new Date(y))}setDonotMakeRequestsUntil(y){this._donotMakeRequestsUntil?.getTime()!==y?.getTime()&&(this._donotMakeRequestsUntil=y,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(t,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,D.createCancelablePromise)(M=>(0,D.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),M).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,M=>null)):this.storageService.remove(t,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(y){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",y),F={},q=await this.request(M.toString(),{type:"GET",headers:F},[],L.CancellationToken.None);return(await(0,g.asJson)(q)||[]).map(({url:U,created:$})=>({ref:(0,E.relativePath)(M,M.with({path:U})),created:$*1e3}))}async resolveContent(y,M){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",y,M).toString(),q={};q["Cache-Control"]="no-cache";const x=await this.request(F,{type:"GET",headers:q},[],L.CancellationToken.None);return await(0,g.asText)(x)}async delete(y){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",y).toString(),F={};await this.request(M,{type:"DELETE",headers:F},[],L.CancellationToken.None)}async read(y,M,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const q=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",y,"latest").toString();F={...F},F["Cache-Control"]="no-cache",M&&(F["If-None-Match"]=M.ref);const x=await this.request(q,{type:"GET",headers:F},[304],L.CancellationToken.None);let U=null;if(x.res.statusCode===304&&(U=M),U===null){const $=x.res.headers.etag;if(!$)throw new o.UserDataSyncStoreError("Server did not return the ref",q,"NoRef",x.res.statusCode,x.res.headers[o.HEADER_OPERATION_ID]);const B=await(0,g.asText)(x);if(!B&&x.res.statusCode===304)throw new o.UserDataSyncStoreError("Empty response",q,"EmptyResponse",x.res.statusCode,x.res.headers[o.HEADER_OPERATION_ID]);U={ref:$,content:B}}return U}async write(y,M,F,q={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const x=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",y).toString();q={...q},q["Content-Type"]=P.Mimes.text,F&&(q["If-Match"]=F);const U=await this.request(x,{type:"POST",data:M,headers:q},[],L.CancellationToken.None),$=U.res.headers.etag;if(!$)throw new o.UserDataSyncStoreError("Server did not return the ref",x,"NoRef",U.res.statusCode,U.res.headers[o.HEADER_OPERATION_ID]);return $}async manifest(y,M={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,E.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();M={...M},M["Content-Type"]="application/json",y&&(M["If-None-Match"]=y.ref);const q=await this.request(F,{type:"GET",headers:M},[304],L.CancellationToken.None);let x=null;if(q.res.statusCode===304&&(x=y),!x){const $=q.res.headers.etag;if(!$)throw new o.UserDataSyncStoreError("Server did not return the ref",F,"NoRef",q.res.statusCode,q.res.headers[o.HEADER_OPERATION_ID]);const B=await(0,g.asText)(q);if(!B&&q.res.statusCode===304)throw new o.UserDataSyncStoreError("Empty response",F,"EmptyResponse",q.res.statusCode,q.res.headers[o.HEADER_OPERATION_ID]);B&&(x={...JSON.parse(B),ref:$})}const U=this.storageService.get(s,0);return U&&x&&U!==x.session&&this.clearSession(),x===null&&U&&this.clearSession(),x&&this.storageService.store(s,x.session,0,1),x}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const y=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),M={"Content-Type":P.Mimes.text};await this.request(y,{type:"DELETE",headers:M},[],L.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(s,0),this.storageService.remove(n,0)}async request(y,M,F,q){if(!this.authToken)throw new o.UserDataSyncStoreError("No Auth Token Available",y,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new o.UserDataSyncStoreError(`${M.type} request '${y}' failed because of too many requests (429).`,y,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const x=await this.commonHeadersPromise;M.headers={...M.headers||{},...x,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(M.headers),this.logService.trace("Sending request to server",{url:y,type:M.type,headers:{...M.headers,authorization:void 0}});let U;try{U=await this.session.request(y,M,q)}catch(j){if(!(j instanceof o.UserDataSyncStoreError)){let N="RequestFailed";const G=(0,R.getErrorMessage)(j).toLowerCase();G.includes("xhr timeout")?N="RequestTimeout":G.includes("protocol")&&G.includes("not supported")?N="RequestProtocolNotSupported":G.includes("request path contains unescaped characters")?N="RequestPathNotEscaped":G.includes("headers must be an object")?N="RequestHeadersNotObject":(0,R.isPromiseCanceledError)(j)&&(N="RequestCanceled"),j=new o.UserDataSyncStoreError(`Connection refused for the request '${y}'.`,y,N,void 0,void 0)}throw this.logService.info("Request failed",y),j}const $=U.res.headers[o.HEADER_OPERATION_ID],B={url:y,status:U.res.statusCode,"execution-id":M.headers[o.HEADER_EXECUTION_ID],"operation-id":$},z=(0,g.isSuccess)(U)||U.res.statusCode&&F.indexOf(U.res.statusCode)!==-1;if(z?this.logService.trace("Request succeeded",B):this.logService.info("Request failed",B),U.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new o.UserDataSyncStoreError(`Request '${y}' failed because of Unauthorized (401).`,y,"Unauthorized",U.res.statusCode,$);if(this._onTokenSucceed.fire(),U.res.statusCode===409)throw new o.UserDataSyncStoreError(`${M.type} request '${y}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,y,"Conflict",U.res.statusCode,$);if(U.res.statusCode===410)throw new o.UserDataSyncStoreError(`${M.type} request '${y}' failed because the requested resource is not longer available (410).`,y,"Gone",U.res.statusCode,$);if(U.res.statusCode===412)throw new o.UserDataSyncStoreError(`${M.type} request '${y}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,y,"PreconditionFailed",U.res.statusCode,$);if(U.res.statusCode===413)throw new o.UserDataSyncStoreError(`${M.type} request '${y}' failed because of too large payload (413).`,y,"TooLarge",U.res.statusCode,$);if(U.res.statusCode===426)throw new o.UserDataSyncStoreError(`${M.type} request '${y}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,y,"UpgradeRequired",U.res.statusCode,$);if(U.res.statusCode===429){const j=U.res.headers["retry-after"];throw j?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(j)*1e3)),new o.UserDataSyncStoreError(`${M.type} request '${y}' failed because of too many requests (429).`,y,"TooManyRequestsAndRetryAfter",U.res.statusCode,$)):new o.UserDataSyncStoreError(`${M.type} request '${y}' failed because of too many requests (429).`,y,"RemoteTooManyRequests",U.res.statusCode,$)}if(!z)throw new o.UserDataSyncStoreError("Server returned "+U.res.statusCode,y,"Unknown",U.res.statusCode,$);return U}addSessionHeaders(y){let M=this.storageService.get(n,0);M===void 0&&(M=(0,h.generateUuid)(),this.storageService.store(n,M,0,1)),y["X-Machine-Session-Id"]=M;const F=this.storageService.get(s,0);F!==void 0&&(y["X-User-Session-Id"]=F)}};d=de([Q(1,b.IProductService),Q(2,g.IRequestService),Q(3,o.IUserDataSyncLogService),Q(4,c.IEnvironmentService),Q(5,S.IFileService),Q(6,p.IStorageService)],d),e.UserDataSyncStoreClient=d;let w=class extends d{constructor(y,M,F,q,x,U,$){super(y.userDataSyncStore?.url,M,F,q,x,U,$);this._register(y.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(y.userDataSyncStore?.url)))}};w=de([Q(0,o.IUserDataSyncStoreManagementService),Q(1,b.IProductService),Q(2,g.IRequestService),Q(3,o.IUserDataSyncLogService),Q(4,c.IEnvironmentService),Q(5,S.IFileService),Q(6,p.IStorageService)],w),e.UserDataSyncStoreService=w;class T{constructor(y,M,F,q){this.limit=y,this.interval=M,this.requestService=F,this.logService=q,this.requests=[],this.startTime=void 0}request(y,M,F){if(this.isExpired()&&this.reset(),M.url=y,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new o.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,y,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(y),this.requestService.request(M,F)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=T}),define(te[213],ne([0,1,3,59,28,21,22,89,23,60,61]),function(K,e,D,L,R,A,k,P,m,E,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let C=class extends P.UserDataAutoSyncService{constructor(v,c,S,b,g,I,p,o,a,t,s,n){super(v,c,S,b,g,p,o,a,t,s,n);this._register(D.Event.debounce(D.Event.any(D.Event.map(I.onDidFocusWindow,()=>"windowFocus"),D.Event.map(I.onDidOpenWindow,()=>"windowOpen")),(r,u)=>r?[...r,u]:[u],1e3)(r=>this.triggerSync(r,!0,!1)))}};C=de([Q(0,R.IProductService),Q(1,m.IUserDataSyncStoreManagementService),Q(2,m.IUserDataSyncStoreService),Q(3,m.IUserDataSyncResourceEnablementService),Q(4,m.IUserDataSyncService),Q(5,L.INativeHostService),Q(6,m.IUserDataSyncLogService),Q(7,E.IUserDataSyncAccountService),Q(8,k.ITelemetryService),Q(9,i.IUserDataSyncMachinesService),Q(10,A.IStorageService),Q(11,m.IUserDataAutoSyncEnablementService)],C),e.UserDataAutoSyncService=C}),define(te[214],ne([0,1,6,3,2]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class A extends R.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:m,getActiveWindowId:E}){super();this.disposables=this._register(new R.DisposableStore),L.Event.latch(L.Event.any(P,m))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,D.createCancelablePromise)(()=>E()),(async()=>{try{const C=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:C}catch(C){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=A}),define(te[62],ne([0,1,51,6,8,16,19,110,222,223]),function(K,e,D,L,R,A,k,P,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class i extends Error{constructor(t,s){let n=s.message;switch(t){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=t,this.cause=s}}e.ExtractError=i;function C(a){const t=a.externalFileAttributes>>16||33188;return[448,56,7].map(s=>t&s).reduce((s,n)=>s+n,t&61440)}function h(a){if(a instanceof i)return a;let t;return/end of central directory record signature not found/.test(a.message)&&(t="CorruptZip"),new i(t,a)}function v(a,t,s,n,r,u){const l=R.dirname(t),f=R.join(n,l);if(!f.startsWith(n))return Promise.reject(new Error(P.localize(0,null,t)));const d=R.join(n,t);let w;return u.onCancellationRequested(()=>{w&&w.destroy()}),Promise.resolve(k.Promises.mkdir(f,{recursive:!0})).then(()=>new Promise((T,O)=>{if(!u.isCancellationRequested)try{w=(0,D.createWriteStream)(d,{mode:s}),w.once("close",()=>T()),w.once("error",O),a.once("error",O),a.pipe(w)}catch(y){O(y)}}))}function c(a,t,s,n){let r=(0,L.createCancelablePromise)(()=>Promise.resolve()),u=0;return n.onCancellationRequested(()=>{r.cancel(),a.close()}),new Promise((l,f)=>{const d=new L.Sequencer,w=T=>{T.isCancellationRequested||(u++,a.readEntry())};a.once("error",f),a.once("close",()=>r.then(()=>{n.isCancellationRequested||a.entryCount===u?l():f(new i("Incomplete",new Error(P.localize(1,null,u,a.entryCount))))},f)),a.readEntry(),a.on("entry",T=>{if(n.isCancellationRequested)return;if(!s.sourcePathRegex.test(T.fileName)){w(n);return}const O=T.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(O)){const F=R.join(t,O);r=(0,L.createCancelablePromise)(q=>k.Promises.mkdir(F,{recursive:!0}).then(()=>w(q)).then(void 0,f));return}const y=b(a,T),M=C(T);r=(0,L.createCancelablePromise)(F=>d.queue(()=>y.then(q=>v(q,O,M,t,s,F).then(()=>w(F)))).then(null,f))})})}function S(a,t=!1){return new Promise((s,n)=>{(0,m.open)(a,t?{lazyEntries:!0}:void 0,(r,u)=>{r?n(h(r)):s((0,A.assertIsDefined)(u))})})}function b(a,t){return new Promise((s,n)=>{a.openReadStream(t,(r,u)=>{r?n(h(r)):s((0,A.assertIsDefined)(u))})})}function g(a,t){return new Promise((s,n)=>{const r=new E.ZipFile;t.forEach(l=>{l.contents?r.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&r.addFile(l.localPath,l.path)}),r.end();const u=(0,D.createWriteStream)(a);r.outputStream.pipe(u),r.outputStream.once("error",n),u.once("error",n),u.once("finish",()=>s(a))})}e.zip=g;function I(a,t,s={},n){const r=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let u=S(a,!0);return s.overwrite&&(u=u.then(l=>k.Promises.rm(t).then(()=>l))),u.then(l=>c(l,t,{sourcePathRegex:r},n))}e.extract=I;function p(a,t){return S(a).then(s=>new Promise((n,r)=>{s.on("entry",u=>{u.fileName===t&&b(s,u).then(l=>n(l),l=>r(l))}),s.once("close",()=>r(new Error(P.localize(2,null,t))))}))}function o(a,t){return p(a,t).then(s=>new Promise((n,r)=>{const u=[];s.once("error",r),s.on("data",l=>u.push(l)),s.on("end",()=>n(Buffer.concat(u)))}))}e.buffer=o}),define(te[215],ne([0,1,62,118]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function R(A){return(0,D.buffer)(A,"extension/package.json").then(k=>{try{return JSON.parse(k.toString("utf8"))}catch(P){throw new Error((0,L.localize)(0,null))}})}e.getManifest=R}),define(te[216],ne([0,1,18,6,11,2,17,8,4,15,58,5,30,19,62,119,12,27,31,141,13,14,28]),function(K,e,D,L,R,A,k,P,m,E,i,C,h,v,c,S,b,g,I,p,o,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const s="scanningSystem",n="scanningUser",r="extracting",u="deleting",l="renaming";let f=class extends A.Disposable{constructor(w,T,O,y,M){super();this.beforeRemovingExtension=w,this.fileService=T,this.logService=O,this.environmentService=y,this.productService=M,this._devSystemExtensionsPath=null,this.systemExtensionsPath=y.builtinExtensionsPath,this.extensionsPath=y.extensionsPath,this.uninstalledPath=P.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new L.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(w){const T=[];(w===null||w===0)&&T.push(this.scanSystemExtensions().then(null,O=>Promise.reject(new g.ExtensionManagementError(this.joinErrors(O).message,s)))),(w===null||w===1)&&T.push(this.scanUserExtensions(!0).then(null,O=>Promise.reject(new g.ExtensionManagementError(this.joinErrors(O).message,n))));try{const O=await Promise.all(T);return(0,D.flatten)(O)}catch(O){throw this.joinErrors(O)}}async scanUserExtensions(w){this.logService.trace("Started scanning user extensions");let[T,O]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return O=O.filter(y=>!T[new I.ExtensionIdentifierWithVersion(y.identifier,y.manifest.version).key()]),w&&(O=(0,I.groupByExtension)(O,M=>M.identifier).map(M=>M.sort((F,q)=>i.rcompare(F.manifest.version,q.manifest.version))[0])),this.logService.trace("Scanned user extensions:",O.length),O}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(w,T,O,y){const M=w.key(),F=P.join(this.extensionsPath,`.${(0,h.generateUuid)()}`),q=P.join(this.extensionsPath,M);try{await v.Promises.rm(q)}catch(U){try{await v.Promises.rm(q)}catch($){}throw new g.ExtensionManagementError((0,S.localize)(0,null,q,w.id),u)}await this.extractAtLocation(w,T,F,y);let x=await this.scanExtension(C.URI.file(F),1);if(!x)throw new Error((0,S.localize)(1,null,F));await this.storeMetadata(x,{...O,installedTimestamp:Date.now()});try{await this.rename(w,F,q,Date.now()+2*60*1e3),this.logService.info("Renamed to",q)}catch(U){try{await v.Promises.rm(F)}catch($){}if(U.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",w.id);else throw this.logService.info(`Rename failed because of ${(0,R.getErrorMessage)(U)}. Deleted from extracted location`,F),U}try{x=await this.scanExtension(C.URI.file(q),1)}catch(U){}if(x)return x;throw new Error((0,S.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(w,T){return this.setMetadata(w,T),await this.storeMetadata(w,{...T,installedTimestamp:w.installedTimestamp}),w}async storeMetadata(w,T){T.isMachineScoped=T.isMachineScoped||void 0,T.isBuiltin=T.isBuiltin||void 0,T.installedTimestamp=T.installedTimestamp||void 0;const O=P.join(w.location.fsPath,"package.json"),y=await v.Promises.readFile(O,"utf8"),{manifest:M}=await this.parseManifest(y);return M.__metadata=T,await v.Promises.writeFile(O,JSON.stringify(M,null,"	")),w}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...w){const T=w.map(O=>new I.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version));await this.withUninstalledExtensions(O=>{T.forEach(y=>O[y.key()]=!0)})}async setInstalled(w){await this.withUninstalledExtensions(y=>delete y[w.key()]);const O=(await this.scanExtensions(1)).find(y=>new I.ExtensionIdentifierWithVersion(y.identifier,y.manifest.version).equals(w))||null;return O?(await this.storeMetadata(O,{installedTimestamp:Date.now()}),this.scanExtension(O.location,1)):null}async withUninstalledExtensions(w){return this.uninstalledFileLimiter.queue(async()=>{let T;try{T=await v.Promises.readFile(this.uninstalledPath,"utf8")}catch(y){if(y.code!=="ENOENT")throw y}let O={};if(T)try{O=JSON.parse(T)}catch(y){}return w&&(w(O),Object.keys(O).length?await v.Promises.writeFile(this.uninstalledPath,JSON.stringify(O)):await v.Promises.rm(this.uninstalledPath)),O})}async removeExtension(w,T){this.logService.trace(`Deleting ${T} extension from disk`,w.identifier.id,w.location.fsPath),await v.Promises.rm(w.location.fsPath),this.logService.info("Deleted from disk",w.identifier.id,w.location.fsPath)}async removeUninstalledExtension(w){await this.removeExtension(w,"uninstalled"),await this.withUninstalledExtensions(T=>delete T[new I.ExtensionIdentifierWithVersion(w.identifier,w.manifest.version).key()])}async extractAtLocation(w,T,O,y){this.logService.trace(`Started extracting the extension from ${T} to ${O}`);try{await v.Promises.rm(O)}catch(M){throw new g.ExtensionManagementError(this.joinErrors(M).message,u)}try{await(0,c.extract)(T,O,{sourcePath:"extension",overwrite:!0},y),this.logService.info(`Extracted extension to ${O}:`,w.id)}catch(M){try{await v.Promises.rm(O)}catch(F){}throw new g.ExtensionManagementError(M.message,M instanceof c.ExtractError&&M.type?M.type:r)}}async rename(w,T,O,y){try{await v.Promises.rename(T,O)}catch(M){if(m.isWindows&&M&&M.code==="EPERM"&&Date.now()<y)return this.logService.info(`Failed renaming ${T} to ${O} with 'EPERM' error. Trying again...`,w.id),this.rename(w,T,O,y);throw new g.ExtensionManagementError(M.message||(0,S.localize)(3,null,T,O),M.code||l)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const w=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return w;const T=this.scanDevSystemExtensions(),[O,y]=await Promise.all([w,T]);return[...O,...y]}async scanExtensionsInDir(w,T){const O=new L.Limiter(10),y=await this.fileService.resolve(C.URI.file(w));return y.children?(await Promise.all(y.children.filter(F=>F.isDirectory).map(F=>O.queue(async()=>T===1&&(0,E.basename)(F.resource).indexOf(".")===0?null:this.scanExtension(F.resource,T))))).filter(F=>F&&F.identifier):[]}async scanExtension(w,T){try{const O=await this.fileService.resolve(w);if(O.children){const{manifest:y,metadata:M}=await this.readManifest(w.fsPath),F=O.children.find(({name:$})=>/^readme(\.txt|\.md|)$/i.test($))?.resource,q=O.children.find(({name:$})=>/^changelog(\.txt|\.md|)$/i.test($))?.resource,x={id:(0,I.getGalleryExtensionId)(y.publisher,y.name)},U={type:T,identifier:x,manifest:y,location:w,readmeUrl:F,changelogUrl:q,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:T===0};return M&&(this.setMetadata(U,M),U.installedTimestamp=M.installedTimestamp),U}}catch(O){T!==0&&this.logService.trace(O)}return null}async scanDefaultSystemExtensions(){const w=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",w.length),w}async scanDevSystemExtensions(){const w=this.getDevSystemExtensionsList();if(w.length){const T=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",T.length),T.filter(O=>w.some(y=>(0,I.areSameExtensions)(O.identifier,{id:y})))}else return[]}setMetadata(w,T){w.publisherDisplayName=T.publisherDisplayName||null,w.publisherId=T.publisherId||null,w.identifier.uuid=T.id,w.isMachineScoped=!!T.isMachineScoped,w.isBuiltin=w.type===0||!!T.isBuiltin}async removeUninstalledExtensions(){const w=await this.getUninstalledExtensions(),T=await this.scanAllUserExtensions(),O=new Set;for(const F of T)w[new I.ExtensionIdentifierWithVersion(F.identifier,F.manifest.version).key()]||O.add(F.identifier.id.toLowerCase());const y=(0,I.groupByExtension)(T,F=>F.identifier);await L.Promises.settled(y.map(async F=>{const q=F.sort((x,U)=>i.rcompare(x.manifest.version,U.manifest.version))[0];O.has(q.identifier.id.toLowerCase())||await this.beforeRemovingExtension(q)}));const M=T.filter(F=>w[new I.ExtensionIdentifierWithVersion(F.identifier,F.manifest.version).key()]);await L.Promises.settled(M.map(F=>this.removeUninstalledExtension(F)))}async removeOutdatedExtensions(){const w=await this.scanAllUserExtensions(),T=[],O=(0,I.groupByExtension)(w,y=>y.identifier);T.push(...(0,D.flatten)(O.map(y=>y.sort((M,F)=>i.rcompare(M.manifest.version,F.manifest.version)).slice(1)))),await L.Promises.settled(T.map(y=>this.removeExtension(y,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(w=>w.name)}joinErrors(w){const T=Array.isArray(w)?w:[w];return T.length===1?T[0]instanceof Error?T[0]:new Error(T[0]):T.reduce((O,y)=>new Error(`${O.message}${O.message?",":""}${y instanceof Error?y.message:y}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=P.normalize(P.join(k.FileAccess.asFileUri("",K).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(w){const T=[v.Promises.readFile(P.join(w,"package.json"),"utf8").then(F=>this.parseManifest(F)),v.Promises.readFile(P.join(w,"package.nls.json"),"utf8").then(void 0,F=>F.code!=="ENOENT"?Promise.reject(F):"{}").then(F=>JSON.parse(F))],[{manifest:O,metadata:y},M]=await Promise.all(T);return{manifest:(0,p.localizeManifest)(O,M),metadata:y}}parseManifest(w){return new Promise((T,O)=>{try{const y=JSON.parse(w),M=y.__metadata||null;T({manifest:y,metadata:M})}catch(y){O(new Error((0,S.localize)(4,null)))}})}};f=de([Q(1,o.IFileService),Q(2,a.ILogService),Q(3,b.INativeEnvironmentService),Q(4,t.IProductService)],f),e.ExtensionsScanner=f}),define(te[217],ne([0,1,37,17,8,4,15,58,5,30,19,62,117,74,12,183,27,31,164,165,215,152,216,166,72,13,7,14,44,22]),function(K,e,D,L,R,A,k,P,m,E,i,C,h,v,c,S,b,g,I,p,o,a,t,s,n,r,u,l,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const w="unsetUninstalled",T="downloading";let O=class extends S.AbstractExtensionManagementService{constructor(U,$,B,z,j,N,G){super(U,$,B);this.environmentService=z,this.downloadService=j;const _=this._register(N.createInstance(p.ExtensionsLifecycle));this.extensionsScanner=this._register(N.createInstance(t.ExtensionsScanner,Y=>_.postUninstall(Y))),this.manifestCache=this._register(new a.ExtensionsManifestCache(z,this)),this.extensionsDownloader=this._register(N.createInstance(I.ExtensionsDownloader));const J=this._register(new s.ExtensionsWatcher(this,G,z,B));this._register(J.onDidChangeExtensionsByAnotherSource(({added:Y,removed:H})=>{Y.length&&this._onDidInstallExtensions.fire(Y.map(W=>({identifier:W.identifier,operation:0,local:W}))),H.forEach(W=>this._onDidUninstallExtension.fire({identifier:W}))}))}async zip(U){this.logService.trace("ExtensionManagementService#zip",U.identifier.id);const $=await this.collectFiles(U),B=await(0,C.zip)((0,k.joinPath)(this.environmentService.tmpDir,(0,E.generateUuid)()).fsPath,$);return m.URI.file(B)}async unzip(U){return this.logService.trace("ExtensionManagementService#unzip",U.toString()),(await this.install(U)).identifier}async getManifest(U){const $=await this.downloadVsix(U),B=R.resolve($.fsPath);return(0,o.getManifest)(B)}getInstalled(U=null){return this.extensionsScanner.scanExtensions(U)}async canInstall(U){return!0}async install(U,$={}){this.logService.trace("ExtensionManagementService#install",U.toString());const B=await this.downloadVsix(U),z=await(0,o.getManifest)(R.resolve(B.fsPath));if(z.engines&&z.engines.vscode&&!(0,n.isEngineValid)(z.engines.vscode,f.default.version,f.default.date))throw new Error(h.localize(0,null,(0,g.getGalleryExtensionId)(z.publisher,z.name),f.default.version));return this.installExtension(z,B,$)}async updateMetadata(U,$){return this.logService.trace("ExtensionManagementService#updateMetadata",U.identifier.id),U=await this.extensionsScanner.saveMetadataForLocalExtension(U,{...U.manifest.__metadata||{},...$}),this.manifestCache.invalidate(),U}async updateExtensionScope(U,$){return this.logService.trace("ExtensionManagementService#updateExtensionScope",U.identifier.id),U=await this.extensionsScanner.saveMetadataForLocalExtension(U,{...U.manifest.__metadata||{},isMachineScoped:$}),this.manifestCache.invalidate(),U}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(U){if(U.scheme===L.Schemas.file)return U;const $=(0,k.joinPath)(this.environmentService.tmpDir,(0,E.generateUuid)());return await this.downloadService.download(U,$),$}createInstallExtensionTask(U,$,B){return m.URI.isUri($)?new F(U,$,B,this.galleryService,this.extensionsScanner,this.logService):new M($,B,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(U,$){return new q(U,$,this.extensionsScanner)}async collectFiles(U){const $=async z=>{let j=await i.Promises.readdir(z);j=j.map(_=>R.join(z,_));const N=await Promise.all(j.map(_=>i.Promises.stat(_)));let G=Promise.resolve([]);return N.forEach((_,J)=>{const Y=j[J];_.isFile()&&(G=G.then(H=>[...H,Y])),_.isDirectory()&&(G=G.then(H=>$(Y).then(W=>[...H,...W])))}),G};return(await $(U.location.fsPath)).map(z=>({path:`extension/${R.relative(U.location.fsPath,z)}`,localPath:z}))}};O=de([Q(0,b.IExtensionGalleryService),Q(1,d.ITelemetryService),Q(2,l.ILogService),Q(3,c.INativeEnvironmentService),Q(4,v.IDownloadService),Q(5,u.IInstantiationService),Q(6,r.IFileService)],O),e.ExtensionManagementService=O;class y extends S.AbstractExtensionTask{constructor(U,$,B,z){super();this.identifier=U,this.source=$,this.extensionsScanner=B,this.logService=z,this._operation=1}get operation(){return this._operation}async installExtension(U,$){try{const B=await this.unsetUninstalledAndGetLocal(U.identifierWithVersion);if(B)return U.metadata?this.extensionsScanner.saveMetadataForLocalExtension(B,U.metadata):B}catch(B){throw A.isMacintosh?new b.ExtensionManagementError(h.localize(1,null),w):new b.ExtensionManagementError(h.localize(2,null),w)}return this.extract(U,$)}async unsetUninstalledAndGetLocal(U){if(!await this.isUninstalled(U))return null;this.logService.trace("Removing the extension from uninstalled list:",U.id);const B=await this.extensionsScanner.setInstalled(U);return this.logService.info("Removed the extension from uninstalled list:",U.id),B}async isUninstalled(U){return!!(await this.extensionsScanner.getUninstalledExtensions())[U.key()]}async extract({zipPath:U,identifierWithVersion:$,metadata:B},z){let j=await this.extensionsScanner.extractUserExtension($,U,B,z);return this.logService.info("Extracting completed.",$.id),j}}class M extends y{constructor(U,$,B,z,j){super(U.identifier,U,z,j);this.gallery=U,this.options=$,this.extensionsDownloader=B}async doRun(U){const B=(await this.extensionsScanner.scanExtensions(null)).find(N=>(0,g.areSameExtensions)(N.identifier,this.gallery.identifier));B&&(this._operation=2);const z=await this.downloadInstallableExtension(this.gallery,this._operation);z.metadata.isMachineScoped=this.options.isMachineScoped||B?.isMachineScoped,z.metadata.isBuiltin=this.options.isBuiltin||B?.isBuiltin;const j=await this.installExtension(z,U);B&&P.neq(B.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(B);try{await this.extensionsDownloader.delete(m.URI.file(z.zipPath))}catch(N){}return j}async downloadInstallableExtension(U,$){const B={id:U.identifier.uuid,publisherId:U.publisherId,publisherDisplayName:U.publisherDisplayName};let z;try{this.logService.trace("Started downloading extension:",U.identifier.id),z=(await this.extensionsDownloader.downloadExtension(U,$)).fsPath,this.logService.info("Downloaded extension:",U.identifier.id,z)}catch(j){throw new b.ExtensionManagementError((0,S.joinErrors)(j).message,T)}try{const j=await(0,o.getManifest)(z);return{zipPath:z,identifierWithVersion:new g.ExtensionIdentifierWithVersion(U.identifier,j.version),metadata:B}}catch(j){throw new b.ExtensionManagementError((0,S.joinErrors)(j).message,S.INSTALL_ERROR_VALIDATING)}}}class F extends y{constructor(U,$,B,z,j,N){super({id:(0,g.getGalleryExtensionId)(U.publisher,U.name)},$,j,N);this.manifest=U,this.location=$,this.options=B,this.galleryService=z}async doRun(U){const $=new g.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),z=(await this.extensionsScanner.scanExtensions(1)).find(N=>(0,g.areSameExtensions)(this.identifier,N.identifier)),j=await this.getMetadata(this.identifier.id,U);if(j.isMachineScoped=this.options.isMachineScoped||z?.isMachineScoped,j.isBuiltin=this.options.isBuiltin||z?.isBuiltin,z)if(this._operation=2,$.equals(new g.ExtensionIdentifierWithVersion(z.identifier,z.manifest.version)))try{await this.extensionsScanner.removeExtension(z,"existing")}catch(N){throw new Error(h.localize(3,null,this.manifest.displayName||this.manifest.name))}else P.gt(z.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(z);else{const N=await this.unsetUninstalledAndGetLocal($);if(N)try{await this.extensionsScanner.removeExtension(N,"existing")}catch(G){throw new Error(h.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:R.resolve(this.location.fsPath),identifierWithVersion:$,metadata:j},U)}async getMetadata(U,$){try{const B=(await this.galleryService.query({names:[U],pageSize:1},$)).firstPage[0];if(B)return{id:B.identifier.uuid,publisherDisplayName:B.publisherDisplayName,publisherId:B.publisherId}}catch(B){}return{}}}class q extends S.AbstractExtensionTask{constructor(U,$,B){super();this.extension=U,this.options=$,this.extensionsScanner=B}async doRun(U){const $=[],B=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const z=new g.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);$.push(...B.filter(j=>z.equals(new g.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version))))}else $.push(...B.filter(z=>(0,g.areSameExtensions)(z.identifier,this.extension.identifier)));if(!$.length)throw new Error(h.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...$),this.options.remove)for(const z of $)try{U.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(z)}catch(j){throw new Error(h.localize(6,null,(0,D.toErrorMessage)(j)))}}}}),define(te[224],ne([0,1,104,51,225,35,37,11,2,17,15,5,36,103,171,151,172,161,162,163,149,153,20,174,73,182,74,176,12,138,178,185,27,140,184,217,75,142,13,168,170,53,7,158,78,159,160,57,167,14,79,59,44,28,175,42,21,180,181,22,82,84,83,46,186,187,85,189,195,87,88,89,23,60,206,207,208,61,209,210,211,212,213,214]),function(K,e,D,L,R,A,k,P,m,E,i,C,h,v,c,S,b,g,I,p,o,a,t,s,n,r,u,l,f,d,w,T,O,y,M,F,q,x,U,$,B,z,j,N,G,_,J,Y,H,W,Z,X,re,oe,ue,le,Se,Ee,be,Le,De,Fe,Re,Ae,We,Be,xe,qe,ee,se,ae,ye,pe,Te,Pe,Oe,ke,V,ie,ce,he,ge,we,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class ve extends m.Disposable{constructor(fe){super();this.configuration=fe,this.server=this._register(new v.Server),(0,R.gracefulify)(L),this.registerListeners()}registerListeners(){const fe=()=>this.dispose();process.once("exit",fe),D.ipcRenderer.once("vscode:electron-main->shared-process=exit",fe)}async open(){const fe=await this.initServices();(0,pe.registerConfiguration)(),fe.invokeFunction(Ue=>{const Me=Ue.get(W.ILogService);Me.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Ue),this.registerErrorHandler(Me)}),this._register((0,m.combinedDisposable)(fe.createInstance(c.CodeCacheCleaner,this.configuration.codeCachePath),fe.createInstance(b.LanguagePackCachedDataCleaner),fe.createInstance(p.StorageDataCleaner,this.configuration.backupWorkspacesPath),fe.createInstance(I.LogsDataCleaner),fe.createInstance(g.LocalizationsUpdater),fe.createInstance(S.DeprecatedExtensionsCleaner)))}async initServices(){const fe=new G.ServiceCollection,Ue={_serviceBrand:void 0,...re.default};fe.set(oe.IProductService,Ue);const Me=new h.StaticRouter(Ve=>Ve==="main"),Ne=new _.MessagePortMainProcessService(this.server,Me);fe.set(J.IMainProcessService,Ne);const _e=new d.NativeEnvironmentService(this.configuration.args,Ue);fe.set(f.INativeEnvironmentService,_e);const et=new Z.LogLevelChannelClient(this.server.getChannel("logLevel",Me)),He=new Z.LoggerChannelClient(this.configuration.logLevel,et.onDidChangeLogLevel,Ne.getChannel("logger"));fe.set(W.ILoggerService,He);const nt=this._register(new W.MultiplexLogService([this._register(new W.ConsoleLogger(this.configuration.logLevel)),this._register(He.createLogger((0,i.joinPath)(C.URI.file(_e.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ge=this._register(new Z.FollowerLogService(et,nt));fe.set(W.ILogService,Ge);const Ke=this._register(new $.FileService(Ge));fe.set(U.IFileService,Ke);const it=this._register(new B.DiskFileSystemProvider(Ge));Ke.registerProvider(E.Schemas.file,it);const $e=this._register(new s.ConfigurationService(_e.settingsResource,Ke));fe.set(t.IConfigurationService,$e),await $e.initialize();const Xe=new Ee.NativeStorageService(void 0,Ne,_e);fe.set(Se.IStorageService,Xe),await Xe.initialize(),this._register((0,m.toDisposable)(()=>Xe.flush())),fe.set(le.IRequestService,new z.SyncDescriptor(ue.RequestService)),fe.set(o.IChecksumService,new z.SyncDescriptor(a.ChecksumService));const tt=h.ProxyChannel.toService(Ne.getChannel("nativeHost"),{context:this.configuration.windowId});fe.set(X.INativeHostService,tt),fe.set(u.IDownloadService,new z.SyncDescriptor(l.DownloadService));const rt=this._register(new me.ActiveWindowManager(tt)),ft=new h.StaticRouter(Ve=>rt.getActiveClientId().then(st=>Ve===st));fe.set(q.IExtensionRecommendationNotificationService,new x.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ft)));let Qe,Ye,ct=(0,Ae.getTelemetryLevel)(Ue,_e);if(ct>=1){Ye=new Fe.TelemetryLogAppender(He,_e);const{appRoot:Ve,extensionsPath:st,installSourcePath:gt}=_e;if(Ue.aiConfig&&Ue.aiConfig.asimovKey&&ct>=2){const lt=new We.AppInsightsAppender("monacoworkbench",null,Ue.aiConfig.asimovKey);this._register((0,m.toDisposable)(()=>lt.flush())),Ye=(0,Ae.combinedAppender)(lt,Ye)}Qe=new Re.TelemetryService({appender:Ye,commonProperties:(0,be.resolveCommonProperties)(Ke,(0,A.release)(),(0,A.hostname)(),process.arch,Ue.commit,Ue.version,this.configuration.machineId,Ue.msftInternalDomains,gt),sendErrorTelemetry:!0,piiPaths:[Ve,st]},$e)}else Qe=Ae.NullTelemetryService,Ye=Ae.NullAppender;this.server.registerChannel("telemetryAppender",new De.TelemetryAppenderChannel(Ye)),fe.set(Le.ITelemetryService,Qe);const dt=new Be.CustomEndpointTelemetryService($e,Qe,He,_e);return fe.set(Le.ICustomEndpointTelemetryService,dt),fe.set(O.IExtensionManagementService,new z.SyncDescriptor(F.ExtensionManagementService)),fe.set(O.IExtensionGalleryService,new z.SyncDescriptor(T.ExtensionGalleryService)),fe.set(O.IExtensionTipsService,new z.SyncDescriptor(M.ExtensionTipsService)),fe.set(Y.ILocalizationsService,new z.SyncDescriptor(H.LocalizationsService)),fe.set(n.IDiagnosticsService,new z.SyncDescriptor(r.DiagnosticsService)),fe.set(Te.IUserDataSyncAccountService,new z.SyncDescriptor(Te.UserDataSyncAccountService)),fe.set(pe.IUserDataSyncLogService,new z.SyncDescriptor(ke.UserDataSyncLogService)),fe.set(pe.IUserDataSyncUtilService,new Oe.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Ve=>Ve.ctx!=="main"))),fe.set(O.IGlobalExtensionEnablementService,new z.SyncDescriptor(w.GlobalExtensionEnablementService)),fe.set(ae.IIgnoredExtensionsManagementService,new z.SyncDescriptor(ae.IgnoredExtensionsManagementService)),fe.set(se.IExtensionsStorageSyncService,new z.SyncDescriptor(se.ExtensionsStorageSyncService)),fe.set(pe.IUserDataSyncStoreManagementService,new z.SyncDescriptor(ge.UserDataSyncStoreManagementService)),fe.set(pe.IUserDataSyncStoreService,new z.SyncDescriptor(ge.UserDataSyncStoreService)),fe.set(V.IUserDataSyncMachinesService,new z.SyncDescriptor(V.UserDataSyncMachinesService)),fe.set(pe.IUserDataSyncBackupStoreService,new z.SyncDescriptor(Pe.UserDataSyncBackupStoreService)),fe.set(pe.IUserDataAutoSyncEnablementService,new z.SyncDescriptor(ye.UserDataAutoSyncEnablementService)),fe.set(pe.IUserDataSyncResourceEnablementService,new z.SyncDescriptor(ie.UserDataSyncResourceEnablementService)),fe.set(pe.IUserDataSyncService,new z.SyncDescriptor(ce.UserDataSyncService)),fe.set(qe.ILocalPtyService,this._register(new ee.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:$e.getValue("terminal.integrated.persistentSessionScrollback")??100,useExperimentalSerialization:$e.getValue("terminal.integrated.persistentSessionExperimentalSerializer")??!0},$e,Ge,Qe))),new N.InstantiationService(fe)}initChannels(fe){const Ue=new y.ExtensionManagementChannel(fe.get(O.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Ue);const Me=h.ProxyChannel.fromService(fe.get(Y.ILocalizationsService));this.server.registerChannel("localizations",Me);const Ne=h.ProxyChannel.fromService(fe.get(n.IDiagnosticsService));this.server.registerChannel("diagnostics",Ne);const _e=new y.ExtensionTipsChannel(fe.get(O.IExtensionTipsService));this.server.registerChannel("extensionTipsService",_e);const et=h.ProxyChannel.fromService(fe.get(o.IChecksumService));this.server.registerChannel("checksum",et);const He=new Oe.UserDataSyncMachinesServiceChannel(fe.get(V.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",He);const nt=h.ProxyChannel.fromService(fe.get(Le.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",nt);const Ge=new Oe.UserDataSyncAccountServiceChannel(fe.get(Te.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ge);const Ke=new Oe.UserDataSyncStoreManagementServiceChannel(fe.get(pe.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Ke);const it=new he.UserDataSyncChannel(fe.get(pe.IUserDataSyncService),fe.get(W.ILogService));this.server.registerChannel("userDataSync",it);const $e=this._register(fe.get(j.IInstantiationService).createInstance(we.UserDataAutoSyncService)),Xe=new Oe.UserDataAutoSyncChannel($e);this.server.registerChannel("userDataAutoSync",Xe);const tt=fe.get(qe.ILocalPtyService),rt=h.ProxyChannel.fromService(tt);this.server.registerChannel(xe.TerminalIpcChannels.LocalPty,rt)}registerErrorHandler(fe){window.addEventListener("unhandledrejection",Ue=>{(0,P.onUnexpectedError)(Ue.reason),Ue.preventDefault()}),(0,P.setUnexpectedErrorHandler)(Ue=>{const Me=(0,k.toErrorMessage)(Ue,!0);!Me||fe.error(`[uncaught exception in sharedProcess]: ${Me}`)})}}async function Ie(Ce){const fe=new ve(Ce);D.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await fe.open(),D.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Ie})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/34861b8c8aa76b517f203743ad5b5d72ef5fcd81/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
