/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/base/common/errors","vs/base/common/buffer","vs/base/node/pfs","vs/platform/files/common/files","vs/platform/product/common/productService","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/platform/environment/electron-main/environmentMainService","vs/base/common/cancellation","vs/base/common/strings","os","vs/platform/workspaces/common/workspaces","vs/base/common/uuid","vs/base/common/extpath","fs","vs/base/common/arrays","vs/base/common/process","vs/base/common/labels","vs/platform/telemetry/common/telemetry","vs/base/parts/ipc/common/ipc","vs/platform/windows/electron-main/windows","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/state/electron-main/state","vs/base/common/json","child_process","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/objects","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/environment/common/environment","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/platform/environment/node/argvHelper","vs/platform/protocol/electron-main/protocol","vs/base/parts/ipc/node/ipc.net","vs/base/common/keyCodes","crypto","net","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/normalization","vs/base/node/id","vs/base/common/errorMessage","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryUtils","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/jsonEdit","vs/base/common/scanCode","vs/base/common/hash","vs/base/node/decoder","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/watcher","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/files/common/io","vs/platform/remote/common/tunnel","vs/platform/storage/common/storage","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/keybindingParser","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/node/crypto","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/configuration/common/userConfigurationFileService","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","zlib","vs/platform/driver/node/driver","vs/platform/driver/electron-main/driver","vs/platform/backup/electron-main/backupMainService","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","assert","vs/code/electron-main/main"],Z=function(K){for(var e=[],y=0,L=K.length;y<L;y++)e[y]=J[K[y]];return e};define(J[102],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function y(L,k){if(!L)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=y}),define(J[46],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function y(E){return(r,f,w)=>{let t=null,P=null;if(typeof w.value=="function"?(t="value",P=w.value):typeof w.get=="function"&&(t="get",P=w.get),!P)throw new Error("not supported");w[t]=E(P,f)}}e.createDecorator=y;function L(E,r,f){let w=null,t=null;if(typeof f.value=="function"?(w="value",t=f.value,t.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(w="get",t=f.get),!t)throw new Error("not supported");const P=`$memoize$${r}`;f[w]=function(...b){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:t.apply(this,b)}),this[P]}}e.memoize=L;function k(E,r,f){return y((w,t)=>{const P=`$debounce$${t}`,b=`$debounce$result$${t}`;return function(...p){this[b]||(this[b]=f?f():void 0),clearTimeout(this[P]),r&&(this[b]=r(this[b],...p),p=[this[b]]),this[P]=setTimeout(()=>{w.apply(this,p),this[b]=f?f():void 0},E)}})}e.debounce=k;function D(E,r,f){return y((w,t)=>{const P=`$throttle$timer$${t}`,b=`$throttle$result$${t}`,p=`$throttle$lastRun$${t}`,d=`$throttle$pending$${t}`;return function(...g){if(this[b]||(this[b]=f?f():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),r&&(this[b]=r(this[b],...g)),this[d])return;const I=this[p]+E;I<=Date.now()?(this[p]=Date.now(),w.apply(this,[this[b]]),this[b]=f?f():void 0):(this[d]=!0,this[P]=setTimeout(()=>{this[d]=!1,this[p]=Date.now(),w.apply(this,[this[b]]),this[b]=f?f():void 0},I-Date.now()))}})}e.throttle=D}),define(J[17],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class y{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(a=>{a(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=y,e.errorHandler=new y;function L(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=L;function k(c){f(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=k;function D(c){f(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=D;function E(c){if(c instanceof Error){let{name:i,message:a}=c;const n=c.stacktrace||c.stack;return{$isError:!0,name:i,message:a,stack:n}}return c}e.transformErrorForSerialization=E;const r="Canceled";function f(c){return c instanceof Error&&c.name===r&&c.message===r}e.isPromiseCanceledError=f;class w extends Error{constructor(){super(r);this.name=this.message}}e.CancellationError=w;function t(){const c=new Error(r);return c.name=c.message,c}e.canceled=t;function P(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=P;function b(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=b;function p(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function d(c){const i=new Error(`${c} has been disposed`);return i.name="DISPOSED",i}e.disposed=d;function g(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=g;class I extends Error{constructor(i){super("NotImplemented");i&&(this.message=i)}}e.NotImplementedError=I;class v extends Error{constructor(i){super("NotSupported");i&&(this.message=i)}}e.NotSupportedError=v;class u extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=u;function h(c){const i=c;return i instanceof Error&&Array.isArray(i.actions)}e.isErrorWithActions=h;function o(c,i=Object.create(null)){const a=new Error(c);return i.actions&&(a.actions=i.actions),a}e.createErrorWithActions=o}),define(J[31],Z([0,1,17]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(T,R=0){return T[T.length-(1+R)]}e.tail=L;function k(T){if(T.length===0)throw new Error("Invalid tail call");return[T.slice(0,T.length-1),T[T.length-1]]}e.tail2=k;function D(T,R,O=(_,N)=>_===N){if(T===R)return!0;if(!T||!R||T.length!==R.length)return!1;for(let _=0,N=T.length;_<N;_++)if(!O(T[_],R[_]))return!1;return!0}e.equals=D;function E(T,R,O){let _=0,N=T.length-1;for(;_<=N;){const B=(_+N)/2|0,H=O(T[B],R);if(H<0)_=B+1;else if(H>0)N=B-1;else return B}return-(_+1)}e.binarySearch=E;function r(T,R){let O=0,_=T.length;if(_===0)return 0;for(;O<_;){const N=Math.floor((O+_)/2);R(T[N])?_=N:O=N+1}return O}e.findFirstInSorted=r;function f(T,R,O){if(T=T|0,T>=R.length)throw new TypeError("invalid index");let _=R[Math.floor(R.length*Math.random())],N=[],B=[],H=[];for(let x of R){const ie=O(x,_);ie<0?N.push(x):ie>0?B.push(x):H.push(x)}return T<N.length?f(T,N,O):T<N.length+H.length?H[0]:f(T-(N.length+H.length),B,O)}e.quickSelect=f;function w(T,R){const O=[];let _;for(const N of T.slice(0).sort(R))!_||R(_[0],N)!==0?(_=[N],O.push(_)):_.push(N);return O}e.groupBy=w;function t(T,R,O){const _=[];function N(x,ie,ae){if(ie===0&&ae.length===0)return;const oe=_[_.length-1];oe&&oe.start+oe.deleteCount===x?(oe.deleteCount+=ie,oe.toInsert.push(...ae)):_.push({start:x,deleteCount:ie,toInsert:ae})}let B=0,H=0;for(;;){if(B===T.length){N(B,0,R.slice(H));break}if(H===R.length){N(B,T.length-B,[]);break}const x=T[B],ie=R[H],ae=O(x,ie);ae===0?(B+=1,H+=1):ae<0?(N(B,1,[]),B+=1):ae>0&&(N(B,0,[ie]),H+=1)}return _}e.sortedDiff=t;function P(T,R,O){const _=t(T,R,O),N=[],B=[];for(const H of _)N.push(...T.slice(H.start,H.start+H.deleteCount)),B.push(...H.toInsert);return{removed:N,added:B}}e.delta=P;function b(T,R,O){if(O===0)return[];const _=T.slice(0,O).sort(R);return d(T,R,_,O,T.length),_}e.top=b;function p(T,R,O,_,N){return O===0?Promise.resolve([]):new Promise((B,H)=>{(async()=>{const x=T.length,ie=T.slice(0,O).sort(R);for(let ae=O,oe=Math.min(O+_,x);ae<x;ae=oe,oe=Math.min(oe+_,x)){if(ae>O&&await new Promise(se=>setTimeout(se)),N&&N.isCancellationRequested)throw(0,y.canceled)();d(T,R,ie,ae,oe)}return ie})().then(B,H)})}e.topAsync=p;function d(T,R,O,_,N){for(const B=O.length;_<N;_++){const H=T[_];if(R(H,O[B-1])<0){O.pop();const x=r(O,ie=>R(H,ie)<0);O.splice(x,0,H)}}}function g(T){return T.filter(R=>!!R)}e.coalesce=g;function I(T){let R=0;for(let O=0;O<T.length;O++)T[O]&&(T[R]=T[O],R+=1);T.length=R}e.coalesceInPlace=I;function v(T,R,O){T.splice(O,0,T.splice(R,1)[0])}e.move=v;function u(T){return!Array.isArray(T)||T.length===0}e.isFalsyOrEmpty=u;function h(T){return Array.isArray(T)&&T.length>0}e.isNonEmptyArray=h;function o(T,R){if(!R)return T.filter((_,N)=>T.indexOf(_)===N);const O=Object.create(null);return T.filter(_=>{const N=R(_);return O[N]?!1:(O[N]=!0,!0)})}e.distinct=o;function c(T){const R=new Set;return T.filter(O=>R.has(O)?!1:(R.add(O),!0))}e.distinctES6=c;function i(T){const R=Object.create(null);return O=>{const _=T(O);return R[_]?!1:(R[_]=!0,!0)}}e.uniqueFilter=i;function a(T,R){for(let O=T.length-1;O>=0;O--){const _=T[O];if(R(_))return O}return-1}e.lastIndex=a;function n(T,R){return T.length>0?T[0]:R}e.firstOrDefault=n;function s(T,R,O=(_,N)=>_===N){let _=0;for(let N=0,B=Math.min(T.length,R.length);N<B&&O(T[N],R[N]);N++)_++;return _}e.commonPrefixLength=s;function l(T){return[].concat(...T)}e.flatten=l;function m(T,R){let O=typeof R=="number"?T:0;typeof R=="number"?O=T:(O=0,R=T);const _=[];if(O<=R)for(let N=O;N<R;N++)_.push(N);else for(let N=O;N>R;N--)_.push(N);return _}e.range=m;function S(T,R,O){return T.reduce((_,N)=>(_[R(N)]=O?O(N):N,_),Object.create(null))}e.index=S;function M(T,R){return T.push(R),()=>A(T,R)}e.insert=M;function A(T,R){const O=T.indexOf(R);if(O>-1)return T.splice(O,1),R}e.remove=A;function F(T,R,O){const _=T.slice(0,R),N=T.slice(R);return _.concat(O,N)}e.arrayInsert=F;function C(T,R){let O;if(typeof R=="number"){let _=R;O=()=>{const N=Math.sin(_++)*179426549;return N-Math.floor(N)}}else O=Math.random;for(let _=T.length-1;_>0;_-=1){const N=Math.floor(O()*(_+1)),B=T[_];T[_]=T[N],T[N]=B}}e.shuffle=C;function X(T,R){const O=T.indexOf(R);O>-1&&(T.splice(O,1),T.unshift(R))}e.pushToStart=X;function ee(T,R){const O=T.indexOf(R);O>-1&&(T.splice(O,1),T.push(R))}e.pushToEnd=ee;function re(T,R){return Array.isArray(T)?T.map(R):R(T)}e.mapArrayOrNot=re;function Y(T){return Array.isArray(T)?T:[T]}e.asArray=Y;function Q(T){return T[Math.floor(Math.random()*T.length)]}e.getRandomElement=Q;function W(T,R){for(const O of T){const _=R(O);if(_!==void 0)return _}}e.mapFind=W;function V(T,R,O){const _=$(T,R),N=T.length,B=O.length;T.length=N+B;for(let H=N-1;H>=_;H--)T[H+B]=T[H];for(let H=0;H<B;H++)T[H+_]=O[H]}e.insertInto=V;function z(T,R,O,_){const N=$(T,R),B=T.splice(N,O);return V(T,N,_),B}e.splice=z;function $(T,R){return R<0?Math.max(R+T.length,0):Math.min(R,T.length)}function j(T,R){let O=Number.MAX_SAFE_INTEGER,_=0;return T.forEach((N,B)=>{const H=R(N);H<O&&(O=H,_=B)}),_}e.minIndex=j;function U(T,R){let O=Number.MIN_SAFE_INTEGER,_=0;return T.forEach((N,B)=>{const H=R(N);H>O&&(O=H,_=B)}),_}e.maxIndex=U;class q{constructor(R){this.items=R,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(R){let O=this.firstIdx;for(;O<this.items.length&&R(this.items[O]);)O++;const _=O===this.firstIdx?null:this.items.slice(this.firstIdx,O);return this.firstIdx=O,_}takeFromEndWhile(R){let O=this.lastIdx;for(;O>=0&&R(this.items[O]);)O--;const _=O===this.lastIdx?null:this.items.slice(O+1,this.lastIdx+1);return this.lastIdx=O,_}}e.ArrayQueue=q}),define(J[43],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function y(L){const k=this;let D=!1,E;return function(){return D||(D=!0,E=L.apply(k,arguments)),E}}e.once=y}),define(J[63],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var y;(function(L){function k(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}L.is=k;const D=Object.freeze([]);function E(){return D}L.empty=E;function*r(c){yield c}L.single=r;function f(c){return c||D}L.from=f;function w(c){return!c||c[Symbol.iterator]().next().done===!0}L.isEmpty=w;function t(c){return c[Symbol.iterator]().next().value}L.first=t;function P(c,i){for(const a of c)if(i(a))return!0;return!1}L.some=P;function b(c,i){for(const a of c)if(i(a))return a}L.find=b;function*p(c,i){for(const a of c)i(a)&&(yield a)}L.filter=p;function*d(c,i){let a=0;for(const n of c)yield i(n,a++)}L.map=d;function*g(...c){for(const i of c)for(const a of i)yield a}L.concat=g;function*I(c){for(const i of c)for(const a of i)yield a}L.concatNested=I;function v(c,i,a){let n=a;for(const s of c)n=i(n,s);return n}L.reduce=v;function*u(c,i,a=c.length){for(i<0&&(i+=c.length),a<0?a+=c.length:a>c.length&&(a=c.length);i<a;i++)yield c[i]}L.slice=u;function h(c,i=Number.POSITIVE_INFINITY){const a=[];if(i===0)return[a,c];const n=c[Symbol.iterator]();for(let s=0;s<i;s++){const l=n.next();if(l.done)return[a,L.empty()];a.push(l.value)}return[a,{[Symbol.iterator](){return n}}]}L.consume=h;function o(c,i,a=(n,s)=>n===s){const n=c[Symbol.iterator](),s=i[Symbol.iterator]();for(;;){const l=n.next(),m=s.next();if(l.done!==m.done)return!1;if(l.done)return!0;if(!a(l.value,m.value))return!1}}L.equals=o})(y=e.Iterable||(e.Iterable={}))}),define(J[40],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var y;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(y=e.ScanError||(e.ScanError={}));var L;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var D;(function(i){i.DEFAULT={allowTrailingComma:!0}})(D=e.ParseOptions||(e.ParseOptions={}));function E(i,a=!1){let n=0,s=i.length,l="",m=0,S=16,M=0;function A(Q){let W=0,V=0;for(;W<Q;){const z=i.charCodeAt(n);if(z>=48&&z<=57)V=V*16+z-48;else if(z>=65&&z<=70)V=V*16+z-65+10;else if(z>=97&&z<=102)V=V*16+z-97+10;else break;n++,W++}return W<Q&&(V=-1),V}function F(Q){n=Q,l="",m=0,S=16,M=0}function C(){const Q=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&w(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&w(i.charCodeAt(n)))for(n++;n<i.length&&w(i.charCodeAt(n));)n++;else return M=3,i.substring(Q,n);let W=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&w(i.charCodeAt(n))){for(n++;n<i.length&&w(i.charCodeAt(n));)n++;W=n}else M=3;return i.substring(Q,W)}function X(){let Q="",W=n;for(;;){if(n>=s){Q+=i.substring(W,n),M=2;break}const V=i.charCodeAt(n);if(V===34){Q+=i.substring(W,n),n++;break}if(V===92){if(Q+=i.substring(W,n),n++,n>=s){M=2;break}switch(i.charCodeAt(n++)){case 34:Q+='"';break;case 92:Q+="\\";break;case 47:Q+="/";break;case 98:Q+="\b";break;case 102:Q+="\f";break;case 110:Q+=`
`;break;case 114:Q+="\r";break;case 116:Q+="	";break;case 117:const $=A(4);$>=0?Q+=String.fromCharCode($):M=4;break;default:M=5}W=n;continue}if(V>=0&&V<=31)if(f(V)){Q+=i.substring(W,n),M=2;break}else M=6;n++}return Q}function ee(){if(l="",M=0,m=n,n>=s)return m=s,S=17;let Q=i.charCodeAt(n);if(r(Q)){do n++,l+=String.fromCharCode(Q),Q=i.charCodeAt(n);while(r(Q));return S=15}if(f(Q))return n++,l+=String.fromCharCode(Q),Q===13&&i.charCodeAt(n)===10&&(n++,l+=`
`),S=14;switch(Q){case 123:return n++,S=1;case 125:return n++,S=2;case 91:return n++,S=3;case 93:return n++,S=4;case 58:return n++,S=6;case 44:return n++,S=5;case 34:return n++,l=X(),S=10;case 47:const W=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<s&&!f(i.charCodeAt(n));)n++;return l=i.substring(W,n),S=12}if(i.charCodeAt(n+1)===42){n+=2;const V=s-1;let z=!1;for(;n<V;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,z=!0;break}n++}return z||(n++,M=1),l=i.substring(W,n),S=13}return l+=String.fromCharCode(Q),n++,S=16;case 45:if(l+=String.fromCharCode(Q),n++,n===s||!w(i.charCodeAt(n)))return S=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=C(),S=11;default:for(;n<s&&re(Q);)n++,Q=i.charCodeAt(n);if(m!==n){switch(l=i.substring(m,n),l){case"true":return S=8;case"false":return S=9;case"null":return S=7}return S=16}return l+=String.fromCharCode(Q),n++,S=16}}function re(Q){if(r(Q)||f(Q))return!1;switch(Q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function Y(){let Q;do Q=ee();while(Q>=12&&Q<=15);return Q}return{setPosition:F,getPosition:()=>n,scan:a?Y:ee,getToken:()=>S,getTokenValue:()=>l,getTokenOffset:()=>m,getTokenLength:()=>n-m,getTokenError:()=>M}}e.createScanner=E;function r(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function f(i){return i===10||i===13||i===8232||i===8233}function w(i){return i>=48&&i<=57}var t;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(t||(t={}));function P(i,a){const n=[],s=new Object;let l;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function M(A,F,C,X){m.value=A,m.offset=F,m.length=C,m.type=X,m.colonOffset=void 0,l=m}try{h(i,{onObjectBegin:(A,F)=>{if(a<=A)throw s;l=void 0,S=a>A,n.push("")},onObjectProperty:(A,F,C)=>{if(a<F||(M(A,F,C,"property"),n[n.length-1]=A,a<=F+C))throw s},onObjectEnd:(A,F)=>{if(a<=A)throw s;l=void 0,n.pop()},onArrayBegin:(A,F)=>{if(a<=A)throw s;l=void 0,n.push(0)},onArrayEnd:(A,F)=>{if(a<=A)throw s;l=void 0,n.pop()},onLiteralValue:(A,F,C)=>{if(a<F||(M(A,F,C,c(A)),a<=F+C))throw s},onSeparator:(A,F,C)=>{if(a<=F)throw s;if(A===":"&&l&&l.type==="property")l.colonOffset=F,S=!1,l=void 0;else if(A===","){const X=n[n.length-1];typeof X=="number"?n[n.length-1]=X+1:(S=!0,n[n.length-1]=""),l=void 0}}})}catch(A){if(A!==s)throw A}return{path:n,previousNode:l,isAtPropertyKey:S,matches:A=>{let F=0;for(let C=0;F<A.length&&C<n.length;C++)if(A[F]===n[C]||A[F]==="*")F++;else if(A[F]!=="**")return!1;return F===A.length}}}e.getLocation=P;function b(i,a=[],n=D.DEFAULT){let s=null,l=[];const m=[];function S(A){Array.isArray(l)?l.push(A):s!==null&&(l[s]=A)}return h(i,{onObjectBegin:()=>{const A={};S(A),m.push(l),l=A,s=null},onObjectProperty:A=>{s=A},onObjectEnd:()=>{l=m.pop()},onArrayBegin:()=>{const A=[];S(A),m.push(l),l=A,s=null},onArrayEnd:()=>{l=m.pop()},onLiteralValue:S,onError:(A,F,C)=>{a.push({error:A,offset:F,length:C})}},n),l[0]}e.parse=b;function p(i,a=[],n=D.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(A){s.type==="property"&&(s.length=A-s.offset,s=s.parent)}function m(A){return s.children.push(A),A}h(i,{onObjectBegin:A=>{s=m({type:"object",offset:A,length:-1,parent:s,children:[]})},onObjectProperty:(A,F,C)=>{s=m({type:"property",offset:F,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:A,offset:F,length:C,parent:s})},onObjectEnd:(A,F)=>{s.length=A+F-s.offset,s=s.parent,l(A+F)},onArrayBegin:(A,F)=>{s=m({type:"array",offset:A,length:-1,parent:s,children:[]})},onArrayEnd:(A,F)=>{s.length=A+F-s.offset,s=s.parent,l(A+F)},onLiteralValue:(A,F,C)=>{m({type:c(A),offset:F,length:C,parent:s,value:A}),l(F+C)},onSeparator:(A,F,C)=>{s.type==="property"&&(A===":"?s.colonOffset=F:A===","&&l(F))},onError:(A,F,C)=>{a.push({error:A,offset:F,length:C})}},n);const M=s.children[0];return M&&delete M.parent,M}e.parseTree=p;function d(i,a){if(!i)return;let n=i;for(let s of a)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let l=!1;for(const m of n.children)if(Array.isArray(m.children)&&m.children[0].value===s){n=m.children[1],l=!0;break}if(!l)return}else{const l=s;if(n.type!=="array"||l<0||!Array.isArray(n.children)||l>=n.children.length)return;n=n.children[l]}return n}e.findNodeAtLocation=d;function g(i){if(!i.parent||!i.parent.children)return[];const a=g(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;a.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&a.push(n)}return a}e.getNodePath=g;function I(i){switch(i.type){case"array":return i.children.map(I);case"object":const a=Object.create(null);for(let n of i.children){const s=n.children[1];s&&(a[n.children[0].value]=I(s))}return a;case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=I;function v(i,a,n=!1){return a>=i.offset&&a<i.offset+i.length||n&&a===i.offset+i.length}e.contains=v;function u(i,a,n=!1){if(v(i,a,n)){const s=i.children;if(Array.isArray(s))for(let l=0;l<s.length&&s[l].offset<=a;l++){const m=u(s[l],a,n);if(m)return m}return i}}e.findNodeAtOffset=u;function h(i,a,n=D.DEFAULT){const s=E(i,!1);function l(O){return O?()=>O(s.getTokenOffset(),s.getTokenLength()):()=>!0}function m(O){return O?_=>O(_,s.getTokenOffset(),s.getTokenLength()):()=>!0}const S=l(a.onObjectBegin),M=m(a.onObjectProperty),A=l(a.onObjectEnd),F=l(a.onArrayBegin),C=l(a.onArrayEnd),X=m(a.onLiteralValue),ee=m(a.onSeparator),re=l(a.onComment),Y=m(a.onError),Q=n&&n.disallowComments,W=n&&n.allowTrailingComma;function V(){for(;;){const O=s.scan();switch(s.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:Q||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(O){case 12:case 13:Q?z(10):re();break;case 16:z(1);break;case 15:case 14:break;default:return O}}}function z(O,_=[],N=[]){if(Y(O),_.length+N.length>0){let B=s.getToken();for(;B!==17;){if(_.indexOf(B)!==-1){V();break}else if(N.indexOf(B)!==-1)break;B=V()}}}function $(O){const _=s.getTokenValue();return O?X(_):M(_),V(),!0}function j(){switch(s.getToken()){case 11:let O=0;try{O=JSON.parse(s.getTokenValue()),typeof O!="number"&&(z(2),O=0)}catch(_){z(2)}X(O);break;case 7:X(null);break;case 8:X(!0);break;case 9:X(!1);break;default:return!1}return V(),!0}function U(){return s.getToken()!==10?(z(3,[],[2,5]),!1):($(!1),s.getToken()===6?(ee(":"),V(),R()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function q(){S(),V();let O=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(O||z(4,[],[]),ee(","),V(),s.getToken()===2&&W)break}else O&&z(6,[],[]);U()||z(4,[],[2,5]),O=!0}return A(),s.getToken()!==2?z(7,[2],[]):V(),!0}function T(){F(),V();let O=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(O||z(4,[],[]),ee(","),V(),s.getToken()===4&&W)break}else O&&z(6,[],[]);R()||z(4,[],[4,5]),O=!0}return C(),s.getToken()!==4?z(8,[4],[]):V(),!0}function R(){switch(s.getToken()){case 3:return T();case 1:return q();case 10:return $(!0);default:return j()}}return V(),s.getToken()===17?n.allowEmptyContent?!0:(z(4,[],[]),!1):R()?(s.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.visit=h;function o(i,a){let n=E(i),s=[],l,m=0,S;do switch(S=n.getPosition(),l=n.scan(),l){case 12:case 13:case 17:m!==S&&s.push(i.substring(m,S)),a!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,a)),m=n.getPosition();break}while(l!==17);return s.join("")}e.stripComments=o;function c(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(J[103],Z([0,1,40]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(f,w,t){let P,b,p,d,g;if(w){for(d=w.offset,g=d+w.length,p=d;p>0&&!r(f,p-1);)p--;let m=g;for(;m<f.length&&!r(f,m);)m++;b=f.substring(p,m),P=D(b,t)}else b=f,P=0,p=0,d=0,g=f.length;const I=E(t,f);let v=!1,u=0,h;t.insertSpaces?h=k(" ",t.tabSize||4):h="	";const o=(0,y.createScanner)(b,!1);let c=!1;function i(){return I+k(h,P+u)}function a(){let m=o.scan();for(v=!1;m===15||m===14;)v=v||m===14,m=o.scan();return c=m===16||o.getTokenError()!==0,m}const n=[];function s(m,S,M){!c&&S<g&&M>d&&f.substring(S,M)!==m&&n.push({offset:S,length:M-S,content:m})}let l=a();if(l!==17){const m=o.getTokenOffset()+p,S=k(h,P);s(S,p,m)}for(;l!==17;){let m=o.getTokenOffset()+o.getTokenLength()+p,S=a(),M="";for(;!v&&(S===12||S===13);){const F=o.getTokenOffset()+p;s(" ",m,F),m=o.getTokenOffset()+o.getTokenLength()+p,M=S===12?i():"",S=a()}if(S===2)l!==1&&(u--,M=i());else if(S===4)l!==3&&(u--,M=i());else{switch(l){case 3:case 1:u++,M=i();break;case 5:case 12:M=i();break;case 13:v?M=i():M=" ";break;case 6:M=" ";break;case 10:if(S===6){M="";break}case 7:case 8:case 9:case 11:case 2:case 4:S===12||S===13?M=" ":S!==5&&S!==17&&(c=!0);break;case 16:c=!0;break}v&&(S===12||S===13)&&(M=i())}const A=o.getTokenOffset()+p;s(M,m,A),l=S}return n}e.format=L;function k(f,w){let t="";for(let P=0;P<w;P++)t+=f;return t}function D(f,w){let t=0,P=0;const b=w.tabSize||4;for(;t<f.length;){const p=f.charAt(t);if(p===" ")P++;else if(p==="	")P+=b;else break;t++}return Math.floor(P/b)}function E(f,w){for(let t=0;t<w.length;t++){const P=w.charAt(t);if(P==="\r")return t+1<w.length&&w.charAt(t+1)===`
`?`\r
`:"\r";if(P===`
`)return`
`}return f&&f.eol||`
`}e.getEOL=E;function r(f,w){return`\r
`.indexOf(f.charAt(w))!==-1}e.isEOL=r}),define(J[77],Z([0,1,40,103]),function(K,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(w,t,P){return D(w,t,void 0,P)}e.removeProperty=k;function D(w,t,P,b,p){const d=t.slice(),g=[],I=(0,y.parseTree)(w,g);let v,u;for(;d.length>0&&(u=d.pop(),v=(0,y.findNodeAtLocation)(I,d),v===void 0&&P!==void 0);)typeof u=="string"?P={[u]:P}:P=[P];if(v)if(v.type==="object"&&typeof u=="string"&&Array.isArray(v.children)){const h=(0,y.findNodeAtLocation)(v,[u]);if(h!==void 0)if(P===void 0){if(!h.parent)throw new Error("Malformed AST");const o=v.children.indexOf(h.parent);let c,i=h.parent.offset+h.parent.length;if(o>0){const a=v.children[o-1];c=a.offset+a.length}else c=v.offset+1,v.children.length>1&&(i=v.children[1].offset);return E(w,{offset:c,length:i-c,content:""},b)}else return E(w,{offset:h.offset,length:h.length,content:JSON.stringify(P)},b);else{if(P===void 0)return[];const o=`${JSON.stringify(u)}: ${JSON.stringify(P)}`,c=p?p(v.children.map(a=>a.children[0].value)):v.children.length;let i;if(c>0){const a=v.children[c-1];i={offset:a.offset+a.length,length:0,content:","+o}}else v.children.length===0?i={offset:v.offset+1,length:0,content:o}:i={offset:v.offset+1,length:0,content:o+","};return E(w,i,b)}}else if(v.type==="array"&&typeof u=="number"&&Array.isArray(v.children))if(P!==void 0){const h=`${JSON.stringify(P)}`;let o;if(v.children.length===0||u===0)o={offset:v.offset+1,length:0,content:v.children.length===0?h:h+","};else{const c=u===-1||u>v.children.length?v.children.length:u,i=v.children[c-1];o={offset:i.offset+i.length,length:0,content:","+h}}return E(w,o,b)}else{const h=u,o=v.children[h];let c;if(v.children.length===1)c={offset:v.offset+1,length:v.length-2,content:""};else if(v.children.length-1===h){const i=v.children[h-1],a=i.offset+i.length,n=v.offset+v.length;c={offset:a,length:n-2-a,content:""}}else c={offset:o.offset,length:v.children[h+1].offset-o.offset,content:""};return E(w,c,b)}else throw new Error(`Can not add ${typeof u!="number"?"index":"property"} to parent of type ${v.type}`);else{if(P===void 0)throw new Error("Can not delete in empty document");return E(w,{offset:I?I.offset:0,length:I?I.length:0,content:JSON.stringify(P)},b)}}e.setProperty=D;function E(w,t,P){let b=r(w,t),p=t.offset,d=t.offset+t.content.length;if(t.length===0||t.content.length===0){for(;p>0&&!(0,L.isEOL)(b,p-1);)p--;for(;d<b.length&&!(0,L.isEOL)(b,d);)d++}const g=(0,L.format)(b,{offset:p,length:d-p},P);for(let v=g.length-1;v>=0;v--){const u=g[v];b=r(b,u),p=Math.min(p,u.offset),d=Math.max(d,u.offset+u.length),d+=u.content.length-u.length}const I=w.length-(b.length-d)-p;return[{offset:p,length:I,content:b.substring(p,d)}]}e.withFormatting=E;function r(w,t){return w.substring(0,t.offset)+t.content+w.substring(t.offset+t.length)}e.applyEdit=r;function f(w,t){let P=t.slice(0).sort((p,d)=>{const g=p.offset-d.offset;return g===0?p.length-d.length:g}),b=w.length;for(let p=P.length-1;p>=0;p--){let d=P[p];if(d.offset+d.length<=b)w=r(w,d);else throw new Error("Overlapping edit");b=d.offset}return w}e.applyEdits=f}),define(J[57],Z([0,1,17]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.KeyCode=void 0;var L;(function(u){u[u.DependsOnKbLayout=-1]="DependsOnKbLayout",u[u.Unknown=0]="Unknown",u[u.Backspace=1]="Backspace",u[u.Tab=2]="Tab",u[u.Enter=3]="Enter",u[u.Shift=4]="Shift",u[u.Ctrl=5]="Ctrl",u[u.Alt=6]="Alt",u[u.PauseBreak=7]="PauseBreak",u[u.CapsLock=8]="CapsLock",u[u.Escape=9]="Escape",u[u.Space=10]="Space",u[u.PageUp=11]="PageUp",u[u.PageDown=12]="PageDown",u[u.End=13]="End",u[u.Home=14]="Home",u[u.LeftArrow=15]="LeftArrow",u[u.UpArrow=16]="UpArrow",u[u.RightArrow=17]="RightArrow",u[u.DownArrow=18]="DownArrow",u[u.Insert=19]="Insert",u[u.Delete=20]="Delete",u[u.KEY_0=21]="KEY_0",u[u.KEY_1=22]="KEY_1",u[u.KEY_2=23]="KEY_2",u[u.KEY_3=24]="KEY_3",u[u.KEY_4=25]="KEY_4",u[u.KEY_5=26]="KEY_5",u[u.KEY_6=27]="KEY_6",u[u.KEY_7=28]="KEY_7",u[u.KEY_8=29]="KEY_8",u[u.KEY_9=30]="KEY_9",u[u.KEY_A=31]="KEY_A",u[u.KEY_B=32]="KEY_B",u[u.KEY_C=33]="KEY_C",u[u.KEY_D=34]="KEY_D",u[u.KEY_E=35]="KEY_E",u[u.KEY_F=36]="KEY_F",u[u.KEY_G=37]="KEY_G",u[u.KEY_H=38]="KEY_H",u[u.KEY_I=39]="KEY_I",u[u.KEY_J=40]="KEY_J",u[u.KEY_K=41]="KEY_K",u[u.KEY_L=42]="KEY_L",u[u.KEY_M=43]="KEY_M",u[u.KEY_N=44]="KEY_N",u[u.KEY_O=45]="KEY_O",u[u.KEY_P=46]="KEY_P",u[u.KEY_Q=47]="KEY_Q",u[u.KEY_R=48]="KEY_R",u[u.KEY_S=49]="KEY_S",u[u.KEY_T=50]="KEY_T",u[u.KEY_U=51]="KEY_U",u[u.KEY_V=52]="KEY_V",u[u.KEY_W=53]="KEY_W",u[u.KEY_X=54]="KEY_X",u[u.KEY_Y=55]="KEY_Y",u[u.KEY_Z=56]="KEY_Z",u[u.Meta=57]="Meta",u[u.ContextMenu=58]="ContextMenu",u[u.F1=59]="F1",u[u.F2=60]="F2",u[u.F3=61]="F3",u[u.F4=62]="F4",u[u.F5=63]="F5",u[u.F6=64]="F6",u[u.F7=65]="F7",u[u.F8=66]="F8",u[u.F9=67]="F9",u[u.F10=68]="F10",u[u.F11=69]="F11",u[u.F12=70]="F12",u[u.F13=71]="F13",u[u.F14=72]="F14",u[u.F15=73]="F15",u[u.F16=74]="F16",u[u.F17=75]="F17",u[u.F18=76]="F18",u[u.F19=77]="F19",u[u.NumLock=78]="NumLock",u[u.ScrollLock=79]="ScrollLock",u[u.US_SEMICOLON=80]="US_SEMICOLON",u[u.US_EQUAL=81]="US_EQUAL",u[u.US_COMMA=82]="US_COMMA",u[u.US_MINUS=83]="US_MINUS",u[u.US_DOT=84]="US_DOT",u[u.US_SLASH=85]="US_SLASH",u[u.US_BACKTICK=86]="US_BACKTICK",u[u.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",u[u.US_BACKSLASH=88]="US_BACKSLASH",u[u.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",u[u.US_QUOTE=90]="US_QUOTE",u[u.OEM_8=91]="OEM_8",u[u.OEM_102=92]="OEM_102",u[u.NUMPAD_0=93]="NUMPAD_0",u[u.NUMPAD_1=94]="NUMPAD_1",u[u.NUMPAD_2=95]="NUMPAD_2",u[u.NUMPAD_3=96]="NUMPAD_3",u[u.NUMPAD_4=97]="NUMPAD_4",u[u.NUMPAD_5=98]="NUMPAD_5",u[u.NUMPAD_6=99]="NUMPAD_6",u[u.NUMPAD_7=100]="NUMPAD_7",u[u.NUMPAD_8=101]="NUMPAD_8",u[u.NUMPAD_9=102]="NUMPAD_9",u[u.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",u[u.NUMPAD_ADD=104]="NUMPAD_ADD",u[u.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",u[u.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",u[u.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",u[u.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",u[u.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",u[u.ABNT_C1=110]="ABNT_C1",u[u.ABNT_C2=111]="ABNT_C2",u[u.MAX_VALUE=112]="MAX_VALUE"})(L=e.KeyCode||(e.KeyCode={}));class k{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(h,o){this._keyCodeToStr[h]=o,this._strToKeyCode[o.toLowerCase()]=h}keyCodeToStr(h){return this._keyCodeToStr[h]}strToKeyCode(h){return this._strToKeyCode[h.toLowerCase()]||0}}const D=new k,E=new k,r=new k;(function(){function u(h,o,c=o,i=c){D.define(h,o),E.define(h,c),r.define(h,i)}u(0,"unknown"),u(1,"Backspace"),u(2,"Tab"),u(3,"Enter"),u(4,"Shift"),u(5,"Ctrl"),u(6,"Alt"),u(7,"PauseBreak"),u(8,"CapsLock"),u(9,"Escape"),u(10,"Space"),u(11,"PageUp"),u(12,"PageDown"),u(13,"End"),u(14,"Home"),u(15,"LeftArrow","Left"),u(16,"UpArrow","Up"),u(17,"RightArrow","Right"),u(18,"DownArrow","Down"),u(19,"Insert"),u(20,"Delete"),u(21,"0"),u(22,"1"),u(23,"2"),u(24,"3"),u(25,"4"),u(26,"5"),u(27,"6"),u(28,"7"),u(29,"8"),u(30,"9"),u(31,"A"),u(32,"B"),u(33,"C"),u(34,"D"),u(35,"E"),u(36,"F"),u(37,"G"),u(38,"H"),u(39,"I"),u(40,"J"),u(41,"K"),u(42,"L"),u(43,"M"),u(44,"N"),u(45,"O"),u(46,"P"),u(47,"Q"),u(48,"R"),u(49,"S"),u(50,"T"),u(51,"U"),u(52,"V"),u(53,"W"),u(54,"X"),u(55,"Y"),u(56,"Z"),u(57,"Meta"),u(58,"ContextMenu"),u(59,"F1"),u(60,"F2"),u(61,"F3"),u(62,"F4"),u(63,"F5"),u(64,"F6"),u(65,"F7"),u(66,"F8"),u(67,"F9"),u(68,"F10"),u(69,"F11"),u(70,"F12"),u(71,"F13"),u(72,"F14"),u(73,"F15"),u(74,"F16"),u(75,"F17"),u(76,"F18"),u(77,"F19"),u(78,"NumLock"),u(79,"ScrollLock"),u(80,";",";","OEM_1"),u(81,"=","=","OEM_PLUS"),u(82,",",",","OEM_COMMA"),u(83,"-","-","OEM_MINUS"),u(84,".",".","OEM_PERIOD"),u(85,"/","/","OEM_2"),u(86,"`","`","OEM_3"),u(110,"ABNT_C1"),u(111,"ABNT_C2"),u(87,"[","[","OEM_4"),u(88,"\\","\\","OEM_5"),u(89,"]","]","OEM_6"),u(90,"'","'","OEM_7"),u(91,"OEM_8"),u(92,"OEM_102"),u(93,"NumPad0"),u(94,"NumPad1"),u(95,"NumPad2"),u(96,"NumPad3"),u(97,"NumPad4"),u(98,"NumPad5"),u(99,"NumPad6"),u(100,"NumPad7"),u(101,"NumPad8"),u(102,"NumPad9"),u(103,"NumPad_Multiply"),u(104,"NumPad_Add"),u(105,"NumPad_Separator"),u(106,"NumPad_Subtract"),u(107,"NumPad_Decimal"),u(108,"NumPad_Divide")})();var f;(function(u){function h(n){return D.keyCodeToStr(n)}u.toString=h;function o(n){return D.strToKeyCode(n)}u.fromString=o;function c(n){return E.keyCodeToStr(n)}u.toUserSettingsUS=c;function i(n){return r.keyCodeToStr(n)}u.toUserSettingsGeneral=i;function a(n){return E.strToKeyCode(n)||r.strToKeyCode(n)}u.fromUserSettings=a})(f=e.KeyCodeUtils||(e.KeyCodeUtils={}));var w;(function(u){u[u.CtrlCmd=2048]="CtrlCmd",u[u.Shift=1024]="Shift",u[u.Alt=512]="Alt",u[u.WinCtrl=256]="WinCtrl",u[u.KeyCode=255]="KeyCode"})(w||(w={}));var t;(function(u){u[u.CtrlCmd=2048]="CtrlCmd",u[u.Shift=1024]="Shift",u[u.Alt=512]="Alt",u[u.WinCtrl=256]="WinCtrl"})(t=e.KeyMod||(e.KeyMod={}));function P(u,h){const o=(h&65535)<<16>>>0;return(u|o)>>>0}e.KeyChord=P;function b(u,h){if(u===0)return null;const o=(u&65535)>>>0,c=(u&4294901760)>>>16;return c!==0?new g([p(o,h),p(c,h)]):new g([p(o,h)])}e.createKeybinding=b;function p(u,h){const o=!!(u&2048),c=!!(u&256),i=h===2?c:o,a=!!(u&1024),n=!!(u&512),s=h===2?o:c,l=u&255;return new d(i,a,n,s,l)}e.createSimpleKeybinding=p;class d{constructor(h,o,c,i,a){this.ctrlKey=h,this.shiftKey=o,this.altKey=c,this.metaKey=i,this.keyCode=a}equals(h){return this.ctrlKey===h.ctrlKey&&this.shiftKey===h.shiftKey&&this.altKey===h.altKey&&this.metaKey===h.metaKey&&this.keyCode===h.keyCode}getHashCode(){const h=this.ctrlKey?"1":"0",o=this.shiftKey?"1":"0",c=this.altKey?"1":"0",i=this.metaKey?"1":"0";return`${h}${o}${c}${i}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new g([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=d;class g{constructor(h){if(h.length===0)throw(0,y.illegalArgument)("parts");this.parts=h}getHashCode(){let h="";for(let o=0,c=this.parts.length;o<c;o++)o!==0&&(h+=";"),h+=this.parts[o].getHashCode();return h}equals(h){if(h===null||this.parts.length!==h.parts.length)return!1;for(let o=0;o<this.parts.length;o++)if(!this.parts[o].equals(h.parts[o]))return!1;return!0}}e.ChordKeybinding=g;class I{constructor(h,o,c,i,a,n){this.ctrlKey=h,this.shiftKey=o,this.altKey=c,this.metaKey=i,this.keyLabel=a,this.keyAriaLabel=n}}e.ResolvedKeybindingPart=I;class v{}e.ResolvedKeybinding=v}),define(J[2],Z([0,1,43,63]),function(K,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let D=null;function E(n){D=n}if(e.setDisposableTracker=E,k){const n="__is_disposable_tracked__";E(new class{trackDisposable(s){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[n]||console.log(l)},3e3)}setParent(s,l){if(s&&s!==u.None)try{s[n]=!0}catch{}}markAsDisposed(s){if(s&&s!==u.None)try{s[n]=!0}catch{}}markAsSingleton(s){}})}function r(n){return D?.trackDisposable(n),n}function f(n){D?.markAsDisposed(n)}function w(n,s){D?.setParent(n,s)}function t(n,s){if(!!D)for(const l of n)D.setParent(l,s)}function P(n){return D?.markAsSingleton(n),n}e.markAsSingleton=P;class b extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=b;function p(n){return typeof n.dispose=="function"&&n.dispose.length===0}e.isDisposable=p;function d(n){if(L.Iterable.is(n)){let s=[];for(const l of n)if(l)try{l.dispose()}catch(m){s.push(m)}if(s.length===1)throw s[0];if(s.length>1)throw new b(s);return Array.isArray(n)?[]:n}else if(n)return n.dispose(),n}e.dispose=d;function g(...n){const s=I(()=>d(n));return t(n,s),s}e.combinedDisposable=g;function I(n){const s=r({dispose:(0,y.once)(()=>{f(s),n()})});return s}e.toDisposable=I;class v{constructor(){this._toDispose=new Set,this._isDisposed=!1,r(this)}dispose(){this._isDisposed||(f(this),this._isDisposed=!0,this.clear())}clear(){try{d(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return w(s,this),this._isDisposed?v.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=v,v.DISABLE_DISPOSED_WARNING=!1;class u{constructor(){this._store=new v,r(this),w(this._store,this)}dispose(){f(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=u,u.None=Object.freeze({dispose(){}});class h{constructor(){this._isDisposed=!1,r(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&w(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,f(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&w(s,null),s}}e.MutableDisposable=h;class o{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=o;class c{constructor(){this.references=new Map}acquire(s,...l){let m=this.references.get(s);m||(m={counter:0,object:this.createReferencedObject(s,...l)},this.references.set(s,m));const{object:S}=m,M=(0,y.once)(()=>{--m.counter==0&&(this.destroyReferencedObject(s,m.object),this.references.delete(s))});return m.counter++,{object:S,dispose:M}}}e.ReferenceCollection=c;class i{constructor(s){this.referenceCollection=s}async acquire(s,...l){const m=this.referenceCollection.acquire(s,...l);try{return{object:await m.object,dispose:()=>m.dispose()}}catch(S){throw m.dispose(),S}}}e.AsyncReferenceCollection=i;class a{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=a}),define(J[104],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class y{constructor(D){this.element=D,this.next=y.Undefined,this.prev=y.Undefined}}y.Undefined=new y(void 0);class L{constructor(){this._first=y.Undefined,this._last=y.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===y.Undefined}clear(){let D=this._first;for(;D!==y.Undefined;){const E=D.next;D.prev=y.Undefined,D.next=y.Undefined,D=E}this._first=y.Undefined,this._last=y.Undefined,this._size=0}unshift(D){return this._insert(D,!1)}push(D){return this._insert(D,!0)}_insert(D,E){const r=new y(D);if(this._first===y.Undefined)this._first=r,this._last=r;else if(E){const w=this._last;this._last=r,r.prev=w,w.next=r}else{const w=this._first;this._first=r,r.next=w,w.prev=r}this._size+=1;let f=!1;return()=>{f||(f=!0,this._remove(r))}}shift(){if(this._first!==y.Undefined){const D=this._first.element;return this._remove(this._first),D}}pop(){if(this._last!==y.Undefined){const D=this._last.element;return this._remove(this._last),D}}_remove(D){if(D.prev!==y.Undefined&&D.next!==y.Undefined){const E=D.prev;E.next=D.next,D.next.prev=E}else D.prev===y.Undefined&&D.next===y.Undefined?(this._first=y.Undefined,this._last=y.Undefined):D.next===y.Undefined?(this._last=this._last.prev,this._last.next=y.Undefined):D.prev===y.Undefined&&(this._first=this._first.next,this._first.prev=y.Undefined);this._size-=1}*[Symbol.iterator](){let D=this._first;for(;D!==y.Undefined;)yield D.element,D=D.next}}e.LinkedList=L}),function(){function K(k){const D=[];typeof k=="number"&&D.push("code/timeOrigin",k);function E(f){D.push(f,Date.now())}function r(){const f=[];for(let w=0;w<D.length;w+=2)f.push({name:D[w],startTime:D[w+1]});return f}return{mark:E,getMarks:r}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const E of performance.getEntriesByType("mark"))D.push({name:E.name,startTime:Math.round(k+E.startTime)});return D}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function y(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=y(L))}(),define(J[3],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const y="en";let L=!1,k=!1,D=!1,E=!1,r=!1,f=!1,w=!1,t,P=y,b,p;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?d=e.globals.vscode.process:typeof process!="undefined"&&(d=process);const g=typeof d?.versions?.electron=="string"&&d.type==="renderer";if(e.isElectronSandboxed=g&&d?.sandboxed,typeof navigator=="object"&&!g)p=navigator.userAgent,L=p.indexOf("Windows")>=0,k=p.indexOf("Macintosh")>=0,w=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=p.indexOf("Linux")>=0,f=!0,t=navigator.language,P=t;else if(typeof d=="object"){L=d.platform==="win32",k=d.platform==="darwin",D=d.platform==="linux",E=D&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,t=y,P=y;const n=d.env.VSCODE_NLS_CONFIG;if(n)try{const s=JSON.parse(n),l=s.availableLanguages["*"];t=s.locale,P=l||y,b=s._translationsConfigFile}catch(s){}r=!0}else console.error("Unable to resolve platform.");var I;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(I=e.Platform||(e.Platform={}));function v(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=v;let u=0;k?u=1:L?u=3:D&&(u=2),e.isWindows=L,e.isMacintosh=k,e.isLinux=D,e.isLinuxSnap=E,e.isNative=r,e.isWeb=f,e.isIOS=w,e.platform=u,e.userAgent=p,e.language=P;var h;(function(n){function s(){return e.language}n.value=s;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=l;function m(){return e.language==="en"}n.isDefault=m})(h=e.Language||(e.Language={})),e.locale=t,e.translationsConfigFile=b,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let l=[];e.globals.addEventListener("message",S=>{if(S.data&&S.data.vscodeSetImmediateId)for(let M=0,A=l.length;M<A;M++){const F=l[M];if(F.id===S.data.vscodeSetImmediateId){l.splice(M,1),F.callback();return}}});let m=0;return S=>{const M=++m;l.push({id:M,callback:S}),e.globals.postMessage({vscodeSetImmediateId:M},"*")}}if(typeof d?.nextTick=="function")return d.nextTick.bind(d);const s=Promise.resolve();return l=>s.then(l)}();var o;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||w?2:L?1:3;let c=!0,i=!1;function a(){if(!i){i=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,c=new Uint16Array(n.buffer)[0]===(2<<8)+1}return c}e.isLittleEndian=a}),define(J[32],Z([0,1,3]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof y.globals.vscode!="undefined"&&typeof y.globals.vscode.process!="undefined"){const k=y.globals.vscode.process;L={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()},nextTick(D){return(0,y.setImmediate)(D)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(k){return process.nextTick(k)}}:L={get platform(){return y.isWindows?"win32":y.isMacintosh?"darwin":"linux"},get arch(){},nextTick(k){return(0,y.setImmediate)(k)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick,e.arch=L.arch}),define(J[8],Z([0,1,32]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,k=97,D=90,E=122,r=46,f=47,w=92,t=58,P=63;class b extends Error{constructor(o,c,i){let a;typeof c=="string"&&c.indexOf("not ")===0?(a="must not be",c=c.replace(/^not /,"")):a="must be";const n=o.indexOf(".")!==-1?"property":"argument";let s=`The "${o}" ${n} ${a} of type ${c}`;s+=`. Received type ${typeof i}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function p(h,o){if(typeof h!="string")throw new b(o,"string",h)}function d(h){return h===f||h===w}function g(h){return h===f}function I(h){return h>=L&&h<=D||h>=k&&h<=E}function v(h,o,c,i){let a="",n=0,s=-1,l=0,m=0;for(let S=0;S<=h.length;++S){if(S<h.length)m=h.charCodeAt(S);else{if(i(m))break;m=f}if(i(m)){if(!(s===S-1||l===1))if(l===2){if(a.length<2||n!==2||a.charCodeAt(a.length-1)!==r||a.charCodeAt(a.length-2)!==r){if(a.length>2){const M=a.lastIndexOf(c);M===-1?(a="",n=0):(a=a.slice(0,M),n=a.length-1-a.lastIndexOf(c)),s=S,l=0;continue}else if(a.length!==0){a="",n=0,s=S,l=0;continue}}o&&(a+=a.length>0?`${c}..`:"..",n=2)}else a.length>0?a+=`${c}${h.slice(s+1,S)}`:a=h.slice(s+1,S),n=S-s-1;s=S,l=0}else m===r&&l!==-1?++l:l=-1}return a}function u(h,o){if(o===null||typeof o!="object")throw new b("pathObject","Object",o);const c=o.dir||o.root,i=o.base||`${o.name||""}${o.ext||""}`;return c?c===o.root?`${c}${i}`:`${c}${h}${i}`:i}e.win32={resolve(...h){let o="",c="",i=!1;for(let a=h.length-1;a>=-1;a--){let n;if(a>=0){if(n=h[a],p(n,"path"),n.length===0)continue}else o.length===0?n=y.cwd():(n=y.env[`=${o}`]||y.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==o.toLowerCase()&&n.charCodeAt(2)===w)&&(n=`${o}\\`));const s=n.length;let l=0,m="",S=!1;const M=n.charCodeAt(0);if(s===1)d(M)&&(l=1,S=!0);else if(d(M))if(S=!0,d(n.charCodeAt(1))){let A=2,F=A;for(;A<s&&!d(n.charCodeAt(A));)A++;if(A<s&&A!==F){const C=n.slice(F,A);for(F=A;A<s&&d(n.charCodeAt(A));)A++;if(A<s&&A!==F){for(F=A;A<s&&!d(n.charCodeAt(A));)A++;(A===s||A!==F)&&(m=`\\\\${C}\\${n.slice(F,A)}`,l=A)}}}else l=1;else I(M)&&n.charCodeAt(1)===t&&(m=n.slice(0,2),l=2,s>2&&d(n.charCodeAt(2))&&(S=!0,l=3));if(m.length>0)if(o.length>0){if(m.toLowerCase()!==o.toLowerCase())continue}else o=m;if(i){if(o.length>0)break}else if(c=`${n.slice(l)}\\${c}`,i=S,S&&o.length>0)break}return c=v(c,!i,"\\",d),i?`${o}\\${c}`:`${o}${c}`||"."},normalize(h){p(h,"path");const o=h.length;if(o===0)return".";let c=0,i,a=!1;const n=h.charCodeAt(0);if(o===1)return g(n)?"\\":h;if(d(n))if(a=!0,d(h.charCodeAt(1))){let l=2,m=l;for(;l<o&&!d(h.charCodeAt(l));)l++;if(l<o&&l!==m){const S=h.slice(m,l);for(m=l;l<o&&d(h.charCodeAt(l));)l++;if(l<o&&l!==m){for(m=l;l<o&&!d(h.charCodeAt(l));)l++;if(l===o)return`\\\\${S}\\${h.slice(m)}\\`;l!==m&&(i=`\\\\${S}\\${h.slice(m,l)}`,c=l)}}}else c=1;else I(n)&&h.charCodeAt(1)===t&&(i=h.slice(0,2),c=2,o>2&&d(h.charCodeAt(2))&&(a=!0,c=3));let s=c<o?v(h.slice(c),!a,"\\",d):"";return s.length===0&&!a&&(s="."),s.length>0&&d(h.charCodeAt(o-1))&&(s+="\\"),i===void 0?a?`\\${s}`:s:a?`${i}\\${s}`:`${i}${s}`},isAbsolute(h){p(h,"path");const o=h.length;if(o===0)return!1;const c=h.charCodeAt(0);return d(c)||o>2&&I(c)&&h.charCodeAt(1)===t&&d(h.charCodeAt(2))},join(...h){if(h.length===0)return".";let o,c;for(let n=0;n<h.length;++n){const s=h[n];p(s,"path"),s.length>0&&(o===void 0?o=c=s:o+=`\\${s}`)}if(o===void 0)return".";let i=!0,a=0;if(typeof c=="string"&&d(c.charCodeAt(0))){++a;const n=c.length;n>1&&d(c.charCodeAt(1))&&(++a,n>2&&(d(c.charCodeAt(2))?++a:i=!1))}if(i){for(;a<o.length&&d(o.charCodeAt(a));)a++;a>=2&&(o=`\\${o.slice(a)}`)}return e.win32.normalize(o)},relative(h,o){if(p(h,"from"),p(o,"to"),h===o)return"";const c=e.win32.resolve(h),i=e.win32.resolve(o);if(c===i||(h=c.toLowerCase(),o=i.toLowerCase(),h===o))return"";let a=0;for(;a<h.length&&h.charCodeAt(a)===w;)a++;let n=h.length;for(;n-1>a&&h.charCodeAt(n-1)===w;)n--;const s=n-a;let l=0;for(;l<o.length&&o.charCodeAt(l)===w;)l++;let m=o.length;for(;m-1>l&&o.charCodeAt(m-1)===w;)m--;const S=m-l,M=s<S?s:S;let A=-1,F=0;for(;F<M;F++){const X=h.charCodeAt(a+F);if(X!==o.charCodeAt(l+F))break;X===w&&(A=F)}if(F!==M){if(A===-1)return i}else{if(S>M){if(o.charCodeAt(l+F)===w)return i.slice(l+F+1);if(F===2)return i.slice(l+F)}s>M&&(h.charCodeAt(a+F)===w?A=F:F===2&&(A=3)),A===-1&&(A=0)}let C="";for(F=a+A+1;F<=n;++F)(F===n||h.charCodeAt(F)===w)&&(C+=C.length===0?"..":"\\..");return l+=A,C.length>0?`${C}${i.slice(l,m)}`:(i.charCodeAt(l)===w&&++l,i.slice(l,m))},toNamespacedPath(h){if(typeof h!="string")return h;if(h.length===0)return"";const o=e.win32.resolve(h);if(o.length<=2)return h;if(o.charCodeAt(0)===w){if(o.charCodeAt(1)===w){const c=o.charCodeAt(2);if(c!==P&&c!==r)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(I(o.charCodeAt(0))&&o.charCodeAt(1)===t&&o.charCodeAt(2)===w)return`\\\\?\\${o}`;return h},dirname(h){p(h,"path");const o=h.length;if(o===0)return".";let c=-1,i=0;const a=h.charCodeAt(0);if(o===1)return d(a)?h:".";if(d(a)){if(c=i=1,d(h.charCodeAt(1))){let l=2,m=l;for(;l<o&&!d(h.charCodeAt(l));)l++;if(l<o&&l!==m){for(m=l;l<o&&d(h.charCodeAt(l));)l++;if(l<o&&l!==m){for(m=l;l<o&&!d(h.charCodeAt(l));)l++;if(l===o)return h;l!==m&&(c=i=l+1)}}}}else I(a)&&h.charCodeAt(1)===t&&(c=o>2&&d(h.charCodeAt(2))?3:2,i=c);let n=-1,s=!0;for(let l=o-1;l>=i;--l)if(d(h.charCodeAt(l))){if(!s){n=l;break}}else s=!1;if(n===-1){if(c===-1)return".";n=c}return h.slice(0,n)},basename(h,o){o!==void 0&&p(o,"ext"),p(h,"path");let c=0,i=-1,a=!0,n;if(h.length>=2&&I(h.charCodeAt(0))&&h.charCodeAt(1)===t&&(c=2),o!==void 0&&o.length>0&&o.length<=h.length){if(o===h)return"";let s=o.length-1,l=-1;for(n=h.length-1;n>=c;--n){const m=h.charCodeAt(n);if(d(m)){if(!a){c=n+1;break}}else l===-1&&(a=!1,l=n+1),s>=0&&(m===o.charCodeAt(s)?--s==-1&&(i=n):(s=-1,i=l))}return c===i?i=l:i===-1&&(i=h.length),h.slice(c,i)}for(n=h.length-1;n>=c;--n)if(d(h.charCodeAt(n))){if(!a){c=n+1;break}}else i===-1&&(a=!1,i=n+1);return i===-1?"":h.slice(c,i)},extname(h){p(h,"path");let o=0,c=-1,i=0,a=-1,n=!0,s=0;h.length>=2&&h.charCodeAt(1)===t&&I(h.charCodeAt(0))&&(o=i=2);for(let l=h.length-1;l>=o;--l){const m=h.charCodeAt(l);if(d(m)){if(!n){i=l+1;break}continue}a===-1&&(n=!1,a=l+1),m===r?c===-1?c=l:s!==1&&(s=1):c!==-1&&(s=-1)}return c===-1||a===-1||s===0||s===1&&c===a-1&&c===i+1?"":h.slice(c,a)},format:u.bind(null,"\\"),parse(h){p(h,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return o;const c=h.length;let i=0,a=h.charCodeAt(0);if(c===1)return d(a)?(o.root=o.dir=h,o):(o.base=o.name=h,o);if(d(a)){if(i=1,d(h.charCodeAt(1))){let A=2,F=A;for(;A<c&&!d(h.charCodeAt(A));)A++;if(A<c&&A!==F){for(F=A;A<c&&d(h.charCodeAt(A));)A++;if(A<c&&A!==F){for(F=A;A<c&&!d(h.charCodeAt(A));)A++;A===c?i=A:A!==F&&(i=A+1)}}}}else if(I(a)&&h.charCodeAt(1)===t){if(c<=2)return o.root=o.dir=h,o;if(i=2,d(h.charCodeAt(2))){if(c===3)return o.root=o.dir=h,o;i=3}}i>0&&(o.root=h.slice(0,i));let n=-1,s=i,l=-1,m=!0,S=h.length-1,M=0;for(;S>=i;--S){if(a=h.charCodeAt(S),d(a)){if(!m){s=S+1;break}continue}l===-1&&(m=!1,l=S+1),a===r?n===-1?n=S:M!==1&&(M=1):n!==-1&&(M=-1)}return l!==-1&&(n===-1||M===0||M===1&&n===l-1&&n===s+1?o.base=o.name=h.slice(s,l):(o.name=h.slice(s,n),o.base=h.slice(s,l),o.ext=h.slice(n,l))),s>0&&s!==i?o.dir=h.slice(0,s-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...h){let o="",c=!1;for(let i=h.length-1;i>=-1&&!c;i--){const a=i>=0?h[i]:y.cwd();p(a,"path"),a.length!==0&&(o=`${a}/${o}`,c=a.charCodeAt(0)===f)}return o=v(o,!c,"/",g),c?`/${o}`:o.length>0?o:"."},normalize(h){if(p(h,"path"),h.length===0)return".";const o=h.charCodeAt(0)===f,c=h.charCodeAt(h.length-1)===f;return h=v(h,!o,"/",g),h.length===0?o?"/":c?"./":".":(c&&(h+="/"),o?`/${h}`:h)},isAbsolute(h){return p(h,"path"),h.length>0&&h.charCodeAt(0)===f},join(...h){if(h.length===0)return".";let o;for(let c=0;c<h.length;++c){const i=h[c];p(i,"path"),i.length>0&&(o===void 0?o=i:o+=`/${i}`)}return o===void 0?".":e.posix.normalize(o)},relative(h,o){if(p(h,"from"),p(o,"to"),h===o||(h=e.posix.resolve(h),o=e.posix.resolve(o),h===o))return"";const c=1,i=h.length,a=i-c,n=1,s=o.length-n,l=a<s?a:s;let m=-1,S=0;for(;S<l;S++){const A=h.charCodeAt(c+S);if(A!==o.charCodeAt(n+S))break;A===f&&(m=S)}if(S===l)if(s>l){if(o.charCodeAt(n+S)===f)return o.slice(n+S+1);if(S===0)return o.slice(n+S)}else a>l&&(h.charCodeAt(c+S)===f?m=S:S===0&&(m=0));let M="";for(S=c+m+1;S<=i;++S)(S===i||h.charCodeAt(S)===f)&&(M+=M.length===0?"..":"/..");return`${M}${o.slice(n+m)}`},toNamespacedPath(h){return h},dirname(h){if(p(h,"path"),h.length===0)return".";const o=h.charCodeAt(0)===f;let c=-1,i=!0;for(let a=h.length-1;a>=1;--a)if(h.charCodeAt(a)===f){if(!i){c=a;break}}else i=!1;return c===-1?o?"/":".":o&&c===1?"//":h.slice(0,c)},basename(h,o){o!==void 0&&p(o,"ext"),p(h,"path");let c=0,i=-1,a=!0,n;if(o!==void 0&&o.length>0&&o.length<=h.length){if(o===h)return"";let s=o.length-1,l=-1;for(n=h.length-1;n>=0;--n){const m=h.charCodeAt(n);if(m===f){if(!a){c=n+1;break}}else l===-1&&(a=!1,l=n+1),s>=0&&(m===o.charCodeAt(s)?--s==-1&&(i=n):(s=-1,i=l))}return c===i?i=l:i===-1&&(i=h.length),h.slice(c,i)}for(n=h.length-1;n>=0;--n)if(h.charCodeAt(n)===f){if(!a){c=n+1;break}}else i===-1&&(a=!1,i=n+1);return i===-1?"":h.slice(c,i)},extname(h){p(h,"path");let o=-1,c=0,i=-1,a=!0,n=0;for(let s=h.length-1;s>=0;--s){const l=h.charCodeAt(s);if(l===f){if(!a){c=s+1;break}continue}i===-1&&(a=!1,i=s+1),l===r?o===-1?o=s:n!==1&&(n=1):o!==-1&&(n=-1)}return o===-1||i===-1||n===0||n===1&&o===i-1&&o===c+1?"":h.slice(o,i)},format:u.bind(null,"/"),parse(h){p(h,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return o;const c=h.charCodeAt(0)===f;let i;c?(o.root="/",i=1):i=0;let a=-1,n=0,s=-1,l=!0,m=h.length-1,S=0;for(;m>=i;--m){const M=h.charCodeAt(m);if(M===f){if(!l){n=m+1;break}continue}s===-1&&(l=!1,s=m+1),M===r?a===-1?a=m:S!==1&&(S=1):a!==-1&&(S=-1)}if(s!==-1){const M=n===0&&c?1:n;a===-1||S===0||S===1&&a===s-1&&a===n+1?o.base=o.name=h.slice(M,s):(o.name=h.slice(M,a),o.base=h.slice(M,s),o.ext=h.slice(a,s))}return n>0?o.dir=h.slice(0,n-1):c&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=y.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=y.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=y.platform==="win32"?e.win32.join:e.posix.join,e.resolve=y.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=y.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=y.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=y.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=y.platform==="win32"?e.win32.extname:e.posix.extname,e.format=y.platform==="win32"?e.win32.format:e.posix.format,e.parse=y.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=y.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=y.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=y.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(J[105],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var y;(function(D){D[D.stdout=0]="stdout",D[D.stderr=1]="stderr"})(y=e.Source||(e.Source={}));var L;(function(D){D[D.Success=0]="Success",D[D.Unknown=1]="Unknown",D[D.AccessDenied=2]="AccessDenied",D[D.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(D,...E){const r=E.reduce((t,P)=>(t[P]=!0,t),{}),f=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(D).filter(t=>!r[t]).forEach(t=>{for(let P=0;P<f.length;P++)if(t.search(f[P])!==-1){delete D[t];break}})}e.sanitizeProcessEnvironment=k}),define(J[78],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ScanCodeBinding=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.ScanCode=void 0;var y;(function(r){r[r.DependsOnKbLayout=-1]="DependsOnKbLayout",r[r.None=0]="None",r[r.Hyper=1]="Hyper",r[r.Super=2]="Super",r[r.Fn=3]="Fn",r[r.FnLock=4]="FnLock",r[r.Suspend=5]="Suspend",r[r.Resume=6]="Resume",r[r.Turbo=7]="Turbo",r[r.Sleep=8]="Sleep",r[r.WakeUp=9]="WakeUp",r[r.KeyA=10]="KeyA",r[r.KeyB=11]="KeyB",r[r.KeyC=12]="KeyC",r[r.KeyD=13]="KeyD",r[r.KeyE=14]="KeyE",r[r.KeyF=15]="KeyF",r[r.KeyG=16]="KeyG",r[r.KeyH=17]="KeyH",r[r.KeyI=18]="KeyI",r[r.KeyJ=19]="KeyJ",r[r.KeyK=20]="KeyK",r[r.KeyL=21]="KeyL",r[r.KeyM=22]="KeyM",r[r.KeyN=23]="KeyN",r[r.KeyO=24]="KeyO",r[r.KeyP=25]="KeyP",r[r.KeyQ=26]="KeyQ",r[r.KeyR=27]="KeyR",r[r.KeyS=28]="KeyS",r[r.KeyT=29]="KeyT",r[r.KeyU=30]="KeyU",r[r.KeyV=31]="KeyV",r[r.KeyW=32]="KeyW",r[r.KeyX=33]="KeyX",r[r.KeyY=34]="KeyY",r[r.KeyZ=35]="KeyZ",r[r.Digit1=36]="Digit1",r[r.Digit2=37]="Digit2",r[r.Digit3=38]="Digit3",r[r.Digit4=39]="Digit4",r[r.Digit5=40]="Digit5",r[r.Digit6=41]="Digit6",r[r.Digit7=42]="Digit7",r[r.Digit8=43]="Digit8",r[r.Digit9=44]="Digit9",r[r.Digit0=45]="Digit0",r[r.Enter=46]="Enter",r[r.Escape=47]="Escape",r[r.Backspace=48]="Backspace",r[r.Tab=49]="Tab",r[r.Space=50]="Space",r[r.Minus=51]="Minus",r[r.Equal=52]="Equal",r[r.BracketLeft=53]="BracketLeft",r[r.BracketRight=54]="BracketRight",r[r.Backslash=55]="Backslash",r[r.IntlHash=56]="IntlHash",r[r.Semicolon=57]="Semicolon",r[r.Quote=58]="Quote",r[r.Backquote=59]="Backquote",r[r.Comma=60]="Comma",r[r.Period=61]="Period",r[r.Slash=62]="Slash",r[r.CapsLock=63]="CapsLock",r[r.F1=64]="F1",r[r.F2=65]="F2",r[r.F3=66]="F3",r[r.F4=67]="F4",r[r.F5=68]="F5",r[r.F6=69]="F6",r[r.F7=70]="F7",r[r.F8=71]="F8",r[r.F9=72]="F9",r[r.F10=73]="F10",r[r.F11=74]="F11",r[r.F12=75]="F12",r[r.PrintScreen=76]="PrintScreen",r[r.ScrollLock=77]="ScrollLock",r[r.Pause=78]="Pause",r[r.Insert=79]="Insert",r[r.Home=80]="Home",r[r.PageUp=81]="PageUp",r[r.Delete=82]="Delete",r[r.End=83]="End",r[r.PageDown=84]="PageDown",r[r.ArrowRight=85]="ArrowRight",r[r.ArrowLeft=86]="ArrowLeft",r[r.ArrowDown=87]="ArrowDown",r[r.ArrowUp=88]="ArrowUp",r[r.NumLock=89]="NumLock",r[r.NumpadDivide=90]="NumpadDivide",r[r.NumpadMultiply=91]="NumpadMultiply",r[r.NumpadSubtract=92]="NumpadSubtract",r[r.NumpadAdd=93]="NumpadAdd",r[r.NumpadEnter=94]="NumpadEnter",r[r.Numpad1=95]="Numpad1",r[r.Numpad2=96]="Numpad2",r[r.Numpad3=97]="Numpad3",r[r.Numpad4=98]="Numpad4",r[r.Numpad5=99]="Numpad5",r[r.Numpad6=100]="Numpad6",r[r.Numpad7=101]="Numpad7",r[r.Numpad8=102]="Numpad8",r[r.Numpad9=103]="Numpad9",r[r.Numpad0=104]="Numpad0",r[r.NumpadDecimal=105]="NumpadDecimal",r[r.IntlBackslash=106]="IntlBackslash",r[r.ContextMenu=107]="ContextMenu",r[r.Power=108]="Power",r[r.NumpadEqual=109]="NumpadEqual",r[r.F13=110]="F13",r[r.F14=111]="F14",r[r.F15=112]="F15",r[r.F16=113]="F16",r[r.F17=114]="F17",r[r.F18=115]="F18",r[r.F19=116]="F19",r[r.F20=117]="F20",r[r.F21=118]="F21",r[r.F22=119]="F22",r[r.F23=120]="F23",r[r.F24=121]="F24",r[r.Open=122]="Open",r[r.Help=123]="Help",r[r.Select=124]="Select",r[r.Again=125]="Again",r[r.Undo=126]="Undo",r[r.Cut=127]="Cut",r[r.Copy=128]="Copy",r[r.Paste=129]="Paste",r[r.Find=130]="Find",r[r.AudioVolumeMute=131]="AudioVolumeMute",r[r.AudioVolumeUp=132]="AudioVolumeUp",r[r.AudioVolumeDown=133]="AudioVolumeDown",r[r.NumpadComma=134]="NumpadComma",r[r.IntlRo=135]="IntlRo",r[r.KanaMode=136]="KanaMode",r[r.IntlYen=137]="IntlYen",r[r.Convert=138]="Convert",r[r.NonConvert=139]="NonConvert",r[r.Lang1=140]="Lang1",r[r.Lang2=141]="Lang2",r[r.Lang3=142]="Lang3",r[r.Lang4=143]="Lang4",r[r.Lang5=144]="Lang5",r[r.Abort=145]="Abort",r[r.Props=146]="Props",r[r.NumpadParenLeft=147]="NumpadParenLeft",r[r.NumpadParenRight=148]="NumpadParenRight",r[r.NumpadBackspace=149]="NumpadBackspace",r[r.NumpadMemoryStore=150]="NumpadMemoryStore",r[r.NumpadMemoryRecall=151]="NumpadMemoryRecall",r[r.NumpadMemoryClear=152]="NumpadMemoryClear",r[r.NumpadMemoryAdd=153]="NumpadMemoryAdd",r[r.NumpadMemorySubtract=154]="NumpadMemorySubtract",r[r.NumpadClear=155]="NumpadClear",r[r.NumpadClearEntry=156]="NumpadClearEntry",r[r.ControlLeft=157]="ControlLeft",r[r.ShiftLeft=158]="ShiftLeft",r[r.AltLeft=159]="AltLeft",r[r.MetaLeft=160]="MetaLeft",r[r.ControlRight=161]="ControlRight",r[r.ShiftRight=162]="ShiftRight",r[r.AltRight=163]="AltRight",r[r.MetaRight=164]="MetaRight",r[r.BrightnessUp=165]="BrightnessUp",r[r.BrightnessDown=166]="BrightnessDown",r[r.MediaPlay=167]="MediaPlay",r[r.MediaRecord=168]="MediaRecord",r[r.MediaFastForward=169]="MediaFastForward",r[r.MediaRewind=170]="MediaRewind",r[r.MediaTrackNext=171]="MediaTrackNext",r[r.MediaTrackPrevious=172]="MediaTrackPrevious",r[r.MediaStop=173]="MediaStop",r[r.Eject=174]="Eject",r[r.MediaPlayPause=175]="MediaPlayPause",r[r.MediaSelect=176]="MediaSelect",r[r.LaunchMail=177]="LaunchMail",r[r.LaunchApp2=178]="LaunchApp2",r[r.LaunchApp1=179]="LaunchApp1",r[r.SelectTask=180]="SelectTask",r[r.LaunchScreenSaver=181]="LaunchScreenSaver",r[r.BrowserSearch=182]="BrowserSearch",r[r.BrowserHome=183]="BrowserHome",r[r.BrowserBack=184]="BrowserBack",r[r.BrowserForward=185]="BrowserForward",r[r.BrowserStop=186]="BrowserStop",r[r.BrowserRefresh=187]="BrowserRefresh",r[r.BrowserFavorites=188]="BrowserFavorites",r[r.ZoomToggle=189]="ZoomToggle",r[r.MailReply=190]="MailReply",r[r.MailForward=191]="MailForward",r[r.MailSend=192]="MailSend",r[r.MAX_VALUE=193]="MAX_VALUE"})(y=e.ScanCode||(e.ScanCode={}));const L=[],k=Object.create(null),D=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:r=>D[r]||0,toEnum:r=>k[r]||0,toString:r=>L[r]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];class E{constructor(f,w,t,P,b){this.ctrlKey=f,this.shiftKey=w,this.altKey=t,this.metaKey=P,this.scanCode=b}equals(f){return this.ctrlKey===f.ctrlKey&&this.shiftKey===f.shiftKey&&this.altKey===f.altKey&&this.metaKey===f.metaKey&&this.scanCode===f.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=E,function(){function r(f,w){L[f]=w,k[w]=f,D[w.toLowerCase()]=f}r(0,"None"),r(1,"Hyper"),r(2,"Super"),r(3,"Fn"),r(4,"FnLock"),r(5,"Suspend"),r(6,"Resume"),r(7,"Turbo"),r(8,"Sleep"),r(9,"WakeUp"),r(10,"KeyA"),r(11,"KeyB"),r(12,"KeyC"),r(13,"KeyD"),r(14,"KeyE"),r(15,"KeyF"),r(16,"KeyG"),r(17,"KeyH"),r(18,"KeyI"),r(19,"KeyJ"),r(20,"KeyK"),r(21,"KeyL"),r(22,"KeyM"),r(23,"KeyN"),r(24,"KeyO"),r(25,"KeyP"),r(26,"KeyQ"),r(27,"KeyR"),r(28,"KeyS"),r(29,"KeyT"),r(30,"KeyU"),r(31,"KeyV"),r(32,"KeyW"),r(33,"KeyX"),r(34,"KeyY"),r(35,"KeyZ"),r(36,"Digit1"),r(37,"Digit2"),r(38,"Digit3"),r(39,"Digit4"),r(40,"Digit5"),r(41,"Digit6"),r(42,"Digit7"),r(43,"Digit8"),r(44,"Digit9"),r(45,"Digit0"),r(46,"Enter"),r(47,"Escape"),r(48,"Backspace"),r(49,"Tab"),r(50,"Space"),r(51,"Minus"),r(52,"Equal"),r(53,"BracketLeft"),r(54,"BracketRight"),r(55,"Backslash"),r(56,"IntlHash"),r(57,"Semicolon"),r(58,"Quote"),r(59,"Backquote"),r(60,"Comma"),r(61,"Period"),r(62,"Slash"),r(63,"CapsLock"),r(64,"F1"),r(65,"F2"),r(66,"F3"),r(67,"F4"),r(68,"F5"),r(69,"F6"),r(70,"F7"),r(71,"F8"),r(72,"F9"),r(73,"F10"),r(74,"F11"),r(75,"F12"),r(76,"PrintScreen"),r(77,"ScrollLock"),r(78,"Pause"),r(79,"Insert"),r(80,"Home"),r(81,"PageUp"),r(82,"Delete"),r(83,"End"),r(84,"PageDown"),r(85,"ArrowRight"),r(86,"ArrowLeft"),r(87,"ArrowDown"),r(88,"ArrowUp"),r(89,"NumLock"),r(90,"NumpadDivide"),r(91,"NumpadMultiply"),r(92,"NumpadSubtract"),r(93,"NumpadAdd"),r(94,"NumpadEnter"),r(95,"Numpad1"),r(96,"Numpad2"),r(97,"Numpad3"),r(98,"Numpad4"),r(99,"Numpad5"),r(100,"Numpad6"),r(101,"Numpad7"),r(102,"Numpad8"),r(103,"Numpad9"),r(104,"Numpad0"),r(105,"NumpadDecimal"),r(106,"IntlBackslash"),r(107,"ContextMenu"),r(108,"Power"),r(109,"NumpadEqual"),r(110,"F13"),r(111,"F14"),r(112,"F15"),r(113,"F16"),r(114,"F17"),r(115,"F18"),r(116,"F19"),r(117,"F20"),r(118,"F21"),r(119,"F22"),r(120,"F23"),r(121,"F24"),r(122,"Open"),r(123,"Help"),r(124,"Select"),r(125,"Again"),r(126,"Undo"),r(127,"Cut"),r(128,"Copy"),r(129,"Paste"),r(130,"Find"),r(131,"AudioVolumeMute"),r(132,"AudioVolumeUp"),r(133,"AudioVolumeDown"),r(134,"NumpadComma"),r(135,"IntlRo"),r(136,"KanaMode"),r(137,"IntlYen"),r(138,"Convert"),r(139,"NonConvert"),r(140,"Lang1"),r(141,"Lang2"),r(142,"Lang3"),r(143,"Lang4"),r(144,"Lang5"),r(145,"Abort"),r(146,"Props"),r(147,"NumpadParenLeft"),r(148,"NumpadParenRight"),r(149,"NumpadBackspace"),r(150,"NumpadMemoryStore"),r(151,"NumpadMemoryRecall"),r(152,"NumpadMemoryClear"),r(153,"NumpadMemoryAdd"),r(154,"NumpadMemorySubtract"),r(155,"NumpadClear"),r(156,"NumpadClearEntry"),r(157,"ControlLeft"),r(158,"ShiftLeft"),r(159,"AltLeft"),r(160,"MetaLeft"),r(161,"ControlRight"),r(162,"ShiftRight"),r(163,"AltRight"),r(164,"MetaRight"),r(165,"BrightnessUp"),r(166,"BrightnessDown"),r(167,"MediaPlay"),r(168,"MediaRecord"),r(169,"MediaFastForward"),r(170,"MediaRewind"),r(171,"MediaTrackNext"),r(172,"MediaTrackPrevious"),r(173,"MediaStop"),r(174,"Eject"),r(175,"MediaPlayPause"),r(176,"MediaSelect"),r(177,"LaunchMail"),r(178,"LaunchApp2"),r(179,"LaunchApp1"),r(180,"SelectTask"),r(181,"LaunchScreenSaver"),r(182,"BrowserSearch"),r(183,"BrowserHome"),r(184,"BrowserBack"),r(185,"BrowserForward"),r(186,"BrowserStop"),r(187,"BrowserRefresh"),r(188,"BrowserFavorites"),r(189,"ZoomToggle"),r(190,"MailReply"),r(191,"MailForward"),r(192,"MailSend")}(),function(){for(let f=0;f<=193;f++)e.IMMUTABLE_CODE_TO_KEY_CODE[f]=-1;for(let f=0;f<=112;f++)e.IMMUTABLE_KEY_CODE_TO_CODE[f]=-1;function r(f,w){e.IMMUTABLE_CODE_TO_KEY_CODE[f]=w,w!==0&&w!==3&&w!==5&&w!==4&&w!==6&&w!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[w]=f)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46,r(0,0),r(1,0),r(2,0),r(3,0),r(4,0),r(5,0),r(6,0),r(7,0),r(8,0),r(9,0),r(46,3),r(47,9),r(48,1),r(49,2),r(50,10),r(63,8),r(64,59),r(65,60),r(66,61),r(67,62),r(68,63),r(69,64),r(70,65),r(71,66),r(72,67),r(73,68),r(74,69),r(75,70),r(76,0),r(77,79),r(78,7),r(79,19),r(80,14),r(81,11),r(82,20),r(83,13),r(84,12),r(85,17),r(86,15),r(87,18),r(88,16),r(89,78),r(90,108),r(91,103),r(92,106),r(93,104),r(94,3),r(95,94),r(96,95),r(97,96),r(98,97),r(99,98),r(100,99),r(101,100),r(102,101),r(103,102),r(104,93),r(105,107),r(107,58),r(108,0),r(109,0),r(110,71),r(111,72),r(112,73),r(113,74),r(114,75),r(115,76),r(116,77),r(117,0),r(118,0),r(119,0),r(120,0),r(121,0),r(122,0),r(123,0),r(124,0),r(125,0),r(126,0),r(127,0),r(128,0),r(129,0),r(130,0),r(131,0),r(132,0),r(133,0),r(134,105),r(136,0),r(138,0),r(139,0),r(140,0),r(141,0),r(142,0),r(143,0),r(144,0),r(145,0),r(146,0),r(147,0),r(148,0),r(149,0),r(150,0),r(151,0),r(152,0),r(153,0),r(154,0),r(155,0),r(156,0),r(157,5),r(158,4),r(159,6),r(160,57),r(161,5),r(162,4),r(163,6),r(164,57),r(165,0),r(166,0),r(167,0),r(168,0),r(169,0),r(170,0),r(171,0),r(172,0),r(173,0),r(174,0),r(175,0),r(176,0),r(177,0),r(178,0),r(179,0),r(180,0),r(181,0),r(182,0),r(183,0),r(184,0),r(185,0),r(186,0),r(187,0),r(188,0),r(189,0),r(190,0),r(191,0),r(192,0)}()}),define(J[106],Z([0,1,57,78]),function(K,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class k{static _readModifiers(E){E=E.toLowerCase().trim();let r=!1,f=!1,w=!1,t=!1,P;do P=!1,/^ctrl(\+|\-)/.test(E)&&(r=!0,E=E.substr("ctrl-".length),P=!0),/^shift(\+|\-)/.test(E)&&(f=!0,E=E.substr("shift-".length),P=!0),/^alt(\+|\-)/.test(E)&&(w=!0,E=E.substr("alt-".length),P=!0),/^meta(\+|\-)/.test(E)&&(t=!0,E=E.substr("meta-".length),P=!0),/^win(\+|\-)/.test(E)&&(t=!0,E=E.substr("win-".length),P=!0),/^cmd(\+|\-)/.test(E)&&(t=!0,E=E.substr("cmd-".length),P=!0);while(P);let b;const p=E.indexOf(" ");return p>0?(b=E.substring(0,p),E=E.substring(p)):(b=E,E=""),{remains:E,ctrl:r,shift:f,alt:w,meta:t,key:b}}static parseSimpleKeybinding(E){const r=this._readModifiers(E),f=y.KeyCodeUtils.fromUserSettings(r.key);return[new y.SimpleKeybinding(r.ctrl,r.shift,r.alt,r.meta,f),r.remains]}static parseKeybinding(E,r){if(!E)return null;const f=[];let w;do[w,E]=this.parseSimpleKeybinding(E),f.push(w);while(E.length>0);return new y.ChordKeybinding(f)}static parseSimpleUserBinding(E){const r=this._readModifiers(E),f=r.key.match(/^\[([^\]]+)\]$/);if(f){const t=f[1],P=L.ScanCodeUtils.lowerCaseToEnum(t);return[new L.ScanCodeBinding(r.ctrl,r.shift,r.alt,r.meta,P),r.remains]}const w=y.KeyCodeUtils.fromUserSettings(r.key);return[new y.SimpleKeybinding(r.ctrl,r.shift,r.alt,r.meta,w),r.remains]}static parseUserBinding(E){if(!E)return[];const r=[];let f;for(;E.length>0;)[f,E]=this.parseSimpleUserBinding(E),r.push(f);return r}}e.KeybindingParser=k}),define(J[107],Z([0,1,3]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=y.globals.performance&&typeof y.globals.performance.now=="function";class k{constructor(E){this._highResolution=L&&E,this._startTime=this._now(),this._stopTime=-1}static create(E=!0){return new k(E)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?y.globals.performance.now():Date.now()}}e.StopWatch=k}),define(J[5],Z([0,1,17,43,2,104,107]),function(K,e,y,L,k,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var r;(function(h){h.None=()=>k.Disposable.None;function o(Q){return(W,V=null,z)=>{let $=!1,j;return j=Q(U=>{if(!$)return j?j.dispose():$=!0,W.call(V,U)},null,z),$&&j.dispose(),j}}h.once=o;function c(Q,W){return m((V,z=null,$)=>Q(j=>V.call(z,W(j)),null,$))}h.map=c;function i(Q,W){return m((V,z=null,$)=>Q(j=>{W(j),V.call(z,j)},null,$))}h.forEach=i;function a(Q,W){return m((V,z=null,$)=>Q(j=>W(j)&&V.call(z,j),null,$))}h.filter=a;function n(Q){return Q}h.signal=n;function s(...Q){return(W,V=null,z)=>(0,k.combinedDisposable)(...Q.map($=>$(j=>W.call(V,j),null,z)))}h.any=s;function l(Q,W,V){let z=V;return c(Q,$=>(z=W(z,$),z))}h.reduce=l;function m(Q){let W;const V=new b({onFirstListenerAdd(){W=Q(V.fire,V)},onLastListenerRemove(){W.dispose()}});return V.event}function S(Q,W,V=100,z=!1,$){let j,U,q,T=0;const R=new b({leakWarningThreshold:$,onFirstListenerAdd(){j=Q(O=>{T++,U=W(U,O),z&&!q&&(R.fire(U),U=void 0),clearTimeout(q),q=setTimeout(()=>{const _=U;U=void 0,q=void 0,(!z||T>1)&&R.fire(_),T=0},V)})},onLastListenerRemove(){j.dispose()}});return R.event}h.debounce=S;function M(Q,W=(V,z)=>V===z){let V=!0,z;return a(Q,$=>{const j=V||!W($,z);return V=!1,z=$,j})}h.latch=M;function A(Q,W){return[h.filter(Q,W),h.filter(Q,V=>!W(V))]}h.split=A;function F(Q,W=!1,V=[]){let z=V.slice(),$=Q(q=>{z?z.push(q):U.fire(q)});const j=()=>{z&&z.forEach(q=>U.fire(q)),z=null},U=new b({onFirstListenerAdd(){$||($=Q(q=>U.fire(q)))},onFirstListenerDidAdd(){z&&(W?setTimeout(j):j())},onLastListenerRemove(){$&&$.dispose(),$=null}});return U.event}h.buffer=F;class C{constructor(W){this.event=W}map(W){return new C(c(this.event,W))}forEach(W){return new C(i(this.event,W))}filter(W){return new C(a(this.event,W))}reduce(W,V){return new C(l(this.event,W,V))}latch(){return new C(M(this.event))}debounce(W,V=100,z=!1,$){return new C(S(this.event,W,V,z,$))}on(W,V,z){return this.event(W,V,z)}once(W,V,z){return o(this.event)(W,V,z)}}function X(Q){return new C(Q)}h.chain=X;function ee(Q,W,V=z=>z){const z=(...q)=>U.fire(V(...q)),$=()=>Q.on(W,z),j=()=>Q.removeListener(W,z),U=new b({onFirstListenerAdd:$,onLastListenerRemove:j});return U.event}h.fromNodeEventEmitter=ee;function re(Q,W,V=z=>z){const z=(...q)=>U.fire(V(...q)),$=()=>Q.addEventListener(W,z),j=()=>Q.removeEventListener(W,z),U=new b({onFirstListenerAdd:$,onLastListenerRemove:j});return U.event}h.fromDOMEventEmitter=re;function Y(Q){return new Promise(W=>o(Q)(W))}h.toPromise=Y})(r=e.Event||(e.Event={}));class f{constructor(o){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${o}_${f._idPool++}`}start(o){this._stopWatch=new E.StopWatch(!0),this._listenerCount=o}stop(){if(this._stopWatch){const o=this._stopWatch.elapsed();this._elapsedOverall+=o,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${o.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}f._idPool=0;let w=-1;function t(h){const o=w;return w=h,{dispose(){w=o}}}e.setGlobalLeakWarningThreshold=t;class P{constructor(o,c=Math.random().toString(18).slice(2,5)){this.customThreshold=o,this.name=c,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(o){let c=w;if(typeof this.customThreshold=="number"&&(c=this.customThreshold),c<=0||o<c)return;this._stacks||(this._stacks=new Map);const i=new Error().stack.split(`
`).slice(3).join(`
`),a=this._stacks.get(i)||0;if(this._stacks.set(i,a+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=c*.5;let n,s=0;for(const[l,m]of this._stacks)(!n||s<m)&&(n=l,s=m);console.warn(`[${this.name}] potential listener LEAK detected, having ${o} listeners already. MOST frequent listener (${s}):`),console.warn(n)}return()=>{const n=this._stacks.get(i)||0;this._stacks.set(i,n-1)}}}class b{constructor(o){this._disposed=!1,this._options=o,this._leakageMon=w>0?new P(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new f(this._options._profName):void 0}get event(){return this._event||(this._event=(o,c,i)=>{this._listeners||(this._listeners=new D.LinkedList);const a=this._listeners.isEmpty();a&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(c?[o,c]:o);a&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,o,c);const s=this._leakageMon?.check(this._listeners.size),l=(0,k.toDisposable)(()=>{s&&s(),this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return i instanceof k.DisposableStore?i.add(l):Array.isArray(i)&&i.push(l),l}),this._event}fire(o){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new D.LinkedList);for(let c of this._listeners)this._deliveryQueue.push([c,o]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[c,i]=this._deliveryQueue.shift();try{typeof c=="function"?c.call(void 0,i):c[0].call(c[1],i)}catch(a){(0,y.onUnexpectedError)(a)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=b;class p extends b{async fireAsync(o,c,i){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new D.LinkedList);for(const a of this._listeners)this._asyncDeliveryQueue.push([a,o]);for(;this._asyncDeliveryQueue.size>0&&!c.isCancellationRequested;){const[a,n]=this._asyncDeliveryQueue.shift(),s=[],l={...n,waitUntil:m=>{if(Object.isFrozen(s))throw new Error("waitUntil can NOT be called asynchronous");i&&(m=i(m,typeof a=="function"?a:a[0])),s.push(m)}};try{typeof a=="function"?a.call(void 0,l):a[0].call(a[1],l)}catch(m){(0,y.onUnexpectedError)(m);continue}Object.freeze(s),await Promise.allSettled(s).then(m=>{for(const S of m)S.status==="rejected"&&(0,y.onUnexpectedError)(S.reason)})}}}}e.AsyncEmitter=p;class d extends b{constructor(o){super(o);this._isPaused=0,this._eventQueue=new D.LinkedList,this._mergeFn=o?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const o=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(o))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(o){this._listeners&&(this._isPaused!==0?this._eventQueue.push(o):super.fire(o))}}e.PauseableEmitter=d;class g extends d{constructor(o){super(o);this._delay=o.delay??100}fire(o){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(o)}}e.DebounceEmitter=g;class I{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new b({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(o){const c={event:o,listener:null};this.events.push(c),this.hasListeners&&this.hook(c);const i=()=>{this.hasListeners&&this.unhook(c);const a=this.events.indexOf(c);this.events.splice(a,1)};return(0,k.toDisposable)((0,L.once)(i))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(o=>this.hook(o))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(o=>this.unhook(o))}hook(o){o.listener=o.event(c=>this.emitter.fire(c))}unhook(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=I;class v{constructor(){this.buffers=[]}wrapEvent(o){return(c,i,a)=>o(n=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>c.call(i,n)):c.call(i,n)},void 0,a)}bufferEvents(o){const c=[];this.buffers.push(c);const i=o();return this.buffers.pop(),c.forEach(a=>a()),i}}e.EventBufferer=v;class u{constructor(){this.listening=!1,this.inputEvent=r.None,this.inputEventListener=k.Disposable.None,this.emitter=new b({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(o){this.inputEvent=o,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=o(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=u}),define(J[24],Z([0,1,5]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(r,f){const w=setTimeout(r.bind(f),0);return{dispose(){clearTimeout(w)}}});var k;(function(r){function f(w){return w===r.None||w===r.Cancelled||w instanceof D?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}r.isCancellationToken=f,r.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:y.Event.None}),r.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(k=e.CancellationToken||(e.CancellationToken={}));class D{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new y.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class E{constructor(f){this._token=void 0,this._parentListener=void 0,this._parentListener=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new D),this._token}cancel(){this._token?this._token instanceof D&&this._token.cancel():this._token=k.Cancelled}dispose(f=!1){f&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof D&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=E}),define(J[108],Z([0,1,5]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new y.Emitter}add(P){const b=this._icons.get(P.id);b?P.description?b.description=P.description:console.error(`Duplicate registration of codicon ${P.id}`):(this._icons.set(P.id,P),this._onDidRegister.fire(P))}get(P){return this._icons.get(P)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const k=new L;e.iconRegistry=k;function D(t,P){return new r(t,P)}e.registerCodicon=D;function E(t){return t?t.replace(/\$\((.*?)\)/g,(P,b)=>` ${b} `).trim():""}e.getCodiconAriaLabel=E;class r{constructor(P,b,p){this.id=P,this.definition=b,this.description=p,k.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=r;function f(t,P){const b=["codicon","codicon-"+t];return P&&b.push("codicon-modifier-"+P),b}e.getClassNamesArray=f;var w;(function(t){t.iconNameSegment="[A-Za-z0-9]+",t.iconNameExpression="[A-Za-z0-9\\-]+",t.iconModifierExpression="~[A-Za-z]+";const P=new RegExp(`^(${t.iconNameExpression})(${t.iconModifierExpression})?$`);function b(g){if(g instanceof r)return["codicon","codicon-"+g.id];const I=P.exec(g.id);if(!I)return b(r.error);let[,v,u]=I;const h=["codicon","codicon-"+v];return u&&h.push("codicon-modifier-"+u.substr(1)),h}t.asClassNameArray=b;function p(g){return b(g).join(" ")}t.asClassName=p;function d(g){return"."+b(g).join(".")}t.asCSSSelector=d})(w=e.CSSIcon||(e.CSSIcon={})),function(t){t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",{fontCharacter:"\\ea60"}),t.gistNew=new t("gist-new",{fontCharacter:"\\ea60"}),t.repoCreate=new t("repo-create",{fontCharacter:"\\ea60"}),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition)}(r=e.Codicon||(e.Codicon={}))}),define(J[64],Z([0,1,17,2]),function(K,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function k(h){const o=h;return o?[o.on,o.pause,o.resume,o.destroy].every(c=>typeof c=="function"):!1}e.isReadableStream=k;function D(h){const o=h;return o?k(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=D;function E(h,o){return new r(h,o)}e.newWriteableStream=E;class r{constructor(o,c){this.reducer=o,this.options=c,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(c=>this.pendingWritePromises.push(c))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(c=>c(o))}emitError(o){this.listeners.error.length===0?(0,y.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(c=>c(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,c){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(c),this.resume();break;case"end":this.listeners.end.push(c),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(c),this.state.flowing&&this.flowErrors();break}}removeListener(o,c){if(this.state.destroyed)return;let i;switch(o){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const a=i.indexOf(c);a>=0&&i.splice(a,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const c=[...this.pendingWritePromises];this.pendingWritePromises.length=0,c.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function f(h,o){const c=[];let i;for(;(i=h.read())!==null;)c.push(i);return o(c)}e.consumeReadable=f;function w(h,o,c){const i=[];let a;for(;(a=h.read())!==null&&i.length<c;)i.push(a);return a===null&&i.length>0?o(i):{read:()=>{if(i.length>0)return i.shift();if(typeof a!="undefined"){const n=a;return a=void 0,n}return h.read()}}}e.peekReadable=w;function t(h,o){return new Promise((c,i)=>{const a=[];P(h,{onData:n=>{o&&a.push(n)},onError:n=>{o?i(n):c(void 0)},onEnd:()=>{c(o?o(a):void 0)}})})}e.consumeStream=t;function P(h,o){h.on("error",c=>o.onError(c)),h.on("end",()=>o.onEnd()),h.on("data",c=>o.onData(c))}e.listenStream=P;function b(h,o){return new Promise((c,i)=>{const a=new L.DisposableStore,n=[],s=S=>{if(n.push(S),n.length>o)return a.dispose(),h.pause(),c({stream:h,buffer:n,ended:!1})},l=S=>i(S),m=()=>c({stream:h,buffer:n,ended:!0});a.add((0,L.toDisposable)(()=>h.removeListener("error",l))),h.on("error",l),a.add((0,L.toDisposable)(()=>h.removeListener("end",m))),h.on("end",m),a.add((0,L.toDisposable)(()=>h.removeListener("data",s))),h.on("data",s)})}e.peekStream=b;function p(h,o){const c=E(o);return c.end(h),c}e.toStream=p;function d(){const h=E(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=d;function g(h){let o=!1;return{read:()=>o?null:(o=!0,h)}}e.toReadable=g;function I(h,o,c){const i=E(c);return P(h,{onData:a=>i.write(o.data(a)),onError:a=>i.error(o.error?o.error(a):a),onEnd:()=>i.end()}),i}e.transform=I;function v(h,o,c){let i=!1;return{read:()=>{const a=o.read();return i?a:(i=!0,a!==null?c([h,a]):h)}}}e.prefixedReadable=v;function u(h,o,c){let i=!1;const a=E(c);return P(o,{onData:n=>i?a.write(n):(i=!0,a.write(c([h,n]))),onError:n=>a.error(n),onEnd:()=>{i||(i=!0,a.write(h)),a.end()}}),a}e.prefixedStream=u}),define(J[18],Z([0,1,64]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let k,D;class E{constructor(s){this.buffer=s,this.byteLength=this.buffer.byteLength}static alloc(s){return L?new E(Buffer.allocUnsafe(s)):new E(new Uint8Array(s))}static wrap(s){return L&&!Buffer.isBuffer(s)&&(s=Buffer.from(s.buffer,s.byteOffset,s.byteLength)),new E(s)}static fromString(s,l){return!(l?.dontUseNodeBuffer||!1)&&L?new E(Buffer.from(s)):(k||(k=new TextEncoder),new E(k.encode(s)))}static concat(s,l){if(typeof l=="undefined"){l=0;for(let M=0,A=s.length;M<A;M++)l+=s[M].byteLength}const m=E.alloc(l);let S=0;for(let M=0,A=s.length;M<A;M++){const F=s[M];m.set(F,S),S+=F.byteLength}return m}toString(){return L?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(s,l){return new E(this.buffer.subarray(s,l))}set(s,l){s instanceof E?this.buffer.set(s.buffer,l):this.buffer.set(s,l)}readUInt32BE(s){return w(this.buffer,s)}writeUInt32BE(s,l){t(this.buffer,s,l)}readUInt32LE(s){return P(this.buffer,s)}writeUInt32LE(s,l){b(this.buffer,s,l)}readUInt8(s){return p(this.buffer,s)}writeUInt8(s,l){d(this.buffer,s,l)}}e.VSBuffer=E;function r(n,s){return n[s+0]<<0>>>0|n[s+1]<<8>>>0}e.readUInt16LE=r;function f(n,s,l){n[l+0]=s&255,s=s>>>8,n[l+1]=s&255}e.writeUInt16LE=f;function w(n,s){return n[s]*2**24+n[s+1]*2**16+n[s+2]*2**8+n[s+3]}e.readUInt32BE=w;function t(n,s,l){n[l+3]=s,s=s>>>8,n[l+2]=s,s=s>>>8,n[l+1]=s,s=s>>>8,n[l]=s}e.writeUInt32BE=t;function P(n,s){return n[s+0]<<0>>>0|n[s+1]<<8>>>0|n[s+2]<<16>>>0|n[s+3]<<24>>>0}e.readUInt32LE=P;function b(n,s,l){n[l+0]=s&255,s=s>>>8,n[l+1]=s&255,s=s>>>8,n[l+2]=s&255,s=s>>>8,n[l+3]=s&255}e.writeUInt32LE=b;function p(n,s){return n[s]}e.readUInt8=p;function d(n,s,l){n[l]=s}e.writeUInt8=d;function g(n){return y.consumeReadable(n,s=>E.concat(s))}e.readableToBuffer=g;function I(n){return y.toReadable(n)}e.bufferToReadable=I;function v(n){return y.consumeStream(n,s=>E.concat(s))}e.streamToBuffer=v;async function u(n){return n.ended?E.concat(n.buffer):E.concat([...n.buffer,await v(n.stream)])}e.bufferedStreamToBuffer=u;function h(n){return y.toStream(n,s=>E.concat(s))}e.bufferToStream=h;function o(n){return y.transform(n,{data:s=>typeof s=="string"?E.fromString(s):E.wrap(s)},s=>E.concat(s))}e.streamToBufferReadableStream=o;function c(n){return y.newWriteableStream(s=>E.concat(s),n)}e.newWriteableBufferStream=c;function i(n,s){return y.prefixedReadable(n,s,l=>E.concat(l))}e.prefixedBufferReadable=i;function a(n,s){return y.prefixedStream(n,s,l=>E.concat(l))}e.prefixedBufferStream=a}),define(J[25],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function y(G){return!G||typeof G!="string"?!0:G.trim().length===0}e.isFalsyOrWhitespace=y;const L=/{(\d+)}/g;function k(G,...ne){return ne.length===0?G:G.replace(L,function(ce,fe){const ye=parseInt(fe,10);return isNaN(ye)||ye<0||ye>=ne.length?ce:ne[ye]})}e.format=k;const D=/{([^}]+)}/g;function E(G,ne){return G.replace(D,(ce,fe)=>ne[fe]??ce)}e.format2=E;function r(G){return G.replace(/[<>&]/g,function(ne){switch(ne){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ne}})}e.escape=r;function f(G){return G.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=f;function w(G,ne){let ce=0;const fe=ne.charCodeAt(0);for(let ye=G.length-1;ye>=0;ye--)G.charCodeAt(ye)===fe&&ce++;return ce}e.count=w;function t(G,ne,ce="\u2026"){return G.length<=ne?G:`${G.substr(0,ne)}${ce}`}e.truncate=t;function P(G,ne=" "){const ce=b(G,ne);return p(ce,ne)}e.trim=P;function b(G,ne){if(!G||!ne)return G;const ce=ne.length;if(ce===0||G.length===0)return G;let fe=0;for(;G.indexOf(ne,fe)===fe;)fe=fe+ce;return G.substring(fe)}e.ltrim=b;function p(G,ne){if(!G||!ne)return G;const ce=ne.length,fe=G.length;if(ce===0||fe===0)return G;let ye=fe,Me=-1;for(;Me=G.lastIndexOf(ne,ye-1),!(Me===-1||Me+ce!==ye);){if(Me===0)return"";ye=Me}return G.substring(0,ye)}e.rtrim=p;function d(G){return G.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function g(G){return G.replace(/\*/g,"")}e.stripWildcards=g;function I(G,ne,ce={}){if(!G)throw new Error("Cannot create regex from empty string");ne||(G=f(G)),ce.wholeWord&&(/\B/.test(G.charAt(0))||(G="\\b"+G),/\B/.test(G.charAt(G.length-1))||(G=G+"\\b"));let fe="";return ce.global&&(fe+="g"),ce.matchCase||(fe+="i"),ce.multiline&&(fe+="m"),ce.unicode&&(fe+="u"),new RegExp(G,fe)}e.createRegExp=I;function v(G){return G.source==="^"||G.source==="^$"||G.source==="$"||G.source==="^\\s*$"?!1:!!(G.exec("")&&G.lastIndex===0)}e.regExpLeadsToEndlessLoop=v;function u(G){return!!G.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=u;function h(G){return(G.global?"g":"")+(G.ignoreCase?"i":"")+(G.multiline?"m":"")+(G.unicode?"u":"")}e.regExpFlags=h;function o(G){return G.split(/\r\n|\r|\n/)}e.splitLines=o;function c(G){for(let ne=0,ce=G.length;ne<ce;ne++){const fe=G.charCodeAt(ne);if(fe!==32&&fe!==9)return ne}return-1}e.firstNonWhitespaceIndex=c;function i(G,ne=0,ce=G.length){for(let fe=ne;fe<ce;fe++){const ye=G.charCodeAt(fe);if(ye!==32&&ye!==9)return G.substring(ne,fe)}return G.substring(ne,ce)}e.getLeadingWhitespace=i;function a(G,ne=G.length-1){for(let ce=ne;ce>=0;ce--){const fe=G.charCodeAt(ce);if(fe!==32&&fe!==9)return ce}return-1}e.lastNonWhitespaceIndex=a;function n(G,ne){return G<ne?-1:G>ne?1:0}e.compare=n;function s(G,ne,ce=0,fe=G.length,ye=0,Me=ne.length){for(;ce<fe&&ye<Me;ce++,ye++){let Ce=G.charCodeAt(ce),ze=ne.charCodeAt(ye);if(Ce<ze)return-1;if(Ce>ze)return 1}const Fe=fe-ce,We=Me-ye;return Fe<We?-1:Fe>We?1:0}e.compareSubstring=s;function l(G,ne){return m(G,ne,0,G.length,0,ne.length)}e.compareIgnoreCase=l;function m(G,ne,ce=0,fe=G.length,ye=0,Me=ne.length){for(;ce<fe&&ye<Me;ce++,ye++){let Ce=G.charCodeAt(ce),ze=ne.charCodeAt(ye);if(Ce===ze)continue;const he=Ce-ze;if(!(he===32&&M(ze))&&!(he===-32&&M(Ce)))return S(Ce)&&S(ze)?he:s(G.toLowerCase(),ne.toLowerCase(),ce,fe,ye,Me)}const Fe=fe-ce,We=Me-ye;return Fe<We?-1:Fe>We?1:0}e.compareSubstringIgnoreCase=m;function S(G){return G>=97&&G<=122}e.isLowerAsciiLetter=S;function M(G){return G>=65&&G<=90}e.isUpperAsciiLetter=M;function A(G){return S(G)||M(G)}function F(G,ne){return G.length===ne.length&&C(G,ne)}e.equalsIgnoreCase=F;function C(G,ne,ce=G.length){for(let fe=0;fe<ce;fe++){const ye=G.charCodeAt(fe),Me=ne.charCodeAt(fe);if(ye!==Me){if(A(ye)&&A(Me)){const Fe=Math.abs(ye-Me);if(Fe!==0&&Fe!==32)return!1}else if(String.fromCharCode(ye).toLowerCase()!==String.fromCharCode(Me).toLowerCase())return!1}}return!0}function X(G,ne){const ce=ne.length;return ne.length>G.length?!1:C(G,ne,ce)}e.startsWithIgnoreCase=X;function ee(G,ne){let ce,fe=Math.min(G.length,ne.length);for(ce=0;ce<fe;ce++)if(G.charCodeAt(ce)!==ne.charCodeAt(ce))return ce;return fe}e.commonPrefixLength=ee;function re(G,ne){let ce,fe=Math.min(G.length,ne.length);const ye=G.length-1,Me=ne.length-1;for(ce=0;ce<fe;ce++)if(G.charCodeAt(ye-ce)!==ne.charCodeAt(Me-ce))return ce;return fe}e.commonSuffixLength=re;function Y(G){return 55296<=G&&G<=56319}e.isHighSurrogate=Y;function Q(G){return 56320<=G&&G<=57343}e.isLowSurrogate=Q;function W(G,ne){return(G-55296<<10)+(ne-56320)+65536}e.computeCodePoint=W;function V(G,ne,ce){const fe=G.charCodeAt(ce);if(Y(fe)&&ce+1<ne){const ye=G.charCodeAt(ce+1);if(Q(ye))return W(fe,ye)}return fe}e.getNextCodePoint=V;function z(G,ne){const ce=G.charCodeAt(ne-1);if(Q(ce)&&ne>1){const fe=G.charCodeAt(ne-2);if(Y(fe))return W(fe,ce)}return ce}function $(G,ne){const ce=Be.getInstance(),fe=ne,ye=G.length,Me=V(G,ye,ne);ne+=Me>=65536?2:1;let Fe=ce.getGraphemeBreakType(Me);for(;ne<ye;){const We=V(G,ye,ne),Ce=ce.getGraphemeBreakType(We);if(Ue(Fe,Ce))break;ne+=We>=65536?2:1,Fe=Ce}return ne-fe}e.nextCharLength=$;function j(G,ne){const ce=Be.getInstance(),fe=ne,ye=z(G,ne);ne-=ye>=65536?2:1;let Me=ce.getGraphemeBreakType(ye);for(;ne>0;){const Fe=z(G,ne),We=ce.getGraphemeBreakType(Fe);if(Ue(We,Me))break;ne-=Fe>=65536?2:1,Me=We}return fe-ne}e.prevCharLength=j;function U(G,ne){const ce=Be.getInstance(),fe=G.length,ye=ne,Me=V(G,fe,ne),Fe=ce.getGraphemeBreakType(Me);ne+=Me>=65536?2:1;let We=Fe;for(;ne<fe;){const ze=V(G,fe,ne),he=ce.getGraphemeBreakType(ze);if(Ue(We,he))break;ne+=ze>=65536?2:1,We=he}const Ce=ne;for(ne=ye,We=Fe;ne>0;){const ze=z(G,ne),he=ce.getGraphemeBreakType(ze);if(Ue(he,We))break;ne-=ze>=65536?2:1,We=he}return[ne,Ce]}function q(G,ne){return ne>0&&Q(G.charCodeAt(ne))?U(G,ne-1):U(G,ne)}e.getCharContainingOffset=q;const T=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function R(G){return T.test(G)}e.containsRTL=R;const O=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function _(G){return O.test(G)}e.containsEmoji=_;const N=/^[\t\n\r\x20-\x7E]*$/;function B(G){return N.test(G)}e.isBasicASCII=B,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function H(G){return e.UNUSUAL_LINE_TERMINATORS.test(G)}e.containsUnusualLineTerminators=H;function x(G){for(let ne=0,ce=G.length;ne<ce;ne++)if(ie(G.charCodeAt(ne)))return!0;return!1}e.containsFullWidthCharacter=x;function ie(G){return G=+G,G>=11904&&G<=55215||G>=63744&&G<=64255||G>=65281&&G<=65374}e.isFullWidthCharacter=ie;function ae(G){return G>=127462&&G<=127487||G===8986||G===8987||G===9200||G===9203||G>=9728&&G<=10175||G===11088||G===11093||G>=127744&&G<=128591||G>=128640&&G<=128764||G>=128992&&G<=129003||G>=129280&&G<=129535||G>=129648&&G<=129750}e.isEmojiImprecise=ae;function oe(G,ne){if(G.length<ne)return G;const ce=/\b/g;let fe=0;for(;ce.test(G)&&!(G.length-ce.lastIndex<ne);)fe=ce.lastIndex,ce.lastIndex+=1;return G.substring(fe).replace(/^\s/,"")}e.lcut=oe;const se=/\x1B\x5B[12]?K/g,le=/\x1b\[\d+m/g,de=/\x1b\[0?m/g;function ge(G){return G&&(G=G.replace(se,""),G=G.replace(le,""),G=G.replace(de,"")),G}e.removeAnsiEscapeCodes=ge,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ve(G){return!!(G&&G.length>0&&G.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ve;function Pe(G){return ve(G)?G.substr(1):G}e.stripUTF8BOM=Pe;function we(G,ne){if(!G||!ne||G.length<ne.length)return!1;const ce=ne.length,fe=G.toLowerCase();let ye=0,Me=-1;for(;ye<ce;){const Fe=fe.indexOf(ne[ye],Me+1);if(Fe<0)return!1;Me=Fe,ye++}return!0}e.fuzzyContains=we;function pe(G,ne=!1){return G?(ne&&(G=G.replace(/\\./g,"")),G.toLowerCase()!==G):!1}e.containsUppercaseCharacter=pe;function Ee(G){return G.charAt(0).toUpperCase()+G.slice(1)}e.uppercaseFirstLetter=Ee;function De(G,ne=1){if(ne===0)return"";let ce=-1;do ce=G.indexOf(`
`,ce+1),ne--;while(ne>0&&ce>=0);return ce===-1?G:(G[ce-1]==="\r"&&ce--,G.substr(0,ce))}e.getNLines=De;function Te(G){const ne=90-65+1;return G=G%(2*ne),G<ne?String.fromCharCode(97+G):String.fromCharCode(65+G-ne)}e.singleLetterHash=Te;function Ne(G){return Be.getInstance().getGraphemeBreakType(G)}e.getGraphemeBreakType=Ne;function Ue(G,ne){return G===0?ne!==5&&ne!==7:G===2&&ne===3?!1:G===4||G===2||G===3||ne===4||ne===2||ne===3?!0:!(G===8&&(ne===8||ne===9||ne===11||ne===12)||(G===11||G===9)&&(ne===9||ne===10)||(G===12||G===10)&&ne===10||ne===5||ne===13||ne===7||G===1||G===13&&ne===14||G===6&&ne===6)}e.breakBetweenGraphemeBreakType=Ue;var Ge;(function(G){G[G.Other=0]="Other",G[G.Prepend=1]="Prepend",G[G.CR=2]="CR",G[G.LF=3]="LF",G[G.Control=4]="Control",G[G.Extend=5]="Extend",G[G.Regional_Indicator=6]="Regional_Indicator",G[G.SpacingMark=7]="SpacingMark",G[G.L=8]="L",G[G.V=9]="V",G[G.T=10]="T",G[G.LV=11]="LV",G[G.LVT=12]="LVT",G[G.ZWJ=13]="ZWJ",G[G.Extended_Pictographic=14]="Extended_Pictographic"})(Ge=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Be{constructor(){this._data=st()}static getInstance(){return Be._INSTANCE||(Be._INSTANCE=new Be),Be._INSTANCE}getGraphemeBreakType(ne){if(ne<32)return ne===10?3:ne===13?2:4;if(ne<127)return 0;const ce=this._data,fe=ce.length/3;let ye=1;for(;ye<=fe;)if(ne<ce[3*ye])ye=2*ye;else if(ne>ce[3*ye+1])ye=2*ye+1;else return ce[3*ye+2];return 0}}Be._INSTANCE=null;function st(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Ze(G,ne){if(G===0)return 0;const ce=ot(G,ne);if(ce!==void 0)return ce;const fe=z(ne,G);return G-=Ye(fe),G}e.getLeftDeleteOffset=Ze;function ot(G,ne){let ce=z(ne,G);for(G-=Ye(ce);ut(ce)||ce===65039||ce===8419;){if(G===0)return;ce=z(ne,G),G-=Ye(ce)}if(!!ae(ce)){if(G>=0){const fe=z(ne,G);fe===8205&&(G-=Ye(fe))}return G}}function Ye(G){return G>=65536?2:1}function ut(G){return 127995<=G&&G<=127999}var xe;(function(G){G[G.zwj=8205]="zwj",G[G.emojiVariantSelector=65039]="emojiVariantSelector",G[G.enclosingKeyCap=8419]="enclosingKeyCap"})(xe||(xe={}))}),define(J[79],Z([0,1,25]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function L(v){return k(v,0)}e.hash=L;function k(v,u){switch(typeof v){case"object":return v===null?D(349,u):Array.isArray(v)?f(v,u):w(v,u);case"string":return r(v,u);case"boolean":return E(v,u);case"number":return D(v,u);case"undefined":return D(937,u);default:return D(617,u)}}e.doHash=k;function D(v,u){return(u<<5)-u+v|0}function E(v,u){return D(v?433:863,u)}function r(v,u){u=D(149417,u);for(let h=0,o=v.length;h<o;h++)u=D(v.charCodeAt(h),u);return u}e.stringHash=r;function f(v,u){return u=D(104579,u),v.reduce((h,o)=>k(o,h),u)}function w(v,u){return u=D(181387,u),Object.keys(v).sort().reduce((h,o)=>(h=r(o,h),k(v[o],h)),u)}class t{constructor(){this._value=0}get value(){return this._value}hash(u){return this._value=k(u,this._value),this._value}}e.Hasher=t;var P;(function(v){v[v.BLOCK_SIZE=64]="BLOCK_SIZE",v[v.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function b(v,u,h=32){const o=h-u,c=~((1<<o)-1);return(v<<u|(c&v)>>>o)>>>0}function p(v,u=0,h=v.byteLength,o=0){for(let c=0;c<h;c++)v[u+c]=o}function d(v,u,h="0"){for(;v.length<u;)v=h+v;return v}function g(v,u=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(h=>h.toString(16).padStart(2,"0")).join(""):d((v>>>0).toString(16),u/4)}e.toHexString=g;class I{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(u){const h=u.length;if(h===0)return;const o=this._buff;let c=this._buffLen,i=this._leftoverHighSurrogate,a,n;for(i!==0?(a=i,n=-1,i=0):(a=u.charCodeAt(0),n=0);;){let s=a;if(y.isHighSurrogate(a))if(n+1<h){const l=u.charCodeAt(n+1);y.isLowSurrogate(l)?(n++,s=y.computeCodePoint(a,l)):s=65533}else{i=a;break}else y.isLowSurrogate(a)&&(s=65533);if(c=this._push(o,c,s),n++,n<h)a=u.charCodeAt(n);else break}this._buffLen=c,this._leftoverHighSurrogate=i}_push(u,h,o){return o<128?u[h++]=o:o<2048?(u[h++]=192|(o&1984)>>>6,u[h++]=128|(o&63)>>>0):o<65536?(u[h++]=224|(o&61440)>>>12,u[h++]=128|(o&4032)>>>6,u[h++]=128|(o&63)>>>0):(u[h++]=240|(o&1835008)>>>18,u[h++]=128|(o&258048)>>>12,u[h++]=128|(o&4032)>>>6,u[h++]=128|(o&63)>>>0),h>=64&&(this._step(),h-=64,this._totalLen+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),h}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const u=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(u/4294967296),!1),this._buffDV.setUint32(60,u%4294967296,!1),this._step()}_step(){const u=I._bigBlock32,h=this._buffDV;for(let S=0;S<64;S+=4)u.setUint32(S,h.getUint32(S,!1),!1);for(let S=64;S<320;S+=4)u.setUint32(S,b(u.getUint32(S-12,!1)^u.getUint32(S-32,!1)^u.getUint32(S-56,!1)^u.getUint32(S-64,!1),1),!1);let o=this._h0,c=this._h1,i=this._h2,a=this._h3,n=this._h4,s,l,m;for(let S=0;S<80;S++)S<20?(s=c&i|~c&a,l=1518500249):S<40?(s=c^i^a,l=1859775393):S<60?(s=c&i|c&a|i&a,l=2400959708):(s=c^i^a,l=3395469782),m=b(o,5)+s+n+l+u.getUint32(S*4,!1)&4294967295,n=a,a=i,i=b(c,30),c=o,o=m;this._h0=this._h0+o&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+a&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=I,I._bigBlock32=new DataView(new ArrayBuffer(320))}),define(J[13],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function y(M){return Array.isArray(M)}e.isArray=y;function L(M){return typeof M=="string"}e.isString=L;function k(M){return Array.isArray(M)&&M.every(A=>L(A))}e.isStringArray=k;function D(M){return typeof M=="object"&&M!==null&&!Array.isArray(M)&&!(M instanceof RegExp)&&!(M instanceof Date)}e.isObject=D;function E(M){return typeof M=="number"&&!isNaN(M)}e.isNumber=E;function r(M){return!!M&&typeof M[Symbol.iterator]=="function"}e.isIterable=r;function f(M){return M===!0||M===!1}e.isBoolean=f;function w(M){return typeof M=="undefined"}e.isUndefined=w;function t(M){return!P(M)}e.isDefined=t;function P(M){return w(M)||M===null}e.isUndefinedOrNull=P;function b(M,A){if(!M)throw new Error(A?`Unexpected type, expected '${A}'`:"Unexpected type")}e.assertType=b;function p(M){if(P(M))throw new Error("Assertion Failed: argument is undefined or null");return M}e.assertIsDefined=p;function d(...M){const A=[];for(let F=0;F<M.length;F++){const C=M[F];if(P(C))throw new Error(`Assertion Failed: argument at index ${F} is undefined or null`);A.push(C)}return A}e.assertAllDefined=d;const g=Object.prototype.hasOwnProperty;function I(M){if(!D(M))return!1;for(let A in M)if(g.call(M,A))return!1;return!0}e.isEmptyObject=I;function v(M){return typeof M=="function"}e.isFunction=v;function u(...M){return M.length>0&&M.every(v)}e.areFunctions=u;function h(M,A){const F=Math.min(M.length,A.length);for(let C=0;C<F;C++)o(M[C],A[C])}e.validateConstraints=h;function o(M,A){if(L(A)){if(typeof M!==A)throw new Error(`argument does not match constraint: typeof ${A}`)}else if(v(A)){try{if(M instanceof A)return}catch{}if(!P(M)&&M.constructor===A||A.length===1&&A.call(void 0,M)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function c(M){let A=[],F=Object.getPrototypeOf(M);for(;Object.prototype!==F;)A=A.concat(Object.getOwnPropertyNames(F)),F=Object.getPrototypeOf(F);return A}e.getAllPropertyNames=c;function i(M){const A=[];for(const F of c(M))typeof M[F]=="function"&&A.push(F);return A}e.getAllMethodNames=i;function a(M,A){const F=X=>function(){const ee=Array.prototype.slice.call(arguments,0);return A(X,ee)};let C={};for(const X of M)C[X]=F(X);return C}e.createProxyObject=a;function n(M){return M===null?void 0:M}e.withNullAsUndefined=n;function s(M){return typeof M=="undefined"?null:M}e.withUndefinedAsNull=s;function l(M){return class{constructor(){return new Proxy({},{get(A,F){if(A[F])return A[F];throw new Error(`Not Implemented: ${M}->${String(F)}`)}})}}}e.NotImplementedProxy=l;function m(M,A="Unreachable"){throw new Error(A)}e.assertNever=m;function S(M){return!!M&&typeof M.then=="function"&&typeof M.catch=="function"}e.isPromise=S}),define(J[29],Z([0,1,8,3,25,13]),function(K,e,y,L,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function E(n){return n===47||n===92}e.isPathSeparator=E;function r(n){return n.replace(/[\\/]/g,y.posix.sep)}e.toSlashes=r;function f(n){return n.indexOf("/")===-1&&(n=r(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=f;function w(n,s=y.posix.sep){if(!n)return"";const l=n.length,m=n.charCodeAt(0);if(E(m)){if(E(n.charCodeAt(1))&&!E(n.charCodeAt(2))){let M=3;const A=M;for(;M<l&&!E(n.charCodeAt(M));M++);if(A!==M&&!E(n.charCodeAt(M+1))){for(M+=1;M<l;M++)if(E(n.charCodeAt(M)))return n.slice(0,M+1).replace(/[\\/]/g,s)}}return s}else if(v(m)&&n.charCodeAt(1)===58)return E(n.charCodeAt(2))?n.slice(0,2)+s:n.slice(0,2);let S=n.indexOf("://");if(S!==-1){for(S+=3;S<l;S++)if(E(n.charCodeAt(S)))return n.slice(0,S+1)}return""}e.getRoot=w;function t(n){if(!L.isWindows||!n||n.length<5)return!1;let s=n.charCodeAt(0);if(s!==92||(s=n.charCodeAt(1),s!==92))return!1;let l=2;const m=l;for(;l<n.length&&(s=n.charCodeAt(l),s!==92);l++);return!(m===l||(s=n.charCodeAt(l+1),isNaN(s)||s===92))}e.isUNC=t;const P=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(n,s=L.isWindows){const l=s?P:b;return!(!n||n.length===0||/^\s+$/.test(n)||(l.lastIndex=0,l.test(n))||s&&p.test(n)||n==="."||n===".."||s&&n[n.length-1]==="."||s&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=d;function g(n,s,l){const m=n===s;return!l||m?m:!n||!s?!1:(0,k.equalsIgnoreCase)(n,s)}e.isEqual=g;function I(n,s,l,m=y.sep){if(n===s)return!0;if(!n||!s||s.length>n.length)return!1;if(l){if(!(0,k.startsWithIgnoreCase)(n,s))return!1;if(s.length===n.length)return!0;let M=s.length;return s.charAt(s.length-1)===m&&M--,n.charAt(M)===m}return s.charAt(s.length-1)!==m&&(s+=m),n.indexOf(s)===0}e.isEqualOrParent=I;function v(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=v;function u(n,s){return L.isWindows&&n.endsWith(":")&&(n+=y.sep),(0,y.isAbsolute)(n)||(n=(0,y.join)(s,n)),n=(0,y.normalize)(n),L.isWindows?(n=(0,k.rtrim)(n,y.sep),n.endsWith(":")&&(n+=y.sep)):(n=(0,k.rtrim)(n,y.sep),n||(n=y.sep)),n}e.sanitizeFilePath=u;function h(n){const s=(0,y.normalize)(n);return L.isWindows?n.length>3?!1:o(s)&&(n.length===2||s.charCodeAt(2)===92):s===y.posix.sep}e.isRootOrDriveLetter=h;function o(n){return L.isWindows?v(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=o;function c(n){return o(n)?n[0]:void 0}e.getDriveLetter=c;function i(n,s,l){return s.length>n.length?-1:n===s?0:(l&&(n=n.toLowerCase(),s=s.toLowerCase()),n.indexOf(s))}e.indexOfPath=i;function a(n){const s=n.split(":");let l,m,S;if(s.forEach(M=>{const A=Number(M);(0,D.isNumber)(A)?m===void 0?m=A:S===void 0&&(S=A):l=l?[l,M].join(":"):M}),!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:m!==void 0?m:void 0,column:S!==void 0?S:m!==void 0?1:void 0}}e.parseLineAndColumnAware=a}),define(J[44],Z([0,1,13]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const I=Array.isArray(g)?[]:{};return Object.keys(g).forEach(v=>{g[v]&&typeof g[v]=="object"?I[v]=L(g[v]):I[v]=g[v]}),I}e.deepClone=L;function k(g){if(!g||typeof g!="object")return g;const I=[g];for(;I.length>0;){const v=I.shift();Object.freeze(v);for(const u in v)if(D.call(v,u)){const h=v[u];typeof h=="object"&&!Object.isFrozen(h)&&I.push(h)}}return g}e.deepFreeze=k;const D=Object.prototype.hasOwnProperty;function E(g,I){return r(g,I,new Set)}e.cloneAndChange=E;function r(g,I,v){if((0,y.isUndefinedOrNull)(g))return g;const u=I(g);if(typeof u!="undefined")return u;if((0,y.isArray)(g)){const h=[];for(const o of g)h.push(r(o,I,v));return h}if((0,y.isObject)(g)){if(v.has(g))throw new Error("Cannot clone recursive data-structure");v.add(g);const h={};for(let o in g)D.call(g,o)&&(h[o]=r(g[o],I,v));return v.delete(g),h}return g}function f(g,I,v=!0){return(0,y.isObject)(g)?((0,y.isObject)(I)&&Object.keys(I).forEach(u=>{u in g?v&&((0,y.isObject)(g[u])&&(0,y.isObject)(I[u])?f(g[u],I[u],v):g[u]=I[u]):g[u]=I[u]}),g):I}e.mixin=f;function w(g,I){if(g===I)return!0;if(g==null||I===null||I===void 0||typeof g!=typeof I||typeof g!="object"||Array.isArray(g)!==Array.isArray(I))return!1;let v,u;if(Array.isArray(g)){if(g.length!==I.length)return!1;for(v=0;v<g.length;v++)if(!w(g[v],I[v]))return!1}else{const h=[];for(u in g)h.push(u);h.sort();const o=[];for(u in I)o.push(u);if(o.sort(),!w(h,o))return!1;for(v=0;v<h.length;v++)if(!w(g[h[v]],I[h[v]]))return!1}return!0}e.equals=w;function t(g){const I=new Set;return JSON.stringify(g,(v,u)=>{if((0,y.isObject)(u)||Array.isArray(u)){if(I.has(u))return"[Circular]";I.add(u)}return u})}e.safeStringify=t;function P(g,I,v){const u=I(g);return typeof u=="undefined"?v:u}e.getOrDefault=P;function b(g,I){const v=Object.create(null);return!g||!I||Object.keys(I).forEach(h=>{const o=g[h],c=I[h];w(o,c)||(v[h]=c)}),v}e.distinct=b;function p(g,I){const v=I.toLowerCase(),u=Object.keys(g).find(h=>h.toLowerCase()===v);return u?g[u]:g[I]}e.getCaseInsensitive=p;function d(g,I){const v=Object.create(null);for(const u of Object.keys(g))I(u,g[u])&&(v[u]=g[u]);return v}e.filter=d}),define(J[7],Z([0,1,8,3]),function(K,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,D=/^\//,E=/^\/\//;function r(n,s){if(!n.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!k.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!D.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(E.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(n,s){return!n&&!s?"file":n}function w(n,s){switch(n){case"https":case"http":case"file":s?s[0]!==P&&(s=P+s):s=P;break}return s}const t="",P="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(s,l,m,S,M,A=!1){typeof s=="object"?(this.scheme=s.scheme||t,this.authority=s.authority||t,this.path=s.path||t,this.query=s.query||t,this.fragment=s.fragment||t):(this.scheme=f(s,A),this.authority=l||t,this.path=w(this.scheme,m||t),this.query=S||t,this.fragment=M||t,r(this,A))}static isUri(s){return s instanceof p?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}get fsPath(){return h(this,!1)}with(s){if(!s)return this;let{scheme:l,authority:m,path:S,query:M,fragment:A}=s;return l===void 0?l=this.scheme:l===null&&(l=t),m===void 0?m=this.authority:m===null&&(m=t),S===void 0?S=this.path:S===null&&(S=t),M===void 0?M=this.query:M===null&&(M=t),A===void 0?A=this.fragment:A===null&&(A=t),l===this.scheme&&m===this.authority&&S===this.path&&M===this.query&&A===this.fragment?this:new g(l,m,S,M,A)}static parse(s,l=!1){const m=b.exec(s);return m?new g(m[2]||t,a(m[4]||t),a(m[5]||t),a(m[7]||t),a(m[9]||t),l):new g(t,t,t,t,t)}static file(s){let l=t;if(L.isWindows&&(s=s.replace(/\\/g,P)),s[0]===P&&s[1]===P){const m=s.indexOf(P,2);m===-1?(l=s.substring(2),s=P):(l=s.substring(2,m),s=s.substring(m)||P)}return new g("file",l,s,t,t)}static from(s){const l=new g(s.scheme,s.authority,s.path,s.query,s.fragment);return r(l,!0),l}static joinPath(s,...l){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let m;return L.isWindows&&s.scheme==="file"?m=p.file(y.win32.join(h(s,!0),...l)).path:m=y.posix.join(s.path,...l),s.with({path:m})}toString(s=!1){return o(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof p)return s;{const l=new g(s);return l._formatted=s.external,l._fsPath=s._sep===d?s.fsPath:null,l}}else return s}}e.URI=p;const d=L.isWindows?1:void 0;class g extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(s=!1){return s?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=d),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const I={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function v(n,s){let l,m=-1;for(let S=0;S<n.length;S++){const M=n.charCodeAt(S);if(M>=97&&M<=122||M>=65&&M<=90||M>=48&&M<=57||M===45||M===46||M===95||M===126||s&&M===47)m!==-1&&(l+=encodeURIComponent(n.substring(m,S)),m=-1),l!==void 0&&(l+=n.charAt(S));else{l===void 0&&(l=n.substr(0,S));const A=I[M];A!==void 0?(m!==-1&&(l+=encodeURIComponent(n.substring(m,S)),m=-1),l+=A):m===-1&&(m=S)}}return m!==-1&&(l+=encodeURIComponent(n.substring(m))),l!==void 0?l:n}function u(n){let s;for(let l=0;l<n.length;l++){const m=n.charCodeAt(l);m===35||m===63?(s===void 0&&(s=n.substr(0,l)),s+=I[m]):s!==void 0&&(s+=n[l])}return s!==void 0?s:n}function h(n,s){let l;return n.authority&&n.path.length>1&&n.scheme==="file"?l=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?s?l=n.path.substr(1):l=n.path[1].toLowerCase()+n.path.substr(2):l=n.path,L.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=h;function o(n,s){const l=s?u:v;let m="",{scheme:S,authority:M,path:A,query:F,fragment:C}=n;if(S&&(m+=S,m+=":"),(M||S==="file")&&(m+=P,m+=P),M){let X=M.indexOf("@");if(X!==-1){const ee=M.substr(0,X);M=M.substr(X+1),X=ee.indexOf(":"),X===-1?m+=l(ee,!1):(m+=l(ee.substr(0,X),!1),m+=":",m+=l(ee.substr(X+1),!1)),m+="@"}M=M.toLowerCase(),X=M.indexOf(":"),X===-1?m+=l(M,!1):(m+=l(M.substr(0,X),!1),m+=M.substr(X))}if(A){if(A.length>=3&&A.charCodeAt(0)===47&&A.charCodeAt(2)===58){const X=A.charCodeAt(1);X>=65&&X<=90&&(A=`/${String.fromCharCode(X+32)}:${A.substr(3)}`)}else if(A.length>=2&&A.charCodeAt(1)===58){const X=A.charCodeAt(0);X>=65&&X<=90&&(A=`${String.fromCharCode(X+32)}:${A.substr(2)}`)}m+=l(A,!0)}return F&&(m+="?",m+=l(F,!1)),C&&(m+="#",m+=s?C:v(C,!1)),m}function c(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+c(n.substr(3)):n}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(n){return n.match(i)?n.replace(i,s=>c(s)):n}}),define(J[109],Z([0,1,7]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(w){const t=w;return t&&typeof t.type=="string"&&typeof t.severity=="string"}e.isRemoteConsoleLog=L;function k(w){const t=[];let P;try{const b=JSON.parse(w.arguments),p=b[b.length-1];p&&p.__$stack&&(b.pop(),P=p.__$stack),t.push(...b)}catch(b){t.push("Unable to log remote console arguments",w.arguments)}return{args:t,stack:P}}e.parse=k;function D(w){if(typeof w!="string")return D(k(w).stack);const t=w;if(t){const P=E(t),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if(b&&b.length===4)return{uri:y.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}e.getFirstFrame=D;function E(w){if(!w)return w;const t=w.indexOf(`
`);return t===-1?w:w.substring(0,t)}function r(w,t){const{args:P,stack:b}=k(w),p=typeof P[0]=="string"&&P.length===1;let d=E(b);d&&(d=`(${d.trim()})`);let g=[];if(typeof P[0]=="string"?d&&p?g=[`%c[${t}] %c${P[0]} %c${d}`,f("blue"),f(""),f("grey")]:g=[`%c[${t}] %c${P[0]}`,f("blue"),f(""),...P.slice(1)]:g=[`%c[${t}]%`,f("blue"),...P],d&&!p&&g.push(d),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,g)}e.log=r;function f(w){return`color: ${w}`}});var bt=this&&this.__classPrivateFieldSet||function(K,e,y,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!k:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(K,y):k?k.value=y:e.set(K,y),y},qe=this&&this.__classPrivateFieldGet||function(K,e,y,L){if(y==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!L:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?L:y==="a"?L.call(K):L?L.value:e.get(K)};define(J[37],Z([0,1,31,25,7]),function(K,e,y,L,k){"use strict";var D,E,r;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function f(a,n,s){let l=a.get(n);return l===void 0&&(l=s,a.set(n,l)),l}e.getOrSet=f;function w(a){const n=[];return a.forEach((s,l)=>{n.push(`${l} => ${s}`)}),`Map(${a.size}) {${n.join(", ")}}`}e.mapToString=w;function t(a){const n=[];return a.forEach(s=>{n.push(s)}),`Set(${a.size}) {${n.join(", ")}}`}e.setToString=t;class P{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const s=n.charCodeAt(0),l=this._value.charCodeAt(this._pos);return s-l}value(){return this._value[this._pos]}}e.StringIterator=P;class b{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,L.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=b;class p{constructor(n=!0,s=!0){this._splitOnBackslash=n,this._caseSensitive=s}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,L.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=p;var d;(function(a){a[a.Scheme=1]="Scheme",a[a.Authority=2]="Authority",a[a.Path=3]="Path",a[a.Query=4]="Query",a[a.Fragment=5]="Fragment"})(d||(d={}));class g{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new p(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,L.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=g;class I{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class v{constructor(n){this._iter=n}static forUris(n=()=>!1){return new v(new g(n))}static forPaths(){return new v(new p)}static forStrings(){return new v(new P)}static forConfigKeys(){return new v(new b)}clear(){this._root=void 0}set(n,s){const l=this._iter.reset(n);let m;for(this._root||(this._root=new I,this._root.segment=l.value()),m=this._root;;){const M=l.cmp(m.segment);if(M>0)m.left||(m.left=new I,m.left.segment=l.value()),m=m.left;else if(M<0)m.right||(m.right=new I,m.right.segment=l.value()),m=m.right;else if(l.hasNext())l.next(),m.mid||(m.mid=new I,m.mid.segment=l.value()),m=m.mid;else break}const S=m.value;return m.value=s,m.key=n,S}fill(n,s){const l=s.slice(0);(0,y.shuffle)(l);for(let m of l)this.set(m,n)}get(n){return this._getNode(n)?.value}_getNode(n){const s=this._iter.reset(n);let l=this._root;for(;l;){const m=s.cmp(l.segment);if(m>0)l=l.left;else if(m<0)l=l.right;else if(s.hasNext())s.next(),l=l.mid;else break}return l}has(n){const s=this._getNode(n);return!(s?.value===void 0&&s?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,s){const l=this._iter.reset(n),m=[];let S=this._root;for(;S;){const M=l.cmp(S.segment);if(M>0)m.push([1,S]),S=S.left;else if(M<0)m.push([-1,S]),S=S.right;else if(l.hasNext())l.next(),m.push([0,S]),S=S.mid;else{for(s?(S.left=void 0,S.mid=void 0,S.right=void 0):S.value=void 0;m.length>0&&S.isEmpty();){let[A,F]=m.pop();switch(A){case 1:F.left=void 0;break;case 0:F.mid=void 0;break;case-1:F.right=void 0;break}S=F}break}}}findSubstr(n){const s=this._iter.reset(n);let l=this._root,m;for(;l;){const S=s.cmp(l.segment);if(S>0)l=l.left;else if(S<0)l=l.right;else if(s.hasNext())s.next(),m=l.value||m,l=l.mid;else break}return l&&l.value||m}findSuperstr(n){const s=this._iter.reset(n);let l=this._root;for(;l;){const m=s.cmp(l.segment);if(m>0)l=l.left;else if(m<0)l=l.right;else if(s.hasNext())s.next(),l=l.mid;else return l.mid?this._entries(l.mid):void 0}}forEach(n){for(const[s,l]of this)n(l,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){if(!n)return;const s=[n];for(;s.length>0;){const l=s.pop();l&&(l.value&&(yield[l.key,l.value]),l.left&&s.push(l.left),l.mid&&s.push(l.mid),l.right&&s.push(l.right))}}}e.TernarySearchTree=v;class u{constructor(n,s){this[D]="ResourceMap",n instanceof u?(this.map=new Map(n.map),this.toKey=s??u.defaultToKey):(this.map=new Map,this.toKey=n??u.defaultToKey)}set(n,s){return this.map.set(this.toKey(n),s),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,s){typeof s!="undefined"&&(n=n.bind(s));for(let[l,m]of this.map)n(m,k.URI.parse(l),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield k.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[k.URI.parse(n[0]),n[1]]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[k.URI.parse(n[0]),n[1]]}}e.ResourceMap=u,u.defaultToKey=a=>a.toString();var h;(function(a){a[a.None=0]="None",a[a.AsOld=1]="AsOld",a[a.AsNew=2]="AsNew"})(h=e.Touch||(e.Touch={}));class o{constructor(){this[E]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,s=0){const l=this._map.get(n);if(!!l)return s!==0&&this.touch(l,s),l.value}set(n,s,l=0){let m=this._map.get(n);if(m)m.value=s,l!==0&&this.touch(m,l);else{switch(m={key:n,value:s,next:void 0,previous:void 0},l){case 0:this.addItemLast(m);break;case 1:this.addItemFirst(m);break;case 2:this.addItemLast(m);break;default:this.addItemLast(m);break}this._map.set(n,m),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const s=this._map.get(n);if(!!s)return this._map.delete(n),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,s){const l=this._state;let m=this._head;for(;m;){if(s?n.bind(s)(m.value,m.key,this):n(m.value,m.key,this),this._state!==l)throw new Error("LinkedMap got modified during iteration.");m=m.next}}keys(){const n=this,s=this._state;let l=this._head;const m={[Symbol.iterator](){return m},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const S={value:l.key,done:!1};return l=l.next,S}else return{value:void 0,done:!0}}};return m}values(){const n=this,s=this._state;let l=this._head;const m={[Symbol.iterator](){return m},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const S={value:l.value,done:!1};return l=l.next,S}else return{value:void 0,done:!0}}};return m}entries(){const n=this,s=this._state;let l=this._head;const m={[Symbol.iterator](){return m},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const S={value:[l.key,l.value],done:!1};return l=l.next,S}else return{value:void 0,done:!0}}};return m}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let s=this._head,l=this.size;for(;s&&l>n;)this._map.delete(s.key),s=s.next,l--;this._head=s,this._size=l,s&&(s.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const s=n.next,l=n.previous;if(!s||!l)throw new Error("Invalid list");s.previous=l,l.next=s}n.next=void 0,n.previous=void 0,this._state++}touch(n,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(n===this._head)return;const l=n.next,m=n.previous;n===this._tail?(m.next=void 0,this._tail=m):(l.previous=m,m.next=l),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(s===2){if(n===this._tail)return;const l=n.next,m=n.previous;n===this._head?(l.previous=void 0,this._head=l):(l.previous=m,m.next=l),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((s,l)=>{n.push([l,s])}),n}fromJSON(n){this.clear();for(const[s,l]of n)this.set(s,l)}}e.LinkedMap=o;class c extends o{constructor(n,s=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,s=2){return super.get(n,s)}peek(n){return super.get(n,0)}set(n,s){return super.set(n,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=c;class i{constructor(n){r.set(this,void 0),bt(this,r,n,"f")}get size(){return qe(this,r,"f").size}forEach(n,s){qe(this,r,"f").forEach(n,s)}get(n){return qe(this,r,"f").get(n)}has(n){return qe(this,r,"f").has(n)}entries(){return qe(this,r,"f").entries()}keys(){return qe(this,r,"f").keys()}values(){return qe(this,r,"f").values()}[(r=new WeakMap,Symbol.iterator)](){return qe(this,r,"f").entries()}}e.ReadonlyMapView=i}),define(J[110],Z([0,1,18,25,7]),function(K,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function D(t){return JSON.stringify(t,f)}e.stringify=D;function E(t){let P=JSON.parse(t);return P=w(P),P}e.parse=E;var r;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadReply=8]="CommentThreadReply",t[t.CommentNode=9]="CommentNode",t[t.CommentThreadNode=10]="CommentThreadNode",t[t.TimelineActionContext=11]="TimelineActionContext",t[t.NotebookCellActionContext=12]="NotebookCellActionContext",t[t.TestItemContext=13]="TestItemContext"})(r=e.MarshalledId||(e.MarshalledId={}));function f(t,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,L.regExpFlags)(P)}:P}function w(t,P=0){if(!t||P>200)return t;if(typeof t=="object"){switch(t.$mid){case 1:return k.URI.revive(t);case 2:return new RegExp(t.source,t.flags)}if(t instanceof y.VSBuffer||t instanceof Uint8Array)return t;if(Array.isArray(t))for(let b=0;b<t.length;++b)t[b]=w(t[b],P+1);else for(const b in t)Object.hasOwnProperty.call(t,b)&&(t[b]=w(t[b],P+1))}return t}e.revive=w}),define(J[10],Z([0,1,3,7]),function(K,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var k;(function(r){r.inMemory="inmemory",r.vscode="vscode",r.internal="private",r.walkThrough="walkThrough",r.walkThroughSnippet="walkThroughSnippet",r.http="http",r.https="https",r.file="file",r.mailto="mailto",r.untitled="untitled",r.data="data",r.command="command",r.vscodeRemote="vscode-remote",r.vscodeRemoteResource="vscode-remote-resource",r.userData="vscode-userdata",r.vscodeCustomEditor="vscode-custom-editor",r.vscodeNotebook="vscode-notebook",r.vscodeNotebookCell="vscode-notebook-cell",r.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",r.vscodeNotebookCellOutput="vscode-notebook-cell-output",r.vscodeInteractive="vscode-interactive",r.vscodeInteractiveInput="vscode-interactive-input",r.vscodeSettings="vscode-settings",r.vscodeWorkspaceTrust="vscode-workspace-trust",r.vscodeTerminal="vscode-terminal",r.webviewPanel="webview-panel",r.vscodeWebview="vscode-webview",r.extension="extension",r.vscodeFileResource="vscode-file",r.tmp="tmp"})(k=e.Schemas||(e.Schemas={}));class D{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(f){this._preferredWebSchema=f}setDelegate(f){this._delegate=f}set(f,w,t){this._hosts[f]=w,this._ports[f]=t}setConnectionToken(f,w){this._connectionTokens[f]=w}rewrite(f){if(this._delegate)return this._delegate(f);const w=f.authority;let t=this._hosts[w];t&&t.indexOf(":")!==-1&&(t=`[${t}]`);const P=this._ports[w],b=this._connectionTokens[w];let p=`path=${encodeURIComponent(f.path)}`;return typeof b=="string"&&(p+=`&tkn=${encodeURIComponent(b)}`),L.URI.from({scheme:y.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${t}:${P}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new D;class E{asBrowserUri(f,w){const t=this.toUri(f,w);return t.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(t):t.scheme===k.file&&(y.isNative||typeof y.globals.importScripts=="function"&&y.globals.origin===`${k.vscodeFileResource}://${E.FALLBACK_AUTHORITY}`)?t.with({scheme:k.vscodeFileResource,authority:t.authority||E.FALLBACK_AUTHORITY,query:null,fragment:null}):t}asFileUri(f,w){const t=this.toUri(f,w);return t.scheme===k.vscodeFileResource?t.with({scheme:k.file,authority:t.authority!==E.FALLBACK_AUTHORITY?t.authority:null,query:null,fragment:null}):t}toUri(f,w){return L.URI.isUri(f)?f:L.URI.parse(w.toUrl(f))}}E.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new E}),define(J[65],Z([0,1,37]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new y.LRUCache(1e4);function k(w){return f(w,"NFC",L)}e.normalizeNFC=k;const D=new y.LRUCache(1e4);function E(w){return f(w,"NFD",D)}e.normalizeNFD=E;const r=/[^\u0000-\u0080]/;function f(w,t,P){if(!w)return w;const b=P.get(w);if(b)return b;let p;return r.test(w)?p=w.normalize(t):p=w,P.set(w,p),p}e.removeAccents=function(){const w=/[\u0300-\u036f]/g;return function(t){return E(t).replace(w,"")}}()}),define(J[15],Z([0,1,29,10,8,3,25,7]),function(K,e,y,L,k,D,E,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function f(p){return(0,r.uriToFsPath)(p,!0)}e.originalFSPath=f;class w{constructor(d){this._ignorePathCasing=d}compare(d,g,I=!1){return d===g?0:(0,E.compare)(this.getComparisonKey(d,I),this.getComparisonKey(g,I))}isEqual(d,g,I=!1){return d===g?!0:!d||!g?!1:this.getComparisonKey(d,I)===this.getComparisonKey(g,I)}getComparisonKey(d,g=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,g,I=!1){if(d.scheme===g.scheme){if(d.scheme===L.Schemas.file)return y.isEqualOrParent(f(d),f(g),this._ignorePathCasing(d))&&d.query===g.query&&(I||d.fragment===g.fragment);if((0,e.isEqualAuthority)(d.authority,g.authority))return y.isEqualOrParent(d.path,g.path,this._ignorePathCasing(d),"/")&&d.query===g.query&&(I||d.fragment===g.fragment)}return!1}joinPath(d,...g){return r.URI.joinPath(d,...g)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return k.posix.basename(d.path)}extname(d){return k.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let g;return d.scheme===L.Schemas.file?g=r.URI.file(k.dirname(f(d))).path:(g=k.posix.dirname(d.path),d.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),g="/")),d.with({path:g})}normalizePath(d){if(!d.path.length)return d;let g;return d.scheme===L.Schemas.file?g=r.URI.file(k.normalize(f(d))).path:g=k.posix.normalize(d.path),d.with({path:g})}relativePath(d,g){if(d.scheme!==g.scheme||!(0,e.isEqualAuthority)(d.authority,g.authority))return;if(d.scheme===L.Schemas.file){const u=k.relative(f(d),f(g));return D.isWindows?y.toSlashes(u):u}let I=d.path||"/",v=g.path||"/";if(this._ignorePathCasing(d)){let u=0;for(const h=Math.min(I.length,v.length);u<h&&!(I.charCodeAt(u)!==v.charCodeAt(u)&&I.charAt(u).toLowerCase()!==v.charAt(u).toLowerCase());u++);I=v.substr(0,u)+I.substr(u)}return k.posix.relative(I,v)}resolvePath(d,g){if(d.scheme===L.Schemas.file){const I=r.URI.file(k.resolve(f(d),g));return d.with({authority:I.authority,path:I.path})}return g=y.toPosixPath(g),d.with({path:k.posix.resolve(d.path,g)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,g){return d===g||(0,E.equalsIgnoreCase)(d,g)}hasTrailingPathSeparator(d,g=k.sep){if(d.scheme===L.Schemas.file){const I=f(d);return I.length>y.getRoot(I).length&&I[I.length-1]===g}else{const I=d.path;return I.length>1&&I.charCodeAt(I.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,g=k.sep){return(0,e.hasTrailingPathSeparator)(d,g)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,g=k.sep){let I=!1;if(d.scheme===L.Schemas.file){const v=f(d);I=v!==void 0&&v.length===y.getRoot(v).length&&v[v.length-1]===g}else{g="/";const v=d.path;I=v.length===1&&v.charCodeAt(v.length-1)===47}return!I&&!(0,e.hasTrailingPathSeparator)(d,g)?d.with({path:d.path+"/"}):d}}e.ExtUri=w,e.extUri=new w(()=>!1),e.extUriBiasedIgnorePathCase=new w(p=>p.scheme===L.Schemas.file?!D.isLinux:!0),e.extUriIgnorePathCase=new w(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function t(p,d){const g=[];for(let I=0;I<p.length;I++){const v=d(p[I]);p.some((u,h)=>h===I?!1:(0,e.isEqualOrParent)(v,d(u)))||g.push(p[I])}return g}e.distinctParents=t;var P;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function d(g){const I=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(h=>{const[o,c]=h.split(":");o&&c&&I.set(o,c)});const u=g.path.substring(0,g.path.indexOf(";"));return u&&I.set(p.META_DATA_MIME,u),I}p.parseMetaData=d})(P=e.DataUri||(e.DataUri={}));function b(p,d,g){if(d){let I=p.path;return I&&I[0]!==k.posix.sep&&(I=k.posix.sep+I),p.with({scheme:g,authority:d,path:I})}return p.with({scheme:g})}e.toLocalResource=b}),define(J[9],Z([0,1,24,17,5,2,15]),function(K,e,y,L,k,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function r(z){return!!z&&typeof z.then=="function"}e.isThenable=r;function f(z){const $=new y.CancellationTokenSource,j=z($.token),U=new Promise((q,T)=>{const R=$.token.onCancellationRequested(()=>{R.dispose(),$.dispose(),T((0,L.canceled)())});Promise.resolve(j).then(O=>{R.dispose(),$.dispose(),q(O)},O=>{R.dispose(),$.dispose(),T(O)})});return new class{cancel(){$.cancel()}then(q,T){return U.then(q,T)}catch(q){return this.then(void 0,q)}finally(q){return U.finally(q)}}}e.createCancelablePromise=f;function w(z,$,j){return Promise.race([z,new Promise(U=>$.onCancellationRequested(()=>U(j)))])}e.raceCancellation=w;async function t(z){let $=-1;const j=z.map((q,T)=>q.then(R=>($=T,R))),U=await Promise.race(j);return z.forEach((q,T)=>{T!==$&&q.cancel()}),U}e.raceCancellablePromises=t;function P(z,$,j){let U;const q=setTimeout(()=>{U?.(void 0),j?.()},$);return Promise.race([z.finally(()=>clearTimeout(q)),new Promise(T=>U=T)])}e.raceTimeout=P;function b(z){return new Promise(($,j)=>{const U=z();r(U)?U.then($,j):$(U)})}e.asPromise=b;class p{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue($){if(this.activePromise){if(this.queuedPromiseFactory=$,!this.queuedPromise){const j=()=>{this.queuedPromise=null;const U=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,U};this.queuedPromise=new Promise(U=>{this.activePromise.then(j,j).then(U)})}return new Promise((j,U)=>{this.queuedPromise.then(j,U)})}return this.activePromise=$(),new Promise((j,U)=>{this.activePromise.then(q=>{this.activePromise=null,j(q)},q=>{this.activePromise=null,U(q)})})}}e.Throttler=p;class d{constructor(){this.current=Promise.resolve(null)}queue($){return this.current=this.current.then(()=>$(),()=>$())}}e.Sequencer=d;class g{constructor(){this.promiseMap=new Map}queue($,j){const q=(this.promiseMap.get($)??Promise.resolve()).catch(()=>{}).then(j).finally(()=>{this.promiseMap.get($)===q&&this.promiseMap.delete($)});return this.promiseMap.set($,q),q}}e.SequencerByKey=g;class I{constructor($){this.defaultDelay=$,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger($,j=this.defaultDelay){return this.task=$,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((U,q)=>{this.doResolve=U,this.doReject=q}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const U=this.task;return this.task=null,U()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},j),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=I;class v{constructor($){this.delayer=new I($),this.throttler=new p}trigger($,j){return this.delayer.trigger(()=>this.throttler.queue($),j)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=v;class u{constructor(){this._isOpen=!1,this._promise=new Promise(($,j)=>{this._completePromise=$})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=u;class h extends u{constructor($){super();this._timeout=setTimeout(()=>this.open(),$)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=h;function o(z,$){return $?new Promise((j,U)=>{const q=setTimeout(()=>{T.dispose(),j()},z),T=$.onCancellationRequested(()=>{clearTimeout(q),T.dispose(),U((0,L.canceled)())})}):f(j=>o(z,j))}e.timeout=o;function c(z,$=0){const j=setTimeout(z,$);return(0,D.toDisposable)(()=>clearTimeout(j))}e.disposableTimeout=c;function i(z){const $=[];let j=0;const U=z.length;function q(){return j<U?z[j++]():null}function T(R){R!=null&&$.push(R);const O=q();return O?O.then(T):Promise.resolve($)}return Promise.resolve(null).then(T)}e.sequence=i;function a(z,$=U=>!!U,j=null){let U=0;const q=z.length,T=()=>{if(U>=q)return Promise.resolve(j);const R=z[U++];return Promise.resolve(R()).then(_=>$(_)?Promise.resolve(_):T())};return T()}e.first=a;function n(z,$=U=>!!U,j=null){if(z.length===0)return Promise.resolve(j);let U=z.length;const q=()=>{U=-1;for(const T of z)T.cancel?.()};return new Promise((T,R)=>{for(const O of z)O.then(_=>{--U>=0&&$(_)?(q(),T(_)):U===0&&T(j)}).catch(_=>{--U>=0&&(q(),R(_))})})}e.firstParallel=n;class s{constructor($){this._size=0,this.maxDegreeOfParalellism=$,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new k.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue($){return this._size++,new Promise((j,U)=>{this.outstandingPromises.push({factory:$,c:j,e:U}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const $=this.outstandingPromises.shift();this.runningPromises++;const j=$.factory();j.then($.c,$.e),j.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=s;class l extends s{constructor(){super(1)}}e.Queue=l;class m{constructor(){this.queues=new Map}queueFor($,j=E.extUri){const U=j.getComparisonKey($);let q=this.queues.get(U);return q||(q=new l,k.Event.once(q.onFinished)(()=>{q?.dispose(),this.queues.delete(U)}),this.queues.set(U,q)),q}dispose(){this.queues.forEach($=>$.dispose()),this.queues.clear()}}e.ResourceQueue=m;class S{constructor($,j){this._token=-1,typeof $=="function"&&typeof j=="number"&&this.setIfNotSet($,j)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet($,j){this.cancel(),this._token=setTimeout(()=>{this._token=-1,$()},j)}setIfNotSet($,j){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,$()},j))}}e.TimeoutTimer=S;class M{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet($,j){this.cancel(),this._token=setInterval(()=>{$()},j)}}e.IntervalTimer=M;class A{constructor($,j){this.timeoutToken=-1,this.runner=$,this.timeout=j,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule($=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,$)}get delay(){return this.timeout}set delay($){this.timeout=$}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=A;class F{constructor($,j){j%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${j}ms is not a multiple of 1000ms.`),this.runner=$,this.timeout=j,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule($=this.timeout){$%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${$}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil($/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=F;class C extends A{constructor($,j){super($,j);this.units=[]}work($){this.units.push($),this.isScheduled()||this.schedule()}doRun(){const $=this.units;this.units=[],this.runner&&this.runner($)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=C;class X extends D.Disposable{constructor($,j,U,q){super();this.maxWorkChunkSize=$,this.maxPendingWork=j,this.throttleDelay=U,this.handler=q,this.pendingWork=[],this.throttler=this._register(new D.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work($){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+$.length>this.maxPendingWork)return!1}else if(this.pending+$.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...$),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new A(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=X,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const z=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=$=>{const j=setTimeout(()=>$(z));let U=!1;return{dispose(){U||(U=!0,clearTimeout(j))}}}}else e.runWhenIdle=(z,$)=>{const j=requestIdleCallback(z,typeof $=="number"?{timeout:$}:void 0);let U=!1;return{dispose(){U||(U=!0,cancelIdleCallback(j))}}}}();class ee{constructor($){this._didRun=!1,this._executor=()=>{try{this._value=$()}catch(j){this._error=j}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=ee;async function re(z,$,j){let U;for(let q=0;q<j;q++)try{return await z()}catch(T){U=T,await o($)}throw U}e.retry=re;class Y{hasPending($){return this._pending?typeof $=="number"?this._pending.taskId===$:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending($,j,U){return this._pending={taskId:$,cancel:()=>U?.(),promise:j},j.then(()=>this.donePending($),()=>this.donePending($)),j}donePending($){this._pending&&$===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const $=this._next;this._next=void 0,$.run().then($.promiseResolve,$.promiseReject)}}setNext($){if(this._next)this._next.run=$;else{let j,U;const q=new Promise((T,R)=>{j=T,U=R});this._next={run:$,promise:q,promiseResolve:j,promiseReject:U}}return this._next.promise}}e.TaskSequentializer=Y;class Q{constructor($){this.interval=$,this.lastIncrementTime=0,this.value=0}increment(){const $=Date.now();return $-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=$,this.value=0),this.value++,this.value}}e.IntervalCounter=Q;class W{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise(($,j)=>{this.completeCallback=$,this.errorCallback=j})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete($){return new Promise(j=>{this.completeCallback($),this.resolved=!0,j()})}error($){return new Promise(j=>{this.errorCallback($),this.rejected=!0,j()})}cancel(){new Promise($=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,$()})}}e.DeferredPromise=W;var V;(function(z){async function $(j){let U;const q=await Promise.all(j.map(T=>T.then(R=>R,R=>{U||(U=R)})));if(typeof U!="undefined")throw U;return q}z.settled=$})(V=e.Promises||(e.Promises={}))}),define(J[111],Z([0,1,9,29,37,8,25]),function(K,e,y,L,k,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function r(){return Object.create(null)}e.getEmptyExpression=r;const f="**",w="/",t="[/\\\\]",P="[^/\\\\]",b=/\//g;function p(U){switch(U){case 0:return"";case 1:return`${P}*?`;default:return`(?:${t}|${P}+${t}|${t}${P}+)*?`}}function d(U,q){if(!U)return[];const T=[];let R=!1,O=!1,_="";for(const N of U){switch(N){case q:if(!R&&!O){T.push(_),_="";continue}break;case"{":R=!0;break;case"}":R=!1;break;case"[":O=!0;break;case"]":O=!1;break}_+=N}return _&&T.push(_),T}e.splitGlobAware=d;function g(U){if(!U)return"";let q="";const T=d(U,w);if(T.every(R=>R===f))q=".*";else{let R=!1;T.forEach((O,_)=>{if(O===f){R||(q+=p(2),R=!0);return}let N=!1,B="",H=!1,x="";for(const ie of O){if(ie!=="}"&&N){B+=ie;continue}if(H&&(ie!=="]"||!x)){let ae;ie==="-"?ae=ie:(ie==="^"||ie==="!")&&!x?ae="^":ie===w?ae="":ae=E.escapeRegExpCharacters(ie),x+=ae;continue}switch(ie){case"{":N=!0;continue;case"[":H=!0;continue;case"}":q+=`(?:${d(B,",").map(se=>g(se)).join("|")})`,N=!1,B="";break;case"]":q+="["+x+"]",H=!1,x="";break;case"?":q+=P;continue;case"*":q+=p(1);continue;default:q+=E.escapeRegExpCharacters(ie)}}_<T.length-1&&(T[_+1]!==f||_+2<T.length)&&(q+=t),R=!1})}return q}const I=/^\*\*\/\*\.[\w\.-]+$/,v=/^\*\*\/([\w\.-]+)\/?$/,u=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,h=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new k.LRUCache(1e4),a=function(){return!1},n=function(){return null};function s(U,q){if(!U)return n;let T;typeof U!="string"?T=U.pattern:T=U,T=T.trim();const R=`${T}_${!!q.trimForExclusions}`;let O=i.get(R);if(O)return l(O,U);let _;if(I.test(T)){const N=T.substr(4);O=function(B,H){return typeof B=="string"&&B.endsWith(N)?T:null}}else(_=v.exec(m(T,q)))?O=S(_[1],T):(q.trimForExclusions?h:u).test(T)?O=M(T,q):(_=o.exec(m(T,q)))?O=A(_[1].substr(1),T,!0):(_=c.exec(m(T,q)))?O=A(_[1],T,!1):O=F(T);return i.set(R,O),l(O,U)}function l(U,q){return typeof q=="string"?U:function(T,R){return L.isEqualOrParent(T,q.base)?U(D.relative(q.base,T),R):null}}function m(U,q){return q.trimForExclusions&&U.endsWith("/**")?U.substr(0,U.length-2):U}function S(U,q){const T=`/${U}`,R=`\\${U}`,O=function(N,B){return typeof N!="string"?null:B?B===U?q:null:N===U||N.endsWith(T)||N.endsWith(R)?q:null},_=[U];return O.basenames=_,O.patterns=[q],O.allBasenames=_,O}function M(U,q){const T=j(U.slice(1,-1).split(",").map(B=>s(B,q)).filter(B=>B!==n),U),R=T.length;if(!R)return n;if(R===1)return T[0];const O=function(B,H){for(let x=0,ie=T.length;x<ie;x++)if(T[x](B,H))return U;return null},_=T.find(B=>!!B.allBasenames);_&&(O.allBasenames=_.allBasenames);const N=T.reduce((B,H)=>H.allPaths?B.concat(H.allPaths):B,[]);return N.length&&(O.allPaths=N),O}function A(U,q,T){const R=D.sep===D.posix.sep,O=R?U:U.replace(b,D.sep),_=D.sep+O,N=D.posix.sep+U,B=T?function(H,x){return typeof H=="string"&&(H===O||H.endsWith(_)||!R&&(H===U||H.endsWith(N)))?q:null}:function(H,x){return typeof H=="string"&&(H===O||!R&&H===U)?q:null};return B.allPaths=[(T?"*/":"./")+U],B}function F(U){try{const q=new RegExp(`^${g(U)}$`);return function(T){return q.lastIndex=0,typeof T=="string"&&q.test(T)?U:null}}catch(q){return n}}function C(U,q,T){return!U||typeof q!="string"?!1:X(U)(q,void 0,T)}e.match=C;function X(U,q={}){if(!U)return a;if(typeof U=="string"||Q(U)){const T=s(U,q);if(T===n)return a;const R=function(O,_){return!!T(O,_)};return T.allBasenames&&(R.allBasenames=T.allBasenames),T.allPaths&&(R.allPaths=T.allPaths),R}return z(U,q)}e.parse=X;function ee(U){if(!U)return;let q;return T=>(q||(q=(U()||Promise.resolve([])).then(R=>R?Y(R):{})),q.then(R=>!!R[T]))}e.hasSiblingPromiseFn=ee;function re(U){if(!U)return;let q;return T=>{if(!q){const R=U();q=R?Y(R):{}}return!!q[T]}}e.hasSiblingFn=re;function Y(U){const q={};for(const T of U)q[T]=!0;return q}function Q(U){const q=U;return q&&typeof q.base=="string"&&typeof q.pattern=="string"}e.isRelativePattern=Q;function W(U){return U.allBasenames||[]}e.getBasenameTerms=W;function V(U){return U.allPaths||[]}e.getPathTerms=V;function z(U,q){const T=j(Object.getOwnPropertyNames(U).map(B=>$(B,U[B],q)).filter(B=>B!==n)),R=T.length;if(!R)return n;if(!T.some(B=>!!B.requiresSiblings)){if(R===1)return T[0];const B=function(ie,ae){for(let oe=0,se=T.length;oe<se;oe++){const le=T[oe](ie,ae);if(le)return le}return null},H=T.find(ie=>!!ie.allBasenames);H&&(B.allBasenames=H.allBasenames);const x=T.reduce((ie,ae)=>ae.allPaths?ie.concat(ae.allPaths):ie,[]);return x.length&&(B.allPaths=x),B}const O=function(B,H,x){let ie;for(let ae=0,oe=T.length;ae<oe;ae++){const se=T[ae];se.requiresSiblings&&x&&(H||(H=D.basename(B)),ie||(ie=H.substr(0,H.length-D.extname(B).length)));const le=se(B,H,ie,x);if(le)return le}return null},_=T.find(B=>!!B.allBasenames);_&&(O.allBasenames=_.allBasenames);const N=T.reduce((B,H)=>H.allPaths?B.concat(H.allPaths):B,[]);return N.length&&(O.allPaths=N),O}function $(U,q,T){if(q===!1)return n;const R=s(U,T);if(R===n)return n;if(typeof q=="boolean")return R;if(q){const O=q.when;if(typeof O=="string"){const _=(N,B,H,x)=>{if(!x||!R(N,B))return null;const ie=O.replace("$(basename)",H),ae=x(ie);return(0,y.isThenable)(ae)?ae.then(oe=>oe?U:null):ae?U:null};return _.requiresSiblings=!0,_}}return R}function j(U,q){const T=U.filter(B=>!!B.basenames);if(T.length<2)return U;const R=T.reduce((B,H)=>{const x=H.basenames;return x?B.concat(x):B},[]);let O;if(q){O=[];for(let B=0,H=R.length;B<H;B++)O.push(q)}else O=T.reduce((B,H)=>{const x=H.patterns;return x?B.concat(x):B},[]);const _=function(B,H){if(typeof B!="string")return null;if(!H){let ie;for(ie=B.length;ie>0;ie--){const ae=B.charCodeAt(ie-1);if(ae===47||ae===92)break}H=B.substr(ie)}const x=R.indexOf(H);return x!==-1?O[x]:null};_.basenames=R,_.patterns=O,_.allBasenames=R;const N=U.filter(B=>!B.basenames);return N.push(_),N}}),define(J[33],Z([0,1,29,10,8,3,15,25,7]),function(K,e,y,L,k,D,E,r,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function w(s,l,m){if(typeof s=="string"&&(s=f.URI.file(s)),m){const M=m.getWorkspaceFolder(s);if(M){const A=m.getWorkspace().folders.length>1;let F;if((0,E.isEqual)(M.uri,s)?F="":F=(0,E.relativePath)(M.uri,s),A){const C=M.name?M.name:(0,E.basename)(M.uri);F=F?C+" \u2022 "+F:C}return F}}if(s.scheme!==L.Schemas.file&&s.scheme!==L.Schemas.untitled)return s.with({query:null,fragment:null}).toString(!0);if((0,y.hasDriveLetter)(s.fsPath))return(0,k.normalize)(P(s.fsPath));let S=(0,k.normalize)(s.fsPath);return!D.isWindows&&l?.userHome&&(S=p(S,l.userHome.fsPath)),S}e.getPathLabel=w;function t(s){if(!s)return;typeof s=="string"&&(s=f.URI.file(s));const l=(0,E.basename)(s)||(s.scheme===L.Schemas.file?s.fsPath:s.path);return D.isWindows&&(0,y.isRootOrDriveLetter)(l)?P(l):l}e.getBaseLabel=t;function P(s){return(0,y.hasDriveLetter)(s)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=P;let b=Object.create(null);function p(s,l){if(D.isWindows||!s||!l)return s;let m=b.original===l?b.normalized:void 0;return m||(m=`${(0,r.rtrim)(l,k.posix.sep)}${k.posix.sep}`,b={original:l,normalized:m}),(D.isLinux?s.startsWith(m):(0,r.startsWithIgnoreCase)(s,m))&&(s=`~/${s.substr(m.length)}`),s}e.tildify=p;function d(s,l){return s.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=d;const g="\u2026",I="\\\\",v="~";function u(s,l=k.sep){const m=new Array(s.length);let S=!1;for(let M=0;M<s.length;M++){let A=s[M];if(A===""){m[M]=`.${l}`;continue}if(!A){m[M]=A;continue}S=!0;let F="";A.indexOf(I)===0?(F=A.substr(0,A.indexOf(I)+I.length),A=A.substr(A.indexOf(I)+I.length)):A.indexOf(l)===0?(F=A.substr(0,A.indexOf(l)+l.length),A=A.substr(A.indexOf(l)+l.length)):A.indexOf(v)===0&&(F=A.substr(0,A.indexOf(v)+v.length),A=A.substr(A.indexOf(v)+v.length));const C=A.split(l);for(let X=1;S&&X<=C.length;X++)for(let ee=C.length-X;S&&ee>=0;ee--){S=!1;let re=C.slice(ee,ee+X).join(l);for(let Y=0;!S&&Y<s.length;Y++)if(Y!==M&&s[Y]&&s[Y].indexOf(re)>-1){const Q=ee+X===C.length,W=ee>0&&s[Y].indexOf(l)>-1?l+re:re,V=s[Y].endsWith(W);S=!Q||V}if(!S){let Y="";(C[0].endsWith(":")||F!=="")&&(ee===1&&(ee=0,X++,re=C[0]+l+re),ee>0&&(Y=C[0]+l),Y=F+Y),ee>0&&(Y=Y+g+l),Y=Y+re,ee+X<C.length&&(Y=Y+l+g),m[M]=Y}}S&&(m[M]=A)}return m}e.shorten=u;var h;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function o(s,l=Object.create(null)){const m=[];let S=!1,M="";for(const A of s)if(A==="$"||S&&A==="{")M&&m.push({value:M,type:h.TEXT}),M="",S=!0;else if(A==="}"&&S){const F=l[M];if(typeof F=="string")F.length&&m.push({value:F,type:h.VARIABLE});else if(F){const C=m[m.length-1];(!C||C.type!==h.SEPARATOR)&&m.push({value:F.label,type:h.SEPARATOR})}M="",S=!1}else M+=A;return M&&!S&&m.push({value:M,type:h.TEXT}),m.filter((A,F)=>{if(A.type===h.SEPARATOR){const C=m[F-1],X=m[F+1];return[C,X].every(ee=>ee&&(ee.type===h.VARIABLE||ee.type===h.TEXT)&&ee.value.length>0)}return!0}).map(A=>A.value).join("")}e.template=o;function c(s,l){return D.isMacintosh||l?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.isMacintosh?"&":"&&"):s.replace(/&&|&/g,m=>m==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function i(s,l){return D.isMacintosh||l?s.replace(/\(&&\w\)|&&/g,""):D.isWindows?s.replace(/&&|&/g,m=>m==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=i;function a(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=a;function n(s){const l=s.indexOf("/")!==-1?k.posix:k.win32,m=l.basename(s),S=l.dirname(s);return m.length?{name:m,parentPath:S}:{name:S,parentPath:""}}e.splitName=n}),define(J[28],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(f){return y.test(f)}e.isUUID=L;const k=new Uint8Array(16),D=[];for(let f=0;f<256;f++)D.push(f.toString(16).padStart(2,"0"));let E;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?E=crypto.getRandomValues.bind(crypto):E=function(f){for(let w=0;w<f.length;w++)f[w]=Math.floor(Math.random()*256);return f};function r(){E(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let f=0,w="";return w+=D[k[f++]],w+=D[k[f++]],w+=D[k[f++]],w+=D[k[f++]],w+="-",w+=D[k[f++]],w+=D[k[f++]],w+="-",w+=D[k[f++]],w+=D[k[f++]],w+="-",w+=D[k[f++]],w+=D[k[f++]],w+="-",w+=D[k[f++]],w+=D[k[f++]],w+=D[k[f++]],w+=D[k[f++]],w+=D[k[f++]],w+=D[k[f++]],w}e.generateUuid=r}),define(J[112],Z([0,1,58,30,43]),function(K,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function D(E,r){if(await new Promise((t,P)=>{const b=L.createReadStream(E),p=y.createHash("sha1");b.pipe(p);const d=(0,k.once)((g,I)=>{b.removeAllListeners(),p.removeAllListeners(),g?P(g):t(I)});b.once("error",d),b.once("end",d),p.once("error",d),p.once("data",g=>d(void 0,g.toString("hex")))})!==r)throw new Error("Hash mismatch")}e.checksum=D}),define(J[80],Z([0,1,239]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(D="utf8"){this.stringDecoder=new y.StringDecoder(D),this.remaining=null}write(D){const E=[],r=this.remaining?this.remaining+this.stringDecoder.write(D):this.stringDecoder.write(D);if(r.length<1)return E;let f=0,w,t=f;for(;t<r.length;)if(w=r.charCodeAt(t),w===13||w===10){if(E.push(r.substring(f,t)),t++,t<r.length){const P=w;w=r.charCodeAt(t),(P===13&&w===10||P===10&&w===13)&&t++}f=t}else t++;return this.remaining=f<r.length?r.substr(f):null,E}end(){return this.remaining}}e.LineDecoder=L}),define(J[113],Z([0,1,26]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(r){const f=r.replace(/\-/g,":").toLowerCase();return!L.has(f)}function D(){return new Promise(async(r,f)=>{const w=setTimeout(()=>f("Unable to retrieve mac address (timeout after 10s)"),1e4);try{r(await E())}catch(t){f(t)}finally{clearTimeout(w)}})}e.getMac=D;function E(){return new Promise((r,f)=>{try{const w=(0,y.networkInterfaces)();for(let t in w){const P=w[t];if(P){for(const{mac:b}of P)if(k(b))return r(b)}}f("Unable to retrieve mac address (unexpected format)")}catch(w){f(w)}})}}),define(J[66],Z([0,1,26,17,37,28,113]),function(K,e,y,L,k,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(t){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(t)}value(){if(this._value===void 0){let t=0,P=0;const b=(0,y.networkInterfaces)();for(let p in b){const d=b[p];if(d)for(const{mac:g,internal:I}of d)I||(P+=1,this._isVirtualMachineMacAddress(g.toUpperCase())&&(t+=1))}this._value=P>0?t/P:0}return this._value}};let r;async function f(){return r||(r=(async()=>await w()||D.generateUuid())()),r}e.getMachineId=f;async function w(){try{const t=await new Promise((b,p)=>{K(["crypto"],b,p)}),P=await(0,E.getMac)();return t.createHash("sha256").update(P,"utf8").digest("hex")}catch(t){L.onUnexpectedError(t);return}}}),define(J[19],Z([0,1,30,26,114,9,29,65,8,3,15,7,28]),function(K,e,y,L,k,D,E,r,f,w,t,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(W){W[W.UNLINK=0]="UNLINK",W[W.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function d(W,V=p.UNLINK){if((0,E.isRootOrDriveLetter)(W))throw new Error("rimraf - will refuse to recursively delete root");return V===p.UNLINK?I(W):g(W)}async function g(W){try{const V=(0,f.join)((0,L.tmpdir)(),(0,b.generateUuid)());try{await e.Promises.rename(W,V)}catch(z){return I(W)}I(V).catch(z=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function I(W){return e.Promises.rmdir(W,{recursive:!0,maxRetries:3})}function v(W){if((0,E.isRootOrDriveLetter)(W))throw new Error("rimraf - will refuse to recursively delete root");y.rmdirSync(W,{recursive:!0})}e.rimrafSync=v;async function u(W,V){return c(await(V?h(W):(0,k.promisify)(y.readdir)(W)))}async function h(W){try{return await(0,k.promisify)(y.readdir)(W,{withFileTypes:!0})}catch($){console.warn("[node.js fs] readdir with filetypes failed with error: ",$)}const V=[],z=await u(W);for(const $ of z){let j=!1,U=!1,q=!1;try{const T=await e.Promises.lstat((0,f.join)(W,$));j=T.isFile(),U=T.isDirectory(),q=T.isSymbolicLink()}catch(T){console.warn("[node.js fs] unexpected error from lstat after readdir: ",T)}V.push({name:$,isFile:()=>j,isDirectory:()=>U,isSymbolicLink:()=>q})}return V}function o(W){return c(y.readdirSync(W))}e.readdirSync=o;function c(W){return W.map(V=>typeof V=="string"?w.isMacintosh?(0,r.normalizeNFC)(V):V:(V.name=w.isMacintosh?(0,r.normalizeNFC)(V.name):V.name,V))}async function i(W){const V=await u(W),z=[];for(const $ of V)await n.existsDirectory((0,f.join)(W,$))&&z.push($);return z}function a(W,V=1e3){return new Promise(z=>{let $=!1;const j=setInterval(()=>{$||($=!0,y.access(W,U=>{$=!1,U&&(clearInterval(j),z(void 0))}))},V)})}e.whenDeleted=a;var n;(function(W){async function V(j){let U;try{if(U=await e.Promises.lstat(j),!U.isSymbolicLink())return{stat:U}}catch(q){}try{return{stat:await e.Promises.stat(j),symbolicLink:U?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};if(w.isWindows&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(j)),symbolicLink:{dangling:!1}}}catch(T){if(T.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};throw T}throw q}}W.stat=V;async function z(j){try{const{stat:U,symbolicLink:q}=await W.stat(j);return U.isFile()&&q?.dangling!==!0}catch(U){}return!1}W.existsFile=z;async function $(j){try{const{stat:U,symbolicLink:q}=await W.stat(j);return U.isDirectory()&&q?.dangling!==!0}catch(U){}return!1}W.existsDirectory=$})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new D.ResourceQueue;function l(W,V,z){return s.queueFor(P.URI.file(W),t.extUriBiasedIgnorePathCase).queue(()=>{const $=A(z);return new Promise((j,U)=>S(W,V,$,q=>q?U(q):j()))})}let m=!0;function S(W,V,z,$){if(!m)return y.writeFile(W,V,{mode:z.mode,flag:z.flag},$);y.open(W,z.flag,z.mode,(j,U)=>{if(j)return $(j);y.writeFile(U,V,q=>{if(q)return y.close(U,()=>$(q));y.fdatasync(U,T=>(T&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",T),m=!1),y.close(U,R=>$(R))))})})}function M(W,V,z){const $=A(z);if(!m)return y.writeFileSync(W,V,{mode:$.mode,flag:$.flag});const j=y.openSync(W,$.flag,$.mode);try{y.writeFileSync(j,V);try{y.fdatasyncSync(j)}catch(U){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",U),m=!1}}finally{y.closeSync(j)}}e.writeFileSync=M;function A(W){return W?{mode:typeof W.mode=="number"?W.mode:438,flag:typeof W.flag=="string"?W.flag:"w"}:{mode:438,flag:"w"}}async function F(W,V){if(W===V)return;async function z($){try{const j=await e.Promises.lstat($);if(j.isDirectory()||j.isSymbolicLink())return;await e.Promises.utimes($,j.atime,new Date)}catch(j){}}try{await e.Promises.rename(W,V),await z(V)}catch($){if(W.toLowerCase()!==V.toLowerCase()&&$.code==="EXDEV"||W.endsWith("."))await C(W,V,{preserveSymlinks:!1}),await d(W,p.MOVE),await z(V);else throw $}}async function C(W,V,z){return ee(W,V,{root:{source:W,target:V},options:z,handledSourcePaths:new Set})}const X=511;async function ee(W,V,z){if(z.handledSourcePaths.has(W))return;z.handledSourcePaths.add(W);const{stat:$,symbolicLink:j}=await n.stat(W);if(j){if(z.options.preserveSymlinks)try{return await Q(W,V,z)}catch(U){console.warn("[node.js fs] copy of symlink failed: ",U)}if(j.dangling)return}return $.isDirectory()?re(W,V,$.mode&X,z):Y(W,V,$.mode&X)}async function re(W,V,z,$){await e.Promises.mkdir(V,{recursive:!0,mode:z});const j=await u(W);for(const U of j)await ee((0,f.join)(W,U),(0,f.join)(V,U),$)}async function Y(W,V,z){await e.Promises.copyFile(W,V),await e.Promises.chmod(V,z)}async function Q(W,V,z){let $=await e.Promises.readlink(W);(0,E.isEqualOrParent)($,z.root.source,!w.isLinux)&&($=(0,f.join)(z.root.target,$.substr(z.root.source.length+1))),await e.Promises.symlink($,V)}e.Promises=new class{get access(){return(0,k.promisify)(y.access)}get stat(){return(0,k.promisify)(y.stat)}get lstat(){return(0,k.promisify)(y.lstat)}get utimes(){return(0,k.promisify)(y.utimes)}get read(){return(0,k.promisify)(y.read)}get readFile(){return(0,k.promisify)(y.readFile)}get write(){return(0,k.promisify)(y.write)}get appendFile(){return(0,k.promisify)(y.appendFile)}get fdatasync(){return(0,k.promisify)(y.fdatasync)}get truncate(){return(0,k.promisify)(y.truncate)}get rename(){return(0,k.promisify)(y.rename)}get copyFile(){return(0,k.promisify)(y.copyFile)}get open(){return(0,k.promisify)(y.open)}get close(){return(0,k.promisify)(y.close)}get symlink(){return(0,k.promisify)(y.symlink)}get readlink(){return(0,k.promisify)(y.readlink)}get chmod(){return(0,k.promisify)(y.chmod)}get mkdir(){return(0,k.promisify)(y.mkdir)}get unlink(){return(0,k.promisify)(y.unlink)}get rmdir(){return(0,k.promisify)(y.rmdir)}get realpath(){return(0,k.promisify)(y.realpath)}async exists(W){try{return await e.Promises.access(W),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return i}get writeFile(){return l}get rm(){return d}get move(){return F}get copy(){return C}}}),define(J[81],Z([0,1,30,8,25,19]),function(K,e,y,L,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function E(t){const P=(0,L.dirname)(t);if(t===P)return t;const b=((0,L.basename)(t)||t).toLowerCase();try{const d=(0,D.readdirSync)(P).filter(g=>g.toLowerCase()===b);if(d.length===1){const g=E(P);if(g)return(0,L.join)(g,d[0])}else if(d.length>1){const g=d.indexOf(b);if(g>=0){const I=E(P);if(I)return(0,L.join)(I,d[g])}}}catch(p){}return null}e.realcaseSync=E;async function r(t){try{return await D.Promises.realpath(t)}catch(P){const b=w(t);return await D.Promises.access(b,y.constants.R_OK),b}}e.realpath=r;function f(t){try{return y.realpathSync(t)}catch(P){const b=w(t);return y.accessSync(b,y.constants.R_OK),b}}e.realpathSync=f;function w(t){return(0,k.rtrim)((0,L.normalize)(t),L.sep)}}),define(J[115],Z([0,1,59]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function L(r,f,w,t=1){let P=!1;return new Promise(b=>{const p=setTimeout(()=>{if(!P)return P=!0,b(0)},w);k(r,f,t,d=>{if(!P)return P=!0,clearTimeout(p),b(d)})})}e.findFreePort=L;function k(r,f,w,t){if(f===0)return t(0);const P=new y.Socket;P.once("connect",()=>(E(P),k(r+w,f-1,w,t))),P.once("data",()=>{}),P.once("error",b=>(E(P),b.code!=="ECONNREFUSED"?k(r+w,f-1,w,t):t(r))),P.connect(r,"127.0.0.1")}function D(r,f,w){let t=!1,P,b=1;const p=y.createServer({pauseOnConnect:!0});function d(g,I){t||(t=!0,p.removeAllListeners(),p.close(),P&&clearTimeout(P),I(g))}return new Promise(g=>{P=setTimeout(()=>{d(0,g)},w),p.on("listening",()=>{d(r,g)}),p.on("error",I=>{I&&(I.code==="EADDRINUSE"||I.code==="EACCES")&&b<f?(r++,b++,p.listen(r,"127.0.0.1")):d(0,g)}),p.on("close",()=>{d(0,g)}),p.listen(r,"127.0.0.1")})}e.findFreePortFaster=D;function E(r){try{r.removeAllListeners("connect"),r.removeAllListeners("error"),r.end(),r.destroy(),r.unref()}catch(f){console.error(f)}}}),define(J[116],Z([0,1,26,8,19]),function(K,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const D=/^\d+$/,E=/^Microsoft.PowerShell_.*/,r=/^Microsoft.PowerShellPreview_.*/;var f;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(f||(f={}));let w;switch(process.arch){case"ia32":case"x32":w=1;break;case"arm":case"arm64":w=2;break;default:w=0;break}let t;process.env.PROCESSOR_ARCHITEW6432?t=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?t=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?t=1:t=0;class P{constructor(c,i,a){this.exePath=c,this.displayName=i,this.knownToExist=a}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function b({useAlternateBitness:o=!1}={}){return o?w===0?process.env["ProgramFiles(x86)"]||null:t===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:o=!1,findPreview:c=!1}={}){const i=b({useAlternateBitness:o});if(!i)return null;const a=L.join(i,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(a))return null;let n=-1,s=null;for(const S of await k.Promises.readdir(a)){let M=-1;if(c){const F=S.indexOf("-");if(F<0)continue;const C=S.substring(0,F);if(!D.test(C)||S.substring(F+1)!=="preview")continue;M=parseInt(C,10)}else{if(!D.test(S))continue;M=parseInt(S,10)}if(M<=n)continue;const A=L.join(a,S,"pwsh.exe");!await k.SymlinkSupport.existsFile(A)||(s=A,n=M)}if(!s)return null;const l=i.includes("x86")?" (x86)":"",m=c?" Preview":"";return new P(s,`PowerShell${m}${l}`,!0)}async function d({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const c=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:i,pwshMsixName:a}=o?{pwshMsixDirRegex:r,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:E,pwshMsixName:"PowerShell (Store)"};for(const n of await k.Promises.readdir(c))if(i.test(n)){const s=L.join(c,n,"pwsh.exe");return new P(s,a)}return null}function g(){const o=L.join(y.homedir(),".dotnet","tools","pwsh.exe");return new P(o,".NET Core PowerShell Global Tool")}function I(){const o=L.join(process.env.windir,w===1&&t!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new P(o,"Windows PowerShell",!0)}async function*v(){let o=await p();o&&(yield o),o=await p({useAlternateBitness:!0}),o&&(yield o),o=await d(),o&&(yield o),o=g(),o&&(yield o),o=await p({findPreview:!0}),o&&(yield o),o=await d({findPreview:!0}),o&&(yield o),o=await p({useAlternateBitness:!0,findPreview:!0}),o&&(yield o),o=I(),o&&(yield o)}async function*u(){for await(const o of v())await o.exists()&&(yield o)}e.enumeratePowerShellInstallations=u;async function h(){for await(const o of u())return o;return null}e.getFirstAvailablePowerShellInstallation=h}),define(J[82],Z([0,1,41,10]),function(K,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(E){return new Promise((r,f)=>{let w;const t=new Map;function P(p,d,g,I,v){const u=t.get(d);if(p===E||u){const h={name:b(g),cmd:g,pid:p,ppid:d,load:I,mem:v};t.set(p,h),p===E&&(w=h),u&&(u.children||(u.children=[]),u.children.push(h),u.children.length>1&&(u.children=u.children.sort((o,c)=>o.pid-c.pid)))}}function b(p){const d=/--disable-blink-features=Auxclick/,g=/\\watcher\\win32\\CodeHelper\.exe/,I=/--crashes-directory/,v=/\\pipe\\winpty-control/,u=/conhost\.exe/,h=/--type=([a-zA-Z-]+)/;if(g.exec(p))return"watcherService ";if(I.exec(p))return"electron-crash-reporter";if(v.exec(p))return"winpty-process";if(u.exec(p))return"console-window-host (Windows internal process)";let o=h.exec(p);if(o&&o.length===2)return o[1]==="renderer"?d.exec(p)?"shared-process":"window":o[1];const c=/[a-zA-Z-]+\.js/g;let i="";do o=c.exec(p),o&&(i+=o+" ");while(o);return i&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron_node ${i}`:p}if(process.platform==="win32"){const p=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,g)=>{K(["windows-process-tree"],d,g)}).then(d=>{d.getProcessList(E,g=>{d.getProcessCpuUsage(g,I=>{const v=new Map;I.forEach(u=>{const h=p(u.commandLine||"");v.set(u.pid,{name:b(h),cmd:h,pid:u.pid,ppid:u.ppid,load:u.cpu||0,mem:u.memory||0})}),w=v.get(E),w?(v.forEach(u=>{const h=v.get(u.ppid);h&&(h.children||(h.children=[]),h.children.push(u))}),v.forEach(u=>{u.children&&(u.children=u.children.sort((h,o)=>h.pid-o.pid))}),r(w)):f(new Error(`Root process ${E} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let p=function(){let d=[w];const g=[];for(;d.length;){const v=d.shift();v&&(g.push(v.pid),v.children&&(d=d.concat(v.children)))}let I=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",K).fsPath);I+=" "+g.join(" "),(0,y.exec)(I,{},(v,u,h)=>{if(v||h)f(v||new Error(h.toString()));else{const o=u.toString().split(`
`);for(let c=0;c<g.length;c++){const i=t.get(g[c]);i.load=parseFloat(o[c])}if(!w){f(new Error(`Root process ${E} not found`));return}r(w)}})};(0,y.exec)("which ps",{},(d,g,I)=>{if(d||I)if(process.platform!=="linux")f(d||new Error(I.toString()));else{const v=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",K).fsPath);(0,y.exec)(v,{},(u,h,o)=>{u||o?f(u||new Error(o.toString())):(D(h,P),p())})}else{const v=g.toString().trim(),u="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,y.exec)(`${v} ${u}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(h,o,c)=>{h||c&&!c.includes("screen size is bogus")?f(h||new Error(c.toString())):(D(o,P),process.platform==="linux"?p():w?r(w):f(new Error(`Root process ${E} not found`)))})}})}})}e.listProcesses=k;function D(E,r){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,w=E.toString().split(`
`);for(const t of w){const P=f.exec(t.trim());P&&P.length===6&&r(parseInt(P[1]),parseInt(P[2]),P[5],parseFloat(P[3]),parseFloat(P[4]))}}}),define(J[117],Z([0,1,30,29,2,65,8,3,19]),function(K,e,y,L,k,D,E,r,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function w(b,p,d){return P({path:b,isDirectory:!1},p,d)}e.watchFile=w;function t(b,p,d){return P({path:b,isDirectory:!0},p,d)}e.watchFolder=t,e.CHANGE_BUFFER_DELAY=100;function P(b,p,d){if(r.isMacintosh&&(0,L.isEqualOrParent)(b.path,"/Volumes/"))return d(`Refusing to watch ${b.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),k.Disposable.None;const g=(0,E.basename)(b.path),I=new Map;let v=!1,u=[(0,k.toDisposable)(()=>{I.forEach(h=>(0,k.dispose)(h)),I.clear()})];try{const h=(0,y.watch)(b.path);u.push((0,k.toDisposable)(()=>{h.removeAllListeners(),h.close()}));const o=new Set;b.isDirectory&&f.Promises.readdir(b.path).then(c=>c.forEach(i=>o.add(i))),h.on("error",(c,i)=>{v||d(`Failed to watch ${b.path} for changes using fs.watch() (${c}, ${i})`)}),h.on("change",(c,i)=>{if(v)return;let a="";if(i&&(a=i.toString(),r.isMacintosh&&(a=(0,D.normalizeNFC)(a))),!a||c!=="change"&&c!=="rename")return;const n=b.isDirectory?(0,E.join)(b.path,a):b.path;if(b.isDirectory)if(c==="rename"){const s=I.get(n);s&&(0,k.dispose)(s);const l=setTimeout(async()=>{I.delete(n);const m=await f.Promises.exists(n);if(v)return;let S;m?o.has(a)?S="changed":(S="added",o.add(a)):(o.delete(a),S="deleted"),p(S,n)},e.CHANGE_BUFFER_DELAY);I.set(n,(0,k.toDisposable)(()=>clearTimeout(l)))}else{let s;o.has(a)?s="changed":(s="added",o.add(a)),p(s,n)}else if(c==="rename"||a!==g){const s=setTimeout(async()=>{const l=await f.Promises.exists(n);v||(l?(p("changed",n),u=[P(b,p,d)]):p("deleted",n))},e.CHANGE_BUFFER_DELAY);(0,k.dispose)(u),u=[(0,k.toDisposable)(()=>clearTimeout(s))]}else p("changed",n)})}catch(h){f.Promises.exists(b.path).then(o=>{o&&!v&&d(`Failed to watch ${b.path} for changes using fs.watch() (${h.toString()})`)})}return(0,k.toDisposable)(()=>{v=!0,u=(0,k.dispose)(u)})}}),define(J[118],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(J[119],Z([0,1,14,13,118]),function(K,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function D(){y.ipcMain.on(k.CONTEXT_MENU_CHANNEL,(r,f,w,t,P)=>{const b=E(r,t,w);b.popup({window:(0,L.withNullAsUndefined)(y.BrowserWindow.fromWebContents(r.sender)),x:P?P.x:void 0,y:P?P.y:void 0,positioningItem:P?P.positioningItem:void 0,callback:()=>{b&&r.sender.send(k.CONTEXT_MENU_CLOSE_CHANNEL,f)}})})}e.registerContextMenuListener=D;function E(r,f,w){const t=new y.Menu;return w.forEach(P=>{let b;P.type==="separator"?b=new y.MenuItem({type:P.type}):Array.isArray(P.submenu)?b=new y.MenuItem({submenu:E(r,f,P.submenu),label:P.label}):b=new y.MenuItem({label:P.label,type:P.type,accelerator:P.accelerator,checked:P.checked,enabled:P.enabled,visible:P.visible,click:(p,d,g)=>r.sender.send(f,P.id,g)}),t.append(b)}),t}});var ue=this&&this.__decorate||function(K,e,y,L){var k=arguments.length,D=k<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,y):L,E;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(K,e,y,L);else for(var r=K.length-1;r>=0;r--)(E=K[r])&&(D=(k<3?E(D):k>3?E(e,y,D):E(e,y))||D);return k>3&&D&&Object.defineProperty(e,y,D),D};define(J[35],Z([0,1,31,9,18,24,46,17,5,2,110,25,13]),function(K,e,y,L,k,D,E,r,f,w,t,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function(j){j[j.Promise=100]="Promise",j[j.PromiseCancel=101]="PromiseCancel",j[j.EventListen=102]="EventListen",j[j.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function d(j){switch(j){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(j){j[j.Initialize=200]="Initialize",j[j.PromiseSuccess=201]="PromiseSuccess",j[j.PromiseError=202]="PromiseError",j[j.PromiseErrorObj=203]="PromiseErrorObj",j[j.EventFire=204]="EventFire"})(g=e.ResponseType||(e.ResponseType={}));function I(j){switch(j){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var v;(function(j){j[j.Uninitialized=0]="Uninitialized",j[j.Idle=1]="Idle"})(v||(v={}));class u{constructor(U){this.buffer=U,this.pos=0}read(U){const q=this.buffer.slice(this.pos,this.pos+U);return this.pos+=q.byteLength,q}}class h{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(U){this.buffers.push(U)}}var o;(function(j){j[j.Undefined=0]="Undefined",j[j.String=1]="String",j[j.Buffer=2]="Buffer",j[j.VSBuffer=3]="VSBuffer",j[j.Array=4]="Array",j[j.Object=5]="Object"})(o||(o={}));function c(j){const U=k.VSBuffer.alloc(4);return U.writeUInt32BE(j,0),U}function i(j){return j.read(4).readUInt32BE(0)}function a(j){const U=k.VSBuffer.alloc(1);return U.writeUInt8(j,0),U}const n={Undefined:a(o.Undefined),String:a(o.String),Buffer:a(o.Buffer),VSBuffer:a(o.VSBuffer),Array:a(o.Array),Object:a(o.Object)},s=typeof Buffer!="undefined";function l(j,U){if(typeof U=="undefined")j.write(n.Undefined);else if(typeof U=="string"){const q=k.VSBuffer.fromString(U);j.write(n.String),j.write(c(q.byteLength)),j.write(q)}else if(s&&Buffer.isBuffer(U)){const q=k.VSBuffer.wrap(U);j.write(n.Buffer),j.write(c(q.byteLength)),j.write(q)}else if(U instanceof k.VSBuffer)j.write(n.VSBuffer),j.write(c(U.byteLength)),j.write(U);else if(Array.isArray(U)){j.write(n.Array),j.write(c(U.length));for(const q of U)l(j,q)}else{const q=k.VSBuffer.fromString(JSON.stringify(U));j.write(n.Object),j.write(c(q.byteLength)),j.write(q)}}function m(j){switch(j.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return j.read(i(j)).toString();case o.Buffer:return j.read(i(j)).buffer;case o.VSBuffer:return j.read(i(j));case o.Array:{const q=i(j),T=[];for(let R=0;R<q;R++)T.push(m(j));return T}case o.Object:return JSON.parse(j.read(i(j)).toString())}}class S{constructor(U,q,T=null,R=1e3){this.protocol=U,this.ctx=q,this.logger=T,this.timeoutDelay=R,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(O=>this.onRawMessage(O)),this.sendResponse({type:200})}registerChannel(U,q){this.channels.set(U,q),setTimeout(()=>this.flushPendingRequests(U),0)}sendResponse(U){switch(U.type){case 200:{const q=this.send([U.type]);this.logger&&this.logger.logOutgoing(q,0,1,I(U.type));return}case 201:case 202:case 204:case 203:{const q=this.send([U.type,U.id],U.data);this.logger&&this.logger.logOutgoing(q,U.id,1,I(U.type),U.data);return}}}send(U,q=void 0){const T=new h;return l(T,U),l(T,q),this.sendBuffer(T.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch(q){return 0}}onRawMessage(U){const q=new u(U),T=m(q),R=m(q),O=T[0];switch(O){case 100:return this.logger&&this.logger.logIncoming(U.byteLength,T[1],1,`${d(O)}: ${T[2]}.${T[3]}`,R),this.onPromise({type:O,id:T[1],channelName:T[2],name:T[3],arg:R});case 102:return this.logger&&this.logger.logIncoming(U.byteLength,T[1],1,`${d(O)}: ${T[2]}.${T[3]}`,R),this.onEventListen({type:O,id:T[1],channelName:T[2],name:T[3],arg:R});case 101:return this.logger&&this.logger.logIncoming(U.byteLength,T[1],1,`${d(O)}`),this.disposeActiveRequest({type:O,id:T[1]});case 103:return this.logger&&this.logger.logIncoming(U.byteLength,T[1],1,`${d(O)}`),this.disposeActiveRequest({type:O,id:T[1]})}}onPromise(U){const q=this.channels.get(U.channelName);if(!q){this.collectPendingRequest(U);return}const T=new D.CancellationTokenSource;let R;try{R=q.call(this.ctx,U.name,U.arg,T.token)}catch(N){R=Promise.reject(N)}const O=U.id;R.then(N=>{this.sendResponse({id:O,data:N,type:201}),this.activeRequests.delete(U.id)},N=>{N instanceof Error?this.sendResponse({id:O,data:{message:N.message,name:N.name,stack:N.stack?N.stack.split?N.stack.split(`
`):N.stack:void 0},type:202}):this.sendResponse({id:O,data:N,type:203}),this.activeRequests.delete(U.id)});const _=(0,w.toDisposable)(()=>T.cancel());this.activeRequests.set(U.id,_)}onEventListen(U){const q=this.channels.get(U.channelName);if(!q){this.collectPendingRequest(U);return}const T=U.id,O=q.listen(this.ctx,U.name,U.arg)(_=>this.sendResponse({id:T,data:_,type:204}));this.activeRequests.set(U.id,O)}disposeActiveRequest(U){const q=this.activeRequests.get(U.id);q&&(q.dispose(),this.activeRequests.delete(U.id))}collectPendingRequest(U){let q=this.pendingRequests.get(U.channelName);q||(q=[],this.pendingRequests.set(U.channelName,q));const T=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.sendResponse({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);q.push({request:U,timeoutTimer:T})}flushPendingRequests(U){const q=this.pendingRequests.get(U);if(q){for(const T of q)switch(clearTimeout(T.timeoutTimer),T.request.type){case 100:this.onPromise(T.request);break;case 102:this.onEventListen(T.request);break}this.pendingRequests.delete(U)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(U=>U.dispose()),this.activeRequests.clear()}}e.ChannelServer=S;var M;(function(j){j[j.LocalSide=0]="LocalSide",j[j.OtherSide=1]="OtherSide"})(M=e.RequestInitiator||(e.RequestInitiator={}));class A{constructor(U,q=null){this.protocol=U,this.isDisposed=!1,this.state=v.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new f.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(T=>this.onBuffer(T)),this.logger=q}getChannel(U){const q=this;return{call(T,R,O){return q.isDisposed?Promise.reject(r.canceled()):q.requestPromise(U,T,R,O)},listen(T,R){return q.isDisposed?Promise.reject(r.canceled()):q.requestEvent(U,T,R)}}}requestPromise(U,q,T,R=D.CancellationToken.None){const O=this.lastRequestId++,N={id:O,type:100,channelName:U,name:q,arg:T};if(R.isCancellationRequested)return Promise.reject(r.canceled());let B;return new Promise((x,ie)=>{if(R.isCancellationRequested)return ie(r.canceled());const ae=()=>{const de=ge=>{switch(ge.type){case 201:this.handlers.delete(O),x(ge.data);break;case 202:this.handlers.delete(O);const ve=new Error(ge.data.message);ve.stack=ge.data.stack,ve.name=ge.data.name,ie(ve);break;case 203:this.handlers.delete(O),ie(ge.data);break}};this.handlers.set(O,de),this.sendRequest(N)};let oe=null;this.state===v.Idle?ae():(oe=(0,L.createCancelablePromise)(de=>this.whenInitialized()),oe.then(()=>{oe=null,ae()}));const se=()=>{oe?(oe.cancel(),oe=null):this.sendRequest({id:O,type:101}),ie(r.canceled())},le=R.onCancellationRequested(se);B=(0,w.combinedDisposable)((0,w.toDisposable)(se),le),this.activeRequests.add(B)}).finally(()=>{this.activeRequests.delete(B)})}requestEvent(U,q,T){const R=this.lastRequestId++,_={id:R,type:102,channelName:U,name:q,arg:T};let N=null;const B=new f.Emitter({onFirstListenerAdd:()=>{N=(0,L.createCancelablePromise)(x=>this.whenInitialized()),N.then(()=>{N=null,this.activeRequests.add(B),this.sendRequest(_)})},onLastListenerRemove:()=>{N?(N.cancel(),N=null):(this.activeRequests.delete(B),this.sendRequest({id:R,type:103}))}}),H=x=>B.fire(x.data);return this.handlers.set(R,H),B.event}sendRequest(U){switch(U.type){case 100:case 102:{const q=this.send([U.type,U.id,U.channelName,U.name],U.arg);this.logger&&this.logger.logOutgoing(q,U.id,0,`${d(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const q=this.send([U.type,U.id]);this.logger&&this.logger.logOutgoing(q,U.id,0,d(U.type));return}}}send(U,q=void 0){const T=new h;return l(T,U),l(T,q),this.sendBuffer(T.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch(q){return 0}}onBuffer(U){const q=new u(U),T=m(q),R=m(q),O=T[0];switch(O){case 200:return this.logger&&this.logger.logIncoming(U.byteLength,0,0,I(O)),this.onResponse({type:T[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(U.byteLength,T[1],0,I(O),R),this.onResponse({type:T[0],id:T[1],data:R})}}onResponse(U){if(U.type===200){this.state=v.Idle,this._onDidInitialize.fire();return}const q=this.handlers.get(U.id);q&&q(U)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===v.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(U=>U.dispose()),this.activeRequests.clear()}}ue([E.memoize],A.prototype,"onDidInitializePromise",null),e.ChannelClient=A;class F{constructor(U){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new f.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new f.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,U(({protocol:q,onDidClientDisconnect:T})=>{f.Event.once(q.onMessage)(O=>{const _=new u(O),N=m(_),B=new S(q,N),H=new A(q);this.channels.forEach((ie,ae)=>B.registerChannel(ae,ie));const x={channelServer:B,channelClient:H,ctx:N};this._connections.add(x),this._onDidAddConnection.fire(x),T(()=>{B.dispose(),H.dispose(),this._connections.delete(x),this._onDidRemoveConnection.fire(x)})})})}get connections(){const U=[];return this._connections.forEach(q=>U.push(q)),U}getChannel(U,q){const T=this;return{call(R,O,_){let N;if((0,b.isFunction)(q)){let H=(0,y.getRandomElement)(T.connections.filter(q));N=H?Promise.resolve(H):f.Event.toPromise(f.Event.filter(T.onDidAddConnection,q))}else N=q.routeCall(T,R,O);const B=N.then(H=>H.channelClient.getChannel(U));return X(B).call(R,O,_)},listen(R,O){if((0,b.isFunction)(q))return T.getMulticastEvent(U,q,R,O);const _=q.routeEvent(T,R,O).then(N=>N.channelClient.getChannel(U));return X(_).listen(R,O)}}}getMulticastEvent(U,q,T,R){const O=this;let _=new w.DisposableStore;const N=new f.Emitter({onFirstListenerAdd:()=>{_=new w.DisposableStore;const B=new f.EventMultiplexer,H=new Map,x=ae=>{const se=ae.channelClient.getChannel(U).listen(T,R),le=B.add(se);H.set(ae,le)},ie=ae=>{const oe=H.get(ae);!oe||(oe.dispose(),H.delete(ae))};O.connections.filter(q).forEach(x),f.Event.filter(O.onDidAddConnection,q)(x,void 0,_),O.onDidRemoveConnection(ie,void 0,_),B.event(N.fire,N,_),_.add(B)},onLastListenerRemove:()=>{_.dispose()}});return N.event}registerChannel(U,q){this.channels.set(U,q),this._connections.forEach(T=>{T.channelServer.registerChannel(U,q)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=F;class C{constructor(U,q,T=null){const R=new h;l(R,q),U.send(R.buffer),this.channelClient=new A(U,T),this.channelServer=new S(U,q,T)}getChannel(U){return this.channelClient.getChannel(U)}registerChannel(U,q){this.channelServer.registerChannel(U,q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=C;function X(j){return{call(U,q,T){return j.then(R=>R.call(U,q,T))},listen(U,q){const T=new f.Relay;return j.then(R=>T.input=R.listen(U,q)),T.event}}}e.getDelayedChannel=X;function ee(j){let U=!1;return{call(q,T,R){return U?j.call(q,T,R):(0,L.timeout)(0).then(()=>U=!0).then(()=>j.call(q,T,R))},listen(q,T){if(U)return j.listen(q,T);const R=new f.Relay;return(0,L.timeout)(0).then(()=>U=!0).then(()=>R.input=j.listen(q,T)),R.event}}}e.getNextTickChannel=ee;class re{constructor(U){this.fn=U}routeCall(U){return this.route(U)}routeEvent(U){return this.route(U)}async route(U){for(const q of U.connections)if(await Promise.resolve(this.fn(q.ctx)))return Promise.resolve(q);return await f.Event.toPromise(U.onDidAddConnection),await this.route(U)}}e.StaticRouter=re;var Y;(function(j){function U(R,O){const _=R,N=O&&O.disableMarshalling,B=new Map;for(const H in _)T(H)&&B.set(H,f.Event.buffer(_[H],!0));return new class{listen(H,x){const ie=B.get(x);if(ie)return ie;throw new Error(`Event not found: ${x}`)}call(H,x,ie){const ae=_[x];if(typeof ae=="function"){if(!N&&Array.isArray(ie))for(let oe=0;oe<ie.length;oe++)ie[oe]=(0,t.revive)(ie[oe]);return ae.apply(_,ie)}throw new Error(`Method not found: ${x}`)}}}j.fromService=U;function q(R,O){const _=O&&O.disableMarshalling;return new Proxy({},{get(N,B){if(typeof B=="string")return O?.properties?.has(B)?O.properties.get(B):T(B)?R.listen(B):async function(...H){let x;O&&!(0,b.isUndefinedOrNull)(O.context)?x=[O.context,...H]:x=H;const ie=await R.call(B,x);return _?ie:(0,t.revive)(ie)};throw new Error(`Property not found: ${String(B)}`)}})}j.toService=q;function T(R){return R[0]==="o"&&R[1]==="n"&&P.isUpperAsciiLetter(R.charCodeAt(2))}})(Y=e.ProxyChannel||(e.ProxyChannel={}));const Q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function W(j){if(Array.isArray(j))return j;if(j&&typeof j=="object"&&typeof j.toString=="function"){let U=j.toString();if(U!=="[object Object]")return U}return j}function V(j){return Array.isArray(j)?j.map(W):W(j)}function z(j,U,q,T,R,O,_){_=V(_);const N=Q[R],B=N[T%N.length];let H=[`%c[${j}]%c[${String(U).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(T).padStart(5," ")} - ${O}`,"color: darkgreen","color: grey","color: grey",`color: ${B}`];/\($/.test(O)?(H=H.concat(_),H.push(")")):H.push(_),console.log.apply(console,H)}e.logWithColors=z;class ${constructor(U,q){this._outgoingPrefix=U,this._incomingPrefix=q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(U,q,T,R,O){this._totalOutgoing+=U,z(this._outgoingPrefix,this._totalOutgoing,U,q,T,R,O)}logIncoming(U,q,T,R,O){this._totalIncoming+=U,z(this._incomingPrefix,this._totalIncoming,U,q,T,R,O)}}e.IPCLogger=$}),define(J[120],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class y{constructor(k,D){this.sender=k,this.onMessage=D}send(k){try{this.sender.send("vscode:message",k.buffer)}catch(D){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=y}),define(J[121],Z([0,1,18,5,35]),function(K,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class D{constructor(f){this.port=f,this.onMessage=L.Event.fromDOMEventEmitter(this.port,"message",w=>y.VSBuffer.wrap(w.data)),f.start()}send(f){this.port.postMessage(f.buffer)}disconnect(){this.port.close()}}e.Protocol=D;class E extends k.IPCClient{constructor(f,w){const t=new D(f);super(t,w);this.protocol=t}dispose(){this.protocol.disconnect()}}e.Client=E}),define(J[83],Z([0,1,18,5,2,3,32,35]),function(K,e,y,L,k,D,E,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var f;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(f=e.SocketCloseEventType||(e.SocketCloseEventType={}));let w=null;function t(){return w||(w=y.VSBuffer.alloc(0)),w}class P{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,l){if(s===0)return t();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const A=this._chunks[0];return l&&(this._chunks.shift(),this._totalLength-=s),A}if(this._chunks[0].byteLength>s){const A=this._chunks[0].slice(0,s);return l&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),A}let m=y.VSBuffer.alloc(s),S=0,M=0;for(;s>0;){const A=this._chunks[M];if(A.byteLength>s){const F=A.slice(0,s);m.set(F,S),S+=s,l&&(this._chunks[M]=A.slice(s),this._totalLength-=s),s-=s}else m.set(A,S),S+=A.byteLength,l?(this._chunks.shift(),this._totalLength-=A.byteLength):M++,s-=A.byteLength}return m}}e.ChunkStream=P;var b;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.KeepAlive=4]="KeepAlive",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest"})(b||(b={}));var p;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",n[n.KeepAliveTime=5e3]="KeepAliveTime",n[n.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(p=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(s,l,m,S){this.type=s,this.id=l,this.ack=m,this.data=S,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends k.Disposable{constructor(s){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new P,this._register(this._socket.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const l=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=l.readUInt32BE(9),this._state.messageType=l.readUInt8(0),this._state.id=l.readUInt32BE(1),this._state.ack=l.readUInt32BE(5);else{const m=this._state.messageType,S=this._state.id,M=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new d(m,S,M,l)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class I{constructor(s){this._isDisposed=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(s){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=y.VSBuffer.alloc(13);l.writeUInt8(s.type,0),l.writeUInt32BE(s.id,1),l.writeUInt32BE(s.ack,5),l.writeUInt32BE(s.data.byteLength,9),this._writeSoon(l,s.data)}_bufferAdd(s,l){const m=this._totalLength===0;return this._data.push(s,l),this._totalLength+=s.byteLength+l.byteLength,m}_bufferTake(){const s=y.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,l){this._bufferAdd(s,l)&&D.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class v extends k.Disposable{constructor(s){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new I(this._socket)),this._socketReader=this._register(new g(this._socket)),this._register(this._socketReader.onMessage(l=>{l.type===1&&this._onMessage.fire(l.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new d(1,0,0,s))}}e.Protocol=v;class u extends r.IPCClient{constructor(s,l,m=null){super(s,l,m);this.protocol=s}static fromSocket(s,l){return new u(new v(s),l)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=u;class h{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,E.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=h;class o{constructor(s){this.data=s,this.next=null}}class c{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],l=0,m=this._first;for(;m;)s[l++]=m.data,m=m.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const l=new o(s);if(!this._first){this._first=l,this._last=l;return}this._last.next=l,this._last=l}}class i{constructor(){this.lastRuns=[];const s=Date.now();for(let l=0;l<i._HISTORY_LENGTH;l++)this.lastRuns[l]=s-1e3*l;setInterval(()=>{for(let l=i._HISTORY_LENGTH;l>=1;l--)this.lastRuns[l]=this.lastRuns[l-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return i._INSTANCE||(i._INSTANCE=new i),i._INSTANCE}load(){const s=Date.now(),l=(1+i._HISTORY_LENGTH)*1e3;let m=0;for(let S=0;S<i._HISTORY_LENGTH;S++)s-this.lastRuns[S]<=l&&m++;return 1-m/i._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}i._HISTORY_LENGTH=10,i._INSTANCE=null;class a{constructor(s,l=null,m=i.getInstance()){this._onControlMessage=new h,this.onControlMessage=this._onControlMessage.event,this._onMessage=new h,this.onMessage=this._onMessage.event,this._onDidDispose=new h,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new h,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new h,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=m,this._isReconnecting=!1,this._outgoingUnackMsg=new c,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=s,this._socketWriter=new I(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(S=>this._receiveMessage(S))),this._socketDisposables.push(this._socket.onClose(S=>this._onSocketClose.fire(S))),l&&this._socketReader.acceptChunk(l),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new d(5,0,0,t());this._socketWriter.write(s),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const s=Date.now()-this._socketWriter.lastWriteTime;if(s>=5e3){const l=new d(4,0,0,t());this._socketWriter.write(l),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-s+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const s=Date.now()-this._socketReader.lastReadTime;if(s>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-s,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,l){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=s,this._socketWriter=new I(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(m=>this._receiveMessage(m))),this._socketDisposables.push(this._socket.onClose(m=>this._onSocketClose.fire(m))),this._socketReader.acceptChunk(l)}endAcceptReconnection(){this._isReconnecting=!1;const s=this._outgoingUnackMsg.toArray();for(let l=0,m=s.length;l<m;l++)this._socketWriter.write(s[l]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const l=this._outgoingUnackMsg.peek();if(l&&l.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(s.type===1){if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const l=Date.now();l-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=l,this._socketWriter.write(new d(6,0,0,t())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data)}else if(s.type===2)this._onControlMessage.fire(s.data);else if(s.type===5)this._onDidDispose.fire();else if(s.type===6){const l=this._outgoingUnackMsg.toArray();for(let m=0,S=l.length;m<S;m++)this._socketWriter.write(l[m]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const l=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const m=new d(1,l,this._incomingAckId,s);this._outgoingUnackMsg.push(m),this._isReconnecting||(this._socketWriter.write(m),this._recvAckCheck())}sendControl(s){const l=new d(2,0,0,s);this._socketWriter.write(l)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),l=Date.now()-s.writtenTime;if(l>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-l,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new d(3,0,this._incomingAckId,t());this._socketWriter.write(s)}}e.PersistentProtocol=a}),define(J[122],Z([0,1,14,18,5,2,35,120]),function(K,e,y,L,k,D,E,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function f(t,P){const b=k.Event.fromNodeEventEmitter(y.ipcMain,P,(d,g)=>({event:d,message:g})),p=k.Event.filter(b,({event:d})=>d.sender.id===t);return k.Event.map(p,({message:d})=>d&&L.VSBuffer.wrap(d))}class w extends E.IPCServer{constructor(){super(w.getOnDidClientConnect())}static getOnDidClientConnect(){const P=k.Event.fromNodeEventEmitter(y.ipcMain,"vscode:hello",({sender:b})=>b);return k.Event.map(P,b=>{const p=b.id,d=w.Clients.get(p);d&&d.dispose();const g=new k.Emitter;w.Clients.set(p,(0,D.toDisposable)(()=>g.fire()));const I=f(p,"vscode:message"),v=k.Event.any(k.Event.signal(f(p,"vscode:disconnect")),g.event);return{protocol:new r.Protocol(b,I),onDidClientDisconnect:v}})}}e.Server=w,w.Clients=new Map}),define(J[84],Z([0,1,14,5,28,121]),function(K,e,y,L,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class E extends D.Client{constructor(w,t){super({addEventListener:(P,b)=>w.addListener(P,b),removeEventListener:(P,b)=>w.removeListener(P,b),postMessage:P=>w.postMessage(P),start:()=>w.start(),close:()=>w.close()},t)}}e.Client=E;async function r(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const w=(0,k.generateUuid)();f.webContents.send("vscode:createMessageChannel",w);const t=L.Event.fromNodeEventEmitter(y.ipcMain,"vscode:createMessageChannelResult",(b,p)=>({nonce:p,port:b.ports[0]})),{port:P}=await L.Event.toPromise(L.Event.once(L.Event.filter(t,b=>b.nonce===w)));return P}e.connect=r}),define(J[85],Z([0,1,9,5,2,13]),function(K,e,y,L,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var E;(function(P){P[P.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(E=e.StorageHint||(e.StorageHint={}));function r(P){const b=P;return b?.changed instanceof Map||b?.deleted instanceof Set}e.isStorageItemsChangeEvent=r;var f;(function(P){P[P.None=0]="None",P[P.Initialized=1]="Initialized",P[P.Closed=2]="Closed"})(f||(f={}));class w extends k.Disposable{constructor(b,p=Object.create(null)){super();this.database=b,this.options=p,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=f.None,this.cache=new Map,this.flushDelayer=new y.ThrottledDelayer(w.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(b=>this.onDidChangeItemsExternal(b)))}onDidChangeItemsExternal(b){b.changed?.forEach((p,d)=>this.accept(d,p)),b.deleted?.forEach(p=>this.accept(p,void 0))}accept(b,p){if(this.state===f.Closed)return;let d=!1;(0,D.isUndefinedOrNull)(p)?d=this.cache.delete(b):this.cache.get(b)!==p&&(this.cache.set(b,p),d=!0),d&&this._onDidChangeStorage.fire(b)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===f.None&&(this.state=f.Initialized,this.options.hint!==E.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(b,p){const d=this.cache.get(b);return(0,D.isUndefinedOrNull)(d)?p:d}getBoolean(b,p){const d=this.get(b);return(0,D.isUndefinedOrNull)(d)?p:d==="true"}getNumber(b,p){const d=this.get(b);return(0,D.isUndefinedOrNull)(d)?p:parseInt(d,10)}async set(b,p){if(this.state===f.Closed)return;if((0,D.isUndefinedOrNull)(p))return this.delete(b);const d=String(p);if(this.cache.get(b)!==d)return this.cache.set(b,d),this.pendingInserts.set(b,d),this.pendingDeletes.delete(b),this._onDidChangeStorage.fire(b),this.flushDelayer.trigger(()=>this.flushPending())}async delete(b){if(!(this.state===f.Closed||!this.cache.delete(b)))return this.pendingDeletes.has(b)||this.pendingDeletes.add(b),this.pendingInserts.delete(b),this._onDidChangeStorage.fire(b),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=f.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(b){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const b={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(b).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(b=>this.whenFlushedCallbacks.push(b))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=w,w.DEFAULT_FLUSH_DELAY=100;class t{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(b){b.insert&&b.insert.forEach((p,d)=>this.items.set(d,p)),b.delete&&b.delete.forEach(p=>this.items.delete(p))}async close(){}}e.InMemoryStorageDatabase=t}),define(J[123],Z([0,1,9,5,37,8,19]),function(K,e,y,L,k,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class r{constructor(t,P=Object.create(null)){this.path=t,this.options=P,this.name=(0,D.basename)(this.path),this.logger=new f(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return L.Event.None}async getItems(){const t=await this.whenConnected,P=new Map;return(await this.all(t,"SELECT * FROM ItemTable")).forEach(p=>P.set(p.key,p.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${P.size} rows`),P}async updateItems(t){const P=await this.whenConnected;return this.doUpdateItems(P,t)}doUpdateItems(t,P){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${P.insert?(0,k.mapToString)(P.insert):"0"}), delete(${P.delete?(0,k.setToString)(P.delete):"0"})`),this.transaction(t,()=>{const b=P.insert,p=P.delete;if(b&&b.size>0){const d=[];d.push([]);let g=0;b.forEach((I,v)=>{let u=d[g];u.length>r.MAX_HOST_PARAMETERS&&(g++,u=[],d.push(u)),u.push(v,I)}),d.forEach(I=>{this.prepare(t,`INSERT INTO ItemTable VALUES ${new Array(I.length/2).fill("(?,?)").join(",")}`,v=>v.run(I),()=>{const v=[];let u=0;return b.forEach((h,o)=>{v.push(o),u+=h.length}),`Keys: ${v.join(", ")} Length: ${u}`})})}if(p&&p.size){const d=[];d.push([]);let g=0;p.forEach(I=>{let v=d[g];v.length>r.MAX_HOST_PARAMETERS&&(g++,v=[],d.push(v)),v.push(I)}),d.forEach(I=>{this.prepare(t,`DELETE FROM ItemTable WHERE key IN (${new Array(I.length).fill("?").join(",")})`,v=>v.run(I),()=>{const v=[];return p.forEach(u=>{v.push(u)}),`Keys: ${v.join(", ")}`})})}})}async close(t){this.logger.trace(`[storage ${this.name}] close()`);const P=await this.whenConnected;return this.doClose(P,t)}doClose(t,P){return new Promise((b,p)=>{t.db.close(d=>(d&&this.handleSQLiteError(t,`[storage ${this.name}] close(): ${d}`),this.path===r.IN_MEMORY_PATH?b():!t.isErroneous&&!t.isInMemory?this.backup().then(b,g=>(this.logger.error(`[storage ${this.name}] backup(): ${g}`),b())):typeof P=="function"?E.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(g=>{const I=()=>this.doClose(g,void 0);return this.doUpdateItems(g,{insert:P()}).then(()=>I(),v=>(I(),Promise.reject(v)))})).then(b,p):p(d||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const t=this.toBackupPath(this.path);return E.Promises.copy(this.path,t,{preserveSymlinks:!1})}toBackupPath(t){return`${t}.backup`}async checkIntegrity(t){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${t})`);const P=await this.whenConnected,b=await this.get(P,t?"PRAGMA integrity_check":"PRAGMA quick_check"),p=t?b.integrity_check:b.quick_check;return P.isErroneous?`${p} (last error: ${P.lastError})`:P.isInMemory?`${p} (in-memory!)`:p}async connect(t,P=!0){this.logger.trace(`[storage ${this.name}] open(${t}, retryOnBusy: ${P})`);try{return await this.doConnect(t)}catch(b){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${b}`),b.code==="SQLITE_BUSY"&&P)return await(0,y.timeout)(r.BUSY_OPEN_TIMEOUT),this.connect(t,!1);try{await E.Promises.unlink(t);try{await E.Promises.rename(this.toBackupPath(t),t)}catch(p){}return await this.doConnect(t)}catch(p){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${p}`),this.doConnect(r.IN_MEMORY_PATH)}}}handleSQLiteError(t,P){t.isErroneous=!0,t.lastError=P,this.logger.error(P)}doConnect(t){return new Promise((P,b)=>{new Promise((p,d)=>{K(["@vscode/sqlite3"],p,d)}).then(p=>{const d={db:new(this.logger.isTracing?p.verbose().Database:p.Database)(t,g=>g?d.db?d.db.close(()=>b(g)):b(g):this.exec(d,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>P(d),I=>d.db.close(()=>b(I)))),isInMemory:t===r.IN_MEMORY_PATH};d.db.on("error",g=>this.handleSQLiteError(d,`[storage ${this.name}] Error (event): ${g}`)),this.logger.isTracing&&d.db.on("trace",g=>this.logger.trace(`[storage ${this.name}] Trace (event): ${g}`))},b)})}exec(t,P){return new Promise((b,p)=>{t.db.exec(P,d=>d?(this.handleSQLiteError(t,`[storage ${this.name}] exec(): ${d}`),p(d)):b())})}get(t,P){return new Promise((b,p)=>{t.db.get(P,(d,g)=>d?(this.handleSQLiteError(t,`[storage ${this.name}] get(): ${d}`),p(d)):b(g))})}all(t,P){return new Promise((b,p)=>{t.db.all(P,(d,g)=>d?(this.handleSQLiteError(t,`[storage ${this.name}] all(): ${d}`),p(d)):b(g))})}transaction(t,P){return new Promise((b,p)=>{t.db.serialize(()=>{t.db.run("BEGIN TRANSACTION"),P(),t.db.run("END TRANSACTION",d=>d?(this.handleSQLiteError(t,`[storage ${this.name}] transaction(): ${d}`),p(d)):b())})})}prepare(t,P,b,p){const d=t.db.prepare(P),g=I=>{this.handleSQLiteError(t,`[storage ${this.name}] prepare(): ${I} (${P}). Details: ${p()}`)};d.on("error",g),b(d),d.finalize(I=>{I&&g(I),d.removeListener("error",g)})}}e.SQLiteStorageDatabase=r,r.IN_MEMORY_PATH=":memory:",r.BUSY_OPEN_TIMEOUT=2e3,r.MAX_HOST_PARAMETERS=256;class f{constructor(t){t&&typeof t.logTrace=="function"&&process.env[f.VSCODE_TRACE_STORAGE]&&(this.logTrace=t.logTrace),t&&typeof t.logError=="function"&&(this.logError=t.logError)}get isTracing(){return!!this.logTrace}trace(t){this.logTrace&&this.logTrace(t)}error(t){this.logError&&this.logError(t)}}f.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(J[124],Z([12,11]),function(K,e){return K.create("vs/base/common/date",e)}),define(J[125],Z([0,1,124]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,k=L*60,D=k*24,E=D*7,r=D*30,f=D*365;function w(P,b){typeof P!="number"&&(P=P.getTime());const p=Math.round((new Date().getTime()-P)/1e3);if(p<-30)return(0,y.localize)(0,null,w(new Date().getTime()+p*1e3,!1));if(p<30)return(0,y.localize)(1,null);let d;return p<L?(d=p,b?d===1?(0,y.localize)(2,null,d):(0,y.localize)(3,null,d):d===1?(0,y.localize)(4,null,d):(0,y.localize)(5,null,d)):p<k?(d=Math.floor(p/L),b?d===1?(0,y.localize)(6,null,d):(0,y.localize)(7,null,d):d===1?(0,y.localize)(8,null,d):(0,y.localize)(9,null,d)):p<D?(d=Math.floor(p/k),b?d===1?(0,y.localize)(10,null,d):(0,y.localize)(11,null,d):d===1?(0,y.localize)(12,null,d):(0,y.localize)(13,null,d)):p<E?(d=Math.floor(p/D),b?d===1?(0,y.localize)(14,null,d):(0,y.localize)(15,null,d):d===1?(0,y.localize)(16,null,d):(0,y.localize)(17,null,d)):p<r?(d=Math.floor(p/E),b?d===1?(0,y.localize)(18,null,d):(0,y.localize)(19,null,d):d===1?(0,y.localize)(20,null,d):(0,y.localize)(21,null,d)):p<f?(d=Math.floor(p/r),b?d===1?(0,y.localize)(22,null,d):(0,y.localize)(23,null,d):d===1?(0,y.localize)(24,null,d):(0,y.localize)(25,null,d)):(d=Math.floor(p/f),b?d===1?(0,y.localize)(26,null,d):(0,y.localize)(27,null,d):d===1?(0,y.localize)(28,null,d):(0,y.localize)(29,null,d))}e.fromNow=w;function t(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=t}),define(J[126],Z([12,11]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(J[67],Z([0,1,31,13,126]),function(K,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function D(w,t){return t&&(w.stack||w.stacktrace)?k.localize(0,null,r(w),E(w.stack)||E(w.stacktrace)):r(w)}function E(w){return Array.isArray(w)?w.join(`
`):w}function r(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?k.localize(1,null,w.message):w.message||k.localize(2,null)}function f(w=null,t=!1){if(!w)return k.localize(3,null);if(Array.isArray(w)){const P=y.coalesce(w),b=f(P[0],t);return P.length>1?k.localize(4,null,b,P.length):b}if(L.isString(w))return w;if(w.detail){const P=w.detail;if(P.error)return D(P.error,t);if(P.exception)return D(P.exception,t)}return w.stack?D(w,t):w.message?w.message:k.localize(5,null)}e.toErrorMessage=f}),define(J[127],Z([12,11]),function(K,e){return K.create("vs/base/common/keybindingLabels",e)}),define(J[128],Z([0,1,127]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class L{constructor(E,r,f=r){this.modifierLabels=[null],this.modifierLabels[2]=E,this.modifierLabels[1]=r,this.modifierLabels[3]=f}toLabel(E,r,f){if(r.length===0)return null;const w=[];for(let t=0,P=r.length;t<P;t++){const b=r[t],p=f(b);if(p===null)return null;w[t]=k(b,p,this.modifierLabels[E])}return w.join(" ")}}e.ModifierLabelProvider=L,e.UILabelProvider=new L({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:y.localize(0,null),shiftKey:y.localize(1,null),altKey:y.localize(2,null),metaKey:y.localize(3,null),separator:"+"},{ctrlKey:y.localize(4,null),shiftKey:y.localize(5,null),altKey:y.localize(6,null),metaKey:y.localize(7,null),separator:"+"}),e.AriaLabelProvider=new L({ctrlKey:y.localize(8,null),shiftKey:y.localize(9,null),altKey:y.localize(10,null),metaKey:y.localize(11,null),separator:"+"},{ctrlKey:y.localize(12,null),shiftKey:y.localize(13,null),altKey:y.localize(14,null),metaKey:y.localize(15,null),separator:"+"},{ctrlKey:y.localize(16,null),shiftKey:y.localize(17,null),altKey:y.localize(18,null),metaKey:y.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new L({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new L({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function k(D,E,r){if(E===null)return"";const f=[];return D.ctrlKey&&f.push(r.ctrlKey),D.shiftKey&&f.push(r.shiftKey),D.altKey&&f.push(r.altKey),D.metaKey&&f.push(r.metaKey),E!==""&&f.push(E),f.join(r.separator)}}),define(J[129],Z([12,11]),function(K,e){return K.create("vs/base/node/processes",e)}),define(J[68],Z([0,1,41,29,10,44,8,3,32,13,80,19,129]),function(K,e,y,L,k,D,E,r,f,w,t,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function p(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function d(o,c){if(r.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};c&&(i.cwd=c);const a=y.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],i);return new Promise(n=>{a.once("error",s=>{n({success:!1,error:s})}),a.once("exit",(s,l)=>{n(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?p(i.status):1})}else if(r.isLinux||r.isMacintosh)try{const i=k.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",K).fsPath;return new Promise(a=>{y.execFile(i,[o.pid.toString()],{encoding:"utf8",shell:!0},(n,s,l)=>{a(n?{success:!1,error:n}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function g(o=f.env){return o.comspec||"cmd.exe"}e.getWindowsShell=g;class I{constructor(c,i,a,n){if(i!==void 0&&a!==void 0&&n!==void 0)this.cmd=c,this.args=i,this.shell=a,this.options=n;else{const s=c;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(f.env).forEach(l=>{s[l]=f.env[l]}),Object.keys(this.options.env).forEach(l=>{s[l]=this.options.env[l]}),this.options.env=s}}getSanitizedCommand(){let c=this.cmd.toLowerCase();const i=c.lastIndexOf(E.sep);return i!==-1&&(c=c.substring(i+1)),I.WellKnowCommands[c]?c:"other"}start(c){return r.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(f.cwd()))?Promise.reject(new Error(b.localize(0,null))):this.useExec().then(i=>{let a,n;const s=new Promise((l,m)=>{a=l,n=m});if(i){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=y.exec(l,this.options,(m,S,M)=>{this.childProcess=null;const A=m;A&&A.killed?n({killed:this.terminateRequested,stdout:S.toString(),stderr:M.toString()}):this.handleExec(a,c,m,S,M)})}else{let l=null;const m=S=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(S,a,c,n);const M={terminated:this.terminateRequested};w.isNumber(S)&&(M.cmdCode=S),a(M)};if(this.shell&&r.isWindows){const S=D.deepClone(this.options);S.windowsVerbatimArguments=!0,S.detached=!1;let M=!1,A=!1;const F=[];let C=this.ensureQuotes(this.cmd);F.push(C.value),M=C.quoted,this.args&&this.args.forEach(ee=>{C=this.ensureQuotes(ee),F.push(C.value),A=A&&C.quoted});const X=["/s","/c"];M?A?X.push('"'+F.join(" ")+'"'):F.length>1?X.push('"'+F[0]+'" '+F.slice(1).join(" ")):X.push('"'+F[0]+'"'):X.push(F.join(" ")),l=y.spawn(g(),X,S)}else this.cmd&&(l=y.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(w.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",S=>{this.childProcess=null,n({terminated:this.terminateRequested,error:S})}),l.pid&&(this.childProcess.on("close",m),this.handleSpawn(l,a,c,n,!0)))}return s})}handleClose(c,i,a,n){}ensureQuotes(c){return I.regexp.test(c)?{value:'"'+c+'"',quoted:!0}:{value:c,quoted:c.length>0&&c[0]==='"'&&c[c.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(c=>c.pid,c=>-1):new Promise(c=>{this.pidResolve=c})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(c=>(this.terminateRequested=!0,d(c,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),c=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(c=>{if(!this.shell||!r.isWindows)return c(!1);const i=y.spawn(g(),["/s","/c"]);i.on("error",a=>c(!0)),i.on("exit",a=>c(!1))})}}e.AbstractProcess=I,I.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},I.regexp=/^[^"].* .*[^"]/;class v extends I{constructor(c,i,a,n){super(c,i,a,n);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(c,i,a,n,s){[n,s].forEach((l,m)=>{const S=new t.LineDecoder;S.write(l).forEach(F=>{i({line:F,source:m===0?0:1})});const A=S.end();A&&i({line:A,source:m===0?0:1})}),c({terminated:this.terminateRequested,error:a})}handleSpawn(c,i,a,n,s){const l=new t.LineDecoder,m=new t.LineDecoder;c.stdout.on("data",S=>{l.write(S).forEach(A=>a({line:A,source:0}))}),c.stderr.on("data",S=>{m.write(S).forEach(A=>a({line:A,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=m}handleClose(c,i,a,n){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&a({line:s,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&a({line:l,source:1})}}e.LineProcess=v;function u(o){let c=[],i=!1;const a=function(n){if(i){c.push(n);return}(!o.send(n,l=>{if(l&&console.error(l),i=!1,c.length>0){const m=c.slice(0);c=[],m.forEach(S=>a(S))}})||r.isWindows)&&(i=!0)};return{send:a}}e.createQueuedSender=u;var h;(function(o){async function c(i,a,n){if(E.isAbsolute(i))return i;if(a===void 0&&(a=f.cwd()),E.dirname(i)!=="."||(n===void 0&&w.isString(f.env.PATH)&&(n=f.env.PATH.split(E.delimiter)),n===void 0||n.length===0))return E.join(a,i);async function l(m){if(await P.Promises.exists(m)){let S;try{S=await P.Promises.stat(m)}catch(M){M.message.startsWith("EACCES")&&(S=await P.Promises.lstat(m))}return S?!S.isDirectory():!1}return!1}for(let m of n){let S;if(E.isAbsolute(m)?S=E.join(m,i):S=E.join(a,m,i),await l(S))return S;let M=S+".com";if(await l(M)||(M=S+".exe",await l(M)))return M}return E.join(a,i)}o.findExecutable=c})(h=e.win32||(e.win32={}))}),define(J[130],Z([0,1,26,3,116,68]),function(K,e,y,L,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function E(p,d){return p===1?L.isWindows?P():D.getWindowsShell(d):w(p,d)}e.getSystemShell=E;function r(p,d){return p===1?L.isWindows?b(d):D.getWindowsShell(d):w(p,d)}e.getSystemShellSync=r;let f=null;function w(p,d){if(L.isLinux&&p===2||L.isMacintosh&&p===3)return"/bin/bash";if(!f){let g;if(L.isWindows)g="/bin/bash";else{if(g=d.SHELL,!g)try{g=(0,y.userInfo)().shell}catch(I){}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}f=g}return f}let t=null;async function P(){return t||(t=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),t}function b(p){if(t)return t;const d=L.isWindows&&parseFloat((0,y.release)())>=10,g=p.hasOwnProperty("PROCESSOR_ARCHITEW6432"),I=`${p.windir}\\${g?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?I:D.getWindowsShell(p)}}),define(J[86],Z([0,1,41,9,18,24,109,17,5,2,44,3,68,35]),function(K,e,y,L,k,D,E,r,f,w,t,P,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends p.ChannelServer{constructor(v){super({send:u=>{try{process.send&&process.send(u.buffer.toString("base64"))}catch(h){}},onMessage:f.Event.fromNodeEventEmitter(process,"message",u=>k.VSBuffer.wrap(Buffer.from(u,"base64")))},v);process.once("disconnect",()=>this.dispose())}}e.Server=d;class g{constructor(v,u){this.modulePath=v,this.options=u,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new f.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const h=u&&u.timeout?u.timeout:6e4;this.disposeDelayer=new L.Delayer(h),this.child=null,this._client=null}getChannel(v){const u=this;return{call(h,o,c){return u.requestPromise(v,h,o,c)},listen(h,o){return u.requestEvent(v,h,o)}}}requestPromise(v,u,h,o=D.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(r.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(v),i=(0,L.createCancelablePromise)(s=>c.call(u,h,s)),a=o.onCancellationRequested(()=>i.cancel()),n=(0,w.toDisposable)(()=>i.cancel());return this.activeRequests.add(n),i.finally(()=>{a.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(v,u,h){if(!this.disposeDelayer)return f.Event.None;this.disposeDelayer.cancel();let o;const c=new f.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(v).listen(u,h)(c.fire,c),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const v=this.options&&this.options.args?this.options.args:[],u=Object.create(null);u.env={...(0,t.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(u.env={...u.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(u.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l))),P.isMacintosh&&u.env&&delete u.env.DYLD_LIBRARY_PATH,this.child=(0,y.fork)(this.modulePath,v,u);const h=new f.Emitter;f.Event.fromNodeEventEmitter(this.child,"message",l=>l)(l=>{if((0,E.isRemoteConsoleLog)(l)){(0,E.log)(l,`IPC Library: ${this.options.serverName}`);return}h.fire(k.VSBuffer.wrap(Buffer.from(l,"base64")))});const c=this.options.useQueue?(0,b.createQueuedSender)(this.child):this.child,i=l=>this.child&&this.child.connected&&c.send(l.buffer.toString("base64")),a=h.event,n={send:i,onMessage:a};this._client=new p.ChannelClient(n);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",l=>console.warn('IPC "'+this.options.serverName+'" errored with '+l)),this.child.on("exit",(l,m)=>{process.removeListener("exit",s),this.activeRequests.forEach(S=>(0,w.dispose)(S)),this.activeRequests.clear(),l!==0&&m!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+l+" and signal "+m),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:l,signal:m})})}return this._client}getCachedChannel(v){let u=this.channels.get(v);return u||(u=this.client.getChannel(v),this.channels.set(v,u)),u}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=g}),define(J[131],Z([12,11]),function(K,e){return K.create("vs/code/electron-main/app",e)}),define(J[132],Z([12,11]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(J[133],Z([12,11]),function(K,e){return K.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(J[134],Z([12,11]),function(K,e){return K.create("vs/platform/environment/node/argv",e)}),define(J[135],Z([12,11]),function(K,e){return K.create("vs/platform/environment/node/argvHelper",e)}),define(J[136],Z([12,11]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(J[137],Z([12,11]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(J[138],Z([12,11]),function(K,e){return K.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(J[139],Z([12,11]),function(K,e){return K.create("vs/platform/files/common/fileService",e)}),define(J[140],Z([12,11]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(J[141],Z([12,11]),function(K,e){return K.create("vs/platform/files/common/io",e)}),define(J[142],Z([12,11]),function(K,e){return K.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(J[143],Z([12,11]),function(K,e){return K.create("vs/platform/issue/electron-main/issueMainService",e)}),define(J[144],Z([12,11]),function(K,e){return K.create("vs/platform/menubar/electron-main/menubar",e)}),define(J[145],Z([12,11]),function(K,e){return K.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(J[146],Z([12,11]),function(K,e){return K.create("vs/platform/request/common/request",e)}),define(J[147],Z([12,11]),function(K,e){return K.create("vs/platform/telemetry/common/telemetryService",e)}),define(J[148],Z([12,11]),function(K,e){return K.create("vs/platform/update/common/update.config.contribution",e)}),define(J[149],Z([12,11]),function(K,e){return K.create("vs/platform/windows/electron-main/window",e)}),define(J[150],Z([12,11]),function(K,e){return K.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(J[151],Z([12,11]),function(K,e){return K.create("vs/platform/workspaces/common/workspaces",e)}),define(J[152],Z([12,11]),function(K,e){return K.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(J[153],Z([12,11]),function(K,e){return K.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(J[154],Z([0,1,5,2]),function(K,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class k{constructor(){this._onCloseEmitter=new y.Emitter,this._onReloadEmitter=new y.Emitter,this._onTerminateEmitter=new y.Emitter,this._onAttachEmitter=new y.Emitter}call(r,f,w){switch(f){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:w[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:w[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:w[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:w[0],port:w[1],subId:w[2]}))}throw new Error("Method not implemented.")}listen(r,f,w){switch(f){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=k,k.ChannelName="extensionhostdebugservice";class D extends L.Disposable{constructor(r){super();this.channel=r}reload(r){this.channel.call("reload",[r])}get onReload(){return this.channel.listen("reload")}close(r){this.channel.call("close",[r])}get onClose(){return this.channel.listen("close")}attachSession(r,f,w){this.channel.call("attach",[r,f,w])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(r,f){this.channel.call("terminate",[r,f])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(r,f,w){return this.channel.call("openExtensionDevelopmentHostWindow",[r,f||{},w])}}e.ExtensionHostDebugChannelClient=D}),define(J[155],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class y{constructor(E){this.driver=E}listen(E,r){throw new Error(`No event found: ${r}`)}call(E,r,f){switch(r){case"click":return this.driver.click(f[0],f[1],f[2]);case"doubleClick":return this.driver.doubleClick(f);case"setValue":return this.driver.setValue(f[0],f[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(f);case"getElements":return this.driver.getElements(f[0],f[1]);case"getElementXY":return this.driver.getElementXY(f[0],f[1],f[2]);case"typeInEditor":return this.driver.typeInEditor(f[0],f[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(f);case"writeInTerminal":return this.driver.writeInTerminal(f[0],f[1]);case"getLocaleInfo":return this.driver.getLocaleInfo();case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${r}`)}}e.WindowDriverChannel=y;class L{constructor(E){this.channel=E}click(E,r,f){return this.channel.call("click",[E,r,f])}doubleClick(E){return this.channel.call("doubleClick",E)}setValue(E,r){return this.channel.call("setValue",[E,r])}getTitle(){return this.channel.call("getTitle")}isActiveElement(E){return this.channel.call("isActiveElement",E)}getElements(E,r){return this.channel.call("getElements",[E,r])}getElementXY(E,r,f){return this.channel.call("getElementXY",[E,r,f])}typeInEditor(E,r){return this.channel.call("typeInEditor",[E,r])}getTerminalBuffer(E){return this.channel.call("getTerminalBuffer",E)}writeInTerminal(E,r){return this.channel.call("writeInTerminal",[E,r])}getLocaleInfo(){return this.channel.call("getLocaleInfo")}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=L;class k{constructor(E){this.channel=E}registerWindowDriver(E){return this.channel.call("registerWindowDriver",E)}reloadWindowDriver(E){return this.channel.call("reloadWindowDriver",E)}}e.WindowDriverRegistryChannelClient=k}),define(J[156],Z([0,1,125,46,10,8,32,15,7]),function(K,e,y,L,k,D,E,r,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class w{constructor(d,g,I){this._args=d,this.paths=g,this.productService=I}get appRoot(){return(0,D.dirname)(k.FileAccess.asFileUri("",K).fsPath)}get userHome(){return f.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return f.URI.file((0,D.join)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,r.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,r.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const d=(0,y.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.join)(this.userDataPath,"logs",d)}return this.args.logsPath}get userDataSyncLogResource(){return f.URI.file((0,D.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,r.joinPath)(f.URI.file((0,D.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return f.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return f.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,r.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,r.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=E.env.VSCODE_PORTABLE;return d?f.URI.file((0,D.join)(d,"argv.json")):(0,r.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,r.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,D.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,D.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,D.resolve)(d):(0,D.normalize)((0,D.join)(k.FileAccess.asFileUri("",K).fsPath,"..","extensions"))}get extensionsDownloadPath(){const d=this.args["extensions-download-dir"];return d?(0,D.resolve)(d):(0,D.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,D.resolve)(d);const g=E.env.VSCODE_EXTENSIONS;if(g)return g;const I=E.env.VSCODE_PORTABLE;return I?(0,D.join)(I,"extensions"):(0,r.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(g=>/^[^:/?#]+?:\/\//.test(g)?f.URI.parse(g):f.URI.file((0,D.normalize)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?f.URI.parse(d):f.URI.file((0,D.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return t(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!E.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,r.joinPath)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return f.URI.file((0,D.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}ue([L.memoize],w.prototype,"appRoot",null),ue([L.memoize],w.prototype,"userHome",null),ue([L.memoize],w.prototype,"userDataPath",null),ue([L.memoize],w.prototype,"appSettingsHome",null),ue([L.memoize],w.prototype,"tmpDir",null),ue([L.memoize],w.prototype,"userRoamingDataHome",null),ue([L.memoize],w.prototype,"settingsResource",null),ue([L.memoize],w.prototype,"userDataSyncHome",null),ue([L.memoize],w.prototype,"userDataSyncLogResource",null),ue([L.memoize],w.prototype,"sync",null),ue([L.memoize],w.prototype,"machineSettingsResource",null),ue([L.memoize],w.prototype,"globalStorageHome",null),ue([L.memoize],w.prototype,"workspaceStorageHome",null),ue([L.memoize],w.prototype,"keybindingsResource",null),ue([L.memoize],w.prototype,"keyboardLayoutResource",null),ue([L.memoize],w.prototype,"argvResource",null),ue([L.memoize],w.prototype,"snippetsHome",null),ue([L.memoize],w.prototype,"isExtensionDevelopment",null),ue([L.memoize],w.prototype,"untitledWorkspacesHome",null),ue([L.memoize],w.prototype,"installSourcePath",null),ue([L.memoize],w.prototype,"builtinExtensionsPath",null),ue([L.memoize],w.prototype,"extensionsPath",null),ue([L.memoize],w.prototype,"extensionDevelopmentLocationURI",null),ue([L.memoize],w.prototype,"extensionDevelopmentKind",null),ue([L.memoize],w.prototype,"extensionTestsLocationURI",null),ue([L.memoize],w.prototype,"debugExtensionHost",null),ue([L.memoize],w.prototype,"serviceMachineIdResource",null),ue([L.memoize],w.prototype,"telemetryLogResource",null),ue([L.memoize],w.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=w;function t(p,d){return b(p["inspect-extensions"],p["inspect-brk-extensions"],5870,d,p.debugId)}e.parseExtensionHostPort=t;function P(p,d){return b(p["inspect-search"],p["inspect-brk-search"],5876,d)}e.parseSearchPort=P;function b(p,d,g,I,v){const h=Number(d||p)||(I?null:g),o=h?Boolean(!!d):!1;return{port:h,break:o,debugId:v}}}),define(J[87],Z([0,1,240,3,134]),function(K,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const D={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,k.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(14,null)},category:{type:"string",cat:"e",description:(0,k.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,k.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,k.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,k.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,k.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,k.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,k.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,k.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,k.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,k.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const E={onUnknownOption:()=>{},onMultipleValues:()=>{}};function r(d,g,I=E){const v={},u=[],h=[];for(let a in g){const n=g[a];n.alias&&(v[a]=n.alias),n.type==="string"||n.type==="string[]"?(u.push(a),n.deprecates&&u.push(n.deprecates)):n.type==="boolean"&&(h.push(a),n.deprecates&&h.push(n.deprecates))}const o=y(d,{string:u,boolean:h,alias:v}),c={},i=o;c._=o._.map(a=>String(a)).filter(a=>a.length>0),delete i._;for(let a in g){const n=g[a];n.alias&&delete i[n.alias];let s=i[a];n.deprecates&&i.hasOwnProperty(n.deprecates)&&(s||(s=i[n.deprecates]),delete i[n.deprecates]),typeof s!="undefined"&&(n.type==="string[]"?s&&!Array.isArray(s)&&(s=[s]):n.type==="string"&&Array.isArray(s)&&(s=s.pop(),I.onMultipleValues(a,s)),c[a]=s),delete i[a]}for(let a in i)I.onUnknownOption(a);return c}e.parseArgs=r;function f(d,g){let I="";return g.args&&(Array.isArray(g.args)?I=` <${g.args.join("> <")}>`:I=` <${g.args}>`),g.alias?`-${g.alias} --${d}${I}`:`--${d}${I}`}function w(d,g){let I=0,v=[];for(const c in d){const i=d[c],a=f(c,i);I=Math.max(I,a.length),v.push([a,i.description])}let u=I+2+1;if(g-u<25)return v.reduce((c,i)=>c.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);let h=g-u-1,o=[];for(const c of v){let i=c[0],a=P(c[1],h),n=t(u-i.length-2);o.push("  "+i+n+a[0]);for(let s=1;s<a.length;s++)o.push(t(u)+a[s])}return o}e.formatOptions=w;function t(d){return" ".repeat(d)}function P(d,g){let I=[];for(;d.length;){let v=d.length<g?d.length:d.lastIndexOf(" ",g),u=d.slice(0,v).trim();d=d.slice(v),I.push(u)}return I}function b(d,g,I,v,u=!0){const h=process.stdout.isTTY&&process.stdout.columns||80;let o=[`${d} ${I}`];o.push(""),o.push(`${(0,k.localize)(32,null)}: ${g} [${(0,k.localize)(33,null)}][${(0,k.localize)(34,null)}...]`),o.push(""),u&&(L.isWindows?o.push((0,k.localize)(35,null,g)):o.push((0,k.localize)(36,null,g)),o.push(""));const c={};for(const i in v){const a=v[i];if(a.description&&a.cat){let n=c[a.cat];n||(c[a.cat]=n={}),n[i]=a}}for(let i in c){const a=i;let n=c[a];n&&(o.push(D[a]),o.push(...w(n,h)),o.push(""))}return o.join(`
`)}e.buildHelpMessage=b;function p(d,g){return`${d||(0,k.localize)(37,null)}
${g||(0,k.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=p}),define(J[157],Z([0,1,59,154,87]),function(K,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class D extends L.ExtensionHostDebugBroadcastChannel{constructor(r){super();this.windowsMainService=r}call(r,f,w){return f==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(w[0],w[1],w[2]):super.call(r,f,w)}async openExtensionDevelopmentHostWindow(r,f,w){const t=(0,k.parseArgs)(r,k.OPTIONS);t.debugRenderer=w;const P=t.extensionDevelopmentPath;if(!P)return{success:!1};let b;const p=Object.keys(f);for(let h of p){let o=f[h];o===null||(b||(b=Object.create(null)),b[h]=o)}const[d]=this.windowsMainService.openExtensionDevelopmentHostWindow(P,{context:5,cli:t,userEnv:b});if(!w)return{success:!0};const g=d.win;if(!g)return{success:!0};const I=g.webContents.debugger;let v=I.isAttached()?Infinity:0;const u=(0,y.createServer)(h=>{v++==0&&I.attach();let o=!1;const c=n=>{o||h.write(JSON.stringify(n)+"\0")},i=(n,s,l,m)=>c({method:s,params:l,sessionId:m});g.on("close",()=>{I.removeListener("message",i),h.end(),o=!0}),I.addListener("message",i);let a=Buffer.alloc(0);h.on("data",n=>{a=Buffer.concat([a,n]);for(let s=a.indexOf(0);s!==-1;s=a.indexOf(0)){let l;try{const m=a.slice(0,s).toString("utf8");a=a.slice(s+1),l=JSON.parse(m)}catch(m){console.error("error reading cdp line",m)}I.sendCommand(l.method,l.params,l.sessionId).then(m=>c({id:l.id,sessionId:l.sessionId,result:m})).catch(m=>c({id:l.id,sessionId:l.sessionId,error:{code:0,message:m.message}}))}}),h.on("error",n=>{console.error("error on cdp pipe:",n)}),h.on("close",()=>{o=!0,--v==0&&I.detach()})});return await new Promise(h=>u.listen(0,h)),g.on("close",()=>u.close()),{rendererDebugPort:u.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=D}),function(){"use strict";function K(e,y,L,k){function D(r){const f=E(r),w=[f];return e.isAbsolute(f)||w.unshift(k),e.resolve(...w)}function E(r){const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let w=process.env.VSCODE_APPDATA;if(w)return e.join(w,L);const t=r["user-data-dir"];if(t)return t;switch(process.platform){case"win32":if(w=process.env.APPDATA,!w){const P=process.env.USERPROFILE;if(typeof P!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");w=e.join(P,"AppData","Roaming")}break;case"darwin":w=e.join(y.homedir(),"Library","Application Support");break;case"linux":w=process.env.XDG_CONFIG_HOME||e.join(y.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(w,L)}return{getUserDataPath:D}}if(typeof define=="function")define(J[158],Z([0,159,26,10,15,32]),function(e,y,L,k,D,E){const r=D.dirname(k.FileAccess.asFileUri("",e)),f=e.__$__nodeRequire(D.joinPath(r,"package.json").fsPath);return K(y,L,f.name,E.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),y=require("path"),L=require("os");module.exports=K(y,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(J[160],Z([0,1,26,156,158]),function(K,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class D extends L.AbstractNativeEnvironmentService{constructor(r,f){super(r,{homeDir:(0,y.homedir)(),tmpDir:(0,y.tmpdir)(),userDataDir:(0,k.getUserDataPath)(r)},f)}}e.NativeEnvironmentService=D}),define(J[161],Z([0,1,30,26,8]),function(K,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function D(E){const r=(0,k.join)((0,L.tmpdir)(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return y.writeFileSync(r,""),E&&console.log(`Marker file for --wait created: ${r}`),r}catch(f){E&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.createWaitMarkerFile=D}),define(J[162],Z([0,1,137]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function D(b){return b=b.trim(),b==="*"||L.test(b)}e.isValidVersionStr=D;function E(b){if(!D(b))return null;if(b=b.trim(),b==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=b.match(L);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=E;function r(b){if(!b)return null;let p=b.majorBase,d=b.majorMustEqual,g=b.minorBase,I=b.minorMustEqual,v=b.patchBase,u=b.patchMustEqual;b.hasCaret&&(p===0||(I=!1),u=!1);let h=0;if(b.preRelease){const o=k.exec(b.preRelease);if(o){const[,c,i,a]=o;h=Date.UTC(Number(c),Number(i)-1,Number(a))}}return{majorBase:p,majorMustEqual:d,minorBase:g,minorMustEqual:I,patchBase:v,patchMustEqual:u,isMinimum:b.hasGreaterEquals,notBefore:h}}e.normalizeVersion=r;function f(b,p,d){let g;typeof b=="string"?g=r(E(b)):g=b;let I;p instanceof Date?I=p.getTime():typeof p=="string"&&(I=new Date(p).getTime());let v;if(typeof d=="string"?v=r(E(d)):v=d,!g||!v)return!1;let u=g.majorBase,h=g.minorBase,o=g.patchBase,c=v.majorBase,i=v.minorBase,a=v.patchBase,n=v.notBefore,s=v.majorMustEqual,l=v.minorMustEqual,m=v.patchMustEqual;return v.isMinimum?u>c?!0:u<c?!1:h>i?!0:h<i||I&&I<n?!1:o>=a:(u===1&&c===0&&(!s||!l||!m)&&(c=1,i=0,a=0,s=!0,l=!1,m=!1),u<c?!1:u>c?!s:h<i?!1:h>i?!l:o<a?!1:o>a?!m:!(I&&I<n))}e.isValidVersion=f;function w(b,p,d,g){return d.isBuiltin||typeof d.main=="undefined"?!0:P(b,p,d.engines.vscode,g)}e.isValidExtensionVersion=w;function t(b,p,d){return b==="*"||P(p,d,b)}e.isEngineValid=t;function P(b,p,d,g=[]){let I=r(E(d));if(!I)return g.push(y.localize(0,null,d)),!1;if(I.majorBase===0){if(!I.majorMustEqual||!I.minorMustEqual)return g.push(y.localize(1,null,d)),!1}else if(!I.majorMustEqual)return g.push(y.localize(2,null,d)),!1;return f(b,p,I)?!0:(g.push(y.localize(3,null,b,d)),!1)}}),define(J[163],Z([0,1,2,10,35,86]),function(K,e,y,L,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class E extends y.Disposable{constructor(f,w,t,P){super();this.folders=f,this.onDidFilesChange=w,this.onLogMessage=t,this.verboseLogging=P,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new D.Client(L.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=E.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=k.ProxyChannel.toService((0,k.getNextTickChannel)(f.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(w=>!this.isDisposed&&this.onDidFilesChange(w))),this._register(this.service.onDidLogMessage(w=>this.onLogMessage(w))),this.setFolders(this.folders)}setVerboseLogging(f){this.verboseLogging=f,!this.isDisposed&&this.service&&this.service.setVerboseLogging(f)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${f}`})}setFolders(f){this.folders=f,this.service&&this.service.setRoots(f)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=E,E.MAX_RESTARTS=5}),define(J[164],Z([0,1,2,10,35,86]),function(K,e,y,L,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class E extends y.Disposable{constructor(f,w,t,P,b={}){super();this.folders=f,this.onDidFilesChange=w,this.onLogMessage=t,this.verboseLogging=P,this.watcherOptions=b,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new D.Client(L.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=E.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=k.ProxyChannel.toService((0,k.getNextTickChannel)(f.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(w=>!this.isDisposed&&this.onDidFilesChange(w))),this._register(this.service.onDidLogMessage(w=>this.onLogMessage(w))),this.service.setRoots(this.folders)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${f}`})}setVerboseLogging(f){this.verboseLogging=f,this.service&&this.service.setVerboseLogging(f)}setFolders(f){this.folders=f,this.service&&this.service.setRoots(f)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=E,E.MAX_RESTARTS=5}),define(J[165],Z([0,1,41,111,10,80]),function(K,e,y,L,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class E{constructor(f,w,t,P,b){this.watchedFolder=f,this.eventCallback=t,this.logCallback=P,this.verboseLogging=b,this.restartCounter=0,Array.isArray(w)?this.ignored=w.map(p=>(0,L.parse)(p)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${f}, excludes: ${w.join(",")}`),this.startWatcher()}startWatcher(){const f=[this.watchedFolder];this.verboseLogging&&f.push("-verbose"),this.handle=(0,y.spawn)(k.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",K).fsPath,f);const w=new D.LineDecoder;this.handle.stdout.on("data",t=>{const P=[];for(const b of w.write(t)){const p=b.split("|");if(p.length===2){const d=Number(p[0]),g=p[1];if(d>=0&&d<3){if(this.ignored&&this.ignored.some(I=>I(g))){this.verboseLogging&&this.log(g);continue}P.push({type:E.changeTypeMap[d],path:g})}else this.log(p[1])}}P.length>0&&this.eventCallback(P)}),this.handle.on("error",t=>this.onError(t)),this.handle.stderr.on("data",t=>this.onError(t)),this.handle.on("exit",(t,P)=>this.onExit(t,P))}onError(f){this.error("process error: "+f.toString())}onExit(f,w){this.handle&&(this.error(`terminated unexpectedly (code: ${f}, signal: ${w})`),this.restartCounter<=E.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(f){this.logCallback({type:"error",message:`[File Watcher (C#)] ${f}`})}log(f){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${f}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=E,E.MAX_RESTARTS=5,E.changeTypeMap=[0,1,2]}),define(J[166],Z([0,1,8,25,165]),function(K,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class D{constructor(r,f,w,t){this.onDidFilesChange=f,this.onLogMessage=w,this.verboseLogging=t,this.service=void 0,this.folder=r[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(y.posix.sep)&&(this.folder.path=(0,L.rtrim)(this.folder.path,y.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new k.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,r=>this.onFileEvents(r),r=>this.onLogMessage(r),this.verboseLogging)}setVerboseLogging(r){this.verboseLogging=r,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(r){this.isDisposed||r.length>0&&this.onDidFilesChange(r)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=D}),define(J[69],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class y{constructor(k,D=[],E=!1){this.ctor=k,this.staticArguments=D,this.supportsDelayedInstantiation=E}}e.SyncDescriptor=y}),define(J[167],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class y{constructor(D){this.incoming=new Map,this.outgoing=new Map,this.data=D}}e.Node=y;class L{constructor(D){this._hashFn=D,this._nodes=new Map}roots(){const D=[];for(let E of this._nodes.values())E.outgoing.size===0&&D.push(E);return D}insertEdge(D,E){const r=this.lookupOrInsertNode(D),f=this.lookupOrInsertNode(E);r.outgoing.set(this._hashFn(E),f),f.incoming.set(this._hashFn(D),r)}removeNode(D){const E=this._hashFn(D);this._nodes.delete(E);for(let r of this._nodes.values())r.outgoing.delete(E),r.incoming.delete(E)}lookupOrInsertNode(D){const E=this._hashFn(D);let r=this._nodes.get(E);return r||(r=new y(D),this._nodes.set(E,r)),r}lookup(D){return this._nodes.get(this._hashFn(D))}isEmpty(){return this._nodes.size===0}toString(){let D=[];for(let[E,r]of this._nodes)D.push(`${E}, (incoming)[${[...r.incoming.keys()].join(", ")}], (outgoing)[${[...r.outgoing.keys()].join(",")}]`);return D.join(`
`)}findCycleSlow(){for(let[D,E]of this._nodes){const r=new Set([D]),f=this._findCycle(E,r);if(f)return f}}_findCycle(D,E){for(let[r,f]of D.outgoing){if(E.has(r))return[...E,r].join(" -> ");E.add(r);const w=this._findCycle(f,E);if(w)return w;E.delete(r)}}}e.Graph=L}),define(J[4],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var y;(function(r){r.serviceIds=new Map,r.DI_TARGET="$di$target",r.DI_DEPENDENCIES="$di$dependencies";function f(w){return w[r.DI_DEPENDENCIES]||[]}r.getServiceDependencies=f})(y=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function L(r,f,w,t){f[y.DI_TARGET]===f?f[y.DI_DEPENDENCIES].push({id:r,index:w,optional:t}):(f[y.DI_DEPENDENCIES]=[{id:r,index:w,optional:t}],f[y.DI_TARGET]=f)}function k(r){if(y.serviceIds.has(r))return y.serviceIds.get(r);const f=function(w,t,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(f,w,P,!1)};return f.toString=()=>r,y.serviceIds.set(r,f),f}e.createDecorator=k;function D(r){return r}e.refineServiceDecorator=D;function E(r){return function(f,w,t){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(r,f,t,!0)}}e.optional=E}),define(J[70],Z([0,1,4]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,y.createDecorator)(e.ID);function L(k){return!!k.hostName&&!!k.errorMessage}e.isRemoteDiagnosticError=L}),define(J[88],Z([0,1,4]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,y.createDecorator)("encryptionMainService");class L{constructor(D){this.machineId=D}encryption(){return new Promise((D,E)=>K(["vscode-encrypt"],D,E))}async encrypt(D){try{return(await this.encryption()).encrypt(this.machineId,D)}catch(E){return D}}async decrypt(D){try{return(await this.encryption()).decrypt(this.machineId,D)}catch(E){return D}}}e.EncryptionMainService=L}),define(J[47],Z([0,1,4]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,y.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,y.refineServiceDecorator)(e.IEnvironmentService)}),define(J[168],Z([0,1,10,3,32,136,4]),function(K,e,y,L,k,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.CURRENT_TARGET_PLATFORM=e.getTargetPlatform=e.getTargetPlatformFromOS=e.toTargetPlatform=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var r;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(r=e.TargetPlatform||(e.TargetPlatform={}));function f(v){switch(v){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=f;function w(v,u){let h;switch(v){case 1:h=3;break;case 3:h=2;break;case 2:h=1;break}return t(h,u)}e.getTargetPlatformFromOS=w;function t(v,u){switch(v){case 3:return u==="x64"?"win32-x64":u==="ia32"?"win32-ia32":u==="arm64"?"win32-arm64":"unknown";case 2:return u==="x64"?"linux-x64":u==="arm64"?"linux-arm64":u==="arm"?"linux-armhf":"unknown";case 1:return u==="x64"?"darwin-x64":u==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=t,e.CURRENT_TARGET_PLATFORM=L.isWeb?"web":t(L.platform,k.arch);function P(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}e.isIExtensionIdentifier=P;var b;(function(v){v[v.NoneOrRelevance=0]="NoneOrRelevance",v[v.LastUpdatedDate=1]="LastUpdatedDate",v[v.Title=2]="Title",v[v.PublisherName=3]="PublisherName",v[v.InstallCount=4]="InstallCount",v[v.PublishedDate=5]="PublishedDate",v[v.AverageRating=6]="AverageRating",v[v.WeightedRating=12]="WeightedRating"})(b=e.SortBy||(e.SortBy={}));var p;(function(v){v[v.Default=0]="Default",v[v.Ascending=1]="Ascending",v[v.Descending=2]="Descending"})(p=e.SortOrder||(e.SortOrder={}));var d;(function(v){v.Install="install",v.Uninstall="uninstall"})(d=e.StatisticType||(e.StatisticType={}));var g;(function(v){v[v.None=0]="None",v[v.Install=1]="Install",v[v.Update=2]="Update"})(g=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,E.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class I extends Error{constructor(u,h){super(u);this.code=h,this.name=h}}e.ExtensionManagementError=I,e.IExtensionManagementService=(0,E.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,E.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,E.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=y.FileAccess.asBrowserUri("./media/defaultIcon.png",K).toString(!0),e.ExtensionsLabel=(0,D.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,D.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,E.createDecorator)("IExtensionManagementCLIService")}),define(J[169],Z([0,1,4]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,y.createDecorator)("extensionUrlTrustService")}),define(J[170],Z([0,1,25,4]),function(K,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(t){if(typeof t=="object"&&t!==null&&t.supported!==!0)return t.description}e.getWorkspaceSupportTypeMessage=k;function D(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var E;(function(t){t[t.System=0]="System",t[t.User=1]="User"})(E=e.ExtensionType||(e.ExtensionType={}));class r{constructor(P){this.value=P,this._lower=P.toLowerCase()}static equals(P,b){if(typeof P=="undefined"||P===null)return typeof b=="undefined"||b===null;if(typeof b=="undefined"||b===null)return!1;if(typeof P=="string"||typeof b=="string"){let p=typeof P=="string"?P:P.value,d=typeof b=="string"?b:b.value;return y.equalsIgnoreCase(p,d)}return P._lower===b._lower}static toKey(P){return typeof P=="string"?P.toLowerCase():P._lower}}e.ExtensionIdentifier=r;function f(t){return t.contributes&&t.contributes.localizations?t.contributes.localizations.length>0:!1}e.isLanguagePackExtension=f;function w(t){return t.contributes&&t.contributes.authentication?t.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=w,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(J[171],Z([0,1,25,170]),function(K,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function k(d,g){return d.uuid&&g.uuid?d.uuid===g.uuid:d.id===g.id?!0:(0,y.compareIgnoreCase)(d.id,g.id)===0}e.areSameExtensions=k;class D{constructor(g,I){this.version=I,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof D?k(this,g)&&this.version===g.version:!1}}e.ExtensionIdentifierWithVersion=D;function E(d,g){return`${d}.${g}`}e.getExtensionId=E;function r(d){return d.toLocaleLowerCase()}e.adoptToGalleryExtensionId=r;function f(d,g){return r(E(d,g))}e.getGalleryExtensionId=f;function w(d,g){const I=[],v=u=>{for(const h of I)if(h.some(o=>k(g(o),g(u))))return h;return null};for(const u of d){const h=v(u);h?h.push(u):I.push([u])}return I}e.groupByExtension=w;function t(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=t;function P(d){return{id:d.identifier.id,name:d.name,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),...d.telemetryData}}e.getGalleryExtensionTelemetryData=P,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function b(d){const g=new Set;for(const I of d)I.malicious&&g.add(I.id.id);return g}e.getMaliciousExtensionsSet=b;function p(d,g){const I=[],v=g.manifest.extensionDependencies?.slice(0)??[];for(;v.length;){const u=v.shift();if(u&&I.every(h=>!k(h.identifier,{id:u}))){const h=d.filter(o=>k(o.identifier,{id:u}));h.length===1&&(I.push(h[0]),v.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return I}e.getExtensionDependencies=p}),define(J[89],Z([0,1,4]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,y.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,y.createDecorator)("externalTerminal")}),define(J[172],Z([0,1,41,10,8,3,105,19,68,138,89]),function(K,e,y,L,k,D,E,r,f,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const P=w.localize(0,null);class b{async getDefaultTerminalForPlatforms(){return{windows:p.getDefaultTerminalWindows(),linux:await g.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class p extends b{openTerminal(o,c){return this.spawnTerminal(y,o,f.getWindowsShell(),c)}spawnTerminal(o,c,i,a){const n=c.windowsExec||p.getDefaultTerminalWindows();a&&a[1]===":"&&(a=a[0].toUpperCase()+a.substr(1));const s=k.basename(n).toLowerCase();if(s==="cmder"||s==="cmder.exe")return o.spawn(n,a?[a]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return n.indexOf(" ")>=0&&l.push('""'),l.push(n),(s==="wt"||s==="wt.exe")&&l.push("-d ."),new Promise((m,S)=>{const M=I(process),A=o.spawn(i,l,{cwd:a,env:M});A.on("error",S),A.on("exit",()=>m())})}runInTerminal(o,c,i,a,n){const s="windowsExec"in n&&n.windowsExec?n.windowsExec:p.getDefaultTerminalWindows();return new Promise((l,m)=>{const S=`"${c} - ${P}"`,M=`""${i.join('" "')}" & pause"`,A=["/c","start",S,"/wait",s,"/c",M],F=Object.assign({},I(process),a);Object.keys(F).filter(ee=>F[ee]===null).forEach(ee=>delete F[ee]);const C={cwd:c,env:F,windowsVerbatimArguments:!0};y.spawn(p.CMD,A,C).on("error",ee=>{m(v(ee))}),l(void 0)})}static getDefaultTerminalWindows(){if(!p._DEFAULT_TERMINAL_WINDOWS){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");p._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return p._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=p,p.CMD="cmd.exe";class d extends b{openTerminal(o,c){return this.spawnTerminal(y,o,c)}runInTerminal(o,c,i,a,n){const s=n.osxExec||t.DEFAULT_TERMINAL_OSX;return new Promise((l,m)=>{if(s===t.DEFAULT_TERMINAL_OSX||s==="iTerm.app"){const S=s===t.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",A=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${S}.scpt`,K).fsPath,"-t",o||P,"-w",c];for(let X of i)A.push("-a"),A.push(X);if(a){const X=Object.assign({},I(process),a);for(let ee in X){const re=X[ee];re===null?(A.push("-u"),A.push(ee)):(A.push("-e"),A.push(`${ee}=${re}`))}}let F="";const C=y.spawn(d.OSASCRIPT,A);C.on("error",X=>{m(v(X))}),C.stderr.on("data",X=>{F+=X.toString()}),C.on("exit",X=>{if(X===0)l(void 0);else if(F){const ee=F.split(`
`,1);m(new Error(ee[0]))}else m(new Error(w.localize(1,null,S,X)))})}else m(new Error(w.localize(2,null,s)))})}spawnTerminal(o,c,i){const a=c.osxExec||t.DEFAULT_TERMINAL_OSX;return new Promise((n,s)=>{const l=["-a",a];i&&l.push(i);const m=I(process),S=o.spawn("/usr/bin/open",l,{cwd:i,env:m});S.on("error",s),S.on("exit",()=>n())})}}e.MacExternalTerminalService=d,d.OSASCRIPT="/usr/bin/osascript";class g extends b{openTerminal(o,c){return this.spawnTerminal(y,o,c)}runInTerminal(o,c,i,a,n){const s=n.linuxExec?Promise.resolve(n.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((l,m)=>{let S=[];s.then(M=>{M.indexOf("gnome-terminal")>=0?S.push("-x"):S.push("-e"),S.push("bash"),S.push("-c");const A=`${u(i)}; echo; read -p "${g.WAIT_MESSAGE}" -n1;`;S.push(`''${A}''`);const F=Object.assign({},I(process),a);Object.keys(F).filter(re=>F[re]===null).forEach(re=>delete F[re]);const C={cwd:c,env:F};let X="";const ee=y.spawn(M,S,C);ee.on("error",re=>{m(v(re))}),ee.stderr.on("data",re=>{X+=re.toString()}),ee.on("exit",re=>{if(re===0)l(void 0);else if(X){const Y=X.split(`
`,1);m(new Error(Y[0]))}else m(new Error(w.localize(4,null,M,re)))})})})}static async getDefaultTerminalLinuxReady(){return g._DEFAULT_TERMINAL_LINUX_READY||(g._DEFAULT_TERMINAL_LINUX_READY=new Promise(async o=>{D.isLinux?await r.Promises.exists("/etc/debian_version")?o("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?o("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?o("konsole"):process.env.COLORTERM?o(process.env.COLORTERM):process.env.TERM?o(process.env.TERM):o("xterm"):o("xterm")})),g._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(o,c,i){const a=c.linuxExec?Promise.resolve(c.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((n,s)=>{a.then(l=>{const m=I(process),S=o.spawn(l,[],{cwd:i,env:m});S.on("error",s),S.on("exit",()=>n())})})}}e.LinuxExternalTerminalService=g,g.WAIT_MESSAGE=w.localize(3,null);function I(h){const o={...h.env};return(0,E.sanitizeProcessEnvironment)(o),o}function v(h){return"errno"in h&&h.errno==="ENOENT"&&"path"in h&&typeof h.path=="string"?new Error(w.localize(5,null,h.path)):h}function u(h){let o="";for(let c of h)c.indexOf(" ")>=0?o+='"'+c+'"':o+=c,o+=" ";return o}}),define(J[20],Z([0,1,37,8,25,13,7,140,4]),function(K,e,y,L,k,D,E,r,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,f.createDecorator)("fileService");function w(W){return W.create===!0}e.isFileOpenForWriteOptions=w;var t;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(t=e.FileType||(e.FileType={}));var P;(function(W){W[W.Readonly=1]="Readonly"})(P=e.FilePermission||(e.FilePermission={}));var b;(function(W){W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock"})(b=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(W){return!!(W.capabilities&2)}e.hasReadWriteCapability=p;function d(W){return!!(W.capabilities&8)}e.hasFileFolderCopyCapability=d;function g(W){return!!(W.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function I(W){return!!(W.capabilities&16)}e.hasFileReadStreamCapability=I;var v;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(v=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class u extends Error{constructor(V,z){super(V);this.code=z}}e.FileSystemProviderError=u;function h(W,V){const z=new u(W.toString(),V);return c(z,V),z}e.createFileSystemProviderError=h;function o(W){return W||h((0,r.localize)(0,null),v.Unknown)}e.ensureFileSystemProviderError=o;function c(W,V){return W.name=V?`${V} (FileSystemError)`:"FileSystemError",W}e.markAsFileSystemProviderError=c;function i(W){if(!W)return v.Unknown;if(W instanceof u)return W.code;const V=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!V)return v.Unknown;switch(V[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileExceedsMemoryLimit:return v.FileExceedsMemoryLimit;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}e.toFileSystemProviderErrorCode=i;function a(W){if(W instanceof M)return W.fileOperationResult;switch(i(W)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 10;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileExceedsMemoryLimit:return 9;case v.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var n;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class s{constructor(V,z,$){this.resource=V,this.operation=z,this.target=$}isOperation(V){return this.operation===V}}e.FileOperationEvent=s;var l;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class m{constructor(V,z){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const $ of V)switch($.type){case 1:this.added||(this.added=y.TernarySearchTree.forUris(()=>z)),this.added.set($.resource,$);break;case 0:this.updated||(this.updated=y.TernarySearchTree.forUris(()=>z)),this.updated.set($.resource,$);break;case 2:this.deleted||(this.deleted=y.TernarySearchTree.forUris(()=>z)),this.deleted.set($.resource,$);break}}contains(V,...z){return this.doContains(V,{includeChildren:!1},...z)}affects(V,...z){return this.doContains(V,{includeChildren:!0},...z)}doContains(V,z,...$){if(!V)return!1;const j=$.length>0;return!!((!j||$.includes(1))&&(this.added?.get(V)||z.includeChildren&&this.added?.findSuperstr(V))||(!j||$.includes(0))&&(this.updated?.get(V)||z.includeChildren&&this.updated?.findSuperstr(V))||(!j||$.includes(2))&&(this.deleted?.findSubstr(V)||z.includeChildren&&this.deleted?.findSuperstr(V)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=m;function S(W,V,z){return!W||!V||W===V||V.length>W.length?!1:(V.charAt(V.length-1)!==L.sep&&(V+=L.sep),z?(0,k.startsWithIgnoreCase)(W,V):W.indexOf(V)===0)}e.isParent=S;class M extends Error{constructor(V,z,$){super(V);this.fileOperationResult=z,this.options=$}}e.FileOperationError=M;class A extends M{constructor(V,z,$){super(V,2,$);this.stat=z}}e.NotModifiedSinceFileOperationError=A;var F;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",W[W.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(F=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var C;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(C=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function X(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.etag=X;async function ee(W,V){if(!V.canHandleResource(E.URI.from({scheme:W.scheme})))return new Promise(z=>{const $=V.onDidChangeFileSystemProviderRegistrations(j=>{j.scheme===W.scheme&&j.added&&($.dispose(),z())})})}e.whenProviderRegistered=ee,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class re{static formatSize(V){return(0,D.isNumber)(V)||(V=0),V<re.KB?(0,r.localize)(1,null,V.toFixed(0)):V<re.MB?(0,r.localize)(2,null,(V/re.KB).toFixed(2)):V<re.GB?(0,r.localize)(3,null,(V/re.MB).toFixed(2)):V<re.TB?(0,r.localize)(4,null,(V/re.GB).toFixed(2)):(0,r.localize)(5,null,(V/re.TB).toFixed(2))}}e.ByteSize=re,re.KB=1024,re.MB=re.KB*re.KB,re.GB=re.MB*re.KB,re.TB=re.GB*re.KB;var Y;(function(W){W[W.IA32=0]="IA32",W[W.OTHER=1]="OTHER"})(Y=e.Arch||(e.Arch={}));function Q(W){return{maxFileSize:W===0?300*re.MB:16*re.GB,maxHeapSize:W===0?700*re.MB:2*700*re.MB}}e.getPlatformLimits=Q}),define(J[54],Z([0,1,241,135,87,20]),function(K,e,y,L,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function E(b,p){const d={onUnknownOption:I=>{console.warn((0,L.localize)(0,null,I))},onMultipleValues:(I,v)=>{console.warn((0,L.localize)(1,null,I,v))}},g=(0,k.parseArgs)(b,k.OPTIONS,p?d:void 0);return g.goto&&g._.forEach(I=>y(/^(\w:)?[^:]+(:\d*){0,2}$/.test(I),(0,L.localize)(2,null))),g["max-memory"]&&y(parseInt(g["max-memory"])>=D.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${D.MIN_MAX_MEMORY_SIZE_MB} MB.`),g}function r(b){const p=b.findIndex(d=>!/^-/.test(d));if(p>-1)return[...b.slice(0,p),...b.slice(p+1)]}function f(b){let[,...p]=b;process.env.VSCODE_DEV&&(p=r(p)||[]);const d=!P(process.env);return E(p,d)}e.parseMainProcessArgv=f;function w(b){const[,,...p]=b;return E(p,!0)}e.parseCLIProcessArgv=w;function t(b,...p){const d=b.indexOf("--");return d===-1?b.push(...p):b.splice(d,0,...p),b}e.addArg=t;function P(b){return b.VSCODE_CLI==="1"}e.isLaunchedFromCli=P}),define(J[90],Z([0,1,41,159,24,67,17,3,28,130,54]),function(K,e,y,L,k,D,E,r,f,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function P(d,g,I){return g["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):r.isWindows?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,t.isLaunchedFromCli)(I)&&!g["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,t.isLaunchedFromCli)(I)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),b||(b=new Promise(async v=>{const u=new k.CancellationTokenSource,h=setTimeout(()=>{d.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),u.dispose(!0),v({})},1e4);try{const o=await p(d,u.token);v(o)}catch(o){(0,E.isPromiseCanceledError)(o)||d.error(`[resolve shell env] Unable to resolve shell environment (${o}). Proceeding without shell environment...`),v({})}finally{clearTimeout(h),u.dispose()}})),b)}e.resolveShellEnv=P;let b;async function p(d,g){const I=new Promise(async(v,u)=>{const h=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",h);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",o);const c=(0,f.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(c+"(.*)"+c),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};d.trace("getUnixShellEnvironment#env",a);const n=await(0,w.getSystemShell)(r.OS,a);if(d.trace("getUnixShellEnvironment#shell",n),g.isCancellationRequested)return u(E.canceled);const s=L.basename(n);let l,m;/^pwsh(-preview)?$/.test(s)?(l=`& '${process.execPath}' -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,m=["-Login","-Command"]):(l=`'${process.execPath}' -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,m=["-ilc"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(m),l);const S=(0,y.spawn)(n,[...m,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});g.onCancellationRequested(()=>(S.kill(),u(E.canceled))),S.on("error",F=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,D.toErrorMessage)(F)),v({})});const M=[];S.stdout.on("data",F=>M.push(F));const A=[];S.stderr.on("data",F=>A.push(F)),S.on("close",(F,C)=>{const X=Buffer.concat(M).toString("utf8");d.trace("getUnixShellEnvironment#raw",X);const ee=Buffer.concat(A).toString("utf8");if(ee.trim()&&d.trace("getUnixShellEnvironment#stderr",ee),F||C)return u(new Error(`Failed to get environment (code ${F}, signal ${C})`));const re=i.exec(X),Y=re?re[1]:"{}";try{const Q=JSON.parse(Y);h?Q.ELECTRON_RUN_AS_NODE=h:delete Q.ELECTRON_RUN_AS_NODE,o?Q.ELECTRON_NO_ATTACH_CONSOLE=o:delete Q.ELECTRON_NO_ATTACH_CONSOLE,delete Q.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",Q),v(Q)}catch(Q){d.error("getUnixShellEnvironment#errorCaught",(0,D.toErrorMessage)(Q)),u(Q)}})});try{return await I}catch(v){return d.error("getUnixShellEnvironment#error",(0,D.toErrorMessage)(v)),{}}}}),define(J[91],Z([0,1,3,7,20]),function(K,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function D(f){return f.map(w=>({type:w.type,resource:L.URI.file(w.path)}))}e.toFileChanges=D;function E(f){const w=new r;for(const t of f)w.processEvent(t);return w.normalize()}e.normalizeFileChanges=E;class r{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(w){const t=this.mapPathToChange.get(w.path);if(t){const P=t.type,b=w.type;P===1&&b===2?(this.mapPathToChange.delete(w.path),this.normalized.splice(this.normalized.indexOf(t),1)):P===2&&b===1?t.type=0:P===1&&b===0||(t.type=b)}else this.normalized.push(w),this.mapPathToChange.set(w.path,w)}normalize(){const w=[],t=[];return this.normalized.filter(P=>P.type!==2?(w.push(P),!1):!0).sort((P,b)=>P.path.length-b.path.length).filter(P=>t.some(b=>(0,k.isParent)(P.path,b,!y.isLinux))?!1:(t.push(P.path),!0)).concat(w)}}}),define(J[173],Z([0,1,9,2,8,81,19,117,91]),function(K,e,y,L,k,D,E,r,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class w extends L.Disposable{constructor(P,b,p,d){super();this.path=P,this.onDidFilesChange=b,this.onLogMessage=p,this.verboseLogging=d,this.fileChangesDelayer=this._register(new y.ThrottledDelayer(r.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(P){this.verboseLogging=P}async startWatching(){try{const{stat:P,symbolicLink:b}=await E.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let p=this.path;if(b)try{p=await(0,D.realpath)(p)}catch(d){if(this.onError(d),b.dangling)return}P.isDirectory()?this._register((0,r.watchFolder)(p,(d,g)=>{this.onFileChange({type:d==="changed"?0:d==="added"?1:2,path:(0,k.join)(this.path,(0,k.basename)(g))})},d=>this.onError(d))):this._register((0,r.watchFile)(p,d=>{this.onFileChange({type:d==="changed"?0:2,path:this.path})},d=>this.onError(d)))}catch(P){P.code!=="ENOENT"&&this.onError(P)}}onFileChange(P){this.fileChangesBuffer.push(P),this.verboseLogging&&this.onVerbose(`${P.type===1?"[ADDED]":P.type===2?"[DELETED]":"[CHANGED]"} ${P.path}`),this.fileChangesDelayer.trigger(async()=>{const b=this.fileChangesBuffer;this.fileChangesBuffer=[];const p=(0,f.normalizeFileChanges)(b);if(this.verboseLogging)for(const d of p)this.onVerbose(`>> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`);p.length>0&&this.onDidFilesChange(p)})}onError(P){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${P}`})}onVerbose(P){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${P}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=w}),define(J[71],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class y{constructor(...k){this._entries=new Map;for(let[D,E]of k)this.set(D,E)}set(k,D){const E=this._entries.get(k);return this._entries.set(k,D),E}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=y}),define(J[174],Z([0,1,9,17,69,167,4,71]),function(K,e,y,L,k,D,E,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const f=!1;class w extends Error{constructor(d){super("cyclic dependency between services");this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class t{constructor(d=new r.ServiceCollection,g=!1,I){this._activeInstantiations=new Set,this._services=d,this._strict=g,this._parent=I,this._services.set(E.IInstantiationService,this)}createChild(d){return new t(d,this._strict,this)}invokeFunction(d,...g){let I=b.traceInvocation(d),v=!1;try{return d({get:(h,o)=>{if(v)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(h,I);if(!c&&o!==E.optional)throw new Error(`[invokeFunction] unknown service '${h}'`);return c}},...g)}finally{v=!0,I.stop()}}createInstance(d,...g){let I,v;return d instanceof k.SyncDescriptor?(I=b.traceCreation(d.ctor),v=this._createInstance(d.ctor,d.staticArguments.concat(g),I)):(I=b.traceCreation(d),v=this._createInstance(d,g,I)),I.stop(),v}_createInstance(d,g=[],I){let v=E._util.getServiceDependencies(d).sort((o,c)=>o.index-c.index),u=[];for(const o of v){let c=this._getOrCreateServiceInstance(o.id,I);if(!c&&this._strict&&!o.optional)throw new Error(`[createInstance] ${d.name} depends on UNKNOWN service ${o.id}.`);u.push(c)}let h=v.length>0?v[0].index:g.length;if(g.length!==h){console.warn(`[createInstance] First service dependency of ${d.name} at position ${h+1} conflicts with ${g.length} static arguments`);let o=h-g.length;o>0?g=g.concat(new Array(o)):g=g.slice(0,h)}return new d(...[...g,...u])}_setServiceInstance(d,g){if(this._services.get(d)instanceof k.SyncDescriptor)this._services.set(d,g);else if(this._parent)this._parent._setServiceInstance(d,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let g=this._services.get(d);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):g}_getOrCreateServiceInstance(d,g){let I=this._getServiceInstanceOrDescriptor(d);return I instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,I,g.branch(d,!0)):(g.branch(d,!1),I)}_safeCreateAndCacheServiceInstance(d,g,I){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,g,I)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,g,I){const v=new D.Graph(o=>o.id.toString());let u=0;const h=[{id:d,desc:g,_trace:I}];for(;h.length;){const o=h.pop();if(v.lookupOrInsertNode(o),u++>1e3)throw new w(v);for(let c of E._util.getServiceDependencies(o.desc.ctor)){let i=this._getServiceInstanceOrDescriptor(c.id);if(!i&&!c.optional&&console.warn(`[createInstance] ${d} depends on ${c.id} which is NOT registered.`),i instanceof k.SyncDescriptor){const a={id:c.id,desc:i,_trace:o._trace.branch(c.id,!0)};v.insertEdge(o,a),h.push(a)}}}for(;;){const o=v.roots();if(o.length===0){if(!v.isEmpty())throw new w(v);break}for(const{data:c}of o){if(this._getServiceInstanceOrDescriptor(c.id)instanceof k.SyncDescriptor){const a=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,a)}v.removeNode(c)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,g,I=[],v,u){if(this._services.get(d)instanceof k.SyncDescriptor)return this._createServiceInstance(g,I,v,u);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,g,I,v,u);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(d,g=[],I,v){if(I){const u=new y.IdleValue(()=>this._createInstance(d,g,v));return new Proxy(Object.create(null),{get(h,o){if(o in h)return h[o];let c=u.value,i=c[o];return typeof i!="function"||(i=i.bind(c),h[o]=i),i},set(h,o,c){return u.value[o]=c,!0}})}else return this._createInstance(d,g,v)}}e.InstantiationService=t;var P;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(P||(P={}));class b{constructor(d,g){this.type=d,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return f?new b(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):b._None}static traceCreation(d){return f?new b(0,d.name):b._None}branch(d,g){let I=new b(2,d.toString());return this._dep.push([d,g,I]),I}stop(){let d=Date.now()-this._start;b._totals+=d;let g=!1;function I(u,h){let o=[],c=new Array(u+1).join("	");for(const[i,a,n]of h._dep)if(a&&n){g=!0,o.push(`${c}CREATES -> ${i}`);let s=I(u+1,n);s&&o.push(s)}else o.push(`${c}uses -> ${i}`);return o.join(`
`)}let v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${I(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${b._totals.toFixed(2)}ms)`];(d>2||g)&&console.log(v.join(`
`))}}b._None=new class extends b{constructor(){super(-1,null)}stop(){}branch(){return this}},b._totals=0}),define(J[175],Z([0,1,17,128,57]),function(K,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class D extends k.ResolvedKeybinding{constructor(r,f){super();if(f.length===0)throw(0,y.illegalArgument)("parts");this._os=r,this._parts=f}getLabel(){return L.UILabelProvider.toLabel(this._os,this._parts,r=>this._getLabel(r))}getAriaLabel(){return L.AriaLabelProvider.toLabel(this._os,this._parts,r=>this._getAriaLabel(r))}getElectronAccelerator(){return this._parts.length>1?null:L.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,r=>this._getElectronAccelerator(r))}getUserSettingsLabel(){return L.UserSettingsLabelProvider.toLabel(this._os,this._parts,r=>this._getUserSettingsLabel(r))}isWYSIWYG(){return this._parts.every(r=>this._isWYSIWYG(r))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(r=>this._getPart(r))}_getPart(r){return new k.ResolvedKeybindingPart(r.ctrlKey,r.shiftKey,r.altKey,r.metaKey,this._getLabel(r),this._getAriaLabel(r))}getDispatchParts(){return this._parts.map(r=>this._getDispatchPart(r))}getSingleModifierDispatchParts(){return this._parts.map(r=>this._getSingleModifierDispatchPart(r))}}e.BaseResolvedKeybinding=D}),define(J[176],Z([0,1,57,175]),function(K,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class k extends L.BaseResolvedKeybinding{constructor(E,r){super(r,E.parts)}_keyCodeToUILabel(E){if(this._os===2)switch(E){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return y.KeyCodeUtils.toString(E)}_getLabel(E){return E.isDuplicateModifierCase()?"":this._keyCodeToUILabel(E.keyCode)}_getAriaLabel(E){return E.isDuplicateModifierCase()?"":y.KeyCodeUtils.toString(E.keyCode)}_keyCodeToElectronAccelerator(E){if(E>=93&&E<=108)return null;switch(E){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return y.KeyCodeUtils.toString(E)}_getElectronAccelerator(E){return E.isDuplicateModifierCase()?null:this._keyCodeToElectronAccelerator(E.keyCode)}_getUserSettingsLabel(E){if(E.isDuplicateModifierCase())return"";const r=y.KeyCodeUtils.toUserSettingsUS(E.keyCode);return r&&r.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(E){return k.getDispatchStr(E)}static getDispatchStr(E){if(E.isModifierKey())return null;let r="";return E.ctrlKey&&(r+="ctrl+"),E.shiftKey&&(r+="shift+"),E.altKey&&(r+="alt+"),E.metaKey&&(r+="meta+"),r+=y.KeyCodeUtils.toString(E.keyCode),r}_getSingleModifierDispatchPart(E){return E.keyCode===5&&!E.shiftKey&&!E.altKey&&!E.metaKey?"ctrl":E.keyCode===4&&!E.ctrlKey&&!E.altKey&&!E.metaKey?"shift":E.keyCode===6&&!E.ctrlKey&&!E.shiftKey&&!E.metaKey?"alt":E.keyCode===57&&!E.ctrlKey&&!E.shiftKey&&!E.altKey?"meta":null}}e.USLayoutResolvedKeybinding=k}),define(J[177],Z([0,1,9]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function L(k,D){if(k.length===0)return Promise.resolve(!1);const E=[];let r=!1;for(let f of k){if(f===!0)return Promise.resolve(!0);(0,y.isThenable)(f)&&E.push(f.then(w=>{w&&(r=!0)},w=>{D(w),r=!0}))}return y.Promises.settled(E).then(()=>r)}e.handleVetos=L}),define(J[6],Z([0,1,67,5,2,3,4]),function(K,e,y,L,k,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,E.createDecorator)("logService"),e.ILoggerService=(0,E.createDecorator)("loggerService");function r(){return new Date().toISOString()}var f;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(f=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=f.Info;class w extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=w;class t extends w{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...a){this.checkLogLevel(f.Trace)&&this.log(f.Trace,this.format([i,...a]))}debug(i,...a){this.checkLogLevel(f.Debug)&&this.log(f.Debug,this.format([i,...a]))}info(i,...a){this.checkLogLevel(f.Info)&&this.log(f.Info,this.format([i,...a]))}warn(i,...a){this.checkLogLevel(f.Warning)&&this.log(f.Warning,this.format([i,...a]))}error(i,...a){if(this.checkLogLevel(f.Error))if(i instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=i.stack,this.log(f.Error,this.format(n))}else this.log(f.Error,this.format([i,...a]))}critical(i,...a){this.checkLogLevel(f.Critical)&&this.log(f.Critical,this.format([i,...a]))}flush(){}format(i){let a="";for(let n=0;n<i.length;n++){let s=i[n];if(typeof s=="object")try{s=JSON.stringify(s)}catch(l){}a+=(n>0?" ":"")+s}return a}}e.AbstractMessageLogger=t;class P extends w{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!D.isWindows}trace(i,...a){this.getLevel()<=f.Trace&&(this.useColors?console.log(`[90m[main ${r()}][0m`,i,...a):console.log(`[main ${r()}]`,i,...a))}debug(i,...a){this.getLevel()<=f.Debug&&(this.useColors?console.log(`[90m[main ${r()}][0m`,i,...a):console.log(`[main ${r()}]`,i,...a))}info(i,...a){this.getLevel()<=f.Info&&(this.useColors?console.log(`[90m[main ${r()}][0m`,i,...a):console.log(`[main ${r()}]`,i,...a))}warn(i,...a){this.getLevel()<=f.Warning&&(this.useColors?console.warn(`[93m[main ${r()}][0m`,i,...a):console.warn(`[main ${r()}]`,i,...a))}error(i,...a){this.getLevel()<=f.Error&&(this.useColors?console.error(`[91m[main ${r()}][0m`,i,...a):console.error(`[main ${r()}]`,i,...a))}critical(i,...a){this.getLevel()<=f.Critical&&(this.useColors?console.error(`[90m[main ${r()}][0m`,i,...a):console.error(`[main ${r()}]`,i,...a))}dispose(){}flush(){}}e.ConsoleMainLogger=P;class b extends w{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...a){this.getLevel()<=f.Trace&&console.log("%cTRACE","color: #888",i,...a)}debug(i,...a){this.getLevel()<=f.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...a)}info(i,...a){this.getLevel()<=f.Info&&console.log("%c INFO","color: #33f",i,...a)}warn(i,...a){this.getLevel()<=f.Warning&&console.log("%c WARN","color: #993",i,...a)}error(i,...a){this.getLevel()<=f.Error&&console.log("%c  ERR","color: #f33",i,...a)}critical(i,...a){this.getLevel()<=f.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...a)}dispose(){}flush(){}}e.ConsoleLogger=b;class p extends w{constructor(i,a=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(a)}trace(i,...a){this.getLevel()<=f.Trace&&this.adapter.log(f.Trace,[this.extractMessage(i),...a])}debug(i,...a){this.getLevel()<=f.Debug&&this.adapter.log(f.Debug,[this.extractMessage(i),...a])}info(i,...a){this.getLevel()<=f.Info&&this.adapter.log(f.Info,[this.extractMessage(i),...a])}warn(i,...a){this.getLevel()<=f.Warning&&this.adapter.log(f.Warning,[this.extractMessage(i),...a])}error(i,...a){this.getLevel()<=f.Error&&this.adapter.log(f.Error,[this.extractMessage(i),...a])}critical(i,...a){this.getLevel()<=f.Critical&&this.adapter.log(f.Critical,[this.extractMessage(i),...a])}extractMessage(i){return typeof i=="string"?i:(0,y.toErrorMessage)(i,this.getLevel()<=f.Trace)}dispose(){}flush(){}}e.AdapterLogger=p;class d extends w{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const a of this.logServices)a.setLevel(i);super.setLevel(i)}trace(i,...a){for(const n of this.logServices)n.trace(i,...a)}debug(i,...a){for(const n of this.logServices)n.debug(i,...a)}info(i,...a){for(const n of this.logServices)n.info(i,...a)}warn(i,...a){for(const n of this.logServices)n.warn(i,...a)}error(i,...a){for(const n of this.logServices)n.error(i,...a)}critical(i,...a){for(const n of this.logServices)n.critical(i,...a)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=d;class g extends k.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...a){this.logger.trace(i,...a)}debug(i,...a){this.logger.debug(i,...a)}info(i,...a){this.logger.info(i,...a)}warn(i,...a){this.logger.warn(i,...a)}error(i,...a){this.logger.error(i,...a)}critical(i,...a){this.logger.critical(i,...a)}flush(){this.logger.flush()}}e.LogService=g;class I extends k.Disposable{constructor(i,a){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(a(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(n))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,a){let n=this.loggers.get(i.toString());return n||(n=this.doCreateLogger(i,a?.always?f.Trace:this.logLevel,a),this.loggers.set(i.toString(),n),a?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=I;class v{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(i){}getLevel(){return f.Info}trace(i,...a){}debug(i,...a){}info(i,...a){}warn(i,...a){}error(i,...a){}critical(i,...a){}dispose(){}flush(){}}e.NullLogService=v;function u(c){if(c.verbose)return f.Trace;if(typeof c.logLevel=="string"){const i=h(c.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=u;function h(c){switch(c){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Critical;case"off":return f.Off}}e.parseLogLevel=h;function o(c){switch(c){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Critical:return"critical";case f.Off:return"off"}}e.LogLevelToString=o});var te=this&&this.__param||function(K,e){return function(y,L){e(y,L,K)}};define(J[178],Z([0,1,9,18,40,77,47,20,4,6]),function(K,e,y,L,k,D,E,r,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var t;(function(b){b.ERROR_INVALID_FILE="ERROR_INVALID_FILE",b.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(t=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=(0,f.createDecorator)(e.UserConfigurationFileServiceId);let P=class{constructor(p,d,g){this.environmentService=p,this.fileService=d,this.logService=g,this.queue=new y.Queue}async updateSettings(p,d){return this.queue.queue(()=>this.doWrite(this.environmentService.settingsResource,p,d))}async doWrite(p,d,g){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,p.toString(),d);const{value:I,mtime:v,etag:u}=await this.fileService.readFile(p,{atomic:!0});let h=I.toString();const o=[];if((0,k.parse)(h,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length)throw new Error("ERROR_INVALID_FILE");const c=this.getEdits(d,h,g)[0];if(c){h=h.substring(0,c.offset)+c.content+h.substring(c.offset+c.length);try{await this.fileService.writeFile(p,L.VSBuffer.fromString(h),{etag:u,mtime:v})}catch(i){if(i.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}getEdits({value:p,path:d},g,I){return d.length?(0,D.setProperty)(g,d,p,I):[{content:JSON.stringify(p,null,I.insertSpaces&&I.tabSize?" ".repeat(I.tabSize):"	"),length:g.length,offset:0}]}};P=ue([te(0,E.IEnvironmentService),te(1,r.IFileService),te(2,w.ILogService)],P),e.UserConfigurationFileService=P}),define(J[92],Z([0,1,6]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function L(D,E){switch(E){case y.LogLevel.Trace:return D.trace;case y.LogLevel.Debug:return D.debug;case y.LogLevel.Info:return D.info;case y.LogLevel.Warning:return D.warn;case y.LogLevel.Error:return D.error;case y.LogLevel.Critical:return D.critical;default:throw new Error("Invalid log level")}}class k extends y.AbstractLogger{constructor(E=y.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(E),this._register(this.onDidChangeLogLevel(r=>{this._logger&&this._logger.setLevel(r)}))}set logger(E){this._logger=E;for(const{level:r,args:f}of this.buffer)L(E,r).apply(E,f);this.buffer=[]}_log(E,...r){this._logger?L(this._logger,E).apply(this._logger,r):this.getLevel()<=E&&this.buffer.push({level:E,args:r})}trace(E,...r){this._log(y.LogLevel.Trace,E,...r)}debug(E,...r){this._log(y.LogLevel.Debug,E,...r)}info(E,...r){this._log(y.LogLevel.Info,E,...r)}warn(E,...r){this._log(y.LogLevel.Warning,E,...r)}error(E,...r){this._log(y.LogLevel.Error,E,...r)}critical(E,...r){this._log(y.LogLevel.Critical,E,...r)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=k}),define(J[179],Z([0,1,9,18,15,20,4,92,6]),function(K,e,y,L,k,D,E,r,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const w=5*D.ByteSize.MB;let t=class extends f.AbstractLogger{constructor(p,d,g,I,v){super();this.name=p,this.resource=d,this.donotUseFormatters=I,this.fileService=v,this.backupIndex=1,this.setLevel(g),this.queue=this._register(new y.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=f.LogLevel.Trace&&this._log(f.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=f.LogLevel.Debug&&this._log(f.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=f.LogLevel.Info&&this._log(f.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=f.LogLevel.Warning&&this._log(f.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=f.LogLevel.Error){const p=arguments[0];if(p instanceof Error){const d=Array.prototype.slice.call(arguments);d[0]=p.stack,this._log(f.LogLevel.Error,this.format(d))}else this._log(f.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=f.LogLevel.Critical&&this._log(f.LogLevel.Critical,this.format(arguments))}flush(){}log(p,d){this._log(p,this.format(d))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(p){if(p.fileOperationResult!==3)throw p}}_log(p,d){this.queue.queue(async()=>{await this.initializePromise;let g=await this.loadContent();g.length>w&&(await this.fileService.writeFile(this.getBackupResource(),L.VSBuffer.fromString(g)),g=""),this.donotUseFormatters?g+=d:g+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(p)}] ${d}
`,await this.fileService.writeFile(this.resource,L.VSBuffer.fromString(g))})}getCurrentTimestamp(){const p=I=>I<10?`0${I}`:I,d=I=>I<10?`00${I}`:I<100?`0${I}`:I,g=new Date;return`${g.getFullYear()}-${p(g.getMonth()+1)}-${p(g.getDate())} ${p(g.getHours())}:${p(g.getMinutes())}:${p(g.getSeconds())}.${d(g.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,k.joinPath)((0,k.dirname)(this.resource),`${(0,k.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(p){return""}}stringifyLogLevel(p){switch(p){case f.LogLevel.Critical:return"critical";case f.LogLevel.Debug:return"debug";case f.LogLevel.Error:return"error";case f.LogLevel.Info:return"info";case f.LogLevel.Trace:return"trace";case f.LogLevel.Warning:return"warning"}return""}format(p){let d="";for(let g=0;g<p.length;g++){let I=p[g];if(typeof I=="object")try{I=JSON.stringify(I)}catch(v){}d+=(g>0?" ":"")+I}return d}};t=ue([te(4,D.IFileService)],t),e.FileLogger=t;let P=class extends f.AbstractLoggerService{constructor(p,d,g){super(p.getLevel(),p.onDidChangeLogLevel);this.instantiationService=d,this.fileService=g}doCreateLogger(p,d,g){const I=new r.BufferLogService(d);return(0,D.whenProviderRegistered)(p,this.fileService).then(()=>I.logger=this.instantiationService.createInstance(t,(0,k.basename)(p),p,I.getLevel(),!!g?.donotUseFormatters)),I}};P=ue([te(0,f.ILogService),te(1,E.IInstantiationService),te(2,D.IFileService)],P),e.FileLoggerService=P}),define(J[180],Z([0,1,5,7,6]),function(K,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class D{constructor(b){this.service=b,this.onDidChangeLogLevel=y.Event.buffer(b.onDidChangeLogLevel,!0)}listen(b,p){switch(p){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${p}`)}async call(b,p,d){switch(p){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${p}`)}}e.LogLevelChannel=D;class E{constructor(b){this.channel=b}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(b){E.setLevel(this.channel,b)}static setLevel(b,p){return b.call("setLevel",p)}}e.LogLevelChannelClient=E;class r{constructor(b){this.loggerService=b,this.loggers=new Map}listen(b,p){throw new Error(`Event not found: ${p}`)}async call(b,p,d){switch(p){case"createLogger":this.createLogger(L.URI.revive(d[0]),d[1]);return;case"log":return this.log(L.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${p}`)}createLogger(b,p){this.loggers.set(b.toString(),this.loggerService.createLogger(b,p))}consoleLog(b,p){let d=console.log;switch(b){case k.LogLevel.Error:d=console.error;break;case k.LogLevel.Warning:d=console.warn;break;case k.LogLevel.Info:d=console.info;break}d.call(console,...p)}log(b,p){const d=this.loggers.get(b.toString());if(!d)throw new Error("Create the logger before logging");for(const[g,I]of p)switch(g){case k.LogLevel.Trace:d.trace(I);break;case k.LogLevel.Debug:d.debug(I);break;case k.LogLevel.Info:d.info(I);break;case k.LogLevel.Warning:d.warn(I);break;case k.LogLevel.Error:d.error(I);break;case k.LogLevel.Critical:d.critical(I);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=r;class f extends k.AbstractLoggerService{constructor(b,p,d){super(b,p);this.channel=d}createConsoleMainLogger(){return new k.AdapterLogger({log:(b,p)=>{this.channel.call("consoleLog",[b,p])}})}doCreateLogger(b,p,d){return new w(this.channel,b,p,d)}}e.LoggerChannelClient=f;class w extends k.AbstractMessageLogger{constructor(b,p,d,g){super(g?.always);this.channel=b,this.file=p,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[p,g]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(b,p){const d=[[b,p]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(b){this.channel.call("log",[this.file,b])}}class t extends k.LogService{constructor(b,p){super(p);this.parent=b,this._register(b.onDidChangeLogLevel(d=>p.setLevel(d)))}setLevel(b){super.setLevel(b),this.parent.setLevel(b)}}e.FollowerLogService=t}),define(J[93],Z([0,1,20,6]),function(K,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function k(f,w,t,P){try{const b=await new Promise((p,d)=>{K(["spdlog"],p,d)});return b.setFlushOn(L.LogLevel.Trace),b.createAsyncRotatingLogger(f,w,t,P)}catch(b){console.error(b)}return null}function D(f,w,t,P){const b=K.__$__nodeRequire("spdlog");return b.setFlushOn(L.LogLevel.Trace),b.createRotatingLogger(f,w,t,P)}e.createRotatingLogger=D;function E(f,w,t){switch(w){case L.LogLevel.Trace:f.trace(t);break;case L.LogLevel.Debug:f.debug(t);break;case L.LogLevel.Info:f.info(t);break;case L.LogLevel.Warning:f.warn(t);break;case L.LogLevel.Error:f.error(t);break;case L.LogLevel.Critical:f.critical(t);break;default:throw new Error("Invalid log level")}}class r extends L.AbstractMessageLogger{constructor(w,t,P,b){super();this.name=w,this.filepath=t,this.rotating=P,this.buffer=[],this.setLevel(b),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(p=>{this._logger&&this._logger.setLevel(p)}))}_createSpdLogLogger(){const w=this.rotating?6:1,t=30/w*y.ByteSize.MB;return k(this.name,this.filepath,t,w).then(P=>{if(P){this._logger=P,this._logger.setLevel(this.getLevel());for(const{level:b,message:p}of this.buffer)E(this._logger,b,p);this.buffer=[]}})}log(w,t){this._logger?E(this._logger,w,t):this.getLevel()<=w&&this.buffer.push({level:w,message:t})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=r}),define(J[181],Z([0,1,10,15,28,20,179,6,93]),function(K,e,y,L,k,D,E,r,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let w=class extends r.AbstractLoggerService{constructor(P,b){super(P.getLevel(),P.onDidChangeLogLevel);this.fileService=b}doCreateLogger(P,b,p){if(P.scheme===y.Schemas.file){const d=new f.SpdLogLogger(p?.name||(0,k.generateUuid)(),P.fsPath,!p?.donotRotate,b);return p?.donotUseFormatters&&d.clearFormatters(),d}else return new E.FileLogger(p?.name??(0,L.basename)(P),P,b,!!p?.donotUseFormatters,this.fileService)}};w=ue([te(0,r.ILogService),te(1,D.IFileService)],w),e.LoggerService=w}),define(J[182],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function y(E){return E.submenu!==void 0}e.isMenubarMenuItemSubmenu=y;function L(E){return E.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=L;function k(E){return E.uri!==void 0}e.isMenubarMenuItemRecentAction=k;function D(E){return!y(E)&&!L(E)&&!k(E)}e.isMenubarMenuItemAction=D}),define(J[48],Z([0,1,10,3,32,15]),function(K,e,y,L,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let E;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const r=L.globals.vscode.context.configuration();if(r)E=r.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof K?.__$__nodeRequire=="function"){const r=(0,D.dirname)(y.FileAccess.asFileUri("",K));E=K.__$__nodeRequire((0,D.joinPath)(r,"product.json").fsPath);const f=K.__$__nodeRequire((0,D.joinPath)(r,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(E,{nameShort:`${E.nameShort} Dev`,nameLong:`${E.nameLong} Dev`,dataFolderName:`${E.dataFolderName}-dev`}),Object.assign(E,{version:f.version})}else E={},Object.keys(E).length===0&&Object.assign(E,{version:"1.61.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=E}),define(J[94],Z([0,1,18,17,141,20,48]),function(K,e,y,L,k,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function r(P,b,p,d,g,I){let v;try{await f(P,b,p,d,g,I)}catch(u){v=u}finally{v&&g.errorTransformer&&(v=g.errorTransformer(v)),typeof v!="undefined"&&p.error(v),p.end()}}e.readFileIntoStream=r;async function f(P,b,p,d,g,I){w(I);const v=await P.open(b,{create:!1});try{w(I);let u=0,h=0,o=g&&typeof g.length=="number"?g.length:void 0,c=y.VSBuffer.alloc(Math.min(g.bufferSize,typeof o=="number"?o:g.bufferSize)),i=g&&typeof g.position=="number"?g.position:0,a=0;do h=await P.read(v,i,c.buffer,a,c.byteLength-a),i+=h,a+=h,u+=h,typeof o=="number"&&(o-=h),a===c.byteLength&&(await p.write(d(c)),c=y.VSBuffer.alloc(Math.min(g.bufferSize,typeof o=="number"?o:g.bufferSize)),a=0);while(h>0&&(typeof o!="number"||o>0)&&w(I)&&t(u,g));if(a>0){let n=a;typeof o=="number"&&(n=Math.min(a,o)),p.write(d(c.slice(0,n)))}}catch(u){throw(0,D.ensureFileSystemProviderError)(u)}finally{await P.close(v)}}function w(P){if(P.isCancellationRequested)throw(0,L.canceled)();return!0}function t(P,b){if(b?.limits){if(typeof b.limits.memory=="number"&&P>b.limits.memory)throw(0,D.createFileSystemProviderError)((0,k.localize)(0,null,E.default.nameShort),D.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof b.limits.size=="number"&&P>b.limits.size)throw(0,D.createFileSystemProviderError)((0,k.localize)(1,null),D.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(J[183],Z([0,1,31,9,18,24,5,63,2,37,10,72,15,64,139,20,94,6]),function(K,e,y,L,k,D,E,r,f,w,t,P,b,p,d,g,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let u=class Ve extends f.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new E.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new E.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new E.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new E.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new E.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new E.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new E.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new L.ThrottledWorker(Ve.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ve.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ve.FILE_EVENTS_THROTTLING.coolDownDelay,c=>this._onDidFilesChange.fire(new g.FileChangesEvent(c,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new L.ThrottledWorker(Ve.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ve.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ve.FILE_EVENTS_THROTTLING.coolDownDelay,c=>this._onDidFilesChange.fire(new g.FileChangesEvent(c,!0)))),this.watchedResources=w.TernarySearchTree.forUris(c=>{const i=this.getProvider(c.scheme);return i?!this.isPathCaseSensitive(i):!1}),this.writeQueue=this._register(new L.ResourceQueue)}registerProvider(o,c){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,P.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,c),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:c});const i=new f.DisposableStore;return i.add(c.onDidChangeFile(a=>this.onDidChangeFile(a,this.isPathCaseSensitive(c)))),i.add(c.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:c,scheme:o}))),typeof c.onDidErrorOccur=="function"&&i.add(c.onDidErrorOccur(a=>this._onError.fire(new Error(a)))),(0,f.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:c}),this.provider.delete(o),(0,f.dispose)(i)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const c=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(i){c.push(i)}}),!this.provider.has(o)&&await L.Promises.settled(c)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,c){const i=this.provider.get(o.scheme);return!!(i&&i.capabilities&c)}listCapabilities(){return r.Iterable.map(this.provider,([o,c])=>({scheme:o,capabilities:c.capabilities}))}async withProvider(o){if(!(0,b.isAbsolutePath)(o))throw new g.FileOperationError((0,d.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const c=this.provider.get(o.scheme);if(!c){const i=new Error;throw i.name="ENOPRO",i.message=(0,d.localize)(1,null,o.toString()),i}return c}async withReadProvider(o){const c=await this.withProvider(o);if((0,g.hasOpenReadWriteCloseCapability)(c)||(0,g.hasReadWriteCapability)(c)||(0,g.hasFileReadStreamCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const c=await this.withProvider(o);if((0,g.hasOpenReadWriteCloseCapability)(c)||(0,g.hasReadWriteCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,c){try{return await this.doResolveFile(o,c)}catch(i){throw(0,g.toFileSystemProviderErrorCode)(i)===g.FileSystemProviderErrorCode.FileNotFound?new g.FileOperationError((0,d.localize)(2,null,this.resourceForError(o)),1):(0,g.ensureFileSystemProviderError)(i)}}async doResolveFile(o,c){const i=await this.withProvider(o),a=this.isPathCaseSensitive(i),n=c?.resolveTo,s=c?.resolveSingleChildDescendants,l=c?.resolveMetadata,m=await i.stat(o);let S;return this.toFileStat(i,o,m,void 0,!!l,(M,A)=>{if(!S&&(S=w.TernarySearchTree.forUris(()=>!a),S.set(o,!0),n))for(const F of n)S.set(F,!0);return S.get(M.resource)||S.findSuperstr(M.resource.with({query:null,fragment:null}))?!0:M.isDirectory&&s?A===1:!1})}async toFileStat(o,c,i,a,n,s){const{providerExtUri:l}=this.getExtUri(o),m={resource:c,name:l.basename(c),isFile:(i.type&g.FileType.File)!=0,isDirectory:(i.type&g.FileType.Directory)!=0,isSymbolicLink:(i.type&g.FileType.SymbolicLink)!=0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:Boolean((i.permissions??0)&g.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,g.etag)({mtime:i.mtime,size:i.size})};if(m.isDirectory&&s(m,a)){try{const S=await o.readdir(c),M=await L.Promises.settled(S.map(async([A,F])=>{try{const C=l.joinPath(c,A),X=n?await o.stat(C):{type:F};return await this.toFileStat(o,C,X,S.length,n,s)}catch(C){return this.logService.trace(C),null}}));m.children=(0,y.coalesce)(M)}catch(S){this.logService.trace(S),m.children=[]}return m}return m}async resolveAll(o){return L.Promises.settled(o.map(async c=>{try{return{stat:await this.doResolveFile(c.resource,c.options),success:!0}}catch(i){return this.logService.trace(i),{stat:void 0,success:!1}}}))}async exists(o){const c=await this.withProvider(o);try{return!!await c.stat(o)}catch(i){return!1}}async canCreateFile(o,c){try{await this.doValidateCreateFile(o,c)}catch(i){return i}return!0}async doValidateCreateFile(o,c){if(!c?.overwrite&&await this.exists(o))throw new g.FileOperationError((0,d.localize)(3,null,this.resourceForError(o)),3,c)}async createFile(o,c=k.VSBuffer.fromString(""),i){await this.doValidateCreateFile(o,i);const a=await this.writeFile(o,c);return this._onDidRunOperation.fire(new g.FileOperationEvent(o,0,a)),a}async writeFile(o,c,i){const a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:n}=this.getExtUri(a);try{await this.validateWriteFile(a,o,i)||await this.mkdirp(a,n.dirname(o));let l;if((0,g.hasReadWriteCapability)(a)&&!(c instanceof k.VSBuffer))if((0,p.isReadableStream)(c)){const m=await(0,p.peekStream)(c,3);m.ended?l=k.VSBuffer.concat(m.buffer):l=m}else l=(0,p.peekReadable)(c,m=>k.VSBuffer.concat(m),3);else l=c;!(0,g.hasOpenReadWriteCloseCapability)(a)||(0,g.hasReadWriteCapability)(a)&&l instanceof k.VSBuffer?await this.doWriteUnbuffered(a,o,i,l):await this.doWriteBuffered(a,o,i,l instanceof k.VSBuffer?(0,k.bufferToReadable)(l):l)}catch(s){throw new g.FileOperationError((0,d.localize)(4,null,this.resourceForError(o),(0,g.ensureFileSystemProviderError)(s).toString()),(0,g.toFileOperationResult)(s),i)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,c,i){if(!!i?.unlock&&!(o.capabilities&8192))throw new Error((0,d.localize)(5,null,this.resourceForError(c)));let n;try{n=await o.stat(c)}catch(s){return}if((n.type&g.FileType.Directory)!=0)throw new g.FileOperationError((0,d.localize)(6,null,this.resourceForError(c)),0,i);if(this.throwIfFileIsReadonly(c,n),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==g.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&i.mtime<n.mtime&&i.etag!==(0,g.etag)({mtime:i.mtime,size:n.size}))throw new g.FileOperationError((0,d.localize)(7,null),3,i);return n}async readFile(o,c){const i=await this.withReadProvider(o);return c?.atomic?this.doReadFileAtomic(i,o,c):this.doReadFile(i,o,c)}async doReadFileAtomic(o,c,i){return new Promise((a,n)=>{this.writeQueue.queueFor(c,this.getExtUri(o).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(o,c,i);a(s)}catch(s){n(s)}})})}async doReadFile(o,c,i){const a=await this.doReadFileStream(o,c,{...i,preferUnbuffered:!0});return{...a,value:await(0,k.streamToBuffer)(a.value)}}async readFileStream(o,c){const i=await this.withReadProvider(o);return this.doReadFileStream(i,o,c)}async doReadFileStream(o,c,i){const a=new D.CancellationTokenSource,n=this.validateReadFile(c,i).then(l=>l,l=>{throw a.cancel(),l});let s;try{return typeof i?.etag=="string"&&i.etag!==g.ETAG_DISABLED&&await n,!((0,g.hasOpenReadWriteCloseCapability)(o)||(0,g.hasFileReadStreamCapability)(o))||(0,g.hasReadWriteCapability)(o)&&i?.preferUnbuffered?s=this.readFileUnbuffered(o,c,i):(0,g.hasFileReadStreamCapability)(o)?s=this.readFileStreamed(o,c,a.token,i):s=this.readFileBuffered(o,c,a.token,i),{...await n,value:s}}catch(l){s&&await(0,p.consumeStream)(s);const m=(0,d.localize)(8,null,this.resourceForError(c),(0,g.ensureFileSystemProviderError)(l).toString());throw l instanceof g.NotModifiedSinceFileOperationError?new g.NotModifiedSinceFileOperationError(m,l.stat,i):new g.FileOperationError(m,(0,g.toFileOperationResult)(l),i)}}readFileStreamed(o,c,i,a=Object.create(null)){const n=o.readFileStream(c,a,i);return(0,p.transform)(n,{data:s=>s instanceof k.VSBuffer?s:k.VSBuffer.wrap(s),error:s=>new g.FileOperationError((0,d.localize)(9,null,this.resourceForError(c),(0,g.ensureFileSystemProviderError)(s).toString()),(0,g.toFileOperationResult)(s),a)},s=>k.VSBuffer.concat(s))}readFileBuffered(o,c,i,a=Object.create(null)){const n=(0,k.newWriteableBufferStream)();return(0,I.readFileIntoStream)(o,c,n,s=>s,{...a,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new g.FileOperationError((0,d.localize)(10,null,this.resourceForError(c),(0,g.ensureFileSystemProviderError)(s).toString()),(0,g.toFileOperationResult)(s),a)},i),n}readFileUnbuffered(o,c,i){const a=(0,p.newWriteableStream)(n=>k.VSBuffer.concat(n));return(async()=>{try{let n=await o.readFile(c);typeof i?.position=="number"&&(n=n.slice(i.position)),typeof i?.length=="number"&&(n=n.slice(0,i.length)),this.validateReadFileLimits(c,n.byteLength,i),a.end(k.VSBuffer.wrap(n))}catch(n){a.error(n),a.end()}})(),a}async validateReadFile(o,c){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new g.FileOperationError((0,d.localize)(11,null,this.resourceForError(o)),0,c);if(typeof c?.etag=="string"&&c.etag!==g.ETAG_DISABLED&&c.etag===i.etag)throw new g.NotModifiedSinceFileOperationError((0,d.localize)(12,null),i,c);return this.validateReadFileLimits(o,i.size,c),i}validateReadFileLimits(o,c,i){if(i?.limits){let a;if(typeof i.limits.memory=="number"&&c>i.limits.memory&&(a=9),typeof i.limits.size=="number"&&c>i.limits.size&&(a=7),typeof a=="number")throw new g.FileOperationError((0,d.localize)(13,null,this.resourceForError(o)),a)}}async canMove(o,c,i){return this.doCanMoveCopy(o,c,"move",i)}async canCopy(o,c,i){return this.doCanMoveCopy(o,c,"copy",i)}async doCanMoveCopy(o,c,i,a){if(o.toString()!==c.toString())try{const n=i==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c);await this.doValidateMoveCopy(n,o,s,c,i,a)}catch(n){return n}return!0}async move(o,c,i){const a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),s=await this.doMoveCopy(a,o,n,c,"move",!!i),l=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(o,s==="move"?2:3,l)),l}async copy(o,c,i){const a=await this.withReadProvider(o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),s=await this.doMoveCopy(a,o,n,c,"copy",!!i),l=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(o,s==="copy"?3:2,l)),l}async doMoveCopy(o,c,i,a,n,s){if(c.toString()===a.toString())return n;const{exists:l,isSameResourceWithDifferentPathCase:m}=await this.doValidateMoveCopy(o,c,i,a,n,s);if(l&&!m&&s&&await this.del(a,{recursive:!0}),await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(a)),n==="copy"){if(o===i&&(0,g.hasFileFolderCopyCapability)(o))await o.copy(c,a,{overwrite:s});else{const S=await this.resolve(c);S.isDirectory?await this.doCopyFolder(o,S,i,a):await this.doCopyFile(o,c,i,a)}return n}else return o===i?(await o.rename(c,a,{overwrite:s}),n):(await this.doMoveCopy(o,c,i,a,"copy",s),await this.del(c,{recursive:!0}),"copy")}async doCopyFile(o,c,i,a){if((0,g.hasOpenReadWriteCloseCapability)(o)&&(0,g.hasOpenReadWriteCloseCapability)(i))return this.doPipeBuffered(o,c,i,a);if((0,g.hasOpenReadWriteCloseCapability)(o)&&(0,g.hasReadWriteCapability)(i))return this.doPipeBufferedToUnbuffered(o,c,i,a);if((0,g.hasReadWriteCapability)(o)&&(0,g.hasOpenReadWriteCloseCapability)(i))return this.doPipeUnbufferedToBuffered(o,c,i,a);if((0,g.hasReadWriteCapability)(o)&&(0,g.hasReadWriteCapability)(i))return this.doPipeUnbuffered(o,c,i,a)}async doCopyFolder(o,c,i,a){await i.mkdir(a),Array.isArray(c.children)&&await L.Promises.settled(c.children.map(async n=>{const s=this.getExtUri(i).providerExtUri.joinPath(a,n.name);return n.isDirectory?this.doCopyFolder(o,await this.resolve(n.resource),i,s):this.doCopyFile(o,n.resource,i,s)}))}async doValidateMoveCopy(o,c,i,a,n,s){let l=!1;if(o===i){const{providerExtUri:S,isPathCaseSensitive:M}=this.getExtUri(o);if(M||(l=S.isEqual(c,a)),l&&n==="copy")throw new Error((0,d.localize)(14,null,this.resourceForError(c),this.resourceForError(a)));if(!l&&S.isEqualOrParent(a,c))throw new Error((0,d.localize)(15,null,this.resourceForError(c),this.resourceForError(a)))}const m=await this.exists(a);if(m&&!l){if(!s)throw new g.FileOperationError((0,d.localize)(16,null,this.resourceForError(c),this.resourceForError(a)),4);if(o===i){const{providerExtUri:S}=this.getExtUri(o);if(S.isEqualOrParent(c,a))throw new Error((0,d.localize)(17,null,this.resourceForError(c),this.resourceForError(a)))}}return{exists:m,isSameResourceWithDifferentPathCase:l}}getExtUri(o){const c=this.isPathCaseSensitive(o);return{providerExtUri:c?b.extUri:b.extUriIgnorePathCase,isPathCaseSensitive:c}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const c=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(c,o);const i=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(o,0,i)),i}async mkdirp(o,c){const i=[],{providerExtUri:a}=this.getExtUri(o);for(;!a.isEqual(c,a.dirname(c));)try{if(((await o.stat(c)).type&g.FileType.Directory)==0)throw new Error((0,d.localize)(18,null,this.resourceForError(c)));break}catch(n){if((0,g.toFileSystemProviderErrorCode)(n)!==g.FileSystemProviderErrorCode.FileNotFound)throw n;i.push(a.basename(c)),c=a.dirname(c)}for(let n=i.length-1;n>=0;n--){c=a.joinPath(c,i[n]);try{await o.mkdir(c)}catch(s){if((0,g.toFileSystemProviderErrorCode)(s)!==g.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(o,c){try{await this.doValidateDelete(o,c)}catch(i){return i}return!0}async doValidateDelete(o,c){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!c?.useTrash&&!(i.capabilities&4096))throw new Error((0,d.localize)(19,null,this.resourceForError(o)));let n;try{n=await i.stat(o)}catch(l){}if(n)this.throwIfFileIsReadonly(o,n);else throw new g.FileOperationError((0,d.localize)(20,null,this.resourceForError(o)),1);if(!!!c?.recursive){const l=await this.resolve(o);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,d.localize)(21,null,this.resourceForError(o)))}return i}async del(o,c){const i=await this.doValidateDelete(o,c),a=!!c?.useTrash,n=!!c?.recursive;await i.delete(o,{recursive:n,useTrash:a}),this._onDidRunOperation.fire(new g.FileOperationEvent(o,1))}onDidChangeFile(o,c){this._onDidChangeFilesRaw.fire({changes:o});let i,a;{for(const n of o)this.watchedResources.has(n.resource)?(i||(i=[]),i.push(n)):(a||(a=[]),a.push(n));i&&this._onDidFilesChange.fire(new g.FileChangesEvent(i,!c))}if(a){const n=c?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(a)&&Ve.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${a.length}, most recent change: ${a[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${a[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,c={recursive:!1,excludes:[]}){const i=new f.DisposableStore;{let a=!1,n=()=>{a=!0};i.add((0,f.toDisposable)(()=>n())),this.doWatch(o,c).then(s=>{a?(0,f.dispose)(s):n=()=>(0,f.dispose)(s)},s=>this.logService.error(s))}return c.recursive||(this.watchedResources.set(o,(this.watchedResources.get(o)??0)+1),i.add((0,f.toDisposable)(()=>{const a=this.watchedResources.get(o);typeof a=="number"&&(a<=1?this.watchedResources.delete(o):this.watchedResources.set(o,a-1))}))),i}async doWatch(o,c){const i=await this.withProvider(o),a=this.toWatchKey(i,o,c),n=this.activeWatchers.get(a)||{count:0,disposable:i.watch(o,c)};return this.activeWatchers.has(a)||this.activeWatchers.set(a,n),n.count+=1,(0,f.toDisposable)(()=>{n.count--,n.count===0&&((0,f.dispose)(n.disposable),this.activeWatchers.delete(a))})}toWatchKey(o,c,i){const{providerExtUri:a}=this.getExtUri(o);return[a.getComparisonKey(c),String(i.recursive),i.excludes.join()].join()}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,f.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,c,i,a){return this.writeQueue.queueFor(c,this.getExtUri(o).providerExtUri).queue(async()=>{const n=await o.open(c,{create:!0,unlock:i?.unlock??!1});try{(0,p.isReadableStream)(a)||(0,p.isReadableBufferedStream)(a)?await this.doWriteStreamBufferedQueued(o,n,a):await this.doWriteReadableBufferedQueued(o,n,a)}catch(s){throw(0,g.ensureFileSystemProviderError)(s)}finally{await o.close(n)}})}async doWriteStreamBufferedQueued(o,c,i){let a=0,n;if((0,p.isReadableBufferedStream)(i)){if(i.buffer.length>0){const s=k.VSBuffer.concat(i.buffer);await this.doWriteBuffer(o,c,s,s.byteLength,a,0),a+=s.byteLength}if(i.ended)return;n=i.stream}else n=i;return new Promise(async(s,l)=>{(0,p.listenStream)(n,{onData:async m=>{n.pause();try{await this.doWriteBuffer(o,c,m,m.byteLength,a,0)}catch(S){return l(S)}a+=m.byteLength,setTimeout(()=>n.resume())},onError:m=>l(m),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(o,c,i){let a=0,n;for(;(n=i.read())!==null;)await this.doWriteBuffer(o,c,n,n.byteLength,a,0),a+=n.byteLength}async doWriteBuffer(o,c,i,a,n,s){let l=0;for(;l<a;)l+=await o.write(c,n+l,i.buffer,s+l,a-l)}async doWriteUnbuffered(o,c,i,a){return this.writeQueue.queueFor(c,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,c,i,a))}async doWriteUnbufferedQueued(o,c,i,a){let n;a instanceof k.VSBuffer?n=a:(0,p.isReadableStream)(a)?n=await(0,k.streamToBuffer)(a):(0,p.isReadableBufferedStream)(a)?n=await(0,k.bufferedStreamToBuffer)(a):n=(0,k.readableToBuffer)(a),await o.writeFile(c,n.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async doPipeBuffered(o,c,i,a){return this.writeQueue.queueFor(a,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,c,i,a))}async doPipeBufferedQueued(o,c,i,a){let n,s;try{n=await o.open(c,{create:!1}),s=await i.open(a,{create:!0,unlock:!1});const l=k.VSBuffer.alloc(this.BUFFER_SIZE);let m=0,S=0,M=0;do M=await o.read(n,m,l.buffer,S,l.byteLength-S),await this.doWriteBuffer(i,s,l,M,m,S),m+=M,S+=M,S===l.byteLength&&(S=0);while(M>0)}catch(l){throw(0,g.ensureFileSystemProviderError)(l)}finally{await L.Promises.settled([typeof n=="number"?o.close(n):Promise.resolve(),typeof s=="number"?i.close(s):Promise.resolve()])}}async doPipeUnbuffered(o,c,i,a){return this.writeQueue.queueFor(a,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,c,i,a))}async doPipeUnbufferedQueued(o,c,i,a){return i.writeFile(a,await o.readFile(c),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,c,i,a){return this.writeQueue.queueFor(a,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,c,i,a))}async doPipeUnbufferedToBufferedQueued(o,c,i,a){const n=await i.open(a,{create:!0,unlock:!1});try{const s=await o.readFile(c);await this.doWriteBuffer(i,n,k.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,g.ensureFileSystemProviderError)(s)}finally{await i.close(n)}}async doPipeBufferedToUnbuffered(o,c,i,a){const n=await(0,k.streamToBuffer)(this.readFileBuffered(o,c,D.CancellationToken.None));await this.doWriteUnbuffered(i,a,void 0,n)}throwIfFileSystemIsReadonly(o,c){if(o.capabilities&2048)throw new g.FileOperationError((0,d.localize)(22,null,this.resourceForError(c)),6);return o}throwIfFileIsReadonly(o,c){if((c.permissions??0)&g.FilePermission.Readonly)throw new g.FileOperationError((0,d.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===t.Schemas.file?o.fsPath:o.toString(!0)}};u.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},u=ue([te(0,v.ILogService)],u),e.FileService=u}),define(J[184],Z([0,1,31,9,18,5,29,2,8,3,15,64,19,142,20,94,173,163,164,91,166,6]),function(K,e,y,L,k,D,E,r,f,w,t,P,b,p,d,g,I,v,u,h,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class i extends r.Disposable{constructor(n,s){super();this.logService=n,this.options=s,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=D.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new D.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,w.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:s,symbolicLink:l}=await b.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(s,l),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size}}catch(s){throw this.toFileSystemProviderError(s)}}async readdir(n){try{const s=await b.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),l=[];return await Promise.all(s.map(async m=>{try{let S;m.isSymbolicLink()?S=(await this.stat((0,t.joinPath)(n,m.name))).type:S=this.toType(m),l.push([m.name,S])}catch(S){this.logService.trace(S)}})),l}catch(s){throw this.toFileSystemProviderError(s)}}toType(n,s){let l;return s?.dangling?l=d.FileType.Unknown:n.isFile()?l=d.FileType.File:n.isDirectory()?l=d.FileType.Directory:l=d.FileType.Unknown,s&&(l|=d.FileType.SymbolicLink),l}async readFile(n){try{const s=this.toFilePath(n);return await b.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}}readFileStream(n,s,l){const m=(0,P.newWriteableStream)(S=>k.VSBuffer.concat(S.map(M=>k.VSBuffer.wrap(M))).buffer);return(0,g.readFileIntoStream)(this,n,m,S=>S.buffer,{...s,bufferSize:this.BUFFER_SIZE},l),m}async writeFile(n,s,l){let m;try{const S=this.toFilePath(n);if(!l.create||!l.overwrite){if(await b.Promises.exists(S)){if(!l.overwrite)throw(0,d.createFileSystemProviderError)((0,p.localize)(0,null),d.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw(0,d.createFileSystemProviderError)((0,p.localize)(1,null),d.FileSystemProviderErrorCode.FileNotFound)}m=await this.open(n,{create:!0,unlock:l.unlock}),await this.write(m,0,s,0,s.byteLength)}catch(S){throw await this.toFileSystemProviderWriteError(n,S)}finally{typeof m=="number"&&await this.close(m)}}async open(n,s){try{const l=this.toFilePath(n);if((0,d.isFileOpenForWriteOptions)(s)&&s.unlock)try{const{stat:M}=await b.SymlinkSupport.stat(l);M.mode&128||await b.Promises.chmod(l,M.mode|128)}catch(M){this.logService.trace(M)}let m;if((0,d.isFileOpenForWriteOptions)(s)){if(w.isWindows)try{await b.Promises.truncate(l,0),m="r+"}catch(M){M.code!=="ENOENT"&&this.logService.trace(M)}m||(m="w")}else m="r";const S=await b.Promises.open(l,m);return this.mapHandleToPos.set(S,0),(0,d.isFileOpenForWriteOptions)(s)&&this.writeHandles.set(S,n),S}catch(l){throw(0,d.isFileOpenForWriteOptions)(s)?await this.toFileSystemProviderWriteError(n,l):this.toFileSystemProviderError(l)}}async close(n){try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&this.canFlush)try{await b.Promises.fdatasync(n)}catch(s){this.canFlush=!1,this.logService.error(s)}return await b.Promises.close(n)}catch(s){throw this.toFileSystemProviderError(s)}}async read(n,s,l,m,S){const M=this.normalizePos(n,s);let A=null;try{const F=await b.Promises.read(n,l,m,S,M);return typeof F=="number"?A=F:A=F.bytesRead,A}catch(F){throw this.toFileSystemProviderError(F)}finally{this.updatePos(n,M,A)}}normalizePos(n,s){return s===this.mapHandleToPos.get(n)?null:s}updatePos(n,s,l){const m=this.mapHandleToPos.get(n);typeof m=="number"&&(typeof s=="number"||(typeof l=="number"?this.mapHandleToPos.set(n,m+l):this.mapHandleToPos.delete(n)))}async write(n,s,l,m,S){return(0,L.retry)(()=>this.doWrite(n,s,l,m,S),100,3)}async doWrite(n,s,l,m,S){const M=this.normalizePos(n,s);let A=null;try{const F=await b.Promises.write(n,l,m,S,M);return typeof F=="number"?A=F:A=F.bytesWritten,A}catch(F){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),F)}finally{this.updatePos(n,M,A)}}async mkdir(n){try{await b.Promises.mkdir(this.toFilePath(n))}catch(s){throw this.toFileSystemProviderError(s)}}async delete(n,s){try{const l=this.toFilePath(n);await this.doDelete(l,s)}catch(l){throw this.toFileSystemProviderError(l)}}async doDelete(n,s){s.recursive?await b.Promises.rm(n,b.RimRafMode.MOVE):await b.Promises.unlink(n)}async rename(n,s,l){const m=this.toFilePath(n),S=this.toFilePath(s);if(m!==S)try{await this.validateTargetDeleted(n,s,"move",l.overwrite),await b.Promises.move(m,S)}catch(M){throw(M.code==="EINVAL"||M.code==="EBUSY"||M.code==="ENAMETOOLONG")&&(M=new Error((0,p.localize)(2,null,(0,f.basename)(m),(0,f.basename)((0,f.dirname)(S)),M.toString()))),this.toFileSystemProviderError(M)}}async copy(n,s,l){const m=this.toFilePath(n),S=this.toFilePath(s);if(m!==S)try{await this.validateTargetDeleted(n,s,"copy",l.overwrite),await b.Promises.copy(m,S,{preserveSymlinks:!0})}catch(M){throw(M.code==="EINVAL"||M.code==="EBUSY"||M.code==="ENAMETOOLONG")&&(M=new Error((0,p.localize)(3,null,(0,f.basename)(m),(0,f.basename)((0,f.dirname)(S)),M.toString()))),this.toFileSystemProviderError(M)}}async validateTargetDeleted(n,s,l,m){const S=this.toFilePath(n),M=this.toFilePath(s);let A=!1;if(!!(this.capabilities&1024)||(A=(0,E.isEqual)(S,M,!0)),A&&l==="copy")throw(0,d.createFileSystemProviderError)((0,p.localize)(4,null),d.FileSystemProviderErrorCode.FileExists);if(!A&&await b.Promises.exists(M)){if(!m)throw(0,d.createFileSystemProviderError)((0,p.localize)(5,null),d.FileSystemProviderErrorCode.FileExists);await this.delete(s,{recursive:!0,useTrash:!1})}}watch(n,s){return s.recursive?this.watchRecursive(n,s.excludes):this.watchNonRecursive(n)}watchRecursive(n,s){const l={path:this.toFilePath(n),excludes:s},m=(0,y.insert)(this.recursiveFoldersToWatch,l);return this.refreshRecursiveWatchers(),(0,r.toDisposable)(()=>{m(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof v.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,r.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let n,s;this.options?.watcher?.usePolling?(n=u.FileWatcher,s=this.options?.watcher):this.recursiveFoldersToWatch.length===1?w.isWindows?n=o.FileWatcher:n=u.FileWatcher:n=v.FileWatcher,this.recursiveWatcher=new n(this.recursiveFoldersToWatch,l=>this._onDidChangeFile.fire((0,h.toFileChanges)(l)),l=>{l.type==="error"&&this._onDidWatchErrorOccur.fire(l.message),this.logService[l.type](l.message)},this.logService.getLevel()===c.LogLevel.Trace,s),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===c.LogLevel.Trace)}))}}watchNonRecursive(n){const s=new I.FileWatcher(this.toFilePath(n),m=>this._onDidChangeFile.fire((0,h.toFileChanges)(m)),m=>{m.type==="error"&&this._onDidWatchErrorOccur.fire(m.message),this.logService[m.type](m.message)},this.logService.getLevel()===c.LogLevel.Trace),l=this.logService.onDidChangeLogLevel(()=>{s.setVerboseLogging(this.logService.getLevel()===c.LogLevel.Trace)});return(0,r.combinedDisposable)(s,l)}toFilePath(n){return(0,f.normalize)(n.fsPath)}toFileSystemProviderError(n){if(n instanceof d.FileSystemProviderError)return n;let s;switch(n.code){case"ENOENT":s=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=d.FileSystemProviderErrorCode.NoPermissions;break;default:s=d.FileSystemProviderErrorCode.Unknown}return(0,d.createFileSystemProviderError)(n,s)}async toFileSystemProviderWriteError(n,s){let l=this.toFileSystemProviderError(s);if(n&&l.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:m}=await b.SymlinkSupport.stat(this.toFilePath(n));m.mode&128||(l=(0,d.createFileSystemProviderError)(s,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(m){this.logService.trace(m)}return l}dispose(){super.dispose(),(0,r.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,r.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=i}),define(J[21],Z([0,1,4]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,y.createDecorator)("productService")}),define(J[185],Z([0,1,58,6,21]),function(K,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let D=class{constructor(r,f){this.productService=r,this.logService=f,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(r,f){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const w=/^(.*)#([^#]+)$/.exec(f);if(!w)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",f),!1;const[,t,P]=w;let b=this.trustedExtensionUrlPublicKeys.get(r);if(!b){if(b=this.productService.trustedExtensionUrlPublicKeys[r],!b||b.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",r),!1;this.trustedExtensionUrlPublicKeys.set(r,[...b])}const p=Buffer.from(decodeURIComponent(P),"base64");if(p.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",f),!1;const d=p.slice(0,6),g=p.readUIntBE(0,6),I=Date.now()-g;if(I<0||I>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",f),!1;const v=p.slice(6),u=y.createVerify("SHA256");u.write(d),u.write(Buffer.from(t)),u.end();for(let h=0;h<b.length;h++){let o=b[h];if(o!==null){if(typeof o=="string")try{o=y.createPublicKey({key:Buffer.from(o,"base64"),format:"der",type:"spki"}),b[h]=o}catch(c){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${h+1} for ${r}:`,c),b[h]=null;continue}if(u.verify(o,v))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",f),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",f),!1}};D=ue([te(0,k.IProductService),te(1,L.ILogService)],D),e.ExtensionUrlTrustService=D}),define(J[55],Z([0,1,4]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,y.createDecorator)("protocolMainService")}),define(J[186],Z([0,1,14,2,37,10,3,15,7,28,47,6]),function(K,e,y,L,k,D,E,r,f,w,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let b=class extends L.Disposable{constructor(d,g){super();this.logService=g,this.validRoots=k.TernarySearchTree.forUris(()=>!E.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(f.URI.file(d.appRoot)),this.addValidFileRoot(f.URI.file(d.extensionsPath)),this.addValidFileRoot(d.globalStorageHome),this.addValidFileRoot(d.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:d}=y.session;d.protocol.registerFileProtocol(D.Schemas.vscodeFileResource,(g,I)=>this.handleResourceRequest(g,I)),d.protocol.interceptFileProtocol(D.Schemas.file,(g,I)=>this.handleFileRequest(g,I)),this._register((0,L.toDisposable)(()=>{d.protocol.unregisterProtocol(D.Schemas.vscodeFileResource),d.protocol.uninterceptProtocol(D.Schemas.file)}))}addValidFileRoot(d){return this.validRoots.get(d)?L.Disposable.None:(this.validRoots.set(d,!0),(0,L.toDisposable)(()=>this.validRoots.delete(d)))}handleFileRequest(d,g){const I=f.URI.parse(d.url);return this.logService.error(`Refused to load resource ${I.fsPath} from ${D.Schemas.file}: protocol (original URL: ${d.url})`),g({error:-3})}handleResourceRequest(d,g){const I=f.URI.parse(d.url),v=D.FileAccess.asFileUri(I);return this.validRoots.findSubstr(v)?g({path:v.fsPath}):this.validExtensions.has((0,r.extname)(v))?g({path:v.fsPath}):(this.logService.error(`${D.Schemas.vscodeFileResource}: Refused to load resource ${v.fsPath} from ${D.Schemas.vscodeFileResource}: protocol (original URL: ${d.url})`),g({error:-3}))}createIPCObjectUrl(){let d;const g=f.URI.from({scheme:"vscode",path:(0,w.generateUuid)()}),I=g.toString(),v=async()=>d;return y.ipcMain.handle(I,v),this.logService.trace(`IPC Object URL: Registered new channel ${I}.`),{resource:g,update:u=>d=u,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${I}.`),y.ipcMain.removeHandler(I)}}}};b=ue([te(0,t.INativeEnvironmentService),te(1,P.ILogService)],b),e.ProtocolMainService=b}),define(J[38],Z([0,1,102,13]),function(K,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(E,r){y.ok(L.isString(E)),y.ok(L.isObject(r)),y.ok(!this.data.has(E),"There is already an extension with this id"),this.data.set(E,r)}knows(E){return this.data.has(E)}as(E){return this.data.get(E)||null}}e.Registry=new k}),define(J[187],Z([0,1,5,38]),function(K,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(r){return r.length>0&&r.charAt(r.length-1)==="#"?r.substring(0,r.length-1):r}class D{constructor(){this._onDidChangeSchema=new y.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(f,w){this.schemasById[k(f)]=w,this._onDidChangeSchema.fire(f)}notifySchemaChanged(f){this._onDidChangeSchema.fire(f)}getSchemaContributions(){return{schemas:this.schemasById}}}const E=new D;L.Registry.add(e.Extensions.JSONContribution,E)}),define(J[49],Z([0,1,5,13,132,187,38]),function(K,e,y,L,k,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var r;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(r=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var f;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(f=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const w=E.Registry.as(D.Extensions.JSONContribution);class t{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new y.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new y.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(u,h=!0){this.registerConfigurations([u],h)}registerConfigurations(u,h=!0){const o=[];u.forEach(c=>{o.push(...this.validateAndRegisterProperties(c,h,c.extensionInfo)),this.configurationContributors.push(c),this.registerJSONConfiguration(c)}),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterConfigurations(u){const h=[],o=c=>{if(c.properties)for(const i in c.properties)h.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,c.properties[i]);c.allOf&&c.allOf.forEach(i=>o(i))};for(const c of u){o(c);const i=this.configurationContributors.indexOf(c);i!==-1&&this.configurationContributors.splice(i,1)}w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}registerDefaultConfigurations(u){const h=[],o=[];for(const c of u)for(const i in c)if(h.push(i),e.OVERRIDE_PROPERTY_PATTERN.test(i)){this.defaultValues[i]={...this.defaultValues[i]||{},...c[i]};const a={type:"object",default:this.defaultValues[i],description:k.localize(1,null,i),$ref:e.resourceLanguageSettingsSchemaId};o.push(b(i)),this.configurationProperties[i]=a,this.defaultLanguageConfigurationOverridesNode.properties[i]=a}else{this.defaultValues[i]=c[i];const a=this.configurationProperties[i];a&&(this.updatePropertyDefaultValue(i,a),this.updateSchema(i,a))}this.registerOverrideIdentifiers(o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}deregisterDefaultConfigurations(u){const h=[];for(const o of u)for(const c in o)if(h.push(c),delete this.defaultValues[c],e.OVERRIDE_PROPERTY_PATTERN.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const i=this.configurationProperties[c];i&&(this.updatePropertyDefaultValue(c,i),this.updateSchema(c,i))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}notifyConfigurationSchemaUpdated(...u){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(u){for(const h of u)this.overrideIdentifiers.add(h);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(u,h=!0,o,c=3){c=L.isUndefinedOrNull(u.scope)?c:u.scope;let i=[],a=u.properties;if(a)for(let s in a){if(h&&g(s)){delete a[s];continue}const l=a[s];if(this.updatePropertyDefaultValue(s,l),e.OVERRIDE_PROPERTY_PATTERN.test(s)?l.scope=void 0:(l.scope=L.isUndefinedOrNull(l.scope)?c:l.scope,l.restricted=L.isUndefinedOrNull(l.restricted)?!!o?.restrictedConfigurations?.includes(s):l.restricted),a[s].hasOwnProperty("included")&&!a[s].included){this.excludedConfigurationProperties[s]=a[s],delete a[s];continue}else this.configurationProperties[s]=a[s];!a[s].deprecationMessage&&a[s].markdownDeprecationMessage&&(a[s].deprecationMessage=a[s].markdownDeprecationMessage),i.push(s)}let n=u.allOf;if(n)for(let s of n)i.push(...this.validateAndRegisterProperties(s,h,o,c));return i}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(u){const h=o=>{let c=o.properties;if(c)for(const a in c)this.updateSchema(a,c[a]);let i=o.allOf;i&&i.forEach(h)};h(u)}updateSchema(u,h){switch(e.allSettings.properties[u]=h,h.scope){case 1:e.applicationSettings.properties[u]=h;break;case 2:e.machineSettings.properties[u]=h;break;case 6:e.machineOverridableSettings.properties[u]=h;break;case 3:e.windowSettings.properties[u]=h;break;case 4:e.resourceSettings.properties[u]=h;break;case 5:e.resourceSettings.properties[u]=h,this.resourceLanguageSettingsSchema.properties[u]=h;break}}removeFromSchema(u,h){switch(delete e.allSettings.properties[u],h.scope){case 1:delete e.applicationSettings.properties[u];break;case 2:delete e.machineSettings.properties[u];break;case 6:delete e.machineOverridableSettings.properties[u];break;case 3:delete e.windowSettings.properties[u];break;case 4:case 5:delete e.resourceSettings.properties[u];break}}updateOverridePropertyPatternKey(){for(const u of this.overrideIdentifiers.values()){const h=`[${u}]`,o={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(h,o),e.allSettings.properties[h]=o,e.applicationSettings.properties[h]=o,e.machineSettings.properties[h]=o,e.machineOverridableSettings.properties[h]=o,e.windowSettings.properties[h]=o,e.resourceSettings.properties[h]=o}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(u,h){let o=this.defaultValues[u];L.isUndefined(o)&&(o=h.default),L.isUndefined(o)&&(o=p(h.type)),h.default=o}}const P="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(P);function b(v){return v.substring(1,v.length-1)}e.overrideIdentifierFromKey=b;function p(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=p;const d=new t;E.Registry.add(e.Extensions.Configuration,d);function g(v){return v.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(v)?k.localize(5,null,v):d.getConfigurationProperties()[v]!==void 0?k.localize(6,null,v):null:k.localize(4,null)}e.validateProperty=g;function I(){const v=[],u=d.getConfigurationProperties();for(const h of Object.keys(u))v.push([h,u[h].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.getScopes=I}),define(J[16],Z([0,1,44,13,7,49,4,38]),function(K,e,y,L,k,D,E,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,E.createDecorator)("configurationService");function f(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof k.URI)}e.isConfigurationOverrides=f;var w;(function(a){a[a.USER=1]="USER",a[a.USER_LOCAL=2]="USER_LOCAL",a[a.USER_REMOTE=3]="USER_REMOTE",a[a.WORKSPACE=4]="WORKSPACE",a[a.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",a[a.DEFAULT=6]="DEFAULT",a[a.MEMORY=7]="MEMORY"})(w=e.ConfigurationTarget||(e.ConfigurationTarget={}));function t(a){switch(a){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=t;function P(a,n){const s=n?a?n.keys.filter(C=>a.keys.indexOf(C)===-1):[...n.keys]:[],l=a?n?a.keys.filter(C=>n.keys.indexOf(C)===-1):[...a.keys]:[],m=[];if(n&&a){for(const C of a.keys)if(n.keys.indexOf(C)!==-1){const X=v(a.contents,C),ee=v(n.contents,C);y.equals(X,ee)||m.push(C)}}const S=[],M=C=>{const X={};for(const ee of C)for(const re of ee.identifiers)X[c(re)]=ee;return X},A=n?M(n.overrides):{},F=a?M(a.overrides):{};if(Object.keys(A).length)for(const C of s){const X=A[C];X&&S.push([(0,D.overrideIdentifierFromKey)(C),X.keys])}if(Object.keys(F).length)for(const C of l){const X=F[C];X&&S.push([(0,D.overrideIdentifierFromKey)(C),X.keys])}if(Object.keys(A).length&&Object.keys(F).length)for(const C of m){const X=F[C],ee=A[C];if(X&&ee){const re=P({contents:X.contents,keys:X.keys,overrides:[]},{contents:ee.contents,keys:ee.keys,overrides:[]});S.push([(0,D.overrideIdentifierFromKey)(C),[...re.added,...re.removed,...re.updated]])}}return{added:s,removed:l,updated:m,overrides:S}}e.compare=P;function b(a,n){const s=[];for(const l of Object.keys(a))if(D.OVERRIDE_PROPERTY_PATTERN.test(l)){const m={};for(const S in a[l])m[S]=a[l][S];s.push({identifiers:[(0,D.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(m),contents:p(m,n)})}return s}e.toOverrides=b;function p(a,n){const s=Object.create(null);for(let l in a)d(s,l,a[l],n);return s}e.toValuesTree=p;function d(a,n,s,l){const m=n.split("."),S=m.pop();let M=a;for(let A=0;A<m.length;A++){let F=m[A],C=M[F];switch(typeof C){case"undefined":C=M[F]=Object.create(null);break;case"object":break;default:l(`Ignoring ${n} as ${m.slice(0,A+1).join(".")} is ${JSON.stringify(C)}`);return}M=C}if(typeof M=="object"&&M!==null)try{M[S]=s}catch(A){l(`Ignoring ${n} as ${m.join(".")} is ${JSON.stringify(M)}`)}else l(`Ignoring ${n} as ${m.join(".")} is ${JSON.stringify(M)}`)}e.addToValueTree=d;function g(a,n){const s=n.split(".");I(a,s)}e.removeFromValueTree=g;function I(a,n){const s=n.shift();if(n.length===0){delete a[s];return}if(Object.keys(a).indexOf(s)!==-1){const l=a[s];typeof l=="object"&&!Array.isArray(l)&&(I(l,n),Object.keys(l).length===0&&delete a[s])}}function v(a,n,s){function l(M,A){let F=M;for(const C of A){if(typeof F!="object"||F===null)return;F=F[C]}return F}const m=n.split("."),S=l(a,m);return typeof S=="undefined"?s:S}e.getConfigurationValue=v;function u(a,n,s){Object.keys(n).forEach(l=>{l!=="__proto__"&&(l in a?L.isObject(a[l])&&L.isObject(n[l])?u(a[l],n[l],s):s&&(a[l]=n[l]):a[l]=n[l])})}e.merge=u;function h(){const a=r.Registry.as(D.Extensions.Configuration).getConfigurationProperties();return Object.keys(a)}e.getConfigurationKeys=h;function o(){const a=Object.create(null),n=r.Registry.as(D.Extensions.Configuration).getConfigurationProperties();for(let s in n){let l=n[s].default;d(a,s,l,m=>console.error(`Conflict in default settings: ${m}`))}return a}e.getDefaultValues=o;function c(a){return`[${a}]`}e.keyFromOverrideIdentifier=c;function i(a,n,s){const l=a.inspect(n),m=a.inspect(s);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:l.defaultValue}e.getMigratedSettingValue=i}),define(J[188],Z([0,1,31,5,40,2,37,44,13,7,16,49,38]),function(K,e,y,L,k,D,E,r,f,w,t,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(i={},a=[],n=[]){this._contents=i,this._keys=a,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,t.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,a){const n=this.getContentsForOverrideIdentifer(a);return n?i?(0,t.getConfigurationValue)(n,i):n:void 0}getKeysForOverrideIdentifier(i){for(const a of this.overrides)if(a.identifiers.indexOf(i)!==-1)return a.keys;return[]}override(i){const a=this.getContentsForOverrideIdentifer(i);if(!a||typeof a!="object"||!Object.keys(a).length)return this;let n={};for(const s of y.distinct([...Object.keys(this.contents),...Object.keys(a)])){let l=this.contents[s],m=a[s];m&&(typeof l=="object"&&typeof m=="object"?(l=r.deepClone(l),this.mergeContents(l,m)):l=m),n[s]=l}return new p(n,this.keys,this.overrides)}merge(...i){const a=r.deepClone(this.contents),n=r.deepClone(this.overrides),s=[...this.keys];for(const l of i){this.mergeContents(a,l.contents);for(const m of l.overrides){const[S]=n.filter(M=>y.equals(M.identifiers,m.identifiers));S?this.mergeContents(S.contents,m.contents):n.push(r.deepClone(m))}for(const m of l.keys)s.indexOf(m)===-1&&s.push(m)}return new p(a,s,n)}freeze(){return this.isFrozen=!0,this}mergeContents(i,a){for(const n of Object.keys(a)){if(n in i&&f.isObject(i[n])&&f.isObject(a[n])){this.mergeContents(i[n],a[n]);continue}i[n]=r.deepClone(a[n])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?r.deepFreeze(i):i}getContentsForOverrideIdentifer(i){for(const a of this.overrides)if(a.identifiers.indexOf(i)!==-1)return a.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,a){this.addKey(i),(0,t.addToValueTree)(this.contents,i,a,n=>{throw new Error(n)})}removeValue(i){this.removeKey(i)&&(0,t.removeFromValueTree)(this.contents,i)}addKey(i){let a=this.keys.length;for(let n=0;n<a;n++)i.indexOf(this.keys[n])===0&&(a=n);this.keys.splice(a,1,i)}removeKey(i){let a=this.keys.indexOf(i);return a!==-1?(this.keys.splice(a,1),!0):!1}}e.ConfigurationModel=p;class d extends p{constructor(){const i=(0,t.getDefaultValues)(),a=(0,t.getConfigurationKeys)(),n=[];for(const s of Object.keys(i))P.OVERRIDE_PROPERTY_PATTERN.test(s)&&n.push({identifiers:[(0,P.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(i[s]),contents:(0,t.toValuesTree)(i[s],l=>console.error(`Conflict in default settings file: ${l}`))});super(i,a,n)}}e.DefaultConfigurationModel=d;class g{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,a){if(!f.isUndefinedOrNull(i)){const n=this.doParseContent(i);this.parseRaw(n,a)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,a){this._raw=i;const{contents:n,keys:s,overrides:l,restricted:m}=this.doParseRaw(i,a);this._configurationModel=new p(n,s,l),this._restrictedConfigurations=m||[]}doParseContent(i){let a={},n=null,s=[],l=[],m=[];function S(A){Array.isArray(s)?s.push(A):n!==null&&(s[n]=A)}let M={onObjectBegin:()=>{let A={};S(A),l.push(s),s=A,n=null},onObjectProperty:A=>{n=A},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{let A=[];S(A),l.push(s),s=A,n=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:S,onError:(A,F,C)=>{m.push({error:A,offset:F,length:C})}};if(i)try{k.visit(i,M),a=s[0]||{}}catch(A){console.error(`Error while parsing settings file ${this._name}: ${A}`),this._parseErrors=[A]}return a}doParseRaw(i,a){const n=b.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),s=this.filter(i,n,!0,a);i=s.raw;const l=(0,t.toValuesTree)(i,M=>console.error(`Conflict in settings file ${this._name}: ${M}`)),m=Object.keys(i),S=(0,t.toOverrides)(i,M=>console.error(`Conflict in settings file ${this._name}: ${M}`));return{contents:l,keys:m,overrides:S,restricted:s.restricted}}filter(i,a,n,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:i,restricted:[]};const l={},m=[];for(let S in i)if(P.OVERRIDE_PROPERTY_PATTERN.test(S)&&n){const M=this.filter(i[S],a,!1,s);l[S]=M.raw,m.push(...M.restricted)}else{const M=a[S],A=M?typeof M.scope!="undefined"?M.scope:3:void 0;M?.restricted&&m.push(S),(A===void 0||s.scopes===void 0||s.scopes.includes(A))&&(s.skipRestricted&&M?.restricted||(l[S]=i[S]))}return{raw:l,restricted:m}}}e.ConfigurationModelParser=g;class I extends D.Disposable{constructor(i,a,n,s){super();this.userSettingsResource=i,this.scopes=a,this.fileService=s,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(i){return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=I;class v{constructor(i,a,n=new p,s=new p,l=new E.ResourceMap,m=new p,S=new E.ResourceMap,M=!0){this._defaultConfiguration=i,this._localUserConfiguration=a,this._remoteUserConfiguration=n,this._workspaceConfiguration=s,this._folderConfigurations=l,this._memoryConfiguration=m,this._memoryConfigurationByResource=S,this._freeze=M,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new E.ResourceMap,this._userConfiguration=null}getValue(i,a,n){return this.getConsolidateConfigurationModel(a,n).getValue(i)}updateValue(i,a,n={}){let s;n.resource?(s=this._memoryConfigurationByResource.get(n.resource),s||(s=new p,this._memoryConfigurationByResource.set(n.resource,s))):s=this._memoryConfiguration,a===void 0?s.removeValue(i):s.setValue(i,a),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,a,n){const s=this.getConsolidateConfigurationModel(a,n),l=this.getFolderConfigurationModelForResource(a.resource,n),m=a.resource?this._memoryConfigurationByResource.get(a.resource)||this._memoryConfiguration:this._memoryConfiguration,S=a.overrideIdentifier?this._defaultConfiguration.freeze().override(a.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),M=a.overrideIdentifier?this.userConfiguration.freeze().override(a.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),A=a.overrideIdentifier?this.localUserConfiguration.freeze().override(a.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),F=a.overrideIdentifier?this.remoteUserConfiguration.freeze().override(a.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),C=n?a.overrideIdentifier?this._workspaceConfiguration.freeze().override(a.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,X=l?a.overrideIdentifier?l.freeze().override(a.overrideIdentifier).getValue(i):l.freeze().getValue(i):void 0,ee=a.overrideIdentifier?m.override(a.overrideIdentifier).getValue(i):m.getValue(i),re=s.getValue(i),Y=y.distinct(y.flatten(s.overrides.map(Q=>Q.identifiers))).filter(Q=>s.getOverrideValue(i,Q)!==void 0);return{defaultValue:S,userValue:M,userLocalValue:A,userRemoteValue:F,workspaceValue:C,workspaceFolderValue:X,memoryValue:ee,value:re,default:S!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:a.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,user:M!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:a.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,userLocal:A!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:a.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,userRemote:F!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:a.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,workspace:C!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:a.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,workspaceFolder:X!==void 0?{value:l?.freeze().getValue(i),override:a.overrideIdentifier?l?.freeze().getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,memory:ee!==void 0?{value:m.getValue(i),override:a.overrideIdentifier?m.getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,overrideIdentifiers:Y.length?Y:void 0}}keys(i){const a=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:a?a.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,a){this._folderConfigurations.set(i,a),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,a){const n=a.filter(s=>P.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const l=(0,P.overrideIdentifierFromKey)(s),m=this._defaultConfiguration.getKeysForOverrideIdentifier(l),S=i.getKeysForOverrideIdentifier(l),M=[...S.filter(A=>m.indexOf(A)===-1),...m.filter(A=>S.indexOf(A)===-1),...m.filter(A=>!r.equals(this._defaultConfiguration.override(l).getValue(A),i.override(l).getValue(A)))];return[l,M]});return this.updateDefaultConfiguration(i),{keys:a,overrides:n}}compareAndUpdateLocalUserConfiguration(i){const{added:a,updated:n,removed:s,overrides:l}=(0,t.compare)(this.localUserConfiguration,i),m=[...a,...n,...s];return m.length&&this.updateLocalUserConfiguration(i),{keys:m,overrides:l}}compareAndUpdateRemoteUserConfiguration(i){const{added:a,updated:n,removed:s,overrides:l}=(0,t.compare)(this.remoteUserConfiguration,i);let m=[...a,...n,...s];return m.length&&this.updateRemoteUserConfiguration(i),{keys:m,overrides:l}}compareAndUpdateWorkspaceConfiguration(i){const{added:a,updated:n,removed:s,overrides:l}=(0,t.compare)(this.workspaceConfiguration,i);let m=[...a,...n,...s];return m.length&&this.updateWorkspaceConfiguration(i),{keys:m,overrides:l}}compareAndUpdateFolderConfiguration(i,a){const n=this.folderConfigurations.get(i),{added:s,updated:l,removed:m,overrides:S}=(0,t.compare)(n,a);let M=[...s,...l,...m];return(M.length||!n)&&this.updateFolderConfiguration(i,a),{keys:M,overrides:S}}compareAndDeleteFolderConfiguration(i){const a=this.folderConfigurations.get(i);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:n,updated:s,removed:l,overrides:m}=(0,t.compare)(a,void 0);return{keys:[...n,...s,...l],overrides:m}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,a){let n=this.getConsolidatedConfigurationModelForResource(i,a);return i.overrideIdentifier?n.override(i.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:i},a){let n=this.getWorkspaceConsolidatedConfiguration();if(a&&i){const s=a.getFolder(i);s&&(n=this.getFolderConsolidatedConfiguration(s.uri)||n);const l=this._memoryConfigurationByResource.get(i);l&&(n=n.merge(l))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let a=this._foldersConsolidatedConfigurations.get(i);if(!a){const n=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(i);s?(a=n.merge(s),this._freeze&&(a=a.freeze()),this._foldersConsolidatedConfigurations.set(i,a)):a=n}return a}getFolderConfigurationModelForResource(i,a){if(a&&i){const n=a.getFolder(i);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,a)=>{const{contents:n,overrides:s,keys:l}=this._folderConfigurations.get(a);return i.push([a,{contents:n,overrides:s,keys:l}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(a=>i.add(a)),this.userConfiguration.freeze().keys.forEach(a=>i.add(a)),this._workspaceConfiguration.freeze().keys.forEach(a=>i.add(a)),this._folderConfigurations.forEach(a=>a.freeze().keys.forEach(n=>i.add(n))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const a=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(n=>a.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(n=>a.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(n=>a.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(i).forEach(s=>a.add(s))),[...a.values()]}static parse(i){const a=this.parseConfigurationModel(i.defaults),n=this.parseConfigurationModel(i.user),s=this.parseConfigurationModel(i.workspace),l=i.folders.reduce((m,S)=>(m.set(w.URI.revive(S[0]),this.parseConfigurationModel(S[1])),m),new E.ResourceMap);return new v(a,n,new p,s,l,new p,new E.ResourceMap,!1)}static parseConfigurationModel(i){return new p(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=v;function u(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const i=new Set,a=new Map;for(const s of c)s.keys.forEach(l=>i.add(l)),s.overrides.forEach(([l,m])=>{const S=(0,E.getOrSet)(a,l,new Set);m.forEach(M=>S.add(M))});const n=[];return a.forEach((s,l)=>n.push([l,[...s.values()]])),{keys:[...i.values()],overrides:n}}e.mergeChanges=u;class h{constructor(i,a,n,s){this.change=i,this.previous=a,this.currentConfiguraiton=n,this.currentWorkspace=s,this._previousConfiguration=void 0;const l=new Set;i.keys.forEach(S=>l.add(S)),i.overrides.forEach(([,S])=>S.forEach(M=>l.add(M))),this.affectedKeys=[...l.values()];const m=new p;this.affectedKeys.forEach(S=>m.setValue(S,{})),this.affectedKeysTree=m.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,a){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(a){const n=this.previousConfiguration?this.previousConfiguration.getValue(i,a,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(i,a,this.currentWorkspace);return!r.equals(n,s)}return!0}return!1}doesAffectedKeysTreeContains(i,a){let n=(0,t.toValuesTree)({[a]:!0},()=>{}),s;for(;typeof n=="object"&&(s=Object.keys(n)[0]);){if(i=i[s],!i)return!1;n=n[s]}return!0}}e.ConfigurationChangeEvent=h;class o extends h{constructor(i,a,n,s){super({keys:i.allKeys(),overrides:[]},void 0,i,a);this.source=n,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=o}),define(J[189],Z([0,1,9,5,2,15,16,188,49,38]),function(K,e,y,L,k,D,E,r,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class t extends k.Disposable{constructor(b,p){super();this.settingsResource=b,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new r.UserSettings(this.settingsResource,void 0,D.extUriBiasedIgnorePathCase,p)),this.configuration=new r.Configuration(new r.DefaultConfigurationModel,new r.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new y.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(w.Registry.as(f.Extensions.Configuration).onDidUpdateConfiguration(d=>this.onDidDefaultConfigurationChange(d))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const b=await this.userConfiguration.loadConfiguration();this.configuration=new r.Configuration(new r.DefaultConfigurationModel,b)}getConfigurationData(){return this.configuration.toData()}getValue(b,p){const d=typeof b=="string"?b:void 0,g=(0,E.isConfigurationOverrides)(b)?b:(0,E.isConfigurationOverrides)(p)?p:{};return this.configuration.getValue(d,g,void 0)}updateValue(b,p,d,g){return Promise.reject(new Error("not supported"))}inspect(b){return this.configuration.inspect(b,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const b=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(b)}onDidChangeUserConfiguration(b){const p=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(b);this.trigger(d,p,1)}onDidDefaultConfigurationChange(b){const p=this.configuration.toData(),d=this.configuration.compareAndUpdateDefaultConfiguration(new r.DefaultConfigurationModel,b);this.trigger(d,p,6)}trigger(b,p,d){const g=new r.ConfigurationChangeEvent(b,{data:p},this.configuration);g.source=d,g.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(g)}getTargetConfiguration(b){switch(b){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=t}),define(J[190],Z([0,1,4]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,y.createDecorator)("remoteAuthorityResolverService");var L;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class k extends Error{constructor(E,r=L.Unknown,f){super(E);this._message=E,this._code=r,this._detail=f,this.isHandled=r===L.NotAvailable&&f===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,k.prototype)}static isTemporarilyNotAvailable(E){return E instanceof k&&E._code===L.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof k&&E._code===L.NoResolverFound}static isHandled(E){return E instanceof k&&E.isHandled}}e.RemoteAuthorityResolverError=k}),define(J[191],Z([0,1,9,18,24,17,5,2,28,83,190]),function(K,e,y,L,k,D,E,r,f,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const P=30*1e3;var b;(function(T){T[T.Management=1]="Management",T[T.ExtensionHost=2]="ExtensionHost",T[T.Tunnel=3]="Tunnel"})(b=e.ConnectionType||(e.ConnectionType={}));function p(T){switch(T){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function d(T){const R=new k.CancellationTokenSource;return setTimeout(()=>R.cancel(),T),R.token}function g(T,R){if(T.isCancellationRequested||R.isCancellationRequested)return k.CancellationToken.Cancelled;const O=new k.CancellationTokenSource;return T.onCancellationRequested(()=>O.cancel()),R.onCancellationRequested(()=>O.cancel()),O.token}class I{constructor(R){this._state="pending",this._disposables=new r.DisposableStore,this.promise=new Promise((O,_)=>{this._resolvePromise=O,this._rejectPromise=_}),R.isCancellationRequested?this._timeout():this._disposables.add(R.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(R){this._state==="pending"?this._disposables.add(R):R.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const R=new Error("Time limit reached");return R.code="ETIMEDOUT",R.syscall="connect",R}resolve(R){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(R))}reject(R){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(R))}}function v(T,R){const O=new I(R);return O.registerDisposable(T.onControlMessage(_=>{const N=JSON.parse(_.toString()),B=z(N);B?O.reject(B):O.resolve(N)})),O.promise}function u(T,R,O,_,N,B){const H=new I(B);return R.connect(O,_,N,(x,ie)=>{H.didTimeout?(x&&T.error(x),ie?.dispose()):x||!ie?H.reject(x):H.resolve(ie)}),H.promise}function h(T,R){const O=new I(R);return T.then(_=>{O.didTimeout||O.resolve(_)},_=>{O.didTimeout||O.reject(_)}),O.promise}async function o(T,R,O,_){const N=U(T,R);T.logService.trace(`${N} 1/6. invoking socketFactory.connect().`);let B;try{B=await u(T.logService,T.socketFactory,T.host,T.port,`reconnectionToken=${T.reconnectionToken}&reconnection=${T.reconnectionProtocol?"true":"false"}`,_)}catch(ae){throw T.logService.error(`${N} socketFactory.connect() failed or timed out. Error:`),T.logService.error(ae),ae}T.logService.trace(`${N} 2/6. socketFactory.connect() was successful.`);let H,x;T.reconnectionProtocol?(T.reconnectionProtocol.beginAcceptReconnection(B,null),H=T.reconnectionProtocol,x=!1):(H=new w.PersistentProtocol(B,null),x=!0),T.logService.trace(`${N} 3/6. sending AuthRequest control message.`);const ie={type:"auth",auth:T.connectionToken||"00000000000000000000"};H.sendControl(L.VSBuffer.fromString(JSON.stringify(ie)));try{const ae=await v(H,g(_,d(1e4)));if(ae.type!=="sign"||typeof ae.data!="string"){const le=new Error("Unexpected handshake message");throw le.code="VSCODE_CONNECTION_ERROR",le}T.logService.trace(`${N} 4/6. received SignRequest control message.`);const oe=await h(T.signService.sign(ae.data),_),se={type:"connectionType",commit:T.commit,signedData:oe,desiredConnectionType:R};return O&&(se.args=O),T.logService.trace(`${N} 5/6. sending ConnectionTypeRequest control message.`),H.sendControl(L.VSBuffer.fromString(JSON.stringify(se))),{protocol:H,ownsProtocol:x}}catch(ae){throw ae&&ae.code==="ETIMEDOUT"&&(T.logService.error(`${N} the handshake timed out. Error:`),T.logService.error(ae)),ae&&ae.code==="VSCODE_CONNECTION_ERROR"&&(T.logService.error(`${N} received error control message when negotiating connection. Error:`),T.logService.error(ae)),x&&V(H),ae}}async function c(T,R,O,_){const N=Date.now(),B=U(T,R),{protocol:H,ownsProtocol:x}=await o(T,R,O,_),ie=new I(_);return ie.registerDisposable(H.onControlMessage(ae=>{const oe=JSON.parse(ae.toString()),se=z(oe);se?(T.logService.error(`${B} received error control message when negotiating connection. Error:`),T.logService.error(se),x&&V(H),ie.reject(se)):(T.reconnectionProtocol&&T.reconnectionProtocol.endAcceptReconnection(),T.logService.trace(`${B} 6/6. handshake finished, connection is up and running after ${q(N)}!`),ie.resolve({protocol:H,firstMessage:oe}))})),ie.promise}async function i(T,R){const{protocol:O}=await c(T,1,void 0,R);return{protocol:O}}async function a(T,R,O){const{protocol:_,firstMessage:N}=await c(T,2,R,O),B=N&&N.debugPort;return{protocol:_,debugPort:B}}async function n(T,R,O){const _=Date.now(),N=U(T,3),{protocol:B}=await o(T,3,R,O);return T.logService.trace(`${N} 6/6. handshake finished, connection is up and running after ${q(_)}!`),B}async function s(T,R,O){const{host:_,port:N,connectionToken:B}=await T.addressProvider.getAddress();return{commit:T.commit,host:_,port:N,connectionToken:B,reconnectionToken:R,reconnectionProtocol:O,socketFactory:T.socketFactory,signService:T.signService,logService:T.logService}}async function l(T,R,O){try{const _=(0,f.generateUuid)(),N=await s(T,_,null),{protocol:B}=await i(N,k.CancellationToken.None);return new Q(T,R,O,_,B)}catch(_){throw T.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),T.logService.error(_),Y.triggerPermanentFailure(0,0,t.RemoteAuthorityResolverError.isHandled(_)),_}}e.connectRemoteAgentManagement=l;async function m(T,R){try{const O=(0,f.generateUuid)(),_=await s(T,O,null),{protocol:N,debugPort:B}=await a(_,R,k.CancellationToken.None);return new W(T,R,O,N,B)}catch(O){throw T.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),T.logService.error(O),Y.triggerPermanentFailure(0,0,t.RemoteAuthorityResolverError.isHandled(O)),O}}e.connectRemoteAgentExtensionHost=m;async function S(T,R,O){const _=await s(T,(0,f.generateUuid)(),null);return await n(_,{host:R,port:O},k.CancellationToken.None)}e.connectRemoteAgentTunnel=S;function M(T){return(0,y.createCancelablePromise)(R=>new Promise((O,_)=>{const N=setTimeout(O,T*1e3);R.onCancellationRequested(()=>{clearTimeout(N),O()})}))}var A;(function(T){T[T.ConnectionLost=0]="ConnectionLost",T[T.ReconnectionWait=1]="ReconnectionWait",T[T.ReconnectionRunning=2]="ReconnectionRunning",T[T.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",T[T.ConnectionGain=4]="ConnectionGain"})(A=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class F{constructor(R,O){this.reconnectionToken=R,this.millisSinceLastIncomingData=O,this.type=0}}e.ConnectionLostEvent=F;class C{constructor(R,O,_,N){this.reconnectionToken=R,this.millisSinceLastIncomingData=O,this.durationSeconds=_,this.cancellableTimer=N,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=C;class X{constructor(R,O,_){this.reconnectionToken=R,this.millisSinceLastIncomingData=O,this.attempt=_,this.type=2}}e.ReconnectionRunningEvent=X;class ee{constructor(R,O,_){this.reconnectionToken=R,this.millisSinceLastIncomingData=O,this.attempt=_,this.type=4}}e.ConnectionGainEvent=ee;class re{constructor(R,O,_,N){this.reconnectionToken=R,this.millisSinceLastIncomingData=O,this.attempt=_,this.handled=N,this.type=3}}e.ReconnectionPermanentFailureEvent=re;class Y extends r.Disposable{constructor(R,O,_,N){super();this._connectionType=R,this._onDidStateChange=this._register(new E.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=O,this.reconnectionToken=_,this.protocol=N,this._isReconnecting=!1,this._onDidStateChange.fire(new ee(this.reconnectionToken,0,0)),this._register(N.onSocketClose(B=>{const H=j(this._connectionType,this.reconnectionToken,!0);B?B.type===0?(this._options.logService.info(`${H} received socket close event (hadError: ${B.hadError}).`),B.error&&this._options.logService.error(B.error)):(this._options.logService.info(`${H} received socket close event (wasClean: ${B.wasClean}, code: ${B.code}, reason: ${B.reason}).`),B.event&&this._options.logService.error(B.event)):this._options.logService.info(`${H} received socket close event.`),this._beginReconnecting()})),this._register(N.onSocketTimeout(()=>{const B=j(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${B} received socket timeout event.`),this._beginReconnecting()})),Y._instances.push(this),Y._permanentFailure&&this._gotoPermanentFailure(Y._permanentFailureMillisSinceLastIncomingData,Y._permanentFailureAttempt,Y._permanentFailureHandled)}static triggerPermanentFailure(R,O,_){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=R,this._permanentFailureAttempt=O,this._permanentFailureHandled=_,this._instances.forEach(N=>N._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(Y._permanentFailure)return;const R=j(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${R} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const O=[0,5,5,10,10,10,10,10,30];let _=-1;do{_++;const N=_<O.length?O[_]:O[O.length-1];try{if(N>0){const H=M(N);this._onDidStateChange.fire(new C(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N,H)),this._options.logService.info(`${R} waiting for ${N} seconds before reconnecting...`);try{await H}catch{}}if(Y._permanentFailure){this._options.logService.error(`${R} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new X(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_+1)),this._options.logService.info(`${R} resolving connection...`);const B=await s(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${R} connecting to ${B.host}:${B.port}...`),await this._reconnect(B,d(P)),this._options.logService.info(`${R} reconnected!`),this._onDidStateChange.fire(new ee(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_+1));break}catch(B){if(B.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${R} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(B),Y.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}if(_>360){this._options.logService.error(`${R} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(B),Y.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}if(t.RemoteAuthorityResolverError.isTemporarilyNotAvailable(B)){this._options.logService.info(`${R} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(B);continue}if((B.code==="ETIMEDOUT"||B.code==="ENETUNREACH"||B.code==="ECONNREFUSED"||B.code==="ECONNRESET")&&B.syscall==="connect"){this._options.logService.info(`${R} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(B);continue}if((0,D.isPromiseCanceledError)(B)){this._options.logService.info(`${R} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(B);continue}if(B instanceof t.RemoteAuthorityResolverError){this._options.logService.error(`${R} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(B),Y.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),_+1,t.RemoteAuthorityResolverError.isHandled(B));break}this._options.logService.error(`${R} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(B),Y.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}}while(!Y._permanentFailure)}_gotoPermanentFailure(R,O,_){this._onDidStateChange.fire(new re(this.reconnectionToken,R,O,_)),V(this.protocol)}}Y._permanentFailure=!1,Y._permanentFailureMillisSinceLastIncomingData=0,Y._permanentFailureAttempt=0,Y._permanentFailureHandled=!1,Y._instances=[];class Q extends Y{constructor(R,O,_,N,B){super(1,R,N,B);this.client=this._register(new w.Client(B,{remoteAuthority:O,clientId:_},R.ipcLogger))}async _reconnect(R,O){await i(R,O)}}e.ManagementPersistentConnection=Q;class W extends Y{constructor(R,O,_,N,B){super(2,R,_,N);this._startArguments=O,this.debugPort=B}async _reconnect(R,O){await a(R,this._startArguments,O)}}e.ExtensionHostPersistentConnection=W;function V(T){try{T.acceptDisconnect();const R=T.getSocket();T.dispose(),R.dispose()}catch(R){(0,D.onUnexpectedError)(R)}}function z(T){if(T&&T.type==="error"){const R=new Error(`Connection error: ${T.reason}`);return R.code="VSCODE_CONNECTION_ERROR",R}return null}function $(T,R){for(;T.length<R;)T+=" ";return T}function j(T,R,O){return`[remote-connection][${$(p(T),13)}][${R.substr(0,5)}\u2026][${O?"reconnect":"initial"}]`}function U(T,R){return`${j(R,T.reconnectionToken,!!T.reconnectionProtocol)}[${T.host}:${T.port}]`}function q(T){return`${Date.now()-T} ms`}}),define(J[73],Z([0,1,10]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(w){return w.scheme===y.Schemas.vscodeRemote?w.authority:void 0}e.getRemoteAuthority=L;function k(w){if(!w)return;const t=w.indexOf("+");return t<0?w:w.substr(0,t)}e.getRemoteName=k;function D(w){return w.scheme!==y.Schemas.file&&w.scheme!==y.Schemas.vscodeRemote}e.isVirtualResource=D;function E(w){if(w.folders.length)return w.folders.every(t=>D(t.uri))?w.folders[0].uri:void 0;if(w.configuration&&D(w.configuration))return w.configuration}e.getVirtualWorkspaceLocation=E;function r(w){return E(w)?.scheme}e.getVirtualWorkspaceScheme=r;function f(w){return E(w)!==void 0}e.isVirtualWorkspace=f}),define(J[95],Z([0,1,5,3,4,6]),function(K,e,y,L,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService");var E;(function(p){p.Http="http",p.Https="https"})(E=e.TunnelProtocol||(e.TunnelProtocol={}));var r;(function(p){p[p.Notify=1]="Notify",p[p.OpenBrowser=2]="OpenBrowser",p[p.OpenPreview=3]="OpenPreview",p[p.Silent=4]="Silent",p[p.Ignore=5]="Ignore",p[p.OpenBrowserOnce=6]="OpenBrowserOnce"})(r=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function f(p){if(p.scheme!=="http"&&p.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(p.authority);if(!!d)return{address:d[1],port:+d[2]}}e.extractLocalHostUriMetaDataForPortMapping=f,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function w(p){return e.LOCALHOST_ADDRESSES.indexOf(p)>=0}e.isLocalhost=w,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function t(p){return e.ALL_INTERFACES_ADDRESSES.indexOf(p)>=0}e.isAllInterfaces=t;function P(p,d){return d?d!==1&&p<1024:!L.isWindows&&p<1024}e.isPortPrivileged=P;let b=class{constructor(d){this.logService=d,this._onTunnelOpened=new y.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new y.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new y.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(d,g){return this._tunnelProvider=d,d?(this._canElevate=g.elevation,this._canMakePublic=g.public,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async d=>{const g=[],I=Array.from(this._tunnels.values());for(let v of I){const u=Array.from(v.values());for(let h of u){const o=await h.value;o&&g.push(o)}}d(g)})}async dispose(){for(const d of this._tunnels.values()){for(const{value:g}of d.values())await g.then(I=>I?.dispose());d.clear()}this._tunnels.clear()}openTunnel(d,g,I,v,u=!1,h=!1,o){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${I} on local port ${v}.`),!d)return;g||(g="localhost");const c=this.retainOrCreateTunnel(d,g,I,v,u,h,o);return c?c.then(i=>{if(!i){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(g,I);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.makeTunnel(i);return(i.tunnelRemoteHost!==g||i.tunnelRemotePort!==I)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(a),a}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),c)}makeTunnel(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,public:d.public,protocol:d.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const g=this._tunnels.get(d.tunnelRemoteHost);if(g){const I=g.get(d.tunnelRemotePort);I&&(I.refcount--,await this.tryDisposeTunnel(d.tunnelRemoteHost,d.tunnelRemotePort,I))}}}}async tryDisposeTunnel(d,g,I){if(I.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${g}.`);const v=I.value.then(async u=>{u&&(await u.dispose(!0),this._onTunnelClosed.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this._tunnels.has(d)&&this._tunnels.get(d).delete(g),v}}async closeTunnel(d,g){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${g} `);const I=this._tunnels.get(d);if(I&&I.has(g)){const v=I.get(g);v.refcount=0,await this.tryDisposeTunnel(d,g,v)}}addTunnelToMap(d,g,I){this._tunnels.has(d)||this._tunnels.set(d,new Map),this._tunnels.get(d).set(g,{refcount:1,value:I})}async removeEmptyTunnelFromMap(d,g){const I=this._tunnels.get(d);I&&(await I.get(g)||I.delete(g),I.size===0&&this._tunnels.delete(d))}getTunnelFromMap(d,g){let I=[d];w(d)?(I.push(...e.LOCALHOST_ADDRESSES),I.push(...e.ALL_INTERFACES_ADDRESSES)):t(d)&&I.push(...e.ALL_INTERFACES_ADDRESSES);const v=I.map(u=>this._tunnels.get(u));for(const u of v){const h=u?.get(g);if(h)return h}}canTunnel(d){return!!f(d)}createWithProvider(d,g,I,v,u,h,o){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${I} on local port ${v}.`);const i={elevationRequired:u?P(v===void 0?I:v):!1},a={remoteAddress:{host:g,port:I},localAddressPort:v,public:h,protocol:o},n=d.forwardPort(a,i);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),n&&this.addTunnelToMap(g,I,n),n}};b=ue([te(0,D.ILogService)],b),e.AbstractTunnelService=b}),define(J[50],Z([0,1,18,146,49,4,38]),function(K,e,y,L,k,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,D.createDecorator)("requestService");function r(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}e.isSuccess=r;function f(d){return d.res.statusCode===204}async function w(d){if(!r(d))throw new Error("Server returned "+d.res.statusCode);return f(d)?null:(await(0,y.streamToBuffer)(d.stream)).toString()}e.asText=w;async function t(d){if(!r(d))throw new Error("Server returned "+d.res.statusCode);if(f(d))return null;const I=(await(0,y.streamToBuffer)(d.stream)).toString();try{return JSON.parse(I)}catch(v){throw v.message+=`:
`+I,v}}e.asJson=t;function P(d){p(d)}e.updateProxyConfigurationsScope=P;let b;function p(d){const g=E.Registry.as(k.Extensions.Configuration);b&&g.deregisterConfigurations([b]),b={id:"http",order:15,title:(0,L.localize)(0,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(4,null),(0,L.localize)(5,null),(0,L.localize)(6,null),(0,L.localize)(7,null)],default:"override",description:(0,L.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(9,null),restricted:!0}}},g.registerConfiguration(b)}p(2)}),define(J[192],Z([0,1,193,13]),function(K,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(E,r){return E.protocol==="http:"?r.HTTP_PROXY||r.http_proxy||null:E.protocol==="https:"&&(r.HTTPS_PROXY||r.https_proxy||r.HTTP_PROXY||r.http_proxy)||null}async function D(E,r,f={}){const w=(0,y.parse)(E),t=f.proxyUrl||k(w,r);if(!t)return null;const P=(0,y.parse)(t);if(!/^https?:$/.test(P.protocol||""))return null;const b={host:P.hostname||"",port:P.port||(P.protocol==="https"?"443":"80"),auth:P.auth,rejectUnauthorized:(0,L.isBoolean)(f.strictSSL)?f.strictSSL:!0};return w.protocol==="http:"?new(await new Promise((p,d)=>{K(["http-proxy-agent"],p,d)}))(b):new(await new Promise((p,d)=>{K(["https-proxy-agent"],p,d)}))(b)}e.getProxyAgent=D}),define(J[194],Z([0,1,18,28]),function(K,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(D,E,r){let f=r&&r.get("storage.serviceMachineId",0)||null;if(f)return f;try{const t=(await E.readFile(D.serviceMachineIdResource)).value.toString();f=(0,L.isUUID)(t)?t:null}catch(w){f=null}if(!f){f=(0,L.generateUuid)();try{await E.writeFile(D.serviceMachineIdResource,y.VSBuffer.fromString(f))}catch(w){}}return r&&r.store("storage.serviceMachineId",f,0,1),f}e.getServiceMachineId=k}),define(J[74],Z([0,1,4]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,y.createDecorator)(e.SIGN_SERVICE_ID)}),define(J[195],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class y{vsda(){return new Promise((k,D)=>K(["vsda"],k,D))}async sign(k){try{const D=await this.vsda(),E=new D.signer;if(E)return E.sign(k)}catch(D){}return k}}e.SignService=y}),define(J[39],Z([0,1,4]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,y.createDecorator)("stateMainService")}),define(J[22],Z([0,1,14,9,5,2,3,32,13,4,177,6,39]),function(K,e,y,L,k,D,E,r,f,w,t,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,w.createDecorator)("lifecycleMainService");var p;(function(g){g[g.Starting=1]="Starting",g[g.Ready=2]="Ready",g[g.AfterWindowOpen=3]="AfterWindowOpen"})(p=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let d=class lt extends D.Disposable{constructor(I,v){super();this.logService=I,this.stateMainService=v,this._onBeforeShutdown=this._register(new k.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new k.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new k.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new k.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new k.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(lt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(lt.QUIT_AND_RESTART_KEY)}registerListeners(){const I=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),E.isMacintosh&&this.windowCounter===0&&this.beginOnWillShutdown())};y.app.addListener("before-quit",I);const v=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!E.isMacintosh)&&y.app.quit()};y.app.addListener("window-all-closed",v),y.app.once("will-quit",u=>{this.logService.trace("Lifecycle#app.on(will-quit)"),u.preventDefault(),this.beginOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),y.app.removeListener("before-quit",I),y.app.removeListener("window-all-closed",v),y.app.quit()})})}beginOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const I=[];return this._onWillShutdown.fire({join(v){I.push(v)}}),this.pendingWillShutdownPromise=(async()=>{try{await L.Promises.settled(I)}catch(v){this.logService.error(v)}try{await this.stateMainService.close()}catch(v){this.logService.error(v)}})(),this.pendingWillShutdownPromise}set phase(I){if(I<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===I)return;this.logService.trace(`lifecycle (main): phase changed (value: ${I})`),this._phase=I;const v=this.phaseWhen.get(this._phase);v&&(v.open(),this.phaseWhen.delete(this._phase))}async when(I){if(I<=this._phase)return;let v=this.phaseWhen.get(I);v||(v=new L.Barrier,this.phaseWhen.set(I,v)),await v.wait()}registerWindow(I){const v=new D.DisposableStore;this.windowCounter++,v.add(I.onWillLoad(h=>this._onWillLoadWindow.fire({window:I,workspace:h.workspace,reason:h.reason})));const u=(0,f.assertIsDefined)(I.win);u.on("close",h=>{const o=I.id;if(this.windowToCloseRequest.has(o)){this.windowToCloseRequest.delete(o);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${I.id}`),h.preventDefault(),this.unload(I,1).then(c=>{if(c){this.windowToCloseRequest.delete(o);return}this.windowToCloseRequest.add(o),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this._onBeforeCloseWindow.fire(I),I.close()})}),u.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${I.id}`),this.windowCounter--,v.dispose(),this.windowCounter===0&&(!E.isMacintosh||this._quitRequested)&&this.beginOnWillShutdown()})}async reload(I,v){await this.unload(I,3)||I.reload(v)}async unload(I,v){if(!I.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${I.id}`);const u=this._quitRequested?2:v;let h=await this.onBeforeUnloadWindowInRenderer(I,u);return h?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${I.id})`),this.handleWindowUnloadVeto(h)):(h=await this.onBeforeUnloadWindowInMain(I,u),h?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${I.id})`),this.handleWindowUnloadVeto(h)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${I.id})`),await this.onWillUnloadWindowInRenderer(I,u),!1))}handleWindowUnloadVeto(I){return I?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(I){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(I),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(I,v){return new Promise(u=>{const h=this.oneTimeListenerTokenGenerator++,o=`vscode:ok${h}`,c=`vscode:cancel${h}`;y.ipcMain.once(o,()=>{u(!1)}),y.ipcMain.once(c,()=>{u(!0)}),I.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:c,reason:v})})}onBeforeUnloadWindowInMain(I,v){const u=[];return this._onBeforeUnloadWindow.fire({reason:v,window:I,veto(h){u.push(h)}}),(0,t.handleVetos)(u,h=>this.logService.error(h))}onWillUnloadWindowInRenderer(I,v){return new Promise(u=>{const o=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;y.ipcMain.once(o,()=>u()),I.send("vscode:onWillUnload",{replyChannel:o,reason:v})})}quit(I){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${I}`),I&&this.stateMainService.setItem(lt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(v=>{this.pendingQuitPromiseResolve=v,this.logService.trace("Lifecycle#quit() - calling app.quit()"),y.app.quit()}),this.pendingQuitPromise)}async relaunch(I){this.logService.trace("Lifecycle#relaunch()");const v=process.argv.slice(1);if(I?.addArgs&&v.push(...I.addArgs),I?.removeArgs)for(const o of I.removeArgs){const c=v.indexOf(o);c>=0&&v.splice(c,1)}const u=()=>{try{if(E.isWindows){const o=(0,r.cwd)();o!==process.cwd()&&process.chdir(o)}}catch(o){this.logService.error(o)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),y.app.relaunch({args:v})};y.app.once("quit",u),await this.quit(!0)&&y.app.removeListener("quit",u)}async kill(I){this.logService.trace("Lifecycle#kill()"),await Promise.race([(0,L.timeout)(1e3),(async()=>{for(const v of y.BrowserWindow.getAllWindows())if(v&&!v.isDestroyed()){let u;v.webContents&&!v.webContents.isDestroyed()?u=new Promise(h=>v.once("closed",h)):u=Promise.resolve(),v.destroy(),await u}})()]),y.app.exit(I)}};d.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",d=ue([te(0,P.ILogService),te(1,b.IStateMainService)],d),e.LifecycleMainService=d}),define(J[196],Z([0,1,5,2,4,22]),function(K,e,y,L,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,k.createDecorator)("keyboardLayoutMainService");let E=class extends L.Disposable{constructor(w){super();this._onDidChangeKeyboardLayout=this._register(new y.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,w.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const w=await new Promise((t,P)=>{K(["native-keymap"],t,P)});this._keyboardLayoutData=r(w),w.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=r(w),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};E=ue([te(0,D.ILifecycleMainService)],E),e.KeyboardLayoutMainService=E;function r(f){const w=f.getKeyMap(),t=f.getCurrentKeyboardLayout();return{keyboardMapping:w,keyboardLayoutInfo:t}}}),define(J[96],Z([0,1,9,5,2,13,85,4]),function(K,e,y,L,k,D,E,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const f="__$__targetStorageMarker";e.IStorageService=(0,r.createDecorator)("storageService");var w;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(w=e.WillSaveStateReason||(e.WillSaveStateReason={}));var t;(function(g){g[g.GLOBAL=0]="GLOBAL",g[g.WORKSPACE=1]="WORKSPACE"})(t=e.StorageScope||(e.StorageScope={}));var P;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(P=e.StorageTarget||(e.StorageTarget={}));class b extends k.Disposable{constructor(I={flushInterval:b.DEFAULT_FLUSH_INTERVAL}){super();this.options=I,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new y.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,y.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(I,v){v===f?(I===0?this._globalKeyTargets=void 0:I===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:I})):this._onDidChangeValue.fire({scope:I,key:v,target:this.getKeyTargets(I)[v]})}emitWillSaveState(I){this._onWillSaveState.fire({reason:I})}get(I,v,u){return this.getStorage(v)?.get(I,u)}getBoolean(I,v,u){return this.getStorage(v)?.getBoolean(I,u)}getNumber(I,v,u){return this.getStorage(v)?.getNumber(I,u)}store(I,v,u,h){if((0,D.isUndefinedOrNull)(v)){this.remove(I,u);return}this.withPausedEmitters(()=>{this.updateKeyTarget(I,u,h),this.getStorage(u)?.set(I,v)})}remove(I,v){this.withPausedEmitters(()=>{this.updateKeyTarget(I,v,void 0),this.getStorage(v)?.delete(I)})}withPausedEmitters(I){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{I()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(I,v){const u=[],h=this.getKeyTargets(I);for(const o of Object.keys(h))h[o]===v&&u.push(o);return u}updateKeyTarget(I,v,u){const h=this.getKeyTargets(v);typeof u=="number"?h[I]!==u&&(h[I]=u,this.getStorage(v)?.set(f,JSON.stringify(h))):typeof h[I]=="number"&&(delete h[I],this.getStorage(v)?.set(f,JSON.stringify(h)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(I){return I===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(I){const v=this.get(f,I);if(v)try{return JSON.parse(v)}catch(u){}return Object.create(null)}isNew(I){return this.getBoolean(e.IS_NEW_KEY,I)===!0}async flush(I=w.NONE){this._onWillSaveState.fire({reason:I}),await y.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const I=this.getStorage(0)?.items??new Map,v=this.getStorage(1)?.items??new Map;return d(I,v,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=b,b.DEFAULT_FLUSH_INTERVAL=60*1e3;class p extends b{constructor(){super();this.globalStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(I=>this.emitDidChangeValue(1,I))),this._register(this.globalStorage.onDidChangeStorage(I=>this.emitDidChangeValue(0,I)))}getStorage(I){return I===0?this.globalStorage:this.workspaceStorage}getLogDetails(I){return I===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(I){}}e.InMemoryStorageService=p;async function d(g,I,v,u){const h=l=>{try{return JSON.parse(l)}catch(m){return l}},o=new Map,c=new Map;g.forEach((l,m)=>{o.set(m,l),c.set(m,h(l))});const i=new Map,a=new Map;I.forEach((l,m)=>{i.set(m,l),a.set(m,h(l))}),console.group(`Storage: Global (path: ${v})`);let n=[];o.forEach((l,m)=>{n.push({key:m,value:l})}),console.table(n),console.groupEnd(),console.log(c),console.group(`Storage: Workspace (path: ${u})`);let s=[];i.forEach((l,m)=>{s.push({key:m,value:l})}),console.table(s),console.groupEnd(),console.log(a)}e.logStorage=d}),define(J[197],Z([0,1,3,32,7,28]),function(K,e,y,L,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function E(w){if(y.platform===2&&/^penguin(\.|$)/i.test(w))return"chromebook"}async function r(w,t,P,b,p,d,g,I,v,u){const h=Object.create(null);h["common.machineId"]=g,h.sessionID=(0,D.generateUuid)()+Date.now(),h.commitHash=p,h.version=d,h["common.platformVersion"]=(t||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,y.PlatformToString)(y.platform),h["common.nodePlatform"]=L.platform,h["common.nodeArch"]=b,h["common.product"]=u||"desktop";const o=f(I||[]);o&&(h["common.msftInternal"]=o);let c=0;const i=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),y.isLinuxSnap&&(h["common.snap"]="true");const a=E(P);a&&(h["common.platformDetail"]=a);try{const n=await w.readFile(k.URI.file(v));h["common.source"]=n.value.toString().slice(0,30)}catch(n){}return h}e.resolveCommonProperties=r;function f(w){const t=L.env.USERDNSDOMAIN;if(!t)return!1;const P=t.toLowerCase();return w.some(b=>P===b)}e.verifyMicrosoftInternalDomain=f}),define(J[34],Z([0,1,4]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,y.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,y.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(J[198],Z([0,1,26,63,40,10,8,3,7,66,19,82,70,20,21,34]),function(K,e,y,L,k,D,E,r,f,w,t,P,b,p,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function I(c,i){const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],n=new Map,s=new Map,l=2e4;function m(A,F,C,X){const ee=F.substring(A.length+1);return new Promise(async re=>{let Y;try{Y=await t.Promises.readdir(F,{withFileTypes:!0})}catch(V){re();return}if(X.count>=l){X.count+=Y.length,X.maxReached=!0,re();return}let Q=Y.length;if(Q===0){re();return}let W=Y;X.count+Y.length>l&&(X.maxReached=!0,Q=l-X.count,W=Y.slice(0,Q)),X.count+=Y.length;for(const V of W)if(V.isDirectory()){if(C.includes(V.name)||await m(A,(0,E.join)(F,V.name),C,X),--Q==0){re();return}}else{const z=V.name.lastIndexOf(".");if(z>=0){const $=V.name.substring(z+1);$&&n.set($,(n.get($)??0)+1)}for(const $ of a)$.relativePathPattern?.test(ee)!==!1&&$.filePattern.test(V.name)&&s.set($.tag,(s.get($.tag)??0)+1);if(--Q==0){re();return}}})}const S={count:0,maxReached:!1};await m(c,c,i,S);const M=await h(c);return{configFiles:v(s),fileTypes:v(n),fileCount:S.count,maxFilesReached:S.maxReached,launchConfigFiles:M}}e.collectWorkspaceStats=I;function v(c){return[...L.Iterable.map(c.entries(),([i,a])=>({name:i,count:a}))].sort((i,a)=>a.count-i.count)}function u(){const c={os:`${y.type()} ${y.arch()} ${y.release()}`,memory:`${(y.totalmem()/p.ByteSize.GB).toFixed(2)}GB (${(y.freemem()/p.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(w.virtualMachineHint.value()*100)}%`},i=y.cpus();return i&&i.length>0&&(c.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),c}e.getMachineInfo=u;async function h(c){try{const i=new Map,a=(0,E.join)(c,".vscode","launch.json"),n=await t.Promises.readFile(a),s=[],l=(0,k.parse)(n.toString(),s);if(s.length)return console.log(`Unable to parse ${a}`),[];if((0,k.getNodeType)(l)==="object"&&l.configurations)for(const m of l.configurations){const S=m.type;S&&(i.has(S)?i.set(S,i.get(S)+1):i.set(S,1))}return v(i)}catch(i){return[]}}e.collectLaunchConfigs=h;let o=class{constructor(i,a){this.telemetryService=i,this.productService=a}formatMachineInfo(i){const a=[];return a.push(`OS Version:       ${i.os}`),a.push(`CPUs:             ${i.cpus}`),a.push(`Memory (System):  ${i.memory}`),a.push(`VM:               ${i.vmHint}`),a.join(`
`)}formatEnvironment(i){const a=[];a.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),a.push(`OS Version:       ${y.type()} ${y.arch()} ${y.release()}`);const n=y.cpus();return n&&n.length>0&&a.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),a.push(`Memory (System):  ${(y.totalmem()/p.ByteSize.GB).toFixed(2)}GB (${(y.freemem()/p.ByteSize.GB).toFixed(2)}GB free)`),r.isWindows||a.push(`Load (avg):       ${y.loadavg().map(s=>Math.round(s)).join(", ")}`),a.push(`VM:               ${Math.round(w.virtualMachineHint.value()*100)}%`),a.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),a.push(`Process Argv:     ${i.mainArguments.join(" ")}`),a.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),a.join(`
`)}async getPerformanceInfo(i,a){return Promise.all([(0,P.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async n=>{let[s,l]=n,m=this.formatProcessList(i,s);return a.forEach(S=>{if((0,b.isRemoteDiagnosticError)(S))m+=`
${S.errorMessage}`,l+=`
${S.errorMessage}`;else if(m+=`

Remote: ${S.hostName}`,S.processes&&(m+=`
${this.formatProcessList(i,S.processes)}`),S.workspaceMetadata){l+=`
|  Remote: ${S.hostName}`;for(const M of Object.keys(S.workspaceMetadata)){const A=S.workspaceMetadata[M];let F=`${A.fileCount} files`;A.maxFilesReached&&(F=`more than ${F}`),l+=`|    Folder (${M}): ${F}`,l+=this.formatWorkspaceStats(A)}}}),{processInfo:m,workspaceInfo:l}})}async getSystemInfo(i,a){const{memory:n,vmHint:s,os:l,cpus:m}=u(),S={os:l,memory:n,cpus:m,vmHint:s,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:a};return r.isWindows||(S.load=`${y.loadavg().map(M=>Math.round(M)).join(", ")}`),r.isLinux&&(S.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(S)}async getDiagnostics(i,a){const n=[];return(0,P.listProcesses)(i.mainPID).then(async s=>(n.push(""),n.push(this.formatEnvironment(i)),n.push(""),n.push(this.formatProcessList(i,s)),i.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.formatWorkspaceMetadata(i))),a.forEach(l=>{if((0,b.isRemoteDiagnosticError)(l))n.push(`
${l.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${l.hostName}`),n.push(this.formatMachineInfo(l.machineInfo)),l.processes&&n.push(this.formatProcessList(i,l.processes)),l.workspaceMetadata)for(const m of Object.keys(l.workspaceMetadata)){const S=l.workspaceMetadata[m];let M=`${S.fileCount} files`;S.maxFilesReached&&(M=`more than ${M}`),n.push(`Folder (${m}): ${M}`),n.push(this.formatWorkspaceStats(S))}}),n.push(""),n.push(""),n.join(`
`)))}formatWorkspaceStats(i){const a=[],n=60;let s=0;const l=(A,F)=>{const C=` ${A}(${F})`;s+C.length>n?(a.push(m),m="|                 ",s=m.length):s+=C.length,m+=C};let m="|      File types:";const S=10;let M=i.fileTypes.length>S?S:i.fileTypes.length;for(let A=0;A<M;A++){const F=i.fileTypes[A];l(F.name,F.count)}if(a.push(m),i.configFiles.length>=0&&(m="|      Conf files:",s=0,i.configFiles.forEach(A=>{l(A.name,A.count)}),a.push(m)),i.launchConfigFiles.length>0){let A="|      Launch Configs:";i.launchConfigFiles.forEach(F=>{A+=F.count>1?` ${F.name}(${F.count})`:` ${F.name}`}),a.push(A)}return a.join(`
`)}expandGPUFeatures(i){const a=Math.max(...Object.keys(i).map(n=>n.length));return Object.keys(i).map(n=>`${n}:  ${" ".repeat(a-n.length)}  ${i[n]}`).join(`
                  `)}formatWorkspaceMetadata(i){const a=[],n=[];return i.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(a.push(`|  Window (${s.title})`),s.folderURIs.forEach(l=>{const m=f.URI.revive(l);if(m.scheme===D.Schemas.file){const S=m.fsPath;n.push(I(S,["node_modules",".git"]).then(M=>{let A=`${M.fileCount} files`;M.maxFilesReached&&(A=`more than ${A}`),a.push(`|    Folder (${(0,E.basename)(S)}): ${A}`),a.push(this.formatWorkspaceStats(M))}).catch(M=>{a.push(`|      Error: Unable to collect workspace stats for folder ${S} (${M.toString()})`)}))}else a.push(`|    Folder (${m.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(s=>a.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(i,a){const n=new Map;i.windows.forEach(l=>n.set(l.pid,l.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),a&&this.formatProcessItem(i.mainPID,n,s,a,0),s.join(`
`)}formatProcessItem(i,a,n,s,l){const m=l===0;let S;m?S=s.pid===i?`${this.productService.applicationName} main`:"remote agent":(S=`${"  ".repeat(l)} ${s.name}`,s.name==="window"&&(S=`${S} (${a.get(s.pid)})`));const M=process.platform==="win32"?s.mem:y.totalmem()*(s.mem/100);n.push(`${s.load.toFixed(0).padStart(5," ")}	${(M/p.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${S}`),Array.isArray(s.children)&&s.children.forEach(A=>this.formatProcessItem(i,a,n,A,l+1))}async reportWorkspaceStats(i){for(const{uri:a}of i.folders){const n=f.URI.revive(a);if(n.scheme!==D.Schemas.file)continue;const s=n.fsPath;try{const l=await I(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),l.fileTypes.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:m.name,count:m.count})}),l.launchConfigFiles.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:m.name,count:m.count})}),l.configFiles.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:m.name,count:m.count})})}catch{}}}};o=ue([te(0,g.ITelemetryService),te(1,d.IProductService)],o),e.DiagnosticsService=o}),define(J[199],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class y{constructor(D){this.appender=D}listen(D,E){throw new Error(`Event not found: ${E}`)}call(D,E,{eventName:r,data:f}){return this.appender.log(r,f),Promise.resolve(null)}}e.TelemetryAppenderChannel=y;class L{constructor(D){this.channel=D}log(D,E){return this.channel.call("log",{eventName:D,data:E}).then(void 0,r=>`Failed to log telemetry: ${console.warn(r)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(J[200],Z([0,1,2,44,25,147,16,49,48,38]),function(K,e,y,L,k,D,E,r,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let t=class{constructor(p,d){this._configurationService=d,this._experimentProperties={},this._disposables=new y.DisposableStore,this._cleanupPatterns=[],this._appender=p.appender,this._commonProperties=p.commonProperties||Promise.resolve({}),this._piiPaths=p.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!p.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let g of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,k.escapeRegExpCharacters)(g),"gi"));this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(g=>{const I=/^[a-f0-9]+$/i.test(g["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!I})})}setExperimentProperty(p,d){this._experimentProperties[p]=d}setEnabled(p){this._enabled=p}_updateUserOptIn(){const p=this._configurationService?.getValue(P);this._userOptIn=p?p.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const p=await this._commonProperties;let d=p.sessionID,g=p["common.instanceId"],I=p["common.machineId"],v=p["common.firstSessionDate"],u=p["common.msftInternal"];return{sessionId:d,instanceId:g,machineId:I,firstSessionDate:v,msftInternal:u}}dispose(){this._disposables.dispose()}publicLog(p,d,g){return this.isOptedIn?this._commonProperties.then(I=>{d=(0,L.mixin)(d,I),d=(0,L.mixin)(d,this._experimentProperties),d=(0,L.cloneAndChange)(d,v=>{if(typeof v=="string")return this._cleanupInfo(v,g)}),this._appender.log(p,d)},I=>{console.error(I)}):Promise.resolve(void 0)}publicLog2(p,d,g){return this.publicLog(p,d,g)}publicLogError(p,d){return this.sendErrorTelemetry?this.publicLog(p,d,!0):Promise.resolve(void 0)}publicLogError2(p,d){return this.publicLogError(p,d)}_cleanupInfo(p,d){let g=p;if(d){const I=[];for(let o of this._cleanupPatterns)for(;;){const c=o.exec(p);if(!c)break;I.push([c.index,o.lastIndex])}const v=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let h=0;for(g="";;){const o=u.exec(p);if(!o)break;!v.test(o[0])&&I.every(([c,i])=>o.index<c||o.index>=i)&&(g+=p.substring(h,o.index)+"<REDACTED: user-file-path>",h=u.lastIndex)}h<p.length&&(g+=p.substr(h))}for(let I of this._cleanupPatterns)g=g.replace(I,"");return g}};t.IDLE_START_EVENT_NAME="UserIdleStart",t.IDLE_STOP_EVENT_NAME="UserIdleStop",t=ue([te(1,E.IConfigurationService)],t),e.TelemetryService=t;const P="telemetry";w.Registry.as(r.Extensions.Configuration).registerConfiguration({id:P,order:110,type:"object",title:(0,D.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:f.default.privacyStatementUrl?(0,D.localize)(2,null,f.default.nameLong,f.default.privacyStatementUrl):(0,D.localize)(1,null,f.default.nameLong),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(J[75],Z([0,1,9,44,13,16]),function(K,e,y,L,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.TelemetryLevel=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(I,v){return Promise.resolve(void 0)}publicLog2(I,v){return this.publicLog(I,v)}publicLogError(I,v){return Promise.resolve(void 0)}publicLogError2(I,v){return this.publicLogError(I,v)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class E{async publicLog(v,u,h){}async publicLogError(v,u,h){}}e.NullEndpointTelemetryService=E;function r(...I){return{log:(v,u)=>I.forEach(h=>h.log(v,u)),flush:()=>y.Promises.settled(I.map(v=>v.flush()))}}e.combinedAppender=r,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function f(I,v){return v.onDidChangeConfiguration(u=>{u.source!==6&&I.publicLog2("updateConfiguration",{configurationSource:(0,D.ConfigurationTargetToString)(u.source),configurationKeys:d(u.sourceConfig)})})}e.configurationTelemetry=f;var w;(function(I){I[I.NONE=0]="NONE",I[I.LOG=1]="LOG",I[I.USER=2]="USER"})(w=e.TelemetryLevel||(e.TelemetryLevel={}));function t(I,v){return v.disableTelemetry||!I.enableTelemetry?0:v.isBuilt?2:1}e.getTelemetryLevel=t;function P(I){const v=Object.create(null),u=Object.create(null),h=Object.create(null);p(I,h);for(let o in h){o=o.length>150?o.substr(o.length-149):o;const c=h[o];typeof c=="number"?u[o]=c:typeof c=="boolean"?u[o]=c?1:0:typeof c=="string"?v[o]=c.substring(0,1023):typeof c!="undefined"&&c!==null&&(v[o]=c)}return{properties:v,measurements:u}}e.validateTelemetryData=P;function b(I){if(!I)return"none";let v="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(h=>{I.indexOf(`${h}+`)===0&&(v=h)}),v}e.cleanRemoteAuthority=b;function p(I,v,u=0,h){if(!!I)for(let o of Object.getOwnPropertyNames(I)){const c=I[o],i=h?h+o:o;Array.isArray(c)?v[i]=(0,L.safeStringify)(c):c instanceof Date?v[i]=c.toISOString():(0,k.isObject)(c)?u<2?p(c,v,u+1,i+"."):v[i]=(0,L.safeStringify)(c):v[i]=c}}function d(I){if(!I)return[];const v=[];return g(v,"",I),v}function g(I,v,u){u&&typeof u=="object"&&!Array.isArray(u)?Object.keys(u).forEach(h=>g(I,v?`${v}.${h}`:h,u[h])):I.push(v)}}),define(J[201],Z([0,1,31,24,17,44,3,7,16,47,168,171,162,20,4,6,21,50,194,96,34,75]),function(K,e,y,L,k,D,E,r,f,w,t,P,b,p,d,g,I,v,u,h,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var i;(function(_){_[_.None=0]="None",_[_.IncludeVersions=1]="IncludeVersions",_[_.IncludeFiles=2]="IncludeFiles",_[_.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",_[_.IncludeSharedAccounts=8]="IncludeSharedAccounts",_[_.IncludeVersionProperties=16]="IncludeVersionProperties",_[_.ExcludeNonValidated=32]="ExcludeNonValidated",_[_.IncludeInstallationTargets=64]="IncludeInstallationTargets",_[_.IncludeAssetUri=128]="IncludeAssetUri",_[_.IncludeStatistics=256]="IncludeStatistics",_[_.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",_[_.Unpublished=4096]="Unpublished"})(i||(i={}));function a(..._){return String(_.reduce((N,B)=>N|B,0))}var n;(function(_){_[_.Tag=1]="Tag",_[_.ExtensionId=4]="ExtensionId",_[_.Category=5]="Category",_[_.ExtensionName=7]="ExtensionName",_[_.Target=8]="Target",_[_.Featured=9]="Featured",_[_.SearchText=10]="SearchText",_[_.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const s={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},S={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class M{constructor(N=S){this.state=N}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(N,B=this.state.pageSize){return new M({...this.state,pageNumber:N,pageSize:B})}withFilter(N,...B){const H=[...this.state.criteria,...B.length?B.map(x=>({filterType:N,value:x})):[{filterType:N}]];return new M({...this.state,criteria:H})}withSortBy(N){return new M({...this.state,sortBy:N})}withSortOrder(N){return new M({...this.state,sortOrder:N})}withFlags(...N){return new M({...this.state,flags:N.reduce((B,H)=>B|H,0)})}withAssetTypes(...N){return new M({...this.state,assetTypes:N})}get raw(){const{criteria:N,pageNumber:B,pageSize:H,sortBy:x,sortOrder:ie,flags:ae,assetTypes:oe}=this.state;return{filters:[{criteria:N,pageNumber:B,pageSize:H,sortBy:x,sortOrder:ie}],assetTypes:oe,flags:ae}}get searchText(){const N=this.state.criteria.filter(B=>B.filterType===n.SearchText)[0];return N&&N.value?N.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(N=>String(N.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function A(_,N){const B=(_||[]).filter(H=>H.statisticName===N)[0];return B?B.value:0}function F(_){const N="Microsoft.VisualStudio.Code.Translation.";return _.files.filter(H=>H.assetType.indexOf(N)===0).reduce((H,x)=>{const ie=re(_,x.assetType);return ie&&H.push([x.assetType.substring(N.length),ie]),H},[])}function C(_){if(_.properties){const N=_.properties.filter(x=>x.key===s.Repository),B=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),H=N.filter(x=>B.test(x.value))[0];return H?{uri:H.value,fallbackUri:H.value}:null}return re(_,s.Repository)}function X(_){return{uri:`${_.fallbackAssetUri}/${s.VSIX}?redirect=true${_.targetPlatform?`&targetPlatform=${_.targetPlatform}`:""}`,fallbackUri:`${_.fallbackAssetUri}/${s.VSIX}${_.targetPlatform?`?targetPlatform=${_.targetPlatform}`:""}`}}function ee(_){const N=re(_,s.Icon);if(N)return N;const B=t.DefaultIconPath;return{uri:B,fallbackUri:B}}function re(_,N){return _.files.filter(H=>H.assetType===N)[0]?{uri:`${_.assetUri}/${N}`,fallbackUri:`${_.fallbackAssetUri}/${N}`}:null}function Y(_,N){const B=_.properties?_.properties.filter(x=>x.key===N):[],H=B.length>0&&B[0].value;return H?H.split(",").map(x=>(0,P.adoptToGalleryExtensionId)(x)):[]}function Q(_){const N=_.properties?_.properties.filter(B=>B.key===l.Engine):[];return N.length>0&&N[0].value||""}function W(_){const N=_.properties?_.properties.filter(H=>H.key===l.LocalizedLanguages):[],B=N.length>0&&N[0].value||"";return B?B.split(","):[]}function V(_){return _.indexOf("preview")!==-1}function z(_){return _.targetPlatform?(0,t.toTargetPlatform)(_.targetPlatform):"undefined"}function $(_){const N=(0,y.distinct)(_.versions.map(z)),B=!!_.tags?.includes(t.WEB_EXTENSION_TAG),H=N.indexOf("web");return B?H===-1&&N.push("web"):H!==-1&&N.splice(H,1),N}function j(_,N){return N==="web"&&!_.includes("web")}function U(_,N,B){if(j(N,B))return!1;if(_==="undefined"||_==="universal")return!0;if(_==="unknown")return!1;if(_===B)return!0;switch(B){case"win32-x64":return _==="win32-ia32";case"win32-arm64":return _==="win32-ia32";default:return!1}}function q(_,N,B,H){const x=$(_);let ie=_.versions[0];return ie=_.versions.find(ae=>ae.version===ie.version&&U(z(ae),x,t.CURRENT_TARGET_PLATFORM))||ie,T(_,ie,x,N,B,H)}function T(_,N,B,H,x,ie){const ae={manifest:re(N,s.Manifest),readme:re(N,s.Details),changelog:re(N,s.Changelog),license:re(N,s.License),repository:C(N),download:X(N),icon:ee(N),coreTranslations:F(N)};return{identifier:{id:(0,P.getGalleryExtensionId)(_.publisher.publisherName,_.extensionName),uuid:_.extensionId},name:_.extensionName,version:N.version,displayName:_.displayName,publisherId:_.publisher.publisherId,publisher:_.publisher.publisherName,publisherDisplayName:_.publisher.displayName,description:_.shortDescription||"",installCount:A(_.statistics,"install"),rating:A(_.statistics,"averagerating"),ratingCount:A(_.statistics,"ratingcount"),categories:_.categories||[],tags:_.tags||[],releaseDate:Date.parse(_.releaseDate),lastUpdated:Date.parse(_.lastUpdated),allTargetPlatforms:B,assets:ae,properties:{dependencies:Y(N,l.Dependency),extensionPack:Y(N,l.ExtensionPack),engine:Q(N),localizedLanguages:W(N),targetPlatform:z(N)},preview:V(_.flags),telemetryData:{index:(x.pageNumber-1)*x.pageSize+H,querySource:ie}}}let R=class{constructor(N,B,H,x,ie,ae,oe,se){this.requestService=N,this.logService=B,this.environmentService=H,this.telemetryService=x,this.fileService=ie,this.productService=ae,this.configurationService=oe;const le=ae.extensionsGallery;this.extensionsGalleryUrl=le&&le.serviceUrl,this.extensionsControlUrl=le&&le.controlUrl,this.commonHeadersPromise=O(ae.version,ae,this.environmentService,this.configurationService,this.fileService,se)}api(N=""){return`${this.extensionsGalleryUrl}${N}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(N,B){const H=[];let x=new M().withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,N.length).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExtensionName,...N.map(({id:ae})=>ae.toLowerCase()));N.every(ae=>!ae.version)&&(x=x.withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties,i.IncludeLatestVersionOnly));const{galleryExtensions:ie}=await this.queryGallery(x,L.CancellationToken.None);for(let ae=0;ae<ie.length;ae++){const oe=ie[ae];if(!oe.versions.length)continue;const se=(0,P.getGalleryExtensionId)(oe.publisher.publisherName,oe.extensionName),le=N.find(de=>(0,P.areSameExtensions)(de,{id:se}))?.version;if(le){const de=oe.versions.find(ge=>ge.version===le);de&&H.push(T(oe,de,$(oe),ae,x))}else H.push(q(oe,ae,x))}return H}async getCompatibleExtension(N,B){const H=(0,t.isIExtensionIdentifier)(N)?null:N;if(H){if(j(H.allTargetPlatforms,B))return null;if(await this.isExtensionCompatible(H,B))return H}const{id:x,uuid:ie}=H?H.identifier:N;let ae=new M().withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1).withFilter(n.Target,"Microsoft.VisualStudio.Code");ie?ae=ae.withFilter(n.ExtensionId,ie):ae=ae.withFilter(n.ExtensionName,x);const{galleryExtensions:oe}=await this.queryGallery(ae,L.CancellationToken.None),[se]=oe;if(!se||!se.versions.length)return null;const le=$(se);if(j(le,B))return null;for(let de of se.versions){if(!Q(de)){const ge=await this.getEngine(de);de={...de,properties:[...de.properties||[],{key:l.Engine,value:ge}]}}if(await this.isRawExtensionVersionCompatible(de,le,B))return T(se,de,le,0,ae)}return null}async isExtensionCompatible(N,B){if(!U(N.properties.targetPlatform,N.allTargetPlatforms,B))return!1;let H=N.properties.engine;if(!H){const x=await this.getManifest(N,L.CancellationToken.None);if(!x)throw new Error("Manifest was not found");H=x.engines.vscode}return(0,b.isEngineValid)(H,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(N,B,H){if(!U(z(N),B,H))return!1;const x=await this.getEngine(N);return(0,b.isEngineValid)(x,this.productService.version,this.productService.date)}async query(N,B){const H=L.CancellationToken.isCancellationToken(N)?{}:N,x=L.CancellationToken.isCancellationToken(N)?N:B;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let ie=H.text||"";const ae=(0,D.getOrDefault)(H,ve=>ve.pageSize,50);let oe=new M().withFlags(i.IncludeLatestVersionOnly,i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,ae).withFilter(n.Target,"Microsoft.VisualStudio.Code");ie?(ie=ie.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ve,Pe,we)=>(oe=oe.withFilter(n.Category,we||Pe),"")),ie=ie.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ve,Pe,we)=>(oe=oe.withFilter(n.Tag,we||Pe),"")),ie=ie.replace(/\bfeatured(\s+|\b|$)/g,()=>(oe=oe.withFilter(n.Featured),"")),ie=ie.trim(),ie&&(ie=ie.length<200?ie:ie.substring(0,200),oe=oe.withFilter(n.SearchText,ie)),oe=oe.withSortBy(0)):H.ids?oe=oe.withFilter(n.ExtensionId,...H.ids):H.names?oe=oe.withFilter(n.ExtensionName,...H.names):oe=oe.withSortBy(4),typeof H.sortBy=="number"&&(oe=oe.withSortBy(H.sortBy)),typeof H.sortOrder=="number"&&(oe=oe.withSortOrder(H.sortOrder));const{galleryExtensions:se,total:le}=await this.queryGallery(oe,x),de=se.map((ve,Pe)=>q(ve,Pe,oe,H.source)),ge=async(ve,Pe)=>{if(Pe.isCancellationRequested)throw(0,k.canceled)();const we=oe.withPage(ve+1),{galleryExtensions:pe}=await this.queryGallery(we,Pe);return pe.map((Ee,De)=>q(Ee,De,we,H.source))};return{firstPage:de,total:le,pageSize:oe.pageSize,getPage:ge}}async queryGallery(N,B){if(!this.isEnabled())throw new Error("No extension gallery service configured.");N=N.withFlags(N.flags,i.ExcludeNonValidated).withFilter(n.ExcludeWithFlags,a(i.Unpublished));const H=await this.commonHeadersPromise,x=JSON.stringify(N.raw),ie={...H,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(x.length)},ae=new Date().getTime();let oe,se,le=0;try{if(oe=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:x,headers:ie},B),oe.res.statusCode&&oe.res.statusCode>=400&&oe.res.statusCode<500)return{galleryExtensions:[],total:le};const de=await(0,v.asJson)(oe);if(de){const ge=de.results[0],ve=ge.extensions,Pe=ge.resultMetadata&&ge.resultMetadata.filter(we=>we.metadataType==="ResultCount")[0];return le=Pe&&Pe.metadataItems.filter(we=>we.name==="TotalCount")[0].count||0,{galleryExtensions:ve,total:le}}return{galleryExtensions:[],total:le}}catch(de){throw se=de,de}finally{this.telemetryService.publicLog2("galleryService:query",{...N.telemetryData,requestBodySize:String(x.length),duration:new Date().getTime()-ae,success:!!oe&&(0,v.isSuccess)(oe),responseBodySize:oe?.res.headers["Content-Length"],statusCode:oe?String(oe.res.statusCode):void 0,errorCode:se?(0,k.isPromiseCanceledError)(se)?"canceled":(0,k.getErrorMessage)(se).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(le)})}}async reportStatistic(N,B,H,x){if(!this.isEnabled())return;const ie=E.isWeb?this.api(`/itemName/${N}.${B}/version/${H}/statType/${x==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${N}/extensions/${B}/${H}/stats?statType=${x}`),ae=E.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",se={...await this.commonHeadersPromise,Accept:ae};try{await this.requestService.request({type:"POST",url:ie,headers:se},L.CancellationToken.None)}catch(le){}}async download(N,B,H){this.logService.trace("ExtensionGalleryService#download",N.identifier.id);const x=(0,P.getGalleryExtensionTelemetryData)(N),ie=new Date().getTime(),ae=de=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...x,duration:de}),oe=H===1?"install":H===2?"update":"",se=oe?{uri:`${N.assets.download.uri}${r.URI.parse(N.assets.download.uri).query?"&":"?"}${oe}=true`,fallbackUri:`${N.assets.download.fallbackUri}${r.URI.parse(N.assets.download.fallbackUri).query?"&":"?"}${oe}=true`}:N.assets.download,le=await this.getAsset(se);await this.fileService.writeFile(B,le.stream),ae(new Date().getTime()-ie)}async getReadme(N,B){if(N.assets.readme){const H=await this.getAsset(N.assets.readme,{},B);return await(0,v.asText)(H)||""}return""}async getManifest(N,B){if(N.assets.manifest){const H=await this.getAsset(N.assets.manifest,{},B),x=await(0,v.asText)(H);return x?JSON.parse(x):null}return null}async getManifestFromRawExtensionVersion(N,B){const H=re(N,s.Manifest);if(!H)throw new Error("Manifest was not found");const x={"Accept-Encoding":"gzip"},ie=await this.getAsset(H,{headers:x});return await(0,v.asJson)(ie)}async getCoreTranslation(N,B){const H=N.assets.coreTranslations.filter(x=>x[0]===B.toUpperCase())[0];if(H){const x=await this.getAsset(H[1]),ie=await(0,v.asText)(x);return ie?JSON.parse(ie):null}return null}async getChangelog(N,B){if(N.assets.changelog){const H=await this.getAsset(N.assets.changelog,{},B);return await(0,v.asText)(H)||""}return""}async getAllCompatibleVersions(N,B){let H=new M().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1).withFilter(n.Target,"Microsoft.VisualStudio.Code");N.identifier.uuid?H=H.withFilter(n.ExtensionId,N.identifier.uuid):H=H.withFilter(n.ExtensionName,N.identifier.id);const{galleryExtensions:x}=await this.queryGallery(H,L.CancellationToken.None);if(!x.length)return[];const ie=$(x[0]);if(j(ie,B))return[];const ae=[];for(const oe of x[0].versions)try{await this.isRawExtensionVersionCompatible(oe,ie,B)&&ae.push({version:oe.version,date:oe.lastUpdated})}catch(se){}return ae}async getAsset(N,B={},H=L.CancellationToken.None){const x=await this.commonHeadersPromise,ie={type:"GET"},ae={...x,...B.headers||{}};B={...B,...ie,headers:ae};const oe=N.uri,se=N.fallbackUri,le={...B,url:oe};try{const de=await this.requestService.request(le,H);if(de.res.statusCode===200)return de;const ge=await(0,v.asText)(de);throw new Error(`Expected 200, got back ${de.res.statusCode} instead.

${ge}`)}catch(de){if((0,k.isPromiseCanceledError)(de))throw de;const ge=(0,k.getErrorMessage)(de);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:oe,message:ge});const ve={...B,url:se};return this.requestService.request(ve,H)}}async getEngine(N){let B=Q(N);if(!B){const H=await this.getManifestFromRawExtensionVersion(N,L.CancellationToken.None);if(!H)throw new Error("Manifest was not found");B=H.engines.vscode}return B}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const N=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},L.CancellationToken.None);if(N.res.statusCode!==200)throw new Error("Could not get extensions report.");const B=await(0,v.asJson)(N),H=new Map;if(B)for(const x of B.malicious){const ie=H.get(x)||{id:{id:x},malicious:!0,slow:!1};ie.malicious=!0,H.set(x,ie)}return[...H.values()]}};R=ue([te(0,v.IRequestService),te(1,g.ILogService),te(2,w.IEnvironmentService),te(3,o.ITelemetryService),te(4,p.IFileService),te(5,I.IProductService),te(6,f.IConfigurationService),te(7,(0,d.optional)(h.IStorageService))],R),e.ExtensionGalleryService=R;async function O(_,N,B,H,x,ie){const ae={"X-Market-Client-Id":`VSCode ${_}`,"User-Agent":`VSCode ${_}`},oe=await(0,u.getServiceMachineId)(B,x,ie);return(0,c.getTelemetryLevel)(N,B)>=2&&H.getValue("telemetry.enableTelemetry")===!0&&(ae["X-Market-User-Id"]=oe),ae}e.resolveMarketplaceHeaders=O}),define(J[202],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var y;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(y=e.ColorScheme||(e.ColorScheme={}))}),define(J[203],Z([0,1,108,5,2,4,38,202]),function(K,e,y,L,k,D,E,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,D.createDecorator)("themeService");var f;(function(I){function v(u){return u&&typeof u=="object"&&typeof u.id=="string"}I.isThemeColor=v})(f=e.ThemeColor||(e.ThemeColor={}));function w(I){return{id:I}}e.themeColorFromId=w;var t;(function(I){function v(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color=="undefined"||f.isThemeColor(a.color))}I.isThemeIcon=v;const u=new RegExp(`^\\$\\((${y.CSSIcon.iconNameExpression}(?:${y.CSSIcon.iconModifierExpression})?)\\)$`);function h(a){const n=u.exec(a);if(!n)return;let[,s]=n;return{id:s}}I.fromString=h;function o(a,n){let s=a.id;const l=s.lastIndexOf("~");return l!==-1&&(s=s.substring(0,l)),n&&(s=`${s}~${n}`),{id:s}}I.modify=o;function c(a,n){return a.id===n.id&&a.color?.id===n.color?.id}I.isEqual=c;function i(a,n){return{id:a.id,color:n?w(n):void 0}}I.asThemeIcon=i,I.asClassNameArray=y.CSSIcon.asClassNameArray,I.asClassName=y.CSSIcon.asClassName,I.asCSSSelector=y.CSSIcon.asCSSSelector})(t=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=y.Codicon.file,e.FolderThemeIcon=y.Codicon.folder;function P(I){switch(I){case r.ColorScheme.DARK:return"vs-dark";case r.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class b{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(v){return this.themingParticipants.push(v),this.onThemingParticipantAddedEmitter.fire(v),(0,k.toDisposable)(()=>{const u=this.themingParticipants.indexOf(v);this.themingParticipants.splice(u,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new b;E.Registry.add(e.Extensions.ThemingContribution,p);function d(I){return p.onColorThemeChange(I)}e.registerThemingParticipant=d;class g extends k.Disposable{constructor(v){super();this.themeService=v,this.theme=v.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(u=>this.onThemeChange(u)))}onThemeChange(v){this.theme=v,this.updateStyles()}updateStyles(){}getColor(v,u){let h=this.theme.getColor(v);return h&&u&&(h=u(h,this.theme)),h?h.toString():null}}e.Themable=g}),define(J[60],Z([0,1,14,3,4,39]),function(K,e,y,L,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const E="#FFFFFF",r="#1E1E1E",f="#000000",w="theme",t="themeBackground",P="windowSplash";e.IThemeMainService=(0,k.createDecorator)("themeMainService");let b=class{constructor(d){this.stateMainService=d}getBackgroundColor(){if((L.isWindows||L.isMacintosh)&&y.nativeTheme.shouldUseInvertedColorScheme)return f;let d=this.stateMainService.getItem(t,null);if(!d){let g;(L.isWindows||L.isMacintosh)&&y.nativeTheme.shouldUseInvertedColorScheme?g="hc-black":g=this.stateMainService.getItem(w,"vs-dark").split(" ")[0],d=g==="hc-black"?f:g==="vs"?E:r}return L.isMacintosh&&d.toUpperCase()===r&&(d="#171717"),d}saveWindowSplash(d,g){this.stateMainService.setItems([{key:w,data:g.baseTheme},{key:t,data:g.colorInfo.background},{key:P,data:g}]),typeof d=="number"&&this.updateBackgroundColor(d,g)}updateBackgroundColor(d,g){for(const I of y.BrowserWindow.getAllWindows())if(I.id===d){I.setBackgroundColor(g.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(P)}};b=ue([te(0,D.IStateMainService)],b),e.ThemeMainService=b}),define(J[42],Z([0,1,4]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var L;(function(D){D.Uninitialized="uninitialized",D.Idle="idle",D.CheckingForUpdates="checking for updates",D.AvailableForDownload="available for download",D.Downloading="downloading",D.Downloaded="downloaded",D.Updating="updating",D.Ready="ready"})(L=e.StateType||(e.StateType={}));var k;(function(D){D[D.Setup=0]="Setup",D[D.Archive=1]="Archive",D[D.Snap=2]="Snap"})(k=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(D,E)=>({type:"idle",updateType:D,error:E}),CheckingForUpdates:D=>({type:"checking for updates",explicit:D}),AvailableForDownload:D=>({type:"available for download",update:D}),Downloading:D=>({type:"downloading",update:D}),Downloaded:D=>({type:"downloaded",update:D}),Updating:D=>({type:"updating",update:D}),Ready:D=>({type:"ready",update:D})},e.IUpdateService=(0,y.createDecorator)("updateService")}),define(J[204],Z([0,1,3,148,49,38]),function(K,e,y,L,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),D.Registry.as(k.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,L.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,L.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,L.localize)(2,null),(0,L.localize)(3,null),(0,L.localize)(4,null),(0,L.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,L.localize)(6,null),deprecationMessage:(0,L.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,L.localize)(8,null),description:(0,L.localize)(9,null),included:y.isWindows&&!y.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,L.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(J[205],Z([0,1,5,42]),function(K,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class k{constructor(r){this.service=r}listen(r,f){switch(f){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${f}`)}call(r,f,w){switch(f){case"checkForUpdates":return this.service.checkForUpdates(w);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${f}`)}}e.UpdateChannel=k;class D{constructor(r){this.channel=r,this._onStateChange=new y.Emitter,this.onStateChange=this._onStateChange.event,this._state=L.State.Uninitialized,this.channel.listen("onStateChange")(f=>this.state=f),this.channel.call("_getInitialState").then(f=>this.state=f)}get state(){return this._state}set state(r){this._state=r,this._onStateChange.fire(r)}checkForUpdates(r){return this.channel.call("checkForUpdates",r)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=D}),define(J[97],Z([0,1,4]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,y.createDecorator)("urlService")}),define(J[206],Z([0,1,7]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class L{constructor(r){this.handler=r}listen(r,f){throw new Error(`Event not found: ${f}`)}call(r,f,w){switch(f){case"handleURL":return this.handler.handleURL(y.URI.revive(w[0]),w[1])}throw new Error(`Call not found: ${f}`)}}e.URLHandlerChannel=L;class k{constructor(r){this.channel=r}handleURL(r,f){return this.channel.call("handleURL",[r.toJSON(),f])}}e.URLHandlerChannelClient=k;class D{constructor(r){this.next=r}async routeCall(r,f,w,t){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(w){const P=y.URI.revive(w);if(P&&P.query){const b=/\bwindowId=(\d+)/.exec(P.query);if(b){const p=b[1],d=new RegExp(`window:${p}`),g=r.connections.find(I=>d.test(I.ctx));if(g)return g}}}return this.next.routeCall(r,f,w,t)}routeEvent(r,f){throw new Error(`Event not found: ${f}`)}}e.URLHandlerRouter=D}),define(J[207],Z([0,1,9,2,7,21]),function(K,e,y,L,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class E extends L.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(w,t){const P=[...this.handlers.values()];return(0,y.first)(P.map(b=>()=>b.handleURL(w,t)),void 0,!1).then(b=>b||!1)}registerHandler(w){return this.handlers.add(w),(0,L.toDisposable)(()=>this.handlers.delete(w))}}e.AbstractURLService=E;let r=class extends E{constructor(w){super();this.productService=w}create(w){let{authority:t,path:P,query:b,fragment:p}=w||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return t&&P&&P.indexOf("/")!==0&&(P=`/${P}`),k.URI.from({scheme:this.productService.urlProtocol,authority:t,path:P,query:b,fragment:p})}};r=ue([te(0,D.IProductService)],r),e.NativeURLService=r}),define(J[208],Z([0,1,14,9,5,2,3,7]),function(K,e,y,L,k,D,E,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function f(t){try{return r.URI.parse(t)}catch(P){return null}}class w{constructor(P,b,p,d,g){if(this.urlService=b,this.uris=[],this.retryCount=0,this.flushDisposable=D.Disposable.None,this.disposables=new D.DisposableStore,this.uris=P,E.isWindows){const u=d.isBuilt?[]:[`"${d.appRoot}"`];u.push("--open-url","--"),y.app.setAsDefaultProtocolClient(g.urlProtocol,process.execPath,u)}const I=k.Event.map(k.Event.fromNodeEventEmitter(y.app,"open-url",(u,h)=>({event:u,url:h})),({event:u,url:h})=>(u.preventDefault(),h));this.disposables.add(I(u=>{const h=f(u);!h||this.urlService.open(h,{originalUrl:u})})),p.getWindows().filter(u=>u.isReady).length>0?this.flush():k.Event.once(p.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const P=[];for(const b of this.uris)await this.urlService.open(b.uri,{originalUrl:b.url})||P.push(b);P.length!==0&&(this.uris=P,this.flushDisposable=(0,L.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=w}),define(J[209],Z([0,1,4]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,y.createDecorator)("webviewManagerService")}),define(J[210],Z([0,1,14,2,10,7]),function(K,e,y,L,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class E extends L.Disposable{constructor(){super();const f=this.handleWebviewRequest.bind(this);y.protocol.registerFileProtocol(k.Schemas.vscodeWebview,f)}handleWebviewRequest(f,w){try{const t=D.URI.parse(f.url),P=E.validWebviewFilePaths.get(t.path);if(typeof P=="string"){const b=`vs/workbench/contrib/webview/browser/pre/${P}`,p=k.FileAccess.asFileUri(b,K);return w(decodeURIComponent(p.fsPath))}else return w({error:-10})}catch{}return w({error:-2})}}e.WebviewProtocolProvider=E,E.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(J[61],Z([0,1,3]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function L(w){return!!w.workspaceUri}e.isWorkspaceToOpen=L;function k(w){return!!w.folderUri}e.isFolderToOpen=k;function D(w){return!!w.fileUri}e.isFileToOpen=D;function E(w){const t=r(w),P=w.getValue("window.menuBarVisibility");return P==="default"||t==="native"&&P==="compact"||y.isMacintosh&&y.isNative?"classic":P}e.getMenuBarVisibility=E;function r(w){if(y.isWeb)return"custom";const t=w.getValue("window");if(t){if(y.isMacintosh&&t.nativeTabs===!0||y.isMacintosh&&t.nativeFullScreen===!1)return"native";const p=t.titleBarStyle;if(p==="native"||p==="custom")return p}return y.isLinux?"native":"custom"}e.getTitleBarStyle=r;function f(w=0){return Math.pow(1.2,w)}e.zoomLevelToZoomFactor=f}),define(J[36],Z([0,1,4]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=e.UnloadReason=e.LoadReason=void 0;var L;(function(w){w[w.INITIAL=1]="INITIAL",w[w.LOAD=2]="LOAD",w[w.RELOAD=3]="RELOAD"})(L=e.LoadReason||(e.LoadReason={}));var k;(function(w){w[w.CLOSE=1]="CLOSE",w[w.QUIT=2]="QUIT",w[w.RELOAD=3]="RELOAD",w[w.LOAD=4]="LOAD"})(k=e.UnloadReason||(e.UnloadReason={}));var D;(function(w){w[w.CLI=0]="CLI",w[w.DOCK=1]="DOCK",w[w.MENU=2]="MENU",w[w.DIALOG=3]="DIALOG",w[w.DESKTOP=4]="DESKTOP",w[w.API=5]="API"})(D=e.OpenContext||(e.OpenContext={}));const E=function(w=1){return{width:1024,height:768,mode:w}};e.defaultWindowState=E;var r;(function(w){w[w.Maximized=0]="Maximized",w[w.Normal=1]="Normal",w[w.Minimized=2]="Minimized",w[w.Fullscreen=3]="Fullscreen"})(r=e.WindowMode||(e.WindowMode={}));var f;(function(w){w[w.UNRESPONSIVE=1]="UNRESPONSIVE",w[w.CRASHED=2]="CRASHED",w[w.LOAD=3]="LOAD"})(f=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,y.createDecorator)("windowsMainService")}),define(J[211],Z([0,1,14,5,2,210,36]),function(K,e,y,L,k,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let r=class extends k.Disposable{constructor(w){super();this.windowsMainService=w,this._onFoundInFrame=this._register(new L.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new D.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(w,t){let P;if(typeof w.windowId=="number"){const{windowId:b}=w,p=this.windowsMainService.getWindowById(b);if(!p?.win)throw new Error(`Invalid windowId: ${b}`);P=p.win.webContents}else{const{webContentsId:b}=w;if(P=y.webContents.fromId(b),!P)throw new Error(`Invalid webContentsId: ${b}`)}P.isDestroyed()||P.setIgnoreMenuShortcuts(t)}async findInFrame(w,t,P,b){const p=this.getFrameByName(w,t),d=p;if(typeof d.findInFrame=="function"){d.findInFrame(P,{findNext:b.findNext,forward:b.forward});const g=(I,v)=>{v.finalUpdate&&(this._onFoundInFrame.fire(v),p.removeListener("found-in-frame",g))};p.on("found-in-frame",g)}}async stopFindInFrame(w,t,P){const p=this.getFrameByName(w,t);typeof p.stopFindInFrame=="function"&&p.stopFindInFrame(P.keepSelection?"keepSelection":"clearSelection")}getFrameByName(w,t){const P=this.windowsMainService.getWindowById(w.windowId);if(!P?.win)throw new Error(`Invalid windowId: ${w}`);const b=P.win.webContents.mainFrame.framesInSubtree.find(p=>p.name===t);if(!b)throw new Error(`Unknown frame: ${t}`);return b}};r=ue([te(0,E.IWindowsMainService)],r),e.WebviewMainService=r}),define(J[212],Z([0,1,9,5,2]),function(K,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class D extends k.Disposable{constructor({onDidOpenWindow:r,onDidFocusWindow:f,getActiveWindowId:w}){super();this.disposables=this._register(new k.DisposableStore),L.Event.latch(L.Event.any(r,f))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,y.createCancelablePromise)(()=>w()),(async()=>{try{const P=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:P}catch(P){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(r){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=r}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=D}),define(J[213],Z([0,1,37,15,7,4]),function(K,e,y,L,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,D.createDecorator)("contextService");var E;(function(b){b[b.EMPTY=1]="EMPTY",b[b.FOLDER=2]="FOLDER",b[b.WORKSPACE=3]="WORKSPACE"})(E=e.WorkbenchState||(e.WorkbenchState={}));function r(b){const p=b;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&Array.isArray(p.folders))}e.isWorkspace=r;function f(b){const p=b;return!!(p&&typeof p=="object"&&k.URI.isUri(p.uri)&&typeof p.name=="string"&&typeof p.toResource=="function")}e.isWorkspaceFolder=f;class w{constructor(p,d,g,I){this._id=p,this._configuration=g,this._ignorePathCasing=I,this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=d}update(p){this._id=p.id,this._configuration=p.configuration,this._ignorePathCasing=p._ignorePathCasing,this.folders=p.folders}get folders(){return this._folders}set folders(p){this._folders=p,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(p){this._configuration=p}getFolder(p){return p&&this._foldersMap.findSubstr(p.with({scheme:p.scheme,authority:p.authority,path:p.path}))||null}updateFoldersMap(){this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing);for(const p of this.folders)this._foldersMap.set(p.uri,p)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=w;class t{constructor(p,d){this.raw=d,this.uri=p.uri,this.index=p.index,this.name=p.name}toResource(p){return(0,L.joinPath)(this.uri,p)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=t;function P(b){return new t({uri:b,index:0,name:(0,L.basenameOrAuthority)(b)},{uri:b.toString()})}e.toWorkspaceFolder=P}),define(J[27],Z([0,1,29,40,77,33,10,8,3,15,7,151,4,73,213]),function(K,e,y,L,k,D,E,r,f,w,t,P,b,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const g=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,P.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function I(W){return(typeof W=="string"?(0,r.extname)(W):(0,w.extname)(W))===g}e.hasWorkspaceFileExtension=I,e.IWorkspacesService=(0,b.createDecorator)("workspacesService");function v(W){return W.hasOwnProperty("workspace")}e.isRecentWorkspace=v;function u(W){return W.hasOwnProperty("folderUri")}e.isRecentFolder=u;function h(W){return W.hasOwnProperty("fileUri")}e.isRecentFile=h;function o(W){const V=W;return typeof V?.id=="string"&&t.URI.isUri(V.uri)}e.isSingleFolderWorkspaceIdentifier=o;function c(W){if(W.configuration)return{id:W.id,configPath:W.configuration};if(W.folders.length===1)return{id:W.id,uri:W.folders[0].uri}}e.toWorkspaceIdentifier=c;function i(W){const V=W;return typeof V?.id=="string"&&t.URI.isUri(V.configPath)}e.isWorkspaceIdentifier=i;function a(W){const V=W;if(V?.uri)return{id:V.id,uri:t.URI.revive(V.uri)};const z=W;if(z?.configPath)return{id:z.id,configPath:t.URI.revive(z.configPath)};if(W?.id)return{id:W.id}}e.reviveIdentifier=a;function n(W,V){return w.extUriBiasedIgnorePathCase.isEqualOrParent(W,V.untitledWorkspacesHome)}e.isUntitledWorkspace=n;function s(W){return l(W)||m(W)}e.isStoredWorkspaceFolder=s;function l(W){const V=W;return typeof V?.path=="string"&&(!V.name||typeof V.name=="string")}e.isRawFileWorkspaceFolder=l;function m(W){const V=W;return typeof V?.uri=="string"&&(!V.name||typeof V.name=="string")}e.isRawUriWorkspaceFolder=m;function S(W,V,z,$,j=!f.isWindows,U){if(W.scheme!==$.scheme)return{name:z,uri:W.toString(!0)};let q=V?void 0:U.relativePath($,W);if(q!==void 0)q.length===0?q=".":f.isWindows&&W.scheme===E.Schemas.file&&!j&&(q=q.replace(/\//g,"\\"));else if(W.scheme===E.Schemas.file)q=W.fsPath,f.isWindows&&(q=(0,D.normalizeDriveLetter)(q),j&&(q=(0,y.toSlashes)(q)));else{if(!U.isEqualAuthority(W.authority,$.authority))return{name:z,uri:W.toString(!0)};q=W.path}return{name:z,path:q}}e.getStoredWorkspaceFolder=S;function M(W,V,z){let $=[],j=new Set;const U=z.dirname(V);for(let q of W){let T;if(l(q))q.path&&(T=z.resolvePath(U,q.path));else if(m(q))try{T=t.URI.parse(q.uri),T.path[0]!=="/"&&(T=T.with({path:"/"+T.path}))}catch(R){console.warn(R)}if(T){let R=z.getComparisonKey(T);if(!j.has(R)){j.add(R);const O=q.name||z.basenameOrAuthority(T);$.push(new d.WorkspaceFolder({uri:T,name:O,index:$.length},q))}}}return $}e.toWorkspaceFolders=M;function A(W,V,z,$,j){let U=F(V,W);const q=j.dirname(V),T=j.dirname($),R=[],O=C(U.folders);for(const H of U.folders){const x=l(H)?j.resolvePath(q,H.path):t.URI.parse(H.uri);let ie;z?ie=!1:ie=!l(H)||(0,r.isAbsolute)(H.path),R.push(S(x,ie,H.name,T,O,j))}const _={insertSpaces:!1,tabSize:4,eol:f.isLinux||f.isMacintosh?`
`:`\r
`},N=k.setProperty(W,["folders"],R,_);let B=k.applyEdits(W,N);return U.remoteAuthority===(0,p.getRemoteAuthority)($)&&(B=k.applyEdits(B,k.removeProperty(B,["remoteAuthority"],_))),B}e.rewriteWorkspaceFileForNewLocation=A;function F(W,V){let z=L.parse(V);if(z&&Array.isArray(z.folders))z.folders=z.folders.filter($=>s($));else throw new Error(`${W} looks like an invalid workspace file.`);return z}function C(W){return f.isWindows?W.some(V=>l(V)&&V.path.indexOf("/")>=0):!0}e.useSlashForPath=C;function X(W){return W.workspace&&typeof W.workspace=="object"&&typeof W.workspace.id=="string"&&typeof W.workspace.configPath=="string"}function ee(W){return typeof W.folderUri=="string"}function re(W){return typeof W.fileUri=="string"}function Y(W,V){const z={workspaces:[],files:[]};if(W){const $=function(U,q){for(let T=0;T<U.length;T++)try{q(U[T],T)}catch(R){V.warn(`Error restoring recent entry ${JSON.stringify(U[T])}: ${R.toString()}. Skip entry.`)}},j=W;if(Array.isArray(j.entries))$(j.entries,U=>{const q=U.label,T=U.remoteAuthority;X(U)?z.workspaces.push({label:q,remoteAuthority:T,workspace:{id:U.workspace.id,configPath:t.URI.parse(U.workspace.configPath)}}):ee(U)?z.workspaces.push({label:q,remoteAuthority:T,folderUri:t.URI.parse(U.folderUri)}):re(U)&&z.files.push({label:q,remoteAuthority:T,fileUri:t.URI.parse(U.fileUri)})});else{const U=W;Array.isArray(U.workspaces3)&&$(U.workspaces3,(q,T)=>{const R=Array.isArray(U.workspaceLabels)&&U.workspaceLabels[T]||void 0;typeof q=="object"&&typeof q.id=="string"&&typeof q.configURIPath=="string"?z.workspaces.push({label:R,workspace:{id:q.id,configPath:t.URI.parse(q.configURIPath)}}):typeof q=="string"&&z.workspaces.push({label:R,folderUri:t.URI.parse(q)})}),Array.isArray(U.files2)&&$(U.files2,(q,T)=>{const R=Array.isArray(U.fileLabels)&&U.fileLabels[T]||void 0;typeof q=="string"&&z.files.push({label:R,fileUri:t.URI.parse(q)})})}}return z}e.restoreRecentlyOpened=Y;function Q(W){const V={entries:[]};for(const z of W.workspaces)u(z)?V.entries.push({folderUri:z.folderUri.toString(),label:z.label,remoteAuthority:z.remoteAuthority}):V.entries.push({workspace:{id:z.workspace.id,configPath:z.workspace.configPath.toString()},label:z.label,remoteAuthority:z.remoteAuthority});for(const z of W.files)V.entries.push({fileUri:z.fileUri.toString(),label:z.label,remoteAuthority:z.remoteAuthority});return V}e.toStoreData=Q}),define(J[51],Z([0,1,4,27]),function(K,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=(0,y.createDecorator)("backupMainService");function k(D){const E=D;return E&&(0,L.isWorkspaceIdentifier)(E.workspace)}e.isWorkspaceBackupInfo=k}),define(J[52],Z([0,1,14,9,79,33,2,65,8,3,13,19,133,4,39,27]),function(K,e,y,L,k,D,E,r,f,w,t,P,b,p,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,p.createDecorator)("dialogMainService");let I=class gt{constructor(u){this.stateMainService=u,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new L.Queue}pickFileFolder(u,h){return this.doPick({...u,pickFolders:!0,pickFiles:!0,title:(0,b.localize)(0,null)},h)}pickFolder(u,h){return this.doPick({...u,pickFolders:!0,title:(0,b.localize)(1,null)},h)}pickFile(u,h){return this.doPick({...u,pickFiles:!0,title:(0,b.localize)(2,null)},h)}pickWorkspace(u,h){const o=(0,b.localize)(3,null),c=(0,D.mnemonicButtonLabel)((0,b.localize)(4,null)),i=g.WORKSPACE_FILTER;return this.doPick({...u,pickFiles:!0,title:o,filters:i,buttonLabel:c},h)}async doPick(u,h){const o={title:u.title,buttonLabel:u.buttonLabel,filters:u.filters};o.defaultPath=u.defaultPath||this.stateMainService.getItem(gt.workingDirPickerStorageKey),(typeof u.pickFiles=="boolean"||typeof u.pickFolders=="boolean")&&(o.properties=void 0,u.pickFiles&&u.pickFolders&&(o.properties=["multiSelections","openDirectory","openFile","createDirectory"])),o.properties||(o.properties=["multiSelections",u.pickFolders?"openDirectory":"openFile","createDirectory"]),w.isMacintosh&&o.properties.push("treatPackageAsDirectory");const c=h||y.BrowserWindow.getFocusedWindow(),i=await this.showOpenDialog(o,(0,t.withNullAsUndefined)(c));if(i&&i.filePaths&&i.filePaths.length>0)return this.stateMainService.setItem(gt.workingDirPickerStorageKey,(0,f.dirname)(i.filePaths[0])),i.filePaths}getWindowDialogQueue(u){if(u){let h=this.windowDialogQueues.get(u.id);return h||(h=new L.Queue,this.windowDialogQueues.set(u.id,h)),h}else return this.noWindowDialogueQueue}showMessageBox(u,h){return this.getWindowDialogQueue(h).queue(async()=>h?y.dialog.showMessageBox(h,u):y.dialog.showMessageBox(u))}async showSaveDialog(u,h){const o=this.acquireFileDialogLock(u,h);if(!o)throw new Error("A file save dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(h).queue(async()=>{let c;return h?c=await y.dialog.showSaveDialog(h,u):c=await y.dialog.showSaveDialog(u),c.filePath=this.normalizePath(c.filePath),c})}finally{(0,E.dispose)(o)}}normalizePath(u){return u&&w.isMacintosh&&(u=(0,r.normalizeNFC)(u)),u}normalizePaths(u){return u.map(h=>this.normalizePath(h))}async showOpenDialog(u,h){u.defaultPath&&(await P.Promises.exists(u.defaultPath)||(u.defaultPath=void 0));const o=this.acquireFileDialogLock(u,h);if(!o)throw new Error("A file open dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(h).queue(async()=>{let c;return h?c=await y.dialog.showOpenDialog(h,u):c=await y.dialog.showOpenDialog(u),c.filePaths=this.normalizePaths(c.filePaths),c})}finally{(0,E.dispose)(o)}}acquireFileDialogLock(u,h){if(!h)return E.Disposable.None;let o=this.windowFileDialogLocks.get(h.id);o||(o=new Set,this.windowFileDialogLocks.set(h.id,o));const c=(0,k.hash)(u);if(!o.has(c))return o.add(c),(0,E.toDisposable)(()=>{o?.delete(c),o?.size===0&&this.windowFileDialogLocks.delete(h.id)})}};I.workingDirPickerStorageKey="pickerWorkingDir",I=ue([te(0,d.IStateMainService)],I),e.DialogMainService=I}),define(J[214],Z([0,1,5,2,27]),function(K,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class D extends L.Disposable{constructor(r,f){super();this.logService=r,this.storageMainService=f,this._onDidChangeGlobalStorage=this._register(new y.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(y.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(r,f)=>(r?r.push(f):r=[f],r),D.STORAGE_CHANGE_DEBOUNCE_TIME)(r=>{r.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(r))}))}serializeGlobalStorageEvents(r){const f=new Map,w=new Set;return r.forEach(t=>{const P=this.storageMainService.globalStorage.get(t.key);typeof P=="string"?f.set(t.key,P):w.add(t.key)}),{changed:Array.from(f.entries()),deleted:Array.from(w.values())}}listen(r,f){switch(f){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${f}`)}async call(r,f,w){const t=(0,k.reviveIdentifier)(w.workspace),P=await this.withStorageInitialized(t);switch(f){case"getItems":return Array.from(P.items.entries());case"updateItems":{const b=w;if(b.insert)for(const[p,d]of b.insert)P.set(p,d);b.delete&&b.delete.forEach(p=>P.delete(p));break}case"close":{if(t)return P.close();break}default:throw new Error(`Call not found: ${f}`)}}async withStorageInitialized(r){const f=r?this.storageMainService.workspaceStorage(r):this.storageMainService.globalStorage;try{await f.init()}catch(w){this.logService.error(`StorageIPC#init: Unable to init ${r?"workspace":"global"} storage due to ${w}`)}return f}}e.StorageDatabaseChannel=D,D.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(J[215],Z([0,1,5,2,8,28,19,85,123,6,96,34,27]),function(K,e,y,L,k,D,E,r,f,w,t,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class p extends L.Disposable{constructor(v){super();this.logService=v,this._onDidChangeStorage=this._register(new y.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new y.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new r.Storage(new r.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const v=await this.doCreate();this.storage.dispose(),this.storage=v,this._register(v.onDidChangeStorage(h=>this._onDidChangeStorage.fire({key:h}))),await this.doInit(v);const u=v.getBoolean(t.IS_NEW_KEY);u===void 0?v.set(t.IS_NEW_KEY,!0):u&&v.set(t.IS_NEW_KEY,!1)}catch(v){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${v}`)}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===w.LogLevel.Trace?v=>this.logService.trace(v):void 0,logError:v=>this.logService.error(v)}}doInit(v){return v.init()}get items(){return this.storage.items}get(v,u){return this.storage.get(v,u)}set(v,u){return this.storage.set(v,u)}delete(v){return this.storage.delete(v)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class d extends p{constructor(v,u,h){super(u);this.options=v,this.environmentService=h}async doCreate(){let v;return this.options.useInMemoryStorage?v=f.SQLiteStorageDatabase.IN_MEMORY_PATH:v=(0,k.join)(this.environmentService.globalStorageHome.fsPath,d.STORAGE_NAME),new r.Storage(new f.SQLiteStorageDatabase(v,{logging:this.createLoggingOptions()}))}async doInit(v){await super.doInit(v),this.updateTelemetryState(v)}updateTelemetryState(v){v.get(P.instanceStorageKey,void 0)===void 0&&v.set(P.instanceStorageKey,(0,D.generateUuid)()),v.get(P.firstSessionDateStorageKey,void 0)===void 0&&v.set(P.firstSessionDateStorageKey,new Date().toUTCString());const o=v.get(P.currentSessionDateStorageKey,void 0),c=new Date().toUTCString();v.set(P.lastSessionDateStorageKey,typeof o=="undefined"?null:o),v.set(P.currentSessionDateStorageKey,c)}}e.GlobalStorageMain=d,d.STORAGE_NAME="state.vscdb";class g extends p{constructor(v,u,h,o){super(h);this.workspace=v,this.options=u,this.environmentService=o}async doCreate(){const{storageFilePath:v,wasCreated:u}=await this.prepareWorkspaceStorageFolder();return new r.Storage(new f.SQLiteStorageDatabase(v,{logging:this.createLoggingOptions()}),{hint:u?r.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:f.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const v=(0,k.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),u=(0,k.join)(v,g.WORKSPACE_STORAGE_NAME);return await E.Promises.exists(v)?{storageFilePath:u,wasCreated:!1}:(await E.Promises.mkdir(v,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(v),{storageFilePath:u,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(v){let u;if((0,b.isSingleFolderWorkspaceIdentifier)(this.workspace)?u={folder:this.workspace.uri.toString()}:(0,b.isWorkspaceIdentifier)(this.workspace)&&(u={workspace:this.workspace.configPath.toString()}),u)try{const h=(0,k.join)(v,g.WORKSPACE_META_NAME);await E.Promises.exists(h)||await E.Promises.writeFile(h,JSON.stringify(u,void 0,2))}catch(h){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${h}`)}}}e.WorkspaceStorageMain=g,g.WORKSPACE_STORAGE_NAME="state.vscdb",g.WORKSPACE_META_NAME="workspace.json"}),define(J[98],Z([0,1,43,2,47,4,22,6,215]),function(K,e,y,L,k,D,E,r,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,D.createDecorator)("storageMainService");let w=class extends L.Disposable{constructor(P,b,p){super();this.logService=P,this.environmentService=b,this.lifecycleMainService=p,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async P=>{P.workspace&&this.workspaceStorage(P.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(P=>{P.join(this.globalStorage.close());for(const[,b]of this.mapWorkspaceToStorage)P.join(b.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const P=new f.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,y.once)(P.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),P}createWorkspaceStorage(P){return new f.WorkspaceStorageMain(P,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(P){let b=this.mapWorkspaceToStorage.get(P.id);return b||(this.logService.trace(`StorageMainService: creating workspace storage (${P.id})`),b=this.createWorkspaceStorage(P),this.mapWorkspaceToStorage.set(P.id,b),(0,y.once)(b.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${P.id})`),this.mapWorkspaceToStorage.delete(P.id)})),b}};w=ue([te(0,r.ILogService),te(1,k.IEnvironmentService),te(2,E.ILifecycleMainService)],w),e.StorageMainService=w}),define(J[99],Z([0,1,15,7,27]),function(K,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function D(f,w,t){for(const b of f){const p=b.openedWorkspace;if((0,k.isWorkspaceIdentifier)(p)){const d=t(p);if(d){if(d.folders.some(g=>y.extUriBiasedIgnorePathCase.isEqualOrParent(w,g.uri)))return b}else if(y.extUriBiasedIgnorePathCase.isEqualOrParent(w,p.configPath))return b}}const P=f.filter(b=>(0,k.isSingleFolderWorkspaceIdentifier)(b.openedWorkspace)&&y.extUriBiasedIgnorePathCase.isEqualOrParent(w,b.openedWorkspace.uri));if(P.length)return P.sort((b,p)=>-(b.openedWorkspace.uri.path.length-p.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=D;function E(f,w){for(const t of f)if((0,k.isWorkspaceIdentifier)(t.openedWorkspace)&&y.extUriBiasedIgnorePathCase.isEqual(t.openedWorkspace.configPath,w)||(0,k.isSingleFolderWorkspaceIdentifier)(t.openedWorkspace)&&y.extUriBiasedIgnorePathCase.isEqual(t.openedWorkspace.uri,w))return t}e.findWindowOnWorkspaceOrFolder=E;function r(f,w){const t=P=>w.some(b=>y.extUriBiasedIgnorePathCase.isEqual(L.URI.file(b),L.URI.file(P)));for(const P of f)if(P.config?.extensionDevelopmentPath?.some(b=>t(b)))return P}e.findWindowOnExtensionDevelopmentPath=r}),define(J[216],Z([0,1,14,2,3,15,7,16,22,6,39,36,27]),function(K,e,y,L,k,D,E,r,f,w,t,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let p=class mt extends L.Disposable{constructor(h,o,c,i,a){super();this.windowsMainService=h,this.stateMainService=o,this.lifecycleMainService=c,this.logService=i,this.configurationService=a,this._state=d(this.stateMainService.getItem(mt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){y.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(h=>this.onBeforeCloseWindow(h)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(h=>{h.newCount-h.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(h=>this.onBeforeCloseWindow(h))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const h={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!h.lastActiveWindow){let i=this.windowsMainService.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.windowsMainService.getWindows().find(a=>!a.isExtensionDevelopmentHost)),i&&(h.lastActiveWindow=this.toWindowState(i))}const o=this.windowsMainService.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);o&&(h.lastPluginDevelopmentHostWindow=this.toWindowState(o)),this.windowsMainService.getWindowCount()>1&&(h.openedWindows=this.windowsMainService.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>this.toWindowState(i)));const c=I(h);this.stateMainService.setItem(mt.windowsStateStorageKey,c),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",c)}onBeforeCloseWindow(h){if(this.lifecycleMainService.quitRequested)return;const o=this.toWindowState(h);h.isExtensionDevelopmentHost&&!h.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=o:!h.isExtensionDevelopmentHost&&h.openedWorkspace&&this._state.openedWindows.forEach(c=>{const i=(0,b.isWorkspaceIdentifier)(h.openedWorkspace)&&c.workspace?.id===h.openedWorkspace.id,a=(0,b.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)&&c.folderUri&&D.extUriBiasedIgnorePathCase.isEqual(c.folderUri,h.openedWorkspace.uri);(i||a)&&(c.uiState=o.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=o)}toWindowState(h){return{workspace:(0,b.isWorkspaceIdentifier)(h.openedWorkspace)?h.openedWorkspace:void 0,folderUri:(0,b.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)?h.openedWorkspace.uri:void 0,backupPath:h.backupPath,remoteAuthority:h.remoteAuthority,uiState:h.serializeWindowState()}}getNewWindowState(h){const o=this.doGetNewWindowState(h),c=this.configurationService.getValue("window");let i;return o.hasDefaultState?i=!!(c?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(c.newWindowDimensions)>=0):(i=!!(this.lifecycleMainService.wasRestarted||c?.restoreFullscreen),i&&k.isMacintosh&&this.windowsMainService.getWindows().some(a=>a.isFullScreen)&&(i=!1)),o.mode===3&&!i&&(o.mode=1),o}doGetNewWindowState(h){const o=this.windowsMainService.getLastActiveWindow();if(!h.extensionTestsPath){if(!!h.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const l=h.workspace;if((0,b.isWorkspaceIdentifier)(l)){const S=this.state.openedWindows.filter(M=>M.workspace&&M.workspace.id===l.id).map(M=>M.uiState);if(S.length)return S[0]}if((0,b.isSingleFolderWorkspaceIdentifier)(l)){const S=this.state.openedWindows.filter(M=>M.folderUri&&D.extUriBiasedIgnorePathCase.isEqual(M.folderUri,l.uri)).map(M=>M.uiState);if(S.length)return S[0]}else if(h.backupPath){const S=this.state.openedWindows.filter(M=>M.backupPath===h.backupPath).map(M=>M.uiState);if(S.length)return S[0]}const m=this.lastClosedState||this.state.lastActiveWindow;if(!o&&m)return m.uiState}let c;const i=y.screen.getAllDisplays();if(i.length===1)c=i[0];else{if(k.isMacintosh){const l=y.screen.getCursorScreenPoint();c=y.screen.getDisplayNearestPoint(l)}!c&&o&&(c=y.screen.getDisplayMatching(o.getBounds())),c||(c=y.screen.getPrimaryDisplay()||i[0])}let a=(0,P.defaultWindowState)();a.x=Math.round(c.bounds.x+c.bounds.width/2-a.width/2),a.y=Math.round(c.bounds.y+c.bounds.height/2-a.height/2);const n=this.configurationService.getValue("window");let s=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")a.mode=0,s=!1;else if(n.newWindowDimensions==="fullscreen")a.mode=3,s=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&o){const l=o.serializeWindowState();l.mode===3?a.mode=3:a=l,s=a.mode!==3&&n.newWindowDimensions==="offset"}}return s&&(a=this.ensureNoOverlap(a)),a.hasDefaultState=!0,a}ensureNoOverlap(h){if(this.windowsMainService.getWindows().length===0)return h;h.x=typeof h.x=="number"?h.x:0,h.y=typeof h.y=="number"?h.y:0;const o=this.windowsMainService.getWindows().map(c=>c.getBounds());for(;o.some(c=>c.x===h.x||c.y===h.y);)h.x+=30,h.y+=30;return h}};p.windowsStateStorageKey="windowsState",p=ue([te(0,P.IWindowsMainService),te(1,t.IStateMainService),te(2,f.ILifecycleMainService),te(3,w.ILogService),te(4,r.IConfigurationService)],p),e.WindowsStateHandler=p;function d(u){const h={openedWindows:[]},o=u||{openedWindows:[]};return o.lastActiveWindow&&(h.lastActiveWindow=g(o.lastActiveWindow)),o.lastPluginDevelopmentHostWindow&&(h.lastPluginDevelopmentHostWindow=g(o.lastPluginDevelopmentHostWindow)),Array.isArray(o.openedWindows)&&(h.openedWindows=o.openedWindows.map(c=>g(c))),h}e.restoreWindowsState=d;function g(u){const h={uiState:u.uiState};return u.backupPath&&(h.backupPath=u.backupPath),u.remoteAuthority&&(h.remoteAuthority=u.remoteAuthority),u.folder&&(h.folderUri=E.URI.parse(u.folder)),u.workspaceIdentifier&&(h.workspace={id:u.workspaceIdentifier.id,configPath:E.URI.parse(u.workspaceIdentifier.configURIPath)}),h}function I(u){return{lastActiveWindow:u.lastActiveWindow&&v(u.lastActiveWindow),lastPluginDevelopmentHostWindow:u.lastPluginDevelopmentHostWindow&&v(u.lastPluginDevelopmentHostWindow),openedWindows:u.openedWindows.map(h=>v(h))}}e.getWindowsStateStoreData=I;function v(u){return{workspaceIdentifier:u.workspace&&{id:u.workspace.id,configURIPath:u.workspace.configPath.toString()},folder:u.folderUri&&u.folderUri.toString(),backupPath:u.backupPath,remoteAuthority:u.remoteAuthority,uiState:u.uiState}}}),define(J[100],Z([0,1,58,30,10,3,15]),function(K,e,y,L,k,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function r(w){function t(){let P=w.scheme===k.Schemas.file?(0,E.originalFSPath)(w):w.toString();return D.isLinux||(P=P.toLowerCase()),(0,y.createHash)("md5").update(P).digest("hex")}return{id:t(),configPath:w}}e.getWorkspaceIdentifier=r;function f(w,t){function P(){if(w.scheme!==k.Schemas.file)return(0,y.createHash)("md5").update(w.toString()).digest("hex");if(!t)try{t=(0,L.statSync)(w.fsPath)}catch(d){return}let p;return D.isLinux?p=t.ino:D.isMacintosh?p=t.birthtime.getTime():D.isWindows&&(typeof t.birthtimeMs=="number"?p=Math.floor(t.birthtimeMs):p=t.birthtime.getTime()),(0,y.createHash)("md5").update(w.fsPath).update(p?String(p):"").digest("hex")}const b=P();if(typeof b=="string")return{id:b,uri:w}}e.getSingleFolderWorkspaceIdentifier=f}),define(J[56],Z([0,1,58,59,26,18,17,5,2,8,3,28,35,83,217]),function(K,e,y,L,k,D,E,r,f,w,t,P,b,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class g{constructor(S){this.socket=S,this._errorListener=M=>{if(M){if(M.code==="EPIPE")return;(0,E.onUnexpectedError)(M)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(S){const M=A=>S(D.VSBuffer.wrap(A));return this.socket.on("data",M),{dispose:()=>this.socket.off("data",M)}}onClose(S){const M=A=>{S({type:0,hadError:A,error:void 0})};return this.socket.on("close",M),{dispose:()=>this.socket.off("close",M)}}onEnd(S){return this.socket.on("end",S),{dispose:()=>this.socket.off("end",S)}}write(S){if(!this.socket.destroyed)try{this.socket.write(S.buffer,M=>{if(M){if(M.code==="EPIPE")return;(0,E.onUnexpectedError)(M)}})}catch(M){if(M.code==="EPIPE")return;(0,E.onUnexpectedError)(M)}}end(){this.socket.end()}drain(){return new Promise((S,M)=>{if(this.socket.bufferSize===0){S();return}const A=()=>{this.socket.off("close",A),this.socket.off("end",A),this.socket.off("error",A),this.socket.off("timeout",A),this.socket.off("drain",A),S()};this.socket.on("close",A),this.socket.on("end",A),this.socket.on("error",A),this.socket.on("timeout",A),this.socket.on("drain",A)})}}e.NodeSocket=g;var I;(function(m){m[m.MinHeaderByteSize=2]="MinHeaderByteSize"})(I||(I={}));var v;(function(m){m[m.PeekHeader=1]="PeekHeader",m[m.ReadHeader=2]="ReadHeader",m[m.ReadBody=3]="ReadBody",m[m.Fin=4]="Fin"})(v||(v={}));class u extends f.Disposable{constructor(S,M,A,F){super();this._onDidZlibFlush=this._register(new r.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new r.Emitter),this._onClose=this._register(new r.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=S,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=M,this._recordInflateBytes=F,M?(this._zlibInflate=d.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",C=>{console.error(C),(0,E.onUnexpectedError)(C),this._onClose.fire({type:0,hadError:!0,error:C})}),this._zlibInflate.on("data",C=>{this._pendingInflateData.push(C)}),A&&(this._zlibInflate.write(A.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=d.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",C=>{console.error(C),(0,E.onUnexpectedError)(C),this._onClose.fire({type:0,hadError:!0,error:C})}),this._zlibDeflate.on("data",C=>{this._pendingDeflateData.push(C)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new p.ChunkStream,this._register(this.socket.onData(C=>this._acceptChunk(C))),this._register(this.socket.onClose(C=>this._onClose.fire(C)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?D.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):D.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(S){return this._onData.event(S)}onClose(S){return this._onClose.event(S)}onEnd(S){return this.socket.onEnd(S)}write(S){this._totalOutgoingDataBytes+=S.byteLength,this._zlibDeflate?(this._zlibDeflate.write(S.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let M=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,M=M.slice(0,M.length-4),this._isEnded||this._write(D.VSBuffer.wrap(M),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(S,!1)}_write(S,M){let A=2;S.byteLength<126?A+=0:S.byteLength<2**16?A+=2:A+=8;const F=D.VSBuffer.alloc(A);if(M?F.writeUInt8(194,0):F.writeUInt8(130,0),S.byteLength<126)F.writeUInt8(S.byteLength,1);else if(S.byteLength<2**16){F.writeUInt8(126,1);let C=1;F.writeUInt8(S.byteLength>>>8&255,++C),F.writeUInt8(S.byteLength>>>0&255,++C)}else{F.writeUInt8(127,1);let C=1;F.writeUInt8(0,++C),F.writeUInt8(0,++C),F.writeUInt8(0,++C),F.writeUInt8(0,++C),F.writeUInt8(S.byteLength>>>24&255,++C),F.writeUInt8(S.byteLength>>>16&255,++C),F.writeUInt8(S.byteLength>>>8&255,++C),F.writeUInt8(S.byteLength>>>0&255,++C)}this._totalOutgoingWireBytes+=F.byteLength+S.byteLength,this.socket.write(D.VSBuffer.concat([F,S]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(S){if(S.byteLength!==0){for(this._totalIncomingWireBytes+=S.byteLength,this._incomingData.acceptChunk(S);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const M=this._incomingData.peek(this._state.readLen),F=(M.readUInt8(0)&128)>>>7,C=M.readUInt8(1),X=(C&128)>>>7,ee=C&127;this._state.state=2,this._state.readLen=2+(X?4:0)+(ee===126?2:0)+(ee===127?8:0),this._state.fin=F,this._state.mask=0}else if(this._state.state===2){const M=this._incomingData.read(this._state.readLen),A=M.readUInt8(1),F=(A&128)>>>7;let C=A&127,X=1;C===126?C=M.readUInt8(++X)*2**8+M.readUInt8(++X):C===127&&(C=M.readUInt8(++X)*0+M.readUInt8(++X)*0+M.readUInt8(++X)*0+M.readUInt8(++X)*0+M.readUInt8(++X)*2**24+M.readUInt8(++X)*2**16+M.readUInt8(++X)*2**8+M.readUInt8(++X));let ee=0;F&&(ee=M.readUInt8(++X)*2**24+M.readUInt8(++X)*2**16+M.readUInt8(++X)*2**8+M.readUInt8(++X)),this._state.state=3,this._state.readLen=C,this._state.mask=ee}else if(this._state.state===3){const M=this._incomingData.read(this._state.readLen);h(M,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(M.buffer)),this._zlibInflate.write(M.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const A=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=A.length,this._onData.fire(D.VSBuffer.wrap(A))})):(this._totalIncomingDataBytes+=M.byteLength,this._onData.fire(M))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await r.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=u;function h(m,S){if(S===0)return;let M=m.byteLength>>>2;for(let re=0;re<M;re++){const Y=m.readUInt32BE(re*4);m.writeUInt32BE(Y^S,re*4)}let A=M*4,F=m.byteLength-A;const C=S>>>24&255,X=S>>>16&255,ee=S>>>8&255;F>=1&&m.writeUInt8(m.readUInt8(A)^C,A),F>=2&&m.writeUInt8(m.readUInt8(A+1)^X,A+1),F>=3&&m.writeUInt8(m.readUInt8(A+2)^ee,A+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function c(){const m=(0,P.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${m}-sock`;let S;return e.XDG_RUNTIME_DIR?S=(0,w.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${m}.sock`):S=(0,w.join)((0,k.tmpdir)(),`vscode-ipc-${m}.sock`),a(S),S}e.createRandomIPCHandle=c;function i(m,S,M){const A=(0,y.createHash)("md5").update(m).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${A}-${M}-${S}-sock`;let F;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?F=(0,w.join)(e.XDG_RUNTIME_DIR,`vscode-${A.substr(0,8)}-${M}-${S}.sock`):F=(0,w.join)(m,`${M}-${S}.sock`),a(F),F}e.createStaticIPCHandle=i;function a(m){const S=o[t.platform];typeof S=="number"&&m.length>=S&&console.warn(`WARNING: IPC handle "${m}" is longer than ${S} chars, try a shorter --user-data-dir`)}class n extends b.IPCServer{constructor(S){super(n.toClientConnectionEvent(S));this.server=S}static toClientConnectionEvent(S){const M=r.Event.fromNodeEventEmitter(S,"connection");return r.Event.map(M,A=>({protocol:new p.Protocol(new g(A)),onDidClientDisconnect:r.Event.once(r.Event.fromNodeEventEmitter(A,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=n;function s(m){return new Promise((S,M)=>{const A=(0,L.createServer)();A.on("error",M),A.listen(m,()=>{A.removeListener("error",M),S(new n(A))})})}e.serve=s;function l(m,S){return new Promise((M,A)=>{const F=(0,L.createConnection)(m,()=>{F.removeListener("error",A),M(p.Client.fromSocket(new g(F),S))});F.once("error",A)})}e.connect=l}),define(J[218],Z([0,1,56]),function(K,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class L{constructor(f){this.driver=f}listen(f,w){throw new Error("No event found")}call(f,w,t){switch(w){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(t);case"reloadWindow":return this.driver.reloadWindow(t);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(t[0],t[1]);case"click":return this.driver.click(t[0],t[1],t[2],t[3]);case"doubleClick":return this.driver.doubleClick(t[0],t[1]);case"setValue":return this.driver.setValue(t[0],t[1],t[2]);case"getTitle":return this.driver.getTitle(t[0]);case"isActiveElement":return this.driver.isActiveElement(t[0],t[1]);case"getElements":return this.driver.getElements(t[0],t[1],t[2]);case"getElementXY":return this.driver.getElementXY(t[0],t[1],t[2]);case"typeInEditor":return this.driver.typeInEditor(t[0],t[1],t[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(t[0],t[1]);case"writeInTerminal":return this.driver.writeInTerminal(t[0],t[1],t[2]);case"getLocaleInfo":return this.driver.getLocaleInfo(t);case"getLocalizedStrings":return this.driver.getLocalizedStrings(t)}throw new Error(`Call not found: ${w}`)}}e.DriverChannel=L;class k{constructor(f){this.channel=f}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(f){return this.channel.call("capturePage",f)}reloadWindow(f){return this.channel.call("reloadWindow",f)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(f,w){return this.channel.call("dispatchKeybinding",[f,w])}click(f,w,t,P){return this.channel.call("click",[f,w,t,P])}doubleClick(f,w){return this.channel.call("doubleClick",[f,w])}setValue(f,w,t){return this.channel.call("setValue",[f,w,t])}getTitle(f){return this.channel.call("getTitle",[f])}isActiveElement(f,w){return this.channel.call("isActiveElement",[f,w])}getElements(f,w,t){return this.channel.call("getElements",[f,w,t])}getElementXY(f,w,t,P){return this.channel.call("getElementXY",[f,w,t,P])}typeInEditor(f,w,t){return this.channel.call("typeInEditor",[f,w,t])}getTerminalBuffer(f,w){return this.channel.call("getTerminalBuffer",[f,w])}writeInTerminal(f,w,t){return this.channel.call("writeInTerminal",[f,w,t])}getLocaleInfo(f){return this.channel.call("getLocaleInfo",f)}getLocalizedStrings(f){return this.channel.call("getLocalizedStrings",f)}}e.DriverChannelClient=k;class D{constructor(f){this.registry=f}listen(f,w){throw new Error(`Event not found: ${w}`)}call(f,w,t){switch(w){case"registerWindowDriver":return this.registry.registerWindowDriver(t);case"reloadWindowDriver":return this.registry.reloadWindowDriver(t)}throw new Error(`Call not found: ${w}`)}}e.WindowDriverRegistryChannel=D;async function E(r){const f=await(0,y.connect)(r,"driverClient"),w=f.getChannel("driver"),t=new k(w);return{client:f,driver:t}}e.connect=E}),define(J[219],Z([0,1,9,5,106,57,2,3,78,35,56,155,218,176,22,36]),function(K,e,y,L,k,D,E,r,f,w,t,P,b,p,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function I(h){return h<21}let v=class{constructor(o,c,i,a){this.windowServer=o,this.options=c,this.windowsMainService=i,this.lifecycleMainService=a,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new L.Emitter}async registerWindowDriver(o){return this.registeredWindowIds.add(o),this.reloadingWindowIds.delete(o),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(o){this.reloadingWindowIds.add(o)}async getWindowIds(){return this.windowsMainService.getWindows().map(o=>o.id).filter(o=>this.registeredWindowIds.has(o)&&!this.reloadingWindowIds.has(o))}async capturePage(o){await this.whenUnfrozen(o);const c=this.windowsMainService.getWindowById(o);if(!c?.win)throw new Error("Invalid window");return(await c.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(o){await this.whenUnfrozen(o);const c=this.windowsMainService.getWindowById(o);if(!c)throw new Error("Invalid window");this.reloadingWindowIds.add(o),this.lifecycleMainService.reload(c)}exitApplication(){return this.lifecycleMainService.quit()}async dispatchKeybinding(o,c){await this.whenUnfrozen(o);const i=k.KeybindingParser.parseUserBinding(c);for(let a of i)await this._dispatchKeybinding(o,a)}async _dispatchKeybinding(o,c){if(c instanceof f.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const i=this.windowsMainService.getWindowById(o);if(!i?.win)throw new Error("Invalid window");const a=i.win.webContents,n=new D.SimpleKeybinding(!1,!1,!1,!1,c.keyCode),l=new p.USLayoutResolvedKeybinding(n.toChord(),r.OS).getElectronAccelerator(),m=[];c.ctrlKey&&m.push("ctrl"),c.metaKey&&m.push("meta"),c.shiftKey&&m.push("shift"),c.altKey&&m.push("alt"),a.sendInputEvent({type:"keyDown",keyCode:l,modifiers:m}),I(c.keyCode)||a.sendInputEvent({type:"char",keyCode:l,modifiers:m}),a.sendInputEvent({type:"keyUp",keyCode:l,modifiers:m}),await(0,y.timeout)(100)}async click(o,c,i,a){await(await this.getWindowDriver(o)).click(c,i,a)}async doubleClick(o,c){await(await this.getWindowDriver(o)).doubleClick(c)}async setValue(o,c,i){await(await this.getWindowDriver(o)).setValue(c,i)}async getTitle(o){return await(await this.getWindowDriver(o)).getTitle()}async isActiveElement(o,c){return await(await this.getWindowDriver(o)).isActiveElement(c)}async getElements(o,c,i){return await(await this.getWindowDriver(o)).getElements(c,i)}async getElementXY(o,c,i,a){return await(await this.getWindowDriver(o)).getElementXY(c,i,a)}async typeInEditor(o,c,i){await(await this.getWindowDriver(o)).typeInEditor(c,i)}async getTerminalBuffer(o,c){return await(await this.getWindowDriver(o)).getTerminalBuffer(c)}async writeInTerminal(o,c,i){await(await this.getWindowDriver(o)).writeInTerminal(c,i)}async getLocaleInfo(o){return await(await this.getWindowDriver(o)).getLocaleInfo()}async getLocalizedStrings(o){return await(await this.getWindowDriver(o)).getLocalizedStrings()}async getWindowDriver(o){await this.whenUnfrozen(o);const c=`window:${o}`,i=new w.StaticRouter(n=>n===c),a=this.windowServer.getChannel("windowDriver",i);return new P.WindowDriverChannelClient(a)}async whenUnfrozen(o){for(;this.reloadingWindowIds.has(o);)await L.Event.toPromise(this.onDidReloadingChange.event)}};v=ue([te(2,g.IWindowsMainService),te(3,d.ILifecycleMainService)],v),e.Driver=v;async function u(h,o,c,i){const a=c.driverVerbose,n=i.createInstance(v,h,{verbose:a}),s=new b.WindowDriverRegistryChannel(n);h.registerChannel("windowDriverRegistry",s);const l=await(0,t.serve)(o),m=new b.DriverChannel(n);return l.registerChannel("driver",m),(0,E.combinedDisposable)(l,h)}e.serve=u}),define(J[23],Z([0,1,46,8,56,47,160,4]),function(K,e,y,L,k,D,E,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,r.refineServiceDecorator)(D.IEnvironmentService);class f extends E.NativeEnvironmentService{get cachedLanguagesPath(){return(0,L.join)(this.userDataPath,"clp")}get backupHome(){return(0,L.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,L.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,k.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,L.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}ue([y.memoize],f.prototype,"cachedLanguagesPath",null),ue([y.memoize],f.prototype,"backupHome",null),ue([y.memoize],f.prototype,"backupWorkspacesPath",null),ue([y.memoize],f.prototype,"mainIPCHandle",null),ue([y.memoize],f.prototype,"mainLockfile",null),ue([y.memoize],f.prototype,"sandbox",null),ue([y.memoize],f.prototype,"driverVerbose",null),ue([y.memoize],f.prototype,"disableUpdates",null),ue([y.memoize],f.prototype,"disableKeytar",null),ue([y.memoize],f.prototype,"codeCachePath",null),ue([y.memoize],f.prototype,"useCodeCache",null),e.EnvironmentMainService=f}),define(J[220],Z([0,1,58,30,29,10,8,3,15,7,19,51,16,23,20,6,27]),function(K,e,y,L,k,D,E,r,f,w,t,P,b,p,d,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let v=class{constructor(h,o,c){this.configurationService=o,this.logService=c,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=f.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(i,a)=>(0,k.isEqual)(i,a,!r.isLinux)},this.backupHome=h.backupHome,this.workspacesJsonPath=h.backupWorkspacesPath}async initialize(){let h;try{h=JSON.parse(await t.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch(i){h=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(h.emptyWorkspaceInfos);let o=[];try{Array.isArray(h.rootURIWorkspaces)&&(o=h.rootURIWorkspaces.map(i=>({workspace:{id:i.id,configPath:w.URI.parse(i.configURIPath)},remoteAuthority:i.remoteAuthority})))}catch(i){}this.workspaces=await this.validateWorkspaces(o);let c=[];try{Array.isArray(h.folderURIWorkspaces)&&(c=h.folderURIWorkspaces.map(i=>w.URI.parse(i)))}catch(i){}this.folders=await this.validateFolders(c),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==d.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===d.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||d.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(h,o){this.workspaces.some(i=>h.workspace.id===i.workspace.id)||(this.workspaces.push(h),this.saveSync());const c=this.getBackupPath(h.workspace.id);return o&&this.moveBackupFolderSync(c,o),c}moveBackupFolderSync(h,o){if(L.existsSync(h)&&this.convertToEmptyWindowBackupSync(h),L.existsSync(o))try{L.renameSync(o,h)}catch(c){this.logService.error(`Backup: Could not move backup folder to new location: ${c.toString()}`)}}unregisterWorkspaceBackupSync(h){const o=h.id,c=this.workspaces.findIndex(i=>i.workspace.id===o);c!==-1&&(this.workspaces.splice(c,1),this.saveSync())}registerFolderBackupSync(h){return this.folders.some(o=>this.backupUriComparer.isEqual(h,o))||(this.folders.push(h),this.saveSync()),this.getBackupPath(this.getFolderHash(h))}unregisterFolderBackupSync(h){const o=this.folders.findIndex(c=>this.backupUriComparer.isEqual(h,c));o!==-1&&(this.folders.splice(o,1),this.saveSync())}registerEmptyWindowBackupSync(h,o){const c=h||this.getRandomEmptyWindowId();return this.emptyWindows.some(i=>!!i.backupFolder&&this.backupPathComparer.isEqual(i.backupFolder,c))||(this.emptyWindows.push({backupFolder:c,remoteAuthority:o}),this.saveSync()),this.getBackupPath(c)}unregisterEmptyWindowBackupSync(h){const o=this.emptyWindows.findIndex(c=>!!c.backupFolder&&this.backupPathComparer.isEqual(c.backupFolder,h));o!==-1&&(this.emptyWindows.splice(o,1),this.saveSync())}getBackupPath(h){return(0,E.join)(this.backupHome,h)}async validateWorkspaces(h){if(!Array.isArray(h))return[];const o=new Set,c=[];for(let i of h){const a=i.workspace;if(!(0,I.isWorkspaceIdentifier)(a))return[];if(!o.has(a.id)){o.add(a.id);const n=this.getBackupPath(a.id);await this.doHasBackups(n)?a.configPath.scheme!==D.Schemas.file||await t.Promises.exists(a.configPath.fsPath)?c.push(i):await this.convertToEmptyWindowBackup(n):await this.deleteStaleBackup(n)}}return c}async validateFolders(h){if(!Array.isArray(h))return[];const o=[],c=new Set;for(let i of h){const a=this.backupUriComparer.getComparisonKey(i);if(!c.has(a)){c.add(a);const n=this.getBackupPath(this.getFolderHash(i));await this.doHasBackups(n)?i.scheme!==D.Schemas.file||await t.Promises.exists(i.fsPath)?o.push(i):await this.convertToEmptyWindowBackup(n):await this.deleteStaleBackup(n)}}return o}async validateEmptyWorkspaces(h){if(!Array.isArray(h))return[];const o=[],c=new Set;for(let i of h){const a=i.backupFolder;if(typeof a!="string")return[];if(!c.has(a)){c.add(a);const n=this.getBackupPath(a);await this.doHasBackups(n)?o.push(i):await this.deleteStaleBackup(n)}}return o}async deleteStaleBackup(h){try{await t.Promises.exists(h)&&await t.Promises.rm(h,t.RimRafMode.MOVE)}catch(o){this.logService.error(`Backup: Could not delete stale backup: ${o.toString()}`)}}async convertToEmptyWindowBackup(h){let o=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(i=>!!i.backupFolder&&this.backupPathComparer.isEqual(i.backupFolder,o));)o=this.getRandomEmptyWindowId();const c=this.getBackupPath(o);try{await t.Promises.rename(h,c)}catch(i){return this.logService.error(`Backup: Could not rename backup folder: ${i.toString()}`),!1}return this.emptyWindows.push({backupFolder:o}),!0}convertToEmptyWindowBackupSync(h){let o=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(i=>!!i.backupFolder&&this.backupPathComparer.isEqual(i.backupFolder,o));)o=this.getRandomEmptyWindowId();const c=this.getBackupPath(o);try{L.renameSync(h,c)}catch(i){return this.logService.error(`Backup: Could not rename backup folder: ${i.toString()}`),!1}return this.emptyWindows.push({backupFolder:o}),!0}async getDirtyWorkspaces(){const h=[];for(const o of this.workspaces)await this.hasBackups(o)&&h.push(o.workspace);for(const o of this.folders)await this.hasBackups(o)&&h.push(o);return h}hasBackups(h){let o;return w.URI.isUri(h)?o=this.getBackupPath(this.getFolderHash(h)):(0,P.isWorkspaceBackupInfo)(h)?o=this.getBackupPath(h.workspace.id):o=h.backupFolder,this.doHasBackups(o)}async doHasBackups(h){try{const o=await t.Promises.readdir(h);for(const c of o)try{if((await t.Promises.readdir((0,E.join)(h,c))).length>0)return!0}catch(i){}}catch(o){}return!1}saveSync(){try{(0,t.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(h){this.logService.error(`Backup: Could not save workspaces.json: ${h.toString()}`)}}async save(){try{await t.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(h){this.logService.error(`Backup: Could not save workspaces.json: ${h.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(h=>({id:h.workspace.id,configURIPath:h.workspace.configPath.toString(),remoteAuthority:h.remoteAuthority})),folderURIWorkspaces:this.folders.map(h=>h.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(h){let o;return h.scheme===D.Schemas.file?o=r.isLinux?h.fsPath:h.fsPath.toLowerCase():o=h.toString().toLowerCase(),(0,y.createHash)("md5").update(o).digest("hex")}};v=ue([te(0,p.IEnvironmentMainService),te(1,b.IConfigurationService),te(2,g.ILogService)],v),e.BackupMainService=v}),define(J[221],Z([0,1,59,56]),function(K,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,D,E,r){const f=t=>r(t,void 0),w=y.createConnection({host:k,port:D},()=>{w.removeListener("error",f);const t=Buffer.alloc(16);for(let d=0;d<16;d++)t[d]=Math.round(Math.random()*256);const P=t.toString("base64");let b=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${D}/?${E}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${P}`];w.write(b.join(`\r
`)+`\r
\r
`);const p=d=>{d.toString().indexOf(`\r
\r
`)>=0&&(w.off("data",p),r(void 0,new L.NodeSocket(w)))};w.on("data",p)});w.once("error",f)}}}),define(J[222],Z([0,1,59,9,2,115,16,6,21,191,95,221,74]),function(K,e,y,L,k,D,E,r,f,w,t,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function p(v,u,h,o,c){return new d(v,u,h,o,c).waitForReady()}class d extends k.Disposable{constructor(u,h,o,c,i){super();this.defaultTunnelHost=h,this.suggestedLocalPort=i,this.public=!1,this._socketsDispose=new Map,this._options=u,this._server=y.createServer(),this._barrier=new L.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=a=>this._onConnection(a),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=c,this.tunnelRemoteHost=o}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(h=>{h()})}async waitForReady(){let u=await(0,D.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),h=null;return this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),h=this._server.address(),h||(u=0,this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),h=this._server.address()),this.tunnelLocalPort=h.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${h.port}`,this}async _onConnection(u){u.pause();const h=await(0,w.connectRemoteAgentTunnel)(this._options,this.tunnelRemoteHost,this.tunnelRemotePort),o=h.getSocket().socket,c=h.readEntireBuffer();h.dispose(),c.byteLength>0&&u.write(c.buffer),u.on("end",()=>{this._socketsDispose.delete(u.localAddress),o.end()}),u.on("close",()=>o.end()),u.on("error",()=>{this._socketsDispose.delete(u.localAddress),o.destroy()}),o.on("end",()=>u.end()),o.on("close",()=>u.end()),o.on("error",()=>{u.destroy()}),u.pipe(o),o.pipe(u),this._socketsDispose.set(u.localAddress,()=>{u.end(),o.end()})}}let g=class extends t.AbstractTunnelService{constructor(u,h,o,c,i){super(h);this.socketFactory=u,this.signService=o,this.productService=c,this.configurationService=i}get defaultTunnelHost(){return this.configurationService.getValue("remote.localPortHost")==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(u,h,o,c,i,a,n){const s=this.getTunnelFromMap(h,o);if(s)return++s.refcount,s.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,h,o,c,i,a,n);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${h}:${o} on local port ${c}.`);const l={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:u,signService:this.signService,logService:this.logService,ipcLogger:null},m=p(l,this.defaultTunnelHost,h,o,c);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(h,o,m),m}}};g=ue([te(1,r.ILogService),te(2,b.ISignService),te(3,f.IProductService),te(4,E.IConfigurationService)],g),e.BaseTunnelService=g;let I=class extends g{constructor(u,h,o,c){super(P.nodeSocketFactory,u,h,o,c)}};I=ue([te(0,r.ILogService),te(1,b.ISignService),te(2,f.IProductService),te(3,E.IConfigurationService)],I),e.TunnelService=I}),define(J[223],Z([0,1,193,18,17,2,13,16,47,90,6,192,217]),function(K,e,y,L,k,D,E,r,f,w,t,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let p=class extends D.Disposable{constructor(g,I,v){super();this.environmentService=I,this.logService=v,this.configure(g.getValue()),this._register(g.onDidChangeConfiguration(()=>this.configure(g.getValue()),this))}configure(g){this.proxyUrl=g.http&&g.http.proxy,this.strictSSL=!!(g.http&&g.http.proxyStrictSSL),this.authorization=g.http&&g.http.proxyAuthorization}async request(g,I){this.logService.trace("RequestService#request",g.url);const{proxyUrl:v,strictSSL:u}=this,h={...process.env,...await(0,w.resolveShellEnv)(this.logService,this.environmentService.args,process.env)},o=g.agent?g.agent:await(0,P.getProxyAgent)(g.url||"",h,{proxyUrl:v,strictSSL:u});return g.agent=o,g.strictSSL=u,this.authorization&&(g.headers={...g.headers||{},"Proxy-Authorization":this.authorization}),this._request(g,I)}async getNodeRequest(g){return((0,y.parse)(g.url).protocol==="https:"?await new Promise((u,h)=>{K(["https"],u,h)}):await new Promise((u,h)=>{K(["http"],u,h)})).request}_request(g,I){return new Promise(async(v,u)=>{let h;const o=(0,y.parse)(g.url),c=g.getRawRequest?g.getRawRequest(g):await this.getNodeRequest(g),i={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,E.isBoolean)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(i.auth=g.user+":"+g.password),h=c(i,a=>{const n=(0,E.isNumber)(g.followRedirects)?g.followRedirects:3;if(a.statusCode&&a.statusCode>=300&&a.statusCode<400&&n>0&&a.headers.location)this._request({...g,url:a.headers.location,followRedirects:n-1},I).then(v,u);else{let s=a;a.headers["content-encoding"]==="gzip"&&(s=a.pipe((0,b.createGunzip)())),v({res:a,stream:(0,L.streamToBufferReadableStream)(s)})}}),h.on("error",u),g.timeout&&h.setTimeout(g.timeout),g.data&&typeof g.data=="string"&&h.write(g.data),h.end(),I.onCancellationRequested(()=>{h.abort(),u((0,k.canceled)())})})}async resolveProxy(g){}};p=ue([te(0,r.IConfigurationService),te(1,f.INativeEnvironmentService),te(2,t.ILogService)],p),e.RequestService=p}),define(J[224],Z([0,1,14,223]),function(K,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function k(E){return y.net.request}class D extends L.RequestService{request(r,f){return super.request({...r||{},getRawRequest:k},f)}}e.RequestMainService=D}),define(J[225],Z([0,1,14,9,5,2,10,13,84,23,22,6,48,55,60]),function(K,e,y,L,k,D,E,r,f,w,t,P,b,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let g=class extends D.Disposable{constructor(v,u,h,o,c,i,a){super();this.machineId=v,this.userEnv=u,this.environmentMainService=h,this.lifecycleMainService=o,this.logService=c,this.themeMainService=i,this.protocolMainService=a,this.firstWindowConnectionBarrier=new L.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new k.Emitter),this.onDidError=k.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown())),y.ipcMain.on("vscode:createSharedProcessMessageChannel",async(v,u)=>this.onWindowConnection(v,u))}async onWindowConnection(v,u){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const h=await this.connect();if(v.sender.isDestroyed())return h.close();v.sender.postMessage("vscode:createSharedProcessMessageChannelResult",u,[h])}onWillShutdown(){const v=this.window;!v||(!v.isDestroyed()&&!v.webContents.isDestroyed()&&v.webContents.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(v.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{v.close()}catch(u){}this.window=void 0},0))}whenReady(){return this._whenReady||(this._whenReady=new Promise(v=>y.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),v()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(v=>y.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),v()}))})()),this._whenIpcReady}createWindow(){const v=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new y.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:E.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",K).fsPath,additionalArguments:[`--vscode-window-config=${v.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}}),v.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:b.default}),this.window.loadURL(E.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",K).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=v=>{this.logService.trace("SharedProcess#close prevented"),v.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(v,u)=>this._onDidError.fire({type:2,details:u})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(v,u,h)=>this._onDidError.fire({type:3,details:{reason:h,exitCode:u}})))}async connect(){await this.whenIpcReady;const v=(0,r.assertIsDefined)(this.window);return(0,f.connect)(v)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}};g=ue([te(2,w.IEnvironmentMainService),te(3,t.ILifecycleMainService),te(4,P.ILogService),te(5,d.IThemeMainService),te(6,p.IProtocolMainService)],g),e.SharedProcess=g}),define(J[226],Z([0,1,9,18,8,13,7,23,20,6]),function(K,e,y,L,k,D,E,r,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class t{constructor(p,d,g){this.storagePath=p,this.logService=d,this.fileService=g,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new y.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(p){p.fileOperationResult!==1&&this.logService.error(p)}}getItem(p,d){const g=this.storage[p];return(0,D.isUndefinedOrNull)(g)?d:g}setItem(p,d){this.setItems([{key:p,data:d}])}setItems(p){let d=!1;for(const{key:g,data:I}of p)this.storage[g]!==I&&((0,D.isUndefinedOrNull)(I)?(0,D.isUndefined)(this.storage[g])||(this.storage[g]=void 0,d=!0):(this.storage[g]=I,d=!0));d&&this.save()}removeItem(p){(0,D.isUndefined)(this.storage[p])||(this.storage[p]=void 0,this.save())}async save(p){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),p)}async doSave(){if(!this.initializing)return;await this.initializing;const p=JSON.stringify(this.storage,null,4);if(p!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,L.VSBuffer.fromString(p)),this.lastSavedStorageContents=p}catch(d){this.logService.error(d)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=t;let P=class yt{constructor(p,d,g){this.fileStorage=new t(E.URI.file((0,k.join)(p.userDataPath,yt.STATE_FILE)),d,g)}async init(){return this.fileStorage.init()}getItem(p,d){return this.fileStorage.getItem(p,d)}setItem(p,d){this.fileStorage.setItem(p,d)}setItems(p){this.fileStorage.setItems(p)}removeItem(p){this.fileStorage.removeItem(p)}close(){return this.fileStorage.close()}};P.STATE_FILE="storage.json",P=ue([te(0,r.IEnvironmentMainService),te(1,w.ILogService),te(2,f.IFileService)],P),e.StateMainService=P}),define(J[76],Z([0,1,9,24,5,16,23,22,6,21,50,42]),function(K,e,y,L,k,D,E,r,f,w,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function b(d,g,I){return`${I.updateUrl}/api/update/${d}/${g}/${I.commit}`}e.createUpdateURL=b;let p=class{constructor(g,I,v,u,h,o){this.lifecycleMainService=g,this.configurationService=I,this.environmentMainService=v,this.requestService=u,this.logService=h,this.productService=o,this._state=P.State.Uninitialized,this._onStateChange=new k.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const g=(0,D.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel"),I=this.getProductQuality(g);if(!I){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(I),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(P.State.Idle(this.getUpdateType())),g==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}g==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,v=>this.logService.error(v))}getProductQuality(g){return g==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(g=60*60*1e3){return(0,y.timeout)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(g){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}isLatestVersion(){return this.url?this.requestService.request({url:this.url},L.CancellationToken.None).then(g=>g.res.statusCode===204):Promise.resolve(void 0)}getUpdateType(){return 1}doQuitAndInstall(){}};p=ue([te(0,r.ILifecycleMainService),te(1,D.IConfigurationService),te(2,E.IEnvironmentMainService),te(3,t.IRequestService),te(4,f.ILogService),te(5,w.IProductService)],p),e.AbstractUpdateService=p}),define(J[227],Z([0,1,14,46,5,2,16,23,22,6,21,50,34,42,76]),function(K,e,y,L,k,D,E,r,f,w,t,P,b,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let g=class extends d.AbstractUpdateService{constructor(v,u,h,o,c,i,a){super(v,u,o,c,i,a);this.telemetryService=h,this.disposables=new D.DisposableStore}get onRawError(){return k.Event.fromNodeEventEmitter(y.autoUpdater,"error",(v,u)=>u)}get onRawUpdateNotAvailable(){return k.Event.fromNodeEventEmitter(y.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return k.Event.fromNodeEventEmitter(y.autoUpdater,"update-available",(v,u,h)=>({url:u,version:h,productVersion:h}))}get onRawUpdateDownloaded(){return k.Event.fromNodeEventEmitter(y.autoUpdater,"update-downloaded",(v,u,h,o)=>({releaseNotes:u,version:h,productVersion:h,date:o}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(v){this.logService.error("UpdateService error:",v);const h=(this.state.type==="checking for updates"?this.state.explicit:!0)?v:void 0;this.setState(p.State.Idle(1,h))}buildUpdateFeedUrl(v){let u;this.productService.darwinUniversalAssetId?u=this.productService.darwinUniversalAssetId:u=process.arch==="x64"?"darwin":"darwin-arm64";const h=(0,d.createUpdateURL)(u,v,this.productService);try{y.autoUpdater.setFeedURL({url:h})}catch(o){this.logService.error("Failed to set update feed URL",o);return}return h}doCheckForUpdates(v){this.setState(p.State.CheckingForUpdates(v)),y.autoUpdater.checkForUpdates()}onUpdateAvailable(v){this.state.type==="checking for updates"&&this.setState(p.State.Downloading(v))}onUpdateDownloaded(v){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:v.version}),this.setState(p.State.Ready(v)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(p.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),y.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};ue([L.memoize],g.prototype,"onRawError",null),ue([L.memoize],g.prototype,"onRawUpdateNotAvailable",null),ue([L.memoize],g.prototype,"onRawUpdateAvailable",null),ue([L.memoize],g.prototype,"onRawUpdateDownloaded",null),g=ue([te(0,f.ILifecycleMainService),te(1,E.IConfigurationService),te(2,b.ITelemetryService),te(3,r.IEnvironmentMainService),te(4,P.IRequestService),te(5,w.ILogService),te(6,t.IProductService)],g),e.DarwinUpdateService=g}),define(J[228],Z([0,1,41,30,9,5,8,23,22,6,34,42]),function(K,e,y,L,k,D,E,r,f,w,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let b=class{constructor(g,I,v){if(this.lifecycleMainService=g,this.logService=v,this._state=P.State.Uninitialized,this._onStateChange=new D.Emitter,this.onStateChange=this._onStateChange.event,I.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(P.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,u=>this.logService.error(u))}get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}scheduleCheckForUpdates(g=60*60*1e3){return(0,k.timeout)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(g){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};b=ue([te(0,f.ILifecycleMainService),te(1,r.IEnvironmentMainService),te(2,w.ILogService)],b);let p=class extends b{constructor(g,I,v,u,h,o){super(v,u,h);this.snap=g,this.snapRevision=I,this.telemetryService=o;const c=(0,L.watch)(E.dirname(this.snap)),i=D.Event.fromNodeEventEmitter(c,"change",(l,m)=>m),a=D.Event.filter(i,l=>l==="current"),s=D.Event.debounce(a,(l,m)=>m,2e3)(()=>this.checkForUpdates(!1));v.onWillShutdown(()=>{s.dispose(),c.close()})}doCheckForUpdates(){this.setState(P.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(g=>{g?this.setState(P.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(P.State.Idle(2)))},g=>{this.logService.error(g),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(P.State.Idle(2,g.message||g))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,y.spawn)("sleep 3 && "+E.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const g=await new Promise((v,u)=>(0,L.realpath)(`${E.dirname(this.snap)}/current`,(h,o)=>h?u(h):v(o))),I=E.basename(g);return this.snapRevision!==I}isLatestVersion(){return this.isUpdateAvailable().then(void 0,g=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};p=ue([te(2,f.ILifecycleMainService),te(3,r.IEnvironmentMainService),te(4,w.ILogService),te(5,t.ITelemetryService)],p),e.SnapUpdateService=p}),define(J[45],Z([0,1,14,30,5,40,33,2,10,8,3,15,13,19,153,51,52,23,4,6,21,99,27,100]),function(K,e,y,L,k,D,E,r,f,w,t,P,b,p,d,g,I,v,u,h,o,c,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,u.createDecorator)("workspacesManagementMainService");let n=class extends r.Disposable{constructor(l,m,S,M,A){super();this.environmentMainService=l,this.logService=m,this.backupMainService=S,this.dialogMainService=M,this.productService=A,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new k.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new k.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(l){return this.doResolveLocalWorkspace(l,m=>(0,L.readFileSync)(m,"utf8"))}resolveLocalWorkspace(l){return this.doResolveLocalWorkspace(l,m=>p.Promises.readFile(m,"utf8"))}doResolveLocalWorkspace(l,m){if(!!this.isWorkspacePath(l)&&l.scheme===f.Schemas.file)try{const S=m(l.fsPath);return S instanceof Promise?S.then(M=>this.doResolveWorkspace(l,M),M=>{}):this.doResolveWorkspace(l,S)}catch{return}}isWorkspacePath(l){return(0,i.isUntitledWorkspace)(l,this.environmentMainService)||(0,i.hasWorkspaceFileExtension)(l)}doResolveWorkspace(l,m){try{const S=this.doParseStoredWorkspace(l,m),M=(0,a.getWorkspaceIdentifier)(l);return{id:M.id,configPath:M.configPath,folders:(0,i.toWorkspaceFolders)(S.folders,M.configPath,P.extUriBiasedIgnorePathCase),remoteAuthority:S.remoteAuthority,transient:S.transient}}catch(S){this.logService.warn(S.toString())}}doParseStoredWorkspace(l,m){const S=(0,D.parse)(m);if(S&&Array.isArray(S.folders))S.folders=S.folders.filter(M=>(0,i.isStoredWorkspaceFolder)(M));else throw new Error(`${l.toString(!0)} looks like an invalid workspace file.`);return S}async createUntitledWorkspace(l,m){const{workspace:S,storedWorkspace:M}=this.newUntitledWorkspace(l,m),A=S.configPath.fsPath;return await p.Promises.mkdir((0,w.dirname)(A),{recursive:!0}),await p.Promises.writeFile(A,JSON.stringify(M,null,"	")),S}createUntitledWorkspaceSync(l,m){const{workspace:S,storedWorkspace:M}=this.newUntitledWorkspace(l,m),A=S.configPath.fsPath;return(0,L.mkdirSync)((0,w.dirname)(A),{recursive:!0}),(0,p.writeFileSync)(A,JSON.stringify(M,null,"	")),S}newUntitledWorkspace(l=[],m){const S=(Date.now()+Math.round(Math.random()*1e3)).toString(),M=(0,P.joinPath)(this.untitledWorkspacesHome,S),A=(0,P.joinPath)(M,i.UNTITLED_WORKSPACE_NAME),F=[];for(const C of l)F.push((0,i.getStoredWorkspaceFolder)(C.uri,!0,C.name,M,!t.isWindows,P.extUriBiasedIgnorePathCase));return{workspace:(0,a.getWorkspaceIdentifier)(A),storedWorkspace:{folders:F,remoteAuthority:m}}}async getWorkspaceIdentifier(l){return(0,a.getWorkspaceIdentifier)(l)}isUntitledWorkspace(l){return(0,i.isUntitledWorkspace)(l.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(l){!this.isUntitledWorkspace(l)||(this.doDeleteUntitledWorkspaceSync(l),this._onDidDeleteUntitledWorkspace.fire(l))}async deleteUntitledWorkspace(l){this.deleteUntitledWorkspaceSync(l)}doDeleteUntitledWorkspaceSync(l){const m=(0,P.originalFSPath)(l.configPath);try{(0,p.rimrafSync)((0,w.dirname)(m));const S=(0,w.join)(this.environmentMainService.workspaceStorageHome.fsPath,l.id);(0,L.existsSync)(S)&&(0,p.writeFileSync)((0,w.join)(S,"obsolete"),"")}catch(S){this.logService.warn(`Unable to delete untitled workspace ${m} (${S}).`)}}getUntitledWorkspacesSync(){const l=[];try{const m=(0,p.readdirSync)(this.untitledWorkspacesHome.fsPath).map(S=>(0,P.joinPath)(this.untitledWorkspacesHome,S,i.UNTITLED_WORKSPACE_NAME));for(const S of m){const M=(0,a.getWorkspaceIdentifier)(S),A=this.resolveLocalWorkspaceSync(S);A?l.push({workspace:M,remoteAuthority:A.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(M)}}catch(m){m.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${m}).`)}return l}async enterWorkspace(l,m,S){if(!l||!l.win||!l.isReady||!await this.isValidTargetWorkspacePath(l,m,S))return;const A=this.doEnterWorkspace(l,(0,a.getWorkspaceIdentifier)(S));if(!!A)return this._onDidEnterWorkspace.fire({window:l,workspace:A.workspace}),A}async isValidTargetWorkspacePath(l,m,S){if(!S)return!0;if((0,i.isWorkspaceIdentifier)(l.openedWorkspace)&&P.extUriBiasedIgnorePathCase.isEqual(l.openedWorkspace.configPath,S))return!1;if((0,c.findWindowOnWorkspaceOrFolder)(m,S)){const M={title:this.productService.nameLong,type:"info",buttons:[(0,E.mnemonicButtonLabel)((0,d.localize)(0,null))],message:(0,d.localize)(1,null,(0,P.basename)(S)),detail:(0,d.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(M,(0,b.withNullAsUndefined)(y.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(l,m){if(!l.config)return;l.focus();let S;return l.config.extensionDevelopmentPath||(S=this.backupMainService.registerWorkspaceBackupSync({workspace:m,remoteAuthority:l.remoteAuthority},l.config.backupPath)),(0,i.isWorkspaceIdentifier)(l.openedWorkspace)&&this.isUntitledWorkspace(l.openedWorkspace)&&this.deleteUntitledWorkspaceSync(l.openedWorkspace),l.config.workspace=m,l.config.backupPath=S,{workspace:m,backupPath:S}}};n=ue([te(0,v.IEnvironmentMainService),te(1,h.ILogService),te(2,g.IBackupMainService),te(3,I.IDialogMainService),te(4,o.IProductService)],n),e.WorkspacesManagementMainService=n}),define(J[101],Z([0,1,14,31,24,3,13,7,19,16,54,4,6,97,36,27,45]),function(K,e,y,L,k,D,E,r,f,w,t,P,b,p,d,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,P.createDecorator)(e.ID);let v=class{constructor(h,o,c,i,a){this.logService=h,this.windowsMainService=o,this.urlService=c,this.workspacesManagementMainService=i,this.configurationService=a}async start(h,o){this.logService.trace("Received data from other instance: ",h,o),D.isMacintosh&&y.app.focus({steal:!0});const c=this.parseOpenUrl(h);if(c.length){let i=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(i=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),i.then(()=>{for(const{uri:a,url:n}of c)this.urlService.open(a,{originalUrl:n})})}else return this.startOpenWindow(h,o)}parseOpenUrl(h){return h["open-url"]&&h._urls&&h._urls.length>0?(0,L.coalesce)(h._urls.map(o=>{try{return{uri:r.URI.parse(o),url:o}}catch(c){return null}})):[]}async startOpenWindow(h,o){const c=(0,t.isLaunchedFromCli)(o)?0:4;let i=[];const a=h.wait&&h.waitMarkerFilePath?r.URI.file(h.waitMarkerFilePath):void 0,n=h.remote||void 0;if(h.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(h.extensionDevelopmentPath,{context:c,cli:h,userEnv:o,waitMarkerFileURI:a,remoteAuthority:n});else if(!h._.length&&!h["folder-uri"]&&!h["file-uri"]){let s=!1;if(h["new-window"]||h["unity-launch"])s=!0;else if(h["reuse-window"])s=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":s=!0;break;case"off":s=!1;break;default:s=!D.isMacintosh}if(s)i=this.windowsMainService.open({context:c,cli:h,userEnv:o,forceNewWindow:!0,forceEmpty:!0,waitMarkerFileURI:a,remoteAuthority:n});else{const l=this.windowsMainService.getLastActiveWindow();l?(l.focus(),i=[l]):i=this.windowsMainService.open({context:c,cli:h,forceEmpty:!0,remoteAuthority:n})}}else i=this.windowsMainService.open({context:c,cli:h,userEnv:o,forceNewWindow:h["new-window"],preferNewWindow:!h["reuse-window"]&&!h.wait,forceReuseWindow:h["reuse-window"],diffMode:h.diff,addMode:h.add,noRecentEntry:!!h["skip-add-to-recently-opened"],waitMarkerFileURI:a,gotoLineMode:h.goto,remoteAuthority:n});if(a&&i.length===1&&i[0])return Promise.race([i[0].whenClosedOrLoaded,(0,f.whenDeleted)(a.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const h=[];return y.BrowserWindow.getAllWindows().forEach(o=>{const c=this.windowsMainService.getWindowById(o.id);c?h.push(this.codeWindowToInfo(c)):h.push(this.browserWindowToInfo(o))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:h,screenReader:!!y.app.accessibilitySupportEnabled,gpuFeatureStatus:y.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(h){const o=this.windowsMainService.getWindows();return(await Promise.all(o.map(i=>new Promise(a=>{const n=i.remoteAuthority;if(n){const s=`vscode:getDiagnosticInfoResponse${i.id}`,l={includeProcesses:h.includeProcesses,folders:h.includeWorkspaceMetadata?this.getFolderURIs(i):void 0};i.sendWhenReady("vscode:getDiagnosticInfo",k.CancellationToken.None,{replyChannel:s,args:l}),y.ipcMain.once(s,(m,S)=>{S||a({hostName:n,errorMessage:`Unable to resolve connection to '${n}'.`}),a(S)}),setTimeout(()=>{a({hostName:n,errorMessage:`Fetching remote diagnostics for '${n}' timed out.`})},5e3)}else a(void 0)})))).filter(i=>!!i)}getFolderURIs(h){const o=[],c=h.openedWorkspace;if((0,g.isSingleFolderWorkspaceIdentifier)(c))o.push(c.uri);else if((0,g.isWorkspaceIdentifier)(c)){const i=this.workspacesManagementMainService.resolveLocalWorkspaceSync(c.configPath);i&&i.folders.forEach(n=>{o.push(n.uri)})}return o}codeWindowToInfo(h){const o=this.getFolderURIs(h),c=(0,E.assertIsDefined)(h.win);return this.browserWindowToInfo(c,o,h.remoteAuthority)}browserWindowToInfo(h,o=[],c){return{pid:h.webContents.getOSProcessId(),title:h.getTitle(),folderURIs:o,remoteAuthority:c}}};v=ue([te(0,b.ILogService),te(1,d.IWindowsMainService),te(2,p.IURLService),te(3,I.IWorkspacesManagementMainService),te(4,w.IConfigurationService)],v),e.LaunchMainService=v}),define(J[53],Z([0,1,41,14,26,114,46,5,33,2,10,8,3,7,81,66,19,145,52,23,4,22,6,21,34,60,36,27,45]),function(K,e,y,L,k,D,E,r,f,w,t,P,b,p,d,g,I,v,u,h,o,c,i,a,n,s,l,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,o.createDecorator)("nativeHostMainService");let M=class ct extends w.Disposable{constructor(F,C,X,ee,re,Y,Q,W,V,z){super();this.sharedProcess=F,this.windowsMainService=C,this.dialogMainService=X,this.lifecycleMainService=ee,this.environmentMainService=re,this.telemetryService=Y,this.logService=Q,this.productService=W,this.themeMainService=V,this.workspacesManagementMainService=z,this.onDidOpenWindow=r.Event.map(this.windowsMainService.onDidOpenWindow,$=>$.id),this.onDidMaximizeWindow=r.Event.filter(r.Event.fromNodeEventEmitter(L.app,"browser-window-maximize",($,j)=>j.id),$=>!!this.windowsMainService.getWindowById($)),this.onDidUnmaximizeWindow=r.Event.filter(r.Event.fromNodeEventEmitter(L.app,"browser-window-unmaximize",($,j)=>j.id),$=>!!this.windowsMainService.getWindowById($)),this.onDidBlurWindow=r.Event.filter(r.Event.fromNodeEventEmitter(L.app,"browser-window-blur",($,j)=>j.id),$=>!!this.windowsMainService.getWindowById($)),this.onDidFocusWindow=r.Event.any(r.Event.map(r.Event.filter(r.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),$=>!!$),$=>$.id),r.Event.filter(r.Event.fromNodeEventEmitter(L.app,"browser-window-focus",($,j)=>j.id),$=>!!this.windowsMainService.getWindowById($))),this.onDidResumeOS=r.Event.fromNodeEventEmitter(L.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new r.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new r.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=r.Event.debounce(r.Event.any(r.Event.filter(r.Event.fromNodeEventEmitter(L.screen,"display-metrics-changed",($,j,U)=>U),$=>!(Array.isArray($)&&$.length===1&&$[0]==="workArea")),r.Event.fromNodeEventEmitter(L.screen,"display-added"),r.Event.fromNodeEventEmitter(L.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){L.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire({highContrast:L.nativeTheme.shouldUseInvertedColorScheme||L.nativeTheme.shouldUseHighContrastColors,dark:L.nativeTheme.shouldUseDarkColors})})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(C=>({id:C.id,workspace:C.openedWorkspace,title:C.win?.getTitle()??"",filename:C.getRepresentedFilename(),dirty:C.isDocumentEdited()}))}async getWindowCount(F){return this.windowsMainService.getWindowCount()}async getActiveWindowId(F){const C=L.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(C)return C.id}openWindow(F,C,X){return Array.isArray(C)?this.doOpenWindow(F,C,X):this.doOpenEmptyWindow(F,C)}async doOpenWindow(F,C,X=Object.create(null)){C.length>0&&this.windowsMainService.open({context:5,contextWindowId:F,urisToOpen:C,cli:this.environmentMainService.args,forceNewWindow:X.forceNewWindow,forceReuseWindow:X.forceReuseWindow,preferNewWindow:X.preferNewWindow,diffMode:X.diffMode,addMode:X.addMode,gotoLineMode:X.gotoLineMode,noRecentEntry:X.noRecentEntry,waitMarkerFileURI:X.waitMarkerFileURI,remoteAuthority:X.remoteAuthority||void 0})}async doOpenEmptyWindow(F,C){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:F},C)}async toggleFullScreen(F){const C=this.windowById(F);C&&C.toggleFullScreen()}async handleTitleDoubleClick(F){const C=this.windowById(F);C&&C.handleTitleDoubleClick()}async isMaximized(F){const C=this.windowById(F);return C?.win?C.win.isMaximized():!1}async maximizeWindow(F){const C=this.windowById(F);C?.win&&C.win.maximize()}async unmaximizeWindow(F){const C=this.windowById(F);C?.win&&C.win.unmaximize()}async minimizeWindow(F){const C=this.windowById(F);C?.win&&C.win.minimize()}async focusWindow(F,C){C&&typeof C.windowId=="number"&&(F=C.windowId);const X=this.windowById(F);X&&X.focus({force:C?.force??!1})}async setMinimumSize(F,C,X){const ee=this.windowById(F);if(ee?.win){const[re,Y]=ee.win.getSize(),[Q,W]=ee.win.getMinimumSize(),[V,z]=[C??Q,X??W],[$,j]=[Math.max(re,V),Math.max(Y,z)];(Q!==V||W!==z)&&ee.win.setMinimumSize(V,z),(re!==$||Y!==j)&&ee.win.setSize($,j)}}async saveWindowSplash(F,C){this.themeMainService.saveWindowSplash(F,C)}async installShellCommand(F){const{source:C,target:X}=await this.getShellCommandLink();try{const{symbolicLink:ee}=await I.SymlinkSupport.stat(C);if(ee&&!ee.dangling){const re=await(0,d.realpath)(C);if(X===re)return}await I.Promises.unlink(C)}catch(ee){if(ee.code!=="ENOENT")throw ee}try{await I.Promises.symlink(X,C)}catch(ee){if(ee.code!=="EACCES"&&ee.code!=="ENOENT")throw ee;const{response:re}=await this.showMessageBox(F,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(0,null,this.productService.nameShort),buttons:[(0,f.mnemonicButtonLabel)((0,v.localize)(1,null)),(0,f.mnemonicButtonLabel)((0,v.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(re===0)try{const Y=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${X}' '${C}'\\" with administrator privileges"`;await(0,D.promisify)(y.exec)(Y)}catch(Y){throw new Error((0,v.localize)(3,null,C))}}}async uninstallShellCommand(F){const{source:C}=await this.getShellCommandLink();try{await I.Promises.unlink(C)}catch(X){switch(X.code){case"EACCES":const{response:ee}=await this.showMessageBox(F,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(4,null,this.productService.nameShort),buttons:[(0,f.mnemonicButtonLabel)((0,v.localize)(5,null)),(0,f.mnemonicButtonLabel)((0,v.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(ee===0)try{const re=`osascript -e "do shell script \\"rm '${C}'\\" with administrator privileges"`;await(0,D.promisify)(y.exec)(re)}catch(re){throw new Error((0,v.localize)(7,null,C))}break;case"ENOENT":break;default:throw X}}}async getShellCommandLink(){const F=(0,P.resolve)(this.environmentMainService.appRoot,"bin","code"),C=`/usr/local/bin/${this.productService.applicationName}`;if(!await I.Promises.exists(F))throw new Error((0,v.localize)(8,null,F));return{source:C,target:F}}async showMessageBox(F,C){return this.dialogMainService.showMessageBox(C,this.toBrowserWindow(F))}async showSaveDialog(F,C){return this.dialogMainService.showSaveDialog(C,this.toBrowserWindow(F))}async showOpenDialog(F,C){return this.dialogMainService.showOpenDialog(C,this.toBrowserWindow(F))}toBrowserWindow(F){const C=this.windowById(F);if(C?.win)return C.win}async pickFileFolderAndOpen(F,C){const X=await this.dialogMainService.pickFileFolder(C);X&&(this.sendPickerTelemetry(X,C.telemetryEventName||"openFileFolder",C.telemetryExtraData),this.doOpenPicked(await Promise.all(X.map(async ee=>await I.SymlinkSupport.existsDirectory(ee)?{folderUri:p.URI.file(ee)}:{fileUri:p.URI.file(ee)})),C,F))}async pickFolderAndOpen(F,C){const X=await this.dialogMainService.pickFolder(C);X&&(this.sendPickerTelemetry(X,C.telemetryEventName||"openFolder",C.telemetryExtraData),this.doOpenPicked(X.map(ee=>({folderUri:p.URI.file(ee)})),C,F))}async pickFileAndOpen(F,C){const X=await this.dialogMainService.pickFile(C);X&&(this.sendPickerTelemetry(X,C.telemetryEventName||"openFile",C.telemetryExtraData),this.doOpenPicked(X.map(ee=>({fileUri:p.URI.file(ee)})),C,F))}async pickWorkspaceAndOpen(F,C){const X=await this.dialogMainService.pickWorkspace(C);X&&(this.sendPickerTelemetry(X,C.telemetryEventName||"openWorkspace",C.telemetryExtraData),this.doOpenPicked(X.map(ee=>({workspaceUri:p.URI.file(ee)})),C,F))}doOpenPicked(F,C,X){this.windowsMainService.open({context:3,contextWindowId:X,cli:this.environmentMainService.args,urisToOpen:F,forceNewWindow:C.forceNewWindow})}sendPickerTelemetry(F,C,X){const ee=F?F.length:0;this.telemetryService.publicLog(C,{...X,outcome:ee?"success":"canceled",numberOfPaths:ee})}async showItemInFolder(F,C){L.shell.showItemInFolder(C)}async setRepresentedFilename(F,C){const X=this.windowById(F);X&&X.setRepresentedFilename(C)}async setDocumentEdited(F,C){const X=this.windowById(F);X&&X.setDocumentEdited(C)}async openExternal(F,C){return b.isLinuxSnap?this.safeSnapOpenExternal(C):L.shell.openExternal(C),!0}safeSnapOpenExternal(F){const C=process.env.GDK_PIXBUF_MODULE_FILE,X=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,L.shell.openExternal(F),process.env.GDK_PIXBUF_MODULE_FILE=C,process.env.GDK_PIXBUF_MODULEDIR=X}moveItemToTrash(F,C){return L.shell.trashItem(C)}async isAdmin(){let F;return b.isWindows?F=(await new Promise((C,X)=>{K(["native-is-elevated"],C,X)}))():F=process.getuid()===0,F}async writeElevated(F,C,X,ee){const re=await new Promise((Y,Q)=>{K(["sudo-prompt"],Y,Q)});return new Promise((Y,Q)=>{const W=[`"${this.cliPath}"`];ee?.unlock&&W.push("--file-chmod"),W.push("--file-write",`"${C.fsPath}"`,`"${X.fsPath}"`);const V={name:this.productService.nameLong.replace("-",""),icns:b.isMacintosh&&this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};re.exec(W.join(" "),V,(z,$,j)=>{$&&this.logService.trace(`[sudo-prompt] received stdout: ${$}`),j&&this.logService.trace(`[sudo-prompt] received stderr: ${j}`),z?Q(z):Y(void 0)})})}get cliPath(){return b.isWindows?this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):b.isLinux?this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,P.join)(this.environmentMainService.appRoot,"bin","code"):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,k.totalmem)(),freemem:(0,k.freemem)(),loadavg:(0,k.loadavg)()}}async getOSProperties(){return{arch:(0,k.arch)(),platform:(0,k.platform)(),release:(0,k.release)(),type:(0,k.type)(),cpus:(0,k.cpus)()}}async getOSVirtualMachineHint(){return g.virtualMachineHint.value()}async killProcess(F,C,X){process.kill(C,X)}async readClipboardText(F,C){return L.clipboard.readText(C)}async writeClipboardText(F,C,X){return L.clipboard.writeText(C,X)}async readClipboardFindText(F){return L.clipboard.readFindText()}async writeClipboardFindText(F,C){return L.clipboard.writeFindText(C)}async writeClipboardBuffer(F,C,X,ee){return L.clipboard.writeBuffer(C,Buffer.from(X),ee)}async readClipboardBuffer(F,C){return L.clipboard.readBuffer(C)}async hasClipboard(F,C,X){return L.clipboard.has(C,X)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){L.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){L.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){L.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){L.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){L.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(F,C){const X=this.windowById(F);X&&X.updateTouchBar(C)}async notifyReady(F){const C=this.windowById(F);C&&C.setReady()}async relaunch(F,C){return this.lifecycleMainService.relaunch(C)}async reload(F,C){const X=this.windowById(F);if(X){if((0,m.isWorkspaceIdentifier)(X.openedWorkspace)){const ee=X.openedWorkspace.configPath;if(ee.scheme===t.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(ee))?.transient)return this.openWindow(X.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(X,C?.disableExtensions!==void 0?{_:[],"disable-extensions":C.disableExtensions}:void 0)}}async closeWindow(F){this.closeWindowById(F,F)}async closeWindowById(F,C){const X=this.windowById(C);if(X?.win)return X.win.close()}async quit(F){const C=this.windowsMainService.getLastActiveWindow();C?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&C.win?C.win.close():this.lifecycleMainService.quit()}async exit(F,C){await this.lifecycleMainService.kill(C)}async resolveProxy(F,C){const ee=this.windowById(F)?.win?.webContents?.session;if(ee)return ee.resolveProxy(C)}async openDevTools(F,C){const X=this.windowById(F);X?.win&&X.win.webContents.openDevTools(C)}async toggleDevTools(F){const C=this.windowById(F);C?.win&&C.win.webContents.toggleDevTools()}async sendInputEvent(F,C){const X=this.windowById(F);X?.win&&(C.type==="mouseDown"||C.type==="mouseUp")&&X.win.webContents.sendInputEvent(C)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(F,C,X,ee){if(!b.isWindows)return;const re=await new Promise((Y,Q)=>{K(["vscode-windows-registry"],Y,Q)});try{return re.GetStringRegKey(C,X,ee)}catch{return}}async getPassword(F,C,X){const ee=await this.withKeytar(),re=await ee.getPassword(C,X);if(re)try{let{content:Y,hasNextChunk:Q}=JSON.parse(re);if(!Y||!Q)return re;let W=1;for(;Q;){const V=await ee.getPassword(C,`${X}-${W}`),z=JSON.parse(V);Y+=z.content,Q=z.hasNextChunk,W++}return Y}catch{return re}return re}async setPassword(F,C,X,ee){const re=await this.withKeytar(),Y=3,Q=async(W,V,z)=>{let $=0,j;for(;$<Y;)try{await re.setPassword(W,V,z);return}catch(U){j=U,this.logService.warn("Error attempting to set a password: ",U),$++,await new Promise(q=>setTimeout(q,200))}throw j};if(b.isWindows&&ee.length>ct.MAX_PASSWORD_LENGTH){let W=0,V=0,z=!0;for(;z;){const $=ee.substring(W,W+ct.PASSWORD_CHUNK_SIZE);W+=ct.PASSWORD_CHUNK_SIZE,z=ee.length-W>0;const j={content:$,hasNextChunk:z};await Q(C,V?`${X}-${V}`:X,JSON.stringify(j)),V++}}else await Q(C,X,ee);this._onDidChangePassword.fire({service:C,account:X})}async deletePassword(F,C,X){const re=await(await this.withKeytar()).deletePassword(C,X);return re&&this._onDidChangePassword.fire({service:C,account:X}),re}async findPassword(F,C){return(await this.withKeytar()).findPassword(C)}async findCredentials(F,C){return(await this.withKeytar()).findCredentials(C)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((F,C)=>{K(["keytar"],F,C)})}windowById(F){if(typeof F=="number")return this.windowsMainService.getWindowById(F)}};M.MAX_PASSWORD_LENGTH=2500,M.PASSWORD_CHUNK_SIZE=M.MAX_PASSWORD_LENGTH-100,ue([E.memoize],M.prototype,"cliPath",null),M=ue([te(1,l.IWindowsMainService),te(2,u.IDialogMainService),te(3,c.ILifecycleMainService),te(4,h.IEnvironmentMainService),te(5,n.ITelemetryService),te(6,i.ILogService),te(7,a.IProductService),te(8,s.IThemeMainService),te(9,S.IWorkspacesManagementMainService)],M),e.NativeHostMainService=M}),define(J[229],Z([0,1,14,24,5,79,2,28,88,6,53,21,36]),function(K,e,y,L,k,D,E,r,f,w,t,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var p;(function(g){g[g.Initial=1]="Initial",g[g.StoredCredentialsUsed=2]="StoredCredentialsUsed",g[g.LoginDialogShown=3]="LoginDialogShown"})(p||(p={}));let d=class extends E.Disposable{constructor(I,v,u,h,o){super();this.logService=I,this.windowsMainService=v,this.nativeHostMainService=u,this.encryptionMainService=h,this.productService=o,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=p.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const I=k.Event.fromNodeEventEmitter(y.app,"login",(v,u,h,o,c)=>({event:v,webContents:u,req:h,authInfo:o,callback:c}));this._register(I(this.onLogin,this))}async onLogin({event:I,authInfo:v,req:u,callback:h}){if(!v.isProxy)return;if(!this.pendingProxyResolve&&this.state===p.LoginDialogShown&&u.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}I.preventDefault();let o;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),o=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(v);try{o=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}h(o?.username,o?.password)}async resolveProxyCredentials(I){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const v=await this.doResolveProxyCredentials(I);if(v)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),v;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(I){this.logService.trace("auth#doResolveProxyCredentials - enter",I);const v=String((0,D.hash)({scheme:I.scheme,host:I.host,port:I.port}));let u,h;try{const a=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,v);if(a){const n=JSON.parse(await this.encryptionMainService.decrypt(a));u=n.username,h=n.password}}catch(a){this.logService.error(a)}if(this.state!==p.StoredCredentialsUsed&&typeof u=="string"&&typeof h=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=p.StoredCredentialsUsed,{username:u,password:h};const o=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!o){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${o.id} to handle proxy login`);const c={authInfo:I,username:this.sessionCredentials?.username??u,password:this.sessionCredentials?.password??h,replyChannel:`vscode:proxyAuthResponse:${(0,r.generateUuid)()}`};o.sendWhenReady("vscode:openProxyAuthenticationDialog",L.CancellationToken.None,c),this.state=p.LoginDialogShown;const i=await new Promise(a=>{const n=async(s,l,m)=>{if(l===c.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${o.id}`),o.win?.webContents.off("ipc-message",n),m){const S={username:m.username,password:m.password};try{if(m.remember){const M=await this.encryptionMainService.encrypt(JSON.stringify(S));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,v,M)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,v)}catch(M){this.logService.error(M)}a({username:S.username,password:S.password})}else a(void 0)};o.win?.webContents.on("ipc-message",n)});return this.sessionCredentials=i,i}};d=ue([te(0,w.ILogService),te(1,b.IWindowsMainService),te(2,t.INativeHostMainService),te(3,f.IEncryptionMainService),te(4,P.IProductService)],d),e.ProxyAuthHandler=d}),define(J[230],Z([0,1,14,26,33,2,10,3,82,143,70,52,23,4,101,6,53,48,21,55,61]),function(K,e,y,L,k,D,E,r,f,w,t,P,b,p,d,g,I,v,u,h,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,p.createDecorator)("issueMainService");let c=class St{constructor(a,n,s,l,m,S,M,A,F){this.userEnv=a,this.environmentMainService=n,this.launchMainService=s,this.logService=l,this.diagnosticsService=m,this.dialogMainService=S,this.nativeHostMainService=M,this.protocolMainService=A,this.productService=F,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){y.ipcMain.on("vscode:issueSystemInfoRequest",async a=>{const[n,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),l=await this.diagnosticsService.getSystemInfo(n,s);this.safeSend(a,"vscode:issueSystemInfoResponse",l)}),y.ipcMain.on("vscode:listProcesses",async a=>{const n=[];try{const s=await this.launchMainService.getMainProcessId();n.push({name:(0,w.localize)(0,null),rootProcess:await(0,f.listProcesses)(s)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(m=>{(0,t.isRemoteDiagnosticError)(m)?n.push({name:m.hostName,rootProcess:m}):m.processes&&n.push({name:m.hostName,rootProcess:m.processes})})}catch(s){this.logService.error(`Listing processes failed: ${s}`)}this.safeSend(a,"vscode:listProcessesResponse",n)}),y.ipcMain.on("vscode:issueReporterClipboard",async a=>{const n={title:this.productService.nameLong,message:(0,w.localize)(1,null),type:"warning",buttons:[(0,k.mnemonicButtonLabel)((0,w.localize)(2,null)),(0,k.mnemonicButtonLabel)((0,w.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const s=await this.dialogMainService.showMessageBox(n,this.issueReporterWindow);this.safeSend(a,"vscode:issueReporterClipboardResponse",s.response===0)}}),y.ipcMain.on("vscode:issuePerformanceInfoRequest",async a=>{const n=await this.getPerformanceInfo();this.safeSend(a,"vscode:issuePerformanceInfoResponse",n)}),y.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const a={title:this.productService.nameLong,message:(0,w.localize)(4,null),type:"warning",buttons:[(0,k.mnemonicButtonLabel)((0,w.localize)(5,null)),(0,k.mnemonicButtonLabel)((0,w.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(a,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),y.ipcMain.on("vscode:workbenchCommand",(a,n)=>{const{id:s,from:l,args:m}=n;let S;switch(l){case"issueReporter":S=this.issueReporterParentWindow;break;case"processExplorer":S=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${l}`)}S&&S.webContents.send("vscode:runAction",{id:s,from:l,args:m})}),y.ipcMain.on("vscode:openExternal",(a,n)=>{this.nativeHostMainService.openExternal(void 0,n)}),y.ipcMain.on("vscode:closeIssueReporter",a=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),y.ipcMain.on("vscode:closeProcessExplorer",a=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),y.ipcMain.on("vscode:windowsInfoRequest",async a=>{const n=await this.launchMainService.getMainProcessInfo();this.safeSend(a,"vscode:windowsInfoResponse",n.windows)})}safeSend(a,n,...s){a.sender.isDestroyed()||a.sender.send(n,...s)}async openReporter(a){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=y.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const n=new D.DisposableStore,s=n.add(this.protocolMainService.createIPCObjectUrl()),l=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(l,s,{backgroundColor:a.styles.backgroundColor,title:(0,w.localize)(7,null),zoomLevel:a.zoomLevel,alwaysOnTop:!1}),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:a,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,L.type)(),arch:(0,L.arch)(),release:(0,L.release)()},product:v.default}),this.issueReporterWindow.loadURL(E.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",K).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,n.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,n.dispose())})}this.issueReporterWindow?.focus()}async openProcessExplorer(a){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=y.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const n=new D.DisposableStore,s=n.add(this.protocolMainService.createIPCObjectUrl()),l=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(l,s,{backgroundColor:a.styles.backgroundColor,title:(0,w.localize)(8,null),zoomLevel:a.zoomLevel,alwaysOnTop:!0}),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:a,product:v.default}),this.processExplorerWindow.loadURL(E.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",K).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,n.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,n.dispose())})}this.processExplorerWindow?.focus()}createBrowserWindow(a,n,s){const l=new y.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:a.width,height:a.height,minWidth:300,minHeight:200,x:a.x,y:a.y,title:s.title,backgroundColor:s.backgroundColor||St.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:E.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",K).fsPath,additionalArguments:[`--vscode-window-config=${n.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,o.zoomLevelToZoomFactor)(s.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:s.alwaysOnTop});return l.setMenuBarVisibility(!1),l}async getSystemStatus(){const[a,n]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(a,n)}getWindowPosition(a,n,s){let l;const m=y.screen.getAllDisplays();if(m.length===1)l=m[0];else{if(r.isMacintosh){const A=y.screen.getCursorScreenPoint();l=y.screen.getDisplayNearestPoint(A)}!l&&a&&(l=y.screen.getDisplayMatching(a.getBounds())),l||(l=y.screen.getPrimaryDisplay()||m[0])}const S={width:n,height:s},M=l.bounds;return S.x=M.x+M.width/2-S.width/2,S.y=M.y+M.height/2-S.height/2,M.width>0&&M.height>0&&(S.x<M.x&&(S.x=M.x),S.y<M.y&&(S.y=M.y),S.x>M.x+M.width&&(S.x=M.x),S.y>M.y+M.height&&(S.y=M.y),S.width>M.width&&(S.width=M.width),S.height>M.height&&(S.height=M.height)),S}async getPerformanceInfo(){try{const[a,n]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(a,n)}catch(a){throw this.logService.warn("issueService#getPerformanceInfo ",a.message),a}}};c.DEFAULT_BACKGROUND_COLOR="#1E1E1E",c=ue([te(1,b.IEnvironmentMainService),te(2,d.ILaunchMainService),te(3,g.ILogService),te(4,t.IDiagnosticsService),te(5,P.IDialogMainService),te(6,I.INativeHostMainService),te(7,h.IProtocolMainService),te(8,u.IProductService)],c),e.IssueMainService=c}),define(J[231],Z([0,1,24,16,23,22,6,53,21,50,34,42,76]),function(K,e,y,L,k,D,E,r,f,w,t,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let p=class extends b.AbstractUpdateService{constructor(g,I,v,u,h,o,c,i){super(g,I,u,h,o,i);this.telemetryService=v,this.nativeHostMainService=c}buildUpdateFeedUrl(g){return(0,b.createUpdateURL)(`linux-${process.arch}`,g,this.productService)}doCheckForUpdates(g){!this.url||(this.setState(P.State.CheckingForUpdates(g)),this.requestService.request({url:this.url},y.CancellationToken.None).then(w.asJson).then(I=>{!I||!I.url||!I.version||!I.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g}),this.setState(P.State.Idle(1))):this.setState(P.State.AvailableForDownload(I))}).then(void 0,I=>{this.logService.error(I),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g});const v=g?I.message||I:void 0;this.setState(P.State.Idle(1,v))}))}async doDownloadUpdate(g){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):g.update.url&&this.nativeHostMainService.openExternal(void 0,g.update.url),this.setState(P.State.Idle(1))}};p=ue([te(0,D.ILifecycleMainService),te(1,L.IConfigurationService),te(2,t.ITelemetryService),te(3,k.IEnvironmentMainService),te(4,w.IRequestService),te(5,E.ILogService),te(6,r.INativeHostMainService),te(7,f.IProductService)],p),e.LinuxUpdateService=p}),define(J[232],Z([0,1,41,30,26,9,24,46,8,7,112,19,16,23,20,22,6,53,21,50,34,42,76]),function(K,e,y,L,k,D,E,r,f,w,t,P,b,p,d,g,I,v,u,h,o,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function a(m,S=1e3){for(;!m();)await(0,D.timeout)(S)}let n;function s(){return typeof n=="undefined"&&(n=L.existsSync(f.join(f.dirname(process.execPath),"unins000.exe"))?0:1),n}let l=class extends i.AbstractUpdateService{constructor(S,M,A,F,C,X,ee,re,Y){super(S,M,F,C,X,Y);this.telemetryService=A,this.fileService=ee,this.nativeHostMainService=re}get cachePath(){const S=f.join((0,k.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return P.Promises.mkdir(S,{recursive:!0}).then(()=>S)}initialize(){super.initialize(),s()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(S){let M="win32";return process.arch!=="ia32"&&(M+=`-${process.arch}`),s()===1?M+="-archive":this.productService.target==="user"&&(M+="-user"),(0,i.createUpdateURL)(M,S,this.productService)}doCheckForUpdates(S){!this.url||(this.setState(c.State.CheckingForUpdates(S)),this.requestService.request({url:this.url},E.CancellationToken.None).then(h.asJson).then(M=>{const A=s();return!M||!M.url||!M.version||!M.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!S}),this.setState(c.State.Idle(A)),Promise.resolve(null)):A===1?(this.setState(c.State.AvailableForDownload(M)),Promise.resolve(null)):(this.setState(c.State.Downloading(M)),this.cleanup(M.version).then(()=>this.getUpdatePackagePath(M.version).then(F=>P.Promises.exists(F).then(C=>{if(C)return Promise.resolve(F);const X=M.url,ee=M.hash,re=`${F}.tmp`;return this.requestService.request({url:X},E.CancellationToken.None).then(Y=>this.fileService.writeFile(w.URI.file(re),Y.stream)).then(ee?()=>(0,t.checksum)(re,M.hash):()=>{}).then(()=>P.Promises.rename(re,F)).then(()=>F)})).then(F=>{const C=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:F},C&&M.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(M)):this.setState(c.State.Ready(M))})))}).then(void 0,M=>{this.logService.error(M),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!S});const A=S?M.message||M:void 0;this.setState(c.State.Idle(s(),A))}))}async doDownloadUpdate(S){S.update.url&&this.nativeHostMainService.openExternal(void 0,S.update.url),this.setState(c.State.Idle(s()))}async getUpdatePackagePath(S){const M=await this.cachePath;return f.join(M,`CodeSetup-${this.productService.quality}-${S}.exe`)}async cleanup(S=null){const M=S?X=>!new RegExp(`${this.productService.quality}-${S}\\.exe$`).test(X):()=>!0,A=await this.cachePath,C=(await P.Promises.readdir(A)).filter(M).map(async X=>{try{await P.Promises.unlink(f.join(A,X))}catch(ee){}});await Promise.all(C)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const S=this.state.update;this.setState(c.State.Updating(S));const M=await this.cachePath;this.availableUpdate.updateFilePath=f.join(M,`CodeSetup-${this.productService.quality}-${S.version}.flag`),await P.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,y.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(c.State.Idle(s()))});const F=`${this.productService.win32MutexName}-ready`,C=await new Promise((X,ee)=>{K(["windows-mutex"],X,ee)});a(()=>C.isActive(F)).then(()=>this.setState(c.State.Ready(S)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?L.unlinkSync(this.availableUpdate.updateFilePath):(0,y.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return s()}};ue([r.memoize],l.prototype,"cachePath",null),l=ue([te(0,g.ILifecycleMainService),te(1,b.IConfigurationService),te(2,o.ITelemetryService),te(3,p.IEnvironmentMainService),te(4,h.IRequestService),te(5,I.ILogService),te(6,d.IFileService),te(7,v.INativeHostMainService),te(8,u.IProductService)],l),e.Win32UpdateService=l}),define(J[233],Z([0,1,14,9,24,5,33,2,10,8,72,3,7,149,51,16,52,23,54,201,20,22,6,21,55,98,34,203,60,61,36,27,45]),function(K,e,y,L,k,D,E,r,f,w,t,P,b,p,d,g,I,v,u,h,o,c,i,a,n,s,l,m,S,M,A,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var X;(function(re){re[re.NONE=0]="NONE",re[re.LOADING=1]="LOADING",re[re.NAVIGATING=2]="NAVIGATING",re[re.READY=3]="READY"})(X||(X={}));let ee=class extends r.Disposable{constructor(Y,Q,W,V,z,$,j,U,q,T,R,O,_,N){super();this.logService=Q,this.environmentMainService=W,this.fileService=V,this.configurationService=$,this.themeMainService=j,this.workspacesManagementMainService=U,this.backupMainService=q,this.telemetryService=T,this.dialogMainService=R,this.lifecycleMainService=O,this.productService=_,this.protocolMainService=N,this._onWillLoad=this._register(new D.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new D.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new D.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new D.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[B,H]=this.restoreWindowState(Y.state);this.windowState=B,this.logService.trace("window#ctor: using window state",B);const x=this.windowState.mode===0||this.windowState.mode===3,ie=this.configurationService.getValue("window"),ae={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:M.WindowMinimumSize.WIDTH,minHeight:M.WindowMinimumSize.HEIGHT,show:!x,title:this.productService.nameLong,webPreferences:{preload:f.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",K).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,M.zoomLevelToZoomFactor)(ie?.zoomLevel),...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}}};P.isLinux?ae.icon=(0,w.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):P.isWindows&&!this.environmentMainService.isBuilt&&(ae.icon=(0,w.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),P.isMacintosh&&!this.useNativeFullScreen()&&(ae.fullscreenable=!1),P.isMacintosh&&(ae.acceptFirstMouse=!0,ie?.clickThroughInactive===!1&&(ae.acceptFirstMouse=!1));const oe=P.isMacintosh&&ie?.nativeTabs===!0;oe&&(ae.tabbingIdentifier=this.productService.nameShort);const se=(0,M.getTitleBarStyle)(this.configurationService)==="custom";if(se&&(ae.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,P.isMacintosh||(ae.frame=!1)),(0,t.mark)("code/willCreateCodeBrowserWindow"),this._win=new y.BrowserWindow(ae),(0,t.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),P.isMacintosh&&se&&this._win.setSheetOffset(22),P.isMacintosh&&H&&(!oe||y.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(le=>typeof le=="number")){const le=this.windowState;this._win.setBounds({width:le.width,height:le.height,x:le.x,y:le.y})}x&&((0,t.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,t.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=(0,h.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,{get:B=>z.globalStorage.get(B),store:(B,H)=>z.globalStorage.set(B,H)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?.backupPath}get openedWorkspace(){return this.currentConfig?.workspace}get remoteAuthority(){return this.currentConfig?.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this.currentConfig?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.currentConfig?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.currentConfig?.debugId}setRepresentedFilename(Y){P.isMacintosh?this._win.setRepresentedFilename(Y):this.representedFilename=Y}getRepresentedFilename(){return P.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(Y){P.isMacintosh&&this._win.setDocumentEdited(Y),this.documentEdited=Y}isDocumentEdited(){return P.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(Y){P.isMacintosh&&Y?.force&&y.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(Y=>{if(this.isReady)return Y(this);this.whenReadyCallbacks.push(Y)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(Y=>{function Q(){W.dispose(),V.dispose(),Y()}const W=this.onDidClose(()=>Q()),V=this.onWillLoad(()=>Q())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(z,$)=>this.onWindowError(2,$)),this._win.webContents.on("did-fail-load",(z,$,j)=>this.onWindowError(3,{reason:j,exitCode:$})),this._win.webContents.on("will-prevent-unload",z=>{z.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const Y=new Set([f.Schemas.file,f.Schemas.vscodeFileResource,f.Schemas.vscodeRemoteResource,"devtools"]),Q=z=>{for(let $=z;$;$=$.parent)if($.url.startsWith(`${f.Schemas.vscodeWebview}://`))return!0;return!1},W=z=>z.resourceType==="xhr"||Q(z.frame);this._win.webContents.session.webRequest.onBeforeRequest((z,$)=>{const j=b.URI.parse(z.url);return j.path.endsWith(".svg")&&!(Y.has(j.scheme)||j.path.includes(f.Schemas.vscodeRemoteResource))?$({cancel:!W(z)}):$({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((z,$)=>{const j=z.responseHeaders,U=j["content-type"]||j["Content-Type"];if(U&&Array.isArray(U)){const q=b.URI.parse(z.url);if(q.path.endsWith(".svg")&&Y.has(q.scheme))return j["Content-Type"]=["image/svg+xml"],$({cancel:!1,responseHeaders:j});if(!q.path.includes(f.Schemas.vscodeRemoteResource)&&U.some(T=>T.toLowerCase().includes("image/svg")))return $({cancel:!W(z)})}return $({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",z=>{this.currentConfig&&(this.currentConfig.maximized=!0),y.app.emit("browser-window-maximize",z,this._win)}),this._win.on("unmaximize",z=>{this.currentConfig&&(this.currentConfig.maximized=!1),y.app.emit("browser-window-unmaximize",z,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",k.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",k.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(z=>this.onDidDeleteUntitledWorkspace(z)));const V=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:V},async(z,$)=>{const j=await this.marketplaceHeadersPromise;$({cancel:!1,requestHeaders:Object.assign(z.requestHeaders,j)})})}async onWindowError(Y,Q){switch(Y){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${Q?.reason||"<unknown>"}, code: ${Q?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${Q?.reason||"<unknown>"}, code: ${Q?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:Y,reason:Q?.reason,code:Q?.exitCode}),Y){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(Y===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const W=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,E.mnemonicButtonLabel)((0,p.localize)(0,null)),(0,E.mnemonicButtonLabel)((0,p.localize)(1,null)),(0,E.mnemonicButtonLabel)((0,p.localize)(2,null))],message:(0,p.localize)(3,null),detail:(0,p.localize)(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(!this._win)return;W.response===0?(this._win.webContents.forcefullyCrashRenderer(),this.reload()):W.response===2&&this.destroyWindow()}else if(Y===2){let W;Q?W=(0,p.localize)(6,null,Q.reason,Q.exitCode??"<unknown>"):W=(0,p.localize)(5,null);const V=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,E.mnemonicButtonLabel)((0,p.localize)(7,null)),(0,E.mnemonicButtonLabel)((0,p.localize)(8,null))],message:W,detail:(0,p.localize)(9,null),noLink:!0,defaultId:0},this._win);if(!this._win)return;V.response===0?this.reload():V.response===1&&this.destroyWindow()}break}}destroyWindow(){this._onDidDestroy.fire(),this._win.destroy()}onDidDeleteUntitledWorkspace(Y){this.openedWorkspace?.id===Y.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const Y=this.getMenuBarVisibility();Y!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=Y,this.setMenuBarVisibility(Y));let Q=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;Q?.endsWith("/")&&(Q=Q.substr(0,Q.length-1));const W=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((Q||"").indexOf("@")===-1&&(Q!==this.currentHttpProxy||W!==this.currentNoProxy)){this.currentHttpProxy=Q,this.currentNoProxy=W;const V=Q||"",z=W?`${W},<local>`:"<local>";this.logService.trace(`Setting proxy to '${V}', bypassing '${z}'`),this._win.webContents.session.setProxy({proxyRules:V,proxyBypassRules:z,pacScript:""})}}addTabbedWindow(Y){P.isMacintosh&&Y.win&&this._win.addTabbedWindow(Y.win)}load(Y,Q=Object.create(null)){this.isDocumentEdited()&&(!Q.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),Q.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(Y,Q),this.readyState===0?this.currentConfig=Y:(this.pendingLoadConfig=Y,this.readyState=2),this._win.loadURL(f.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",K).toString(!0));const W=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new L.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:Y.workspace,reason:Q.isReload?3:W?2:1})}updateConfiguration(Y,Q){const W=(this.currentConfig??this.pendingLoadConfig)?.userEnv;if(W){const V=(0,u.isLaunchedFromCli)(W)&&!(0,u.isLaunchedFromCli)(Y.userEnv),z=this.isExtensionDevelopmentHost;(V||z)&&(Y.userEnv={...W,...Y.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(Y.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),Q.disableExtensions!==void 0&&(Y["disable-extensions"]=Q.disableExtensions),Y.fullscreen=this.isFullScreen,Y.maximized=this._win.isMaximized(),Y.partsSplash=this.themeMainService.getWindowSplash(),(0,t.mark)("code/willOpenNewWindow"),Y.perfMarks=(0,t.getMarks)(),this.configObjectUrl.update(Y)}async reload(Y){const Q=Object.assign({},this.currentConfig);Q.workspace=await this.validateWorkspaceBeforeReload(Q),delete Q.filesToOpenOrCreate,delete Q.filesToDiff,delete Q.filesToWait,this.isExtensionDevelopmentHost&&Y&&(Q.verbose=Y.verbose,Q.debugId=Y.debugId,Q["inspect-extensions"]=Y["inspect-extensions"],Q["inspect-brk-extensions"]=Y["inspect-brk-extensions"],Q["extensions-dir"]=Y["extensions-dir"]),Q.isInitialStartup=!1,this.load(Q,{isReload:!0,disableExtensions:Y?.["disable-extensions"]})}async validateWorkspaceBeforeReload(Y){if((0,F.isWorkspaceIdentifier)(Y.workspace)){const Q=Y.workspace.configPath;if(Q.scheme===f.Schemas.file&&!await this.fileService.exists(Q))return}else if((0,F.isSingleFolderWorkspaceIdentifier)(Y.workspace)){const Q=Y.workspace.uri;if(Q.scheme===f.Schemas.file&&!await this.fileService.exists(Q))return}return Y.workspace}serializeWindowState(){if(!this._win)return(0,A.defaultWindowState)();if(this.isFullScreen){let W;try{W=y.screen.getDisplayMatching(this.getBounds())}catch($){}const V=(0,A.defaultWindowState)();return{mode:3,display:W?W.id:void 0,width:this.windowState.width||V.width,height:this.windowState.height||V.height,x:this.windowState.x||0,y:this.windowState.y||0}}const Y=Object.create(null);let Q;if(!P.isMacintosh&&this._win.isMaximized()?Q=0:Q=1,Q===0?Y.mode=0:Y.mode=1,Q===1||Q===0){let W;Q===1?W=this.getBounds():W=this._win.getNormalBounds(),Y.x=W.x,Y.y=W.y,Y.width=W.width,Y.height=W.height}return Y}restoreWindowState(Y){(0,t.mark)("code/willRestoreCodeWindowState");let Q=!1;if(Y)try{const W=y.screen.getAllDisplays();Q=W.length>1,Y=this.validateWindowState(Y,W)}catch(W){this.logService.warn(`Unexpected error validating window state: ${W}
${W.stack}`)}return(0,t.mark)("code/didRestoreCodeWindowState"),[Y||(0,A.defaultWindowState)(),Q]}validateWindowState(Y,Q){if(this.logService.trace(`window#validateWindowState: validating window state on ${Q.length} display(s)`,Y),typeof Y.x!="number"||typeof Y.y!="number"||typeof Y.width!="number"||typeof Y.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(Y.width<=0||Y.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(Q.length===1){const z=this.getWorkingArea(Q[0]);if(z){let $=function(){!Y||typeof Y.x!="number"||typeof Y.y!="number"||!z||(Y.x<z.x&&(Y.x=z.x),Y.y<z.y&&(Y.y=z.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",z),$(),Y.width>z.width&&(Y.width=z.width),Y.height>z.height&&(Y.height=z.height),Y.x>z.x+z.width-128&&(Y.x=z.x+z.width-Y.width),Y.y>z.y+z.height-128&&(Y.y=z.y+z.height-Y.height),$()}return Y}if(Y.display&&Y.mode===3){const z=Q.find($=>$.id===Y.display);if(z&&typeof z.bounds?.x=="number"&&typeof z.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const $=(0,A.defaultWindowState)(3);return $.x=z.bounds.x,$.y=z.bounds.y,$}}let W,V;try{W=y.screen.getDisplayMatching({x:Y.x,y:Y.y,width:Y.width,height:Y.height}),V=this.getWorkingArea(W)}catch(z){}if(W&&V&&Y.x+Y.width>V.x&&Y.y+Y.height>V.y&&Y.x<V.x+V.width&&Y.y<V.y+V.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",V),Y}getWorkingArea(Y){if(Y.workArea.width>0&&Y.workArea.height>0)return Y.workArea;if(Y.bounds.width>0&&Y.bounds.height>0)return Y.bounds}getBounds(){const[Y,Q]=this._win.getPosition(),[W,V]=this._win.getSize();return{x:Y,y:Q,width:W,height:V}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(Y){this.useNativeFullScreen()?this.setNativeFullScreen(Y):this.setSimpleFullScreen(Y),this.sendWhenReady(Y?"vscode:enterFullScreen":"vscode:leaveFullScreen",k.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(Y){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(Y)}setSimpleFullScreen(Y){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(Y),this._win.webContents.focus()}useNativeFullScreen(){const Y=this.configurationService.getValue("window");return!Y||typeof Y.nativeFullScreen!="boolean"||Y.nativeTabs?!0:Y.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let Y=(0,M.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(Y)<0&&(Y="classic"),Y}setMenuBarVisibility(Y,Q=!0){P.isMacintosh||(Y==="toggle"&&Q&&this.send("vscode:showInfoMessage",(0,p.localize)(10,null)),Y==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(Y)}):this.doSetMenuBarVisibility(Y))}doSetMenuBarVisibility(Y){const Q=this.isFullScreen;switch(Y){case"classic":this._win.setMenuBarVisibility(!Q),this._win.autoHideMenuBar=Q;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(P.isMacintosh)switch(y.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(Y,Q,...W){this.isReady?this.send(Y,...W):this.ready().then(()=>{Q.isCancellationRequested||this.send(Y,...W)})}send(Y,...Q){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel ${Y} for window that is destroyed`);return}this._win.webContents.send(Y,...Q)}}updateTouchBar(Y){!P.isMacintosh||this.touchBarGroups.forEach((Q,W)=>{const V=Y[W];Q.segments=this.createTouchBarGroupSegments(V)})}createTouchBar(){if(!!P.isMacintosh){for(let Y=0;Y<10;Y++){const Q=this.createTouchBarGroup();this.touchBarGroups.push(Q)}this._win.setTouchBar(new y.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(Y=[]){const Q=this.createTouchBarGroupSegments(Y),W=new y.TouchBar.TouchBarSegmentedControl({segments:Q,mode:"buttons",segmentStyle:"automatic",change:V=>{this.sendWhenReady("vscode:runAction",k.CancellationToken.None,{id:W.segments[V].id,from:"touchbar"})}});return W}createTouchBarGroupSegments(Y=[]){return Y.map(W=>{let V;W.icon&&!m.ThemeIcon.isThemeIcon(W.icon)&&W.icon?.dark?.scheme===f.Schemas.file&&(V=y.nativeImage.createFromPath(b.URI.revive(W.icon.dark).fsPath),V.isEmpty()&&(V=void 0));let z;return typeof W.title=="string"?z=W.title:z=W.title.value,{id:W.id,label:V?void 0:z,icon:V}})}dispose(){super.dispose(),this._win=null}};ee=ue([te(1,i.ILogService),te(2,v.IEnvironmentMainService),te(3,o.IFileService),te(4,s.IStorageMainService),te(5,g.IConfigurationService),te(6,S.IThemeMainService),te(7,C.IWorkspacesManagementMainService),te(8,d.IBackupMainService),te(9,l.ITelemetryService),te(10,I.IDialogMainService),te(11,c.ILifecycleMainService),te(12,a.IProductService),te(13,n.IProtocolMainService)],ee),e.CodeWindow=ee}),define(J[62],Z([0,1,14,31,9,5,33,2,10,3,15,7,19,152,4,22,6,39,27,45]),function(K,e,y,L,k,D,E,r,f,w,t,P,b,p,d,g,I,v,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,d.createDecorator)("workspacesHistoryMainService");let o=class je extends r.Disposable{constructor(m,S,M,A){super();this.stateMainService=m,this.logService=S,this.workspacesManagementMainService=M,this.lifecycleMainService=A,this._onDidChangeRecentlyOpened=this._register(new D.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new k.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(m=>this.addRecentlyOpened([{workspace:m.workspace}])))}handleWindowsJumpList(){!w.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(m){const S=[],M=[];for(let A of m)if((0,u.isRecentWorkspace)(A))!this.workspacesManagementMainService.isUntitledWorkspace(A.workspace)&&a(S,A.workspace)===-1&&S.push(A);else if((0,u.isRecentFolder)(A))n(S,A.folderUri)===-1&&S.push(A);else{const F=s(M,A.fileUri)>=0,C=A.fileUri.scheme===f.Schemas.file&&je.COMMON_FILES_FILTER.indexOf((0,t.basename)(A.fileUri))>=0;!F&&!C&&(M.push(A),w.isWindows&&A.fileUri.scheme===f.Schemas.file&&y.app.addRecentDocument(A.fileUri.fsPath))}this.addEntriesFromStorage(S,M),S.length>je.MAX_TOTAL_RECENT_ENTRIES&&(S.length=je.MAX_TOTAL_RECENT_ENTRIES),M.length>je.MAX_TOTAL_RECENT_ENTRIES&&(M.length=je.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:S,files:M}),this._onDidChangeRecentlyOpened.fire(),w.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(m){const S=C=>{const X=i(C);for(const ee of m)if(t.extUriBiasedIgnorePathCase.isEqual(ee,X))return!1;return!0},M=this.getRecentlyOpened(),A=M.workspaces.filter(S),F=M.files.filter(S);(A.length!==M.workspaces.length||F.length!==M.files.length)&&(this.saveRecentlyOpened({files:F,workspaces:A}),this._onDidChangeRecentlyOpened.fire(),w.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!w.isMacintosh)return;y.app.clearRecentDocuments();const m=this.getRecentlyOpened(),S=[];let M=0;for(let F=0;F<m.workspaces.length&&M<je.MAX_MACOS_DOCK_RECENT_WORKSPACES;F++){const C=i(m.workspaces[F]);if(C.scheme===f.Schemas.file){const X=(0,t.originalFSPath)(C);await b.Promises.exists(X)&&(S.push(X),M++)}}const A=[];for(let F=0;F<m.files.length&&M<je.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;F++){const C=i(m.files[F]);if(C.scheme===f.Schemas.file){const X=(0,t.originalFSPath)(C);if(je.COMMON_FILES_FILTER.includes((0,t.basename)(C))||S.includes(X))continue;await b.Promises.exists(X)&&(A.push(X),M++)}}A.reverse().forEach(F=>y.app.addRecentDocument(F)),S.reverse().forEach(F=>y.app.addRecentDocument(F))}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),y.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(m){const S=[],M=[],A=m?.config?.workspace;(0,u.isWorkspaceIdentifier)(A)&&!this.workspacesManagementMainService.isUntitledWorkspace(A)?S.push({workspace:A}):(0,u.isSingleFolderWorkspaceIdentifier)(A)&&S.push({folderUri:A.uri});const F=m?.config?.filesToOpenOrCreate;if(F)for(let C of F){const X=C.fileUri;X&&s(M,X)===-1&&M.push({fileUri:X})}return this.addEntriesFromStorage(S,M),{workspaces:S,files:M}}addEntriesFromStorage(m,S){let M=this.getRecentlyOpenedFromStorage();for(let A of M.workspaces){let F=(0,u.isRecentFolder)(A)?n(m,A.folderUri):a(m,A.workspace);F>=0?m[F].label=m[F].label||A.label:m.push(A)}for(let A of M.files){let F=s(S,A.fileUri);F>=0?S[F].label=S[F].label||A.label:S.push(A)}}getRecentlyOpenedFromStorage(){const m=this.stateMainService.getItem(je.recentlyOpenedStorageKey);return(0,u.restoreRecentlyOpened)(m,this.logService)}saveRecentlyOpened(m){const S=(0,u.toStoreData)(m);this.stateMainService.setItem(je.recentlyOpenedStorageKey,S)}updateWindowsJumpList(){if(!w.isWindows)return;const m=[];if(m.push({type:"tasks",items:[{type:"task",title:(0,p.localize)(0,null),description:(0,p.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let S=[];for(let F of y.app.getJumpListSettings().removedItems){const C=F.args;if(C){const X=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(C);X&&S.push(P.URI.parse(X[2]))}}this.removeRecentlyOpened(S);let M=!1;const A=(0,L.coalesce)(this.getRecentlyOpened().workspaces.slice(0,7).map(F=>{const C=(0,u.isRecentWorkspace)(F)?F.workspace:F.folderUri,{title:X,description:ee}=this.getWindowsJumpListLabel(C,F.label);let re;return P.URI.isUri(C)?re=`--folder-uri "${C.toString()}"`:(M=!0,re=`--file-uri "${C.configPath.toString()}"`),{type:"task",title:X.substr(0,255),description:ee.substr(0,255),program:process.execPath,args:re,iconPath:"explorer.exe",iconIndex:0}}));A.length>0&&m.push({type:"custom",name:M?(0,p.localize)(2,null):(0,p.localize)(3,null),items:A})}m.push({type:"recent"});try{y.app.setJumpList(m)}catch(S){this.logService.warn("updateWindowsJumpList#setJumpList",S)}}getWindowsJumpListLabel(m,S){if(S)return{title:(0,E.splitName)(S).name,description:S};if(P.URI.isUri(m))return{title:(0,t.basename)(m),description:c(m)};if(this.workspacesManagementMainService.isUntitledWorkspace(m))return{title:(0,p.localize)(4,null),description:""};let M=(0,t.basename)(m.configPath);return M.endsWith(u.WORKSPACE_EXTENSION)&&(M=M.substr(0,M.length-u.WORKSPACE_EXTENSION.length-1)),{title:(0,p.localize)(5,null,M),description:c(m.configPath)}}};o.MAX_TOTAL_RECENT_ENTRIES=100,o.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,o.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,o.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],o.recentlyOpenedStorageKey="openedPathsList",o=ue([te(0,v.IStateMainService),te(1,I.ILogService),te(2,h.IWorkspacesManagementMainService),te(3,g.ILifecycleMainService)],o),e.WorkspacesHistoryMainService=o;function c(l){return l.scheme==="file"?(0,E.normalizeDriveLetter)(l.fsPath):l.toString()}function i(l){return(0,u.isRecentFolder)(l)?l.folderUri:(0,u.isRecentFile)(l)?l.fileUri:l.workspace.configPath}function a(l,m){return l.findIndex(S=>(0,u.isRecentWorkspace)(S)&&S.workspace.id===m.id)}function n(l,m){return l.findIndex(S=>(0,u.isRecentFolder)(S)&&t.extUriBiasedIgnorePathCase.isEqual(S.folderUri,m))}function s(l,m){return l.findIndex(S=>t.extUriBiasedIgnorePathCase.isEqual(S.fileUri,m))}}),define(J[234],Z([0,1,14,9,24,33,3,7,144,16,23,22,6,182,53,21,39,34,42,61,36,62]),function(K,e,y,L,k,D,E,r,f,w,t,P,b,p,d,g,I,v,u,h,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const i="menu";let a=class wt{constructor(l,m,S,M,A,F,C,X,ee,re,Y){this.updateService=l,this.configurationService=m,this.windowsMainService=S,this.environmentMainService=M,this.telemetryService=A,this.workspacesHistoryMainService=F,this.stateMainService=C,this.lifecycleMainService=X,this.logService=ee,this.nativeHostMainService=re,this.productService=Y,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new L.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new L.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(E.isMacintosh||(0,h.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const l=this.stateMainService.getItem(wt.lastKnownMenubarStorageKey);l&&(l.menus&&(this.menubarMenus=l.menus),l.keybindings&&(this.keybindings=l.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(F,C,X)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:C?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(F,C,X)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:C?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(F,C,X)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(X),telemetryExtraData:{from:i}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(F,C,X)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(X),telemetryExtraData:{from:i}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const l=this.productService.twitterUrl;l&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(l,"openTwitterUrl"));const m=this.productService.requestFeatureUrl;m&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(m,"openUserVoiceUrl"));const S=this.productService.reportIssueUrl;S&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(S,"openReportIssues"));const M=this.productService.licenseUrl;M&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(E.language){const F=M.indexOf("?")>0?"&":"?";this.openUrl(`${M}${F}lang=${E.language}`,"openLicenseUrl")}else this.openUrl(M,"openLicenseUrl")});const A=this.productService.privacyStatementUrl;A&&M&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(A,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(l=>this.onDidChangeWindowsCount(l)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let l=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof l!="boolean"?!0:l}get currentEnableNativeTabs(){if(!E.isMacintosh)return!1;let l=this.configurationService.getValue("window.nativeTabs");return typeof l!="boolean"?!1:l}updateMenu(l,m){this.menubarMenus=l.menus,this.keybindings=l.keybindings,this.stateMainService.setItem(wt.lastKnownMenubarStorageKey,l),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(l){!E.isMacintosh||(l.oldCount===0&&l.newCount>0||l.oldCount>0&&l.newCount===0)&&(this.closedLastWindow=l.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!E.isMacintosh||(this.noActiveWindow=!y.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const l=y.Menu.getApplicationMenu();if(l&&this.oldMenus.push(l),Object.keys(this.menubarMenus).length===0){y.Menu.setApplicationMenu(E.isMacintosh?new y.Menu:null);return}const m=new y.Menu;let S;if(E.isMacintosh){const A=new y.Menu;S=new y.MenuItem({label:this.productService.nameShort,submenu:A}),this.setMacApplicationMenu(A),m.append(S)}if(E.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const A=new y.Menu;A.append(new y.MenuItem({label:this.mnemonicLabel(f.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),y.app.dock.setMenu(A)}if(this.shouldDrawMenu("File")){const A=new y.Menu,F=new y.MenuItem({label:this.mnemonicLabel(f.localize(1,null)),submenu:A});this.setMenuById(A,"File"),m.append(F)}if(this.shouldDrawMenu("Edit")){const A=new y.Menu,F=new y.MenuItem({label:this.mnemonicLabel(f.localize(2,null)),submenu:A});this.setMenuById(A,"Edit"),m.append(F)}if(this.shouldDrawMenu("Selection")){const A=new y.Menu,F=new y.MenuItem({label:this.mnemonicLabel(f.localize(3,null)),submenu:A});this.setMenuById(A,"Selection"),m.append(F)}if(this.shouldDrawMenu("View")){const A=new y.Menu,F=new y.MenuItem({label:this.mnemonicLabel(f.localize(4,null)),submenu:A});this.setMenuById(A,"View"),m.append(F)}if(this.shouldDrawMenu("Go")){const A=new y.Menu,F=new y.MenuItem({label:this.mnemonicLabel(f.localize(5,null)),submenu:A});this.setMenuById(A,"Go"),m.append(F)}if(this.shouldDrawMenu("Run")){const A=new y.Menu,F=new y.MenuItem({label:this.mnemonicLabel(f.localize(6,null)),submenu:A});this.setMenuById(A,"Run"),m.append(F)}if(this.shouldDrawMenu("Terminal")){const A=new y.Menu,F=new y.MenuItem({label:this.mnemonicLabel(f.localize(7,null)),submenu:A});this.setMenuById(A,"Terminal"),m.append(F)}let M;if(this.shouldDrawMenu("Window")){const A=new y.Menu;M=new y.MenuItem({label:this.mnemonicLabel(f.localize(8,null)),submenu:A,role:"window"}),this.setMacWindowMenu(A)}if(M&&m.append(M),this.shouldDrawMenu("Help")){const A=new y.Menu,F=new y.MenuItem({label:this.mnemonicLabel(f.localize(9,null)),submenu:A,role:"help"});this.setMenuById(A,"Help"),m.append(F)}m.items&&m.items.length>0?y.Menu.setApplicationMenu(m):y.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(l){const m=this.createMenuItem(f.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),S=this.getUpdateMenuItems();let M;if(this.shouldDrawMenu("Preferences")){const Q=new y.Menu;this.setMenuById(Q,"Preferences"),M=new y.MenuItem({label:this.mnemonicLabel(f.localize(11,null)),submenu:Q})}const A=new y.Menu,F=new y.MenuItem({label:f.localize(12,null),role:"services",submenu:A}),C=new y.MenuItem({label:f.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),X=new y.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),ee=new y.MenuItem({label:f.localize(15,null),role:"unhide"}),re=new y.MenuItem(this.likeAction("workbench.action.quit",{label:f.localize(16,null,this.productService.nameLong),click:()=>{const Q=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!y.BrowserWindow.getFocusedWindow()||Q?.isMinimized())&&this.nativeHostMainService.quit(void 0)}})),Y=[m];Y.push(...S),M&&Y.push(n(),M),Y.push(n(),F,n(),C,X,ee,n(),re),Y.forEach(Q=>l.append(Q))}shouldDrawMenu(l){if(!E.isMacintosh&&(0,h.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(l){case"File":case"Help":if(E.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[l];case"Window":if(E.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[l]}}setMenu(l,m){m.forEach(S=>{if((0,p.isMenubarMenuItemSeparator)(S))l.append(n());else if((0,p.isMenubarMenuItemSubmenu)(S)){const M=new y.Menu,A=new y.MenuItem({label:this.mnemonicLabel(S.label),submenu:M});this.setMenu(M,S.submenu.items),l.append(A)}else(0,p.isMenubarMenuItemRecentAction)(S)?l.append(this.createOpenRecentMenuItem(S)):(0,p.isMenubarMenuItemAction)(S)&&(S.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(l),E.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[S.id]?l.append(new y.MenuItem(this.likeAction(S.id,{label:this.mnemonicLabel(S.label),click:this.fallbackMenuHandlers[S.id]}))):l.append(this.createMenuItem(S.label,S.id,!1,S.checked)):l.append(this.createMenuItem(S.label,S.id,S.enabled!==!1,!!S.checked)):l.append(this.createMenuItem(S.label,S.id,S.enabled!==!1,!!S.checked)))})}setMenuById(l,m){this.menubarMenus&&this.menubarMenus[m]&&this.setMenu(l,this.menubarMenus[m].items)}insertCheckForUpdatesItems(l){const m=this.getUpdateMenuItems();m.length&&(m.forEach(S=>l.append(S)),l.append(n()))}createOpenRecentMenuItem(l){const m=r.URI.revive(l.uri),S=l.id,M=S==="openRecentFile"?{fileUri:m}:S==="openRecentWorkspace"?{workspaceUri:m}:{folderUri:m};return new y.MenuItem(this.likeAction(S,{label:l.label,click:(A,F,C)=>{const X=this.isOptionClick(C);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[M],forceNewWindow:X,gotoLineMode:!1,remoteAuthority:l.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([m])}},!1))}isOptionClick(l){return!!(l&&(!E.isMacintosh&&(l.ctrlKey||l.shiftKey)||E.isMacintosh&&(l.metaKey||l.altKey)))}createRoleMenuItem(l,m,S){const M={label:this.mnemonicLabel(l),role:S,enabled:!0};return new y.MenuItem(this.withKeybinding(m,M))}setMacWindowMenu(l){const m=new y.MenuItem({label:f.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),S=new y.MenuItem({label:f.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),M=new y.MenuItem({label:f.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),A=this.createMenuItem(f.localize(20,null),"workbench.action.switchWindow"),F=[];this.currentEnableNativeTabs&&(F.push(n()),F.push(this.createMenuItem(f.localize(21,null),"workbench.action.newWindowTab")),F.push(this.createRoleMenuItem(f.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),F.push(this.createRoleMenuItem(f.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),F.push(this.createRoleMenuItem(f.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),F.push(this.createRoleMenuItem(f.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[m,S,n(),A,...F,n(),M].forEach(C=>l.append(C))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new y.MenuItem({label:this.mnemonicLabel(f.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new y.MenuItem({label:f.localize(27,null),enabled:!1})];case"available for download":return[new y.MenuItem({label:this.mnemonicLabel(f.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new y.MenuItem({label:f.localize(29,null),enabled:!1})];case"downloaded":return[new y.MenuItem({label:this.mnemonicLabel(f.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new y.MenuItem({label:f.localize(31,null),enabled:!1})];case"ready":return[new y.MenuItem({label:this.mnemonicLabel(f.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(l,m,S,M){const A=this.mnemonicLabel(l),F=typeof m=="function"?m:(Y,Q,W)=>{const V=Y?Y.userSettingsLabel:null;let z=m;Array.isArray(m)&&(z=this.isOptionClick(W)?m[1]:m[0]),V&&W.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:V}):this.runActionInRenderer({type:"commandId",commandId:z})},C=typeof S=="boolean"?S:this.windowsMainService.getWindowCount()>0,X=typeof M=="boolean"?M:!1,ee={label:A,click:F,enabled:C};X&&(ee.type="checkbox",ee.checked=X);let re;return typeof m=="string"?re=m:Array.isArray(m)&&(re=m[0]),E.isMacintosh&&(re==="editor.action.clipboardCutAction"?ee.role="cut":re==="editor.action.clipboardCopyAction"?ee.role="copy":re==="editor.action.clipboardPasteAction"&&(ee.role="paste"),re==="undo"?ee.click=this.makeContextAwareClickHandler(F,{inDevTools:Y=>Y.undo(),inNoWindow:()=>y.Menu.sendActionToFirstResponder("undo:")}):re==="redo"?ee.click=this.makeContextAwareClickHandler(F,{inDevTools:Y=>Y.redo(),inNoWindow:()=>y.Menu.sendActionToFirstResponder("redo:")}):re==="editor.action.selectAll"&&(ee.click=this.makeContextAwareClickHandler(F,{inDevTools:Y=>Y.selectAll(),inNoWindow:()=>y.Menu.sendActionToFirstResponder("selectAll:")}))),new y.MenuItem(this.withKeybinding(re,ee))}makeContextAwareClickHandler(l,m){return(S,M,A)=>{const F=y.BrowserWindow.getFocusedWindow();if(!F)return m.inNoWindow();if(F.webContents.isDevToolsFocused()&&F.webContents.devToolsWebContents)return m.inDevTools(F.webContents.devToolsWebContents);l(S,M||F,A)}}runActionInRenderer(l){let m=y.BrowserWindow.getFocusedWindow();if(!m){const M=this.windowsMainService.getLastActiveWindow();M?.isMinimized()&&(m=M.win)}const S=m?this.windowsMainService.getWindowById(m.id):void 0;if(S){if(this.logService.trace("menubar#runActionInRenderer",l),E.isMacintosh&&!this.environmentMainService.isBuilt&&!S.isReady&&(l.type==="commandId"&&l.commandId==="workbench.action.toggleDevTools"||l.type!=="commandId"&&l.userSettingsLabel==="alt+cmd+i"))return;if(l.type==="commandId"){const M={id:l.commandId,from:"menu"};S.sendWhenReady("vscode:runAction",k.CancellationToken.None,M)}else{const M={userSettingsLabel:l.userSettingsLabel};S.sendWhenReady("vscode:runKeybinding",k.CancellationToken.None,M)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",l)}withKeybinding(l,m){const S=typeof l=="string"?this.keybindings[l]:void 0;if(S?.label){if(S.isNative!==!1)m.accelerator=S.label,m.userSettingsLabel=S.userSettingsLabel;else if(typeof m.label=="string"){const M=m.label.indexOf("[");M>=0?m.label=`${m.label.substr(0,M)} [${S.label}]`:m.label=`${m.label} [${S.label}]`}}else m.accelerator=void 0;return m}likeAction(l,m,S=!m.accelerator){S&&(m=this.withKeybinding(l,m));const M=m.click;return m.click=(A,F,C)=>{this.reportMenuActionTelemetry(l),M&&M(A,F,C)},m}openUrl(l,m){this.nativeHostMainService.openExternal(void 0,l),this.reportMenuActionTelemetry(m)}reportMenuActionTelemetry(l){this.telemetryService.publicLog2("workbenchActionExecuted",{id:l,from:i})}mnemonicLabel(l){return(0,D.mnemonicMenuLabel)(l,!this.currentEnableMenuBarMnemonics)}};a.lastKnownMenubarStorageKey="lastKnownMenubarData",a=ue([te(0,u.IUpdateService),te(1,w.IConfigurationService),te(2,o.IWindowsMainService),te(3,t.IEnvironmentMainService),te(4,v.ITelemetryService),te(5,c.IWorkspacesHistoryMainService),te(6,I.IStateMainService),te(7,P.ILifecycleMainService),te(8,b.ILogService),te(9,d.INativeHostMainService),te(10,g.IProductService)],a),e.Menubar=a;function n(){return new y.MenuItem({type:"separator"})}}),define(J[235],Z([0,1,4,22,6,234]),function(K,e,y,L,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,y.createDecorator)("menubarMainService");let E=class{constructor(f,w,t){this.instantiationService=f,this.lifecycleMainService=w,this.logService=t,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(D.Menubar)}async updateMenubar(f,w){this.logService.trace("menubarService#updateMenubar",f),(await this.menubar).updateMenu(w,f)}};E=ue([te(0,y.IInstantiationService),te(1,L.ILifecycleMainService),te(2,k.ILogService)],E),e.MenubarMainService=E}),define(J[236],Z([0,1,14,30,26,31,24,5,29,43,33,2,10,8,72,3,32,15,13,7,150,51,16,52,23,20,4,22,6,48,21,55,73,39,61,233,99,216,27,100,62,45]),function(K,e,y,L,k,D,E,r,f,w,t,P,b,p,d,g,I,v,u,h,o,c,i,a,n,s,l,m,S,M,A,F,C,X,ee,re,Y,Q,W,V,z,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function j(T){return(0,W.isWorkspaceIdentifier)(T?.workspace)}function U(T){return(0,W.isSingleFolderWorkspaceIdentifier)(T?.workspace)}let q=class Je extends P.Disposable{constructor(R,O,_,N,B,H,x,ie,ae,oe,se,le,de,ge,ve){super();this.machineId=R,this.initialUserEnv=O,this.logService=_,this.stateMainService=N,this.environmentMainService=B,this.lifecycleMainService=H,this.backupMainService=x,this.configurationService=ie,this.workspacesHistoryMainService=ae,this.workspacesManagementMainService=oe,this.instantiationService=se,this.dialogMainService=le,this.fileService=de,this.productService=ge,this.protocolMainService=ve,this._onDidOpenWindow=this._register(new r.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new r.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new r.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new r.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new Q.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(R=>this._onDidSignalReadyWindow.fire(R.window))),this._register(this.onDidSignalReadyWindow(R=>{if(R.config?.extensionDevelopmentPath||R.config?.extensionTestsPath){const O=new P.DisposableStore;if(O.add(r.Event.any(R.onDidClose,R.onDidDestroy)(()=>O.dispose())),R.config.extensionDevelopmentPath)for(const _ of R.config.extensionDevelopmentPath)O.add(this.protocolMainService.addValidFileRoot(h.URI.file(_)));R.config.extensionTestsPath&&O.add(this.protocolMainService.addValidFileRoot(h.URI.file(R.config.extensionTestsPath)))}}))}openEmptyWindow(R,O){let _=this.environmentMainService.args;const N=O?.remoteAuthority||void 0,B=!0,H=O?.forceReuseWindow,x=!H;return this.open({...R,cli:_,forceEmpty:B,forceNewWindow:x,forceReuseWindow:H,remoteAuthority:N})}open(R){this.logService.trace("windowsManager#open"),R.addMode&&(R.initialStartup||!this.getLastActiveWindow())&&(R.addMode=!1);const O=[],_=[],N=[],B=[],H=[];let x,ie=0;const ae=this.getPathsToOpen(R);this.logService.trace("windowsManager#open pathsToOpen",ae);for(const ge of ae)U(ge)?R.addMode?O.push(ge):_.push(ge):j(ge)?N.push(ge):ge.fileUri?(x||(x={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:ge.remoteAuthority}),x.filesToOpenOrCreate.push(ge)):ge.backupPath?H.push({backupFolder:(0,p.basename)(ge.backupPath),remoteAuthority:ge.remoteAuthority}):ie++;R.diffMode&&x&&x.filesToOpenOrCreate.length>=2&&(x.filesToDiff=x.filesToOpenOrCreate.slice(0,2),x.filesToOpenOrCreate=[]),x&&R.waitMarkerFileURI&&(x.filesToWait={paths:[...x.filesToDiff,...x.filesToOpenOrCreate],waitMarkerFileUri:R.waitMarkerFileURI}),R.initialStartup?(B.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),N.push(...B),H.push(...this.backupMainService.getEmptyWindowBackupPaths())):H.length=0;const{windows:oe,filesOpenedInWindow:se}=this.doOpen(R,N,_,H,ie,x,O);if(this.logService.trace(`windowsManager#open used window count ${oe.length} (workspacesToOpen: ${N.length}, foldersToOpen: ${_.length}, emptyToRestore: ${H.length}, emptyToOpen: ${ie})`),oe.length>1)if(se)se.focus();else{const ge=this.windowsStateHandler.state.lastActiveWindow&&!R.forceEmpty&&!R.cli._.length&&!R.cli["file-uri"]&&!R.cli["folder-uri"]&&!(R.urisToOpen&&R.urisToOpen.length);let ve=!0,Pe=!0;if(ge){const we=oe.filter(pe=>this.windowsStateHandler.state.lastActiveWindow&&pe.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);we.length&&(we[0].focus(),ve=!1,Pe=!1)}if(ve)for(let we=oe.length-1;we>=0;we--){const pe=oe[we];if(!(pe.openedWorkspace&&B.some(Ee=>pe.openedWorkspace&&Ee.workspace.id===pe.openedWorkspace.id)||pe.backupPath&&H.some(Ee=>pe.backupPath&&Ee.backupFolder===(0,p.basename)(pe.backupPath)))){pe.focus(),Pe=!1;break}}Pe&&oe[oe.length-1].focus()}const le=x&&x.filesToDiff.length>0;if(!oe.some(ge=>ge.isExtensionDevelopmentHost)&&!le&&!R.noRecentEntry){const ge=[];for(const ve of ae)j(ve)&&!ve.transient?ge.push({label:ve.label,workspace:ve.workspace,remoteAuthority:ve.remoteAuthority}):U(ve)?ge.push({label:ve.label,folderUri:ve.workspace.uri,remoteAuthority:ve.remoteAuthority}):ve.fileUri&&ge.push({label:ve.label,fileUri:ve.fileUri,remoteAuthority:ve.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(ge)}const de=R.waitMarkerFileURI;return R.context===0&&de&&oe.length===1&&oe[0]&&(async()=>{await oe[0].whenClosedOrLoaded;try{await this.fileService.del(de)}catch(ge){}})(),oe}doOpen(R,O,_,N,B,H,x){const ie=[];let ae;function oe(we,pe){ie.push(we),pe&&(ae=we,H=void 0)}let{openFolderInNewWindow:se,openFilesInNewWindow:le}=this.shouldOpenNewWindow(R);if(!R.initialStartup&&x.length>0){const we=x[0].remoteAuthority,pe=this.getLastActiveWindowForAuthority(we);pe&&oe(this.doAddFoldersToExistingWindow(pe,x.map(Ee=>Ee.workspace.uri)))}const de=_.length+O.length+N.length;if(H&&de===0){const we=H.filesToOpenOrCreate[0]||H.filesToDiff[0],pe=this.getWindows().filter(De=>H&&De.remoteAuthority===H.remoteAuthority);let Ee;we?.fileUri&&!le&&((R.context===4||R.context===0||R.context===1)&&(Ee=(0,Y.findWindowOnFile)(pe,we.fileUri,De=>De.configPath.scheme===b.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(De.configPath):void 0)),Ee||(Ee=this.doGetLastActiveWindow(pe))),Ee?(0,W.isWorkspaceIdentifier)(Ee.openedWorkspace)?O.push({workspace:Ee.openedWorkspace,remoteAuthority:Ee.remoteAuthority}):(0,W.isSingleFolderWorkspaceIdentifier)(Ee.openedWorkspace)?_.push({workspace:Ee.openedWorkspace,remoteAuthority:Ee.remoteAuthority}):oe(this.doOpenFilesInExistingWindow(R,Ee,H),!0):oe(this.openInBrowserWindow({userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,filesToOpen:H,forceNewWindow:!0,remoteAuthority:H.remoteAuthority,forceNewTabbedWindow:R.forceNewTabbedWindow}),!0)}const ge=(0,D.distinct)(O,we=>we.workspace.id);if(ge.length>0){const we=(0,D.coalesce)(ge.map(pe=>(0,Y.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe.workspace.configPath)));if(we.length>0){const pe=we[0],Ee=H?.remoteAuthority===pe.remoteAuthority?H:void 0;oe(this.doOpenFilesInExistingWindow(R,pe,Ee),!!Ee),se=!0}ge.forEach(pe=>{if(we.some(Te=>Te.openedWorkspace&&Te.openedWorkspace.id===pe.workspace.id))return;const Ee=pe.remoteAuthority,De=H?.remoteAuthority===Ee?H:void 0;oe(this.doOpenFolderOrWorkspace(R,pe,se,De),!!De),se=!0})}const ve=(0,D.distinct)(_,we=>v.extUriBiasedIgnorePathCase.getComparisonKey(we.workspace.uri));if(ve.length>0){const we=(0,D.coalesce)(ve.map(pe=>(0,Y.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe.workspace.uri)));if(we.length>0){const pe=we[0],Ee=H?.remoteAuthority===pe.remoteAuthority?H:void 0;oe(this.doOpenFilesInExistingWindow(R,pe,Ee),!!Ee),se=!0}ve.forEach(pe=>{if(we.some(Te=>(0,W.isSingleFolderWorkspaceIdentifier)(Te.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(Te.openedWorkspace.uri,pe.workspace.uri)))return;const Ee=pe.remoteAuthority,De=H?.remoteAuthority===Ee?H:void 0;oe(this.doOpenFolderOrWorkspace(R,pe,se,De),!!De),se=!0})}const Pe=(0,D.distinct)(N,we=>we.backupFolder);if(Pe.length>0&&Pe.forEach(we=>{const pe=we.remoteAuthority,Ee=H?.remoteAuthority===pe?H:void 0;oe(this.openInBrowserWindow({userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,filesToOpen:Ee,remoteAuthority:pe,forceNewWindow:!0,forceNewTabbedWindow:R.forceNewTabbedWindow,emptyWindowBackupInfo:we}),!!Ee),se=!0}),ie.length===0||H){H&&!B&&B++;const we=H?H.remoteAuthority:R.remoteAuthority;for(let pe=0;pe<B;pe++)oe(this.doOpenEmpty(R,se,we,H),!!H),se=!0}return{windows:(0,D.distinct)(ie),filesOpenedInWindow:ae}}doOpenFilesInExistingWindow(R,O,_){this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),O.focus();const N={filesToOpenOrCreate:_?.filesToOpenOrCreate,filesToDiff:_?.filesToDiff,filesToWait:_?.filesToWait,termProgram:R?.userEnv?.TERM_PROGRAM};return O.sendWhenReady("vscode:openFiles",E.CancellationToken.None,N),O}doAddFoldersToExistingWindow(R,O){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),R.focus();const _={foldersToAdd:O};return R.sendWhenReady("vscode:addFolders",E.CancellationToken.None,_),R}doOpenEmpty(R,O,_,N,B){return!O&&!B&&typeof R.contextWindowId=="number"&&(B=this.getWindowById(R.contextWindowId)),this.openInBrowserWindow({userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,remoteAuthority:_,forceNewWindow:O,forceNewTabbedWindow:R.forceNewTabbedWindow,filesToOpen:N,windowToUse:B})}doOpenFolderOrWorkspace(R,O,_,N,B){return!_&&!B&&typeof R.contextWindowId=="number"&&(B=this.getWindowById(R.contextWindowId)),this.openInBrowserWindow({workspace:O.workspace,userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,remoteAuthority:O.remoteAuthority,forceNewWindow:_,forceNewTabbedWindow:R.forceNewTabbedWindow,filesToOpen:N,windowToUse:B})}getPathsToOpen(R){let O,_=!1,N=!1;if(R.urisToOpen&&R.urisToOpen.length>0?(O=this.doExtractPathsFromAPI(R),_=!0):R.forceEmpty?O=[Object.create(null)]:R.cli._.length||R.cli["folder-uri"]||R.cli["file-uri"]?(O=this.doExtractPathsFromCLI(R.cli),O.length===0&&O.push(Object.create(null)),_=!0):(O=this.doGetPathsFromLastSession(),O.length===0&&O.push(Object.create(null)),N=!0),!R.addMode&&_){const B=O.filter(H=>U(H));if(B.length>1){const H=B[0].remoteAuthority;if(B.every(x=>x.remoteAuthority===H)){const x=this.workspacesManagementMainService.createUntitledWorkspaceSync(B.map(ie=>({uri:ie.workspace.uri})));O.push({workspace:x,remoteAuthority:H}),O=O.filter(ie=>!U(ie))}}}return R.initialStartup&&!N&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&O.unshift(...this.doGetPathsFromLastSession().filter(B=>j(B)||U(B)||B.backupPath)),O}doExtractPathsFromAPI(R){const O=[],_={gotoLineMode:R.gotoLineMode,remoteAuthority:R.remoteAuthority};for(const N of(0,D.coalesce)(R.urisToOpen||[])){const B=this.resolveOpenable(N,_);if(B)B.label=N.label,O.push(B);else{const H=this.resourceFromOpenable(N),x={title:this.productService.nameLong,type:"info",buttons:[(0,t.mnemonicButtonLabel)((0,o.localize)(0,null))],defaultId:0,message:H.scheme===b.Schemas.file?(0,o.localize)(1,null):(0,o.localize)(2,null),detail:H.scheme===b.Schemas.file?(0,o.localize)(3,null,(0,t.getPathLabel)(H.fsPath,this.environmentMainService)):(0,o.localize)(4,null,H.toString()),noLink:!0};this.dialogMainService.showMessageBox(x,(0,u.withNullAsUndefined)(y.BrowserWindow.getFocusedWindow()))}}return O}doExtractPathsFromCLI(R){const O=[],_={ignoreFileNotFound:!0,gotoLineMode:R.goto,remoteAuthority:R.remote||void 0,forceOpenWorkspaceAsFile:!1},N=R["folder-uri"];if(N)for(const x of N){const ie=this.cliArgToUri(x);if(ie){const ae=this.resolveOpenable({folderUri:ie},_);ae&&O.push(ae)}}const B=R["file-uri"];if(B)for(const x of B){const ie=this.cliArgToUri(x);if(ie){const ae=this.resolveOpenable((0,W.hasWorkspaceFileExtension)(x)?{workspaceUri:ie}:{fileUri:ie},_);ae&&O.push(ae)}}const H=R._;for(const x of H){const ie=_.remoteAuthority?this.doResolvePathRemote(x,_):this.doResolveFilePath(x,_);ie&&O.push(ie)}return O}cliArgToUri(R){try{const O=h.URI.parse(R);if(!O.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${R}`);return}return O}catch(O){this.logService.error(`Invalid URI input string: ${R}, ${O.message}`)}}doGetPathsFromLastSession(){const R=this.getRestoreWindowsSetting();switch(R){case"none":return[];case"one":case"all":case"preserve":case"folders":const O=[];R!=="one"&&O.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&O.push(this.windowsStateHandler.state.lastActiveWindow);const _=[];for(const N of O)if(N.workspace){const B=this.resolveOpenable({workspaceUri:N.workspace.configPath},{remoteAuthority:N.remoteAuthority,rejectTransientWorkspaces:!0});j(B)&&_.push(B)}else if(N.folderUri){const B=this.resolveOpenable({folderUri:N.folderUri},{remoteAuthority:N.remoteAuthority});U(B)&&_.push(B)}else R!=="folders"&&N.backupPath&&_.push({backupPath:N.backupPath,remoteAuthority:N.remoteAuthority});return _}}getRestoreWindowsSetting(){let R;return this.lifecycleMainService.wasRestarted?R="all":(R=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(R)||(R="all")),R}resolveOpenable(R,O=Object.create(null)){let _=this.resourceFromOpenable(R);return _.scheme===b.Schemas.file?((0,ee.isFileToOpen)(R)&&(O={...O,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(_.fsPath,O)):this.doResolveRemoteOpenable(R,O)}doResolveRemoteOpenable(R,O){let _=this.resourceFromOpenable(R);const N=(0,C.getRemoteAuthority)(_)||O.remoteAuthority;if(_=(0,v.removeTrailingPathSeparator)((0,v.normalizePath)(_)),(0,ee.isFileToOpen)(R)){if(O.gotoLineMode){const{path:B,line:H,column:x}=(0,f.parseLineAndColumnAware)(_.path);return{fileUri:_.with({path:B}),selection:H?{startLineNumber:H,startColumn:x||1}:void 0,remoteAuthority:N}}return{fileUri:_,remoteAuthority:N}}else if((0,ee.isWorkspaceToOpen)(R))return{workspace:(0,V.getWorkspaceIdentifier)(_),remoteAuthority:N};return{workspace:(0,V.getSingleFolderWorkspaceIdentifier)(_),remoteAuthority:N}}resourceFromOpenable(R){return(0,ee.isWorkspaceToOpen)(R)?R.workspaceUri:(0,ee.isFolderToOpen)(R)?R.folderUri:R.fileUri}doResolveFilePath(R,O){let _,N;O.gotoLineMode&&({path:R,line:_,column:N}=(0,f.parseLineAndColumnAware)(R)),R=(0,f.sanitizeFilePath)((0,p.normalize)(R),(0,I.cwd)());try{const B=(0,L.statSync)(R);if(B.isFile()){if(!O.forceOpenWorkspaceAsFile){const H=this.workspacesManagementMainService.resolveLocalWorkspaceSync(h.URI.file(R));if(H)return H.transient&&O.rejectTransientWorkspaces?void 0:{workspace:{id:H.id,configPath:H.configPath},remoteAuthority:H.remoteAuthority,exists:!0,transient:H.transient}}return{fileUri:h.URI.file(R),selection:_?{startLineNumber:_,startColumn:N||1}:void 0,exists:!0}}else if(B.isDirectory())return{workspace:(0,V.getSingleFolderWorkspaceIdentifier)(h.URI.file(R),B),exists:!0}}catch(B){const H=h.URI.file(R);if(this.workspacesHistoryMainService.removeRecentlyOpened([H]),O.ignoreFileNotFound)return{fileUri:H,exists:!1}}}doResolvePathRemote(R,O){const _=R.charCodeAt(0),N=O.remoteAuthority;let B,H;O.gotoLineMode&&({path:R,line:B,column:H}=(0,f.parseLineAndColumnAware)(R)),_!==47&&((0,f.isWindowsDriveLetter)(_)&&R.charCodeAt(R.charCodeAt(1))===58&&(R=(0,f.toSlashes)(R)),R=`/${R}`);const x=h.URI.from({scheme:b.Schemas.vscodeRemote,authority:N,path:R});if(R.charCodeAt(R.length-1)!==47){if((0,W.hasWorkspaceFileExtension)(R))return O.forceOpenWorkspaceAsFile?{fileUri:x,selection:B?{startLineNumber:B,startColumn:H||1}:void 0,remoteAuthority:O.remoteAuthority}:{workspace:(0,V.getWorkspaceIdentifier)(x),remoteAuthority:N};if(O.gotoLineMode||p.posix.basename(R).indexOf(".")!==-1)return{fileUri:x,selection:B?{startLineNumber:B,startColumn:H||1}:void 0,remoteAuthority:N}}return{workspace:(0,V.getSingleFolderWorkspaceIdentifier)(x),remoteAuthority:N}}shouldOpenNewWindow(R){const O=this.configurationService.getValue("window"),_=O?.openFoldersInNewWindow||"default",N=O?.openFilesInNewWindow||"off";let B=(R.preferNewWindow||R.forceNewWindow)&&!R.forceReuseWindow;!R.forceNewWindow&&!R.forceReuseWindow&&(_==="on"||_==="off")&&(B=_==="on");let H=!1;return R.forceNewWindow||R.forceReuseWindow?H=!!R.forceNewWindow&&!R.forceReuseWindow:(g.isMacintosh?R.context===1&&(H=!0):R.context!==3&&R.context!==2&&!(R.userEnv&&R.userEnv.TERM_PROGRAM==="vscode")&&(H=!0),!R.cli.extensionDevelopmentPath&&(N==="on"||N==="off")&&(H=N==="on")),{openFolderInNewWindow:!!B,openFilesInNewWindow:H}}openExtensionDevelopmentHostWindow(R,O){const _=(0,Y.findWindowOnExtensionDevelopmentPath)(this.getWindows(),R);if(_)return this.lifecycleMainService.reload(_,O.cli),_.focus(),[_];let N=O.cli["folder-uri"]||[],B=O.cli["file-uri"]||[],H=O.cli._;if(!H.length&&!N.length&&!B.length&&!O.cli.extensionTestsPath){const oe=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,se=oe&&(oe.workspace||oe.folderUri);se&&(h.URI.isUri(se)?se.scheme===b.Schemas.file?H=[se.fsPath]:N=[se.toString()]:se.configPath.scheme===b.Schemas.file?H=[(0,v.originalFSPath)(se.configPath)]:B=[se.configPath.toString()])}let x=O.remoteAuthority;for(const oe of R)if(oe.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const se=h.URI.parse(oe),le=(0,C.getRemoteAuthority)(se);le&&(x?le!==x&&this.logService.error("more than one extension development path authority"):x=le)}H=H.filter(oe=>{const se=h.URI.file(oe);return(0,Y.findWindowOnWorkspaceOrFolder)(this.getWindows(),se)?!1:(0,C.getRemoteAuthority)(se)===x}),N=N.filter(oe=>{const se=this.cliArgToUri(oe);return se&&!!(0,Y.findWindowOnWorkspaceOrFolder)(this.getWindows(),se)?!1:se?(0,C.getRemoteAuthority)(se)===x:!1}),B=B.filter(oe=>{const se=this.cliArgToUri(oe);return se&&!!(0,Y.findWindowOnWorkspaceOrFolder)(this.getWindows(),se)?!1:se?(0,C.getRemoteAuthority)(se)===x:!1}),O.cli._=H,O.cli["folder-uri"]=N,O.cli["file-uri"]=B;const ie=!H.length&&!N.length&&!B.length,ae={context:O.context,cli:O.cli,forceNewWindow:!0,forceEmpty:ie,userEnv:O.userEnv,noRecentEntry:!0,waitMarkerFileURI:O.waitMarkerFileURI,remoteAuthority:x};return this.open(ae)}openInBrowserWindow(R){const O=this.configurationService.getValue("window"),_={...this.environmentMainService.args,...R.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:R.emptyWindowBackupInfo?(0,p.join)(this.environmentMainService.backupHome,R.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:R.remoteAuthority,workspace:R.workspace,userEnv:{...this.initialUserEnv,...R.userEnv},filesToOpenOrCreate:R.filesToOpen?.filesToOpenOrCreate,filesToDiff:R.filesToOpen?.filesToDiff,filesToWait:R.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:M.default,isInitialStartup:R.initialStartup,perfMarks:(0,d.getMarks)(),os:{release:(0,k.release)(),hostname:(0,k.hostname)()},zoomLevel:typeof O?.zoomLevel=="number"?O.zoomLevel:void 0,autoDetectHighContrast:O?.autoDetectHighContrast??!0,accessibilitySupport:y.app.accessibilitySupportEnabled,colorScheme:{dark:y.nativeTheme.shouldUseDarkColors,highContrast:y.nativeTheme.shouldUseInvertedColorScheme||y.nativeTheme.shouldUseHighContrastColors}};let N;if(!R.forceNewWindow&&!R.forceNewTabbedWindow&&(N=R.windowToUse||this.getLastActiveWindow(),N&&N.focus()),N){const B=N.config;!_.extensionDevelopmentPath&&B&&!!B.extensionDevelopmentPath&&(_.extensionDevelopmentPath=B.extensionDevelopmentPath,_.verbose=B.verbose,_["inspect-brk-extensions"]=B["inspect-brk-extensions"],_.debugId=B.debugId,_["inspect-extensions"]=B["inspect-extensions"],_["extensions-dir"]=B["extensions-dir"])}else{const B=this.windowsStateHandler.getNewWindowState(_);(0,d.mark)("code/willCreateCodeWindow");const H=N=this.instantiationService.createInstance(re.CodeWindow,{state:B,extensionDevelopmentPath:_.extensionDevelopmentPath,isExtensionTestHost:!!_.extensionTestsPath});if((0,d.mark)("code/didCreateCodeWindow"),R.forceNewTabbedWindow){const ie=this.getLastActiveWindow();ie&&ie.addTabbedWindow(H)}Je.WINDOWS.push(H),this._onDidOpenWindow.fire(H),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,w.once)(H.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(H)),(0,w.once)(H.onDidClose)(()=>this.onWindowClosed(H)),(0,w.once)(H.onDidDestroy)(()=>this._onDidDestroyWindow.fire(H));const x=(0,u.assertIsDefined)(H.win?.webContents);x.removeAllListeners("devtools-reload-page"),x.on("devtools-reload-page",()=>this.lifecycleMainService.reload(H)),this.lifecycleMainService.registerWindow(H)}return _.windowId=N.id,N.isReady?this.lifecycleMainService.unload(N,4).then(B=>{B||this.doOpenInBrowserWindow(N,_,R)}):this.doOpenInBrowserWindow(N,_,R),N}doOpenInBrowserWindow(R,O,_){if(!O.extensionDevelopmentPath)if((0,W.isWorkspaceIdentifier)(O.workspace))O.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:O.workspace,remoteAuthority:O.remoteAuthority});else if((0,W.isSingleFolderWorkspaceIdentifier)(O.workspace))O.backupPath=this.backupMainService.registerFolderBackupSync(O.workspace.uri);else{const N=_.emptyWindowBackupInfo&&_.emptyWindowBackupInfo.backupFolder;O.backupPath=this.backupMainService.registerEmptyWindowBackupSync(N,O.remoteAuthority)}R.load(O)}onWindowClosed(R){const O=Je.WINDOWS.indexOf(R);Je.WINDOWS.splice(O,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const R=y.BrowserWindow.getFocusedWindow();if(R)return this.getWindowById(R.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(R){return this.doGetLastActiveWindow(this.getWindows().filter(O=>O.remoteAuthority===R))}doGetLastActiveWindow(R){const O=Math.max.apply(Math,R.map(_=>_.lastFocusTime));return R.find(_=>_.lastFocusTime===O)}sendToFocused(R,...O){const _=this.getFocusedWindow()||this.getLastActiveWindow();_&&_.sendWhenReady(R,E.CancellationToken.None,...O)}sendToAll(R,O,_){for(const N of this.getWindows())_&&_.indexOf(N.id)>=0||N.sendWhenReady(R,E.CancellationToken.None,O)}getWindows(){return Je.WINDOWS}getWindowCount(){return Je.WINDOWS.length}getWindowById(R){const O=this.getWindows().filter(_=>_.id===R);return(0,D.firstOrDefault)(O)}getWindowByWebContents(R){const O=y.BrowserWindow.fromWebContents(R);if(!!O)return this.getWindowById(O.id)}};q.WINDOWS=[],q=ue([te(2,S.ILogService),te(3,X.IStateMainService),te(4,n.IEnvironmentMainService),te(5,m.ILifecycleMainService),te(6,c.IBackupMainService),te(7,i.IConfigurationService),te(8,z.IWorkspacesHistoryMainService),te(9,$.IWorkspacesManagementMainService),te(10,l.IInstantiationService),te(11,a.IDialogMainService),te(12,s.IFileService),te(13,A.IProductService),te(14,F.IProtocolMainService)],q),e.WindowsMainService=q}),define(J[237],Z([0,1,51,36,62,45]),function(K,e,y,L,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let E=class{constructor(f,w,t,P){this.workspacesManagementMainService=f,this.windowsMainService=w,this.workspacesHistoryMainService=t,this.backupMainService=P,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(f,w){const t=this.windowsMainService.getWindowById(f);if(t)return this.workspacesManagementMainService.enterWorkspace(t,this.windowsMainService.getWindows(),w)}createUntitledWorkspace(f,w,t){return this.workspacesManagementMainService.createUntitledWorkspace(w,t)}deleteUntitledWorkspace(f,w){return this.workspacesManagementMainService.deleteUntitledWorkspace(w)}getWorkspaceIdentifier(f,w){return this.workspacesManagementMainService.getWorkspaceIdentifier(w)}async getRecentlyOpened(f){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(f))}async addRecentlyOpened(f,w){return this.workspacesHistoryMainService.addRecentlyOpened(w)}async removeRecentlyOpened(f,w){return this.workspacesHistoryMainService.removeRecentlyOpened(w)}async clearRecentlyOpened(f){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};E=ue([te(0,D.IWorkspacesManagementMainService),te(1,L.IWindowsMainService),te(2,k.IWorkspacesHistoryMainService),te(3,y.IBackupMainService)],E),e.WorkspacesMainService=E}),define(J[238],Z([0,1,14,30,26,18,17,29,43,40,33,2,10,8,3,15,13,7,28,66,119,35,122,84,229,131,51,220,16,178,157,70,52,219,88,23,54,90,169,185,89,172,20,69,4,71,230,196,101,22,6,180,235,53,21,73,225,74,39,214,98,197,34,199,200,75,42,205,227,231,228,232,97,206,207,208,209,211,36,236,212,27,62,237,45]),function(K,e,y,L,k,D,E,r,f,w,t,P,b,p,d,g,I,v,u,h,o,c,i,a,n,s,l,m,S,M,A,F,C,X,ee,re,Y,Q,W,V,z,$,j,U,q,T,R,O,_,N,B,H,x,ie,ae,oe,se,le,de,ge,ve,Pe,we,pe,Ee,De,Te,Ne,Ue,Ge,Be,st,Ze,ot,Ye,ut,xe,G,ne,ce,fe,ye,Me,Fe,We){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Ce=class extends P.Disposable{constructor(he,Se,be,me,Ie,Le,ke,Ae,Re,$e){super();this.mainProcessNodeIpcServer=he,this.userEnv=Se,this.mainInstantiationService=be,this.logService=me,this.environmentMainService=Ie,this.lifecycleMainService=Le,this.configurationService=ke,this.stateMainService=Ae,this.fileService=Re,this.productService=$e,this.configureSession(),this.registerListeners()}configureSession(){const he=me=>me?.startsWith(`${b.Schemas.vscodeWebview}://`),Se=new Set(["clipboard-read","clipboard-sanitized-write"]);y.session.defaultSession.setPermissionRequestHandler((me,Ie,Le,ke)=>he(ke.requestingUrl)?Le(Se.has(Ie)):Le(!1)),y.session.defaultSession.setPermissionCheckHandler((me,Ie,Le,ke)=>he(ke.requestingUrl)?Se.has(Ie):!1);const be=y.session.defaultSession;typeof be.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&be.setCodeCachePath((0,p.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,E.setUnexpectedErrorHandler)(be=>this.onUnexpectedError(be)),process.on("uncaughtException",be=>(0,E.onUnexpectedError)(be)),process.on("unhandledRejection",be=>(0,E.onUnexpectedError)(be)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,o.registerContextMenuListener)(),y.app.on("accessibility-support-changed",(be,me)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",me)}),y.app.on("activate",(be,me)=>{this.logService.trace("app#activate"),me||this.windowsMainService?.openEmptyWindow({context:1})}),y.app.on("web-contents-created",(be,me)=>{me.on("will-navigate",Ie=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Ie.preventDefault()}),me.setWindowOpenHandler(({url:Ie})=>(this.nativeHostMainService?.openExternal(void 0,Ie),{action:"deny"}))});let he=[],Se;y.app.on("open-file",(be,me)=>{this.logService.trace("app#open-file: ",me),be.preventDefault(),he.push(this.getWindowOpenableFromPathSync(me)),Se!==void 0&&(clearTimeout(Se),Se=void 0),Se=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:he,gotoLineMode:!1,preferNewWindow:!0}),he=[],Se=void 0},100)}),y.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),y.ipcMain.handle("vscode:fetchShellEnv",be=>{const me=this.windowsMainService?.getWindowByWebContents(be.sender);let Ie,Le;return me?.config?(Ie=me.config,Le={...process.env,...me.config.userEnv}):(Ie=this.environmentMainService.args,Le=process.env),(0,Q.resolveShellEnv)(this.logService,Ie,Le)}),y.ipcMain.handle("vscode:writeNlsFile",(be,me,Ie)=>{const Le=this.validateNlsPath([me]);if(!Le||typeof Ie!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Le,D.VSBuffer.fromString(Ie))}),y.ipcMain.handle("vscode:readNlsFile",async(be,...me)=>{const Ie=this.validateNlsPath(me);if(!Ie)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Ie)).value.toString()}),y.ipcMain.on("vscode:toggleDevTools",be=>be.sender.toggleDevTools()),y.ipcMain.on("vscode:openDevTools",be=>be.sender.openDevTools()),y.ipcMain.on("vscode:reloadWindow",be=>be.sender.reload())}validateNlsPath(he){let Se;for(const be of he)typeof be=="string"&&(typeof Se!="string"?Se=be:Se=(0,p.join)(Se,be));if(!(typeof Se!="string"||!(0,p.isAbsolute)(Se)||!(0,r.isEqualOrParent)(Se,this.environmentMainService.cachedLanguagesPath,!d.isLinux)))return v.URI.file(Se)}onUnexpectedError(he){if(he){const Se={message:`[uncaught exception in main]: ${he.message}`,stack:he.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Se))}this.logService.error(`[uncaught exception in main]: ${he}`),he.stack&&this.logService.error(he.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const he=this.productService.win32AppUserModelId;d.isWindows&&he&&y.app.setAppUserModelId(he);try{d.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!y.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&y.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Re){this.logService.error(Re)}const Se=new i.Server;this.logService.trace("Resolving machine identifier...");const be=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${be}`);const{sharedProcess:me,sharedProcessReady:Ie,sharedProcessClient:Le}=this.setupSharedProcess(be),ke=await this.initServices(be,me,Ie);if(this.environmentMainService.driverHandle){const Re=await(0,X.serve)(Se,this.environmentMainService.driverHandle,this.environmentMainService,ke);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Re)}this._register(ke.createInstance(n.ProxyAuthHandler)),ke.invokeFunction(Re=>this.initChannels(Re,Se,Le));const Ae=ke.invokeFunction(Re=>this.openFirstWindow(Re,Se));ke.invokeFunction(Re=>this.afterWindowOpen(Re,me)),this.environmentMainService.args.trace&&ke.invokeFunction(Re=>this.stopTracingEventually(Re,Ae))}async resolveMachineId(){let he=this.stateMainService.getItem(we.machineIdKey);return(!he||d.isMacintosh&&he==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(he=await(0,h.getMachineId)(),this.stateMainService.setItem(we.machineIdKey,he)),he}setupSharedProcess(he){const Se=this._register(this.mainInstantiationService.createInstance(se.SharedProcess,he,this.userEnv)),be=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Ie=await Se.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new a.Client(Ie,"main")})(),me=(async()=>(await Se.whenReady(),be))();return{sharedProcess:Se,sharedProcessReady:me,sharedProcessClient:be}}async initServices(he,Se,be){const me=new T.ServiceCollection;switch(process.platform){case"win32":me.set(Te.IUpdateService,new U.SyncDescriptor(st.Win32UpdateService));break;case"linux":d.isLinuxSnap?me.set(Te.IUpdateService,new U.SyncDescriptor(Be.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):me.set(Te.IUpdateService,new U.SyncDescriptor(Ge.LinuxUpdateService));break;case"darwin":me.set(Te.IUpdateService,new U.SyncDescriptor(Ue.DarwinUpdateService));break}me.set(ne.IWindowsMainService,new U.SyncDescriptor(ce.WindowsMainService,[he,this.userEnv])),me.set(C.IDialogMainService,new U.SyncDescriptor(C.DialogMainService)),me.set(_.ILaunchMainService,new U.SyncDescriptor(_.LaunchMainService)),me.set(F.IDiagnosticsService,c.ProxyChannel.toService((0,c.getDelayedChannel)(be.then(Le=>Le.getChannel("diagnostics"))))),me.set(R.IIssueMainService,new U.SyncDescriptor(R.IssueMainService,[this.userEnv])),me.set(ee.IEncryptionMainService,new U.SyncDescriptor(ee.EncryptionMainService,[he])),me.set(O.IKeyboardLayoutMainService,new U.SyncDescriptor(O.KeyboardLayoutMainService)),me.set(ie.INativeHostMainService,new U.SyncDescriptor(ie.NativeHostMainService,[Se])),me.set(xe.IWebviewManagerService,new U.SyncDescriptor(G.WebviewMainService)),me.set(ye.IWorkspacesService,new U.SyncDescriptor(Fe.WorkspacesMainService)),me.set(We.IWorkspacesManagementMainService,new U.SyncDescriptor(We.WorkspacesManagementMainService)),me.set(Me.IWorkspacesHistoryMainService,new U.SyncDescriptor(Me.WorkspacesHistoryMainService)),me.set(x.IMenubarMainService,new U.SyncDescriptor(x.MenubarMainService)),me.set(W.IExtensionUrlTrustService,new U.SyncDescriptor(V.ExtensionUrlTrustService)),me.set(ve.IStorageMainService,new U.SyncDescriptor(ve.StorageMainService)),d.isWindows?me.set(z.IExternalTerminalMainService,new U.SyncDescriptor($.WindowsExternalTerminalService)):d.isMacintosh?me.set(z.IExternalTerminalMainService,new U.SyncDescriptor($.MacExternalTerminalService)):d.isLinux&&me.set(z.IExternalTerminalMainService,new U.SyncDescriptor($.LinuxExternalTerminalService));const Ie=new m.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(me.set(l.IBackupMainService,Ie),me.set(Ze.IURLService,new U.SyncDescriptor(Ye.NativeURLService)),(0,De.getTelemetryLevel)(this.productService,this.environmentMainService)>=2){const Le=(0,c.getDelayedChannel)(be.then(Ke=>Ke.getChannel("telemetryAppender"))),ke=new pe.TelemetryAppenderClient(Le),Ae=(0,Pe.resolveCommonProperties)(this.fileService,(0,k.release)(),(0,k.hostname)(),process.arch,this.productService.commit,this.productService.version,he,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Re=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],$e={appender:ke,commonProperties:Ae,piiPaths:Re,sendErrorTelemetry:!0};me.set(we.ITelemetryService,new U.SyncDescriptor(Ee.TelemetryService,[$e]))}else me.set(we.ITelemetryService,De.NullTelemetryService);return await Ie.initialize(),this.mainInstantiationService.createChild(me)}initChannels(he,Se,be){const me=c.ProxyChannel.fromService(he.get(_.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",me),Se.registerChannel(M.UserConfigurationFileServiceId,c.ProxyChannel.fromService(new M.UserConfigurationFileService(this.environmentMainService,this.fileService,this.logService)));const Ie=new Ne.UpdateChannel(he.get(Te.IUpdateService));Se.registerChannel("update",Ie);const Le=c.ProxyChannel.fromService(he.get(R.IIssueMainService));Se.registerChannel("issue",Le);const ke=c.ProxyChannel.fromService(he.get(ee.IEncryptionMainService));Se.registerChannel("encryption",ke);const Ae=c.ProxyChannel.fromService(he.get(le.ISignService));Se.registerChannel("sign",Ae);const Re=c.ProxyChannel.fromService(he.get(O.IKeyboardLayoutMainService));Se.registerChannel("keyboardLayout",Re),this.nativeHostMainService=he.get(ie.INativeHostMainService);const $e=c.ProxyChannel.fromService(this.nativeHostMainService);Se.registerChannel("nativeHost",$e),be.then(He=>He.registerChannel("nativeHost",$e));const Ke=c.ProxyChannel.fromService(he.get(ye.IWorkspacesService));Se.registerChannel("workspaces",Ke);const et=c.ProxyChannel.fromService(he.get(x.IMenubarMainService));Se.registerChannel("menubar",et);const tt=c.ProxyChannel.fromService(he.get(Ze.IURLService));Se.registerChannel("url",tt);const ht=c.ProxyChannel.fromService(he.get(W.IExtensionUrlTrustService));Se.registerChannel("extensionUrlTrust",ht);const _e=c.ProxyChannel.fromService(he.get(xe.IWebviewManagerService));Se.registerChannel("webview",_e);const it=this._register(new ge.StorageDatabaseChannel(this.logService,he.get(ve.IStorageMainService)));Se.registerChannel("storage",it),be.then(He=>He.registerChannel("storage",it));const nt=c.ProxyChannel.fromService(he.get(z.IExternalTerminalMainService));Se.registerChannel("externalTerminal",nt);const Xe=new H.LogLevelChannel(he.get(B.ILogService));Se.registerChannel("logLevel",Xe),be.then(He=>He.registerChannel("logLevel",Xe));const rt=new H.LoggerChannel(he.get(B.ILoggerService));Se.registerChannel("logger",rt),be.then(He=>He.registerChannel("logger",rt));const at=new A.ElectronExtensionHostDebugBroadcastChannel(he.get(ne.IWindowsMainService));Se.registerChannel("extensionhostdebugservice",at)}openFirstWindow(he,Se){const be=this.windowsMainService=he.get(ne.IWindowsMainService),me=he.get(Ze.IURLService),Ie=he.get(ie.INativeHostMainService);this.lifecycleMainService.phase=2;const Le=[],ke=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Oe=>{try{return{uri:v.URI.parse(Oe),url:Oe}}catch{return}}).filter(Oe=>{if(!Oe||this.shouldBlockURI(Oe.uri))return!1;const Qe=this.getWindowOpenableFromProtocolLink(Oe.uri);return Qe?(Le.push(Qe),!1):!0}),Ae=this,Re=this.environmentMainService,$e=this.productService;me.registerHandler({async handleURL(Oe,Qe){if(Oe.scheme===$e.urlProtocol&&Oe.path==="workspace"&&(Oe=Oe.with({authority:"file",path:v.URI.parse(Oe.query).path,query:""})),Ae.shouldBlockURI(Oe))return!0;const vt=Ae.getWindowOpenableFromProtocolLink(Oe);if(vt){const[ft]=be.open({context:5,cli:{...Re.args},urisToOpen:[vt],gotoLineMode:!0});return ft.focus(),!0}if(d.isMacintosh&&be.getWindowCount()===0){const[ft]=be.open({context:5,cli:{...Re.args},forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,oe.getRemoteAuthority)(Oe)});return await ft.ready(),me.open(Oe,Qe)}return!1}});const Ke=this._register(new fe.ActiveWindowManager({onDidOpenWindow:Ie.onDidOpenWindow,onDidFocusWindow:Ie.onDidFocusWindow,getActiveWindowId:()=>Ie.getActiveWindowId(-1)})),et=new c.StaticRouter(Oe=>Ke.getActiveClientId().then(Qe=>Oe===Qe)),tt=new ot.URLHandlerRouter(et),ht=Se.getChannel("urlHandler",tt);me.registerHandler(new ot.URLHandlerChannelClient(ht)),this._register(new ut.ElectronURLListener(ke,me,be,this.environmentMainService,this.productService));const _e=this.environmentMainService.args,it=global.macOpenFiles,nt=(0,Y.isLaunchedFromCli)(process.env)?0:4,Xe=_e._.length,rt=!!_e["folder-uri"],at=!!_e["file-uri"],He=_e["skip-add-to-recently-opened"]===!0,dt=_e.wait&&_e.waitMarkerFilePath?v.URI.file(_e.waitMarkerFilePath):void 0,pt=_e.remote||void 0;return Le.length>0?be.open({context:nt,cli:_e,urisToOpen:Le,gotoLineMode:!0,initialStartup:!0}):_e["new-window"]&&!Xe&&!rt&&!at?be.open({context:nt,cli:_e,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:He,waitMarkerFileURI:dt,initialStartup:!0,remoteAuthority:pt}):it.length&&!Xe&&!rt&&!at?be.open({context:1,cli:_e,urisToOpen:it.map(Oe=>this.getWindowOpenableFromPathSync(Oe)),noRecentEntry:He,waitMarkerFileURI:dt,initialStartup:!0}):be.open({context:nt,cli:_e,forceNewWindow:_e["new-window"]||!Xe&&_e["unity-launch"],diffMode:_e.diff,noRecentEntry:He,waitMarkerFileURI:dt,gotoLineMode:_e.goto,initialStartup:!0,remoteAuthority:pt})}shouldBlockURI(he){return!!(he.authority===b.Schemas.file&&d.isWindows&&y.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,t.mnemonicButtonLabel)((0,s.localize)(0,null)),(0,t.mnemonicButtonLabel)((0,s.localize)(1,null))],defaultId:0,cancelId:1,message:(0,s.localize)(2,null,(0,t.getPathLabel)(he.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,s.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(he){if(!!he.path){if(he.authority===b.Schemas.file)return{fileUri:v.URI.file(he.fsPath)};if(he.authority===b.Schemas.vscodeRemote){const Se=he.path.indexOf(p.posix.sep,1);if(Se!==-1){const be=he.path.substring(1,Se),me=he.path.substring(Se),Ie=v.URI.from({scheme:b.Schemas.vscodeRemote,authority:be,path:me,query:he.query,fragment:he.fragment});return(0,ye.hasWorkspaceFileExtension)(me)?{workspaceUri:Ie}:/:[\d]+$/.test(me)?{fileUri:Ie}:{folderUri:Ie}}}}}getWindowOpenableFromPathSync(he){try{if((0,L.statSync)(he).isDirectory())return{folderUri:v.URI.file(he)};if((0,ye.hasWorkspaceFileExtension)(he))return{workspaceUri:v.URI.file(he)}}catch(Se){}return{fileUri:v.URI.file(he)}}async afterWindowOpen(he,Se){this.lifecycleMainService.phase=3;let be=!1;(0,f.once)(this.lifecycleMainService.onWillShutdown)(()=>be=!0);const me=he.get(we.ITelemetryService);this._register(Se.onDidError(({type:ke,details:Ae})=>{let Re;switch(ke){case 1:Re="SharedProcess: detected unresponsive window";break;case 2:Re=`SharedProcess: crashed (detail: ${Ae?.reason??"<unknown>"}, code: ${Ae?.exitCode??"<unknown>"})`;break;case 3:Re=`SharedProcess: failed to load (detail: ${Ae?.reason??"<unknown>"}, code: ${Ae?.exitCode??"<unknown>"})`;break}(0,E.onUnexpectedError)(new Error(Re)),me.publicLog2("sharedprocesserror",{type:ke,reason:Ae?.reason,code:Ae?.exitCode,visible:Se.isVisible(),shuttingdown:be})}));const Ie=this.productService.win32MutexName;if(d.isWindows&&Ie)try{const ke=K.__$__nodeRequire("windows-mutex").Mutex,Ae=new ke(Ie);(0,f.once)(this.lifecycleMainService.onWillShutdown)(()=>Ae.release())}catch(ke){this.logService.error(ke)}y.protocol.registerHttpProtocol(b.Schemas.vscodeRemoteResource,(ke,Ae)=>{Ae({url:ke.url.replace(/^vscode-remote-resource:/,"http:"),method:ke.method})});const Le=he.get(Te.IUpdateService);(Le instanceof st.Win32UpdateService||Le instanceof Ge.LinuxUpdateService||Le instanceof Ue.DarwinUpdateService)&&Le.initialize(),(0,Q.resolveShellEnv)(this.logService,this.environmentMainService.args,process.env);try{const Ae=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,w.stripComments)(Ae))["enable-crash-reporter"]===void 0){const $e=this.configurationService.getValue("telemetry.enableCrashReporter"),Ke=typeof $e=="boolean"?$e:!0,et=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ke},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,u.generateUuid)()}"`,"}"],tt=Ae.substring(0,Ae.length-2).concat(`,
`,et.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,D.VSBuffer.fromString(tt))}}catch(ke){this.logService.error(ke)}}stopTracingEventually(he,Se){this.logService.info("Tracing: waiting for windows to get ready...");const be=he.get(C.IDialogMainService);let me=!1;const Ie=async ke=>{if(me)return;me=!0;const Ae=await y.contentTracing.stopRecording((0,g.joinPath)(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);ke?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Ae}`):be.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,s.localize)(4,null),detail:(0,s.localize)(5,null,Ae),buttons:[(0,t.mnemonicButtonLabel)((0,s.localize)(6,null))],defaultId:0,noLink:!0},(0,I.withNullAsUndefined)(y.BrowserWindow.getFocusedWindow()))},Le=setTimeout(()=>Ie(!0),3e4);Promise.all(Se.map(ke=>ke.ready())).then(()=>{clearTimeout(Le),Ie(!1)})}};Ce=ue([te(2,q.IInstantiationService),te(3,B.ILogService),te(4,re.IEnvironmentMainService),te(5,N.ILifecycleMainService),te(6,S.IConfigurationService),te(7,de.IStateMainService),te(8,j.IFileService),te(9,ae.IProductService)],Ce),e.CodeApplication=Ce}),define(J[242],Z([0,1,14,30,31,9,67,17,29,43,33,10,8,72,3,32,25,19,35,56,238,11,16,189,198,23,54,161,20,183,184,69,174,71,22,92,6,181,93,48,21,55,186,95,222,50,224,74,195,39,226,75,60,204]),function(K,e,y,L,k,D,E,r,f,w,t,P,b,p,d,g,I,v,u,h,o,c,i,a,n,s,l,m,S,M,A,F,C,X,ee,re,Y,Q,W,V,z,$,j,U,q,T,R,O,_,N,B,H,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ie{main(){try{this.startup()}catch(se){console.error(se.message),y.app.exit(1)}}async startup(){(0,r.setUnexpectedErrorHandler)(pe=>console.error(pe));const[se,le,de,ge,ve,Pe,we]=this.createServices();try{try{await this.initServices(de,ge,ve)}catch(pe){throw this.handleStartupDataDirError(de,we.nameLong,pe),pe}await se.invokeFunction(async pe=>{const Ee=pe.get(Y.ILogService),De=pe.get(ee.ILifecycleMainService),Te=pe.get(S.IFileService),Ne=await this.claimInstance(Ee,de,De,se,we,!0);return v.Promises.writeFile(de.mainLockfile,String(process.pid)).catch(Ue=>{Ee.warn(`Error writing main lockfile: ${Ue.stack}`)}),Pe.logger=new W.SpdLogLogger("main",(0,b.join)(de.logsPath,"main.log"),!0,Pe.getLevel()),(0,w.once)(De.onWillShutdown)(Ue=>{Te.dispose(),ge.dispose(),Ue.join(v.Promises.unlink(de.mainLockfile).catch(()=>{}))}),se.createInstance(o.CodeApplication,Ne,le).startup()})}catch(pe){se.invokeFunction(this.quit,pe)}}createServices(){const se=new X.ServiceCollection,le={_serviceBrand:void 0,...V.default};se.set(z.IProductService,le);const de=new s.EnvironmentMainService(this.resolveArgs(),le),ge=this.patchEnvironment(de);se.set(s.IEnvironmentMainService,de);const ve=new re.BufferLogService,Pe=new Y.MultiplexLogService([new Y.ConsoleMainLogger((0,Y.getLogLevel)(de)),ve]);process.once("exit",()=>Pe.dispose()),se.set(Y.ILogService,Pe);const we=new M.FileService(Pe);se.set(S.IFileService,we);const pe=new A.DiskFileSystemProvider(Pe);we.registerProvider(P.Schemas.file,pe),se.set(Y.ILoggerService,new Q.LoggerService(Pe,we));const Ee=new a.ConfigurationService(de.settingsResource,we);se.set(i.IConfigurationService,Ee),se.set(ee.ILifecycleMainService,new F.SyncDescriptor(ee.LifecycleMainService));const De=new B.StateMainService(de,Pe,we);return se.set(N.IStateMainService,De),se.set(T.IRequestService,new F.SyncDescriptor(R.RequestMainService)),se.set(x.IThemeMainService,new F.SyncDescriptor(x.ThemeMainService)),se.set(O.ISignService,new F.SyncDescriptor(_.SignService)),se.set(U.ITunnelService,new F.SyncDescriptor(q.TunnelService)),se.set($.IProtocolMainService,new F.SyncDescriptor(j.ProtocolMainService)),[new C.InstantiationService(se,!0),ge,de,Ee,De,ve,le]}patchEnvironment(se){const le={VSCODE_IPC_HOOK:se.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(de=>{const ge=process.env[de];typeof ge=="string"&&(le[de]=ge)}),Object.assign(process.env,le),le}initServices(se,le,de){return D.Promises.settled([Promise.all([se.extensionsPath,se.codeCachePath,se.logsPath,se.globalStorageHome.fsPath,se.workspaceStorageHome.fsPath,se.backupHome].map(ge=>ge?v.Promises.mkdir(ge,{recursive:!0}):void 0)),le.initialize(),de.init()])}async claimInstance(se,le,de,ge,ve,Pe){let we;try{(0,p.mark)("code/willStartMainServer"),we=await(0,h.serve)(le.mainIPCHandle),(0,p.mark)("code/didStartMainServer"),(0,w.once)(de.onWillShutdown)(()=>we.dispose())}catch(pe){if(pe.code!=="EADDRINUSE")throw this.handleStartupDataDirError(le,ve.nameLong,pe),pe;let Ee;try{Ee=await(0,h.connect)(le.mainIPCHandle,"main")}catch(Ne){if(!Pe||d.isWindows||Ne.code!=="ECONNREFUSED")throw Ne.code==="EPERM"&&this.showStartupWarningDialog((0,c.localize)(0,null,ve.nameShort),(0,c.localize)(1,null),ve.nameLong),Ne;try{(0,L.unlinkSync)(le.mainIPCHandle)}catch(Ue){throw se.warn("Could not delete obsolete instance handle",Ue),Ue}return this.claimInstance(se,le,de,ge,ve,!1)}if(le.extensionTestsLocationURI&&!le.debugExtensionHost.break){const Ne="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw se.error(Ne),Ee.dispose(),new Error(Ne)}let De;!le.args.wait&&!le.args.status&&(De=setTimeout(()=>{this.showStartupWarningDialog((0,c.localize)(2,null,ve.nameShort),(0,c.localize)(3,null),ve.nameLong)},1e4));const Te=u.ProxyChannel.toService(Ee.getChannel("launch"),{disableMarshalling:!0});if(le.args.status)return ge.invokeFunction(async()=>{const Ne=new n.DiagnosticsService(H.NullTelemetryService,ve),Ue=await Te.getMainProcessInfo(),Ge=await Te.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Be=await Ne.getDiagnostics(Ue,Ge);throw console.log(Be),new r.ExpectedError});throw d.isWindows&&await this.windowsAllowSetForegroundWindow(Te,se),se.trace("Sending env to running instance..."),await Te.start(le.args,process.env),Ee.dispose(),De&&clearTimeout(De),new r.ExpectedError("Sent env to running instance. Terminating...")}if(le.args.status)throw se.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new r.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),we}handleStartupDataDirError(se,le,de){if(de.code==="EACCES"||de.code==="EPERM"){const ge=(0,k.coalesce)([se.userDataPath,se.extensionsPath,h.XDG_RUNTIME_DIR]).map(ve=>(0,t.getPathLabel)(ve,se));this.showStartupWarningDialog((0,c.localize)(4,null),(0,c.localize)(5,null,(0,E.toErrorMessage)(de),ge.join(`
`)),le)}}showStartupWarningDialog(se,le,de){y.dialog.showMessageBoxSync({title:de,type:"warning",buttons:[(0,t.mnemonicButtonLabel)((0,c.localize)(6,null))],message:se,detail:le,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(se,le){if(d.isWindows){const de=await se.getMainProcessId();le.trace("Sending some foreground love to the running instance:",de);try{(await new Promise((ge,ve)=>{K(["windows-foreground-love"],ge,ve)})).allowSetForegroundWindow(de)}catch(ge){le.error(ge)}}}quit(se,le){const de=se.get(Y.ILogService),ge=se.get(ee.ILifecycleMainService);let ve=0;le&&(le.isExpected?le.message&&de.trace(le.message):(ve=1,le.stack?de.error(le.stack):de.error(`Startup error: ${le.toString()}`))),ge.kill(ve)}resolveArgs(){const se=this.validatePaths((0,l.parseMainProcessArgv)(process.argv));if(se.wait&&!se.waitMarkerFilePath){const le=(0,m.createWaitMarkerFile)(se.verbose);le&&((0,l.addArg)(process.argv,"--waitMarkerFilePath",le),se.waitMarkerFilePath=le)}return se}validatePaths(se){if(se["open-url"]&&(se._urls=se._,se._=[]),!se.remote){const le=this.doValidatePaths(se._,se.goto);se._=le}return se}doValidatePaths(se,le){const de=(0,g.cwd)(),ge=se.map(we=>{let pe=String(we),Ee;le&&(Ee=(0,f.parseLineAndColumnAware)(pe),pe=Ee.path),pe&&(pe=this.preparePath(de,pe));const De=(0,f.sanitizeFilePath)(pe,de),Te=(0,b.basename)(De);return Te&&!(0,f.isValidBasename)(Te)?null:le&&Ee?(Ee.path=De,this.toPath(Ee)):De}),ve=d.isWindows||d.isMacintosh,Pe=(0,k.distinct)(ge,we=>we&&ve?we.toLowerCase():we||"");return(0,k.coalesce)(Pe)}preparePath(se,le){return d.isWindows&&(le=(0,I.rtrim)(le,'"')),le=(0,I.trim)((0,I.trim)(le," "),"	"),d.isWindows&&(le=(0,b.resolve)(se,le),le=(0,I.rtrim)(le,".")),le}toPath(se){const le=[se.path];return typeof se.line=="number"&&le.push(String(se.line)),typeof se.column=="number"&&le.push(String(se.column)),le.join(":")}}new ie().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/34861b8c8aa76b517f203743ad5b5d72ef5fcd81/core/vs/code/electron-main/main.js.map
