/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/base/common/path","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/uri","vs/base/common/network","vs/base/common/platform","vs/base/node/pfs","vs/base/common/errors","vs/base/common/types","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/strings","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/cancellation","vs/platform/registry/common/platform","vs/platform/configuration/common/configuration","vs/base/common/errorMessage","vs/base/common/process","vs/base/common/uuid","vs/platform/configuration/common/configurationRegistry","vs/base/common/extpath","os","child_process","vs/platform/product/common/product","vs/platform/telemetry/common/telemetry","vs/base/common/stream","fs","vs/base/parts/ipc/common/ipc","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/product/common/productService","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/base/node/zip","vs/base/common/decorators","vs/base/common/map","vs/base/node/decoder","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/download/common/download","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/platform/files/common/io","vs/base/common/assert","vs/base/common/json","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/labels","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/log/node/spdlogLog","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/telemetry/common/telemetryService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","vs/base/common/normalization","vs/platform/environment/node/argvHelper","crypto","vs/base/common/iterator","vs/base/common/performance","yauzl","yazl","zlib","vs/code/node/cliProcessMain","graceful-fs"],te=function($){for(var t=[],C=0,b=$.length;C<b;C++)t[C]=ee[$[C]];return t};define(ee[58],te([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function C(b,S){if(!b)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}t.ok=C}),define(ee[46],te([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function C(D){return(I,c,g)=>{let m=null,R=null;if(typeof g.value=="function"?(m="value",R=g.value):typeof g.get=="function"&&(m="get",R=g.get),!R)throw new Error("not supported");g[m]=D(R,c)}}t.createDecorator=C;function b(D,I,c){let g=null,m=null;if(typeof c.value=="function"?(g="value",m=c.value,m.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof c.get=="function"&&(g="get",m=c.get),!m)throw new Error("not supported");const R=`$memoize$${I}`;c[g]=function(...h){return this.hasOwnProperty(R)||Object.defineProperty(this,R,{configurable:!1,enumerable:!1,writable:!1,value:m.apply(this,h)}),this[R]}}t.memoize=b;function S(D,I,c){return C((g,m)=>{const R=`$debounce$${m}`,h=`$debounce$result$${m}`;return function(...v){this[h]||(this[h]=c?c():void 0),clearTimeout(this[R]),I&&(this[h]=I(this[h],...v),v=[this[h]]),this[R]=setTimeout(()=>{g.apply(this,v),this[h]=c?c():void 0},D)}})}t.debounce=S;function L(D,I,c){return C((g,m)=>{const R=`$throttle$timer$${m}`,h=`$throttle$result$${m}`,v=`$throttle$lastRun$${m}`,l=`$throttle$pending$${m}`;return function(...u){if(this[h]||(this[h]=c?c():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),I&&(this[h]=I(this[h],...u)),this[l])return;const y=this[v]+D;y<=Date.now()?(this[v]=Date.now(),g.apply(this,[this[h]]),this[h]=c?c():void 0):(this[l]=!0,this[R]=setTimeout(()=>{this[l]=!1,this[v]=Date.now(),g.apply(this,[this[h]]),this[h]=c?c():void 0},y-Date.now()))}})}t.throttle=L}),define(ee[59],te([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var C;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(C=t.ScanError||(t.ScanError={}));var b;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(b=t.SyntaxKind||(t.SyntaxKind={}));var S;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(S=t.ParseErrorCode||(t.ParseErrorCode={}));var L;(function(e){e.DEFAULT={allowTrailingComma:!0}})(L=t.ParseOptions||(t.ParseOptions={}));function D(e,n=!1){let i=0,r=e.length,a="",E=0,P=16,A=0;function w(Z){let K=0,J=0;for(;K<Z;){const Q=e.charCodeAt(i);if(Q>=48&&Q<=57)J=J*16+Q-48;else if(Q>=65&&Q<=70)J=J*16+Q-65+10;else if(Q>=97&&Q<=102)J=J*16+Q-97+10;else break;i++,K++}return K<Z&&(J=-1),J}function T(Z){i=Z,a="",E=0,P=16,A=0}function M(){const Z=i;if(e.charCodeAt(i)===48)i++;else for(i++;i<e.length&&g(e.charCodeAt(i));)i++;if(i<e.length&&e.charCodeAt(i)===46)if(i++,i<e.length&&g(e.charCodeAt(i)))for(i++;i<e.length&&g(e.charCodeAt(i));)i++;else return A=3,e.substring(Z,i);let K=i;if(i<e.length&&(e.charCodeAt(i)===69||e.charCodeAt(i)===101))if(i++,(i<e.length&&e.charCodeAt(i)===43||e.charCodeAt(i)===45)&&i++,i<e.length&&g(e.charCodeAt(i))){for(i++;i<e.length&&g(e.charCodeAt(i));)i++;K=i}else A=3;return e.substring(Z,K)}function j(){let Z="",K=i;for(;;){if(i>=r){Z+=e.substring(K,i),A=2;break}const J=e.charCodeAt(i);if(J===34){Z+=e.substring(K,i),i++;break}if(J===92){if(Z+=e.substring(K,i),i++,i>=r){A=2;break}switch(e.charCodeAt(i++)){case 34:Z+='"';break;case 92:Z+="\\";break;case 47:Z+="/";break;case 98:Z+="\b";break;case 102:Z+="\f";break;case 110:Z+=`
`;break;case 114:Z+="\r";break;case 116:Z+="	";break;case 117:const se=w(4);se>=0?Z+=String.fromCharCode(se):A=4;break;default:A=5}K=i;continue}if(J>=0&&J<=31)if(c(J)){Z+=e.substring(K,i),A=2;break}else A=6;i++}return Z}function Y(){if(a="",A=0,E=i,i>=r)return E=r,P=17;let Z=e.charCodeAt(i);if(I(Z)){do i++,a+=String.fromCharCode(Z),Z=e.charCodeAt(i);while(I(Z));return P=15}if(c(Z))return i++,a+=String.fromCharCode(Z),Z===13&&e.charCodeAt(i)===10&&(i++,a+=`
`),P=14;switch(Z){case 123:return i++,P=1;case 125:return i++,P=2;case 91:return i++,P=3;case 93:return i++,P=4;case 58:return i++,P=6;case 44:return i++,P=5;case 34:return i++,a=j(),P=10;case 47:const K=i-1;if(e.charCodeAt(i+1)===47){for(i+=2;i<r&&!c(e.charCodeAt(i));)i++;return a=e.substring(K,i),P=12}if(e.charCodeAt(i+1)===42){i+=2;const J=r-1;let Q=!1;for(;i<J;){if(e.charCodeAt(i)===42&&e.charCodeAt(i+1)===47){i+=2,Q=!0;break}i++}return Q||(i++,A=1),a=e.substring(K,i),P=13}return a+=String.fromCharCode(Z),i++,P=16;case 45:if(a+=String.fromCharCode(Z),i++,i===r||!g(e.charCodeAt(i)))return P=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=M(),P=11;default:for(;i<r&&ie(Z);)i++,Z=e.charCodeAt(i);if(E!==i){switch(a=e.substring(E,i),a){case"true":return P=8;case"false":return P=9;case"null":return P=7}return P=16}return a+=String.fromCharCode(Z),i++,P=16}}function ie(Z){if(I(Z)||c(Z))return!1;switch(Z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let Z;do Z=Y();while(Z>=12&&Z<=15);return Z}return{setPosition:T,getPosition:()=>i,scan:n?oe:Y,getToken:()=>P,getTokenValue:()=>a,getTokenOffset:()=>E,getTokenLength:()=>i-E,getTokenError:()=>A}}t.createScanner=D;function I(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function c(e){return e===10||e===13||e===8232||e===8233}function g(e){return e>=48&&e<=57}var m;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(m||(m={}));function R(e,n){const i=[],r=new Object;let a;const E={value:{},offset:0,length:0,type:"object",parent:void 0};let P=!1;function A(w,T,M,j){E.value=w,E.offset=T,E.length=M,E.type=j,E.colonOffset=void 0,a=E}try{d(e,{onObjectBegin:(w,T)=>{if(n<=w)throw r;a=void 0,P=n>w,i.push("")},onObjectProperty:(w,T,M)=>{if(n<T||(A(w,T,M,"property"),i[i.length-1]=w,n<=T+M))throw r},onObjectEnd:(w,T)=>{if(n<=w)throw r;a=void 0,i.pop()},onArrayBegin:(w,T)=>{if(n<=w)throw r;a=void 0,i.push(0)},onArrayEnd:(w,T)=>{if(n<=w)throw r;a=void 0,i.pop()},onLiteralValue:(w,T,M)=>{if(n<T||(A(w,T,M,s(w)),n<=T+M))throw r},onSeparator:(w,T,M)=>{if(n<=T)throw r;if(w===":"&&a&&a.type==="property")a.colonOffset=T,P=!1,a=void 0;else if(w===","){const j=i[i.length-1];typeof j=="number"?i[i.length-1]=j+1:(P=!0,i[i.length-1]=""),a=void 0}}})}catch(w){if(w!==r)throw w}return{path:i,previousNode:a,isAtPropertyKey:P,matches:w=>{let T=0;for(let M=0;T<w.length&&M<i.length;M++)if(w[T]===i[M]||w[T]==="*")T++;else if(w[T]!=="**")return!1;return T===w.length}}}t.getLocation=R;function h(e,n=[],i=L.DEFAULT){let r=null,a=[];const E=[];function P(w){Array.isArray(a)?a.push(w):r!==null&&(a[r]=w)}return d(e,{onObjectBegin:()=>{const w={};P(w),E.push(a),a=w,r=null},onObjectProperty:w=>{r=w},onObjectEnd:()=>{a=E.pop()},onArrayBegin:()=>{const w=[];P(w),E.push(a),a=w,r=null},onArrayEnd:()=>{a=E.pop()},onLiteralValue:P,onError:(w,T,M)=>{n.push({error:w,offset:T,length:M})}},i),a[0]}t.parse=h;function v(e,n=[],i=L.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(w){r.type==="property"&&(r.length=w-r.offset,r=r.parent)}function E(w){return r.children.push(w),w}d(e,{onObjectBegin:w=>{r=E({type:"object",offset:w,length:-1,parent:r,children:[]})},onObjectProperty:(w,T,M)=>{r=E({type:"property",offset:T,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:w,offset:T,length:M,parent:r})},onObjectEnd:(w,T)=>{r.length=w+T-r.offset,r=r.parent,a(w+T)},onArrayBegin:(w,T)=>{r=E({type:"array",offset:w,length:-1,parent:r,children:[]})},onArrayEnd:(w,T)=>{r.length=w+T-r.offset,r=r.parent,a(w+T)},onLiteralValue:(w,T,M)=>{E({type:s(w),offset:T,length:M,parent:r,value:w}),a(T+M)},onSeparator:(w,T,M)=>{r.type==="property"&&(w===":"?r.colonOffset=T:w===","&&a(T))},onError:(w,T,M)=>{n.push({error:w,offset:T,length:M})}},i);const A=r.children[0];return A&&delete A.parent,A}t.parseTree=v;function l(e,n){if(!e)return;let i=e;for(let r of n)if(typeof r=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let a=!1;for(const E of i.children)if(Array.isArray(E.children)&&E.children[0].value===r){i=E.children[1],a=!0;break}if(!a)return}else{const a=r;if(i.type!=="array"||a<0||!Array.isArray(i.children)||a>=i.children.length)return;i=i.children[a]}return i}t.findNodeAtLocation=l;function u(e){if(!e.parent||!e.parent.children)return[];const n=u(e.parent);if(e.parent.type==="property"){const i=e.parent.children[0].value;n.push(i)}else if(e.parent.type==="array"){const i=e.parent.children.indexOf(e);i!==-1&&n.push(i)}return n}t.getNodePath=u;function y(e){switch(e.type){case"array":return e.children.map(y);case"object":const n=Object.create(null);for(let i of e.children){const r=i.children[1];r&&(n[i.children[0].value]=y(r))}return n;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=y;function f(e,n,i=!1){return n>=e.offset&&n<e.offset+e.length||i&&n===e.offset+e.length}t.contains=f;function p(e,n,i=!1){if(f(e,n,i)){const r=e.children;if(Array.isArray(r))for(let a=0;a<r.length&&r[a].offset<=n;a++){const E=p(r[a],n,i);if(E)return E}return e}}t.findNodeAtOffset=p;function d(e,n,i=L.DEFAULT){const r=D(e,!1);function a(B){return B?()=>B(r.getTokenOffset(),r.getTokenLength()):()=>!0}function E(B){return B?k=>B(k,r.getTokenOffset(),r.getTokenLength()):()=>!0}const P=a(n.onObjectBegin),A=E(n.onObjectProperty),w=a(n.onObjectEnd),T=a(n.onArrayBegin),M=a(n.onArrayEnd),j=E(n.onLiteralValue),Y=E(n.onSeparator),ie=a(n.onComment),oe=E(n.onError),Z=i&&i.disallowComments,K=i&&i.allowTrailingComma;function J(){for(;;){const B=r.scan();switch(r.getTokenError()){case 4:Q(14);break;case 5:Q(15);break;case 3:Q(13);break;case 1:Z||Q(11);break;case 2:Q(12);break;case 6:Q(16);break}switch(B){case 12:case 13:Z?Q(10):ie();break;case 16:Q(1);break;case 15:case 14:break;default:return B}}}function Q(B,k=[],F=[]){if(oe(B),k.length+F.length>0){let U=r.getToken();for(;U!==17;){if(k.indexOf(U)!==-1){J();break}else if(F.indexOf(U)!==-1)break;U=J()}}}function se(B){const k=r.getTokenValue();return B?j(k):A(k),J(),!0}function W(){switch(r.getToken()){case 11:let B=0;try{B=JSON.parse(r.getTokenValue()),typeof B!="number"&&(Q(2),B=0)}catch(k){Q(2)}j(B);break;case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return J(),!0}function O(){return r.getToken()!==10?(Q(3,[],[2,5]),!1):(se(!1),r.getToken()===6?(Y(":"),J(),H()||Q(4,[],[2,5])):Q(5,[],[2,5]),!0)}function x(){P(),J();let B=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(B||Q(4,[],[]),Y(","),J(),r.getToken()===2&&K)break}else B&&Q(6,[],[]);O()||Q(4,[],[2,5]),B=!0}return w(),r.getToken()!==2?Q(7,[2],[]):J(),!0}function z(){T(),J();let B=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(B||Q(4,[],[]),Y(","),J(),r.getToken()===4&&K)break}else B&&Q(6,[],[]);H()||Q(4,[],[4,5]),B=!0}return M(),r.getToken()!==4?Q(8,[4],[]):J(),!0}function H(){switch(r.getToken()){case 3:return z();case 1:return x();case 10:return se(!0);default:return W()}}return J(),r.getToken()===17?i.allowEmptyContent?!0:(Q(4,[],[]),!1):H()?(r.getToken()!==17&&Q(9,[],[]),!0):(Q(4,[],[]),!1)}t.visit=d;function o(e,n){let i=D(e),r=[],a,E=0,P;do switch(P=i.getPosition(),a=i.scan(),a){case 12:case 13:case 17:E!==P&&r.push(e.substring(E,P)),n!==void 0&&r.push(i.getTokenValue().replace(/[^\r\n]/g,n)),E=i.getPosition();break}while(a!==17);return r.join("")}t.stripComments=o;function s(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=s}),function(){function $(S){const L=[];typeof S=="number"&&L.push("code/timeOrigin",S);function D(c){L.push(c,Date.now())}function I(){const c=[];for(let g=0;g<L.length;g+=2)c.push({name:L[g],startTime:L[g+1]});return c}return{mark:D,getMarks:I}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?$():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const D of performance.getEntriesByType("mark"))L.push({name:D.name,startTime:Math.round(S+D.startTime)});return L}};if(typeof process=="object"){const S=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return $(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),$()}function C(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=t()),S.MonacoPerformanceMarks}var b;typeof global=="object"?b=global:typeof self=="object"?b=self:b={},typeof define=="function"?define("vs/base/common/performance",[],function(){return C(b)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=C(b):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),b.perf=C(b))}(),function($,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var C=t();for(var b in C)(typeof exports=="object"?exports:$)[b]=C[b]}}(typeof self!="undefined"?self:this,function(){return function($){var t={};function C(b){if(t[b])return t[b].exports;var S=t[b]={i:b,l:!1,exports:{}};return $[b].call(S.exports,S,S.exports,C),S.l=!0,S.exports}return C.m=$,C.c=t,C.d=function(b,S,L){C.o(b,S)||Object.defineProperty(b,S,{enumerable:!0,get:L})},C.r=function(b){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(b,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(b,"__esModule",{value:!0})},C.t=function(b,S){if(1&S&&(b=C(b)),8&S||4&S&&typeof b=="object"&&b&&b.__esModule)return b;var L=Object.create(null);if(C.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:b}),2&S&&typeof b!="string")for(var D in b)C.d(L,D,function(I){return b[I]}.bind(null,D));return L},C.n=function(b){var S=b&&b.__esModule?function(){return b.default}:function(){return b};return C.d(S,"a",S),S},C.o=function(b,S){return Object.prototype.hasOwnProperty.call(b,S)},C.p="",C(C.s=0)}([function($,t,C){(function(b){var S;t=$.exports=F,S=typeof b=="object"&&b.env&&b.env.NODE_DEBUG&&/\bsemver\b/i.test(b.env.NODE_DEBUG)?function(){var N=Array.prototype.slice.call(arguments,0);N.unshift("SEMVER"),console.log.apply(console,N)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var L=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,I=t.re=[],c=t.src=[],g=0,m=g++;c[m]="0|[1-9]\\d*";var R=g++;c[R]="[0-9]+";var h=g++;c[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=g++;c[v]="("+c[m]+")\\.("+c[m]+")\\.("+c[m]+")";var l=g++;c[l]="("+c[R]+")\\.("+c[R]+")\\.("+c[R]+")";var u=g++;c[u]="(?:"+c[m]+"|"+c[h]+")";var y=g++;c[y]="(?:"+c[R]+"|"+c[h]+")";var f=g++;c[f]="(?:-("+c[u]+"(?:\\."+c[u]+")*))";var p=g++;c[p]="(?:-?("+c[y]+"(?:\\."+c[y]+")*))";var d=g++;c[d]="[0-9A-Za-z-]+";var o=g++;c[o]="(?:\\+("+c[d]+"(?:\\."+c[d]+")*))";var s=g++,e="v?"+c[v]+c[f]+"?"+c[o]+"?";c[s]="^"+e+"$";var n="[v=\\s]*"+c[l]+c[p]+"?"+c[o]+"?",i=g++;c[i]="^"+n+"$";var r=g++;c[r]="((?:<|>)?=?)";var a=g++;c[a]=c[R]+"|x|X|\\*";var E=g++;c[E]=c[m]+"|x|X|\\*";var P=g++;c[P]="[v=\\s]*("+c[E]+")(?:\\.("+c[E]+")(?:\\.("+c[E]+")(?:"+c[f]+")?"+c[o]+"?)?)?";var A=g++;c[A]="[v=\\s]*("+c[a]+")(?:\\.("+c[a]+")(?:\\.("+c[a]+")(?:"+c[p]+")?"+c[o]+"?)?)?";var w=g++;c[w]="^"+c[r]+"\\s*"+c[P]+"$";var T=g++;c[T]="^"+c[r]+"\\s*"+c[A]+"$";var M=g++;c[M]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=g++;c[j]="(?:~>?)";var Y=g++;c[Y]="(\\s*)"+c[j]+"\\s+",I[Y]=new RegExp(c[Y],"g");var ie=g++;c[ie]="^"+c[j]+c[P]+"$";var oe=g++;c[oe]="^"+c[j]+c[A]+"$";var Z=g++;c[Z]="(?:\\^)";var K=g++;c[K]="(\\s*)"+c[Z]+"\\s+",I[K]=new RegExp(c[K],"g");var J=g++;c[J]="^"+c[Z]+c[P]+"$";var Q=g++;c[Q]="^"+c[Z]+c[A]+"$";var se=g++;c[se]="^"+c[r]+"\\s*("+n+")$|^$";var W=g++;c[W]="^"+c[r]+"\\s*("+e+")$|^$";var O=g++;c[O]="(\\s*)"+c[r]+"\\s*("+n+"|"+c[P]+")",I[O]=new RegExp(c[O],"g");var x=g++;c[x]="^\\s*("+c[P]+")\\s+-\\s+("+c[P]+")\\s*$";var z=g++;c[z]="^\\s*("+c[A]+")\\s+-\\s+("+c[A]+")\\s*$";var H=g++;c[H]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)S(B,c[B]),I[B]||(I[B]=new RegExp(c[B]));function k(N,_){if(N instanceof F)return N;if(typeof N!="string"||N.length>L||!(_?I[i]:I[s]).test(N))return null;try{return new F(N,_)}catch(G){return null}}function F(N,_){if(N instanceof F){if(N.loose===_)return N;N=N.version}else if(typeof N!="string")throw new TypeError("Invalid Version: "+N);if(N.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof F))return new F(N,_);S("SemVer",N,_),this.loose=_;var G=N.trim().match(_?I[i]:I[s]);if(!G)throw new TypeError("Invalid Version: "+N);if(this.raw=N,this.major=+G[1],this.minor=+G[2],this.patch=+G[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");G[4]?this.prerelease=G[4].split(".").map(function(ae){if(/^[0-9]+$/.test(ae)){var le=+ae;if(le>=0&&le<D)return le}return ae}):this.prerelease=[],this.build=G[5]?G[5].split("."):[],this.format()}t.parse=k,t.valid=function(N,_){var G=k(N,_);return G?G.version:null},t.clean=function(N,_){var G=k(N.trim().replace(/^[=v]+/,""),_);return G?G.version:null},t.SemVer=F,F.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},F.prototype.toString=function(){return this.version},F.prototype.compare=function(N){return S("SemVer.compare",this.version,this.loose,N),N instanceof F||(N=new F(N,this.loose)),this.compareMain(N)||this.comparePre(N)},F.prototype.compareMain=function(N){return N instanceof F||(N=new F(N,this.loose)),V(this.major,N.major)||V(this.minor,N.minor)||V(this.patch,N.patch)},F.prototype.comparePre=function(N){if(N instanceof F||(N=new F(N,this.loose)),this.prerelease.length&&!N.prerelease.length)return-1;if(!this.prerelease.length&&N.prerelease.length)return 1;if(!this.prerelease.length&&!N.prerelease.length)return 0;var _=0;do{var G=this.prerelease[_],ae=N.prerelease[_];if(S("prerelease compare",_,G,ae),G===void 0&&ae===void 0)return 0;if(ae===void 0)return 1;if(G===void 0)return-1;if(G!==ae)return V(G,ae)}while(++_)},F.prototype.inc=function(N,_){switch(N){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",_);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",_);break;case"prepatch":this.prerelease.length=0,this.inc("patch",_),this.inc("pre",_);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",_),this.inc("pre",_);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var G=this.prerelease.length;--G>=0;)typeof this.prerelease[G]=="number"&&(this.prerelease[G]++,G=-2);G===-1&&this.prerelease.push(0)}_&&(this.prerelease[0]===_?isNaN(this.prerelease[1])&&(this.prerelease=[_,0]):this.prerelease=[_,0]);break;default:throw new Error("invalid increment argument: "+N)}return this.format(),this.raw=this.version,this},t.inc=function(N,_,G,ae){typeof G=="string"&&(ae=G,G=void 0);try{return new F(N,G).inc(_,ae).version}catch(le){return null}},t.diff=function(N,_){if(ne(N,_))return null;var G=k(N),ae=k(_);if(G.prerelease.length||ae.prerelease.length){for(var le in G)if((le==="major"||le==="minor"||le==="patch")&&G[le]!==ae[le])return"pre"+le;return"prerelease"}for(var le in G)if((le==="major"||le==="minor"||le==="patch")&&G[le]!==ae[le])return le},t.compareIdentifiers=V;var U=/^[0-9]+$/;function V(N,_){var G=U.test(N),ae=U.test(_);return G&&ae&&(N=+N,_=+_),G&&!ae?-1:ae&&!G?1:N<_?-1:N>_?1:0}function q(N,_,G){return new F(N,G).compare(new F(_,G))}function X(N,_,G){return q(N,_,G)>0}function re(N,_,G){return q(N,_,G)<0}function ne(N,_,G){return q(N,_,G)===0}function de(N,_,G){return q(N,_,G)!==0}function ge(N,_,G){return q(N,_,G)>=0}function he(N,_,G){return q(N,_,G)<=0}function Ee(N,_,G,ae){var le;switch(_){case"===":typeof N=="object"&&(N=N.version),typeof G=="object"&&(G=G.version),le=N===G;break;case"!==":typeof N=="object"&&(N=N.version),typeof G=="object"&&(G=G.version),le=N!==G;break;case"":case"=":case"==":le=ne(N,G,ae);break;case"!=":le=de(N,G,ae);break;case">":le=X(N,G,ae);break;case">=":le=ge(N,G,ae);break;case"<":le=re(N,G,ae);break;case"<=":le=he(N,G,ae);break;default:throw new TypeError("Invalid operator: "+_)}return le}function ye(N,_){if(N instanceof ye){if(N.loose===_)return N;N=N.value}if(!(this instanceof ye))return new ye(N,_);S("comparator",N,_),this.loose=_,this.parse(N),this.semver===Re?this.value="":this.value=this.operator+this.semver.version,S("comp",this)}t.rcompareIdentifiers=function(N,_){return V(_,N)},t.major=function(N,_){return new F(N,_).major},t.minor=function(N,_){return new F(N,_).minor},t.patch=function(N,_){return new F(N,_).patch},t.compare=q,t.compareLoose=function(N,_){return q(N,_,!0)},t.rcompare=function(N,_,G){return q(_,N,G)},t.sort=function(N,_){return N.sort(function(G,ae){return t.compare(G,ae,_)})},t.rsort=function(N,_){return N.sort(function(G,ae){return t.rcompare(G,ae,_)})},t.gt=X,t.lt=re,t.eq=ne,t.neq=de,t.gte=ge,t.lte=he,t.cmp=Ee,t.Comparator=ye;var Re={};function pe(N,_){if(N instanceof pe)return N.loose===_?N:new pe(N.raw,_);if(N instanceof ye)return new pe(N.value,_);if(!(this instanceof pe))return new pe(N,_);if(this.loose=_,this.raw=N,this.set=N.split(/\s*\|\|\s*/).map(function(G){return this.parseRange(G.trim())},this).filter(function(G){return G.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+N);this.format()}function be(N){return!N||N.toLowerCase()==="x"||N==="*"}function ze(N,_,G,ae,le,De,ve,Oe,Pe,Te,ke,Ie,Le){return((_=be(G)?"":be(ae)?">="+G+".0.0":be(le)?">="+G+"."+ae+".0":">="+_)+" "+(Oe=be(Pe)?"":be(Te)?"<"+(+Pe+1)+".0.0":be(ke)?"<"+Pe+"."+(+Te+1)+".0":Ie?"<="+Pe+"."+Te+"."+ke+"-"+Ie:"<="+Oe)).trim()}function Ve(N,_){for(var G=0;G<N.length;G++)if(!N[G].test(_))return!1;if(_.prerelease.length){for(G=0;G<N.length;G++)if(S(N[G].semver),N[G].semver!==Re&&N[G].semver.prerelease.length>0){var ae=N[G].semver;if(ae.major===_.major&&ae.minor===_.minor&&ae.patch===_.patch)return!0}return!1}return!0}function xe(N,_,G){try{_=new pe(_,G)}catch(ae){return!1}return _.test(N)}function je(N,_,G,ae){var le,De,ve,Oe,Pe;switch(N=new F(N,ae),_=new pe(_,ae),G){case">":le=X,De=he,ve=re,Oe=">",Pe=">=";break;case"<":le=re,De=ge,ve=X,Oe="<",Pe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(xe(N,_,ae))return!1;for(var Te=0;Te<_.set.length;++Te){var ke=_.set[Te],Ie=null,Le=null;if(ke.forEach(function(Fe){Fe.semver===Re&&(Fe=new ye(">=0.0.0")),Ie=Ie||Fe,Le=Le||Fe,le(Fe.semver,Ie.semver,ae)?Ie=Fe:ve(Fe.semver,Le.semver,ae)&&(Le=Fe)}),Ie.operator===Oe||Ie.operator===Pe||(!Le.operator||Le.operator===Oe)&&De(N,Le.semver)||Le.operator===Pe&&ve(N,Le.semver))return!1}return!0}ye.prototype.parse=function(N){var _=this.loose?I[se]:I[W],G=N.match(_);if(!G)throw new TypeError("Invalid comparator: "+N);this.operator=G[1],this.operator==="="&&(this.operator=""),G[2]?this.semver=new F(G[2],this.loose):this.semver=Re},ye.prototype.toString=function(){return this.value},ye.prototype.test=function(N){return S("Comparator.test",N,this.loose),this.semver===Re||(typeof N=="string"&&(N=new F(N,this.loose)),Ee(N,this.operator,this.semver,this.loose))},ye.prototype.intersects=function(N,_){if(!(N instanceof ye))throw new TypeError("a Comparator is required");var G;if(this.operator==="")return G=new pe(N.value,_),xe(this.value,G,_);if(N.operator==="")return G=new pe(this.value,_),xe(N.semver,G,_);var ae=!(this.operator!==">="&&this.operator!==">"||N.operator!==">="&&N.operator!==">"),le=!(this.operator!=="<="&&this.operator!=="<"||N.operator!=="<="&&N.operator!=="<"),De=this.semver.version===N.semver.version,ve=!(this.operator!==">="&&this.operator!=="<="||N.operator!==">="&&N.operator!=="<="),Oe=Ee(this.semver,"<",N.semver,_)&&(this.operator===">="||this.operator===">")&&(N.operator==="<="||N.operator==="<"),Pe=Ee(this.semver,">",N.semver,_)&&(this.operator==="<="||this.operator==="<")&&(N.operator===">="||N.operator===">");return ae||le||De&&ve||Oe||Pe},t.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(N){return N.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(N){var _=this.loose;N=N.trim(),S("range",N,_);var G=_?I[z]:I[x];N=N.replace(G,ze),S("hyphen replace",N),N=N.replace(I[O],"$1$2$3"),S("comparator trim",N,I[O]),N=(N=(N=N.replace(I[Y],"$1~")).replace(I[K],"$1^")).split(/\s+/).join(" ");var ae=_?I[se]:I[W],le=N.split(" ").map(function(De){return function(ve,Oe){return S("comp",ve),ve=function(Pe,Te){return Pe.trim().split(/\s+/).map(function(ke){return function(Ie,Le){S("caret",Ie,Le);var Fe=Le?I[Q]:I[J];return Ie.replace(Fe,function(Ae,ce,me,we,Se){var Ce;return S("caret",Ie,Ae,ce,me,we,Se),be(ce)?Ce="":be(me)?Ce=">="+ce+".0.0 <"+(+ce+1)+".0.0":be(we)?Ce=ce==="0"?">="+ce+"."+me+".0 <"+ce+"."+(+me+1)+".0":">="+ce+"."+me+".0 <"+(+ce+1)+".0.0":Se?(S("replaceCaret pr",Se),Se.charAt(0)!=="-"&&(Se="-"+Se),Ce=ce==="0"?me==="0"?">="+ce+"."+me+"."+we+Se+" <"+ce+"."+me+"."+(+we+1):">="+ce+"."+me+"."+we+Se+" <"+ce+"."+(+me+1)+".0":">="+ce+"."+me+"."+we+Se+" <"+(+ce+1)+".0.0"):(S("no pr"),Ce=ce==="0"?me==="0"?">="+ce+"."+me+"."+we+" <"+ce+"."+me+"."+(+we+1):">="+ce+"."+me+"."+we+" <"+ce+"."+(+me+1)+".0":">="+ce+"."+me+"."+we+" <"+(+ce+1)+".0.0"),S("caret return",Ce),Ce})}(ke,Te)}).join(" ")}(ve,Oe),S("caret",ve),ve=function(Pe,Te){return Pe.trim().split(/\s+/).map(function(ke){return function(Ie,Le){var Fe=Le?I[oe]:I[ie];return Ie.replace(Fe,function(Ae,ce,me,we,Se){var Ce;return S("tilde",Ie,Ae,ce,me,we,Se),be(ce)?Ce="":be(me)?Ce=">="+ce+".0.0 <"+(+ce+1)+".0.0":be(we)?Ce=">="+ce+"."+me+".0 <"+ce+"."+(+me+1)+".0":Se?(S("replaceTilde pr",Se),Se.charAt(0)!=="-"&&(Se="-"+Se),Ce=">="+ce+"."+me+"."+we+Se+" <"+ce+"."+(+me+1)+".0"):Ce=">="+ce+"."+me+"."+we+" <"+ce+"."+(+me+1)+".0",S("tilde return",Ce),Ce})}(ke,Te)}).join(" ")}(ve,Oe),S("tildes",ve),ve=function(Pe,Te){return S("replaceXRanges",Pe,Te),Pe.split(/\s+/).map(function(ke){return function(Ie,Le){Ie=Ie.trim();var Fe=Le?I[T]:I[w];return Ie.replace(Fe,function(Ae,ce,me,we,Se,Ce){S("xRange",Ie,Ae,ce,me,we,Se,Ce);var We=be(me),Me=We||be(we),Ue=Me||be(Se);return ce==="="&&Ue&&(ce=""),We?Ae=ce===">"||ce==="<"?"<0.0.0":"*":ce&&Ue?(Me&&(we=0),Ue&&(Se=0),ce===">"?(ce=">=",Me?(me=+me+1,we=0,Se=0):Ue&&(we=+we+1,Se=0)):ce==="<="&&(ce="<",Me?me=+me+1:we=+we+1),Ae=ce+me+"."+we+"."+Se):Me?Ae=">="+me+".0.0 <"+(+me+1)+".0.0":Ue&&(Ae=">="+me+"."+we+".0 <"+me+"."+(+we+1)+".0"),S("xRange return",Ae),Ae})}(ke,Te)}).join(" ")}(ve,Oe),S("xrange",ve),ve=function(Pe,Te){return S("replaceStars",Pe,Te),Pe.trim().replace(I[H],"")}(ve,Oe),S("stars",ve),ve}(De,_)}).join(" ").split(/\s+/);return this.loose&&(le=le.filter(function(De){return!!De.match(ae)})),le=le.map(function(De){return new ye(De,_)})},pe.prototype.intersects=function(N,_){if(!(N instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(G){return G.every(function(ae){return N.set.some(function(le){return le.every(function(De){return ae.intersects(De,_)})})})})},t.toComparators=function(N,_){return new pe(N,_).set.map(function(G){return G.map(function(ae){return ae.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(N){if(!N)return!1;typeof N=="string"&&(N=new F(N,this.loose));for(var _=0;_<this.set.length;_++)if(Ve(this.set[_],N))return!0;return!1},t.satisfies=xe,t.maxSatisfying=function(N,_,G){var ae=null,le=null;try{var De=new pe(_,G)}catch(ve){return null}return N.forEach(function(ve){De.test(ve)&&(ae&&le.compare(ve)!==-1||(le=new F(ae=ve,G)))}),ae},t.minSatisfying=function(N,_,G){var ae=null,le=null;try{var De=new pe(_,G)}catch(ve){return null}return N.forEach(function(ve){De.test(ve)&&(ae&&le.compare(ve)!==1||(le=new F(ae=ve,G)))}),ae},t.validRange=function(N,_){try{return new pe(N,_).range||"*"}catch(G){return null}},t.ltr=function(N,_,G){return je(N,_,"<",G)},t.gtr=function(N,_,G){return je(N,_,">",G)},t.outside=je,t.prerelease=function(N,_){var G=k(N,_);return G&&G.prerelease.length?G.prerelease:null},t.intersects=function(N,_,G){return N=new pe(N,G),_=new pe(_,G),N.intersects(_)},t.coerce=function(N){if(N instanceof F)return N;if(typeof N!="string")return null;var _=N.match(I[M]);return _==null?null:k((_[1]||"0")+"."+(_[2]||"0")+"."+(_[3]||"0"))}}).call(this,C(1))},function($,t){var C,b,S=$.exports={};function L(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function I(y){if(C===setTimeout)return setTimeout(y,0);if((C===L||!C)&&setTimeout)return C=setTimeout,setTimeout(y,0);try{return C(y,0)}catch(f){try{return C.call(null,y,0)}catch(p){return C.call(this,y,0)}}}(function(){try{C=typeof setTimeout=="function"?setTimeout:L}catch(y){C=L}try{b=typeof clearTimeout=="function"?clearTimeout:D}catch(y){b=D}})();var c,g=[],m=!1,R=-1;function h(){m&&c&&(m=!1,c.length?g=c.concat(g):R=-1,g.length&&v())}function v(){if(!m){var y=I(h);m=!0;for(var f=g.length;f;){for(c=g,g=[];++R<f;)c&&c[R].run();R=-1,f=g.length}c=null,m=!1,function(p){if(b===clearTimeout)return clearTimeout(p);if((b===D||!b)&&clearTimeout)return b=clearTimeout,clearTimeout(p);try{b(p)}catch(d){try{return b.call(null,p)}catch(o){return b.call(this,p)}}}(y)}}function l(y,f){this.fun=y,this.array=f}function u(){}S.nextTick=function(y){var f=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)f[p-1]=arguments[p];g.push(new l(y,f)),g.length!==1||m||I(v)},l.prototype.run=function(){this.fun.apply(null,this.array)},S.title="browser",S.browser=!0,S.env={},S.argv=[],S.version="",S.versions={},S.on=u,S.addListener=u,S.once=u,S.off=u,S.removeListener=u,S.removeAllListeners=u,S.emit=u,S.prependListener=u,S.prependOnceListener=u,S.listeners=function(y){return[]},S.binding=function(y){throw new Error("process.binding is not supported")},S.cwd=function(){return"/"},S.chdir=function(y){throw new Error("process.chdir is not supported")},S.umask=function(){return 0}}])}),define(ee[37],te([0,1,11,2]),function($,t,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function S(d){const o=d;return o?[o.on,o.pause,o.resume,o.destroy].every(s=>typeof s=="function"):!1}t.isReadableStream=S;function L(d){const o=d;return o?S(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}t.isReadableBufferedStream=L;function D(d,o){return new I(d,o)}t.newWriteableStream=D;class I{constructor(o,s){this.reducer=o,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(s=>this.pendingWritePromises.push(s))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(s=>s(o))}emitError(o){this.listeners.error.length===0?(0,C.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(s=>s(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,s){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(o,s){if(this.state.destroyed)return;let e;switch(o){case"data":e=this.listeners.data;break;case"end":e=this.listeners.end;break;case"error":e=this.listeners.error;break}if(e){const n=e.indexOf(s);n>=0&&e.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function c(d,o){const s=[];let e;for(;(e=d.read())!==null;)s.push(e);return o(s)}t.consumeReadable=c;function g(d,o,s){const e=[];let n;for(;(n=d.read())!==null&&e.length<s;)e.push(n);return n===null&&e.length>0?o(e):{read:()=>{if(e.length>0)return e.shift();if(typeof n!="undefined"){const i=n;return n=void 0,i}return d.read()}}}t.peekReadable=g;function m(d,o){return new Promise((s,e)=>{const n=[];R(d,{onData:i=>{o&&n.push(i)},onError:i=>{o?e(i):s(void 0)},onEnd:()=>{s(o?o(n):void 0)}})})}t.consumeStream=m;function R(d,o){d.on("error",s=>o.onError(s)),d.on("end",()=>o.onEnd()),d.on("data",s=>o.onData(s))}t.listenStream=R;function h(d,o){return new Promise((s,e)=>{const n=new b.DisposableStore,i=[],r=P=>{if(i.push(P),i.length>o)return n.dispose(),d.pause(),s({stream:d,buffer:i,ended:!1})},a=P=>e(P),E=()=>s({stream:d,buffer:i,ended:!0});n.add((0,b.toDisposable)(()=>d.removeListener("error",a))),d.on("error",a),n.add((0,b.toDisposable)(()=>d.removeListener("end",E))),d.on("end",E),n.add((0,b.toDisposable)(()=>d.removeListener("data",r))),d.on("data",r)})}t.peekStream=h;function v(d,o){const s=D(o);return s.end(d),s}t.toStream=v;function l(){const d=D(()=>{throw new Error("not supported")});return d.end(),d}t.emptyStream=l;function u(d){let o=!1;return{read:()=>o?null:(o=!0,d)}}t.toReadable=u;function y(d,o,s){const e=D(s);return R(d,{onData:n=>e.write(o.data(n)),onError:n=>e.error(o.error?o.error(n):n),onEnd:()=>e.end()}),e}t.transform=y;function f(d,o,s){let e=!1;return{read:()=>{const n=o.read();return e?n:(e=!0,n!==null?s([d,n]):d)}}}t.prefixedReadable=f;function p(d,o,s){let e=!1;const n=D(s);return R(o,{onData:i=>e?n.write(i):(e=!0,n.write(s([d,i]))),onError:i=>n.error(i),onEnd:()=>{e||(e=!0,n.write(d)),n.end()}}),n}t.prefixedStream=p}),define(ee[17],te([0,1,37]),function($,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const b=typeof Buffer!="undefined";let S,L;class D{constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}static alloc(r){return b?new D(Buffer.allocUnsafe(r)):new D(new Uint8Array(r))}static wrap(r){return b&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new D(r)}static fromString(r,a){return!(a?.dontUseNodeBuffer||!1)&&b?new D(Buffer.from(r)):(S||(S=new TextEncoder),new D(S.encode(r)))}static concat(r,a){if(typeof a=="undefined"){a=0;for(let A=0,w=r.length;A<w;A++)a+=r[A].byteLength}const E=D.alloc(a);let P=0;for(let A=0,w=r.length;A<w;A++){const T=r[A];E.set(T,P),P+=T.byteLength}return E}toString(){return b?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(r,a){return new D(this.buffer.subarray(r,a))}set(r,a){r instanceof D?this.buffer.set(r.buffer,a):this.buffer.set(r,a)}readUInt32BE(r){return g(this.buffer,r)}writeUInt32BE(r,a){m(this.buffer,r,a)}readUInt32LE(r){return R(this.buffer,r)}writeUInt32LE(r,a){h(this.buffer,r,a)}readUInt8(r){return v(this.buffer,r)}writeUInt8(r,a){l(this.buffer,r,a)}}t.VSBuffer=D;function I(i,r){return i[r+0]<<0>>>0|i[r+1]<<8>>>0}t.readUInt16LE=I;function c(i,r,a){i[a+0]=r&255,r=r>>>8,i[a+1]=r&255}t.writeUInt16LE=c;function g(i,r){return i[r]*2**24+i[r+1]*2**16+i[r+2]*2**8+i[r+3]}t.readUInt32BE=g;function m(i,r,a){i[a+3]=r,r=r>>>8,i[a+2]=r,r=r>>>8,i[a+1]=r,r=r>>>8,i[a]=r}t.writeUInt32BE=m;function R(i,r){return i[r+0]<<0>>>0|i[r+1]<<8>>>0|i[r+2]<<16>>>0|i[r+3]<<24>>>0}t.readUInt32LE=R;function h(i,r,a){i[a+0]=r&255,r=r>>>8,i[a+1]=r&255,r=r>>>8,i[a+2]=r&255,r=r>>>8,i[a+3]=r&255}t.writeUInt32LE=h;function v(i,r){return i[r]}t.readUInt8=v;function l(i,r,a){i[a]=r}t.writeUInt8=l;function u(i){return C.consumeReadable(i,r=>D.concat(r))}t.readableToBuffer=u;function y(i){return C.toReadable(i)}t.bufferToReadable=y;function f(i){return C.consumeStream(i,r=>D.concat(r))}t.streamToBuffer=f;async function p(i){return i.ended?D.concat(i.buffer):D.concat([...i.buffer,await f(i.stream)])}t.bufferedStreamToBuffer=p;function d(i){return C.toStream(i,r=>D.concat(r))}t.bufferToStream=d;function o(i){return C.transform(i,{data:r=>typeof r=="string"?D.fromString(r):D.wrap(r)},r=>D.concat(r))}t.streamToBufferReadableStream=o;function s(i){return C.newWriteableStream(r=>D.concat(r),i)}t.newWriteableBufferStream=s;function e(i,r){return C.prefixedReadable(i,r,a=>D.concat(a))}t.prefixedBufferReadable=e;function n(i,r){return C.prefixedStream(i,r,a=>D.concat(a))}t.prefixedBufferStream=n}),define(ee[18],te([0,1,12]),function($,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function b(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const y=Array.isArray(u)?[]:{};return Object.keys(u).forEach(f=>{u[f]&&typeof u[f]=="object"?y[f]=b(u[f]):y[f]=u[f]}),y}t.deepClone=b;function S(u){if(!u||typeof u!="object")return u;const y=[u];for(;y.length>0;){const f=y.shift();Object.freeze(f);for(const p in f)if(L.call(f,p)){const d=f[p];typeof d=="object"&&!Object.isFrozen(d)&&y.push(d)}}return u}t.deepFreeze=S;const L=Object.prototype.hasOwnProperty;function D(u,y){return I(u,y,new Set)}t.cloneAndChange=D;function I(u,y,f){if((0,C.isUndefinedOrNull)(u))return u;const p=y(u);if(typeof p!="undefined")return p;if((0,C.isArray)(u)){const d=[];for(const o of u)d.push(I(o,y,f));return d}if((0,C.isObject)(u)){if(f.has(u))throw new Error("Cannot clone recursive data-structure");f.add(u);const d={};for(let o in u)L.call(u,o)&&(d[o]=I(u[o],y,f));return f.delete(u),d}return u}function c(u,y,f=!0){return(0,C.isObject)(u)?((0,C.isObject)(y)&&Object.keys(y).forEach(p=>{p in u?f&&((0,C.isObject)(u[p])&&(0,C.isObject)(y[p])?c(u[p],y[p],f):u[p]=y[p]):u[p]=y[p]}),u):y}t.mixin=c;function g(u,y){if(u===y)return!0;if(u==null||y===null||y===void 0||typeof u!=typeof y||typeof u!="object"||Array.isArray(u)!==Array.isArray(y))return!1;let f,p;if(Array.isArray(u)){if(u.length!==y.length)return!1;for(f=0;f<u.length;f++)if(!g(u[f],y[f]))return!1}else{const d=[];for(p in u)d.push(p);d.sort();const o=[];for(p in y)o.push(p);if(o.sort(),!g(d,o))return!1;for(f=0;f<d.length;f++)if(!g(u[d[f]],y[d[f]]))return!1}return!0}t.equals=g;function m(u){const y=new Set;return JSON.stringify(u,(f,p)=>{if((0,C.isObject)(p)||Array.isArray(p)){if(y.has(p))return"[Circular]";y.add(p)}return p})}t.safeStringify=m;function R(u,y,f){const p=y(u);return typeof p=="undefined"?f:p}t.getOrDefault=R;function h(u,y){const f=Object.create(null);return!u||!y||Object.keys(y).forEach(d=>{const o=u[d],s=y[d];g(o,s)||(f[d]=s)}),f}t.distinct=h;function v(u,y){const f=y.toLowerCase(),p=Object.keys(u).find(d=>d.toLowerCase()===f);return p?u[p]:u[y]}t.getCaseInsensitive=v;function l(u,y){const f=Object.create(null);for(const p of Object.keys(u))y(p,u[p])&&(f[p]=u[p]);return f}t.filter=l}),define(ee[60],te([0,1,7]),function($,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function b(g){const m=g;return m&&typeof m.type=="string"&&typeof m.severity=="string"}t.isRemoteConsoleLog=b;function S(g){const m=[];let R;try{const h=JSON.parse(g.arguments),v=h[h.length-1];v&&v.__$stack&&(h.pop(),R=v.__$stack),m.push(...h)}catch(h){m.push("Unable to log remote console arguments",g.arguments)}return{args:m,stack:R}}t.parse=S;function L(g){if(typeof g!="string")return L(S(g).stack);const m=g;if(m){const R=D(m),h=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(R||"");if(h&&h.length===4)return{uri:C.URI.file(h[1]),line:Number(h[2]),column:Number(h[3])}}}t.getFirstFrame=L;function D(g){if(!g)return g;const m=g.indexOf(`
`);return m===-1?g:g.substring(0,m)}function I(g,m){const{args:R,stack:h}=S(g),v=typeof R[0]=="string"&&R.length===1;let l=D(h);l&&(l=`(${l.trim()})`);let u=[];if(typeof R[0]=="string"?l&&v?u=[`%c[${m}] %c${R[0]} %c${l}`,c("blue"),c(""),c("grey")]:u=[`%c[${m}] %c${R[0]}`,c("blue"),c(""),...R.slice(1)]:u=[`%c[${m}]%`,c("blue"),...R],l&&!v&&u.push(l),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,u)}t.log=I;function c(g){return`color: ${g}`}}),define(ee[61],te([0,1,17,21,7]),function($,t,C,b,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.MarshalledId=t.parse=t.stringify=void 0;function L(m){return JSON.stringify(m,c)}t.stringify=L;function D(m){let R=JSON.parse(m);return R=g(R),R}t.parse=D;var I;(function(m){m[m.Uri=1]="Uri",m[m.Regexp=2]="Regexp",m[m.ScmResource=3]="ScmResource",m[m.ScmResourceGroup=4]="ScmResourceGroup",m[m.ScmProvider=5]="ScmProvider",m[m.CommentController=6]="CommentController",m[m.CommentThread=7]="CommentThread",m[m.CommentThreadReply=8]="CommentThreadReply",m[m.CommentNode=9]="CommentNode",m[m.CommentThreadNode=10]="CommentThreadNode",m[m.TimelineActionContext=11]="TimelineActionContext",m[m.NotebookCellActionContext=12]="NotebookCellActionContext",m[m.TestItemContext=13]="TestItemContext"})(I=t.MarshalledId||(t.MarshalledId={}));function c(m,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,b.regExpFlags)(R)}:R}function g(m,R=0){if(!m||R>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return S.URI.revive(m);case 2:return new RegExp(m.source,m.flags)}if(m instanceof C.VSBuffer||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let h=0;h<m.length;++h)m[h]=g(m[h],R+1);else for(const h in m)Object.hasOwnProperty.call(m,h)&&(m[h]=g(m[h],R+1))}return m}t.revive=g}),define(ee[62],te([0,1,3,32,47,4,21]),function($,t,C,b,S,L,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPathTerms=t.getBasenameTerms=t.isRelativePattern=t.hasSiblingFn=t.hasSiblingPromiseFn=t.parse=t.match=t.splitGlobAware=t.getEmptyExpression=void 0;function I(){return Object.create(null)}t.getEmptyExpression=I;const c="**",g="/",m="[/\\\\]",R="[^/\\\\]",h=/\//g;function v(O){switch(O){case 0:return"";case 1:return`${R}*?`;default:return`(?:${m}|${R}+${m}|${m}${R}+)*?`}}function l(O,x){if(!O)return[];const z=[];let H=!1,B=!1,k="";for(const F of O){switch(F){case x:if(!H&&!B){z.push(k),k="";continue}break;case"{":H=!0;break;case"}":H=!1;break;case"[":B=!0;break;case"]":B=!1;break}k+=F}return k&&z.push(k),z}t.splitGlobAware=l;function u(O){if(!O)return"";let x="";const z=l(O,g);if(z.every(H=>H===c))x=".*";else{let H=!1;z.forEach((B,k)=>{if(B===c){H||(x+=v(2),H=!0);return}let F=!1,U="",V=!1,q="";for(const X of B){if(X!=="}"&&F){U+=X;continue}if(V&&(X!=="]"||!q)){let re;X==="-"?re=X:(X==="^"||X==="!")&&!q?re="^":X===g?re="":re=D.escapeRegExpCharacters(X),q+=re;continue}switch(X){case"{":F=!0;continue;case"[":V=!0;continue;case"}":x+=`(?:${l(U,",").map(de=>u(de)).join("|")})`,F=!1,U="";break;case"]":x+="["+q+"]",V=!1,q="";break;case"?":x+=R;continue;case"*":x+=v(1);continue;default:x+=D.escapeRegExpCharacters(X)}}k<z.length-1&&(z[k+1]!==c||k+2<z.length)&&(x+=m),H=!1})}return x}const y=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,p=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,d=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,e=new S.LRUCache(1e4),n=function(){return!1},i=function(){return null};function r(O,x){if(!O)return i;let z;typeof O!="string"?z=O.pattern:z=O,z=z.trim();const H=`${z}_${!!x.trimForExclusions}`;let B=e.get(H);if(B)return a(B,O);let k;if(y.test(z)){const F=z.substr(4);B=function(U,V){return typeof U=="string"&&U.endsWith(F)?z:null}}else(k=f.exec(E(z,x)))?B=P(k[1],z):(x.trimForExclusions?d:p).test(z)?B=A(z,x):(k=o.exec(E(z,x)))?B=w(k[1].substr(1),z,!0):(k=s.exec(E(z,x)))?B=w(k[1],z,!1):B=T(z);return e.set(H,B),a(B,O)}function a(O,x){return typeof x=="string"?O:function(z,H){return b.isEqualOrParent(z,x.base)?O(L.relative(x.base,z),H):null}}function E(O,x){return x.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function P(O,x){const z=`/${O}`,H=`\\${O}`,B=function(F,U){return typeof F!="string"?null:U?U===O?x:null:F===O||F.endsWith(z)||F.endsWith(H)?x:null},k=[O];return B.basenames=k,B.patterns=[x],B.allBasenames=k,B}function A(O,x){const z=W(O.slice(1,-1).split(",").map(U=>r(U,x)).filter(U=>U!==i),O),H=z.length;if(!H)return i;if(H===1)return z[0];const B=function(U,V){for(let q=0,X=z.length;q<X;q++)if(z[q](U,V))return O;return null},k=z.find(U=>!!U.allBasenames);k&&(B.allBasenames=k.allBasenames);const F=z.reduce((U,V)=>V.allPaths?U.concat(V.allPaths):U,[]);return F.length&&(B.allPaths=F),B}function w(O,x,z){const H=L.sep===L.posix.sep,B=H?O:O.replace(h,L.sep),k=L.sep+B,F=L.posix.sep+O,U=z?function(V,q){return typeof V=="string"&&(V===B||V.endsWith(k)||!H&&(V===O||V.endsWith(F)))?x:null}:function(V,q){return typeof V=="string"&&(V===B||!H&&V===O)?x:null};return U.allPaths=[(z?"*/":"./")+O],U}function T(O){try{const x=new RegExp(`^${u(O)}$`);return function(z){return x.lastIndex=0,typeof z=="string"&&x.test(z)?O:null}}catch(x){return i}}function M(O,x,z){return!O||typeof x!="string"?!1:j(O)(x,void 0,z)}t.match=M;function j(O,x={}){if(!O)return n;if(typeof O=="string"||Z(O)){const z=r(O,x);if(z===i)return n;const H=function(B,k){return!!z(B,k)};return z.allBasenames&&(H.allBasenames=z.allBasenames),z.allPaths&&(H.allPaths=z.allPaths),H}return Q(O,x)}t.parse=j;function Y(O){if(!O)return;let x;return z=>(x||(x=(O()||Promise.resolve([])).then(H=>H?oe(H):{})),x.then(H=>!!H[z]))}t.hasSiblingPromiseFn=Y;function ie(O){if(!O)return;let x;return z=>{if(!x){const H=O();x=H?oe(H):{}}return!!x[z]}}t.hasSiblingFn=ie;function oe(O){const x={};for(const z of O)x[z]=!0;return x}function Z(O){const x=O;return x&&typeof x.base=="string"&&typeof x.pattern=="string"}t.isRelativePattern=Z;function K(O){return O.allBasenames||[]}t.getBasenameTerms=K;function J(O){return O.allPaths||[]}t.getPathTerms=J;function Q(O,x){const z=W(Object.getOwnPropertyNames(O).map(U=>se(U,O[U],x)).filter(U=>U!==i)),H=z.length;if(!H)return i;if(!z.some(U=>!!U.requiresSiblings)){if(H===1)return z[0];const U=function(X,re){for(let ne=0,de=z.length;ne<de;ne++){const ge=z[ne](X,re);if(ge)return ge}return null},V=z.find(X=>!!X.allBasenames);V&&(U.allBasenames=V.allBasenames);const q=z.reduce((X,re)=>re.allPaths?X.concat(re.allPaths):X,[]);return q.length&&(U.allPaths=q),U}const B=function(U,V,q){let X;for(let re=0,ne=z.length;re<ne;re++){const de=z[re];de.requiresSiblings&&q&&(V||(V=L.basename(U)),X||(X=V.substr(0,V.length-L.extname(U).length)));const ge=de(U,V,X,q);if(ge)return ge}return null},k=z.find(U=>!!U.allBasenames);k&&(B.allBasenames=k.allBasenames);const F=z.reduce((U,V)=>V.allPaths?U.concat(V.allPaths):U,[]);return F.length&&(B.allPaths=F),B}function se(O,x,z){if(x===!1)return i;const H=r(O,z);if(H===i)return i;if(typeof x=="boolean")return H;if(x){const B=x.when;if(typeof B=="string"){const k=(F,U,V,q)=>{if(!q||!H(F,U))return null;const X=B.replace("$(basename)",V),re=q(X);return(0,C.isThenable)(re)?re.then(ne=>ne?O:null):re?O:null};return k.requiresSiblings=!0,k}}return H}function W(O,x){const z=O.filter(U=>!!U.basenames);if(z.length<2)return O;const H=z.reduce((U,V)=>{const q=V.basenames;return q?U.concat(q):U},[]);let B;if(x){B=[];for(let U=0,V=H.length;U<V;U++)B.push(x)}else B=z.reduce((U,V)=>{const q=V.patterns;return q?U.concat(q):U},[]);const k=function(U,V){if(typeof U!="string")return null;if(!V){let X;for(X=U.length;X>0;X--){const re=U.charCodeAt(X-1);if(re===47||re===92)break}V=U.substr(X)}const q=H.indexOf(V);return q!==-1?B[q]:null};k.basenames=H,k.patterns=B,k.allBasenames=H;const F=O.filter(U=>!U.basenames);return F.push(k),F}}),define(ee[63],te([0,1,32,8,4,9,19,21,7]),function($,t,C,b,S,L,D,I,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function g(r,a,E){if(typeof r=="string"&&(r=c.URI.file(r)),E){const A=E.getWorkspaceFolder(r);if(A){const w=E.getWorkspace().folders.length>1;let T;if((0,D.isEqual)(A.uri,r)?T="":T=(0,D.relativePath)(A.uri,r),w){const M=A.name?A.name:(0,D.basename)(A.uri);T=T?M+" \u2022 "+T:M}return T}}if(r.scheme!==b.Schemas.file&&r.scheme!==b.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,C.hasDriveLetter)(r.fsPath))return(0,S.normalize)(R(r.fsPath));let P=(0,S.normalize)(r.fsPath);return!L.isWindows&&a?.userHome&&(P=v(P,a.userHome.fsPath)),P}t.getPathLabel=g;function m(r){if(!r)return;typeof r=="string"&&(r=c.URI.file(r));const a=(0,D.basename)(r)||(r.scheme===b.Schemas.file?r.fsPath:r.path);return L.isWindows&&(0,C.isRootOrDriveLetter)(a)?R(a):a}t.getBaseLabel=m;function R(r){return(0,C.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}t.normalizeDriveLetter=R;let h=Object.create(null);function v(r,a){if(L.isWindows||!r||!a)return r;let E=h.original===a?h.normalized:void 0;return E||(E=`${(0,I.rtrim)(a,S.posix.sep)}${S.posix.sep}`,h={original:a,normalized:E}),(L.isLinux?r.startsWith(E):(0,I.startsWithIgnoreCase)(r,E))&&(r=`~/${r.substr(E.length)}`),r}t.tildify=v;function l(r,a){return r.replace(/^~($|\/|\\)/,`${a}$1`)}t.untildify=l;const u="\u2026",y="\\\\",f="~";function p(r,a=S.sep){const E=new Array(r.length);let P=!1;for(let A=0;A<r.length;A++){let w=r[A];if(w===""){E[A]=`.${a}`;continue}if(!w){E[A]=w;continue}P=!0;let T="";w.indexOf(y)===0?(T=w.substr(0,w.indexOf(y)+y.length),w=w.substr(w.indexOf(y)+y.length)):w.indexOf(a)===0?(T=w.substr(0,w.indexOf(a)+a.length),w=w.substr(w.indexOf(a)+a.length)):w.indexOf(f)===0&&(T=w.substr(0,w.indexOf(f)+f.length),w=w.substr(w.indexOf(f)+f.length));const M=w.split(a);for(let j=1;P&&j<=M.length;j++)for(let Y=M.length-j;P&&Y>=0;Y--){P=!1;let ie=M.slice(Y,Y+j).join(a);for(let oe=0;!P&&oe<r.length;oe++)if(oe!==A&&r[oe]&&r[oe].indexOf(ie)>-1){const Z=Y+j===M.length,K=Y>0&&r[oe].indexOf(a)>-1?a+ie:ie,J=r[oe].endsWith(K);P=!Z||J}if(!P){let oe="";(M[0].endsWith(":")||T!=="")&&(Y===1&&(Y=0,j++,ie=M[0]+a+ie),Y>0&&(oe=M[0]+a),oe=T+oe),Y>0&&(oe=oe+u+a),oe=oe+ie,Y+j<M.length&&(oe=oe+a+u),E[A]=oe}}P&&(E[A]=w)}return E}t.shorten=p;var d;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function o(r,a=Object.create(null)){const E=[];let P=!1,A="";for(const w of r)if(w==="$"||P&&w==="{")A&&E.push({value:A,type:d.TEXT}),A="",P=!0;else if(w==="}"&&P){const T=a[A];if(typeof T=="string")T.length&&E.push({value:T,type:d.VARIABLE});else if(T){const M=E[E.length-1];(!M||M.type!==d.SEPARATOR)&&E.push({value:T.label,type:d.SEPARATOR})}A="",P=!1}else A+=w;return A&&!P&&E.push({value:A,type:d.TEXT}),E.filter((w,T)=>{if(w.type===d.SEPARATOR){const M=E[T-1],j=E[T+1];return[M,j].every(Y=>Y&&(Y.type===d.VARIABLE||Y.type===d.TEXT)&&Y.value.length>0)}return!0}).map(w=>w.value).join("")}t.template=o;function s(r,a){return L.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.isMacintosh?"&":"&&"):r.replace(/&&|&/g,E=>E==="&"?"&&":"&")}t.mnemonicMenuLabel=s;function e(r,a){return L.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,""):L.isWindows?r.replace(/&&|&/g,E=>E==="&"?"&&":"&"):r.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function n(r){return r.replace(/&/g,"&&")}t.unmnemonicLabel=n;function i(r){const a=r.indexOf("/")!==-1?S.posix:S.win32,E=a.basename(r),P=a.dirname(r);return E.length?{name:E,parentPath:P}:{name:P,parentPath:""}}t.splitName=i}),define(ee[48],te([0,1,127]),function($,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class b{constructor(L="utf8"){this.stringDecoder=new C.StringDecoder(L),this.remaining=null}write(L){const D=[],I=this.remaining?this.remaining+this.stringDecoder.write(L):this.stringDecoder.write(L);if(I.length<1)return D;let c=0,g,m=c;for(;m<I.length;)if(g=I.charCodeAt(m),g===13||g===10){if(D.push(I.substring(c,m)),m++,m<I.length){const R=g;g=I.charCodeAt(m),(R===13&&g===10||R===10&&g===13)&&m++}c=m}else m++;return this.remaining=c<I.length?I.substr(c):null,D}end(){return this.remaining}}t.LineDecoder=b}),define(ee[64],te([0,1,38,4,21,10]),function($,t,C,b,S,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function D(m){const R=(0,b.dirname)(m);if(m===R)return m;const h=((0,b.basename)(m)||m).toLowerCase();try{const l=(0,L.readdirSync)(R).filter(u=>u.toLowerCase()===h);if(l.length===1){const u=D(R);if(u)return(0,b.join)(u,l[0])}else if(l.length>1){const u=l.indexOf(h);if(u>=0){const y=D(R);if(y)return(0,b.join)(y,l[u])}}}catch(v){}return null}t.realcaseSync=D;async function I(m){try{return await L.Promises.realpath(m)}catch(R){const h=g(m);return await L.Promises.access(h,C.constants.R_OK),h}}t.realpath=I;function c(m){try{return C.realpathSync(m)}catch(R){const h=g(m);return C.accessSync(h,C.constants.R_OK),h}}t.realpathSync=c;function g(m){return(0,S.rtrim)((0,b.normalize)(m),b.sep)}}),define(ee[65],te([0,1,33,4,10]),function($,t,C,b,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const L=/^\d+$/,D=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var c;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(c||(c={}));let g;switch(process.arch){case"ia32":case"x32":g=1;break;case"arm":case"arm64":g=2;break;default:g=0;break}let m;process.env.PROCESSOR_ARCHITEW6432?m=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?m=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?m=1:m=0;class R{constructor(s,e,n){this.exePath=s,this.displayName=e,this.knownToExist=n}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await S.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function h({useAlternateBitness:o=!1}={}){return o?g===0?process.env["ProgramFiles(x86)"]||null:m===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function v({useAlternateBitness:o=!1,findPreview:s=!1}={}){const e=h({useAlternateBitness:o});if(!e)return null;const n=b.join(e,"PowerShell");if(!await S.SymlinkSupport.existsDirectory(n))return null;let i=-1,r=null;for(const P of await S.Promises.readdir(n)){let A=-1;if(s){const T=P.indexOf("-");if(T<0)continue;const M=P.substring(0,T);if(!L.test(M)||P.substring(T+1)!=="preview")continue;A=parseInt(M,10)}else{if(!L.test(P))continue;A=parseInt(P,10)}if(A<=i)continue;const w=b.join(n,P,"pwsh.exe");!await S.SymlinkSupport.existsFile(w)||(r=w,i=A)}if(!r)return null;const a=e.includes("x86")?" (x86)":"",E=s?" Preview":"";return new R(r,`PowerShell${E}${a}`,!0)}async function l({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const s=b.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await S.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:e,pwshMsixName:n}=o?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const i of await S.Promises.readdir(s))if(e.test(i)){const r=b.join(s,i,"pwsh.exe");return new R(r,n)}return null}function u(){const o=b.join(C.homedir(),".dotnet","tools","pwsh.exe");return new R(o,".NET Core PowerShell Global Tool")}function y(){const o=b.join(process.env.windir,g===1&&m!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new R(o,"Windows PowerShell",!0)}async function*f(){let o=await v();o&&(yield o),o=await v({useAlternateBitness:!0}),o&&(yield o),o=await l(),o&&(yield o),o=u(),o&&(yield o),o=await v({findPreview:!0}),o&&(yield o),o=await l({findPreview:!0}),o&&(yield o),o=await v({useAlternateBitness:!0,findPreview:!0}),o&&(yield o),o=y(),o&&(yield o)}async function*p(){for await(const o of f())await o.exists()&&(yield o)}t.enumeratePowerShellInstallations=p;async function d(){for await(const o of p())return o;return null}t.getFirstAvailablePowerShellInstallation=d}),define(ee[66],te([0,1,38,32,2,128,4,9,10]),function($,t,C,b,S,L,D,I,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CHANGE_BUFFER_DELAY=t.watchFolder=t.watchFile=void 0;function g(h,v,l){return R({path:h,isDirectory:!1},v,l)}t.watchFile=g;function m(h,v,l){return R({path:h,isDirectory:!0},v,l)}t.watchFolder=m,t.CHANGE_BUFFER_DELAY=100;function R(h,v,l){if(I.isMacintosh&&(0,b.isEqualOrParent)(h.path,"/Volumes/"))return l(`Refusing to watch ${h.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),S.Disposable.None;const u=(0,D.basename)(h.path),y=new Map;let f=!1,p=[(0,S.toDisposable)(()=>{y.forEach(d=>(0,S.dispose)(d)),y.clear()})];try{const d=(0,C.watch)(h.path);p.push((0,S.toDisposable)(()=>{d.removeAllListeners(),d.close()}));const o=new Set;h.isDirectory&&c.Promises.readdir(h.path).then(s=>s.forEach(e=>o.add(e))),d.on("error",(s,e)=>{f||l(`Failed to watch ${h.path} for changes using fs.watch() (${s}, ${e})`)}),d.on("change",(s,e)=>{if(f)return;let n="";if(e&&(n=e.toString(),I.isMacintosh&&(n=(0,L.normalizeNFC)(n))),!n||s!=="change"&&s!=="rename")return;const i=h.isDirectory?(0,D.join)(h.path,n):h.path;if(h.isDirectory)if(s==="rename"){const r=y.get(i);r&&(0,S.dispose)(r);const a=setTimeout(async()=>{y.delete(i);const E=await c.Promises.exists(i);if(f)return;let P;E?o.has(n)?P="changed":(P="added",o.add(n)):(o.delete(n),P="deleted"),v(P,i)},t.CHANGE_BUFFER_DELAY);y.set(i,(0,S.toDisposable)(()=>clearTimeout(a)))}else{let r;o.has(n)?r="changed":(r="added",o.add(n)),v(r,i)}else if(s==="rename"||n!==u){const r=setTimeout(async()=>{const a=await c.Promises.exists(i);f||(a?(v("changed",i),p=[R(h,v,l)]):v("deleted",i))},t.CHANGE_BUFFER_DELAY);(0,S.dispose)(p),p=[(0,S.toDisposable)(()=>clearTimeout(r))]}else v("changed",i)})}catch(d){c.Promises.exists(h.path).then(o=>{o&&!f&&l(`Failed to watch ${h.path} for changes using fs.watch() (${d.toString()})`)})}return(0,S.toDisposable)(()=>{f=!0,p=(0,S.dispose)(p)})}});var fe=this&&this.__decorate||function($,t,C,b){var S=arguments.length,L=S<3?t:b===null?b=Object.getOwnPropertyDescriptor(t,C):b,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate($,t,C,b);else for(var I=$.length-1;I>=0;I--)(D=$[I])&&(L=(S<3?D(L):S>3?D(t,C,L):D(t,C))||L);return S>3&&L&&Object.defineProperty(t,C,L),L};define(ee[39],te([0,1,22,3,17,25,46,11,13,2,61,21,12]),function($,t,C,b,S,L,D,I,c,g,m,R,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var v;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(v=t.RequestType||(t.RequestType={}));function l(W){switch(W){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var u;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(u=t.ResponseType||(t.ResponseType={}));function y(W){switch(W){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(f||(f={}));class p{constructor(O){this.buffer=O,this.pos=0}read(O){const x=this.buffer.slice(this.pos,this.pos+O);return this.pos+=x.byteLength,x}}class d{constructor(){this.buffers=[]}get buffer(){return S.VSBuffer.concat(this.buffers)}write(O){this.buffers.push(O)}}var o;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object"})(o||(o={}));function s(W){const O=S.VSBuffer.alloc(4);return O.writeUInt32BE(W,0),O}function e(W){return W.read(4).readUInt32BE(0)}function n(W){const O=S.VSBuffer.alloc(1);return O.writeUInt8(W,0),O}const i={Undefined:n(o.Undefined),String:n(o.String),Buffer:n(o.Buffer),VSBuffer:n(o.VSBuffer),Array:n(o.Array),Object:n(o.Object)},r=typeof Buffer!="undefined";function a(W,O){if(typeof O=="undefined")W.write(i.Undefined);else if(typeof O=="string"){const x=S.VSBuffer.fromString(O);W.write(i.String),W.write(s(x.byteLength)),W.write(x)}else if(r&&Buffer.isBuffer(O)){const x=S.VSBuffer.wrap(O);W.write(i.Buffer),W.write(s(x.byteLength)),W.write(x)}else if(O instanceof S.VSBuffer)W.write(i.VSBuffer),W.write(s(O.byteLength)),W.write(O);else if(Array.isArray(O)){W.write(i.Array),W.write(s(O.length));for(const x of O)a(W,x)}else{const x=S.VSBuffer.fromString(JSON.stringify(O));W.write(i.Object),W.write(s(x.byteLength)),W.write(x)}}function E(W){switch(W.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return W.read(e(W)).toString();case o.Buffer:return W.read(e(W)).buffer;case o.VSBuffer:return W.read(e(W));case o.Array:{const x=e(W),z=[];for(let H=0;H<x;H++)z.push(E(W));return z}case o.Object:return JSON.parse(W.read(e(W)).toString())}}class P{constructor(O,x,z=null,H=1e3){this.protocol=O,this.ctx=x,this.logger=z,this.timeoutDelay=H,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(B=>this.onRawMessage(B)),this.sendResponse({type:200})}registerChannel(O,x){this.channels.set(O,x),setTimeout(()=>this.flushPendingRequests(O),0)}sendResponse(O){switch(O.type){case 200:{const x=this.send([O.type]);this.logger&&this.logger.logOutgoing(x,0,1,y(O.type));return}case 201:case 202:case 204:case 203:{const x=this.send([O.type,O.id],O.data);this.logger&&this.logger.logOutgoing(x,O.id,1,y(O.type),O.data);return}}}send(O,x=void 0){const z=new d;return a(z,O),a(z,x),this.sendBuffer(z.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(x){return 0}}onRawMessage(O){const x=new p(O),z=E(x),H=E(x),B=z[0];switch(B){case 100:return this.logger&&this.logger.logIncoming(O.byteLength,z[1],1,`${l(B)}: ${z[2]}.${z[3]}`,H),this.onPromise({type:B,id:z[1],channelName:z[2],name:z[3],arg:H});case 102:return this.logger&&this.logger.logIncoming(O.byteLength,z[1],1,`${l(B)}: ${z[2]}.${z[3]}`,H),this.onEventListen({type:B,id:z[1],channelName:z[2],name:z[3],arg:H});case 101:return this.logger&&this.logger.logIncoming(O.byteLength,z[1],1,`${l(B)}`),this.disposeActiveRequest({type:B,id:z[1]});case 103:return this.logger&&this.logger.logIncoming(O.byteLength,z[1],1,`${l(B)}`),this.disposeActiveRequest({type:B,id:z[1]})}}onPromise(O){const x=this.channels.get(O.channelName);if(!x){this.collectPendingRequest(O);return}const z=new L.CancellationTokenSource;let H;try{H=x.call(this.ctx,O.name,O.arg,z.token)}catch(F){H=Promise.reject(F)}const B=O.id;H.then(F=>{this.sendResponse({id:B,data:F,type:201}),this.activeRequests.delete(O.id)},F=>{F instanceof Error?this.sendResponse({id:B,data:{message:F.message,name:F.name,stack:F.stack?F.stack.split?F.stack.split(`
`):F.stack:void 0},type:202}):this.sendResponse({id:B,data:F,type:203}),this.activeRequests.delete(O.id)});const k=(0,g.toDisposable)(()=>z.cancel());this.activeRequests.set(O.id,k)}onEventListen(O){const x=this.channels.get(O.channelName);if(!x){this.collectPendingRequest(O);return}const z=O.id,B=x.listen(this.ctx,O.name,O.arg)(k=>this.sendResponse({id:z,data:k,type:204}));this.activeRequests.set(O.id,B)}disposeActiveRequest(O){const x=this.activeRequests.get(O.id);x&&(x.dispose(),this.activeRequests.delete(O.id))}collectPendingRequest(O){let x=this.pendingRequests.get(O.channelName);x||(x=[],this.pendingRequests.set(O.channelName,x));const z=setTimeout(()=>{console.error(`Unknown channel: ${O.channelName}`),O.type===100&&this.sendResponse({id:O.id,data:{name:"Unknown channel",message:`Channel name '${O.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);x.push({request:O,timeoutTimer:z})}flushPendingRequests(O){const x=this.pendingRequests.get(O);if(x){for(const z of x)switch(clearTimeout(z.timeoutTimer),z.request.type){case 100:this.onPromise(z.request);break;case 102:this.onEventListen(z.request);break}this.pendingRequests.delete(O)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}t.ChannelServer=P;var A;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(A=t.RequestInitiator||(t.RequestInitiator={}));class w{constructor(O,x=null){this.protocol=O,this.isDisposed=!1,this.state=f.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new c.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(z=>this.onBuffer(z)),this.logger=x}getChannel(O){const x=this;return{call(z,H,B){return x.isDisposed?Promise.reject(I.canceled()):x.requestPromise(O,z,H,B)},listen(z,H){return x.isDisposed?Promise.reject(I.canceled()):x.requestEvent(O,z,H)}}}requestPromise(O,x,z,H=L.CancellationToken.None){const B=this.lastRequestId++,F={id:B,type:100,channelName:O,name:x,arg:z};if(H.isCancellationRequested)return Promise.reject(I.canceled());let U;return new Promise((q,X)=>{if(H.isCancellationRequested)return X(I.canceled());const re=()=>{const he=Ee=>{switch(Ee.type){case 201:this.handlers.delete(B),q(Ee.data);break;case 202:this.handlers.delete(B);const ye=new Error(Ee.data.message);ye.stack=Ee.data.stack,ye.name=Ee.data.name,X(ye);break;case 203:this.handlers.delete(B),X(Ee.data);break}};this.handlers.set(B,he),this.sendRequest(F)};let ne=null;this.state===f.Idle?re():(ne=(0,b.createCancelablePromise)(he=>this.whenInitialized()),ne.then(()=>{ne=null,re()}));const de=()=>{ne?(ne.cancel(),ne=null):this.sendRequest({id:B,type:101}),X(I.canceled())},ge=H.onCancellationRequested(de);U=(0,g.combinedDisposable)((0,g.toDisposable)(de),ge),this.activeRequests.add(U)}).finally(()=>{this.activeRequests.delete(U)})}requestEvent(O,x,z){const H=this.lastRequestId++,k={id:H,type:102,channelName:O,name:x,arg:z};let F=null;const U=new c.Emitter({onFirstListenerAdd:()=>{F=(0,b.createCancelablePromise)(q=>this.whenInitialized()),F.then(()=>{F=null,this.activeRequests.add(U),this.sendRequest(k)})},onLastListenerRemove:()=>{F?(F.cancel(),F=null):(this.activeRequests.delete(U),this.sendRequest({id:H,type:103}))}}),V=q=>U.fire(q.data);return this.handlers.set(H,V),U.event}sendRequest(O){switch(O.type){case 100:case 102:{const x=this.send([O.type,O.id,O.channelName,O.name],O.arg);this.logger&&this.logger.logOutgoing(x,O.id,0,`${l(O.type)}: ${O.channelName}.${O.name}`,O.arg);return}case 101:case 103:{const x=this.send([O.type,O.id]);this.logger&&this.logger.logOutgoing(x,O.id,0,l(O.type));return}}}send(O,x=void 0){const z=new d;return a(z,O),a(z,x),this.sendBuffer(z.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(x){return 0}}onBuffer(O){const x=new p(O),z=E(x),H=E(x),B=z[0];switch(B){case 200:return this.logger&&this.logger.logIncoming(O.byteLength,0,0,y(B)),this.onResponse({type:z[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(O.byteLength,z[1],0,y(B),H),this.onResponse({type:z[0],id:z[1],data:H})}}onResponse(O){if(O.type===200){this.state=f.Idle,this._onDidInitialize.fire();return}const x=this.handlers.get(O.id);x&&x(O)}get onDidInitializePromise(){return c.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}fe([D.memoize],w.prototype,"onDidInitializePromise",null),t.ChannelClient=w;class T{constructor(O){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new c.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new c.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,O(({protocol:x,onDidClientDisconnect:z})=>{c.Event.once(x.onMessage)(B=>{const k=new p(B),F=E(k),U=new P(x,F),V=new w(x);this.channels.forEach((X,re)=>U.registerChannel(re,X));const q={channelServer:U,channelClient:V,ctx:F};this._connections.add(q),this._onDidAddConnection.fire(q),z(()=>{U.dispose(),V.dispose(),this._connections.delete(q),this._onDidRemoveConnection.fire(q)})})})}get connections(){const O=[];return this._connections.forEach(x=>O.push(x)),O}getChannel(O,x){const z=this;return{call(H,B,k){let F;if((0,h.isFunction)(x)){let V=(0,C.getRandomElement)(z.connections.filter(x));F=V?Promise.resolve(V):c.Event.toPromise(c.Event.filter(z.onDidAddConnection,x))}else F=x.routeCall(z,H,B);const U=F.then(V=>V.channelClient.getChannel(O));return j(U).call(H,B,k)},listen(H,B){if((0,h.isFunction)(x))return z.getMulticastEvent(O,x,H,B);const k=x.routeEvent(z,H,B).then(F=>F.channelClient.getChannel(O));return j(k).listen(H,B)}}}getMulticastEvent(O,x,z,H){const B=this;let k=new g.DisposableStore;const F=new c.Emitter({onFirstListenerAdd:()=>{k=new g.DisposableStore;const U=new c.EventMultiplexer,V=new Map,q=re=>{const de=re.channelClient.getChannel(O).listen(z,H),ge=U.add(de);V.set(re,ge)},X=re=>{const ne=V.get(re);!ne||(ne.dispose(),V.delete(re))};B.connections.filter(x).forEach(q),c.Event.filter(B.onDidAddConnection,x)(q,void 0,k),B.onDidRemoveConnection(X,void 0,k),U.event(F.fire,F,k),k.add(U)},onLastListenerRemove:()=>{k.dispose()}});return F.event}registerChannel(O,x){this.channels.set(O,x),this._connections.forEach(z=>{z.channelServer.registerChannel(O,x)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=T;class M{constructor(O,x,z=null){const H=new d;a(H,x),O.send(H.buffer),this.channelClient=new w(O,z),this.channelServer=new P(O,x,z)}getChannel(O){return this.channelClient.getChannel(O)}registerChannel(O,x){this.channelServer.registerChannel(O,x)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=M;function j(W){return{call(O,x,z){return W.then(H=>H.call(O,x,z))},listen(O,x){const z=new c.Relay;return W.then(H=>z.input=H.listen(O,x)),z.event}}}t.getDelayedChannel=j;function Y(W){let O=!1;return{call(x,z,H){return O?W.call(x,z,H):(0,b.timeout)(0).then(()=>O=!0).then(()=>W.call(x,z,H))},listen(x,z){if(O)return W.listen(x,z);const H=new c.Relay;return(0,b.timeout)(0).then(()=>O=!0).then(()=>H.input=W.listen(x,z)),H.event}}}t.getNextTickChannel=Y;class ie{constructor(O){this.fn=O}routeCall(O){return this.route(O)}routeEvent(O){return this.route(O)}async route(O){for(const x of O.connections)if(await Promise.resolve(this.fn(x.ctx)))return Promise.resolve(x);return await c.Event.toPromise(O.onDidAddConnection),await this.route(O)}}t.StaticRouter=ie;var oe;(function(W){function O(H,B){const k=H,F=B&&B.disableMarshalling,U=new Map;for(const V in k)z(V)&&U.set(V,c.Event.buffer(k[V],!0));return new class{listen(V,q){const X=U.get(q);if(X)return X;throw new Error(`Event not found: ${q}`)}call(V,q,X){const re=k[q];if(typeof re=="function"){if(!F&&Array.isArray(X))for(let ne=0;ne<X.length;ne++)X[ne]=(0,m.revive)(X[ne]);return re.apply(k,X)}throw new Error(`Method not found: ${q}`)}}}W.fromService=O;function x(H,B){const k=B&&B.disableMarshalling;return new Proxy({},{get(F,U){if(typeof U=="string")return B?.properties?.has(U)?B.properties.get(U):z(U)?H.listen(U):async function(...V){let q;B&&!(0,h.isUndefinedOrNull)(B.context)?q=[B.context,...V]:q=V;const X=await H.call(U,q);return k?X:(0,m.revive)(X)};throw new Error(`Property not found: ${String(U)}`)}})}W.toService=x;function z(H){return H[0]==="o"&&H[1]==="n"&&R.isUpperAsciiLetter(H.charCodeAt(2))}})(oe=t.ProxyChannel||(t.ProxyChannel={}));const Z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function K(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){let O=W.toString();if(O!=="[object Object]")return O}return W}function J(W){return Array.isArray(W)?W.map(K):K(W)}function Q(W,O,x,z,H,B,k){k=J(k);const F=Z[H],U=F[z%F.length];let V=[`%c[${W}]%c[${String(O).padStart(7," ")}]%c[len: ${String(x).padStart(5," ")}]%c${String(z).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(B)?(V=V.concat(k),V.push(")")):V.push(k),console.log.apply(console,V)}t.logWithColors=Q;class se{constructor(O,x){this._outgoingPrefix=O,this._incomingPrefix=x,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(O,x,z,H,B){this._totalOutgoing+=O,Q(this._outgoingPrefix,this._totalOutgoing,O,x,z,H,B)}logIncoming(O,x,z,H,B){this._totalIncoming+=O,Q(this._incomingPrefix,this._totalIncoming,O,x,z,H,B)}}t.IPCLogger=se}),define(ee[67],te([0,1,3,13,2,12]),function($,t,C,b,S,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.isStorageItemsChangeEvent=t.StorageHint=void 0;var D;(function(R){R[R.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(D=t.StorageHint||(t.StorageHint={}));function I(R){const h=R;return h?.changed instanceof Map||h?.deleted instanceof Set}t.isStorageItemsChangeEvent=I;var c;(function(R){R[R.None=0]="None",R[R.Initialized=1]="Initialized",R[R.Closed=2]="Closed"})(c||(c={}));class g extends S.Disposable{constructor(h,v=Object.create(null)){super();this.database=h,this.options=v,this._onDidChangeStorage=this._register(new b.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=c.None,this.cache=new Map,this.flushDelayer=new C.ThrottledDelayer(g.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(h=>this.onDidChangeItemsExternal(h)))}onDidChangeItemsExternal(h){h.changed?.forEach((v,l)=>this.accept(l,v)),h.deleted?.forEach(v=>this.accept(v,void 0))}accept(h,v){if(this.state===c.Closed)return;let l=!1;(0,L.isUndefinedOrNull)(v)?l=this.cache.delete(h):this.cache.get(h)!==v&&(this.cache.set(h,v),l=!0),l&&this._onDidChangeStorage.fire(h)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===c.None&&(this.state=c.Initialized,this.options.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(h,v){const l=this.cache.get(h);return(0,L.isUndefinedOrNull)(l)?v:l}getBoolean(h,v){const l=this.get(h);return(0,L.isUndefinedOrNull)(l)?v:l==="true"}getNumber(h,v){const l=this.get(h);return(0,L.isUndefinedOrNull)(l)?v:parseInt(l,10)}async set(h,v){if(this.state===c.Closed)return;if((0,L.isUndefinedOrNull)(v))return this.delete(h);const l=String(v);if(this.cache.get(h)!==l)return this.cache.set(h,l),this.pendingInserts.set(h,l),this.pendingDeletes.delete(h),this._onDidChangeStorage.fire(h),this.flushDelayer.trigger(()=>this.flushPending())}async delete(h){if(!(this.state===c.Closed||!this.cache.delete(h)))return this.pendingDeletes.has(h)||this.pendingDeletes.add(h),this.pendingInserts.delete(h),this._onDidChangeStorage.fire(h),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=c.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(h){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const h={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(h).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(h=>this.whenFlushedCallbacks.push(h))}dispose(){this.flushDelayer.dispose(),super.dispose()}}t.Storage=g,g.DEFAULT_FLUSH_DELAY=100;class m{constructor(){this.onDidChangeItemsExternal=b.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(h){h.insert&&h.insert.forEach((v,l)=>this.items.set(l,v)),h.delete&&h.delete.forEach(v=>this.items.delete(v))}async close(){}}t.InMemoryStorageDatabase=m}),define(ee[68],te([5,6]),function($,t){return $.create("vs/base/common/date",t)}),define(ee[69],te([0,1,68]),function($,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const b=60,S=b*60,L=S*24,D=L*7,I=L*30,c=L*365;function g(R,h){typeof R!="number"&&(R=R.getTime());const v=Math.round((new Date().getTime()-R)/1e3);if(v<-30)return(0,C.localize)(0,null,g(new Date().getTime()+v*1e3,!1));if(v<30)return(0,C.localize)(1,null);let l;return v<b?(l=v,h?l===1?(0,C.localize)(2,null,l):(0,C.localize)(3,null,l):l===1?(0,C.localize)(4,null,l):(0,C.localize)(5,null,l)):v<S?(l=Math.floor(v/b),h?l===1?(0,C.localize)(6,null,l):(0,C.localize)(7,null,l):l===1?(0,C.localize)(8,null,l):(0,C.localize)(9,null,l)):v<L?(l=Math.floor(v/S),h?l===1?(0,C.localize)(10,null,l):(0,C.localize)(11,null,l):l===1?(0,C.localize)(12,null,l):(0,C.localize)(13,null,l)):v<D?(l=Math.floor(v/L),h?l===1?(0,C.localize)(14,null,l):(0,C.localize)(15,null,l):l===1?(0,C.localize)(16,null,l):(0,C.localize)(17,null,l)):v<I?(l=Math.floor(v/D),h?l===1?(0,C.localize)(18,null,l):(0,C.localize)(19,null,l):l===1?(0,C.localize)(20,null,l):(0,C.localize)(21,null,l)):v<c?(l=Math.floor(v/I),h?l===1?(0,C.localize)(22,null,l):(0,C.localize)(23,null,l):l===1?(0,C.localize)(24,null,l):(0,C.localize)(25,null,l)):(l=Math.floor(v/c),h?l===1?(0,C.localize)(26,null,l):(0,C.localize)(27,null,l):l===1?(0,C.localize)(28,null,l):(0,C.localize)(29,null,l))}t.fromNow=g;function m(R){return R.getFullYear()+"-"+String(R.getMonth()+1).padStart(2,"0")+"-"+String(R.getDate()).padStart(2,"0")+"T"+String(R.getHours()).padStart(2,"0")+":"+String(R.getMinutes()).padStart(2,"0")+":"+String(R.getSeconds()).padStart(2,"0")+"."+(R.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=m}),define(ee[70],te([5,6]),function($,t){return $.create("vs/base/common/errorMessage",t)}),define(ee[28],te([0,1,22,12,70]),function($,t,C,b,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function L(g,m){return m&&(g.stack||g.stacktrace)?S.localize(0,null,I(g),D(g.stack)||D(g.stacktrace)):I(g)}function D(g){return Array.isArray(g)?g.join(`
`):g}function I(g){return typeof g.code=="string"&&typeof g.errno=="number"&&typeof g.syscall=="string"?S.localize(1,null,g.message):g.message||S.localize(2,null)}function c(g=null,m=!1){if(!g)return S.localize(3,null);if(Array.isArray(g)){const R=C.coalesce(g),h=c(R[0],m);return R.length>1?S.localize(4,null,h,R.length):h}if(b.isString(g))return g;if(g.detail){const R=g.detail;if(R.error)return L(R.error,m);if(R.exception)return L(R.exception,m)}return g.stack?L(g,m):g.message?g.message:S.localize(5,null)}t.toErrorMessage=c}),define(ee[71],te([5,6]),function($,t){return $.create("vs/base/node/processes",t)}),define(ee[49],te([0,1,34,32,8,18,4,9,29,12,48,10,71]),function($,t,C,b,S,L,D,I,c,g,m,R,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0;function v(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function l(o,s){if(I.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};s&&(e.cwd=s);const n=C.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],e);return new Promise(i=>{n.once("error",r=>{i({success:!1,error:r})}),n.once("exit",(r,a)=>{i(r===0?{success:!0}:{success:!1,code:r!==null?r:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?v(e.status):1})}else if(I.isLinux||I.isMacintosh)try{const e=S.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",$).fsPath;return new Promise(n=>{C.execFile(e,[o.pid.toString()],{encoding:"utf8",shell:!0},(i,r,a)=>{n(i?{success:!1,error:i}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function u(o=c.env){return o.comspec||"cmd.exe"}t.getWindowsShell=u;class y{constructor(s,e,n,i){if(e!==void 0&&n!==void 0&&i!==void 0)this.cmd=s,this.args=e,this.shell=n,this.options=i;else{const r=s;this.cmd=r.command,this.shell=r.isShellCommand,this.args=r.args.slice(0),this.options=r.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const r=Object.create(null);Object.keys(c.env).forEach(a=>{r[a]=c.env[a]}),Object.keys(this.options.env).forEach(a=>{r[a]=this.options.env[a]}),this.options.env=r}}getSanitizedCommand(){let s=this.cmd.toLowerCase();const e=s.lastIndexOf(D.sep);return e!==-1&&(s=s.substring(e+1)),y.WellKnowCommands[s]?s:"other"}start(s){return I.isWindows&&(this.options&&this.options.cwd&&b.isUNC(this.options.cwd)||!this.options&&b.isUNC(c.cwd()))?Promise.reject(new Error(h.localize(0,null))):this.useExec().then(e=>{let n,i;const r=new Promise((a,E)=>{n=a,i=E});if(e){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=C.exec(a,this.options,(E,P,A)=>{this.childProcess=null;const w=E;w&&w.killed?i({killed:this.terminateRequested,stdout:P.toString(),stderr:A.toString()}):this.handleExec(n,s,E,P,A)})}else{let a=null;const E=P=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(P,n,s,i);const A={terminated:this.terminateRequested};g.isNumber(P)&&(A.cmdCode=P),n(A)};if(this.shell&&I.isWindows){const P=L.deepClone(this.options);P.windowsVerbatimArguments=!0,P.detached=!1;let A=!1,w=!1;const T=[];let M=this.ensureQuotes(this.cmd);T.push(M.value),A=M.quoted,this.args&&this.args.forEach(Y=>{M=this.ensureQuotes(Y),T.push(M.value),w=w&&M.quoted});const j=["/s","/c"];A?w?j.push('"'+T.join(" ")+'"'):T.length>1?j.push('"'+T[0]+'" '+T.slice(1).join(" ")):j.push('"'+T[0]+'"'):j.push(T.join(" ")),a=C.spawn(u(),j,P)}else this.cmd&&(a=C.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(g.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",P=>{this.childProcess=null,i({terminated:this.terminateRequested,error:P})}),a.pid&&(this.childProcess.on("close",E),this.handleSpawn(a,n,s,i,!0)))}return r})}handleClose(s,e,n,i){}ensureQuotes(s){return y.regexp.test(s)?{value:'"'+s+'"',quoted:!0}:{value:s,quoted:s.length>0&&s[0]==='"'&&s[s.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(s=>s.pid,s=>-1):new Promise(s=>{this.pidResolve=s})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(s=>(this.terminateRequested=!0,l(s,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),s=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(s=>{if(!this.shell||!I.isWindows)return s(!1);const e=C.spawn(u(),["/s","/c"]);e.on("error",n=>s(!0)),e.on("exit",n=>s(!1))})}}t.AbstractProcess=y,y.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},y.regexp=/^[^"].* .*[^"]/;class f extends y{constructor(s,e,n,i){super(s,e,n,i);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(s,e,n,i,r){[i,r].forEach((a,E)=>{const P=new m.LineDecoder;P.write(a).forEach(T=>{e({line:T,source:E===0?0:1})});const w=P.end();w&&e({line:w,source:E===0?0:1})}),s({terminated:this.terminateRequested,error:n})}handleSpawn(s,e,n,i,r){const a=new m.LineDecoder,E=new m.LineDecoder;s.stdout.on("data",P=>{a.write(P).forEach(w=>n({line:w,source:0}))}),s.stderr.on("data",P=>{E.write(P).forEach(w=>n({line:w,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=E}handleClose(s,e,n,i){const r=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;r&&n({line:r,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&n({line:a,source:1})}}t.LineProcess=f;function p(o){let s=[],e=!1;const n=function(i){if(e){s.push(i);return}(!o.send(i,a=>{if(a&&console.error(a),e=!1,s.length>0){const E=s.slice(0);s=[],E.forEach(P=>n(P))}})||I.isWindows)&&(e=!0)};return{send:n}}t.createQueuedSender=p;var d;(function(o){async function s(e,n,i){if(D.isAbsolute(e))return e;if(n===void 0&&(n=c.cwd()),D.dirname(e)!=="."||(i===void 0&&g.isString(c.env.PATH)&&(i=c.env.PATH.split(D.delimiter)),i===void 0||i.length===0))return D.join(n,e);async function a(E){if(await R.Promises.exists(E)){let P;try{P=await R.Promises.stat(E)}catch(A){A.message.startsWith("EACCES")&&(P=await R.Promises.lstat(E))}return P?!P.isDirectory():!1}return!1}for(let E of i){let P;if(D.isAbsolute(E)?P=D.join(E,e):P=D.join(n,E,e),await a(P))return P;let A=P+".com";if(await a(A)||(A=P+".exe",await a(A)))return A}return D.join(n,e)}o.findExecutable=s})(d=t.win32||(t.win32={}))}),define(ee[72],te([0,1,33,9,65,49]),function($,t,C,b,S,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function D(v,l){return v===1?b.isWindows?R():L.getWindowsShell(l):g(v,l)}t.getSystemShell=D;function I(v,l){return v===1?b.isWindows?h(l):L.getWindowsShell(l):g(v,l)}t.getSystemShellSync=I;let c=null;function g(v,l){if(b.isLinux&&v===2||b.isMacintosh&&v===3)return"/bin/bash";if(!c){let u;if(b.isWindows)u="/bin/bash";else{if(u=l.SHELL,!u)try{u=(0,C.userInfo)().shell}catch(y){}u||(u="sh"),u==="/bin/false"&&(u="/bin/bash")}c=u}return c}let m=null;async function R(){return m||(m=(await(0,S.getFirstAvailablePowerShellInstallation)()).exePath),m}function h(v){if(m)return m;const l=b.isWindows&&parseFloat((0,C.release)())>=10,u=v.hasOwnProperty("PROCESSOR_ARCHITEW6432"),y=`${v.windir}\\${u?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return l?y:L.getWindowsShell(v)}}),define(ee[50],te([0,1,34,3,17,25,60,11,13,2,18,9,49,39]),function($,t,C,b,S,L,D,I,c,g,m,R,h,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class l extends v.ChannelServer{constructor(f){super({send:p=>{try{process.send&&process.send(p.buffer.toString("base64"))}catch(d){}},onMessage:c.Event.fromNodeEventEmitter(process,"message",p=>S.VSBuffer.wrap(Buffer.from(p,"base64")))},f);process.once("disconnect",()=>this.dispose())}}t.Server=l;class u{constructor(f,p){this.modulePath=f,this.options=p,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new c.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const d=p&&p.timeout?p.timeout:6e4;this.disposeDelayer=new b.Delayer(d),this.child=null,this._client=null}getChannel(f){const p=this;return{call(d,o,s){return p.requestPromise(f,d,o,s)},listen(d,o){return p.requestEvent(f,d,o)}}}requestPromise(f,p,d,o=L.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(I.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(f),e=(0,b.createCancelablePromise)(r=>s.call(p,d,r)),n=o.onCancellationRequested(()=>e.cancel()),i=(0,g.toDisposable)(()=>e.cancel());return this.activeRequests.add(i),e.finally(()=>{n.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(f,p,d){if(!this.disposeDelayer)return c.Event.None;this.disposeDelayer.cancel();let o;const s=new c.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(f).listen(p,d)(s.fire,s),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const f=this.options&&this.options.args?this.options.args:[],p=Object.create(null);p.env={...(0,m.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(p.env={...p.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(p.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a))),R.isMacintosh&&p.env&&delete p.env.DYLD_LIBRARY_PATH,this.child=(0,C.fork)(this.modulePath,f,p);const d=new c.Emitter;c.Event.fromNodeEventEmitter(this.child,"message",a=>a)(a=>{if((0,D.isRemoteConsoleLog)(a)){(0,D.log)(a,`IPC Library: ${this.options.serverName}`);return}d.fire(S.VSBuffer.wrap(Buffer.from(a,"base64")))});const s=this.options.useQueue?(0,h.createQueuedSender)(this.child):this.child,e=a=>this.child&&this.child.connected&&s.send(a.buffer.toString("base64")),n=d.event,i={send:e,onMessage:n};this._client=new v.ChannelClient(i);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",a=>console.warn('IPC "'+this.options.serverName+'" errored with '+a)),this.child.on("exit",(a,E)=>{process.removeListener("exit",r),this.activeRequests.forEach(P=>(0,g.dispose)(P)),this.activeRequests.clear(),a!==0&&E!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+a+" and signal "+E),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:a,signal:E})})}return this._client}getCachedChannel(f){let p=this.channels.get(f);return p||(p=this.client.getChannel(f),this.channels.set(f,p)),p}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=u}),define(ee[73],te([5,6]),function($,t){return $.create("vs/base/node/zip",t)}),define(ee[74],te([5,6]),function($,t){return $.create("vs/platform/configuration/common/configurationRegistry",t)}),define(ee[75],te([5,6]),function($,t){return $.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(ee[76],te([5,6]),function($,t){return $.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(ee[77],te([5,6]),function($,t){return $.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(ee[78],te([5,6]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(ee[79],te([5,6]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(ee[80],te([5,6]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(ee[81],te([5,6]),function($,t){return $.create("vs/platform/extensions/common/extensionValidator",t)}),define(ee[82],te([5,6]),function($,t){return $.create("vs/platform/files/common/fileService",t)}),define(ee[83],te([5,6]),function($,t){return $.create("vs/platform/files/common/io",t)}),define(ee[84],te([5,6]),function($,t){return $.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(ee[85],te([5,6]),function($,t){return $.create("vs/platform/request/common/request",t)}),define(ee[86],te([5,6]),function($,t){return $.create("vs/platform/telemetry/common/telemetryService",t)}),define(ee[87],te([0,1,69,46,8,4,29,19,7]),function($,t,C,b,S,L,D,I,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class g{constructor(l,u,y){this._args=l,this.paths=u,this.productService=y}get appRoot(){return(0,L.dirname)(S.FileAccess.asFileUri("",$).fsPath)}get userHome(){return c.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return c.URI.file((0,L.join)(this.userDataPath,"User"))}get tmpDir(){return c.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,I.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,I.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const l=(0,C.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.join)(this.userDataPath,"logs",l)}return this.args.logsPath}get userDataSyncLogResource(){return c.URI.file((0,L.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(c.URI.file((0,L.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return c.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return c.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const l=D.env.VSCODE_PORTABLE;return l?c.URI.file((0,L.join)(l,"argv.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,I.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return c.URI.file((0,L.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,L.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const l=this.args["builtin-extensions-dir"];return l?(0,L.resolve)(l):(0,L.normalize)((0,L.join)(S.FileAccess.asFileUri("",$).fsPath,"..","extensions"))}get extensionsDownloadPath(){const l=this.args["extensions-download-dir"];return l?(0,L.resolve)(l):(0,L.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const l=this.args["extensions-dir"];if(l)return(0,L.resolve)(l);const u=D.env.VSCODE_EXTENSIONS;if(u)return u;const y=D.env.VSCODE_PORTABLE;return y?(0,L.join)(y,"extensions"):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const l=this.args.extensionDevelopmentPath;if(Array.isArray(l))return l.map(u=>/^[^:/?#]+?:\/\//.test(u)?c.URI.parse(u):c.URI.file((0,L.normalize)(u)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(l=>l==="ui"||l==="workspace"||l==="web"?l:"workspace")}get extensionTestsLocationURI(){const l=this.args.extensionTestsPath;if(l)return/^[^:/?#]+?:\/\//.test(l)?c.URI.parse(l):c.URI.file((0,L.normalize)(l))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const l=this.args["disable-extension"];if(l){if(typeof l=="string")return[l];if(Array.isArray(l)&&l.length>0)return l}return!1}get debugExtensionHost(){return m(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,I.joinPath)(c.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return c.URI.file((0,L.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}fe([b.memoize],g.prototype,"appRoot",null),fe([b.memoize],g.prototype,"userHome",null),fe([b.memoize],g.prototype,"userDataPath",null),fe([b.memoize],g.prototype,"appSettingsHome",null),fe([b.memoize],g.prototype,"tmpDir",null),fe([b.memoize],g.prototype,"userRoamingDataHome",null),fe([b.memoize],g.prototype,"settingsResource",null),fe([b.memoize],g.prototype,"userDataSyncHome",null),fe([b.memoize],g.prototype,"userDataSyncLogResource",null),fe([b.memoize],g.prototype,"sync",null),fe([b.memoize],g.prototype,"machineSettingsResource",null),fe([b.memoize],g.prototype,"globalStorageHome",null),fe([b.memoize],g.prototype,"workspaceStorageHome",null),fe([b.memoize],g.prototype,"keybindingsResource",null),fe([b.memoize],g.prototype,"keyboardLayoutResource",null),fe([b.memoize],g.prototype,"argvResource",null),fe([b.memoize],g.prototype,"snippetsHome",null),fe([b.memoize],g.prototype,"isExtensionDevelopment",null),fe([b.memoize],g.prototype,"untitledWorkspacesHome",null),fe([b.memoize],g.prototype,"installSourcePath",null),fe([b.memoize],g.prototype,"builtinExtensionsPath",null),fe([b.memoize],g.prototype,"extensionsPath",null),fe([b.memoize],g.prototype,"extensionDevelopmentLocationURI",null),fe([b.memoize],g.prototype,"extensionDevelopmentKind",null),fe([b.memoize],g.prototype,"extensionTestsLocationURI",null),fe([b.memoize],g.prototype,"debugExtensionHost",null),fe([b.memoize],g.prototype,"serviceMachineIdResource",null),fe([b.memoize],g.prototype,"telemetryLogResource",null),fe([b.memoize],g.prototype,"disableWorkspaceTrust",null),t.AbstractNativeEnvironmentService=g;function m(v,l){return h(v["inspect-extensions"],v["inspect-brk-extensions"],5870,l,v.debugId)}t.parseExtensionHostPort=m;function R(v,l){return h(v["inspect-search"],v["inspect-brk-search"],5876,l)}t.parseSearchPort=R;function h(v,l,u,y,f){const d=Number(l||v)||(y?null:u),o=d?Boolean(!!l):!1;return{port:d,break:o,debugId:f}}}),function(){"use strict";function $(t,C,b,S){function L(I){const c=D(I),g=[c];return t.isAbsolute(c)||g.unshift(S),t.resolve(...g)}function D(I){const c=process.env.VSCODE_PORTABLE;if(c)return t.join(c,"user-data");let g=process.env.VSCODE_APPDATA;if(g)return t.join(g,b);const m=I["user-data-dir"];if(m)return m;switch(process.platform){case"win32":if(g=process.env.APPDATA,!g){const R=process.env.USERPROFILE;if(typeof R!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");g=t.join(R,"AppData","Roaming")}break;case"darwin":g=t.join(C.homedir(),"Library","Application Support");break;case"linux":g=process.env.XDG_CONFIG_HOME||t.join(C.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(g,b)}return{getUserDataPath:L}}if(typeof define=="function")define(ee[88],te([0,89,33,8,19,29]),function(t,C,b,S,L,D){const I=L.dirname(S.FileAccess.asFileUri("",t)),c=t.__$__nodeRequire(L.joinPath(I,"package.json").fsPath);return $(C,b,c.name,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),C=require("path"),b=require("os");module.exports=$(C,b,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ee[90],te([0,1,33,87,88]),function($,t,C,b,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class L extends b.AbstractNativeEnvironmentService{constructor(I,c){super(I,{homeDir:(0,C.homedir)(),tmpDir:(0,C.tmpdir)(),userDataDir:(0,S.getUserDataPath)(I)},c)}}t.NativeEnvironmentService=L}),define(ee[91],te([0,1,18]),function($,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const b=/^%([\w\d.-]+)%$/i;function S(L,D){const I=c=>{if(typeof c!="string")return;const g=b.exec(c);if(!g)return;const m=D[g[1]]??c;return typeof m=="string"?m:typeof m.message=="string"?m.message:c};return(0,C.cloneAndChange)(L,I)}t.localizeManifest=S}),define(ee[51],te([0,1,81]),function($,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const b=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function L(h){return h=h.trim(),h==="*"||b.test(h)}t.isValidVersionStr=L;function D(h){if(!L(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let v=h.match(b);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}t.parseVersion=D;function I(h){if(!h)return null;let v=h.majorBase,l=h.majorMustEqual,u=h.minorBase,y=h.minorMustEqual,f=h.patchBase,p=h.patchMustEqual;h.hasCaret&&(v===0||(y=!1),p=!1);let d=0;if(h.preRelease){const o=S.exec(h.preRelease);if(o){const[,s,e,n]=o;d=Date.UTC(Number(s),Number(e)-1,Number(n))}}return{majorBase:v,majorMustEqual:l,minorBase:u,minorMustEqual:y,patchBase:f,patchMustEqual:p,isMinimum:h.hasGreaterEquals,notBefore:d}}t.normalizeVersion=I;function c(h,v,l){let u;typeof h=="string"?u=I(D(h)):u=h;let y;v instanceof Date?y=v.getTime():typeof v=="string"&&(y=new Date(v).getTime());let f;if(typeof l=="string"?f=I(D(l)):f=l,!u||!f)return!1;let p=u.majorBase,d=u.minorBase,o=u.patchBase,s=f.majorBase,e=f.minorBase,n=f.patchBase,i=f.notBefore,r=f.majorMustEqual,a=f.minorMustEqual,E=f.patchMustEqual;return f.isMinimum?p>s?!0:p<s?!1:d>e?!0:d<e||y&&y<i?!1:o>=n:(p===1&&s===0&&(!r||!a||!E)&&(s=1,e=0,n=0,r=!0,a=!1,E=!1),p<s?!1:p>s?!r:d<e?!1:d>e?!a:o<n?!1:o>n?!E:!(y&&y<i))}t.isValidVersion=c;function g(h,v,l,u){return l.isBuiltin||typeof l.main=="undefined"?!0:R(h,v,l.engines.vscode,u)}t.isValidExtensionVersion=g;function m(h,v,l){return h==="*"||R(v,l,h)}t.isEngineValid=m;function R(h,v,l,u=[]){let y=I(D(l));if(!y)return u.push(C.localize(0,null,l)),!1;if(y.majorBase===0){if(!y.majorMustEqual||!y.minorMustEqual)return u.push(C.localize(1,null,l)),!1}else if(!y.majorMustEqual)return u.push(C.localize(2,null,l)),!1;return c(h,v,y)?!0:(u.push(C.localize(3,null,h,l)),!1)}}),define(ee[92],te([0,1,2,8,39,50]),function($,t,C,b,S,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class D extends C.Disposable{constructor(c,g,m,R){super();this.folders=c,this.onDidFilesChange=g,this.onLogMessage=m,this.verboseLogging=R,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const c=this._register(new L.Client(b.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(c.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=D.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=S.ProxyChannel.toService((0,S.getNextTickChannel)(c.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(g=>!this.isDisposed&&this.onDidFilesChange(g))),this._register(this.service.onDidLogMessage(g=>this.onLogMessage(g))),this.setFolders(this.folders)}setVerboseLogging(c){this.verboseLogging=c,!this.isDisposed&&this.service&&this.service.setVerboseLogging(c)}error(c){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${c}`})}setFolders(c){this.folders=c,this.service&&this.service.setRoots(c)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=D,D.MAX_RESTARTS=5}),define(ee[93],te([0,1,2,8,39,50]),function($,t,C,b,S,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class D extends C.Disposable{constructor(c,g,m,R,h={}){super();this.folders=c,this.onDidFilesChange=g,this.onLogMessage=m,this.verboseLogging=R,this.watcherOptions=h,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const c=this._register(new L.Client(b.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(c.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=D.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=S.ProxyChannel.toService((0,S.getNextTickChannel)(c.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(g=>!this.isDisposed&&this.onDidFilesChange(g))),this._register(this.service.onDidLogMessage(g=>this.onLogMessage(g))),this.service.setRoots(this.folders)}error(c){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${c}`})}setVerboseLogging(c){this.verboseLogging=c,this.service&&this.service.setVerboseLogging(c)}setFolders(c){this.folders=c,this.service&&this.service.setRoots(c)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=D,D.MAX_RESTARTS=5}),define(ee[94],te([0,1,34,62,8,48]),function($,t,C,b,S,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OutOfProcessWin32FolderWatcher=void 0;class D{constructor(c,g,m,R,h){this.watchedFolder=c,this.eventCallback=m,this.logCallback=R,this.verboseLogging=h,this.restartCounter=0,Array.isArray(g)?this.ignored=g.map(v=>(0,b.parse)(v)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${c}, excludes: ${g.join(",")}`),this.startWatcher()}startWatcher(){const c=[this.watchedFolder];this.verboseLogging&&c.push("-verbose"),this.handle=(0,C.spawn)(S.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",$).fsPath,c);const g=new L.LineDecoder;this.handle.stdout.on("data",m=>{const R=[];for(const h of g.write(m)){const v=h.split("|");if(v.length===2){const l=Number(v[0]),u=v[1];if(l>=0&&l<3){if(this.ignored&&this.ignored.some(y=>y(u))){this.verboseLogging&&this.log(u);continue}R.push({type:D.changeTypeMap[l],path:u})}else this.log(v[1])}}R.length>0&&this.eventCallback(R)}),this.handle.on("error",m=>this.onError(m)),this.handle.stderr.on("data",m=>this.onError(m)),this.handle.on("exit",(m,R)=>this.onExit(m,R))}onError(c){this.error("process error: "+c.toString())}onExit(c,g){this.handle&&(this.error(`terminated unexpectedly (code: ${c}, signal: ${g})`),this.restartCounter<=D.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(c){this.logCallback({type:"error",message:`[File Watcher (C#)] ${c}`})}log(c){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${c}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}t.OutOfProcessWin32FolderWatcher=D,D.MAX_RESTARTS=5,D.changeTypeMap=[0,1,2]}),define(ee[95],te([0,1,4,21,94]),function($,t,C,b,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class L{constructor(I,c,g,m){this.onDidFilesChange=c,this.onLogMessage=g,this.verboseLogging=m,this.service=void 0,this.folder=I[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(C.posix.sep)&&(this.folder.path=(0,b.rtrim)(this.folder.path,C.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new S.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,I=>this.onFileEvents(I),I=>this.onLogMessage(I),this.verboseLogging)}setVerboseLogging(I){this.verboseLogging=I,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(I){this.isDisposed||I.length>0&&this.onDidFilesChange(I)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}t.FileWatcher=L}),define(ee[52],te([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class C{constructor(S,L=[],D=!1){this.ctor=S,this.staticArguments=L,this.supportsDelayedInstantiation=D}}t.SyncDescriptor=C}),define(ee[96],te([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class C{constructor(L){this.incoming=new Map,this.outgoing=new Map,this.data=L}}t.Node=C;class b{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(let D of this._nodes.values())D.outgoing.size===0&&L.push(D);return L}insertEdge(L,D){const I=this.lookupOrInsertNode(L),c=this.lookupOrInsertNode(D);I.outgoing.set(this._hashFn(D),c),c.incoming.set(this._hashFn(L),I)}removeNode(L){const D=this._hashFn(L);this._nodes.delete(D);for(let I of this._nodes.values())I.outgoing.delete(D),I.incoming.delete(D)}lookupOrInsertNode(L){const D=this._hashFn(L);let I=this._nodes.get(D);return I||(I=new C(L),this._nodes.set(D,I)),I}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){let L=[];for(let[D,I]of this._nodes)L.push(`${D}, (incoming)[${[...I.incoming.keys()].join(", ")}], (outgoing)[${[...I.outgoing.keys()].join(",")}]`);return L.join(`
`)}findCycleSlow(){for(let[L,D]of this._nodes){const I=new Set([L]),c=this._findCycle(D,I);if(c)return c}}_findCycle(L,D){for(let[I,c]of L.outgoing){if(D.has(I))return[...D,I].join(" -> ");D.add(I);const g=this._findCycle(c,D);if(g)return g;D.delete(I)}}}t.Graph=b}),define(ee[53],te([0,1,14]),function($,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,C.createDecorator)("downloadService")}),define(ee[20],te([0,1,14]),function($,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,C.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,C.refineServiceDecorator)(t.IEnvironmentService)}),define(ee[23],te([0,1,8,9,29,76,14]),function($,t,C,b,S,L,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.CURRENT_TARGET_PLATFORM=t.getTargetPlatform=t.getTargetPlatformFromOS=t.toTargetPlatform=t.TargetPlatform=t.WEB_EXTENSION_TAG=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.WEB_EXTENSION_TAG="__web_extension";var I;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(I=t.TargetPlatform||(t.TargetPlatform={}));function c(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}t.toTargetPlatform=c;function g(f,p){let d;switch(f){case 1:d=3;break;case 3:d=2;break;case 2:d=1;break}return m(d,p)}t.getTargetPlatformFromOS=g;function m(f,p){switch(f){case 3:return p==="x64"?"win32-x64":p==="ia32"?"win32-ia32":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}t.getTargetPlatform=m,t.CURRENT_TARGET_PLATFORM=b.isWeb?"web":m(b.platform,S.arch);function R(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}t.isIExtensionIdentifier=R;var h;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=5]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(h=t.SortBy||(t.SortBy={}));var v;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(v=t.SortOrder||(t.SortOrder={}));var l;(function(f){f.Install="install",f.Uninstall="uninstall"})(l=t.StatisticType||(t.StatisticType={}));var u;(function(f){f[f.None=0]="None",f[f.Install=1]="Install",f[f.Update=2]="Update"})(u=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService"),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class y extends Error{constructor(p,d){super(p);this.code=d,this.name=d}}t.ExtensionManagementError=y,t.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),t.DefaultIconPath=C.FileAccess.asBrowserUri("./media/defaultIcon.png",$).toString(!0),t.ExtensionsLabel=(0,L.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,L.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,D.createDecorator)("IExtensionManagementCLIService")}),define(ee[40],te([0,1,21,14]),function($,t,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isAuthenticaionProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkspaceSupportTypeMessage=t.ALL_EXTENSION_KINDS=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin",t.ALL_EXTENSION_KINDS=["ui","workspace","web"];function S(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}t.getWorkspaceSupportTypeMessage=S;function L(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}t.isIExtensionIdentifier=L,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(D=t.ExtensionType||(t.ExtensionType={}));class I{constructor(R){this.value=R,this._lower=R.toLowerCase()}static equals(R,h){if(typeof R=="undefined"||R===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof R=="string"||typeof h=="string"){let v=typeof R=="string"?R:R.value,l=typeof h=="string"?h:h.value;return C.equalsIgnoreCase(v,l)}return R._lower===h._lower}static toKey(R){return typeof R=="string"?R.toLowerCase():R._lower}}t.ExtensionIdentifier=I;function c(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}t.isLanguagePackExtension=c;function g(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}t.isAuthenticaionProviderExtension=g,t.IBuiltinExtensionsScannerService=(0,b.createDecorator)("IBuiltinExtensionsScannerService")}),define(ee[24],te([0,1,21,40]),function($,t,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getExtensionDependencies=t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function S(l,u){return l.uuid&&u.uuid?l.uuid===u.uuid:l.id===u.id?!0:(0,C.compareIgnoreCase)(l.id,u.id)===0}t.areSameExtensions=S;class L{constructor(u,y){this.version=y,this.id=u.id,this.uuid=u.uuid}key(){return`${this.id}-${this.version}`}equals(u){return u instanceof L?S(this,u)&&this.version===u.version:!1}}t.ExtensionIdentifierWithVersion=L;function D(l,u){return`${l}.${u}`}t.getExtensionId=D;function I(l){return l.toLocaleLowerCase()}t.adoptToGalleryExtensionId=I;function c(l,u){return I(D(l,u))}t.getGalleryExtensionId=c;function g(l,u){const y=[],f=p=>{for(const d of y)if(d.some(o=>S(u(o),u(p))))return d;return null};for(const p of l){const d=f(p);d?d.push(p):y.push([p])}return y}t.groupByExtension=g;function m(l){return{id:l.identifier.id,name:l.manifest.name,galleryId:null,publisherId:l.publisherId,publisherName:l.manifest.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:l.manifest.extensionDependencies&&l.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=m;function R(l){return{id:l.identifier.id,name:l.name,galleryId:l.identifier.uuid,publisherId:l.publisherId,publisherName:l.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:!!(l.properties.dependencies&&l.properties.dependencies.length>0),...l.telemetryData}}t.getGalleryExtensionTelemetryData=R,t.BetterMergeId=new b.ExtensionIdentifier("pprice.better-merge");function h(l){const u=new Set;for(const y of l)y.malicious&&u.add(y.id.id);return u}t.getMaliciousExtensionsSet=h;function v(l,u){const y=[],f=u.manifest.extensionDependencies?.slice(0)??[];for(;f.length;){const p=f.shift();if(p&&y.every(d=>!S(d.identifier,{id:p}))){const d=l.filter(o=>S(o.identifier,{id:p}));d.length===1&&(y.push(d[0]),f.push(...d[0].manifest.extensionDependencies?.slice(0)??[]))}}return y}t.getExtensionDependencies=v});var ue=this&&this.__param||function($,t){return function(C,b){t(C,b,$)}};define(ee[97],te([0,1,25,11,63,8,41,7,77,23,24,40]),function($,t,C,b,S,L,D,I,c,g,m,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const h=p=>(0,c.localize)(0,null,p),v=(0,c.localize)(1,null,"ms-dotnettools.csharp");function l(p,d){return d?`${p.publisher}.${p.name}@${p.version}`:`${p.publisher}.${p.name}`}const u=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function y(p){const d=u.exec(p);return d&&d[1]?[(0,m.adoptToGalleryExtensionId)(d[1]),d[2]]:[(0,m.adoptToGalleryExtensionId)(p),void 0]}t.getIdAndVersion=y;let f=class{constructor(d,o){this.extensionManagementService=d,this.extensionGalleryService=o}get location(){}async listExtensions(d,o,s=console){let e=await this.extensionManagementService.getInstalled(1);const n=R.EXTENSION_CATEGORIES.map(r=>r.toLowerCase());if(o&&o!==""){if(n.indexOf(o.toLowerCase())<0){s.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}e=e.filter(r=>r.manifest.categories?r.manifest.categories.map(E=>E.toLowerCase()).indexOf(o.toLowerCase())>-1:!1)}else if(o===""){s.log("Possible Categories: "),n.forEach(r=>{s.log(r)});return}this.location&&s.log((0,c.localize)(2,null,this.location)),e=e.sort((r,a)=>r.identifier.id.localeCompare(a.identifier.id));let i;for(let r of e)i!==r.identifier.id&&(i=r.identifier.id,s.log(l(r.manifest,d)))}async installExtensions(d,o,s,e,n=console){const i=[],r=[];d.length&&n.log(this.location?(0,c.localize)(3,null,this.location):(0,c.localize)(4,null));const a=await this.extensionManagementService.getInstalled(1),E=(w,T)=>{const M=a.find(j=>(0,m.areSameExtensions)(j.identifier,{id:w}));if(M){if(!T&&!e)return n.log((0,c.localize)(5,null,w,M.manifest.version,w)),!1;if(T&&M.manifest.version===T)return n.log((0,c.localize)(6,null,`${w}@${T}`)),!1}return!0},P=[],A=[];for(const w of d)if(w instanceof I.URI)P.push(w);else{const[T,M]=y(w);E(T,M)&&A.push({id:T,version:M,installOptions:{isBuiltin:!1,isMachineScoped:s}})}for(const w of o){const[T,M]=y(w);E(T,M)&&A.push({id:T,version:M,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(P.length&&await Promise.all(P.map(async w=>{try{const T=await this.installVSIX(w,{isBuiltin:!1,isMachineScoped:s},e,n);T&&r.push(T)}catch(T){n.error(T.message||T.stack||T),i.push(w.toString())}})),A.length){const w=await this.getGalleryExtensions(A);await Promise.all(A.map(async T=>{const M=w.get(T.id.toLowerCase());if(M)try{const j=await this.installFromGallery(T,M,a,e,n);j&&r.push(j)}catch(j){n.error(j.message||j.stack||j),i.push(T.id)}else n.error(`${h(T.version?`${T.id}@${T.version}`:T.id)}
${v}`),i.push(T.id)}))}if(i.length)throw new Error((0,c.localize)(7,null,i.join(", ")))}async installVSIX(d,o,s,e){const n=await this.extensionManagementService.getManifest(d);if(!n)throw new Error("Invalid vsix");if(await this.validateVSIX(n,s,e))try{return await this.extensionManagementService.install(d,o),e.log((0,c.localize)(8,null,(0,S.getBaseLabel)(d))),n}catch(r){if((0,b.isPromiseCanceledError)(r))return e.log((0,c.localize)(9,null,(0,S.getBaseLabel)(d))),null;throw r}return null}async getGalleryExtensions(d){const o=new Map,s=await this.extensionGalleryService.getExtensions(d,C.CancellationToken.None);for(const e of s)o.set(e.identifier.id.toLowerCase(),e);return o}async installFromGallery({id:d,version:o,installOptions:s},e,n,i,r){const a=await this.extensionGalleryService.getManifest(e,C.CancellationToken.None);if(a&&!this.validateExtensionKind(a,r))return null;const E=n.find(P=>(0,m.areSameExtensions)(P.identifier,e.identifier));if(E){if(e.version===E.manifest.version)return r.log((0,c.localize)(10,null,o?`${d}@${o}`:d)),null;r.log((0,c.localize)(11,null,d,e.version))}try{return s.isBuiltin?r.log(o?(0,c.localize)(12,null,d,o):(0,c.localize)(13,null,d)):r.log(o?(0,c.localize)(14,null,d,o):(0,c.localize)(15,null,d)),await this.extensionManagementService.installFromGallery(e,{...s,installGivenVersion:!!o}),r.log((0,c.localize)(16,null,d,e.version)),a}catch(P){if((0,b.isPromiseCanceledError)(P))return r.log((0,c.localize)(17,null,d)),null;throw P}}validateExtensionKind(d,o){return!0}async validateVSIX(d,o,s){const e={id:(0,m.getGalleryExtensionId)(d.publisher,d.name)},i=(await this.extensionManagementService.getInstalled(1)).find(r=>(0,m.areSameExtensions)(e,r.identifier)&&(0,D.gt)(r.manifest.version,d.version));return i&&!o?(s.log((0,c.localize)(18,null,i.identifier.id,i.manifest.version,d.version)),!1):this.validateExtensionKind(d,s)}async uninstallExtensions(d,o,s=console){const e=async i=>{if(i instanceof I.URI){const r=await this.extensionManagementService.getManifest(i);return l(r)}return i},n=[];for(const i of d){const r=await e(i),E=(await this.extensionManagementService.getInstalled()).filter(P=>(0,m.areSameExtensions)(P.identifier,{id:r}));if(!E.length)throw new Error(`${this.notInstalled(r)}
${v}`);if(E.some(P=>P.type===0)){s.log((0,c.localize)(19,null,r));return}if(!o&&E.some(P=>P.isBuiltin)){s.log((0,c.localize)(20,null,r));return}s.log((0,c.localize)(21,null,r));for(const P of E)await this.extensionManagementService.uninstall(P),n.push(P);this.location?s.log((0,c.localize)(22,null,r,this.location)):s.log((0,c.localize)(23,null,r))}}async locateExtension(d,o=console){const s=await this.extensionManagementService.getInstalled();d.forEach(e=>{s.forEach(n=>{if(n.identifier.id===e&&n.location.scheme===L.Schemas.file){o.log(n.location.fsPath);return}})})}notInstalled(d){return this.location?(0,c.localize)(24,null,d,this.location):(0,c.localize)(25,null,d)}};f=fe([ue(0,g.IExtensionManagementService),ue(1,g.IExtensionGalleryService)],f),t.ExtensionManagementCLIService=f}),define(ee[98],te([0,1,2,4,10,40]),function($,t,C,b,S,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class D extends C.Disposable{constructor(c,g){super();this.environmentService=c,this.extensionsManifestCache=(0,b.join)(this.environmentService.userDataPath,L.MANIFEST_CACHE_FOLDER,L.USER_MANIFEST_CACHE_FILE),this._register(g.onDidInstallExtensions(m=>this.onDidInstallExtensions(m))),this._register(g.onDidUninstallExtension(m=>this.onDidUnInstallExtension(m)))}onDidInstallExtensions(c){c.some(g=>!!g.local)&&this.invalidate()}onDidUnInstallExtension(c){c.error||this.invalidate()}invalidate(){S.Promises.rm(this.extensionsManifestCache,S.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=D}),define(ee[99],te([0,1,34,89,25,28,11,9,30,72,129]),function($,t,C,b,S,L,D,I,c,g,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveShellEnv=void 0;async function R(l,u,y){return u["force-disable-user-env"]?(l.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):I.isWindows?(l.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,m.isLaunchedFromCli)(y)&&!u["force-user-env"]?(l.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,m.isLaunchedFromCli)(y)?l.trace("resolveShellEnv(): running (--force-user-env)"):l.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=new Promise(async f=>{const p=new S.CancellationTokenSource,d=setTimeout(()=>{l.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),p.dispose(!0),f({})},1e4);try{const o=await v(l,p.token);f(o)}catch(o){(0,D.isPromiseCanceledError)(o)||l.error(`[resolve shell env] Unable to resolve shell environment (${o}). Proceeding without shell environment...`),f({})}finally{clearTimeout(d),p.dispose()}})),h)}t.resolveShellEnv=R;let h;async function v(l,u){const y=new Promise(async(f,p)=>{const d=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",d);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",o);const s=(0,c.generateUuid)().replace(/-/g,"").substr(0,12),e=new RegExp(s+"(.*)"+s),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};l.trace("getUnixShellEnvironment#env",n);const i=await(0,g.getSystemShell)(I.OS,n);if(l.trace("getUnixShellEnvironment#shell",i),u.isCancellationRequested)return p(D.canceled);const r=b.basename(i);let a,E;/^pwsh(-preview)?$/.test(r)?(a=`& '${process.execPath}' -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,E=["-Login","-Command"]):(a=`'${process.execPath}' -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,E=["-ilc"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(E),a);const P=(0,C.spawn)(i,[...E,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});u.onCancellationRequested(()=>(P.kill(),p(D.canceled))),P.on("error",T=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,L.toErrorMessage)(T)),f({})});const A=[];P.stdout.on("data",T=>A.push(T));const w=[];P.stderr.on("data",T=>w.push(T)),P.on("close",(T,M)=>{const j=Buffer.concat(A).toString("utf8");l.trace("getUnixShellEnvironment#raw",j);const Y=Buffer.concat(w).toString("utf8");if(Y.trim()&&l.trace("getUnixShellEnvironment#stderr",Y),T||M)return p(new Error(`Failed to get environment (code ${T}, signal ${M})`));const ie=e.exec(j),oe=ie?ie[1]:"{}";try{const Z=JSON.parse(oe);d?Z.ELECTRON_RUN_AS_NODE=d:delete Z.ELECTRON_RUN_AS_NODE,o?Z.ELECTRON_NO_ATTACH_CONSOLE=o:delete Z.ELECTRON_NO_ATTACH_CONSOLE,delete Z.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",Z),f(Z)}catch(Z){l.error("getUnixShellEnvironment#errorCaught",(0,L.toErrorMessage)(Z)),p(Z)}})});try{return await y}catch(f){return l.error("getUnixShellEnvironment#error",(0,L.toErrorMessage)(f)),{}}}}),define(ee[54],te([0,1,9,7,16]),function($,t,C,b,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=void 0;function L(c){return c.map(g=>({type:g.type,resource:b.URI.file(g.path)}))}t.toFileChanges=L;function D(c){const g=new I;for(const m of c)g.processEvent(m);return g.normalize()}t.normalizeFileChanges=D;class I{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(g){const m=this.mapPathToChange.get(g.path);if(m){const R=m.type,h=g.type;R===1&&h===2?(this.mapPathToChange.delete(g.path),this.normalized.splice(this.normalized.indexOf(m),1)):R===2&&h===1?m.type=0:R===1&&h===0||(m.type=h)}else this.normalized.push(g),this.mapPathToChange.set(g.path,g)}normalize(){const g=[],m=[];return this.normalized.filter(R=>R.type!==2?(g.push(R),!1):!0).sort((R,h)=>R.path.length-h.path.length).filter(R=>m.some(h=>(0,S.isParent)(R.path,h,!C.isLinux))?!1:(m.push(R.path),!0)).concat(g)}}}),define(ee[100],te([0,1,3,2,4,64,10,66,54]),function($,t,C,b,S,L,D,I,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class g extends b.Disposable{constructor(R,h,v,l){super();this.path=R,this.onDidFilesChange=h,this.onLogMessage=v,this.verboseLogging=l,this.fileChangesDelayer=this._register(new C.ThrottledDelayer(I.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(R){this.verboseLogging=R}async startWatching(){try{const{stat:R,symbolicLink:h}=await D.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let v=this.path;if(h)try{v=await(0,L.realpath)(v)}catch(l){if(this.onError(l),h.dangling)return}R.isDirectory()?this._register((0,I.watchFolder)(v,(l,u)=>{this.onFileChange({type:l==="changed"?0:l==="added"?1:2,path:(0,S.join)(this.path,(0,S.basename)(u))})},l=>this.onError(l))):this._register((0,I.watchFile)(v,l=>{this.onFileChange({type:l==="changed"?0:2,path:this.path})},l=>this.onError(l)))}catch(R){R.code!=="ENOENT"&&this.onError(R)}}onFileChange(R){this.fileChangesBuffer.push(R),this.verboseLogging&&this.onVerbose(`${R.type===1?"[ADDED]":R.type===2?"[DELETED]":"[CHANGED]"} ${R.path}`),this.fileChangesDelayer.trigger(async()=>{const h=this.fileChangesBuffer;this.fileChangesBuffer=[];const v=(0,c.normalizeFileChanges)(h);if(this.verboseLogging)for(const l of v)this.onVerbose(`>> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.path}`);v.length>0&&this.onDidFilesChange(v)})}onError(R){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${R}`})}onVerbose(R){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${R}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=g}),define(ee[55],te([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class C{constructor(...S){this._entries=new Map;for(let[L,D]of S)this.set(L,D)}set(S,L){const D=this._entries.get(S);return this._entries.set(S,L),D}has(S){return this._entries.has(S)}get(S){return this._entries.get(S)}}t.ServiceCollection=C}),define(ee[101],te([0,1,3,11,52,96,14,55]),function($,t,C,b,S,L,D,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const c=!1;class g extends Error{constructor(l){super("cyclic dependency between services");this.message=l.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class m{constructor(l=new I.ServiceCollection,u=!1,y){this._activeInstantiations=new Set,this._services=l,this._strict=u,this._parent=y,this._services.set(D.IInstantiationService,this)}createChild(l){return new m(l,this._strict,this)}invokeFunction(l,...u){let y=h.traceInvocation(l),f=!1;try{return l({get:(d,o)=>{if(f)throw(0,b.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(d,y);if(!s&&o!==D.optional)throw new Error(`[invokeFunction] unknown service '${d}'`);return s}},...u)}finally{f=!0,y.stop()}}createInstance(l,...u){let y,f;return l instanceof S.SyncDescriptor?(y=h.traceCreation(l.ctor),f=this._createInstance(l.ctor,l.staticArguments.concat(u),y)):(y=h.traceCreation(l),f=this._createInstance(l,u,y)),y.stop(),f}_createInstance(l,u=[],y){let f=D._util.getServiceDependencies(l).sort((o,s)=>o.index-s.index),p=[];for(const o of f){let s=this._getOrCreateServiceInstance(o.id,y);if(!s&&this._strict&&!o.optional)throw new Error(`[createInstance] ${l.name} depends on UNKNOWN service ${o.id}.`);p.push(s)}let d=f.length>0?f[0].index:u.length;if(u.length!==d){console.warn(`[createInstance] First service dependency of ${l.name} at position ${d+1} conflicts with ${u.length} static arguments`);let o=d-u.length;o>0?u=u.concat(new Array(o)):u=u.slice(0,d)}return new l(...[...u,...p])}_setServiceInstance(l,u){if(this._services.get(l)instanceof S.SyncDescriptor)this._services.set(l,u);else if(this._parent)this._parent._setServiceInstance(l,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(l){let u=this._services.get(l);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(l):u}_getOrCreateServiceInstance(l,u){let y=this._getServiceInstanceOrDescriptor(l);return y instanceof S.SyncDescriptor?this._safeCreateAndCacheServiceInstance(l,y,u.branch(l,!0)):(u.branch(l,!1),y)}_safeCreateAndCacheServiceInstance(l,u,y){if(this._activeInstantiations.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this._activeInstantiations.add(l);try{return this._createAndCacheServiceInstance(l,u,y)}finally{this._activeInstantiations.delete(l)}}_createAndCacheServiceInstance(l,u,y){const f=new L.Graph(o=>o.id.toString());let p=0;const d=[{id:l,desc:u,_trace:y}];for(;d.length;){const o=d.pop();if(f.lookupOrInsertNode(o),p++>1e3)throw new g(f);for(let s of D._util.getServiceDependencies(o.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(s.id);if(!e&&!s.optional&&console.warn(`[createInstance] ${l} depends on ${s.id} which is NOT registered.`),e instanceof S.SyncDescriptor){const n={id:s.id,desc:e,_trace:o._trace.branch(s.id,!0)};f.insertEdge(o,n),d.push(n)}}}for(;;){const o=f.roots();if(o.length===0){if(!f.isEmpty())throw new g(f);break}for(const{data:s}of o){if(this._getServiceInstanceOrDescriptor(s.id)instanceof S.SyncDescriptor){const n=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,n)}f.removeNode(s)}}return this._getServiceInstanceOrDescriptor(l)}_createServiceInstanceWithOwner(l,u,y=[],f,p){if(this._services.get(l)instanceof S.SyncDescriptor)return this._createServiceInstance(u,y,f,p);if(this._parent)return this._parent._createServiceInstanceWithOwner(l,u,y,f,p);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(l,u=[],y,f){if(y){const p=new C.IdleValue(()=>this._createInstance(l,u,f));return new Proxy(Object.create(null),{get(d,o){if(o in d)return d[o];let s=p.value,e=s[o];return typeof e!="function"||(e=e.bind(s),d[o]=e),e},set(d,o,s){return p.value[o]=s,!0}})}else return this._createInstance(l,u,f)}}t.InstantiationService=m;var R;(function(v){v[v.Creation=0]="Creation",v[v.Invocation=1]="Invocation",v[v.Branch=2]="Branch"})(R||(R={}));class h{constructor(l,u){this.type=l,this.name=u,this._start=Date.now(),this._dep=[]}static traceInvocation(l){return c?new h(1,l.name||l.toString().substring(0,42).replace(/\n/g,"")):h._None}static traceCreation(l){return c?new h(0,l.name):h._None}branch(l,u){let y=new h(2,l.toString());return this._dep.push([l,u,y]),y}stop(){let l=Date.now()-this._start;h._totals+=l;let u=!1;function y(p,d){let o=[],s=new Array(p+1).join("	");for(const[e,n,i]of d._dep)if(n&&i){u=!0,o.push(`${s}CREATES -> ${e}`);let r=y(p+1,i);r&&o.push(r)}else o.push(`${s}uses -> ${e}`);return o.join(`
`)}let f=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${y(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${h._totals.toFixed(2)}ms)`];(l>2||u)&&console.log(f.join(`
`))}}h._None=new class extends h{constructor(){super(-1,null)}stop(){}branch(){return this}},h._totals=0}),define(ee[56],te([0,1,14]),function($,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,C.createDecorator)("localizationsService");function b(S){if(typeof S.languageId!="string"||!Array.isArray(S.translations)||S.translations.length===0)return!1;for(const L of S.translations)if(typeof L.id!="string"||typeof L.path!="string")return!1;return!(S.languageName&&typeof S.languageName!="string"||S.localizedLanguageName&&typeof S.localizedLanguageName!="string")}t.isValidLocalization=b}),define(ee[15],te([0,1,28,13,2,9,14]),function($,t,C,b,S,L,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,D.createDecorator)("logService"),t.ILoggerService=(0,D.createDecorator)("loggerService");function I(){return new Date().toISOString()}var c;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(c=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=c.Info;class g extends S.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new b.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=g;class m extends g{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...n){this.checkLogLevel(c.Trace)&&this.log(c.Trace,this.format([e,...n]))}debug(e,...n){this.checkLogLevel(c.Debug)&&this.log(c.Debug,this.format([e,...n]))}info(e,...n){this.checkLogLevel(c.Info)&&this.log(c.Info,this.format([e,...n]))}warn(e,...n){this.checkLogLevel(c.Warning)&&this.log(c.Warning,this.format([e,...n]))}error(e,...n){if(this.checkLogLevel(c.Error))if(e instanceof Error){const i=Array.prototype.slice.call(arguments);i[0]=e.stack,this.log(c.Error,this.format(i))}else this.log(c.Error,this.format([e,...n]))}critical(e,...n){this.checkLogLevel(c.Critical)&&this.log(c.Critical,this.format([e,...n]))}flush(){}format(e){let n="";for(let i=0;i<e.length;i++){let r=e[i];if(typeof r=="object")try{r=JSON.stringify(r)}catch(a){}n+=(i>0?" ":"")+r}return n}}t.AbstractMessageLogger=m;class R extends g{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!L.isWindows}trace(e,...n){this.getLevel()<=c.Trace&&(this.useColors?console.log(`[90m[main ${I()}][0m`,e,...n):console.log(`[main ${I()}]`,e,...n))}debug(e,...n){this.getLevel()<=c.Debug&&(this.useColors?console.log(`[90m[main ${I()}][0m`,e,...n):console.log(`[main ${I()}]`,e,...n))}info(e,...n){this.getLevel()<=c.Info&&(this.useColors?console.log(`[90m[main ${I()}][0m`,e,...n):console.log(`[main ${I()}]`,e,...n))}warn(e,...n){this.getLevel()<=c.Warning&&(this.useColors?console.warn(`[93m[main ${I()}][0m`,e,...n):console.warn(`[main ${I()}]`,e,...n))}error(e,...n){this.getLevel()<=c.Error&&(this.useColors?console.error(`[91m[main ${I()}][0m`,e,...n):console.error(`[main ${I()}]`,e,...n))}critical(e,...n){this.getLevel()<=c.Critical&&(this.useColors?console.error(`[90m[main ${I()}][0m`,e,...n):console.error(`[main ${I()}]`,e,...n))}dispose(){}flush(){}}t.ConsoleMainLogger=R;class h extends g{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...n){this.getLevel()<=c.Trace&&console.log("%cTRACE","color: #888",e,...n)}debug(e,...n){this.getLevel()<=c.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...n)}info(e,...n){this.getLevel()<=c.Info&&console.log("%c INFO","color: #33f",e,...n)}warn(e,...n){this.getLevel()<=c.Warning&&console.log("%c WARN","color: #993",e,...n)}error(e,...n){this.getLevel()<=c.Error&&console.log("%c  ERR","color: #f33",e,...n)}critical(e,...n){this.getLevel()<=c.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...n)}dispose(){}flush(){}}t.ConsoleLogger=h;class v extends g{constructor(e,n=t.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(n)}trace(e,...n){this.getLevel()<=c.Trace&&this.adapter.log(c.Trace,[this.extractMessage(e),...n])}debug(e,...n){this.getLevel()<=c.Debug&&this.adapter.log(c.Debug,[this.extractMessage(e),...n])}info(e,...n){this.getLevel()<=c.Info&&this.adapter.log(c.Info,[this.extractMessage(e),...n])}warn(e,...n){this.getLevel()<=c.Warning&&this.adapter.log(c.Warning,[this.extractMessage(e),...n])}error(e,...n){this.getLevel()<=c.Error&&this.adapter.log(c.Error,[this.extractMessage(e),...n])}critical(e,...n){this.getLevel()<=c.Critical&&this.adapter.log(c.Critical,[this.extractMessage(e),...n])}extractMessage(e){return typeof e=="string"?e:(0,C.toErrorMessage)(e,this.getLevel()<=c.Trace)}dispose(){}flush(){}}t.AdapterLogger=v;class l extends g{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const n of this.logServices)n.setLevel(e);super.setLevel(e)}trace(e,...n){for(const i of this.logServices)i.trace(e,...n)}debug(e,...n){for(const i of this.logServices)i.debug(e,...n)}info(e,...n){for(const i of this.logServices)i.info(e,...n)}warn(e,...n){for(const i of this.logServices)i.warn(e,...n)}error(e,...n){for(const i of this.logServices)i.error(e,...n)}critical(e,...n){for(const i of this.logServices)i.critical(e,...n)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}t.MultiplexLogService=l;class u extends S.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...n){this.logger.trace(e,...n)}debug(e,...n){this.logger.debug(e,...n)}info(e,...n){this.logger.info(e,...n)}warn(e,...n){this.logger.warn(e,...n)}error(e,...n){this.logger.error(e,...n)}critical(e,...n){this.logger.critical(e,...n)}flush(){this.logger.flush()}}t.LogService=u;class y extends S.Disposable{constructor(e,n){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(i=>{this.logLevel=i,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(i))}))}getLogger(e){return this.loggers.get(e.toString())}createLogger(e,n){let i=this.loggers.get(e.toString());return i||(i=this.doCreateLogger(e,n?.always?c.Trace:this.logLevel,n),this.loggers.set(e.toString(),i),n?.always||this.logLevelChangeableLoggers.push(i)),i}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=y;class f{constructor(){this.onDidChangeLogLevel=new b.Emitter().event}setLevel(e){}getLevel(){return c.Info}trace(e,...n){}debug(e,...n){}info(e,...n){}warn(e,...n){}error(e,...n){}critical(e,...n){}dispose(){}flush(){}}t.NullLogService=f;function p(s){if(s.verbose)return c.Trace;if(typeof s.logLevel=="string"){const e=d(s.logLevel.toLowerCase());if(e!==void 0)return e}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=p;function d(s){switch(s){case"trace":return c.Trace;case"debug":return c.Debug;case"info":return c.Info;case"warn":return c.Warning;case"error":return c.Error;case"critical":return c.Critical;case"off":return c.Off}}t.parseLogLevel=d;function o(s){switch(s){case c.Trace:return"trace";case c.Debug:return"debug";case c.Info:return"info";case c.Warning:return"warn";case c.Error:return"error";case c.Critical:return"critical";case c.Off:return"off"}}t.LogLevelToString=o}),define(ee[102],te([0,1,3,11,2,9,19,41,7,30,10,20,23,24,16,15]),function($,t,C,b,S,L,D,I,c,g,m,R,h,v,l,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let f=class extends S.Disposable{constructor(d,o,s,e){super();this.fileService=o,this.extensionGalleryService=s,this.logService=e,this.extensionsDownloadDir=c.URI.file(d.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(d,o){await this.cleanUpPromise;const s=this.getName(d),e=(0,D.joinPath)(this.extensionsDownloadDir,s);if(!await this.fileService.exists(e)){const n=(0,D.joinPath)(this.extensionsDownloadDir,`.${(0,g.generateUuid)()}`);await this.fileService.exists(n)||await this.extensionGalleryService.download(d,n,o);try{await this.rename(n,e,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(n)}catch(r){}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",d.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,b.getErrorMessage)(i)}. Deleted the vsix from downloaded location`,n.path),i}}return e}async delete(d){}async rename(d,o,s){try{await m.Promises.rename(d.fsPath,o.fsPath)}catch(e){if(L.isWindows&&e&&e.code==="EPERM"&&Date.now()<s)return this.logService.info(`Failed renaming ${d} to ${o} with 'EPERM' error. Trying again...`),this.rename(d,o,s);throw e}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const d=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(d.children){const o=[],s=[];for(const i of d.children){const r=this.parse(i.name);r&&s.push([r,i])}const e=(0,v.groupByExtension)(s,([i])=>i),n=[];for(const i of e)i.sort((r,a)=>I.rcompare(r[0].version,a[0].version)),o.push(...i.slice(1).map(r=>r[1].resource)),n.push(i[0][1]);n.sort((i,r)=>i.mtime-r.mtime),o.push(...n.slice(0,Math.max(0,n.length-this.cache)).map(i=>i.resource)),await C.Promises.settled(o.map(i=>(this.logService.trace("Deleting vsix from cache",i.path),this.fileService.del(i))))}}catch(d){this.logService.error(d)}}getName(d){return this.cache?`${new v.ExtensionIdentifierWithVersion(d.identifier,d.version).key().toLowerCase()}${d.properties.targetPlatform!=="undefined"?`-${d.properties.targetPlatform}`:""}`:(0,g.generateUuid)()}parse(d){const o=y.exec(d);return o&&o[1]&&o[2]?new v.ExtensionIdentifierWithVersion({id:o[1]},o[2]):null}};f=fe([ue(0,R.INativeEnvironmentService),ue(1,l.IFileService),ue(2,h.IExtensionGalleryService),ue(3,u.ILogService)],f),t.ExtensionsDownloader=f}),define(ee[103],te([0,1,34,3,28,13,2,8,4,10,20,15]),function($,t,C,b,S,L,D,I,c,g,m,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let h=class extends D.Disposable{constructor(l,u){super();this.environmentService=l,this.logService=u,this.processesLimiter=new b.Limiter(5)}async postUninstall(l){const u=this.parseScript(l,"uninstall");return u&&(this.logService.info(l.identifier.id,l.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(u.script,"uninstall",u.args,!0,l).then(()=>this.logService.info(l.identifier.id,l.manifest.version,"Finished running post uninstall script"),y=>this.logService.error(l.identifier.id,l.manifest.version,`Failed to run post uninstall script: ${y}`)))),g.Promises.rm(this.getExtensionStoragePath(l)).then(void 0,y=>this.logService.error("Error while removing extension storage path",y))}parseScript(l,u){const y=`vscode:${u}`;if(l.location.scheme===I.Schemas.file&&l.manifest&&l.manifest.scripts&&typeof l.manifest.scripts[y]=="string"){const f=l.manifest.scripts[y].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.logService.warn(l.identifier.id,l.manifest.version,`${y} should be a node script`),null):{script:(0,c.join)(l.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}runLifecycleHook(l,u,y,f,p){return new Promise((d,o)=>{const s=this.start(l,u,y,p);let e;const n=i=>{e&&(clearTimeout(e),e=null),i?o(i):d(void 0)};s.on("error",i=>{n((0,S.toErrorMessage)(i)||"Unknown")}),s.on("exit",(i,r)=>{n(i?`post-${u} process exited with code ${i}`:void 0)}),f&&(e=setTimeout(()=>{e=null,s.kill(),o("timed out")},5e3))})}start(l,u,y,f){const p={silent:!0,execArgv:void 0},d=(0,C.fork)(l,[`--type=extension-post-${u}`,...y],p);d.stdout.setEncoding("utf8"),d.stderr.setEncoding("utf8");const o=L.Event.fromNodeEventEmitter(d.stdout,"data"),s=L.Event.fromNodeEventEmitter(d.stderr,"data");o(i=>this.logService.info(f.identifier.id,f.manifest.version,`post-${u}`,i)),s(i=>this.logService.error(f.identifier.id,f.manifest.version,`post-${u}`,i));const e=L.Event.any(L.Event.map(o,i=>({data:`%c${i}`,format:[""]})),L.Event.map(s,i=>({data:`%c${i}`,format:["color: red"]})));return L.Event.debounce(e,(i,r)=>i?{data:i.data+r.data,format:[...i.format,...r.format]}:{data:r.data,format:r.format},100)(i=>{console.group(f.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),d}getExtensionStoragePath(l){return(0,c.join)(this.environmentService.globalStorageHome.fsPath,l.identifier.id.toLowerCase())}};h=fe([ue(0,m.IEnvironmentService),ue(1,R.ILogService)],h),t.ExtensionsLifecycle=h}),define(ee[104],te([0,1,13,2,19,7,20,24,16,15]),function($,t,C,b,S,L,D,I,c,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let m=class extends b.Disposable{constructor(h,v,l,u){super();this.extensionsManagementService=h,this.logService=u,this._onDidChangeExtensionsByAnotherSource=this._register(new C.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(p=>{this.installedExtensions=p.map(d=>d.identifier),this.startTimestamp=Date.now()}),this._register(h.onInstallExtension(p=>this.onInstallExtension(p))),this._register(h.onDidInstallExtensions(p=>this.onDidInstallExtensions(p))),this._register(h.onDidUninstallExtension(p=>this.onDidUninstallExtension(p)));const y=L.URI.file(l.extensionsPath),f=new S.ExtUri(p=>!v.hasCapability(p,1024));this._register(v.watch(y)),this._register(C.Event.filter(v.onDidChangeFilesRaw,p=>p.changes.some(d=>this.doesChangeAffects(d,y,f)))(()=>this.onDidChange()))}doesChangeAffects(h,v,l){return l.isEqual(l.dirname(h.resource),v)?l.isEqual(h.resource,l.joinPath(v,".obsolete"))?!0:!(h.type!==1&&h.type!==2||l.basename(h.resource).startsWith(".")):!1}onInstallExtension(h){this.addInstallingExtension(h.identifier)}onDidInstallExtensions(h){for(const v of h)this.removeInstallingExtension(v.identifier),v.local&&this.addInstalledExtension(v.identifier)}onDidUninstallExtension(h){h.error||this.removeInstalledExtension(h.identifier)}addInstallingExtension(h){this.removeInstallingExtension(h),this.installingExtensions.push(h)}removeInstallingExtension(h){this.installingExtensions=this.installingExtensions.filter(v=>!(0,I.areSameExtensions)(v,h))}addInstalledExtension(h){this.installedExtensions&&(this.removeInstalledExtension(h),this.installedExtensions.push(h))}removeInstalledExtension(h){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(v=>!(0,I.areSameExtensions)(v,h)))}async onDidChange(){if(this.installedExtensions){const h=await this.extensionsManagementService.getInstalled(1),v=h.filter(u=>[...this.installingExtensions,...this.installedExtensions].some(y=>(0,I.areSameExtensions)(y,u.identifier))?!1:u.installedTimestamp&&u.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",u.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",u.identifier.id),!1)),l=this.installedExtensions.filter(u=>this.installingExtensions.some(y=>(0,I.areSameExtensions)(y,u))?!1:h.every(y=>!(0,I.areSameExtensions)(y.identifier,u))?(this.logService.info("Detected extension removed from another source",u.id),!0):!1);this.installedExtensions=h.map(u=>u.identifier),(v.length||l.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:v,removed:l})}}};m=fe([ue(1,c.IFileService),ue(2,D.INativeEnvironmentService),ue(3,g.ILogService)],m),t.ExtensionsWatcher=m}),define(ee[105],te([0,1,130,22,3,2,8,4,10,20,23,24,56,15]),function($,t,C,b,S,L,D,I,c,g,m,R,h,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let l=class extends L.Disposable{constructor(f,p,d){super();this.extensionManagementService=f,this.logService=d,this.cache=this._register(new u(p,d)),this.extensionManagementService.registerParticipant({postInstall:async o=>this.postInstallExtension(o),postUninstall:async o=>this.postUninstallExtension(o)})}async getLanguageIds(){const f=await this.cache.getLanguagePacks(),p=["en",...Object.keys(f)];return(0,b.distinct)(p)}async postInstallExtension(f){f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",f.identifier.id),await this.update())}async postUninstallExtension(f){const p=await this.cache.getLanguagePacks();Object.keys(p).some(d=>p[d]&&p[d].extensions.some(o=>(0,R.areSameExtensions)(o.extensionIdentifier,f.identifier)))&&(this.logService.info("Removing language packs from the extension",f.identifier.id),await this.update())}async update(){const[f,p]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),d=await this.cache.update(p);return!(0,b.equals)(Object.keys(f),Object.keys(d))}};l=fe([ue(0,m.IExtensionManagementService),ue(1,g.INativeEnvironmentService),ue(2,v.ILogService)],l),t.LocalizationsService=l;let u=class extends L.Disposable{constructor(f,p){super();this.logService=p,this.languagePacks={},this.languagePacksFilePath=(0,I.join)(f.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new S.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(f){return this.withLanguagePacks(p=>{Object.keys(p).forEach(d=>delete p[d]),this.createLanguagePacksFromExtensions(p,...f)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(f,...p){for(const d of p)d&&d.manifest&&d.manifest.contributes&&d.manifest.contributes.localizations&&d.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(f,d);Object.keys(f).forEach(d=>this.updateHash(f[d]))}createLanguagePacksFromExtension(f,p){const d=p.identifier,o=p.manifest.contributes&&p.manifest.contributes.localizations?p.manifest.contributes.localizations:[];for(const s of o)if(p.location.scheme===D.Schemas.file&&(0,h.isValidLocalization)(s)){let e=f[s.languageId];e||(e={hash:"",extensions:[],translations:{}},f[s.languageId]=e);let n=e.extensions.filter(i=>(0,R.areSameExtensions)(i.extensionIdentifier,d))[0];n?n.version=p.manifest.version:e.extensions.push({extensionIdentifier:d,version:p.manifest.version});for(const i of s.translations)e.translations[i.id]=(0,I.join)(p.location.fsPath,i.path)}}updateHash(f){if(f){const p=(0,C.createHash)("md5");for(const d of f.extensions)p.update(d.extensionIdentifier.uuid||d.extensionIdentifier.id).update(d.version);f.hash=p.digest("hex")}}withLanguagePacks(f=()=>null){return this.languagePacksFileLimiter.queue(()=>{let p=null;return c.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,d=>d.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(d)).then(d=>{try{return JSON.parse(d)}catch(o){return{}}}).then(d=>(p=f(d),d)).then(d=>{for(const s of Object.keys(d))d[s]||delete d[s];this.languagePacks=d,this.initializedCache=!0;const o=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",o),c.Promises.writeFile(this.languagePacksFilePath,o)}).then(()=>p,d=>this.logService.error(d))})}};u=fe([ue(0,g.INativeEnvironmentService),ue(1,v.ILogService)],u)}),define(ee[106],te([0,1,16,15]),function($,t,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=t.createRotatingLogger=void 0;async function S(c,g,m,R){try{const h=await new Promise((v,l)=>{$(["spdlog"],v,l)});return h.setFlushOn(b.LogLevel.Trace),h.createAsyncRotatingLogger(c,g,m,R)}catch(h){console.error(h)}return null}function L(c,g,m,R){const h=$.__$__nodeRequire("spdlog");return h.setFlushOn(b.LogLevel.Trace),h.createRotatingLogger(c,g,m,R)}t.createRotatingLogger=L;function D(c,g,m){switch(g){case b.LogLevel.Trace:c.trace(m);break;case b.LogLevel.Debug:c.debug(m);break;case b.LogLevel.Info:c.info(m);break;case b.LogLevel.Warning:c.warn(m);break;case b.LogLevel.Error:c.error(m);break;case b.LogLevel.Critical:c.critical(m);break;default:throw new Error("Invalid log level")}}class I extends b.AbstractMessageLogger{constructor(g,m,R,h){super();this.name=g,this.filepath=m,this.rotating=R,this.buffer=[],this.setLevel(h),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(v=>{this._logger&&this._logger.setLevel(v)}))}_createSpdLogLogger(){const g=this.rotating?6:1,m=30/g*C.ByteSize.MB;return S(this.name,this.filepath,m,g).then(R=>{if(R){this._logger=R,this._logger.setLevel(this.getLevel());for(const{level:h,message:v}of this.buffer)D(this._logger,h,v);this.buffer=[]}})}log(g,m){this._logger?D(this._logger,g,m):this.getLevel()<=g&&this.buffer.push({level:g,message:m})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=I}),define(ee[57],te([0,1,17,11,83,16,35]),function($,t,C,b,S,L,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function I(R,h,v,l,u,y){let f;try{await c(R,h,v,l,u,y)}catch(p){f=p}finally{f&&u.errorTransformer&&(f=u.errorTransformer(f)),typeof f!="undefined"&&v.error(f),v.end()}}t.readFileIntoStream=I;async function c(R,h,v,l,u,y){g(y);const f=await R.open(h,{create:!1});try{g(y);let p=0,d=0,o=u&&typeof u.length=="number"?u.length:void 0,s=C.VSBuffer.alloc(Math.min(u.bufferSize,typeof o=="number"?o:u.bufferSize)),e=u&&typeof u.position=="number"?u.position:0,n=0;do d=await R.read(f,e,s.buffer,n,s.byteLength-n),e+=d,n+=d,p+=d,typeof o=="number"&&(o-=d),n===s.byteLength&&(await v.write(l(s)),s=C.VSBuffer.alloc(Math.min(u.bufferSize,typeof o=="number"?o:u.bufferSize)),n=0);while(d>0&&(typeof o!="number"||o>0)&&g(y)&&m(p,u));if(n>0){let i=n;typeof o=="number"&&(i=Math.min(n,o)),v.write(l(s.slice(0,i)))}}catch(p){throw(0,L.ensureFileSystemProviderError)(p)}finally{await R.close(f)}}function g(R){if(R.isCancellationRequested)throw(0,b.canceled)();return!0}function m(R,h){if(h?.limits){if(typeof h.limits.memory=="number"&&R>h.limits.memory)throw(0,L.createFileSystemProviderError)((0,S.localize)(0,null,D.default.nameShort),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof h.limits.size=="number"&&R>h.limits.size)throw(0,L.createFileSystemProviderError)((0,S.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ee[107],te([0,1,22,3,17,25,13,131,2,47,8,132,19,37,82,16,57,15]),function($,t,C,b,S,L,D,I,c,g,m,R,h,v,l,u,y,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let p=class Ne extends c.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new D.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new D.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new D.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new D.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new D.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new D.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new b.ThrottledWorker(Ne.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ne.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ne.FILE_EVENTS_THROTTLING.coolDownDelay,s=>this._onDidFilesChange.fire(new u.FileChangesEvent(s,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new b.ThrottledWorker(Ne.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ne.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ne.FILE_EVENTS_THROTTLING.coolDownDelay,s=>this._onDidFilesChange.fire(new u.FileChangesEvent(s,!0)))),this.watchedResources=g.TernarySearchTree.forUris(s=>{const e=this.getProvider(s.scheme);return e?!this.isPathCaseSensitive(e):!1}),this.writeQueue=this._register(new b.ResourceQueue)}registerProvider(o,s){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,R.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:s});const e=new c.DisposableStore;return e.add(s.onDidChangeFile(n=>this.onDidChangeFile(n,this.isPathCaseSensitive(s)))),e.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:o}))),typeof s.onDidErrorOccur=="function"&&e.add(s.onDidErrorOccur(n=>this._onError.fire(new Error(n)))),(0,c.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:s}),this.provider.delete(o),(0,c.dispose)(e)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(e){s.push(e)}}),!this.provider.has(o)&&await b.Promises.settled(s)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,s){const e=this.provider.get(o.scheme);return!!(e&&e.capabilities&s)}listCapabilities(){return I.Iterable.map(this.provider,([o,s])=>({scheme:o,capabilities:s.capabilities}))}async withProvider(o){if(!(0,h.isAbsolutePath)(o))throw new u.FileOperationError((0,l.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const s=this.provider.get(o.scheme);if(!s){const e=new Error;throw e.name="ENOPRO",e.message=(0,l.localize)(1,null,o.toString()),e}return s}async withReadProvider(o){const s=await this.withProvider(o);if((0,u.hasOpenReadWriteCloseCapability)(s)||(0,u.hasReadWriteCapability)(s)||(0,u.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const s=await this.withProvider(o);if((0,u.hasOpenReadWriteCloseCapability)(s)||(0,u.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,s){try{return await this.doResolveFile(o,s)}catch(e){throw(0,u.toFileSystemProviderErrorCode)(e)===u.FileSystemProviderErrorCode.FileNotFound?new u.FileOperationError((0,l.localize)(2,null,this.resourceForError(o)),1):(0,u.ensureFileSystemProviderError)(e)}}async doResolveFile(o,s){const e=await this.withProvider(o),n=this.isPathCaseSensitive(e),i=s?.resolveTo,r=s?.resolveSingleChildDescendants,a=s?.resolveMetadata,E=await e.stat(o);let P;return this.toFileStat(e,o,E,void 0,!!a,(A,w)=>{if(!P&&(P=g.TernarySearchTree.forUris(()=>!n),P.set(o,!0),i))for(const T of i)P.set(T,!0);return P.get(A.resource)||P.findSuperstr(A.resource.with({query:null,fragment:null}))?!0:A.isDirectory&&r?w===1:!1})}async toFileStat(o,s,e,n,i,r){const{providerExtUri:a}=this.getExtUri(o),E={resource:s,name:a.basename(s),isFile:(e.type&u.FileType.File)!=0,isDirectory:(e.type&u.FileType.Directory)!=0,isSymbolicLink:(e.type&u.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,readonly:Boolean((e.permissions??0)&u.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,u.etag)({mtime:e.mtime,size:e.size})};if(E.isDirectory&&r(E,n)){try{const P=await o.readdir(s),A=await b.Promises.settled(P.map(async([w,T])=>{try{const M=a.joinPath(s,w),j=i?await o.stat(M):{type:T};return await this.toFileStat(o,M,j,P.length,i,r)}catch(M){return this.logService.trace(M),null}}));E.children=(0,C.coalesce)(A)}catch(P){this.logService.trace(P),E.children=[]}return E}return E}async resolveAll(o){return b.Promises.settled(o.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(o){const s=await this.withProvider(o);try{return!!await s.stat(o)}catch(e){return!1}}async canCreateFile(o,s){try{await this.doValidateCreateFile(o,s)}catch(e){return e}return!0}async doValidateCreateFile(o,s){if(!s?.overwrite&&await this.exists(o))throw new u.FileOperationError((0,l.localize)(3,null,this.resourceForError(o)),3,s)}async createFile(o,s=S.VSBuffer.fromString(""),e){await this.doValidateCreateFile(o,e);const n=await this.writeFile(o,s);return this._onDidRunOperation.fire(new u.FileOperationEvent(o,0,n)),n}async writeFile(o,s,e){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:i}=this.getExtUri(n);try{await this.validateWriteFile(n,o,e)||await this.mkdirp(n,i.dirname(o));let a;if((0,u.hasReadWriteCapability)(n)&&!(s instanceof S.VSBuffer))if((0,v.isReadableStream)(s)){const E=await(0,v.peekStream)(s,3);E.ended?a=S.VSBuffer.concat(E.buffer):a=E}else a=(0,v.peekReadable)(s,E=>S.VSBuffer.concat(E),3);else a=s;!(0,u.hasOpenReadWriteCloseCapability)(n)||(0,u.hasReadWriteCapability)(n)&&a instanceof S.VSBuffer?await this.doWriteUnbuffered(n,o,e,a):await this.doWriteBuffered(n,o,e,a instanceof S.VSBuffer?(0,S.bufferToReadable)(a):a)}catch(r){throw new u.FileOperationError((0,l.localize)(4,null,this.resourceForError(o),(0,u.ensureFileSystemProviderError)(r).toString()),(0,u.toFileOperationResult)(r),e)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,s,e){if(!!e?.unlock&&!(o.capabilities&8192))throw new Error((0,l.localize)(5,null,this.resourceForError(s)));let i;try{i=await o.stat(s)}catch(r){return}if((i.type&u.FileType.Directory)!=0)throw new u.FileOperationError((0,l.localize)(6,null,this.resourceForError(s)),0,e);if(this.throwIfFileIsReadonly(s,i),typeof e?.mtime=="number"&&typeof e.etag=="string"&&e.etag!==u.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&e.mtime<i.mtime&&e.etag!==(0,u.etag)({mtime:e.mtime,size:i.size}))throw new u.FileOperationError((0,l.localize)(7,null),3,e);return i}async readFile(o,s){const e=await this.withReadProvider(o);return s?.atomic?this.doReadFileAtomic(e,o,s):this.doReadFile(e,o,s)}async doReadFileAtomic(o,s,e){return new Promise((n,i)=>{this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(async()=>{try{const r=await this.doReadFile(o,s,e);n(r)}catch(r){i(r)}})})}async doReadFile(o,s,e){const n=await this.doReadFileStream(o,s,{...e,preferUnbuffered:!0});return{...n,value:await(0,S.streamToBuffer)(n.value)}}async readFileStream(o,s){const e=await this.withReadProvider(o);return this.doReadFileStream(e,o,s)}async doReadFileStream(o,s,e){const n=new L.CancellationTokenSource,i=this.validateReadFile(s,e).then(a=>a,a=>{throw n.cancel(),a});let r;try{return typeof e?.etag=="string"&&e.etag!==u.ETAG_DISABLED&&await i,!((0,u.hasOpenReadWriteCloseCapability)(o)||(0,u.hasFileReadStreamCapability)(o))||(0,u.hasReadWriteCapability)(o)&&e?.preferUnbuffered?r=this.readFileUnbuffered(o,s,e):(0,u.hasFileReadStreamCapability)(o)?r=this.readFileStreamed(o,s,n.token,e):r=this.readFileBuffered(o,s,n.token,e),{...await i,value:r}}catch(a){r&&await(0,v.consumeStream)(r);const E=(0,l.localize)(8,null,this.resourceForError(s),(0,u.ensureFileSystemProviderError)(a).toString());throw a instanceof u.NotModifiedSinceFileOperationError?new u.NotModifiedSinceFileOperationError(E,a.stat,e):new u.FileOperationError(E,(0,u.toFileOperationResult)(a),e)}}readFileStreamed(o,s,e,n=Object.create(null)){const i=o.readFileStream(s,n,e);return(0,v.transform)(i,{data:r=>r instanceof S.VSBuffer?r:S.VSBuffer.wrap(r),error:r=>new u.FileOperationError((0,l.localize)(9,null,this.resourceForError(s),(0,u.ensureFileSystemProviderError)(r).toString()),(0,u.toFileOperationResult)(r),n)},r=>S.VSBuffer.concat(r))}readFileBuffered(o,s,e,n=Object.create(null)){const i=(0,S.newWriteableBufferStream)();return(0,y.readFileIntoStream)(o,s,i,r=>r,{...n,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new u.FileOperationError((0,l.localize)(10,null,this.resourceForError(s),(0,u.ensureFileSystemProviderError)(r).toString()),(0,u.toFileOperationResult)(r),n)},e),i}readFileUnbuffered(o,s,e){const n=(0,v.newWriteableStream)(i=>S.VSBuffer.concat(i));return(async()=>{try{let i=await o.readFile(s);typeof e?.position=="number"&&(i=i.slice(e.position)),typeof e?.length=="number"&&(i=i.slice(0,e.length)),this.validateReadFileLimits(s,i.byteLength,e),n.end(S.VSBuffer.wrap(i))}catch(i){n.error(i),n.end()}})(),n}async validateReadFile(o,s){const e=await this.resolve(o,{resolveMetadata:!0});if(e.isDirectory)throw new u.FileOperationError((0,l.localize)(11,null,this.resourceForError(o)),0,s);if(typeof s?.etag=="string"&&s.etag!==u.ETAG_DISABLED&&s.etag===e.etag)throw new u.NotModifiedSinceFileOperationError((0,l.localize)(12,null),e,s);return this.validateReadFileLimits(o,e.size,s),e}validateReadFileLimits(o,s,e){if(e?.limits){let n;if(typeof e.limits.memory=="number"&&s>e.limits.memory&&(n=9),typeof e.limits.size=="number"&&s>e.limits.size&&(n=7),typeof n=="number")throw new u.FileOperationError((0,l.localize)(13,null,this.resourceForError(o)),n)}}async canMove(o,s,e){return this.doCanMoveCopy(o,s,"move",e)}async canCopy(o,s,e){return this.doCanMoveCopy(o,s,"copy",e)}async doCanMoveCopy(o,s,e,n){if(o.toString()!==s.toString())try{const i=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(i,o,r,s,e,n)}catch(i){return i}return!0}async move(o,s,e){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=await this.doMoveCopy(n,o,i,s,"move",!!e),a=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new u.FileOperationEvent(o,r==="move"?2:3,a)),a}async copy(o,s,e){const n=await this.withReadProvider(o),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=await this.doMoveCopy(n,o,i,s,"copy",!!e),a=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new u.FileOperationEvent(o,r==="copy"?3:2,a)),a}async doMoveCopy(o,s,e,n,i,r){if(s.toString()===n.toString())return i;const{exists:a,isSameResourceWithDifferentPathCase:E}=await this.doValidateMoveCopy(o,s,e,n,i,r);if(a&&!E&&r&&await this.del(n,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(n)),i==="copy"){if(o===e&&(0,u.hasFileFolderCopyCapability)(o))await o.copy(s,n,{overwrite:r});else{const P=await this.resolve(s);P.isDirectory?await this.doCopyFolder(o,P,e,n):await this.doCopyFile(o,s,e,n)}return i}else return o===e?(await o.rename(s,n,{overwrite:r}),i):(await this.doMoveCopy(o,s,e,n,"copy",r),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(o,s,e,n){if((0,u.hasOpenReadWriteCloseCapability)(o)&&(0,u.hasOpenReadWriteCloseCapability)(e))return this.doPipeBuffered(o,s,e,n);if((0,u.hasOpenReadWriteCloseCapability)(o)&&(0,u.hasReadWriteCapability)(e))return this.doPipeBufferedToUnbuffered(o,s,e,n);if((0,u.hasReadWriteCapability)(o)&&(0,u.hasOpenReadWriteCloseCapability)(e))return this.doPipeUnbufferedToBuffered(o,s,e,n);if((0,u.hasReadWriteCapability)(o)&&(0,u.hasReadWriteCapability)(e))return this.doPipeUnbuffered(o,s,e,n)}async doCopyFolder(o,s,e,n){await e.mkdir(n),Array.isArray(s.children)&&await b.Promises.settled(s.children.map(async i=>{const r=this.getExtUri(e).providerExtUri.joinPath(n,i.name);return i.isDirectory?this.doCopyFolder(o,await this.resolve(i.resource),e,r):this.doCopyFile(o,i.resource,e,r)}))}async doValidateMoveCopy(o,s,e,n,i,r){let a=!1;if(o===e){const{providerExtUri:P,isPathCaseSensitive:A}=this.getExtUri(o);if(A||(a=P.isEqual(s,n)),a&&i==="copy")throw new Error((0,l.localize)(14,null,this.resourceForError(s),this.resourceForError(n)));if(!a&&P.isEqualOrParent(n,s))throw new Error((0,l.localize)(15,null,this.resourceForError(s),this.resourceForError(n)))}const E=await this.exists(n);if(E&&!a){if(!r)throw new u.FileOperationError((0,l.localize)(16,null,this.resourceForError(s),this.resourceForError(n)),4);if(o===e){const{providerExtUri:P}=this.getExtUri(o);if(P.isEqualOrParent(s,n))throw new Error((0,l.localize)(17,null,this.resourceForError(s),this.resourceForError(n)))}}return{exists:E,isSameResourceWithDifferentPathCase:a}}getExtUri(o){const s=this.isPathCaseSensitive(o);return{providerExtUri:s?h.extUri:h.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(s,o);const e=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new u.FileOperationEvent(o,0,e)),e}async mkdirp(o,s){const e=[],{providerExtUri:n}=this.getExtUri(o);for(;!n.isEqual(s,n.dirname(s));)try{if(((await o.stat(s)).type&u.FileType.Directory)==0)throw new Error((0,l.localize)(18,null,this.resourceForError(s)));break}catch(i){if((0,u.toFileSystemProviderErrorCode)(i)!==u.FileSystemProviderErrorCode.FileNotFound)throw i;e.push(n.basename(s)),s=n.dirname(s)}for(let i=e.length-1;i>=0;i--){s=n.joinPath(s,e[i]);try{await o.mkdir(s)}catch(r){if((0,u.toFileSystemProviderErrorCode)(r)!==u.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(o,s){try{await this.doValidateDelete(o,s)}catch(e){return e}return!0}async doValidateDelete(o,s){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!s?.useTrash&&!(e.capabilities&4096))throw new Error((0,l.localize)(19,null,this.resourceForError(o)));let i;try{i=await e.stat(o)}catch(a){}if(i)this.throwIfFileIsReadonly(o,i);else throw new u.FileOperationError((0,l.localize)(20,null,this.resourceForError(o)),1);if(!!!s?.recursive){const a=await this.resolve(o);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,l.localize)(21,null,this.resourceForError(o)))}return e}async del(o,s){const e=await this.doValidateDelete(o,s),n=!!s?.useTrash,i=!!s?.recursive;await e.delete(o,{recursive:i,useTrash:n}),this._onDidRunOperation.fire(new u.FileOperationEvent(o,1))}onDidChangeFile(o,s){this._onDidChangeFilesRaw.fire({changes:o});let e,n;{for(const i of o)this.watchedResources.has(i.resource)?(e||(e=[]),e.push(i)):(n||(n=[]),n.push(i));e&&this._onDidFilesChange.fire(new u.FileChangesEvent(e,!s))}if(n){const i=s?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!i.work(n)&&Ne.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${n.length}, most recent change: ${n[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),i.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${i.pending}, most recent change: ${n[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,s={recursive:!1,excludes:[]}){const e=new c.DisposableStore;{let n=!1,i=()=>{n=!0};e.add((0,c.toDisposable)(()=>i())),this.doWatch(o,s).then(r=>{n?(0,c.dispose)(r):i=()=>(0,c.dispose)(r)},r=>this.logService.error(r))}return s.recursive||(this.watchedResources.set(o,(this.watchedResources.get(o)??0)+1),e.add((0,c.toDisposable)(()=>{const n=this.watchedResources.get(o);typeof n=="number"&&(n<=1?this.watchedResources.delete(o):this.watchedResources.set(o,n-1))}))),e}async doWatch(o,s){const e=await this.withProvider(o),n=this.toWatchKey(e,o,s),i=this.activeWatchers.get(n)||{count:0,disposable:e.watch(o,s)};return this.activeWatchers.has(n)||this.activeWatchers.set(n,i),i.count+=1,(0,c.toDisposable)(()=>{i.count--,i.count===0&&((0,c.dispose)(i.disposable),this.activeWatchers.delete(n))})}toWatchKey(o,s,e){const{providerExtUri:n}=this.getExtUri(o);return[n.getComparisonKey(s),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,c.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,s,e,n){return this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(async()=>{const i=await o.open(s,{create:!0,unlock:e?.unlock??!1});try{(0,v.isReadableStream)(n)||(0,v.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(o,i,n):await this.doWriteReadableBufferedQueued(o,i,n)}catch(r){throw(0,u.ensureFileSystemProviderError)(r)}finally{await o.close(i)}})}async doWriteStreamBufferedQueued(o,s,e){let n=0,i;if((0,v.isReadableBufferedStream)(e)){if(e.buffer.length>0){const r=S.VSBuffer.concat(e.buffer);await this.doWriteBuffer(o,s,r,r.byteLength,n,0),n+=r.byteLength}if(e.ended)return;i=e.stream}else i=e;return new Promise(async(r,a)=>{(0,v.listenStream)(i,{onData:async E=>{i.pause();try{await this.doWriteBuffer(o,s,E,E.byteLength,n,0)}catch(P){return a(P)}n+=E.byteLength,setTimeout(()=>i.resume())},onError:E=>a(E),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(o,s,e){let n=0,i;for(;(i=e.read())!==null;)await this.doWriteBuffer(o,s,i,i.byteLength,n,0),n+=i.byteLength}async doWriteBuffer(o,s,e,n,i,r){let a=0;for(;a<n;)a+=await o.write(s,i+a,e.buffer,r+a,n-a)}async doWriteUnbuffered(o,s,e,n){return this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,s,e,n))}async doWriteUnbufferedQueued(o,s,e,n){let i;n instanceof S.VSBuffer?i=n:(0,v.isReadableStream)(n)?i=await(0,S.streamToBuffer)(n):(0,v.isReadableBufferedStream)(n)?i=await(0,S.bufferedStreamToBuffer)(n):i=(0,S.readableToBuffer)(n),await o.writeFile(s,i.buffer,{create:!0,overwrite:!0,unlock:e?.unlock??!1})}async doPipeBuffered(o,s,e,n){return this.writeQueue.queueFor(n,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,s,e,n))}async doPipeBufferedQueued(o,s,e,n){let i,r;try{i=await o.open(s,{create:!1}),r=await e.open(n,{create:!0,unlock:!1});const a=S.VSBuffer.alloc(this.BUFFER_SIZE);let E=0,P=0,A=0;do A=await o.read(i,E,a.buffer,P,a.byteLength-P),await this.doWriteBuffer(e,r,a,A,E,P),E+=A,P+=A,P===a.byteLength&&(P=0);while(A>0)}catch(a){throw(0,u.ensureFileSystemProviderError)(a)}finally{await b.Promises.settled([typeof i=="number"?o.close(i):Promise.resolve(),typeof r=="number"?e.close(r):Promise.resolve()])}}async doPipeUnbuffered(o,s,e,n){return this.writeQueue.queueFor(n,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,s,e,n))}async doPipeUnbufferedQueued(o,s,e,n){return e.writeFile(n,await o.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,s,e,n){return this.writeQueue.queueFor(n,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,s,e,n))}async doPipeUnbufferedToBufferedQueued(o,s,e,n){const i=await e.open(n,{create:!0,unlock:!1});try{const r=await o.readFile(s);await this.doWriteBuffer(e,i,S.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,u.ensureFileSystemProviderError)(r)}finally{await e.close(i)}}async doPipeBufferedToUnbuffered(o,s,e,n){const i=await(0,S.streamToBuffer)(this.readFileBuffered(o,s,L.CancellationToken.None));await this.doWriteUnbuffered(e,n,void 0,i)}throwIfFileSystemIsReadonly(o,s){if(o.capabilities&2048)throw new u.FileOperationError((0,l.localize)(22,null,this.resourceForError(s)),6);return o}throwIfFileIsReadonly(o,s){if((s.permissions??0)&u.FilePermission.Readonly)throw new u.FileOperationError((0,l.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===m.Schemas.file?o.fsPath:o.toString(!0)}};p.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},p=fe([ue(0,f.ILogService)],p),t.FileService=p}),define(ee[108],te([0,1,22,3,17,13,32,2,4,9,19,37,10,84,16,57,100,92,93,54,95,15]),function($,t,C,b,S,L,D,I,c,g,m,R,h,v,l,u,y,f,p,d,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;class e extends I.Disposable{constructor(i,r){super();this.logService=i,this.options=r,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=L.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new L.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new b.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,g.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:r,symbolicLink:a}=await h.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(r,a),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.toFileSystemProviderError(r)}}async readdir(i){try{const r=await h.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),a=[];return await Promise.all(r.map(async E=>{try{let P;E.isSymbolicLink()?P=(await this.stat((0,m.joinPath)(i,E.name))).type:P=this.toType(E),a.push([E.name,P])}catch(P){this.logService.trace(P)}})),a}catch(r){throw this.toFileSystemProviderError(r)}}toType(i,r){let a;return r?.dangling?a=l.FileType.Unknown:i.isFile()?a=l.FileType.File:i.isDirectory()?a=l.FileType.Directory:a=l.FileType.Unknown,r&&(a|=l.FileType.SymbolicLink),a}async readFile(i){try{const r=this.toFilePath(i);return await h.Promises.readFile(r)}catch(r){throw this.toFileSystemProviderError(r)}}readFileStream(i,r,a){const E=(0,R.newWriteableStream)(P=>S.VSBuffer.concat(P.map(A=>S.VSBuffer.wrap(A))).buffer);return(0,u.readFileIntoStream)(this,i,E,P=>P.buffer,{...r,bufferSize:this.BUFFER_SIZE},a),E}async writeFile(i,r,a){let E;try{const P=this.toFilePath(i);if(!a.create||!a.overwrite){if(await h.Promises.exists(P)){if(!a.overwrite)throw(0,l.createFileSystemProviderError)((0,v.localize)(0,null),l.FileSystemProviderErrorCode.FileExists)}else if(!a.create)throw(0,l.createFileSystemProviderError)((0,v.localize)(1,null),l.FileSystemProviderErrorCode.FileNotFound)}E=await this.open(i,{create:!0,unlock:a.unlock}),await this.write(E,0,r,0,r.byteLength)}catch(P){throw await this.toFileSystemProviderWriteError(i,P)}finally{typeof E=="number"&&await this.close(E)}}async open(i,r){try{const a=this.toFilePath(i);if((0,l.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:A}=await h.SymlinkSupport.stat(a);A.mode&128||await h.Promises.chmod(a,A.mode|128)}catch(A){this.logService.trace(A)}let E;if((0,l.isFileOpenForWriteOptions)(r)){if(g.isWindows)try{await h.Promises.truncate(a,0),E="r+"}catch(A){A.code!=="ENOENT"&&this.logService.trace(A)}E||(E="w")}else E="r";const P=await h.Promises.open(a,E);return this.mapHandleToPos.set(P,0),(0,l.isFileOpenForWriteOptions)(r)&&this.writeHandles.set(P,i),P}catch(a){throw(0,l.isFileOpenForWriteOptions)(r)?await this.toFileSystemProviderWriteError(i,a):this.toFileSystemProviderError(a)}}async close(i){try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await h.Promises.fdatasync(i)}catch(r){this.canFlush=!1,this.logService.error(r)}return await h.Promises.close(i)}catch(r){throw this.toFileSystemProviderError(r)}}async read(i,r,a,E,P){const A=this.normalizePos(i,r);let w=null;try{const T=await h.Promises.read(i,a,E,P,A);return typeof T=="number"?w=T:w=T.bytesRead,w}catch(T){throw this.toFileSystemProviderError(T)}finally{this.updatePos(i,A,w)}}normalizePos(i,r){return r===this.mapHandleToPos.get(i)?null:r}updatePos(i,r,a){const E=this.mapHandleToPos.get(i);typeof E=="number"&&(typeof r=="number"||(typeof a=="number"?this.mapHandleToPos.set(i,E+a):this.mapHandleToPos.delete(i)))}async write(i,r,a,E,P){return(0,b.retry)(()=>this.doWrite(i,r,a,E,P),100,3)}async doWrite(i,r,a,E,P){const A=this.normalizePos(i,r);let w=null;try{const T=await h.Promises.write(i,a,E,P,A);return typeof T=="number"?w=T:w=T.bytesWritten,w}catch(T){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),T)}finally{this.updatePos(i,A,w)}}async mkdir(i){try{await h.Promises.mkdir(this.toFilePath(i))}catch(r){throw this.toFileSystemProviderError(r)}}async delete(i,r){try{const a=this.toFilePath(i);await this.doDelete(a,r)}catch(a){throw this.toFileSystemProviderError(a)}}async doDelete(i,r){r.recursive?await h.Promises.rm(i,h.RimRafMode.MOVE):await h.Promises.unlink(i)}async rename(i,r,a){const E=this.toFilePath(i),P=this.toFilePath(r);if(E!==P)try{await this.validateTargetDeleted(i,r,"move",a.overwrite),await h.Promises.move(E,P)}catch(A){throw(A.code==="EINVAL"||A.code==="EBUSY"||A.code==="ENAMETOOLONG")&&(A=new Error((0,v.localize)(2,null,(0,c.basename)(E),(0,c.basename)((0,c.dirname)(P)),A.toString()))),this.toFileSystemProviderError(A)}}async copy(i,r,a){const E=this.toFilePath(i),P=this.toFilePath(r);if(E!==P)try{await this.validateTargetDeleted(i,r,"copy",a.overwrite),await h.Promises.copy(E,P,{preserveSymlinks:!0})}catch(A){throw(A.code==="EINVAL"||A.code==="EBUSY"||A.code==="ENAMETOOLONG")&&(A=new Error((0,v.localize)(3,null,(0,c.basename)(E),(0,c.basename)((0,c.dirname)(P)),A.toString()))),this.toFileSystemProviderError(A)}}async validateTargetDeleted(i,r,a,E){const P=this.toFilePath(i),A=this.toFilePath(r);let w=!1;if(!!(this.capabilities&1024)||(w=(0,D.isEqual)(P,A,!0)),w&&a==="copy")throw(0,l.createFileSystemProviderError)((0,v.localize)(4,null),l.FileSystemProviderErrorCode.FileExists);if(!w&&await h.Promises.exists(A)){if(!E)throw(0,l.createFileSystemProviderError)((0,v.localize)(5,null),l.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}watch(i,r){return r.recursive?this.watchRecursive(i,r.excludes):this.watchNonRecursive(i)}watchRecursive(i,r){const a={path:this.toFilePath(i),excludes:r},E=(0,C.insert)(this.recursiveFoldersToWatch,a);return this.refreshRecursiveWatchers(),(0,I.toDisposable)(()=>{E(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof f.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,I.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let i,r;this.options?.watcher?.usePolling?(i=p.FileWatcher,r=this.options?.watcher):this.recursiveFoldersToWatch.length===1?g.isWindows?i=o.FileWatcher:i=p.FileWatcher:i=f.FileWatcher,this.recursiveWatcher=new i(this.recursiveFoldersToWatch,a=>this._onDidChangeFile.fire((0,d.toFileChanges)(a)),a=>{a.type==="error"&&this._onDidWatchErrorOccur.fire(a.message),this.logService[a.type](a.message)},this.logService.getLevel()===s.LogLevel.Trace,r),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===s.LogLevel.Trace)}))}}watchNonRecursive(i){const r=new y.FileWatcher(this.toFilePath(i),E=>this._onDidChangeFile.fire((0,d.toFileChanges)(E)),E=>{E.type==="error"&&this._onDidWatchErrorOccur.fire(E.message),this.logService[E.type](E.message)},this.logService.getLevel()===s.LogLevel.Trace),a=this.logService.onDidChangeLogLevel(()=>{r.setVerboseLogging(this.logService.getLevel()===s.LogLevel.Trace)});return(0,I.combinedDisposable)(r,a)}toFilePath(i){return(0,c.normalize)(i.fsPath)}toFileSystemProviderError(i){if(i instanceof l.FileSystemProviderError)return i;let r;switch(i.code){case"ENOENT":r=l.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=l.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=l.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=l.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=l.FileSystemProviderErrorCode.NoPermissions;break;default:r=l.FileSystemProviderErrorCode.Unknown}return(0,l.createFileSystemProviderError)(i,r)}async toFileSystemProviderWriteError(i,r){let a=this.toFileSystemProviderError(r);if(i&&a.code===l.FileSystemProviderErrorCode.NoPermissions)try{const{stat:E}=await h.SymlinkSupport.stat(this.toFilePath(i));E.mode&128||(a=(0,l.createFileSystemProviderError)(r,l.FileSystemProviderErrorCode.FileWriteLocked))}catch(E){this.logService.trace(E)}return a}dispose(){super.dispose(),(0,I.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,I.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}t.DiskFileSystemProvider=e}),define(ee[42],te([0,1,14]),function($,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=(0,C.createDecorator)("productService")}),define(ee[26],te([0,1,58,12]),function($,t,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class S{constructor(){this.data=new Map}add(D,I){C.ok(b.isString(D)),C.ok(b.isObject(I)),C.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,I)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}t.Registry=new S}),define(ee[109],te([0,1,13,26]),function($,t,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function S(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class L{constructor(){this._onDidChangeSchema=new C.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(c,g){this.schemasById[S(c)]=g,this._onDidChangeSchema.fire(c)}notifySchemaChanged(c){this._onDidChangeSchema.fire(c)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new L;b.Registry.add(t.Extensions.JSONContribution,D)}),define(ee[31],te([0,1,13,12,74,109,26]),function($,t,C,b,S,L,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=t.EditPresentationTypes=void 0;var I;(function(f){f.Multiline="multilineText",f.Singleline="singlelineText"})(I=t.EditPresentationTypes||(t.EditPresentationTypes={})),t.Extensions={Configuration:"base.contributions.configuration"};var c;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.MACHINE=2]="MACHINE",f[f.WINDOW=3]="WINDOW",f[f.RESOURCE=4]="RESOURCE",f[f.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",f[f.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(c=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const g=D.Registry.as(L.Extensions.JSONContribution);class m{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new C.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new C.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:S.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},g.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(p,d=!0){this.registerConfigurations([p],d)}registerConfigurations(p,d=!0){const o=[];p.forEach(s=>{o.push(...this.validateAndRegisterProperties(s,d,s.extensionInfo)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),g.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterConfigurations(p){const d=[],o=s=>{if(s.properties)for(const e in s.properties)d.push(e),delete this.configurationProperties[e],this.removeFromSchema(e,s.properties[e]);s.allOf&&s.allOf.forEach(e=>o(e))};for(const s of p){o(s);const e=this.configurationContributors.indexOf(s);e!==-1&&this.configurationContributors.splice(e,1)}g.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}registerDefaultConfigurations(p){const d=[],o=[];for(const s of p)for(const e in s)if(d.push(e),t.OVERRIDE_PROPERTY_PATTERN.test(e)){this.defaultValues[e]={...this.defaultValues[e]||{},...s[e]};const n={type:"object",default:this.defaultValues[e],description:S.localize(1,null,e),$ref:t.resourceLanguageSettingsSchemaId};o.push(h(e)),this.configurationProperties[e]=n,this.defaultLanguageConfigurationOverridesNode.properties[e]=n}else{this.defaultValues[e]=s[e];const n=this.configurationProperties[e];n&&(this.updatePropertyDefaultValue(e,n),this.updateSchema(e,n))}this.registerOverrideIdentifiers(o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}deregisterDefaultConfigurations(p){const d=[];for(const o of p)for(const s in o)if(d.push(s),delete this.defaultValues[s],t.OVERRIDE_PROPERTY_PATTERN.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const e=this.configurationProperties[s];e&&(this.updatePropertyDefaultValue(s,e),this.updateSchema(s,e))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}notifyConfigurationSchemaUpdated(...p){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(p){for(const d of p)this.overrideIdentifiers.add(d);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(p,d=!0,o,s=3){s=b.isUndefinedOrNull(p.scope)?s:p.scope;let e=[],n=p.properties;if(n)for(let r in n){if(d&&u(r)){delete n[r];continue}const a=n[r];if(this.updatePropertyDefaultValue(r,a),t.OVERRIDE_PROPERTY_PATTERN.test(r)?a.scope=void 0:(a.scope=b.isUndefinedOrNull(a.scope)?s:a.scope,a.restricted=b.isUndefinedOrNull(a.restricted)?!!o?.restrictedConfigurations?.includes(r):a.restricted),n[r].hasOwnProperty("included")&&!n[r].included){this.excludedConfigurationProperties[r]=n[r],delete n[r];continue}else this.configurationProperties[r]=n[r];!n[r].deprecationMessage&&n[r].markdownDeprecationMessage&&(n[r].deprecationMessage=n[r].markdownDeprecationMessage),e.push(r)}let i=p.allOf;if(i)for(let r of i)e.push(...this.validateAndRegisterProperties(r,d,o,s));return e}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(p){const d=o=>{let s=o.properties;if(s)for(const n in s)this.updateSchema(n,s[n]);let e=o.allOf;e&&e.forEach(d)};d(p)}updateSchema(p,d){switch(t.allSettings.properties[p]=d,d.scope){case 1:t.applicationSettings.properties[p]=d;break;case 2:t.machineSettings.properties[p]=d;break;case 6:t.machineOverridableSettings.properties[p]=d;break;case 3:t.windowSettings.properties[p]=d;break;case 4:t.resourceSettings.properties[p]=d;break;case 5:t.resourceSettings.properties[p]=d,this.resourceLanguageSettingsSchema.properties[p]=d;break}}removeFromSchema(p,d){switch(delete t.allSettings.properties[p],d.scope){case 1:delete t.applicationSettings.properties[p];break;case 2:delete t.machineSettings.properties[p];break;case 6:delete t.machineOverridableSettings.properties[p];break;case 3:delete t.windowSettings.properties[p];break;case 4:case 5:delete t.resourceSettings.properties[p];break}}updateOverridePropertyPatternKey(){for(const p of this.overrideIdentifiers.values()){const d=`[${p}]`,o={type:"object",description:S.localize(2,null),errorMessage:S.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(d,o),t.allSettings.properties[d]=o,t.applicationSettings.properties[d]=o,t.machineSettings.properties[d]=o,t.machineOverridableSettings.properties[d]=o,t.windowSettings.properties[d]=o,t.resourceSettings.properties[d]=o}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(p,d){let o=this.defaultValues[p];b.isUndefined(o)&&(o=d.default),b.isUndefined(o)&&(o=v(d.type)),d.default=o}}const R="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(R);function h(f){return f.substring(1,f.length-1)}t.overrideIdentifierFromKey=h;function v(f){switch(Array.isArray(f)?f[0]:f){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=v;const l=new m;D.Registry.add(t.Extensions.Configuration,l);function u(f){return f.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(f)?S.localize(5,null,f):l.getConfigurationProperties()[f]!==void 0?S.localize(6,null,f):null:S.localize(4,null)}t.validateProperty=u;function y(){const f=[],p=l.getConfigurationProperties();for(const d of Object.keys(p))f.push([d,p[d].scope]);return f.push(["launch",4]),f.push(["task",4]),f}t.getScopes=y}),define(ee[27],te([0,1,18,12,7,31,14,26]),function($,t,C,b,S,L,D,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,D.createDecorator)("configurationService");function c(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof S.URI)}t.isConfigurationOverrides=c;var g;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(g=t.ConfigurationTarget||(t.ConfigurationTarget={}));function m(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=m;function R(n,i){const r=i?n?i.keys.filter(M=>n.keys.indexOf(M)===-1):[...i.keys]:[],a=n?i?n.keys.filter(M=>i.keys.indexOf(M)===-1):[...n.keys]:[],E=[];if(i&&n){for(const M of n.keys)if(i.keys.indexOf(M)!==-1){const j=f(n.contents,M),Y=f(i.contents,M);C.equals(j,Y)||E.push(M)}}const P=[],A=M=>{const j={};for(const Y of M)for(const ie of Y.identifiers)j[s(ie)]=Y;return j},w=i?A(i.overrides):{},T=n?A(n.overrides):{};if(Object.keys(w).length)for(const M of r){const j=w[M];j&&P.push([(0,L.overrideIdentifierFromKey)(M),j.keys])}if(Object.keys(T).length)for(const M of a){const j=T[M];j&&P.push([(0,L.overrideIdentifierFromKey)(M),j.keys])}if(Object.keys(w).length&&Object.keys(T).length)for(const M of E){const j=T[M],Y=w[M];if(j&&Y){const ie=R({contents:j.contents,keys:j.keys,overrides:[]},{contents:Y.contents,keys:Y.keys,overrides:[]});P.push([(0,L.overrideIdentifierFromKey)(M),[...ie.added,...ie.removed,...ie.updated]])}}return{added:r,removed:a,updated:E,overrides:P}}t.compare=R;function h(n,i){const r=[];for(const a of Object.keys(n))if(L.OVERRIDE_PROPERTY_PATTERN.test(a)){const E={};for(const P in n[a])E[P]=n[a][P];r.push({identifiers:[(0,L.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(E),contents:v(E,i)})}return r}t.toOverrides=h;function v(n,i){const r=Object.create(null);for(let a in n)l(r,a,n[a],i);return r}t.toValuesTree=v;function l(n,i,r,a){const E=i.split("."),P=E.pop();let A=n;for(let w=0;w<E.length;w++){let T=E[w],M=A[T];switch(typeof M){case"undefined":M=A[T]=Object.create(null);break;case"object":break;default:a(`Ignoring ${i} as ${E.slice(0,w+1).join(".")} is ${JSON.stringify(M)}`);return}A=M}if(typeof A=="object"&&A!==null)try{A[P]=r}catch(w){a(`Ignoring ${i} as ${E.join(".")} is ${JSON.stringify(A)}`)}else a(`Ignoring ${i} as ${E.join(".")} is ${JSON.stringify(A)}`)}t.addToValueTree=l;function u(n,i){const r=i.split(".");y(n,r)}t.removeFromValueTree=u;function y(n,i){const r=i.shift();if(i.length===0){delete n[r];return}if(Object.keys(n).indexOf(r)!==-1){const a=n[r];typeof a=="object"&&!Array.isArray(a)&&(y(a,i),Object.keys(a).length===0&&delete n[r])}}function f(n,i,r){function a(A,w){let T=A;for(const M of w){if(typeof T!="object"||T===null)return;T=T[M]}return T}const E=i.split("."),P=a(n,E);return typeof P=="undefined"?r:P}t.getConfigurationValue=f;function p(n,i,r){Object.keys(i).forEach(a=>{a!=="__proto__"&&(a in n?b.isObject(n[a])&&b.isObject(i[a])?p(n[a],i[a],r):r&&(n[a]=i[a]):n[a]=i[a])})}t.merge=p;function d(){const n=I.Registry.as(L.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}t.getConfigurationKeys=d;function o(){const n=Object.create(null),i=I.Registry.as(L.Extensions.Configuration).getConfigurationProperties();for(let r in i){let a=i[r].default;l(n,r,a,E=>console.error(`Conflict in default settings: ${E}`))}return n}t.getDefaultValues=o;function s(n){return`[${n}]`}t.keyFromOverrideIdentifier=s;function e(n,i,r){const a=n.inspect(i),E=n.inspect(r);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof E.userValue!="undefined"||typeof E.workspaceValue!="undefined"||typeof E.workspaceFolderValue!="undefined"?E.value:a.defaultValue}t.getMigratedSettingValue=e}),define(ee[110],te([0,1,22,13,59,2,47,18,12,7,27,31,26]),function($,t,C,b,S,L,D,I,c,g,m,R,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class v{constructor(e={},n=[],i=[]){this._contents=e,this._keys=n,this._overrides=i,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,m.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,n){const i=this.getContentsForOverrideIdentifer(n);return i?e?(0,m.getConfigurationValue)(i,e):i:void 0}getKeysForOverrideIdentifier(e){for(const n of this.overrides)if(n.identifiers.indexOf(e)!==-1)return n.keys;return[]}override(e){const n=this.getContentsForOverrideIdentifer(e);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let i={};for(const r of C.distinct([...Object.keys(this.contents),...Object.keys(n)])){let a=this.contents[r],E=n[r];E&&(typeof a=="object"&&typeof E=="object"?(a=I.deepClone(a),this.mergeContents(a,E)):a=E),i[r]=a}return new v(i,this.keys,this.overrides)}merge(...e){const n=I.deepClone(this.contents),i=I.deepClone(this.overrides),r=[...this.keys];for(const a of e){this.mergeContents(n,a.contents);for(const E of a.overrides){const[P]=i.filter(A=>C.equals(A.identifiers,E.identifiers));P?this.mergeContents(P.contents,E.contents):i.push(I.deepClone(E))}for(const E of a.keys)r.indexOf(E)===-1&&r.push(E)}return new v(n,r,i)}freeze(){return this.isFrozen=!0,this}mergeContents(e,n){for(const i of Object.keys(n)){if(i in e&&c.isObject(e[i])&&c.isObject(n[i])){this.mergeContents(e[i],n[i]);continue}e[i]=I.deepClone(n[i])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?I.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const n of this.overrides)if(n.identifiers.indexOf(e)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,n){this.addKey(e),(0,m.addToValueTree)(this.contents,e,n,i=>{throw new Error(i)})}removeValue(e){this.removeKey(e)&&(0,m.removeFromValueTree)(this.contents,e)}addKey(e){let n=this.keys.length;for(let i=0;i<n;i++)e.indexOf(this.keys[i])===0&&(n=i);this.keys.splice(n,1,e)}removeKey(e){let n=this.keys.indexOf(e);return n!==-1?(this.keys.splice(n,1),!0):!1}}t.ConfigurationModel=v;class l extends v{constructor(){const e=(0,m.getDefaultValues)(),n=(0,m.getConfigurationKeys)(),i=[];for(const r of Object.keys(e))R.OVERRIDE_PROPERTY_PATTERN.test(r)&&i.push({identifiers:[(0,R.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(e[r]),contents:(0,m.toValuesTree)(e[r],a=>console.error(`Conflict in default settings file: ${a}`))});super(e,n,i)}}t.DefaultConfigurationModel=l;class u{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new v}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,n){if(!c.isUndefinedOrNull(e)){const i=this.doParseContent(e);this.parseRaw(i,n)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,n){this._raw=e;const{contents:i,keys:r,overrides:a,restricted:E}=this.doParseRaw(e,n);this._configurationModel=new v(i,r,a),this._restrictedConfigurations=E||[]}doParseContent(e){let n={},i=null,r=[],a=[],E=[];function P(w){Array.isArray(r)?r.push(w):i!==null&&(r[i]=w)}let A={onObjectBegin:()=>{let w={};P(w),a.push(r),r=w,i=null},onObjectProperty:w=>{i=w},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{let w=[];P(w),a.push(r),r=w,i=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:P,onError:(w,T,M)=>{E.push({error:w,offset:T,length:M})}};if(e)try{S.visit(e,A),n=r[0]||{}}catch(w){console.error(`Error while parsing settings file ${this._name}: ${w}`),this._parseErrors=[w]}return n}doParseRaw(e,n){const i=h.Registry.as(R.Extensions.Configuration).getConfigurationProperties(),r=this.filter(e,i,!0,n);e=r.raw;const a=(0,m.toValuesTree)(e,A=>console.error(`Conflict in settings file ${this._name}: ${A}`)),E=Object.keys(e),P=(0,m.toOverrides)(e,A=>console.error(`Conflict in settings file ${this._name}: ${A}`));return{contents:a,keys:E,overrides:P,restricted:r.restricted}}filter(e,n,i,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:e,restricted:[]};const a={},E=[];for(let P in e)if(R.OVERRIDE_PROPERTY_PATTERN.test(P)&&i){const A=this.filter(e[P],n,!1,r);a[P]=A.raw,E.push(...A.restricted)}else{const A=n[P],w=A?typeof A.scope!="undefined"?A.scope:3:void 0;A?.restricted&&E.push(P),(w===void 0||r.scopes===void 0||r.scopes.includes(w))&&(r.skipRestricted&&A?.restricted||(a[P]=e[P]))}return{raw:a,restricted:E}}}t.ConfigurationModelParser=u;class y extends L.Disposable{constructor(e,n,i,r){super();this.userSettingsResource=e,this.scopes=n,this.fileService=r,this._onDidChange=this._register(new b.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new u(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(b.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(e){return new v}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=y;class f{constructor(e,n,i=new v,r=new v,a=new D.ResourceMap,E=new v,P=new D.ResourceMap,A=!0){this._defaultConfiguration=e,this._localUserConfiguration=n,this._remoteUserConfiguration=i,this._workspaceConfiguration=r,this._folderConfigurations=a,this._memoryConfiguration=E,this._memoryConfigurationByResource=P,this._freeze=A,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(e,n,i){return this.getConsolidateConfigurationModel(n,i).getValue(e)}updateValue(e,n,i={}){let r;i.resource?(r=this._memoryConfigurationByResource.get(i.resource),r||(r=new v,this._memoryConfigurationByResource.set(i.resource,r))):r=this._memoryConfiguration,n===void 0?r.removeValue(e):r.setValue(e,n),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,n,i){const r=this.getConsolidateConfigurationModel(n,i),a=this.getFolderConfigurationModelForResource(n.resource,i),E=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,P=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),A=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),w=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),T=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),M=i?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,j=a?n.overrideIdentifier?a.freeze().override(n.overrideIdentifier).getValue(e):a.freeze().getValue(e):void 0,Y=n.overrideIdentifier?E.override(n.overrideIdentifier).getValue(e):E.getValue(e),ie=r.getValue(e),oe=C.distinct(C.flatten(r.overrides.map(Z=>Z.identifiers))).filter(Z=>r.getOverrideValue(e,Z)!==void 0);return{defaultValue:P,userValue:A,userLocalValue:w,userRemoteValue:T,workspaceValue:M,workspaceFolderValue:j,memoryValue:Y,value:ie,default:P!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,user:A!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,userLocal:w!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,userRemote:T!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,workspace:M!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,workspaceFolder:j!==void 0?{value:a?.freeze().getValue(e),override:n.overrideIdentifier?a?.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,memory:Y!==void 0?{value:E.getValue(e),override:n.overrideIdentifier?E.getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:oe.length?oe:void 0}}keys(e){const n=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,n){this._folderConfigurations.set(e,n),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,n){const i=n.filter(r=>R.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const a=(0,R.overrideIdentifierFromKey)(r),E=this._defaultConfiguration.getKeysForOverrideIdentifier(a),P=e.getKeysForOverrideIdentifier(a),A=[...P.filter(w=>E.indexOf(w)===-1),...E.filter(w=>P.indexOf(w)===-1),...E.filter(w=>!I.equals(this._defaultConfiguration.override(a).getValue(w),e.override(a).getValue(w)))];return[a,A]});return this.updateDefaultConfiguration(e),{keys:n,overrides:i}}compareAndUpdateLocalUserConfiguration(e){const{added:n,updated:i,removed:r,overrides:a}=(0,m.compare)(this.localUserConfiguration,e),E=[...n,...i,...r];return E.length&&this.updateLocalUserConfiguration(e),{keys:E,overrides:a}}compareAndUpdateRemoteUserConfiguration(e){const{added:n,updated:i,removed:r,overrides:a}=(0,m.compare)(this.remoteUserConfiguration,e);let E=[...n,...i,...r];return E.length&&this.updateRemoteUserConfiguration(e),{keys:E,overrides:a}}compareAndUpdateWorkspaceConfiguration(e){const{added:n,updated:i,removed:r,overrides:a}=(0,m.compare)(this.workspaceConfiguration,e);let E=[...n,...i,...r];return E.length&&this.updateWorkspaceConfiguration(e),{keys:E,overrides:a}}compareAndUpdateFolderConfiguration(e,n){const i=this.folderConfigurations.get(e),{added:r,updated:a,removed:E,overrides:P}=(0,m.compare)(i,n);let A=[...r,...a,...E];return(A.length||!i)&&this.updateFolderConfiguration(e,n),{keys:A,overrides:P}}compareAndDeleteFolderConfiguration(e){const n=this.folderConfigurations.get(e);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:i,updated:r,removed:a,overrides:E}=(0,m.compare)(n,void 0);return{keys:[...i,...r,...a],overrides:E}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,n){let i=this.getConsolidatedConfigurationModelForResource(e,n);return e.overrideIdentifier?i.override(e.overrideIdentifier):i}getConsolidatedConfigurationModelForResource({resource:e},n){let i=this.getWorkspaceConsolidatedConfiguration();if(n&&e){const r=n.getFolder(e);r&&(i=this.getFolderConsolidatedConfiguration(r.uri)||i);const a=this._memoryConfigurationByResource.get(e);a&&(i=i.merge(a))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let n=this._foldersConsolidatedConfigurations.get(e);if(!n){const i=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(e);r?(n=i.merge(r),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(e,n)):n=i}return n}getFolderConfigurationModelForResource(e,n){if(n&&e){const i=n.getFolder(e);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,n)=>{const{contents:i,overrides:r,keys:a}=this._folderConfigurations.get(n);return e.push([n,{contents:i,overrides:r,keys:a}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>e.add(n)),this.userConfiguration.freeze().keys.forEach(n=>e.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>e.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(i=>e.add(i))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(i=>n.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(i=>n.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(e).forEach(r=>n.add(r))),[...n.values()]}static parse(e){const n=this.parseConfigurationModel(e.defaults),i=this.parseConfigurationModel(e.user),r=this.parseConfigurationModel(e.workspace),a=e.folders.reduce((E,P)=>(E.set(g.URI.revive(P[0]),this.parseConfigurationModel(P[1])),E),new D.ResourceMap);return new f(n,i,new v,r,a,new v,new D.ResourceMap,!1)}static parseConfigurationModel(e){return new v(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=f;function p(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const e=new Set,n=new Map;for(const r of s)r.keys.forEach(a=>e.add(a)),r.overrides.forEach(([a,E])=>{const P=(0,D.getOrSet)(n,a,new Set);E.forEach(A=>P.add(A))});const i=[];return n.forEach((r,a)=>i.push([a,[...r.values()]])),{keys:[...e.values()],overrides:i}}t.mergeChanges=p;class d{constructor(e,n,i,r){this.change=e,this.previous=n,this.currentConfiguraiton=i,this.currentWorkspace=r,this._previousConfiguration=void 0;const a=new Set;e.keys.forEach(P=>a.add(P)),e.overrides.forEach(([,P])=>P.forEach(A=>a.add(A))),this.affectedKeys=[...a.values()];const E=new v;this.affectedKeys.forEach(P=>E.setValue(P,{})),this.affectedKeysTree=E.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=f.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(n){const i=this.previousConfiguration?this.previousConfiguration.getValue(e,n,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(e,n,this.currentWorkspace);return!I.equals(i,r)}return!0}return!1}doesAffectedKeysTreeContains(e,n){let i=(0,m.toValuesTree)({[n]:!0},()=>{}),r;for(;typeof i=="object"&&(r=Object.keys(i)[0]);){if(e=e[r],!e)return!1;i=i[r]}return!0}}t.ConfigurationChangeEvent=d;class o extends d{constructor(e,n,i,r){super({keys:e.allKeys(),overrides:[]},void 0,e,n);this.source=i,this.sourceConfig=r}}t.AllKeysConfigurationChangeEvent=o}),define(ee[111],te([0,1,3,13,2,19,27,110,31,26]),function($,t,C,b,S,L,D,I,c,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class m extends S.Disposable{constructor(h,v){super();this.settingsResource=h,this._onDidChangeConfiguration=this._register(new b.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new I.UserSettings(this.settingsResource,void 0,L.extUriBiasedIgnorePathCase,v)),this.configuration=new I.Configuration(new I.DefaultConfigurationModel,new I.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new C.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(g.Registry.as(c.Extensions.Configuration).onDidUpdateConfiguration(l=>this.onDidDefaultConfigurationChange(l))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const h=await this.userConfiguration.loadConfiguration();this.configuration=new I.Configuration(new I.DefaultConfigurationModel,h)}getConfigurationData(){return this.configuration.toData()}getValue(h,v){const l=typeof h=="string"?h:void 0,u=(0,D.isConfigurationOverrides)(h)?h:(0,D.isConfigurationOverrides)(v)?v:{};return this.configuration.getValue(l,u,void 0)}updateValue(h,v,l,u){return Promise.reject(new Error("not supported"))}inspect(h){return this.configuration.inspect(h,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const h=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(h)}onDidChangeUserConfiguration(h){const v=this.configuration.toData(),l=this.configuration.compareAndUpdateLocalUserConfiguration(h);this.trigger(l,v,1)}onDidDefaultConfigurationChange(h){const v=this.configuration.toData(),l=this.configuration.compareAndUpdateDefaultConfiguration(new I.DefaultConfigurationModel,h);this.trigger(l,v,6)}trigger(h,v,l){const u=new I.ConfigurationChangeEvent(h,{data:v},this.configuration);u.source=l,u.sourceConfig=this.getTargetConfiguration(l),this._onDidChangeConfiguration.fire(u)}getTargetConfiguration(h){switch(h){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=m}),define(ee[43],te([0,1,17,85,31,14,26]),function($,t,C,b,S,L,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,L.createDecorator)("requestService");function I(l){return l.res.statusCode&&l.res.statusCode>=200&&l.res.statusCode<300||l.res.statusCode===1223}t.isSuccess=I;function c(l){return l.res.statusCode===204}async function g(l){if(!I(l))throw new Error("Server returned "+l.res.statusCode);return c(l)?null:(await(0,C.streamToBuffer)(l.stream)).toString()}t.asText=g;async function m(l){if(!I(l))throw new Error("Server returned "+l.res.statusCode);if(c(l))return null;const y=(await(0,C.streamToBuffer)(l.stream)).toString();try{return JSON.parse(y)}catch(f){throw f.message+=`:
`+y,f}}t.asJson=m;function R(l){v(l)}t.updateProxyConfigurationsScope=R;let h;function v(l){const u=D.Registry.as(S.Extensions.Configuration);h&&u.deregisterConfigurations([h]),h={id:"http",order:15,title:(0,b.localize)(0,null),type:"object",scope:l,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,b.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,b.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,b.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,b.localize)(4,null),(0,b.localize)(5,null),(0,b.localize)(6,null),(0,b.localize)(7,null)],default:"override",description:(0,b.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,b.localize)(9,null),restricted:!0}}},u.registerConfiguration(h)}v(2)}),define(ee[112],te([0,1,25,8,16,43]),function($,t,C,b,S,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DownloadService=void 0;let D=class{constructor(c,g){this.requestService=c,this.fileService=g}async download(c,g,m=C.CancellationToken.None){if(c.scheme===b.Schemas.file||c.scheme===b.Schemas.vscodeRemote){await this.fileService.copy(c,g);return}const R={type:"GET",url:c.toString()},h=await this.requestService.request(R,m);if(h.res.statusCode===200)await this.fileService.writeFile(g,h.stream);else{const v=await(0,L.asText)(h);throw new Error(`Expected 200, got back ${h.res.statusCode} instead.

${v}`)}}};D=fe([ue(0,L.IRequestService),ue(1,S.IFileService)],D),t.DownloadService=D}),define(ee[113],te([0,1,114,12]),function($,t,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function S(D,I){return D.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:D.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function L(D,I,c={}){const g=(0,C.parse)(D),m=c.proxyUrl||S(g,I);if(!m)return null;const R=(0,C.parse)(m);if(!/^https?:$/.test(R.protocol||""))return null;const h={host:R.hostname||"",port:R.port||(R.protocol==="https"?"443":"80"),auth:R.auth,rejectUnauthorized:(0,b.isBoolean)(c.strictSSL)?c.strictSSL:!0};return g.protocol==="http:"?new(await new Promise((v,l)=>{$(["http-proxy-agent"],v,l)}))(h):new(await new Promise((v,l)=>{$(["https-proxy-agent"],v,l)}))(h)}t.getProxyAgent=L}),define(ee[115],te([0,1,17,30]),function($,t,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function S(L,D,I){let c=I&&I.get("storage.serviceMachineId",0)||null;if(c)return c;try{const m=(await D.readFile(L.serviceMachineIdResource)).value.toString();c=(0,b.isUUID)(m)?m:null}catch(g){c=null}if(!c){c=(0,b.generateUuid)();try{await D.writeFile(L.serviceMachineIdResource,C.VSBuffer.fromString(c))}catch(g){}}return I&&I.store("storage.serviceMachineId",c,0,1),c}t.getServiceMachineId=S}),define(ee[116],te([0,1,3,13,2,12,67,14]),function($,t,C,b,S,L,D,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const c="__$__targetStorageMarker";t.IStorageService=(0,I.createDecorator)("storageService");var g;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(g=t.WillSaveStateReason||(t.WillSaveStateReason={}));var m;(function(u){u[u.GLOBAL=0]="GLOBAL",u[u.WORKSPACE=1]="WORKSPACE"})(m=t.StorageScope||(t.StorageScope={}));var R;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(R=t.StorageTarget||(t.StorageTarget={}));class h extends S.Disposable{constructor(y={flushInterval:h.DEFAULT_FLUSH_INTERVAL}){super();this.options=y,this._onDidChangeValue=this._register(new b.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new b.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new b.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new C.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new S.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,C.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,S.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(y,f){f===c?(y===0?this._globalKeyTargets=void 0:y===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:y})):this._onDidChangeValue.fire({scope:y,key:f,target:this.getKeyTargets(y)[f]})}emitWillSaveState(y){this._onWillSaveState.fire({reason:y})}get(y,f,p){return this.getStorage(f)?.get(y,p)}getBoolean(y,f,p){return this.getStorage(f)?.getBoolean(y,p)}getNumber(y,f,p){return this.getStorage(f)?.getNumber(y,p)}store(y,f,p,d){if((0,L.isUndefinedOrNull)(f)){this.remove(y,p);return}this.withPausedEmitters(()=>{this.updateKeyTarget(y,p,d),this.getStorage(p)?.set(y,f)})}remove(y,f){this.withPausedEmitters(()=>{this.updateKeyTarget(y,f,void 0),this.getStorage(f)?.delete(y)})}withPausedEmitters(y){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{y()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(y,f){const p=[],d=this.getKeyTargets(y);for(const o of Object.keys(d))d[o]===f&&p.push(o);return p}updateKeyTarget(y,f,p){const d=this.getKeyTargets(f);typeof p=="number"?d[y]!==p&&(d[y]=p,this.getStorage(f)?.set(c,JSON.stringify(d))):typeof d[y]=="number"&&(delete d[y],this.getStorage(f)?.set(c,JSON.stringify(d)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(y){return y===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(y){const f=this.get(c,y);if(f)try{return JSON.parse(f)}catch(p){}return Object.create(null)}isNew(y){return this.getBoolean(t.IS_NEW_KEY,y)===!0}async flush(y=g.NONE){this._onWillSaveState.fire({reason:y}),await C.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const y=this.getStorage(0)?.items??new Map,f=this.getStorage(1)?.items??new Map;return l(y,f,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}t.AbstractStorageService=h,h.DEFAULT_FLUSH_INTERVAL=60*1e3;class v extends h{constructor(){super();this.globalStorage=this._register(new D.Storage(new D.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new D.Storage(new D.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(y=>this.emitDidChangeValue(1,y))),this._register(this.globalStorage.onDidChangeStorage(y=>this.emitDidChangeValue(0,y)))}getStorage(y){return y===0?this.globalStorage:this.workspaceStorage}getLogDetails(y){return y===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(y){}}t.InMemoryStorageService=v;async function l(u,y,f,p){const d=a=>{try{return JSON.parse(a)}catch(E){return a}},o=new Map,s=new Map;u.forEach((a,E)=>{o.set(E,a),s.set(E,d(a))});const e=new Map,n=new Map;y.forEach((a,E)=>{e.set(E,a),n.set(E,d(a))}),console.group(`Storage: Global (path: ${f})`);let i=[];o.forEach((a,E)=>{i.push({key:E,value:a})}),console.table(i),console.groupEnd(),console.log(s),console.group(`Storage: Workspace (path: ${p})`);let r=[];e.forEach((a,E)=>{r.push({key:E,value:a})}),console.table(r),console.groupEnd(),console.log(n)}t.logStorage=l}),define(ee[117],te([0,1,9,29,7,30]),function($,t,C,b,S,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function D(g){if(C.platform===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}async function I(g,m,R,h,v,l,u,y,f,p){const d=Object.create(null);d["common.machineId"]=u,d.sessionID=(0,L.generateUuid)()+Date.now(),d.commitHash=v,d.version=l,d["common.platformVersion"]=(m||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=(0,C.PlatformToString)(C.platform),d["common.nodePlatform"]=b.platform,d["common.nodeArch"]=h,d["common.product"]=p||"desktop";const o=c(y||[]);o&&(d["common.msftInternal"]=o);let s=0;const e=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-e,enumerable:!0},"common.sequence":{get:()=>s++,enumerable:!0}}),C.isLinuxSnap&&(d["common.snap"]="true");const n=D(R);n&&(d["common.platformDetail"]=n);try{const i=await g.readFile(S.URI.file(f));d["common.source"]=i.value.toString().slice(0,30)}catch(i){}return d}t.resolveCommonProperties=I;function c(g){const m=b.env.USERDNSDOMAIN;if(!m)return!1;const R=m.toLowerCase();return g.some(h=>R===h)}t.verifyMicrosoftInternalDomain=c}),define(ee[36],te([0,1,14]),function($,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,C.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,C.createDecorator)("customEndpointTelemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId"}),define(ee[118],te([0,1,22,3,25,11,13,2,9,7,75,23,24,15,35,36]),function($,t,C,b,S,L,D,I,c,g,m,R,h,v,l,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractExtensionTask=t.reportTelemetry=t.joinErrors=t.AbstractExtensionManagementService=t.INSTALL_ERROR_LOCAL=t.ERROR_UNKNOWN=t.INSTALL_ERROR_VALIDATING=void 0,t.INSTALL_ERROR_VALIDATING="validating",t.ERROR_UNKNOWN="unknown",t.INSTALL_ERROR_LOCAL="local";let y=class extends I.Disposable{constructor(s,e,n){super();this.galleryService=s,this.telemetryService=e,this.logService=n,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new D.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new D.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new D.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new D.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,I.toDisposable)(()=>{this.installingExtensions.forEach(i=>i.cancel()),this.uninstallingExtensions.forEach(i=>i.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async installFromGallery(s,e={}){if(!this.galleryService.isEnabled())throw new Error(m.localize(0,null));try{s=await this.checkAndGetCompatibleVersion(s,!e.installGivenVersion)}catch(i){throw this.logService.error((0,L.getErrorMessage)(i)),p(this.telemetryService,"extensionGallery:install",(0,h.getGalleryExtensionTelemetryData)(s),void 0,i),i}if(!await this.canInstall(s)){const i=new R.ExtensionManagementError("Not supported",t.INSTALL_ERROR_VALIDATING);throw this.logService.error("Cannot install extension as it is not supported.",s.identifier.id,i.message),p(this.telemetryService,"extensionGallery:install",(0,h.getGalleryExtensionTelemetryData)(s),void 0,i),i}const n=await this.galleryService.getManifest(s,S.CancellationToken.None);if(n===null){const i=new R.ExtensionManagementError(`Missing manifest for extension ${s.identifier.id}`,t.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",s.identifier.id,i.message),p(this.telemetryService,"extensionGallery:install",(0,h.getGalleryExtensionTelemetryData)(s),void 0,i),i}if(n.version!==s.version){const i=new R.ExtensionManagementError(`Cannot install '${s.identifier.id}' extension because of version mismatch in Marketplace`,t.INSTALL_ERROR_VALIDATING);throw this.logService.error(i.message),p(this.telemetryService,"extensionGallery:install",(0,h.getGalleryExtensionTelemetryData)(s),void 0,i),i}return this.installExtension(n,s,e)}async uninstall(s,e={}){return this.logService.trace("ExtensionManagementService#uninstall",s.identifier.id),this.unininstallExtension(s,e)}async reinstallFromGallery(s){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",s.identifier.id),!this.galleryService.isEnabled())throw new Error(m.localize(1,null));const e=await this.findGalleryExtension(s);if(!e)throw new Error(m.localize(2,null));await this.createUninstallExtensionTask(s,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(e)}getExtensionsReport(){const s=new Date().getTime();return(!this.reportedExtensions||s-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=s),this.reportedExtensions}registerParticipant(s){this.participants.push(s)}async installExtension(s,e,n){if(!g.URI.isUri(e)){let P=this.installingExtensions.get(new h.ExtensionIdentifierWithVersion(e.identifier,e.version).key());if(P)return this.logService.info("Extensions is already requested to install",e.identifier.id),P.waitUntilTaskIsFinished();n={...n,installOnlyNewlyAddedFromExtensionPack:!0}}const i=[],r=[],a=this.createInstallExtensionTask(s,e,n);g.URI.isUri(e)||this.installingExtensions.set(new h.ExtensionIdentifierWithVersion(a.identifier,s.version).key(),a),this._onInstallExtension.fire({identifier:a.identifier,source:e}),this.logService.info("Installing extension:",a.identifier.id),i.push({task:a,manifest:s});let E=!1;try{if(n.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",a.identifier.id);else try{const A=await this.getAllDepsAndPackExtensionsToInstall(a.identifier,s,!!n.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:w,manifest:T}of A)if(E=E||!!T.extensionDependencies?.some(M=>(0,h.areSameExtensions)({id:M},a.identifier)),this.installingExtensions.has(new h.ExtensionIdentifierWithVersion(w.identifier,w.version).key()))this.logService.info("Extension is already requested to install",w.identifier.id);else{const M=this.createInstallExtensionTask(T,w,{...n,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new h.ExtensionIdentifierWithVersion(M.identifier,T.version).key(),M),this._onInstallExtension.fire({identifier:M.identifier,source:w}),this.logService.info("Installing extension:",M.identifier.id),i.push({task:M,manifest:T})}}catch(A){if(g.URI.isUri(a.source))(0,C.isNonEmptyArray)(s.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",a.identifier.id,A.message),(0,C.isNonEmptyArray)(s.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",a.identifier.id,A.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",a.identifier.id),this.logService.error(A),A}const P=i.reduce((A,{task:w,manifest:T})=>(A.set(w.identifier.id.toLowerCase(),{task:w,manifest:T}),A),new Map);for(;P.size;){let A;const w=[...P.values()].filter(({manifest:T})=>!T.extensionDependencies?.some(M=>P.has(M.toLowerCase())));w.length?A=P.size===1?w:w.filter(({task:T})=>!(T===a&&!E)):(this.logService.info("Found extensions with circular dependencies",w.map(({task:T})=>T.identifier.id)),A=[...P.values()]),await this.joinAllSettled(A.map(async({task:T})=>{const M=new Date().getTime();try{const j=await T.run();if(await this.joinAllSettled(this.participants.map(Y=>Y.postInstall(j,T.source,n,S.CancellationToken.None))),!g.URI.isUri(T.source)&&(p(this.telemetryService,T.operation===2?"extensionGallery:update":"extensionGallery:install",(0,h.getGalleryExtensionTelemetryData)(T.source),new Date().getTime()-M,void 0),c.isWeb&&T.operation===1))try{await this.galleryService.reportStatistic(j.manifest.publisher,j.manifest.name,j.manifest.version,"install")}catch(Y){}r.push({local:j,identifier:T.identifier,operation:T.operation,source:T.source})}catch(j){throw g.URI.isUri(T.source)||p(this.telemetryService,T.operation===2?"extensionGallery:update":"extensionGallery:install",(0,h.getGalleryExtensionTelemetryData)(T.source),new Date().getTime()-M,j),this.logService.error("Error while installing the extension:",T.identifier.id),this.logService.error(j),j}finally{P.delete(T.identifier.id.toLowerCase())}}))}return r.forEach(({identifier:A})=>this.logService.info("Extension installed successfully:",A.id)),this._onDidInstallExtensions.fire(r),r.filter(({identifier:A})=>(0,h.areSameExtensions)(A,a.identifier))[0].local}catch(P){if(i.forEach(({task:A})=>A.cancel()),r.length)try{const A=await Promise.allSettled(r.map(({local:w})=>this.createUninstallExtensionTask(w,{versionOnly:!0}).run()));for(let w=0;w<A.length;w++){const T=A[w],{identifier:M}=r[w];T.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",M.id):this.logService.warn("Rollback: Error while uninstalling extension",M.id,(0,L.getErrorMessage)(T.reason))}}catch(A){this.logService.warn("Error while rolling back extensions",(0,L.getErrorMessage)(A),r.map(({identifier:w})=>w.id))}throw this.logService.error("Failed to install extension:",a.identifier.id,(0,L.getErrorMessage)(P)),this._onDidInstallExtensions.fire(i.map(({task:A})=>({identifier:A.identifier,operation:1,source:A.source}))),P instanceof Error&&(P.name=P&&P.code?P.code:t.ERROR_UNKNOWN),P}finally{for(const{task:P,manifest:A}of i)if(!g.URI.isUri(P.source)){const w=new h.ExtensionIdentifierWithVersion(P.identifier,A.version).key();this.installingExtensions.delete(w)||this.logService.warn("Installation task is not found in the cache",w)}}}async joinAllSettled(s){const e=[],n=[],i=await Promise.allSettled(s);for(const r of i)r.status==="fulfilled"?e.push(r.value):n.push(r.reason);if(n.length)throw f(n);return e}async getAllDepsAndPackExtensionsToInstall(s,e,n){if(!this.galleryService.isEnabled())return[];let i=await this.getInstalled();const r=[s,...i.map(P=>P.identifier)],a=[],E=async(P,A)=>{const w=A.extensionDependencies||[],T=[...w];if(A.extensionPack){const M=n?i.find(j=>(0,h.areSameExtensions)(j.identifier,P)):void 0;for(const j of A.extensionPack)M&&M.manifest.extensionPack&&M.manifest.extensionPack.some(Y=>(0,h.areSameExtensions)({id:Y},{id:j}))||T.every(Y=>!(0,h.areSameExtensions)({id:Y},{id:j}))&&T.push(j)}if(T.length){const M=[...r,...a.map(Y=>Y.gallery.identifier)],j=T.filter(Y=>M.every(ie=>!(0,h.areSameExtensions)(ie,{id:Y})));if(j.length){const Y=await this.galleryService.query({names:j,pageSize:T.length},S.CancellationToken.None);for(const ie of Y.firstPage){if(M.find(J=>(0,h.areSameExtensions)(J,ie.identifier)))continue;if(!w.some(J=>(0,h.areSameExtensions)({id:J},ie.identifier))&&!await this.canInstall(ie)){this.logService.info("Skipping the packed extension as it cannot be installed",ie.identifier.id);continue}const Z=await this.checkAndGetCompatibleVersion(ie,!0),K=await this.galleryService.getManifest(Z,S.CancellationToken.None);if(K===null)throw new R.ExtensionManagementError(`Missing manifest for extension ${Z.identifier.id}`,t.INSTALL_ERROR_VALIDATING);a.push({gallery:Z,manifest:K}),await E(Z.identifier,K)}}}};return await E(s,e),i=await this.getInstalled(),a.filter(P=>!i.some(A=>(0,h.areSameExtensions)(A.identifier,P.gallery.identifier)))}async checkAndGetCompatibleVersion(s,e){if(await this.isMalicious(s))throw new R.ExtensionManagementError(m.localize(3,null,s.identifier.id),R.INSTALL_ERROR_MALICIOUS);let n=null;if(await this.galleryService.isExtensionCompatible(s,R.CURRENT_TARGET_PLATFORM)&&(n=s),!n&&e&&(n=await this.galleryService.getCompatibleExtension(s,R.CURRENT_TARGET_PLATFORM)),!n)throw new R.ExtensionManagementError(m.localize(4,null,s.identifier.id,l.default.version),R.INSTALL_ERROR_INCOMPATIBLE);return n}async isMalicious(s){const e=await this.getExtensionsReport();return(0,h.getMaliciousExtensionsSet)(e).has(s.identifier.id)}async unininstallExtension(s,e){const n=this.uninstallingExtensions.get(s.identifier.id.toLowerCase());if(n)return this.logService.info("Extensions is already requested to uninstall",s.identifier.id),n.waitUntilTaskIsFinished();const i=(P,A)=>{const w=this.createUninstallExtensionTask(P,A);return this.uninstallingExtensions.set(w.extension.identifier.id.toLowerCase(),w),this.logService.info("Uninstalling extension:",P.identifier.id),this._onUninstallExtension.fire(P.identifier),w},r=(P,A)=>{A?this.logService.error("Failed to uninstall extension:",P.identifier.id,A.message):this.logService.info("Successfully uninstalled extension:",P.identifier.id),p(this.telemetryService,"extensionGallery:uninstall",(0,h.getLocalExtensionTelemetryData)(P),void 0,A),this._onDidUninstallExtension.fire({identifier:P.identifier,error:A?.code})},a=[],E=[];try{a.push(i(s,{}));const P=await this.getInstalled(1);if(e.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",s.identifier.id);else{const A=this.getAllPackExtensionsToUninstall(s,P);for(const w of A)this.uninstallingExtensions.has(w.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",w.identifier.id):a.push(i(w,{}))}e.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",s.identifier.id):this.checkForDependents(a.map(A=>A.extension),P,s),await this.joinAllSettled(a.map(async A=>{try{if(await A.run(),await this.joinAllSettled(this.participants.map(w=>w.postUninstall(A.extension,e,S.CancellationToken.None))),A.extension.identifier.uuid)try{await this.galleryService.reportStatistic(A.extension.manifest.publisher,A.extension.manifest.name,A.extension.manifest.version,"uninstall")}catch(w){}r(A.extension)}catch(w){const T=w instanceof R.ExtensionManagementError?w:new R.ExtensionManagementError((0,L.getErrorMessage)(w),t.ERROR_UNKNOWN);throw r(A.extension,T),T}finally{E.push(A)}}))}catch(P){const A=P instanceof R.ExtensionManagementError?P:new R.ExtensionManagementError((0,L.getErrorMessage)(P),t.ERROR_UNKNOWN);for(const w of a){try{w.cancel()}catch(T){}E.includes(w)||r(w.extension,A)}throw A}finally{for(const P of a)this.uninstallingExtensions.delete(P.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",P.extension.identifier.id)}}checkForDependents(s,e,n){for(const i of s){const r=this.getDependents(i,e);if(r.length){const a=r.filter(E=>!s.some(P=>(0,h.areSameExtensions)(P.identifier,E.identifier)));if(a.length)throw new Error(this.getDependentsErrorMessage(i,a,n))}}}getDependentsErrorMessage(s,e,n){return n===s?e.length===1?m.localize(5,null,n.manifest.displayName||n.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?m.localize(6,null,n.manifest.displayName||n.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):m.localize(7,null,n.manifest.displayName||n.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):e.length===1?m.localize(8,null,n.manifest.displayName||n.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?m.localize(9,null,n.manifest.displayName||n.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):m.localize(10,null,n.manifest.displayName||n.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name)}getAllPackExtensionsToUninstall(s,e,n=[]){if(n.indexOf(s)!==-1)return[];n.push(s);const i=s.manifest.extensionPack?s.manifest.extensionPack:[];if(i.length){const r=e.filter(E=>!E.isBuiltin&&i.some(P=>(0,h.areSameExtensions)({id:P},E.identifier))),a=[];for(const E of r)a.push(...this.getAllPackExtensionsToUninstall(E,e,n));return[...r,...a]}return[]}getDependents(s,e){return e.filter(n=>n.manifest.extensionDependencies&&n.manifest.extensionDependencies.some(i=>(0,h.areSameExtensions)({id:i},s.identifier)))}async findGalleryExtension(s){if(s.identifier.uuid){const e=await this.findGalleryExtensionById(s.identifier.uuid);return e||this.findGalleryExtensionByName(s.identifier.id)}return this.findGalleryExtensionByName(s.identifier.id)}async findGalleryExtensionById(s){return(await this.galleryService.query({ids:[s],pageSize:1},S.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(s){return(await this.galleryService.query({names:[s],pageSize:1},S.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const s=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${s.length} reported extensions from service`),s}catch(s){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};y=fe([ue(0,R.IExtensionGalleryService),ue(1,u.ITelemetryService),ue(2,v.ILogService)],y),t.AbstractExtensionManagementService=y;function f(o){const s=Array.isArray(o)?o:[o];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((e,n)=>new Error(`${e.message}${e.message?",":""}${n instanceof Error?n.message:n}`),new Error(""))}t.joinErrors=f;function p(o,s,e,n,i){const r=i?i instanceof R.ExtensionManagementError?i.code:t.ERROR_UNKNOWN:void 0;o.publicLogError(s,{...e,success:!i,duration:n,errorcode:r})}t.reportTelemetry=p;class d{constructor(){this.barrier=new b.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,b.createCancelablePromise)(s=>this.doRun(s))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,b.createCancelablePromise)(s=>new Promise((e,n)=>{const i=s.onCancellationRequested(()=>{i.dispose(),n((0,L.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}t.AbstractExtensionTask=d}),define(ee[119],te([0,1,2,18,21,86,27,31,35,26]),function($,t,C,b,S,L,D,I,c,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let m=class{constructor(v,l){this._configurationService=l,this._experimentProperties={},this._disposables=new C.DisposableStore,this._cleanupPatterns=[],this._appender=v.appender,this._commonProperties=v.commonProperties||Promise.resolve({}),this._piiPaths=v.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!v.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let u of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,S.escapeRegExpCharacters)(u),"gi"));this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(u=>{const y=/^[a-f0-9]+$/i.test(u["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!y})})}setExperimentProperty(v,l){this._experimentProperties[v]=l}setEnabled(v){this._enabled=v}_updateUserOptIn(){const v=this._configurationService?.getValue(R);this._userOptIn=v?v.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const v=await this._commonProperties;let l=v.sessionID,u=v["common.instanceId"],y=v["common.machineId"],f=v["common.firstSessionDate"],p=v["common.msftInternal"];return{sessionId:l,instanceId:u,machineId:y,firstSessionDate:f,msftInternal:p}}dispose(){this._disposables.dispose()}publicLog(v,l,u){return this.isOptedIn?this._commonProperties.then(y=>{l=(0,b.mixin)(l,y),l=(0,b.mixin)(l,this._experimentProperties),l=(0,b.cloneAndChange)(l,f=>{if(typeof f=="string")return this._cleanupInfo(f,u)}),this._appender.log(v,l)},y=>{console.error(y)}):Promise.resolve(void 0)}publicLog2(v,l,u){return this.publicLog(v,l,u)}publicLogError(v,l){return this.sendErrorTelemetry?this.publicLog(v,l,!0):Promise.resolve(void 0)}publicLogError2(v,l){return this.publicLogError(v,l)}_cleanupInfo(v,l){let u=v;if(l){const y=[];for(let o of this._cleanupPatterns)for(;;){const s=o.exec(v);if(!s)break;y.push([s.index,o.lastIndex])}const f=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,p=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let d=0;for(u="";;){const o=p.exec(v);if(!o)break;!f.test(o[0])&&y.every(([s,e])=>o.index<s||o.index>=e)&&(u+=v.substring(d,o.index)+"<REDACTED: user-file-path>",d=p.lastIndex)}d<v.length&&(u+=v.substr(d))}for(let y of this._cleanupPatterns)u=u.replace(y,"");return u}};m.IDLE_START_EVENT_NAME="UserIdleStart",m.IDLE_STOP_EVENT_NAME="UserIdleStop",m=fe([ue(1,D.IConfigurationService)],m),t.TelemetryService=m;const R="telemetry";g.Registry.as(I.Extensions.Configuration).registerConfiguration({id:R,order:110,type:"object",title:(0,L.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,L.localize)(2,null,c.default.nameLong,c.default.privacyStatementUrl):(0,L.localize)(1,null,c.default.nameLong),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ee[44],te([0,1,3,18,12,27]),function($,t,C,b,S,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.getTelemetryLevel=t.TelemetryLevel=t.configurationTelemetry=t.NullAppender=t.combinedAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=void 0,t.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(y,f){return Promise.resolve(void 0)}publicLog2(y,f){return this.publicLog(y,f)}publicLogError(y,f){return Promise.resolve(void 0)}publicLogError2(y,f){return this.publicLogError(y,f)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class D{async publicLog(f,p,d){}async publicLogError(f,p,d){}}t.NullEndpointTelemetryService=D;function I(...y){return{log:(f,p)=>y.forEach(d=>d.log(f,p)),flush:()=>C.Promises.settled(y.map(f=>f.flush()))}}t.combinedAppender=I,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function c(y,f){return f.onDidChangeConfiguration(p=>{p.source!==6&&y.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(p.source),configurationKeys:l(p.sourceConfig)})})}t.configurationTelemetry=c;var g;(function(y){y[y.NONE=0]="NONE",y[y.LOG=1]="LOG",y[y.USER=2]="USER"})(g=t.TelemetryLevel||(t.TelemetryLevel={}));function m(y,f){return f.disableTelemetry||!y.enableTelemetry?0:f.isBuilt?2:1}t.getTelemetryLevel=m;function R(y){const f=Object.create(null),p=Object.create(null),d=Object.create(null);v(y,d);for(let o in d){o=o.length>150?o.substr(o.length-149):o;const s=d[o];typeof s=="number"?p[o]=s:typeof s=="boolean"?p[o]=s?1:0:typeof s=="string"?f[o]=s.substring(0,1023):typeof s!="undefined"&&s!==null&&(f[o]=s)}return{properties:f,measurements:p}}t.validateTelemetryData=R;function h(y){if(!y)return"none";let f="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(d=>{y.indexOf(`${d}+`)===0&&(f=d)}),f}t.cleanRemoteAuthority=h;function v(y,f,p=0,d){if(!!y)for(let o of Object.getOwnPropertyNames(y)){const s=y[o],e=d?d+o:o;Array.isArray(s)?f[e]=(0,b.safeStringify)(s):s instanceof Date?f[e]=s.toISOString():(0,S.isObject)(s)?p<2?v(s,f,p+1,e+"."):f[e]=(0,b.safeStringify)(s):f[e]=s}}function l(y){if(!y)return[];const f=[];return u(f,"",y),f}function u(y,f,p){p&&typeof p=="object"&&!Array.isArray(p)?Object.keys(p).forEach(d=>u(y,f?`${f}.${d}`:d,p[d])):y.push(f)}}),define(ee[120],te([0,1,22,25,11,18,9,7,27,20,23,24,51,16,14,15,42,43,115,116,36,44]),function($,t,C,b,S,L,D,I,c,g,m,R,h,v,l,u,y,f,p,d,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryService=void 0;var e;(function(k){k[k.None=0]="None",k[k.IncludeVersions=1]="IncludeVersions",k[k.IncludeFiles=2]="IncludeFiles",k[k.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",k[k.IncludeSharedAccounts=8]="IncludeSharedAccounts",k[k.IncludeVersionProperties=16]="IncludeVersionProperties",k[k.ExcludeNonValidated=32]="ExcludeNonValidated",k[k.IncludeInstallationTargets=64]="IncludeInstallationTargets",k[k.IncludeAssetUri=128]="IncludeAssetUri",k[k.IncludeStatistics=256]="IncludeStatistics",k[k.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",k[k.Unpublished=4096]="Unpublished"})(e||(e={}));function n(...k){return String(k.reduce((F,U)=>F|U,0))}var i;(function(k){k[k.Tag=1]="Tag",k[k.ExtensionId=4]="ExtensionId",k[k.Category=5]="Category",k[k.ExtensionName=7]="ExtensionName",k[k.Target=8]="Target",k[k.Featured=9]="Featured",k[k.SearchText=10]="SearchText",k[k.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},P={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:e.None,criteria:[],assetTypes:[]};class A{constructor(F=P){this.state=F}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(F,U=this.state.pageSize){return new A({...this.state,pageNumber:F,pageSize:U})}withFilter(F,...U){const V=[...this.state.criteria,...U.length?U.map(q=>({filterType:F,value:q})):[{filterType:F}]];return new A({...this.state,criteria:V})}withSortBy(F){return new A({...this.state,sortBy:F})}withSortOrder(F){return new A({...this.state,sortOrder:F})}withFlags(...F){return new A({...this.state,flags:F.reduce((U,V)=>U|V,0)})}withAssetTypes(...F){return new A({...this.state,assetTypes:F})}get raw(){const{criteria:F,pageNumber:U,pageSize:V,sortBy:q,sortOrder:X,flags:re,assetTypes:ne}=this.state;return{filters:[{criteria:F,pageNumber:U,pageSize:V,sortBy:q,sortOrder:X}],assetTypes:ne,flags:re}}get searchText(){const F=this.state.criteria.filter(U=>U.filterType===i.SearchText)[0];return F&&F.value?F.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(F=>String(F.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function w(k,F){const U=(k||[]).filter(V=>V.statisticName===F)[0];return U?U.value:0}function T(k){const F="Microsoft.VisualStudio.Code.Translation.";return k.files.filter(V=>V.assetType.indexOf(F)===0).reduce((V,q)=>{const X=ie(k,q.assetType);return X&&V.push([q.assetType.substring(F.length),X]),V},[])}function M(k){if(k.properties){const F=k.properties.filter(q=>q.key===r.Repository),U=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),V=F.filter(q=>U.test(q.value))[0];return V?{uri:V.value,fallbackUri:V.value}:null}return ie(k,r.Repository)}function j(k){return{uri:`${k.fallbackAssetUri}/${r.VSIX}?redirect=true${k.targetPlatform?`&targetPlatform=${k.targetPlatform}`:""}`,fallbackUri:`${k.fallbackAssetUri}/${r.VSIX}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`}}function Y(k){const F=ie(k,r.Icon);if(F)return F;const U=m.DefaultIconPath;return{uri:U,fallbackUri:U}}function ie(k,F){return k.files.filter(V=>V.assetType===F)[0]?{uri:`${k.assetUri}/${F}`,fallbackUri:`${k.fallbackAssetUri}/${F}`}:null}function oe(k,F){const U=k.properties?k.properties.filter(q=>q.key===F):[],V=U.length>0&&U[0].value;return V?V.split(",").map(q=>(0,R.adoptToGalleryExtensionId)(q)):[]}function Z(k){const F=k.properties?k.properties.filter(U=>U.key===a.Engine):[];return F.length>0&&F[0].value||""}function K(k){const F=k.properties?k.properties.filter(V=>V.key===a.LocalizedLanguages):[],U=F.length>0&&F[0].value||"";return U?U.split(","):[]}function J(k){return k.indexOf("preview")!==-1}function Q(k){return k.targetPlatform?(0,m.toTargetPlatform)(k.targetPlatform):"undefined"}function se(k){const F=(0,C.distinct)(k.versions.map(Q)),U=!!k.tags?.includes(m.WEB_EXTENSION_TAG),V=F.indexOf("web");return U?V===-1&&F.push("web"):V!==-1&&F.splice(V,1),F}function W(k,F){return F==="web"&&!k.includes("web")}function O(k,F,U){if(W(F,U))return!1;if(k==="undefined"||k==="universal")return!0;if(k==="unknown")return!1;if(k===U)return!0;switch(U){case"win32-x64":return k==="win32-ia32";case"win32-arm64":return k==="win32-ia32";default:return!1}}function x(k,F,U,V){const q=se(k);let X=k.versions[0];return X=k.versions.find(re=>re.version===X.version&&O(Q(re),q,m.CURRENT_TARGET_PLATFORM))||X,z(k,X,q,F,U,V)}function z(k,F,U,V,q,X){const re={manifest:ie(F,r.Manifest),readme:ie(F,r.Details),changelog:ie(F,r.Changelog),license:ie(F,r.License),repository:M(F),download:j(F),icon:Y(F),coreTranslations:T(F)};return{identifier:{id:(0,R.getGalleryExtensionId)(k.publisher.publisherName,k.extensionName),uuid:k.extensionId},name:k.extensionName,version:F.version,displayName:k.displayName,publisherId:k.publisher.publisherId,publisher:k.publisher.publisherName,publisherDisplayName:k.publisher.displayName,description:k.shortDescription||"",installCount:w(k.statistics,"install"),rating:w(k.statistics,"averagerating"),ratingCount:w(k.statistics,"ratingcount"),categories:k.categories||[],tags:k.tags||[],releaseDate:Date.parse(k.releaseDate),lastUpdated:Date.parse(k.lastUpdated),allTargetPlatforms:U,assets:re,properties:{dependencies:oe(F,a.Dependency),extensionPack:oe(F,a.ExtensionPack),engine:Z(F),localizedLanguages:K(F),targetPlatform:Q(F)},preview:J(k.flags),telemetryData:{index:(q.pageNumber-1)*q.pageSize+V,querySource:X}}}let H=class{constructor(F,U,V,q,X,re,ne,de){this.requestService=F,this.logService=U,this.environmentService=V,this.telemetryService=q,this.fileService=X,this.productService=re,this.configurationService=ne;const ge=re.extensionsGallery;this.extensionsGalleryUrl=ge&&ge.serviceUrl,this.extensionsControlUrl=ge&&ge.controlUrl,this.commonHeadersPromise=B(re.version,re,this.environmentService,this.configurationService,this.fileService,de)}api(F=""){return`${this.extensionsGalleryUrl}${F}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(F,U){const V=[];let q=new A().withFlags(e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,F.length).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExtensionName,...F.map(({id:re})=>re.toLowerCase()));F.every(re=>!re.version)&&(q=q.withFlags(e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties,e.IncludeLatestVersionOnly));const{galleryExtensions:X}=await this.queryGallery(q,b.CancellationToken.None);for(let re=0;re<X.length;re++){const ne=X[re];if(!ne.versions.length)continue;const de=(0,R.getGalleryExtensionId)(ne.publisher.publisherName,ne.extensionName),ge=F.find(he=>(0,R.areSameExtensions)(he,{id:de}))?.version;if(ge){const he=ne.versions.find(Ee=>Ee.version===ge);he&&V.push(z(ne,he,se(ne),re,q))}else V.push(x(ne,re,q))}return V}async getCompatibleExtension(F,U){const V=(0,m.isIExtensionIdentifier)(F)?null:F;if(V){if(W(V.allTargetPlatforms,U))return null;if(await this.isExtensionCompatible(V,U))return V}const{id:q,uuid:X}=V?V.identifier:F;let re=new A().withFlags(e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,1).withFilter(i.Target,"Microsoft.VisualStudio.Code");X?re=re.withFilter(i.ExtensionId,X):re=re.withFilter(i.ExtensionName,q);const{galleryExtensions:ne}=await this.queryGallery(re,b.CancellationToken.None),[de]=ne;if(!de||!de.versions.length)return null;const ge=se(de);if(W(ge,U))return null;for(let he of de.versions){if(!Z(he)){const Ee=await this.getEngine(he);he={...he,properties:[...he.properties||[],{key:a.Engine,value:Ee}]}}if(await this.isRawExtensionVersionCompatible(he,ge,U))return z(de,he,ge,0,re)}return null}async isExtensionCompatible(F,U){if(!O(F.properties.targetPlatform,F.allTargetPlatforms,U))return!1;let V=F.properties.engine;if(!V){const q=await this.getManifest(F,b.CancellationToken.None);if(!q)throw new Error("Manifest was not found");V=q.engines.vscode}return(0,h.isEngineValid)(V,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(F,U,V){if(!O(Q(F),U,V))return!1;const q=await this.getEngine(F);return(0,h.isEngineValid)(q,this.productService.version,this.productService.date)}async query(F,U){const V=b.CancellationToken.isCancellationToken(F)?{}:F,q=b.CancellationToken.isCancellationToken(F)?F:U;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let X=V.text||"";const re=(0,L.getOrDefault)(V,ye=>ye.pageSize,50);let ne=new A().withFlags(e.IncludeLatestVersionOnly,e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,re).withFilter(i.Target,"Microsoft.VisualStudio.Code");X?(X=X.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ye,Re,pe)=>(ne=ne.withFilter(i.Category,pe||Re),"")),X=X.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ye,Re,pe)=>(ne=ne.withFilter(i.Tag,pe||Re),"")),X=X.replace(/\bfeatured(\s+|\b|$)/g,()=>(ne=ne.withFilter(i.Featured),"")),X=X.trim(),X&&(X=X.length<200?X:X.substring(0,200),ne=ne.withFilter(i.SearchText,X)),ne=ne.withSortBy(0)):V.ids?ne=ne.withFilter(i.ExtensionId,...V.ids):V.names?ne=ne.withFilter(i.ExtensionName,...V.names):ne=ne.withSortBy(4),typeof V.sortBy=="number"&&(ne=ne.withSortBy(V.sortBy)),typeof V.sortOrder=="number"&&(ne=ne.withSortOrder(V.sortOrder));const{galleryExtensions:de,total:ge}=await this.queryGallery(ne,q),he=de.map((ye,Re)=>x(ye,Re,ne,V.source)),Ee=async(ye,Re)=>{if(Re.isCancellationRequested)throw(0,S.canceled)();const pe=ne.withPage(ye+1),{galleryExtensions:be}=await this.queryGallery(pe,Re);return be.map((ze,Ve)=>x(ze,Ve,pe,V.source))};return{firstPage:he,total:ge,pageSize:ne.pageSize,getPage:Ee}}async queryGallery(F,U){if(!this.isEnabled())throw new Error("No extension gallery service configured.");F=F.withFlags(F.flags,e.ExcludeNonValidated).withFilter(i.ExcludeWithFlags,n(e.Unpublished));const V=await this.commonHeadersPromise,q=JSON.stringify(F.raw),X={...V,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(q.length)},re=new Date().getTime();let ne,de,ge=0;try{if(ne=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:q,headers:X},U),ne.res.statusCode&&ne.res.statusCode>=400&&ne.res.statusCode<500)return{galleryExtensions:[],total:ge};const he=await(0,f.asJson)(ne);if(he){const Ee=he.results[0],ye=Ee.extensions,Re=Ee.resultMetadata&&Ee.resultMetadata.filter(pe=>pe.metadataType==="ResultCount")[0];return ge=Re&&Re.metadataItems.filter(pe=>pe.name==="TotalCount")[0].count||0,{galleryExtensions:ye,total:ge}}return{galleryExtensions:[],total:ge}}catch(he){throw de=he,he}finally{this.telemetryService.publicLog2("galleryService:query",{...F.telemetryData,requestBodySize:String(q.length),duration:new Date().getTime()-re,success:!!ne&&(0,f.isSuccess)(ne),responseBodySize:ne?.res.headers["Content-Length"],statusCode:ne?String(ne.res.statusCode):void 0,errorCode:de?(0,S.isPromiseCanceledError)(de)?"canceled":(0,S.getErrorMessage)(de).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ge)})}}async reportStatistic(F,U,V,q){if(!this.isEnabled())return;const X=D.isWeb?this.api(`/itemName/${F}.${U}/version/${V}/statType/${q==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${F}/extensions/${U}/${V}/stats?statType=${q}`),re=D.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",de={...await this.commonHeadersPromise,Accept:re};try{await this.requestService.request({type:"POST",url:X,headers:de},b.CancellationToken.None)}catch(ge){}}async download(F,U,V){this.logService.trace("ExtensionGalleryService#download",F.identifier.id);const q=(0,R.getGalleryExtensionTelemetryData)(F),X=new Date().getTime(),re=he=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...q,duration:he}),ne=V===1?"install":V===2?"update":"",de=ne?{uri:`${F.assets.download.uri}${I.URI.parse(F.assets.download.uri).query?"&":"?"}${ne}=true`,fallbackUri:`${F.assets.download.fallbackUri}${I.URI.parse(F.assets.download.fallbackUri).query?"&":"?"}${ne}=true`}:F.assets.download,ge=await this.getAsset(de);await this.fileService.writeFile(U,ge.stream),re(new Date().getTime()-X)}async getReadme(F,U){if(F.assets.readme){const V=await this.getAsset(F.assets.readme,{},U);return await(0,f.asText)(V)||""}return""}async getManifest(F,U){if(F.assets.manifest){const V=await this.getAsset(F.assets.manifest,{},U),q=await(0,f.asText)(V);return q?JSON.parse(q):null}return null}async getManifestFromRawExtensionVersion(F,U){const V=ie(F,r.Manifest);if(!V)throw new Error("Manifest was not found");const q={"Accept-Encoding":"gzip"},X=await this.getAsset(V,{headers:q});return await(0,f.asJson)(X)}async getCoreTranslation(F,U){const V=F.assets.coreTranslations.filter(q=>q[0]===U.toUpperCase())[0];if(V){const q=await this.getAsset(V[1]),X=await(0,f.asText)(q);return X?JSON.parse(X):null}return null}async getChangelog(F,U){if(F.assets.changelog){const V=await this.getAsset(F.assets.changelog,{},U);return await(0,f.asText)(V)||""}return""}async getAllCompatibleVersions(F,U){let V=new A().withFlags(e.IncludeVersions,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,1).withFilter(i.Target,"Microsoft.VisualStudio.Code");F.identifier.uuid?V=V.withFilter(i.ExtensionId,F.identifier.uuid):V=V.withFilter(i.ExtensionName,F.identifier.id);const{galleryExtensions:q}=await this.queryGallery(V,b.CancellationToken.None);if(!q.length)return[];const X=se(q[0]);if(W(X,U))return[];const re=[];for(const ne of q[0].versions)try{await this.isRawExtensionVersionCompatible(ne,X,U)&&re.push({version:ne.version,date:ne.lastUpdated})}catch(de){}return re}async getAsset(F,U={},V=b.CancellationToken.None){const q=await this.commonHeadersPromise,X={type:"GET"},re={...q,...U.headers||{}};U={...U,...X,headers:re};const ne=F.uri,de=F.fallbackUri,ge={...U,url:ne};try{const he=await this.requestService.request(ge,V);if(he.res.statusCode===200)return he;const Ee=await(0,f.asText)(he);throw new Error(`Expected 200, got back ${he.res.statusCode} instead.

${Ee}`)}catch(he){if((0,S.isPromiseCanceledError)(he))throw he;const Ee=(0,S.getErrorMessage)(he);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ne,message:Ee});const ye={...U,url:de};return this.requestService.request(ye,V)}}async getEngine(F){let U=Z(F);if(!U){const V=await this.getManifestFromRawExtensionVersion(F,b.CancellationToken.None);if(!V)throw new Error("Manifest was not found");U=V.engines.vscode}return U}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const F=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},b.CancellationToken.None);if(F.res.statusCode!==200)throw new Error("Could not get extensions report.");const U=await(0,f.asJson)(F),V=new Map;if(U)for(const q of U.malicious){const X=V.get(q)||{id:{id:q},malicious:!0,slow:!1};X.malicious=!0,V.set(q,X)}return[...V.values()]}};H=fe([ue(0,f.IRequestService),ue(1,u.ILogService),ue(2,g.IEnvironmentService),ue(3,o.ITelemetryService),ue(4,v.IFileService),ue(5,y.IProductService),ue(6,c.IConfigurationService),ue(7,(0,l.optional)(d.IStorageService))],H),t.ExtensionGalleryService=H;async function B(k,F,U,V,q,X){const re={"X-Market-Client-Id":`VSCode ${k}`,"User-Agent":`VSCode ${k}`},ne=await(0,p.getServiceMachineId)(U,q,X);return(0,s.getTelemetryLevel)(F,U)>=2&&V.getValue("telemetry.enableTelemetry")===!0&&(re["X-Market-User-Id"]=ne),re}t.resolveMarketplaceHeaders=B}),define(ee[121],te([0,1,11,18,44]),function($,t,C,b,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function L(I){const c=await new Promise((m,R)=>{$(["applicationinsights"],m,R)});let g;return c.defaultClient?(g=new c.TelemetryClient(I),g.channel.setUseDiskRetryCaching(!0)):(c.setup(I).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),g=c.defaultClient),I.indexOf("AIF-")===0&&(g.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),g}class D{constructor(c,g,m){this._eventPrefix=c,this._defaultData=g,this._defaultData||(this._defaultData=Object.create(null)),typeof m=="function"?this._aiClient=m():this._aiClient=m,this._asyncAIClient=null}_withAIClient(c){if(!!this._aiClient){if(typeof this._aiClient!="string"){c(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=L(this._aiClient)),this._asyncAIClient.then(g=>{c(g)},g=>{(0,C.onUnexpectedError)(g),console.error(g)})}}log(c,g){!this._aiClient||(g=(0,b.mixin)(g,this._defaultData),g=(0,S.validateTelemetryData)(g),this._withAIClient(m=>m.trackEvent({name:this._eventPrefix+"/"+c,properties:g.properties,measurements:g.measurements})))}flush(){return this._aiClient?new Promise(c=>{this._withAIClient(g=>{g.flush({callback:()=>{this._aiClient=void 0,c(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=D}),define(ee[122],te([0,1,4,10]),function($,t,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;async function S(L,D){const I=Object.create(null),c=(m,R)=>{const h=JSON.parse(m);I[R]=h};if(D){const m=[],R=await b.Promises.readdir(D);for(const v of R)try{(await b.Promises.stat((0,C.join)(D,v))).isDirectory()&&m.push(v)}catch{}const h=[];for(const v of m)(await b.Promises.readdir((0,C.join)(D,v))).filter(u=>u==="telemetry.json").length===1&&h.push(v);for(const v of h){const l=(await b.Promises.readFile((0,C.join)(D,v,"telemetry.json"))).toString();c(l,v)}}let g=(await b.Promises.readFile((0,C.join)(L,"telemetry-core.json"))).toString();return c(g,"vscode-core"),g=(await b.Promises.readFile((0,C.join)(L,"telemetry-extensions.json"))).toString(),c(g,"vscode-extensions"),JSON.stringify(I,null,4)}t.buildTelemetryMessage=S}),define(ee[45],te([0,1,38,3,4,12,10,73,133,134]),function($,t,C,b,S,L,D,I,c,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class m extends Error{constructor(e,n){let i=n.message;switch(e){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=e,this.cause=n}}t.ExtractError=m;function R(s){const e=s.externalFileAttributes>>16||33188;return[448,56,7].map(n=>e&n).reduce((n,i)=>n+i,e&61440)}function h(s){if(s instanceof m)return s;let e;return/end of central directory record signature not found/.test(s.message)&&(e="CorruptZip"),new m(e,s)}function v(s,e,n,i,r,a){const E=S.dirname(e),P=S.join(i,E);if(!P.startsWith(i))return Promise.reject(new Error(I.localize(0,null,e)));const A=S.join(i,e);let w;return a.onCancellationRequested(()=>{w&&w.destroy()}),Promise.resolve(D.Promises.mkdir(P,{recursive:!0})).then(()=>new Promise((T,M)=>{if(!a.isCancellationRequested)try{w=(0,C.createWriteStream)(A,{mode:n}),w.once("close",()=>T()),w.once("error",M),s.once("error",M),s.pipe(w)}catch(j){M(j)}}))}function l(s,e,n,i){let r=(0,b.createCancelablePromise)(()=>Promise.resolve()),a=0;return i.onCancellationRequested(()=>{r.cancel(),s.close()}),new Promise((E,P)=>{const A=new b.Sequencer,w=T=>{T.isCancellationRequested||(a++,s.readEntry())};s.once("error",P),s.once("close",()=>r.then(()=>{i.isCancellationRequested||s.entryCount===a?E():P(new m("Incomplete",new Error(I.localize(1,null,a,s.entryCount))))},P)),s.readEntry(),s.on("entry",T=>{if(i.isCancellationRequested)return;if(!n.sourcePathRegex.test(T.fileName)){w(i);return}const M=T.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(M)){const ie=S.join(e,M);r=(0,b.createCancelablePromise)(oe=>D.Promises.mkdir(ie,{recursive:!0}).then(()=>w(oe)).then(void 0,P));return}const j=y(s,T),Y=R(T);r=(0,b.createCancelablePromise)(ie=>A.queue(()=>j.then(oe=>v(oe,M,Y,e,n,ie).then(()=>w(ie)))).then(null,P))})})}function u(s,e=!1){return new Promise((n,i)=>{(0,c.open)(s,e?{lazyEntries:!0}:void 0,(r,a)=>{r?i(h(r)):n((0,L.assertIsDefined)(a))})})}function y(s,e){return new Promise((n,i)=>{s.openReadStream(e,(r,a)=>{r?i(h(r)):n((0,L.assertIsDefined)(a))})})}function f(s,e){return new Promise((n,i)=>{const r=new g.ZipFile;e.forEach(E=>{E.contents?r.addBuffer(typeof E.contents=="string"?Buffer.from(E.contents,"utf8"):E.contents,E.path):E.localPath&&r.addFile(E.localPath,E.path)}),r.end();const a=(0,C.createWriteStream)(s);r.outputStream.pipe(a),r.outputStream.once("error",i),a.once("error",i),a.once("finish",()=>n(s))})}t.zip=f;function p(s,e,n={},i){const r=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let a=u(s,!0);return n.overwrite&&(a=a.then(E=>D.Promises.rm(e).then(()=>E))),a.then(E=>l(E,e,{sourcePathRegex:r},i))}t.extract=p;function d(s,e){return u(s).then(n=>new Promise((i,r)=>{n.on("entry",a=>{a.fileName===e&&y(n,a).then(E=>i(E),E=>r(E))}),n.once("close",()=>r(new Error(I.localize(2,null,e))))}))}function o(s,e){return d(s,e).then(n=>new Promise((i,r)=>{const a=[];n.once("error",r),n.on("data",E=>a.push(E)),n.on("end",()=>i(Buffer.concat(a)))}))}t.buffer=o}),define(ee[123],te([0,1,45,79]),function($,t,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function S(L){return(0,C.buffer)(L,"extension/package.json").then(D=>{try{return JSON.parse(D.toString("utf8"))}catch(I){throw new Error((0,b.localize)(0,null))}})}t.getManifest=S}),define(ee[124],te([0,1,22,3,11,2,8,4,9,19,41,7,30,10,45,80,20,23,24,91,16,15,42]),function($,t,C,b,S,L,D,I,c,g,m,R,h,v,l,u,y,f,p,d,o,s,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;const n="scanningSystem",i="scanningUser",r="extracting",a="deleting",E="renaming";let P=class extends L.Disposable{constructor(w,T,M,j,Y){super();this.beforeRemovingExtension=w,this.fileService=T,this.logService=M,this.environmentService=j,this.productService=Y,this._devSystemExtensionsPath=null,this.systemExtensionsPath=j.builtinExtensionsPath,this.extensionsPath=j.extensionsPath,this.uninstalledPath=I.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new b.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(w){const T=[];(w===null||w===0)&&T.push(this.scanSystemExtensions().then(null,M=>Promise.reject(new f.ExtensionManagementError(this.joinErrors(M).message,n)))),(w===null||w===1)&&T.push(this.scanUserExtensions(!0).then(null,M=>Promise.reject(new f.ExtensionManagementError(this.joinErrors(M).message,i))));try{const M=await Promise.all(T);return(0,C.flatten)(M)}catch(M){throw this.joinErrors(M)}}async scanUserExtensions(w){this.logService.trace("Started scanning user extensions");let[T,M]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return M=M.filter(j=>!T[new p.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version).key()]),w&&(M=(0,p.groupByExtension)(M,Y=>Y.identifier).map(Y=>Y.sort((ie,oe)=>m.rcompare(ie.manifest.version,oe.manifest.version))[0])),this.logService.trace("Scanned user extensions:",M.length),M}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(w,T,M,j){const Y=w.key(),ie=I.join(this.extensionsPath,`.${(0,h.generateUuid)()}`),oe=I.join(this.extensionsPath,Y);try{await v.Promises.rm(oe)}catch(K){try{await v.Promises.rm(oe)}catch(J){}throw new f.ExtensionManagementError((0,u.localize)(0,null,oe,w.id),a)}await this.extractAtLocation(w,T,ie,j);let Z=await this.scanExtension(R.URI.file(ie),1);if(!Z)throw new Error((0,u.localize)(1,null,ie));await this.storeMetadata(Z,{...M,installedTimestamp:Date.now()});try{await this.rename(w,ie,oe,Date.now()+2*60*1e3),this.logService.info("Renamed to",oe)}catch(K){try{await v.Promises.rm(ie)}catch(J){}if(K.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",w.id);else throw this.logService.info(`Rename failed because of ${(0,S.getErrorMessage)(K)}. Deleted from extracted location`,ie),K}try{Z=await this.scanExtension(R.URI.file(oe),1)}catch(K){}if(Z)return Z;throw new Error((0,u.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(w,T){return this.setMetadata(w,T),await this.storeMetadata(w,{...T,installedTimestamp:w.installedTimestamp}),w}async storeMetadata(w,T){T.isMachineScoped=T.isMachineScoped||void 0,T.isBuiltin=T.isBuiltin||void 0,T.installedTimestamp=T.installedTimestamp||void 0;const M=I.join(w.location.fsPath,"package.json"),j=await v.Promises.readFile(M,"utf8"),{manifest:Y}=await this.parseManifest(j);return Y.__metadata=T,await v.Promises.writeFile(M,JSON.stringify(Y,null,"	")),w}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...w){const T=w.map(M=>new p.ExtensionIdentifierWithVersion(M.identifier,M.manifest.version));await this.withUninstalledExtensions(M=>{T.forEach(j=>M[j.key()]=!0)})}async setInstalled(w){await this.withUninstalledExtensions(j=>delete j[w.key()]);const M=(await this.scanExtensions(1)).find(j=>new p.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version).equals(w))||null;return M?(await this.storeMetadata(M,{installedTimestamp:Date.now()}),this.scanExtension(M.location,1)):null}async withUninstalledExtensions(w){return this.uninstalledFileLimiter.queue(async()=>{let T;try{T=await v.Promises.readFile(this.uninstalledPath,"utf8")}catch(j){if(j.code!=="ENOENT")throw j}let M={};if(T)try{M=JSON.parse(T)}catch(j){}return w&&(w(M),Object.keys(M).length?await v.Promises.writeFile(this.uninstalledPath,JSON.stringify(M)):await v.Promises.rm(this.uninstalledPath)),M})}async removeExtension(w,T){this.logService.trace(`Deleting ${T} extension from disk`,w.identifier.id,w.location.fsPath),await v.Promises.rm(w.location.fsPath),this.logService.info("Deleted from disk",w.identifier.id,w.location.fsPath)}async removeUninstalledExtension(w){await this.removeExtension(w,"uninstalled"),await this.withUninstalledExtensions(T=>delete T[new p.ExtensionIdentifierWithVersion(w.identifier,w.manifest.version).key()])}async extractAtLocation(w,T,M,j){this.logService.trace(`Started extracting the extension from ${T} to ${M}`);try{await v.Promises.rm(M)}catch(Y){throw new f.ExtensionManagementError(this.joinErrors(Y).message,a)}try{await(0,l.extract)(T,M,{sourcePath:"extension",overwrite:!0},j),this.logService.info(`Extracted extension to ${M}:`,w.id)}catch(Y){try{await v.Promises.rm(M)}catch(ie){}throw new f.ExtensionManagementError(Y.message,Y instanceof l.ExtractError&&Y.type?Y.type:r)}}async rename(w,T,M,j){try{await v.Promises.rename(T,M)}catch(Y){if(c.isWindows&&Y&&Y.code==="EPERM"&&Date.now()<j)return this.logService.info(`Failed renaming ${T} to ${M} with 'EPERM' error. Trying again...`,w.id),this.rename(w,T,M,j);throw new f.ExtensionManagementError(Y.message||(0,u.localize)(3,null,T,M),Y.code||E)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const w=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return w;const T=this.scanDevSystemExtensions(),[M,j]=await Promise.all([w,T]);return[...M,...j]}async scanExtensionsInDir(w,T){const M=new b.Limiter(10),j=await this.fileService.resolve(R.URI.file(w));return j.children?(await Promise.all(j.children.filter(ie=>ie.isDirectory).map(ie=>M.queue(async()=>T===1&&(0,g.basename)(ie.resource).indexOf(".")===0?null:this.scanExtension(ie.resource,T))))).filter(ie=>ie&&ie.identifier):[]}async scanExtension(w,T){try{const M=await this.fileService.resolve(w);if(M.children){const{manifest:j,metadata:Y}=await this.readManifest(w.fsPath),ie=M.children.find(({name:J})=>/^readme(\.txt|\.md|)$/i.test(J))?.resource,oe=M.children.find(({name:J})=>/^changelog(\.txt|\.md|)$/i.test(J))?.resource,Z={id:(0,p.getGalleryExtensionId)(j.publisher,j.name)},K={type:T,identifier:Z,manifest:j,location:w,readmeUrl:ie,changelogUrl:oe,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:T===0};return Y&&(this.setMetadata(K,Y),K.installedTimestamp=Y.installedTimestamp),K}}catch(M){T!==0&&this.logService.trace(M)}return null}async scanDefaultSystemExtensions(){const w=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",w.length),w}async scanDevSystemExtensions(){const w=this.getDevSystemExtensionsList();if(w.length){const T=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",T.length),T.filter(M=>w.some(j=>(0,p.areSameExtensions)(M.identifier,{id:j})))}else return[]}setMetadata(w,T){w.publisherDisplayName=T.publisherDisplayName||null,w.publisherId=T.publisherId||null,w.identifier.uuid=T.id,w.isMachineScoped=!!T.isMachineScoped,w.isBuiltin=w.type===0||!!T.isBuiltin}async removeUninstalledExtensions(){const w=await this.getUninstalledExtensions(),T=await this.scanAllUserExtensions(),M=new Set;for(const ie of T)w[new p.ExtensionIdentifierWithVersion(ie.identifier,ie.manifest.version).key()]||M.add(ie.identifier.id.toLowerCase());const j=(0,p.groupByExtension)(T,ie=>ie.identifier);await b.Promises.settled(j.map(async ie=>{const oe=ie.sort((Z,K)=>m.rcompare(Z.manifest.version,K.manifest.version))[0];M.has(oe.identifier.id.toLowerCase())||await this.beforeRemovingExtension(oe)}));const Y=T.filter(ie=>w[new p.ExtensionIdentifierWithVersion(ie.identifier,ie.manifest.version).key()]);await b.Promises.settled(Y.map(ie=>this.removeUninstalledExtension(ie)))}async removeOutdatedExtensions(){const w=await this.scanAllUserExtensions(),T=[],M=(0,p.groupByExtension)(w,j=>j.identifier);T.push(...(0,C.flatten)(M.map(j=>j.sort((Y,ie)=>m.rcompare(Y.manifest.version,ie.manifest.version)).slice(1)))),await b.Promises.settled(T.map(j=>this.removeExtension(j,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(w=>w.name)}joinErrors(w){const T=Array.isArray(w)?w:[w];return T.length===1?T[0]instanceof Error?T[0]:new Error(T[0]):T.reduce((M,j)=>new Error(`${M.message}${M.message?",":""}${j instanceof Error?j.message:j}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=I.normalize(I.join(D.FileAccess.asFileUri("",$).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(w){const T=[v.Promises.readFile(I.join(w,"package.json"),"utf8").then(ie=>this.parseManifest(ie)),v.Promises.readFile(I.join(w,"package.nls.json"),"utf8").then(void 0,ie=>ie.code!=="ENOENT"?Promise.reject(ie):"{}").then(ie=>JSON.parse(ie))],[{manifest:M,metadata:j},Y]=await Promise.all(T);return{manifest:(0,d.localizeManifest)(M,Y),metadata:j}}parseManifest(w){return new Promise((T,M)=>{try{const j=JSON.parse(w),Y=j.__metadata||null;T({manifest:j,metadata:Y})}catch(j){M(new Error((0,u.localize)(4,null)))}})}};P=fe([ue(1,o.IFileService),ue(2,s.ILogService),ue(3,y.INativeEnvironmentService),ue(4,e.IProductService)],P),t.ExtensionsScanner=P}),define(ee[125],te([0,1,28,8,4,9,19,41,7,30,10,45,78,53,20,118,23,24,102,103,123,98,124,104,51,16,14,15,35,36]),function($,t,C,b,S,L,D,I,c,g,m,R,h,v,l,u,y,f,p,d,o,s,e,n,i,r,a,E,P,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;const w="unsetUninstalled",T="downloading";let M=class extends u.AbstractExtensionManagementService{constructor(K,J,Q,se,W,O,x){super(K,J,Q);this.environmentService=se,this.downloadService=W;const z=this._register(O.createInstance(d.ExtensionsLifecycle));this.extensionsScanner=this._register(O.createInstance(e.ExtensionsScanner,B=>z.postUninstall(B))),this.manifestCache=this._register(new s.ExtensionsManifestCache(se,this)),this.extensionsDownloader=this._register(O.createInstance(p.ExtensionsDownloader));const H=this._register(new n.ExtensionsWatcher(this,x,se,Q));this._register(H.onDidChangeExtensionsByAnotherSource(({added:B,removed:k})=>{B.length&&this._onDidInstallExtensions.fire(B.map(F=>({identifier:F.identifier,operation:0,local:F}))),k.forEach(F=>this._onDidUninstallExtension.fire({identifier:F}))}))}async zip(K){this.logService.trace("ExtensionManagementService#zip",K.identifier.id);const J=await this.collectFiles(K),Q=await(0,R.zip)((0,D.joinPath)(this.environmentService.tmpDir,(0,g.generateUuid)()).fsPath,J);return c.URI.file(Q)}async unzip(K){return this.logService.trace("ExtensionManagementService#unzip",K.toString()),(await this.install(K)).identifier}async getManifest(K){const J=await this.downloadVsix(K),Q=S.resolve(J.fsPath);return(0,o.getManifest)(Q)}getInstalled(K=null){return this.extensionsScanner.scanExtensions(K)}async canInstall(K){return!0}async install(K,J={}){this.logService.trace("ExtensionManagementService#install",K.toString());const Q=await this.downloadVsix(K),se=await(0,o.getManifest)(S.resolve(Q.fsPath));if(se.engines&&se.engines.vscode&&!(0,i.isEngineValid)(se.engines.vscode,P.default.version,P.default.date))throw new Error(h.localize(0,null,(0,f.getGalleryExtensionId)(se.publisher,se.name),P.default.version));return this.installExtension(se,Q,J)}async updateMetadata(K,J){return this.logService.trace("ExtensionManagementService#updateMetadata",K.identifier.id),K=await this.extensionsScanner.saveMetadataForLocalExtension(K,{...K.manifest.__metadata||{},...J}),this.manifestCache.invalidate(),K}async updateExtensionScope(K,J){return this.logService.trace("ExtensionManagementService#updateExtensionScope",K.identifier.id),K=await this.extensionsScanner.saveMetadataForLocalExtension(K,{...K.manifest.__metadata||{},isMachineScoped:J}),this.manifestCache.invalidate(),K}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(K){if(K.scheme===b.Schemas.file)return K;const J=(0,D.joinPath)(this.environmentService.tmpDir,(0,g.generateUuid)());return await this.downloadService.download(K,J),J}createInstallExtensionTask(K,J,Q){return c.URI.isUri(J)?new ie(K,J,Q,this.galleryService,this.extensionsScanner,this.logService):new Y(J,Q,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(K,J){return new oe(K,J,this.extensionsScanner)}async collectFiles(K){const J=async se=>{let W=await m.Promises.readdir(se);W=W.map(z=>S.join(se,z));const O=await Promise.all(W.map(z=>m.Promises.stat(z)));let x=Promise.resolve([]);return O.forEach((z,H)=>{const B=W[H];z.isFile()&&(x=x.then(k=>[...k,B])),z.isDirectory()&&(x=x.then(k=>J(B).then(F=>[...k,...F])))}),x};return(await J(K.location.fsPath)).map(se=>({path:`extension/${S.relative(K.location.fsPath,se)}`,localPath:se}))}};M=fe([ue(0,y.IExtensionGalleryService),ue(1,A.ITelemetryService),ue(2,E.ILogService),ue(3,l.INativeEnvironmentService),ue(4,v.IDownloadService),ue(5,a.IInstantiationService),ue(6,r.IFileService)],M),t.ExtensionManagementService=M;class j extends u.AbstractExtensionTask{constructor(K,J,Q,se){super();this.identifier=K,this.source=J,this.extensionsScanner=Q,this.logService=se,this._operation=1}get operation(){return this._operation}async installExtension(K,J){try{const Q=await this.unsetUninstalledAndGetLocal(K.identifierWithVersion);if(Q)return K.metadata?this.extensionsScanner.saveMetadataForLocalExtension(Q,K.metadata):Q}catch(Q){throw L.isMacintosh?new y.ExtensionManagementError(h.localize(1,null),w):new y.ExtensionManagementError(h.localize(2,null),w)}return this.extract(K,J)}async unsetUninstalledAndGetLocal(K){if(!await this.isUninstalled(K))return null;this.logService.trace("Removing the extension from uninstalled list:",K.id);const Q=await this.extensionsScanner.setInstalled(K);return this.logService.info("Removed the extension from uninstalled list:",K.id),Q}async isUninstalled(K){return!!(await this.extensionsScanner.getUninstalledExtensions())[K.key()]}async extract({zipPath:K,identifierWithVersion:J,metadata:Q},se){let W=await this.extensionsScanner.extractUserExtension(J,K,Q,se);return this.logService.info("Extracting completed.",J.id),W}}class Y extends j{constructor(K,J,Q,se,W){super(K.identifier,K,se,W);this.gallery=K,this.options=J,this.extensionsDownloader=Q}async doRun(K){const Q=(await this.extensionsScanner.scanExtensions(null)).find(O=>(0,f.areSameExtensions)(O.identifier,this.gallery.identifier));Q&&(this._operation=2);const se=await this.downloadInstallableExtension(this.gallery,this._operation);se.metadata.isMachineScoped=this.options.isMachineScoped||Q?.isMachineScoped,se.metadata.isBuiltin=this.options.isBuiltin||Q?.isBuiltin;const W=await this.installExtension(se,K);Q&&I.neq(Q.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(Q);try{await this.extensionsDownloader.delete(c.URI.file(se.zipPath))}catch(O){}return W}async downloadInstallableExtension(K,J){const Q={id:K.identifier.uuid,publisherId:K.publisherId,publisherDisplayName:K.publisherDisplayName};let se;try{this.logService.trace("Started downloading extension:",K.identifier.id),se=(await this.extensionsDownloader.downloadExtension(K,J)).fsPath,this.logService.info("Downloaded extension:",K.identifier.id,se)}catch(W){throw new y.ExtensionManagementError((0,u.joinErrors)(W).message,T)}try{const W=await(0,o.getManifest)(se);return{zipPath:se,identifierWithVersion:new f.ExtensionIdentifierWithVersion(K.identifier,W.version),metadata:Q}}catch(W){throw new y.ExtensionManagementError((0,u.joinErrors)(W).message,u.INSTALL_ERROR_VALIDATING)}}}class ie extends j{constructor(K,J,Q,se,W,O){super({id:(0,f.getGalleryExtensionId)(K.publisher,K.name)},J,W,O);this.manifest=K,this.location=J,this.options=Q,this.galleryService=se}async doRun(K){const J=new f.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),se=(await this.extensionsScanner.scanExtensions(1)).find(O=>(0,f.areSameExtensions)(this.identifier,O.identifier)),W=await this.getMetadata(this.identifier.id,K);if(W.isMachineScoped=this.options.isMachineScoped||se?.isMachineScoped,W.isBuiltin=this.options.isBuiltin||se?.isBuiltin,se)if(this._operation=2,J.equals(new f.ExtensionIdentifierWithVersion(se.identifier,se.manifest.version)))try{await this.extensionsScanner.removeExtension(se,"existing")}catch(O){throw new Error(h.localize(3,null,this.manifest.displayName||this.manifest.name))}else I.gt(se.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(se);else{const O=await this.unsetUninstalledAndGetLocal(J);if(O)try{await this.extensionsScanner.removeExtension(O,"existing")}catch(x){throw new Error(h.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:S.resolve(this.location.fsPath),identifierWithVersion:J,metadata:W},K)}async getMetadata(K,J){try{const Q=(await this.galleryService.query({names:[K],pageSize:1},J)).firstPage[0];if(Q)return{id:Q.identifier.uuid,publisherDisplayName:Q.publisherDisplayName,publisherId:Q.publisherId}}catch(Q){}return{}}}class oe extends u.AbstractExtensionTask{constructor(K,J,Q){super();this.extension=K,this.options=J,this.extensionsScanner=Q}async doRun(K){const J=[],Q=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const se=new f.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);J.push(...Q.filter(W=>se.equals(new f.ExtensionIdentifierWithVersion(W.identifier,W.manifest.version))))}else J.push(...Q.filter(se=>(0,f.areSameExtensions)(se.identifier,this.extension.identifier)));if(!J.length)throw new Error(h.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...J),this.options.remove)for(const se of J)try{K.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(se)}catch(W){throw new Error(h.localize(6,null,(0,C.toErrorMessage)(W)))}}}}),define(ee[126],te([0,1,114,17,11,2,12,27,20,99,15,113,135]),function($,t,C,b,S,L,D,I,c,g,m,R,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let v=class extends L.Disposable{constructor(u,y,f){super();this.environmentService=y,this.logService=f,this.configure(u.getValue()),this._register(u.onDidChangeConfiguration(()=>this.configure(u.getValue()),this))}configure(u){this.proxyUrl=u.http&&u.http.proxy,this.strictSSL=!!(u.http&&u.http.proxyStrictSSL),this.authorization=u.http&&u.http.proxyAuthorization}async request(u,y){this.logService.trace("RequestService#request",u.url);const{proxyUrl:f,strictSSL:p}=this,d={...process.env,...await(0,g.resolveShellEnv)(this.logService,this.environmentService.args,process.env)},o=u.agent?u.agent:await(0,R.getProxyAgent)(u.url||"",d,{proxyUrl:f,strictSSL:p});return u.agent=o,u.strictSSL=p,this.authorization&&(u.headers={...u.headers||{},"Proxy-Authorization":this.authorization}),this._request(u,y)}async getNodeRequest(u){return((0,C.parse)(u.url).protocol==="https:"?await new Promise((p,d)=>{$(["https"],p,d)}):await new Promise((p,d)=>{$(["http"],p,d)})).request}_request(u,y){return new Promise(async(f,p)=>{let d;const o=(0,C.parse)(u.url),s=u.getRawRequest?u.getRawRequest(u):await this.getNodeRequest(u),e={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:u.type||"GET",headers:u.headers,agent:u.agent,rejectUnauthorized:(0,D.isBoolean)(u.strictSSL)?u.strictSSL:!0};u.user&&u.password&&(e.auth=u.user+":"+u.password),d=s(e,n=>{const i=(0,D.isNumber)(u.followRedirects)?u.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&i>0&&n.headers.location)this._request({...u,url:n.headers.location,followRedirects:i-1},y).then(f,p);else{let r=n;n.headers["content-encoding"]==="gzip"&&(r=n.pipe((0,h.createGunzip)())),f({res:n,stream:(0,b.streamToBufferReadableStream)(r)})}}),d.on("error",p),u.timeout&&d.setTimeout(u.timeout),u.data&&typeof u.data=="string"&&d.write(u.data),d.end(),y.onCancellationRequested(()=>{d.abort(),p((0,S.canceled)())})})}async resolveProxy(u){}};v=fe([ue(0,I.IConfigurationService),ue(1,c.INativeEnvironmentService),ue(2,m.ILogService)],v),t.RequestService=v}),define(ee[136],te([0,1,38,137,33,3,17,28,11,2,8,4,29,7,10,27,111,53,112,20,90,120,23,97,125,16,107,108,52,101,55,56,105,15,106,35,42,43,126,117,36,119,44,121,122]),function($,t,C,b,S,L,D,I,c,g,m,R,h,v,l,u,y,f,p,d,o,s,e,n,i,r,a,E,P,A,w,T,M,j,Y,ie,oe,Z,K,J,Q,se,W,O,x){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class z extends g.Disposable{constructor(k){super();this.argv=k,(0,b.gracefulify)(C),this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[k,F]=await this.initServices();return k.invokeFunction(async U=>{const V=U.get(j.ILogService),q=U.get(r.IFileService),X=U.get(d.INativeEnvironmentService),re=U.get(e.IExtensionManagementCLIService);return V.info("CLI main",this.argv),this.registerErrorHandler(V),await this.doRun(X,re,q),(0,L.raceTimeout)((0,W.combinedAppender)(...F).flush(),1e3)})}async initServices(){const k=new w.ServiceCollection,F={_serviceBrand:void 0,...ie.default};k.set(oe.IProductService,F);const U=new o.NativeEnvironmentService(this.argv,F);k.set(d.INativeEnvironmentService,U),await Promise.all([U.appSettingsHome.fsPath,U.extensionsPath].map(he=>he?l.Promises.mkdir(he,{recursive:!0}):void 0));const V=(0,j.getLogLevel)(U),q=[];q.push(new Y.SpdLogLogger("cli",(0,R.join)(U.logsPath,"cli.log"),!0,V)),V===j.LogLevel.Trace&&q.push(new j.ConsoleLogger(V));const X=this._register(new j.MultiplexLogService(q));k.set(j.ILogService,X);const re=this._register(new a.FileService(X));k.set(r.IFileService,re);const ne=this._register(new E.DiskFileSystemProvider(X));re.registerProvider(m.Schemas.file,ne);const de=this._register(new y.ConfigurationService(U.settingsResource,re));k.set(u.IConfigurationService,de),await de.initialize(),k.set(Z.IRequestService,new P.SyncDescriptor(K.RequestService)),k.set(f.IDownloadService,new P.SyncDescriptor(p.DownloadService)),k.set(e.IExtensionManagementService,new P.SyncDescriptor(i.ExtensionManagementService)),k.set(e.IExtensionGalleryService,new P.SyncDescriptor(s.ExtensionGalleryService)),k.set(e.IExtensionManagementCLIService,new P.SyncDescriptor(n.ExtensionManagementCLIService)),k.set(T.ILocalizationsService,new P.SyncDescriptor(M.LocalizationsService));const ge=[];if((0,W.getTelemetryLevel)(F,U)>=2){F.aiConfig&&F.aiConfig.asimovKey&&ge.push(new O.AppInsightsAppender("monacoworkbench",null,F.aiConfig.asimovKey));const{appRoot:he,extensionsPath:Ee,installSourcePath:ye}=U,Re={appender:(0,W.combinedAppender)(...ge),sendErrorTelemetry:!1,commonProperties:(async()=>{let pe;try{const be=await l.Promises.readFile((0,R.join)(U.userDataPath,"storage.json"));pe=JSON.parse(be.toString())[Q.machineIdKey]}catch(be){be.code!=="ENOENT"&&X.error(be)}return(0,J.resolveCommonProperties)(re,(0,S.release)(),(0,S.hostname)(),process.arch,F.commit,F.version,pe,F.msftInternalDomains,ye)})(),piiPaths:[he,Ee]};k.set(Q.ITelemetryService,new P.SyncDescriptor(se.TelemetryService,[Re]))}else k.set(Q.ITelemetryService,W.NullTelemetryService);return[new A.InstantiationService(k),ge]}registerErrorHandler(k){(0,c.setUnexpectedErrorHandler)(F=>{const U=(0,I.toErrorMessage)(F,!0);!U||k.error(`[uncaught exception in CLI]: ${U}`)}),process.on("uncaughtException",F=>(0,c.onUnexpectedError)(F)),process.on("unhandledRejection",F=>(0,c.onUnexpectedError)(F))}async doRun(k,F,U){if(this.argv["install-source"])return this.setInstallSource(k,U,this.argv["install-source"]);if(this.argv["list-extensions"])return F.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return F.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return F.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return F.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,x.buildTelemetryMessage)(k.appRoot,k.extensionsPath))}asExtensionIdOrVSIX(k){return k.map(F=>/\.vsix$/i.test(F)?v.URI.file((0,R.isAbsolute)(F)?F:(0,R.join)((0,h.cwd)(),F)):F)}async setInstallSource(k,F,U){await F.writeFile(v.URI.file(k.installSourcePath),D.VSBuffer.fromString(U.slice(0,30)))}}async function H(B){const k=new z(B);try{await k.run()}finally{k.dispose()}}t.main=H})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/34861b8c8aa76b517f203743ad5b5d72ef5fcd81/core/vs/code/node/cliProcessMain.js.map
