/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/path","vs/base/common/strings","vs/base/common/network","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/base/common/arrays","vs/base/common/async","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/buffer","vs/base/common/map","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/node/pfs","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/base/common/process","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","child_process","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/hash","vs/base/common/severity","fs","vs/editor/common/core/position","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/collections","vs/base/common/decorators","vs/base/common/json","vs/base/common/marshalling","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/theme/common/themeService","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/normalization","vs/base/common/labels","os","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/tunnel","vs/platform/sign/node/signService","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","path","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],ge=function(J){for(var e=[],m=0,L=J.length;m<L;m++)e[m]=me[J[m]];return e};define(me[56],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function m(L,I){if(!L)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}e.ok=m}),define(me[57],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const m=Object.prototype.hasOwnProperty;function L(n){const A=[];for(let u in n)m.call(n,u)&&A.push(n[u]);return A}e.values=L;function I(n,A){for(let u in n)if(m.call(n,u)&&A({key:u,value:n[u]},function(){delete n[u]})===!1)return}e.forEach=I;function k(n,A){const u=Object.create(null);for(const f of n){const l=A(f);let v=u[l];v||(v=u[l]=[]),v.push(f)}return u}e.groupBy=k;function R(n){const A=Object.create(null);return n&&n.forEach((u,f)=>{A[f]=u}),A}e.fromMap=R;function C(n,A){const u=[],f=[];for(let l of n)A.has(l)||u.push(l);for(let l of A)n.has(l)||f.push(l);return{removed:u,added:f}}e.diffSets=C;function D(n,A){const u=[],f=[];for(let[l,v]of n)A.has(l)||u.push(v);for(let[l,v]of A)n.has(l)||f.push(v);return{removed:u,added:f}}e.diffMaps=D;class T{constructor(){this.map=new Map}add(A,u){let f=this.map.get(A);f||(f=new Set,this.map.set(A,f)),f.add(u)}delete(A,u){const f=this.map.get(A);!f||(f.delete(u),f.size===0&&this.map.delete(A))}forEach(A,u){const f=this.map.get(A);!f||f.forEach(u)}}e.SetMap=T}),define(me[58],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function m(R){return(C,D,T)=>{let n=null,A=null;if(typeof T.value=="function"?(n="value",A=T.value):typeof T.get=="function"&&(n="get",A=T.get),!A)throw new Error("not supported");T[n]=R(A,D)}}e.createDecorator=m;function L(R,C,D){let T=null,n=null;if(typeof D.value=="function"?(T="value",n=D.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(T="get",n=D.get),!n)throw new Error("not supported");const A=`$memoize$${C}`;D[T]=function(...u){return this.hasOwnProperty(A)||Object.defineProperty(this,A,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,u)}),this[A]}}e.memoize=L;function I(R,C,D){return m((T,n)=>{const A=`$debounce$${n}`,u=`$debounce$result$${n}`;return function(...f){this[u]||(this[u]=D?D():void 0),clearTimeout(this[A]),C&&(this[u]=C(this[u],...f),f=[this[u]]),this[A]=setTimeout(()=>{T.apply(this,f),this[u]=D?D():void 0},R)}})}e.debounce=I;function k(R,C,D){return m((T,n)=>{const A=`$throttle$timer$${n}`,u=`$throttle$result$${n}`,f=`$throttle$lastRun$${n}`,l=`$throttle$pending$${n}`;return function(...v){if(this[u]||(this[u]=D?D():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),C&&(this[u]=C(this[u],...v)),this[l])return;const S=this[f]+R;S<=Date.now()?(this[f]=Date.now(),T.apply(this,[this[u]]),this[u]=D?D():void 0):(this[l]=!0,this[A]=setTimeout(()=>{this[l]=!1,this[f]=Date.now(),T.apply(this,[this[u]]),this[u]=D?D():void 0},S-Date.now()))}})}e.throttle=k}),define(me[16],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class m{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(o=>{o(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=m,e.errorHandler=new m;function L(p){e.errorHandler.setUnexpectedErrorHandler(p)}e.setUnexpectedErrorHandler=L;function I(p){D(p)||e.errorHandler.onUnexpectedError(p)}e.onUnexpectedError=I;function k(p){D(p)||e.errorHandler.onUnexpectedExternalError(p)}e.onUnexpectedExternalError=k;function R(p){if(p instanceof Error){let{name:t,message:o}=p;const r=p.stacktrace||p.stack;return{$isError:!0,name:t,message:o,stack:r}}return p}e.transformErrorForSerialization=R;const C="Canceled";function D(p){return p instanceof Error&&p.name===C&&p.message===C}e.isPromiseCanceledError=D;class T extends Error{constructor(){super(C);this.name=this.message}}e.CancellationError=T;function n(){const p=new Error(C);return p.name=p.message,p}e.canceled=n;function A(p){return p?new Error(`Illegal argument: ${p}`):new Error("Illegal argument")}e.illegalArgument=A;function u(p){return p?new Error(`Illegal state: ${p}`):new Error("Illegal state")}e.illegalState=u;function f(p){return p?new Error(`readonly property '${p} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=f;function l(p){const t=new Error(`${p} has been disposed`);return t.name="DISPOSED",t}e.disposed=l;function v(p){return p?p.message?p.message:p.stack?p.stack.split(`
`)[0]:String(p):"Error"}e.getErrorMessage=v;class S extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=S;class P extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=P;class E extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=E;function s(p){const t=p;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=s;function a(p,t=Object.create(null)){const o=new Error(p);return t.actions&&(o.actions=t.actions),o}e.createErrorWithActions=a}),define(me[17],ge([0,1,16]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(W,Q=0){return W[W.length-(1+Q)]}e.tail=L;function I(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}e.tail2=I;function k(W,Q,X=(he,_e)=>he===_e){if(W===Q)return!0;if(!W||!Q||W.length!==Q.length)return!1;for(let he=0,_e=W.length;he<_e;he++)if(!X(W[he],Q[he]))return!1;return!0}e.equals=k;function R(W,Q,X){let he=0,_e=W.length-1;for(;he<=_e;){const ye=(he+_e)/2|0,Re=X(W[ye],Q);if(Re<0)he=ye+1;else if(Re>0)_e=ye-1;else return ye}return-(he+1)}e.binarySearch=R;function C(W,Q){let X=0,he=W.length;if(he===0)return 0;for(;X<he;){const _e=Math.floor((X+he)/2);Q(W[_e])?he=_e:X=_e+1}return X}e.findFirstInSorted=C;function D(W,Q,X){if(W=W|0,W>=Q.length)throw new TypeError("invalid index");let he=Q[Math.floor(Q.length*Math.random())],_e=[],ye=[],Re=[];for(let $e of Q){const Be=X($e,he);Be<0?_e.push($e):Be>0?ye.push($e):Re.push($e)}return W<_e.length?D(W,_e,X):W<_e.length+Re.length?Re[0]:D(W-(_e.length+Re.length),ye,X)}e.quickSelect=D;function T(W,Q){const X=[];let he;for(const _e of W.slice(0).sort(Q))!he||Q(he[0],_e)!==0?(he=[_e],X.push(he)):he.push(_e);return X}e.groupBy=T;function n(W,Q,X){const he=[];function _e($e,Be,je){if(Be===0&&je.length===0)return;const V=he[he.length-1];V&&V.start+V.deleteCount===$e?(V.deleteCount+=Be,V.toInsert.push(...je)):he.push({start:$e,deleteCount:Be,toInsert:je})}let ye=0,Re=0;for(;;){if(ye===W.length){_e(ye,0,Q.slice(Re));break}if(Re===Q.length){_e(ye,W.length-ye,[]);break}const $e=W[ye],Be=Q[Re],je=X($e,Be);je===0?(ye+=1,Re+=1):je<0?(_e(ye,1,[]),ye+=1):je>0&&(_e(ye,0,[Be]),Re+=1)}return he}e.sortedDiff=n;function A(W,Q,X){const he=n(W,Q,X),_e=[],ye=[];for(const Re of he)_e.push(...W.slice(Re.start,Re.start+Re.deleteCount)),ye.push(...Re.toInsert);return{removed:_e,added:ye}}e.delta=A;function u(W,Q,X){if(X===0)return[];const he=W.slice(0,X).sort(Q);return l(W,Q,he,X,W.length),he}e.top=u;function f(W,Q,X,he,_e){return X===0?Promise.resolve([]):new Promise((ye,Re)=>{(async()=>{const $e=W.length,Be=W.slice(0,X).sort(Q);for(let je=X,V=Math.min(X+he,$e);je<$e;je=V,V=Math.min(V+he,$e)){if(je>X&&await new Promise(ee=>setTimeout(ee)),_e&&_e.isCancellationRequested)throw(0,m.canceled)();l(W,Q,Be,je,V)}return Be})().then(ye,Re)})}e.topAsync=f;function l(W,Q,X,he,_e){for(const ye=X.length;he<_e;he++){const Re=W[he];if(Q(Re,X[ye-1])<0){X.pop();const $e=C(X,Be=>Q(Re,Be)<0);X.splice($e,0,Re)}}}function v(W){return W.filter(Q=>!!Q)}e.coalesce=v;function S(W){let Q=0;for(let X=0;X<W.length;X++)W[X]&&(W[Q]=W[X],Q+=1);W.length=Q}e.coalesceInPlace=S;function P(W,Q,X){W.splice(X,0,W.splice(Q,1)[0])}e.move=P;function E(W){return!Array.isArray(W)||W.length===0}e.isFalsyOrEmpty=E;function s(W){return Array.isArray(W)&&W.length>0}e.isNonEmptyArray=s;function a(W,Q){if(!Q)return W.filter((he,_e)=>W.indexOf(he)===_e);const X=Object.create(null);return W.filter(he=>{const _e=Q(he);return X[_e]?!1:(X[_e]=!0,!0)})}e.distinct=a;function p(W){const Q=new Set;return W.filter(X=>Q.has(X)?!1:(Q.add(X),!0))}e.distinctES6=p;function t(W){const Q=Object.create(null);return X=>{const he=W(X);return Q[he]?!1:(Q[he]=!0,!0)}}e.uniqueFilter=t;function o(W,Q){for(let X=W.length-1;X>=0;X--){const he=W[X];if(Q(he))return X}return-1}e.lastIndex=o;function r(W,Q){return W.length>0?W[0]:Q}e.firstOrDefault=r;function i(W,Q,X=(he,_e)=>he===_e){let he=0;for(let _e=0,ye=Math.min(W.length,Q.length);_e<ye&&X(W[_e],Q[_e]);_e++)he++;return he}e.commonPrefixLength=i;function h(W){return[].concat(...W)}e.flatten=h;function c(W,Q){let X=typeof Q=="number"?W:0;typeof Q=="number"?X=W:(X=0,Q=W);const he=[];if(X<=Q)for(let _e=X;_e<Q;_e++)he.push(_e);else for(let _e=X;_e>Q;_e--)he.push(_e);return he}e.range=c;function d(W,Q,X){return W.reduce((he,_e)=>(he[Q(_e)]=X?X(_e):_e,he),Object.create(null))}e.index=d;function b(W,Q){return W.push(Q),()=>y(W,Q)}e.insert=b;function y(W,Q){const X=W.indexOf(Q);if(X>-1)return W.splice(X,1),Q}e.remove=y;function g(W,Q,X){const he=W.slice(0,Q),_e=W.slice(Q);return he.concat(X,_e)}e.arrayInsert=g;function _(W,Q){let X;if(typeof Q=="number"){let he=Q;X=()=>{const _e=Math.sin(he++)*179426549;return _e-Math.floor(_e)}}else X=Math.random;for(let he=W.length-1;he>0;he-=1){const _e=Math.floor(X()*(he+1)),ye=W[he];W[he]=W[_e],W[_e]=ye}}e.shuffle=_;function w(W,Q){const X=W.indexOf(Q);X>-1&&(W.splice(X,1),W.unshift(Q))}e.pushToStart=w;function F(W,Q){const X=W.indexOf(Q);X>-1&&(W.splice(X,1),W.push(Q))}e.pushToEnd=F;function N(W,Q){return Array.isArray(W)?W.map(Q):Q(W)}e.mapArrayOrNot=N;function G(W){return Array.isArray(W)?W:[W]}e.asArray=G;function K(W){return W[Math.floor(Math.random()*W.length)]}e.getRandomElement=K;function U(W,Q){for(const X of W){const he=Q(X);if(he!==void 0)return he}}e.mapFind=U;function z(W,Q,X){const he=B(W,Q),_e=W.length,ye=X.length;W.length=_e+ye;for(let Re=_e-1;Re>=he;Re--)W[Re+ye]=W[Re];for(let Re=0;Re<ye;Re++)W[Re+he]=X[Re]}e.insertInto=z;function O(W,Q,X,he){const _e=B(W,Q),ye=W.splice(_e,X);return z(W,_e,he),ye}e.splice=O;function B(W,Q){return Q<0?Math.max(Q+W.length,0):Math.min(Q,W.length)}function x(W,Q){let X=Number.MAX_SAFE_INTEGER,he=0;return W.forEach((_e,ye)=>{const Re=Q(_e);Re<X&&(X=Re,he=ye)}),he}e.minIndex=x;function M(W,Q){let X=Number.MIN_SAFE_INTEGER,he=0;return W.forEach((_e,ye)=>{const Re=Q(_e);Re>X&&(X=Re,he=ye)}),he}e.maxIndex=M;class H{constructor(Q){this.items=Q,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(Q){let X=this.firstIdx;for(;X<this.items.length&&Q(this.items[X]);)X++;const he=X===this.firstIdx?null:this.items.slice(this.firstIdx,X);return this.firstIdx=X,he}takeFromEndWhile(Q){let X=this.lastIdx;for(;X>=0&&Q(this.items[X]);)X--;const he=X===this.lastIdx?null:this.items.slice(X+1,this.lastIdx+1);return this.lastIdx=X,he}}e.ArrayQueue=H}),define(me[75],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function m(L){const I=this;let k=!1,R;return function(){return k||(k=!0,R=L.apply(I,arguments)),R}}e.once=m}),define(me[76],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class m{constructor(I){this._prefix=I,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=m,e.defaultGenerator=new m("id#")}),define(me[94],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var m;(function(L){function I(p){return p&&typeof p=="object"&&typeof p[Symbol.iterator]=="function"}L.is=I;const k=Object.freeze([]);function R(){return k}L.empty=R;function*C(p){yield p}L.single=C;function D(p){return p||k}L.from=D;function T(p){return!p||p[Symbol.iterator]().next().done===!0}L.isEmpty=T;function n(p){return p[Symbol.iterator]().next().value}L.first=n;function A(p,t){for(const o of p)if(t(o))return!0;return!1}L.some=A;function u(p,t){for(const o of p)if(t(o))return o}L.find=u;function*f(p,t){for(const o of p)t(o)&&(yield o)}L.filter=f;function*l(p,t){let o=0;for(const r of p)yield t(r,o++)}L.map=l;function*v(...p){for(const t of p)for(const o of t)yield o}L.concat=v;function*S(p){for(const t of p)for(const o of t)yield o}L.concatNested=S;function P(p,t,o){let r=o;for(const i of p)r=t(r,i);return r}L.reduce=P;function*E(p,t,o=p.length){for(t<0&&(t+=p.length),o<0?o+=p.length:o>p.length&&(o=p.length);t<o;t++)yield p[t]}L.slice=E;function s(p,t=Number.POSITIVE_INFINITY){const o=[];if(t===0)return[o,p];const r=p[Symbol.iterator]();for(let i=0;i<t;i++){const h=r.next();if(h.done)return[o,L.empty()];o.push(h.value)}return[o,{[Symbol.iterator](){return r}}]}L.consume=s;function a(p,t,o=(r,i)=>r===i){const r=p[Symbol.iterator](),i=t[Symbol.iterator]();for(;;){const h=r.next(),c=i.next();if(h.done!==c.done)return!1;if(h.done)return!0;if(!o(h.value,c.value))return!1}}L.equals=a})(m=e.Iterable||(e.Iterable={}))}),define(me[59],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var m;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(m=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var I;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(I=e.ParseErrorCode||(e.ParseErrorCode={}));var k;(function(t){t.DEFAULT={allowTrailingComma:!0}})(k=e.ParseOptions||(e.ParseOptions={}));function R(t,o=!1){let r=0,i=t.length,h="",c=0,d=16,b=0;function y(K){let U=0,z=0;for(;U<K;){const O=t.charCodeAt(r);if(O>=48&&O<=57)z=z*16+O-48;else if(O>=65&&O<=70)z=z*16+O-65+10;else if(O>=97&&O<=102)z=z*16+O-97+10;else break;r++,U++}return U<K&&(z=-1),z}function g(K){r=K,h="",c=0,d=16,b=0}function _(){const K=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&T(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&T(t.charCodeAt(r)))for(r++;r<t.length&&T(t.charCodeAt(r));)r++;else return b=3,t.substring(K,r);let U=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&T(t.charCodeAt(r))){for(r++;r<t.length&&T(t.charCodeAt(r));)r++;U=r}else b=3;return t.substring(K,U)}function w(){let K="",U=r;for(;;){if(r>=i){K+=t.substring(U,r),b=2;break}const z=t.charCodeAt(r);if(z===34){K+=t.substring(U,r),r++;break}if(z===92){if(K+=t.substring(U,r),r++,r>=i){b=2;break}switch(t.charCodeAt(r++)){case 34:K+='"';break;case 92:K+="\\";break;case 47:K+="/";break;case 98:K+="\b";break;case 102:K+="\f";break;case 110:K+=`
`;break;case 114:K+="\r";break;case 116:K+="	";break;case 117:const B=y(4);B>=0?K+=String.fromCharCode(B):b=4;break;default:b=5}U=r;continue}if(z>=0&&z<=31)if(D(z)){K+=t.substring(U,r),b=2;break}else b=6;r++}return K}function F(){if(h="",b=0,c=r,r>=i)return c=i,d=17;let K=t.charCodeAt(r);if(C(K)){do r++,h+=String.fromCharCode(K),K=t.charCodeAt(r);while(C(K));return d=15}if(D(K))return r++,h+=String.fromCharCode(K),K===13&&t.charCodeAt(r)===10&&(r++,h+=`
`),d=14;switch(K){case 123:return r++,d=1;case 125:return r++,d=2;case 91:return r++,d=3;case 93:return r++,d=4;case 58:return r++,d=6;case 44:return r++,d=5;case 34:return r++,h=w(),d=10;case 47:const U=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!D(t.charCodeAt(r));)r++;return h=t.substring(U,r),d=12}if(t.charCodeAt(r+1)===42){r+=2;const z=i-1;let O=!1;for(;r<z;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,O=!0;break}r++}return O||(r++,b=1),h=t.substring(U,r),d=13}return h+=String.fromCharCode(K),r++,d=16;case 45:if(h+=String.fromCharCode(K),r++,r===i||!T(t.charCodeAt(r)))return d=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return h+=_(),d=11;default:for(;r<i&&N(K);)r++,K=t.charCodeAt(r);if(c!==r){switch(h=t.substring(c,r),h){case"true":return d=8;case"false":return d=9;case"null":return d=7}return d=16}return h+=String.fromCharCode(K),r++,d=16}}function N(K){if(C(K)||D(K))return!1;switch(K){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function G(){let K;do K=F();while(K>=12&&K<=15);return K}return{setPosition:g,getPosition:()=>r,scan:o?G:F,getToken:()=>d,getTokenValue:()=>h,getTokenOffset:()=>c,getTokenLength:()=>r-c,getTokenError:()=>b}}e.createScanner=R;function C(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function D(t){return t===10||t===13||t===8232||t===8233}function T(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function A(t,o){const r=[],i=new Object;let h;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let d=!1;function b(y,g,_,w){c.value=y,c.offset=g,c.length=_,c.type=w,c.colonOffset=void 0,h=c}try{s(t,{onObjectBegin:(y,g)=>{if(o<=y)throw i;h=void 0,d=o>y,r.push("")},onObjectProperty:(y,g,_)=>{if(o<g||(b(y,g,_,"property"),r[r.length-1]=y,o<=g+_))throw i},onObjectEnd:(y,g)=>{if(o<=y)throw i;h=void 0,r.pop()},onArrayBegin:(y,g)=>{if(o<=y)throw i;h=void 0,r.push(0)},onArrayEnd:(y,g)=>{if(o<=y)throw i;h=void 0,r.pop()},onLiteralValue:(y,g,_)=>{if(o<g||(b(y,g,_,p(y)),o<=g+_))throw i},onSeparator:(y,g,_)=>{if(o<=g)throw i;if(y===":"&&h&&h.type==="property")h.colonOffset=g,d=!1,h=void 0;else if(y===","){const w=r[r.length-1];typeof w=="number"?r[r.length-1]=w+1:(d=!0,r[r.length-1]=""),h=void 0}}})}catch(y){if(y!==i)throw y}return{path:r,previousNode:h,isAtPropertyKey:d,matches:y=>{let g=0;for(let _=0;g<y.length&&_<r.length;_++)if(y[g]===r[_]||y[g]==="*")g++;else if(y[g]!=="**")return!1;return g===y.length}}}e.getLocation=A;function u(t,o=[],r=k.DEFAULT){let i=null,h=[];const c=[];function d(y){Array.isArray(h)?h.push(y):i!==null&&(h[i]=y)}return s(t,{onObjectBegin:()=>{const y={};d(y),c.push(h),h=y,i=null},onObjectProperty:y=>{i=y},onObjectEnd:()=>{h=c.pop()},onArrayBegin:()=>{const y=[];d(y),c.push(h),h=y,i=null},onArrayEnd:()=>{h=c.pop()},onLiteralValue:d,onError:(y,g,_)=>{o.push({error:y,offset:g,length:_})}},r),h[0]}e.parse=u;function f(t,o=[],r=k.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function h(y){i.type==="property"&&(i.length=y-i.offset,i=i.parent)}function c(y){return i.children.push(y),y}s(t,{onObjectBegin:y=>{i=c({type:"object",offset:y,length:-1,parent:i,children:[]})},onObjectProperty:(y,g,_)=>{i=c({type:"property",offset:g,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:y,offset:g,length:_,parent:i})},onObjectEnd:(y,g)=>{i.length=y+g-i.offset,i=i.parent,h(y+g)},onArrayBegin:(y,g)=>{i=c({type:"array",offset:y,length:-1,parent:i,children:[]})},onArrayEnd:(y,g)=>{i.length=y+g-i.offset,i=i.parent,h(y+g)},onLiteralValue:(y,g,_)=>{c({type:p(y),offset:g,length:_,parent:i,value:y}),h(g+_)},onSeparator:(y,g,_)=>{i.type==="property"&&(y===":"?i.colonOffset=g:y===","&&h(g))},onError:(y,g,_)=>{o.push({error:y,offset:g,length:_})}},r);const b=i.children[0];return b&&delete b.parent,b}e.parseTree=f;function l(t,o){if(!t)return;let r=t;for(let i of o)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let h=!1;for(const c of r.children)if(Array.isArray(c.children)&&c.children[0].value===i){r=c.children[1],h=!0;break}if(!h)return}else{const h=i;if(r.type!=="array"||h<0||!Array.isArray(r.children)||h>=r.children.length)return;r=r.children[h]}return r}e.findNodeAtLocation=l;function v(t){if(!t.parent||!t.parent.children)return[];const o=v(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;o.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&o.push(r)}return o}e.getNodePath=v;function S(t){switch(t.type){case"array":return t.children.map(S);case"object":const o=Object.create(null);for(let r of t.children){const i=r.children[1];i&&(o[r.children[0].value]=S(i))}return o;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=S;function P(t,o,r=!1){return o>=t.offset&&o<t.offset+t.length||r&&o===t.offset+t.length}e.contains=P;function E(t,o,r=!1){if(P(t,o,r)){const i=t.children;if(Array.isArray(i))for(let h=0;h<i.length&&i[h].offset<=o;h++){const c=E(i[h],o,r);if(c)return c}return t}}e.findNodeAtOffset=E;function s(t,o,r=k.DEFAULT){const i=R(t,!1);function h(X){return X?()=>X(i.getTokenOffset(),i.getTokenLength()):()=>!0}function c(X){return X?he=>X(he,i.getTokenOffset(),i.getTokenLength()):()=>!0}const d=h(o.onObjectBegin),b=c(o.onObjectProperty),y=h(o.onObjectEnd),g=h(o.onArrayBegin),_=h(o.onArrayEnd),w=c(o.onLiteralValue),F=c(o.onSeparator),N=h(o.onComment),G=c(o.onError),K=r&&r.disallowComments,U=r&&r.allowTrailingComma;function z(){for(;;){const X=i.scan();switch(i.getTokenError()){case 4:O(14);break;case 5:O(15);break;case 3:O(13);break;case 1:K||O(11);break;case 2:O(12);break;case 6:O(16);break}switch(X){case 12:case 13:K?O(10):N();break;case 16:O(1);break;case 15:case 14:break;default:return X}}}function O(X,he=[],_e=[]){if(G(X),he.length+_e.length>0){let ye=i.getToken();for(;ye!==17;){if(he.indexOf(ye)!==-1){z();break}else if(_e.indexOf(ye)!==-1)break;ye=z()}}}function B(X){const he=i.getTokenValue();return X?w(he):b(he),z(),!0}function x(){switch(i.getToken()){case 11:let X=0;try{X=JSON.parse(i.getTokenValue()),typeof X!="number"&&(O(2),X=0)}catch(he){O(2)}w(X);break;case 7:w(null);break;case 8:w(!0);break;case 9:w(!1);break;default:return!1}return z(),!0}function M(){return i.getToken()!==10?(O(3,[],[2,5]),!1):(B(!1),i.getToken()===6?(F(":"),z(),Q()||O(4,[],[2,5])):O(5,[],[2,5]),!0)}function H(){d(),z();let X=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(X||O(4,[],[]),F(","),z(),i.getToken()===2&&U)break}else X&&O(6,[],[]);M()||O(4,[],[2,5]),X=!0}return y(),i.getToken()!==2?O(7,[2],[]):z(),!0}function W(){g(),z();let X=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(X||O(4,[],[]),F(","),z(),i.getToken()===4&&U)break}else X&&O(6,[],[]);Q()||O(4,[],[4,5]),X=!0}return _(),i.getToken()!==4?O(8,[4],[]):z(),!0}function Q(){switch(i.getToken()){case 3:return W();case 1:return H();case 10:return B(!0);default:return x()}}return z(),i.getToken()===17?r.allowEmptyContent?!0:(O(4,[],[]),!1):Q()?(i.getToken()!==17&&O(9,[],[]),!0):(O(4,[],[]),!1)}e.visit=s;function a(t,o){let r=R(t),i=[],h,c=0,d;do switch(d=r.getPosition(),h=r.scan(),h){case 12:case 13:case 17:c!==d&&i.push(t.substring(c,d)),o!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,o)),c=r.getPosition();break}while(h!==17);return i.join("")}e.stripComments=a;function p(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=p}),define(me[137],ge([0,1,59]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(D,T,n){let A,u,f,l,v;if(T){for(l=T.offset,v=l+T.length,f=l;f>0&&!C(D,f-1);)f--;let c=v;for(;c<D.length&&!C(D,c);)c++;u=D.substring(f,c),A=k(u,n)}else u=D,A=0,f=0,l=0,v=D.length;const S=R(n,D);let P=!1,E=0,s;n.insertSpaces?s=I(" ",n.tabSize||4):s="	";const a=(0,m.createScanner)(u,!1);let p=!1;function t(){return S+I(s,A+E)}function o(){let c=a.scan();for(P=!1;c===15||c===14;)P=P||c===14,c=a.scan();return p=c===16||a.getTokenError()!==0,c}const r=[];function i(c,d,b){!p&&d<v&&b>l&&D.substring(d,b)!==c&&r.push({offset:d,length:b-d,content:c})}let h=o();if(h!==17){const c=a.getTokenOffset()+f,d=I(s,A);i(d,f,c)}for(;h!==17;){let c=a.getTokenOffset()+a.getTokenLength()+f,d=o(),b="";for(;!P&&(d===12||d===13);){const g=a.getTokenOffset()+f;i(" ",c,g),c=a.getTokenOffset()+a.getTokenLength()+f,b=d===12?t():"",d=o()}if(d===2)h!==1&&(E--,b=t());else if(d===4)h!==3&&(E--,b=t());else{switch(h){case 3:case 1:E++,b=t();break;case 5:case 12:b=t();break;case 13:P?b=t():b=" ";break;case 6:b=" ";break;case 10:if(d===6){b="";break}case 7:case 8:case 9:case 11:case 2:case 4:d===12||d===13?b=" ":d!==5&&d!==17&&(p=!0);break;case 16:p=!0;break}P&&(d===12||d===13)&&(b=t())}const y=a.getTokenOffset()+f;i(b,c,y),h=d}return r}e.format=L;function I(D,T){let n="";for(let A=0;A<T;A++)n+=D;return n}function k(D,T){let n=0,A=0;const u=T.tabSize||4;for(;n<D.length;){const f=D.charAt(n);if(f===" ")A++;else if(f==="	")A+=u;else break;n++}return Math.floor(A/u)}function R(D,T){for(let n=0;n<T.length;n++){const A=T.charAt(n);if(A==="\r")return n+1<T.length&&T.charAt(n+1)===`
`?`\r
`:"\r";if(A===`
`)return`
`}return D&&D.eol||`
`}e.getEOL=R;function C(D,T){return`\r
`.indexOf(D.charAt(T))!==-1}e.isEOL=C}),define(me[138],ge([0,1,59,137]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function I(T,n,A){return k(T,n,void 0,A)}e.removeProperty=I;function k(T,n,A,u,f){const l=n.slice(),v=[],S=(0,m.parseTree)(T,v);let P,E;for(;l.length>0&&(E=l.pop(),P=(0,m.findNodeAtLocation)(S,l),P===void 0&&A!==void 0);)typeof E=="string"?A={[E]:A}:A=[A];if(P)if(P.type==="object"&&typeof E=="string"&&Array.isArray(P.children)){const s=(0,m.findNodeAtLocation)(P,[E]);if(s!==void 0)if(A===void 0){if(!s.parent)throw new Error("Malformed AST");const a=P.children.indexOf(s.parent);let p,t=s.parent.offset+s.parent.length;if(a>0){const o=P.children[a-1];p=o.offset+o.length}else p=P.offset+1,P.children.length>1&&(t=P.children[1].offset);return R(T,{offset:p,length:t-p,content:""},u)}else return R(T,{offset:s.offset,length:s.length,content:JSON.stringify(A)},u);else{if(A===void 0)return[];const a=`${JSON.stringify(E)}: ${JSON.stringify(A)}`,p=f?f(P.children.map(o=>o.children[0].value)):P.children.length;let t;if(p>0){const o=P.children[p-1];t={offset:o.offset+o.length,length:0,content:","+a}}else P.children.length===0?t={offset:P.offset+1,length:0,content:a}:t={offset:P.offset+1,length:0,content:a+","};return R(T,t,u)}}else if(P.type==="array"&&typeof E=="number"&&Array.isArray(P.children))if(A!==void 0){const s=`${JSON.stringify(A)}`;let a;if(P.children.length===0||E===0)a={offset:P.offset+1,length:0,content:P.children.length===0?s:s+","};else{const p=E===-1||E>P.children.length?P.children.length:E,t=P.children[p-1];a={offset:t.offset+t.length,length:0,content:","+s}}return R(T,a,u)}else{const s=E,a=P.children[s];let p;if(P.children.length===1)p={offset:P.offset+1,length:P.length-2,content:""};else if(P.children.length-1===s){const t=P.children[s-1],o=t.offset+t.length,r=P.offset+P.length;p={offset:o,length:r-2-o,content:""}}else p={offset:a.offset,length:P.children[s+1].offset-a.offset,content:""};return R(T,p,u)}else throw new Error(`Can not add ${typeof E!="number"?"index":"property"} to parent of type ${P.type}`);else{if(A===void 0)throw new Error("Can not delete in empty document");return R(T,{offset:S?S.offset:0,length:S?S.length:0,content:JSON.stringify(A)},u)}}e.setProperty=k;function R(T,n,A){let u=C(T,n),f=n.offset,l=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;f>0&&!(0,L.isEOL)(u,f-1);)f--;for(;l<u.length&&!(0,L.isEOL)(u,l);)l++}const v=(0,L.format)(u,{offset:f,length:l-f},A);for(let P=v.length-1;P>=0;P--){const E=v[P];u=C(u,E),f=Math.min(f,E.offset),l=Math.max(l,E.offset+E.length),l+=E.content.length-E.length}const S=T.length-(u.length-l)-f;return[{offset:f,length:S,content:u.substring(f,l)}]}e.withFormatting=R;function C(T,n){return T.substring(0,n.offset)+n.content+T.substring(n.offset+n.length)}e.applyEdit=C;function D(T,n){let A=n.slice(0).sort((f,l)=>{const v=f.offset-l.offset;return v===0?f.length-l.length:v}),u=T.length;for(let f=A.length-1;f>=0;f--){let l=A[f];if(l.offset+l.length<=u)T=C(T,l);else throw new Error("Overlapping edit");u=l.offset}return T}e.applyEdits=D}),define(me[139],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class m{constructor(I){this.executor=I,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(I){this._error=I}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(I){return new m(()=>I(this.getValue()))}}e.Lazy=m}),define(me[6],ge([0,1,75,94]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const I=!1;let k=null;function R(r){k=r}if(e.setDisposableTracker=R,I){const r="__is_disposable_tracked__";R(new class{trackDisposable(i){const h=new Error("Potentially leaked disposable").stack;setTimeout(()=>{i[r]||console.log(h)},3e3)}setParent(i,h){if(i&&i!==E.None)try{i[r]=!0}catch{}}markAsDisposed(i){if(i&&i!==E.None)try{i[r]=!0}catch{}}markAsSingleton(i){}})}function C(r){return k?.trackDisposable(r),r}function D(r){k?.markAsDisposed(r)}function T(r,i){k?.setParent(r,i)}function n(r,i){if(!!k)for(const h of r)k.setParent(h,i)}function A(r){return k?.markAsSingleton(r),r}e.markAsSingleton=A;class u extends Error{constructor(i){super(`Encountered errors while disposing of store. Errors: [${i.join(", ")}]`);this.errors=i}}e.MultiDisposeError=u;function f(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=f;function l(r){if(L.Iterable.is(r)){let i=[];for(const h of r)if(h)try{h.dispose()}catch(c){i.push(c)}if(i.length===1)throw i[0];if(i.length>1)throw new u(i);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=l;function v(...r){const i=S(()=>l(r));return n(r,i),i}e.combinedDisposable=v;function S(r){const i=C({dispose:(0,m.once)(()=>{D(i),r()})});return i}e.toDisposable=S;class P{constructor(){this._toDispose=new Set,this._isDisposed=!1,C(this)}dispose(){this._isDisposed||(D(this),this._isDisposed=!0,this.clear())}clear(){try{l(this._toDispose.values())}finally{this._toDispose.clear()}}add(i){if(!i)return i;if(i===this)throw new Error("Cannot register a disposable on itself!");return T(i,this),this._isDisposed?P.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(i),i}}e.DisposableStore=P,P.DISABLE_DISPOSED_WARNING=!1;class E{constructor(){this._store=new P,C(this),T(this._store,this)}dispose(){D(this),this._store.dispose()}_register(i){if(i===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(i)}}e.Disposable=E,E.None=Object.freeze({dispose(){}});class s{constructor(){this._isDisposed=!1,C(this)}get value(){return this._isDisposed?void 0:this._value}set value(i){this._isDisposed||i===this._value||(this._value?.dispose(),i&&T(i,this),this._value=i)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,D(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const i=this._value;return this._value=void 0,i&&T(i,null),i}}e.MutableDisposable=s;class a{constructor(i){this._disposable=i,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=a;class p{constructor(){this.references=new Map}acquire(i,...h){let c=this.references.get(i);c||(c={counter:0,object:this.createReferencedObject(i,...h)},this.references.set(i,c));const{object:d}=c,b=(0,m.once)(()=>{--c.counter==0&&(this.destroyReferencedObject(i,c.object),this.references.delete(i))});return c.counter++,{object:d,dispose:b}}}e.ReferenceCollection=p;class t{constructor(i){this.referenceCollection=i}async acquire(i,...h){const c=this.referenceCollection.acquire(i,...h);try{return{object:await c.object,dispose:()=>c.dispose()}}catch(d){throw c.dispose(),d}}}e.AsyncReferenceCollection=t;class o{constructor(i){this.object=i}dispose(){}}e.ImmortalReference=o}),define(me[95],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class m{constructor(k){this.element=k,this.next=m.Undefined,this.prev=m.Undefined}}m.Undefined=new m(void 0);class L{constructor(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===m.Undefined}clear(){let k=this._first;for(;k!==m.Undefined;){const R=k.next;k.prev=m.Undefined,k.next=m.Undefined,k=R}this._first=m.Undefined,this._last=m.Undefined,this._size=0}unshift(k){return this._insert(k,!1)}push(k){return this._insert(k,!0)}_insert(k,R){const C=new m(k);if(this._first===m.Undefined)this._first=C,this._last=C;else if(R){const T=this._last;this._last=C,C.prev=T,T.next=C}else{const T=this._first;this._first=C,C.next=T,T.prev=C}this._size+=1;let D=!1;return()=>{D||(D=!0,this._remove(C))}}shift(){if(this._first!==m.Undefined){const k=this._first.element;return this._remove(this._first),k}}pop(){if(this._last!==m.Undefined){const k=this._last.element;return this._remove(this._last),k}}_remove(k){if(k.prev!==m.Undefined&&k.next!==m.Undefined){const R=k.prev;R.next=k.next,k.next.prev=R}else k.prev===m.Undefined&&k.next===m.Undefined?(this._first=m.Undefined,this._last=m.Undefined):k.next===m.Undefined?(this._last=this._last.prev,this._last.next=m.Undefined):k.prev===m.Undefined&&(this._first=this._first.next,this._first.prev=m.Undefined);this._size-=1}*[Symbol.iterator](){let k=this._first;for(;k!==m.Undefined;)yield k.element,k=k.next}}e.LinkedList=L}),function(J,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(J=typeof globalThis!="undefined"?globalThis:J||self,J.marked=e())}(this,function(){"use strict";function J(Le,De){for(var ke=0;ke<De.length;ke++){var ne=De[ke];ne.enumerable=ne.enumerable||!1,ne.configurable=!0,"value"in ne&&(ne.writable=!0),Object.defineProperty(Le,ne.key,ne)}}function e(Le,De,ke){return De&&J(Le.prototype,De),ke&&J(Le,ke),Le}function m(Le,De){if(!!Le){if(typeof Le=="string")return L(Le,De);var ke=Object.prototype.toString.call(Le).slice(8,-1);if(ke==="Object"&&Le.constructor&&(ke=Le.constructor.name),ke==="Map"||ke==="Set")return Array.from(Le);if(ke==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ke))return L(Le,De)}}function L(Le,De){(De==null||De>Le.length)&&(De=Le.length);for(var ke=0,ne=new Array(De);ke<De;ke++)ne[ke]=Le[ke];return ne}function I(Le,De){var ke=typeof Symbol!="undefined"&&Le[Symbol.iterator]||Le["@@iterator"];if(ke)return(ke=ke.call(Le)).next.bind(ke);if(Array.isArray(Le)||(ke=m(Le))||De&&Le&&typeof Le.length=="number"){ke&&(Le=ke);var ne=0;return function(){return ne>=Le.length?{done:!0}:{done:!1,value:Le[ne++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var k={exports:{}};function R(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function C(Le){k.exports.defaults=Le}k.exports={defaults:R(),getDefaults:R,changeDefaults:C};var D=/[&<>"']/,T=/[&<>"']/g,n=/[<>"']|&(?!#?\w+;)/,A=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},f=function(De){return u[De]};function l(Le,De){if(De){if(D.test(Le))return Le.replace(T,f)}else if(n.test(Le))return Le.replace(A,f);return Le}var v=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function S(Le){return Le.replace(v,function(De,ke){return ke=ke.toLowerCase(),ke==="colon"?":":ke.charAt(0)==="#"?ke.charAt(1)==="x"?String.fromCharCode(parseInt(ke.substring(2),16)):String.fromCharCode(+ke.substring(1)):""})}var P=/(^|[^\[])\^/g;function E(Le,De){Le=Le.source||Le,De=De||"";var ke={replace:function(de,be){return be=be.source||be,be=be.replace(P,"$1"),Le=Le.replace(de,be),ke},getRegex:function(){return new RegExp(Le,De)}};return ke}var s=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function p(Le,De,ke){if(Le){var ne;try{ne=decodeURIComponent(S(ke)).replace(s,"").toLowerCase()}catch(de){return null}if(ne.indexOf("javascript:")===0||ne.indexOf("vbscript:")===0||ne.indexOf("data:")===0)return null}De&&!a.test(ke)&&(ke=h(De,ke));try{ke=encodeURI(ke).replace(/%25/g,"%")}catch(de){return null}return ke}var t={},o=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function h(Le,De){t[" "+Le]||(o.test(Le)?t[" "+Le]=Le+"/":t[" "+Le]=y(Le,"/",!0)),Le=t[" "+Le];var ke=Le.indexOf(":")===-1;return De.substring(0,2)==="//"?ke?De:Le.replace(r,"$1")+De:De.charAt(0)==="/"?ke?De:Le.replace(i,"$1")+De:Le+De}var c={exec:function(){}};function d(Le){for(var De=1,ke,ne;De<arguments.length;De++){ke=arguments[De];for(ne in ke)Object.prototype.hasOwnProperty.call(ke,ne)&&(Le[ne]=ke[ne])}return Le}function b(Le,De){var ke=Le.replace(/\|/g,function(be,we,Fe){for(var Ge=!1,He=we;--He>=0&&Fe[He]==="\\";)Ge=!Ge;return Ge?"|":" |"}),ne=ke.split(/ \|/),de=0;if(ne[0].trim()||ne.shift(),ne[ne.length-1].trim()||ne.pop(),ne.length>De)ne.splice(De);else for(;ne.length<De;)ne.push("");for(;de<ne.length;de++)ne[de]=ne[de].trim().replace(/\\\|/g,"|");return ne}function y(Le,De,ke){var ne=Le.length;if(ne===0)return"";for(var de=0;de<ne;){var be=Le.charAt(ne-de-1);if(be===De&&!ke)de++;else if(be!==De&&ke)de++;else break}return Le.substr(0,ne-de)}function g(Le,De){if(Le.indexOf(De[1])===-1)return-1;for(var ke=Le.length,ne=0,de=0;de<ke;de++)if(Le[de]==="\\")de++;else if(Le[de]===De[0])ne++;else if(Le[de]===De[1]&&(ne--,ne<0))return de;return-1}function _(Le){Le&&Le.sanitize&&!Le.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function w(Le,De){if(De<1)return"";for(var ke="";De>1;)De&1&&(ke+=Le),De>>=1,Le+=Le;return ke+Le}var F={escape:l,unescape:S,edit:E,cleanUrl:p,resolveUrl:h,noopTest:c,merge:d,splitCells:b,rtrim:y,findClosingBracket:g,checkSanitizeDeprecation:_,repeatString:w},N=k.exports.defaults,G=F.rtrim,K=F.splitCells,U=F.escape,z=F.findClosingBracket;function O(Le,De,ke,ne){var de=De.href,be=De.title?U(De.title):null,we=Le[1].replace(/\\([\[\]])/g,"$1");if(Le[0].charAt(0)!=="!"){ne.state.inLink=!0;var Fe={type:"link",raw:ke,href:de,title:be,text:we,tokens:ne.inlineTokens(we,[])};return ne.state.inLink=!1,Fe}else return{type:"image",raw:ke,href:de,title:be,text:U(we)}}function B(Le,De){var ke=Le.match(/^(\s+)(?:```)/);if(ke===null)return De;var ne=ke[1];return De.split(`
`).map(function(de){var be=de.match(/^\s+/);if(be===null)return de;var we=be[0];return we.length>=ne.length?de.slice(ne.length):de}).join(`
`)}var x=function(){function Le(ke){this.options=ke||N}var De=Le.prototype;return De.space=function(ne){var de=this.rules.block.newline.exec(ne);if(de)return de[0].length>1?{type:"space",raw:de[0]}:{raw:`
`}},De.code=function(ne){var de=this.rules.block.code.exec(ne);if(de){var be=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?be:G(be,`
`)}}},De.fences=function(ne){var de=this.rules.block.fences.exec(ne);if(de){var be=de[0],we=B(be,de[3]||"");return{type:"code",raw:be,lang:de[2]?de[2].trim():de[2],text:we}}},De.heading=function(ne){var de=this.rules.block.heading.exec(ne);if(de){var be=de[2].trim();if(/#$/.test(be)){var we=G(be,"#");(this.options.pedantic||!we||/ $/.test(we))&&(be=we.trim())}var Fe={type:"heading",raw:de[0],depth:de[1].length,text:be,tokens:[]};return this.lexer.inline(Fe.text,Fe.tokens),Fe}},De.hr=function(ne){var de=this.rules.block.hr.exec(ne);if(de)return{type:"hr",raw:de[0]}},De.blockquote=function(ne){var de=this.rules.block.blockquote.exec(ne);if(de){var be=de[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:de[0],tokens:this.lexer.blockTokens(be,[]),text:be}}},De.list=function(ne){var de=this.rules.block.list.exec(ne);if(de){var be,we,Fe,Ge,He,Ye,it,le,Ee,ce,q=de[1].trim(),Ae=q.length>1,Pe={type:"list",raw:"",ordered:Ae,start:Ae?+q.slice(0,-1):"",loose:!1,items:[]};q=Ae?"\\d{1,9}\\"+q.slice(-1):"\\"+q,this.options.pedantic&&(q=Ae?q:"[*+-]");for(var Ze=new RegExp("^( {0,3}"+q+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");ne&&!(this.rules.block.hr.test(ne)||!(de=Ze.exec(ne)));){Ee=de[2].split(`
`),this.options.pedantic?(Ge=2,ce=Ee[0].trimLeft()):(Ge=de[2].search(/[^ ]/),Ge=de[1].length+(Ge>4?1:Ge),ce=Ee[0].slice(Ge-de[1].length)),Ye=!1,be=de[0],!Ee[0]&&/^ *$/.test(Ee[1])&&(be=de[1]+Ee.slice(0,2).join(`
`)+`
`,Pe.loose=!0,Ee=[]);var Xe=new RegExp("^ {0,"+Math.min(3,Ge-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(He=1;He<Ee.length;He++){if(le=Ee[He],this.options.pedantic&&(le=le.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Xe.test(le)){be=de[1]+Ee.slice(0,He).join(`
`)+`
`;break}if(!Ye){le.trim()||(Ye=!0),le.search(/[^ ]/)>=Ge?ce+=`
`+le.slice(Ge):ce+=`
`+le;continue}if(le.search(/[^ ]/)>=Ge||!le.trim()){ce+=`
`+le.slice(Ge);continue}else{be=de[1]+Ee.slice(0,He).join(`
`)+`
`;break}}Pe.loose||(it?Pe.loose=!0:/\n *\n *$/.test(be)&&(it=!0)),this.options.gfm&&(we=/^\[[ xX]\] /.exec(ce),we&&(Fe=we[0]!=="[ ] ",ce=ce.replace(/^\[[ xX]\] +/,""))),Pe.items.push({type:"list_item",raw:be,task:!!we,checked:Fe,loose:!1,text:ce}),Pe.raw+=be,ne=ne.slice(be.length)}Pe.items[Pe.items.length-1].raw=be.trimRight(),Pe.items[Pe.items.length-1].text=ce.trimRight(),Pe.raw=Pe.raw.trimRight();var ot=Pe.items.length;for(He=0;He<ot;He++)this.lexer.state.top=!1,Pe.items[He].tokens=this.lexer.blockTokens(Pe.items[He].text,[]),Pe.items[He].tokens.some(function(vt){return vt.type==="space"})&&(Pe.loose=!0,Pe.items[He].loose=!0);return Pe}},De.html=function(ne){var de=this.rules.block.html.exec(ne);if(de){var be={type:"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:de[0]};return this.options.sanitize&&(be.type="paragraph",be.text=this.options.sanitizer?this.options.sanitizer(de[0]):U(de[0]),be.tokens=[],this.lexer.inline(be.text,be.tokens)),be}},De.def=function(ne){var de=this.rules.block.def.exec(ne);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var be=de[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:be,raw:de[0],href:de[2],title:de[3]}}},De.table=function(ne){var de=this.rules.block.table.exec(ne);if(de){var be={type:"table",header:K(de[1]).map(function(it){return{text:it}}),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:de[3]?de[3].replace(/\n$/,"").split(`
`):[]};if(be.header.length===be.align.length){be.raw=de[0];var we=be.align.length,Fe,Ge,He,Ye;for(Fe=0;Fe<we;Fe++)/^ *-+: *$/.test(be.align[Fe])?be.align[Fe]="right":/^ *:-+: *$/.test(be.align[Fe])?be.align[Fe]="center":/^ *:-+ *$/.test(be.align[Fe])?be.align[Fe]="left":be.align[Fe]=null;for(we=be.rows.length,Fe=0;Fe<we;Fe++)be.rows[Fe]=K(be.rows[Fe],be.header.length).map(function(it){return{text:it}});for(we=be.header.length,Ge=0;Ge<we;Ge++)be.header[Ge].tokens=[],this.lexer.inlineTokens(be.header[Ge].text,be.header[Ge].tokens);for(we=be.rows.length,Ge=0;Ge<we;Ge++)for(Ye=be.rows[Ge],He=0;He<Ye.length;He++)Ye[He].tokens=[],this.lexer.inlineTokens(Ye[He].text,Ye[He].tokens);return be}}},De.lheading=function(ne){var de=this.rules.block.lheading.exec(ne);if(de){var be={type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},De.paragraph=function(ne){var de=this.rules.block.paragraph.exec(ne);if(de){var be={type:"paragraph",raw:de[0],text:de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},De.text=function(ne){var de=this.rules.block.text.exec(ne);if(de){var be={type:"text",raw:de[0],text:de[0],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},De.escape=function(ne){var de=this.rules.inline.escape.exec(ne);if(de)return{type:"escape",raw:de[0],text:U(de[1])}},De.tag=function(ne){var de=this.rules.inline.tag.exec(ne);if(de)return!this.lexer.state.inLink&&/^<a /i.test(de[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(de[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(de[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(de[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:de[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):U(de[0]):de[0]}},De.link=function(ne){var de=this.rules.inline.link.exec(ne);if(de){var be=de[2].trim();if(!this.options.pedantic&&/^</.test(be)){if(!/>$/.test(be))return;var we=G(be.slice(0,-1),"\\");if((be.length-we.length)%2==0)return}else{var Fe=z(de[2],"()");if(Fe>-1){var Ge=de[0].indexOf("!")===0?5:4,He=Ge+de[1].length+Fe;de[2]=de[2].substring(0,Fe),de[0]=de[0].substring(0,He).trim(),de[3]=""}}var Ye=de[2],it="";if(this.options.pedantic){var le=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ye);le&&(Ye=le[1],it=le[3])}else it=de[3]?de[3].slice(1,-1):"";return Ye=Ye.trim(),/^</.test(Ye)&&(this.options.pedantic&&!/>$/.test(be)?Ye=Ye.slice(1):Ye=Ye.slice(1,-1)),O(de,{href:Ye&&Ye.replace(this.rules.inline._escapes,"$1"),title:it&&it.replace(this.rules.inline._escapes,"$1")},de[0],this.lexer)}},De.reflink=function(ne,de){var be;if((be=this.rules.inline.reflink.exec(ne))||(be=this.rules.inline.nolink.exec(ne))){var we=(be[2]||be[1]).replace(/\s+/g," ");if(we=de[we.toLowerCase()],!we||!we.href){var Fe=be[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return O(be,we,be[0],this.lexer)}},De.emStrong=function(ne,de,be){be===void 0&&(be="");var we=this.rules.inline.emStrong.lDelim.exec(ne);if(!!we&&!(we[3]&&be.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=we[1]||we[2]||"";if(!Fe||Fe&&(be===""||this.rules.inline.punctuation.exec(be))){var Ge=we[0].length-1,He,Ye,it=Ge,le=0,Ee=we[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ee.lastIndex=0,de=de.slice(-1*ne.length+Ge);(we=Ee.exec(de))!=null;)if(He=we[1]||we[2]||we[3]||we[4]||we[5]||we[6],!!He){if(Ye=He.length,we[3]||we[4]){it+=Ye;continue}else if((we[5]||we[6])&&Ge%3&&!((Ge+Ye)%3)){le+=Ye;continue}if(it-=Ye,!(it>0)){if(Ye=Math.min(Ye,Ye+it+le),Math.min(Ge,Ye)%2){var ce=ne.slice(1,Ge+we.index+Ye);return{type:"em",raw:ne.slice(0,Ge+we.index+Ye+1),text:ce,tokens:this.lexer.inlineTokens(ce,[])}}var q=ne.slice(2,Ge+we.index+Ye-1);return{type:"strong",raw:ne.slice(0,Ge+we.index+Ye+1),text:q,tokens:this.lexer.inlineTokens(q,[])}}}}}},De.codespan=function(ne){var de=this.rules.inline.code.exec(ne);if(de){var be=de[2].replace(/\n/g," "),we=/[^ ]/.test(be),Fe=/^ /.test(be)&&/ $/.test(be);return we&&Fe&&(be=be.substring(1,be.length-1)),be=U(be,!0),{type:"codespan",raw:de[0],text:be}}},De.br=function(ne){var de=this.rules.inline.br.exec(ne);if(de)return{type:"br",raw:de[0]}},De.del=function(ne){var de=this.rules.inline.del.exec(ne);if(de)return{type:"del",raw:de[0],text:de[2],tokens:this.lexer.inlineTokens(de[2],[])}},De.autolink=function(ne,de){var be=this.rules.inline.autolink.exec(ne);if(be){var we,Fe;return be[2]==="@"?(we=U(this.options.mangle?de(be[1]):be[1]),Fe="mailto:"+we):(we=U(be[1]),Fe=we),{type:"link",raw:be[0],text:we,href:Fe,tokens:[{type:"text",raw:we,text:we}]}}},De.url=function(ne,de){var be;if(be=this.rules.inline.url.exec(ne)){var we,Fe;if(be[2]==="@")we=U(this.options.mangle?de(be[0]):be[0]),Fe="mailto:"+we;else{var Ge;do Ge=be[0],be[0]=this.rules.inline._backpedal.exec(be[0])[0];while(Ge!==be[0]);we=U(be[0]),be[1]==="www."?Fe="http://"+we:Fe=we}return{type:"link",raw:be[0],text:we,href:Fe,tokens:[{type:"text",raw:we,text:we}]}}},De.inlineText=function(ne,de){var be=this.rules.inline.text.exec(ne);if(be){var we;return this.lexer.state.inRawBlock?we=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(be[0]):U(be[0]):be[0]:we=U(this.options.smartypants?de(be[0]):be[0]),{type:"text",raw:be[0],text:we}}},Le}(),M=F.noopTest,H=F.edit,W=F.merge,Q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:M,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};Q._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,Q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,Q.def=H(Q.def).replace("label",Q._label).replace("title",Q._title).getRegex(),Q.bullet=/(?:[*+-]|\d{1,9}[.)])/,Q.listItemStart=H(/^( *)(bull) */).replace("bull",Q.bullet).getRegex(),Q.list=H(Q.list).replace(/bull/g,Q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+Q.def.source+")").getRegex(),Q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",Q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,Q.html=H(Q.html,"i").replace("comment",Q._comment).replace("tag",Q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),Q.paragraph=H(Q._paragraph).replace("hr",Q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Q._tag).getRegex(),Q.blockquote=H(Q.blockquote).replace("paragraph",Q.paragraph).getRegex(),Q.normal=W({},Q),Q.gfm=W({},Q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),Q.gfm.table=H(Q.gfm.table).replace("hr",Q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Q._tag).getRegex(),Q.pedantic=W({},Q.normal,{html:H(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",Q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:M,paragraph:H(Q.normal._paragraph).replace("hr",Q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",Q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var X={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:M,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:M,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};X._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",X.punctuation=H(X.punctuation).replace(/punctuation/g,X._punctuation).getRegex(),X.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,X.escapedEmSt=/\\\*|\\_/g,X._comment=H(Q._comment).replace("(?:-->|$)","-->").getRegex(),X.emStrong.lDelim=H(X.emStrong.lDelim).replace(/punct/g,X._punctuation).getRegex(),X.emStrong.rDelimAst=H(X.emStrong.rDelimAst,"g").replace(/punct/g,X._punctuation).getRegex(),X.emStrong.rDelimUnd=H(X.emStrong.rDelimUnd,"g").replace(/punct/g,X._punctuation).getRegex(),X._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,X._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,X._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,X.autolink=H(X.autolink).replace("scheme",X._scheme).replace("email",X._email).getRegex(),X._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,X.tag=H(X.tag).replace("comment",X._comment).replace("attribute",X._attribute).getRegex(),X._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,X._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,X._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,X.link=H(X.link).replace("label",X._label).replace("href",X._href).replace("title",X._title).getRegex(),X.reflink=H(X.reflink).replace("label",X._label).getRegex(),X.reflinkSearch=H(X.reflinkSearch,"g").replace("reflink",X.reflink).replace("nolink",X.nolink).getRegex(),X.normal=W({},X),X.pedantic=W({},X.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:H(/^!?\[(label)\]\((.*?)\)/).replace("label",X._label).getRegex(),reflink:H(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",X._label).getRegex()}),X.gfm=W({},X.normal,{escape:H(X.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),X.gfm.url=H(X.gfm.url,"i").replace("email",X.gfm._extended_email).getRegex(),X.breaks=W({},X.gfm,{br:H(X.br).replace("{2,}","*").getRegex(),text:H(X.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var he={block:Q,inline:X},_e=x,ye=k.exports.defaults,Re=he.block,$e=he.inline,Be=F.repeatString;function je(Le){return Le.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function V(Le){var De="",ke,ne,de=Le.length;for(ke=0;ke<de;ke++)ne=Le.charCodeAt(ke),Math.random()>.5&&(ne="x"+ne.toString(16)),De+="&#"+ne+";";return De}var ee=function(){function Le(ke){this.tokens=[],this.tokens.links=Object.create(null),this.options=ke||ye,this.options.tokenizer=this.options.tokenizer||new _e,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ne={block:Re.normal,inline:$e.normal};this.options.pedantic?(ne.block=Re.pedantic,ne.inline=$e.pedantic):this.options.gfm&&(ne.block=Re.gfm,this.options.breaks?ne.inline=$e.breaks:ne.inline=$e.gfm),this.tokenizer.rules=ne}Le.lex=function(ne,de){var be=new Le(de);return be.lex(ne)},Le.lexInline=function(ne,de){var be=new Le(de);return be.inlineTokens(ne)};var De=Le.prototype;return De.lex=function(ne){ne=ne.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ne,this.tokens);for(var de;de=this.inlineQueue.shift();)this.inlineTokens(de.src,de.tokens);return this.tokens},De.blockTokens=function(ne,de){var be=this;de===void 0&&(de=[]),this.options.pedantic&&(ne=ne.replace(/^ +$/gm,""));for(var we,Fe,Ge,He;ne;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(it){return(we=it.call({lexer:be},ne,de))?(ne=ne.substring(we.raw.length),de.push(we),!0):!1}))){if(we=this.tokenizer.space(ne)){ne=ne.substring(we.raw.length),we.type&&de.push(we);continue}if(we=this.tokenizer.code(ne)){ne=ne.substring(we.raw.length),Fe=de[de.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):de.push(we);continue}if(we=this.tokenizer.fences(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.heading(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.hr(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.blockquote(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.list(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.html(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.def(ne)){ne=ne.substring(we.raw.length),Fe=de[de.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[we.tag]||(this.tokens.links[we.tag]={href:we.href,title:we.title});continue}if(we=this.tokenizer.table(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.lheading(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(Ge=ne,this.options.extensions&&this.options.extensions.startBlock&&function(){var it=Infinity,le=ne.slice(1),Ee=void 0;be.options.extensions.startBlock.forEach(function(ce){Ee=ce.call({lexer:this},le),typeof Ee=="number"&&Ee>=0&&(it=Math.min(it,Ee))}),it<Infinity&&it>=0&&(Ge=ne.substring(0,it+1))}(),this.state.top&&(we=this.tokenizer.paragraph(Ge))){Fe=de[de.length-1],He&&Fe.type==="paragraph"?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):de.push(we),He=Ge.length!==ne.length,ne=ne.substring(we.raw.length);continue}if(we=this.tokenizer.text(ne)){ne=ne.substring(we.raw.length),Fe=de[de.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):de.push(we);continue}if(ne){var Ye="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(Ye);break}else throw new Error(Ye)}}return this.state.top=!0,de},De.inline=function(ne,de){this.inlineQueue.push({src:ne,tokens:de})},De.inlineTokens=function(ne,de){var be=this;de===void 0&&(de=[]);var we,Fe,Ge,He=ne,Ye,it,le;if(this.tokens.links){var Ee=Object.keys(this.tokens.links);if(Ee.length>0)for(;(Ye=this.tokenizer.rules.inline.reflinkSearch.exec(He))!=null;)Ee.includes(Ye[0].slice(Ye[0].lastIndexOf("[")+1,-1))&&(He=He.slice(0,Ye.index)+"["+Be("a",Ye[0].length-2)+"]"+He.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ye=this.tokenizer.rules.inline.blockSkip.exec(He))!=null;)He=He.slice(0,Ye.index)+"["+Be("a",Ye[0].length-2)+"]"+He.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ye=this.tokenizer.rules.inline.escapedEmSt.exec(He))!=null;)He=He.slice(0,Ye.index)+"++"+He.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ne;)if(it||(le=""),it=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(q){return(we=q.call({lexer:be},ne,de))?(ne=ne.substring(we.raw.length),de.push(we),!0):!1}))){if(we=this.tokenizer.escape(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.tag(ne)){ne=ne.substring(we.raw.length),Fe=de[de.length-1],Fe&&we.type==="text"&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):de.push(we);continue}if(we=this.tokenizer.link(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.reflink(ne,this.tokens.links)){ne=ne.substring(we.raw.length),Fe=de[de.length-1],Fe&&we.type==="text"&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):de.push(we);continue}if(we=this.tokenizer.emStrong(ne,He,le)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.codespan(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.br(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.del(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.autolink(ne,V)){ne=ne.substring(we.raw.length),de.push(we);continue}if(!this.state.inLink&&(we=this.tokenizer.url(ne,V))){ne=ne.substring(we.raw.length),de.push(we);continue}if(Ge=ne,this.options.extensions&&this.options.extensions.startInline&&function(){var q=Infinity,Ae=ne.slice(1),Pe=void 0;be.options.extensions.startInline.forEach(function(Ze){Pe=Ze.call({lexer:this},Ae),typeof Pe=="number"&&Pe>=0&&(q=Math.min(q,Pe))}),q<Infinity&&q>=0&&(Ge=ne.substring(0,q+1))}(),we=this.tokenizer.inlineText(Ge,je)){ne=ne.substring(we.raw.length),we.raw.slice(-1)!=="_"&&(le=we.raw.slice(-1)),it=!0,Fe=de[de.length-1],Fe&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):de.push(we);continue}if(ne){var ce="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(ce);break}else throw new Error(ce)}}return de},e(Le,null,[{key:"rules",get:function(){return{block:Re,inline:$e}}}]),Le}(),re=k.exports.defaults,ae=F.cleanUrl,Y=F.escape,oe=function(){function Le(ke){this.options=ke||re}var De=Le.prototype;return De.code=function(ne,de,be){var we=(de||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(ne,we);Fe!=null&&Fe!==ne&&(be=!0,ne=Fe)}return ne=ne.replace(/\n$/,"")+`
`,we?'<pre><code class="'+this.options.langPrefix+Y(we,!0)+'">'+(be?ne:Y(ne,!0))+`</code></pre>
`:"<pre><code>"+(be?ne:Y(ne,!0))+`</code></pre>
`},De.blockquote=function(ne){return`<blockquote>
`+ne+`</blockquote>
`},De.html=function(ne){return ne},De.heading=function(ne,de,be,we){return this.options.headerIds?"<h"+de+' id="'+this.options.headerPrefix+we.slug(be)+'">'+ne+"</h"+de+`>
`:"<h"+de+">"+ne+"</h"+de+`>
`},De.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},De.list=function(ne,de,be){var we=de?"ol":"ul",Fe=de&&be!==1?' start="'+be+'"':"";return"<"+we+Fe+`>
`+ne+"</"+we+`>
`},De.listitem=function(ne){return"<li>"+ne+`</li>
`},De.checkbox=function(ne){return"<input "+(ne?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},De.paragraph=function(ne){return"<p>"+ne+`</p>
`},De.table=function(ne,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+ne+`</thead>
`+de+`</table>
`},De.tablerow=function(ne){return`<tr>
`+ne+`</tr>
`},De.tablecell=function(ne,de){var be=de.header?"th":"td",we=de.align?"<"+be+' align="'+de.align+'">':"<"+be+">";return we+ne+"</"+be+`>
`},De.strong=function(ne){return"<strong>"+ne+"</strong>"},De.em=function(ne){return"<em>"+ne+"</em>"},De.codespan=function(ne){return"<code>"+ne+"</code>"},De.br=function(){return this.options.xhtml?"<br/>":"<br>"},De.del=function(ne){return"<del>"+ne+"</del>"},De.link=function(ne,de,be){if(ne=ae(this.options.sanitize,this.options.baseUrl,ne),ne===null)return be;var we='<a href="'+Y(ne)+'"';return de&&(we+=' title="'+de+'"'),we+=">"+be+"</a>",we},De.image=function(ne,de,be){if(ne=ae(this.options.sanitize,this.options.baseUrl,ne),ne===null)return be;var we='<img src="'+ne+'" alt="'+be+'"';return de&&(we+=' title="'+de+'"'),we+=this.options.xhtml?"/>":">",we},De.text=function(ne){return ne},Le}(),ve=function(){function Le(){}var De=Le.prototype;return De.strong=function(ne){return ne},De.em=function(ne){return ne},De.codespan=function(ne){return ne},De.del=function(ne){return ne},De.html=function(ne){return ne},De.text=function(ne){return ne},De.link=function(ne,de,be){return""+be},De.image=function(ne,de,be){return""+be},De.br=function(){return""},Le}(),Me=function(){function Le(){this.seen={}}var De=Le.prototype;return De.serialize=function(ne){return ne.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},De.getNextSafeSlug=function(ne,de){var be=ne,we=0;if(this.seen.hasOwnProperty(be)){we=this.seen[ne];do we++,be=ne+"-"+we;while(this.seen.hasOwnProperty(be))}return de||(this.seen[ne]=we,this.seen[be]=0),be},De.slug=function(ne,de){de===void 0&&(de={});var be=this.serialize(ne);return this.getNextSafeSlug(be,de.dryrun)},Le}(),qe=oe,Ke=ve,Se=Me,tt=k.exports.defaults,Z=F.unescape,te=function(){function Le(ke){this.options=ke||tt,this.options.renderer=this.options.renderer||new qe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Ke,this.slugger=new Se}Le.parse=function(ne,de){var be=new Le(de);return be.parse(ne)},Le.parseInline=function(ne,de){var be=new Le(de);return be.parseInline(ne)};var De=Le.prototype;return De.parse=function(ne,de){de===void 0&&(de=!0);var be="",we,Fe,Ge,He,Ye,it,le,Ee,ce,q,Ae,Pe,Ze,Xe,ot,vt,Et,lt,dt,mt=ne.length;for(we=0;we<mt;we++){if(q=ne[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[q.type]&&(dt=this.options.extensions.renderers[q.type].call({parser:this},q),dt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(q.type))){be+=dt||"";continue}switch(q.type){case"space":continue;case"hr":{be+=this.renderer.hr();continue}case"heading":{be+=this.renderer.heading(this.parseInline(q.tokens),q.depth,Z(this.parseInline(q.tokens,this.textRenderer)),this.slugger);continue}case"code":{be+=this.renderer.code(q.text,q.lang,q.escaped);continue}case"table":{for(Ee="",le="",He=q.header.length,Fe=0;Fe<He;Fe++)le+=this.renderer.tablecell(this.parseInline(q.header[Fe].tokens),{header:!0,align:q.align[Fe]});for(Ee+=this.renderer.tablerow(le),ce="",He=q.rows.length,Fe=0;Fe<He;Fe++){for(it=q.rows[Fe],le="",Ye=it.length,Ge=0;Ge<Ye;Ge++)le+=this.renderer.tablecell(this.parseInline(it[Ge].tokens),{header:!1,align:q.align[Ge]});ce+=this.renderer.tablerow(le)}be+=this.renderer.table(Ee,ce);continue}case"blockquote":{ce=this.parse(q.tokens),be+=this.renderer.blockquote(ce);continue}case"list":{for(Ae=q.ordered,Pe=q.start,Ze=q.loose,He=q.items.length,ce="",Fe=0;Fe<He;Fe++)ot=q.items[Fe],vt=ot.checked,Et=ot.task,Xe="",ot.task&&(lt=this.renderer.checkbox(vt),Ze?ot.tokens.length>0&&ot.tokens[0].type==="paragraph"?(ot.tokens[0].text=lt+" "+ot.tokens[0].text,ot.tokens[0].tokens&&ot.tokens[0].tokens.length>0&&ot.tokens[0].tokens[0].type==="text"&&(ot.tokens[0].tokens[0].text=lt+" "+ot.tokens[0].tokens[0].text)):ot.tokens.unshift({type:"text",text:lt}):Xe+=lt),Xe+=this.parse(ot.tokens,Ze),ce+=this.renderer.listitem(Xe,Et,vt);be+=this.renderer.list(ce,Ae,Pe);continue}case"html":{be+=this.renderer.html(q.text);continue}case"paragraph":{be+=this.renderer.paragraph(this.parseInline(q.tokens));continue}case"text":{for(ce=q.tokens?this.parseInline(q.tokens):q.text;we+1<mt&&ne[we+1].type==="text";)q=ne[++we],ce+=`
`+(q.tokens?this.parseInline(q.tokens):q.text);be+=de?this.renderer.paragraph(ce):ce;continue}default:{var Rt='Token with "'+q.type+'" type was not found.';if(this.options.silent){console.error(Rt);return}else throw new Error(Rt)}}}return be},De.parseInline=function(ne,de){de=de||this.renderer;var be="",we,Fe,Ge,He=ne.length;for(we=0;we<He;we++){if(Fe=ne[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(Ge=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),Ge!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){be+=Ge||"";continue}switch(Fe.type){case"escape":{be+=de.text(Fe.text);break}case"html":{be+=de.html(Fe.text);break}case"link":{be+=de.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,de));break}case"image":{be+=de.image(Fe.href,Fe.title,Fe.text);break}case"strong":{be+=de.strong(this.parseInline(Fe.tokens,de));break}case"em":{be+=de.em(this.parseInline(Fe.tokens,de));break}case"codespan":{be+=de.codespan(Fe.text);break}case"br":{be+=de.br();break}case"del":{be+=de.del(this.parseInline(Fe.tokens,de));break}case"text":{be+=de.text(Fe.text);break}default:{var Ye='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(Ye);return}else throw new Error(Ye)}}}return be},Le}(),pe=ee,xe=te,Je=x,rt=oe,ft=ve,pt=Me,St=F.merge,Ct=F.checkSanitizeDeprecation,ue=F.escape,Ie=k.exports.getDefaults,Ue=k.exports.changeDefaults,Qe=k.exports.defaults;function ze(Le,De,ke){if(typeof Le=="undefined"||Le===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Le!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Le)+", string expected");if(typeof De=="function"&&(ke=De,De=null),De=St({},ze.defaults,De||{}),Ct(De),ke){var ne=De.highlight,de;try{de=pe.lex(Le,De)}catch(Ge){return ke(Ge)}var be=function(He){var Ye;if(!He)try{De.walkTokens&&ze.walkTokens(de,De.walkTokens),Ye=xe.parse(de,De)}catch(it){He=it}return De.highlight=ne,He?ke(He):ke(null,Ye)};if(!ne||ne.length<3||(delete De.highlight,!de.length))return be();var we=0;ze.walkTokens(de,function(Ge){Ge.type==="code"&&(we++,setTimeout(function(){ne(Ge.text,Ge.lang,function(He,Ye){if(He)return be(He);Ye!=null&&Ye!==Ge.text&&(Ge.text=Ye,Ge.escaped=!0),we--,we===0&&be()})},0))}),we===0&&be();return}try{var Fe=pe.lex(Le,De);return De.walkTokens&&ze.walkTokens(Fe,De.walkTokens),xe.parse(Fe,De)}catch(Ge){if(Ge.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+ue(Ge.message+"",!0)+"</pre>";throw Ge}}ze.options=ze.setOptions=function(Le){return St(ze.defaults,Le),Ue(ze.defaults),ze},ze.getDefaults=Ie,ze.defaults=Qe,ze.use=function(){for(var Le=this,De=arguments.length,ke=new Array(De),ne=0;ne<De;ne++)ke[ne]=arguments[ne];var de=St.apply(void 0,[{}].concat(ke)),be=ze.defaults.extensions||{renderers:{},childTokens:{}},we;ke.forEach(function(Fe){if(Fe.extensions&&(we=!0,Fe.extensions.forEach(function(He){if(!He.name)throw new Error("extension name required");if(He.renderer){var Ye=be.renderers?be.renderers[He.name]:null;Ye?be.renderers[He.name]=function(){for(var it=arguments.length,le=new Array(it),Ee=0;Ee<it;Ee++)le[Ee]=arguments[Ee];var ce=He.renderer.apply(this,le);return ce===!1&&(ce=Ye.apply(this,le)),ce}:be.renderers[He.name]=He.renderer}if(He.tokenizer){if(!He.level||He.level!=="block"&&He.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");be[He.level]?be[He.level].unshift(He.tokenizer):be[He.level]=[He.tokenizer],He.start&&(He.level==="block"?be.startBlock?be.startBlock.push(He.start):be.startBlock=[He.start]:He.level==="inline"&&(be.startInline?be.startInline.push(He.start):be.startInline=[He.start]))}He.childTokens&&(be.childTokens[He.name]=He.childTokens)})),Fe.renderer&&function(){var He=ze.defaults.renderer||new rt,Ye=function(Ee){var ce=He[Ee];He[Ee]=function(){for(var q=arguments.length,Ae=new Array(q),Pe=0;Pe<q;Pe++)Ae[Pe]=arguments[Pe];var Ze=Fe.renderer[Ee].apply(He,Ae);return Ze===!1&&(Ze=ce.apply(He,Ae)),Ze}};for(var it in Fe.renderer)Ye(it);de.renderer=He}(),Fe.tokenizer&&function(){var He=ze.defaults.tokenizer||new Je,Ye=function(Ee){var ce=He[Ee];He[Ee]=function(){for(var q=arguments.length,Ae=new Array(q),Pe=0;Pe<q;Pe++)Ae[Pe]=arguments[Pe];var Ze=Fe.tokenizer[Ee].apply(He,Ae);return Ze===!1&&(Ze=ce.apply(He,Ae)),Ze}};for(var it in Fe.tokenizer)Ye(it);de.tokenizer=He}(),Fe.walkTokens){var Ge=ze.defaults.walkTokens;de.walkTokens=function(He){Fe.walkTokens.call(Le,He),Ge&&Ge(He)}}we&&(de.extensions=be),ze.setOptions(de)})},ze.walkTokens=function(Le,De){for(var ke=function(){var we=de.value;switch(De(we),we.type){case"table":{for(var Fe=I(we.header),Ge;!(Ge=Fe()).done;){var He=Ge.value;ze.walkTokens(He.tokens,De)}for(var Ye=I(we.rows),it;!(it=Ye()).done;)for(var le=it.value,Ee=I(le),ce;!(ce=Ee()).done;){var q=ce.value;ze.walkTokens(q.tokens,De)}break}case"list":{ze.walkTokens(we.items,De);break}default:ze.defaults.extensions&&ze.defaults.extensions.childTokens&&ze.defaults.extensions.childTokens[we.type]?ze.defaults.extensions.childTokens[we.type].forEach(function(Ae){ze.walkTokens(we[Ae],De)}):we.tokens&&ze.walkTokens(we.tokens,De)}},ne=I(Le),de;!(de=ne()).done;)ke()},ze.parseInline=function(Le,De){if(typeof Le=="undefined"||Le===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Le!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Le)+", string expected");De=St({},ze.defaults,De||{}),Ct(De);try{var ke=pe.lexInline(Le,De);return De.walkTokens&&ze.walkTokens(ke,De.walkTokens),xe.parseInline(ke,De)}catch(ne){if(ne.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+ue(ne.message+"",!0)+"</pre>";throw ne}},ze.Parser=xe,ze.parser=xe.parse,ze.Renderer=rt,ze.TextRenderer=ft,ze.Lexer=pe,ze.lexer=pe.lex,ze.Tokenizer=Je,ze.Slugger=pt,ze.parse=ze;var at=ze;return at}),define(me[77],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function m(R,C,D){return Math.min(Math.max(R,C),D)}e.clamp=m;function L(R,C){return(C+R%C)%C}e.rot=L;class I{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=I;class k{constructor(){this._n=1,this._val=0}update(C){return this._val=this._val+(C-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=k}),function(){function J(I){const k=[];typeof I=="number"&&k.push("code/timeOrigin",I);function R(D){k.push(D,Date.now())}function C(){const D=[];for(let T=0;T<k.length;T+=2)D.push({name:k[T],startTime:k[T+1]});return D}return{mark:R,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const R of performance.getEntriesByType("mark"))k.push({name:R.name,startTime:Math.round(I+R.startTime)});return k}};if(typeof process=="object"){const I=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function m(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=m(L))}(),define(me[11],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const m="en";let L=!1,I=!1,k=!1,R=!1,C=!1,D=!1,T=!1,n,A=m,u,f;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let l;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?l=e.globals.vscode.process:typeof process!="undefined"&&(l=process);const v=typeof l?.versions?.electron=="string"&&l.type==="renderer";if(e.isElectronSandboxed=v&&l?.sandboxed,typeof navigator=="object"&&!v)f=navigator.userAgent,L=f.indexOf("Windows")>=0,I=f.indexOf("Macintosh")>=0,T=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=f.indexOf("Linux")>=0,D=!0,n=navigator.language,A=n;else if(typeof l=="object"){L=l.platform==="win32",I=l.platform==="darwin",k=l.platform==="linux",R=k&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,n=m,A=m;const r=l.env.VSCODE_NLS_CONFIG;if(r)try{const i=JSON.parse(r),h=i.availableLanguages["*"];n=i.locale,A=h||m,u=i._translationsConfigFile}catch(i){}C=!0}else console.error("Unable to resolve platform.");var S;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(S=e.Platform||(e.Platform={}));function P(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=P;let E=0;I?E=1:L?E=3:k&&(E=2),e.isWindows=L,e.isMacintosh=I,e.isLinux=k,e.isLinuxSnap=R,e.isNative=C,e.isWeb=D,e.isIOS=T,e.platform=E,e.userAgent=f,e.language=A;var s;(function(r){function i(){return e.language}r.value=i;function h(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=h;function c(){return e.language==="en"}r.isDefault=c})(s=e.Language||(e.Language={})),e.locale=n,e.translationsConfigFile=u,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let h=[];e.globals.addEventListener("message",d=>{if(d.data&&d.data.vscodeSetImmediateId)for(let b=0,y=h.length;b<y;b++){const g=h[b];if(g.id===d.data.vscodeSetImmediateId){h.splice(b,1),g.callback();return}}});let c=0;return d=>{const b=++c;h.push({id:b,callback:d}),e.globals.postMessage({vscodeSetImmediateId:b},"*")}}if(typeof l?.nextTick=="function")return l.nextTick.bind(l);const i=Promise.resolve();return h=>i.then(h)}();var a;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(a=e.OperatingSystem||(e.OperatingSystem={})),e.OS=I||T?2:L?1:3;let p=!0,t=!1;function o(){if(!t){t=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,p=new Uint16Array(r.buffer)[0]===(2<<8)+1}return p}e.isLittleEndian=o}),define(me[34],ge([0,1,11]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof m.globals.vscode!="undefined"&&typeof m.globals.vscode.process!="undefined"){const I=m.globals.vscode.process;L={get platform(){return I.platform},get arch(){return I.arch},get env(){return I.env},cwd(){return I.cwd()},nextTick(k){return(0,m.setImmediate)(k)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(I){return process.nextTick(I)}}:L={get platform(){return m.isWindows?"win32":m.isMacintosh?"darwin":"linux"},get arch(){},nextTick(I){return(0,m.setImmediate)(I)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick,e.arch=L.arch}),define(me[8],ge([0,1,34]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,I=97,k=90,R=122,C=46,D=47,T=92,n=58,A=63;class u extends Error{constructor(a,p,t){let o;typeof p=="string"&&p.indexOf("not ")===0?(o="must not be",p=p.replace(/^not /,"")):o="must be";const r=a.indexOf(".")!==-1?"property":"argument";let i=`The "${a}" ${r} ${o} of type ${p}`;i+=`. Received type ${typeof t}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function f(s,a){if(typeof s!="string")throw new u(a,"string",s)}function l(s){return s===D||s===T}function v(s){return s===D}function S(s){return s>=L&&s<=k||s>=I&&s<=R}function P(s,a,p,t){let o="",r=0,i=-1,h=0,c=0;for(let d=0;d<=s.length;++d){if(d<s.length)c=s.charCodeAt(d);else{if(t(c))break;c=D}if(t(c)){if(!(i===d-1||h===1))if(h===2){if(o.length<2||r!==2||o.charCodeAt(o.length-1)!==C||o.charCodeAt(o.length-2)!==C){if(o.length>2){const b=o.lastIndexOf(p);b===-1?(o="",r=0):(o=o.slice(0,b),r=o.length-1-o.lastIndexOf(p)),i=d,h=0;continue}else if(o.length!==0){o="",r=0,i=d,h=0;continue}}a&&(o+=o.length>0?`${p}..`:"..",r=2)}else o.length>0?o+=`${p}${s.slice(i+1,d)}`:o=s.slice(i+1,d),r=d-i-1;i=d,h=0}else c===C&&h!==-1?++h:h=-1}return o}function E(s,a){if(a===null||typeof a!="object")throw new u("pathObject","Object",a);const p=a.dir||a.root,t=a.base||`${a.name||""}${a.ext||""}`;return p?p===a.root?`${p}${t}`:`${p}${s}${t}`:t}e.win32={resolve(...s){let a="",p="",t=!1;for(let o=s.length-1;o>=-1;o--){let r;if(o>=0){if(r=s[o],f(r,"path"),r.length===0)continue}else a.length===0?r=m.cwd():(r=m.env[`=${a}`]||m.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==a.toLowerCase()&&r.charCodeAt(2)===T)&&(r=`${a}\\`));const i=r.length;let h=0,c="",d=!1;const b=r.charCodeAt(0);if(i===1)l(b)&&(h=1,d=!0);else if(l(b))if(d=!0,l(r.charCodeAt(1))){let y=2,g=y;for(;y<i&&!l(r.charCodeAt(y));)y++;if(y<i&&y!==g){const _=r.slice(g,y);for(g=y;y<i&&l(r.charCodeAt(y));)y++;if(y<i&&y!==g){for(g=y;y<i&&!l(r.charCodeAt(y));)y++;(y===i||y!==g)&&(c=`\\\\${_}\\${r.slice(g,y)}`,h=y)}}}else h=1;else S(b)&&r.charCodeAt(1)===n&&(c=r.slice(0,2),h=2,i>2&&l(r.charCodeAt(2))&&(d=!0,h=3));if(c.length>0)if(a.length>0){if(c.toLowerCase()!==a.toLowerCase())continue}else a=c;if(t){if(a.length>0)break}else if(p=`${r.slice(h)}\\${p}`,t=d,d&&a.length>0)break}return p=P(p,!t,"\\",l),t?`${a}\\${p}`:`${a}${p}`||"."},normalize(s){f(s,"path");const a=s.length;if(a===0)return".";let p=0,t,o=!1;const r=s.charCodeAt(0);if(a===1)return v(r)?"\\":s;if(l(r))if(o=!0,l(s.charCodeAt(1))){let h=2,c=h;for(;h<a&&!l(s.charCodeAt(h));)h++;if(h<a&&h!==c){const d=s.slice(c,h);for(c=h;h<a&&l(s.charCodeAt(h));)h++;if(h<a&&h!==c){for(c=h;h<a&&!l(s.charCodeAt(h));)h++;if(h===a)return`\\\\${d}\\${s.slice(c)}\\`;h!==c&&(t=`\\\\${d}\\${s.slice(c,h)}`,p=h)}}}else p=1;else S(r)&&s.charCodeAt(1)===n&&(t=s.slice(0,2),p=2,a>2&&l(s.charCodeAt(2))&&(o=!0,p=3));let i=p<a?P(s.slice(p),!o,"\\",l):"";return i.length===0&&!o&&(i="."),i.length>0&&l(s.charCodeAt(a-1))&&(i+="\\"),t===void 0?o?`\\${i}`:i:o?`${t}\\${i}`:`${t}${i}`},isAbsolute(s){f(s,"path");const a=s.length;if(a===0)return!1;const p=s.charCodeAt(0);return l(p)||a>2&&S(p)&&s.charCodeAt(1)===n&&l(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let a,p;for(let r=0;r<s.length;++r){const i=s[r];f(i,"path"),i.length>0&&(a===void 0?a=p=i:a+=`\\${i}`)}if(a===void 0)return".";let t=!0,o=0;if(typeof p=="string"&&l(p.charCodeAt(0))){++o;const r=p.length;r>1&&l(p.charCodeAt(1))&&(++o,r>2&&(l(p.charCodeAt(2))?++o:t=!1))}if(t){for(;o<a.length&&l(a.charCodeAt(o));)o++;o>=2&&(a=`\\${a.slice(o)}`)}return e.win32.normalize(a)},relative(s,a){if(f(s,"from"),f(a,"to"),s===a)return"";const p=e.win32.resolve(s),t=e.win32.resolve(a);if(p===t||(s=p.toLowerCase(),a=t.toLowerCase(),s===a))return"";let o=0;for(;o<s.length&&s.charCodeAt(o)===T;)o++;let r=s.length;for(;r-1>o&&s.charCodeAt(r-1)===T;)r--;const i=r-o;let h=0;for(;h<a.length&&a.charCodeAt(h)===T;)h++;let c=a.length;for(;c-1>h&&a.charCodeAt(c-1)===T;)c--;const d=c-h,b=i<d?i:d;let y=-1,g=0;for(;g<b;g++){const w=s.charCodeAt(o+g);if(w!==a.charCodeAt(h+g))break;w===T&&(y=g)}if(g!==b){if(y===-1)return t}else{if(d>b){if(a.charCodeAt(h+g)===T)return t.slice(h+g+1);if(g===2)return t.slice(h+g)}i>b&&(s.charCodeAt(o+g)===T?y=g:g===2&&(y=3)),y===-1&&(y=0)}let _="";for(g=o+y+1;g<=r;++g)(g===r||s.charCodeAt(g)===T)&&(_+=_.length===0?"..":"\\..");return h+=y,_.length>0?`${_}${t.slice(h,c)}`:(t.charCodeAt(h)===T&&++h,t.slice(h,c))},toNamespacedPath(s){if(typeof s!="string")return s;if(s.length===0)return"";const a=e.win32.resolve(s);if(a.length<=2)return s;if(a.charCodeAt(0)===T){if(a.charCodeAt(1)===T){const p=a.charCodeAt(2);if(p!==A&&p!==C)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(S(a.charCodeAt(0))&&a.charCodeAt(1)===n&&a.charCodeAt(2)===T)return`\\\\?\\${a}`;return s},dirname(s){f(s,"path");const a=s.length;if(a===0)return".";let p=-1,t=0;const o=s.charCodeAt(0);if(a===1)return l(o)?s:".";if(l(o)){if(p=t=1,l(s.charCodeAt(1))){let h=2,c=h;for(;h<a&&!l(s.charCodeAt(h));)h++;if(h<a&&h!==c){for(c=h;h<a&&l(s.charCodeAt(h));)h++;if(h<a&&h!==c){for(c=h;h<a&&!l(s.charCodeAt(h));)h++;if(h===a)return s;h!==c&&(p=t=h+1)}}}}else S(o)&&s.charCodeAt(1)===n&&(p=a>2&&l(s.charCodeAt(2))?3:2,t=p);let r=-1,i=!0;for(let h=a-1;h>=t;--h)if(l(s.charCodeAt(h))){if(!i){r=h;break}}else i=!1;if(r===-1){if(p===-1)return".";r=p}return s.slice(0,r)},basename(s,a){a!==void 0&&f(a,"ext"),f(s,"path");let p=0,t=-1,o=!0,r;if(s.length>=2&&S(s.charCodeAt(0))&&s.charCodeAt(1)===n&&(p=2),a!==void 0&&a.length>0&&a.length<=s.length){if(a===s)return"";let i=a.length-1,h=-1;for(r=s.length-1;r>=p;--r){const c=s.charCodeAt(r);if(l(c)){if(!o){p=r+1;break}}else h===-1&&(o=!1,h=r+1),i>=0&&(c===a.charCodeAt(i)?--i==-1&&(t=r):(i=-1,t=h))}return p===t?t=h:t===-1&&(t=s.length),s.slice(p,t)}for(r=s.length-1;r>=p;--r)if(l(s.charCodeAt(r))){if(!o){p=r+1;break}}else t===-1&&(o=!1,t=r+1);return t===-1?"":s.slice(p,t)},extname(s){f(s,"path");let a=0,p=-1,t=0,o=-1,r=!0,i=0;s.length>=2&&s.charCodeAt(1)===n&&S(s.charCodeAt(0))&&(a=t=2);for(let h=s.length-1;h>=a;--h){const c=s.charCodeAt(h);if(l(c)){if(!r){t=h+1;break}continue}o===-1&&(r=!1,o=h+1),c===C?p===-1?p=h:i!==1&&(i=1):p!==-1&&(i=-1)}return p===-1||o===-1||i===0||i===1&&p===o-1&&p===t+1?"":s.slice(p,o)},format:E.bind(null,"\\"),parse(s){f(s,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return a;const p=s.length;let t=0,o=s.charCodeAt(0);if(p===1)return l(o)?(a.root=a.dir=s,a):(a.base=a.name=s,a);if(l(o)){if(t=1,l(s.charCodeAt(1))){let y=2,g=y;for(;y<p&&!l(s.charCodeAt(y));)y++;if(y<p&&y!==g){for(g=y;y<p&&l(s.charCodeAt(y));)y++;if(y<p&&y!==g){for(g=y;y<p&&!l(s.charCodeAt(y));)y++;y===p?t=y:y!==g&&(t=y+1)}}}}else if(S(o)&&s.charCodeAt(1)===n){if(p<=2)return a.root=a.dir=s,a;if(t=2,l(s.charCodeAt(2))){if(p===3)return a.root=a.dir=s,a;t=3}}t>0&&(a.root=s.slice(0,t));let r=-1,i=t,h=-1,c=!0,d=s.length-1,b=0;for(;d>=t;--d){if(o=s.charCodeAt(d),l(o)){if(!c){i=d+1;break}continue}h===-1&&(c=!1,h=d+1),o===C?r===-1?r=d:b!==1&&(b=1):r!==-1&&(b=-1)}return h!==-1&&(r===-1||b===0||b===1&&r===h-1&&r===i+1?a.base=a.name=s.slice(i,h):(a.name=s.slice(i,r),a.base=s.slice(i,h),a.ext=s.slice(r,h))),i>0&&i!==t?a.dir=s.slice(0,i-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...s){let a="",p=!1;for(let t=s.length-1;t>=-1&&!p;t--){const o=t>=0?s[t]:m.cwd();f(o,"path"),o.length!==0&&(a=`${o}/${a}`,p=o.charCodeAt(0)===D)}return a=P(a,!p,"/",v),p?`/${a}`:a.length>0?a:"."},normalize(s){if(f(s,"path"),s.length===0)return".";const a=s.charCodeAt(0)===D,p=s.charCodeAt(s.length-1)===D;return s=P(s,!a,"/",v),s.length===0?a?"/":p?"./":".":(p&&(s+="/"),a?`/${s}`:s)},isAbsolute(s){return f(s,"path"),s.length>0&&s.charCodeAt(0)===D},join(...s){if(s.length===0)return".";let a;for(let p=0;p<s.length;++p){const t=s[p];f(t,"path"),t.length>0&&(a===void 0?a=t:a+=`/${t}`)}return a===void 0?".":e.posix.normalize(a)},relative(s,a){if(f(s,"from"),f(a,"to"),s===a||(s=e.posix.resolve(s),a=e.posix.resolve(a),s===a))return"";const p=1,t=s.length,o=t-p,r=1,i=a.length-r,h=o<i?o:i;let c=-1,d=0;for(;d<h;d++){const y=s.charCodeAt(p+d);if(y!==a.charCodeAt(r+d))break;y===D&&(c=d)}if(d===h)if(i>h){if(a.charCodeAt(r+d)===D)return a.slice(r+d+1);if(d===0)return a.slice(r+d)}else o>h&&(s.charCodeAt(p+d)===D?c=d:d===0&&(c=0));let b="";for(d=p+c+1;d<=t;++d)(d===t||s.charCodeAt(d)===D)&&(b+=b.length===0?"..":"/..");return`${b}${a.slice(r+c)}`},toNamespacedPath(s){return s},dirname(s){if(f(s,"path"),s.length===0)return".";const a=s.charCodeAt(0)===D;let p=-1,t=!0;for(let o=s.length-1;o>=1;--o)if(s.charCodeAt(o)===D){if(!t){p=o;break}}else t=!1;return p===-1?a?"/":".":a&&p===1?"//":s.slice(0,p)},basename(s,a){a!==void 0&&f(a,"ext"),f(s,"path");let p=0,t=-1,o=!0,r;if(a!==void 0&&a.length>0&&a.length<=s.length){if(a===s)return"";let i=a.length-1,h=-1;for(r=s.length-1;r>=0;--r){const c=s.charCodeAt(r);if(c===D){if(!o){p=r+1;break}}else h===-1&&(o=!1,h=r+1),i>=0&&(c===a.charCodeAt(i)?--i==-1&&(t=r):(i=-1,t=h))}return p===t?t=h:t===-1&&(t=s.length),s.slice(p,t)}for(r=s.length-1;r>=0;--r)if(s.charCodeAt(r)===D){if(!o){p=r+1;break}}else t===-1&&(o=!1,t=r+1);return t===-1?"":s.slice(p,t)},extname(s){f(s,"path");let a=-1,p=0,t=-1,o=!0,r=0;for(let i=s.length-1;i>=0;--i){const h=s.charCodeAt(i);if(h===D){if(!o){p=i+1;break}continue}t===-1&&(o=!1,t=i+1),h===C?a===-1?a=i:r!==1&&(r=1):a!==-1&&(r=-1)}return a===-1||t===-1||r===0||r===1&&a===t-1&&a===p+1?"":s.slice(a,t)},format:E.bind(null,"/"),parse(s){f(s,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return a;const p=s.charCodeAt(0)===D;let t;p?(a.root="/",t=1):t=0;let o=-1,r=0,i=-1,h=!0,c=s.length-1,d=0;for(;c>=t;--c){const b=s.charCodeAt(c);if(b===D){if(!h){r=c+1;break}continue}i===-1&&(h=!1,i=c+1),b===C?o===-1?o=c:d!==1&&(d=1):o!==-1&&(d=-1)}if(i!==-1){const b=r===0&&p?1:r;o===-1||d===0||d===1&&o===i-1&&o===r+1?a.base=a.name=s.slice(b,i):(a.name=s.slice(b,o),a.base=s.slice(b,i),a.ext=s.slice(o,i))}return r>0?a.dir=s.slice(0,r-1):p&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=m.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m.platform==="win32"?e.win32.join:e.posix.join,e.resolve=m.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=m.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=m.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=m.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=m.platform==="win32"?e.win32.extname:e.posix.extname,e.format=m.platform==="win32"?e.win32.format:e.posix.format,e.parse=m.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=m.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=m.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(me[140],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var m;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(m=e.Source||(e.Source={}));var L;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function I(k,...R){const C=R.reduce((n,A)=>(n[A]=!0,n),{}),D=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(n=>!C[n]).forEach(n=>{for(let A=0;A<D.length;A++)if(n.search(D[A])!==-1){delete k[n];break}})}e.sanitizeProcessEnvironment=I}),define(me[46],ge([0,1,11]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=m.globals.performance&&typeof m.globals.performance.now=="function";class I{constructor(R){this._highResolution=L&&R,this._startTime=this._now(),this._stopTime=-1}static create(R=!0){return new I(R)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?m.globals.performance.now():Date.now()}}e.StopWatch=I}),define(me[3],ge([0,1,16,75,6,95,46]),function(J,e,m,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var C;(function(s){s.None=()=>I.Disposable.None;function a(K){return(U,z=null,O)=>{let B=!1,x;return x=K(M=>{if(!B)return x?x.dispose():B=!0,U.call(z,M)},null,O),B&&x.dispose(),x}}s.once=a;function p(K,U){return c((z,O=null,B)=>K(x=>z.call(O,U(x)),null,B))}s.map=p;function t(K,U){return c((z,O=null,B)=>K(x=>{U(x),z.call(O,x)},null,B))}s.forEach=t;function o(K,U){return c((z,O=null,B)=>K(x=>U(x)&&z.call(O,x),null,B))}s.filter=o;function r(K){return K}s.signal=r;function i(...K){return(U,z=null,O)=>(0,I.combinedDisposable)(...K.map(B=>B(x=>U.call(z,x),null,O)))}s.any=i;function h(K,U,z){let O=z;return p(K,B=>(O=U(O,B),O))}s.reduce=h;function c(K){let U;const z=new u({onFirstListenerAdd(){U=K(z.fire,z)},onLastListenerRemove(){U.dispose()}});return z.event}function d(K,U,z=100,O=!1,B){let x,M,H,W=0;const Q=new u({leakWarningThreshold:B,onFirstListenerAdd(){x=K(X=>{W++,M=U(M,X),O&&!H&&(Q.fire(M),M=void 0),clearTimeout(H),H=setTimeout(()=>{const he=M;M=void 0,H=void 0,(!O||W>1)&&Q.fire(he),W=0},z)})},onLastListenerRemove(){x.dispose()}});return Q.event}s.debounce=d;function b(K,U=(z,O)=>z===O){let z=!0,O;return o(K,B=>{const x=z||!U(B,O);return z=!1,O=B,x})}s.latch=b;function y(K,U){return[s.filter(K,U),s.filter(K,z=>!U(z))]}s.split=y;function g(K,U=!1,z=[]){let O=z.slice(),B=K(H=>{O?O.push(H):M.fire(H)});const x=()=>{O&&O.forEach(H=>M.fire(H)),O=null},M=new u({onFirstListenerAdd(){B||(B=K(H=>M.fire(H)))},onFirstListenerDidAdd(){O&&(U?setTimeout(x):x())},onLastListenerRemove(){B&&B.dispose(),B=null}});return M.event}s.buffer=g;class _{constructor(U){this.event=U}map(U){return new _(p(this.event,U))}forEach(U){return new _(t(this.event,U))}filter(U){return new _(o(this.event,U))}reduce(U,z){return new _(h(this.event,U,z))}latch(){return new _(b(this.event))}debounce(U,z=100,O=!1,B){return new _(d(this.event,U,z,O,B))}on(U,z,O){return this.event(U,z,O)}once(U,z,O){return a(this.event)(U,z,O)}}function w(K){return new _(K)}s.chain=w;function F(K,U,z=O=>O){const O=(...H)=>M.fire(z(...H)),B=()=>K.on(U,O),x=()=>K.removeListener(U,O),M=new u({onFirstListenerAdd:B,onLastListenerRemove:x});return M.event}s.fromNodeEventEmitter=F;function N(K,U,z=O=>O){const O=(...H)=>M.fire(z(...H)),B=()=>K.addEventListener(U,O),x=()=>K.removeEventListener(U,O),M=new u({onFirstListenerAdd:B,onLastListenerRemove:x});return M.event}s.fromDOMEventEmitter=N;function G(K){return new Promise(U=>a(K)(U))}s.toPromise=G})(C=e.Event||(e.Event={}));class D{constructor(a){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${a}_${D._idPool++}`}start(a){this._stopWatch=new R.StopWatch(!0),this._listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this._elapsedOverall+=a,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${a.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}D._idPool=0;let T=-1;function n(s){const a=T;return T=s,{dispose(){T=a}}}e.setGlobalLeakWarningThreshold=n;class A{constructor(a,p=Math.random().toString(18).slice(2,5)){this.customThreshold=a,this.name=p,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(a){let p=T;if(typeof this.customThreshold=="number"&&(p=this.customThreshold),p<=0||a<p)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),o=this._stacks.get(t)||0;if(this._stacks.set(t,o+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=p*.5;let r,i=0;for(const[h,c]of this._stacks)(!r||i<c)&&(r=h,i=c);console.warn(`[${this.name}] potential listener LEAK detected, having ${a} listeners already. MOST frequent listener (${i}):`),console.warn(r)}return()=>{const r=this._stacks.get(t)||0;this._stacks.set(t,r-1)}}}class u{constructor(a){this._disposed=!1,this._options=a,this._leakageMon=T>0?new A(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new D(this._options._profName):void 0}get event(){return this._event||(this._event=(a,p,t)=>{this._listeners||(this._listeners=new k.LinkedList);const o=this._listeners.isEmpty();o&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(p?[a,p]:a);o&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,a,p);const i=this._leakageMon?.check(this._listeners.size),h=(0,I.toDisposable)(()=>{i&&i(),this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof I.DisposableStore?t.add(h):Array.isArray(t)&&t.push(h),h}),this._event}fire(a){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new k.LinkedList);for(let p of this._listeners)this._deliveryQueue.push([p,a]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[p,t]=this._deliveryQueue.shift();try{typeof p=="function"?p.call(void 0,t):p[0].call(p[1],t)}catch(o){(0,m.onUnexpectedError)(o)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=u;class f extends u{async fireAsync(a,p,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new k.LinkedList);for(const o of this._listeners)this._asyncDeliveryQueue.push([o,a]);for(;this._asyncDeliveryQueue.size>0&&!p.isCancellationRequested;){const[o,r]=this._asyncDeliveryQueue.shift(),i=[],h={...r,waitUntil:c=>{if(Object.isFrozen(i))throw new Error("waitUntil can NOT be called asynchronous");t&&(c=t(c,typeof o=="function"?o:o[0])),i.push(c)}};try{typeof o=="function"?o.call(void 0,h):o[0].call(o[1],h)}catch(c){(0,m.onUnexpectedError)(c);continue}Object.freeze(i),await Promise.allSettled(i).then(c=>{for(const d of c)d.status==="rejected"&&(0,m.onUnexpectedError)(d.reason)})}}}}e.AsyncEmitter=f;class l extends u{constructor(a){super(a);this._isPaused=0,this._eventQueue=new k.LinkedList,this._mergeFn=a?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=l;class v extends l{constructor(a){super(a);this._delay=a.delay??100}fire(a){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(a)}}e.DebounceEmitter=v;class S{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new u({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const p={event:a,listener:null};this.events.push(p),this.hasListeners&&this.hook(p);const t=()=>{this.hasListeners&&this.unhook(p);const o=this.events.indexOf(p);this.events.splice(o,1)};return(0,I.toDisposable)((0,L.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(p=>this.emitter.fire(p))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=S;class P{constructor(){this.buffers=[]}wrapEvent(a){return(p,t,o)=>a(r=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>p.call(t,r)):p.call(t,r)},void 0,o)}bufferEvents(a){const p=[];this.buffers.push(p);const t=a();return this.buffers.pop(),p.forEach(o=>o()),t}}e.EventBufferer=P;class E{constructor(){this.listening=!1,this.inputEvent=C.None,this.inputEventListener=I.Disposable.None,this.emitter=new u({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=E}),define(me[21],ge([0,1,3]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(C,D){const T=setTimeout(C.bind(D),0);return{dispose(){clearTimeout(T)}}});var I;(function(C){function D(T){return T===C.None||T===C.Cancelled||T instanceof k?!0:!T||typeof T!="object"?!1:typeof T.isCancellationRequested=="boolean"&&typeof T.onCancellationRequested=="function"}C.isCancellationToken=D,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:m.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(I=e.CancellationToken||(e.CancellationToken={}));class k{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new m.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class R{constructor(D){this._token=void 0,this._parentListener=void 0,this._parentListener=D&&D.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new k),this._token}cancel(){this._token?this._token instanceof k&&this._token.cancel():this._token=I.Cancelled}dispose(D=!1){D&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof k&&this._token.dispose():this._token=I.None}}e.CancellationTokenSource=R}),define(me[47],ge([0,1,3]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new m.Emitter}add(A){const u=this._icons.get(A.id);u?A.description?u.description=A.description:console.error(`Duplicate registration of codicon ${A.id}`):(this._icons.set(A.id,A),this._onDidRegister.fire(A))}get(A){return this._icons.get(A)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const I=new L;e.iconRegistry=I;function k(n,A){return new C(n,A)}e.registerCodicon=k;function R(n){return n?n.replace(/\$\((.*?)\)/g,(A,u)=>` ${u} `).trim():""}e.getCodiconAriaLabel=R;class C{constructor(A,u,f){this.id=A,this.definition=u,this.description=f,I.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=C;function D(n,A){const u=["codicon","codicon-"+n];return A&&u.push("codicon-modifier-"+A),u}e.getClassNamesArray=D;var T;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const A=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function u(v){if(v instanceof C)return["codicon","codicon-"+v.id];const S=A.exec(v.id);if(!S)return u(C.error);let[,P,E]=S;const s=["codicon","codicon-"+P];return E&&s.push("codicon-modifier-"+E.substr(1)),s}n.asClassNameArray=u;function f(v){return u(v).join(" ")}n.asClassName=f;function l(v){return"."+u(v).join(".")}n.asCSSSelector=l})(T=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(C=e.Codicon||(e.Codicon={}))}),define(me[96],ge([0,1,16,6]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function I(s){const a=s;return a?[a.on,a.pause,a.resume,a.destroy].every(p=>typeof p=="function"):!1}e.isReadableStream=I;function k(s){const a=s;return a?I(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=k;function R(s,a){return new C(s,a)}e.newWriteableStream=R;class C{constructor(a,p){this.reducer=a,this.options=p,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(p=>this.pendingWritePromises.push(p))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a!="undefined"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(p=>p(a))}emitError(a){this.listeners.error.length===0?(0,m.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(p=>p(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,p){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(p),this.resume();break;case"end":this.listeners.end.push(p),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(p),this.state.flowing&&this.flowErrors();break}}removeListener(a,p){if(this.state.destroyed)return;let t;switch(a){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const o=t.indexOf(p);o>=0&&t.splice(o,1)}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const p=[...this.pendingWritePromises];this.pendingWritePromises.length=0,p.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(s,a){const p=[];let t;for(;(t=s.read())!==null;)p.push(t);return a(p)}e.consumeReadable=D;function T(s,a,p){const t=[];let o;for(;(o=s.read())!==null&&t.length<p;)t.push(o);return o===null&&t.length>0?a(t):{read:()=>{if(t.length>0)return t.shift();if(typeof o!="undefined"){const r=o;return o=void 0,r}return s.read()}}}e.peekReadable=T;function n(s,a){return new Promise((p,t)=>{const o=[];A(s,{onData:r=>{a&&o.push(r)},onError:r=>{a?t(r):p(void 0)},onEnd:()=>{p(a?a(o):void 0)}})})}e.consumeStream=n;function A(s,a){s.on("error",p=>a.onError(p)),s.on("end",()=>a.onEnd()),s.on("data",p=>a.onData(p))}e.listenStream=A;function u(s,a){return new Promise((p,t)=>{const o=new L.DisposableStore,r=[],i=d=>{if(r.push(d),r.length>a)return o.dispose(),s.pause(),p({stream:s,buffer:r,ended:!1})},h=d=>t(d),c=()=>p({stream:s,buffer:r,ended:!0});o.add((0,L.toDisposable)(()=>s.removeListener("error",h))),s.on("error",h),o.add((0,L.toDisposable)(()=>s.removeListener("end",c))),s.on("end",c),o.add((0,L.toDisposable)(()=>s.removeListener("data",i))),s.on("data",i)})}e.peekStream=u;function f(s,a){const p=R(a);return p.end(s),p}e.toStream=f;function l(){const s=R(()=>{throw new Error("not supported")});return s.end(),s}e.emptyStream=l;function v(s){let a=!1;return{read:()=>a?null:(a=!0,s)}}e.toReadable=v;function S(s,a,p){const t=R(p);return A(s,{onData:o=>t.write(a.data(o)),onError:o=>t.error(a.error?a.error(o):o),onEnd:()=>t.end()}),t}e.transform=S;function P(s,a,p){let t=!1;return{read:()=>{const o=a.read();return t?o:(t=!0,o!==null?p([s,o]):s)}}}e.prefixedReadable=P;function E(s,a,p){let t=!1;const o=R(p);return A(a,{onData:r=>t?o.write(r):(t=!0,o.write(p([s,r]))),onError:r=>o.error(r),onEnd:()=>{t||(t=!0,o.write(s)),o.end()}}),o}e.prefixedStream=E}),define(me[23],ge([0,1,96]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let I,k;class R{constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}static alloc(i){return L?new R(Buffer.allocUnsafe(i)):new R(new Uint8Array(i))}static wrap(i){return L&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new R(i)}static fromString(i,h){return!(h?.dontUseNodeBuffer||!1)&&L?new R(Buffer.from(i)):(I||(I=new TextEncoder),new R(I.encode(i)))}static concat(i,h){if(typeof h=="undefined"){h=0;for(let b=0,y=i.length;b<y;b++)h+=i[b].byteLength}const c=R.alloc(h);let d=0;for(let b=0,y=i.length;b<y;b++){const g=i[b];c.set(g,d),d+=g.byteLength}return c}toString(){return L?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(i,h){return new R(this.buffer.subarray(i,h))}set(i,h){i instanceof R?this.buffer.set(i.buffer,h):this.buffer.set(i,h)}readUInt32BE(i){return T(this.buffer,i)}writeUInt32BE(i,h){n(this.buffer,i,h)}readUInt32LE(i){return A(this.buffer,i)}writeUInt32LE(i,h){u(this.buffer,i,h)}readUInt8(i){return f(this.buffer,i)}writeUInt8(i,h){l(this.buffer,i,h)}}e.VSBuffer=R;function C(r,i){return r[i+0]<<0>>>0|r[i+1]<<8>>>0}e.readUInt16LE=C;function D(r,i,h){r[h+0]=i&255,i=i>>>8,r[h+1]=i&255}e.writeUInt16LE=D;function T(r,i){return r[i]*2**24+r[i+1]*2**16+r[i+2]*2**8+r[i+3]}e.readUInt32BE=T;function n(r,i,h){r[h+3]=i,i=i>>>8,r[h+2]=i,i=i>>>8,r[h+1]=i,i=i>>>8,r[h]=i}e.writeUInt32BE=n;function A(r,i){return r[i+0]<<0>>>0|r[i+1]<<8>>>0|r[i+2]<<16>>>0|r[i+3]<<24>>>0}e.readUInt32LE=A;function u(r,i,h){r[h+0]=i&255,i=i>>>8,r[h+1]=i&255,i=i>>>8,r[h+2]=i&255,i=i>>>8,r[h+3]=i&255}e.writeUInt32LE=u;function f(r,i){return r[i]}e.readUInt8=f;function l(r,i,h){r[h]=i}e.writeUInt8=l;function v(r){return m.consumeReadable(r,i=>R.concat(i))}e.readableToBuffer=v;function S(r){return m.toReadable(r)}e.bufferToReadable=S;function P(r){return m.consumeStream(r,i=>R.concat(i))}e.streamToBuffer=P;async function E(r){return r.ended?R.concat(r.buffer):R.concat([...r.buffer,await P(r.stream)])}e.bufferedStreamToBuffer=E;function s(r){return m.toStream(r,i=>R.concat(i))}e.bufferToStream=s;function a(r){return m.transform(r,{data:i=>typeof i=="string"?R.fromString(i):R.wrap(i)},i=>R.concat(i))}e.streamToBufferReadableStream=a;function p(r){return m.newWriteableStream(i=>R.concat(i),r)}e.newWriteableBufferStream=p;function t(r,i){return m.prefixedReadable(r,i,h=>R.concat(h))}e.prefixedBufferReadable=t;function o(r,i){return m.prefixedStream(r,i,h=>R.concat(h))}e.prefixedBufferStream=o}),define(me[9],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function m(ue){return!ue||typeof ue!="string"?!0:ue.trim().length===0}e.isFalsyOrWhitespace=m;const L=/{(\d+)}/g;function I(ue,...Ie){return Ie.length===0?ue:ue.replace(L,function(Ue,Qe){const ze=parseInt(Qe,10);return isNaN(ze)||ze<0||ze>=Ie.length?Ue:Ie[ze]})}e.format=I;const k=/{([^}]+)}/g;function R(ue,Ie){return ue.replace(k,(Ue,Qe)=>Ie[Qe]??Ue)}e.format2=R;function C(ue){return ue.replace(/[<>&]/g,function(Ie){switch(Ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ie}})}e.escape=C;function D(ue){return ue.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=D;function T(ue,Ie){let Ue=0;const Qe=Ie.charCodeAt(0);for(let ze=ue.length-1;ze>=0;ze--)ue.charCodeAt(ze)===Qe&&Ue++;return Ue}e.count=T;function n(ue,Ie,Ue="\u2026"){return ue.length<=Ie?ue:`${ue.substr(0,Ie)}${Ue}`}e.truncate=n;function A(ue,Ie=" "){const Ue=u(ue,Ie);return f(Ue,Ie)}e.trim=A;function u(ue,Ie){if(!ue||!Ie)return ue;const Ue=Ie.length;if(Ue===0||ue.length===0)return ue;let Qe=0;for(;ue.indexOf(Ie,Qe)===Qe;)Qe=Qe+Ue;return ue.substring(Qe)}e.ltrim=u;function f(ue,Ie){if(!ue||!Ie)return ue;const Ue=Ie.length,Qe=ue.length;if(Ue===0||Qe===0)return ue;let ze=Qe,at=-1;for(;at=ue.lastIndexOf(Ie,ze-1),!(at===-1||at+Ue!==ze);){if(at===0)return"";ze=at}return ue.substring(0,ze)}e.rtrim=f;function l(ue){return ue.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=l;function v(ue){return ue.replace(/\*/g,"")}e.stripWildcards=v;function S(ue,Ie,Ue={}){if(!ue)throw new Error("Cannot create regex from empty string");Ie||(ue=D(ue)),Ue.wholeWord&&(/\B/.test(ue.charAt(0))||(ue="\\b"+ue),/\B/.test(ue.charAt(ue.length-1))||(ue=ue+"\\b"));let Qe="";return Ue.global&&(Qe+="g"),Ue.matchCase||(Qe+="i"),Ue.multiline&&(Qe+="m"),Ue.unicode&&(Qe+="u"),new RegExp(ue,Qe)}e.createRegExp=S;function P(ue){return ue.source==="^"||ue.source==="^$"||ue.source==="$"||ue.source==="^\\s*$"?!1:!!(ue.exec("")&&ue.lastIndex===0)}e.regExpLeadsToEndlessLoop=P;function E(ue){return!!ue.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=E;function s(ue){return(ue.global?"g":"")+(ue.ignoreCase?"i":"")+(ue.multiline?"m":"")+(ue.unicode?"u":"")}e.regExpFlags=s;function a(ue){return ue.split(/\r\n|\r|\n/)}e.splitLines=a;function p(ue){for(let Ie=0,Ue=ue.length;Ie<Ue;Ie++){const Qe=ue.charCodeAt(Ie);if(Qe!==32&&Qe!==9)return Ie}return-1}e.firstNonWhitespaceIndex=p;function t(ue,Ie=0,Ue=ue.length){for(let Qe=Ie;Qe<Ue;Qe++){const ze=ue.charCodeAt(Qe);if(ze!==32&&ze!==9)return ue.substring(Ie,Qe)}return ue.substring(Ie,Ue)}e.getLeadingWhitespace=t;function o(ue,Ie=ue.length-1){for(let Ue=Ie;Ue>=0;Ue--){const Qe=ue.charCodeAt(Ue);if(Qe!==32&&Qe!==9)return Ue}return-1}e.lastNonWhitespaceIndex=o;function r(ue,Ie){return ue<Ie?-1:ue>Ie?1:0}e.compare=r;function i(ue,Ie,Ue=0,Qe=ue.length,ze=0,at=Ie.length){for(;Ue<Qe&&ze<at;Ue++,ze++){let ke=ue.charCodeAt(Ue),ne=Ie.charCodeAt(ze);if(ke<ne)return-1;if(ke>ne)return 1}const Le=Qe-Ue,De=at-ze;return Le<De?-1:Le>De?1:0}e.compareSubstring=i;function h(ue,Ie){return c(ue,Ie,0,ue.length,0,Ie.length)}e.compareIgnoreCase=h;function c(ue,Ie,Ue=0,Qe=ue.length,ze=0,at=Ie.length){for(;Ue<Qe&&ze<at;Ue++,ze++){let ke=ue.charCodeAt(Ue),ne=Ie.charCodeAt(ze);if(ke===ne)continue;const de=ke-ne;if(!(de===32&&b(ne))&&!(de===-32&&b(ke)))return d(ke)&&d(ne)?de:i(ue.toLowerCase(),Ie.toLowerCase(),Ue,Qe,ze,at)}const Le=Qe-Ue,De=at-ze;return Le<De?-1:Le>De?1:0}e.compareSubstringIgnoreCase=c;function d(ue){return ue>=97&&ue<=122}e.isLowerAsciiLetter=d;function b(ue){return ue>=65&&ue<=90}e.isUpperAsciiLetter=b;function y(ue){return d(ue)||b(ue)}function g(ue,Ie){return ue.length===Ie.length&&_(ue,Ie)}e.equalsIgnoreCase=g;function _(ue,Ie,Ue=ue.length){for(let Qe=0;Qe<Ue;Qe++){const ze=ue.charCodeAt(Qe),at=Ie.charCodeAt(Qe);if(ze!==at){if(y(ze)&&y(at)){const Le=Math.abs(ze-at);if(Le!==0&&Le!==32)return!1}else if(String.fromCharCode(ze).toLowerCase()!==String.fromCharCode(at).toLowerCase())return!1}}return!0}function w(ue,Ie){const Ue=Ie.length;return Ie.length>ue.length?!1:_(ue,Ie,Ue)}e.startsWithIgnoreCase=w;function F(ue,Ie){let Ue,Qe=Math.min(ue.length,Ie.length);for(Ue=0;Ue<Qe;Ue++)if(ue.charCodeAt(Ue)!==Ie.charCodeAt(Ue))return Ue;return Qe}e.commonPrefixLength=F;function N(ue,Ie){let Ue,Qe=Math.min(ue.length,Ie.length);const ze=ue.length-1,at=Ie.length-1;for(Ue=0;Ue<Qe;Ue++)if(ue.charCodeAt(ze-Ue)!==Ie.charCodeAt(at-Ue))return Ue;return Qe}e.commonSuffixLength=N;function G(ue){return 55296<=ue&&ue<=56319}e.isHighSurrogate=G;function K(ue){return 56320<=ue&&ue<=57343}e.isLowSurrogate=K;function U(ue,Ie){return(ue-55296<<10)+(Ie-56320)+65536}e.computeCodePoint=U;function z(ue,Ie,Ue){const Qe=ue.charCodeAt(Ue);if(G(Qe)&&Ue+1<Ie){const ze=ue.charCodeAt(Ue+1);if(K(ze))return U(Qe,ze)}return Qe}e.getNextCodePoint=z;function O(ue,Ie){const Ue=ue.charCodeAt(Ie-1);if(K(Ue)&&Ie>1){const Qe=ue.charCodeAt(Ie-2);if(G(Qe))return U(Qe,Ue)}return Ue}function B(ue,Ie){const Ue=xe.getInstance(),Qe=Ie,ze=ue.length,at=z(ue,ze,Ie);Ie+=at>=65536?2:1;let Le=Ue.getGraphemeBreakType(at);for(;Ie<ze;){const De=z(ue,ze,Ie),ke=Ue.getGraphemeBreakType(De);if(te(Le,ke))break;Ie+=De>=65536?2:1,Le=ke}return Ie-Qe}e.nextCharLength=B;function x(ue,Ie){const Ue=xe.getInstance(),Qe=Ie,ze=O(ue,Ie);Ie-=ze>=65536?2:1;let at=Ue.getGraphemeBreakType(ze);for(;Ie>0;){const Le=O(ue,Ie),De=Ue.getGraphemeBreakType(Le);if(te(De,at))break;Ie-=Le>=65536?2:1,at=De}return Qe-Ie}e.prevCharLength=x;function M(ue,Ie){const Ue=xe.getInstance(),Qe=ue.length,ze=Ie,at=z(ue,Qe,Ie),Le=Ue.getGraphemeBreakType(at);Ie+=at>=65536?2:1;let De=Le;for(;Ie<Qe;){const ne=z(ue,Qe,Ie),de=Ue.getGraphemeBreakType(ne);if(te(De,de))break;Ie+=ne>=65536?2:1,De=de}const ke=Ie;for(Ie=ze,De=Le;Ie>0;){const ne=O(ue,Ie),de=Ue.getGraphemeBreakType(ne);if(te(de,De))break;Ie-=ne>=65536?2:1,De=de}return[Ie,ke]}function H(ue,Ie){return Ie>0&&K(ue.charCodeAt(Ie))?M(ue,Ie-1):M(ue,Ie)}e.getCharContainingOffset=H;const W=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Q(ue){return W.test(ue)}e.containsRTL=Q;const X=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function he(ue){return X.test(ue)}e.containsEmoji=he;const _e=/^[\t\n\r\x20-\x7E]*$/;function ye(ue){return _e.test(ue)}e.isBasicASCII=ye,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Re(ue){return e.UNUSUAL_LINE_TERMINATORS.test(ue)}e.containsUnusualLineTerminators=Re;function $e(ue){for(let Ie=0,Ue=ue.length;Ie<Ue;Ie++)if(Be(ue.charCodeAt(Ie)))return!0;return!1}e.containsFullWidthCharacter=$e;function Be(ue){return ue=+ue,ue>=11904&&ue<=55215||ue>=63744&&ue<=64255||ue>=65281&&ue<=65374}e.isFullWidthCharacter=Be;function je(ue){return ue>=127462&&ue<=127487||ue===8986||ue===8987||ue===9200||ue===9203||ue>=9728&&ue<=10175||ue===11088||ue===11093||ue>=127744&&ue<=128591||ue>=128640&&ue<=128764||ue>=128992&&ue<=129003||ue>=129280&&ue<=129535||ue>=129648&&ue<=129750}e.isEmojiImprecise=je;function V(ue,Ie){if(ue.length<Ie)return ue;const Ue=/\b/g;let Qe=0;for(;Ue.test(ue)&&!(ue.length-Ue.lastIndex<Ie);)Qe=Ue.lastIndex,Ue.lastIndex+=1;return ue.substring(Qe).replace(/^\s/,"")}e.lcut=V;const ee=/\x1B\x5B[12]?K/g,re=/\x1b\[\d+m/g,ae=/\x1b\[0?m/g;function Y(ue){return ue&&(ue=ue.replace(ee,""),ue=ue.replace(re,""),ue=ue.replace(ae,"")),ue}e.removeAnsiEscapeCodes=Y,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function oe(ue){return!!(ue&&ue.length>0&&ue.charCodeAt(0)===65279)}e.startsWithUTF8BOM=oe;function ve(ue){return oe(ue)?ue.substr(1):ue}e.stripUTF8BOM=ve;function Me(ue,Ie){if(!ue||!Ie||ue.length<Ie.length)return!1;const Ue=Ie.length,Qe=ue.toLowerCase();let ze=0,at=-1;for(;ze<Ue;){const Le=Qe.indexOf(Ie[ze],at+1);if(Le<0)return!1;at=Le,ze++}return!0}e.fuzzyContains=Me;function qe(ue,Ie=!1){return ue?(Ie&&(ue=ue.replace(/\\./g,"")),ue.toLowerCase()!==ue):!1}e.containsUppercaseCharacter=qe;function Ke(ue){return ue.charAt(0).toUpperCase()+ue.slice(1)}e.uppercaseFirstLetter=Ke;function Se(ue,Ie=1){if(Ie===0)return"";let Ue=-1;do Ue=ue.indexOf(`
`,Ue+1),Ie--;while(Ie>0&&Ue>=0);return Ue===-1?ue:(ue[Ue-1]==="\r"&&Ue--,ue.substr(0,Ue))}e.getNLines=Se;function tt(ue){const Ie=90-65+1;return ue=ue%(2*Ie),ue<Ie?String.fromCharCode(97+ue):String.fromCharCode(65+ue-Ie)}e.singleLetterHash=tt;function Z(ue){return xe.getInstance().getGraphemeBreakType(ue)}e.getGraphemeBreakType=Z;function te(ue,Ie){return ue===0?Ie!==5&&Ie!==7:ue===2&&Ie===3?!1:ue===4||ue===2||ue===3||Ie===4||Ie===2||Ie===3?!0:!(ue===8&&(Ie===8||Ie===9||Ie===11||Ie===12)||(ue===11||ue===9)&&(Ie===9||Ie===10)||(ue===12||ue===10)&&Ie===10||Ie===5||Ie===13||Ie===7||ue===1||ue===13&&Ie===14||ue===6&&Ie===6)}e.breakBetweenGraphemeBreakType=te;var pe;(function(ue){ue[ue.Other=0]="Other",ue[ue.Prepend=1]="Prepend",ue[ue.CR=2]="CR",ue[ue.LF=3]="LF",ue[ue.Control=4]="Control",ue[ue.Extend=5]="Extend",ue[ue.Regional_Indicator=6]="Regional_Indicator",ue[ue.SpacingMark=7]="SpacingMark",ue[ue.L=8]="L",ue[ue.V=9]="V",ue[ue.T=10]="T",ue[ue.LV=11]="LV",ue[ue.LVT=12]="LVT",ue[ue.ZWJ=13]="ZWJ",ue[ue.Extended_Pictographic=14]="Extended_Pictographic"})(pe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class xe{constructor(){this._data=Je()}static getInstance(){return xe._INSTANCE||(xe._INSTANCE=new xe),xe._INSTANCE}getGraphemeBreakType(Ie){if(Ie<32)return Ie===10?3:Ie===13?2:4;if(Ie<127)return 0;const Ue=this._data,Qe=Ue.length/3;let ze=1;for(;ze<=Qe;)if(Ie<Ue[3*ze])ze=2*ze;else if(Ie>Ue[3*ze+1])ze=2*ze+1;else return Ue[3*ze+2];return 0}}xe._INSTANCE=null;function Je(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function rt(ue,Ie){if(ue===0)return 0;const Ue=ft(ue,Ie);if(Ue!==void 0)return Ue;const Qe=O(Ie,ue);return ue-=pt(Qe),ue}e.getLeftDeleteOffset=rt;function ft(ue,Ie){let Ue=O(Ie,ue);for(ue-=pt(Ue);St(Ue)||Ue===65039||Ue===8419;){if(ue===0)return;Ue=O(Ie,ue),ue-=pt(Ue)}if(!!je(Ue)){if(ue>=0){const Qe=O(Ie,ue);Qe===8205&&(ue-=pt(Qe))}return ue}}function pt(ue){return ue>=65536?2:1}function St(ue){return 127995<=ue&&ue<=127999}var Ct;(function(ue){ue[ue.zwj=8205]="zwj",ue[ue.emojiVariantSelector=65039]="emojiVariantSelector",ue[ue.enclosingKeyCap=8419]="enclosingKeyCap"})(Ct||(Ct={}))}),define(me[48],ge([0,1,9]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function L(P){return I(P,0)}e.hash=L;function I(P,E){switch(typeof P){case"object":return P===null?k(349,E):Array.isArray(P)?D(P,E):T(P,E);case"string":return C(P,E);case"boolean":return R(P,E);case"number":return k(P,E);case"undefined":return k(937,E);default:return k(617,E)}}e.doHash=I;function k(P,E){return(E<<5)-E+P|0}function R(P,E){return k(P?433:863,E)}function C(P,E){E=k(149417,E);for(let s=0,a=P.length;s<a;s++)E=k(P.charCodeAt(s),E);return E}e.stringHash=C;function D(P,E){return E=k(104579,E),P.reduce((s,a)=>I(a,s),E)}function T(P,E){return E=k(181387,E),Object.keys(P).sort().reduce((s,a)=>(s=C(a,s),I(P[a],s)),E)}class n{constructor(){this._value=0}get value(){return this._value}hash(E){return this._value=I(E,this._value),this._value}}e.Hasher=n;var A;(function(P){P[P.BLOCK_SIZE=64]="BLOCK_SIZE",P[P.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(A||(A={}));function u(P,E,s=32){const a=s-E,p=~((1<<a)-1);return(P<<E|(p&P)>>>a)>>>0}function f(P,E=0,s=P.byteLength,a=0){for(let p=0;p<s;p++)P[E+p]=a}function l(P,E,s="0"){for(;P.length<E;)P=s+P;return P}function v(P,E=32){return P instanceof ArrayBuffer?Array.from(new Uint8Array(P)).map(s=>s.toString(16).padStart(2,"0")).join(""):l((P>>>0).toString(16),E/4)}e.toHexString=v;class S{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(E){const s=E.length;if(s===0)return;const a=this._buff;let p=this._buffLen,t=this._leftoverHighSurrogate,o,r;for(t!==0?(o=t,r=-1,t=0):(o=E.charCodeAt(0),r=0);;){let i=o;if(m.isHighSurrogate(o))if(r+1<s){const h=E.charCodeAt(r+1);m.isLowSurrogate(h)?(r++,i=m.computeCodePoint(o,h)):i=65533}else{t=o;break}else m.isLowSurrogate(o)&&(i=65533);if(p=this._push(a,p,i),r++,r<s)o=E.charCodeAt(r);else break}this._buffLen=p,this._leftoverHighSurrogate=t}_push(E,s,a){return a<128?E[s++]=a:a<2048?(E[s++]=192|(a&1984)>>>6,E[s++]=128|(a&63)>>>0):a<65536?(E[s++]=224|(a&61440)>>>12,E[s++]=128|(a&4032)>>>6,E[s++]=128|(a&63)>>>0):(E[s++]=240|(a&1835008)>>>18,E[s++]=128|(a&258048)>>>12,E[s++]=128|(a&4032)>>>6,E[s++]=128|(a&63)>>>0),s>=64&&(this._step(),s-=64,this._totalLen+=64,E[0]=E[64+0],E[1]=E[64+1],E[2]=E[64+2]),s}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),v(this._h0)+v(this._h1)+v(this._h2)+v(this._h3)+v(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,f(this._buff,this._buffLen),this._buffLen>56&&(this._step(),f(this._buff));const E=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(E/4294967296),!1),this._buffDV.setUint32(60,E%4294967296,!1),this._step()}_step(){const E=S._bigBlock32,s=this._buffDV;for(let d=0;d<64;d+=4)E.setUint32(d,s.getUint32(d,!1),!1);for(let d=64;d<320;d+=4)E.setUint32(d,u(E.getUint32(d-12,!1)^E.getUint32(d-32,!1)^E.getUint32(d-56,!1)^E.getUint32(d-64,!1),1),!1);let a=this._h0,p=this._h1,t=this._h2,o=this._h3,r=this._h4,i,h,c;for(let d=0;d<80;d++)d<20?(i=p&t|~p&o,h=1518500249):d<40?(i=p^t^o,h=1859775393):d<60?(i=p&t|p&o|t&o,h=2400959708):(i=p^t^o,h=3395469782),c=u(a,5)+i+r+h+E.getUint32(d*4,!1)&4294967295,r=o,o=t,t=u(p,30),p=a,a=c;this._h0=this._h0+a&4294967295,this._h1=this._h1+p&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=S,S._bigBlock32=new DataView(new ArrayBuffer(320))}),define(me[49],ge([0,1,9]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(L||(L={})),function(I){const k="error",R="warning",C="warn",D="info",T="ignore";function n(u){return u?m.equalsIgnoreCase(k,u)?I.Error:m.equalsIgnoreCase(R,u)||m.equalsIgnoreCase(C,u)?I.Warning:m.equalsIgnoreCase(D,u)?I.Info:I.Ignore:I.Ignore}I.fromValue=n;function A(u){switch(u){case I.Error:return k;case I.Warning:return R;case I.Info:return D;default:return T}}I.toString=A}(L||(L={})),e.default=L}),define(me[13],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function m(b){return Array.isArray(b)}e.isArray=m;function L(b){return typeof b=="string"}e.isString=L;function I(b){return Array.isArray(b)&&b.every(y=>L(y))}e.isStringArray=I;function k(b){return typeof b=="object"&&b!==null&&!Array.isArray(b)&&!(b instanceof RegExp)&&!(b instanceof Date)}e.isObject=k;function R(b){return typeof b=="number"&&!isNaN(b)}e.isNumber=R;function C(b){return!!b&&typeof b[Symbol.iterator]=="function"}e.isIterable=C;function D(b){return b===!0||b===!1}e.isBoolean=D;function T(b){return typeof b=="undefined"}e.isUndefined=T;function n(b){return!A(b)}e.isDefined=n;function A(b){return T(b)||b===null}e.isUndefinedOrNull=A;function u(b,y){if(!b)throw new Error(y?`Unexpected type, expected '${y}'`:"Unexpected type")}e.assertType=u;function f(b){if(A(b))throw new Error("Assertion Failed: argument is undefined or null");return b}e.assertIsDefined=f;function l(...b){const y=[];for(let g=0;g<b.length;g++){const _=b[g];if(A(_))throw new Error(`Assertion Failed: argument at index ${g} is undefined or null`);y.push(_)}return y}e.assertAllDefined=l;const v=Object.prototype.hasOwnProperty;function S(b){if(!k(b))return!1;for(let y in b)if(v.call(b,y))return!1;return!0}e.isEmptyObject=S;function P(b){return typeof b=="function"}e.isFunction=P;function E(...b){return b.length>0&&b.every(P)}e.areFunctions=E;function s(b,y){const g=Math.min(b.length,y.length);for(let _=0;_<g;_++)a(b[_],y[_])}e.validateConstraints=s;function a(b,y){if(L(y)){if(typeof b!==y)throw new Error(`argument does not match constraint: typeof ${y}`)}else if(P(y)){try{if(b instanceof y)return}catch{}if(!A(b)&&b.constructor===y||y.length===1&&y.call(void 0,b)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=a;function p(b){let y=[],g=Object.getPrototypeOf(b);for(;Object.prototype!==g;)y=y.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return y}e.getAllPropertyNames=p;function t(b){const y=[];for(const g of p(b))typeof b[g]=="function"&&y.push(g);return y}e.getAllMethodNames=t;function o(b,y){const g=w=>function(){const F=Array.prototype.slice.call(arguments,0);return y(w,F)};let _={};for(const w of b)_[w]=g(w);return _}e.createProxyObject=o;function r(b){return b===null?void 0:b}e.withNullAsUndefined=r;function i(b){return typeof b=="undefined"?null:b}e.withUndefinedAsNull=i;function h(b){return class{constructor(){return new Proxy({},{get(y,g){if(y[g])return y[g];throw new Error(`Not Implemented: ${b}->${String(g)}`)}})}}}e.NotImplementedProxy=h;function c(b,y="Unreachable"){throw new Error(y)}e.assertNever=c;function d(b){return!!b&&typeof b.then=="function"&&typeof b.catch=="function"}e.isPromise=d}),define(me[29],ge([0,1,8,11,9,13]),function(J,e,m,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function R(r){return r===47||r===92}e.isPathSeparator=R;function C(r){return r.replace(/[\\/]/g,m.posix.sep)}e.toSlashes=C;function D(r){return r.indexOf("/")===-1&&(r=C(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=D;function T(r,i=m.posix.sep){if(!r)return"";const h=r.length,c=r.charCodeAt(0);if(R(c)){if(R(r.charCodeAt(1))&&!R(r.charCodeAt(2))){let b=3;const y=b;for(;b<h&&!R(r.charCodeAt(b));b++);if(y!==b&&!R(r.charCodeAt(b+1))){for(b+=1;b<h;b++)if(R(r.charCodeAt(b)))return r.slice(0,b+1).replace(/[\\/]/g,i)}}return i}else if(P(c)&&r.charCodeAt(1)===58)return R(r.charCodeAt(2))?r.slice(0,2)+i:r.slice(0,2);let d=r.indexOf("://");if(d!==-1){for(d+=3;d<h;d++)if(R(r.charCodeAt(d)))return r.slice(0,d+1)}return""}e.getRoot=T;function n(r){if(!L.isWindows||!r||r.length<5)return!1;let i=r.charCodeAt(0);if(i!==92||(i=r.charCodeAt(1),i!==92))return!1;let h=2;const c=h;for(;h<r.length&&(i=r.charCodeAt(h),i!==92);h++);return!(c===h||(i=r.charCodeAt(h+1),isNaN(i)||i===92))}e.isUNC=n;const A=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function l(r,i=L.isWindows){const h=i?A:u;return!(!r||r.length===0||/^\s+$/.test(r)||(h.lastIndex=0,h.test(r))||i&&f.test(r)||r==="."||r===".."||i&&r[r.length-1]==="."||i&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=l;function v(r,i,h){const c=r===i;return!h||c?c:!r||!i?!1:(0,I.equalsIgnoreCase)(r,i)}e.isEqual=v;function S(r,i,h,c=m.sep){if(r===i)return!0;if(!r||!i||i.length>r.length)return!1;if(h){if(!(0,I.startsWithIgnoreCase)(r,i))return!1;if(i.length===r.length)return!0;let b=i.length;return i.charAt(i.length-1)===c&&b--,r.charAt(b)===c}return i.charAt(i.length-1)!==c&&(i+=c),r.indexOf(i)===0}e.isEqualOrParent=S;function P(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=P;function E(r,i){return L.isWindows&&r.endsWith(":")&&(r+=m.sep),(0,m.isAbsolute)(r)||(r=(0,m.join)(i,r)),r=(0,m.normalize)(r),L.isWindows?(r=(0,I.rtrim)(r,m.sep),r.endsWith(":")&&(r+=m.sep)):(r=(0,I.rtrim)(r,m.sep),r||(r=m.sep)),r}e.sanitizeFilePath=E;function s(r){const i=(0,m.normalize)(r);return L.isWindows?r.length>3?!1:a(i)&&(r.length===2||i.charCodeAt(2)===92):i===m.posix.sep}e.isRootOrDriveLetter=s;function a(r){return L.isWindows?P(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function p(r){return a(r)?r[0]:void 0}e.getDriveLetter=p;function t(r,i,h){return i.length>r.length?-1:r===i?0:(h&&(r=r.toLowerCase(),i=i.toLowerCase()),r.indexOf(i))}e.indexOfPath=t;function o(r){const i=r.split(":");let h,c,d;if(i.forEach(b=>{const y=Number(b);(0,k.isNumber)(y)?c===void 0?c=y:d===void 0&&(d=y):h=h?[h,b].join(":"):b}),!h)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:h,line:c!==void 0?c:void 0,column:d!==void 0?d:c!==void 0?1:void 0}}e.parseLineAndColumnAware=o}),define(me[25],ge([0,1,13]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(v){if(!v||typeof v!="object"||v instanceof RegExp)return v;const S=Array.isArray(v)?[]:{};return Object.keys(v).forEach(P=>{v[P]&&typeof v[P]=="object"?S[P]=L(v[P]):S[P]=v[P]}),S}e.deepClone=L;function I(v){if(!v||typeof v!="object")return v;const S=[v];for(;S.length>0;){const P=S.shift();Object.freeze(P);for(const E in P)if(k.call(P,E)){const s=P[E];typeof s=="object"&&!Object.isFrozen(s)&&S.push(s)}}return v}e.deepFreeze=I;const k=Object.prototype.hasOwnProperty;function R(v,S){return C(v,S,new Set)}e.cloneAndChange=R;function C(v,S,P){if((0,m.isUndefinedOrNull)(v))return v;const E=S(v);if(typeof E!="undefined")return E;if((0,m.isArray)(v)){const s=[];for(const a of v)s.push(C(a,S,P));return s}if((0,m.isObject)(v)){if(P.has(v))throw new Error("Cannot clone recursive data-structure");P.add(v);const s={};for(let a in v)k.call(v,a)&&(s[a]=C(v[a],S,P));return P.delete(v),s}return v}function D(v,S,P=!0){return(0,m.isObject)(v)?((0,m.isObject)(S)&&Object.keys(S).forEach(E=>{E in v?P&&((0,m.isObject)(v[E])&&(0,m.isObject)(S[E])?D(v[E],S[E],P):v[E]=S[E]):v[E]=S[E]}),v):S}e.mixin=D;function T(v,S){if(v===S)return!0;if(v==null||S===null||S===void 0||typeof v!=typeof S||typeof v!="object"||Array.isArray(v)!==Array.isArray(S))return!1;let P,E;if(Array.isArray(v)){if(v.length!==S.length)return!1;for(P=0;P<v.length;P++)if(!T(v[P],S[P]))return!1}else{const s=[];for(E in v)s.push(E);s.sort();const a=[];for(E in S)a.push(E);if(a.sort(),!T(s,a))return!1;for(P=0;P<s.length;P++)if(!T(v[s[P]],S[s[P]]))return!1}return!0}e.equals=T;function n(v){const S=new Set;return JSON.stringify(v,(P,E)=>{if((0,m.isObject)(E)||Array.isArray(E)){if(S.has(E))return"[Circular]";S.add(E)}return E})}e.safeStringify=n;function A(v,S,P){const E=S(v);return typeof E=="undefined"?P:E}e.getOrDefault=A;function u(v,S){const P=Object.create(null);return!v||!S||Object.keys(S).forEach(s=>{const a=v[s],p=S[s];T(a,p)||(P[s]=p)}),P}e.distinct=u;function f(v,S){const P=S.toLowerCase(),E=Object.keys(v).find(s=>s.toLowerCase()===P);return E?v[E]:v[S]}e.getCaseInsensitive=f;function l(v,S){const P=Object.create(null);for(const E of Object.keys(v))S(E,v[E])&&(P[E]=v[E]);return P}e.filter=l}),define(me[97],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var m;(function(k){k[k.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",k[k.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",k[k.MAX_UINT_8=255]="MAX_UINT_8",k[k.MAX_UINT_16=65535]="MAX_UINT_16",k[k.MAX_UINT_32=4294967295]="MAX_UINT_32",k[k.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(m=e.Constants||(e.Constants={}));function L(k){return k<0?0:k>255?255:k|0}e.toUint8=L;function I(k){return k<0?0:k>4294967295?4294967295:k|0}e.toUint32=I}),define(me[2],ge([0,1,8,11]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const I=/^\w[\w\d+.-]*$/,k=/^\//,R=/^\/\//;function C(r,i){if(!r.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!I.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!k.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function D(r,i){return!r&&!i?"file":r}function T(r,i){switch(r){case"https":case"http":case"file":i?i[0]!==A&&(i=A+i):i=A;break}return i}const n="",A="/",u=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{constructor(i,h,c,d,b,y=!1){typeof i=="object"?(this.scheme=i.scheme||n,this.authority=i.authority||n,this.path=i.path||n,this.query=i.query||n,this.fragment=i.fragment||n):(this.scheme=D(i,y),this.authority=h||n,this.path=T(this.scheme,c||n),this.query=d||n,this.fragment=b||n,C(this,y))}static isUri(i){return i instanceof f?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return s(this,!1)}with(i){if(!i)return this;let{scheme:h,authority:c,path:d,query:b,fragment:y}=i;return h===void 0?h=this.scheme:h===null&&(h=n),c===void 0?c=this.authority:c===null&&(c=n),d===void 0?d=this.path:d===null&&(d=n),b===void 0?b=this.query:b===null&&(b=n),y===void 0?y=this.fragment:y===null&&(y=n),h===this.scheme&&c===this.authority&&d===this.path&&b===this.query&&y===this.fragment?this:new v(h,c,d,b,y)}static parse(i,h=!1){const c=u.exec(i);return c?new v(c[2]||n,o(c[4]||n),o(c[5]||n),o(c[7]||n),o(c[9]||n),h):new v(n,n,n,n,n)}static file(i){let h=n;if(L.isWindows&&(i=i.replace(/\\/g,A)),i[0]===A&&i[1]===A){const c=i.indexOf(A,2);c===-1?(h=i.substring(2),i=A):(h=i.substring(2,c),i=i.substring(c)||A)}return new v("file",h,i,n,n)}static from(i){const h=new v(i.scheme,i.authority,i.path,i.query,i.fragment);return C(h,!0),h}static joinPath(i,...h){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return L.isWindows&&i.scheme==="file"?c=f.file(m.win32.join(s(i,!0),...h)).path:c=m.posix.join(i.path,...h),i.with({path:c})}toString(i=!1){return a(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof f)return i;{const h=new v(i);return h._formatted=i.external,h._fsPath=i._sep===l?i.fsPath:null,h}}else return i}}e.URI=f;const l=L.isWindows?1:void 0;class v extends f{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=s(this,!1)),this._fsPath}toString(i=!1){return i?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=l),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const S={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function P(r,i){let h,c=-1;for(let d=0;d<r.length;d++){const b=r.charCodeAt(d);if(b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57||b===45||b===46||b===95||b===126||i&&b===47)c!==-1&&(h+=encodeURIComponent(r.substring(c,d)),c=-1),h!==void 0&&(h+=r.charAt(d));else{h===void 0&&(h=r.substr(0,d));const y=S[b];y!==void 0?(c!==-1&&(h+=encodeURIComponent(r.substring(c,d)),c=-1),h+=y):c===-1&&(c=d)}}return c!==-1&&(h+=encodeURIComponent(r.substring(c))),h!==void 0?h:r}function E(r){let i;for(let h=0;h<r.length;h++){const c=r.charCodeAt(h);c===35||c===63?(i===void 0&&(i=r.substr(0,h)),i+=S[c]):i!==void 0&&(i+=r[h])}return i!==void 0?i:r}function s(r,i){let h;return r.authority&&r.path.length>1&&r.scheme==="file"?h=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?i?h=r.path.substr(1):h=r.path[1].toLowerCase()+r.path.substr(2):h=r.path,L.isWindows&&(h=h.replace(/\//g,"\\")),h}e.uriToFsPath=s;function a(r,i){const h=i?E:P;let c="",{scheme:d,authority:b,path:y,query:g,fragment:_}=r;if(d&&(c+=d,c+=":"),(b||d==="file")&&(c+=A,c+=A),b){let w=b.indexOf("@");if(w!==-1){const F=b.substr(0,w);b=b.substr(w+1),w=F.indexOf(":"),w===-1?c+=h(F,!1):(c+=h(F.substr(0,w),!1),c+=":",c+=h(F.substr(w+1),!1)),c+="@"}b=b.toLowerCase(),w=b.indexOf(":"),w===-1?c+=h(b,!1):(c+=h(b.substr(0,w),!1),c+=b.substr(w))}if(y){if(y.length>=3&&y.charCodeAt(0)===47&&y.charCodeAt(2)===58){const w=y.charCodeAt(1);w>=65&&w<=90&&(y=`/${String.fromCharCode(w+32)}:${y.substr(3)}`)}else if(y.length>=2&&y.charCodeAt(1)===58){const w=y.charCodeAt(0);w>=65&&w<=90&&(y=`${String.fromCharCode(w+32)}:${y.substr(2)}`)}c+=h(y,!0)}return g&&(c+="?",c+=h(g,!1)),_&&(c+="#",c+=i?_:P(_,!1)),c}function p(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+p(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(r){return r.match(t)?r.replace(t,i=>p(i)):r}});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(J,m):I?I.value=m:e.set(J,m),m},Oe=this&&this.__classPrivateFieldGet||function(J,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(J):L?L.value:e.get(J)};define(me[24],ge([0,1,17,9,2]),function(J,e,m,L,I){"use strict";var k,R,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function D(o,r,i){let h=o.get(r);return h===void 0&&(h=i,o.set(r,h)),h}e.getOrSet=D;function T(o){const r=[];return o.forEach((i,h)=>{r.push(`${h} => ${i}`)}),`Map(${o.size}) {${r.join(", ")}}`}e.mapToString=T;function n(o){const r=[];return o.forEach(i=>{r.push(i)}),`Set(${o.size}) {${r.join(", ")}}`}e.setToString=n;class A{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const i=r.charCodeAt(0),h=this._value.charCodeAt(this._pos);return i-h}value(){return this._value[this._pos]}}e.StringIterator=A;class u{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=u;class f{constructor(r=!0,i=!0){this._splitOnBackslash=r,this._caseSensitive=i}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const i=this._value.charCodeAt(this._to);if(i===47||this._splitOnBackslash&&i===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=f;var l;(function(o){o[o.Scheme=1]="Scheme",o[o.Authority=2]="Authority",o[o.Path=3]="Path",o[o.Query=4]="Query",o[o.Fragment=5]="Fragment"})(l||(l={}));class v{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new f(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,L.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=v;class S{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class P{constructor(r){this._iter=r}static forUris(r=()=>!1){return new P(new v(r))}static forPaths(){return new P(new f)}static forStrings(){return new P(new A)}static forConfigKeys(){return new P(new u)}clear(){this._root=void 0}set(r,i){const h=this._iter.reset(r);let c;for(this._root||(this._root=new S,this._root.segment=h.value()),c=this._root;;){const b=h.cmp(c.segment);if(b>0)c.left||(c.left=new S,c.left.segment=h.value()),c=c.left;else if(b<0)c.right||(c.right=new S,c.right.segment=h.value()),c=c.right;else if(h.hasNext())h.next(),c.mid||(c.mid=new S,c.mid.segment=h.value()),c=c.mid;else break}const d=c.value;return c.value=i,c.key=r,d}fill(r,i){const h=i.slice(0);(0,m.shuffle)(h);for(let c of h)this.set(c,r)}get(r){return this._getNode(r)?.value}_getNode(r){const i=this._iter.reset(r);let h=this._root;for(;h;){const c=i.cmp(h.segment);if(c>0)h=h.left;else if(c<0)h=h.right;else if(i.hasNext())i.next(),h=h.mid;else break}return h}has(r){const i=this._getNode(r);return!(i?.value===void 0&&i?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,i){const h=this._iter.reset(r),c=[];let d=this._root;for(;d;){const b=h.cmp(d.segment);if(b>0)c.push([1,d]),d=d.left;else if(b<0)c.push([-1,d]),d=d.right;else if(h.hasNext())h.next(),c.push([0,d]),d=d.mid;else{for(i?(d.left=void 0,d.mid=void 0,d.right=void 0):d.value=void 0;c.length>0&&d.isEmpty();){let[y,g]=c.pop();switch(y){case 1:g.left=void 0;break;case 0:g.mid=void 0;break;case-1:g.right=void 0;break}d=g}break}}}findSubstr(r){const i=this._iter.reset(r);let h=this._root,c;for(;h;){const d=i.cmp(h.segment);if(d>0)h=h.left;else if(d<0)h=h.right;else if(i.hasNext())i.next(),c=h.value||c,h=h.mid;else break}return h&&h.value||c}findSuperstr(r){const i=this._iter.reset(r);let h=this._root;for(;h;){const c=i.cmp(h.segment);if(c>0)h=h.left;else if(c<0)h=h.right;else if(i.hasNext())i.next(),h=h.mid;else return h.mid?this._entries(h.mid):void 0}}forEach(r){for(const[i,h]of this)r(h,i)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const i=[r];for(;i.length>0;){const h=i.pop();h&&(h.value&&(yield[h.key,h.value]),h.left&&i.push(h.left),h.mid&&i.push(h.mid),h.right&&i.push(h.right))}}}e.TernarySearchTree=P;class E{constructor(r,i){this[k]="ResourceMap",r instanceof E?(this.map=new Map(r.map),this.toKey=i??E.defaultToKey):(this.map=new Map,this.toKey=r??E.defaultToKey)}set(r,i){return this.map.set(this.toKey(r),i),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,i){typeof i!="undefined"&&(r=r.bind(i));for(let[h,c]of this.map)r(c,I.URI.parse(h),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield I.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[I.URI.parse(r[0]),r[1]]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[I.URI.parse(r[0]),r[1]]}}e.ResourceMap=E,E.defaultToKey=o=>o.toString();var s;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(s=e.Touch||(e.Touch={}));class a{constructor(){this[R]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,i=0){const h=this._map.get(r);if(!!h)return i!==0&&this.touch(h,i),h.value}set(r,i,h=0){let c=this._map.get(r);if(c)c.value=i,h!==0&&this.touch(c,h);else{switch(c={key:r,value:i,next:void 0,previous:void 0},h){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(r,c),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const i=this._map.get(r);if(!!i)return this._map.delete(r),this.removeItem(i),this._size--,i.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,i){const h=this._state;let c=this._head;for(;c;){if(i?r.bind(i)(c.value,c.key,this):r(c.value,c.key,this),this._state!==h)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const r=this,i=this._state;let h=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(h){const d={value:h.key,done:!1};return h=h.next,d}else return{value:void 0,done:!0}}};return c}values(){const r=this,i=this._state;let h=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(h){const d={value:h.value,done:!1};return h=h.next,d}else return{value:void 0,done:!0}}};return c}entries(){const r=this,i=this._state;let h=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(h){const d={value:[h.key,h.value],done:!1};return h=h.next,d}else return{value:void 0,done:!0}}};return c}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let i=this._head,h=this.size;for(;i&&h>r;)this._map.delete(i.key),i=i.next,h--;this._head=i,this._size=h,i&&(i.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const i=r.next,h=r.previous;if(!i||!h)throw new Error("Invalid list");i.previous=h,h.next=i}r.next=void 0,r.previous=void 0,this._state++}touch(r,i){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(i!==1&&i!==2)){if(i===1){if(r===this._head)return;const h=r.next,c=r.previous;r===this._tail?(c.next=void 0,this._tail=c):(h.previous=c,c.next=h),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(i===2){if(r===this._tail)return;const h=r.next,c=r.previous;r===this._head?(h.previous=void 0,this._head=h):(h.previous=c,c.next=h),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((i,h)=>{r.push([h,i])}),r}fromJSON(r){this.clear();for(const[i,h]of r)this.set(i,h)}}e.LinkedMap=a;class p extends a{constructor(r,i=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,i),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,i=2){return super.get(r,i)}peek(r){return super.get(r,0)}set(r,i){return super.set(r,i,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=p;class t{constructor(r){C.set(this,void 0),nt(this,C,r,"f")}get size(){return Oe(this,C,"f").size}forEach(r,i){Oe(this,C,"f").forEach(r,i)}get(r){return Oe(this,C,"f").get(r)}has(r){return Oe(this,C,"f").has(r)}entries(){return Oe(this,C,"f").entries()}keys(){return Oe(this,C,"f").keys()}values(){return Oe(this,C,"f").values()}[(C=new WeakMap,Symbol.iterator)](){return Oe(this,C,"f").entries()}}e.ReadonlyMapView=t}),define(me[98],ge([0,1,24,9]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function I(...Y){return function(oe,ve){for(let Me=0,qe=Y.length;Me<qe;Me++){const Ke=Y[Me](oe,ve);if(Ke)return Ke}return null}}e.or=I,e.matchesStrictPrefix=k.bind(void 0,!1),e.matchesPrefix=k.bind(void 0,!0);function k(Y,oe,ve){if(!ve||ve.length<oe.length)return null;let Me;return Y?Me=L.startsWithIgnoreCase(ve,oe):Me=ve.indexOf(oe)===0,Me?oe.length>0?[{start:0,end:oe.length}]:[]:null}function R(Y,oe){const ve=oe.toLowerCase().indexOf(Y.toLowerCase());return ve===-1?null:[{start:ve,end:ve+Y.length}]}e.matchesContiguousSubString=R;function C(Y,oe){return D(Y.toLowerCase(),oe.toLowerCase(),0,0)}e.matchesSubString=C;function D(Y,oe,ve,Me){if(ve===Y.length)return[];if(Me===oe.length)return null;if(Y[ve]===oe[Me]){let qe=null;return(qe=D(Y,oe,ve+1,Me+1))?P({start:Me,end:Me+1},qe):null}return D(Y,oe,ve,Me+1)}function T(Y){return 97<=Y&&Y<=122}function n(Y){return 65<=Y&&Y<=90}e.isUpper=n;function A(Y){return 48<=Y&&Y<=57}function u(Y){return Y===32||Y===9||Y===10||Y===13}const f=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(Y=>f.add(Y.charCodeAt(0)));function l(Y){return u(Y)||f.has(Y)}function v(Y,oe){return Y===oe||l(Y)&&l(oe)}function S(Y){return T(Y)||n(Y)||A(Y)}function P(Y,oe){return oe.length===0?oe=[Y]:Y.end===oe[0].start?oe[0].start=Y.start:oe.unshift(Y),oe}function E(Y,oe){for(let ve=oe;ve<Y.length;ve++){const Me=Y.charCodeAt(ve);if(n(Me)||A(Me)||ve>0&&!S(Y.charCodeAt(ve-1)))return ve}return Y.length}function s(Y,oe,ve,Me){if(ve===Y.length)return[];if(Me===oe.length)return null;if(Y[ve]!==oe[Me].toLowerCase())return null;{let qe=null,Ke=Me+1;for(qe=s(Y,oe,ve+1,Me+1);!qe&&(Ke=E(oe,Ke))<oe.length;)qe=s(Y,oe,ve+1,Ke),Ke++;return qe===null?null:P({start:Me,end:Me+1},qe)}}function a(Y){let oe=0,ve=0,Me=0,qe=0,Ke=0;for(let pe=0;pe<Y.length;pe++)Ke=Y.charCodeAt(pe),n(Ke)&&oe++,T(Ke)&&ve++,S(Ke)&&Me++,A(Ke)&&qe++;const Se=oe/Y.length,tt=ve/Y.length,Z=Me/Y.length,te=qe/Y.length;return{upperPercent:Se,lowerPercent:tt,alphaPercent:Z,numericPercent:te}}function p(Y){const{upperPercent:oe,lowerPercent:ve}=Y;return ve===0&&oe>.6}function t(Y){const{upperPercent:oe,lowerPercent:ve,alphaPercent:Me,numericPercent:qe}=Y;return ve>.2&&oe<.8&&Me>.6&&qe<.2}function o(Y){let oe=0,ve=0,Me=0,qe=0;for(let Ke=0;Ke<Y.length;Ke++)Me=Y.charCodeAt(Ke),n(Me)&&oe++,T(Me)&&ve++,u(Me)&&qe++;return(oe===0||ve===0)&&qe===0?Y.length<=30:oe<=5}function r(Y,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!o(Y)||oe.length>60)return null;const ve=a(oe);if(!t(ve)){if(!p(ve))return null;oe=oe.toLowerCase()}let Me=null,qe=0;for(Y=Y.toLowerCase();qe<oe.length&&(Me=s(Y,oe,0,qe))===null;)qe=E(oe,qe+1);return Me}e.matchesCamelCase=r;function i(Y,oe,ve=!1){if(!oe||oe.length===0)return null;let Me=null,qe=0;for(Y=Y.toLowerCase(),oe=oe.toLowerCase();qe<oe.length&&(Me=h(Y,oe,0,qe,ve))===null;)qe=c(oe,qe+1);return Me}e.matchesWords=i;function h(Y,oe,ve,Me,qe){if(ve===Y.length)return[];if(Me===oe.length)return null;if(v(Y.charCodeAt(ve),oe.charCodeAt(Me))){let Ke=null,Se=Me+1;if(Ke=h(Y,oe,ve+1,Me+1,qe),!qe)for(;!Ke&&(Se=c(oe,Se))<oe.length;)Ke=h(Y,oe,ve+1,Se,qe),Se++;return Ke===null?null:P({start:Me,end:Me+1},Ke)}else return null}function c(Y,oe){for(let ve=oe;ve<Y.length;ve++)if(l(Y.charCodeAt(ve))||ve>0&&l(Y.charCodeAt(ve-1)))return ve;return Y.length}const d=I(e.matchesPrefix,r,R),b=I(e.matchesPrefix,r,C),y=new m.LRUCache(1e4);function g(Y,oe,ve=!1){if(typeof Y!="string"||typeof oe!="string")return null;let Me=y.get(Y);Me||(Me=new RegExp(L.convertSimple2RegExpPattern(Y),"i"),y.set(Y,Me));const qe=Me.exec(oe);return qe?[{start:qe.index,end:qe.index+qe[0].length}]:ve?b(Y,oe):d(Y,oe)}e.matchesFuzzy=g;function _(Y,oe){const ve=$e(Y,Y.toLowerCase(),0,oe,oe.toLowerCase(),0,!0);return ve?F(ve):null}e.matchesFuzzy2=_;function w(Y,oe,ve,Me,qe,Ke){const Se=Math.min(13,Y.length);for(;ve<Se;ve++){const tt=$e(Y,oe,ve,Me,qe,Ke,!1);if(tt)return tt}return[0,Ke]}e.anyScore=w;function F(Y){if(typeof Y=="undefined")return[];const oe=[],ve=Y[1];for(let Me=Y.length-1;Me>1;Me--){const qe=Y[Me]+ve,Ke=oe[oe.length-1];Ke&&Ke.end===qe?Ke.end=qe+1:oe.push({start:qe,end:qe+1})}return oe}e.createMatches=F;const N=128;function G(){const Y=[],oe=[];for(let ve=0;ve<=N;ve++)oe[ve]=0;for(let ve=0;ve<=N;ve++)Y.push(oe.slice(0));return Y}function K(Y){const oe=[];for(let ve=0;ve<=Y;ve++)oe[ve]=0;return oe}const U=K(2*N),z=K(2*N),O=G(),B=G(),x=G(),M=!1;function H(Y,oe,ve,Me,qe){function Ke(tt,Z,te=" "){for(;tt.length<Z;)tt=te+tt;return tt}let Se=` |   |${Me.split("").map(tt=>Ke(tt,3)).join("|")}
`;for(let tt=0;tt<=ve;tt++)tt===0?Se+=" |":Se+=`${oe[tt-1]}|`,Se+=Y[tt].slice(0,qe+1).map(Z=>Ke(Z.toString(),3)).join("|")+`
`;return Se}function W(Y,oe,ve,Me){Y=Y.substr(oe),ve=ve.substr(Me),console.log(H(B,Y,Y.length,ve,ve.length)),console.log(H(x,Y,Y.length,ve,ve.length)),console.log(H(O,Y,Y.length,ve,ve.length))}function Q(Y,oe){if(oe<0||oe>=Y.length)return!1;const ve=Y.codePointAt(oe);switch(ve){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!L.isEmojiImprecise(ve)}}function X(Y,oe){if(oe<0||oe>=Y.length)return!1;switch(Y.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function he(Y,oe,ve){return oe[Y]!==ve[Y]}function _e(Y,oe,ve,Me,qe,Ke,Se=!1){for(;oe<ve&&qe<Ke;)Y[oe]===Me[qe]&&(Se&&(U[oe]=qe),oe+=1),qe+=1;return oe===ve}e.isPatternInWord=_e;var ye;(function(Y){Y[Y.Diag=1]="Diag",Y[Y.Left=2]="Left",Y[Y.LeftLeft=3]="LeftLeft"})(ye||(ye={}));var Re;(function(Y){Y.Default=[-100,0];function oe(ve){return!ve||ve.length===2&&ve[0]===-100&&ve[1]===0}Y.isDefault=oe})(Re=e.FuzzyScore||(e.FuzzyScore={}));function $e(Y,oe,ve,Me,qe,Ke,Se){const tt=Y.length>N?N:Y.length,Z=Me.length>N?N:Me.length;if(ve>=tt||Ke>=Z||tt-ve>Z-Ke||!_e(oe,ve,tt,qe,Ke,Z,!0))return;Be(tt,Z,ve,Ke,oe,qe);let te=1,pe=1,xe=ve,Je=Ke;const rt=[!1];for(te=1,xe=ve;xe<tt;te++,xe++){const ue=U[xe],Ie=z[xe],Ue=xe+1<tt?z[xe+1]:Z;for(pe=ue-Ke+1,Je=ue;Je<Ue;pe++,Je++){let Qe=Number.MIN_SAFE_INTEGER,ze=!1;Je<=Ie&&(Qe=je(Y,oe,xe,ve,Me,qe,Je,Z,Ke,O[te-1][pe-1]===0,rt));let at=0;Qe!==Number.MAX_SAFE_INTEGER&&(ze=!0,at=Qe+B[te-1][pe-1]);const Le=Je>ue,De=Le?B[te][pe-1]+(O[te][pe-1]>0?-5:0):0,ke=Je>ue+1&&O[te][pe-1]>0,ne=ke?B[te][pe-2]+(O[te][pe-2]>0?-5:0):0;if(ke&&(!Le||ne>=De)&&(!ze||ne>=at))B[te][pe]=ne,x[te][pe]=3,O[te][pe]=0;else if(Le&&(!ze||De>=at))B[te][pe]=De,x[te][pe]=2,O[te][pe]=0;else if(ze)B[te][pe]=at,x[te][pe]=1,O[te][pe]=O[te-1][pe-1]+1;else throw new Error("not possible")}}if(M&&W(Y,ve,Me,Ke),!rt[0]&&!Se)return;te--,pe--;const ft=[B[te][pe],Ke];let pt=0,St=0;for(;te>=1;){let ue=pe;do{const Ie=x[te][ue];if(Ie===3)ue=ue-2;else if(Ie===2)ue=ue-1;else break}while(ue>=1);pt>1&&oe[ve+te-1]===qe[Ke+pe-1]&&!he(ue+Ke-1,Me,qe)&&pt+1>O[te][ue]&&(ue=pe),ue===pe?pt++:pt=1,St||(St=ue),te--,pe=ue-1,ft.push(pe)}Z===tt&&(ft[0]+=2);const Ct=St-tt;return ft[0]-=Ct,ft}e.fuzzyScore=$e;function Be(Y,oe,ve,Me,qe,Ke){let Se=Y-1,tt=oe-1;for(;Se>=ve&&tt>=Me;)qe[Se]===Ke[tt]&&(z[Se]=tt,Se--),tt--}function je(Y,oe,ve,Me,qe,Ke,Se,tt,Z,te,pe){if(oe[ve]!==Ke[Se])return Number.MIN_SAFE_INTEGER;let xe=1,Je=!1;return Se===ve-Me?xe=Y[ve]===qe[Se]?7:5:he(Se,qe,Ke)&&(Se===0||!he(Se-1,qe,Ke))?(xe=Y[ve]===qe[Se]?7:5,Je=!0):Q(Ke,Se)&&(Se===0||!Q(Ke,Se-1))?xe=5:(Q(Ke,Se-1)||X(Ke,Se-1))&&(xe=5,Je=!0),xe>1&&ve===Me&&(pe[0]=!0),Je||(Je=he(Se,qe,Ke)||Q(Ke,Se-1)||X(Ke,Se-1)),ve===Me?Se>Z&&(xe-=Je?3:5):te?xe+=Je?2:0:xe+=Je?0:1,Se+1===tt&&(xe-=Je?3:5),xe}function V(Y,oe,ve,Me,qe,Ke,Se){return re(Y,oe,ve,Me,qe,Ke,!0,Se)}e.fuzzyScoreGracefulAggressive=V;function ee(Y,oe,ve,Me,qe,Ke,Se){return re(Y,oe,ve,Me,qe,Ke,!1,Se)}e.fuzzyScoreGraceful=ee;function re(Y,oe,ve,Me,qe,Ke,Se,tt){let Z=$e(Y,oe,ve,Me,qe,Ke,tt);if(Z&&!Se)return Z;if(Y.length>=3){const te=Math.min(7,Y.length-1);for(let pe=ve+1;pe<te;pe++){const xe=ae(Y,pe);if(xe){const Je=$e(xe,xe.toLowerCase(),ve,Me,qe,Ke,tt);Je&&(Je[0]-=3,(!Z||Je[0]>Z[0])&&(Z=Je))}}}return Z}function ae(Y,oe){if(oe+1>=Y.length)return;const ve=Y[oe],Me=Y[oe+1];if(ve!==Me)return Y.slice(0,oe)+Me+ve+Y.slice(oe+2)}}),define(me[141],ge([0,1,47,98,9]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const k=new RegExp(`\\$\\(${m.CSSIcon.iconNameExpression}(?:${m.CSSIcon.iconModifierExpression})?\\)`,"g"),R=new RegExp(`(\\\\)?${k.source}`,"g");function C(v){return v.replace(R,(S,P)=>P?S:`\\${S}`)}e.escapeIcons=C;const D=new RegExp(`\\\\${k.source}`,"g");function T(v){return v.replace(D,S=>`\\${S}`)}e.markdownEscapeEscapedIcons=T;const n=new RegExp(`(\\s)?(\\\\)?${k.source}(\\s)?`,"g");function A(v){return v.indexOf(e.iconStartMarker)===-1?v:v.replace(n,(S,P,E,s)=>E?S:P||s||"")}e.stripIcons=A;function u(v){const S=v.indexOf(e.iconStartMarker);return S===-1?{text:v}:f(v,S)}e.parseLabelWithIcons=u;function f(v,S){const P=[];let E="";function s(c){if(c){E+=c;for(const d of c)P.push(t)}}let a=-1,p="",t=0,o,r,i=S;const h=v.length;for(s(v.substr(0,S));i<h;)o=v[i],r=v[i+1],o===e.iconStartMarker[0]&&r===e.iconStartMarker[1]?(a=i,s(p),p=e.iconStartMarker,i++):o===")"&&a!==-1?(t+=i-a+1,a=-1,p=""):a!==-1?/^[a-z0-9\-]$/i.test(o)?p+=o:(s(p),a=-1,p=""):s(o),i++;return s(p),{text:E,iconOffsets:P}}function l(v,S,P=!1){const{text:E,iconOffsets:s}=S;if(!s||s.length===0)return(0,L.matchesFuzzy)(v,E,P);const a=(0,I.ltrim)(E," "),p=E.length-a.length,t=(0,L.matchesFuzzy)(v,a,P);if(t)for(const o of t){const r=s[o.start+p]+p;o.start+=r,o.end+=r}return t}e.matchesFuzzyIconAware=l}),define(me[99],ge([0,1,16,141]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var I;(function(u){u[u.Paragraph=0]="Paragraph",u[u.Break=1]="Break"})(I=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class k{constructor(f="",l=!1){if(this.value=f,typeof this.value!="string")throw(0,m.illegalArgument)("value");typeof l=="boolean"?(this.isTrusted=l,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=l.isTrusted??void 0,this.supportThemeIcons=l.supportThemeIcons??!1,this.supportHtml=l.supportHtml??!1)}appendText(f,l=0){return this.value+=T(this.supportThemeIcons?(0,L.escapeIcons)(f):f).replace(/([ \t]+)/g,(v,S)=>"&nbsp;".repeat(S.length)).replace(/\>/gm,"\\>").replace(/\n/g,l===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,l){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=l,this.value+="\n```\n",this}}e.MarkdownString=k;function R(u){return C(u)?!u.value:Array.isArray(u)?u.every(R):!0}e.isEmptyMarkdownString=R;function C(u){return u instanceof k?!0:u&&typeof u=="object"?typeof u.value=="string"&&(typeof u.isTrusted=="boolean"||u.isTrusted===void 0)&&(typeof u.supportThemeIcons=="boolean"||u.supportThemeIcons===void 0):!1}e.isMarkdownString=C;function D(u,f){return u===f?!0:!u||!f?!1:u.value===f.value&&u.isTrusted===f.isTrusted&&u.supportThemeIcons===f.supportThemeIcons}e.markdownStringEqual=D;function T(u){return u.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=T;function n(u){return u&&u.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=n;function A(u){const f=[],l=u.split("|").map(S=>S.trim());u=l[0];const v=l[1];if(v){const S=/height=(\d+)/.exec(v),P=/width=(\d+)/.exec(v),E=S?S[1]:"",s=P?P[1]:"",a=isFinite(parseInt(s)),p=isFinite(parseInt(E));a&&f.push(`width="${s}"`),p&&f.push(`height="${E}"`)}return{href:u,dimensions:f}}e.parseHrefAndDimensions=A}),define(me[60],ge([0,1,23,9,2]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function k(n){return JSON.stringify(n,D)}e.stringify=k;function R(n){let A=JSON.parse(n);return A=T(A),A}e.parse=R;var C;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(C=e.MarshalledId||(e.MarshalledId={}));function D(n,A){return A instanceof RegExp?{$mid:2,source:A.source,flags:(0,L.regExpFlags)(A)}:A}function T(n,A=0){if(!n||A>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return I.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof m.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let u=0;u<n.length;++u)n[u]=T(n[u],A+1);else for(const u in n)Object.hasOwnProperty.call(n,u)&&(n[u]=T(n[u],A+1))}return n}e.revive=T}),define(me[10],ge([0,1,11,2]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var I;(function(C){C.inMemory="inmemory",C.vscode="vscode",C.internal="private",C.walkThrough="walkThrough",C.walkThroughSnippet="walkThroughSnippet",C.http="http",C.https="https",C.file="file",C.mailto="mailto",C.untitled="untitled",C.data="data",C.command="command",C.vscodeRemote="vscode-remote",C.vscodeRemoteResource="vscode-remote-resource",C.userData="vscode-userdata",C.vscodeCustomEditor="vscode-custom-editor",C.vscodeNotebook="vscode-notebook",C.vscodeNotebookCell="vscode-notebook-cell",C.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",C.vscodeNotebookCellOutput="vscode-notebook-cell-output",C.vscodeInteractive="vscode-interactive",C.vscodeInteractiveInput="vscode-interactive-input",C.vscodeSettings="vscode-settings",C.vscodeWorkspaceTrust="vscode-workspace-trust",C.vscodeTerminal="vscode-terminal",C.webviewPanel="webview-panel",C.vscodeWebview="vscode-webview",C.extension="extension",C.vscodeFileResource="vscode-file",C.tmp="tmp"})(I=e.Schemas||(e.Schemas={}));class k{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}set(D,T,n){this._hosts[D]=T,this._ports[D]=n}setConnectionToken(D,T){this._connectionTokens[D]=T}rewrite(D){if(this._delegate)return this._delegate(D);const T=D.authority;let n=this._hosts[T];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const A=this._ports[T],u=this._connectionTokens[T];let f=`path=${encodeURIComponent(D.path)}`;return typeof u=="string"&&(f+=`&tkn=${encodeURIComponent(u)}`),L.URI.from({scheme:m.isWeb?this._preferredWebSchema:I.vscodeRemoteResource,authority:`${n}:${A}`,path:"/vscode-remote-resource",query:f})}}e.RemoteAuthorities=new k;class R{asBrowserUri(D,T){const n=this.toUri(D,T);return n.scheme===I.vscodeRemote?e.RemoteAuthorities.rewrite(n):n.scheme===I.file&&(m.isNative||typeof m.globals.importScripts=="function"&&m.globals.origin===`${I.vscodeFileResource}://${R.FALLBACK_AUTHORITY}`)?n.with({scheme:I.vscodeFileResource,authority:n.authority||R.FALLBACK_AUTHORITY,query:null,fragment:null}):n}asFileUri(D,T){const n=this.toUri(D,T);return n.scheme===I.vscodeFileResource?n.with({scheme:I.file,authority:n.authority!==R.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(D,T){return L.URI.isUri(D)?D:L.URI.parse(T.toUrl(D))}}R.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new R}),define(me[78],ge([0,1,24]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new m.LRUCache(1e4);function I(T){return D(T,"NFC",L)}e.normalizeNFC=I;const k=new m.LRUCache(1e4);function R(T){return D(T,"NFD",k)}e.normalizeNFD=R;const C=/[^\u0000-\u0080]/;function D(T,n,A){if(!T)return T;const u=A.get(T);if(u)return u;let f;return C.test(T)?f=T.normalize(n):f=T,A.set(T,f),f}e.removeAccents=function(){const T=/[\u0300-\u036f]/g;return function(n){return R(n).replace(T,"")}}()}),define(me[22],ge([0,1,29,10,8,11,9,2]),function(J,e,m,L,I,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(f){return(0,C.uriToFsPath)(f,!0)}e.originalFSPath=D;class T{constructor(l){this._ignorePathCasing=l}compare(l,v,S=!1){return l===v?0:(0,R.compare)(this.getComparisonKey(l,S),this.getComparisonKey(v,S))}isEqual(l,v,S=!1){return l===v?!0:!l||!v?!1:this.getComparisonKey(l,S)===this.getComparisonKey(v,S)}getComparisonKey(l,v=!1){return l.with({path:this._ignorePathCasing(l)?l.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(l){return this._ignorePathCasing(l)}isEqualOrParent(l,v,S=!1){if(l.scheme===v.scheme){if(l.scheme===L.Schemas.file)return m.isEqualOrParent(D(l),D(v),this._ignorePathCasing(l))&&l.query===v.query&&(S||l.fragment===v.fragment);if((0,e.isEqualAuthority)(l.authority,v.authority))return m.isEqualOrParent(l.path,v.path,this._ignorePathCasing(l),"/")&&l.query===v.query&&(S||l.fragment===v.fragment)}return!1}joinPath(l,...v){return C.URI.joinPath(l,...v)}basenameOrAuthority(l){return(0,e.basename)(l)||l.authority}basename(l){return I.posix.basename(l.path)}extname(l){return I.posix.extname(l.path)}dirname(l){if(l.path.length===0)return l;let v;return l.scheme===L.Schemas.file?v=C.URI.file(I.dirname(D(l))).path:(v=I.posix.dirname(l.path),l.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${l.toString})) resulted in a relative path`),v="/")),l.with({path:v})}normalizePath(l){if(!l.path.length)return l;let v;return l.scheme===L.Schemas.file?v=C.URI.file(I.normalize(D(l))).path:v=I.posix.normalize(l.path),l.with({path:v})}relativePath(l,v){if(l.scheme!==v.scheme||!(0,e.isEqualAuthority)(l.authority,v.authority))return;if(l.scheme===L.Schemas.file){const E=I.relative(D(l),D(v));return k.isWindows?m.toSlashes(E):E}let S=l.path||"/",P=v.path||"/";if(this._ignorePathCasing(l)){let E=0;for(const s=Math.min(S.length,P.length);E<s&&!(S.charCodeAt(E)!==P.charCodeAt(E)&&S.charAt(E).toLowerCase()!==P.charAt(E).toLowerCase());E++);S=P.substr(0,E)+S.substr(E)}return I.posix.relative(S,P)}resolvePath(l,v){if(l.scheme===L.Schemas.file){const S=C.URI.file(I.resolve(D(l),v));return l.with({authority:S.authority,path:S.path})}return v=m.toPosixPath(v),l.with({path:I.posix.resolve(l.path,v)})}isAbsolutePath(l){return!!l.path&&l.path[0]==="/"}isEqualAuthority(l,v){return l===v||(0,R.equalsIgnoreCase)(l,v)}hasTrailingPathSeparator(l,v=I.sep){if(l.scheme===L.Schemas.file){const S=D(l);return S.length>m.getRoot(S).length&&S[S.length-1]===v}else{const S=l.path;return S.length>1&&S.charCodeAt(S.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(l.fsPath)}}removeTrailingPathSeparator(l,v=I.sep){return(0,e.hasTrailingPathSeparator)(l,v)?l.with({path:l.path.substr(0,l.path.length-1)}):l}addTrailingPathSeparator(l,v=I.sep){let S=!1;if(l.scheme===L.Schemas.file){const P=D(l);S=P!==void 0&&P.length===m.getRoot(P).length&&P[P.length-1]===v}else{v="/";const P=l.path;S=P.length===1&&P.charCodeAt(P.length-1)===47}return!S&&!(0,e.hasTrailingPathSeparator)(l,v)?l.with({path:l.path+"/"}):l}}e.ExtUri=T,e.extUri=new T(()=>!1),e.extUriBiasedIgnorePathCase=new T(f=>f.scheme===L.Schemas.file?!k.isLinux:!0),e.extUriIgnorePathCase=new T(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(f,l){const v=[];for(let S=0;S<f.length;S++){const P=l(f[S]);f.some((E,s)=>s===S?!1:(0,e.isEqualOrParent)(P,l(E)))||v.push(f[S])}return v}e.distinctParents=n;var A;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function l(v){const S=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(s=>{const[a,p]=s.split(":");a&&p&&S.set(a,p)});const E=v.path.substring(0,v.path.indexOf(";"));return E&&S.set(f.META_DATA_MIME,E),S}f.parseMetaData=l})(A=e.DataUri||(e.DataUri={}));function u(f,l,v){if(l){let S=f.path;return S&&S[0]!==I.posix.sep&&(S=I.posix.sep+S),f.with({scheme:v,authority:l,path:S})}return f.with({scheme:v})}e.toLocalResource=u}),define(me[18],ge([0,1,21,16,3,6,22]),function(J,e,m,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C(O){return!!O&&typeof O.then=="function"}e.isThenable=C;function D(O){const B=new m.CancellationTokenSource,x=O(B.token),M=new Promise((H,W)=>{const Q=B.token.onCancellationRequested(()=>{Q.dispose(),B.dispose(),W((0,L.canceled)())});Promise.resolve(x).then(X=>{Q.dispose(),B.dispose(),H(X)},X=>{Q.dispose(),B.dispose(),W(X)})});return new class{cancel(){B.cancel()}then(H,W){return M.then(H,W)}catch(H){return this.then(void 0,H)}finally(H){return M.finally(H)}}}e.createCancelablePromise=D;function T(O,B,x){return Promise.race([O,new Promise(M=>B.onCancellationRequested(()=>M(x)))])}e.raceCancellation=T;async function n(O){let B=-1;const x=O.map((H,W)=>H.then(Q=>(B=W,Q))),M=await Promise.race(x);return O.forEach((H,W)=>{W!==B&&H.cancel()}),M}e.raceCancellablePromises=n;function A(O,B,x){let M;const H=setTimeout(()=>{M?.(void 0),x?.()},B);return Promise.race([O.finally(()=>clearTimeout(H)),new Promise(W=>M=W)])}e.raceTimeout=A;function u(O){return new Promise((B,x)=>{const M=O();C(M)?M.then(B,x):B(M)})}e.asPromise=u;class f{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(B){if(this.activePromise){if(this.queuedPromiseFactory=B,!this.queuedPromise){const x=()=>{this.queuedPromise=null;const M=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,M};this.queuedPromise=new Promise(M=>{this.activePromise.then(x,x).then(M)})}return new Promise((x,M)=>{this.queuedPromise.then(x,M)})}return this.activePromise=B(),new Promise((x,M)=>{this.activePromise.then(H=>{this.activePromise=null,x(H)},H=>{this.activePromise=null,M(H)})})}}e.Throttler=f;class l{constructor(){this.current=Promise.resolve(null)}queue(B){return this.current=this.current.then(()=>B(),()=>B())}}e.Sequencer=l;class v{constructor(){this.promiseMap=new Map}queue(B,x){const H=(this.promiseMap.get(B)??Promise.resolve()).catch(()=>{}).then(x).finally(()=>{this.promiseMap.get(B)===H&&this.promiseMap.delete(B)});return this.promiseMap.set(B,H),H}}e.SequencerByKey=v;class S{constructor(B){this.defaultDelay=B,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(B,x=this.defaultDelay){return this.task=B,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((M,H)=>{this.doResolve=M,this.doReject=H}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const M=this.task;return this.task=null,M()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},x),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=S;class P{constructor(B){this.delayer=new S(B),this.throttler=new f}trigger(B,x){return this.delayer.trigger(()=>this.throttler.queue(B),x)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=P;class E{constructor(){this._isOpen=!1,this._promise=new Promise((B,x)=>{this._completePromise=B})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=E;class s extends E{constructor(B){super();this._timeout=setTimeout(()=>this.open(),B)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=s;function a(O,B){return B?new Promise((x,M)=>{const H=setTimeout(()=>{W.dispose(),x()},O),W=B.onCancellationRequested(()=>{clearTimeout(H),W.dispose(),M((0,L.canceled)())})}):D(x=>a(O,x))}e.timeout=a;function p(O,B=0){const x=setTimeout(O,B);return(0,k.toDisposable)(()=>clearTimeout(x))}e.disposableTimeout=p;function t(O){const B=[];let x=0;const M=O.length;function H(){return x<M?O[x++]():null}function W(Q){Q!=null&&B.push(Q);const X=H();return X?X.then(W):Promise.resolve(B)}return Promise.resolve(null).then(W)}e.sequence=t;function o(O,B=M=>!!M,x=null){let M=0;const H=O.length,W=()=>{if(M>=H)return Promise.resolve(x);const Q=O[M++];return Promise.resolve(Q()).then(he=>B(he)?Promise.resolve(he):W())};return W()}e.first=o;function r(O,B=M=>!!M,x=null){if(O.length===0)return Promise.resolve(x);let M=O.length;const H=()=>{M=-1;for(const W of O)W.cancel?.()};return new Promise((W,Q)=>{for(const X of O)X.then(he=>{--M>=0&&B(he)?(H(),W(he)):M===0&&W(x)}).catch(he=>{--M>=0&&(H(),Q(he))})})}e.firstParallel=r;class i{constructor(B){this._size=0,this.maxDegreeOfParalellism=B,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new I.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(B){return this._size++,new Promise((x,M)=>{this.outstandingPromises.push({factory:B,c:x,e:M}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const B=this.outstandingPromises.shift();this.runningPromises++;const x=B.factory();x.then(B.c,B.e),x.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=i;class h extends i{constructor(){super(1)}}e.Queue=h;class c{constructor(){this.queues=new Map}queueFor(B,x=R.extUri){const M=x.getComparisonKey(B);let H=this.queues.get(M);return H||(H=new h,I.Event.once(H.onFinished)(()=>{H?.dispose(),this.queues.delete(M)}),this.queues.set(M,H)),H}dispose(){this.queues.forEach(B=>B.dispose()),this.queues.clear()}}e.ResourceQueue=c;class d{constructor(B,x){this._token=-1,typeof B=="function"&&typeof x=="number"&&this.setIfNotSet(B,x)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(B,x){this.cancel(),this._token=setTimeout(()=>{this._token=-1,B()},x)}setIfNotSet(B,x){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,B()},x))}}e.TimeoutTimer=d;class b{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(B,x){this.cancel(),this._token=setInterval(()=>{B()},x)}}e.IntervalTimer=b;class y{constructor(B,x){this.timeoutToken=-1,this.runner=B,this.timeout=x,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(B=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,B)}get delay(){return this.timeout}set delay(B){this.timeout=B}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=y;class g{constructor(B,x){x%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.runner=B,this.timeout=x,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(B=this.timeout){B%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(B/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=g;class _ extends y{constructor(B,x){super(B,x);this.units=[]}work(B){this.units.push(B),this.isScheduled()||this.schedule()}doRun(){const B=this.units;this.units=[],this.runner&&this.runner(B)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=_;class w extends k.Disposable{constructor(B,x,M,H){super();this.maxWorkChunkSize=B,this.maxPendingWork=x,this.throttleDelay=M,this.handler=H,this.pendingWork=[],this.throttler=this._register(new k.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(B){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+B.length>this.maxPendingWork)return!1}else if(this.pending+B.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...B),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new y(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=w,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const O=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=B=>{const x=setTimeout(()=>B(O));let M=!1;return{dispose(){M||(M=!0,clearTimeout(x))}}}}else e.runWhenIdle=(O,B)=>{const x=requestIdleCallback(O,typeof B=="number"?{timeout:B}:void 0);let M=!1;return{dispose(){M||(M=!0,cancelIdleCallback(x))}}}}();class F{constructor(B){this._didRun=!1,this._executor=()=>{try{this._value=B()}catch(x){this._error=x}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=F;async function N(O,B,x){let M;for(let H=0;H<x;H++)try{return await O()}catch(W){M=W,await a(B)}throw M}e.retry=N;class G{hasPending(B){return this._pending?typeof B=="number"?this._pending.taskId===B:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(B,x,M){return this._pending={taskId:B,cancel:()=>M?.(),promise:x},x.then(()=>this.donePending(B),()=>this.donePending(B)),x}donePending(B){this._pending&&B===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const B=this._next;this._next=void 0,B.run().then(B.promiseResolve,B.promiseReject)}}setNext(B){if(this._next)this._next.run=B;else{let x,M;const H=new Promise((W,Q)=>{x=W,M=Q});this._next={run:B,promise:H,promiseResolve:x,promiseReject:M}}return this._next.promise}}e.TaskSequentializer=G;class K{constructor(B){this.interval=B,this.lastIncrementTime=0,this.value=0}increment(){const B=Date.now();return B-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=B,this.value=0),this.value++,this.value}}e.IntervalCounter=K;class U{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((B,x)=>{this.completeCallback=B,this.errorCallback=x})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(B){return new Promise(x=>{this.completeCallback(B),this.resolved=!0,x()})}error(B){return new Promise(x=>{this.errorCallback(B),this.rejected=!0,x()})}cancel(){new Promise(B=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,B()})}}e.DeferredPromise=U;var z;(function(O){async function B(x){let M;const H=await Promise.all(x.map(W=>W.then(Q=>Q,Q=>{M||(M=Q)})));if(typeof M!="undefined")throw M;return H}O.settled=B})(z=e.Promises||(e.Promises={}))}),define(me[100],ge([0,1,18,8]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const I=new m.IdleValue(()=>{const y=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:y,collatorIsNumeric:y.resolvedOptions().numeric}}),k=new m.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new m.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function C(y,g,_=!1){const w=y||"",F=g||"",N=I.value.collator.compare(w,F);return I.value.collatorIsNumeric&&N===0&&w!==F?w<F?-1:1:N}e.compareFileNames=C;function D(y,g){const _=k.value.collator;return y=y||"",g=g||"",p(_,y,g)}e.compareFileNamesDefault=D;function T(y,g){const _=k.value.collator;return y=y||"",g=g||"",i(y,g)||p(_,y,g)}e.compareFileNamesUpper=T;function n(y,g){const _=k.value.collator;return y=y||"",g=g||"",r(y,g)||p(_,y,g)}e.compareFileNamesLower=n;function A(y,g){return y=y||"",g=g||"",y===g?0:y<g?-1:1}e.compareFileNamesUnicode=A;function u(y,g,_=!1){_||(y=y&&y.toLowerCase(),g=g&&g.toLowerCase());const[w,F]=s(y),[N,G]=s(g);return w!==N?w<N?-1:1:F===G?0:F<G?-1:1}e.noIntlCompareFileNames=u;function f(y,g){const[_,w]=s(y),[F,N]=s(g);let G=I.value.collator.compare(w,N);if(G===0){if(I.value.collatorIsNumeric&&w!==N)return w<N?-1:1;if(G=I.value.collator.compare(_,F),I.value.collatorIsNumeric&&G===0&&_!==F)return _<F?-1:1}return G}e.compareFileExtensions=f;function l(y,g){y=y||"",g=g||"";const _=a(y),w=a(g),F=k.value.collator,N=R.value.collator;return p(N,_,w)||p(F,y,g)}e.compareFileExtensionsDefault=l;function v(y,g){y=y||"",g=g||"";const _=a(y),w=a(g),F=k.value.collator,N=R.value.collator;return p(N,_,w)||i(y,g)||p(F,y,g)}e.compareFileExtensionsUpper=v;function S(y,g){y=y||"",g=g||"";const _=a(y),w=a(g),F=k.value.collator,N=R.value.collator;return p(N,_,w)||r(y,g)||p(F,y,g)}e.compareFileExtensionsLower=S;function P(y,g){y=y||"",g=g||"";const _=a(y).toLowerCase(),w=a(g).toLowerCase();return _!==w?_<w?-1:1:y!==g?y<g?-1:1:0}e.compareFileExtensionsUnicode=P;const E=/^(.*?)(\.([^.]*))?$/;function s(y,g=!1){const _=y?E.exec(y):[];let w=[_&&_[1]||"",_&&_[3]||""];return g&&(!w[0]&&w[1]||w[0]&&w[0].charAt(0)===".")&&(w=[w[0]+"."+w[1],""]),w}function a(y){const g=y?E.exec(y):[];return g&&g[1]&&g[1].charAt(0)!=="."&&g[3]||""}function p(y,g,_){let w=y.compare(g,_);return w!==0?w:g.length!==_.length?g.length<_.length?-1:1:0}function t(y){const g=y.charAt(0);return g.toLocaleUpperCase()!==g}function o(y){const g=y.charAt(0);return g.toLocaleLowerCase()!==g}function r(y,g){return t(y)&&o(g)?-1:o(y)&&t(g)?1:0}function i(y,g){return o(y)&&t(g)?-1:t(y)&&o(g)?1:0}function h(y,g,_=!1){return _||(y=y&&y.toLowerCase(),g=g&&g.toLowerCase()),y===g?0:y<g?-1:1}function c(y,g,_=!1){const w=y.split(L.sep),F=g.split(L.sep),N=w.length-1,G=F.length-1;let K,U;for(let z=0;;z++){if(K=N===z,U=G===z,K&&U)return C(w[z],F[z],_);if(K)return-1;if(U)return 1;const O=h(w[z],F[z],_);if(O!==0)return O}}e.comparePaths=c;function d(y,g,_){const w=y.toLowerCase(),F=g.toLowerCase(),N=b(y,g,_);if(N)return N;const G=w.endsWith(_),K=F.endsWith(_);if(G!==K)return G?-1:1;const U=C(w,F);return U!==0?U:w.localeCompare(F)}e.compareAnything=d;function b(y,g,_){const w=y.toLowerCase(),F=g.toLowerCase(),N=w.startsWith(_),G=F.startsWith(_);if(N!==G)return N?-1:1;if(N&&G){if(w.length<F.length)return-1;if(w.length>F.length)return 1}return 0}e.compareByPrefix=b}),define(me[101],ge([0,1,100,98,48,8,11,9]),function(J,e,m,L,I,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const D=0,T=[D,[]];function n(O,B,x,M){if(!O||!B)return T;const H=O.length,W=B.length;if(H<W)return T;const Q=O.toLowerCase();return A(B,x,W,O,Q,H,M)}e.scoreFuzzy=n;function A(O,B,x,M,H,W,Q){const X=[],he=[];for(let $e=0;$e<x;$e++){const Be=$e*W,je=Be-W,V=$e>0,ee=O[$e],re=B[$e];for(let ae=0;ae<W;ae++){const Y=ae>0,oe=Be+ae,ve=oe-1,Me=je+ae-1,qe=Y?X[ve]:0,Ke=V&&Y?X[Me]:0,Se=V&&Y?he[Me]:0;let tt;!Ke&&V?tt=0:tt=u(ee,re,M,H,ae,Se),tt&&Ke+tt>=qe&&(Q||V||H.startsWith(B,ae))?(he[oe]=Se+1,X[oe]=Ke+tt):(he[oe]=D,X[oe]=qe)}}const _e=[];let ye=x-1,Re=W-1;for(;ye>=0&&Re>=0;){const $e=ye*W+Re;he[$e]===D||(_e.push(Re),ye--),Re--}return[X[x*W-1],_e.reverse()]}function u(O,B,x,M,H,W){let Q=0;if(!f(B,M[H]))return Q;if(Q+=1,W>0&&(Q+=W*5),O===x[H]&&(Q+=1),H===0)Q+=8;else{const X=l(x.charCodeAt(H-1));X?Q+=X:(0,L.isUpper)(x.charCodeAt(H))&&(Q+=2)}return Q}function f(O,B){return O===B?!0:O==="/"||O==="\\"?B==="/"||B==="\\":!1}function l(O){switch(O){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const v=[void 0,[]];function S(O,B,x=0,M=0){const H=B;return H.values&&H.values.length>1?P(O,H.values,x,M):E(O,B,x,M)}e.scoreFuzzy2=S;function P(O,B,x,M){let H=0;const W=[];for(const Q of B){const[X,he]=E(O,Q,x,M);if(typeof X!="number")return v;H+=X,W.push(...he)}return[H,b(W)]}function E(O,B,x,M){const H=(0,L.fuzzyScore)(B.original,B.originalLowercase,x,O,O.toLowerCase(),M,!0);return H?[H[0],(0,L.createMatches)(H)]:v}const s=Object.freeze({score:0}),a=1<<18,p=1<<17,t=1<<16;function o(O,B,x,M){const H=M.values?M.values:[M];return(0,I.hash)({[M.normalized]:{values:H.map(Q=>({value:Q.normalized,expectContiguousMatch:Q.expectContiguousMatch})),label:O,description:B,allowNonContiguousMatches:x}})}function r(O,B,x,M,H){if(!O||!B.normalized)return s;const W=M.getItemLabel(O);if(!W)return s;const Q=M.getItemDescription(O),X=o(W,Q,x,B),he=H[X];if(he)return he;const _e=i(W,Q,M.getItemPath(O),B,x);return H[X]=_e,_e}e.scoreItemFuzzy=r;function i(O,B,x,M,H){const W=!x||!M.containsPathSeparator;return x&&(R.isLinux?M.pathNormalized===x:(0,C.equalsIgnoreCase)(M.pathNormalized,x))?{score:a,labelMatch:[{start:0,end:O.length}],descriptionMatch:B?[{start:0,end:B.length}]:void 0}:M.values&&M.values.length>1?h(O,B,x,M.values,W,H):c(O,B,x,M,W,H)}function h(O,B,x,M,H,W){let Q=0;const X=[],he=[];for(const _e of M){const{score:ye,labelMatch:Re,descriptionMatch:$e}=c(O,B,x,_e,H,W);if(ye===D)return s;Q+=ye,Re&&X.push(...Re),$e&&he.push(...$e)}return{score:Q,labelMatch:b(X),descriptionMatch:b(he)}}function c(O,B,x,M,H,W){if(H||!B){const[Q,X]=n(O,M.normalized,M.normalizedLowercase,W&&!M.expectContiguousMatch);if(Q){const he=(0,L.matchesPrefix)(M.normalized,O);let _e;return he?(_e=p,_e+=Math.round(M.normalized.length/O.length*100)):_e=t,{score:_e+Q,labelMatch:he||d(X)}}}if(B){let Q=B;x&&(Q=`${B}${k.sep}`);const X=Q.length,he=`${Q}${O}`,[_e,ye]=n(he,M.normalized,M.normalizedLowercase,W&&!M.expectContiguousMatch);if(_e){const Re=d(ye),$e=[],Be=[];return Re.forEach(je=>{je.start<X&&je.end>X?($e.push({start:0,end:je.end-X}),Be.push({start:je.start,end:X})):je.start>=X?$e.push({start:je.start-X,end:je.end-X}):Be.push(je)}),{score:_e,labelMatch:$e,descriptionMatch:Be}}}return s}function d(O){const B=[];if(!O)return B;let x;for(const M of O)x&&x.end===M?x.end+=1:(x={start:M,end:M+1},B.push(x));return B}function b(O){const B=O.sort((H,W)=>H.start-W.start),x=[];let M;for(const H of B)!M||!y(M,H)?(M=H,x.push(H)):(M.start=Math.min(M.start,H.start),M.end=Math.max(M.end,H.end));return x}function y(O,B){return!(O.end<B.start||B.end<O.start)}function g(O,B,x,M,H,W){const Q=r(O,x,M,H,W),X=r(B,x,M,H,W),he=Q.score,_e=X.score;if((he===a||_e===a)&&he!==_e)return he===a?-1:1;if(he>t||_e>t){if(he!==_e)return he>_e?-1:1;if(he<p&&_e<p){const ee=w(Q.labelMatch,X.labelMatch);if(ee!==0)return ee}const je=H.getItemLabel(O)||"",V=H.getItemLabel(B)||"";if(je.length!==V.length)return je.length-V.length}if(he!==_e)return he>_e?-1:1;const ye=Array.isArray(Q.labelMatch)&&Q.labelMatch.length>0,Re=Array.isArray(X.labelMatch)&&X.labelMatch.length>0;if(ye&&!Re)return-1;if(Re&&!ye)return 1;const $e=_(O,Q,H),Be=_(B,X,H);return $e&&Be&&$e!==Be?Be>$e?-1:1:F(O,B,x,H)}e.compareItemsByFuzzyScore=g;function _(O,B,x){let M=-1,H=-1;if(B.descriptionMatch&&B.descriptionMatch.length?M=B.descriptionMatch[0].start:B.labelMatch&&B.labelMatch.length&&(M=B.labelMatch[0].start),B.labelMatch&&B.labelMatch.length){if(H=B.labelMatch[B.labelMatch.length-1].end,B.descriptionMatch&&B.descriptionMatch.length){const W=x.getItemDescription(O);W&&(H+=W.length)}}else B.descriptionMatch&&B.descriptionMatch.length&&(H=B.descriptionMatch[B.descriptionMatch.length-1].end);return H-M}function w(O,B){if(!O&&!B||(!O||!O.length)&&(!B||!B.length))return 0;if(!B||!B.length)return-1;if(!O||!O.length)return 1;const x=O[0].start,H=O[O.length-1].end-x,W=B[0].start,X=B[B.length-1].end-W;return H===X?0:X<H?1:-1}function F(O,B,x,M){const H=M.getItemLabel(O)||"",W=M.getItemLabel(B)||"",Q=M.getItemDescription(O),X=M.getItemDescription(B),he=H.length+(Q?Q.length:0),_e=W.length+(X?X.length:0);if(he!==_e)return he-_e;const ye=M.getItemPath(O),Re=M.getItemPath(B);return ye&&Re&&ye.length!==Re.length?ye.length-Re.length:H!==W?(0,m.compareAnything)(H,W,x.normalized):Q&&X&&Q!==X?(0,m.compareAnything)(Q,X,x.normalized):ye&&Re&&ye!==Re?(0,m.compareAnything)(ye,Re,x.normalized):0}function N(O){return O.startsWith('"')&&O.endsWith('"')}const G=" ";function K(O){typeof O!="string"&&(O="");const B=O.toLowerCase(),{pathNormalized:x,normalized:M,normalizedLowercase:H}=U(O),W=x.indexOf(k.sep)>=0,Q=N(O);let X;const he=O.split(G);if(he.length>1)for(const _e of he){const ye=N(_e),{pathNormalized:Re,normalized:$e,normalizedLowercase:Be}=U(_e);$e&&(X||(X=[]),X.push({original:_e,originalLowercase:_e.toLowerCase(),pathNormalized:Re,normalized:$e,normalizedLowercase:Be,expectContiguousMatch:ye}))}return{original:O,originalLowercase:B,pathNormalized:x,normalized:M,normalizedLowercase:H,values:X,containsPathSeparator:W,expectContiguousMatch:Q}}e.prepareQuery=K;function U(O){let B;R.isWindows?B=O.replace(/\//g,k.sep):B=O.replace(/\\/g,k.sep);const x=(0,C.stripWildcards)(B).replace(/\s|"/g,"");return{pathNormalized:B,normalized:x,normalizedLowercase:x.toLowerCase()}}function z(O){return Array.isArray(O)?K(O.map(B=>B.original).join(G)):K(O.original)}e.pieceToQuery=z}),define(me[30],ge([0,1,18,29,24,8,9]),function(J,e,m,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C;const D="**",T="/",n="[/\\\\]",A="[^/\\\\]",u=/\//g;function f(M){switch(M){case 0:return"";case 1:return`${A}*?`;default:return`(?:${n}|${A}+${n}|${n}${A}+)*?`}}function l(M,H){if(!M)return[];const W=[];let Q=!1,X=!1,he="";for(const _e of M){switch(_e){case H:if(!Q&&!X){W.push(he),he="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":X=!0;break;case"]":X=!1;break}he+=_e}return he&&W.push(he),W}e.splitGlobAware=l;function v(M){if(!M)return"";let H="";const W=l(M,T);if(W.every(Q=>Q===D))H=".*";else{let Q=!1;W.forEach((X,he)=>{if(X===D){Q||(H+=f(2),Q=!0);return}let _e=!1,ye="",Re=!1,$e="";for(const Be of X){if(Be!=="}"&&_e){ye+=Be;continue}if(Re&&(Be!=="]"||!$e)){let je;Be==="-"?je=Be:(Be==="^"||Be==="!")&&!$e?je="^":Be===T?je="":je=R.escapeRegExpCharacters(Be),$e+=je;continue}switch(Be){case"{":_e=!0;continue;case"[":Re=!0;continue;case"}":H+=`(?:${l(ye,",").map(ee=>v(ee)).join("|")})`,_e=!1,ye="";break;case"]":H+="["+$e+"]",Re=!1,$e="";break;case"?":H+=A;continue;case"*":H+=f(1);continue;default:H+=R.escapeRegExpCharacters(Be)}}he<W.length-1&&(W[he+1]!==D||he+2<W.length)&&(H+=n),Q=!1})}return H}const S=/^\*\*\/\*\.[\w\.-]+$/,P=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,s=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new I.LRUCache(1e4),o=function(){return!1},r=function(){return null};function i(M,H){if(!M)return r;let W;typeof M!="string"?W=M.pattern:W=M,W=W.trim();const Q=`${W}_${!!H.trimForExclusions}`;let X=t.get(Q);if(X)return h(X,M);let he;if(S.test(W)){const _e=W.substr(4);X=function(ye,Re){return typeof ye=="string"&&ye.endsWith(_e)?W:null}}else(he=P.exec(c(W,H)))?X=d(he[1],W):(H.trimForExclusions?s:E).test(W)?X=b(W,H):(he=a.exec(c(W,H)))?X=y(he[1].substr(1),W,!0):(he=p.exec(c(W,H)))?X=y(he[1],W,!1):X=g(W);return t.set(Q,X),h(X,M)}function h(M,H){return typeof H=="string"?M:function(W,Q){return L.isEqualOrParent(W,H.base)?M(k.relative(H.base,W),Q):null}}function c(M,H){return H.trimForExclusions&&M.endsWith("/**")?M.substr(0,M.length-2):M}function d(M,H){const W=`/${M}`,Q=`\\${M}`,X=function(_e,ye){return typeof _e!="string"?null:ye?ye===M?H:null:_e===M||_e.endsWith(W)||_e.endsWith(Q)?H:null},he=[M];return X.basenames=he,X.patterns=[H],X.allBasenames=he,X}function b(M,H){const W=x(M.slice(1,-1).split(",").map(ye=>i(ye,H)).filter(ye=>ye!==r),M),Q=W.length;if(!Q)return r;if(Q===1)return W[0];const X=function(ye,Re){for(let $e=0,Be=W.length;$e<Be;$e++)if(W[$e](ye,Re))return M;return null},he=W.find(ye=>!!ye.allBasenames);he&&(X.allBasenames=he.allBasenames);const _e=W.reduce((ye,Re)=>Re.allPaths?ye.concat(Re.allPaths):ye,[]);return _e.length&&(X.allPaths=_e),X}function y(M,H,W){const Q=k.sep===k.posix.sep,X=Q?M:M.replace(u,k.sep),he=k.sep+X,_e=k.posix.sep+M,ye=W?function(Re,$e){return typeof Re=="string"&&(Re===X||Re.endsWith(he)||!Q&&(Re===M||Re.endsWith(_e)))?H:null}:function(Re,$e){return typeof Re=="string"&&(Re===X||!Q&&Re===M)?H:null};return ye.allPaths=[(W?"*/":"./")+M],ye}function g(M){try{const H=new RegExp(`^${v(M)}$`);return function(W){return H.lastIndex=0,typeof W=="string"&&H.test(W)?M:null}}catch(H){return r}}function _(M,H,W){return!M||typeof H!="string"?!1:w(M)(H,void 0,W)}e.match=_;function w(M,H={}){if(!M)return o;if(typeof M=="string"||K(M)){const W=i(M,H);if(W===r)return o;const Q=function(X,he){return!!W(X,he)};return W.allBasenames&&(Q.allBasenames=W.allBasenames),W.allPaths&&(Q.allPaths=W.allPaths),Q}return O(M,H)}e.parse=w;function F(M){if(!M)return;let H;return W=>(H||(H=(M()||Promise.resolve([])).then(Q=>Q?G(Q):{})),H.then(Q=>!!Q[W]))}e.hasSiblingPromiseFn=F;function N(M){if(!M)return;let H;return W=>{if(!H){const Q=M();H=Q?G(Q):{}}return!!H[W]}}e.hasSiblingFn=N;function G(M){const H={};for(const W of M)H[W]=!0;return H}function K(M){const H=M;return H&&typeof H.base=="string"&&typeof H.pattern=="string"}e.isRelativePattern=K;function U(M){return M.allBasenames||[]}e.getBasenameTerms=U;function z(M){return M.allPaths||[]}e.getPathTerms=z;function O(M,H){const W=x(Object.getOwnPropertyNames(M).map(ye=>B(ye,M[ye],H)).filter(ye=>ye!==r)),Q=W.length;if(!Q)return r;if(!W.some(ye=>!!ye.requiresSiblings)){if(Q===1)return W[0];const ye=function(Be,je){for(let V=0,ee=W.length;V<ee;V++){const re=W[V](Be,je);if(re)return re}return null},Re=W.find(Be=>!!Be.allBasenames);Re&&(ye.allBasenames=Re.allBasenames);const $e=W.reduce((Be,je)=>je.allPaths?Be.concat(je.allPaths):Be,[]);return $e.length&&(ye.allPaths=$e),ye}const X=function(ye,Re,$e){let Be;for(let je=0,V=W.length;je<V;je++){const ee=W[je];ee.requiresSiblings&&$e&&(Re||(Re=k.basename(ye)),Be||(Be=Re.substr(0,Re.length-k.extname(ye).length)));const re=ee(ye,Re,Be,$e);if(re)return re}return null},he=W.find(ye=>!!ye.allBasenames);he&&(X.allBasenames=he.allBasenames);const _e=W.reduce((ye,Re)=>Re.allPaths?ye.concat(Re.allPaths):ye,[]);return _e.length&&(X.allPaths=_e),X}function B(M,H,W){if(H===!1)return r;const Q=i(M,W);if(Q===r)return r;if(typeof H=="boolean")return Q;if(H){const X=H.when;if(typeof X=="string"){const he=(_e,ye,Re,$e)=>{if(!$e||!Q(_e,ye))return null;const Be=X.replace("$(basename)",Re),je=$e(Be);return(0,m.isThenable)(je)?je.then(V=>V?M:null):je?M:null};return he.requiresSiblings=!0,he}}return Q}function x(M,H){const W=M.filter(ye=>!!ye.basenames);if(W.length<2)return M;const Q=W.reduce((ye,Re)=>{const $e=Re.basenames;return $e?ye.concat($e):ye},[]);let X;if(H){X=[];for(let ye=0,Re=Q.length;ye<Re;ye++)X.push(H)}else X=W.reduce((ye,Re)=>{const $e=Re.patterns;return $e?ye.concat($e):ye},[]);const he=function(ye,Re){if(typeof ye!="string")return null;if(!Re){let Be;for(Be=ye.length;Be>0;Be--){const je=ye.charCodeAt(Be-1);if(je===47||je===92)break}Re=ye.substr(Be)}const $e=Q.indexOf(Re);return $e!==-1?X[$e]:null};he.basenames=Q,he.patterns=X,he.allBasenames=Q;const _e=M.filter(ye=>!ye.basenames);return _e.push(he),_e}}),define(me[79],ge([0,1,29,10,8,11,22,9,2]),function(J,e,m,L,I,k,R,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function T(i,h,c){if(typeof i=="string"&&(i=D.URI.file(i)),c){const b=c.getWorkspaceFolder(i);if(b){const y=c.getWorkspace().folders.length>1;let g;if((0,R.isEqual)(b.uri,i)?g="":g=(0,R.relativePath)(b.uri,i),y){const _=b.name?b.name:(0,R.basename)(b.uri);g=g?_+" \u2022 "+g:_}return g}}if(i.scheme!==L.Schemas.file&&i.scheme!==L.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,m.hasDriveLetter)(i.fsPath))return(0,I.normalize)(A(i.fsPath));let d=(0,I.normalize)(i.fsPath);return!k.isWindows&&h?.userHome&&(d=f(d,h.userHome.fsPath)),d}e.getPathLabel=T;function n(i){if(!i)return;typeof i=="string"&&(i=D.URI.file(i));const h=(0,R.basename)(i)||(i.scheme===L.Schemas.file?i.fsPath:i.path);return k.isWindows&&(0,m.isRootOrDriveLetter)(h)?A(h):h}e.getBaseLabel=n;function A(i){return(0,m.hasDriveLetter)(i)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=A;let u=Object.create(null);function f(i,h){if(k.isWindows||!i||!h)return i;let c=u.original===h?u.normalized:void 0;return c||(c=`${(0,C.rtrim)(h,I.posix.sep)}${I.posix.sep}`,u={original:h,normalized:c}),(k.isLinux?i.startsWith(c):(0,C.startsWithIgnoreCase)(i,c))&&(i=`~/${i.substr(c.length)}`),i}e.tildify=f;function l(i,h){return i.replace(/^~($|\/|\\)/,`${h}$1`)}e.untildify=l;const v="\u2026",S="\\\\",P="~";function E(i,h=I.sep){const c=new Array(i.length);let d=!1;for(let b=0;b<i.length;b++){let y=i[b];if(y===""){c[b]=`.${h}`;continue}if(!y){c[b]=y;continue}d=!0;let g="";y.indexOf(S)===0?(g=y.substr(0,y.indexOf(S)+S.length),y=y.substr(y.indexOf(S)+S.length)):y.indexOf(h)===0?(g=y.substr(0,y.indexOf(h)+h.length),y=y.substr(y.indexOf(h)+h.length)):y.indexOf(P)===0&&(g=y.substr(0,y.indexOf(P)+P.length),y=y.substr(y.indexOf(P)+P.length));const _=y.split(h);for(let w=1;d&&w<=_.length;w++)for(let F=_.length-w;d&&F>=0;F--){d=!1;let N=_.slice(F,F+w).join(h);for(let G=0;!d&&G<i.length;G++)if(G!==b&&i[G]&&i[G].indexOf(N)>-1){const K=F+w===_.length,U=F>0&&i[G].indexOf(h)>-1?h+N:N,z=i[G].endsWith(U);d=!K||z}if(!d){let G="";(_[0].endsWith(":")||g!=="")&&(F===1&&(F=0,w++,N=_[0]+h+N),F>0&&(G=_[0]+h),G=g+G),F>0&&(G=G+v+h),G=G+N,F+w<_.length&&(G=G+h+v),c[b]=G}}d&&(c[b]=y)}return c}e.shorten=E;var s;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(s||(s={}));function a(i,h=Object.create(null)){const c=[];let d=!1,b="";for(const y of i)if(y==="$"||d&&y==="{")b&&c.push({value:b,type:s.TEXT}),b="",d=!0;else if(y==="}"&&d){const g=h[b];if(typeof g=="string")g.length&&c.push({value:g,type:s.VARIABLE});else if(g){const _=c[c.length-1];(!_||_.type!==s.SEPARATOR)&&c.push({value:g.label,type:s.SEPARATOR})}b="",d=!1}else b+=y;return b&&!d&&c.push({value:b,type:s.TEXT}),c.filter((y,g)=>{if(y.type===s.SEPARATOR){const _=c[g-1],w=c[g+1];return[_,w].every(F=>F&&(F.type===s.VARIABLE||F.type===s.TEXT)&&F.value.length>0)}return!0}).map(y=>y.value).join("")}e.template=a;function p(i,h){return k.isMacintosh||h?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,k.isMacintosh?"&":"&&"):i.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.mnemonicMenuLabel=p;function t(i,h){return k.isMacintosh||h?i.replace(/\(&&\w\)|&&/g,""):k.isWindows?i.replace(/&&|&/g,c=>c==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function o(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=o;function r(i){const h=i.indexOf("/")!==-1?I.posix:I.win32,c=h.basename(i),d=h.dirname(i);return c.length?{name:c,parentPath:d}:{name:d,parentPath:""}}e.splitName=r}),define(me[102],ge([0,1,30,10,8,22,9]),function(J,e,m,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var C;(function(i){i.text="text/plain",i.binary="application/octet-stream",i.unknown="application/unknown",i.markdown="text/markdown"})(C=e.Mimes||(e.Mimes={}));let D=[],T=[],n=[];function A(i,h=!1){const c=u(i);D.push(c),c.userConfigured?n.push(c):T.push(c),h&&!c.userConfigured&&D.forEach(d=>{d.mime===c.mime||d.userConfigured||(c.extension&&d.extension===c.extension&&console.warn(`Overwriting extension <<${c.extension}>> to now point to mime <<${c.mime}>>`),c.filename&&d.filename===c.filename&&console.warn(`Overwriting filename <<${c.filename}>> to now point to mime <<${c.mime}>>`),c.filepattern&&d.filepattern===c.filepattern&&console.warn(`Overwriting filepattern <<${c.filepattern}>> to now point to mime <<${c.mime}>>`),c.firstline&&d.firstline===c.firstline&&console.warn(`Overwriting firstline <<${c.firstline}>> to now point to mime <<${c.mime}>>`))})}e.registerTextMime=A;function u(i){return{id:i.id,mime:i.mime,filename:i.filename,extension:i.extension,filepattern:i.filepattern,firstline:i.firstline,userConfigured:i.userConfigured,filenameLowercase:i.filename?i.filename.toLowerCase():void 0,extensionLowercase:i.extension?i.extension.toLowerCase():void 0,filepatternLowercase:i.filepattern?(0,m.parse)(i.filepattern.toLowerCase()):void 0,filepatternOnPath:i.filepattern?i.filepattern.indexOf(I.posix.sep)>=0:!1}}function f(i){i?(D=D.filter(h=>!h.userConfigured),n=[]):(D=[],T=[],n=[])}e.clearTextMimes=f;function l(i,h){let c;if(i)switch(i.scheme){case L.Schemas.file:c=i.fsPath;break;case L.Schemas.data:c=k.DataUri.parseMetaData(i).get(k.DataUri.META_DATA_LABEL);break;default:c=i.path}if(!c)return[C.unknown];c=c.toLowerCase();const d=(0,I.basename)(c),b=v(c,d,n);if(b)return[b,C.text];const y=v(c,d,T);if(y)return[y,C.text];if(h){const g=S(h);if(g)return[g,C.text]}return[C.unknown]}e.guessMimeTypes=l;function v(i,h,c){let d=null,b=null,y=null;for(let g=c.length-1;g>=0;g--){const _=c[g];if(h===_.filenameLowercase){d=_;break}if(_.filepattern&&(!b||_.filepattern.length>b.filepattern.length)){const w=_.filepatternOnPath?i:h;_.filepatternLowercase?.(w)&&(b=_)}_.extension&&(!y||_.extension.length>y.extension.length)&&h.endsWith(_.extensionLowercase)&&(y=_)}return d?d.mime:b?b.mime:y?y.mime:null}function S(i){if((0,R.startsWithUTF8BOM)(i)&&(i=i.substr(1)),i.length>0)for(let h=D.length-1;h>=0;h--){const c=D[h];if(!c.firstline)continue;const d=i.match(c.firstline);if(d&&d.length>0)return c.mime}return null}function P(i){return i?typeof i=="string"?i===C.binary||i===C.text||i===C.unknown:i.length===1&&P(i[0]):!0}e.isUnspecific=P;const E={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},s={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function a(i){const h=(0,I.extname)(i),c=E[h.toLowerCase()];return c!==void 0?c:p(i)}e.getMediaOrTextMime=a;function p(i){const h=(0,I.extname)(i);return s[h.toLowerCase()]}e.getMediaMime=p;function t(i){for(const h in s)if(s[h]===i)return h}e.getExtensionForMimeType=t;const o=/^(.+)\/(.+?)(;.+)?$/;function r(i,h){const c=o.exec(i);return c?`${c[1].toLowerCase()}/${c[2].toLowerCase()}${c[3]??""}`:h?void 0:i}e.normalizeMimeType=r}),define(me[103],ge([0,1,2]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(n){return n.toJSON()}class I{constructor(A){this._uriTransformer=A}transformIncoming(A){const u=this._uriTransformer.transformIncoming(A);return u===A?A:L(m.URI.from(u))}transformOutgoing(A){const u=this._uriTransformer.transformOutgoing(A);return u===A?A:L(m.URI.from(u))}transformOutgoingURI(A){const u=this._uriTransformer.transformOutgoing(A);return u===A?A:m.URI.from(u)}transformOutgoingScheme(A){return this._uriTransformer.transformOutgoingScheme(A)}}e.URITransformer=I,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function k(n,A,u){if(!n||u>200)return null;if(typeof n=="object"){if(n instanceof m.URI)return A.transformOutgoing(n);for(let f in n)if(Object.hasOwnProperty.call(n,f)){const l=k(n[f],A,u+1);l!==null&&(n[f]=l)}}return null}function R(n,A){const u=k(n,A,0);return u===null?n:u}e.transformOutgoingURIs=R;function C(n,A,u,f){if(!n||f>200)return null;if(typeof n=="object"){if(n.$mid===1)return u?m.URI.revive(A.transformIncoming(n)):A.transformIncoming(n);for(let l in n)if(Object.hasOwnProperty.call(n,l)){const v=C(n[l],A,u,f+1);v!==null&&(n[l]=v)}}return null}function D(n,A){const u=C(n,A,!1,0);return u===null?n:u}e.transformIncomingURIs=D;function T(n,A){const u=C(n,A,!0,0);return u===null?n:u}e.transformAndReviveIncomingURIs=T}),define(me[32],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const m=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(D){return m.test(D)}e.isUUID=L;const I=new Uint8Array(16),k=[];for(let D=0;D<256;D++)k.push(D.toString(16).padStart(2,"0"));let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(D){for(let T=0;T<D.length;T++)D[T]=Math.floor(Math.random()*256);return D};function C(){R(I),I[6]=I[6]&15|64,I[8]=I[8]&63|128;let D=0,T="";return T+=k[I[D++]],T+=k[I[D++]],T+=k[I[D++]],T+=k[I[D++]],T+="-",T+=k[I[D++]],T+=k[I[D++]],T+="-",T+=k[I[D++]],T+=k[I[D++]],T+="-",T+=k[I[D++]],T+=k[I[D++]],T+="-",T+=k[I[D++]],T+=k[I[D++]],T+=k[I[D++]],T+=k[I[D++]],T+=k[I[D++]],T+=k[I[D++]],T}e.generateUuid=C}),define(me[142],ge([0,1,104]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(k="utf8"){this.stringDecoder=new m.StringDecoder(k),this.remaining=null}write(k){const R=[],C=this.remaining?this.remaining+this.stringDecoder.write(k):this.stringDecoder.write(k);if(C.length<1)return R;let D=0,T,n=D;for(;n<C.length;)if(T=C.charCodeAt(n),T===13||T===10){if(R.push(C.substring(D,n)),n++,n<C.length){const A=T;T=C.charCodeAt(n),(A===13&&T===10||A===10&&T===13)&&n++}D=n}else n++;return this.remaining=D<C.length?C.substr(D):null,R}end(){return this.remaining}}e.LineDecoder=L}),define(me[28],ge([0,1,50,80,291,18,29,78,8,11,22,2,32]),function(J,e,m,L,I,k,R,C,D,T,n,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var f;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(f=e.RimRafMode||(e.RimRafMode={}));async function l(U,z=f.UNLINK){if((0,R.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");return z===f.UNLINK?S(U):v(U)}async function v(U){try{const z=(0,D.join)((0,L.tmpdir)(),(0,u.generateUuid)());try{await e.Promises.rename(U,z)}catch(O){return S(U)}S(z).catch(O=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function S(U){return e.Promises.rmdir(U,{recursive:!0,maxRetries:3})}function P(U){if((0,R.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");m.rmdirSync(U,{recursive:!0})}e.rimrafSync=P;async function E(U,z){return p(await(z?s(U):(0,I.promisify)(m.readdir)(U)))}async function s(U){try{return await(0,I.promisify)(m.readdir)(U,{withFileTypes:!0})}catch(B){console.warn("[node.js fs] readdir with filetypes failed with error: ",B)}const z=[],O=await E(U);for(const B of O){let x=!1,M=!1,H=!1;try{const W=await e.Promises.lstat((0,D.join)(U,B));x=W.isFile(),M=W.isDirectory(),H=W.isSymbolicLink()}catch(W){console.warn("[node.js fs] unexpected error from lstat after readdir: ",W)}z.push({name:B,isFile:()=>x,isDirectory:()=>M,isSymbolicLink:()=>H})}return z}function a(U){return p(m.readdirSync(U))}e.readdirSync=a;function p(U){return U.map(z=>typeof z=="string"?T.isMacintosh?(0,C.normalizeNFC)(z):z:(z.name=T.isMacintosh?(0,C.normalizeNFC)(z.name):z.name,z))}async function t(U){const z=await E(U),O=[];for(const B of z)await r.existsDirectory((0,D.join)(U,B))&&O.push(B);return O}function o(U,z=1e3){return new Promise(O=>{let B=!1;const x=setInterval(()=>{B||(B=!0,m.access(U,M=>{B=!1,M&&(clearInterval(x),O(void 0))}))},z)})}e.whenDeleted=o;var r;(function(U){async function z(x){let M;try{if(M=await e.Promises.lstat(x),!M.isSymbolicLink())return{stat:M}}catch(H){}try{return{stat:await e.Promises.stat(x),symbolicLink:M?.isSymbolicLink()?{dangling:!1}:void 0}}catch(H){if(H.code==="ENOENT"&&M)return{stat:M,symbolicLink:{dangling:!0}};if(T.isWindows&&H.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(W){if(W.code==="ENOENT"&&M)return{stat:M,symbolicLink:{dangling:!0}};throw W}throw H}}U.stat=z;async function O(x){try{const{stat:M,symbolicLink:H}=await U.stat(x);return M.isFile()&&H?.dangling!==!0}catch(M){}return!1}U.existsFile=O;async function B(x){try{const{stat:M,symbolicLink:H}=await U.stat(x);return M.isDirectory()&&H?.dangling!==!0}catch(M){}return!1}U.existsDirectory=B})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new k.ResourceQueue;function h(U,z,O){return i.queueFor(A.URI.file(U),n.extUriBiasedIgnorePathCase).queue(()=>{const B=y(O);return new Promise((x,M)=>d(U,z,B,H=>H?M(H):x()))})}let c=!0;function d(U,z,O,B){if(!c)return m.writeFile(U,z,{mode:O.mode,flag:O.flag},B);m.open(U,O.flag,O.mode,(x,M)=>{if(x)return B(x);m.writeFile(M,z,H=>{if(H)return m.close(M,()=>B(H));m.fdatasync(M,W=>(W&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",W),c=!1),m.close(M,Q=>B(Q))))})})}function b(U,z,O){const B=y(O);if(!c)return m.writeFileSync(U,z,{mode:B.mode,flag:B.flag});const x=m.openSync(U,B.flag,B.mode);try{m.writeFileSync(x,z);try{m.fdatasyncSync(x)}catch(M){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",M),c=!1}}finally{m.closeSync(x)}}e.writeFileSync=b;function y(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function g(U,z){if(U===z)return;async function O(B){try{const x=await e.Promises.lstat(B);if(x.isDirectory()||x.isSymbolicLink())return;await e.Promises.utimes(B,x.atime,new Date)}catch(x){}}try{await e.Promises.rename(U,z),await O(z)}catch(B){if(U.toLowerCase()!==z.toLowerCase()&&B.code==="EXDEV"||U.endsWith("."))await _(U,z,{preserveSymlinks:!1}),await l(U,f.MOVE),await O(z);else throw B}}async function _(U,z,O){return F(U,z,{root:{source:U,target:z},options:O,handledSourcePaths:new Set})}const w=511;async function F(U,z,O){if(O.handledSourcePaths.has(U))return;O.handledSourcePaths.add(U);const{stat:B,symbolicLink:x}=await r.stat(U);if(x){if(O.options.preserveSymlinks)try{return await K(U,z,O)}catch(M){console.warn("[node.js fs] copy of symlink failed: ",M)}if(x.dangling)return}return B.isDirectory()?N(U,z,B.mode&w,O):G(U,z,B.mode&w)}async function N(U,z,O,B){await e.Promises.mkdir(z,{recursive:!0,mode:O});const x=await E(U);for(const M of x)await F((0,D.join)(U,M),(0,D.join)(z,M),B)}async function G(U,z,O){await e.Promises.copyFile(U,z),await e.Promises.chmod(z,O)}async function K(U,z,O){let B=await e.Promises.readlink(U);(0,R.isEqualOrParent)(B,O.root.source,!T.isLinux)&&(B=(0,D.join)(O.root.target,B.substr(O.root.source.length+1))),await e.Promises.symlink(B,z)}e.Promises=new class{get access(){return(0,I.promisify)(m.access)}get stat(){return(0,I.promisify)(m.stat)}get lstat(){return(0,I.promisify)(m.lstat)}get utimes(){return(0,I.promisify)(m.utimes)}get read(){return(0,I.promisify)(m.read)}get readFile(){return(0,I.promisify)(m.readFile)}get write(){return(0,I.promisify)(m.write)}get appendFile(){return(0,I.promisify)(m.appendFile)}get fdatasync(){return(0,I.promisify)(m.fdatasync)}get truncate(){return(0,I.promisify)(m.truncate)}get rename(){return(0,I.promisify)(m.rename)}get copyFile(){return(0,I.promisify)(m.copyFile)}get open(){return(0,I.promisify)(m.open)}get close(){return(0,I.promisify)(m.close)}get symlink(){return(0,I.promisify)(m.symlink)}get readlink(){return(0,I.promisify)(m.readlink)}get chmod(){return(0,I.promisify)(m.chmod)}get mkdir(){return(0,I.promisify)(m.mkdir)}get unlink(){return(0,I.promisify)(m.unlink)}get rmdir(){return(0,I.promisify)(m.rmdir)}get realpath(){return(0,I.promisify)(m.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return E}get readDirsInDir(){return t}get writeFile(){return h}get rm(){return l}get move(){return g}get copy(){return _}}}),define(me[105],ge([0,1,50,8,9,28]),function(J,e,m,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function R(n){const A=(0,L.dirname)(n);if(n===A)return n;const u=((0,L.basename)(n)||n).toLowerCase();try{const l=(0,k.readdirSync)(A).filter(v=>v.toLowerCase()===u);if(l.length===1){const v=R(A);if(v)return(0,L.join)(v,l[0])}else if(l.length>1){const v=l.indexOf(u);if(v>=0){const S=R(A);if(S)return(0,L.join)(S,l[v])}}}catch(f){}return null}e.realcaseSync=R;async function C(n){try{return await k.Promises.realpath(n)}catch(A){const u=T(n);return await k.Promises.access(u,m.constants.R_OK),u}}e.realpath=C;function D(n){try{return m.realpathSync(n)}catch(A){const u=T(n);return m.accessSync(u,m.constants.R_OK),u}}e.realpathSync=D;function T(n){return(0,I.rtrim)((0,L.normalize)(n),L.sep)}});var Ve=this&&this.__decorate||function(J,e,m,L){var I=arguments.length,k=I<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,m):L,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(J,e,m,L);else for(var C=J.length-1;C>=0;C--)(R=J[C])&&(k=(I<3?R(k):I>3?R(e,m,k):R(e,m))||k);return I>3&&k&&Object.defineProperty(e,m,k),k};define(me[106],ge([0,1,17,18,23,21,58,16,3,6,60,9,13]),function(J,e,m,L,I,k,R,C,D,T,n,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var f;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(f=e.RequestType||(e.RequestType={}));function l(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(v=e.ResponseType||(e.ResponseType={}));function S(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var P;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(P||(P={}));class E{constructor(M){this.buffer=M,this.pos=0}read(M){const H=this.buffer.slice(this.pos,this.pos+M);return this.pos+=H.byteLength,H}}class s{constructor(){this.buffers=[]}get buffer(){return I.VSBuffer.concat(this.buffers)}write(M){this.buffers.push(M)}}var a;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object"})(a||(a={}));function p(x){const M=I.VSBuffer.alloc(4);return M.writeUInt32BE(x,0),M}function t(x){return x.read(4).readUInt32BE(0)}function o(x){const M=I.VSBuffer.alloc(1);return M.writeUInt8(x,0),M}const r={Undefined:o(a.Undefined),String:o(a.String),Buffer:o(a.Buffer),VSBuffer:o(a.VSBuffer),Array:o(a.Array),Object:o(a.Object)},i=typeof Buffer!="undefined";function h(x,M){if(typeof M=="undefined")x.write(r.Undefined);else if(typeof M=="string"){const H=I.VSBuffer.fromString(M);x.write(r.String),x.write(p(H.byteLength)),x.write(H)}else if(i&&Buffer.isBuffer(M)){const H=I.VSBuffer.wrap(M);x.write(r.Buffer),x.write(p(H.byteLength)),x.write(H)}else if(M instanceof I.VSBuffer)x.write(r.VSBuffer),x.write(p(M.byteLength)),x.write(M);else if(Array.isArray(M)){x.write(r.Array),x.write(p(M.length));for(const H of M)h(x,H)}else{const H=I.VSBuffer.fromString(JSON.stringify(M));x.write(r.Object),x.write(p(H.byteLength)),x.write(H)}}function c(x){switch(x.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return x.read(t(x)).toString();case a.Buffer:return x.read(t(x)).buffer;case a.VSBuffer:return x.read(t(x));case a.Array:{const H=t(x),W=[];for(let Q=0;Q<H;Q++)W.push(c(x));return W}case a.Object:return JSON.parse(x.read(t(x)).toString())}}class d{constructor(M,H,W=null,Q=1e3){this.protocol=M,this.ctx=H,this.logger=W,this.timeoutDelay=Q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(X=>this.onRawMessage(X)),this.sendResponse({type:200})}registerChannel(M,H){this.channels.set(M,H),setTimeout(()=>this.flushPendingRequests(M),0)}sendResponse(M){switch(M.type){case 200:{const H=this.send([M.type]);this.logger&&this.logger.logOutgoing(H,0,1,S(M.type));return}case 201:case 202:case 204:case 203:{const H=this.send([M.type,M.id],M.data);this.logger&&this.logger.logOutgoing(H,M.id,1,S(M.type),M.data);return}}}send(M,H=void 0){const W=new s;return h(W,M),h(W,H),this.sendBuffer(W.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch(H){return 0}}onRawMessage(M){const H=new E(M),W=c(H),Q=c(H),X=W[0];switch(X){case 100:return this.logger&&this.logger.logIncoming(M.byteLength,W[1],1,`${l(X)}: ${W[2]}.${W[3]}`,Q),this.onPromise({type:X,id:W[1],channelName:W[2],name:W[3],arg:Q});case 102:return this.logger&&this.logger.logIncoming(M.byteLength,W[1],1,`${l(X)}: ${W[2]}.${W[3]}`,Q),this.onEventListen({type:X,id:W[1],channelName:W[2],name:W[3],arg:Q});case 101:return this.logger&&this.logger.logIncoming(M.byteLength,W[1],1,`${l(X)}`),this.disposeActiveRequest({type:X,id:W[1]});case 103:return this.logger&&this.logger.logIncoming(M.byteLength,W[1],1,`${l(X)}`),this.disposeActiveRequest({type:X,id:W[1]})}}onPromise(M){const H=this.channels.get(M.channelName);if(!H){this.collectPendingRequest(M);return}const W=new k.CancellationTokenSource;let Q;try{Q=H.call(this.ctx,M.name,M.arg,W.token)}catch(_e){Q=Promise.reject(_e)}const X=M.id;Q.then(_e=>{this.sendResponse({id:X,data:_e,type:201}),this.activeRequests.delete(M.id)},_e=>{_e instanceof Error?this.sendResponse({id:X,data:{message:_e.message,name:_e.name,stack:_e.stack?_e.stack.split?_e.stack.split(`
`):_e.stack:void 0},type:202}):this.sendResponse({id:X,data:_e,type:203}),this.activeRequests.delete(M.id)});const he=(0,T.toDisposable)(()=>W.cancel());this.activeRequests.set(M.id,he)}onEventListen(M){const H=this.channels.get(M.channelName);if(!H){this.collectPendingRequest(M);return}const W=M.id,X=H.listen(this.ctx,M.name,M.arg)(he=>this.sendResponse({id:W,data:he,type:204}));this.activeRequests.set(M.id,X)}disposeActiveRequest(M){const H=this.activeRequests.get(M.id);H&&(H.dispose(),this.activeRequests.delete(M.id))}collectPendingRequest(M){let H=this.pendingRequests.get(M.channelName);H||(H=[],this.pendingRequests.set(M.channelName,H));const W=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.sendResponse({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);H.push({request:M,timeoutTimer:W})}flushPendingRequests(M){const H=this.pendingRequests.get(M);if(H){for(const W of H)switch(clearTimeout(W.timeoutTimer),W.request.type){case 100:this.onPromise(W.request);break;case 102:this.onEventListen(W.request);break}this.pendingRequests.delete(M)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(M=>M.dispose()),this.activeRequests.clear()}}e.ChannelServer=d;var b;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(b=e.RequestInitiator||(e.RequestInitiator={}));class y{constructor(M,H=null){this.protocol=M,this.isDisposed=!1,this.state=P.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new D.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(W=>this.onBuffer(W)),this.logger=H}getChannel(M){const H=this;return{call(W,Q,X){return H.isDisposed?Promise.reject(C.canceled()):H.requestPromise(M,W,Q,X)},listen(W,Q){return H.isDisposed?Promise.reject(C.canceled()):H.requestEvent(M,W,Q)}}}requestPromise(M,H,W,Q=k.CancellationToken.None){const X=this.lastRequestId++,_e={id:X,type:100,channelName:M,name:H,arg:W};if(Q.isCancellationRequested)return Promise.reject(C.canceled());let ye;return new Promise(($e,Be)=>{if(Q.isCancellationRequested)return Be(C.canceled());const je=()=>{const ae=Y=>{switch(Y.type){case 201:this.handlers.delete(X),$e(Y.data);break;case 202:this.handlers.delete(X);const oe=new Error(Y.data.message);oe.stack=Y.data.stack,oe.name=Y.data.name,Be(oe);break;case 203:this.handlers.delete(X),Be(Y.data);break}};this.handlers.set(X,ae),this.sendRequest(_e)};let V=null;this.state===P.Idle?je():(V=(0,L.createCancelablePromise)(ae=>this.whenInitialized()),V.then(()=>{V=null,je()}));const ee=()=>{V?(V.cancel(),V=null):this.sendRequest({id:X,type:101}),Be(C.canceled())},re=Q.onCancellationRequested(ee);ye=(0,T.combinedDisposable)((0,T.toDisposable)(ee),re),this.activeRequests.add(ye)}).finally(()=>{this.activeRequests.delete(ye)})}requestEvent(M,H,W){const Q=this.lastRequestId++,he={id:Q,type:102,channelName:M,name:H,arg:W};let _e=null;const ye=new D.Emitter({onFirstListenerAdd:()=>{_e=(0,L.createCancelablePromise)($e=>this.whenInitialized()),_e.then(()=>{_e=null,this.activeRequests.add(ye),this.sendRequest(he)})},onLastListenerRemove:()=>{_e?(_e.cancel(),_e=null):(this.activeRequests.delete(ye),this.sendRequest({id:Q,type:103}))}}),Re=$e=>ye.fire($e.data);return this.handlers.set(Q,Re),ye.event}sendRequest(M){switch(M.type){case 100:case 102:{const H=this.send([M.type,M.id,M.channelName,M.name],M.arg);this.logger&&this.logger.logOutgoing(H,M.id,0,`${l(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const H=this.send([M.type,M.id]);this.logger&&this.logger.logOutgoing(H,M.id,0,l(M.type));return}}}send(M,H=void 0){const W=new s;return h(W,M),h(W,H),this.sendBuffer(W.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch(H){return 0}}onBuffer(M){const H=new E(M),W=c(H),Q=c(H),X=W[0];switch(X){case 200:return this.logger&&this.logger.logIncoming(M.byteLength,0,0,S(X)),this.onResponse({type:W[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(M.byteLength,W[1],0,S(X),Q),this.onResponse({type:W[0],id:W[1],data:Q})}}onResponse(M){if(M.type===200){this.state=P.Idle,this._onDidInitialize.fire();return}const H=this.handlers.get(M.id);H&&H(M)}get onDidInitializePromise(){return D.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===P.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(M=>M.dispose()),this.activeRequests.clear()}}Ve([R.memoize],y.prototype,"onDidInitializePromise",null),e.ChannelClient=y;class g{constructor(M){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new D.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new D.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,M(({protocol:H,onDidClientDisconnect:W})=>{D.Event.once(H.onMessage)(X=>{const he=new E(X),_e=c(he),ye=new d(H,_e),Re=new y(H);this.channels.forEach((Be,je)=>ye.registerChannel(je,Be));const $e={channelServer:ye,channelClient:Re,ctx:_e};this._connections.add($e),this._onDidAddConnection.fire($e),W(()=>{ye.dispose(),Re.dispose(),this._connections.delete($e),this._onDidRemoveConnection.fire($e)})})})}get connections(){const M=[];return this._connections.forEach(H=>M.push(H)),M}getChannel(M,H){const W=this;return{call(Q,X,he){let _e;if((0,u.isFunction)(H)){let Re=(0,m.getRandomElement)(W.connections.filter(H));_e=Re?Promise.resolve(Re):D.Event.toPromise(D.Event.filter(W.onDidAddConnection,H))}else _e=H.routeCall(W,Q,X);const ye=_e.then(Re=>Re.channelClient.getChannel(M));return w(ye).call(Q,X,he)},listen(Q,X){if((0,u.isFunction)(H))return W.getMulticastEvent(M,H,Q,X);const he=H.routeEvent(W,Q,X).then(_e=>_e.channelClient.getChannel(M));return w(he).listen(Q,X)}}}getMulticastEvent(M,H,W,Q){const X=this;let he=new T.DisposableStore;const _e=new D.Emitter({onFirstListenerAdd:()=>{he=new T.DisposableStore;const ye=new D.EventMultiplexer,Re=new Map,$e=je=>{const ee=je.channelClient.getChannel(M).listen(W,Q),re=ye.add(ee);Re.set(je,re)},Be=je=>{const V=Re.get(je);!V||(V.dispose(),Re.delete(je))};X.connections.filter(H).forEach($e),D.Event.filter(X.onDidAddConnection,H)($e,void 0,he),X.onDidRemoveConnection(Be,void 0,he),ye.event(_e.fire,_e,he),he.add(ye)},onLastListenerRemove:()=>{he.dispose()}});return _e.event}registerChannel(M,H){this.channels.set(M,H),this._connections.forEach(W=>{W.channelServer.registerChannel(M,H)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=g;class _{constructor(M,H,W=null){const Q=new s;h(Q,H),M.send(Q.buffer),this.channelClient=new y(M,W),this.channelServer=new d(M,H,W)}getChannel(M){return this.channelClient.getChannel(M)}registerChannel(M,H){this.channelServer.registerChannel(M,H)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=_;function w(x){return{call(M,H,W){return x.then(Q=>Q.call(M,H,W))},listen(M,H){const W=new D.Relay;return x.then(Q=>W.input=Q.listen(M,H)),W.event}}}e.getDelayedChannel=w;function F(x){let M=!1;return{call(H,W,Q){return M?x.call(H,W,Q):(0,L.timeout)(0).then(()=>M=!0).then(()=>x.call(H,W,Q))},listen(H,W){if(M)return x.listen(H,W);const Q=new D.Relay;return(0,L.timeout)(0).then(()=>M=!0).then(()=>Q.input=x.listen(H,W)),Q.event}}}e.getNextTickChannel=F;class N{constructor(M){this.fn=M}routeCall(M){return this.route(M)}routeEvent(M){return this.route(M)}async route(M){for(const H of M.connections)if(await Promise.resolve(this.fn(H.ctx)))return Promise.resolve(H);return await D.Event.toPromise(M.onDidAddConnection),await this.route(M)}}e.StaticRouter=N;var G;(function(x){function M(Q,X){const he=Q,_e=X&&X.disableMarshalling,ye=new Map;for(const Re in he)W(Re)&&ye.set(Re,D.Event.buffer(he[Re],!0));return new class{listen(Re,$e){const Be=ye.get($e);if(Be)return Be;throw new Error(`Event not found: ${$e}`)}call(Re,$e,Be){const je=he[$e];if(typeof je=="function"){if(!_e&&Array.isArray(Be))for(let V=0;V<Be.length;V++)Be[V]=(0,n.revive)(Be[V]);return je.apply(he,Be)}throw new Error(`Method not found: ${$e}`)}}}x.fromService=M;function H(Q,X){const he=X&&X.disableMarshalling;return new Proxy({},{get(_e,ye){if(typeof ye=="string")return X?.properties?.has(ye)?X.properties.get(ye):W(ye)?Q.listen(ye):async function(...Re){let $e;X&&!(0,u.isUndefinedOrNull)(X.context)?$e=[X.context,...Re]:$e=Re;const Be=await Q.call(ye,$e);return he?Be:(0,n.revive)(Be)};throw new Error(`Property not found: ${String(ye)}`)}})}x.toService=H;function W(Q){return Q[0]==="o"&&Q[1]==="n"&&A.isUpperAsciiLetter(Q.charCodeAt(2))}})(G=e.ProxyChannel||(e.ProxyChannel={}));const K=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){let M=x.toString();if(M!=="[object Object]")return M}return x}function z(x){return Array.isArray(x)?x.map(U):U(x)}function O(x,M,H,W,Q,X,he){he=z(he);const _e=K[Q],ye=_e[W%_e.length];let Re=[`%c[${x}]%c[${String(M).padStart(7," ")}]%c[len: ${String(H).padStart(5," ")}]%c${String(W).padStart(5," ")} - ${X}`,"color: darkgreen","color: grey","color: grey",`color: ${ye}`];/\($/.test(X)?(Re=Re.concat(he),Re.push(")")):Re.push(he),console.log.apply(console,Re)}e.logWithColors=O;class B{constructor(M,H){this._outgoingPrefix=M,this._incomingPrefix=H,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(M,H,W,Q,X){this._totalOutgoing+=M,O(this._outgoingPrefix,this._totalOutgoing,M,H,W,Q,X)}logIncoming(M,H,W,Q,X){this._totalIncoming+=M,O(this._incomingPrefix,this._totalIncoming,M,H,W,Q,X)}}e.IPCLogger=B}),define(me[107],ge([0,1,23,3,6,11,34,106]),function(J,e,m,L,I,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var D;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(D=e.SocketCloseEventType||(e.SocketCloseEventType={}));let T=null;function n(){return T||(T=m.VSBuffer.alloc(0)),T}class A{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(i){this._chunks.push(i),this._totalLength+=i.byteLength}read(i){return this._read(i,!0)}peek(i){return this._read(i,!1)}_read(i,h){if(i===0)return n();if(i>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===i){const y=this._chunks[0];return h&&(this._chunks.shift(),this._totalLength-=i),y}if(this._chunks[0].byteLength>i){const y=this._chunks[0].slice(0,i);return h&&(this._chunks[0]=this._chunks[0].slice(i),this._totalLength-=i),y}let c=m.VSBuffer.alloc(i),d=0,b=0;for(;i>0;){const y=this._chunks[b];if(y.byteLength>i){const g=y.slice(0,i);c.set(g,d),d+=i,h&&(this._chunks[b]=y.slice(i),this._totalLength-=i),i-=i}else c.set(y,d),d+=y.byteLength,h?(this._chunks.shift(),this._totalLength-=y.byteLength):b++,i-=y.byteLength}return c}}e.ChunkStream=A;var u;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(u||(u={}));var f;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(f=e.ProtocolConstants||(e.ProtocolConstants={}));class l{constructor(i,h,c,d){this.type=i,this.id=h,this.ack=c,this.data=d,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends I.Disposable{constructor(i){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=i,this._isDisposed=!1,this._incomingData=new A,this._register(this._socket.onData(h=>this.acceptChunk(h))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(i);this._incomingData.byteLength>=this._state.readLen;){const h=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=h.readUInt32BE(9),this._state.messageType=h.readUInt8(0),this._state.id=h.readUInt32BE(1),this._state.ack=h.readUInt32BE(5);else{const c=this._state.messageType,d=this._state.id,b=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new l(c,d,b,h)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class S{constructor(i){this._isDisposed=!1,this._socket=i,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(i){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(i){if(this._isDisposed)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const h=m.VSBuffer.alloc(13);h.writeUInt8(i.type,0),h.writeUInt32BE(i.id,1),h.writeUInt32BE(i.ack,5),h.writeUInt32BE(i.data.byteLength,9),this._writeSoon(h,i.data)}_bufferAdd(i,h){const c=this._totalLength===0;return this._data.push(i,h),this._totalLength+=i.byteLength+h.byteLength,c}_bufferTake(){const i=m.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,i}_writeSoon(i,h){this._bufferAdd(i,h)&&k.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class P extends I.Disposable{constructor(i){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=i,this._socketWriter=this._register(new S(this._socket)),this._socketReader=this._register(new v(this._socket)),this._register(this._socketReader.onMessage(h=>{h.type===1&&this._onMessage.fire(h.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(i){this._socketWriter.write(new l(1,0,0,i))}}e.Protocol=P;class E extends C.IPCClient{constructor(i,h,c=null){super(i,h,c);this.protocol=i}static fromSocket(i,h){return new E(new P(i),h)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const i=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),i.end()}}e.Client=E;class s{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,R.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(i){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(i):this._emitter.fire(i):this._bufferedMessages.push(i)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=s;class a{constructor(i){this.data=i,this.next=null}}class p{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let i=[],h=0,c=this._first;for(;c;)i[h++]=c.data,c=c.next;return i}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(i){const h=new a(i);if(!this._first){this._first=h,this._last=h;return}this._last.next=h,this._last=h}}class t{constructor(){this.lastRuns=[];const i=Date.now();for(let h=0;h<t._HISTORY_LENGTH;h++)this.lastRuns[h]=i-1e3*h;setInterval(()=>{for(let h=t._HISTORY_LENGTH;h>=1;h--)this.lastRuns[h]=this.lastRuns[h-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const i=Date.now(),h=(1+t._HISTORY_LENGTH)*1e3;let c=0;for(let d=0;d<t._HISTORY_LENGTH;d++)i-this.lastRuns[d]<=h&&c++;return 1-c/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class o{constructor(i,h=null,c=t.getInstance()){this._onControlMessage=new s,this.onControlMessage=this._onControlMessage.event,this._onMessage=new s,this.onMessage=this._onMessage.event,this._onDidDispose=new s,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new s,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new s,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=c,this._isReconnecting=!1,this._outgoingUnackMsg=new p,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=i,this._socketWriter=new S(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.push(this._socket.onClose(d=>this._onSocketClose.fire(d))),h&&this._socketReader.acceptChunk(h),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,I.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const i=new l(5,0,0,n());this._socketWriter.write(i),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const i=Date.now()-this._socketWriter.lastWriteTime;if(i>=5e3){const h=new l(4,0,0,n());this._socketWriter.write(h),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-i+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const i=Date.now()-this._socketReader.lastReadTime;if(i>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-i,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(i,h){this._isReconnecting=!0,this._socketDisposables=(0,I.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=i,this._socketWriter=new S(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(c=>this._onSocketClose.fire(c))),this._socketReader.acceptChunk(h)}endAcceptReconnection(){this._isReconnecting=!1;const i=this._outgoingUnackMsg.toArray();for(let h=0,c=i.length;h<c;h++)this._socketWriter.write(i[h]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(i){if(i.ack>this._outgoingAckId){this._outgoingAckId=i.ack;do{const h=this._outgoingUnackMsg.peek();if(h&&h.id<=i.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(i.type===1){if(i.id>this._incomingMsgId)if(i.id!==this._incomingMsgId+1){const h=Date.now();h-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=h,this._socketWriter.write(new l(6,0,0,n())))}else this._incomingMsgId=i.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(i.data)}else if(i.type===2)this._onControlMessage.fire(i.data);else if(i.type===5)this._onDidDispose.fire();else if(i.type===6){const h=this._outgoingUnackMsg.toArray();for(let c=0,d=h.length;c<d;c++)this._socketWriter.write(h[c]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(i){const h=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const c=new l(1,h,this._incomingAckId,i);this._outgoingUnackMsg.push(c),this._isReconnecting||(this._socketWriter.write(c),this._recvAckCheck())}sendControl(i){const h=new l(2,0,0,i);this._socketWriter.write(h)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const i=Date.now()-this._incomingMsgLastTime;if(i>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-i+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const i=this._outgoingUnackMsg.peek(),h=Date.now()-i.writtenTime;if(h>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-h,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const i=new l(3,0,this._incomingAckId,n());this._socketWriter.write(i)}}e.PersistentProtocol=o}),define(me[108],ge([0,1,97]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class L{constructor(C){let D=(0,m.toUint8)(C);this._defaultValue=D,this._asciiMap=L._createAsciiMap(D),this._map=new Map}static _createAsciiMap(C){let D=new Uint8Array(256);for(let T=0;T<256;T++)D[T]=C;return D}set(C,D){let T=(0,m.toUint8)(D);C>=0&&C<256?this._asciiMap[C]=T:this._map.set(C,T)}get(C){return C>=0&&C<256?this._asciiMap[C]:this._map.get(C)||this._defaultValue}}e.CharacterClassifier=L;var I;(function(R){R[R.False=0]="False",R[R.True=1]="True"})(I||(I={}));class k{constructor(){this._actual=new L(0)}add(C){this._actual.set(C,1)}has(C){return this._actual.get(C)===1}}e.CharacterSet=k}),define(me[143],ge([0,1,108]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var L;(function(R){R[R.Regular=0]="Regular",R[R.Whitespace=1]="Whitespace",R[R.WordSeparator=2]="WordSeparator"})(L=e.WordCharacterClass||(e.WordCharacterClass={}));class I extends m.CharacterClassifier{constructor(C){super(0);for(let D=0,T=C.length;D<T;D++)this.set(C.charCodeAt(D),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=I;function k(R){let C={};return D=>(C.hasOwnProperty(D)||(C[D]=R(D)),C[D])}e.getMapForWordSeparators=k(R=>new I(R))}),define(me[51],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class m{constructor(I,k){this.lineNumber=I,this.column=k}with(I=this.lineNumber,k=this.column){return I===this.lineNumber&&k===this.column?this:new m(I,k)}delta(I=0,k=0){return this.with(this.lineNumber+I,this.column+k)}equals(I){return m.equals(this,I)}static equals(I,k){return!I&&!k?!0:!!I&&!!k&&I.lineNumber===k.lineNumber&&I.column===k.column}isBefore(I){return m.isBefore(this,I)}static isBefore(I,k){return I.lineNumber<k.lineNumber?!0:k.lineNumber<I.lineNumber?!1:I.column<k.column}isBeforeOrEqual(I){return m.isBeforeOrEqual(this,I)}static isBeforeOrEqual(I,k){return I.lineNumber<k.lineNumber?!0:k.lineNumber<I.lineNumber?!1:I.column<=k.column}static compare(I,k){let R=I.lineNumber|0,C=k.lineNumber|0;if(R===C){let D=I.column|0,T=k.column|0;return D-T}return R-C}clone(){return new m(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(I){return new m(I.lineNumber,I.column)}static isIPosition(I){return I&&typeof I.lineNumber=="number"&&typeof I.column=="number"}}e.Position=m}),define(me[41],ge([0,1,51]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class L{constructor(k,R,C,D){k>C||k===C&&R>D?(this.startLineNumber=C,this.startColumn=D,this.endLineNumber=k,this.endColumn=R):(this.startLineNumber=k,this.startColumn=R,this.endLineNumber=C,this.endColumn=D)}isEmpty(){return L.isEmpty(this)}static isEmpty(k){return k.startLineNumber===k.endLineNumber&&k.startColumn===k.endColumn}containsPosition(k){return L.containsPosition(this,k)}static containsPosition(k,R){return!(R.lineNumber<k.startLineNumber||R.lineNumber>k.endLineNumber||R.lineNumber===k.startLineNumber&&R.column<k.startColumn||R.lineNumber===k.endLineNumber&&R.column>k.endColumn)}containsRange(k){return L.containsRange(this,k)}static containsRange(k,R){return!(R.startLineNumber<k.startLineNumber||R.endLineNumber<k.startLineNumber||R.startLineNumber>k.endLineNumber||R.endLineNumber>k.endLineNumber||R.startLineNumber===k.startLineNumber&&R.startColumn<k.startColumn||R.endLineNumber===k.endLineNumber&&R.endColumn>k.endColumn)}strictContainsRange(k){return L.strictContainsRange(this,k)}static strictContainsRange(k,R){return!(R.startLineNumber<k.startLineNumber||R.endLineNumber<k.startLineNumber||R.startLineNumber>k.endLineNumber||R.endLineNumber>k.endLineNumber||R.startLineNumber===k.startLineNumber&&R.startColumn<=k.startColumn||R.endLineNumber===k.endLineNumber&&R.endColumn>=k.endColumn)}plusRange(k){return L.plusRange(this,k)}static plusRange(k,R){let C,D,T,n;return R.startLineNumber<k.startLineNumber?(C=R.startLineNumber,D=R.startColumn):R.startLineNumber===k.startLineNumber?(C=R.startLineNumber,D=Math.min(R.startColumn,k.startColumn)):(C=k.startLineNumber,D=k.startColumn),R.endLineNumber>k.endLineNumber?(T=R.endLineNumber,n=R.endColumn):R.endLineNumber===k.endLineNumber?(T=R.endLineNumber,n=Math.max(R.endColumn,k.endColumn)):(T=k.endLineNumber,n=k.endColumn),new L(C,D,T,n)}intersectRanges(k){return L.intersectRanges(this,k)}static intersectRanges(k,R){let C=k.startLineNumber,D=k.startColumn,T=k.endLineNumber,n=k.endColumn,A=R.startLineNumber,u=R.startColumn,f=R.endLineNumber,l=R.endColumn;return C<A?(C=A,D=u):C===A&&(D=Math.max(D,u)),T>f?(T=f,n=l):T===f&&(n=Math.min(n,l)),C>T||C===T&&D>n?null:new L(C,D,T,n)}equalsRange(k){return L.equalsRange(this,k)}static equalsRange(k,R){return!!k&&!!R&&k.startLineNumber===R.startLineNumber&&k.startColumn===R.startColumn&&k.endLineNumber===R.endLineNumber&&k.endColumn===R.endColumn}getEndPosition(){return L.getEndPosition(this)}static getEndPosition(k){return new m.Position(k.endLineNumber,k.endColumn)}getStartPosition(){return L.getStartPosition(this)}static getStartPosition(k){return new m.Position(k.startLineNumber,k.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(k,R){return new L(this.startLineNumber,this.startColumn,k,R)}setStartPosition(k,R){return new L(k,R,this.endLineNumber,this.endColumn)}collapseToStart(){return L.collapseToStart(this)}static collapseToStart(k){return new L(k.startLineNumber,k.startColumn,k.startLineNumber,k.startColumn)}static fromPositions(k,R=k){return new L(k.lineNumber,k.column,R.lineNumber,R.column)}static lift(k){return k?new L(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn):null}static isIRange(k){return k&&typeof k.startLineNumber=="number"&&typeof k.startColumn=="number"&&typeof k.endLineNumber=="number"&&typeof k.endColumn=="number"}static areIntersectingOrTouching(k,R){return!(k.endLineNumber<R.startLineNumber||k.endLineNumber===R.startLineNumber&&k.endColumn<R.startColumn||R.endLineNumber<k.startLineNumber||R.endLineNumber===k.startLineNumber&&R.endColumn<k.startColumn)}static areIntersecting(k,R){return!(k.endLineNumber<R.startLineNumber||k.endLineNumber===R.startLineNumber&&k.endColumn<=R.startColumn||R.endLineNumber<k.startLineNumber||R.endLineNumber===k.startLineNumber&&R.endColumn<=k.startColumn)}static compareRangesUsingStarts(k,R){if(k&&R){const T=k.startLineNumber|0,n=R.startLineNumber|0;if(T===n){const A=k.startColumn|0,u=R.startColumn|0;if(A===u){const f=k.endLineNumber|0,l=R.endLineNumber|0;if(f===l){const v=k.endColumn|0,S=R.endColumn|0;return v-S}return f-l}return A-u}return T-n}return(k?1:0)-(R?1:0)}static compareRangesUsingEnds(k,R){return k.endLineNumber===R.endLineNumber?k.endColumn===R.endColumn?k.startLineNumber===R.startLineNumber?k.startColumn-R.startColumn:k.startLineNumber-R.startLineNumber:k.endColumn-R.endColumn:k.endLineNumber-R.endLineNumber}static spansMultipleLines(k){return k.endLineNumber>k.startLineNumber}}e.Range=L}),define(me[144],ge([0,1,51,41]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var I;(function(R){R[R.LTR=0]="LTR",R[R.RTL=1]="RTL"})(I=e.SelectionDirection||(e.SelectionDirection={}));class k extends L.Range{constructor(C,D,T,n){super(C,D,T,n);this.selectionStartLineNumber=C,this.selectionStartColumn=D,this.positionLineNumber=T,this.positionColumn=n}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(C){return k.selectionsEqual(this,C)}static selectionsEqual(C,D){return C.selectionStartLineNumber===D.selectionStartLineNumber&&C.selectionStartColumn===D.selectionStartColumn&&C.positionLineNumber===D.positionLineNumber&&C.positionColumn===D.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(C,D){return this.getDirection()===0?new k(this.startLineNumber,this.startColumn,C,D):new k(C,D,this.startLineNumber,this.startColumn)}getPosition(){return new m.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(C,D){return this.getDirection()===0?new k(C,D,this.endLineNumber,this.endColumn):new k(this.endLineNumber,this.endColumn,C,D)}static fromPositions(C,D=C){return new k(C.lineNumber,C.column,D.lineNumber,D.column)}static liftSelection(C){return new k(C.selectionStartLineNumber,C.selectionStartColumn,C.positionLineNumber,C.positionColumn)}static selectionsArrEqual(C,D){if(C&&!D||!C&&D)return!1;if(!C&&!D)return!0;if(C.length!==D.length)return!1;for(let T=0,n=C.length;T<n;T++)if(!this.selectionsEqual(C[T],D[T]))return!1;return!0}static isISelection(C){return C&&typeof C.selectionStartLineNumber=="number"&&typeof C.selectionStartColumn=="number"&&typeof C.positionLineNumber=="number"&&typeof C.positionColumn=="number"}static createWithDirection(C,D,T,n,A){return A===0?new k(C,D,T,n):new k(T,n,C,D)}}e.Selection=k}),define(me[109],ge([0,1,25]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var L;(function(v){v[v.Left=1]="Left",v[v.Center=2]="Center",v[v.Right=4]="Right",v[v.Full=7]="Full"})(L=e.OverviewRulerLane||(e.OverviewRulerLane={}));var I;(function(v){v[v.Inline=1]="Inline",v[v.Gutter=2]="Gutter"})(I=e.MinimapPosition||(e.MinimapPosition={}));var k;(function(v){v[v.TextDefined=0]="TextDefined",v[v.LF=1]="LF",v[v.CRLF=2]="CRLF"})(k=e.EndOfLinePreference||(e.EndOfLinePreference={}));var R;(function(v){v[v.LF=1]="LF",v[v.CRLF=2]="CRLF"})(R=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var C;(function(v){v[v.LF=0]="LF",v[v.CRLF=1]="CRLF"})(C=e.EndOfLineSequence||(e.EndOfLineSequence={}));class D{constructor(S){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,S.tabSize|0),this.indentSize=S.tabSize|0,this.insertSpaces=Boolean(S.insertSpaces),this.defaultEOL=S.defaultEOL|0,this.trimAutoWhitespace=Boolean(S.trimAutoWhitespace),this.bracketPairColorizationOptions=S.bracketPairColorizationOptions}equals(S){return this.tabSize===S.tabSize&&this.indentSize===S.indentSize&&this.insertSpaces===S.insertSpaces&&this.defaultEOL===S.defaultEOL&&this.trimAutoWhitespace===S.trimAutoWhitespace&&(0,m.equals)(this.bracketPairColorizationOptions,S.bracketPairColorizationOptions)}createChangeEvent(S){return{tabSize:this.tabSize!==S.tabSize,indentSize:this.indentSize!==S.indentSize,insertSpaces:this.insertSpaces!==S.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==S.trimAutoWhitespace}}}e.TextModelResolvedOptions=D;class T{constructor(S,P){this._findMatchBrand=void 0,this.range=S,this.matches=P}}e.FindMatch=T;var n;(function(v){v[v.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",v[v.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",v[v.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",v[v.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(n=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var A;(function(v){v[v.Left=0]="Left",v[v.Right=1]="Right",v[v.None=2]="None"})(A=e.PositionAffinity||(e.PositionAffinity={}));var u;(function(v){v[v.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(u=e.ModelConstants||(e.ModelConstants={}));class f{constructor(S,P,E,s,a,p){this.identifier=S,this.range=P,this.text=E,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=a,this._isTracked=p}}e.ValidAnnotatedEditOperation=f;class l{constructor(S,P,E){this.reverseEdits=S,this.changes=P,this.trimAutoWhitespaceLineNumbers=E}}e.ApplyEditsResult=l}),define(me[145],ge([0,1,9,143,51,41,109]),function(J,e,m,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const C=999;class D{constructor(s,a,p,t){this.searchString=s,this.isRegex=a,this.matchCase=p,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let s;this.isRegex?s=T(this.searchString):s=this.searchString.indexOf(`
`)>=0;let a=null;try{a=m.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:s,global:!0,unicode:!0})}catch(t){return null}if(!a)return null;let p=!this.isRegex&&!s;return p&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(p=this.matchCase),new n(a,this.wordSeparators?(0,L.getMapForWordSeparators)(this.wordSeparators):null,p?this.searchString:null)}}e.SearchParams=D;function T(E){if(!E||E.length===0)return!1;for(let s=0,a=E.length;s<a;s++)if(E.charCodeAt(s)===92){if(s++,s>=a)break;const t=E.charCodeAt(s);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=T;class n{constructor(s,a,p){this.regex=s,this.wordSeparators=a,this.simpleSearch=p}}e.SearchData=n;function A(E,s,a){if(!a)return new R.FindMatch(E,null);let p=[];for(let t=0,o=s.length;t<o;t++)p[t]=s[t];return new R.FindMatch(E,p)}e.createFindMatch=A;class u{constructor(s){let a=[],p=0;for(let t=0,o=s.length;t<o;t++)s.charCodeAt(t)===10&&(a[p++]=t);this._lineFeedsOffsets=a}findLineFeedCountBeforeOffset(s){const a=this._lineFeedsOffsets;let p=0,t=a.length-1;if(t===-1||s<=a[0])return 0;for(;p<t;){const o=p+((t-p)/2>>0);a[o]>=s?t=o-1:a[o+1]>=s?(p=o,t=o):p=o+1}return p+1}}class f{static findMatches(s,a,p,t,o){const r=a.parseSearchRequest();return r?r.regex.multiline?this._doFindMatchesMultiline(s,p,new P(r.wordSeparators,r.regex),t,o):this._doFindMatchesLineByLine(s,p,r,t,o):[]}static _getMultilineMatchRange(s,a,p,t,o,r){let i,h=0;t?(h=t.findLineFeedCountBeforeOffset(o),i=a+o+h):i=a+o;let c;if(t){let g=t.findLineFeedCountBeforeOffset(o+r.length)-h;c=i+r.length+g}else c=i+r.length;const d=s.getPositionAt(i),b=s.getPositionAt(c);return new k.Range(d.lineNumber,d.column,b.lineNumber,b.column)}static _doFindMatchesMultiline(s,a,p,t,o){const r=s.getOffsetAt(a.getStartPosition()),i=s.getValueInRange(a,1),h=s.getEOL()===`\r
`?new u(i):null,c=[];let d=0,b;for(p.reset(0);b=p.next(i);)if(c[d++]=A(this._getMultilineMatchRange(s,r,i,h,b.index,b[0]),b,t),d>=o)return c;return c}static _doFindMatchesLineByLine(s,a,p,t,o){const r=[];let i=0;if(a.startLineNumber===a.endLineNumber){const c=s.getLineContent(a.startLineNumber).substring(a.startColumn-1,a.endColumn-1);return i=this._findMatchesInLine(p,c,a.startLineNumber,a.startColumn-1,i,r,t,o),r}const h=s.getLineContent(a.startLineNumber).substring(a.startColumn-1);i=this._findMatchesInLine(p,h,a.startLineNumber,a.startColumn-1,i,r,t,o);for(let c=a.startLineNumber+1;c<a.endLineNumber&&i<o;c++)i=this._findMatchesInLine(p,s.getLineContent(c),c,0,i,r,t,o);if(i<o){const c=s.getLineContent(a.endLineNumber).substring(0,a.endColumn-1);i=this._findMatchesInLine(p,c,a.endLineNumber,0,i,r,t,o)}return r}static _findMatchesInLine(s,a,p,t,o,r,i,h){const c=s.wordSeparators;if(!i&&s.simpleSearch){const y=s.simpleSearch,g=y.length,_=a.length;let w=-g;for(;(w=a.indexOf(y,w+g))!==-1;)if((!c||S(c,a,_,w,g))&&(r[o++]=new R.FindMatch(new k.Range(p,w+1+t,p,w+1+g+t),null),o>=h))return o;return o}const d=new P(s.wordSeparators,s.regex);let b;d.reset(0);do if(b=d.next(a),b&&(r[o++]=A(new k.Range(p,b.index+1+t,p,b.index+1+b[0].length+t),b,i),o>=h))return o;while(b);return o}static findNextMatch(s,a,p,t){const o=a.parseSearchRequest();if(!o)return null;const r=new P(o.wordSeparators,o.regex);return o.regex.multiline?this._doFindNextMatchMultiline(s,p,r,t):this._doFindNextMatchLineByLine(s,p,r,t)}static _doFindNextMatchMultiline(s,a,p,t){const o=new I.Position(a.lineNumber,1),r=s.getOffsetAt(o),i=s.getLineCount(),h=s.getValueInRange(new k.Range(o.lineNumber,o.column,i,s.getLineMaxColumn(i)),1),c=s.getEOL()===`\r
`?new u(h):null;p.reset(a.column-1);let d=p.next(h);return d?A(this._getMultilineMatchRange(s,r,h,c,d.index,d[0]),d,t):a.lineNumber!==1||a.column!==1?this._doFindNextMatchMultiline(s,new I.Position(1,1),p,t):null}static _doFindNextMatchLineByLine(s,a,p,t){const o=s.getLineCount(),r=a.lineNumber,i=s.getLineContent(r),h=this._findFirstMatchInLine(p,i,r,a.column,t);if(h)return h;for(let c=1;c<=o;c++){const d=(r+c-1)%o,b=s.getLineContent(d+1),y=this._findFirstMatchInLine(p,b,d+1,1,t);if(y)return y}return null}static _findFirstMatchInLine(s,a,p,t,o){s.reset(t-1);const r=s.next(a);return r?A(new k.Range(p,r.index+1,p,r.index+1+r[0].length),r,o):null}static findPreviousMatch(s,a,p,t){const o=a.parseSearchRequest();if(!o)return null;const r=new P(o.wordSeparators,o.regex);return o.regex.multiline?this._doFindPreviousMatchMultiline(s,p,r,t):this._doFindPreviousMatchLineByLine(s,p,r,t)}static _doFindPreviousMatchMultiline(s,a,p,t){const o=this._doFindMatchesMultiline(s,new k.Range(1,1,a.lineNumber,a.column),p,t,10*C);if(o.length>0)return o[o.length-1];const r=s.getLineCount();return a.lineNumber!==r||a.column!==s.getLineMaxColumn(r)?this._doFindPreviousMatchMultiline(s,new I.Position(r,s.getLineMaxColumn(r)),p,t):null}static _doFindPreviousMatchLineByLine(s,a,p,t){const o=s.getLineCount(),r=a.lineNumber,i=s.getLineContent(r).substring(0,a.column-1),h=this._findLastMatchInLine(p,i,r,t);if(h)return h;for(let c=1;c<=o;c++){const d=(o+r-c-1)%o,b=s.getLineContent(d+1),y=this._findLastMatchInLine(p,b,d+1,t);if(y)return y}return null}static _findLastMatchInLine(s,a,p,t){let o=null,r;for(s.reset(0);r=s.next(a);)o=A(new k.Range(p,r.index+1,p,r.index+1+r[0].length),r,t);return o}}e.TextModelSearch=f;function l(E,s,a,p,t){if(p===0)return!0;const o=s.charCodeAt(p-1);if(E.get(o)!==0||o===13||o===10)return!0;if(t>0){const r=s.charCodeAt(p);if(E.get(r)!==0)return!0}return!1}function v(E,s,a,p,t){if(p+t===a)return!0;const o=s.charCodeAt(p+t);if(E.get(o)!==0||o===13||o===10)return!0;if(t>0){const r=s.charCodeAt(p+t-1);if(E.get(r)!==0)return!0}return!1}function S(E,s,a,p,t){return l(E,s,a,p,t)&&v(E,s,a,p,t)}e.isValidMatch=S;class P{constructor(s,a){this._wordSeparators=s,this._searchRegex=a,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(s){this._searchRegex.lastIndex=s,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(s){const a=s.length;let p;do{if(this._prevMatchStartIndex+this._prevMatchLength===a||(p=this._searchRegex.exec(s),!p))return null;const t=p.index,o=p[0].length;if(t===this._prevMatchStartIndex&&o===this._prevMatchLength){if(o===0){m.getNextCodePoint(s,a,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=o,!this._wordSeparators||S(this._wordSeparators,s,a,t,o))return p}while(p);return null}}e.Searcher=P}),define(me[110],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function m(C=""){let D="(-?\\d*\\.\\d\\w*)|([^";for(const T of e.USUAL_WORD_SEPARATORS)C.indexOf(T)>=0||(D+="\\"+T);return D+="\\s]+)",new RegExp(D,"g")}e.DEFAULT_WORD_REGEXP=m();function L(C){let D=e.DEFAULT_WORD_REGEXP;if(C&&C instanceof RegExp)if(C.global)D=C;else{let T="g";C.ignoreCase&&(T+="i"),C.multiline&&(T+="m"),C.unicode&&(T+="u"),D=new RegExp(C.source,T)}return D.lastIndex=0,D}e.ensureValidWordDefinition=L;const I={maxLen:1e3,windowSize:15,timeBudget:150};function k(C,D,T,n,A=I){if(T.length>A.maxLen){let S=C-A.maxLen/2;return S<0?S=0:n+=S,T=T.substring(S,C+A.maxLen/2),k(C,D,T,n,A)}const u=Date.now(),f=C-1-n;let l=-1,v=null;for(let S=1;!(Date.now()-u>=A.timeBudget);S++){const P=f-A.windowSize*S;D.lastIndex=Math.max(0,P);const E=R(D,T,f,l);if(!E&&v||(v=E,P<=0))break;l=P}if(v){let S={word:v[0],startColumn:n+1+v.index,endColumn:n+1+v.index+v[0].length};return D.lastIndex=0,S}return null}e.getWordAtText=k;function R(C,D,T,n){let A;for(;A=C.exec(D);){const u=A.index||0;if(u<=T&&C.lastIndex>=T)return A;if(n>0&&u>n)return null}return null}}),define(me[146],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var m;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(m=e.IndentAction||(e.IndentAction={}));class L{constructor(C){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=C.open,this.close=C.close,this._standardTokenMask=0,Array.isArray(C.notIn))for(let D=0,T=C.notIn.length;D<T;D++)switch(C.notIn[D]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(C){return(this._standardTokenMask&C)==0}}e.StandardAutoClosingPairConditional=L;class I{constructor(C){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of C)k(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),k(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),k(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),k(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&k(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=I;function k(R,C,D){R.has(C)?R.get(C).push(D):R.set(C,[D])}}),define(me[81],ge([0,1,30,8]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function I(k,R,C,D){if(Array.isArray(k)){let T=0;for(const n of k){const A=I(n,R,C,D);if(A===10)return A;A>T&&(T=A)}return T}else{if(typeof k=="string")return D?k==="*"?5:k===C?10:0:0;if(k){const{language:T,pattern:n,scheme:A,hasAccessToAllModels:u}=k;if(!D&&!u)return 0;let f=0;if(A)if(A===R.scheme)f=10;else if(A==="*")f=5;else return 0;if(T)if(T===C)f=10;else if(T==="*")f=Math.max(f,5);else return 0;if(n){let l;if(typeof n=="string"?l=n:l={...n,base:(0,L.normalize)(n.base)},l===R.fsPath||(0,m.match)(l,R.fsPath))f=10;else return 0}return f}else return 0}}e.score=I}),define(me[147],ge([0,1,108]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var L;(function(f){f[f.Invalid=0]="Invalid",f[f.Start=1]="Start",f[f.H=2]="H",f[f.HT=3]="HT",f[f.HTT=4]="HTT",f[f.HTTP=5]="HTTP",f[f.F=6]="F",f[f.FI=7]="FI",f[f.FIL=8]="FIL",f[f.BeforeColon=9]="BeforeColon",f[f.AfterColon=10]="AfterColon",f[f.AlmostThere=11]="AlmostThere",f[f.End=12]="End",f[f.Accept=13]="Accept",f[f.LastKnownState=14]="LastKnownState"})(L=e.State||(e.State={}));class I{constructor(l,v,S){const P=new Uint8Array(l*v);for(let E=0,s=l*v;E<s;E++)P[E]=S;this._data=P,this.rows=l,this.cols=v}get(l,v){return this._data[l*this.cols+v]}set(l,v,S){this._data[l*this.cols+v]=S}}e.Uint8Matrix=I;class k{constructor(l){let v=0,S=0;for(let E=0,s=l.length;E<s;E++){let[a,p,t]=l[E];p>v&&(v=p),a>S&&(S=a),t>S&&(S=t)}v++,S++;let P=new I(S,v,0);for(let E=0,s=l.length;E<s;E++){let[a,p,t]=l[E];P.set(a,p,t)}this._states=P,this._maxCharCode=v}nextState(l,v){return v<0||v>=this._maxCharCode?0:this._states.get(l,v)}}e.StateMachine=k;let R=null;function C(){return R===null&&(R=new k([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),R}var D;(function(f){f[f.None=0]="None",f[f.ForceTermination=1]="ForceTermination",f[f.CannotEndIn=2]="CannotEndIn"})(D||(D={}));let T=null;function n(){if(T===null){T=new m.CharacterClassifier(0);const f=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let v=0;v<f.length;v++)T.set(f.charCodeAt(v),1);const l=".,;";for(let v=0;v<l.length;v++)T.set(l.charCodeAt(v),2)}return T}class A{static _createLink(l,v,S,P,E){let s=E-1;do{const a=v.charCodeAt(s);if(l.get(a)!==2)break;s--}while(s>P);if(P>0){const a=v.charCodeAt(P-1),p=v.charCodeAt(s);(a===40&&p===41||a===91&&p===93||a===123&&p===125)&&s--}return{range:{startLineNumber:S,startColumn:P+1,endLineNumber:S,endColumn:s+2},url:v.substring(P,s+1)}}static computeLinks(l,v=C()){const S=n();let P=[];for(let E=1,s=l.getLineCount();E<=s;E++){const a=l.getLineContent(E),p=a.length;let t=0,o=0,r=0,i=1,h=!1,c=!1,d=!1,b=!1;for(;t<p;){let y=!1;const g=a.charCodeAt(t);if(i===13){let _;switch(g){case 40:h=!0,_=0;break;case 41:_=h?0:1;break;case 91:d=!0,c=!0,_=0;break;case 93:d=!1,_=c?0:1;break;case 123:b=!0,_=0;break;case 125:_=b?0:1;break;case 39:_=r===34||r===96?0:1;break;case 34:_=r===39||r===96?0:1;break;case 96:_=r===39||r===34?0:1;break;case 42:_=r===42?1:0;break;case 124:_=r===124?1:0;break;case 32:_=d?0:1;break;default:_=S.get(g)}_===1&&(P.push(A._createLink(S,a,E,o,t)),y=!0)}else if(i===12){let _;g===91?(c=!0,_=0):_=S.get(g),_===1?y=!0:i=13}else i=v.nextState(i,g),i===0&&(y=!0);y&&(i=1,h=!1,c=!1,b=!1,o=t+1,r=g),t++}i===13&&P.push(A._createLink(S,a,E,o,p))}return P}}e.LinkComputer=A;function u(f){return!f||typeof f.getLineCount!="function"||typeof f.getLineContent!="function"?[]:A.computeLinks(f)}e.computeLinks=u}),define(me[148],ge([0,1,3,6]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class I{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new m.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(R){this._onDidChange.fire({changedLanguages:R,changedColorMap:!1})}register(R,C){return this._map.set(R,C),this.fire([R]),(0,L.toDisposable)(()=>{this._map.get(R)===C&&(this._map.delete(R),this.fire([R]))})}registerPromise(R,C){let D=null,T=!1;return this._promises.set(R,C.then(n=>{this._promises.delete(R),!(T||!n)&&(D=this.register(R,n))})),(0,L.toDisposable)(()=>{T=!0,D&&D.dispose()})}getPromise(R){const C=this.get(R);if(C)return Promise.resolve(C);const D=this._promises.get(R);return D?D.then(T=>this.get(R)):null}get(R){return this._map.get(R)||null}setColorMap(R){this._colorMap=R,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=I}),define(me[111],ge([0,1,23,11]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var I;(function(A){A[A.Full=1]="Full",A[A.Delta=2]="Delta"})(I||(I={}));function k(A){for(let u=0,f=A.length;u<f;u+=4){const l=A[u+0],v=A[u+1],S=A[u+2],P=A[u+3];A[u+0]=P,A[u+1]=S,A[u+2]=v,A[u+3]=l}}function R(A){const u=new Uint8Array(A.buffer,A.byteOffset,A.length*4);return L.isLittleEndian()||k(u),m.VSBuffer.wrap(u)}function C(A){const u=A.buffer;if(L.isLittleEndian()||k(u),u.byteOffset%4==0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const f=new Uint8Array(u.byteLength);return f.set(u),new Uint32Array(f.buffer,f.byteOffset,f.length/4)}}function D(A){const u=new Uint32Array(T(A));let f=0;if(u[f++]=A.id,A.type==="full")u[f++]=1,u[f++]=A.data.length,u.set(A.data,f),f+=A.data.length;else{u[f++]=2,u[f++]=A.deltas.length;for(const l of A.deltas)u[f++]=l.start,u[f++]=l.deleteCount,l.data?(u[f++]=l.data.length,u.set(l.data,f),f+=l.data.length):u[f++]=0}return R(u)}e.encodeSemanticTokensDto=D;function T(A){let u=0;if(u+=1+1,A.type==="full")u+=1+A.data.length;else{u+=1,u+=(1+1+1)*A.deltas.length;for(const f of A.deltas)f.data&&(u+=f.data.length)}return u}function n(A){const u=C(A);let f=0;const l=u[f++];if(u[f++]===1){const E=u[f++],s=u.subarray(f,f+E);return f+=E,{id:l,type:"full",data:s}}const S=u[f++];let P=[];for(let E=0;E<S;E++){const s=u[f++],a=u[f++],p=u[f++];let t;p>0&&(t=u.subarray(f,f+p),f+=p),P[E]={start:s,deleteCount:a,data:t}}return{id:l,type:"delta",deltas:P}}e.decodeSemanticTokensDto=n}),define(me[112],ge([0,1,97]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class L{constructor(R,C){this._prefixSumIndexOfResultBrand=void 0,this.index=R,this.remainder=C}}e.PrefixSumIndexOfResult=L;class I{constructor(R){this.values=R,this.prefixSum=new Uint32Array(R.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(R,C){R=(0,m.toUint32)(R);const D=this.values,T=this.prefixSum,n=C.length;return n===0?!1:(this.values=new Uint32Array(D.length+n),this.values.set(D.subarray(0,R),0),this.values.set(D.subarray(R),R+n),this.values.set(C,R),R-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=R-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(T.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(R,C){return R=(0,m.toUint32)(R),C=(0,m.toUint32)(C),this.values[R]===C?!1:(this.values[R]=C,R-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=R-1),!0)}removeValues(R,C){R=(0,m.toUint32)(R),C=(0,m.toUint32)(C);const D=this.values,T=this.prefixSum;if(R>=D.length)return!1;let n=D.length-R;return C>=n&&(C=n),C===0?!1:(this.values=new Uint32Array(D.length-C),this.values.set(D.subarray(0,R),0),this.values.set(D.subarray(R+C),R),this.prefixSum=new Uint32Array(this.values.length),R-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=R-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(T.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(R){return R<0?0:(R=(0,m.toUint32)(R),this._getPrefixSum(R))}_getPrefixSum(R){if(R<=this.prefixSumValidIndex[0])return this.prefixSum[R];let C=this.prefixSumValidIndex[0]+1;C===0&&(this.prefixSum[0]=this.values[0],C++),R>=this.values.length&&(R=this.values.length-1);for(let D=C;D<=R;D++)this.prefixSum[D]=this.prefixSum[D-1]+this.values[D];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],R),this.prefixSum[R]}getIndexOf(R){R=Math.floor(R),this.getTotalSum();let C=0,D=this.values.length-1,T=0,n=0,A=0;for(;C<=D;)if(T=C+(D-C)/2|0,n=this.prefixSum[T],A=n-this.values[T],R<A)D=T-1;else if(R>=n)C=T+1;else break;return new L(T,R-A)}}e.PrefixSumComputer=I}),define(me[149],ge([0,1,9,51,112]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class k{constructor(C,D,T,n){this._uri=C,this._lines=D,this._eol=T,this._versionId=n,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(C){C.eol&&C.eol!==this._eol&&(this._eol=C.eol,this._lineStarts=null);const D=C.changes;for(const T of D)this._acceptDeleteRange(T.range),this._acceptInsertText(new L.Position(T.range.startLineNumber,T.range.startColumn),T.text);this._versionId=C.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const C=this._eol.length,D=this._lines.length,T=new Uint32Array(D);for(let n=0;n<D;n++)T[n]=this._lines[n].length+C;this._lineStarts=new I.PrefixSumComputer(T)}}_setLineText(C,D){this._lines[C]=D,this._lineStarts&&this._lineStarts.changeValue(C,this._lines[C].length+this._eol.length)}_acceptDeleteRange(C){if(C.startLineNumber===C.endLineNumber){if(C.startColumn===C.endColumn)return;this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.startLineNumber-1].substring(C.endColumn-1));return}this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.endLineNumber-1].substring(C.endColumn-1)),this._lines.splice(C.startLineNumber,C.endLineNumber-C.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(C.startLineNumber,C.endLineNumber-C.startLineNumber)}_acceptInsertText(C,D){if(D.length===0)return;let T=(0,m.splitLines)(D);if(T.length===1){this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+T[0]+this._lines[C.lineNumber-1].substring(C.column-1));return}T[T.length-1]+=this._lines[C.lineNumber-1].substring(C.column-1),this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+T[0]);let n=new Uint32Array(T.length-1);for(let A=1;A<T.length;A++)this._lines.splice(C.lineNumber+A-1,0,T[A]),n[A-1]=T[A].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(C.lineNumber,n)}}e.MirrorTextModel=k}),define(me[150],ge([19,20]),function(J,e){return J.create("vs/base/common/date",e)}),define(me[151],ge([0,1,150]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,I=L*60,k=I*24,R=k*7,C=k*30,D=k*365;function T(A,u){typeof A!="number"&&(A=A.getTime());const f=Math.round((new Date().getTime()-A)/1e3);if(f<-30)return(0,m.localize)(0,null,T(new Date().getTime()+f*1e3,!1));if(f<30)return(0,m.localize)(1,null);let l;return f<L?(l=f,u?l===1?(0,m.localize)(2,null,l):(0,m.localize)(3,null,l):l===1?(0,m.localize)(4,null,l):(0,m.localize)(5,null,l)):f<I?(l=Math.floor(f/L),u?l===1?(0,m.localize)(6,null,l):(0,m.localize)(7,null,l):l===1?(0,m.localize)(8,null,l):(0,m.localize)(9,null,l)):f<k?(l=Math.floor(f/I),u?l===1?(0,m.localize)(10,null,l):(0,m.localize)(11,null,l):l===1?(0,m.localize)(12,null,l):(0,m.localize)(13,null,l)):f<R?(l=Math.floor(f/k),u?l===1?(0,m.localize)(14,null,l):(0,m.localize)(15,null,l):l===1?(0,m.localize)(16,null,l):(0,m.localize)(17,null,l)):f<C?(l=Math.floor(f/R),u?l===1?(0,m.localize)(18,null,l):(0,m.localize)(19,null,l):l===1?(0,m.localize)(20,null,l):(0,m.localize)(21,null,l)):f<D?(l=Math.floor(f/C),u?l===1?(0,m.localize)(22,null,l):(0,m.localize)(23,null,l):l===1?(0,m.localize)(24,null,l):(0,m.localize)(25,null,l)):(l=Math.floor(f/D),u?l===1?(0,m.localize)(26,null,l):(0,m.localize)(27,null,l):l===1?(0,m.localize)(28,null,l):(0,m.localize)(29,null,l))}e.fromNow=T;function n(A){return A.getFullYear()+"-"+String(A.getMonth()+1).padStart(2,"0")+"-"+String(A.getDate()).padStart(2,"0")+"T"+String(A.getHours()).padStart(2,"0")+":"+String(A.getMinutes()).padStart(2,"0")+":"+String(A.getSeconds()).padStart(2,"0")+"."+(A.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=n}),define(me[152],ge([19,20]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(me[61],ge([0,1,17,13,152]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function k(T,n){return n&&(T.stack||T.stacktrace)?I.localize(0,null,C(T),R(T.stack)||R(T.stacktrace)):C(T)}function R(T){return Array.isArray(T)?T.join(`
`):T}function C(T){return typeof T.code=="string"&&typeof T.errno=="number"&&typeof T.syscall=="string"?I.localize(1,null,T.message):T.message||I.localize(2,null)}function D(T=null,n=!1){if(!T)return I.localize(3,null);if(Array.isArray(T)){const A=m.coalesce(T),u=D(A[0],n);return A.length>1?I.localize(4,null,u,A.length):u}if(L.isString(T))return T;if(T.detail){const A=T.detail;if(A.error)return k(A.error,n);if(A.exception)return k(A.exception,n)}return T.stack?k(T,n):T.message?T.message:I.localize(5,null)}e.toErrorMessage=D}),define(me[153],ge([19,20]),function(J,e){return J.create("vs/base/node/processes",e)}),define(me[113],ge([0,1,39,29,10,25,8,11,34,13,142,28,153]),function(J,e,m,L,I,k,R,C,D,T,n,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function f(a){switch(a){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function l(a,p){if(C.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};p&&(t.cwd=p);const o=m.execFile("taskkill",["/T","/F","/PID",a.pid.toString()],t);return new Promise(r=>{o.once("error",i=>{r({success:!1,error:i})}),o.once("exit",(i,h)=>{r(i===0?{success:!0}:{success:!1,code:i!==null?i:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?f(t.status):1})}else if(C.isLinux||C.isMacintosh)try{const t=I.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",J).fsPath;return new Promise(o=>{m.execFile(t,[a.pid.toString()],{encoding:"utf8",shell:!0},(r,i,h)=>{o(r?{success:!1,error:r}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else a.kill("SIGKILL");return Promise.resolve({success:!0})}function v(a=D.env){return a.comspec||"cmd.exe"}e.getWindowsShell=v;class S{constructor(p,t,o,r){if(t!==void 0&&o!==void 0&&r!==void 0)this.cmd=p,this.args=t,this.shell=o,this.options=r;else{const i=p;this.cmd=i.command,this.shell=i.isShellCommand,this.args=i.args.slice(0),this.options=i.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const i=Object.create(null);Object.keys(D.env).forEach(h=>{i[h]=D.env[h]}),Object.keys(this.options.env).forEach(h=>{i[h]=this.options.env[h]}),this.options.env=i}}getSanitizedCommand(){let p=this.cmd.toLowerCase();const t=p.lastIndexOf(R.sep);return t!==-1&&(p=p.substring(t+1)),S.WellKnowCommands[p]?p:"other"}start(p){return C.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(D.cwd()))?Promise.reject(new Error(u.localize(0,null))):this.useExec().then(t=>{let o,r;const i=new Promise((h,c)=>{o=h,r=c});if(t){let h=this.cmd;this.args&&(h=h+" "+this.args.join(" ")),this.childProcess=m.exec(h,this.options,(c,d,b)=>{this.childProcess=null;const y=c;y&&y.killed?r({killed:this.terminateRequested,stdout:d.toString(),stderr:b.toString()}):this.handleExec(o,p,c,d,b)})}else{let h=null;const c=d=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(d,o,p,r);const b={terminated:this.terminateRequested};T.isNumber(d)&&(b.cmdCode=d),o(b)};if(this.shell&&C.isWindows){const d=k.deepClone(this.options);d.windowsVerbatimArguments=!0,d.detached=!1;let b=!1,y=!1;const g=[];let _=this.ensureQuotes(this.cmd);g.push(_.value),b=_.quoted,this.args&&this.args.forEach(F=>{_=this.ensureQuotes(F),g.push(_.value),y=y&&_.quoted});const w=["/s","/c"];b?y?w.push('"'+g.join(" ")+'"'):g.length>1?w.push('"'+g[0]+'" '+g.slice(1).join(" ")):w.push('"'+g[0]+'"'):w.push(g.join(" ")),h=m.spawn(v(),w,d)}else this.cmd&&(h=m.spawn(this.cmd,this.args,this.options));h&&(this.childProcess=h,this.childProcessPromise=Promise.resolve(h),this.pidResolve&&(this.pidResolve(T.isNumber(h.pid)?h.pid:-1),this.pidResolve=void 0),h.on("error",d=>{this.childProcess=null,r({terminated:this.terminateRequested,error:d})}),h.pid&&(this.childProcess.on("close",c),this.handleSpawn(h,o,p,r,!0)))}return i})}handleClose(p,t,o,r){}ensureQuotes(p){return S.regexp.test(p)?{value:'"'+p+'"',quoted:!0}:{value:p,quoted:p.length>0&&p[0]==='"'&&p[p.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(p=>p.pid,p=>-1):new Promise(p=>{this.pidResolve=p})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(p=>(this.terminateRequested=!0,l(p,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),p=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(p=>{if(!this.shell||!C.isWindows)return p(!1);const t=m.spawn(v(),["/s","/c"]);t.on("error",o=>p(!0)),t.on("exit",o=>p(!1))})}}e.AbstractProcess=S,S.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},S.regexp=/^[^"].* .*[^"]/;class P extends S{constructor(p,t,o,r){super(p,t,o,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(p,t,o,r,i){[r,i].forEach((h,c)=>{const d=new n.LineDecoder;d.write(h).forEach(g=>{t({line:g,source:c===0?0:1})});const y=d.end();y&&t({line:y,source:c===0?0:1})}),p({terminated:this.terminateRequested,error:o})}handleSpawn(p,t,o,r,i){const h=new n.LineDecoder,c=new n.LineDecoder;p.stdout.on("data",d=>{h.write(d).forEach(y=>o({line:y,source:0}))}),p.stderr.on("data",d=>{c.write(d).forEach(y=>o({line:y,source:1}))}),this.stdoutLineDecoder=h,this.stderrLineDecoder=c}handleClose(p,t,o,r){const i=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;i&&o({line:i,source:0});const h=this.stderrLineDecoder?this.stderrLineDecoder.end():null;h&&o({line:h,source:1})}}e.LineProcess=P;function E(a){let p=[],t=!1;const o=function(r){if(t){p.push(r);return}(!a.send(r,h=>{if(h&&console.error(h),t=!1,p.length>0){const c=p.slice(0);p=[],c.forEach(d=>o(d))}})||C.isWindows)&&(t=!0)};return{send:o}}e.createQueuedSender=E;var s;(function(a){async function p(t,o,r){if(R.isAbsolute(t))return t;if(o===void 0&&(o=D.cwd()),R.dirname(t)!=="."||(r===void 0&&T.isString(D.env.PATH)&&(r=D.env.PATH.split(R.delimiter)),r===void 0||r.length===0))return R.join(o,t);async function h(c){if(await A.Promises.exists(c)){let d;try{d=await A.Promises.stat(c)}catch(b){b.message.startsWith("EACCES")&&(d=await A.Promises.lstat(c))}return d?!d.isDirectory():!1}return!1}for(let c of r){let d;if(R.isAbsolute(c)?d=R.join(c,t):d=R.join(o,c,t),await h(d))return d;let b=d+".com";if(await h(b)||(b=d+".exe",await h(b)))return b}return R.join(o,t)}a.findExecutable=p})(s=e.win32||(e.win32={}))}),define(me[154],ge([19,20]),function(J,e){return J.create("vs/editor/common/config/editorOptions",e)}),define(me[114],ge([0,1,154,11,110]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var k;(function(Z){Z[Z.None=0]="None",Z[Z.Keep=1]="Keep",Z[Z.Brackets=2]="Brackets",Z[Z.Advanced=3]="Advanced",Z[Z.Full=4]="Full"})(k=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class R{constructor(te){this._values=te}hasChanged(te){return this._values[te]}}e.ConfigurationChangedEvent=R;class C{constructor(){this._values=[]}_read(te){return this._values[te]}get(te){return this._values[te]}_write(te,pe){this._values[te]=pe}}e.ValidatedEditorOptions=C;class D{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=D;class T{constructor(te,pe,xe,Je){this.id=te,this.name=pe,this.defaultValue=xe,this.schema=Je}compute(te,pe,xe){return xe}}class n{constructor(te,pe=null){this.schema=void 0,this.id=te,this.name="_never_",this.defaultValue=void 0,this.deps=pe}validate(te){return this.defaultValue}}class A{constructor(te,pe,xe,Je){this.id=te,this.name=pe,this.defaultValue=xe,this.schema=Je}validate(te){return typeof te=="undefined"?this.defaultValue:te}compute(te,pe,xe){return xe}}function u(Z,te){return typeof Z=="undefined"?te:Z==="false"?!1:Boolean(Z)}e.boolean=u;class f extends A{constructor(te,pe,xe,Je=void 0){typeof Je!="undefined"&&(Je.type="boolean",Je.default=xe),super(te,pe,xe,Je)}validate(te){return u(te,this.defaultValue)}}class l extends A{constructor(te,pe,xe,Je,rt,ft=void 0){typeof ft!="undefined"&&(ft.type="integer",ft.default=xe,ft.minimum=Je,ft.maximum=rt),super(te,pe,xe,ft),this.minimum=Je,this.maximum=rt}static clampedInt(te,pe,xe,Je){if(typeof te=="undefined")return pe;let rt=parseInt(te,10);return isNaN(rt)?pe:(rt=Math.max(xe,rt),rt=Math.min(Je,rt),rt|0)}validate(te){return l.clampedInt(te,this.defaultValue,this.minimum,this.maximum)}}class v extends A{constructor(te,pe,xe,Je,rt){typeof rt!="undefined"&&(rt.type="number",rt.default=xe),super(te,pe,xe,rt),this.validationFn=Je}static clamp(te,pe,xe){return te<pe?pe:te>xe?xe:te}static float(te,pe){if(typeof te=="number")return te;if(typeof te=="undefined")return pe;const xe=parseFloat(te);return isNaN(xe)?pe:xe}validate(te){return this.validationFn(v.float(te,this.defaultValue))}}class S extends A{static string(te,pe){return typeof te!="string"?pe:te}constructor(te,pe,xe,Je=void 0){typeof Je!="undefined"&&(Je.type="string",Je.default=xe),super(te,pe,xe,Je)}validate(te){return S.string(te,this.defaultValue)}}function P(Z,te,pe){return typeof Z!="string"||pe.indexOf(Z)===-1?te:Z}e.stringSet=P;class E extends A{constructor(te,pe,xe,Je,rt=void 0){typeof rt!="undefined"&&(rt.type="string",rt.enum=Je,rt.default=xe),super(te,pe,xe,rt),this._allowedValues=Je}validate(te){return P(te,this.defaultValue,this._allowedValues)}}class s extends T{constructor(te,pe,xe,Je,rt,ft,pt=void 0){typeof pt!="undefined"&&(pt.type="string",pt.enum=rt,pt.default=Je),super(te,pe,xe,pt),this._allowedValues=rt,this._convert=ft}validate(te){return typeof te!="string"?this.defaultValue:this._allowedValues.indexOf(te)===-1?this.defaultValue:this._convert(te)}}function a(Z){switch(Z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class p extends T{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",description:m.localize(3,null)})}validate(te){switch(te){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(te,pe,xe){return xe===0?te.accessibilitySupport:xe}}class t extends T{constructor(){const te={insertSpace:!0,ignoreEmptyLines:!0};super(18,"comments",te,{"editor.comments.insertSpace":{type:"boolean",default:te.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:te.ignoreEmptyLines,description:m.localize(5,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{insertSpace:u(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:u(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var o;(function(Z){Z[Z.Hidden=0]="Hidden",Z[Z.Blink=1]="Blink",Z[Z.Smooth=2]="Smooth",Z[Z.Phase=3]="Phase",Z[Z.Expand=4]="Expand",Z[Z.Solid=5]="Solid"})(o=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function r(Z){switch(Z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var i;(function(Z){Z[Z.Line=1]="Line",Z[Z.Block=2]="Block",Z[Z.Underline=3]="Underline",Z[Z.LineThin=4]="LineThin",Z[Z.BlockOutline=5]="BlockOutline",Z[Z.UnderlineThin=6]="UnderlineThin"})(i=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function h(Z){switch(Z){case i.Line:return"line";case i.Block:return"block";case i.Underline:return"underline";case i.LineThin:return"line-thin";case i.BlockOutline:return"block-outline";case i.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=h;function c(Z){switch(Z){case"line":return i.Line;case"block":return i.Block;case"underline":return i.Underline;case"line-thin":return i.LineThin;case"block-outline":return i.BlockOutline;case"underline-thin":return i.UnderlineThin}}class d extends n{constructor(){super(127,[65,32])}compute(te,pe,xe){const Je=["monaco-editor"];return pe.get(32)&&Je.push(pe.get(32)),te.extraEditorClassName&&Je.push(te.extraEditorClassName),pe.get(65)==="default"?Je.push("mouse-default"):pe.get(65)==="copy"&&Je.push("mouse-copy"),pe.get(100)&&Je.push("showUnused"),pe.get(125)&&Je.push("showDeprecated"),Je.join(" ")}}class b extends f{constructor(){super(31,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(te,pe,xe){return xe&&te.emptySelectionClipboard}}class y extends T{constructor(){const te={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(34,"find",te,{"editor.find.cursorMoveOnType":{type:"boolean",default:te.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:te.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:te.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:te.globalFindClipboard,description:m.localize(16,null),included:L.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:te.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:te.loop,description:m.localize(18,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{cursorMoveOnType:u(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof te.seedSearchStringFromSelection=="boolean"?te.seedSearchStringFromSelection?"always":"never":P(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof te.autoFindInSelection=="boolean"?te.autoFindInSelection?"always":"never":P(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:u(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:u(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:u(pe.loop,this.defaultValue.loop)}}}class g extends T{constructor(){super(43,"fontLigatures",g.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(te){return typeof te=="undefined"?this.defaultValue:typeof te=="string"?te==="false"?g.OFF:te==="true"?g.ON:te:Boolean(te)?g.ON:g.OFF}}e.EditorFontLigatures=g,g.OFF='"liga" off, "calt" off',g.ON='"liga" on, "calt" on';class _ extends n{constructor(){super(42)}compute(te,pe,xe){return te.fontInfo}}class w extends A{constructor(){super(44,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(22,null)})}validate(te){let pe=v.float(te,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:v.clamp(pe,6,100)}compute(te,pe,xe){return te.fontInfo.fontSize}}class F extends T{constructor(){super(45,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:F.MINIMUM_VALUE,maximum:F.MAXIMUM_VALUE,errorMessage:m.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:F.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(24,null)})}validate(te){return te==="normal"||te==="bold"?te:String(l.clampedInt(te,e.EDITOR_FONT_DEFAULTS.fontWeight,F.MINIMUM_VALUE,F.MAXIMUM_VALUE))}}F.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],F.MINIMUM_VALUE=1,F.MAXIMUM_VALUE=1e3;class N extends T{constructor(){const te={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:te.multiple,enumDescriptions:[m.localize(25,null),m.localize(26,null),m.localize(27,null)]},xe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(49,"gotoLocation",te,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(29,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(30,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:m.localize(31,null),...pe},"editor.gotoLocation.multipleImplementations":{description:m.localize(32,null),...pe},"editor.gotoLocation.multipleReferences":{description:m.localize(33,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:te.alternativeDefinitionCommand,enum:xe,description:m.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:te.alternativeTypeDefinitionCommand,enum:xe,description:m.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:te.alternativeDeclarationCommand,enum:xe,description:m.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:te.alternativeImplementationCommand,enum:xe,description:m.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:te.alternativeReferenceCommand,enum:xe,description:m.localize(38,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{multiple:P(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??P(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??P(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??P(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??P(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??P(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:S.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:S.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:S.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:S.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:S.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class G extends T{constructor(){const te={enabled:!0,delay:300,sticky:!0};super(52,"hover",te,{"editor.hover.enabled":{type:"boolean",default:te.enabled,description:m.localize(39,null)},"editor.hover.delay":{type:"number",default:te.delay,description:m.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:te.sticky,description:m.localize(41,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:u(pe.enabled,this.defaultValue.enabled),delay:l.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:u(pe.sticky,this.defaultValue.sticky)}}}var K;(function(Z){Z[Z.None=0]="None",Z[Z.Text=1]="Text",Z[Z.Blocks=2]="Blocks"})(K=e.RenderMinimap||(e.RenderMinimap={}));class U extends n{constructor(){super(130,[48,57,36,64,92,59,60,94,117,120,121,122,2])}compute(te,pe,xe){return U.computeLayout(pe,{memory:te.memory,outerWidth:te.outerWidth,outerHeight:te.outerHeight,isDominatedByLongLines:te.isDominatedByLongLines,lineHeight:te.fontInfo.lineHeight,viewLineCount:te.viewLineCount,lineNumbersDigitCount:te.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:te.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:te.fontInfo.maxDigitWidth,pixelRatio:te.pixelRatio})}static computeContainedMinimapLineCount(te){const pe=te.height/te.lineHeight,xe=te.scrollBeyondLastLine?pe-1:0,Je=(te.viewLineCount+xe)/(te.pixelRatio*te.height),rt=Math.floor(te.viewLineCount/Je);return{typicalViewportLineCount:pe,extraLinesBeyondLastLine:xe,desiredRatio:Je,minimapLineCount:rt}}static _computeMinimapLayout(te,pe){const xe=te.outerWidth,Je=te.outerHeight,rt=te.pixelRatio;if(!te.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(rt*Je),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Je};const ft=pe.stableMinimapLayoutInput,pt=ft&&te.outerHeight===ft.outerHeight&&te.lineHeight===ft.lineHeight&&te.typicalHalfwidthCharacterWidth===ft.typicalHalfwidthCharacterWidth&&te.pixelRatio===ft.pixelRatio&&te.scrollBeyondLastLine===ft.scrollBeyondLastLine&&te.minimap.enabled===ft.minimap.enabled&&te.minimap.side===ft.minimap.side&&te.minimap.size===ft.minimap.size&&te.minimap.showSlider===ft.minimap.showSlider&&te.minimap.renderCharacters===ft.minimap.renderCharacters&&te.minimap.maxColumn===ft.minimap.maxColumn&&te.minimap.scale===ft.minimap.scale&&te.verticalScrollbarWidth===ft.verticalScrollbarWidth&&te.isViewportWrapping===ft.isViewportWrapping,St=te.lineHeight,Ct=te.typicalHalfwidthCharacterWidth,ue=te.scrollBeyondLastLine,Ie=te.minimap.renderCharacters;let Ue=rt>=2?Math.round(te.minimap.scale*2):te.minimap.scale;const Qe=te.minimap.maxColumn,ze=te.minimap.size,at=te.minimap.side,Le=te.verticalScrollbarWidth,De=te.viewLineCount,ke=te.remainingWidth,ne=te.isViewportWrapping,de=Ie?2:3;let be=Math.floor(rt*Je);const we=be/rt;let Fe=!1,Ge=!1,He=de*Ue,Ye=Ue/rt,it=1;if(ze==="fill"||ze==="fit"){const{typicalViewportLineCount:Ze,extraLinesBeyondLastLine:Xe,desiredRatio:ot,minimapLineCount:vt}=U.computeContainedMinimapLineCount({viewLineCount:De,scrollBeyondLastLine:ue,height:Je,lineHeight:St,pixelRatio:rt});if(De/vt>1)Fe=!0,Ge=!0,Ue=1,He=1,Ye=Ue/rt;else{let lt=!1,dt=Ue+1;if(ze==="fit"){const mt=Math.ceil((De+Xe)*He);ne&&pt&&ke<=pe.stableFitRemainingWidth?(lt=!0,dt=pe.stableFitMaxMinimapScale):lt=mt>be}if(ze==="fill"||lt){Fe=!0;const mt=Ue;He=Math.min(St*rt,Math.max(1,Math.floor(1/ot))),ne&&pt&&ke<=pe.stableFitRemainingWidth&&(dt=pe.stableFitMaxMinimapScale),Ue=Math.min(dt,Math.max(1,Math.floor(He/de))),Ue>mt&&(it=Math.min(2,Ue/mt)),Ye=Ue/rt/it,be=Math.ceil(Math.max(Ze,De+Xe)*He),ne?(pe.stableMinimapLayoutInput=te,pe.stableFitRemainingWidth=ke,pe.stableFitMaxMinimapScale=Ue):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const le=Math.floor(Qe*Ye),Ee=Math.min(le,Math.max(0,Math.floor((ke-Le-2)*Ye/(Ct+Ye)))+e.MINIMAP_GUTTER_WIDTH);let ce=Math.floor(rt*Ee);const q=ce/rt;ce=Math.floor(ce*it);const Ae=Ie?1:2,Pe=at==="left"?0:xe-Ee-Le;return{renderMinimap:Ae,minimapLeft:Pe,minimapWidth:Ee,minimapHeightIsEditorHeight:Fe,minimapIsSampling:Ge,minimapScale:Ue,minimapLineHeight:He,minimapCanvasInnerWidth:ce,minimapCanvasInnerHeight:be,minimapCanvasOuterWidth:q,minimapCanvasOuterHeight:we}}static computeLayout(te,pe){const xe=pe.outerWidth|0,Je=pe.outerHeight|0,rt=pe.lineHeight|0,ft=pe.lineNumbersDigitCount|0,pt=pe.typicalHalfwidthCharacterWidth,St=pe.maxDigitWidth,Ct=pe.pixelRatio,ue=pe.viewLineCount,Ie=te.get(122),Ue=Ie==="inherit"?te.get(121):Ie,Qe=Ue==="inherit"?te.get(117):Ue,ze=te.get(120),at=te.get(2),Le=pe.isDominatedByLongLines,De=te.get(48),ke=te.get(59).renderType!==0,ne=te.get(60),de=te.get(94),be=te.get(64),we=te.get(92),Fe=we.verticalScrollbarSize,Ge=we.verticalHasArrows,He=we.arrowSize,Ye=we.horizontalScrollbarSize,it=te.get(57),le=te.get(36);let Ee;if(typeof it=="string"&&/^\d+(\.\d+)?ch$/.test(it)){const Ot=parseFloat(it.substr(0,it.length-2));Ee=l.clampedInt(Ot*pt,0,0,1e3)}else Ee=l.clampedInt(it,0,0,1e3);le&&(Ee+=16);let ce=0;if(ke){const Ot=Math.max(ft,ne);ce=Math.round(Ot*St)}let q=0;De&&(q=rt);let Ae=0,Pe=Ae+q,Ze=Pe+ce,Xe=Ze+Ee;const ot=xe-q-ce-Ee;let vt=!1,Et=!1,lt=-1;at!==2&&(Ue==="inherit"&&Le?(vt=!0,Et=!0):Qe==="on"||Qe==="bounded"?Et=!0:Qe==="wordWrapColumn"&&(lt=ze));const dt=U._computeMinimapLayout({outerWidth:xe,outerHeight:Je,lineHeight:rt,typicalHalfwidthCharacterWidth:pt,pixelRatio:Ct,scrollBeyondLastLine:de,minimap:be,verticalScrollbarWidth:Fe,viewLineCount:ue,remainingWidth:ot,isViewportWrapping:Et},pe.memory||new D);dt.renderMinimap!==0&&dt.minimapLeft===0&&(Ae+=dt.minimapWidth,Pe+=dt.minimapWidth,Ze+=dt.minimapWidth,Xe+=dt.minimapWidth);const mt=ot-dt.minimapWidth,Rt=Math.max(1,Math.floor((mt-Fe-2)/pt)),yt=Ge?He:0;return Et&&(lt=Math.max(1,Rt),Qe==="bounded"&&(lt=Math.min(lt,ze))),{width:xe,height:Je,glyphMarginLeft:Ae,glyphMarginWidth:q,lineNumbersLeft:Pe,lineNumbersWidth:ce,decorationsLeft:Ze,decorationsWidth:Ee,contentLeft:Xe,contentWidth:mt,minimap:dt,viewportColumn:Rt,isWordWrapMinified:vt,isViewportWrapping:Et,wrappingColumn:lt,verticalScrollbarWidth:Fe,horizontalScrollbarHeight:Ye,overviewRuler:{top:yt,width:Fe,height:Je-2*yt,right:0}}}}e.EditorLayoutInfoComputer=U;class z extends T{constructor(){const te={enabled:!0};super(56,"lightbulb",te,{"editor.lightbulb.enabled":{type:"boolean",default:te.enabled,description:m.localize(42,null)}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{enabled:u(te.enabled,this.defaultValue.enabled)}}}class O extends T{constructor(){const te={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",te,{"editor.inlayHints.enabled":{type:"boolean",default:te.enabled,description:m.localize(43,null)},"editor.inlayHints.fontSize":{type:"number",default:te.fontSize,markdownDescription:m.localize(44,null)},"editor.inlayHints.fontFamily":{type:"string",default:te.fontFamily,markdownDescription:m.localize(45,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:u(pe.enabled,this.defaultValue.enabled),fontSize:l.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:S.string(pe.fontFamily,this.defaultValue.fontFamily)}}}class B extends v{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,te=>v.clamp(te,0,150),{markdownDescription:m.localize(46,null)})}compute(te,pe,xe){return te.fontInfo.lineHeight}}class x extends T{constructor(){const te={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",te,{"editor.minimap.enabled":{type:"boolean",default:te.enabled,description:m.localize(47,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(48,null),m.localize(49,null),m.localize(50,null)],default:te.size,description:m.localize(51,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:te.side,description:m.localize(52,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:te.showSlider,description:m.localize(53,null)},"editor.minimap.scale":{type:"number",default:te.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(54,null)},"editor.minimap.renderCharacters":{type:"boolean",default:te.renderCharacters,description:m.localize(55,null)},"editor.minimap.maxColumn":{type:"number",default:te.maxColumn,description:m.localize(56,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:u(pe.enabled,this.defaultValue.enabled),size:P(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:P(pe.side,this.defaultValue.side,["right","left"]),showSlider:P(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:u(pe.renderCharacters,this.defaultValue.renderCharacters),scale:l.clampedInt(pe.scale,1,1,3),maxColumn:l.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function M(Z){return Z==="ctrlCmd"?L.isMacintosh?"metaKey":"ctrlKey":"altKey"}class H extends T{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(57,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(58,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{top:l.clampedInt(pe.top,0,0,1e3),bottom:l.clampedInt(pe.bottom,0,0,1e3)}}}class W extends T{constructor(){const te={enabled:!0,cycle:!1};super(75,"parameterHints",te,{"editor.parameterHints.enabled":{type:"boolean",default:te.enabled,description:m.localize(59,null)},"editor.parameterHints.cycle":{type:"boolean",default:te.cycle,description:m.localize(60,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:u(pe.enabled,this.defaultValue.enabled),cycle:u(pe.cycle,this.defaultValue.cycle)}}}class Q extends n{constructor(){super(128)}compute(te,pe,xe){return te.pixelRatio}}class X extends T{constructor(){const te={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",te,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:te.strings,description:m.localize(61,null)},comments:{type:"boolean",default:te.comments,description:m.localize(62,null)},other:{type:"boolean",default:te.other,description:m.localize(63,null)}}}],default:te,description:m.localize(64,null)});this.defaultValue=te}validate(te){if(typeof te=="boolean")return te;if(te&&typeof te=="object"){const pe=te,xe={other:u(pe.other,this.defaultValue.other),comments:u(pe.comments,this.defaultValue.comments),strings:u(pe.strings,this.defaultValue.strings)};return xe.other&&xe.comments&&xe.strings?!0:!xe.other&&!xe.comments&&!xe.strings?!1:xe}return this.defaultValue}}var he;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval",Z[Z.Custom=4]="Custom"})(he=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class _e extends T{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(65,null),m.localize(66,null),m.localize(67,null),m.localize(68,null)],default:"on",description:m.localize(69,null)})}validate(te){let pe=this.defaultValue.renderType,xe=this.defaultValue.renderFn;return typeof te!="undefined"&&(typeof te=="function"?(pe=4,xe=te):te==="interval"?pe=3:te==="relative"?pe=2:te==="on"?pe=1:pe=0),{renderType:pe,renderFn:xe}}}function ye(Z){const te=Z.get(87);return te==="editable"?Z.get(80):te!=="on"}e.filterValidationDecorations=ye;class Re extends T{constructor(){const te=[],pe={type:"number",description:m.localize(70,null)};super(91,"rulers",te,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:m.localize(71,null),format:"color-hex"}}}]},default:te,description:m.localize(72,null)})}validate(te){if(Array.isArray(te)){let pe=[];for(let xe of te)if(typeof xe=="number")pe.push({column:l.clampedInt(xe,0,0,1e4),color:null});else if(xe&&typeof xe=="object"){const Je=xe;pe.push({column:l.clampedInt(Je.column,0,0,1e4),color:Je.color})}return pe.sort((xe,Je)=>xe.column-Je.column),pe}return this.defaultValue}}function $e(Z,te){if(typeof Z!="string")return te;switch(Z){case"hidden":return 2;case"visible":return 3;default:return 1}}class Be extends T{constructor(){const te={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",te,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(73,null),m.localize(74,null),m.localize(75,null)],default:"auto",description:m.localize(76,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(77,null),m.localize(78,null),m.localize(79,null)],default:"auto",description:m.localize(80,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:te.verticalScrollbarSize,description:m.localize(81,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:te.horizontalScrollbarSize,description:m.localize(82,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:te.scrollByPage,description:m.localize(83,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te,xe=l.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Je=l.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:l.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:$e(pe.vertical,this.defaultValue.vertical),horizontal:$e(pe.horizontal,this.defaultValue.horizontal),useShadows:u(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:u(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:u(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:u(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:u(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:xe,horizontalSliderSize:l.clampedInt(pe.horizontalSliderSize,xe,0,1e3),verticalScrollbarSize:Je,verticalSliderSize:l.clampedInt(pe.verticalSliderSize,Je,0,1e3),scrollByPage:u(pe.scrollByPage,this.defaultValue.scrollByPage)}}}class je extends T{constructor(){const te={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",te,{"editor.inlineSuggest.enabled":{type:"boolean",default:te.enabled,description:m.localize(84,null)},"editor.inlineSuggest.mode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[m.localize(85,null),m.localize(86,null),m.localize(87,null)],default:te.mode,description:m.localize(88,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:u(pe.enabled,this.defaultValue.enabled),mode:P(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class V extends T{constructor(){const te={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",te,{"editor.bracketPairColorization.enabled":{type:"boolean",default:te.enabled,description:m.localize(89,null)}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{enabled:u(te.enabled,this.defaultValue.enabled)}}}class ee extends T{constructor(){const te={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",te,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(90,null),m.localize(91,null)],default:te.insertMode,description:m.localize(92,null)},"editor.suggest.filterGraceful":{type:"boolean",default:te.filterGraceful,description:m.localize(93,null)},"editor.suggest.localityBonus":{type:"boolean",default:te.localityBonus,description:m.localize(94,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:te.shareSuggestSelections,markdownDescription:m.localize(95,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:te.snippetsPreventQuickSuggestions,description:m.localize(96,null)},"editor.suggest.showIcons":{type:"boolean",default:te.showIcons,description:m.localize(97,null)},"editor.suggest.showStatusBar":{type:"boolean",default:te.showStatusBar,description:m.localize(98,null)},"editor.suggest.preview":{type:"boolean",default:te.preview,description:m.localize(99,null)},"editor.suggest.previewMode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[m.localize(100,null),m.localize(101,null),m.localize(102,null)],default:te.previewMode,description:m.localize(103,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:te.showInlineDetails,description:m.localize(104,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(105,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(106,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(107,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(108,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(109,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(110,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(111,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(112,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(113,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(114,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(115,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(116,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(117,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(118,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(119,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(120,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(121,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(122,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(123,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(124,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(125,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(126,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(127,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(128,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(129,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(130,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(131,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(132,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(133,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(134,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(135,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{insertMode:P(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:u(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:u(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:u(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:u(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:u(pe.showIcons,this.defaultValue.showIcons),showStatusBar:u(pe.showStatusBar,this.defaultValue.showStatusBar),preview:u(pe.preview,this.defaultValue.preview),previewMode:P(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:u(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:u(pe.showMethods,this.defaultValue.showMethods),showFunctions:u(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:u(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:u(pe.showDeprecated,this.defaultValue.showDeprecated),showFields:u(pe.showFields,this.defaultValue.showFields),showVariables:u(pe.showVariables,this.defaultValue.showVariables),showClasses:u(pe.showClasses,this.defaultValue.showClasses),showStructs:u(pe.showStructs,this.defaultValue.showStructs),showInterfaces:u(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:u(pe.showModules,this.defaultValue.showModules),showProperties:u(pe.showProperties,this.defaultValue.showProperties),showEvents:u(pe.showEvents,this.defaultValue.showEvents),showOperators:u(pe.showOperators,this.defaultValue.showOperators),showUnits:u(pe.showUnits,this.defaultValue.showUnits),showValues:u(pe.showValues,this.defaultValue.showValues),showConstants:u(pe.showConstants,this.defaultValue.showConstants),showEnums:u(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:u(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:u(pe.showKeywords,this.defaultValue.showKeywords),showWords:u(pe.showWords,this.defaultValue.showWords),showColors:u(pe.showColors,this.defaultValue.showColors),showFiles:u(pe.showFiles,this.defaultValue.showFiles),showReferences:u(pe.showReferences,this.defaultValue.showReferences),showFolders:u(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:u(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:u(pe.showSnippets,this.defaultValue.showSnippets),showUsers:u(pe.showUsers,this.defaultValue.showUsers),showIssues:u(pe.showIssues,this.defaultValue.showIssues)}}}class re extends T{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(136,null),default:!0,type:"boolean"}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:u(te.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ae extends n{constructor(){super(129,[80])}compute(te,pe,xe){return pe.get(80)?!0:te.tabFocusMode}}var Y;(function(Z){Z[Z.None=0]="None",Z[Z.Same=1]="Same",Z[Z.Indent=2]="Indent",Z[Z.DeepIndent=3]="DeepIndent"})(Y=e.WrappingIndent||(e.WrappingIndent={}));function oe(Z){switch(Z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ve extends n{constructor(){super(131,[130])}compute(te,pe,xe){const Je=pe.get(130);return{isDominatedByLongLines:te.isDominatedByLongLines,isWordWrapMinified:Je.isWordWrapMinified,isViewportWrapping:Je.isViewportWrapping,wrappingColumn:Je.wrappingColumn}}}const Me="Consolas, 'Courier New', monospace",qe="Menlo, Monaco, 'Courier New', monospace",Ke="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:L.isMacintosh?qe:L.isLinux?Ke:Me,fontWeight:"normal",fontSize:L.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function Se(Z){return e.editorOptionsRegistry[Z.id]=Z,Z}var tt;(function(Z){Z[Z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Z[Z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Z[Z.accessibilitySupport=2]="accessibilitySupport",Z[Z.accessibilityPageSize=3]="accessibilityPageSize",Z[Z.ariaLabel=4]="ariaLabel",Z[Z.autoClosingBrackets=5]="autoClosingBrackets",Z[Z.autoClosingDelete=6]="autoClosingDelete",Z[Z.autoClosingOvertype=7]="autoClosingOvertype",Z[Z.autoClosingQuotes=8]="autoClosingQuotes",Z[Z.autoIndent=9]="autoIndent",Z[Z.automaticLayout=10]="automaticLayout",Z[Z.autoSurround=11]="autoSurround",Z[Z.bracketPairColorization=12]="bracketPairColorization",Z[Z.codeLens=13]="codeLens",Z[Z.codeLensFontFamily=14]="codeLensFontFamily",Z[Z.codeLensFontSize=15]="codeLensFontSize",Z[Z.colorDecorators=16]="colorDecorators",Z[Z.columnSelection=17]="columnSelection",Z[Z.comments=18]="comments",Z[Z.contextmenu=19]="contextmenu",Z[Z.copyWithSyntaxHighlighting=20]="copyWithSyntaxHighlighting",Z[Z.cursorBlinking=21]="cursorBlinking",Z[Z.cursorSmoothCaretAnimation=22]="cursorSmoothCaretAnimation",Z[Z.cursorStyle=23]="cursorStyle",Z[Z.cursorSurroundingLines=24]="cursorSurroundingLines",Z[Z.cursorSurroundingLinesStyle=25]="cursorSurroundingLinesStyle",Z[Z.cursorWidth=26]="cursorWidth",Z[Z.disableLayerHinting=27]="disableLayerHinting",Z[Z.disableMonospaceOptimizations=28]="disableMonospaceOptimizations",Z[Z.domReadOnly=29]="domReadOnly",Z[Z.dragAndDrop=30]="dragAndDrop",Z[Z.emptySelectionClipboard=31]="emptySelectionClipboard",Z[Z.extraEditorClassName=32]="extraEditorClassName",Z[Z.fastScrollSensitivity=33]="fastScrollSensitivity",Z[Z.find=34]="find",Z[Z.fixedOverflowWidgets=35]="fixedOverflowWidgets",Z[Z.folding=36]="folding",Z[Z.foldingStrategy=37]="foldingStrategy",Z[Z.foldingHighlight=38]="foldingHighlight",Z[Z.foldingImportsByDefault=39]="foldingImportsByDefault",Z[Z.unfoldOnClickAfterEndOfLine=40]="unfoldOnClickAfterEndOfLine",Z[Z.fontFamily=41]="fontFamily",Z[Z.fontInfo=42]="fontInfo",Z[Z.fontLigatures=43]="fontLigatures",Z[Z.fontSize=44]="fontSize",Z[Z.fontWeight=45]="fontWeight",Z[Z.formatOnPaste=46]="formatOnPaste",Z[Z.formatOnType=47]="formatOnType",Z[Z.glyphMargin=48]="glyphMargin",Z[Z.gotoLocation=49]="gotoLocation",Z[Z.hideCursorInOverviewRuler=50]="hideCursorInOverviewRuler",Z[Z.highlightActiveIndentGuide=51]="highlightActiveIndentGuide",Z[Z.hover=52]="hover",Z[Z.inDiffEditor=53]="inDiffEditor",Z[Z.inlineSuggest=54]="inlineSuggest",Z[Z.letterSpacing=55]="letterSpacing",Z[Z.lightbulb=56]="lightbulb",Z[Z.lineDecorationsWidth=57]="lineDecorationsWidth",Z[Z.lineHeight=58]="lineHeight",Z[Z.lineNumbers=59]="lineNumbers",Z[Z.lineNumbersMinChars=60]="lineNumbersMinChars",Z[Z.linkedEditing=61]="linkedEditing",Z[Z.links=62]="links",Z[Z.matchBrackets=63]="matchBrackets",Z[Z.minimap=64]="minimap",Z[Z.mouseStyle=65]="mouseStyle",Z[Z.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",Z[Z.mouseWheelZoom=67]="mouseWheelZoom",Z[Z.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",Z[Z.multiCursorModifier=69]="multiCursorModifier",Z[Z.multiCursorPaste=70]="multiCursorPaste",Z[Z.occurrencesHighlight=71]="occurrencesHighlight",Z[Z.overviewRulerBorder=72]="overviewRulerBorder",Z[Z.overviewRulerLanes=73]="overviewRulerLanes",Z[Z.padding=74]="padding",Z[Z.parameterHints=75]="parameterHints",Z[Z.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",Z[Z.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",Z[Z.quickSuggestions=78]="quickSuggestions",Z[Z.quickSuggestionsDelay=79]="quickSuggestionsDelay",Z[Z.readOnly=80]="readOnly",Z[Z.renameOnType=81]="renameOnType",Z[Z.renderControlCharacters=82]="renderControlCharacters",Z[Z.renderIndentGuides=83]="renderIndentGuides",Z[Z.renderFinalNewline=84]="renderFinalNewline",Z[Z.renderLineHighlight=85]="renderLineHighlight",Z[Z.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",Z[Z.renderValidationDecorations=87]="renderValidationDecorations",Z[Z.renderWhitespace=88]="renderWhitespace",Z[Z.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",Z[Z.roundedSelection=90]="roundedSelection",Z[Z.rulers=91]="rulers",Z[Z.scrollbar=92]="scrollbar",Z[Z.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",Z[Z.scrollBeyondLastLine=94]="scrollBeyondLastLine",Z[Z.scrollPredominantAxis=95]="scrollPredominantAxis",Z[Z.selectionClipboard=96]="selectionClipboard",Z[Z.selectionHighlight=97]="selectionHighlight",Z[Z.selectOnLineNumbers=98]="selectOnLineNumbers",Z[Z.showFoldingControls=99]="showFoldingControls",Z[Z.showUnused=100]="showUnused",Z[Z.snippetSuggestions=101]="snippetSuggestions",Z[Z.smartSelect=102]="smartSelect",Z[Z.smoothScrolling=103]="smoothScrolling",Z[Z.stickyTabStops=104]="stickyTabStops",Z[Z.stopRenderingLineAfter=105]="stopRenderingLineAfter",Z[Z.suggest=106]="suggest",Z[Z.suggestFontSize=107]="suggestFontSize",Z[Z.suggestLineHeight=108]="suggestLineHeight",Z[Z.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",Z[Z.suggestSelection=110]="suggestSelection",Z[Z.tabCompletion=111]="tabCompletion",Z[Z.tabIndex=112]="tabIndex",Z[Z.unusualLineTerminators=113]="unusualLineTerminators",Z[Z.useShadowDOM=114]="useShadowDOM",Z[Z.useTabStops=115]="useTabStops",Z[Z.wordSeparators=116]="wordSeparators",Z[Z.wordWrap=117]="wordWrap",Z[Z.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",Z[Z.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",Z[Z.wordWrapColumn=120]="wordWrapColumn",Z[Z.wordWrapOverride1=121]="wordWrapOverride1",Z[Z.wordWrapOverride2=122]="wordWrapOverride2",Z[Z.wrappingIndent=123]="wrappingIndent",Z[Z.wrappingStrategy=124]="wrappingStrategy",Z[Z.showDeprecated=125]="showDeprecated",Z[Z.inlayHints=126]="inlayHints",Z[Z.editorClassName=127]="editorClassName",Z[Z.pixelRatio=128]="pixelRatio",Z[Z.tabFocusMode=129]="tabFocusMode",Z[Z.layoutInfo=130]="layoutInfo",Z[Z.wrappingInfo=131]="wrappingInfo"})(tt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Se(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(137,null)})),acceptSuggestionOnEnter:Se(new E(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(138,null),""],markdownDescription:m.localize(139,null)})),accessibilitySupport:Se(new p),accessibilityPageSize:Se(new l(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(140,null)})),ariaLabel:Se(new S(4,"ariaLabel",m.localize(141,null))),autoClosingBrackets:Se(new E(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(142,null),m.localize(143,null),""],description:m.localize(144,null)})),autoClosingDelete:Se(new E(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(145,null),""],description:m.localize(146,null)})),autoClosingOvertype:Se(new E(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(147,null),""],description:m.localize(148,null)})),autoClosingQuotes:Se(new E(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(149,null),m.localize(150,null),""],description:m.localize(151,null)})),autoIndent:Se(new s(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],a,{enumDescriptions:[m.localize(152,null),m.localize(153,null),m.localize(154,null),m.localize(155,null),m.localize(156,null)],description:m.localize(157,null)})),automaticLayout:Se(new f(10,"automaticLayout",!1)),autoSurround:Se(new E(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(158,null),m.localize(159,null),m.localize(160,null),""],description:m.localize(161,null)})),bracketPairColorization:Se(new V),stickyTabStops:Se(new f(104,"stickyTabStops",!1,{description:m.localize(162,null)})),codeLens:Se(new f(13,"codeLens",!0,{description:m.localize(163,null)})),codeLensFontFamily:Se(new S(14,"codeLensFontFamily","",{description:m.localize(164,null)})),codeLensFontSize:Se(new l(15,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(165,null)})),colorDecorators:Se(new f(16,"colorDecorators",!0,{description:m.localize(166,null)})),columnSelection:Se(new f(17,"columnSelection",!1,{description:m.localize(167,null)})),comments:Se(new t),contextmenu:Se(new f(19,"contextmenu",!0)),copyWithSyntaxHighlighting:Se(new f(20,"copyWithSyntaxHighlighting",!0,{description:m.localize(168,null)})),cursorBlinking:Se(new s(21,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],r,{description:m.localize(169,null)})),cursorSmoothCaretAnimation:Se(new f(22,"cursorSmoothCaretAnimation",!1,{description:m.localize(170,null)})),cursorStyle:Se(new s(23,"cursorStyle",i.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],c,{description:m.localize(171,null)})),cursorSurroundingLines:Se(new l(24,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(172,null)})),cursorSurroundingLinesStyle:Se(new E(25,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(173,null),m.localize(174,null)],description:m.localize(175,null)})),cursorWidth:Se(new l(26,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(176,null)})),disableLayerHinting:Se(new f(27,"disableLayerHinting",!1)),disableMonospaceOptimizations:Se(new f(28,"disableMonospaceOptimizations",!1)),domReadOnly:Se(new f(29,"domReadOnly",!1)),dragAndDrop:Se(new f(30,"dragAndDrop",!0,{description:m.localize(177,null)})),emptySelectionClipboard:Se(new b),extraEditorClassName:Se(new S(32,"extraEditorClassName","")),fastScrollSensitivity:Se(new v(33,"fastScrollSensitivity",5,Z=>Z<=0?5:Z,{markdownDescription:m.localize(178,null)})),find:Se(new y),fixedOverflowWidgets:Se(new f(35,"fixedOverflowWidgets",!1)),folding:Se(new f(36,"folding",!0,{description:m.localize(179,null)})),foldingStrategy:Se(new E(37,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(180,null),m.localize(181,null)],description:m.localize(182,null)})),foldingHighlight:Se(new f(38,"foldingHighlight",!0,{description:m.localize(183,null)})),foldingImportsByDefault:Se(new f(39,"foldingImportsByDefault",!1,{description:m.localize(184,null)})),unfoldOnClickAfterEndOfLine:Se(new f(40,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(185,null)})),fontFamily:Se(new S(41,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(186,null)})),fontInfo:Se(new _),fontLigatures2:Se(new g),fontSize:Se(new w),fontWeight:Se(new F),formatOnPaste:Se(new f(46,"formatOnPaste",!1,{description:m.localize(187,null)})),formatOnType:Se(new f(47,"formatOnType",!1,{description:m.localize(188,null)})),glyphMargin:Se(new f(48,"glyphMargin",!0,{description:m.localize(189,null)})),gotoLocation:Se(new N),hideCursorInOverviewRuler:Se(new f(50,"hideCursorInOverviewRuler",!1,{description:m.localize(190,null)})),highlightActiveIndentGuide:Se(new f(51,"highlightActiveIndentGuide",!0,{description:m.localize(191,null)})),hover:Se(new G),inDiffEditor:Se(new f(53,"inDiffEditor",!1)),letterSpacing:Se(new v(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Z=>v.clamp(Z,-5,20),{description:m.localize(192,null)})),lightbulb:Se(new z),lineDecorationsWidth:Se(new A(57,"lineDecorationsWidth",10)),lineHeight:Se(new B),lineNumbers:Se(new _e),lineNumbersMinChars:Se(new l(60,"lineNumbersMinChars",5,1,300)),linkedEditing:Se(new f(61,"linkedEditing",!1,{description:m.localize(193,null)})),links:Se(new f(62,"links",!0,{description:m.localize(194,null)})),matchBrackets:Se(new E(63,"matchBrackets","always",["always","near","never"],{description:m.localize(195,null)})),minimap:Se(new x),mouseStyle:Se(new E(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Se(new v(66,"mouseWheelScrollSensitivity",1,Z=>Z===0?1:Z,{markdownDescription:m.localize(196,null)})),mouseWheelZoom:Se(new f(67,"mouseWheelZoom",!1,{markdownDescription:m.localize(197,null)})),multiCursorMergeOverlapping:Se(new f(68,"multiCursorMergeOverlapping",!0,{description:m.localize(198,null)})),multiCursorModifier:Se(new s(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],M,{markdownEnumDescriptions:[m.localize(199,null),m.localize(200,null)],markdownDescription:m.localize(201,null)})),multiCursorPaste:Se(new E(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(202,null),m.localize(203,null)],markdownDescription:m.localize(204,null)})),occurrencesHighlight:Se(new f(71,"occurrencesHighlight",!0,{description:m.localize(205,null)})),overviewRulerBorder:Se(new f(72,"overviewRulerBorder",!0,{description:m.localize(206,null)})),overviewRulerLanes:Se(new l(73,"overviewRulerLanes",3,0,3)),padding:Se(new H),parameterHints:Se(new W),peekWidgetDefaultFocus:Se(new E(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(207,null),m.localize(208,null)],description:m.localize(209,null)})),definitionLinkOpensInPeek:Se(new f(77,"definitionLinkOpensInPeek",!1,{description:m.localize(210,null)})),quickSuggestions:Se(new X),quickSuggestionsDelay:Se(new l(79,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(211,null)})),readOnly:Se(new f(80,"readOnly",!1)),renameOnType:Se(new f(81,"renameOnType",!1,{description:m.localize(212,null),markdownDeprecationMessage:m.localize(213,null)})),renderControlCharacters:Se(new f(82,"renderControlCharacters",!1,{description:m.localize(214,null)})),renderIndentGuides:Se(new f(83,"renderIndentGuides",!0,{description:m.localize(215,null)})),renderFinalNewline:Se(new f(84,"renderFinalNewline",!0,{description:m.localize(216,null)})),renderLineHighlight:Se(new E(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(217,null)],description:m.localize(218,null)})),renderLineHighlightOnlyWhenFocus:Se(new f(86,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(219,null)})),renderValidationDecorations:Se(new E(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Se(new E(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(220,null),m.localize(221,null),m.localize(222,null),""],description:m.localize(223,null)})),revealHorizontalRightPadding:Se(new l(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Se(new f(90,"roundedSelection",!0,{description:m.localize(224,null)})),rulers:Se(new Re),scrollbar:Se(new Be),scrollBeyondLastColumn:Se(new l(93,"scrollBeyondLastColumn",5,0,1073741824,{description:m.localize(225,null)})),scrollBeyondLastLine:Se(new f(94,"scrollBeyondLastLine",!0,{description:m.localize(226,null)})),scrollPredominantAxis:Se(new f(95,"scrollPredominantAxis",!0,{description:m.localize(227,null)})),selectionClipboard:Se(new f(96,"selectionClipboard",!0,{description:m.localize(228,null),included:L.isLinux})),selectionHighlight:Se(new f(97,"selectionHighlight",!0,{description:m.localize(229,null)})),selectOnLineNumbers:Se(new f(98,"selectOnLineNumbers",!0)),showFoldingControls:Se(new E(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[m.localize(230,null),m.localize(231,null)],description:m.localize(232,null)})),showUnused:Se(new f(100,"showUnused",!0,{description:m.localize(233,null)})),showDeprecated:Se(new f(125,"showDeprecated",!0,{description:m.localize(234,null)})),inlayHints:Se(new O),snippetSuggestions:Se(new E(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(235,null),m.localize(236,null),m.localize(237,null),m.localize(238,null)],description:m.localize(239,null)})),smartSelect:Se(new re),smoothScrolling:Se(new f(103,"smoothScrolling",!1,{description:m.localize(240,null)})),stopRenderingLineAfter:Se(new l(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Se(new ee),inlineSuggest:Se(new je),suggestFontSize:Se(new l(107,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(241,null)})),suggestLineHeight:Se(new l(108,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(242,null)})),suggestOnTriggerCharacters:Se(new f(109,"suggestOnTriggerCharacters",!0,{description:m.localize(243,null)})),suggestSelection:Se(new E(110,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(244,null),m.localize(245,null),m.localize(246,null)],description:m.localize(247,null)})),tabCompletion:Se(new E(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(248,null),m.localize(249,null),m.localize(250,null)],description:m.localize(251,null)})),tabIndex:Se(new l(112,"tabIndex",0,-1,1073741824)),unusualLineTerminators:Se(new E(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(252,null),m.localize(253,null),m.localize(254,null)],description:m.localize(255,null)})),useShadowDOM:Se(new f(114,"useShadowDOM",!0)),useTabStops:Se(new f(115,"useTabStops",!0,{description:m.localize(256,null)})),wordSeparators:Se(new S(116,"wordSeparators",I.USUAL_WORD_SEPARATORS,{description:m.localize(257,null)})),wordWrap:Se(new E(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(258,null),m.localize(259,null),m.localize(260,null),m.localize(261,null)],description:m.localize(262,null)})),wordWrapBreakAfterCharacters:Se(new S(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Se(new S(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Se(new l(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(263,null)})),wordWrapOverride1:Se(new E(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Se(new E(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Se(new s(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],oe,{enumDescriptions:[m.localize(264,null),m.localize(265,null),m.localize(266,null),m.localize(267,null)],description:m.localize(268,null)})),wrappingStrategy:Se(new E(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[m.localize(269,null),m.localize(270,null)],description:m.localize(271,null)})),editorClassName:Se(new d),pixelRatio:Se(new Q),tabFocusMode:Se(new ae),layoutInfo:Se(new U),wrappingInfo:Se(new ve)}}),define(me[155],ge([19,20]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(me[156],ge([19,20]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(me[157],ge([19,20]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(me[158],ge([19,20]),function(J,e){return J.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(me[159],ge([19,20]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(me[160],ge([19,20]),function(J,e){return J.create("vs/platform/markers/common/markers",e)}),define(me[161],ge([19,20]),function(J,e){return J.create("vs/platform/theme/common/iconRegistry",e)}),define(me[162],ge([19,20]),function(J,e){return J.create("vs/platform/workspaces/common/workspaces",e)}),define(me[163],ge([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(me[164],ge([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostExtensionService",e)}),define(me[165],ge([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostProgress",e)}),define(me[166],ge([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostStatusBar",e)}),define(me[167],ge([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostTerminalService",e)}),define(me[168],ge([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostTreeViews",e)}),define(me[169],ge([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostWorkspace",e)}),define(me[170],ge([19,20]),function(J,e){return J.create("vs/workbench/api/node/extHostDebugService",e)}),define(me[171],ge([19,20]),function(J,e){return J.create("vs/workbench/common/editor",e)}),define(me[172],ge([19,20]),function(J,e){return J.create("vs/workbench/common/views",e)}),define(me[173],ge([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(me[174],ge([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(me[175],ge([19,20]),function(J,e){return J.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(me[176],ge([19,20]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(me[177],ge([19,20]),function(J,e){return J.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(me[178],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var m;(function(R){R[R.ACTIVATE=1]="ACTIVATE",R[R.RESTORE=2]="RESTORE",R[R.PRESERVE=3]="PRESERVE"})(m=e.EditorActivation||(e.EditorActivation={}));var L;(function(R){R[R.PICK=0]="PICK",R[R.DISABLED=1]="DISABLED",R[R.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(L=e.EditorResolution||(e.EditorResolution={}));var I;(function(R){R[R.API=0]="API",R[R.USER=1]="USER"})(I=e.EditorOpenContext||(e.EditorOpenContext={}));var k;(function(R){R[R.Center=0]="Center",R[R.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",R[R.NearTop=2]="NearTop",R[R.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(k=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(me[179],ge([0,1,157]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function k(u){return u=u.trim(),u==="*"||L.test(u)}e.isValidVersionStr=k;function R(u){if(!k(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let f=u.match(L);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=R;function C(u){if(!u)return null;let f=u.majorBase,l=u.majorMustEqual,v=u.minorBase,S=u.minorMustEqual,P=u.patchBase,E=u.patchMustEqual;u.hasCaret&&(f===0||(S=!1),E=!1);let s=0;if(u.preRelease){const a=I.exec(u.preRelease);if(a){const[,p,t,o]=a;s=Date.UTC(Number(p),Number(t)-1,Number(o))}}return{majorBase:f,majorMustEqual:l,minorBase:v,minorMustEqual:S,patchBase:P,patchMustEqual:E,isMinimum:u.hasGreaterEquals,notBefore:s}}e.normalizeVersion=C;function D(u,f,l){let v;typeof u=="string"?v=C(R(u)):v=u;let S;f instanceof Date?S=f.getTime():typeof f=="string"&&(S=new Date(f).getTime());let P;if(typeof l=="string"?P=C(R(l)):P=l,!v||!P)return!1;let E=v.majorBase,s=v.minorBase,a=v.patchBase,p=P.majorBase,t=P.minorBase,o=P.patchBase,r=P.notBefore,i=P.majorMustEqual,h=P.minorMustEqual,c=P.patchMustEqual;return P.isMinimum?E>p?!0:E<p?!1:s>t?!0:s<t||S&&S<r?!1:a>=o:(E===1&&p===0&&(!i||!h||!c)&&(p=1,t=0,o=0,i=!0,h=!1,c=!1),E<p?!1:E>p?!i:s<t?!1:s>t?!h:a<o?!1:a>o?!c:!(S&&S<r))}e.isValidVersion=D;function T(u,f,l,v){return l.isBuiltin||typeof l.main=="undefined"?!0:A(u,f,l.engines.vscode,v)}e.isValidExtensionVersion=T;function n(u,f,l){return u==="*"||A(f,l,u)}e.isEngineValid=n;function A(u,f,l,v=[]){let S=C(R(l));if(!S)return v.push(m.localize(0,null,l)),!1;if(S.majorBase===0){if(!S.majorMustEqual||!S.minorMustEqual)return v.push(m.localize(1,null,l)),!1}else if(!S.majorMustEqual)return v.push(m.localize(2,null,l)),!1;return D(u,f,S)?!0:(v.push(m.localize(3,null,u,l)),!1)}}),define(me[115],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class m{constructor(I,k=[],R=!1){this.ctor=I,this.staticArguments=k,this.supportsDelayedInstantiation=R}}e.SyncDescriptor=m}),define(me[82],ge([0,1,115]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function I(R,C,D){C instanceof m.SyncDescriptor||(C=new m.SyncDescriptor(C,[],D)),L.push([R,C])}e.registerSingleton=I;function k(){return L}e.getSingletonServiceDescriptors=k}),define(me[180],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class m{constructor(k){this.incoming=new Map,this.outgoing=new Map,this.data=k}}e.Node=m;class L{constructor(k){this._hashFn=k,this._nodes=new Map}roots(){const k=[];for(let R of this._nodes.values())R.outgoing.size===0&&k.push(R);return k}insertEdge(k,R){const C=this.lookupOrInsertNode(k),D=this.lookupOrInsertNode(R);C.outgoing.set(this._hashFn(R),D),D.incoming.set(this._hashFn(k),C)}removeNode(k){const R=this._hashFn(k);this._nodes.delete(R);for(let C of this._nodes.values())C.outgoing.delete(R),C.incoming.delete(R)}lookupOrInsertNode(k){const R=this._hashFn(k);let C=this._nodes.get(R);return C||(C=new m(k),this._nodes.set(R,C)),C}lookup(k){return this._nodes.get(this._hashFn(k))}isEmpty(){return this._nodes.size===0}toString(){let k=[];for(let[R,C]of this._nodes)k.push(`${R}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return k.join(`
`)}findCycleSlow(){for(let[k,R]of this._nodes){const C=new Set([k]),D=this._findCycle(R,C);if(D)return D}}_findCycle(k,R){for(let[C,D]of k.outgoing){if(R.has(C))return[...R,C].join(" -> ");R.add(C);const T=this._findCycle(D,R);if(T)return T;R.delete(C)}}}e.Graph=L}),define(me[4],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var m;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function D(T){return T[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=D})(m=e._util||(e._util={})),e.IInstantiationService=I("instantiationService");function L(C,D,T,n){D[m.DI_TARGET]===D?D[m.DI_DEPENDENCIES].push({id:C,index:T,optional:n}):(D[m.DI_DEPENDENCIES]=[{id:C,index:T,optional:n}],D[m.DI_TARGET]=D)}function I(C){if(m.serviceIds.has(C))return m.serviceIds.get(C);const D=function(T,n,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(D,T,A,!1)};return D.toString=()=>C,m.serviceIds.set(C,D),D}e.createDecorator=I;function k(C){return C}e.refineServiceDecorator=k;function R(C){return function(D,T,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(C,D,n,!0)}}e.optional=R}),define(me[181],ge([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,m.createDecorator)("modelService");function L(I){return!I.isTooLargeForSyncing()&&!I.isForSimpleWidget}e.shouldSynchronizeModel=L}),define(me[182],ge([0,1,3,48,6,24,77,81,181]),function(J,e,m,L,I,k,R,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function T(v){return typeof v=="string"?!1:Array.isArray(v)?v.every(T):!!v.exclusive}class n{constructor(){this._clock=0,this._entries=[],this._onDidChange=new m.Emitter}get onDidChange(){return this._onDidChange.event}register(S,P){let E={selector:S,provider:P,_score:-1,_time:this._clock++};return this._entries.push(E),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,I.toDisposable)(()=>{if(E){let s=this._entries.indexOf(E);s>=0&&(this._entries.splice(s,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),E=void 0)}})}has(S){return this.all(S).length>0}all(S){if(!S)return[];this._updateScores(S);const P=[];for(let E of this._entries)E._score>0&&P.push(E.provider);return P}ordered(S){const P=[];return this._orderedForEach(S,E=>P.push(E.provider)),P}orderedGroups(S){const P=[];let E,s;return this._orderedForEach(S,a=>{E&&s===a._score?E.push(a.provider):(s=a._score,E=[a.provider],P.push(E))}),P}_orderedForEach(S,P){if(!!S){this._updateScores(S);for(const E of this._entries)E._score>0&&P(E)}}_updateScores(S){let P={uri:S.uri.toString(),language:S.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===P.language&&this._lastCandidate.uri===P.uri)){this._lastCandidate=P;for(let E of this._entries)if(E._score=(0,C.score)(E.selector,S.uri,S.getLanguageIdentifier().language,(0,D.shouldSynchronizeModel)(S)),T(E.selector)&&E._score>0){for(let s of this._entries)s._score=0;E._score=1e3;break}this._entries.sort(n._compareByScoreAndTime)}}static _compareByScoreAndTime(S,P){return S._score<P._score?1:S._score>P._score?-1:S._time<P._time?1:S._time>P._time?-1:0}}e.LanguageFeatureRegistry=n;const A=new WeakMap;let u=0;function f(v){let S=A.get(v);return S===void 0&&(S=++u,A.set(v,S)),S}class l{constructor(S,P,E=Number.MAX_SAFE_INTEGER){this._registry=S,this.min=P,this.max=E,this._cache=new k.LRUCache(50,.7)}_key(S){return S.id+this._registry.all(S).reduce((P,E)=>(0,L.doHash)(f(E),P),0)}_clamp(S){return S===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(S*1.3)))}get(S){const P=this._key(S),E=this._cache.get(P);return this._clamp(E?.value)}update(S,P){const E=this._key(S);let s=this._cache.get(E);return s||(s=new R.MovingAverage,this._cache.set(E,s)),s.update(P),this.get(S)}}e.LanguageFeatureRequestDelays=l}),define(me[83],ge([0,1,2,41,182,148,47]),function(J,e,m,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var C;(function(g){g[g.Null=0]="Null",g[g.PlainText=1]="PlainText"})(C=e.LanguageId||(e.LanguageId={}));class D{constructor(_,w){this.language=_,this.id=w}}e.LanguageIdentifier=D;var T;(function(g){g[g.NotSet=-1]="NotSet",g[g.None=0]="None",g[g.Italic=1]="Italic",g[g.Bold=2]="Bold",g[g.Underline=4]="Underline"})(T=e.FontStyle||(e.FontStyle={}));var n;(function(g){g[g.None=0]="None",g[g.DefaultForeground=1]="DefaultForeground",g[g.DefaultBackground=2]="DefaultBackground"})(n=e.ColorId||(e.ColorId={}));var A;(function(g){g[g.Other=0]="Other",g[g.Comment=1]="Comment",g[g.String=2]="String",g[g.RegEx=4]="RegEx"})(A=e.StandardTokenType||(e.StandardTokenType={}));var u;(function(g){g[g.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",g[g.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",g[g.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",g[g.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",g[g.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",g[g.ITALIC_MASK=2048]="ITALIC_MASK",g[g.BOLD_MASK=4096]="BOLD_MASK",g[g.UNDERLINE_MASK=8192]="UNDERLINE_MASK",g[g.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",g[g.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",g[g.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",g[g.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",g[g.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",g[g.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",g[g.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",g[g.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",g[g.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",g[g.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(u=e.MetadataConsts||(e.MetadataConsts={}));class f{static getLanguageId(_){return(_&255)>>>0}static getTokenType(_){return(_&1792)>>>8}static getFontStyle(_){return(_&14336)>>>11}static getForeground(_){return(_&8372224)>>>14}static getBackground(_){return(_&4286578688)>>>23}static getClassNameFromMetadata(_){let w=this.getForeground(_),F="mtk"+w,N=this.getFontStyle(_);return N&1&&(F+=" mtki"),N&2&&(F+=" mtkb"),N&4&&(F+=" mtku"),F}static getInlineStyleFromMetadata(_,w){const F=this.getForeground(_),N=this.getFontStyle(_);let G=`color: ${w[F]};`;return N&1&&(G+="font-style: italic;"),N&2&&(G+="font-weight: bold;"),N&4&&(G+="text-decoration: underline;"),G}}e.TokenMetadata=f;var l;(function(g){g[g.Method=0]="Method",g[g.Function=1]="Function",g[g.Constructor=2]="Constructor",g[g.Field=3]="Field",g[g.Variable=4]="Variable",g[g.Class=5]="Class",g[g.Struct=6]="Struct",g[g.Interface=7]="Interface",g[g.Module=8]="Module",g[g.Property=9]="Property",g[g.Event=10]="Event",g[g.Operator=11]="Operator",g[g.Unit=12]="Unit",g[g.Value=13]="Value",g[g.Constant=14]="Constant",g[g.Enum=15]="Enum",g[g.EnumMember=16]="EnumMember",g[g.Keyword=17]="Keyword",g[g.Text=18]="Text",g[g.Color=19]="Color",g[g.File=20]="File",g[g.Reference=21]="Reference",g[g.Customcolor=22]="Customcolor",g[g.Folder=23]="Folder",g[g.TypeParameter=24]="TypeParameter",g[g.User=25]="User",g[g.Issue=26]="Issue",g[g.Snippet=27]="Snippet"})(l=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let g=Object.create(null);return g[0]="symbol-method",g[1]="symbol-function",g[2]="symbol-constructor",g[3]="symbol-field",g[4]="symbol-variable",g[5]="symbol-class",g[6]="symbol-struct",g[7]="symbol-interface",g[8]="symbol-module",g[9]="symbol-property",g[10]="symbol-event",g[11]="symbol-operator",g[12]="symbol-unit",g[13]="symbol-value",g[14]="symbol-constant",g[15]="symbol-enum",g[16]="symbol-enum-member",g[17]="symbol-keyword",g[27]="symbol-snippet",g[18]="symbol-text",g[19]="symbol-color",g[20]="symbol-file",g[21]="symbol-reference",g[22]="symbol-customcolor",g[23]="symbol-folder",g[24]="symbol-type-parameter",g[25]="account",g[26]="issues",function(_){const w=g[_];let F=w&&R.iconRegistry.get(w);return F||(console.info("No codicon found for CompletionItemKind "+_),F=R.Codicon.symbolProperty),F.classNames}}(),e.completionKindFromString=function(){let g=Object.create(null);return g.method=0,g.function=1,g.constructor=2,g.field=3,g.variable=4,g.class=5,g.struct=6,g.interface=7,g.module=8,g.property=9,g.event=10,g.operator=11,g.unit=12,g.value=13,g.constant=14,g.enum=15,g["enum-member"]=16,g.enumMember=16,g.keyword=17,g.snippet=27,g.text=18,g.color=19,g.file=20,g.reference=21,g.customcolor=22,g.folder=23,g["type-parameter"]=24,g.typeParameter=24,g.account=25,g.issue=26,function(_,w){let F=g[_];return typeof F=="undefined"&&!w&&(F=9),F}}();var v;(function(g){g[g.Deprecated=1]="Deprecated"})(v=e.CompletionItemTag||(e.CompletionItemTag={}));var S;(function(g){g[g.KeepWhitespace=1]="KeepWhitespace",g[g.InsertAsSnippet=4]="InsertAsSnippet"})(S=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var P;(function(g){g[g.Invoke=0]="Invoke",g[g.TriggerCharacter=1]="TriggerCharacter",g[g.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(P=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var E;(function(g){g[g.Automatic=0]="Automatic",g[g.Explicit=1]="Explicit"})(E=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var s;(function(g){g[g.Invoke=1]="Invoke",g[g.Auto=2]="Auto"})(s=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var a;(function(g){g[g.Invoke=1]="Invoke",g[g.TriggerCharacter=2]="TriggerCharacter",g[g.ContentChange=3]="ContentChange"})(a=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var p;(function(g){g[g.Text=0]="Text",g[g.Read=1]="Read",g[g.Write=2]="Write"})(p=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(g){return g&&m.URI.isUri(g.uri)&&L.Range.isIRange(g.range)&&(L.Range.isIRange(g.originSelectionRange)||L.Range.isIRange(g.targetSelectionRange))}e.isLocationLink=t;var o;(function(g){g[g.File=0]="File",g[g.Module=1]="Module",g[g.Namespace=2]="Namespace",g[g.Package=3]="Package",g[g.Class=4]="Class",g[g.Method=5]="Method",g[g.Property=6]="Property",g[g.Field=7]="Field",g[g.Constructor=8]="Constructor",g[g.Enum=9]="Enum",g[g.Interface=10]="Interface",g[g.Function=11]="Function",g[g.Variable=12]="Variable",g[g.Constant=13]="Constant",g[g.String=14]="String",g[g.Number=15]="Number",g[g.Boolean=16]="Boolean",g[g.Array=17]="Array",g[g.Object=18]="Object",g[g.Key=19]="Key",g[g.Null=20]="Null",g[g.EnumMember=21]="EnumMember",g[g.Struct=22]="Struct",g[g.Event=23]="Event",g[g.Operator=24]="Operator",g[g.TypeParameter=25]="TypeParameter"})(o=e.SymbolKind||(e.SymbolKind={}));var r;(function(g){g[g.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var i;(function(g){const _=new Map;_.set("file",0),_.set("module",1),_.set("namespace",2),_.set("package",3),_.set("class",4),_.set("method",5),_.set("property",6),_.set("field",7),_.set("constructor",8),_.set("enum",9),_.set("interface",10),_.set("function",11),_.set("variable",12),_.set("constant",13),_.set("string",14),_.set("number",15),_.set("boolean",16),_.set("array",17),_.set("object",18),_.set("key",19),_.set("null",20),_.set("enum-member",21),_.set("struct",22),_.set("event",23),_.set("operator",24),_.set("type-parameter",25);const w=new Map;w.set(0,"file"),w.set(1,"module"),w.set(2,"namespace"),w.set(3,"package"),w.set(4,"class"),w.set(5,"method"),w.set(6,"property"),w.set(7,"field"),w.set(8,"constructor"),w.set(9,"enum"),w.set(10,"interface"),w.set(11,"function"),w.set(12,"variable"),w.set(13,"constant"),w.set(14,"string"),w.set(15,"number"),w.set(16,"boolean"),w.set(17,"array"),w.set(18,"object"),w.set(19,"key"),w.set(20,"null"),w.set(21,"enum-member"),w.set(22,"struct"),w.set(23,"event"),w.set(24,"operator"),w.set(25,"type-parameter");function F(K){return _.get(K)}g.fromString=F;function N(K){return w.get(K)}g.toString=N;function G(K,U){const z=w.get(K);let O=z&&R.iconRegistry.get("symbol-"+z);return O||(console.info("No codicon found for SymbolKind "+K),O=R.Codicon.symbolProperty),`${U?"inline":"block"} ${O.classNames}`}g.toCssClassName=G})(i=e.SymbolKinds||(e.SymbolKinds={}));class h{constructor(_){this.value=_}}e.FoldingRangeKind=h,h.Comment=new h("comment"),h.Imports=new h("imports"),h.Region=new h("region");var c;(function(g){g[g.Collapsed=0]="Collapsed",g[g.Expanded=1]="Expanded"})(c=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var d;(function(g){g[g.Editing=0]="Editing",g[g.Preview=1]="Preview"})(d=e.CommentMode||(e.CommentMode={}));var b;(function(g){g[g.Other=0]="Other",g[g.Type=1]="Type",g[g.Parameter=2]="Parameter"})(b=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new I.LanguageFeatureRegistry,e.RenameProviderRegistry=new I.LanguageFeatureRegistry,e.CompletionProviderRegistry=new I.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new I.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new I.LanguageFeatureRegistry,e.HoverProviderRegistry=new I.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new I.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new I.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new I.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new I.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new I.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new I.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new I.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new I.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new I.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.LinkProviderRegistry=new I.LanguageFeatureRegistry,e.ColorProviderRegistry=new I.LanguageFeatureRegistry,e.SelectionRangeRegistry=new I.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new I.LanguageFeatureRegistry,e.TokenizationRegistry=new k.TokenizationRegistryImpl;var y;(function(g){g[g.None=0]="None",g[g.Option=1]="Option",g[g.Default=2]="Default",g[g.Preferred=3]="Preferred"})(y=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(me[62],ge([0,1,11,9,4]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let k=m.userAgent||"";const R=new Map;R.set("false",!1),R.set("true",!0),R.set("isMac",m.isMacintosh),R.set("isLinux",m.isLinux),R.set("isWindows",m.isWindows),R.set("isWeb",m.isWeb),R.set("isMacNative",m.isMacintosh&&!m.isWeb),R.set("isEdge",k.indexOf("Edg/")>=0),R.set("isFirefox",k.indexOf("Firefox")>=0),R.set("isChrome",k.indexOf("Chrome")>=0),R.set("isSafari",k.indexOf("Safari")>=0);const C=Object.prototype.hasOwnProperty;var D;(function(_){_[_.False=0]="False",_[_.True=1]="True",_[_.Defined=2]="Defined",_[_.Not=3]="Not",_[_.Equals=4]="Equals",_[_.NotEquals=5]="NotEquals",_[_.And=6]="And",_[_.Regex=7]="Regex",_[_.NotRegex=8]="NotRegex",_[_.Or=9]="Or",_[_.In=10]="In",_[_.NotIn=11]="NotIn",_[_.Greater=12]="Greater",_[_.GreaterEquals=13]="GreaterEquals",_[_.Smaller=14]="Smaller",_[_.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class T{static false(){return A.INSTANCE}static true(){return u.INSTANCE}static has(w){return f.create(w)}static equals(w,F){return l.create(w,F)}static notEquals(w,F){return P.create(w,F)}static regex(w,F){return o.create(w,F)}static in(w,F){return v.create(w,F)}static not(w){return E.create(w)}static and(...w){return i.create(w,null)}static or(...w){return h.create(w,null,!0)}static greater(w,F){return s.create(w,F)}static less(w,F){return p.create(w,F)}static deserialize(w,F=!1){if(!!w)return this._deserializeOrExpression(w,F)}static _deserializeOrExpression(w,F){let N=w.split("||");return h.create(N.map(G=>this._deserializeAndExpression(G,F)),null,!0)}static _deserializeAndExpression(w,F){let N=w.split("&&");return i.create(N.map(G=>this._deserializeOne(G,F)),null)}static _deserializeOne(w,F){if(w=w.trim(),w.indexOf("!=")>=0){let N=w.split("!=");return P.create(N[0].trim(),this._deserializeValue(N[1],F))}if(w.indexOf("==")>=0){let N=w.split("==");return l.create(N[0].trim(),this._deserializeValue(N[1],F))}if(w.indexOf("=~")>=0){let N=w.split("=~");return o.create(N[0].trim(),this._deserializeRegexValue(N[1],F))}if(w.indexOf(" in ")>=0){let N=w.split(" in ");return v.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(w)){const N=w.split(">=");return a.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(w)){const N=w.split(">");return s.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(w)){const N=w.split("<=");return t.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(w)){const N=w.split("<");return p.create(N[0].trim(),N[1].trim())}return/^\!\s*/.test(w)?E.create(w.substr(1).trim()):f.create(w)}static _deserializeValue(w,F){if(w=w.trim(),w==="true")return!0;if(w==="false")return!1;let N=/^'([^']*)'$/.exec(w);return N?N[1].trim():w}static _deserializeRegexValue(w,F){if((0,L.isFalsyOrWhitespace)(w)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let N=w.indexOf("/"),G=w.lastIndexOf("/");if(N===G||N<0){if(F)throw new Error(`bad regexp-value '${w}', missing /-enclosure`);return console.warn(`bad regexp-value '${w}', missing /-enclosure`),null}let K=w.slice(N+1,G),U=w[G+1]==="i"?"i":"";try{return new RegExp(K,U)}catch(z){if(F)throw new Error(`bad regexp-value '${w}', parse error: ${z}`);return console.warn(`bad regexp-value '${w}', parse error: ${z}`),null}}}e.ContextKeyExpr=T;function n(_,w){return _.cmp(w)}class A{constructor(){this.type=0}cmp(w){return this.type-w.type}equals(w){return w.type===this.type}evaluate(w){return!1}serialize(){return"false"}keys(){return[]}map(w){return this}negate(){return u.INSTANCE}}e.ContextKeyFalseExpr=A,A.INSTANCE=new A;class u{constructor(){this.type=1}cmp(w){return this.type-w.type}equals(w){return w.type===this.type}evaluate(w){return!0}serialize(){return"true"}keys(){return[]}map(w){return this}negate(){return A.INSTANCE}}e.ContextKeyTrueExpr=u,u.INSTANCE=new u;class f{constructor(w,F){this.key=w,this.negated=F,this.type=2}static create(w,F=null){const N=R.get(w);return typeof N=="boolean"?N?u.INSTANCE:A.INSTANCE:new f(w,F)}cmp(w){return w.type!==this.type?this.type-w.type:d(this.key,w.key)}equals(w){return w.type===this.type?this.key===w.key:!1}evaluate(w){return!!w.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(w){return w.mapDefined(this.key)}negate(){return this.negated||(this.negated=E.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=f;class l{constructor(w,F,N){this.key=w,this.value=F,this.negated=N,this.type=4}static create(w,F,N=null){if(typeof F=="boolean")return F?f.create(w,N):E.create(w,N);const G=R.get(w);return typeof G=="boolean"?F===(G?"true":"false")?u.INSTANCE:A.INSTANCE:new l(w,F,N)}cmp(w){return w.type!==this.type?this.type-w.type:b(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return w.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(w){return w.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=P.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=l;class v{constructor(w,F){this.key=w,this.valueKey=F,this.type=10,this.negated=null}static create(w,F){return new v(w,F)}cmp(w){return w.type!==this.type?this.type-w.type:b(this.key,this.valueKey,w.key,w.valueKey)}equals(w){return w.type===this.type?this.key===w.key&&this.valueKey===w.valueKey:!1}evaluate(w){const F=w.getValue(this.valueKey),N=w.getValue(this.key);return Array.isArray(F)?F.indexOf(N)>=0:typeof N=="string"&&typeof F=="object"&&F!==null?C.call(F,N):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(w){return w.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=S.create(this)),this.negated}}e.ContextKeyInExpr=v;class S{constructor(w){this._actual=w,this.type=11}static create(w){return new S(w)}cmp(w){return w.type!==this.type?this.type-w.type:this._actual.cmp(w._actual)}equals(w){return w.type===this.type?this._actual.equals(w._actual):!1}evaluate(w){return!this._actual.evaluate(w)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(w){return new S(this._actual.map(w))}negate(){return this._actual}}e.ContextKeyNotInExpr=S;class P{constructor(w,F,N){this.key=w,this.value=F,this.negated=N,this.type=5}static create(w,F,N=null){if(typeof F=="boolean")return F?E.create(w,N):f.create(w,N);const G=R.get(w);return typeof G=="boolean"?F===(G?"true":"false")?A.INSTANCE:u.INSTANCE:new P(w,F,N)}cmp(w){return w.type!==this.type?this.type-w.type:b(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return w.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(w){return w.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=P;class E{constructor(w,F){this.key=w,this.negated=F,this.type=3}static create(w,F=null){const N=R.get(w);return typeof N=="boolean"?N?A.INSTANCE:u.INSTANCE:new E(w,F)}cmp(w){return w.type!==this.type?this.type-w.type:d(this.key,w.key)}equals(w){return w.type===this.type?this.key===w.key:!1}evaluate(w){return!w.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(w){return w.mapNot(this.key)}negate(){return this.negated||(this.negated=f.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=E;class s{constructor(w,F,N){this.key=w,this.value=F,this.negated=N,this.type=12}static create(w,F,N=null){return new s(w,F,N)}cmp(w){return w.type!==this.type?this.type-w.type:b(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(w){return w.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=t.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=s;class a{constructor(w,F,N){this.key=w,this.value=F,this.negated=N,this.type=13}static create(w,F,N=null){return new a(w,F,N)}cmp(w){return w.type!==this.type?this.type-w.type:b(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(w){return w.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=a;class p{constructor(w,F,N){this.key=w,this.value=F,this.negated=N,this.type=14}static create(w,F,N=null){return new p(w,F,N)}cmp(w){return w.type!==this.type?this.type-w.type:b(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(w){return w.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=p;class t{constructor(w,F,N){this.key=w,this.value=F,this.negated=N,this.type=15}static create(w,F,N=null){return new t(w,F,N)}cmp(w){return w.type!==this.type?this.type-w.type:b(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(w){return w.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=t;class o{constructor(w,F){this.key=w,this.regexp=F,this.type=7,this.negated=null}static create(w,F){return new o(w,F)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.key<w.key)return-1;if(this.key>w.key)return 1;const F=this.regexp?this.regexp.source:"",N=w.regexp?w.regexp.source:"";return F<N?-1:F>N?1:0}equals(w){if(w.type===this.type){const F=this.regexp?this.regexp.source:"",N=w.regexp?w.regexp.source:"";return this.key===w.key&&F===N}return!1}evaluate(w){let F=w.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const w=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${w}`}keys(){return[this.key]}map(w){return w.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=r.create(this)),this.negated}}e.ContextKeyRegexExpr=o;class r{constructor(w){this._actual=w,this.type=8}static create(w){return new r(w)}cmp(w){return w.type!==this.type?this.type-w.type:this._actual.cmp(w._actual)}equals(w){return w.type===this.type?this._actual.equals(w._actual):!1}evaluate(w){return!this._actual.evaluate(w)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(w){return new r(this._actual.map(w))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;class i{constructor(w,F){this.expr=w,this.negated=F,this.type=6}static create(w,F){return i._normalizeArr(w,F)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.expr.length<w.expr.length)return-1;if(this.expr.length>w.expr.length)return 1;for(let F=0,N=this.expr.length;F<N;F++){const G=n(this.expr[F],w.expr[F]);if(G!==0)return G}return 0}equals(w){if(w.type===this.type){if(this.expr.length!==w.expr.length)return!1;for(let F=0,N=this.expr.length;F<N;F++)if(!this.expr[F].equals(w.expr[F]))return!1;return!0}return!1}evaluate(w){for(let F=0,N=this.expr.length;F<N;F++)if(!this.expr[F].evaluate(w))return!1;return!0}static _normalizeArr(w,F){const N=[];let G=!1;for(const K of w)if(!!K){if(K.type===1){G=!0;continue}if(K.type===0)return A.INSTANCE;if(K.type===6){N.push(...K.expr);continue}N.push(K)}if(N.length===0&&G)return u.INSTANCE;if(N.length!==0){if(N.length===1)return N[0];N.sort(n);for(let K=1;K<N.length;K++)N[K-1].equals(N[K])&&(N.splice(K,1),K--);if(N.length===1)return N[0];for(;N.length>1;){const K=N[N.length-1];if(K.type!==9)break;N.pop();const U=N.pop(),z=N.length===0,O=h.create(K.expr.map(B=>i.create([B,U],null)),null,z);O&&(N.push(O),N.sort(n))}return N.length===1?N[0]:new i(N,F)}}serialize(){return this.expr.map(w=>w.serialize()).join(" && ")}keys(){const w=[];for(let F of this.expr)w.push(...F.keys());return w}map(w){return new i(this.expr.map(F=>F.map(w)),null)}negate(){if(!this.negated){const w=[];for(let F of this.expr)w.push(F.negate());this.negated=h.create(w,this,!0)}return this.negated}}class h{constructor(w,F){this.expr=w,this.negated=F,this.type=9}static create(w,F,N){return h._normalizeArr(w,F,N)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.expr.length<w.expr.length)return-1;if(this.expr.length>w.expr.length)return 1;for(let F=0,N=this.expr.length;F<N;F++){const G=n(this.expr[F],w.expr[F]);if(G!==0)return G}return 0}equals(w){if(w.type===this.type){if(this.expr.length!==w.expr.length)return!1;for(let F=0,N=this.expr.length;F<N;F++)if(!this.expr[F].equals(w.expr[F]))return!1;return!0}return!1}evaluate(w){for(let F=0,N=this.expr.length;F<N;F++)if(this.expr[F].evaluate(w))return!0;return!1}static _normalizeArr(w,F,N){let G=[],K=!1;if(w){for(let U=0,z=w.length;U<z;U++){const O=w[U];if(!!O){if(O.type===0){K=!0;continue}if(O.type===1)return u.INSTANCE;if(O.type===9){G=G.concat(O.expr);continue}G.push(O)}}if(G.length===0&&K)return A.INSTANCE;G.sort(n)}if(G.length!==0){if(G.length===1)return G[0];for(let U=1;U<G.length;U++)G[U-1].equals(G[U])&&(G.splice(U,1),U--);if(G.length===1)return G[0];if(N){for(let U=0;U<G.length;U++)for(let z=U+1;z<G.length;z++)y(G[U],G[z])&&(G.splice(z,1),z--);if(G.length===1)return G[0]}return new h(G,F)}}serialize(){return this.expr.map(w=>w.serialize()).join(" || ")}keys(){const w=[];for(let F of this.expr)w.push(...F.keys());return w}map(w){return new h(this.expr.map(F=>F.map(w)),null)}negate(){if(!this.negated){let w=[];for(let F of this.expr)w.push(F.negate());for(;w.length>1;){const F=w.shift(),N=w.shift(),G=[];for(const U of g(F))for(const z of g(N))G.push(i.create([U,z],null));const K=w.length===0;w.unshift(h.create(G,null,K))}this.negated=w[0]}return this.negated}}class c extends f{constructor(w,F,N){super(w,null);this._defaultValue=F,typeof N=="object"?c._info.push({...N,key:w}):N!==!0&&c._info.push({key:w,description:N,type:F!=null?typeof F:void 0})}static all(){return c._info.values()}bindTo(w){return w.createKey(this.key,this._defaultValue)}getValue(w){return w.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(w){return l.create(this.key,w)}notEqualsTo(w){return P.create(this.key,w)}}e.RawContextKey=c,c._info=[],e.IContextKeyService=(0,I.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function d(_,w){return _<w?-1:_>w?1:0}function b(_,w,F,N){return _<F?-1:_>F?1:w<N?-1:w>N?1:0}function y(_,w){if(w.type===6&&_.type!==9&&_.type!==6){for(const G of w.expr)if(_.equals(G))return!0}const F=_.negate(),N=g(F).concat(g(w));N.sort(n);for(let G=0;G<N.length;G++){const U=N[G].negate();for(let z=G+1;z<N.length;z++){const O=N[z];if(U.equals(O))return!0}}return!1}e.implies=y;function g(_){return _.type===9?_.expr:[_]}}),define(me[183],ge([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,m.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,m.refineServiceDecorator)(e.IEnvironmentService)}),define(me[184],ge([0,1,10,11,34,156,4]),function(J,e,m,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.CURRENT_TARGET_PLATFORM=e.getTargetPlatform=e.getTargetPlatformFromOS=e.toTargetPlatform=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var C;(function(P){P.WIN32_X64="win32-x64",P.WIN32_IA32="win32-ia32",P.WIN32_ARM64="win32-arm64",P.LINUX_X64="linux-x64",P.LINUX_ARM64="linux-arm64",P.LINUX_ARMHF="linux-armhf",P.DARWIN_X64="darwin-x64",P.DARWIN_ARM64="darwin-arm64",P.WEB="web",P.UNIVERSAL="universal",P.UNKNOWN="unknown",P.UNDEFINED="undefined"})(C=e.TargetPlatform||(e.TargetPlatform={}));function D(P){switch(P){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=D;function T(P,E){let s;switch(P){case 1:s=3;break;case 3:s=2;break;case 2:s=1;break}return n(s,E)}e.getTargetPlatformFromOS=T;function n(P,E){switch(P){case 3:return E==="x64"?"win32-x64":E==="ia32"?"win32-ia32":E==="arm64"?"win32-arm64":"unknown";case 2:return E==="x64"?"linux-x64":E==="arm64"?"linux-arm64":E==="arm"?"linux-armhf":"unknown";case 1:return E==="x64"?"darwin-x64":E==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=n,e.CURRENT_TARGET_PLATFORM=L.isWeb?"web":n(L.platform,I.arch);function A(P){return P&&typeof P=="object"&&typeof P.id=="string"&&(!P.uuid||typeof P.uuid=="string")}e.isIExtensionIdentifier=A;var u;(function(P){P[P.NoneOrRelevance=0]="NoneOrRelevance",P[P.LastUpdatedDate=1]="LastUpdatedDate",P[P.Title=2]="Title",P[P.PublisherName=3]="PublisherName",P[P.InstallCount=4]="InstallCount",P[P.PublishedDate=5]="PublishedDate",P[P.AverageRating=6]="AverageRating",P[P.WeightedRating=12]="WeightedRating"})(u=e.SortBy||(e.SortBy={}));var f;(function(P){P[P.Default=0]="Default",P[P.Ascending=1]="Ascending",P[P.Descending=2]="Descending"})(f=e.SortOrder||(e.SortOrder={}));var l;(function(P){P.Install="install",P.Uninstall="uninstall"})(l=e.StatisticType||(e.StatisticType={}));var v;(function(P){P[P.None=0]="None",P[P.Install=1]="Install",P[P.Update=2]="Update"})(v=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class S extends Error{constructor(E,s){super(E);this.code=s,this.name=s}}e.ExtensionManagementError=S,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=m.FileAccess.asBrowserUri("./media/defaultIcon.png",J).toString(!0),e.ExtensionsLabel=(0,k.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,k.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,R.createDecorator)("IExtensionManagementCLIService")}),define(me[26],ge([0,1,9,4]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function I(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=I;function k(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));class C{constructor(A){this.value=A,this._lower=A.toLowerCase()}static equals(A,u){if(typeof A=="undefined"||A===null)return typeof u=="undefined"||u===null;if(typeof u=="undefined"||u===null)return!1;if(typeof A=="string"||typeof u=="string"){let f=typeof A=="string"?A:A.value,l=typeof u=="string"?u:u.value;return m.equalsIgnoreCase(f,l)}return A._lower===u._lower}static toKey(A){return typeof A=="string"?A.toLowerCase():A._lower}}e.ExtensionIdentifier=C;function D(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=D;function T(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=T,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(me[185],ge([0,1,9,26]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function I(l,v){return l.uuid&&v.uuid?l.uuid===v.uuid:l.id===v.id?!0:(0,m.compareIgnoreCase)(l.id,v.id)===0}e.areSameExtensions=I;class k{constructor(v,S){this.version=S,this.id=v.id,this.uuid=v.uuid}key(){return`${this.id}-${this.version}`}equals(v){return v instanceof k?I(this,v)&&this.version===v.version:!1}}e.ExtensionIdentifierWithVersion=k;function R(l,v){return`${l}.${v}`}e.getExtensionId=R;function C(l){return l.toLocaleLowerCase()}e.adoptToGalleryExtensionId=C;function D(l,v){return C(R(l,v))}e.getGalleryExtensionId=D;function T(l,v){const S=[],P=E=>{for(const s of S)if(s.some(a=>I(v(a),v(E))))return s;return null};for(const E of l){const s=P(E);s?s.push(E):S.push([E])}return S}e.groupByExtension=T;function n(l){return{id:l.identifier.id,name:l.manifest.name,galleryId:null,publisherId:l.publisherId,publisherName:l.manifest.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:l.manifest.extensionDependencies&&l.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function A(l){return{id:l.identifier.id,name:l.name,galleryId:l.identifier.uuid,publisherId:l.publisherId,publisherName:l.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:!!(l.properties.dependencies&&l.properties.dependencies.length>0),...l.telemetryData}}e.getGalleryExtensionTelemetryData=A,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function u(l){const v=new Set;for(const S of l)S.malicious&&v.add(S.id.id);return v}e.getMaliciousExtensionsSet=u;function f(l,v){const S=[],P=v.manifest.extensionDependencies?.slice(0)??[];for(;P.length;){const E=P.shift();if(E&&S.every(s=>!I(s.identifier,{id:E}))){const s=l.filter(a=>I(a.identifier,{id:E}));s.length===1&&(S.push(s[0]),P.push(...s[0].manifest.extensionDependencies?.slice(0)??[]))}}return S}e.getExtensionDependencies=f}),define(me[186],ge([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,m.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,m.createDecorator)("externalTerminal")}),define(me[187],ge([0,1,39,10,8,11,140,28,113,158,186]),function(J,e,m,L,I,k,R,C,D,T,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const A=T.localize(0,null);class u{async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends u{openTerminal(a,p){return this.spawnTerminal(m,a,D.getWindowsShell(),p)}spawnTerminal(a,p,t,o){const r=p.windowsExec||f.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const i=I.basename(r).toLowerCase();if(i==="cmder"||i==="cmder.exe")return a.spawn(r,o?[o]:void 0),Promise.resolve(void 0);const h=["/c","start","/wait"];return r.indexOf(" ")>=0&&h.push('""'),h.push(r),(i==="wt"||i==="wt.exe")&&h.push("-d ."),new Promise((c,d)=>{const b=S(process),y=a.spawn(t,h,{cwd:o,env:b});y.on("error",d),y.on("exit",()=>c())})}runInTerminal(a,p,t,o,r){const i="windowsExec"in r&&r.windowsExec?r.windowsExec:f.getDefaultTerminalWindows();return new Promise((h,c)=>{const d=`"${p} - ${A}"`,b=`""${t.join('" "')}" & pause"`,y=["/c","start",d,"/wait",i,"/c",b],g=Object.assign({},S(process),o);Object.keys(g).filter(F=>g[F]===null).forEach(F=>delete g[F]);const _={cwd:p,env:g,windowsVerbatimArguments:!0};m.spawn(f.CMD,y,_).on("error",F=>{c(P(F))}),h(void 0)})}static getDefaultTerminalWindows(){if(!f._DEFAULT_TERMINAL_WINDOWS){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return f._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=f,f.CMD="cmd.exe";class l extends u{openTerminal(a,p){return this.spawnTerminal(m,a,p)}runInTerminal(a,p,t,o,r){const i=r.osxExec||n.DEFAULT_TERMINAL_OSX;return new Promise((h,c)=>{if(i===n.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const d=i===n.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",y=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${d}.scpt`,J).fsPath,"-t",a||A,"-w",p];for(let w of t)y.push("-a"),y.push(w);if(o){const w=Object.assign({},S(process),o);for(let F in w){const N=w[F];N===null?(y.push("-u"),y.push(F)):(y.push("-e"),y.push(`${F}=${N}`))}}let g="";const _=m.spawn(l.OSASCRIPT,y);_.on("error",w=>{c(P(w))}),_.stderr.on("data",w=>{g+=w.toString()}),_.on("exit",w=>{if(w===0)h(void 0);else if(g){const F=g.split(`
`,1);c(new Error(F[0]))}else c(new Error(T.localize(1,null,d,w)))})}else c(new Error(T.localize(2,null,i)))})}spawnTerminal(a,p,t){const o=p.osxExec||n.DEFAULT_TERMINAL_OSX;return new Promise((r,i)=>{const h=["-a",o];t&&h.push(t);const c=S(process),d=a.spawn("/usr/bin/open",h,{cwd:t,env:c});d.on("error",i),d.on("exit",()=>r())})}}e.MacExternalTerminalService=l,l.OSASCRIPT="/usr/bin/osascript";class v extends u{openTerminal(a,p){return this.spawnTerminal(m,a,p)}runInTerminal(a,p,t,o,r){const i=r.linuxExec?Promise.resolve(r.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((h,c)=>{let d=[];i.then(b=>{b.indexOf("gnome-terminal")>=0?d.push("-x"):d.push("-e"),d.push("bash"),d.push("-c");const y=`${E(t)}; echo; read -p "${v.WAIT_MESSAGE}" -n1;`;d.push(`''${y}''`);const g=Object.assign({},S(process),o);Object.keys(g).filter(N=>g[N]===null).forEach(N=>delete g[N]);const _={cwd:p,env:g};let w="";const F=m.spawn(b,d,_);F.on("error",N=>{c(P(N))}),F.stderr.on("data",N=>{w+=N.toString()}),F.on("exit",N=>{if(N===0)h(void 0);else if(w){const G=w.split(`
`,1);c(new Error(G[0]))}else c(new Error(T.localize(4,null,b,N)))})})})}static async getDefaultTerminalLinuxReady(){return v._DEFAULT_TERMINAL_LINUX_READY||(v._DEFAULT_TERMINAL_LINUX_READY=new Promise(async a=>{k.isLinux?await C.Promises.exists("/etc/debian_version")?a("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?a("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?a("konsole"):process.env.COLORTERM?a(process.env.COLORTERM):process.env.TERM?a(process.env.TERM):a("xterm"):a("xterm")})),v._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(a,p,t){const o=p.linuxExec?Promise.resolve(p.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((r,i)=>{o.then(h=>{const c=S(process),d=a.spawn(h,[],{cwd:t,env:c});d.on("error",i),d.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=v,v.WAIT_MESSAGE=T.localize(3,null);function S(s){const a={...s.env};return(0,R.sanitizeProcessEnvironment)(a),a}function P(s){return"errno"in s&&s.errno==="ENOENT"&&"path"in s&&typeof s.path=="string"?new Error(T.localize(5,null,s.path)):s}function E(s){let a="";for(let p of s)p.indexOf(" ")>=0?a+='"'+p+'"':a+=p,a+=" ";return a}}),define(me[42],ge([0,1,24,8,9,13,2,159,4]),function(J,e,m,L,I,k,R,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,D.createDecorator)("fileService");function T(U){return U.create===!0}e.isFileOpenForWriteOptions=T;var n;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var A;(function(U){U[U.Readonly=1]="Readonly"})(A=e.FilePermission||(e.FilePermission={}));var u;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock"})(u=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=f;function l(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=l;function v(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=v;function S(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=S;var P;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(P=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class E extends Error{constructor(z,O){super(z);this.code=O}}e.FileSystemProviderError=E;function s(U,z){const O=new E(U.toString(),z);return p(O,z),O}e.createFileSystemProviderError=s;function a(U){return U||s((0,C.localize)(0,null),P.Unknown)}e.ensureFileSystemProviderError=a;function p(U,z){return U.name=z?`${z} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=p;function t(U){if(!U)return P.Unknown;if(U instanceof E)return U.code;const z=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!z)return P.Unknown;switch(z[1]){case P.FileExists:return P.FileExists;case P.FileIsADirectory:return P.FileIsADirectory;case P.FileNotADirectory:return P.FileNotADirectory;case P.FileNotFound:return P.FileNotFound;case P.FileExceedsMemoryLimit:return P.FileExceedsMemoryLimit;case P.FileTooLarge:return P.FileTooLarge;case P.FileWriteLocked:return P.FileWriteLocked;case P.NoPermissions:return P.NoPermissions;case P.Unavailable:return P.Unavailable}return P.Unknown}e.toFileSystemProviderErrorCode=t;function o(U){if(U instanceof b)return U.fileOperationResult;switch(t(U)){case P.FileNotFound:return 1;case P.FileIsADirectory:return 0;case P.FileNotADirectory:return 10;case P.FileWriteLocked:return 5;case P.NoPermissions:return 6;case P.FileExists:return 4;case P.FileExceedsMemoryLimit:return 9;case P.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=o;var r;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class i{constructor(z,O,B){this.resource=z,this.operation=O,this.target=B}isOperation(z){return this.operation===z}}e.FileOperationEvent=i;var h;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(h=e.FileChangeType||(e.FileChangeType={}));class c{constructor(z,O){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const B of z)switch(B.type){case 1:this.added||(this.added=m.TernarySearchTree.forUris(()=>O)),this.added.set(B.resource,B);break;case 0:this.updated||(this.updated=m.TernarySearchTree.forUris(()=>O)),this.updated.set(B.resource,B);break;case 2:this.deleted||(this.deleted=m.TernarySearchTree.forUris(()=>O)),this.deleted.set(B.resource,B);break}}contains(z,...O){return this.doContains(z,{includeChildren:!1},...O)}affects(z,...O){return this.doContains(z,{includeChildren:!0},...O)}doContains(z,O,...B){if(!z)return!1;const x=B.length>0;return!!((!x||B.includes(1))&&(this.added?.get(z)||O.includeChildren&&this.added?.findSuperstr(z))||(!x||B.includes(0))&&(this.updated?.get(z)||O.includeChildren&&this.updated?.findSuperstr(z))||(!x||B.includes(2))&&(this.deleted?.findSubstr(z)||O.includeChildren&&this.deleted?.findSuperstr(z)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=c;function d(U,z,O){return!U||!z||U===z||z.length>U.length?!1:(z.charAt(z.length-1)!==L.sep&&(z+=L.sep),O?(0,I.startsWithIgnoreCase)(U,z):U.indexOf(z)===0)}e.isParent=d;class b extends Error{constructor(z,O,B){super(z);this.fileOperationResult=O,this.options=B}}e.FileOperationError=b;class y extends b{constructor(z,O,B){super(z,2,B);this.stat=O}}e.NotModifiedSinceFileOperationError=y;var g;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(g=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var _;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(_=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function w(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=w;async function F(U,z){if(!z.canHandleResource(R.URI.from({scheme:U.scheme})))return new Promise(O=>{const B=z.onDidChangeFileSystemProviderRegistrations(x=>{x.scheme===U.scheme&&x.added&&(B.dispose(),O())})})}e.whenProviderRegistered=F,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class N{static formatSize(z){return(0,k.isNumber)(z)||(z=0),z<N.KB?(0,C.localize)(1,null,z.toFixed(0)):z<N.MB?(0,C.localize)(2,null,(z/N.KB).toFixed(2)):z<N.GB?(0,C.localize)(3,null,(z/N.MB).toFixed(2)):z<N.TB?(0,C.localize)(4,null,(z/N.GB).toFixed(2)):(0,C.localize)(5,null,(z/N.TB).toFixed(2))}}e.ByteSize=N,N.KB=1024,N.MB=N.KB*N.KB,N.GB=N.MB*N.KB,N.TB=N.GB*N.KB;var G;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(G=e.Arch||(e.Arch={}));function K(U){return{maxFileSize:U===0?300*N.MB:16*N.GB,maxHeapSize:U===0?700*N.MB:2*700*N.MB}}e.getPlatformLimits=K}),define(me[84],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class m{constructor(...I){this._entries=new Map;for(let[k,R]of I)this.set(k,R)}set(I,k){const R=this._entries.get(I);return this._entries.set(I,k),R}has(I){return this._entries.has(I)}get(I){return this._entries.get(I)}}e.ServiceCollection=m}),define(me[188],ge([0,1,18,16,115,180,4,84]),function(J,e,m,L,I,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const D=!1;class T extends Error{constructor(l){super("cyclic dependency between services");this.message=l.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class n{constructor(l=new C.ServiceCollection,v=!1,S){this._activeInstantiations=new Set,this._services=l,this._strict=v,this._parent=S,this._services.set(R.IInstantiationService,this)}createChild(l){return new n(l,this._strict,this)}invokeFunction(l,...v){let S=u.traceInvocation(l),P=!1;try{return l({get:(s,a)=>{if(P)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const p=this._getOrCreateServiceInstance(s,S);if(!p&&a!==R.optional)throw new Error(`[invokeFunction] unknown service '${s}'`);return p}},...v)}finally{P=!0,S.stop()}}createInstance(l,...v){let S,P;return l instanceof I.SyncDescriptor?(S=u.traceCreation(l.ctor),P=this._createInstance(l.ctor,l.staticArguments.concat(v),S)):(S=u.traceCreation(l),P=this._createInstance(l,v,S)),S.stop(),P}_createInstance(l,v=[],S){let P=R._util.getServiceDependencies(l).sort((a,p)=>a.index-p.index),E=[];for(const a of P){let p=this._getOrCreateServiceInstance(a.id,S);if(!p&&this._strict&&!a.optional)throw new Error(`[createInstance] ${l.name} depends on UNKNOWN service ${a.id}.`);E.push(p)}let s=P.length>0?P[0].index:v.length;if(v.length!==s){console.warn(`[createInstance] First service dependency of ${l.name} at position ${s+1} conflicts with ${v.length} static arguments`);let a=s-v.length;a>0?v=v.concat(new Array(a)):v=v.slice(0,s)}return new l(...[...v,...E])}_setServiceInstance(l,v){if(this._services.get(l)instanceof I.SyncDescriptor)this._services.set(l,v);else if(this._parent)this._parent._setServiceInstance(l,v);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(l){let v=this._services.get(l);return!v&&this._parent?this._parent._getServiceInstanceOrDescriptor(l):v}_getOrCreateServiceInstance(l,v){let S=this._getServiceInstanceOrDescriptor(l);return S instanceof I.SyncDescriptor?this._safeCreateAndCacheServiceInstance(l,S,v.branch(l,!0)):(v.branch(l,!1),S)}_safeCreateAndCacheServiceInstance(l,v,S){if(this._activeInstantiations.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this._activeInstantiations.add(l);try{return this._createAndCacheServiceInstance(l,v,S)}finally{this._activeInstantiations.delete(l)}}_createAndCacheServiceInstance(l,v,S){const P=new k.Graph(a=>a.id.toString());let E=0;const s=[{id:l,desc:v,_trace:S}];for(;s.length;){const a=s.pop();if(P.lookupOrInsertNode(a),E++>1e3)throw new T(P);for(let p of R._util.getServiceDependencies(a.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(p.id);if(!t&&!p.optional&&console.warn(`[createInstance] ${l} depends on ${p.id} which is NOT registered.`),t instanceof I.SyncDescriptor){const o={id:p.id,desc:t,_trace:a._trace.branch(p.id,!0)};P.insertEdge(a,o),s.push(o)}}}for(;;){const a=P.roots();if(a.length===0){if(!P.isEmpty())throw new T(P);break}for(const{data:p}of a){if(this._getServiceInstanceOrDescriptor(p.id)instanceof I.SyncDescriptor){const o=this._createServiceInstanceWithOwner(p.id,p.desc.ctor,p.desc.staticArguments,p.desc.supportsDelayedInstantiation,p._trace);this._setServiceInstance(p.id,o)}P.removeNode(p)}}return this._getServiceInstanceOrDescriptor(l)}_createServiceInstanceWithOwner(l,v,S=[],P,E){if(this._services.get(l)instanceof I.SyncDescriptor)return this._createServiceInstance(v,S,P,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(l,v,S,P,E);throw new Error(`illegalState - creating UNKNOWN service instance ${v.name}`)}_createServiceInstance(l,v=[],S,P){if(S){const E=new m.IdleValue(()=>this._createInstance(l,v,P));return new Proxy(Object.create(null),{get(s,a){if(a in s)return s[a];let p=E.value,t=p[a];return typeof t!="function"||(t=t.bind(p),s[a]=t),t},set(s,a,p){return E.value[a]=p,!0}})}else return this._createInstance(l,v,P)}}e.InstantiationService=n;var A;(function(f){f[f.Creation=0]="Creation",f[f.Invocation=1]="Invocation",f[f.Branch=2]="Branch"})(A||(A={}));class u{constructor(l,v){this.type=l,this.name=v,this._start=Date.now(),this._dep=[]}static traceInvocation(l){return D?new u(1,l.name||l.toString().substring(0,42).replace(/\n/g,"")):u._None}static traceCreation(l){return D?new u(0,l.name):u._None}branch(l,v){let S=new u(2,l.toString());return this._dep.push([l,v,S]),S}stop(){let l=Date.now()-this._start;u._totals+=l;let v=!1;function S(E,s){let a=[],p=new Array(E+1).join("	");for(const[t,o,r]of s._dep)if(o&&r){v=!0,a.push(`${p}CREATES -> ${t}`);let i=S(E+1,r);i&&a.push(i)}else a.push(`${p}uses -> ${t}`);return a.join(`
`)}let P=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${u._totals.toFixed(2)}ms)`];(l>2||v)&&console.log(P.join(`
`))}}u._None=new class extends u{constructor(){super(-1,null)}stop(){}branch(){return this}},u._totals=0}),define(me[12],ge([0,1,61,3,6,11,4]),function(J,e,m,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,R.createDecorator)("logService"),e.ILoggerService=(0,R.createDecorator)("loggerService");function C(){return new Date().toISOString()}var D;(function(p){p[p.Trace=0]="Trace",p[p.Debug=1]="Debug",p[p.Info=2]="Info",p[p.Warning=3]="Warning",p[p.Error=4]="Error",p[p.Critical=5]="Critical",p[p.Off=6]="Off"})(D=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=D.Info;class T extends I.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=T;class n extends T{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...o){this.checkLogLevel(D.Trace)&&this.log(D.Trace,this.format([t,...o]))}debug(t,...o){this.checkLogLevel(D.Debug)&&this.log(D.Debug,this.format([t,...o]))}info(t,...o){this.checkLogLevel(D.Info)&&this.log(D.Info,this.format([t,...o]))}warn(t,...o){this.checkLogLevel(D.Warning)&&this.log(D.Warning,this.format([t,...o]))}error(t,...o){if(this.checkLogLevel(D.Error))if(t instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=t.stack,this.log(D.Error,this.format(r))}else this.log(D.Error,this.format([t,...o]))}critical(t,...o){this.checkLogLevel(D.Critical)&&this.log(D.Critical,this.format([t,...o]))}flush(){}format(t){let o="";for(let r=0;r<t.length;r++){let i=t[r];if(typeof i=="object")try{i=JSON.stringify(i)}catch(h){}o+=(r>0?" ":"")+i}return o}}e.AbstractMessageLogger=n;class A extends T{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!k.isWindows}trace(t,...o){this.getLevel()<=D.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...o):console.log(`[main ${C()}]`,t,...o))}debug(t,...o){this.getLevel()<=D.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...o):console.log(`[main ${C()}]`,t,...o))}info(t,...o){this.getLevel()<=D.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...o):console.log(`[main ${C()}]`,t,...o))}warn(t,...o){this.getLevel()<=D.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,t,...o):console.warn(`[main ${C()}]`,t,...o))}error(t,...o){this.getLevel()<=D.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,t,...o):console.error(`[main ${C()}]`,t,...o))}critical(t,...o){this.getLevel()<=D.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,t,...o):console.error(`[main ${C()}]`,t,...o))}dispose(){}flush(){}}e.ConsoleMainLogger=A;class u extends T{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...o){this.getLevel()<=D.Trace&&console.log("%cTRACE","color: #888",t,...o)}debug(t,...o){this.getLevel()<=D.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...o)}info(t,...o){this.getLevel()<=D.Info&&console.log("%c INFO","color: #33f",t,...o)}warn(t,...o){this.getLevel()<=D.Warning&&console.log("%c WARN","color: #993",t,...o)}error(t,...o){this.getLevel()<=D.Error&&console.log("%c  ERR","color: #f33",t,...o)}critical(t,...o){this.getLevel()<=D.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...o)}dispose(){}flush(){}}e.ConsoleLogger=u;class f extends T{constructor(t,o=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(o)}trace(t,...o){this.getLevel()<=D.Trace&&this.adapter.log(D.Trace,[this.extractMessage(t),...o])}debug(t,...o){this.getLevel()<=D.Debug&&this.adapter.log(D.Debug,[this.extractMessage(t),...o])}info(t,...o){this.getLevel()<=D.Info&&this.adapter.log(D.Info,[this.extractMessage(t),...o])}warn(t,...o){this.getLevel()<=D.Warning&&this.adapter.log(D.Warning,[this.extractMessage(t),...o])}error(t,...o){this.getLevel()<=D.Error&&this.adapter.log(D.Error,[this.extractMessage(t),...o])}critical(t,...o){this.getLevel()<=D.Critical&&this.adapter.log(D.Critical,[this.extractMessage(t),...o])}extractMessage(t){return typeof t=="string"?t:(0,m.toErrorMessage)(t,this.getLevel()<=D.Trace)}dispose(){}flush(){}}e.AdapterLogger=f;class l extends T{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const o of this.logServices)o.setLevel(t);super.setLevel(t)}trace(t,...o){for(const r of this.logServices)r.trace(t,...o)}debug(t,...o){for(const r of this.logServices)r.debug(t,...o)}info(t,...o){for(const r of this.logServices)r.info(t,...o)}warn(t,...o){for(const r of this.logServices)r.warn(t,...o)}error(t,...o){for(const r of this.logServices)r.error(t,...o)}critical(t,...o){for(const r of this.logServices)r.critical(t,...o)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=l;class v extends I.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...o){this.logger.trace(t,...o)}debug(t,...o){this.logger.debug(t,...o)}info(t,...o){this.logger.info(t,...o)}warn(t,...o){this.logger.warn(t,...o)}error(t,...o){this.logger.error(t,...o)}critical(t,...o){this.logger.critical(t,...o)}flush(){this.logger.flush()}}e.LogService=v;class S extends I.Disposable{constructor(t,o){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(o(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(i=>i.setLevel(r))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,o){let r=this.loggers.get(t.toString());return r||(r=this.doCreateLogger(t,o?.always?D.Trace:this.logLevel,o),this.loggers.set(t.toString(),r),o?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=S;class P{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(t){}getLevel(){return D.Info}trace(t,...o){}debug(t,...o){}info(t,...o){}warn(t,...o){}error(t,...o){}critical(t,...o){}dispose(){}flush(){}}e.NullLogService=P;function E(p){if(p.verbose)return D.Trace;if(typeof p.logLevel=="string"){const t=s(p.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=E;function s(p){switch(p){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Critical;case"off":return D.Off}}e.parseLogLevel=s;function a(p){switch(p){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Critical:return"critical";case D.Off:return"off"}}e.LogLevelToString=a}),define(me[116],ge([0,1,42,12]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function I(D,T,n,A){try{const u=await new Promise((f,l)=>{J(["spdlog"],f,l)});return u.setFlushOn(L.LogLevel.Trace),u.createAsyncRotatingLogger(D,T,n,A)}catch(u){console.error(u)}return null}function k(D,T,n,A){const u=J.__$__nodeRequire("spdlog");return u.setFlushOn(L.LogLevel.Trace),u.createRotatingLogger(D,T,n,A)}e.createRotatingLogger=k;function R(D,T,n){switch(T){case L.LogLevel.Trace:D.trace(n);break;case L.LogLevel.Debug:D.debug(n);break;case L.LogLevel.Info:D.info(n);break;case L.LogLevel.Warning:D.warn(n);break;case L.LogLevel.Error:D.error(n);break;case L.LogLevel.Critical:D.critical(n);break;default:throw new Error("Invalid log level")}}class C extends L.AbstractMessageLogger{constructor(T,n,A,u){super();this.name=T,this.filepath=n,this.rotating=A,this.buffer=[],this.setLevel(u),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(f=>{this._logger&&this._logger.setLevel(f)}))}_createSpdLogLogger(){const T=this.rotating?6:1,n=30/T*m.ByteSize.MB;return I(this.name,this.filepath,n,T).then(A=>{if(A){this._logger=A,this._logger.setLevel(this.getLevel());for(const{level:u,message:f}of this.buffer)R(this._logger,u,f);this.buffer=[]}})}log(T,n){this._logger?R(this._logger,T,n):this.getLevel()<=T&&this.buffer.push({level:T,message:n})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=C}),define(me[117],ge([0,1,49,160,4]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var k;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(k=e.MarkerTag||(e.MarkerTag={}));var R;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(R=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function T(l,v){return v-l}D.compare=T;const n=Object.create(null);n[D.Error]=(0,L.localize)(0,null),n[D.Warning]=(0,L.localize)(1,null),n[D.Info]=(0,L.localize)(2,null);function A(l){return n[l]||""}D.toString=A;function u(l){switch(l){case m.default.Error:return D.Error;case m.default.Warning:return D.Warning;case m.default.Info:return D.Info;case m.default.Ignore:return D.Hint}}D.fromSeverity=u;function f(l){switch(l){case D.Error:return m.default.Error;case D.Warning:return m.default.Warning;case D.Info:return m.default.Info;case D.Hint:return m.default.Ignore}}D.toSeverity=f}(R=e.MarkerSeverity||(e.MarkerSeverity={}));var C;(function(D){const T="";function n(u){return A(u,!0)}D.makeKey=n;function A(u,f){let l=[T];return u.source?l.push(u.source.replace("\xA6","\\\xA6")):l.push(T),u.code?typeof u.code=="string"?l.push(u.code.replace("\xA6","\\\xA6")):l.push(u.code.value.replace("\xA6","\\\xA6")):l.push(T),u.severity!==void 0&&u.severity!==null?l.push(R.toString(u.severity)):l.push(T),u.message&&f?l.push(u.message.replace("\xA6","\\\xA6")):l.push(T),u.startLineNumber!==void 0&&u.startLineNumber!==null?l.push(u.startLineNumber.toString()):l.push(T),u.startColumn!==void 0&&u.startColumn!==null?l.push(u.startColumn.toString()):l.push(T),u.endLineNumber!==void 0&&u.endLineNumber!==null?l.push(u.endLineNumber.toString()):l.push(T),u.endColumn!==void 0&&u.endColumn!==null?l.push(u.endColumn.toString()):l.push(T),l.push(T),l.join("\xA6")}D.makeKeyOptionalMessage=A})(C=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,I.createDecorator)("markerService")}),define(me[189],ge([0,1,3,49,4]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=L.default,e.INotificationService=(0,I.createDecorator)("notificationService");var k;(function(T){T[T.WORKSPACE=0]="WORKSPACE",T[T.GLOBAL=1]="GLOBAL"})(k=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var R;(function(T){T[T.OFF=0]="OFF",T[T.SILENT=1]="SILENT",T[T.ERROR=2]="ERROR"})(R=e.NotificationsFilter||(e.NotificationsFilter={}));class C{constructor(){this.progress=new D,this.onDidClose=m.Event.None,this.onDidChangeVisibility=m.Event.None}updateSeverity(n){}updateMessage(n){}updateActions(n){}close(){}}e.NoOpNotification=C;class D{infinite(){}done(){}total(n){}worked(n){}}e.NoOpProgress=D}),define(me[190],ge([0,1,6,9,2,4]),function(J,e,m,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,k.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return m.Disposable.None},registerValidator(){return m.Disposable.None},registerExternalUriResolver(){return m.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return m.Disposable.None},async open(){return!1},async resolveExternalUri(C){return{resolved:C,dispose(){}}}});function R(C,D){return I.URI.isUri(C)?(0,L.equalsIgnoreCase)(C.scheme,D):(0,L.startsWithIgnoreCase)(C,D+":")}e.matchesScheme=R}),define(me[191],ge([0,1,10,11,34,22]),function(J,e,m,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let R;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const C=L.globals.vscode.context.configuration();if(C)R=C.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const C=(0,k.dirname)(m.FileAccess.asFileUri("",J));R=J.__$__nodeRequire((0,k.joinPath)(C,"product.json").fsPath);const D=J.__$__nodeRequire((0,k.joinPath)(C,"package.json").fsPath);I.env.VSCODE_DEV&&Object.assign(R,{nameShort:`${R.nameShort} Dev`,nameLong:`${R.nameLong} Dev`,dataFolderName:`${R.dataFolderName}-dev`}),Object.assign(R,{version:D.version})}else R={},Object.keys(R).length===0&&Object.assign(R,{version:"1.61.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=R});var We=this&&this.__param||function(J,e){return function(m,L){e(m,L,J)}};define(me[118],ge([0,1,18,21,6,4]),function(J,e,m,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,k.createDecorator)("progressService");var R;(function(n){n[n.Explorer=1]="Explorer",n[n.Scm=3]="Scm",n[n.Extensions=5]="Extensions",n[n.Window=10]="Window",n[n.Notification=15]="Notification",n[n.Dialog=20]="Dialog"})(R=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class C{constructor(A){this.callback=A}get value(){return this._value}report(A){this._value=A,this.callback(this._value)}}e.Progress=C,C.None=Object.freeze({report(){}});let D=class extends I.Disposable{constructor(A,u){super();this.deferred=new m.DeferredPromise,u.withProgress(A,f=>(this.reporter=f,this.lastStep&&f.report(this.lastStep),this.deferred.p)),this._register((0,I.toDisposable)(()=>this.deferred.complete()))}report(A){this.reporter?this.reporter.report(A):this.lastStep=A}};D=Ve([We(1,e.IProgressService)],D),e.UnmanagedProgress=D;class T extends I.Disposable{constructor(A){super();this.progressIndicator=A,this.currentOperationId=0,this.currentOperationDisposables=this._register(new I.DisposableStore)}start(A){this.stop();const u=++this.currentOperationId,f=new L.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{u===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},A),this.currentOperationDisposables.add((0,I.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,I.toDisposable)(()=>f.cancel())),this.currentOperationDisposables.add((0,I.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:u,token:f.token,stop:()=>this.doStop(u),isCurrent:()=>this.currentOperationId===u}}stop(){this.doStop(this.currentOperationId)}doStop(A){this.currentOperationId===A&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=T,e.IEditorProgressService=(0,k.createDecorator)("editorProgressService")}),define(me[35],ge([0,1,56,13]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class I{constructor(){this.data=new Map}add(R,C){m.ok(L.isString(R)),m.ok(L.isObject(C)),m.ok(!this.data.has(R),"There is already an extension with this id"),this.data.set(R,C)}knows(R){return this.data.has(R)}as(R){return this.data.get(R)||null}}e.Registry=new I}),define(me[119],ge([0,1,3,35]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function I(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class k{constructor(){this._onDidChangeSchema=new m.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,T){this.schemasById[I(D)]=T,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const R=new k;L.Registry.add(e.Extensions.JSONContribution,R)}),define(me[85],ge([0,1,3,13,155,119,35]),function(J,e,m,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(P){P.Multiline="multilineText",P.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var D;(function(P){P[P.APPLICATION=1]="APPLICATION",P[P.MACHINE=2]="MACHINE",P[P.WINDOW=3]="WINDOW",P[P.RESOURCE=4]="RESOURCE",P[P.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",P[P.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const T=R.Registry.as(k.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new m.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new m.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:I.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(E,s=!0){this.registerConfigurations([E],s)}registerConfigurations(E,s=!0){const a=[];E.forEach(p=>{a.push(...this.validateAndRegisterProperties(p,s,p.extensionInfo)),this.configurationContributors.push(p),this.registerJSONConfiguration(p)}),T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}deregisterConfigurations(E){const s=[],a=p=>{if(p.properties)for(const t in p.properties)s.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,p.properties[t]);p.allOf&&p.allOf.forEach(t=>a(t))};for(const p of E){a(p);const t=this.configurationContributors.indexOf(p);t!==-1&&this.configurationContributors.splice(t,1)}T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}registerDefaultConfigurations(E){const s=[],a=[];for(const p of E)for(const t in p)if(s.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...p[t]};const o={type:"object",default:this.defaultValues[t],description:I.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};a.push(u(t)),this.configurationProperties[t]=o,this.defaultLanguageConfigurationOverridesNode.properties[t]=o}else{this.defaultValues[t]=p[t];const o=this.configurationProperties[t];o&&(this.updatePropertyDefaultValue(t,o),this.updateSchema(t,o))}this.registerOverrideIdentifiers(a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}deregisterDefaultConfigurations(E){const s=[];for(const a of E)for(const p in a)if(s.push(p),delete this.defaultValues[p],e.OVERRIDE_PROPERTY_PATTERN.test(p))delete this.configurationProperties[p],delete this.defaultLanguageConfigurationOverridesNode.properties[p];else{const t=this.configurationProperties[p];t&&(this.updatePropertyDefaultValue(p,t),this.updateSchema(p,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}notifyConfigurationSchemaUpdated(...E){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(E){for(const s of E)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(E,s=!0,a,p=3){p=L.isUndefinedOrNull(E.scope)?p:E.scope;let t=[],o=E.properties;if(o)for(let i in o){if(s&&v(i)){delete o[i];continue}const h=o[i];if(this.updatePropertyDefaultValue(i,h),e.OVERRIDE_PROPERTY_PATTERN.test(i)?h.scope=void 0:(h.scope=L.isUndefinedOrNull(h.scope)?p:h.scope,h.restricted=L.isUndefinedOrNull(h.restricted)?!!a?.restrictedConfigurations?.includes(i):h.restricted),o[i].hasOwnProperty("included")&&!o[i].included){this.excludedConfigurationProperties[i]=o[i],delete o[i];continue}else this.configurationProperties[i]=o[i];!o[i].deprecationMessage&&o[i].markdownDeprecationMessage&&(o[i].deprecationMessage=o[i].markdownDeprecationMessage),t.push(i)}let r=E.allOf;if(r)for(let i of r)t.push(...this.validateAndRegisterProperties(i,s,a,p));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(E){const s=a=>{let p=a.properties;if(p)for(const o in p)this.updateSchema(o,p[o]);let t=a.allOf;t&&t.forEach(s)};s(E)}updateSchema(E,s){switch(e.allSettings.properties[E]=s,s.scope){case 1:e.applicationSettings.properties[E]=s;break;case 2:e.machineSettings.properties[E]=s;break;case 6:e.machineOverridableSettings.properties[E]=s;break;case 3:e.windowSettings.properties[E]=s;break;case 4:e.resourceSettings.properties[E]=s;break;case 5:e.resourceSettings.properties[E]=s,this.resourceLanguageSettingsSchema.properties[E]=s;break}}removeFromSchema(E,s){switch(delete e.allSettings.properties[E],s.scope){case 1:delete e.applicationSettings.properties[E];break;case 2:delete e.machineSettings.properties[E];break;case 6:delete e.machineOverridableSettings.properties[E];break;case 3:delete e.windowSettings.properties[E];break;case 4:case 5:delete e.resourceSettings.properties[E];break}}updateOverridePropertyPatternKey(){for(const E of this.overrideIdentifiers.values()){const s=`[${E}]`,a={type:"object",description:I.localize(2,null),errorMessage:I.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,a),e.allSettings.properties[s]=a,e.applicationSettings.properties[s]=a,e.machineSettings.properties[s]=a,e.machineOverridableSettings.properties[s]=a,e.windowSettings.properties[s]=a,e.resourceSettings.properties[s]=a}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(E,s){let a=this.defaultValues[E];L.isUndefined(a)&&(a=s.default),L.isUndefined(a)&&(a=f(s.type)),s.default=a}}const A="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(A);function u(P){return P.substring(1,P.length-1)}e.overrideIdentifierFromKey=u;function f(P){switch(Array.isArray(P)?P[0]:P){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const l=new n;R.Registry.add(e.Extensions.Configuration,l);function v(P){return P.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(P)?I.localize(5,null,P):l.getConfigurationProperties()[P]!==void 0?I.localize(6,null,P):null:I.localize(4,null)}e.validateProperty=v;function S(){const P=[],E=l.getConfigurationProperties();for(const s of Object.keys(E))P.push([s,E[s].scope]);return P.push(["launch",4]),P.push(["task",4]),P}e.getScopes=S}),define(me[120],ge([0,1,25,13,2,85,4,35]),function(J,e,m,L,I,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,R.createDecorator)("configurationService");function D(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof I.URI)}e.isConfigurationOverrides=D;var T;(function(o){o[o.USER=1]="USER",o[o.USER_LOCAL=2]="USER_LOCAL",o[o.USER_REMOTE=3]="USER_REMOTE",o[o.WORKSPACE=4]="WORKSPACE",o[o.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",o[o.DEFAULT=6]="DEFAULT",o[o.MEMORY=7]="MEMORY"})(T=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(o){switch(o){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function A(o,r){const i=r?o?r.keys.filter(_=>o.keys.indexOf(_)===-1):[...r.keys]:[],h=o?r?o.keys.filter(_=>r.keys.indexOf(_)===-1):[...o.keys]:[],c=[];if(r&&o){for(const _ of o.keys)if(r.keys.indexOf(_)!==-1){const w=P(o.contents,_),F=P(r.contents,_);m.equals(w,F)||c.push(_)}}const d=[],b=_=>{const w={};for(const F of _)for(const N of F.identifiers)w[p(N)]=F;return w},y=r?b(r.overrides):{},g=o?b(o.overrides):{};if(Object.keys(y).length)for(const _ of i){const w=y[_];w&&d.push([(0,k.overrideIdentifierFromKey)(_),w.keys])}if(Object.keys(g).length)for(const _ of h){const w=g[_];w&&d.push([(0,k.overrideIdentifierFromKey)(_),w.keys])}if(Object.keys(y).length&&Object.keys(g).length)for(const _ of c){const w=g[_],F=y[_];if(w&&F){const N=A({contents:w.contents,keys:w.keys,overrides:[]},{contents:F.contents,keys:F.keys,overrides:[]});d.push([(0,k.overrideIdentifierFromKey)(_),[...N.added,...N.removed,...N.updated]])}}return{added:i,removed:h,updated:c,overrides:d}}e.compare=A;function u(o,r){const i=[];for(const h of Object.keys(o))if(k.OVERRIDE_PROPERTY_PATTERN.test(h)){const c={};for(const d in o[h])c[d]=o[h][d];i.push({identifiers:[(0,k.overrideIdentifierFromKey)(h).trim()],keys:Object.keys(c),contents:f(c,r)})}return i}e.toOverrides=u;function f(o,r){const i=Object.create(null);for(let h in o)l(i,h,o[h],r);return i}e.toValuesTree=f;function l(o,r,i,h){const c=r.split("."),d=c.pop();let b=o;for(let y=0;y<c.length;y++){let g=c[y],_=b[g];switch(typeof _){case"undefined":_=b[g]=Object.create(null);break;case"object":break;default:h(`Ignoring ${r} as ${c.slice(0,y+1).join(".")} is ${JSON.stringify(_)}`);return}b=_}if(typeof b=="object"&&b!==null)try{b[d]=i}catch(y){h(`Ignoring ${r} as ${c.join(".")} is ${JSON.stringify(b)}`)}else h(`Ignoring ${r} as ${c.join(".")} is ${JSON.stringify(b)}`)}e.addToValueTree=l;function v(o,r){const i=r.split(".");S(o,i)}e.removeFromValueTree=v;function S(o,r){const i=r.shift();if(r.length===0){delete o[i];return}if(Object.keys(o).indexOf(i)!==-1){const h=o[i];typeof h=="object"&&!Array.isArray(h)&&(S(h,r),Object.keys(h).length===0&&delete o[i])}}function P(o,r,i){function h(b,y){let g=b;for(const _ of y){if(typeof g!="object"||g===null)return;g=g[_]}return g}const c=r.split("."),d=h(o,c);return typeof d=="undefined"?i:d}e.getConfigurationValue=P;function E(o,r,i){Object.keys(r).forEach(h=>{h!=="__proto__"&&(h in o?L.isObject(o[h])&&L.isObject(r[h])?E(o[h],r[h],i):i&&(o[h]=r[h]):o[h]=r[h])})}e.merge=E;function s(){const o=C.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(o)}e.getConfigurationKeys=s;function a(){const o=Object.create(null),r=C.Registry.as(k.Extensions.Configuration).getConfigurationProperties();for(let i in r){let h=r[i].default;l(o,i,h,c=>console.error(`Conflict in default settings: ${c}`))}return o}e.getDefaultValues=a;function p(o){return`[${o}]`}e.keyFromOverrideIdentifier=p;function t(o,r,i){const h=o.inspect(r),c=o.inspect(i);return typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:h.defaultValue}e.getMigratedSettingValue=t}),define(me[192],ge([0,1,17,3,59,6,24,25,13,2,120,85,35]),function(J,e,m,L,I,k,R,C,D,T,n,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class f{constructor(t={},o=[],r=[]){this._contents=t,this._keys=o,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,n.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,o){const r=this.getContentsForOverrideIdentifer(o);return r?t?(0,n.getConfigurationValue)(r,t):r:void 0}getKeysForOverrideIdentifier(t){for(const o of this.overrides)if(o.identifiers.indexOf(t)!==-1)return o.keys;return[]}override(t){const o=this.getContentsForOverrideIdentifer(t);if(!o||typeof o!="object"||!Object.keys(o).length)return this;let r={};for(const i of m.distinct([...Object.keys(this.contents),...Object.keys(o)])){let h=this.contents[i],c=o[i];c&&(typeof h=="object"&&typeof c=="object"?(h=C.deepClone(h),this.mergeContents(h,c)):h=c),r[i]=h}return new f(r,this.keys,this.overrides)}merge(...t){const o=C.deepClone(this.contents),r=C.deepClone(this.overrides),i=[...this.keys];for(const h of t){this.mergeContents(o,h.contents);for(const c of h.overrides){const[d]=r.filter(b=>m.equals(b.identifiers,c.identifiers));d?this.mergeContents(d.contents,c.contents):r.push(C.deepClone(c))}for(const c of h.keys)i.indexOf(c)===-1&&i.push(c)}return new f(o,i,r)}freeze(){return this.isFrozen=!0,this}mergeContents(t,o){for(const r of Object.keys(o)){if(r in t&&D.isObject(t[r])&&D.isObject(o[r])){this.mergeContents(t[r],o[r]);continue}t[r]=C.deepClone(o[r])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?C.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const o of this.overrides)if(o.identifiers.indexOf(t)!==-1)return o.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,o){this.addKey(t),(0,n.addToValueTree)(this.contents,t,o,r=>{throw new Error(r)})}removeValue(t){this.removeKey(t)&&(0,n.removeFromValueTree)(this.contents,t)}addKey(t){let o=this.keys.length;for(let r=0;r<o;r++)t.indexOf(this.keys[r])===0&&(o=r);this.keys.splice(o,1,t)}removeKey(t){let o=this.keys.indexOf(t);return o!==-1?(this.keys.splice(o,1),!0):!1}}e.ConfigurationModel=f;class l extends f{constructor(){const t=(0,n.getDefaultValues)(),o=(0,n.getConfigurationKeys)(),r=[];for(const i of Object.keys(t))A.OVERRIDE_PROPERTY_PATTERN.test(i)&&r.push({identifiers:[(0,A.overrideIdentifierFromKey)(i).trim()],keys:Object.keys(t[i]),contents:(0,n.toValuesTree)(t[i],h=>console.error(`Conflict in default settings file: ${h}`))});super(t,o,r)}}e.DefaultConfigurationModel=l;class v{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,o){if(!D.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r,o)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,o){this._raw=t;const{contents:r,keys:i,overrides:h,restricted:c}=this.doParseRaw(t,o);this._configurationModel=new f(r,i,h),this._restrictedConfigurations=c||[]}doParseContent(t){let o={},r=null,i=[],h=[],c=[];function d(y){Array.isArray(i)?i.push(y):r!==null&&(i[r]=y)}let b={onObjectBegin:()=>{let y={};d(y),h.push(i),i=y,r=null},onObjectProperty:y=>{r=y},onObjectEnd:()=>{i=h.pop()},onArrayBegin:()=>{let y=[];d(y),h.push(i),i=y,r=null},onArrayEnd:()=>{i=h.pop()},onLiteralValue:d,onError:(y,g,_)=>{c.push({error:y,offset:g,length:_})}};if(t)try{I.visit(t,b),o=i[0]||{}}catch(y){console.error(`Error while parsing settings file ${this._name}: ${y}`),this._parseErrors=[y]}return o}doParseRaw(t,o){const r=u.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),i=this.filter(t,r,!0,o);t=i.raw;const h=(0,n.toValuesTree)(t,b=>console.error(`Conflict in settings file ${this._name}: ${b}`)),c=Object.keys(t),d=(0,n.toOverrides)(t,b=>console.error(`Conflict in settings file ${this._name}: ${b}`));return{contents:h,keys:c,overrides:d,restricted:i.restricted}}filter(t,o,r,i){if(!i?.scopes&&!i?.skipRestricted)return{raw:t,restricted:[]};const h={},c=[];for(let d in t)if(A.OVERRIDE_PROPERTY_PATTERN.test(d)&&r){const b=this.filter(t[d],o,!1,i);h[d]=b.raw,c.push(...b.restricted)}else{const b=o[d],y=b?typeof b.scope!="undefined"?b.scope:3:void 0;b?.restricted&&c.push(d),(y===void 0||i.scopes===void 0||i.scopes.includes(y))&&(i.skipRestricted&&b?.restricted||(h[d]=t[d]))}return{raw:h,restricted:c}}}e.ConfigurationModelParser=v;class S extends k.Disposable{constructor(t,o,r,i){super();this.userSettingsResource=t,this.scopes=o,this.fileService=i,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new v(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,h=>h.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new f}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=S;class P{constructor(t,o,r=new f,i=new f,h=new R.ResourceMap,c=new f,d=new R.ResourceMap,b=!0){this._defaultConfiguration=t,this._localUserConfiguration=o,this._remoteUserConfiguration=r,this._workspaceConfiguration=i,this._folderConfigurations=h,this._memoryConfiguration=c,this._memoryConfigurationByResource=d,this._freeze=b,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(t,o,r){return this.getConsolidateConfigurationModel(o,r).getValue(t)}updateValue(t,o,r={}){let i;r.resource?(i=this._memoryConfigurationByResource.get(r.resource),i||(i=new f,this._memoryConfigurationByResource.set(r.resource,i))):i=this._memoryConfiguration,o===void 0?i.removeValue(t):i.setValue(t,o),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,o,r){const i=this.getConsolidateConfigurationModel(o,r),h=this.getFolderConfigurationModelForResource(o.resource,r),c=o.resource?this._memoryConfigurationByResource.get(o.resource)||this._memoryConfiguration:this._memoryConfiguration,d=o.overrideIdentifier?this._defaultConfiguration.freeze().override(o.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),b=o.overrideIdentifier?this.userConfiguration.freeze().override(o.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),y=o.overrideIdentifier?this.localUserConfiguration.freeze().override(o.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),g=o.overrideIdentifier?this.remoteUserConfiguration.freeze().override(o.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),_=r?o.overrideIdentifier?this._workspaceConfiguration.freeze().override(o.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,w=h?o.overrideIdentifier?h.freeze().override(o.overrideIdentifier).getValue(t):h.freeze().getValue(t):void 0,F=o.overrideIdentifier?c.override(o.overrideIdentifier).getValue(t):c.getValue(t),N=i.getValue(t),G=m.distinct(m.flatten(i.overrides.map(K=>K.identifiers))).filter(K=>i.getOverrideValue(t,K)!==void 0);return{defaultValue:d,userValue:b,userLocalValue:y,userRemoteValue:g,workspaceValue:_,workspaceFolderValue:w,memoryValue:F,value:N,default:d!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:o.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,o.overrideIdentifier):void 0}:void 0,user:b!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:o.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,o.overrideIdentifier):void 0}:void 0,userLocal:y!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:o.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,o.overrideIdentifier):void 0}:void 0,userRemote:g!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:o.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,o.overrideIdentifier):void 0}:void 0,workspace:_!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:o.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,o.overrideIdentifier):void 0}:void 0,workspaceFolder:w!==void 0?{value:h?.freeze().getValue(t),override:o.overrideIdentifier?h?.freeze().getOverrideValue(t,o.overrideIdentifier):void 0}:void 0,memory:F!==void 0?{value:c.getValue(t),override:o.overrideIdentifier?c.getOverrideValue(t,o.overrideIdentifier):void 0}:void 0,overrideIdentifiers:G.length?G:void 0}}keys(t){const o=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:o?o.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,o){this._folderConfigurations.set(t,o),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,o){const r=o.filter(i=>A.OVERRIDE_PROPERTY_PATTERN.test(i)).map(i=>{const h=(0,A.overrideIdentifierFromKey)(i),c=this._defaultConfiguration.getKeysForOverrideIdentifier(h),d=t.getKeysForOverrideIdentifier(h),b=[...d.filter(y=>c.indexOf(y)===-1),...c.filter(y=>d.indexOf(y)===-1),...c.filter(y=>!C.equals(this._defaultConfiguration.override(h).getValue(y),t.override(h).getValue(y)))];return[h,b]});return this.updateDefaultConfiguration(t),{keys:o,overrides:r}}compareAndUpdateLocalUserConfiguration(t){const{added:o,updated:r,removed:i,overrides:h}=(0,n.compare)(this.localUserConfiguration,t),c=[...o,...r,...i];return c.length&&this.updateLocalUserConfiguration(t),{keys:c,overrides:h}}compareAndUpdateRemoteUserConfiguration(t){const{added:o,updated:r,removed:i,overrides:h}=(0,n.compare)(this.remoteUserConfiguration,t);let c=[...o,...r,...i];return c.length&&this.updateRemoteUserConfiguration(t),{keys:c,overrides:h}}compareAndUpdateWorkspaceConfiguration(t){const{added:o,updated:r,removed:i,overrides:h}=(0,n.compare)(this.workspaceConfiguration,t);let c=[...o,...r,...i];return c.length&&this.updateWorkspaceConfiguration(t),{keys:c,overrides:h}}compareAndUpdateFolderConfiguration(t,o){const r=this.folderConfigurations.get(t),{added:i,updated:h,removed:c,overrides:d}=(0,n.compare)(r,o);let b=[...i,...h,...c];return(b.length||!r)&&this.updateFolderConfiguration(t,o),{keys:b,overrides:d}}compareAndDeleteFolderConfiguration(t){const o=this.folderConfigurations.get(t);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:i,removed:h,overrides:c}=(0,n.compare)(o,void 0);return{keys:[...r,...i,...h],overrides:c}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,o){let r=this.getConsolidatedConfigurationModelForResource(t,o);return t.overrideIdentifier?r.override(t.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:t},o){let r=this.getWorkspaceConsolidatedConfiguration();if(o&&t){const i=o.getFolder(t);i&&(r=this.getFolderConsolidatedConfiguration(i.uri)||r);const h=this._memoryConfigurationByResource.get(t);h&&(r=r.merge(h))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let o=this._foldersConsolidatedConfigurations.get(t);if(!o){const r=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(t);i?(o=r.merge(i),this._freeze&&(o=o.freeze()),this._foldersConsolidatedConfigurations.set(t,o)):o=r}return o}getFolderConfigurationModelForResource(t,o){if(o&&t){const r=o.getFolder(t);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,o)=>{const{contents:r,overrides:i,keys:h}=this._folderConfigurations.get(o);return t.push([o,{contents:r,overrides:i,keys:h}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(o=>t.add(o)),this.userConfiguration.freeze().keys.forEach(o=>t.add(o)),this._workspaceConfiguration.freeze().keys.forEach(o=>t.add(o)),this._folderConfigurations.forEach(o=>o.freeze().keys.forEach(r=>t.add(r))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const o=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>o.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>o.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>o.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(i=>o.add(i))),[...o.values()]}static parse(t){const o=this.parseConfigurationModel(t.defaults),r=this.parseConfigurationModel(t.user),i=this.parseConfigurationModel(t.workspace),h=t.folders.reduce((c,d)=>(c.set(T.URI.revive(d[0]),this.parseConfigurationModel(d[1])),c),new R.ResourceMap);return new P(o,r,new f,i,h,new f,new R.ResourceMap,!1)}static parseConfigurationModel(t){return new f(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=P;function E(...p){if(p.length===0)return{keys:[],overrides:[]};if(p.length===1)return p[0];const t=new Set,o=new Map;for(const i of p)i.keys.forEach(h=>t.add(h)),i.overrides.forEach(([h,c])=>{const d=(0,R.getOrSet)(o,h,new Set);c.forEach(b=>d.add(b))});const r=[];return o.forEach((i,h)=>r.push([h,[...i.values()]])),{keys:[...t.values()],overrides:r}}e.mergeChanges=E;class s{constructor(t,o,r,i){this.change=t,this.previous=o,this.currentConfiguraiton=r,this.currentWorkspace=i,this._previousConfiguration=void 0;const h=new Set;t.keys.forEach(d=>h.add(d)),t.overrides.forEach(([,d])=>d.forEach(b=>h.add(b))),this.affectedKeys=[...h.values()];const c=new f;this.affectedKeys.forEach(d=>c.setValue(d,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=P.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,o){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(o){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,o,this.previous?.workspace):void 0,i=this.currentConfiguraiton.getValue(t,o,this.currentWorkspace);return!C.equals(r,i)}return!0}return!1}doesAffectedKeysTreeContains(t,o){let r=(0,n.toValuesTree)({[o]:!0},()=>{}),i;for(;typeof r=="object"&&(i=Object.keys(r)[0]);){if(t=t[i],!t)return!1;r=r[i]}return!0}}e.ConfigurationChangeEvent=s;class a extends s{constructor(t,o,r,i){super({keys:t.allKeys(),overrides:[]},void 0,t,o);this.source=r,this.sourceConfig=i}}e.AllKeysConfigurationChangeEvent=a}),define(me[121],ge([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,m.createDecorator)("remoteAuthorityResolverService");var L;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class I extends Error{constructor(R,C=L.Unknown,D){super(R);this._message=R,this._code=C,this._detail=D,this.isHandled=C===L.NotAvailable&&D===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,I.prototype)}static isTemporarilyNotAvailable(R){return R instanceof I&&R._code===L.TemporarilyNotAvailable}static isNoResolverFound(R){return R instanceof I&&R._code===L.NoResolverFound}static isHandled(R){return R instanceof I&&R.isHandled}}e.RemoteAuthorityResolverError=I}),define(me[86],ge([0,1,10]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(T){return T.scheme===m.Schemas.vscodeRemote?T.authority:void 0}e.getRemoteAuthority=L;function I(T){if(!T)return;const n=T.indexOf("+");return n<0?T:T.substr(0,n)}e.getRemoteName=I;function k(T){return T.scheme!==m.Schemas.file&&T.scheme!==m.Schemas.vscodeRemote}e.isVirtualResource=k;function R(T){if(T.folders.length)return T.folders.every(n=>k(n.uri))?T.folders[0].uri:void 0;if(T.configuration&&k(T.configuration))return T.configuration}e.getVirtualWorkspaceLocation=R;function C(T){return R(T)?.scheme}e.getVirtualWorkspaceScheme=C;function D(T){return R(T)!==void 0}e.isVirtualWorkspace=D}),define(me[193],ge([0,1,3,11,4,12]),function(J,e,m,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,I.createDecorator)("tunnelService");var R;(function(f){f.Http="http",f.Https="https"})(R=e.TunnelProtocol||(e.TunnelProtocol={}));var C;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(C=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function D(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const l=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(!!l)return{address:l[1],port:+l[2]}}e.extractLocalHostUriMetaDataForPortMapping=D,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function T(f){return e.LOCALHOST_ADDRESSES.indexOf(f)>=0}e.isLocalhost=T,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function n(f){return e.ALL_INTERFACES_ADDRESSES.indexOf(f)>=0}e.isAllInterfaces=n;function A(f,l){return l?l!==1&&f<1024:!L.isWindows&&f<1024}e.isPortPrivileged=A;let u=class{constructor(l){this.logService=l,this._onTunnelOpened=new m.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new m.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new m.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(l,v){return this._tunnelProvider=l,l?(this._canElevate=v.elevation,this._canMakePublic=v.public,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async l=>{const v=[],S=Array.from(this._tunnels.values());for(let P of S){const E=Array.from(P.values());for(let s of E){const a=await s.value;a&&v.push(a)}}l(v)})}async dispose(){for(const l of this._tunnels.values()){for(const{value:v}of l.values())await v.then(S=>S?.dispose());l.clear()}this._tunnels.clear()}openTunnel(l,v,S,P,E=!1,s=!1,a){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${v}:${S} on local port ${P}.`),!l)return;v||(v="localhost");const p=this.retainOrCreateTunnel(l,v,S,P,E,s,a);return p?p.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(v,S);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.makeTunnel(t);return(t.tunnelRemoteHost!==v||t.tunnelRemotePort!==S)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(o),o}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),p)}makeTunnel(l){return{tunnelRemotePort:l.tunnelRemotePort,tunnelRemoteHost:l.tunnelRemoteHost,tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress,public:l.public,protocol:l.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${l.tunnelRemoteHost}:${l.tunnelRemotePort} `);const v=this._tunnels.get(l.tunnelRemoteHost);if(v){const S=v.get(l.tunnelRemotePort);S&&(S.refcount--,await this.tryDisposeTunnel(l.tunnelRemoteHost,l.tunnelRemotePort,S))}}}}async tryDisposeTunnel(l,v,S){if(S.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${l}:${v}.`);const P=S.value.then(async E=>{E&&(await E.dispose(!0),this._onTunnelClosed.fire({host:E.tunnelRemoteHost,port:E.tunnelRemotePort}))});return this._tunnels.has(l)&&this._tunnels.get(l).delete(v),P}}async closeTunnel(l,v){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${l}:${v} `);const S=this._tunnels.get(l);if(S&&S.has(v)){const P=S.get(v);P.refcount=0,await this.tryDisposeTunnel(l,v,P)}}addTunnelToMap(l,v,S){this._tunnels.has(l)||this._tunnels.set(l,new Map),this._tunnels.get(l).set(v,{refcount:1,value:S})}async removeEmptyTunnelFromMap(l,v){const S=this._tunnels.get(l);S&&(await S.get(v)||S.delete(v),S.size===0&&this._tunnels.delete(l))}getTunnelFromMap(l,v){let S=[l];T(l)?(S.push(...e.LOCALHOST_ADDRESSES),S.push(...e.ALL_INTERFACES_ADDRESSES)):n(l)&&S.push(...e.ALL_INTERFACES_ADDRESSES);const P=S.map(E=>this._tunnels.get(E));for(const E of P){const s=E?.get(v);if(s)return s}}canTunnel(l){return!!D(l)}createWithProvider(l,v,S,P,E,s,a){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${v}:${S} on local port ${P}.`);const t={elevationRequired:E?A(P===void 0?S:P):!1},o={remoteAddress:{host:v,port:S},localAddressPort:P,public:s,protocol:a},r=l.forwardPort(o,t);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),r&&this.addTunnelToMap(v,S,r),r}};u=Ve([We(0,k.ILogService)],u),e.AbstractTunnelService=u}),define(me[194],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class m{vsda(){return new Promise((I,k)=>J(["vsda"],I,k))}async sign(I){try{const k=await this.vsda(),R=new k.signer;if(R)return R.sign(I)}catch(k){}return I}}e.SignService=m}),define(me[195],ge([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var L;(function(l){l.Shell="terminal.integrated.shell.",l.ShellArgs="terminal.integrated.shellArgs.",l.DefaultProfile="terminal.integrated.defaultProfile.",l.Profiles="terminal.integrated.profiles."})(L=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var I;(function(l){l.ShellLinux="terminal.integrated.shell.linux",l.ShellMacOs="terminal.integrated.shell.osx",l.ShellWindows="terminal.integrated.shell.windows",l.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",l.AutomationShellLinux="terminal.integrated.automationShell.linux",l.AutomationShellMacOs="terminal.integrated.automationShell.osx",l.AutomationShellWindows="terminal.integrated.automationShell.windows",l.ShellArgsLinux="terminal.integrated.shellArgs.linux",l.ShellArgsMacOs="terminal.integrated.shellArgs.osx",l.ShellArgsWindows="terminal.integrated.shellArgs.windows",l.ProfilesWindows="terminal.integrated.profiles.windows",l.ProfilesMacOs="terminal.integrated.profiles.osx",l.ProfilesLinux="terminal.integrated.profiles.linux",l.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",l.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",l.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",l.UseWslProfiles="terminal.integrated.useWslProfiles",l.TabsEnabled="terminal.integrated.tabs.enabled",l.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",l.TabsHideCondition="terminal.integrated.tabs.hideCondition",l.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",l.TabsShowActions="terminal.integrated.tabs.showActions",l.TabsLocation="terminal.integrated.tabs.location",l.TabsFocusMode="terminal.integrated.tabs.focusMode",l.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",l.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",l.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",l.CopyOnSelection="terminal.integrated.copyOnSelection",l.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",l.FontFamily="terminal.integrated.fontFamily",l.FontSize="terminal.integrated.fontSize",l.LetterSpacing="terminal.integrated.letterSpacing",l.LineHeight="terminal.integrated.lineHeight",l.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",l.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",l.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",l.BellDuration="terminal.integrated.bellDuration",l.FontWeight="terminal.integrated.fontWeight",l.FontWeightBold="terminal.integrated.fontWeightBold",l.CursorBlinking="terminal.integrated.cursorBlinking",l.CursorStyle="terminal.integrated.cursorStyle",l.CursorWidth="terminal.integrated.cursorWidth",l.Scrollback="terminal.integrated.scrollback",l.DetectLocale="terminal.integrated.detectLocale",l.DefaultLocation="terminal.integrated.defaultLocation",l.GpuAcceleration="terminal.integrated.gpuAcceleration",l.RightClickBehavior="terminal.integrated.rightClickBehavior",l.Cwd="terminal.integrated.cwd",l.ConfirmOnExit="terminal.integrated.confirmOnExit",l.ConfirmOnKill="terminal.integrated.confirmOnKill",l.EnableBell="terminal.integrated.enableBell",l.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",l.AllowChords="terminal.integrated.allowChords",l.AllowMnemonics="terminal.integrated.allowMnemonics",l.EnvMacOs="terminal.integrated.env.osx",l.EnvLinux="terminal.integrated.env.linux",l.EnvWindows="terminal.integrated.env.windows",l.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",l.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",l.ShowExitAlert="terminal.integrated.showExitAlert",l.SplitCwd="terminal.integrated.splitCwd",l.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",l.WordSeparators="terminal.integrated.wordSeparators",l.TitleMode="terminal.integrated.titleMode",l.EnableFileLinks="terminal.integrated.enableFileLinks",l.UnicodeVersion="terminal.integrated.unicodeVersion",l.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",l.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",l.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",l.LocalEchoStyle="terminal.integrated.localEchoStyle",l.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",l.CustomGlyphs="terminal.integrated.customGlyphs",l.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",l.PersistentSessionExperimentalSerializer="terminal.integrated.persistentSessionExperimentalSerializer",l.InheritEnv="terminal.integrated.inheritEnv",l.ShowLinkHover="terminal.integrated.showLinkHover"})(I=e.TerminalSettingId||(e.TerminalSettingId={}));var k;(function(l){l.CommandPrompt="cmd",l.PowerShell="pwsh",l.Wsl="wsl",l.GitBash="gitbash"})(k=e.WindowsShellType||(e.WindowsShellType={}));var R;(function(l){l[l.Api=0]="Api",l[l.Process=1]="Process",l[l.Sequence=2]="Sequence"})(R=e.TitleEventSource||(e.TitleEventSource={}));var C;(function(l){l.LocalPty="localPty",l.PtyHost="ptyHost",l.Log="log",l.Heartbeat="heartbeat"})(C=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,m.createDecorator)("ptyService");var D;(function(l){l[l.BeatInterval=5e3]="BeatInterval",l[l.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",l[l.SecondWaitMultiplier=1]="SecondWaitMultiplier",l[l.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(D=e.HeartbeatConstants||(e.HeartbeatConstants={}));var T;(function(l){l[l.Panel=1]="Panel",l[l.Editor=2]="Editor"})(T=e.TerminalLocation||(e.TerminalLocation={}));var n;(function(l){l.TerminalView="view",l.Editor="editor"})(n=e.TerminalLocationString||(e.TerminalLocationString={}));var A;(function(l){l[l.GraceTime=6e4]="GraceTime",l[l.ShortGraceTime=6e3]="ShortGraceTime"})(A=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var u;(function(l){l[l.HighWatermarkChars=1e5]="HighWatermarkChars",l[l.LowWatermarkChars=5e3]="LowWatermarkChars",l[l.CharCountAckSize=5e3]="CharCountAckSize"})(u=e.FlowControlConstants||(e.FlowControlConstants={}));var f;(function(l){l.GitBash="Git Bash",l.Pwsh="PowerShell"})(f=e.ProfileSource||(e.ProfileSource={}))}),define(me[196],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class m{constructor(I){this._callback=I,this._terminalBufferMap=new Map}dispose(){for(const I of this._terminalBufferMap.values())I.dispose()}startBuffering(I,k,R=5){let C;return C=k(D=>{const T=typeof D=="string"?D:D.data;let n=this._terminalBufferMap.get(I);if(n){n.data.push(T);return}const A=setTimeout(()=>this.flushBuffer(I),R);n={data:[T],timeoutId:A,dispose:()=>{clearTimeout(A),this.flushBuffer(I),C.dispose()}},this._terminalBufferMap.set(I,n)}),C}stopBuffering(I){const k=this._terminalBufferMap.get(I);k&&k.dispose()}flushBuffer(I){const k=this._terminalBufferMap.get(I);k&&(this._terminalBufferMap.delete(I),this._callback(I,k.data.join("")))}}e.TerminalDataBufferer=m}),define(me[197],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var m;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(m=e.ColorScheme||(e.ColorScheme={}))}),define(me[63],ge([0,1,47,3,6,4,35,197]),function(J,e,m,L,I,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,k.createDecorator)("themeService");var D;(function(S){function P(E){return E&&typeof E=="object"&&typeof E.id=="string"}S.isThemeColor=P})(D=e.ThemeColor||(e.ThemeColor={}));function T(S){return{id:S}}e.themeColorFromId=T;var n;(function(S){function P(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(typeof o.color=="undefined"||D.isThemeColor(o.color))}S.isThemeIcon=P;const E=new RegExp(`^\\$\\((${m.CSSIcon.iconNameExpression}(?:${m.CSSIcon.iconModifierExpression})?)\\)$`);function s(o){const r=E.exec(o);if(!r)return;let[,i]=r;return{id:i}}S.fromString=s;function a(o,r){let i=o.id;const h=i.lastIndexOf("~");return h!==-1&&(i=i.substring(0,h)),r&&(i=`${i}~${r}`),{id:i}}S.modify=a;function p(o,r){return o.id===r.id&&o.color?.id===r.color?.id}S.isEqual=p;function t(o,r){return{id:o.id,color:r?T(r):void 0}}S.asThemeIcon=t,S.asClassNameArray=m.CSSIcon.asClassNameArray,S.asClassName=m.CSSIcon.asClassName,S.asCSSSelector=m.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=m.Codicon.file,e.FolderThemeIcon=m.Codicon.folder;function A(S){switch(S){case C.ColorScheme.DARK:return"vs-dark";case C.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=A,e.Extensions={ThemingContribution:"base.contributions.theming"};class u{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(P){return this.themingParticipants.push(P),this.onThemingParticipantAddedEmitter.fire(P),(0,I.toDisposable)(()=>{const E=this.themingParticipants.indexOf(P);this.themingParticipants.splice(E,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let f=new u;R.Registry.add(e.Extensions.ThemingContribution,f);function l(S){return f.onColorThemeChange(S)}e.registerThemingParticipant=l;class v extends I.Disposable{constructor(P){super();this.themeService=P,this.theme=P.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(E=>this.onThemeChange(E)))}onThemeChange(P){this.theme=P,this.updateStyles()}updateStyles(){}getColor(P,E){let s=this.theme.getColor(P);return s&&E&&(s=E(s,this.theme)),s?s.toString():null}}e.Themable=v}),define(me[198],ge([0,1,18,47,3,161,119,35,63]),function(J,e,m,L,I,k,R,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class T{constructor(){this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,k.localize)(0,null)},fontCharacter:{type:"string",description:(0,k.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${L.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(P,E,s,a){const p=this.iconsById[P];if(p){if(s&&!p.description){p.description=s,this.iconSchema.properties[P].markdownDescription=`${s} $(${P})`;const r=this.iconReferenceSchema.enum.indexOf(P);r!==-1&&(this.iconReferenceSchema.enumDescriptions[r]=s),this._onDidChange.fire()}return p}let t={id:P,description:s,defaults:E,deprecationMessage:a};this.iconsById[P]=t;let o={$ref:"#/definitions/icons"};return a&&(o.deprecationMessage=a),s&&(o.markdownDescription=`${s}: $(${P})`),this.iconSchema.properties[P]=o,this.iconReferenceSchema.enum.push(P),this.iconReferenceSchema.enumDescriptions.push(s||""),this._onDidChange.fire(),{id:P}}deregisterIcon(P){delete this.iconsById[P],delete this.iconSchema.properties[P];const E=this.iconReferenceSchema.enum.indexOf(P);E!==-1&&(this.iconReferenceSchema.enum.splice(E,1),this.iconReferenceSchema.enumDescriptions.splice(E,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(P=>this.iconsById[P])}getIcon(P){return this.iconsById[P]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(P,E){const s=this.iconFontsById[P];if(s)return s;let a={id:P,definition:E};return this.iconFontsById[P]=a,this._onDidChange.fire(),a}deregisterIconFont(P){delete this.iconFontsById[P]}getIconFonts(){return Object.keys(this.iconFontsById).map(P=>this.iconFontsById[P])}getIconFont(P){return this.iconFontsById[P]}toString(){const P=(p,t)=>p.id.localeCompare(t.id),E=p=>{for(;D.ThemeIcon.isThemeIcon(p.defaults);)p=this.iconsById[p.defaults.id];return`codicon codicon-${p?p.id:""}`};let s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const a=Object.keys(this.iconsById).map(p=>this.iconsById[p]);for(const p of a.filter(t=>!!t.description).sort(P))s.push(`|<i class="${E(p)}"></i>|${p.id}|${D.ThemeIcon.isThemeIcon(p.defaults)?p.defaults.id:p.id}|${p.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const p of a.filter(t=>!D.ThemeIcon.isThemeIcon(t.defaults)).sort(P))s.push(`|<i class="${E(p)}"></i>|${p.id}|`);return s.join(`
`)}}const n=new T;C.Registry.add(e.Extensions.IconContribution,n);function A(S,P,E,s){return n.registerIcon(S,P,E,s)}e.registerIcon=A;function u(){return n}e.getIconRegistry=u;function f(){for(const S of L.iconRegistry.all)n.registerIcon(S.id,S.definition,S.description);L.iconRegistry.onDidRegister(S=>n.registerIcon(S.id,S.definition,S.description))}f(),e.iconsSchemaId="vscode://schemas/icons";let l=C.Registry.as(R.Extensions.JSONContribution);l.registerSchema(e.iconsSchemaId,n.getIconSchema());const v=new m.RunOnceScheduler(()=>l.notifySchemaChanged(e.iconsSchemaId),200);n.onDidChange(()=>{v.isScheduled()||v.schedule()}),e.widgetClose=A("widget-close",L.Codicon.close,(0,k.localize)(2,null)),e.gotoPreviousLocation=A("goto-previous-location",L.Codicon.arrowUp,(0,k.localize)(3,null)),e.gotoNextLocation=A("goto-next-location",L.Codicon.arrowDown,(0,k.localize)(4,null)),e.syncing=D.ThemeIcon.modify(L.Codicon.sync,"spin")}),define(me[43],ge([0,1,24,22,2,4]),function(J,e,m,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,k.createDecorator)("contextService");var R;(function(u){u[u.EMPTY=1]="EMPTY",u[u.FOLDER=2]="FOLDER",u[u.WORKSPACE=3]="WORKSPACE"})(R=e.WorkbenchState||(e.WorkbenchState={}));function C(u){const f=u;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}e.isWorkspace=C;function D(u){const f=u;return!!(f&&typeof f=="object"&&I.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}e.isWorkspaceFolder=D;class T{constructor(f,l,v,S){this._id=f,this._configuration=v,this._ignorePathCasing=S,this._foldersMap=m.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=l}update(f){this._id=f.id,this._configuration=f.configuration,this._ignorePathCasing=f._ignorePathCasing,this.folders=f.folders}get folders(){return this._folders}set folders(f){this._folders=f,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(f){this._configuration=f}getFolder(f){return f&&this._foldersMap.findSubstr(f.with({scheme:f.scheme,authority:f.authority,path:f.path}))||null}updateFoldersMap(){this._foldersMap=m.TernarySearchTree.forUris(this._ignorePathCasing);for(const f of this.folders)this._foldersMap.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=T;class n{constructor(f,l){this.raw=l,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return(0,L.joinPath)(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=n;function A(u){return new n({uri:u,index:0,name:(0,L.basenameOrAuthority)(u)},{uri:u.toString()})}e.toWorkspaceFolder=A}),define(me[199],ge([0,1,29,59,138,79,10,8,11,22,2,162,4,86,43]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const v=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,A.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S(U){return(typeof U=="string"?(0,C.extname)(U):(0,T.extname)(U))===v}e.hasWorkspaceFileExtension=S,e.IWorkspacesService=(0,u.createDecorator)("workspacesService");function P(U){return U.hasOwnProperty("workspace")}e.isRecentWorkspace=P;function E(U){return U.hasOwnProperty("folderUri")}e.isRecentFolder=E;function s(U){return U.hasOwnProperty("fileUri")}e.isRecentFile=s;function a(U){const z=U;return typeof z?.id=="string"&&n.URI.isUri(z.uri)}e.isSingleFolderWorkspaceIdentifier=a;function p(U){if(U.configuration)return{id:U.id,configPath:U.configuration};if(U.folders.length===1)return{id:U.id,uri:U.folders[0].uri}}e.toWorkspaceIdentifier=p;function t(U){const z=U;return typeof z?.id=="string"&&n.URI.isUri(z.configPath)}e.isWorkspaceIdentifier=t;function o(U){const z=U;if(z?.uri)return{id:z.id,uri:n.URI.revive(z.uri)};const O=U;if(O?.configPath)return{id:O.id,configPath:n.URI.revive(O.configPath)};if(U?.id)return{id:U.id}}e.reviveIdentifier=o;function r(U,z){return T.extUriBiasedIgnorePathCase.isEqualOrParent(U,z.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function i(U){return h(U)||c(U)}e.isStoredWorkspaceFolder=i;function h(U){const z=U;return typeof z?.path=="string"&&(!z.name||typeof z.name=="string")}e.isRawFileWorkspaceFolder=h;function c(U){const z=U;return typeof z?.uri=="string"&&(!z.name||typeof z.name=="string")}e.isRawUriWorkspaceFolder=c;function d(U,z,O,B,x=!D.isWindows,M){if(U.scheme!==B.scheme)return{name:O,uri:U.toString(!0)};let H=z?void 0:M.relativePath(B,U);if(H!==void 0)H.length===0?H=".":D.isWindows&&U.scheme===R.Schemas.file&&!x&&(H=H.replace(/\//g,"\\"));else if(U.scheme===R.Schemas.file)H=U.fsPath,D.isWindows&&(H=(0,k.normalizeDriveLetter)(H),x&&(H=(0,m.toSlashes)(H)));else{if(!M.isEqualAuthority(U.authority,B.authority))return{name:O,uri:U.toString(!0)};H=U.path}return{name:O,path:H}}e.getStoredWorkspaceFolder=d;function b(U,z,O){let B=[],x=new Set;const M=O.dirname(z);for(let H of U){let W;if(h(H))H.path&&(W=O.resolvePath(M,H.path));else if(c(H))try{W=n.URI.parse(H.uri),W.path[0]!=="/"&&(W=W.with({path:"/"+W.path}))}catch(Q){console.warn(Q)}if(W){let Q=O.getComparisonKey(W);if(!x.has(Q)){x.add(Q);const X=H.name||O.basenameOrAuthority(W);B.push(new l.WorkspaceFolder({uri:W,name:X,index:B.length},H))}}}return B}e.toWorkspaceFolders=b;function y(U,z,O,B,x){let M=g(z,U);const H=x.dirname(z),W=x.dirname(B),Q=[],X=_(M.folders);for(const Re of M.folders){const $e=h(Re)?x.resolvePath(H,Re.path):n.URI.parse(Re.uri);let Be;O?Be=!1:Be=!h(Re)||(0,C.isAbsolute)(Re.path),Q.push(d($e,Be,Re.name,W,X,x))}const he={insertSpaces:!1,tabSize:4,eol:D.isLinux||D.isMacintosh?`
`:`\r
`},_e=I.setProperty(U,["folders"],Q,he);let ye=I.applyEdits(U,_e);return M.remoteAuthority===(0,f.getRemoteAuthority)(B)&&(ye=I.applyEdits(ye,I.removeProperty(ye,["remoteAuthority"],he))),ye}e.rewriteWorkspaceFileForNewLocation=y;function g(U,z){let O=L.parse(z);if(O&&Array.isArray(O.folders))O.folders=O.folders.filter(B=>i(B));else throw new Error(`${U} looks like an invalid workspace file.`);return O}function _(U){return D.isWindows?U.some(z=>h(z)&&z.path.indexOf("/")>=0):!0}e.useSlashForPath=_;function w(U){return U.workspace&&typeof U.workspace=="object"&&typeof U.workspace.id=="string"&&typeof U.workspace.configPath=="string"}function F(U){return typeof U.folderUri=="string"}function N(U){return typeof U.fileUri=="string"}function G(U,z){const O={workspaces:[],files:[]};if(U){const B=function(M,H){for(let W=0;W<M.length;W++)try{H(M[W],W)}catch(Q){z.warn(`Error restoring recent entry ${JSON.stringify(M[W])}: ${Q.toString()}. Skip entry.`)}},x=U;if(Array.isArray(x.entries))B(x.entries,M=>{const H=M.label,W=M.remoteAuthority;w(M)?O.workspaces.push({label:H,remoteAuthority:W,workspace:{id:M.workspace.id,configPath:n.URI.parse(M.workspace.configPath)}}):F(M)?O.workspaces.push({label:H,remoteAuthority:W,folderUri:n.URI.parse(M.folderUri)}):N(M)&&O.files.push({label:H,remoteAuthority:W,fileUri:n.URI.parse(M.fileUri)})});else{const M=U;Array.isArray(M.workspaces3)&&B(M.workspaces3,(H,W)=>{const Q=Array.isArray(M.workspaceLabels)&&M.workspaceLabels[W]||void 0;typeof H=="object"&&typeof H.id=="string"&&typeof H.configURIPath=="string"?O.workspaces.push({label:Q,workspace:{id:H.id,configPath:n.URI.parse(H.configURIPath)}}):typeof H=="string"&&O.workspaces.push({label:Q,folderUri:n.URI.parse(H)})}),Array.isArray(M.files2)&&B(M.files2,(H,W)=>{const Q=Array.isArray(M.fileLabels)&&M.fileLabels[W]||void 0;typeof H=="string"&&O.files.push({label:Q,fileUri:n.URI.parse(H)})})}}return O}e.restoreRecentlyOpened=G;function K(U){const z={entries:[]};for(const O of U.workspaces)E(O)?z.entries.push({folderUri:O.folderUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority}):z.entries.push({workspace:{id:O.workspace.id,configPath:O.workspace.configPath.toString()},label:O.label,remoteAuthority:O.remoteAuthority});for(const O of U.files)z.entries.push({fileUri:O.fileUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority});return z}e.toStoreData=K}),define(me[87],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class m{constructor(I){this.id=I,this._data=new Map,this._idPool=1}add(I){const k=this._idPool++;return this._data.set(k,I),this.logDebugInfo(),k}get(I,k){return this._data.has(I)?this._data.get(I)[k]:void 0}delete(I){this._data.delete(I),this.logDebugInfo()}logDebugInfo(){!m.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=m,m.enableDebugLogging=!1}),define(me[52],ge([0,1,10,22,4]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class k{constructor(){this._systemSchemes=new Set(Object.keys(m.Schemas)),this._providerInfo=new Map,this.extUri=new L.ExtUri(C=>{const D=this._providerInfo.get(C.scheme);return!(D===void 0||D&1024)})}$acceptProviderInfos(C,D){D===null?this._providerInfo.delete(C):this._providerInfo.set(C,D)}isFreeScheme(C){return!this._providerInfo.has(C)&&!this._systemSchemes.has(C)}getCapabilities(C){return this._providerInfo.get(C)}}e.ExtHostFileSystemInfo=k,e.IExtHostFileSystemInfo=(0,I.createDecorator)("IExtHostFileSystemInfo")}),define(me[27],ge([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,m.createDecorator)("IExtHostInitDataService")}),define(me[200],ge([0,1,18]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class L{constructor(R,C,D){this._deferredPromises=new Map,this._id=R,this._shared=C,this._storage=D,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(T=>(this._value=T,this)),this._storageListener=this._storage.onDidChangeStorage(T=>{T.shared===this._shared&&T.key===this._id&&(this._value=T.value)}),this._scheduler=new m.RunOnceScheduler(()=>{const T=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const n of T.values())n.complete()}catch(n){for(const A of T.values())A.error(n)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this._init}get(R,C){let D=this._value[R];return typeof D=="undefined"&&(D=C),D}update(R,C){this._value[R]=C;let D=this._deferredPromises.get(R);if(D!==void 0)return D.p;const T=new m.DeferredPromise;return this._deferredPromises.set(R,T),this._scheduler.isScheduled()||this._scheduler.schedule(),T.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=L;class I extends L{constructor(R,C){super(R.identifier.value,!0,C);this._extension=R}setKeysForSync(R){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},R)}}e.ExtensionGlobalMemento=I}),define(me[201],ge([0,1,3,2,12]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let k=class{constructor(C,D){this._logService=C,this._notebooksAndEditors=D,this._onDidChangeNotebookDocumentMetadata=new m.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new m.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(C,D,T){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(C)).acceptModelChanged(D.value,T)}$acceptDirtyStateChanged(C,D){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(C)).acceptDirty(D)}$acceptModelSaved(C){const D=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(C));this._onDidSaveNotebookDocument.fire(D.apiNotebook)}$acceptDocumentPropertiesChanged(C,D){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",C.path,D);const T=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(C));T.acceptDocumentPropertiesChanged(D),D.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:T.apiNotebook})}};k=Ve([We(0,I.ILogService)],k),e.ExtHostNotebookDocuments=k}),define(me[14],ge([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,m.createDecorator)("IExtHostRpcService");class L{constructor(k){this.getProxy=k.getProxy.bind(k),this.set=k.set.bind(k),this.assertRegistered=k.assertRegistered.bind(k),this.drain=k.drain.bind(k)}}e.ExtHostRpcService=L});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(J,m):I?I.value=m:e.set(J,m),m},Oe=this&&this.__classPrivateFieldGet||function(J,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(J):L?L.value:e.get(J)};define(me[202],ge([0,1,26,3]),function(J,e,m,L){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class k{constructor(C,D){I.set(this,void 0),this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._id=m.ExtensionIdentifier.toKey(C.identifier),nt(this,I,D,"f"),Oe(this,I,"f").onDidChangePassword(T=>{T.extensionId===this._id&&this._onDidChange.fire({key:T.key})})}get(C){return Oe(this,I,"f").get(this._id,C)}store(C,D){return Oe(this,I,"f").store(this._id,C,D)}delete(C){return Oe(this,I,"f").delete(this._id,C)}}e.ExtensionSecrets=k,I=new WeakMap}),define(me[122],ge([0,1,4,3]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class I{constructor(){this._onDidChangeTelemetryEnabled=new L.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(R){this._enabled=R}$onDidChangeTelemetryEnabled(R){this._enabled=R,this._onDidChangeTelemetryEnabled.fire(R)}}e.ExtHostTelemetry=I,e.IExtHostTelemetry=(0,m.createDecorator)("IExtHostTelemetry")}),define(me[64],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var m;(function(E){E[E.Upsert=0]="Upsert",E[E.RemoveChild=1]="RemoveChild",E[E.Invalidated=2]="Invalidated",E[E.SetProp=3]="SetProp",E[E.Bulk=4]="Bulk"})(m=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const L=new WeakMap,I=(E,s)=>{const a={controllerId:s};return L.set(E,a),a};e.createPrivateApiFor=I;const k=E=>L.get(E);e.getPrivateApiFor=k;const R=(E,s,a,p)=>{let t=a;return{enumerable:!0,configurable:!1,get(){return t},set(o){if(!p(t,o)){const r=t;t=o,E.listener?.({op:3,key:s,value:o,previous:r})}}}},C=(E,s)=>E===s,D={range:(E,s)=>E===s?!0:!E||!s?!1:E.isEqual(s),label:C,description:C,busy:C,error:C,canResolveChildren:C,tags:(E,s)=>!(E.length!==s.length||E.some(a=>!s.find(p=>a.id===p.id)))},T=Object.keys(D),n=(E,s)=>({range:R(E,"range",void 0,D.range),label:R(E,"label",s,D.label),description:R(E,"description",void 0,D.description),canResolveChildren:R(E,"canResolveChildren",!1,D.canResolveChildren),busy:R(E,"busy",!1,D.busy),error:R(E,"error",void 0,D.error),tags:R(E,"tags",[],D.tags)}),A=(E,s)=>{const a=new Map;for(const p of T)D[p](E[p],s[p])||a.set(p,s[p]);return a};e.diffTestItems=A;class u extends Error{constructor(s){super(`Attempted to insert a duplicate test item ID ${s}`)}}e.DuplicateTestItemError=u;class f extends Error{constructor(s){super(`TestItem with ID "${s}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=f;class l extends Error{constructor(s,a,p){super(`TestItem with ID "${s}" is from controller "${a}" and cannot be added as a child of an item from controller "${p}".`)}}e.MixedTestItemController=l;const v=E=>{const s=(0,e.getPrivateApiFor)(E);let a=new Map;return{get size(){return a.size},forEach(p,t){for(const o of a.values())p.call(t,o,this)},replace(p){const t=new Map,o=new Set(a.keys()),r={op:4,ops:[]};for(const i of p){if(!(i instanceof S))throw new f(i.id);const h=(0,e.getPrivateApiFor)(i).controllerId;if(h!==s.controllerId)throw new l(i.id,h,s.controllerId);if(t.has(i.id))throw new u(i.id);t.set(i.id,i),o.delete(i.id),r.ops.push({op:0,item:i})}for(const i of o.keys())r.ops.push({op:1,id:i});s.listener?.(r),a=t},add(p){if(!(p instanceof S))throw new f(p.id);a.set(p.id,p),s.listener?.({op:0,item:p})},delete(p){a.delete(p)&&s.listener?.({op:1,id:p})},get(p){return a.get(p)},toJSON(){return Array.from(a.values())},[Symbol.iterator](){return a.values()}}};class S{constructor(s,a,p,t){if(a.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(a)} symbol`);const o=(0,e.createPrivateApiFor)(this,s);Object.defineProperties(this,{id:{value:a,enumerable:!0,writable:!1},uri:{value:t,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return o.parent instanceof P?void 0:o.parent}},children:{value:v(this),enumerable:!0,writable:!1},...n(o,p)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=S;class P extends S{constructor(s,a){super(s,s,a,void 0)}}e.TestItemRootImpl=P}),define(me[53],ge([0,1,4,3,14]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var k;(function(C){function D(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,protocol:n.protocol}}C.fromApiTunnel=D;function T(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.public,protocol:n.protocol}}C.fromServiceTunnel=T})(k=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,m.createDecorator)("IExtHostTunnelService");let R=class{constructor(D){this.onDidChangeTunnels=new L.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,T){}async getTunnels(){return[]}async setTunnelExtensionFunctions(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,T){return{dispose:()=>{}}}async $providePortAttributes(D,T,n,A,u){return[]}async $forwardPort(D,T){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};R=Ve([We(0,I.IExtHostRpcService)],R),e.ExtHostTunnelService=R});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(J,m):I?I.value=m:e.set(J,m),m},Oe=this&&this.__classPrivateFieldGet||function(J,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(J):L?L.value:e.get(J)};define(me[7],ge([0,1,17,16,99,24,102,13,2,32,42,121]),function(J,e,m,L,I,k,R,C,D,T,n,A){"use strict";var u,f,l,v,S,P,E,s,a,p,t,o,r,i,h,c,d,b,y,g;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function _(j){function $(){return Reflect.construct(j,arguments,this.constructor)}return Object.defineProperty($,"name",Object.getOwnPropertyDescriptor(j,"name")),Object.setPrototypeOf($,j),Object.setPrototypeOf($.prototype,j.prototype),$}let w=S=class{constructor($){u.set(this,void 0),nt(this,u,$,"f")}static from(...$){let se=$;return new S(function(){if(se){for(const Ce of se)Ce&&typeof Ce.dispose=="function"&&Ce.dispose();se=void 0}})}dispose(){typeof Oe(this,u,"f")=="function"&&(Oe(this,u,"f").call(this),nt(this,u,void 0,"f"))}};u=new WeakMap,w=S=Ve([_],w),e.Disposable=w;let F=P=class{constructor($,se){if($<0)throw(0,L.illegalArgument)("line must be non-negative");if(se<0)throw(0,L.illegalArgument)("character must be non-negative");this._line=$,this._character=se}static Min(...$){if($.length===0)throw new TypeError;let se=$[0];for(let Ce=1;Ce<$.length;Ce++){const et=$[Ce];et.isBefore(se)&&(se=et)}return se}static Max(...$){if($.length===0)throw new TypeError;let se=$[0];for(let Ce=1;Ce<$.length;Ce++){const et=$[Ce];et.isAfter(se)&&(se=et)}return se}static isPosition($){if(!$)return!1;if($ instanceof P)return!0;let{line:se,character:Ce}=$;return typeof se=="number"&&typeof Ce=="number"}get line(){return this._line}get character(){return this._character}isBefore($){return this._line<$._line?!0:$._line<this._line?!1:this._character<$._character}isBeforeOrEqual($){return this._line<$._line?!0:$._line<this._line?!1:this._character<=$._character}isAfter($){return!this.isBeforeOrEqual($)}isAfterOrEqual($){return!this.isBefore($)}isEqual($){return this._line===$._line&&this._character===$._character}compareTo($){return this._line<$._line?-1:this._line>$.line?1:this._character<$._character?-1:this._character>$._character?1:0}translate($,se=0){if($===null||se===null)throw(0,L.illegalArgument)();let Ce;return typeof $=="undefined"?Ce=0:typeof $=="number"?Ce=$:(Ce=typeof $.lineDelta=="number"?$.lineDelta:0,se=typeof $.characterDelta=="number"?$.characterDelta:0),Ce===0&&se===0?this:new P(this.line+Ce,this.character+se)}with($,se=this.character){if($===null||se===null)throw(0,L.illegalArgument)();let Ce;return typeof $=="undefined"?Ce=this.line:typeof $=="number"?Ce=$:(Ce=typeof $.line=="number"?$.line:this.line,se=typeof $.character=="number"?$.character:this.character),Ce===this.line&&se===this.character?this:new P(Ce,se)}toJSON(){return{line:this.line,character:this.character}}};F=P=Ve([_],F),e.Position=F;let N=E=class{constructor($,se,Ce,et){let st,ut;if(typeof $=="number"&&typeof se=="number"&&typeof Ce=="number"&&typeof et=="number"?(st=new F($,se),ut=new F(Ce,et)):$ instanceof F&&se instanceof F&&(st=$,ut=se),!st||!ut)throw new Error("Invalid arguments");st.isBefore(ut)?(this._start=st,this._end=ut):(this._start=ut,this._end=st)}static isRange($){return $ instanceof E?!0:$?F.isPosition($.start)&&F.isPosition($.end):!1}get start(){return this._start}get end(){return this._end}contains($){return $ instanceof E?this.contains($._start)&&this.contains($._end):$ instanceof F?!($.isBefore(this._start)||this._end.isBefore($)):!1}isEqual($){return this._start.isEqual($._start)&&this._end.isEqual($._end)}intersection($){const se=F.Max($.start,this._start),Ce=F.Min($.end,this._end);if(!se.isAfter(Ce))return new E(se,Ce)}union($){if(this.contains($))return this;if($.contains(this))return $;const se=F.Min($.start,this._start),Ce=F.Max($.end,this.end);return new E(se,Ce)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with($,se=this.end){if($===null||se===null)throw(0,L.illegalArgument)();let Ce;return $?F.isPosition($)?Ce=$:(Ce=$.start||this.start,se=$.end||this.end):Ce=this.start,Ce.isEqual(this._start)&&se.isEqual(this.end)?this:new E(Ce,se)}toJSON(){return[this.start,this.end]}};N=E=Ve([_],N),e.Range=N;let G=s=class extends N{constructor($,se,Ce,et){let st,ut;if(typeof $=="number"&&typeof se=="number"&&typeof Ce=="number"&&typeof et=="number"?(st=new F($,se),ut=new F(Ce,et)):$ instanceof F&&se instanceof F&&(st=$,ut=se),!st||!ut)throw new Error("Invalid arguments");super(st,ut);this._anchor=st,this._active=ut}static isSelection($){return $ instanceof s?!0:$?N.isRange($)&&F.isPosition($.anchor)&&F.isPosition($.active)&&typeof $.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};G=s=Ve([_],G),e.Selection=G;class K{constructor($,se,Ce){if(typeof $!="string"||$.length===0)throw(0,L.illegalArgument)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,L.illegalArgument)("port");if(typeof Ce!="undefined"&&(typeof Ce!="string"||Ce.length===0||!/^[0-9A-Za-z\-]+$/.test(Ce)))throw(0,L.illegalArgument)("connectionToken");this.host=$,this.port=Math.round(se),this.connectionToken=Ce}}e.ResolvedAuthority=K;class U extends Error{constructor($,se=A.RemoteAuthorityResolverErrorCode.Unknown,Ce){super($);this._message=$,this._code=se,this._detail=Ce,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,U.prototype)}static NotAvailable($,se){return new U($,A.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable($){return new U($,A.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=U;var z;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(z=e.EndOfLine||(e.EndOfLine={}));var O;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(O=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let B=a=class{constructor($,se){this._range=$,this._newText=se}static isTextEdit($){return $ instanceof a?!0:$?N.isRange($)&&typeof $.newText=="string":!1}static replace($,se){return new a($,se)}static insert($,se){return a.replace(new N($,$),se)}static delete($){return a.replace($,"")}static setEndOfLine($){const se=new a(new N(new F(0,0),new F(0,0)),"");return se.newEol=$,se}get range(){return this._range}set range($){if($&&!N.isRange($))throw(0,L.illegalArgument)("range");this._range=$}get newText(){return this._newText||""}set newText($){if($&&typeof $!="string")throw(0,L.illegalArgument)("newText");this._newText=$}get newEol(){return this._newEol}set newEol($){if($&&typeof $!="number")throw(0,L.illegalArgument)("newEol");this._newEol=$}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};B=a=Ve([_],B),e.TextEdit=B;var x;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace"})(x=e.FileEditType||(e.FileEditType={}));let M=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile($,se,Ce,et){this._edits.push({_type:1,from:$,to:se,options:Ce,metadata:et})}createFile($,se,Ce){this._edits.push({_type:1,from:void 0,to:$,options:se,metadata:Ce})}deleteFile($,se,Ce){this._edits.push({_type:1,from:$,to:void 0,options:se,metadata:Ce})}replaceNotebookMetadata($,se,Ce){this._edits.push({_type:3,metadata:Ce,uri:$,edit:{editType:5,metadata:se},notebookMetadata:se})}replaceNotebookCells($,se,Ce,et,st){let ut,ht,Dt=[],At;if(zt.isNotebookRange(se)&&Ft.isNotebookCellDataArray(Ce)&&!Ft.isNotebookCellDataArray(et)?(ut=se.start,ht=se.end,Dt=Ce,At=et):typeof se=="number"&&typeof Ce=="number"&&Ft.isNotebookCellDataArray(et)&&(ut=se,ht=Ce,Dt=et,At=st),ut===void 0||ht===void 0)throw new Error("Invalid arguments");(ut!==ht||Dt.length>0)&&this._edits.push({_type:5,uri:$,index:ut,count:ht-ut,cells:Dt,metadata:At})}replaceNotebookCellMetadata($,se,Ce,et){this._edits.push({_type:3,metadata:et,uri:$,edit:{editType:8,index:se,metadata:Ce}})}replace($,se,Ce,et){this._edits.push({_type:2,uri:$,edit:new B(se,Ce),metadata:et})}insert($,se,Ce,et){this.replace($,new N(se,se),Ce,et)}delete($,se,Ce){this.replace($,se,"",Ce)}has($){return this._edits.some(se=>se._type===2&&se.uri.toString()===$.toString())}set($,se){if(se)for(const Ce of se)Ce&&this._edits.push({_type:2,uri:$,edit:Ce});else{for(let Ce=0;Ce<this._edits.length;Ce++){const et=this._edits[Ce];et._type===2&&et.uri.toString()===$.toString()&&(this._edits[Ce]=void 0)}(0,m.coalesceInPlace)(this._edits)}}get($){const se=[];for(let Ce of this._edits)Ce._type===2&&Ce.uri.toString()===$.toString()&&se.push(Ce.edit);return se}entries(){const $=new k.ResourceMap;for(let se of this._edits)if(se._type===2){let Ce=$.get(se.uri);Ce||(Ce=[se.uri,[]],$.set(se.uri,Ce)),Ce[1].push(se.edit)}return[...$.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};M=Ve([_],M),e.WorkspaceEdit=M;let H=p=class{constructor($){this._tabstop=1,this.value=$||""}static isSnippetString($){return $ instanceof p?!0:$?typeof $.value=="string":!1}static _escape($){return $.replace(/\$|}|\\/g,"\\$&")}appendText($){return this.value+=p._escape($),this}appendTabstop($=this._tabstop++){return this.value+="$",this.value+=$,this}appendPlaceholder($,se=this._tabstop++){if(typeof $=="function"){const Ce=new p;Ce._tabstop=this._tabstop,$(Ce),this._tabstop=Ce._tabstop,$=Ce.value}else $=p._escape($);return this.value+="${",this.value+=se,this.value+=":",this.value+=$,this.value+="}",this}appendChoice($,se=this._tabstop++){const Ce=$.map(et=>et.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=Ce,this.value+="|}",this}appendVariable($,se){if(typeof se=="function"){const Ce=new p;Ce._tabstop=this._tabstop,se(Ce),this._tabstop=Ce._tabstop,se=Ce.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=$,se&&(this.value+=":",this.value+=se),this.value+="}",this}};H=p=Ve([_],H),e.SnippetString=H;var W;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(W=e.DiagnosticTag||(e.DiagnosticTag={}));var Q;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(Q=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let X=t=class{constructor($,se){if(this.uri=$,se)if(se instanceof N)this.range=se;else if(se instanceof F)this.range=new N(se,se);else throw new Error("Illegal argument")}static isLocation($){return $ instanceof t?!0:$?N.isRange($.range)&&D.URI.isUri($.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};X=t=Ve([_],X),e.Location=X;let he=class{constructor($,se){this.location=$,this.message=se}static is($){return $?typeof $.message=="string"&&$.location&&N.isRange($.location.range)&&D.URI.isUri($.location.uri):!1}static isEqual($,se){return $===se?!0:!$||!se?!1:$.message===se.message&&$.location.range.isEqual(se.location.range)&&$.location.uri.toString()===se.location.uri.toString()}};he=Ve([_],he),e.DiagnosticRelatedInformation=he;let _e=class{constructor($,se,Ce=Q.Error){if(!N.isRange($))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=$,this.message=se,this.severity=Ce}toJSON(){return{severity:Q[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual($,se){return $===se?!0:!$||!se?!1:$.message===se.message&&$.severity===se.severity&&$.code===se.code&&$.severity===se.severity&&$.source===se.source&&$.range.isEqual(se.range)&&(0,m.equals)($.tags,se.tags)&&(0,m.equals)($.relatedInformation,se.relatedInformation,he.isEqual)}};_e=Ve([_],_e),e.Diagnostic=_e;let ye=class{constructor($,se){if(!$)throw new Error("Illegal argument, contents must be defined");Array.isArray($)?this.contents=$:this.contents=[$],this.range=se}};ye=Ve([_],ye),e.Hover=ye;var Re;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(Re=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let $e=class{constructor($,se=Re.Text){this.range=$,this.kind=se}toJSON(){return{range:this.range,kind:Re[this.kind]}}};$e=Ve([_],$e),e.DocumentHighlight=$e;var Be;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(Be=e.SymbolKind||(e.SymbolKind={}));var je;(function(j){j[j.Deprecated=1]="Deprecated"})(je=e.SymbolTag||(e.SymbolTag={}));let V=o=class{constructor($,se,Ce,et,st){this.name=$,this.kind=se,this.containerName=st,typeof Ce=="string"&&(this.containerName=Ce),et instanceof X?this.location=et:Ce instanceof N&&(this.location=new X(et,Ce)),o.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Be[this.kind],location:this.location,containerName:this.containerName}}};V=o=Ve([_],V),e.SymbolInformation=V;let ee=r=class{constructor($,se,Ce,et,st){this.name=$,this.detail=se,this.kind=Ce,this.range=et,this.selectionRange=st,this.children=[],r.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy");if(!$.range.contains($.selectionRange))throw new Error("selectionRange must be contained in fullRange");$.children&&$.children.forEach(r.validate)}};ee=r=Ve([_],ee),e.DocumentSymbol=ee;var re;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(re=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ae=class{constructor($,se){this.title=$,this.kind=se}};ae=Ve([_],ae),e.CodeAction=ae;let Y=i=class{constructor($){this.value=$}append($){return new i(this.value?this.value+i.sep+$:$)}intersects($){return this.contains($)||$.contains(this)}contains($){return this.value===$.value||$.value.startsWith(this.value+i.sep)}};Y.sep=".",Y=i=Ve([_],Y),e.CodeActionKind=Y,Y.Empty=new Y(""),Y.QuickFix=Y.Empty.append("quickfix"),Y.Refactor=Y.Empty.append("refactor"),Y.RefactorExtract=Y.Refactor.append("extract"),Y.RefactorInline=Y.Refactor.append("inline"),Y.RefactorRewrite=Y.Refactor.append("rewrite"),Y.Source=Y.Empty.append("source"),Y.SourceOrganizeImports=Y.Source.append("organizeImports"),Y.SourceFixAll=Y.Source.append("fixAll");let oe=class{constructor($,se){if(this.range=$,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};oe=Ve([_],oe),e.SelectionRange=oe;class ve{constructor($,se,Ce,et,st,ut){this.kind=$,this.name=se,this.detail=Ce,this.uri=et,this.range=st,this.selectionRange=ut}}e.CallHierarchyItem=ve;class Me{constructor($,se){this.fromRanges=se,this.from=$}}e.CallHierarchyIncomingCall=Me;class qe{constructor($,se){this.fromRanges=se,this.to=$}}e.CallHierarchyOutgoingCall=qe;var Ke;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Ke=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Se=class{constructor($,se){this.range=$,this.command=se}get isResolved(){return!!this.command}};Se=Ve([_],Se),e.CodeLens=Se;let tt=h=class{constructor($,se=!1){f.set(this,void 0),nt(this,f,new I.MarkdownString($,{supportThemeIcons:se}),"f")}static isMarkdownString($){return $ instanceof h?!0:$&&$.appendCodeblock&&$.appendMarkdown&&$.appendText&&$.value!==void 0}get value(){return Oe(this,f,"f").value}set value($){Oe(this,f,"f").value=$}get isTrusted(){return Oe(this,f,"f").isTrusted}set isTrusted($){Oe(this,f,"f").isTrusted=$}get supportThemeIcons(){return Oe(this,f,"f").supportThemeIcons}set supportThemeIcons($){Oe(this,f,"f").supportThemeIcons=$}get supportHtml(){return Oe(this,f,"f").supportHtml}set supportHtml($){Oe(this,f,"f").supportHtml=$}appendText($){return Oe(this,f,"f").appendText($),this}appendMarkdown($){return Oe(this,f,"f").appendMarkdown($),this}appendCodeblock($,se){return Oe(this,f,"f").appendCodeblock(se??"",$),this}};f=new WeakMap,tt=h=Ve([_],tt),e.MarkdownString=tt;let Z=class{constructor($,se){this.label=$,this.documentation=se}};Z=Ve([_],Z),e.ParameterInformation=Z;let te=class{constructor($,se){this.label=$,this.documentation=se,this.parameters=[]}};te=Ve([_],te),e.SignatureInformation=te;let pe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};pe=Ve([_],pe),e.SignatureHelp=pe;var xe;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(xe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Je;(function(j){j[j.Other=0]="Other",j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(Je=e.InlayHintKind||(e.InlayHintKind={}));let rt=class{constructor($,se,Ce){this.text=$,this.position=se,this.kind=Ce}};rt=Ve([_],rt),e.InlayHint=rt;var ft;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ft=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var pt;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(pt=e.CompletionItemKind||(e.CompletionItemKind={}));var St;(function(j){j[j.Deprecated=1]="Deprecated"})(St=e.CompletionItemTag||(e.CompletionItemTag={}));let Ct=class{constructor($,se){this.label=$,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&pt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ct=Ve([_],Ct),e.CompletionItem=Ct;let ue=class{constructor($=[],se=!1){this.items=$,this.isIncomplete=se}};ue=Ve([_],ue),e.CompletionList=ue;let Ie=class{constructor($,se,Ce){this.text=$,this.range=se,this.command=Ce}};Ie=Ve([_],Ie),e.InlineSuggestion=Ie;let Ue=class{constructor($){this.items=$}};Ue=Ve([_],Ue),e.InlineSuggestions=Ue;var Qe;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(Qe=e.ViewColumn||(e.ViewColumn={}));var ze;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(ze=e.StatusBarAlignment||(e.StatusBarAlignment={}));var at;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(at=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Le;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(Le=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var De;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(De=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ke;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(ke=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ne;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(ne=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var de;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(de=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(j){function $(se){switch(se){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=$}(ke=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let be=class{constructor($,se){if(se&&!D.URI.isUri(se))throw(0,L.illegalArgument)("target");if(!N.isRange($)||$.isEmpty)throw(0,L.illegalArgument)("range");this.range=$,this.target=se}};be=Ve([_],be),e.DocumentLink=be;let we=class{constructor($,se,Ce,et){this.red=$,this.green=se,this.blue=Ce,this.alpha=et}};we=Ve([_],we),e.Color=we;let Fe=class{constructor($,se){if(se&&!(se instanceof we))throw(0,L.illegalArgument)("color");if(!N.isRange($)||$.isEmpty)throw(0,L.illegalArgument)("range");this.range=$,this.color=se}};Fe=Ve([_],Fe),e.ColorInformation=Fe;let Ge=class{constructor($){if(!$||typeof $!="string")throw(0,L.illegalArgument)("label");this.label=$}};Ge=Ve([_],Ge),e.ColorPresentation=Ge;var He;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(He=e.ColorFormat||(e.ColorFormat={}));var Ye;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(Ye=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class it{constructor($,se,Ce){if(this.startIndex=$,this.length=se,this.tooltip=Ce,typeof $!="number"||$<0)throw(0,L.illegalArgument)("startIndex");if(typeof se!="number"||se<1)throw(0,L.illegalArgument)("length");if(Ce!==void 0&&typeof Ce!="string")throw(0,L.illegalArgument)("tooltip")}}e.TerminalLink=it;var le;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(le=e.TerminalLocation||(e.TerminalLocation={}));class Ee{constructor($){this.options=$,typeof $!="object"&&(0,L.illegalArgument)("options")}}e.TerminalProfile=Ee;var ce;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(ce=e.TaskRevealKind||(e.TaskRevealKind={}));var q;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(q=e.TaskPanelKind||(e.TaskPanelKind={}));let Ae=c=class{constructor($,se){if(this.label=se,typeof $!="string"||typeof se!="string")throw(0,L.illegalArgument)("name");this._id=$}static from($){switch($){case"clean":return c.Clean;case"build":return c.Build;case"rebuild":return c.Rebuild;case"test":return c.Test;default:return}}get id(){return this._id}};Ae.Clean=new c("clean","Clean"),Ae.Build=new c("build","Build"),Ae.Rebuild=new c("rebuild","Rebuild"),Ae.Test=new c("test","Test"),Ae=c=Ve([_],Ae),e.TaskGroup=Ae;function Pe(j){let $="";for(let se=0;se<j.length;se++)$+=j[se].replace(/,/g,",,")+",";return $}let Ze=class{constructor($,se,Ce){if(typeof $!="string")throw(0,L.illegalArgument)("process");this._args=[],this._process=$,se!==void 0&&(Array.isArray(se)?(this._args=se,this._options=Ce):this._options=se)}get process(){return this._process}set process($){if(typeof $!="string")throw(0,L.illegalArgument)("process");this._process=$}get args(){return this._args}set args($){Array.isArray($)||($=[]),this._args=$}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("process"),this._process!==void 0&&$.push(this._process),this._args&&this._args.length>0)for(let se of this._args)$.push(se);return Pe($)}};Ze=Ve([_],Ze),e.ProcessExecution=Ze;let Xe=class{constructor($,se,Ce){if(this._args=[],Array.isArray(se)){if(!$)throw(0,L.illegalArgument)("command can't be undefined or null");if(typeof $!="string"&&typeof $.value!="string")throw(0,L.illegalArgument)("command");this._command=$,this._args=se,this._options=Ce}else{if(typeof $!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=$,this._options=se}}get commandLine(){return this._commandLine}set commandLine($){if(typeof $!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=$}get command(){return this._command?this._command:""}set command($){if(typeof $!="string"&&typeof $.value!="string")throw(0,L.illegalArgument)("command");this._command=$}get args(){return this._args}set args($){this._args=$||[]}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("shell"),this._commandLine!==void 0&&$.push(this._commandLine),this._command!==void 0&&$.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let se of this._args)$.push(typeof se=="string"?se:se.value);return Pe($)}};Xe=Ve([_],Xe),e.ShellExecution=Xe;var ot;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(ot=e.ShellQuoting||(e.ShellQuoting={}));var vt;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(vt=e.TaskScope||(e.TaskScope={}));class Et{constructor($){this._callback=$}computeId(){return"customExecution"+(0,T.generateUuid)()}set callback($){this._callback=$}get callback(){return this._callback}}e.CustomExecution=Et;let lt=d=class{constructor($,se,Ce,et,st,ut){this.__deprecated=!1,this._definition=this.definition=$;let ht;typeof se=="string"?(this._name=this.name=se,this._source=this.source=Ce,this.execution=et,ht=st,this.__deprecated=!0):se===vt.Global||se===vt.Workspace?(this.target=se,this._name=this.name=Ce,this._source=this.source=et,this.execution=st,ht=ut):(this.target=se,this._name=this.name=Ce,this._source=this.source=et,this.execution=st,ht=ut),typeof ht=="string"?(this._problemMatchers=[ht],this._hasDefinedMatchers=!0):Array.isArray(ht)?(this._problemMatchers=ht,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id($){this.__id=$}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ze?this._definition={type:d.ProcessType,id:this._execution.computeId()}:this._execution instanceof Xe?this._definition={type:d.ShellType,id:this._execution.computeId()}:this._execution instanceof Et?this._definition={type:d.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:d.EmptyType,id:(0,T.generateUuid)()}}get definition(){return this._definition}set definition($){if($==null)throw(0,L.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=$}get scope(){return this._scope}set target($){this.clear(),this._scope=$}get name(){return this._name}set name($){if(typeof $!="string")throw(0,L.illegalArgument)("name");this.clear(),this._name=$}get execution(){return this._execution}set execution($){$===null&&($=void 0),this.clear(),this._execution=$;const se=this._definition.type;(d.EmptyType===se||d.ProcessType===se||d.ShellType===se||d.ExtensionCallbackType===se)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers($){if(Array.isArray($))this.clear(),this._problemMatchers=$,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground($){$!==!0&&$!==!1&&($=!1),this.clear(),this._isBackground=$}get source(){return this._source}set source($){if(typeof $!="string"||$.length===0)throw(0,L.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=$}get group(){return this._group}set group($){$===null&&($=void 0),this.clear(),this._group=$}get detail(){return this._detail}set detail($){$===null&&($=void 0),this._detail=$}get presentationOptions(){return this._presentationOptions}set presentationOptions($){$==null&&($=Object.create(null)),this.clear(),this._presentationOptions=$}get runOptions(){return this._runOptions}set runOptions($){$==null&&($=Object.create(null)),this.clear(),this._runOptions=$}};lt.ExtensionCallbackType="customExecution",lt.ProcessType="process",lt.ShellType="shell",lt.EmptyType="$empty",lt=d=Ve([_],lt),e.Task=lt;var dt;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(dt=e.ProgressLocation||(e.ProgressLocation={}));let mt=class{constructor($,se=Rt.None){this.collapsibleState=se,D.URI.isUri($)?this.resourceUri=$:this.label=$}};mt=Ve([_],mt),e.TreeItem=mt;var Rt;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(Rt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let yt=class{constructor($,se){this.id=$,this.color=se}};yt=Ve([_],yt),e.ThemeIcon=yt,yt.File=new yt("file"),yt.Folder=new yt("folder");let Ot=class{constructor($){this.id=$}};Ot=Ve([_],Ot),e.ThemeColor=Ot;var hn;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(hn=e.ConfigurationTarget||(e.ConfigurationTarget={}));let It=class{constructor($,se){if(typeof $!="string"&&(!$||!D.URI.isUri($)&&!D.URI.isUri($.uri)))throw(0,L.illegalArgument)("base");if(typeof se!="string")throw(0,L.illegalArgument)("pattern");typeof $=="string"?(this.baseFolder=D.URI.file($),this.base=$):D.URI.isUri($)?(this.baseFolder=$,this.base=$.fsPath):(this.baseFolder=$.uri,this.base=$.uri.fsPath),this.pattern=se}};It=Ve([_],It),e.RelativePattern=It;let $t=class{constructor($,se,Ce,et){this.enabled=typeof $=="boolean"?$:!0,typeof se=="string"&&(this.condition=se),typeof Ce=="string"&&(this.hitCondition=Ce),typeof et=="string"&&(this.logMessage=et)}get id(){return this._id||(this._id=(0,T.generateUuid)()),this._id}};$t=Ve([_],$t),e.Breakpoint=$t;let Zt=class extends $t{constructor($,se,Ce,et,st){super(se,Ce,et,st);if($===null)throw(0,L.illegalArgument)("location");this.location=$}};Zt=Ve([_],Zt),e.SourceBreakpoint=Zt;let wt=class extends $t{constructor($,se,Ce,et,st){super(se,Ce,et,st);this.functionName=$}};wt=Ve([_],wt),e.FunctionBreakpoint=wt;let Kt=class extends $t{constructor($,se,Ce,et,st,ut,ht){super(et,st,ut,ht);if(!se)throw(0,L.illegalArgument)("dataId");this.label=$,this.dataId=se,this.canPersist=Ce}};Kt=Ve([_],Kt),e.DataBreakpoint=Kt;let Vt=class{constructor($,se,Ce){this.command=$,this.args=se||[],this.options=Ce}};Vt=Ve([_],Vt),e.DebugAdapterExecutable=Vt;let en=class{constructor($,se){this.port=$,this.host=se}};en=Ve([_],en),e.DebugAdapterServer=en;let tn=class{constructor($){this.path=$}};tn=Ve([_],tn),e.DebugAdapterNamedPipeServer=tn;let Pt=class{constructor($){this.implementation=$}};Pt=Ve([_],Pt),e.DebugAdapterInlineImplementation=Pt;let Qt=class{constructor($,se){this.range=$,this.expression=se}};Qt=Ve([_],Qt),e.EvaluatableExpression=Qt;var bn;(function(j){j[j.Automatic=0]="Automatic",j[j.Explicit=1]="Explicit"})(bn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Wt=class{constructor($,se){this.range=$,this.text=se}};Wt=Ve([_],Wt),e.InlineValueText=Wt;let Ht=class{constructor($,se,Ce=!0){this.range=$,this.variableName=se,this.caseSensitiveLookup=Ce}};Ht=Ve([_],Ht),e.InlineValueVariableLookup=Ht;let gt=class{constructor($,se){this.range=$,this.expression=se}};gt=Ve([_],gt),e.InlineValueEvaluatableExpression=gt;let nn=class{constructor($,se){this.frameId=$,this.stoppedLocation=se}};nn=Ve([_],nn),e.InlineValueContext=nn;var Nt;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Nt=e.FileChangeType||(e.FileChangeType={}));let Ut=b=class extends Error{constructor($,se=n.FileSystemProviderErrorCode.Unknown,Ce){super(D.URI.isUri($)?$.toString(!0):$);this.code=Ce?.name??"Unknown",(0,n.markAsFileSystemProviderError)(this,se),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,b.prototype),typeof Error.captureStackTrace=="function"&&typeof Ce=="function"&&Error.captureStackTrace(this,Ce)}static FileExists($){return new b($,n.FileSystemProviderErrorCode.FileExists,b.FileExists)}static FileNotFound($){return new b($,n.FileSystemProviderErrorCode.FileNotFound,b.FileNotFound)}static FileNotADirectory($){return new b($,n.FileSystemProviderErrorCode.FileNotADirectory,b.FileNotADirectory)}static FileIsADirectory($){return new b($,n.FileSystemProviderErrorCode.FileIsADirectory,b.FileIsADirectory)}static NoPermissions($){return new b($,n.FileSystemProviderErrorCode.NoPermissions,b.NoPermissions)}static Unavailable($){return new b($,n.FileSystemProviderErrorCode.Unavailable,b.Unavailable)}};Ut=b=Ve([_],Ut),e.FileSystemError=Ut;let Xt=class{constructor($,se,Ce){this.start=$,this.end=se,this.kind=Ce}};Xt=Ve([_],Xt),e.FoldingRange=Xt;var En;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(En=e.FoldingRangeKind||(e.FoldingRangeKind={}));var fn;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(fn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var _n;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(_n=e.CommentMode||(e.CommentMode={}));class mn{constructor($,se=[]){this.tokenTypes=$,this.tokenModifiers=se}}e.SemanticTokensLegend=mn;function rn(j){return typeof j=="undefined"||(0,C.isStringArray)(j)}class sn{constructor($){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,$){this._hasLegend=!0;for(let se=0,Ce=$.tokenTypes.length;se<Ce;se++)this._tokenTypeStrToInt.set($.tokenTypes[se],se);for(let se=0,Ce=$.tokenModifiers.length;se<Ce;se++)this._tokenModifierStrToInt.set($.tokenModifiers[se],se)}}push($,se,Ce,et,st){if(typeof $=="number"&&typeof se=="number"&&typeof Ce=="number"&&typeof et=="number"&&(typeof st=="number"||typeof st=="undefined"))return typeof st=="undefined"&&(st=0),this._pushEncoded($,se,Ce,et,st);if(N.isRange($)&&typeof se=="string"&&rn(Ce))return this._push($,se,Ce);throw(0,L.illegalArgument)()}_push($,se,Ce){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if($.start.line!==$.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(se))throw new Error("`tokenType` is not in the provided legend");const et=$.start.line,st=$.start.character,ut=$.end.character-$.start.character,ht=this._tokenTypeStrToInt.get(se);let Dt=0;if(Ce)for(const At of Ce){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Lt=this._tokenModifierStrToInt.get(At);Dt|=1<<Lt>>>0}this._pushEncoded(et,st,ut,ht,Dt)}_pushEncoded($,se,Ce,et,st){if(this._dataIsSortedAndDeltaEncoded&&($<this._prevLine||$===this._prevLine&&se<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Dt=this._data.length/5|0;let At=0,Lt=0;for(let Mt=0;Mt<Dt;Mt++){let Bt=this._data[5*Mt],un=this._data[5*Mt+1];Bt===0?(Bt=At,un+=Lt):Bt+=At,this._data[5*Mt]=Bt,this._data[5*Mt+1]=un,At=Bt,Lt=un}}let ut=$,ht=se;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ut-=this._prevLine,ut===0&&(ht-=this._prevChar)),this._data[this._dataLen++]=ut,this._data[this._dataLen++]=ht,this._data[this._dataLen++]=Ce,this._data[this._dataLen++]=et,this._data[this._dataLen++]=st,this._prevLine=$,this._prevChar=se}static _sortAndDeltaEncode($){let se=[];const Ce=$.length/5|0;for(let ht=0;ht<Ce;ht++)se[ht]=ht;se.sort((ht,Dt)=>{const At=$[5*ht],Lt=$[5*Dt];if(At===Lt){const Mt=$[5*ht+1],Bt=$[5*Dt+1];return Mt-Bt}return At-Lt});const et=new Uint32Array($.length);let st=0,ut=0;for(let ht=0;ht<Ce;ht++){const Dt=5*se[ht],At=$[Dt+0],Lt=$[Dt+1],Mt=$[Dt+2],Bt=$[Dt+3],un=$[Dt+4],Bn=At-st,Gn=Bn===0?Lt-ut:Lt,dn=5*ht;et[dn+0]=Bn,et[dn+1]=Gn,et[dn+2]=Mt,et[dn+3]=Bt,et[dn+4]=un,st=At,ut=Lt}return et}build($){return this._dataIsSortedAndDeltaEncoded?new jt(new Uint32Array(this._data),$):new jt(sn._sortAndDeltaEncode(this._data),$)}}e.SemanticTokensBuilder=sn;class jt{constructor($,se){this.resultId=se,this.data=$}}e.SemanticTokens=jt;class on{constructor($,se,Ce){this.start=$,this.deleteCount=se,this.data=Ce}}e.SemanticTokensEdit=on;class Sn{constructor($,se){this.resultId=se,this.edits=$}}e.SemanticTokensEdits=Sn;var yn;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(yn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var qt;(function(j){j[j.Initial=1]="Initial",j[j.Dynamic=2]="Dynamic"})(qt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Jt=class{constructor(){}};Jt.Back={iconPath:new yt("arrow-left")},Jt=Ve([_],Jt),e.QuickInputButtons=Jt;var Dn;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(Dn=e.ExtensionKind||(e.ExtensionKind={}));class Cn{constructor($,se,Ce){this.badge=$,this.tooltip=se,this.color=Ce}static validate($){if($.badge&&$.badge.length!==1&&$.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!$.color&&!$.badge&&!$.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Cn;let an=class{constructor($){this.kind=$}};an=Ve([_],an),e.ColorTheme=an;var ln;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast"})(ln=e.ColorThemeKind||(e.ColorThemeKind={}));class zt{constructor($,se){if($<0)throw(0,L.illegalArgument)("start must be positive");if(se<0)throw(0,L.illegalArgument)("end must be positive");$<=se?(this._start=$,this._end=se):(this._start=se,this._end=$)}static isNotebookRange($){return $ instanceof zt?!0:$?typeof $.start=="number"&&typeof $.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with($){let se=this._start,Ce=this._end;return $.start!==void 0&&(se=$.start),$.end!==void 0&&(Ce=$.end),se===this._start&&Ce===this._end?this:new zt(se,Ce)}}e.NotebookRange=zt;class Ft{constructor($,se,Ce,et,st,ut,ht){this.kind=$,this.value=se,this.languageId=Ce,this.mime=et,this.outputs=st??[],this.metadata=ut,this.executionSummary=ht,Ft.validate(this)}static validate($){if(typeof $.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof $.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof $.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray($){return Array.isArray($)&&$.every(se=>Ft.isNotebookCellData(se))}static isNotebookCellData($){return!0}}e.NotebookCellData=Ft;class Ne{constructor($){this.cells=$}}e.NotebookData=Ne;class Tt{constructor($,se){this.data=$,this.mime=se;const Ce=(0,R.normalizeMimeType)(se,!0);if(!Ce)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ce}static isNotebookCellOutputItem($){return $ instanceof Tt?!0:$?typeof $.mime=="string"&&$.data instanceof Uint8Array:!1}static error($){const se={name:$.name,message:$.message,stack:$.stack};return Tt.json(se,"application/vnd.code.notebook.error")}static stdout($){return Tt.text($,"application/vnd.code.notebook.stdout")}static stderr($){return Tt.text($,"application/vnd.code.notebook.stderr")}static bytes($,se="application/octet-stream"){return new Tt($,se)}static text($,se=R.Mimes.text){const Ce=Oe(Tt,l,"f",v).encode(String($));return new Tt(Ce,se)}static json($,se="application/json"){const Ce=JSON.stringify($,void 0,"	");return Tt.text(Ce,se)}}e.NotebookCellOutputItem=Tt,l=Tt,v={value:new TextEncoder};class Gt{constructor($,se,Ce){this.items=Gt.ensureUniqueMimeTypes($,!0),typeof se=="string"?(this.id=se,this.metadata=Ce):(this.id=(0,T.generateUuid)(),this.metadata=se??Ce)}static isNotebookCellOutput($){return $ instanceof Gt?!0:!$||typeof $!="object"?!1:typeof $.id=="string"&&(0,C.isArray)($.items)}static ensureUniqueMimeTypes($,se=!1){const Ce=new Set,et=new Set;for(let st=0;st<$.length;st++){const ut=$[st],ht=(0,R.normalizeMimeType)(ut.mime);if(!Ce.has(ht)){Ce.add(ht);continue}et.add(st),se&&console.warn(`DUPLICATED mime type '${ut.mime}' will be dropped`)}return et.size===0?$:$.filter((st,ut)=>!et.has(ut))}}e.NotebookCellOutput=Gt;var bt;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(bt=e.NotebookCellKind||(e.NotebookCellKind={}));var kn;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(kn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var In;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(In=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var gn;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(gn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class pn{constructor($,se){this.text=$,this.alignment=se}}e.NotebookCellStatusBarItem=pn;var Pn;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(Pn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class An{constructor($,se=[]){this.uri=$,this.provides=(0,m.asArray)(se)}}e.NotebookRendererScript=An;let cn=class{constructor($,se){this.label=$,this.timestamp=se}};cn=Ve([_],cn),e.TimelineItem=cn;var Tn;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(Tn=e.ExtensionMode||(e.ExtensionMode={}));var vn;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(vn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Rn;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=4]="RegEx"})(Rn=e.StandardTokenType||(e.StandardTokenType={}));class Ln{constructor($,se){this.ranges=$,this.wordPattern=se}}e.LinkedEditingRanges=Ln;class Fn{constructor($,se){this._port=$,this._autoForwardAction=se}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Fn;var Mn;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(Mn=e.TestResultState||(e.TestResultState={}));var On;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(On=e.TestRunProfileKind||(e.TestRunProfileKind={}));let ie=class{constructor($,se,Ce){this.include=$,this.exclude=se,this.profile=Ce}};ie=Ve([_],ie),e.TestRunRequest=ie;let fe=y=class{constructor($){this.message=$}static diff($,se,Ce){const et=new y($);return et.expectedOutput=se,et.actualOutput=Ce,et}};fe=y=Ve([_],fe),e.TestMessage=fe;let Te=class{constructor($){this.id=$}};Te=Ve([_],Te),e.TestTag=Te;let ct=class{constructor($,se){this.covered=$,this.total=se}};ct=Ve([_],ct),e.CoveredCount=ct;let _t=g=class{constructor($,se,Ce,et){this.uri=$,this.statementCoverage=se,this.branchCoverage=Ce,this.functionCoverage=et}static fromDetails($,se){const Ce=new ct(0,0),et=new ct(0,0),st=new ct(0,0);for(const ht of se)if("branches"in ht){Ce.total+=1,Ce.covered+=ht.executionCount>0?1:0;for(const Dt of ht.branches)et.total+=1,et.covered+=Dt.executionCount>0?1:0}else st.total+=1,st.covered+=ht.executionCount>0?1:0;const ut=new g($,Ce,et.total>0?et:void 0,st.total>0?st:void 0);return ut.detailedCoverage=se,ut}};_t=g=Ve([_],_t),e.FileCoverage=_t;let kt=class{constructor($,se,Ce=[]){this.executionCount=$,this.location=se,this.branches=Ce}};kt=Ve([_],kt),e.StatementCoverage=kt;let Nn=class{constructor($,se){this.executionCount=$,this.location=se}};Nn=Ve([_],Nn),e.BranchCoverage=Nn;let Un=class{constructor($,se){this.executionCount=$,this.location=se}};Un=Ve([_],Un),e.FunctionCoverage=Un;var zn;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(zn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Vn;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(Vn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var jn;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(jn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class qn{constructor($,se,Ce,et,st,ut){this.kind=$,this.name=se,this.detail=Ce,this.uri=et,this.range=st,this.selectionRange=ut}}e.TypeHierarchyItem=qn}),define(me[123],ge([0,1,56,10,9,149,110,7,17]),function(J,e,m,L,I,k,R,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const T=new Map;function n(l,v){v?T.set(l,v):T.delete(l)}e.setWordDefinitionFor=n;function A(l){return T.get(l)}e.getWordDefinitionFor=A;class u extends k.MirrorTextModel{constructor(v,S,P,E,s,a,p,t){super(S,P,E,s);this._proxy=v,this._languageId=a,this._isDirty=p,this._notebook=t,this._isDisposed=!1}dispose(){(0,m.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(v){return(0,D.equals)(this._lines,v)}get document(){if(!this._document){const v=this;this._document={get uri(){return v._uri},get fileName(){return v._uri.fsPath},get isUntitled(){return v._uri.scheme===L.Schemas.untitled},get languageId(){return v._languageId},get version(){return v._versionId},get isClosed(){return v._isDisposed},get isDirty(){return v._isDirty},get notebook(){return v._notebook},save(){return v._save()},getText(S){return S?v._getTextInRange(S):v.getText()},get eol(){return v._eol===`
`?C.EndOfLine.LF:C.EndOfLine.CRLF},get lineCount(){return v._lines.length},lineAt(S){return v._lineAt(S)},offsetAt(S){return v._offsetAt(S)},positionAt(S){return v._positionAt(S)},validateRange(S){return v._validateRange(S)},validatePosition(S){return v._validatePosition(S)},getWordRangeAtPosition(S,P){return v._getWordRangeAtPosition(S,P)}}}return Object.freeze(this._document)}_acceptLanguageId(v){(0,m.ok)(!this._isDisposed),this._languageId=v}_acceptIsDirty(v){(0,m.ok)(!this._isDisposed),this._isDirty=v}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(v){const S=this._validateRange(v);if(S.isEmpty)return"";if(S.isSingleLine)return this._lines[S.start.line].substring(S.start.character,S.end.character);const P=this._eol,E=S.start.line,s=S.end.line,a=[];a.push(this._lines[E].substring(S.start.character));for(let p=E+1;p<s;p++)a.push(this._lines[p]);return a.push(this._lines[s].substring(0,S.end.character)),a.join(P)}_lineAt(v){let S;if(v instanceof C.Position?S=v.line:typeof v=="number"&&(S=v),typeof S!="number"||S<0||S>=this._lines.length||Math.floor(S)!==S)throw new Error("Illegal value for `line`");return new f(S,this._lines[S],S===this._lines.length-1)}_offsetAt(v){return v=this._validatePosition(v),this._ensureLineStarts(),this._lineStarts.getPrefixSum(v.line-1)+v.character}_positionAt(v){v=Math.floor(v),v=Math.max(0,v),this._ensureLineStarts();const S=this._lineStarts.getIndexOf(v),P=this._lines[S.index].length;return new C.Position(S.index,Math.min(S.remainder,P))}_validateRange(v){if(!(v instanceof C.Range))throw new Error("Invalid argument");const S=this._validatePosition(v.start),P=this._validatePosition(v.end);return S===v.start&&P===v.end?v:new C.Range(S.line,S.character,P.line,P.character)}_validatePosition(v){if(!(v instanceof C.Position))throw new Error("Invalid argument");if(this._lines.length===0)return v.with(0,0);let{line:S,character:P}=v,E=!1;if(S<0)S=0,P=0,E=!0;else if(S>=this._lines.length)S=this._lines.length-1,P=this._lines[S].length,E=!0;else{const s=this._lines[S].length;P<0?(P=0,E=!0):P>s&&(P=s,E=!0)}return E?new C.Position(S,P):v}_getWordRangeAtPosition(v,S){const P=this._validatePosition(v);if(!S)S=A(this._languageId);else if((0,I.regExpLeadsToEndlessLoop)(S))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${S.source}' because it matches the empty string.`);const E=(0,R.getWordAtText)(P.character+1,(0,R.ensureValidWordDefinition)(S),this._lines[P.line],0);if(E)return new C.Range(P.line,E.startColumn-1,P.line,E.endColumn-1)}}e.ExtHostDocumentData=u;class f{constructor(v,S,P){this._line=v,this._text=S,this._isLastLine=P}get lineNumber(){return this._line}get text(){return this._text}get range(){return new C.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new C.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=f}),define(me[203],ge([0,1,7,3,112,6,81,24,2,32]),function(J,e,m,L,I,k,R,C,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class n{constructor(u,f,l,v){this._notebook=l,this._selector=v,this._disposables=new k.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this.uri=D.URI.from({scheme:"vscode-concat-doc",path:(0,T.generateUuid)()}),this._init(),this._disposables.add(f.onDidChangeDocument(P=>{const E=this._cellUris.get(P.document.uri);E!==void 0&&(this._cellLengths.changeValue(E,this._cells[E].document.getText().length+1),this._cellLines.changeValue(E,this._cells[E].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const S=P=>{P===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(u.onDidChangeNotebookCells(P=>S(P.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new C.ResourceMap;const u=[],f=[];for(const l of this._notebook.getCells())l.kind===m.NotebookCellKind.Code&&(!this._selector||(0,R.score)(this._selector,l.document.uri,l.document.languageId,!0))&&(this._cellUris.set(l.document.uri,this._cells.length),this._cells.push(l),u.push(l.document.getText().length+1),f.push(l.document.lineCount));this._cellLengths=new I.PrefixSumComputer(new Uint32Array(u)),this._cellLines=new I.PrefixSumComputer(new Uint32Array(f))}get version(){return this._versionId}getText(u){if(!u){let E="";for(const s of this._cells)E+=s.document.getText()+`
`;return E=E.slice(0,-1),E}if(u.isEmpty)return"";const f=this.locationAt(u.start),l=this.locationAt(u.end),v=this._cellUris.get(f.uri),S=this._cellUris.get(l.uri);if(v===void 0||S===void 0)return"";if(v===S)return this._cells[v].document.getText(new m.Range(f.range.start,l.range.end));const P=[this._cells[v].document.getText(new m.Range(f.range.start,new m.Position(this._cells[v].document.lineCount,0)))];for(let E=v+1;E<S;E++)P.push(this._cells[E].document.getText());return P.push(this._cells[S].document.getText(new m.Range(new m.Position(0,0),l.range.end))),P.join(`
`)}offsetAt(u){const f=this._cellLines.getIndexOf(u.line),l=this._cellLengths.getPrefixSum(f.index-1),v=this._cells[f.index].document.offsetAt(u.with(f.remainder));return l+v}positionAt(u){if(typeof u=="number"){const l=this._cellLengths.getIndexOf(u),v=this._cellLines.getPrefixSum(l.index-1);return this._cells[l.index].document.positionAt(l.remainder).translate(v)}const f=this._cellUris.get(u.uri);if(f!==void 0){const l=this._cellLines.getPrefixSum(f-1);return new m.Position(l+u.range.start.line,u.range.start.character)}return new m.Position(0,0)}locationAt(u){m.Range.isRange(u)||(u=new m.Range(u,u));const f=this._cellLines.getIndexOf(u.start.line);let l=f;u.isEmpty||(l=this._cellLines.getIndexOf(u.end.line));const v=new m.Position(f.remainder,u.start.character),S=new m.Position(l.remainder,u.end.character),P=new m.Range(v,S),E=this._cells[f.index];return new m.Location(E.document.uri,E.document.validateRange(P))}contains(u){return this._cellUris.has(u)}validateRange(u){const f=this.validatePosition(u.start),l=this.validatePosition(u.end);return u.with(f,l)}validatePosition(u){const f=this._cellLines.getIndexOf(u.line),l=new m.Position(f.remainder,u.character),v=this._cells[f.index].document.validatePosition(l),S=this._cellLines.getPrefixSum(f.index-1);return new m.Position(S+v.line,v.character)}}e.ExtHostNotebookConcatDocument=n}),define(me[204],ge([0,1,7,14,3]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let k=class{constructor(C){this._actual=new m.ColorTheme(m.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new I.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(C){let D=C==="light"?m.ColorThemeKind.Light:C==="dark"?m.ColorThemeKind.Dark:m.ColorThemeKind.HighContrast;this._actual=new m.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};k=Ve([We(0,L.IExtHostRpcService)],k),e.ExtHostTheming=k}),define(me[65],ge([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,m.createDecorator)("IURITransformerService");class L{constructor(k){k?(this.transformIncoming=k.transformIncoming.bind(k),this.transformOutgoing=k.transformOutgoing.bind(k),this.transformOutgoingURI=k.transformOutgoingURI.bind(k),this.transformOutgoingScheme=k.transformOutgoingScheme.bind(k)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.URITransformerService=L}),define(me[205],ge([0,1,23]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class L{constructor(){this.buffers=[]}add(D){let T=this.buffers.indexOf(D);return T<0&&(T=this.buffers.length,this.buffers.push(D)),T}}function I(C,D){if(D.serializeBuffersForPostMessage){const T=new L,n=(f,l)=>{if(l instanceof ArrayBuffer){const v=T.add(l);return{$$vscode_array_buffer_reference$$:!0,index:v}}else if(ArrayBuffer.isView(l)){const v=k(l);if(v){const S=T.add(l.buffer);return{$$vscode_array_buffer_reference$$:!0,index:S,view:{type:v,byteLength:l.byteLength,byteOffset:l.byteOffset}}}}return l},A=JSON.stringify(C,n),u=T.buffers.map(f=>{const l=new Uint8Array(f);return m.VSBuffer.wrap(l)});return{message:A,buffers:u}}else return{message:JSON.stringify(C),buffers:[]}}e.serializeWebviewMessage=I;function k(C){switch(C.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(C,D){const T=D.map(u=>{const f=new ArrayBuffer(u.byteLength);return new Uint8Array(f).set(u.buffer),f}),n=D.length?(u,f)=>{if(typeof f=="object"&&f.$$vscode_array_buffer_reference$$){const l=f,{index:v}=l,S=T[v];if(l.view)switch(l.view.type){case 1:return new Int8Array(S,l.view.byteOffset,l.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(S,l.view.byteOffset,l.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(S,l.view.byteOffset,l.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(S,l.view.byteOffset,l.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(S,l.view.byteOffset,l.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(S,l.view.byteOffset,l.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(S,l.view.byteOffset,l.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(S,l.view.byteOffset,l.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(S,l.view.byteOffset,l.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(S,l.view.byteOffset,l.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(S,l.view.byteOffset,l.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return S}return f}:void 0;return{message:JSON.parse(C,n),arrayBuffers:T}}e.deserializeWebviewMessage=R}),define(me[206],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var m;(function(L){function I(R){const C={items:new Map};return R.types.forEach((D,T)=>{C.items.set(D,{asString:async()=>R.items[T].asString})}),C}L.toITreeDataTransfer=I;async function k(R){const C={types:[],items:[]},D=Array.from(R.items.entries());for(const T of D)C.types.push(T[0]),C.items.push({asString:await T[1].asString()});return C}L.toTreeDataTransferDTO=k})(m=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(me[88],ge([0,1,10,2]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function I(C,D){return C.scheme===m.Schemas.http||C.scheme===m.Schemas.https?C:(D&&D.authority&&D.isRemote&&C.scheme===m.Schemas.file&&(C=L.URI.from({scheme:m.Schemas.vscodeRemote,authority:D.authority,path:C.path})),L.URI.from({scheme:m.Schemas.https,authority:`${C.scheme}+${k(C.authority)}.${e.webviewRootResourceAuthority}`,path:C.path,fragment:C.fragment,query:C.query}))}e.asWebviewUri=I;function k(C){return C.replace(/./g,D=>{const T=D.charCodeAt(0);return T>=97&&T<=122||T>=65&&T<=90||T>=48&&T<=57?D:"-"+T.toString(16).padStart(4,"0")})}function R(C){return C.replace(/-([0-9a-f]{4})/g,(D,T)=>String.fromCharCode(parseInt(T,16)))}e.decodeAuthority=R}),define(me[207],ge([0,1,3,6,88]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class k{constructor(C,D,T){this._proxy=C,this._editors=D,this._initData=T,this._handlePool=0,this._disposables=new L.DisposableStore,this._insets=new Map,this._disposables.add(D.onDidChangeVisibleTextEditors(()=>{const n=D.getVisibleTextEditors();for(const A of this._insets.values())n.indexOf(A.editor)<0&&A.inset.dispose()}))}dispose(){this._insets.forEach(C=>C.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(C,D,T,n,A){let u;for(const s of this._editors.getVisibleTextEditors(!0))if(s.value===C){u=s;break}if(!u)throw new Error("not a visible editor");const f=this,l=this._handlePool++,v=new m.Emitter,S=new m.Emitter,P=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(s){return(0,I.asWebviewUri)(s,f._initData.remote)}get cspSource(){return I.webviewGenericCspSource}set options(s){this._options=s,f._proxy.$setOptions(l,s)}get options(){return this._options}set html(s){this._html=s,f._proxy.$setHtml(l,s)}get html(){return this._html}get onDidReceiveMessage(){return v.event}postMessage(s){return f._proxy.$postMessage(l,s)}},E=new class{constructor(){this.editor=C,this.line=D,this.height=T,this.webview=P,this.onDidDispose=S.event}dispose(){f._insets.has(l)&&(f._insets.delete(l),f._proxy.$disposeEditorInset(l),S.fire(),S.dispose(),v.dispose())}};return this._proxy.$createEditorInset(l,u.id,u.value.document.uri,D+1,T,n||{},A.identifier,A.extensionLocation),this._insets.set(l,{editor:C,inset:E,onDidReceiveMessage:v}),E}$onDidDispose(C){const D=this._insets.get(C);D&&D.inset.dispose()}$onDidReceiveMessage(C,D){const T=this._insets.get(C);T&&T.onDidReceiveMessage.fire(D)}}e.ExtHostEditorInsets=k}),define(me[208],ge([0,1,171,13,2,6,4,62,35,17,10]),function(J,e,m,L,I,k,R,C,D,T,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,m.localize)(0,null),providerDisplayName:(0,m.localize)(1,null)},e.ActiveEditorDirtyContext=new C.RawContextKey("activeEditorIsDirty",!1,(0,m.localize)(2,null)),e.ActiveEditorPinnedContext=new C.RawContextKey("activeEditorIsNotPreview",!1,(0,m.localize)(3,null)),e.ActiveEditorStickyContext=new C.RawContextKey("activeEditorIsPinned",!1,(0,m.localize)(4,null)),e.ActiveEditorReadonlyContext=new C.RawContextKey("activeEditorIsReadonly",!1,(0,m.localize)(5,null)),e.ActiveEditorCanRevertContext=new C.RawContextKey("activeEditorCanRevert",!1,(0,m.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new C.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new C.RawContextKey("activeEditor",null,{type:"string",description:(0,m.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new C.RawContextKey("activeEditorAvailableEditorIds","",(0,m.localize)(8,null)),e.TextCompareEditorVisibleContext=new C.RawContextKey("textCompareEditorVisible",!1,(0,m.localize)(9,null)),e.TextCompareEditorActiveContext=new C.RawContextKey("textCompareEditorActive",!1,(0,m.localize)(10,null)),e.EditorGroupEditorsCountContext=new C.RawContextKey("groupEditorsCount",0,(0,m.localize)(11,null)),e.ActiveEditorGroupEmptyContext=new C.RawContextKey("activeEditorGroupEmpty",!1,(0,m.localize)(12,null)),e.ActiveEditorGroupIndexContext=new C.RawContextKey("activeEditorGroupIndex",0,(0,m.localize)(13,null)),e.ActiveEditorGroupLastContext=new C.RawContextKey("activeEditorGroupLast",!1,(0,m.localize)(14,null)),e.ActiveEditorGroupLockedContext=new C.RawContextKey("activeEditorGroupLocked",!1,(0,m.localize)(15,null)),e.MultipleEditorGroupsContext=new C.RawContextKey("multipleEditorGroups",!1,(0,m.localize)(16,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new C.RawContextKey("editorIsOpen",!1,(0,m.localize)(17,null)),e.InEditorZenModeContext=new C.RawContextKey("inZenMode",!1,(0,m.localize)(18,null)),e.IsCenteredLayoutContext=new C.RawContextKey("isCenteredLayout",!1,(0,m.localize)(19,null)),e.SplitEditorsVertically=new C.RawContextKey("splitEditorsVertically",!1,(0,m.localize)(20,null)),e.EditorAreaVisibleContext=new C.RawContextKey("editorAreaVisible",!0,(0,m.localize)(21,null)),e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function A(_){if(s(_))return!1;const w=_;return I.URI.isUri(w?.resource)}e.isResourceEditorInput=A;function u(_){if(s(_))return!1;const w=_;return w?.original!==void 0&&w.modified!==void 0}e.isResourceDiffEditorInput=u;function f(_){if(s(_))return!1;const w=_;return w?.primary!==void 0&&w.secondary!==void 0}e.isResourceSideBySideEditorInput=f;function l(_){if(s(_))return!1;const w=_;return w?w.resource===void 0||w.resource.scheme===n.Schemas.untitled||w.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=l;var v;(function(_){_[_.SHORT=0]="SHORT",_[_.MEDIUM=1]="MEDIUM",_[_.LONG=2]="LONG"})(v=e.Verbosity||(e.Verbosity={}));var S;(function(_){_[_.EXPLICIT=1]="EXPLICIT",_[_.AUTO=2]="AUTO",_[_.FOCUS_CHANGE=3]="FOCUS_CHANGE",_[_.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(S=e.SaveReason||(e.SaveReason={}));var P;(function(_){_[_.None=0]="None",_[_.Readonly=2]="Readonly",_[_.Untitled=4]="Untitled",_[_.Singleton=8]="Singleton",_[_.RequiresTrust=16]="RequiresTrust",_[_.CanSplitInGroup=32]="CanSplitInGroup"})(P=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class E extends k.Disposable{}e.AbstractEditorInput=E;function s(_){return _ instanceof E}e.isEditorInput=s;function a(_){const w=_;return I.URI.isUri(w?.preferredResource)}function p(_){const w=_;return s(w?.primary)&&s(w?.secondary)}e.isSideBySideEditorInput=p;function t(_){const w=_;return s(w?.modified)&&s(w?.original)}e.isDiffEditorInput=t;function o(_){return s(_?.editor)}e.isEditorInputWithOptions=o;function r(_){const w=_;return o(_)&&w?.group!==void 0}e.isEditorInputWithOptionsAndGroup=r;function i(_){const w=_;return typeof w?.groupId=="number"&&s(w.editor)}e.isEditorIdentifier=i;var h;(function(_){_[_.PRIMARY=1]="PRIMARY",_[_.SECONDARY=2]="SECONDARY",_[_.BOTH=3]="BOTH"})(h=e.SideBySideEditor||(e.SideBySideEditor={}));class c{getOriginalUri(w,F){if(!w)return;if(F?.supportSideBySide){const{primary:G,secondary:K}=this.getSideEditors(w);if(G&&K){if(F?.supportSideBySide===h.BOTH)return{primary:this.getOriginalUri(G,{filterByScheme:F.filterByScheme}),secondary:this.getOriginalUri(K,{filterByScheme:F.filterByScheme})};w=F.supportSideBySide===h.PRIMARY?G:K}}if(u(w)||f(w))return;const N=a(w)?w.preferredResource:w.resource;return!N||!F||!F.filterByScheme?N:this.filterUri(N,F.filterByScheme)}getSideEditors(w){return p(w)||f(w)?{primary:w.primary,secondary:w.secondary}:t(w)||u(w)?{primary:w.modified,secondary:w.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(w,F){if(!w)return;if(F?.supportSideBySide){const{primary:G,secondary:K}=this.getSideEditors(w);if(G&&K){if(F?.supportSideBySide===h.BOTH)return{primary:this.getCanonicalUri(G,{filterByScheme:F.filterByScheme}),secondary:this.getCanonicalUri(K,{filterByScheme:F.filterByScheme})};w=F.supportSideBySide===h.PRIMARY?G:K}}if(u(w)||f(w))return;const N=w.resource;return!N||!F||!F.filterByScheme?N:this.filterUri(N,F.filterByScheme)}filterUri(w,F){if(Array.isArray(F)){if(F.some(N=>w.scheme===N))return w}else if(F===w.scheme)return w}}e.EditorResourceAccessor=new c;var d;(function(_){_[_.LEFT=0]="LEFT",_[_.RIGHT=1]="RIGHT"})(d=e.CloseDirection||(e.CloseDirection={}));class b{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(w){const F=this.instantiationService=w.get(R.IInstantiationService);for(const[N,G]of this.editorSerializerConstructors)this.createEditorSerializer(N,G,F);this.editorSerializerConstructors.clear()}createEditorSerializer(w,F,N){const G=N.createInstance(F);this.editorSerializerInstances.set(w,G)}registerFileEditorFactory(w){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=w}getFileEditorFactory(){return(0,L.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(w,F){if(this.editorSerializerConstructors.has(w)||this.editorSerializerInstances.has(w))throw new Error(`A editor serializer with type ID '${w}' was already registered.`);return this.instantiationService?this.createEditorSerializer(w,F,this.instantiationService):this.editorSerializerConstructors.set(w,F),(0,k.toDisposable)(()=>{this.editorSerializerConstructors.delete(w),this.editorSerializerInstances.delete(w)})}getEditorSerializer(w){return this.editorSerializerInstances.get(typeof w=="string"?w:w.typeId)}}D.Registry.add(e.EditorExtensions.EditorFactory,new b);async function y(_,w){if(!_||!_.length)return[];const F=await Promise.all(_.map(async N=>{const G=I.URI.revive(N.fileUri);if(!G||(await w.activateProvider(G.scheme),!w.canHandleResource(G)))return;const K=typeof N.exists=="boolean"?N.exists:await w.exists(G);if(!K&&N.openOnlyIfExists)return;const U={selection:K?N.selection:void 0,pinned:!0,override:N.editorOverrideId};let z;return K?z={resource:G,options:U}:z={resource:G,options:U,forceUntitled:!0},z}));return(0,T.coalesce)(F)}e.pathsToEditors=y;var g;(function(_){_[_.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",_[_.SEQUENTIAL=1]="SEQUENTIAL"})(g=e.EditorsOrder||(e.EditorsOrder={}))}),define(me[209],ge([0,1,3,62,172,4,6,24,35,17,57,25,47,198]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,f.registerIcon)("default-view-icon",u.Codicon.window,(0,I.localize)(0,null));var l;(function(h){h.ViewContainersRegistry="workbench.registry.view.containers",h.ViewsRegistry="workbench.registry.view"})(l=e.Extensions||(e.Extensions={}));var v;(function(h){h[h.Sidebar=0]="Sidebar",h[h.Panel=1]="Panel"})(v=e.ViewContainerLocation||(e.ViewContainerLocation={}));function S(h){switch(h){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=S;function P(h){return`viewContainer.${h}.enabled`}e.getEnabledViewContainerContextKey=P;class E extends R.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new m.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new m.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,T.flatten)([...this.viewContainers.values()])}registerViewContainer(c,d,b){const y=this.get(c.id);if(y)return y;const g=c;return g.openCommandActionDescriptor=b?.donotRegisterOpenCommand?void 0:g.openCommandActionDescriptor??{id:g.id},(0,C.getOrSet)(this.viewContainers,d,[]).push(g),b?.isDefault&&this.defaultViewContainers.push(g),this._onDidRegister.fire({viewContainer:g,viewContainerLocation:d}),g}deregisterViewContainer(c){for(const d of this.viewContainers.keys()){const b=this.viewContainers.get(d),y=b?.indexOf(c);if(y!==-1){b?.splice(y,1),b.length===0&&this.viewContainers.delete(d),this._onDidDeregister.fire({viewContainer:c,viewContainerLocation:d});return}}}get(c){return this.all.filter(d=>d.id===c)[0]}getViewContainers(c){return[...this.viewContainers.get(c)||[]]}getViewContainerLocation(c){return[...this.viewContainers.keys()].filter(d=>this.getViewContainers(d).filter(b=>b?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.defaultViewContainers.find(d=>this.getViewContainerLocation(d)===c)}}D.Registry.add(l.ViewContainersRegistry,new E);var s;(function(h){h.Open="2_open",h.Debug="4_debug",h.SCM="5_scm",h.More="9_more"})(s=e.ViewContentGroups||(e.ViewContentGroups={}));function a(h,c){const d=h.group??s.More,b=c.group??s.More;return d!==b?d.localeCompare(b):(h.order??5)-(c.order??5)}class p extends R.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new m.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new m.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new m.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new m.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new n.SetMap}registerViews(c,d){this.registerViews2([{views:c,viewContainer:d}])}registerViews2(c){c.forEach(({views:d,viewContainer:b})=>this.addViews(d,b)),this._onViewsRegistered.fire(c)}deregisterViews(c,d){const b=this.removeViews(c,d);b.length&&this._onViewsDeregistered.fire({views:b,viewContainer:d})}moveViews(c,d){for(const b of this._views.keys())if(b!==d){const y=this.removeViews(c,b);y.length&&(this.addViews(y,d),this._onDidChangeContainer.fire({views:y,from:b,to:d}))}}getViews(c){return this._views.get(c)||[]}getView(c){for(const d of this._viewContainers){const b=(this._views.get(d)||[]).filter(y=>y.id===c)[0];if(b)return b}return null}getViewContainer(c){for(const d of this._viewContainers)if((this._views.get(d)||[]).filter(y=>y.id===c)[0])return d;return null}registerViewWelcomeContent(c,d){return this._viewWelcomeContents.add(c,d),this._onDidChangeViewWelcomeContent.fire(c),(0,R.toDisposable)(()=>{this._viewWelcomeContents.delete(c,d),this._onDidChangeViewWelcomeContent.fire(c)})}registerViewWelcomeContent2(c,d){const b=new Map;for(const[y,g]of d)this._viewWelcomeContents.add(c,g),b.set(y,(0,R.toDisposable)(()=>{this._viewWelcomeContents.delete(c,g),this._onDidChangeViewWelcomeContent.fire(c)}));return this._onDidChangeViewWelcomeContent.fire(c),b}getViewWelcomeContent(c){const d=[];return this._viewWelcomeContents.forEach(c,b=>d.push(b)),d.sort(a)}addViews(c,d){let b=this._views.get(d);b||(b=[],this._views.set(d,b),this._viewContainers.push(d));for(const y of c){if(this.getView(y.id)!==null)throw new Error((0,I.localize)(1,null,y.id));b.push(y)}}removeViews(c,d){const b=this._views.get(d);if(!b)return[];const y=[],g=[];for(const _ of b)c.includes(_)?y.push(_):g.push(_);return y.length&&(g.length?this._views.set(d,g):(this._views.delete(d),this._viewContainers.splice(this._viewContainers.indexOf(d),1))),y}}D.Registry.add(l.ViewsRegistry,new p),e.IViewsService=(0,k.createDecorator)("viewsService"),e.FocusedViewContext=new L.RawContextKey("focusedView","",(0,I.localize)(2,null));function t(h){return`view.${h}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,k.createDecorator)("viewDescriptorService");var o;(function(h){h[h.Default=0]="Default",h[h.Expand=1]="Expand"})(o=e.ViewVisibilityState||(e.ViewVisibilityState={}));var r;(function(h){h[h.None=0]="None",h[h.Collapsed=1]="Collapsed",h[h.Expanded=2]="Expanded"})(r=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class i{constructor(c,d){this.resolved=!1,this._hasResolve=!1,(0,A.mixin)(this,c),this._hasResolve=!!d,this.resolve=async b=>{if(d&&!this.resolved){const y=await d(b);y&&(this.tooltip=this.tooltip??y.tooltip,this.command=this.command??y.command)}b.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(me[124],ge([0,1,3,18,173]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class k{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new m.Emitter,this._onExit=new m.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(C){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=C}onEvent(C){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=C}onRequest(C){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=C}sendResponse(C){C.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${C.command}`)):this.internalSend("response",C)}sendRequest(C,D,T,n){const A={command:C};if(D&&Object.keys(D).length>0&&(A.arguments=D),this.internalSend("request",A),typeof n=="number"){const u=setTimeout(()=>{clearTimeout(u);const f=this.pendingRequests.get(A.seq);if(f){this.pendingRequests.delete(A.seq);const l={type:"response",seq:0,request_seq:A.seq,success:!1,command:C,message:(0,I.localize)(0,null,n,C)};f(l)}},n)}return T&&this.pendingRequests.set(A.seq,T),A.seq}acceptMessage(C){this.messageCallback?this.messageCallback(C):(this.queue.push(C),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(C,D){return C.type!=="event"||D.type!=="event"}async processQueue(){let C;for(;this.queue.length;){if((!C||this.needsTaskBoundaryBetween(this.queue[0],C))&&await(0,L.timeout)(0),C=this.queue.shift(),!C)return;switch(C.type){case"event":this.eventCallback&&this.eventCallback(C);break;case"request":this.requestCallback&&this.requestCallback(C);break;case"response":const D=C,T=this.pendingRequests.get(D.request_seq);T&&(this.pendingRequests.delete(D.request_seq),T(D));break}}}internalSend(C,D){D.type=C,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const C=new Map;this.pendingRequests.forEach((D,T)=>C.set(T,D)),await(0,L.timeout)(500),C.forEach((D,T)=>{D({type:"response",seq:0,request_seq:T,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(T)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=k}),define(me[210],ge([0,1,9,2,8,25,10]),function(J,e,m,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const C=/{([^}]+)}/g;function D(r,i,h){return r.replace(C,function(c,d){return i&&d.length>0&&d[0]!=="_"?c:h&&h.hasOwnProperty(d)?h[d]:c})}e.formatPII=D;function T(r){const i={};for(const h of Object.keys(r))h.startsWith("!")||(i[h]=r[h]);return i}e.filterExceptionsFromTelemetry=T;function n(r){return r.configuration.request==="attach"&&!A(r)&&(!r.parentSession||n(r.parentSession))}e.isSessionAttach=n;function A(r){let i=r.configuration.type;if(!!i)return i==="vslsShare"&&(i=r.configuration.adapterProxy.configuration.type),(0,m.equalsIgnoreCase)(i,"extensionhost")||(0,m.equalsIgnoreCase)(i,"pwa-extensionhost")?r:r.parentSession?A(r.parentSession):void 0}e.getExtensionHostDebugSession=A;function u(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=u;function f(r,i,h){let c,d=0,b=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,y=null;for(;y=b.exec(r);){let g=y.index+1,_=g+y[0].length;if(g<=i&&_>=h){c=y[0],d=g;break}}if(c){let g=/\w+/g,_=null;for(;(_=g.exec(c))&&!(_.index+1+d+_[0].length>=h););_&&(c=c.substring(0,g.lastIndex))}return c?{start:d,end:d+c.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=f;const l=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function v(r){return!!(r&&r.match(l))}e.isUri=v;function S(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(v(r.path))return L.URI.parse(r.path);if((0,I.isAbsolute)(r.path))return L.URI.file(r.path)}return r.path}function P(r){if(typeof r.path=="object"){const i=L.URI.revive(r.path);if(i)return i.scheme===R.Schemas.file?i.fsPath:i.toString()}return r.path}function E(r,i){const h=i?S:P,c=(0,k.deepClone)(r);return a(c,(d,b)=>{d&&b&&(b.path=h(b))}),c}e.convertToDAPaths=E;function s(r,i){const h=i?S:P,c=(0,k.deepClone)(r);return a(c,(d,b)=>{!d&&b&&(b.path=h(b))}),c}e.convertToVSCPaths=s;function a(r,i){switch(r.type){case"event":const h=r;switch(h.event){case"output":i(!1,h.body.source);break;case"loadedSource":i(!1,h.body.source);break;case"breakpoint":i(!1,h.body.breakpoint.source);break;default:break}break;case"request":const c=r;switch(c.command){case"setBreakpoints":i(!0,c.arguments.source);break;case"breakpointLocations":i(!0,c.arguments.source);break;case"source":i(!0,c.arguments.source);break;case"gotoTargets":i(!0,c.arguments.source);break;case"launchVSCode":c.arguments.args.forEach(b=>i(!1,b));break;default:break}break;case"response":const d=r;if(d.success&&d.body)switch(d.command){case"stackTrace":d.body.stackFrames.forEach(b=>i(!1,b.source));break;case"loadedSources":d.body.sources.forEach(b=>i(!1,b));break;case"scopes":d.body.scopes.forEach(b=>i(!1,b.source));break;case"setFunctionBreakpoints":d.body.breakpoints.forEach(b=>i(!1,b.source));break;case"setBreakpoints":d.body.breakpoints.forEach(b=>i(!1,b.source));break;default:break}break}}function p(r){return r.filter(i=>!i.presentation?.hidden).sort((i,h)=>i.presentation?h.presentation?i.presentation.group?h.presentation.group?i.presentation.group!==h.presentation.group?i.presentation.group.localeCompare(h.presentation.group):t(i.presentation.order,h.presentation.order):-1:h.presentation.group?1:t(i.presentation.order,h.presentation.order):-1:h.presentation?1:0)}e.getVisibleAndSorted=p;function t(r,i){return typeof r!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:r-i}async function o(r,i){const h=r.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorMode});if(h!=="none"&&(await i.saveAll(),h==="allEditorsInActiveGroup")){const c=i.activeEditorPane;c&&await i.save({editor:c.input,groupId:c.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=o}),define(me[211],ge([0,1,28,39,174,125,8,9,25,11,184,124]),function(J,e,m,L,I,k,R,C,D,T,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class u extends A.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(E,s){this.outputStream=s,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,E.on("data",a=>this.handleData(a))}sendMessage(E){if(this.outputStream){const s=JSON.stringify(E);this.outputStream.write(`Content-Length: ${Buffer.byteLength(s,"utf8")}${u.TWO_CRLF}${s}`,"utf8")}}handleData(E){for(this.rawData=Buffer.concat([this.rawData,E]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const s=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,s.length>0)try{this.acceptMessage(JSON.parse(s))}catch(a){this._onError.fire(new Error((a.message||a)+`
`+s))}continue}}else{const s=this.rawData.indexOf(u.TWO_CRLF);if(s!==-1){const p=this.rawData.toString("utf8",0,s).split(u.HEADER_LINESEPARATOR);for(const t of p){const o=t.split(u.HEADER_FIELDSEPARATOR);o[0]==="Content-Length"&&(this.contentLength=Number(o[1]))}this.rawData=this.rawData.slice(s+u.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=u,u.TWO_CRLF=`\r
\r
`,u.HEADER_LINESEPARATOR=/\r?\n/,u.HEADER_FIELDSEPARATOR=/: */;class f extends u{startSession(){return new Promise((E,s)=>{let a=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),E(),a=!0}),this.socket.on("close",()=>{a?this._onError.fire(new Error("connection closed")):s(new Error("connection closed"))}),this.socket.on("error",p=>{a?this._onError.fire(p):s(p)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=f;class l extends f{constructor(E){super();this.adapterServer=E}createConnection(E){return k.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",E)}}e.SocketDebugAdapter=l;class v extends f{constructor(E){super();this.adapterServer=E}createConnection(E){return k.createConnection(this.adapterServer.path,E)}}e.NamedPipeDebugAdapter=v;class S extends u{constructor(E,s,a){super();this.adapterExecutable=E,this.debugType=s,this.outputService=a}async startSession(){const E=this.adapterExecutable.command,s=this.adapterExecutable.args,a=this.adapterExecutable.options||{};try{if(E)if(R.isAbsolute(E)){if(!await m.Promises.exists(E))throw new Error(I.localize(0,null,E))}else E.indexOf("/")<0&&E.indexOf("\\")<0;else throw new Error(I.localize(1,null,this.debugType));let p=process.env;if(a.env&&Object.keys(a.env).length>0&&(p=D.mixin(D.deepClone(process.env),a.env)),E==="node")if(Array.isArray(s)&&s.length>0){const o=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,r={env:p,execArgv:o?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};a.cwd&&(r.cwd=a.cwd);const i=L.fork(s[0],s.slice(1),r);if(!i.pid)throw new Error(I.localize(2,null,s[0]));this.serverProcess=i}else throw new Error(I.localize(3,null));else{const o={env:p};a.cwd&&(o.cwd=a.cwd),this.serverProcess=L.spawn(E,s,o)}this.serverProcess.on("error",o=>{this._onError.fire(o)}),this.serverProcess.on("exit",(o,r)=>{this._onExit.fire(o)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",o=>{this._onError.fire(o)}),this.serverProcess.stdin.on("error",o=>{this._onError.fire(o)});const t=this.outputService;if(t){const o=r=>r.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",r=>{const i=t.getChannel(n.ExtensionsChannelId);i&&i.append(o(r))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(p){this._onError.fire(p)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),T.isWindows?new Promise((E,s)=>{const a=L.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(p,t,o){if(p)return s(p)});a.on("exit",E),a.on("error",s)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(E,s){if(!E)return;const a=Object.create(null);E.runtime&&(E.runtime.indexOf("./")===0?a.runtime=R.join(s,E.runtime):a.runtime=E.runtime),E.runtimeArgs&&(a.runtimeArgs=E.runtimeArgs),E.program&&(R.isAbsolute(E.program)?a.program=E.program:a.program=R.join(s,E.program)),E.args&&(a.args=E.args);const p=E;return p.win&&(a.win=S.extract(p.win,s)),p.winx86&&(a.winx86=S.extract(p.winx86,s)),p.windows&&(a.windows=S.extract(p.windows,s)),p.osx&&(a.osx=S.extract(p.osx,s)),p.linux&&(a.linux=S.extract(p.linux,s)),a}static platformAdapterExecutable(E,s){let a=Object.create(null);s=s.toLowerCase();for(const h of E)if(h.contributes){const c=h.contributes.debuggers;c&&c.length>0&&c.filter(d=>typeof d.type=="string"&&C.equalsIgnoreCase(d.type,s)).forEach(d=>{const b=S.extract(d,h.extensionLocation.fsPath);a=D.mixin(a,b,h.isBuiltin)})}let p;T.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?p=a.winx86||a.win||a.windows:T.isWindows?p=a.win||a.windows:T.isMacintosh?p=a.osx:T.isLinux&&(p=a.linux),p=p||a;let t=p.program||a.program;const o=p.args||a.args;let r=p.runtime||a.runtime;const i=p.runtimeArgs||a.runtimeArgs;if(r)return{type:"executable",command:r,args:(i||[]).concat(typeof t=="string"?[t]:[]).concat(o||[])};if(t)return{type:"executable",command:t,args:o||[]}}}e.ExecutableDebugAdapter=S}),define(me[212],ge([0,1,39,11,29,187]),function(J,e,m,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function R(u,f){return new Promise((l,v)=>{let S="";const P=m.spawn(u,f);P.pid&&P.stdout.on("data",E=>{S+=E.toString()}),P.on("error",E=>{v(E)}),P.on("close",E=>{l(S)})})}let C;function D(u,f){if(!C)if(L.isWindows)C=new k.WindowsExternalTerminalService;else if(L.isMacintosh)C=new k.MacExternalTerminalService;else if(L.isLinux)C=new k.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const l=f.getConfiguration("terminal");return C.runInTerminal(u.title,u.cwd,u.args,u.env||{},l.external||{})}e.runInExternalTerminal=D;function T(u){return u?L.isWindows?new Promise(async f=>{(await new Promise((v,S)=>{J(["windows-process-tree"],v,S)})).getProcessTree(u,v=>{f(v.children.length>0)})}):R("/usr/bin/pgrep",["-lP",String(u)]).then(f=>{const l=f.trim();return!(l.length===0||l.indexOf(" tmux")>=0)},f=>!0):Promise.resolve(!0)}e.hasChildProcesses=T;var n;(function(u){u[u.cmd=0]="cmd",u[u.powershell=1]="powershell",u[u.bash=2]="bash"})(n||(n={}));function A(u,f,l,v){u=u.trim().toLowerCase();let S;u.indexOf("powershell")>=0||u.indexOf("pwsh")>=0?S=1:u.indexOf("cmd.exe")>=0?S=0:u.indexOf("bash")>=0?S=2:L.isWindows?S=0:S=2;let P,E=" ";switch(S){case 1:if(P=a=>(a=a.replace(/\'/g,"''"),a.length>0&&a.charAt(a.length-1)==="\\"?`'${a}\\'`:`'${a}'`),l){const a=(0,I.getDriveLetter)(l);a&&(E+=`${a}:; `),E+=`cd ${P(l)}; `}if(v)for(let a in v){const p=v[a];p===null?E+=`Remove-Item env:${a}; `:E+=`\${env:${a}}='${p}'; `}if(f.length>0){const a=P(f.shift());E+=a[0]==="'"?`& ${a} `:`${a} `;for(let p of f)E+=`${P(p)} `}break;case 0:if(P=a=>(a=a.replace(/\"/g,'""'),a.indexOf(" ")>=0||a.indexOf('"')>=0||a.length===0?`"${a}"`:a),l){const a=(0,I.getDriveLetter)(l);a&&(E+=`${a}: && `),E+=`cd ${P(l)} && `}if(v){E+='cmd /C "';for(let a in v){let p=v[a];p===null?E+=`set "${a}=" && `:(p=p.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),E+=`set "${a}=${p}" && `)}}for(let a of f)E+=`${P(a)} `;v&&(E+='"');break;case 2:P=a=>(a=a.replace(/(["'\\\$])/g,"\\$1"),a.indexOf(" ")>=0||a.indexOf(";")>=0||a.length===0?`"${a}"`:a);const s=a=>/[^\w@%\/+=,.:^-]/.test(a)?`'${a.replace(/'/g,"'\\''")}'`:a;if(l&&(E+=`cd ${P(l)} ; `),v){E+="/usr/bin/env";for(let a in v){const p=v[a];p===null?E+=` -u ${s(a)}`:E+=` ${s(`${a}=${p}`)}`}E+=" "}for(let a of f)E+=`${P(a)} `;break}return E}e.prepareCommand=A}),define(me[126],ge([0,1,30,102,10,8,11,62]),function(J,e,m,L,I,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var D;(function(g){g[g.Markup=1]="Markup",g[g.Code=2]="Code"})(D=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",L.Mimes.markdown,"image/png","image/jpeg",L.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[L.Mimes.markdown,"application/json",L.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var T;(function(g){g[g.Running=1]="Running",g[g.Idle=2]="Idle"})(T=e.NotebookRunState||(e.NotebookRunState={}));var n;(function(g){g[g.Pending=2]="Pending",g[g.Executing=3]="Executing"})(n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var A;(function(g){g[g.WithHardKernelDependency=0]="WithHardKernelDependency",g[g.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",g[g.Pure=2]="Pure",g[g.Never=3]="Never"})(A=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var u;(function(g){g.Always="always",g.Never="never",g.Optional="optional"})(u=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var f;(function(g){g[g.ModelChange=1]="ModelChange",g[g.Move=2]="Move",g[g.ChangeLanguage=5]="ChangeLanguage",g[g.Initialize=6]="Initialize",g[g.ChangeCellMetadata=7]="ChangeCellMetadata",g[g.Output=8]="Output",g[g.OutputItem=9]="OutputItem",g[g.ChangeCellContent=10]="ChangeCellContent",g[g.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",g[g.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",g[g.ChangeCellMime=13]="ChangeCellMime",g[g.Unknown=100]="Unknown"})(f=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var l;(function(g){g[g.Handle=0]="Handle",g[g.Index=1]="Index"})(l=e.SelectionStateType||(e.SelectionStateType={}));var v;(function(g){g[g.Replace=1]="Replace",g[g.Output=2]="Output",g[g.Metadata=3]="Metadata",g[g.CellLanguage=4]="CellLanguage",g[g.DocumentMetadata=5]="DocumentMetadata",g[g.Move=6]="Move",g[g.OutputItems=7]="OutputItems",g[g.PartialMetadata=8]="PartialMetadata",g[g.PartialInternalMetadata=9]="PartialInternalMetadata"})(v=e.CellEditType||(e.CellEditType={}));var S;(function(g){g.scheme=I.Schemas.vscodeNotebookCell;const _=/^ch(\d{7,})/;function w(U,z){return U.with({scheme:g.scheme,fragment:`ch${z.toString().padStart(7,"0")}${U.scheme!==I.Schemas.file?U.scheme:""}`})}g.generate=w;function F(U){if(U.scheme!==g.scheme)return;const z=_.exec(U.fragment);return z?{handle:Number(z[1]),notebook:U.with({scheme:U.fragment.substr(z[0].length)||I.Schemas.file,fragment:null})}:void 0}g.parse=F;function N(U){if(U.scheme!==I.Schemas.vscodeNotebookCellMetadata)return;const z=_.exec(U.fragment);return z?{handle:Number(z[1]),notebook:U.with({scheme:U.fragment.substr(z[0].length)||I.Schemas.file,fragment:null})}:void 0}g.parseCellMetadataUri=N;function G(U,z,O){return U.with({scheme:O,fragment:`ch${z.toString().padStart(7,"0")}${U.scheme!==I.Schemas.file?U.scheme:""}`})}g.generateCellUri=G;function K(U,z){if(U.scheme!==z)return;const O=_.exec(U.fragment);return O?{handle:Number(O[1]),notebook:U.with({scheme:U.fragment.substr(O[0].length)||I.Schemas.file,fragment:null})}:void 0}g.parseCellUri=K})(S=e.CellUri||(e.CellUri={}));const P=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[L.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[L.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function E(g){return P.get(g)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=E;function s(g){return P.get(g)?.supportedByCore??!1}e.mimeTypeSupportedByCore=s;function a(g){return P.get(g)?.mergeable??!1}e.mimeTypeIsMergeable=a;function p(g,_){return R.isWindows&&(g=g.replace(/\//g,"\\"),_=_.replace(/\//g,"\\")),m.match(g,_)}function t(g,_,w){let F=0;for(let N=0;N<_.length;N++){if(p(_[N],g))return F;F++}for(let N=0;N<w.length;N++){if(p(w[N],g))return F;F++}return F}function o(g,_,w){return g.sort((F,N)=>t(F,_,w)-t(N,_,w))}e.sortMimeTypes=o;function r(g,_,w,F=(N,G)=>N===G){const N=[];function G(z,O,B){if(O===0&&B.length===0)return;const x=N[N.length-1];x&&x.start+x.deleteCount===z?(x.deleteCount+=O,x.toInsert.push(...B)):N.push({start:z,deleteCount:O,toInsert:B})}let K=0,U=0;for(;;){if(K===g.length){G(K,0,_.slice(U));break}if(U===_.length){G(K,g.length-K,[]);break}const z=g[K],O=_[U];if(F(z,O)){K+=1,U+=1;continue}w(O)?(G(K,1,[]),K+=1):(G(K,0,[O]),U+=1)}return N}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(g){g.default="default",g.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function h(g){const _=g;return!!((typeof _.include=="string"||m.isRelativePattern(_.include))&&(typeof _.exclude=="string"||m.isRelativePattern(_.exclude)))}e.isDocumentExcludePattern=h;function c(g,_,w){if(Array.isArray(g.viewType)&&g.viewType.indexOf(_)>=0||g.viewType===_)return!0;if(g.filenamePattern){let F=h(g.filenamePattern)?g.filenamePattern.include:g.filenamePattern,N=h(g.filenamePattern)?g.filenamePattern.exclude:void 0;if(m.match(F,(0,k.basename)(w.fsPath).toLowerCase()))return!(N&&m.match(N,(0,k.basename)(w.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=c;class d{constructor(_){this.textModel=_}getElements(){const _=new Int32Array(this.textModel.cells.length);for(let w=0;w<this.textModel.cells.length;w++)_[w]=this.textModel.cells[w].getHashValue();return _}}e.CellSequence=d,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var b;(function(g){g[g.Left=1]="Left",g[g.Right=2]="Right"})(b=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class y{static create(_){return`${y._prefix}${_}`}static parse(_){if(_.startsWith(y._prefix))return _.substr(y._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=y,y._prefix="notebook/"}),define(me[213],ge([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var L;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState",I[I.Complete=4]="Complete"})(L=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,m.createDecorator)("INotebookExecutionService")}),define(me[214],ge([0,1,176,4,62]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new I.RawContextKey("customExecutionSupported",!0,m.localize(0,null)),e.ShellExecutionSupportedContext=new I.RawContextKey("shellExecutionSupported",!1,m.localize(1,null)),e.ProcessExecutionSupportedContext=new I.RawContextKey("processExecutionSupported",!1,m.localize(2,null)),e.ITaskService=(0,L.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(me[215],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function m(I){return[...I.entries()]}e.serializeEnvironmentVariableCollection=m;function L(I){return new Map(I)}e.deserializeEnvironmentVariableCollection=L}),define(me[127],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var m;(function(A){A[A.Unset=0]="Unset",A[A.Queued=1]="Queued",A[A.Running=2]="Running",A[A.Passed=3]="Passed",A[A.Failed=4]="Failed",A[A.Skipped=5]="Skipped",A[A.Errored=6]="Errored"})(m=e.TestResultState||(e.TestResultState={}));var L;(function(A){A[A.Run=2]="Run",A[A.Debug=4]="Debug",A[A.Coverage=8]="Coverage",A[A.HasNonDefaultProfile=16]="HasNonDefaultProfile",A[A.HasConfigurable=32]="HasConfigurable"})(L=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var I;(function(A){A[A.Error=0]="Error",A[A.Info=1]="Info"})(I=e.TestMessageType||(e.TestMessageType={}));var k;(function(A){A[A.NotExpandable=0]="NotExpandable",A[A.Expandable=1]="Expandable",A[A.BusyExpanding=2]="BusyExpanding",A[A.Expanded=3]="Expanded"})(k=e.TestItemExpandState||(e.TestItemExpandState={}));const R=(A,u)=>{u.expand!==void 0&&(A.expand=u.expand),u.item!==void 0&&(A.item=A.item?Object.assign(A.item,u.item):u.item)};e.applyTestItemUpdate=R;var C;(function(A){A[A.Function=0]="Function",A[A.Statement=1]="Statement"})(C=e.DetailType||(e.DetailType={}));var D;(function(A){A[A.Add=0]="Add",A[A.Update=1]="Update",A[A.Remove=2]="Remove",A[A.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",A[A.Retire=4]="Retire",A[A.AddTag=5]="AddTag",A[A.RemoveTag=6]="RemoveTag"})(D=e.TestDiffOpType||(e.TestDiffOpType={}));class T{add(u){}update(u){}remove(u,f){}complete(){}}e.IncrementalChangeCollector=T;class n{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(u){const f=this.createChangeCollector();for(const l of u)switch(l[0]){case 0:{const v=l[1];if(v.parent){if(this.items.has(v.parent)){const S=this.items.get(v.parent);S.children.add(v.item.extId);const P=this.createItem(v,S);this.items.set(v.item.extId,P),f.add(P)}}else{const S=this.createItem(v);this.roots.add(S),this.items.set(v.item.extId,S),f.add(S)}v.expand===2&&this.busyControllerCount++;break}case 1:{const v=l[1],S=this.items.get(v.extId);if(!S)break;v.expand!==void 0&&(S.expand===2&&this.busyControllerCount--,v.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(S,v),f.update(S);break}case 2:{const v=this.items.get(l[1]);if(!v)break;v.parent?this.items.get(v.parent).children.delete(v.item.extId):this.roots.delete(v);const S=[[l[1]]];for(;S.length;)for(const P of S.pop()){const E=this.items.get(P);E&&(S.push(E.children),this.items.delete(P),f.remove(E,E!==v),E.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(l[1]);break;case 3:this.updatePendingRoots(l[1]);break;case 5:this._tags.set(l[1].id,l[1]);break;case 6:this._tags.delete(l[1]);break}f.complete()}retireTest(u){}updatePendingRoots(u){this.pendingRootCount+=u}createChangeCollector(){return new T}}e.AbstractIncrementalTestCollection=n}),define(me[89],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var m;(function(k){k.Delimiter="\0"})(m=e.TestIdPathParts||(e.TestIdPathParts={}));var L;(function(k){k[k.IsSame=0]="IsSame",k[k.Disconnected=1]="Disconnected",k[k.IsChild=2]="IsChild",k[k.IsParent=3]="IsParent"})(L=e.TestPosition||(e.TestPosition={}));class I{constructor(R,C=R.length){if(this.path=R,this.viewEnd=C,R.length===0||C<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(R,C,D=R.parent){if(R.id===C)return new I([C]);let T=[R.id];for(let n=D;n&&n.id!==C;n=n.parent)T.push(n.id);return T.push(C),new I(T.reverse())}static isRoot(R){return!R.includes("\0")}static fromString(R){return new I(R.split("\0"))}static join(R,C){return new I([...R.path,C])}static joinToString(R,C){return R.toString()+"\0"+C}static compare(R,C){return R===C?0:C.startsWith(R+"\0")?2:R.startsWith(C+"\0")?3:1}get parentId(){return this.viewEnd>1?new I(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let R=1;R<=this.viewEnd;R++)yield new I(this.path,R)}compare(R){if(typeof R=="string")return I.compare(this.toString(),R);for(let C=0;C<R.viewEnd&&C<this.viewEnd;C++)if(R.path[C]!==this.path[C])return 1;return R.viewEnd>this.viewEnd?2:R.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let R=1;R<this.viewEnd;R++)this.stringifed+="\0",this.stringifed+=this.path[R]}return this.stringifed}}e.TestId=I}),define(me[216],ge([0,1,8,34,13,25,11,79,177]),function(J,e,m,L,I,k,R,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class T{constructor(A,u,f){this._contributedVariables=new Map,this._context=A,this._labelService=u,f&&(this._envVariablesPromise=f.then(l=>this.prepareEnv(l)))}prepareEnv(A){if(R.isWindows){const u=Object.create(null);return Object.keys(A).forEach(f=>{u[f.toLowerCase()]=A[f]}),u}return A}resolveWithEnvironment(A,u,f){return this.recursiveResolve(this.prepareEnv(A),u?u.uri:void 0,f)}async resolveAsync(A,u){return this.recursiveResolve(await this._envVariablesPromise,A?A.uri:void 0,u)}async resolveAnyBase(A,u,f,l){const v=k.deepClone(u);return R.isWindows&&v.windows?Object.keys(v.windows).forEach(S=>v[S]=v.windows[S]):R.isMacintosh&&v.osx?Object.keys(v.osx).forEach(S=>v[S]=v.osx[S]):R.isLinux&&v.linux&&Object.keys(v.linux).forEach(S=>v[S]=v.linux[S]),delete v.windows,delete v.osx,delete v.linux,this.recursiveResolve(await this._envVariablesPromise,A?A.uri:void 0,v,f,l)}async resolveAnyAsync(A,u,f){return this.resolveAnyBase(A,u,f)}async resolveAnyMap(A,u,f){const l=new Map;return{newConfig:await this.resolveAnyBase(A,u,f,l),resolvedVariables:l}}resolveWithInteractionReplace(A,u,f,l){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(A,u,f,l){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(A,u){if(this._contributedVariables.has(A))throw new Error("Variable "+A+" is contributed twice.");this._contributedVariables.set(A,u)}recursiveResolve(A,u,f,l,v){if(I.isString(f))return this.resolveString(A,u,f,l,v);if(I.isArray(f))return f.map(S=>this.recursiveResolve(A,u,S,l,v));if(I.isObject(f)){let S=Object.create(null);return Object.keys(f).forEach(P=>{const E=this.resolveString(A,u,P,l,v);S[E]=this.recursiveResolve(A,u,f[P],l,v)}),S}return f}resolveString(A,u,f,l,v){return f.replace(T.VARIABLE_REGEXP,(P,E)=>{if(E.includes(T.VARIABLE_LHS))return P;let s=this.evaluateSingleVariable(A,P,E,u,l);return v&&v.set(E,s),s!==P&&I.isString(s)&&s.match(T.VARIABLE_REGEXP)&&(s=this.resolveString(A,u,s,l,v)),s})}fsPath(A){return this._labelService?this._labelService.getUriLabel(A,{noPrefix:!0}):A.fsPath}evaluateSingleVariable(A,u,f,l,v){let S;const P=f.split(":");P.length>1&&(f=P[0],S=P[1]);const E=()=>{const p=this._context.getFilePath();if(p)return p;throw new Error((0,D.localize)(0,null,u))},s=()=>{const p=E();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,D.localize)(1,null,u,m.basename(p)))},a=()=>{if(S){const p=this._context.getFolderUri(S);if(p)return p;throw new Error((0,D.localize)(2,null,u,S))}if(l)return l;throw this._context.getWorkspaceFolderCount()>1?new Error((0,D.localize)(3,null,u)):new Error((0,D.localize)(4,null,u))};switch(f){case"env":if(S){if(A){const p=A[R.isWindows?S.toLowerCase():S];if(I.isString(p))return p}return""}throw new Error((0,D.localize)(5,null,u));case"config":if(S){const p=this._context.getConfigurationValue(l,S);if(I.isUndefinedOrNull(p))throw new Error((0,D.localize)(6,null,u,S));if(I.isObject(p))throw new Error((0,D.localize)(7,null,u,S));return p}throw new Error((0,D.localize)(8,null,u));case"command":return this.resolveFromMap(u,S,v,"command");case"input":return this.resolveFromMap(u,S,v,"input");default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,C.normalizeDriveLetter)(this.fsPath(a()));case"cwd":return l||S?(0,C.normalizeDriveLetter)(this.fsPath(a())):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return m.basename(this.fsPath(a()));case"lineNumber":const p=this._context.getLineNumber();if(p)return p;throw new Error((0,D.localize)(9,null,u));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,D.localize)(10,null,u));case"file":return E();case"fileWorkspaceFolder":return s();case"relativeFile":return l||S?m.relative(this.fsPath(a()),E()):E();case"relativeFileDirname":const o=m.dirname(E());if(l||S){const c=m.relative(this.fsPath(a()),o);return c.length===0?".":c}return o;case"fileDirname":return m.dirname(E());case"fileExtname":return m.extname(E());case"fileBasename":return m.basename(E());case"fileBasenameNoExtension":const r=m.basename(E());return r.slice(0,r.length-m.extname(r).length);case"fileDirnameBasename":return m.basename(m.dirname(E()));case"execPath":const i=this._context.getExecPath();return i||u;case"execInstallFolder":const h=this._context.getAppRoot();return h||u;case"pathSeparator":return m.sep;default:try{const c=S?`${f}:${S}`:f;return this.resolveFromMap(u,c,v,void 0)}catch(c){return u}}}}resolveFromMap(A,u,f,l){if(u&&f){const v=l===void 0?f[u]:f[l+":"+u];if(typeof v=="string")return v;throw new Error((0,D.localize)(11,null,A))}return A}}e.AbstractVariableResolverService=T,T.VARIABLE_LHS="${",T.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(me[128],ge([0,1,4,208]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,m.createDecorator)("editorGroupsService");var I;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(I=e.GroupDirection||(e.GroupDirection={}));var k;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(k=e.GroupOrientation||(e.GroupOrientation={}));var R;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(R=e.GroupLocation||(e.GroupLocation={}));var C;(function(v){v[v.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",v[v.EVEN=1]="EVEN",v[v.TOGGLE=2]="TOGGLE"})(C=e.GroupsArrangement||(e.GroupsArrangement={}));var D;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(D=e.MergeGroupMode||(e.MergeGroupMode={}));function T(v){const S=v;return(0,L.isEditorInput)(S?.editor)&&(0,L.isEditorInput)(S?.replacement)}e.isEditorReplacement=T;var n;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(n=e.GroupsOrder||(e.GroupsOrder={}));var A;(function(v){v[v.GROUP_ACTIVE=0]="GROUP_ACTIVE",v[v.GROUP_INDEX=1]="GROUP_INDEX",v[v.GROUP_LOCKED=2]="GROUP_LOCKED",v[v.EDITOR_OPEN=3]="EDITOR_OPEN",v[v.EDITOR_CLOSE=4]="EDITOR_CLOSE",v[v.EDITOR_MOVE=5]="EDITOR_MOVE",v[v.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",v[v.EDITOR_LABEL=7]="EDITOR_LABEL",v[v.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",v[v.EDITOR_PIN=9]="EDITOR_PIN",v[v.EDITOR_STICKY=10]="EDITOR_STICKY",v[v.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(A=e.GroupChangeKind||(e.GroupChangeKind={}));var u;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(u=e.OpenEditorContext||(e.OpenEditorContext={}));function f(v){const S=v;return!!S&&typeof S.id=="number"&&Array.isArray(S.editors)}e.isEditorGroup=f;function l(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=l}),define(me[217],ge([0,1,4,128]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,m.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function I(k){const R=k;return typeof k=="number"||(0,L.isEditorGroup)(R)}e.isPreferredGroup=I}),define(me[15],ge([0,1,17,23,99,292,60,25,13,2,41,83,178,117,64,126,89,217,7]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,l,v,S,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(le){function Ee(q){const{selectionStartLineNumber:Ae,selectionStartColumn:Pe,positionLineNumber:Ze,positionColumn:Xe}=q,ot=new E.Position(Ae-1,Pe-1),vt=new E.Position(Ze-1,Xe-1);return new E.Selection(ot,vt)}le.to=Ee;function ce(q){const{anchor:Ae,active:Pe}=q;return{selectionStartLineNumber:Ae.line+1,selectionStartColumn:Ae.character+1,positionLineNumber:Pe.line+1,positionColumn:Pe.character+1}}le.from=ce})(s=e.Selection||(e.Selection={}));var a;(function(le){function Ee(q){if(!q)return;const{start:Ae,end:Pe}=q;return{startLineNumber:Ae.line+1,startColumn:Ae.character+1,endLineNumber:Pe.line+1,endColumn:Pe.character+1}}le.from=Ee;function ce(q){if(!q)return;const{startLineNumber:Ae,startColumn:Pe,endLineNumber:Ze,endColumn:Xe}=q;return new E.Range(Ae-1,Pe-1,Ze-1,Xe-1)}le.to=ce})(a=e.Range||(e.Range={}));var p;(function(le){function Ee(ce){switch(ce){case 1:return E.StandardTokenType.Comment;case 0:return E.StandardTokenType.Other;case 4:return E.StandardTokenType.RegEx;case 2:return E.StandardTokenType.String}}le.to=Ee})(p=e.TokenType||(e.TokenType={}));var t;(function(le){function Ee(q){return new E.Position(q.lineNumber-1,q.column-1)}le.to=Ee;function ce(q){return{lineNumber:q.line+1,column:q.character+1}}le.from=ce})(t=e.Position||(e.Position={}));var o;(function(le){function Ee(q){switch(q){case E.DiagnosticTag.Unnecessary:return 1;case E.DiagnosticTag.Deprecated:return 2}}le.from=Ee;function ce(q){switch(q){case 1:return E.DiagnosticTag.Unnecessary;case 2:return E.DiagnosticTag.Deprecated;default:return}}le.to=ce})(o=e.DiagnosticTag||(e.DiagnosticTag={}));var r;(function(le){function Ee(q){let Ae;return q.code&&((0,D.isString)(q.code)||(0,D.isNumber)(q.code)?Ae=String(q.code):Ae={value:String(q.code.value),target:q.code.target}),{...a.from(q.range),message:q.message,source:q.source,code:Ae,severity:h.from(q.severity),relatedInformation:q.relatedInformation&&q.relatedInformation.map(i.from),tags:Array.isArray(q.tags)?(0,m.coalesce)(q.tags.map(o.from)):void 0}}le.from=Ee;function ce(q){const Ae=new E.Diagnostic(a.to(q),q.message,h.to(q.severity));return Ae.source=q.source,Ae.code=(0,D.isString)(q.code)?q.code:q.code?.value,Ae.relatedInformation=q.relatedInformation&&q.relatedInformation.map(i.to),Ae.tags=q.tags&&(0,m.coalesce)(q.tags.map(o.to)),Ae}le.to=ce})(r=e.Diagnostic||(e.Diagnostic={}));var i;(function(le){function Ee(q){return{...a.from(q.location.range),message:q.message,resource:q.location.uri}}le.from=Ee;function ce(q){return new E.DiagnosticRelatedInformation(new E.Location(q.resource,a.to(q)),q.message)}le.to=ce})(i=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var h;(function(le){function Ee(q){switch(q){case E.DiagnosticSeverity.Error:return f.MarkerSeverity.Error;case E.DiagnosticSeverity.Warning:return f.MarkerSeverity.Warning;case E.DiagnosticSeverity.Information:return f.MarkerSeverity.Info;case E.DiagnosticSeverity.Hint:return f.MarkerSeverity.Hint}return f.MarkerSeverity.Error}le.from=Ee;function ce(q){switch(q){case f.MarkerSeverity.Info:return E.DiagnosticSeverity.Information;case f.MarkerSeverity.Warning:return E.DiagnosticSeverity.Warning;case f.MarkerSeverity.Error:return E.DiagnosticSeverity.Error;case f.MarkerSeverity.Hint:return E.DiagnosticSeverity.Hint;default:return E.DiagnosticSeverity.Error}}le.to=ce})(h=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var c;(function(le){function Ee(q){return typeof q=="number"&&q>=E.ViewColumn.One?q-1:q===E.ViewColumn.Beside?P.SIDE_GROUP:P.ACTIVE_GROUP}le.from=Ee;function ce(q){if(typeof q=="number"&&q>=0)return q+1;throw new Error("invalid 'EditorGroupColumn'")}le.to=ce})(c=e.ViewColumn||(e.ViewColumn={}));function d(le){return typeof le.range!="undefined"}function b(le){return le.length===0?!0:!!d(le[0])}e.isDecorationOptionsArr=b;var y;(function(le){function Ee(Xe){return Xe.map(le.from)}le.fromMany=Ee;function ce(Xe){return Xe&&typeof Xe=="object"&&typeof Xe.language=="string"&&typeof Xe.value=="string"}function q(Xe){let ot;if(ce(Xe)){const{language:dt,value:mt}=Xe;ot={value:"```"+dt+`
`+mt+"\n```\n"}}else E.MarkdownString.isMarkdownString(Xe)?ot={value:Xe.value,isTrusted:Xe.isTrusted,supportThemeIcons:Xe.supportThemeIcons,supportHtml:Xe.supportHtml}:typeof Xe=="string"?ot={value:Xe}:ot={value:""};const vt=Object.create(null);ot.uris=vt;const Et=dt=>{try{let mt=T.URI.parse(dt,!0);mt=mt.with({query:Ae(mt.query,vt)}),vt[dt]=mt}catch(mt){}return""},lt=new k.Renderer;return lt.link=Et,lt.image=dt=>Et(I.parseHrefAndDimensions(dt).href),k(ot.value,{renderer:lt}),ot}le.from=q;function Ae(Xe,ot){if(!Xe)return Xe;let vt;try{vt=(0,R.parse)(Xe)}catch(lt){}if(!vt)return Xe;let Et=!1;return vt=(0,C.cloneAndChange)(vt,lt=>{if(T.URI.isUri(lt)){const dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ot[dt]=lt,Et=!0,dt}else return}),Et?JSON.stringify(vt):Xe}function Pe(Xe){const ot=new E.MarkdownString(Xe.value,Xe.supportThemeIcons);return ot.isTrusted=Xe.isTrusted,ot.supportHtml=Xe.supportHtml,ot}le.to=Pe;function Ze(Xe){if(!!Xe)return typeof Xe=="string"?Xe:le.from(Xe)}le.fromStrict=Ze})(y=e.MarkdownString||(e.MarkdownString={}));function g(le){return b(le)?le.map(Ee=>({range:a.from(Ee.range),hoverMessage:Array.isArray(Ee.hoverMessage)?y.fromMany(Ee.hoverMessage):Ee.hoverMessage?y.from(Ee.hoverMessage):void 0,renderOptions:Ee.renderOptions})):le.map(Ee=>({range:a.from(Ee)}))}e.fromRangeOrRangeWithMessage=g;function _(le){return typeof le=="undefined"?le:typeof le=="string"?T.URI.file(le):le}e.pathOrURIToURI=_;var w;(function(le){function Ee(ce){return typeof ce=="undefined"?ce:{contentText:ce.contentText,contentIconPath:ce.contentIconPath?_(ce.contentIconPath):void 0,border:ce.border,borderColor:ce.borderColor,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,color:ce.color,backgroundColor:ce.backgroundColor,margin:ce.margin,width:ce.width,height:ce.height}}le.from=Ee})(w=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var F;(function(le){function Ee(ce){return typeof ce=="undefined"?ce:{backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?_(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?w.from(ce.before):void 0,after:ce.after?w.from(ce.after):void 0}}le.from=Ee})(F=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var N;(function(le){function Ee(ce){if(typeof ce=="undefined")return ce;switch(ce){case E.DecorationRangeBehavior.OpenOpen:return 0;case E.DecorationRangeBehavior.ClosedClosed:return 1;case E.DecorationRangeBehavior.OpenClosed:return 2;case E.DecorationRangeBehavior.ClosedOpen:return 3}}le.from=Ee})(N=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var G;(function(le){function Ee(ce){return{isWholeLine:ce.isWholeLine,rangeBehavior:ce.rangeBehavior?N.from(ce.rangeBehavior):void 0,overviewRulerLane:ce.overviewRulerLane,light:ce.light?F.from(ce.light):void 0,dark:ce.dark?F.from(ce.dark):void 0,backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?_(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?w.from(ce.before):void 0,after:ce.after?w.from(ce.after):void 0}}le.from=Ee})(G=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var K;(function(le){function Ee(q){return{text:q.newText,eol:q.newEol&&pe.from(q.newEol),range:a.from(q.range)}}le.from=Ee;function ce(q){const Ae=new E.TextEdit(a.to(q.range),q.text);return Ae.newEol=typeof q.eol=="undefined"?void 0:pe.to(q.eol),Ae}le.to=ce})(K=e.TextEdit||(e.TextEdit={}));var U;(function(le){function Ee(q,Ae,Pe){const Ze={edits:[]};if(q instanceof E.WorkspaceEdit)for(let Xe of q._allEntries())if(Xe._type===1)Ze.edits.push({_type:1,oldUri:Xe.from,newUri:Xe.to,options:Xe.options,metadata:Xe.metadata});else if(Xe._type===2){const ot=Ae?.getDocument(Xe.uri);Ze.edits.push({_type:2,resource:Xe.uri,edit:K.from(Xe.edit),modelVersionId:ot?.version,metadata:Xe.metadata})}else Xe._type===3?Ze.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:Xe.edit,notebookMetadata:Xe.notebookMetadata,notebookVersionId:Pe?.getNotebookDocument(Xe.uri,!0)?.apiNotebook.version}):Xe._type===5&&Ze.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,notebookVersionId:Pe?.getNotebookDocument(Xe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Xe.index,count:Xe.count,cells:Xe.cells.map(Qe.from)}});return Ze}le.from=Ee;function ce(q){const Ae=new E.WorkspaceEdit;for(const Pe of q.edits)Pe.edit?Ae.replace(T.URI.revive(Pe.resource),a.to(Pe.edit.range),Pe.edit.text):Ae.renameFile(T.URI.revive(Pe.oldUri),T.URI.revive(Pe.newUri),Pe.options);return Ae}le.to=ce})(U=e.WorkspaceEdit||(e.WorkspaceEdit={}));var z;(function(le){const Ee=Object.create(null);Ee[E.SymbolKind.File]=0,Ee[E.SymbolKind.Module]=1,Ee[E.SymbolKind.Namespace]=2,Ee[E.SymbolKind.Package]=3,Ee[E.SymbolKind.Class]=4,Ee[E.SymbolKind.Method]=5,Ee[E.SymbolKind.Property]=6,Ee[E.SymbolKind.Field]=7,Ee[E.SymbolKind.Constructor]=8,Ee[E.SymbolKind.Enum]=9,Ee[E.SymbolKind.Interface]=10,Ee[E.SymbolKind.Function]=11,Ee[E.SymbolKind.Variable]=12,Ee[E.SymbolKind.Constant]=13,Ee[E.SymbolKind.String]=14,Ee[E.SymbolKind.Number]=15,Ee[E.SymbolKind.Boolean]=16,Ee[E.SymbolKind.Array]=17,Ee[E.SymbolKind.Object]=18,Ee[E.SymbolKind.Key]=19,Ee[E.SymbolKind.Null]=20,Ee[E.SymbolKind.EnumMember]=21,Ee[E.SymbolKind.Struct]=22,Ee[E.SymbolKind.Event]=23,Ee[E.SymbolKind.Operator]=24,Ee[E.SymbolKind.TypeParameter]=25;function ce(Ae){return typeof Ee[Ae]=="number"?Ee[Ae]:6}le.from=ce;function q(Ae){for(const Pe in Ee)if(Ee[Pe]===Ae)return Number(Pe);return E.SymbolKind.Property}le.to=q})(z=e.SymbolKind||(e.SymbolKind={}));var O;(function(le){function Ee(q){switch(q){case E.SymbolTag.Deprecated:return 1}}le.from=Ee;function ce(q){switch(q){case 1:return E.SymbolTag.Deprecated}}le.to=ce})(O=e.SymbolTag||(e.SymbolTag={}));var B;(function(le){function Ee(q){return{name:q.name,kind:z.from(q.kind),tags:q.tags&&q.tags.map(O.from),containerName:q.containerName,location:Q.from(q.location)}}le.from=Ee;function ce(q){const Ae=new E.SymbolInformation(q.name,z.to(q.kind),q.containerName,Q.to(q.location));return Ae.tags=q.tags&&q.tags.map(O.to),Ae}le.to=ce})(B=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var x;(function(le){function Ee(q){const Ae={name:q.name||"!!MISSING: name!!",detail:q.detail,range:a.from(q.range),selectionRange:a.from(q.selectionRange),kind:z.from(q.kind),tags:q.tags?.map(O.from)??[]};return q.children&&(Ae.children=q.children.map(Ee)),Ae}le.from=Ee;function ce(q){const Ae=new E.DocumentSymbol(q.name,q.detail,z.to(q.kind),a.to(q.range),a.to(q.selectionRange));return(0,m.isNonEmptyArray)(q.tags)&&(Ae.tags=q.tags.map(O.to)),q.children&&(Ae.children=q.children.map(ce)),Ae}le.to=ce})(x=e.DocumentSymbol||(e.DocumentSymbol={}));var M;(function(le){function Ee(q){const Ae=new E.CallHierarchyItem(z.to(q.kind),q.name,q.detail||"",T.URI.revive(q.uri),a.to(q.range),a.to(q.selectionRange));return Ae._sessionId=q._sessionId,Ae._itemId=q._itemId,Ae}le.to=Ee;function ce(q,Ae,Pe){if(Ae=Ae??q._sessionId,Pe=Pe??q._itemId,Ae===void 0||Pe===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Pe,name:q.name,detail:q.detail,kind:z.from(q.kind),uri:q.uri,range:a.from(q.range),selectionRange:a.from(q.selectionRange),tags:q.tags?.map(O.from)}}le.from=ce})(M=e.CallHierarchyItem||(e.CallHierarchyItem={}));var H;(function(le){function Ee(ce){return new E.CallHierarchyIncomingCall(M.to(ce.from),ce.fromRanges.map(q=>a.to(q)))}le.to=Ee})(H=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var W;(function(le){function Ee(ce){return new E.CallHierarchyOutgoingCall(M.to(ce.to),ce.fromRanges.map(q=>a.to(q)))}le.to=Ee})(W=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Q;(function(le){function Ee(q){return{range:q.range&&a.from(q.range),uri:q.uri}}le.from=Ee;function ce(q){return new E.Location(T.URI.revive(q.uri),a.to(q.range))}le.to=ce})(Q=e.location||(e.location={}));var X;(function(le){function Ee(q){const Ae=q,Pe=q;return{originSelectionRange:Ae.originSelectionRange?a.from(Ae.originSelectionRange):void 0,uri:Ae.targetUri?Ae.targetUri:Pe.uri,range:a.from(Ae.targetRange?Ae.targetRange:Pe.range),targetSelectionRange:Ae.targetSelectionRange?a.from(Ae.targetSelectionRange):void 0}}le.from=Ee;function ce(q){return{targetUri:T.URI.revive(q.uri),targetRange:a.to(q.range),targetSelectionRange:q.targetSelectionRange?a.to(q.targetSelectionRange):void 0,originSelectionRange:q.originSelectionRange?a.to(q.originSelectionRange):void 0}}le.to=ce})(X=e.DefinitionLink||(e.DefinitionLink={}));var he;(function(le){function Ee(q){return{range:a.from(q.range),contents:y.fromMany(q.contents)}}le.from=Ee;function ce(q){return new E.Hover(q.contents.map(y.to),a.to(q.range))}le.to=ce})(he=e.Hover||(e.Hover={}));var _e;(function(le){function Ee(q){return{range:a.from(q.range),expression:q.expression}}le.from=Ee;function ce(q){return new E.EvaluatableExpression(a.to(q.range),q.expression)}le.to=ce})(_e=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ye;(function(le){function Ee(q){if(q instanceof E.InlineValueText)return{type:"text",range:a.from(q.range),text:q.text};if(q instanceof E.InlineValueVariableLookup)return{type:"variable",range:a.from(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};if(q instanceof E.InlineValueEvaluatableExpression)return{type:"expression",range:a.from(q.range),expression:q.expression};throw new Error("Unknown 'InlineValue' type")}le.from=Ee;function ce(q){switch(q.type){case"text":return{range:a.to(q.range),text:q.text};case"variable":return{range:a.to(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};case"expression":return{range:a.to(q.range),expression:q.expression}}}le.to=ce})(ye=e.InlineValue||(e.InlineValue={}));var Re;(function(le){function Ee(q){return{frameId:q.frameId,stoppedLocation:a.from(q.stoppedLocation)}}le.from=Ee;function ce(q){return new E.InlineValueContext(q.frameId,a.to(q.stoppedLocation))}le.to=ce})(Re=e.InlineValueContext||(e.InlineValueContext={}));var $e;(function(le){function Ee(q){return{range:a.from(q.range),kind:q.kind}}le.from=Ee;function ce(q){return new E.DocumentHighlight(a.to(q.range),q.kind)}le.to=ce})($e=e.DocumentHighlight||(e.DocumentHighlight={}));var Be;(function(le){function Ee(ce){switch(ce){case 1:return E.CompletionTriggerKind.TriggerCharacter;case 2:return E.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return E.CompletionTriggerKind.Invoke}}le.to=Ee})(Be=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var je;(function(le){function Ee(ce){return{triggerKind:Be.to(ce.triggerKind),triggerCharacter:ce.triggerCharacter}}le.to=Ee})(je=e.CompletionContext||(e.CompletionContext={}));var V;(function(le){function Ee(q){switch(q){case E.CompletionItemTag.Deprecated:return 1}}le.from=Ee;function ce(q){switch(q){case 1:return E.CompletionItemTag.Deprecated}}le.to=ce})(V=e.CompletionItemTag||(e.CompletionItemTag={}));var ee;(function(le){const Ee=new Map([[E.CompletionItemKind.Method,0],[E.CompletionItemKind.Function,1],[E.CompletionItemKind.Constructor,2],[E.CompletionItemKind.Field,3],[E.CompletionItemKind.Variable,4],[E.CompletionItemKind.Class,5],[E.CompletionItemKind.Interface,7],[E.CompletionItemKind.Struct,6],[E.CompletionItemKind.Module,8],[E.CompletionItemKind.Property,9],[E.CompletionItemKind.Unit,12],[E.CompletionItemKind.Value,13],[E.CompletionItemKind.Constant,14],[E.CompletionItemKind.Enum,15],[E.CompletionItemKind.EnumMember,16],[E.CompletionItemKind.Keyword,17],[E.CompletionItemKind.Snippet,27],[E.CompletionItemKind.Text,18],[E.CompletionItemKind.Color,19],[E.CompletionItemKind.File,20],[E.CompletionItemKind.Reference,21],[E.CompletionItemKind.Folder,23],[E.CompletionItemKind.Event,10],[E.CompletionItemKind.Operator,11],[E.CompletionItemKind.TypeParameter,24],[E.CompletionItemKind.Issue,26],[E.CompletionItemKind.User,25]]);function ce(Pe){return Ee.get(Pe)??9}le.from=ce;const q=new Map([[0,E.CompletionItemKind.Method],[1,E.CompletionItemKind.Function],[2,E.CompletionItemKind.Constructor],[3,E.CompletionItemKind.Field],[4,E.CompletionItemKind.Variable],[5,E.CompletionItemKind.Class],[7,E.CompletionItemKind.Interface],[6,E.CompletionItemKind.Struct],[8,E.CompletionItemKind.Module],[9,E.CompletionItemKind.Property],[12,E.CompletionItemKind.Unit],[13,E.CompletionItemKind.Value],[14,E.CompletionItemKind.Constant],[15,E.CompletionItemKind.Enum],[16,E.CompletionItemKind.EnumMember],[17,E.CompletionItemKind.Keyword],[27,E.CompletionItemKind.Snippet],[18,E.CompletionItemKind.Text],[19,E.CompletionItemKind.Color],[20,E.CompletionItemKind.File],[21,E.CompletionItemKind.Reference],[23,E.CompletionItemKind.Folder],[10,E.CompletionItemKind.Event],[11,E.CompletionItemKind.Operator],[24,E.CompletionItemKind.TypeParameter],[25,E.CompletionItemKind.User],[26,E.CompletionItemKind.Issue]]);function Ae(Pe){return q.get(Pe)??E.CompletionItemKind.Property}le.to=Ae})(ee=e.CompletionItemKind||(e.CompletionItemKind={}));var re;(function(le){function Ee(ce,q){const Ae=new E.CompletionItem(ce.label);return Ae.insertText=ce.insertText,Ae.kind=ee.to(ce.kind),Ae.tags=ce.tags?.map(V.to),Ae.detail=ce.detail,Ae.documentation=I.isMarkdownString(ce.documentation)?y.to(ce.documentation):ce.documentation,Ae.sortText=ce.sortText,Ae.filterText=ce.filterText,Ae.preselect=ce.preselect,Ae.commitCharacters=ce.commitCharacters,n.Range.isIRange(ce.range)?Ae.range=a.to(ce.range):typeof ce.range=="object"&&(Ae.range={inserting:a.to(ce.range.insert),replacing:a.to(ce.range.replace)}),Ae.keepWhitespace=typeof ce.insertTextRules=="undefined"?!1:Boolean(ce.insertTextRules&1),typeof ce.insertTextRules!="undefined"&&ce.insertTextRules&4?Ae.insertText=new E.SnippetString(ce.insertText):(Ae.insertText=ce.insertText,Ae.textEdit=Ae.range instanceof E.Range?new E.TextEdit(Ae.range,Ae.insertText):void 0),ce.additionalTextEdits&&ce.additionalTextEdits.length>0&&(Ae.additionalTextEdits=ce.additionalTextEdits.map(Pe=>K.to(Pe))),Ae.command=q&&ce.command?q.fromInternal(ce.command):void 0,Ae}le.to=Ee})(re=e.CompletionItem||(e.CompletionItem={}));var ae;(function(le){function Ee(q){return{label:q.label,documentation:q.documentation?y.fromStrict(q.documentation):void 0}}le.from=Ee;function ce(q){return{label:q.label,documentation:I.isMarkdownString(q.documentation)?y.to(q.documentation):q.documentation}}le.to=ce})(ae=e.ParameterInformation||(e.ParameterInformation={}));var Y;(function(le){function Ee(q){return{label:q.label,documentation:q.documentation?y.fromStrict(q.documentation):void 0,parameters:Array.isArray(q.parameters)?q.parameters.map(ae.from):[],activeParameter:q.activeParameter}}le.from=Ee;function ce(q){return{label:q.label,documentation:I.isMarkdownString(q.documentation)?y.to(q.documentation):q.documentation,parameters:Array.isArray(q.parameters)?q.parameters.map(ae.to):[],activeParameter:q.activeParameter}}le.to=ce})(Y=e.SignatureInformation||(e.SignatureInformation={}));var oe;(function(le){function Ee(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(Y.from):[]}}le.from=Ee;function ce(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(Y.to):[]}}le.to=ce})(oe=e.SignatureHelp||(e.SignatureHelp={}));var ve;(function(le){function Ee(q){return{text:q.text,position:t.from(q.position),kind:Me.from(q.kind??E.InlayHintKind.Other),whitespaceBefore:q.whitespaceBefore,whitespaceAfter:q.whitespaceAfter}}le.from=Ee;function ce(q){const Ae=new E.InlayHint(q.text,t.to(q.position),Me.to(q.kind));return Ae.whitespaceAfter=q.whitespaceAfter,Ae.whitespaceBefore=q.whitespaceBefore,Ae}le.to=ce})(ve=e.InlayHint||(e.InlayHint={}));var Me;(function(le){function Ee(q){return q}le.from=Ee;function ce(q){return q}le.to=ce})(Me=e.InlayHintKind||(e.InlayHintKind={}));var qe;(function(le){function Ee(q){return{range:a.from(q.range),url:q.target,tooltip:q.tooltip}}le.from=Ee;function ce(q){let Ae;if(q.url)try{Ae=typeof q.url=="string"?T.URI.parse(q.url,!0):T.URI.revive(q.url)}catch(Pe){}return new E.DocumentLink(a.to(q.range),Ae)}le.to=ce})(qe=e.DocumentLink||(e.DocumentLink={}));var Ke;(function(le){function Ee(q){const Ae=new E.ColorPresentation(q.label);return q.textEdit&&(Ae.textEdit=K.to(q.textEdit)),q.additionalTextEdits&&(Ae.additionalTextEdits=q.additionalTextEdits.map(Pe=>K.to(Pe))),Ae}le.to=Ee;function ce(q){return{label:q.label,textEdit:q.textEdit?K.from(q.textEdit):void 0,additionalTextEdits:q.additionalTextEdits?q.additionalTextEdits.map(Ae=>K.from(Ae)):void 0}}le.from=ce})(Ke=e.ColorPresentation||(e.ColorPresentation={}));var Se;(function(le){function Ee(q){return new E.Color(q[0],q[1],q[2],q[3])}le.to=Ee;function ce(q){return[q.red,q.green,q.blue,q.alpha]}le.from=ce})(Se=e.Color||(e.Color={}));var tt;(function(le){function Ee(q){return{range:a.from(q.range)}}le.from=Ee;function ce(q){return new E.SelectionRange(a.to(q.range))}le.to=ce})(tt=e.SelectionRange||(e.SelectionRange={}));var Z;(function(le){function Ee(ce){switch(ce){case 2:return E.TextDocumentSaveReason.AfterDelay;case 1:return E.TextDocumentSaveReason.Manual;case 3:case 4:return E.TextDocumentSaveReason.FocusOut}}le.to=Ee})(Z=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var te;(function(le){function Ee(q){switch(q){case E.TextEditorLineNumbersStyle.Off:return 0;case E.TextEditorLineNumbersStyle.Relative:return 2;case E.TextEditorLineNumbersStyle.On:default:return 1}}le.from=Ee;function ce(q){switch(q){case 0:return E.TextEditorLineNumbersStyle.Off;case 2:return E.TextEditorLineNumbersStyle.Relative;case 1:default:return E.TextEditorLineNumbersStyle.On}}le.to=ce})(te=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var pe;(function(le){function Ee(q){if(q===E.EndOfLine.CRLF)return 1;if(q===E.EndOfLine.LF)return 0}le.from=Ee;function ce(q){if(q===1)return E.EndOfLine.CRLF;if(q===0)return E.EndOfLine.LF}le.to=ce})(pe=e.EndOfLine||(e.EndOfLine={}));var xe;(function(le){function Ee(ce){if(typeof ce=="object")return ce.viewId;switch(ce){case E.ProgressLocation.SourceControl:return 3;case E.ProgressLocation.Window:return 10;case E.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}le.from=Ee})(xe=e.ProgressLocation||(e.ProgressLocation={}));var Je;(function(le){function Ee(ce){const q={start:ce.start+1,end:ce.end+1};return ce.kind&&(q.kind=rt.from(ce.kind)),q}le.from=Ee})(Je=e.FoldingRange||(e.FoldingRange={}));var rt;(function(le){function Ee(ce){if(ce)switch(ce){case E.FoldingRangeKind.Comment:return A.FoldingRangeKind.Comment;case E.FoldingRangeKind.Imports:return A.FoldingRangeKind.Imports;case E.FoldingRangeKind.Region:return A.FoldingRangeKind.Region}}le.from=Ee})(rt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ft;(function(le){function Ee(ce){if(ce)return{pinned:typeof ce.preview=="boolean"?!ce.preview:void 0,inactive:ce.background,preserveFocus:ce.preserveFocus,selection:typeof ce.selection=="object"?a.from(ce.selection):void 0,override:typeof ce.override=="boolean"?u.EditorResolution.DISABLED:void 0}}le.from=Ee})(ft=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var pt;(function(le){function Ee(q){return q instanceof E.RelativePattern||typeof q=="string"?q:ce(q)?new E.RelativePattern(q.base,q.pattern):q}le.from=Ee;function ce(q){const Ae=q;return Ae&&typeof Ae.base=="string"&&typeof Ae.pattern=="string"}})(pt=e.GlobPattern||(e.GlobPattern={}));var St;(function(le){function Ee(ce){if(ce){if(Array.isArray(ce))return ce.map(Ee);if(typeof ce=="string")return ce;{const q=ce;return{language:q.language,scheme:q.scheme,pattern:typeof q.pattern=="undefined"?void 0:pt.from(q.pattern),exclusive:q.exclusive}}}else return}le.from=Ee})(St=e.LanguageSelector||(e.LanguageSelector={}));var Ct;(function(le){function Ee(q){return{start:q.start,end:q.end}}le.from=Ee;function ce(q){return new E.NotebookRange(q.start,q.end)}le.to=ce})(Ct=e.NotebookRange||(e.NotebookRange={}));var ue;(function(le){function Ee(q){return{timing:typeof q.runStartTime=="number"&&typeof q.runEndTime=="number"?{startTime:q.runStartTime,endTime:q.runEndTime}:void 0,executionOrder:q.executionOrder,success:q.lastRunSuccess}}le.to=Ee;function ce(q){return{lastRunSuccess:q.success,runStartTime:q.timing?.startTime,runEndTime:q.timing?.endTime,executionOrder:q.executionOrder}}le.from=ce})(ue=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ie;(function(le){function Ee(q){switch(q){case E.NotebookCellKind.Markup:return v.CellKind.Markup;case E.NotebookCellKind.Code:default:return v.CellKind.Code}}le.from=Ee;function ce(q){switch(q){case v.CellKind.Markup:return E.NotebookCellKind.Markup;case v.CellKind.Code:default:return E.NotebookCellKind.Code}}le.to=ce})(Ie=e.NotebookCellKind||(e.NotebookCellKind={}));var Ue;(function(le){function Ee(q){const Ae={metadata:q.metadata??Object.create(null),cells:[]};for(let Pe of q.cells)E.NotebookCellData.validate(Pe),Ae.cells.push(Qe.from(Pe));return Ae}le.from=Ee;function ce(q){const Ae=new E.NotebookData(q.cells.map(Qe.to));return(0,D.isEmptyObject)(q.metadata)||(Ae.metadata=q.metadata),Ae}le.to=ce})(Ue=e.NotebookData||(e.NotebookData={}));var Qe;(function(le){function Ee(q){return{cellKind:Ie.from(q.kind),language:q.languageId,mime:q.mime,source:q.value,metadata:q.metadata,internalMetadata:ue.from(q.executionSummary??{}),outputs:q.outputs?q.outputs.map(at.from):[]}}le.from=Ee;function ce(q){return new E.NotebookCellData(Ie.to(q.cellKind),q.source,q.language,q.mime,q.outputs?q.outputs.map(at.to):void 0,q.metadata,q.internalMetadata?ue.to(q.internalMetadata):void 0)}le.to=ce})(Qe=e.NotebookCellData||(e.NotebookCellData={}));var ze;(function(le){function Ee(q){return{mime:q.mime,valueBytes:L.VSBuffer.wrap(q.data)}}le.from=Ee;function ce(q){return new E.NotebookCellOutputItem(q.valueBytes.buffer,q.mime)}le.to=ce})(ze=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var at;(function(le){function Ee(q){return{outputId:q.id,items:q.items.map(ze.from),metadata:q.metadata}}le.from=Ee;function ce(q){const Ae=q.items.map(ze.to);return new E.NotebookCellOutput(Ae,q.outputId,q.metadata)}le.to=ce})(at=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Le;(function(le){function Ee(Pe){if(Pe!=null){if(Pe instanceof E.RelativePattern||typeof Pe=="string")return Pe;if(Ae(Pe))return new E.RelativePattern(Pe.base,Pe.pattern);if(q(Pe))return{include:pt.from(Pe.include)||void 0,exclude:pt.from(Pe.exclude)||void 0}}}le.from=Ee;function ce(Pe){return typeof Pe=="string"?Pe:Ae(Pe)?{base:Pe.base,pattern:Pe.pattern}:{include:Pe.include,exclude:Pe.exclude}}le.to=ce;function q(Pe){const Ze=Pe,Xe=pt.from(Ze.include);if(!(Xe&&Xe instanceof E.RelativePattern||typeof Xe=="string"))return!1;const ot=pt.from(Ze.exclude);return!!(ot&&ot instanceof E.RelativePattern||typeof ot=="string")}function Ae(Pe){const Ze=Pe;return Ze&&typeof Ze.base=="string"&&typeof Ze.pattern=="string"}})(Le=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var De;(function(le){function Ee(ce){return{backgroundColor:ce.backgroundColor,borderColor:ce.borderColor,top:ce.top?w.from(ce.top):void 0}}le.from=Ee})(De=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var ke;(function(le){function Ee(ce,q,Ae){const Pe=typeof ce.command=="string"?{title:"",command:ce.command}:ce.command;return{alignment:ce.alignment===E.NotebookCellStatusBarAlignment.Left?1:2,command:q.toInternal(Pe,Ae),text:ce.text,tooltip:ce.tooltip,accessibilityInformation:ce.accessibilityInformation,priority:ce.priority}}le.from=Ee})(ke=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ne;(function(le){function Ee(ce){return{transientOutputs:ce?.transientOutputs??!1,transientCellMetadata:ce?.transientCellMetadata??{},transientDocumentMetadata:ce?.transientDocumentMetadata??{}}}le.from=Ee})(ne=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var de;(function(le){function Ee(q){return{uri:q.uri,provides:q.provides}}le.from=Ee;function ce(q){return new E.NotebookRendererScript(T.URI.revive(q.uri),q.provides)}le.to=ce})(de=e.NotebookRendererScript||(e.NotebookRendererScript={}));var be;(function(le){function Ee(q){return{message:y.fromStrict(q.message)||"",type:0,expected:q.expectedOutput,actual:q.actualOutput,location:q.location?Q.from(q.location):void 0}}le.from=Ee;function ce(q){const Ae=new E.TestMessage(typeof q.message=="string"?q.message:y.to(q.message));return Ae.actualOutput=q.actual,Ae.expectedOutput=q.expected,Ae.location=q.location?Q.to(q.location):void 0,Ae}le.to=ce})(be=e.TestMessage||(e.TestMessage={}));var we;(function(le){let Ee;(function(ce){ce.Delimiter="\0"})(Ee||(Ee={})),le.namespace=(ce,q)=>ce+"\0"+q,le.denamespace=ce=>{const q=ce.indexOf("\0");return{ctrlId:ce.slice(0,q),tagId:ce.slice(q+1)}}})(we=e.TestTag||(e.TestTag={}));var Fe;(function(le){function Ee(Pe){const Ze=(0,l.getPrivateApiFor)(Pe).controllerId;return{extId:S.TestId.fromExtHostTestItem(Pe,Ze).toString(),label:Pe.label,uri:Pe.uri,tags:Pe.tags.map(Xe=>we.namespace(Ze,Xe.id)),range:a.from(Pe.range)||null,description:Pe.description||null,error:Pe.error&&y.fromStrict(Pe.error)||null}}le.from=Ee;function ce(Pe){return{id:S.TestId.fromString(Pe.extId).localId,label:Pe.label,uri:T.URI.revive(Pe.uri),tags:(Pe.tags||[]).map(Ze=>{const{tagId:Xe}=we.denamespace(Ze);return new E.TestTag(Xe)}),range:a.to(Pe.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Pe.description||void 0}}le.toPlain=ce;function q(Pe){const Ze=S.TestId.fromString(Pe.extId),Xe=new l.TestItemImpl(Ze.controllerId,Ze.localId,Pe.label,T.URI.revive(Pe.uri));return Xe.range=a.to(Pe.range||void 0),Xe.description=Pe.description||void 0,Xe}function Ae(Pe){let Ze;for(const Xe of Pe.tests){const ot=q(Xe.item);(0,l.getPrivateApiFor)(ot).parent=Ze,Ze=ot}return Ze}le.toItemFromContext=Ae})(Fe=e.TestItem||(e.TestItem={})),function(le){function Ee(q){return{id:q.id}}le.from=Ee;function ce(q){return new E.TestTag(q.id)}le.to=ce}(we=e.TestTag||(e.TestTag={}));var Ge;(function(le){const Ee=(q,Ae)=>{const Pe={...Fe.toPlain(q.item),parent:void 0,taskStates:q.tasks.map(Ze=>({state:Ze.state,duration:Ze.duration,messages:Ze.messages.filter(Xe=>Xe.type===0).map(be.to)})),children:q.children.map(Ze=>Ae.get(Ze)).filter(D.isDefined).map(Ze=>Ee(Ze,Ae))};for(const Ze of Pe.children)Ze.parent=Pe;return Pe};function ce(q){const Ae=[],Pe=new Map;for(const Ze of q.items)Pe.set(Ze.item.extId,Ze),q.request.targets.some(Xe=>Xe.controllerId===Ze.controllerId&&Xe.testIds.includes(Ze.item.extId))&&Ae.push(Ze);return{completedAt:q.completedAt,results:Ae.map(Ze=>Ee(Ze,Pe))}}le.to=ce})(Ge=e.TestResults||(e.TestResults={}));var He;(function(le){function Ee(Pe){return{covered:Pe.covered,total:Pe.covered}}function ce(Pe){return"line"in Pe?t.from(Pe):a.from(Pe)}function q(Pe){return"branches"in Pe?{count:Pe.executionCount,location:ce(Pe.location),type:1,branches:Pe.branches.length?Pe.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&ce(Ze.location)})):void 0}:{type:0,count:Pe.executionCount,location:ce(Pe.location)}}le.fromDetailed=q;function Ae(Pe){return{uri:Pe.uri,statement:Ee(Pe.statementCoverage),branch:Pe.branchCoverage&&Ee(Pe.branchCoverage),function:Pe.functionCoverage&&Ee(Pe.functionCoverage),details:Pe.detailedCoverage?.map(q)}}le.fromFile=Ae})(He=e.TestCoverage||(e.TestCoverage={}));var Ye;(function(le){function Ee(ce){switch(ce){case 1:return E.CodeActionTriggerKind.Invoke;case 2:return E.CodeActionTriggerKind.Automatic}}le.to=Ee})(Ye=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var it;(function(le){function Ee(q){const Ae=new E.TypeHierarchyItem(z.to(q.kind),q.name,q.detail||"",T.URI.revive(q.uri),a.to(q.range),a.to(q.selectionRange));return Ae._sessionId=q._sessionId,Ae._itemId=q._itemId,Ae}le.to=Ee;function ce(q,Ae,Pe){if(Ae=Ae??q._sessionId,Pe=Pe??q._itemId,Ae===void 0||Pe===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Pe,kind:z.from(q.kind),name:q.name,detail:q.detail??"",uri:q.uri,range:a.from(q.range),selectionRange:a.from(q.selectionRange),tags:q.tags?.map(O.from)}}le.from=ce})(it=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(me[218],ge([0,1,2,16,7,15,95]),function(J,e,m,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class C{constructor(T,n,A,u={timeout:1500,errors:3}){this._logService=T,this._documents=n,this._mainThreadBulkEdits=A,this._thresholds=u,this._callbacks=new R.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(T){return(n,A,u)=>{const l={dispose:this._callbacks.push([n,A,T])};return Array.isArray(u)&&u.push(l),l}}async $participateInSave(T,n){const A=m.URI.revive(T);let u=!1;const f=setTimeout(()=>u=!0,this._thresholds.timeout),l=[];try{for(let v of[...this._callbacks]){if(u)break;const S=this._documents.getDocument(A),P=await this._deliverEventAsyncAndBlameBadListeners(v,{document:S,reason:k.TextDocumentSaveReason.to(n)});l.push(P)}}finally{clearTimeout(f)}return l}_deliverEventAsyncAndBlameBadListeners([T,n,A],u){const f=this._badListeners.get(T);return typeof f=="number"&&f>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(A,T,n,u).then(()=>!0,l=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' threw ERROR`),this._logService.error(l),!(l instanceof Error)||l.message!=="concurrent_edits"){const v=this._badListeners.get(T);this._badListeners.set(T,v?v+1:1),typeof v=="number"&&v>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(T,n,A,u){const f=[],l=Date.now(),{document:v,reason:S}=u,{version:P}=v,E=Object.freeze({document:v,reason:S,waitUntil(s){if(Object.isFrozen(f))throw(0,L.illegalState)("waitUntil can not be called async");f.push(Promise.resolve(s))}});try{n.apply(A,[E])}catch(s){return Promise.reject(s)}return Object.freeze(f),new Promise((s,a)=>{const p=setTimeout(()=>a(new Error("timeout")),this._thresholds.timeout);return Promise.all(f).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-l}ms`),clearTimeout(p),s(t)}).catch(t=>{clearTimeout(p),a(t)})}).then(s=>{const a={edits:[]};for(const p of s)if(Array.isArray(p)&&p.every(t=>t instanceof I.TextEdit))for(const{newText:t,newEol:o,range:r}of p)a.edits.push({_type:2,resource:v.uri,edit:{range:r&&k.Range.from(r),text:t,eol:o&&k.EndOfLine.from(o)}});if(a.edits.length!==0)return P===v.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(a):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=C}),define(me[54],ge([0,1,15,2,3,4]),function(J,e,m,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,k.createDecorator)("IExtHostEditorTabs");class R{constructor(){this._onDidChangeTabs=new I.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new I.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[]}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(D){let T=-1;this._tabs=D.map((A,u)=>{A.isActive&&(T=u);let f;if(A.resource){const l=A.resource;l.primary||l.secondary?f={primary:L.URI.revive(l.primary),secondary:L.URI.revive(l.secondary)}:f=L.URI.revive(A.resource)}return Object.freeze({label:A.label,viewColumn:m.ViewColumn.to(A.viewColumn),resource:f,editorId:A.editorId,isActive:A.isActive})});const n=this._activeTab;this._activeTab=T===-1?void 0:this._tabs[T],this._activeTab!==n&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}}e.ExtHostEditorTabs=R}),define(me[219],ge([0,1,3,30,2,15,7]),function(J,e,m,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class C{constructor(n,A,u,f,l){this._onDidCreate=new m.Emitter,this._onDidChange=new m.Emitter,this._onDidDelete=new m.Emitter,this._config=0,u&&(this._config+=1),f&&(this._config+=2),l&&(this._config+=4);const v=(0,L.parse)(A),S=n(P=>{if(!u)for(let E of P.created){const s=I.URI.revive(E);v(s.fsPath)&&this._onDidCreate.fire(s)}if(!f)for(let E of P.changed){const s=I.URI.revive(E);v(s.fsPath)&&this._onDidChange.fire(s)}if(!l)for(let E of P.deleted){const s=I.URI.revive(E);v(s.fsPath)&&this._onDidDelete.fire(s)}});this._disposable=R.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,S)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class D{constructor(n,A,u){this._logService=A,this._extHostDocumentsAndEditors=u,this._onFileSystemEvent=new m.Emitter,this._onDidRenameFile=new m.Emitter,this._onDidCreateFile=new m.Emitter,this._onDidDeleteFile=new m.Emitter,this._onWillRenameFile=new m.AsyncEmitter,this._onWillCreateFile=new m.AsyncEmitter,this._onWillDeleteFile=new m.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(n,A,u,f){return new C(this._onFileSystemEvent.event,n,A,u,f)}$onFileEvent(n){this._onFileSystemEvent.fire(n)}$onDidRunFileOperation(n,A){switch(n){case 2:this._onDidRenameFile.fire(Object.freeze({files:A.map(u=>({oldUri:I.URI.revive(u.source),newUri:I.URI.revive(u.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:A.map(u=>I.URI.revive(u.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:A.map(u=>I.URI.revive(u.target))}));break;default:}}getOnWillRenameFileEvent(n){return this._createWillExecuteEvent(n,this._onWillRenameFile)}getOnWillCreateFileEvent(n){return this._createWillExecuteEvent(n,this._onWillCreateFile)}getOnWillDeleteFileEvent(n){return this._createWillExecuteEvent(n,this._onWillDeleteFile)}_createWillExecuteEvent(n,A){return(u,f,l)=>{const v=function(P){u.call(f,P)};return v.extension=n,A.event(v,void 0,l)}}async $onWillRunFileOperation(n,A,u,f){switch(n){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:A.map(l=>({oldUri:I.URI.revive(l.source),newUri:I.URI.revive(l.target)}))},u,f);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:A.map(l=>I.URI.revive(l.target))},u,f);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:A.map(l=>I.URI.revive(l.target))},u,f)}}async _fireWillEvent(n,A,u,f){const l=new Set,v=[];if(await n.fireAsync(A,f,async(P,E)=>{const s=Date.now(),a=await Promise.resolve(P);a instanceof R.WorkspaceEdit&&(v.push(a),l.add(E.extension.displayName??E.extension.identifier.value)),Date.now()-s>u&&this._logService.warn("SLOW file-participant",E.extension.identifier)}),f.isCancellationRequested||v.length===0)return;const S={edits:[]};for(let P of v){let{edits:E}=k.WorkspaceEdit.from(P,this._extHostDocumentsAndEditors);S.edits=S.edits.concat(E)}return{edit:S,extensionNames:Array.from(l)}}}e.ExtHostFileSystemEventService=D}),define(me[220],ge([0,1,10,25,2,15,7,126]),function(J,e,m,L,I,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class D{constructor(u,f,l,v){this.start=u,this.deletedCount=f,this.deletedItems=l,this.items=v}static asApiEvents(u){return u.map(f=>({start:f.start,deletedCount:f.deletedCount,deletedItems:f.deletedItems,items:f.items.map(l=>l.apiCell)}))}}class T{constructor(u,f,l){this.notebook=u,this._extHostDocument=f,this._cellData=l,this.handle=l.handle,this.uri=I.URI.revive(l.uri),this.cellKind=l.cellKind,this._outputs=l.outputs.map(k.NotebookCellOutput.to),this._internalMetadata=l.internalMetadata??{},this._metadata=Object.freeze(l.metadata??{}),this._previousResult=Object.freeze(k.NotebookCellExecutionSummary.to(l.internalMetadata??{}))}static asModelAddData(u,f){return{EOL:f.eol,lines:f.source,modeId:f.language,uri:f.uri,isDirty:!1,versionId:1,notebook:u}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const u=this,f=this._extHostDocument.getDocument(this.uri);if(!f)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return u.notebook.getCellIndex(u)},notebook:u.notebook.apiNotebook,kind:k.NotebookCellKind.to(this._cellData.cellKind),document:f.document,get mime(){return u._mime},set mime(l){u._mime=l},get outputs(){return u._outputs.slice(0)},get metadata(){return u._metadata},get executionSummary(){return u._previousResult}})}return this._apiCell}setOutputs(u){this._outputs=u.map(k.NotebookCellOutput.to)}setOutputItems(u,f,l){const v=l.map(k.NotebookCellOutputItem.to),S=this._outputs.find(P=>P.id===u);S&&(f||(S.items.length=0),S.items.push(...v))}setMetadata(u){this._metadata=Object.freeze(u)}setInternalMetadata(u){this._internalMetadata=u,this._previousResult=Object.freeze(k.NotebookCellExecutionSummary.to(u))}setMime(u){}}e.ExtHostCell=T;class n{constructor(u,f,l,v,S,P){this._proxy=u,this._textDocumentsAndEditors=f,this._textDocuments=l,this._emitter=v,this.uri=S,this.handle=n._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=P.viewType,this._metadata=Object.freeze(P.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,P.cells]],!0),this._versionId=P.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const u=this;this._notebook={get uri(){return u.uri},get version(){return u._versionId},get notebookType(){return u._notebookType},get isDirty(){return u._isDirty},get isUntitled(){return u.uri.scheme===m.Schemas.untitled},get isClosed(){return u._disposed},get metadata(){return u._metadata},get cellCount(){return u._cells.length},cellAt(f){return f=u._validateIndex(f),u._cells[f].apiCell},getCells(f){return(f?u._getCells(f):u._cells).map(v=>v.apiCell)},save(){return u._save()}}}return this._notebook}updateBackup(u){this._backup?.delete(),this._backup=u}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(u){u.metadata&&(this._metadata=Object.freeze({...this._metadata,...u.metadata}))}acceptDirty(u){this._isDirty=u}acceptModelChanged(u,f){this._versionId=u.versionId,this._isDirty=f;for(const l of u.rawEvents)l.kind===C.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(l.changes,!1):l.kind===C.NotebookCellsChangeType.Move?this._moveCell(l.index,l.newIdx):l.kind===C.NotebookCellsChangeType.Output?this._setCellOutputs(l.index,l.outputs):l.kind===C.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(l.index,l.outputId,l.append,l.outputItems):l.kind===C.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(l.index,l.language):l.kind===C.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(l.index,l.mime):l.kind===C.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(l.index,l.metadata):l.kind===C.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(l.index,l.internalMetadata)}_validateIndex(u){return u=u|0,u<0?0:u>=this._cells.length?this._cells.length-1:u}_validateRange(u){let f=u.start|0,l=u.end|0;return f<0&&(f=0),l>this._cells.length&&(l=this._cells.length),u.with({start:f,end:l})}_getCells(u){u=this._validateRange(u);const f=[];for(let l=u.start;l<u.end;l++)f.push(this._cells[l]);return f}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(u,f){if(this._disposed)return;const l=[],v=[],S=[];u.reverse().forEach(P=>{const s=P[2].map(t=>{const o=new T(this,this._textDocumentsAndEditors,t);return f||v.push(T.asModelAddData(this.apiNotebook,t)),o}),a=new D(P[0],P[1],[],s),p=this._cells.splice(P[0],P[1],...s);for(const t of p)S.push(t.uri),a.deletedItems.push(t.apiCell);l.push(a)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:v,removedDocuments:S}),f||this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(l)}))}_moveCell(u,f){const l=this._cells.splice(u,1);this._cells.splice(f,0,...l);const v=[new D(u,1,l.map(S=>S.apiCell),[]),new D(f,0,[],l)];this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(v)}))}_setCellOutputs(u,f){const l=this._cells[u];l.setOutputs(f),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[l.apiCell]}))}_setCellOutputItems(u,f,l,v){const S=this._cells[u];S.setOutputItems(f,l,v),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[S.apiCell]}))}_changeCellLanguage(u,f){const l=this._cells[u];l.apiCell.document.languageId!==f&&this._textDocuments.$acceptModelModeChanged(l.uri,f)}_changeCellMime(u,f){const l=this._cells[u];l.apiCell.mime=f}_changeCellMetadata(u,f){const l=this._cells[u],v=l.apiCell.metadata;l.setMetadata(f);const S=l.apiCell.metadata;(0,L.equals)(v,S)||this._emitter.emitCellMetadataChange((0,L.deepFreeze)({document:this.apiNotebook,cell:l.apiCell}))}_changeCellInternalMetadata(u,f){const l=this._cells[u],v=l.internalMetadata;if(l.setInternalMetadata(f),v.runState!==f.runState){const S=f.runState??R.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,L.deepFreeze)({document:this.apiNotebook,cell:l.apiCell,state:S}))}}getCellFromApiCell(u){return this._cells.find(f=>f.apiCell===u)}getCellFromIndex(u){return this._cells[u]}getCell(u){return this._cells.find(f=>f.handle===u)}getCellIndex(u){return this._cells.indexOf(u)}}e.ExtHostNotebookDocument=n,n._handlePool=0}),define(me[129],ge([0,1,7,15,16]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class k{constructor(D){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=D}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(D){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:D})}replaceCellMetadata(D,T){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:D,metadata:T})}replaceCells(D,T,n){this._throwIfFinalized(),!(D===T&&n.length===0)&&this._collectedEdits.push({editType:1,index:D,count:T-D,cells:n.map(L.NotebookCellData.from)})}}class R{constructor(D,T,n,A,u,f){this.id=D,this._proxy=T,this.notebookData=n,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=u,this._visibleRanges=A,this._viewColumn=f}get apiEditor(){if(!this._editor){const D=this;this._editor={get document(){return D.notebookData.apiNotebook},get selections(){return D._selections},set selections(T){if(!Array.isArray(T)||!T.every(m.NotebookRange.isNotebookRange))throw(0,I.illegalArgument)("selections");D._selections=T,D._trySetSelections(T)},get visibleRanges(){return D._visibleRanges},revealRange(T,n){D._proxy.$tryRevealRange(D.id,L.NotebookRange.from(T),n??m.NotebookEditorRevealType.Default)},get viewColumn(){return D._viewColumn},edit(T){const n=new k(this.document.version);return T(n),D._applyEdit(n.finalize())},setDecorations(T,n){return D.setDecorations(T,n)}},R.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(D){this._visible=D}_acceptVisibleRanges(D){this._visibleRanges=D}_acceptSelections(D){this._selections=D}_trySetSelections(D){this._proxy.$trySetSelections(this.id,D.map(L.NotebookRange.from))}_acceptViewColumn(D){this._viewColumn=D}_applyEdit(D){if(D.cellEdits.length===0)return Promise.resolve(!0);const T=[];let n=-1;for(let A=0;A<D.cellEdits.length;A++){if(n<0){T.push(D.cellEdits[A]),n++;continue}const f=T[n],l=D.cellEdits[A];if(f.editType===1&&l.editType===1&&f.index===l.index){f.cells.push(...D.cellEdits[A].cells),f.count+=D.cellEdits[A].count;continue}T.push(D.cellEdits[A]),n++}return this._proxy.$tryApplyEdits(this.id,D.documentVersionId,T)}setDecorations(D,T){if(!(T.isEmpty&&!this._hasDecorationsForKey.has(D.key)))return T.isEmpty?this._hasDecorationsForKey.delete(D.key):this._hasDecorationsForKey.add(D.key),this._proxy.$trySetDecorations(this.id,L.NotebookRange.from(T),D.key)}}e.ExtHostNotebookEditor=R,R.apiEditorsToExtHost=new WeakMap}),define(me[221],ge([0,1,15,118,165,21,58]),function(J,e,m,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(A){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=A}withProgress(A,u,f){const l=this._handles++,{title:v,location:S,cancellable:P}=u,E={label:(0,I.localize)(0,null,A.displayName||A.name),id:A.identifier.value};return this._proxy.$startProgress(l,{location:m.ProgressLocation.from(S),title:v,source:E,cancellable:P},A),this._withProgress(l,f,!!P)}_withProgress(A,u,f){let l;f&&(l=new k.CancellationTokenSource,this._mapHandleToCancellationSource.set(A,l));const v=P=>{this._proxy.$progressEnd(P),this._mapHandleToCancellationSource.delete(P),l&&l.dispose()};let S;try{S=u(new T(this._proxy,A),f&&l?l.token:k.CancellationToken.None)}catch(P){throw v(A),P}return S.then(P=>v(A),P=>v(A)),S}$acceptProgressCanceled(A){const u=this._mapHandleToCancellationSource.get(A);u&&(u.cancel(),this._mapHandleToCancellationSource.delete(A))}}e.ExtHostProgress=C;function D(n,A){return n.message=A.message,typeof A.increment=="number"&&(typeof n.increment=="number"?n.increment+=A.increment:n.increment=A.increment),n}class T extends L.Progress{constructor(A,u){super(f=>this.throttledReport(f));this._proxy=A,this._handle=u}throttledReport(A){this._proxy.$progressReport(this._handle,A)}}Ve([(0,R.throttle)(100,(n,A)=>D(n,A),()=>Object.create(null))],T.prototype,"throttledReport",null)}),define(me[130],ge([0,1,56,16,76,15,7]),function(J,e,m,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class C{constructor(u,f,l){const v=C._Keys.nextId();u.$registerTextEditorDecorationType(f.identifier,v,k.DecorationRenderOptions.from(l)),this.value=Object.freeze({key:v,dispose(){u.$removeTextEditorDecorationType(v)}})}}e.TextEditorDecorationType=C,C._Keys=new I.IdGenerator("TextEditorDecorationType");class D{constructor(u,f){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=u,this._documentVersionId=u.version,this._undoStopBefore=f.undoStopBefore,this._undoStopAfter=f.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(u,f){this._throwIfFinalized();let l=null;if(u instanceof R.Position)l=new R.Range(u,u);else if(u instanceof R.Range)l=u;else throw new Error("Unrecognized location");this._pushEdit(l,f,!1)}insert(u,f){this._throwIfFinalized(),this._pushEdit(new R.Range(u,u),f,!0)}delete(u){this._throwIfFinalized();let f=null;if(u instanceof R.Range)f=u;else throw new Error("Unrecognized location");this._pushEdit(f,null,!0)}_pushEdit(u,f,l){const v=this._document.validateRange(u);this._collectedEdits.push({range:v,text:f,forceMoveMarkers:l})}setEndOfLine(u){if(this._throwIfFinalized(),u!==R.EndOfLine.LF&&u!==R.EndOfLine.CRLF)throw(0,L.illegalArgument)("endOfLine");this._setEndOfLine=u}}e.TextEditorEdit=D;class T{constructor(u,f,l,v){this._proxy=u,this._id=f,this._accept(l),this._logService=v;const S=this;this.value={get tabSize(){return S._tabSize},set tabSize(P){S._setTabSize(P)},get insertSpaces(){return S._insertSpaces},set insertSpaces(P){S._setInsertSpaces(P)},get cursorStyle(){return S._cursorStyle},set cursorStyle(P){S._setCursorStyle(P)},get lineNumbers(){return S._lineNumbers},set lineNumbers(P){S._setLineNumbers(P)}}}_accept(u){this._tabSize=u.tabSize,this._insertSpaces=u.insertSpaces,this._cursorStyle=u.cursorStyle,this._lineNumbers=k.TextEditorLineNumbersStyle.to(u.lineNumbers)}_validateTabSize(u){if(u==="auto")return"auto";if(typeof u=="number"){const f=Math.floor(u);return f>0?f:null}if(typeof u=="string"){const f=parseInt(u,10);return isNaN(f)?null:f>0?f:null}return null}_setTabSize(u){const f=this._validateTabSize(u);if(f!==null){if(typeof f=="number"){if(this._tabSize===f)return;this._tabSize=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:f}))}}_validateInsertSpaces(u){return u==="auto"?"auto":u==="false"?!1:Boolean(u)}_setInsertSpaces(u){const f=this._validateInsertSpaces(u);if(typeof f=="boolean"){if(this._insertSpaces===f)return;this._insertSpaces=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:f}))}_setCursorStyle(u){this._cursorStyle!==u&&(this._cursorStyle=u,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:u})))}_setLineNumbers(u){this._lineNumbers!==u&&(this._lineNumbers=u,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:k.TextEditorLineNumbersStyle.from(u)})))}assign(u){const f={};let l=!1;if(typeof u.tabSize!="undefined"){const v=this._validateTabSize(u.tabSize);v==="auto"?(l=!0,f.tabSize=v):typeof v=="number"&&this._tabSize!==v&&(this._tabSize=v,l=!0,f.tabSize=v)}if(typeof u.insertSpaces!="undefined"){const v=this._validateInsertSpaces(u.insertSpaces);v==="auto"?(l=!0,f.insertSpaces=v):this._insertSpaces!==v&&(this._insertSpaces=v,l=!0,f.insertSpaces=v)}typeof u.cursorStyle!="undefined"&&this._cursorStyle!==u.cursorStyle&&(this._cursorStyle=u.cursorStyle,l=!0,f.cursorStyle=u.cursorStyle),typeof u.lineNumbers!="undefined"&&this._lineNumbers!==u.lineNumbers&&(this._lineNumbers=u.lineNumbers,l=!0,f.lineNumbers=k.TextEditorLineNumbersStyle.from(u.lineNumbers)),l&&this._warnOnError(this._proxy.$trySetOptions(this._id,f))}_warnOnError(u){u.catch(f=>this._logService.warn(f))}}e.ExtHostTextEditorOptions=T;class n{constructor(u,f,l,v,S,P,E,s){this.id=u,this._proxy=f,this._logService=l,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=S,this._options=new T(this._proxy,this.id,P,l),this._visibleRanges=E,this._viewColumn=s;const a=this;this.value=Object.freeze({get document(){return v.getValue()},set document(p){throw(0,L.readonly)("document")},get selection(){return a._selections&&a._selections[0]},set selection(p){if(!(p instanceof R.Selection))throw(0,L.illegalArgument)("selection");a._selections=[p],a._trySetSelection()},get selections(){return a._selections},set selections(p){if(!Array.isArray(p)||p.some(t=>!(t instanceof R.Selection)))throw(0,L.illegalArgument)("selections");a._selections=p,a._trySetSelection()},get visibleRanges(){return a._visibleRanges},set visibleRanges(p){throw(0,L.readonly)("visibleRanges")},get options(){return a._options.value},set options(p){a._disposed||a._options.assign(p)},get viewColumn(){return a._viewColumn},set viewColumn(p){throw(0,L.readonly)("viewColumn")},edit(p,t={undoStopBefore:!0,undoStopAfter:!0}){if(a._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const o=new D(v.getValue(),t);return p(o),a._applyEdit(o)},insertSnippet(p,t,o={undoStopBefore:!0,undoStopAfter:!0}){if(a._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=a._selections.map(i=>k.Range.from(i));else if(t instanceof R.Position){const{lineNumber:i,column:h}=k.Position.from(t);r=[{startLineNumber:i,startColumn:h,endLineNumber:i,endColumn:h}]}else if(t instanceof R.Range)r=[k.Range.from(t)];else{r=[];for(const i of t)if(i instanceof R.Range)r.push(k.Range.from(i));else{const{lineNumber:h,column:c}=k.Position.from(i);r.push({startLineNumber:h,startColumn:c,endLineNumber:h,endColumn:c})}}return f.$tryInsertSnippet(u,p.value,r,o)},setDecorations(p,t){const o=t.length===0;o&&!a._hasDecorationsForKey.has(p.key)||(o?a._hasDecorationsForKey.delete(p.key):a._hasDecorationsForKey.add(p.key),a._runOnProxy(()=>{if(k.isDecorationOptionsArr(t))return f.$trySetDecorations(u,p.key,k.fromRangeOrRangeWithMessage(t));{const r=new Array(4*t.length);for(let i=0,h=t.length;i<h;i++){const c=t[i];r[4*i]=c.start.line+1,r[4*i+1]=c.start.character+1,r[4*i+2]=c.end.line+1,r[4*i+3]=c.end.character+1}return f.$trySetDecorationsFast(u,p.key,r)}}))},revealRange(p,t){a._runOnProxy(()=>f.$tryRevealRange(u,k.Range.from(p),t||R.TextEditorRevealType.Default))},show(p){f.$tryShowEditor(u,k.ViewColumn.from(p))},hide(){f.$tryHideEditor(u)}})}dispose(){(0,m.ok)(!this._disposed),this._disposed=!0}_acceptOptions(u){(0,m.ok)(!this._disposed),this._options._accept(u)}_acceptVisibleRanges(u){(0,m.ok)(!this._disposed),this._visibleRanges=u}_acceptViewColumn(u){(0,m.ok)(!this._disposed),this._viewColumn=u}_acceptSelections(u){(0,m.ok)(!this._disposed),this._selections=u}async _trySetSelection(){const u=this._selections.map(k.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,u)),this.value}_applyEdit(u){const f=u.finalize();if(f.edits.length===0&&!f.setEndOfLine)return Promise.resolve(!0);const l=f.edits.map(S=>S.range);l.sort((S,P)=>S.end.line===P.end.line?S.end.character===P.end.character?S.start.line===P.start.line?S.start.character-P.start.character:S.start.line-P.start.line:S.end.character-P.end.character:S.end.line-P.end.line);for(let S=0,P=l.length-1;S<P;S++){const E=l[S].end;if(l[S+1].start.isBefore(E))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const v=f.edits.map(S=>({range:k.Range.from(S.range),text:S.text,forceMoveMarkers:S.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,f.documentVersionId,v,{setEndOfLine:typeof f.setEndOfLine=="number"?k.EndOfLine.from(f.setEndOfLine):void 0,undoStopBefore:f.undoStopBefore,undoStopAfter:f.undoStopAfter})}_runOnProxy(u){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,f=>(f instanceof Error&&f.name==="DISPOSED"||this._logService.warn(f),null))}}e.ExtHostTextEditor=n}),define(me[222],ge([0,1,168,22,2,3,6,209,18,7,13,17,15,21,206]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function v(E,s){if((0,n.isString)(E))return{label:E};if(E&&typeof E=="object"&&typeof E.label=="string"){let a;return Array.isArray(E.highlights)&&(a=E.highlights.filter(p=>p.length===2&&typeof p[0]=="number"&&typeof p[1]=="number"),a=a.length?a:void 0),{label:E.label,highlights:a}}}class S{constructor(s,a,p){this._proxy=s,this.commands=a,this.logService=p,this.treeViews=new Map;function t(o){return o&&o.$treeViewId&&o.$treeItemHandle}a.registerArgumentProcessor({processArgument:o=>t(o)?this.convertArgument(o):Array.isArray(o)&&o.length>0?o.map(r=>t(r)?this.convertArgument(r):r):o})}registerTreeDataProvider(s,a,p){const t=this.createTreeView(s,{treeDataProvider:a},p);return{dispose:()=>t.dispose()}}createTreeView(s,a,p){if(!a||!a.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const t=a.dragAndDropController!==void 0,o=this._proxy.$registerTreeViewDataProvider(s,{showCollapseAll:!!a.showCollapseAll,canSelectMany:!!a.canSelectMany,canDragAndDrop:t}),r=this.createExtHostTreeView(s,a,p);return{get onDidCollapseElement(){return r.onDidCollapseElement},get onDidExpandElement(){return r.onDidExpandElement},get selection(){return r.selectedElements},get onDidChangeSelection(){return r.onDidChangeSelection},get visible(){return r.visible},get onDidChangeVisibility(){return r.onDidChangeVisibility},get message(){return r.message},set message(i){r.message=i},get title(){return r.title},set title(i){r.title=i},get description(){return r.description},set description(i){r.description=i},reveal:(i,h)=>r.reveal(i,h),dispose:async()=>{await o,this.treeViews.delete(s),r.dispose()}}}$getChildren(s,a){const p=this.treeViews.get(s);return p?p.getChildren(a):Promise.reject(new Error((0,m.localize)(0,null,s)))}async $onDrop(s,a,p){const t=this.treeViews.get(s);if(!t)return Promise.reject(new Error((0,m.localize)(1,null,s)));const o=l.TreeDataTransferConverter.toITreeDataTransfer(a);if(o.items.has(C.TREE_ITEM_DATA_TRANSFER_TYPE)){const i=JSON.parse(await o.items.get(C.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(h=>t.getExtensionElement(h)).filter(h=>!!h);i.length>0?o.items.set(C.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(i)}):o.items.delete(C.TREE_ITEM_DATA_TRANSFER_TYPE)}return t.onDrop(o,p)}async $hasResolve(s){const a=this.treeViews.get(s);if(!a)throw new Error((0,m.localize)(2,null,s));return a.hasResolve}$resolve(s,a,p){const t=this.treeViews.get(s);if(!t)throw new Error((0,m.localize)(3,null,s));return t.resolveTreeItem(a,p)}$setExpanded(s,a,p){const t=this.treeViews.get(s);if(!t)throw new Error((0,m.localize)(4,null,s));t.setExpanded(a,p)}$setSelection(s,a){const p=this.treeViews.get(s);if(!p)throw new Error((0,m.localize)(5,null,s));p.setSelection(a)}$setVisible(s,a){const p=this.treeViews.get(s);if(!p)throw new Error((0,m.localize)(6,null,s));p.setVisible(a)}createExtHostTreeView(s,a,p){const t=new P(s,a,this._proxy,this.commands.converter,this.logService,p);return this.treeViews.set(s,t),t}convertArgument(s){const a=this.treeViews.get(s.$treeViewId);return a?a.getExtensionElement(s.$treeItemHandle):null}}e.ExtHostTreeViews=S;class P extends R.Disposable{constructor(s,a,p,t,o,r){super();if(this.viewId=s,this.proxy=p,this.commands=t,this.logService=o,this.extension=r,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new k.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new k.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new k.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new k.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new k.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new f.CancellationTokenSource,r.contributes&&r.contributes.views)for(const c in r.contributes.views)for(const d of r.contributes.views[c])d.id===s&&(this._title=d.name);this.dataProvider=a.treeDataProvider,this.dndController=a.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(c=>this._onDidChangeData.fire({message:!1,element:c}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(c=>this._onDidChangeData.fire({message:!1,element:c})));let i,h;this._register(k.Event.debounce(this._onDidChangeData.event,(c,d)=>(c||(c={message:!1,elements:[]}),d.element!==!1&&(i||(i=new Promise(b=>h=b),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(d.element)?c.elements.push(...d.element):c.elements.push(d.element)),d.message&&(c.message=!0),c),200,!0)(({message:c,elements:d})=>{d.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const b=h;return i=null,this.refresh(d).then(()=>b())})),c&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(s=>this.getExtensionElement(s)).filter(s=>!(0,n.isUndefinedOrNull)(s))}async getChildren(s){const a=s?this.getExtensionElement(s):void 0;if(s&&!a)return this.logService.error(`No tree item with id '${s}' found.`),Promise.resolve([]);let p=this.getChildrenNodes(s);return p||(p=await this.fetchChildrenNodes(a)),p?p.map(t=>t.item):void 0}getExtensionElement(s){return this.elements.get(s)}reveal(s,a){a=a||{select:!0,focus:!1};const p=(0,n.isUndefinedOrNull)(a.select)?!0:a.select,t=(0,n.isUndefinedOrNull)(a.focus)?!1:a.focus,o=(0,n.isUndefinedOrNull)(a.expand)?!1:a.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):s?this.refreshPromise.then(()=>this.resolveUnknownParentChain(s)).then(r=>this.resolveTreeNode(s,r[r.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:r.map(h=>h.item)},{select:p,focus:t,expand:o})),r=>this.logService.error(r)):this.proxy.$reveal(this.viewId,void 0,{select:p,focus:t,expand:o})}get message(){return this._message}set message(s){this._message=s,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(s){this._title=s,this.proxy.$setTitle(this.viewId,s,this._description)}get description(){return this._description}set description(s){this._description=s,this.proxy.$setTitle(this.viewId,this._title,s)}setExpanded(s,a){const p=this.getExtensionElement(s);p&&(a?this._onDidExpandElement.fire(Object.freeze({element:p})):this._onDidCollapseElement.fire(Object.freeze({element:p})))}setSelection(s){(0,A.equals)(this._selectedHandles,s)||(this._selectedHandles=s,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(s){s!==this._visible&&(this._visible=s,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(s,a){const p=this.getExtensionElement(a);if(!!p)return(0,D.asPromise)(()=>this.dndController?.onDrop(s,p))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(s,a){if(!this.dataProvider.resolveTreeItem)return;const p=this.elements.get(s);if(p){const t=this.nodes.get(p);if(t){const o=await this.dataProvider.resolveTreeItem(t.extensionItem,p,a)??t.extensionItem;return t.item.tooltip=this.getTooltip(o.tooltip),t.item.command=this.getCommand(t.disposableStore,o.command),t.item}}}resolveUnknownParentChain(s){return this.resolveParent(s).then(a=>a?this.resolveUnknownParentChain(a).then(p=>this.resolveTreeNode(a,p[p.length-1]).then(t=>(p.push(t),p))):Promise.resolve([]))}resolveParent(s){const a=this.nodes.get(s);return a?Promise.resolve(a.parent?this.elements.get(a.parent.item.handle):void 0):(0,D.asPromise)(()=>this.dataProvider.getParent(s))}resolveTreeNode(s,a){const p=this.nodes.get(s);return p?Promise.resolve(p):(0,D.asPromise)(()=>this.dataProvider.getTreeItem(s)).then(t=>this.createHandle(s,t,a,!0)).then(t=>this.getChildren(a?a.item.handle:void 0).then(()=>{const o=this.getExtensionElement(t);if(o){const r=this.nodes.get(o);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${t}`)}))}getChildrenNodes(s){if(s){let a;if(typeof s=="string"){const p=this.getExtensionElement(s);a=p?this.nodes.get(p):void 0}else a=s;return a&&a.children||void 0}return this.roots}async fetchChildrenNodes(s){this.clearChildren(s);const a=new f.CancellationTokenSource(this._refreshCancellationSource.token);try{const p=s?this.nodes.get(s):void 0,t=await this.dataProvider.getChildren(s);if(a.token.isCancellationRequested)return;const o=await Promise.all((0,A.coalesce)(t||[]).map(async r=>{const i=await this.dataProvider.getTreeItem(r);return i&&!a.token.isCancellationRequested?this.createAndRegisterTreeNode(r,i,p):null}));return a.token.isCancellationRequested?void 0:(0,A.coalesce)(o)}finally{a.dispose()}}refresh(s){if(s.some(p=>!p))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new f.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const p=this.getHandlesToRefresh(s);if(p.length)return this.refreshHandles(p)}return Promise.resolve(void 0)}getHandlesToRefresh(s){const a=new Set,p=s.map(o=>this.nodes.get(o));for(const o of p)if(o&&!a.has(o.item.handle)){let r=o;for(;r&&r.parent&&p.findIndex(i=>r&&r.parent&&i&&i.item.handle===r.parent.item.handle)===-1;){const i=this.elements.get(r.parent.item.handle);r=i?this.nodes.get(i):void 0}r&&!r.parent&&a.add(o.item.handle)}const t=[];return a.forEach(o=>{const r=this.elements.get(o);if(r){const i=this.nodes.get(r);i&&(!i.parent||!a.has(i.parent.item.handle))&&t.push(o)}}),t}refreshHandles(s){const a={};return Promise.all(s.map(p=>this.refreshNode(p).then(t=>{t&&(a[p]=t.item)}))).then(()=>Object.keys(a).length?this.proxy.$refresh(this.viewId,a):void 0)}refreshNode(s){const a=this.getExtensionElement(s);if(a){const p=this.nodes.get(a);if(p)return this.clearChildren(a),(0,D.asPromise)(()=>this.dataProvider.getTreeItem(a)).then(t=>{if(t){const o=this.createTreeNode(a,t,p.parent);return this.updateNodeCache(a,o,p,p.parent),p.dispose(),o}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(s,a,p){const t=this.createTreeNode(s,a,p);if(a.id&&this.elements.has(t.item.handle))throw new Error((0,m.localize)(7,null,a.id));return this.addNodeToCache(s,t),this.addNodeToParentCache(t,p),t}getTooltip(s){return T.MarkdownString.isMarkdownString(s)?u.MarkdownString.from(s):s}getCommand(s,a){return a?this.commands.toInternal(a,s):void 0}createTreeNode(s,a,p){const t=new R.DisposableStore,o=this.createHandle(s,a,p),r=this.getLightIconPath(a);return{item:{handle:o,parentHandle:p?p.item.handle:void 0,label:v(a.label,this.extension),description:a.description,resourceUri:a.resourceUri,tooltip:this.getTooltip(a.tooltip),command:this.getCommand(t,a.command),contextValue:a.contextValue,icon:r,iconDark:this.getDarkIconPath(a)||r,themeIcon:this.getThemeIcon(a),collapsibleState:(0,n.isUndefinedOrNull)(a.collapsibleState)?T.TreeItemCollapsibleState.None:a.collapsibleState,accessibilityInformation:a.accessibilityInformation},extensionItem:a,parent:p,children:void 0,disposableStore:t,dispose(){t.dispose()}}}getThemeIcon(s){return s.iconPath instanceof T.ThemeIcon?s.iconPath:void 0}createHandle(s,{id:a,label:p,resourceUri:t},o,r){if(a)return`${P.ID_HANDLE_PREFIX}/${a}`;const i=v(p,this.extension),h=o?o.item.handle:P.LABEL_HANDLE_PREFIX;let c=i?i.label:t?(0,L.basename)(t):"";c=c.indexOf("/")!==-1?c.replace("/","//"):c;const d=this.nodes.has(s)?this.nodes.get(s).item.handle:void 0,b=this.getChildrenNodes(o)||[];let y,g=0;do{if(y=`${h}/${g}:${c}`,r||!this.elements.has(y)||d===y)break;g++}while(g<=b.length);return y}getLightIconPath(s){if(s.iconPath&&!(s.iconPath instanceof T.ThemeIcon))return typeof s.iconPath=="string"||I.URI.isUri(s.iconPath)?this.getIconPath(s.iconPath):this.getIconPath(s.iconPath.light)}getDarkIconPath(s){if(s.iconPath&&!(s.iconPath instanceof T.ThemeIcon)&&s.iconPath.dark)return this.getIconPath(s.iconPath.dark)}getIconPath(s){return I.URI.isUri(s)?s:I.URI.file(s)}addNodeToCache(s,a){this.elements.set(a.item.handle,s),this.nodes.set(s,a)}updateNodeCache(s,a,p,t){this.elements.delete(a.item.handle),this.nodes.delete(s),a.item.handle!==p.item.handle&&this.elements.delete(p.item.handle),this.addNodeToCache(s,a);const o=this.getChildrenNodes(t)||[],r=o.filter(i=>i.item.handle===p.item.handle)[0];r&&o.splice(o.indexOf(r),1,a)}addNodeToParentCache(s,a){a?(a.children||(a.children=[]),a.children.push(s)):(this.roots||(this.roots=[]),this.roots.push(s))}clearChildren(s){if(s){const a=this.nodes.get(s);if(a){if(a.children)for(const p of a.children){const t=this.elements.get(p.item.handle);t&&this.clear(t)}a.children=void 0}}else this.clearAll()}clear(s){const a=this.nodes.get(s);if(a){if(a.children)for(const p of a.children){const t=this.elements.get(p.item.handle);t&&this.clear(t)}this.nodes.delete(s),this.elements.delete(a.item.handle),a.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(s=>s.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}P.LABEL_HANDLE_PREFIX="0",P.ID_HANDLE_PREFIX="1"}),define(me[223],ge([0,1,18,3,6,13,64,15,127,89]),function(J,e,m,L,I,k,R,C,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class n extends I.Disposable{constructor(u){super();this.controllerId=u,this.debounceSendDiff=this._register(new m.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new L.Emitter),this.root=new R.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(u){this._resolveHandler=u;for(const f of this.tree.values())this.updateExpandability(f)}collectDiff(){const u=this.diff;return this.diff=[],u}pushDiff(u){const f=this.diff[this.diff.length-1];if(f&&u[0]===1){if(f[0]===1&&f[1].extId===u[1].extId){(0,D.applyTestItemUpdate)(f[1],u[1]);return}if(f[0]===0&&f[1].item.extId===u[1].extId){(0,D.applyTestItemUpdate)(f[1],u[1]);return}}this.diff.push(u),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(u,f){const l=this.tree.get(u);if(!!l){if((l.expandLevels===void 0||f>l.expandLevels)&&(l.expandLevels=f),l.expand===1){const v=this.resolveChildren(l);return v.isOpen()?this.expandChildren(l,f-1):v.wait().then(()=>this.expandChildren(l,f-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.expandChildren(l,f-1)):this.expandChildren(l,f-1)}}dispose(){for(const u of this.tree.values())(0,R.getPrivateApiFor)(u.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(u,f){switch(f.op){case 2:this.pushDiff([4,u.fullId.toString()]);break;case 1:this.removeItem(T.TestId.joinToString(u.fullId,f.id));break;case 0:this.upsertItem(f.item,u);break;case 4:for(const E of f.ops)this.onTestItemEvent(u,E);break;case 3:const{key:l,value:v,previous:S}=f,P=u.fullId.toString();switch(l){case"canResolveChildren":this.updateExpandability(u);break;case"tags":this.diffTagRefs(v,S,P);break;case"range":this.pushDiff([1,{extId:P,item:{range:C.Range.from(v)}}]);break;case"error":this.pushDiff([1,{extId:P,item:{error:C.MarkdownString.fromStrict(v)||null}}]);break;default:this.pushDiff([1,{extId:P,item:{[l]:v??null}}]);break}break;default:(0,k.assertNever)(f)}}upsertItem(u,f){if(!(u instanceof R.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${u.id} did not`);const l=T.TestId.fromExtHostTestItem(u,this.root.id,f?.actual),v=(0,R.getPrivateApiFor)(u);v.parent&&v.parent!==f?.actual&&v.parent.children.delete(u.id);let S=this.tree.get(l.toString());if(!S){S={fullId:l,actual:u,parent:f?l.parentId:null,expandLevels:f?.expandLevels?f.expandLevels-1:void 0,expand:0},u.tags.forEach(this.incrementTagRefs,this),this.tree.set(S.fullId.toString(),S),this.setItemParent(u,f),this.pushDiff([0,{parent:S.parent&&S.parent.toString(),controllerId:this.controllerId,expand:S.expand,item:C.TestItem.from(u)}]),this.connectItemAndChildren(u,S,f);return}if(S.actual===u){this.connectItem(u,S,f);return}const P=S.actual.children,E=S.actual,s=(0,R.diffTestItems)(E,u);(0,R.getPrivateApiFor)(E).listener=void 0,S.actual=u,S.expand=0;for(const[a,p]of s)this.onTestItemEvent(S,{op:3,key:a,value:p,previous:E[a]});this.connectItemAndChildren(u,S,f);for(const a of P)u.children.get(a.id)||this.removeItem(T.TestId.joinToString(l,a.id))}diffTagRefs(u,f,l){const v=new Set(f.map(S=>S.id));for(const S of u)v.delete(S.id)||this.incrementTagRefs(S);this.pushDiff([1,{extId:l,item:{tags:u.map(S=>C.TestTag.namespace(this.controllerId,S.id))}}]),v.forEach(this.decrementTagRefs,this)}incrementTagRefs(u){const f=this.tags.get(u.id);f?f.refCount++:(this.tags.set(u.id,{refCount:1}),this.pushDiff([5,{id:C.TestTag.namespace(this.controllerId,u.id),ctrlLabel:this.root.label}]))}decrementTagRefs(u){const f=this.tags.get(u);f&&!--f.refCount&&(this.tags.delete(u),this.pushDiff([6,C.TestTag.namespace(this.controllerId,u)]))}setItemParent(u,f){(0,R.getPrivateApiFor)(u).parent=f&&f.actual!==this.root?f.actual:void 0}connectItem(u,f,l){this.setItemParent(u,l);const v=(0,R.getPrivateApiFor)(u);v.parent=l?.actual,v.listener=S=>this.onTestItemEvent(f,S),this.updateExpandability(f)}connectItemAndChildren(u,f,l){this.connectItem(u,f,l);for(const v of u.children)this.upsertItem(v,f)}updateExpandability(u){let f;this._resolveHandler?u.resolveBarrier?f=u.resolveBarrier.isOpen()?3:2:f=u.actual.canResolveChildren?1:0:f=0,f!==u.expand&&(u.expand=f,this.pushDiff([1,{extId:u.fullId.toString(),expand:f}]),f===1&&u.expandLevels!==void 0&&this.resolveChildren(u))}expandChildren(u,f){if(f<0)return;const l=[];for(const v of u.actual.children){const S=this.expand(T.TestId.joinToString(u.fullId,v.id),f);(0,m.isThenable)(S)&&l.push(S)}if(l.length)return Promise.all(l).then(()=>{})}resolveChildren(u){if(u.resolveBarrier)return u.resolveBarrier;if(!this._resolveHandler){const S=new m.Barrier;return S.open(),S}u.expand=2,this.pushExpandStateUpdate(u);const f=u.resolveBarrier=new m.Barrier,l=S=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),u.actual!==this.root&&(u.actual.error=S.stack||S.message||String(S))};let v;try{v=this._resolveHandler(u.actual===this.root?void 0:u.actual)}catch(S){l(S)}return(0,m.isThenable)(v)?v.catch(l).then(()=>{f.open(),this.updateExpandability(u)}):(f.open(),this.updateExpandability(u)),u.resolveBarrier}pushExpandStateUpdate(u){this.pushDiff([1,{extId:u.fullId.toString(),expand:u.expand}])}removeItem(u){const f=this.tree.get(u);if(!f)throw new Error("attempting to remove non-existent child");this.pushDiff([2,u]);const l=[f];for(;l.length;){const v=l.pop();if(!!v){(0,R.getPrivateApiFor)(v.actual).listener=void 0;for(const S of v.actual.tags)this.decrementTagRefs(S.id);this.tree.delete(v.fullId.toString());for(const S of v.actual.children)l.push(this.tree.get(T.TestId.joinToString(v.fullId,S.id)))}}}flushDiff(){const u=this.collectDiff();u.length&&this.diffOpEmitter.fire(u)}}e.SingleUseTestCollection=n}),define(me[224],ge([0,1,4,183]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,m.refineServiceDecorator)(L.IEnvironmentService)}),define(me[225],ge([0,1,26,3,8]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class k{constructor(n){this.removedDueToLooping=n}}e.DeltaExtensionsResult=k;class R{constructor(n){this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=n,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const n of this._extensionDescriptions){if(this._extensionsMap.has(m.ExtensionIdentifier.toKey(n.identifier))){console.error("Extension `"+n.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(m.ExtensionIdentifier.toKey(n.identifier),n),this._extensionsArr.push(n),Array.isArray(n.activationEvents))for(let A of n.activationEvents)A==="onUri"&&(A=`onUri:${m.ExtensionIdentifier.toKey(n.identifier)}`),this._activationMap.has(A)||this._activationMap.set(A,[]),this._activationMap.get(A).push(n)}}keepOnly(n){const A=new Set;n.forEach(u=>A.add(m.ExtensionIdentifier.toKey(u))),this._extensionDescriptions=this._extensionDescriptions.filter(u=>A.has(m.ExtensionIdentifier.toKey(u.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(n,A){n.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(n));const u=R._findLoopingExtensions(this._extensionDescriptions);if(A=A.concat(u.map(f=>f.identifier)),A.length>0){const f=new Set;A.forEach(l=>f.add(m.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>!f.has(m.ExtensionIdentifier.toKey(l.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new k(u)}static _findLoopingExtensions(n){const A=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(S){this._nodesSet.has(S)||(this._nodesSet.add(S),this._nodesArr.push(S))}addArc(S,P){this.addNode(S),this.addNode(P),this._arcs.has(S)?this._arcs.get(S).push(P):this._arcs.set(S,[P])}getArcs(S){return this._arcs.has(S)?this._arcs.get(S):[]}hasOnlyGoodArcs(S,P){const E=A.getArcs(S);for(let s=0;s<E.length;s++)if(!P.has(E[s]))return!1;return!0}getNodes(){return this._nodesArr}};let u=new Map;for(let S of n){const P=m.ExtensionIdentifier.toKey(S.identifier);if(u.set(P,S),S.extensionDependencies)for(let E of S.extensionDependencies){const s=m.ExtensionIdentifier.toKey(E);A.addArc(P,s)}}let f=new Set;A.getNodes().filter(S=>A.getArcs(S).length===0).forEach(S=>f.add(S));let l=A.getNodes().filter(S=>!f.has(S)),v;do{v=!1;for(let S=0;S<l.length;S++){const P=l[S];A.hasOnlyGoodArcs(P,f)&&(l.splice(S,1),S--,f.add(P),v=!0)}}while(v);return l.map(S=>u.get(S))}containsActivationEvent(n){return this._activationMap.has(n)}containsExtension(n){return this._extensionsMap.has(m.ExtensionIdentifier.toKey(n))}getExtensionDescriptionsForActivationEvent(n){const A=this._activationMap.get(n);return A?A.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(n){const A=this._extensionsMap.get(m.ExtensionIdentifier.toKey(n));return A||void 0}}e.ExtensionDescriptionRegistry=R;var C;(function(T){T[T.Builtin=0]="Builtin",T[T.User=1]="User",T[T.Dev=2]="Dev"})(C||(C={}));function D(T,n){const A=T.isBuiltin?0:T.isUnderDevelopment?2:1,u=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(A!==u)return A-u;const f=I.posix.basename(T.extensionLocation.path),l=I.posix.basename(n.extensionLocation.path);return f<l?-1:f>l?1:0}}),define(me[226],ge([0,1,23]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var L;(function(C){C[C.VersionMismatch=55]="VersionMismatch",C[C.UnexpectedError=81]="UnexpectedError"})(L=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var I;(function(C){C[C.Initialized=0]="Initialized",C[C.Ready=1]="Ready",C[C.Terminate=2]="Terminate"})(I=e.MessageType||(e.MessageType={}));function k(C){const D=m.VSBuffer.alloc(1);switch(C){case 0:D.writeUInt8(1,0);break;case 1:D.writeUInt8(2,0);break;case 2:D.writeUInt8(3,0);break}return D}e.createMessageOfType=k;function R(C,D){if(C.byteLength!==1)return!1;switch(C.readUInt8(0)){case 1:return D===0;case 2:return D===1;case 3:return D===2;default:return!1}}e.isMessageOfType=R}),define(me[36],ge([0,1,3,2,4,26,185]),function(J,e,m,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new k.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,I.createDecorator)("extensionService");var C;(function(s){s[s.None=0]="None",s[s.LocalProcess=1]="LocalProcess",s[s.LocalWebWorker=2]="LocalWebWorker",s[s.Remote=3]="Remote"})(C=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));class D{constructor(a){this.dependency=a}}e.MissingExtensionDependency=D;var T;(function(s){s[s.LocalProcess=0]="LocalProcess",s[s.LocalWebWorker=1]="LocalWebWorker",s[s.Remote=2]="Remote"})(T=e.ExtensionHostKind||(e.ExtensionHostKind={}));function n(s){switch(s){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=n;class A{constructor(a,p,t,o){this.codeLoadingTime=a,this.activateCallTime=p,this.activateResolvedTime=t,this.activationReason=o}}e.ActivationTimes=A;class u{constructor(a,p){this.description=a,this.value=p}}e.ExtensionPointContribution=u,e.ExtensionHostLogFileName="exthost";var f;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(f=e.ActivationKind||(e.ActivationKind={}));function l(s){s.enableProposedApi||v(s)}e.checkProposedApiEnabled=l;function v(s){throw new Error(`[${s.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${s.identifier.value}`)}e.throwProposedApiError=v;function S(s){return{type:s.isBuiltin?0:1,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,R.getGalleryExtensionId)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation}}e.toExtension=S;function P(s,a){return{identifier:new k.ExtensionIdentifier(s.identifier.id),isBuiltin:s.type===0,isUserBuiltin:s.type===1&&s.isBuiltin,isUnderDevelopment:!!a,extensionLocation:s.location,...s.manifest,uuid:s.identifier.uuid}}e.toExtensionDescription=P;class E{constructor(){this.onDidRegisterExtensions=m.Event.None,this.onDidChangeExtensionsStatus=m.Event.None,this.onDidChangeExtensions=m.Event.None,this.onWillActivateByEvent=m.Event.None,this.onDidChangeResponsiveChange=m.Event.None}activateByEvent(a){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(a){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(a){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(a){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(a,p){return Promise.resolve()}_onWillActivateExtension(a){}_onDidActivateExtension(a,p,t,o,r){}_onDidActivateExtensionError(a,p){}_onExtensionRuntimeError(a,p){}_onExtensionHostExit(a){}}e.NullExtensionService=E}),define(me[227],ge([0,1,26,36,12]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const k=Promise.resolve(void 0);class R{constructor(l,v,S,P){this.startup=l,this.codeLoadingTime=v,this.activateCallTime=S,this.activateResolvedTime=P}}e.ExtensionActivationTimes=R,R.NONE=new R(!1,-1,-1,-1);class C{constructor(l){this._startup=l,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(l,v){return l===-1||v===-1?-1:v-l}build(){return new R(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=C;class D{constructor(l,v,S,P,E,s){this.activationFailed=l,this.activationFailedError=v,this.activationTimes=S,this.module=P,this.exports=E,this.subscriptions=s}}e.ActivatedExtension=D;class T extends D{constructor(l){super(!1,null,l,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=T;class n extends D{constructor(){super(!1,null,R.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=n;class A extends D{constructor(l){super(!0,l,R.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=A;let u=class{constructor(l,v,S,P,E){this._logService=E,this._registry=l,this._resolvedExtensionsSet=new Set,v.forEach(s=>this._resolvedExtensionsSet.add(m.ExtensionIdentifier.toKey(s))),this._hostExtensionsMap=new Map,S.forEach(s=>this._hostExtensionsMap.set(m.ExtensionIdentifier.toKey(s),s)),this._host=P,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(l){const v=m.ExtensionIdentifier.toKey(l);return this._activatedExtensions.has(v)}getActivatedExtension(l){const v=m.ExtensionIdentifier.toKey(l),S=this._activatedExtensions.get(v);if(!S)throw new Error("Extension `"+l.value+"` is not known or not activated");return S}activateByEvent(l,v){if(this._alreadyActivatedEvents[l])return k;const S=this._registry.getExtensionDescriptionsForActivationEvent(l);return this._activateExtensions(S.map(P=>({id:P.identifier,reason:{startup:v,extensionId:P.identifier,activationEvent:l}}))).then(()=>{this._alreadyActivatedEvents[l]=!0})}activateById(l,v){const S=this._registry.getExtensionDescription(l);if(!S)throw new Error("Extension `"+l+"` is not known");return this._activateExtensions([{id:S.identifier,reason:v}])}_handleActivateRequest(l,v,S){if(this._hostExtensionsMap.has(m.ExtensionIdentifier.toKey(l.id))){v[m.ExtensionIdentifier.toKey(l.id)]=l;return}const P=this._registry.getExtensionDescription(l.id);if(!P){const a=new Error(`Cannot activate unknown extension '${l.id.value}'`);this._host.onExtensionActivationError(l.id,a,new L.MissingExtensionDependency(l.id.value)),this._activatedExtensions.set(m.ExtensionIdentifier.toKey(l.id),new A(a));return}const E=typeof P.extensionDependencies=="undefined"?[]:P.extensionDependencies;let s=!0;for(let a=0,p=E.length;a<p;a++){const t=E[a];if(this._resolvedExtensionsSet.has(m.ExtensionIdentifier.toKey(t)))continue;const o=this._activatedExtensions.get(m.ExtensionIdentifier.toKey(t));if(o&&!o.activationFailed)continue;if(o&&o.activationFailed){const c=P.displayName||P.identifier.value,d=this._registry.getExtensionDescription(t),b=d&&d.displayName||t,y=new Error(`Cannot activate the '${c}' extension because its dependency '${b}' failed to activate`);y.detail=o.activationFailedError,this._host.onExtensionActivationError(P.identifier,y,null),this._activatedExtensions.set(m.ExtensionIdentifier.toKey(P.identifier),new A(y));return}if(this._hostExtensionsMap.has(m.ExtensionIdentifier.toKey(t))){s=!1,v[m.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(m.ExtensionIdentifier.toKey(t)),reason:l.reason};continue}const r=this._registry.getExtensionDescription(t);if(r){s=!1,v[m.ExtensionIdentifier.toKey(t)]={id:r.identifier,reason:l.reason};continue}const i=P.displayName||P.identifier.value,h=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(P.identifier,h,new L.MissingExtensionDependency(t)),this._activatedExtensions.set(m.ExtensionIdentifier.toKey(P.identifier),new A(h));return}s?v[m.ExtensionIdentifier.toKey(P.identifier)]=l:S.push(l)}_activateExtensions(l){if(l.length===0||(l=l.filter(E=>!this._activatedExtensions.has(m.ExtensionIdentifier.toKey(E.id))),l.length===0))return Promise.resolve(void 0);const v=Object.create(null),S=[];for(let E=0,s=l.length;E<s;E++)this._handleActivateRequest(l[E],v,S);for(let E=0,s=S.length;E<s;E++){const a=m.ExtensionIdentifier.toKey(S[E].id);v[a]&&delete v[a]}const P=Object.keys(v).map(E=>v[E]);return S.length===0?Promise.all(P.map(E=>this._activateExtension(E.id,E.reason))).then(E=>{}):this._activateExtensions(P).then(E=>this._activateExtensions(S))}_activateExtension(l,v){const S=m.ExtensionIdentifier.toKey(l);if(this._activatedExtensions.has(S))return Promise.resolve(void 0);const P=this._activatingExtensions.get(S);if(P)return P;const E=this._host.actualActivateExtension(l,v).then(void 0,s=>{const a=new Error;return s&&s.name&&(a.name=s.name),s&&s.message?a.message=`Activating extension '${l.value}' failed: ${s.message}.`:a.message=`Activating extension '${l.value}' failed: ${s}.`,s&&s.stack&&(a.stack=s.stack),this._host.onExtensionActivationError(l,a,null),this._logService.error(`Activating extension ${l.value} failed due to an error:`),this._logService.error(s),new A(s)}).then(s=>{this._activatedExtensions.set(S,s),this._activatingExtensions.delete(S)});return this._activatingExtensions.set(S,E),E}};u=Ve([We(4,I.ILogService)],u),e.ExtensionsActivator=u}),define(me[228],ge([0,1,12,36,27,10,116]),function(J,e,m,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let C=class extends m.LogService{constructor(T){if(T.logFile.scheme!==k.Schemas.file)throw new Error("Only file-logging supported");super(new R.SpdLogLogger(L.ExtensionHostLogFileName,T.logFile.fsPath,!0,T.logLevel))}$setLevel(T){this.setLevel(T)}};C=Ve([We(0,I.IExtHostInitDataService)],C),e.ExtHostLogService=C}),define(me[229],ge([0,1,16]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class L{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((k,R)=>{this._actualOk=k,this._actualErr=R,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(k){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=k,this._actual&&this._actualOk(k))}resolveErr(k){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=k,this._actual?this._actualErr(k):(0,m.onUnexpectedError)(k))}then(k,R){return this._ensureActual().then(k,R)}catch(k){return this._ensureActual().then(void 0,k)}finally(k){return this._ensureActual().finally(k)}}e.LazyPromise=L}),define(me[66],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class m{constructor(T,n){this._proxyIdentifierBrand=void 0,this.isMain=T,this.sid=n,this.nid=++m.count}}e.ProxyIdentifier=m,m.count=0;const L=[];function I(D){const T=new m(!0,D);return L[T.nid]=T,T}e.createMainContextProxyIdentifier=I;function k(D){const T=new m(!1,D);return L[T.nid]=T,T}e.createExtHostContextProxyIdentifier=k;function R(D){return L[D].sid}e.getStringIdentifierForProxy=R;class C{constructor(T){this.value=T}}e.SerializableObjectWithBuffers=C}),define(me[5],ge([0,1,60,2,66]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var k;(function(s){s[s.Desktop=1]="Desktop",s[s.Web=2]="Web"})(k=e.UIKind||(e.UIKind={}));var R;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(R=e.TextEditorRevealType||(e.TextEditorRevealType={}));var C;(function(s){s[s.Editable=0]="Editable",s[s.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(s){s[s.Int8Array=1]="Int8Array",s[s.Uint8Array=2]="Uint8Array",s[s.Uint8ClampedArray=3]="Uint8ClampedArray",s[s.Int16Array=4]="Int16Array",s[s.Uint16Array=5]="Uint16Array",s[s.Int32Array=6]="Int32Array",s[s.Uint32Array=7]="Uint32Array",s[s.Float32Array=8]="Float32Array",s[s.Float64Array=9]="Float64Array",s[s.BigInt64Array=10]="BigInt64Array",s[s.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var T;(function(s){s[s.Text=1]="Text",s[s.Error=2]="Error",s[s.Rich=3]="Rich"})(T=e.CellOutputKind||(e.CellOutputKind={}));var n;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(n=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var A;(function(s){s[s.None=0]="None",s[s.Process=1]="Process",s[s.Output=2]="Output"})(A=e.CandidatePortSource||(e.CandidatePortSource={}));var u;(function(s){s.name="$ident";function a(t,o){return Object.defineProperty(t,s.name,{value:o,enumerable:!0}),t}s.mixin=a;function p(t){return t[s.name]}s.of=p})(u=e.ObjectIdentifier||(e.ObjectIdentifier={}));class f{static mixin(a){return a._id=f._n++,a}}e.IdObject=f,f._n=0;var l;(function(s){s.label="a",s.kind="b",s.detail="c",s.documentation="d",s.sortText="e",s.filterText="f",s.preselect="g",s.insertText="h",s.insertTextRules="i",s.range="j",s.commitCharacters="k",s.additionalTextEdits="l",s.command="m",s.kindModifier="n"})(l=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var v;(function(s){s.defaultRanges="a",s.completions="b",s.isIncomplete="c",s.duration="d"})(v=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var S;(function(s){s[s.File=1]="File",s[s.Text=2]="Text",s[s.Cell=3]="Cell"})(S=e.WorkspaceEditType||(e.WorkspaceEditType={}));function P(s){if(s&&s.edits)for(const a of s.edits)typeof a.resource=="object"?a.resource=L.URI.revive(a.resource):(a.newUri=L.URI.revive(a.newUri),a.oldUri=L.URI.revive(a.oldUri)),a.metadata&&a.metadata.iconPath&&(a.metadata=(0,m.revive)(a.metadata));return s}e.reviveWorkspaceEditDto=P;var E;(function(s){s[s.Workspace=0]="Workspace",s[s.TextDocument=1]="TextDocument"})(E=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,I.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,I.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,I.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,I.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,I.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,I.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,I.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,I.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,I.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,I.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,I.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,I.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,I.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,I.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,I.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,I.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,I.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,I.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,I.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,I.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,I.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,I.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,I.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,I.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,I.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,I.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,I.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,I.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,I.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,I.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,I.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,I.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,I.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,I.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,I.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,I.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,I.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,I.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,I.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,I.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,I.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,I.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,I.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,I.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,I.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,I.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,I.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,I.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,I.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,I.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,I.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,I.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,I.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,I.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,I.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,I.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,I.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,I.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,I.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,I.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,I.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,I.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,I.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(me[90],ge([0,1,5,3,4]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class k{constructor(C){this._onDidChangePassword=new L.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=C.getProxy(m.MainContext.MainThreadSecretState)}async $onDidChangePassword(C){this._onDidChangePassword.fire(C)}get(C,D){return this._proxy.$getPassword(C,D)}store(C,D,T){return this._proxy.$setPassword(C,D,T)}delete(C,D){return this._proxy.$deletePassword(C,D)}}e.ExtHostSecretState=k,e.IExtHostSecretState=(0,I.createDecorator)("IExtHostSecretState")}),define(me[67],ge([0,1,4,12,5,14]),function(J,e,m,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,m.createDecorator)("IExtHostApiDeprecationService");let R=class{constructor(D,T){this._extHostLogService=T,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(I.MainContext.MainThreadTelemetry)}report(D,T,n){const A=this.getUsageKey(D,T);this._reportedUsages.has(A)||(this._reportedUsages.add(A),T.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${n}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:T.identifier.value,apiId:D}))}getUsageKey(D,T){return`${D}-${T.identifier.value}`}};R=Ve([We(0,k.IExtHostRpcService),We(1,L.ILogService)],R),e.ExtHostApiDeprecationService=R,e.NullApiDeprecationService=Object.freeze(new class{report(C,D,T){}})}),define(me[230],ge([0,1,3,5,7,26]),function(J,e,m,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class R{constructor(D){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new m.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=D.getProxy(L.MainContext.MainThreadAuthentication)}$setProviders(D){return this._providers=D,Promise.resolve()}async getSession(D,T,n,A={}){const u=k.ExtensionIdentifier.toKey(D.identifier),f=this._inFlightRequests.get(u)||[],l=[...n].sort().join(" ");let v=f.find(S=>S.scopes===l);if(v)return v.result;{const S=this._getSession(D,u,T,n,A);v={scopes:l,result:S},f.push(v),this._inFlightRequests.set(u,f);try{await S}finally{const P=f.findIndex(E=>E.scopes===l);P>-1&&(f.splice(P),this._inFlightRequests.set(u,f))}return S}}async _getSession(D,T,n,A,u={}){await this._proxy.$ensureProvider(n);const f=D.displayName||D.name;return this._proxy.$getSession(n,A,T,f,u)}async removeSession(D,T){const n=this._authenticationProviders.get(D);return n?n.provider.removeSession(T):this._proxy.$removeSession(D,T)}registerAuthenticationProvider(D,T,n,A){if(this._authenticationProviders.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this._authenticationProviders.set(D,{label:T,provider:n,options:A??{supportsMultipleAccounts:!1}}),this._providers.find(f=>f.id===D)||this._providers.push({id:D,label:T});const u=n.onDidChangeSessions(f=>{this._proxy.$sendDidChangeSessions(D,{added:f.added??[],changed:f.changed??[],removed:f.removed??[]})});return this._proxy.$registerAuthenticationProvider(D,T,A?.supportsMultipleAccounts??!1),new I.Disposable(()=>{u.dispose(),this._authenticationProviders.delete(D);const f=this._providers.findIndex(l=>l.id===D);f>-1&&this._providers.splice(f),this._proxy.$unregisterAuthenticationProvider(D)})}$createSession(D,T){const n=this._authenticationProviders.get(D);if(n)return Promise.resolve(n.provider.createSession(T));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,T){const n=this._authenticationProviders.get(D);if(n)return Promise.resolve(n.provider.removeSession(T));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,T){const n=this._authenticationProviders.get(D);if(n)return Promise.resolve(n.provider.getSessions(T));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,T){return this._onDidChangeSessions.fire({provider:{id:D,label:T}}),Promise.resolve()}}e.ExtHostAuthentication=R}),define(me[231],ge([0,1,5,14,15]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let k=class{constructor(C,D){this._extHostDocumentsAndEditors=D,this._proxy=C.getProxy(m.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(C){const D=I.WorkspaceEdit.from(C,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(D)}};k=Ve([We(0,L.IExtHostRpcService)],k),e.ExtHostBulkEdits=k}),define(me[232],ge([0,1,5]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class L{constructor(k){const R=k.getProxy(m.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(C){return R.$writeText(C)}})}}e.ExtHostClipboard=L}),define(me[44],ge([0,1,13,7,15,25,5,17,12,60,41,51,2,6,4,14,64]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,l,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let P=class{constructor(o,r){this._commands=new Map,this._apiCommands=new Map,this._proxy=o.getProxy(R.MainContext.MainThreadCommands),this._logService=r,this.converter=new E(this,i=>{const h=this._apiCommands.get(i);return h?.result===a.Void?h:void 0},r),this._argumentProcessors=[{processArgument(i){return(0,T.revive)(i)}},{processArgument(i){return(0,k.cloneAndChange)(i,function(h){if(n.Range.isIRange(h))return I.Range.to(h);if(A.Position.isIPosition(h))return I.Position.to(h);if(n.Range.isIRange(h.range)&&u.URI.isUri(h.uri))return I.location.to(h);if(!Array.isArray(h))return h})}}]}registerArgumentProcessor(o){this._argumentProcessors.push(o)}registerApiCommand(o){const r=this.registerCommand(!1,o.id,async(...i)=>{const h=o.args.map((d,b)=>{if(!d.validate(i[b]))throw new Error(`Invalid argument '${d.name}' when running '${o.id}', received: ${i[b]}`);return d.convert(i[b])}),c=await this.executeCommand(o.internalId,...h);return o.result.convert(c,i,this.converter)},void 0,{description:o.description,args:o.args,returns:o.result.description});return this._apiCommands.set(o.id,o),new L.Disposable(()=>{r.dispose(),this._apiCommands.delete(o.id)})}registerCommand(o,r,i,h,c){if(this._logService.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this._commands.has(r))throw new Error(`command '${r}' already exists`);return this._commands.set(r,{callback:i,thisArg:h,description:c}),o&&this._proxy.$registerCommand(r),new L.Disposable(()=>{this._commands.delete(r)&&o&&this._proxy.$unregisterCommand(r)})}executeCommand(o,...r){return this._logService.trace("ExtHostCommands#executeCommand",o),this._doExecuteCommand(o,r,!0)}async _doExecuteCommand(o,r,i){if(this._commands.has(o))return this._executeContributedCommand(o,r);{const h=(0,k.cloneAndChange)(r,function(c){if(c instanceof L.Position)return I.Position.from(c);if(c instanceof L.Range)return I.Range.from(c);if(c instanceof L.Location)return I.location.from(c);if(L.NotebookRange.isNotebookRange(c))return I.NotebookRange.from(c);if(!Array.isArray(c))return c});try{const c=await this._proxy.$executeCommand(o,h,i);return(0,T.revive)(c)}catch(c){if(c instanceof Error&&c.message==="$executeCommand:retry")return this._doExecuteCommand(o,r,!1);throw c}}}async _executeContributedCommand(o,r){const i=this._commands.get(o);if(!i)throw new Error("Unknown command");let{callback:h,thisArg:c,description:d}=i;if(d)for(let b=0;b<d.args.length;b++)try{(0,m.validateConstraint)(r[b],d.args[b].constraint)}catch(y){throw new Error(`Running the contributed command: '${o}' failed. Illegal argument '${d.args[b].name}' - ${d.args[b].description}`)}try{return await h.apply(c,r)}catch(b){if(o===this.converter.delegatingCommandId){const y=this.converter.getActualCommand(...r);y&&(o=y.command)}throw this._logService.error(b,o),new Error(`Running the contributed command: '${o}' failed.`)}}$executeContributedCommand(o,...r){return this._logService.trace("ExtHostCommands#$executeContributedCommand",o),this._commands.has(o)?(r=r.map(i=>this._argumentProcessors.reduce((h,c)=>c.processArgument(h),i)),this._executeContributedCommand(o,r)):Promise.reject(new Error(`Contributed command '${o}' does not exist.`))}getCommands(o=!1){return this._logService.trace("ExtHostCommands#getCommands",o),this._proxy.$getCommands().then(r=>(o&&(r=r.filter(i=>i[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const o=Object.create(null);for(let[r,i]of this._commands){let{description:h}=i;h&&(o[r]=h)}return Promise.resolve(o)}};P=Ve([We(0,v.IExtHostRpcService),We(1,D.ILogService)],P),e.ExtHostCommands=P,e.IExtHostCommands=(0,l.createDecorator)("IExtHostCommands");class E{constructor(o,r,i){this._commands=o,this._lookupApiCommand=r,this._logService=i,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(o,r){if(!o)return;const i={$ident:void 0,id:o.command,title:o.title,tooltip:o.tooltip};if(!o.command)return i;const h=this._lookupApiCommand(o.command);if(h)i.id=h.internalId,i.arguments=h.args.map((c,d)=>c.convert(o.arguments&&o.arguments[d]));else if((0,C.isNonEmptyArray)(o.arguments)){const c=++this._cachIdPool;this._cache.set(c,o),r.add((0,f.toDisposable)(()=>{this._cache.delete(c),this._logService.trace("CommandsConverter#DISPOSE",c)})),i.$ident=c,i.id=this.delegatingCommandId,i.arguments=[c],this._logService.trace("CommandsConverter#CREATE",o.command,c)}return i}fromInternal(o){const r=R.ObjectIdentifier.of(o);return typeof r=="number"?this._cache.get(r):{command:o.id,title:o.title,arguments:o.arguments}}getActualCommand(...o){return this._cache.get(o[0])}_executeConvertedCommand(...o){const r=this.getActualCommand(...o);return this._logService.trace("CommandsConverter#EXECUTE",o[0],r?r.command:"MISSING"),r?this._commands.executeCommand(r.command,...r.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=E;class s{constructor(o,r,i,h){this.name=o,this.description=r,this.validate=i,this.convert=h}optional(){return new s(this.name,`(optional) ${this.description}`,o=>o==null||this.validate(o),o=>o===void 0?void 0:o===null?null:this.convert(o))}with(o,r){return new s(o??this.name,r??this.description,this.validate,this.convert)}}e.ApiCommandArgument=s,s.Uri=new s("uri","Uri of a text document",t=>u.URI.isUri(t),t=>t),s.Position=new s("position","A position in a text document",t=>L.Position.isPosition(t),I.Position.from),s.Range=new s("range","A range in a text document",t=>L.Range.isRange(t),I.Range.from),s.Selection=new s("selection","A selection in a text document",t=>L.Selection.isSelection(t),I.Selection.from),s.Number=new s("number","",t=>typeof t=="number",t=>t),s.String=new s("string","",t=>typeof t=="string",t=>t),s.CallHierarchyItem=new s("item","A call hierarchy item",t=>t instanceof L.CallHierarchyItem,I.CallHierarchyItem.from),s.TypeHierarchyItem=new s("item","A type hierarchy item",t=>t instanceof L.TypeHierarchyItem,I.TypeHierarchyItem.from),s.TestItem=new s("testItem","A VS Code TestItem",t=>t instanceof S.TestItemImpl,I.TestItem.from);class a{constructor(o,r){this.description=o,this.convert=r}}e.ApiCommandResult=a,a.Void=new a("no result",t=>t);class p{constructor(o,r,i,h,c){this.id=o,this.internalId=r,this.description=i,this.args=h,this.result=c}}e.ApiCommand=p}),define(me[233],ge([0,1,15,7,83,44,17,111]),function(J,e,m,L,I,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const D=[new k.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",n(m.DocumentHighlight.to))),new k.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[k.ApiCommandArgument.Uri],new k.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(u,f)=>{if((0,R.isFalsyOrEmpty)(u))return;class l extends L.SymbolInformation{static to(S){const P=new l(S.name,m.SymbolKind.to(S.kind),S.containerName||"",new L.Location(f[0],m.Range.to(S.range)));return P.detail=S.detail,P.range=P.location.range,P.selectionRange=m.Range.to(S.selectionRange),P.children=S.children?S.children.map(l.to):[],P}}return u.map(l.to)})),new k.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[k.ApiCommandArgument.Uri,new k.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new k.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(m.TextEdit.to))),new k.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Range,new k.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new k.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(m.TextEdit.to))),new k.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position,new k.ApiCommandArgument("ch","Trigger character",u=>typeof u=="string",u=>u),new k.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new k.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(m.TextEdit.to))),new k.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",A)),new k.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",A)),new k.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",A)),new k.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",A)),new k.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Location-instances.",n(m.location.to))),new k.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Hover-instances.",n(m.Hover.to))),new k.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[k.ApiCommandArgument.Uri,new k.ApiCommandArgument("position","A position in a text document",u=>Array.isArray(u)&&u.every(f=>L.Position.isPosition(f)),u=>u.map(m.Position.from))],new k.ApiCommandResult("A promise that resolves to an array of ranges.",u=>u.map(f=>{let l;for(const v of f.reverse())l=new L.SelectionRange(m.Range.to(v),l);return l}))),new k.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[k.ApiCommandArgument.String.with("query","Search string")],new k.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",u=>{const f=[];if(Array.isArray(u))for(let l of u)f.push(...l[1].map(m.WorkspaceSymbol.to));return f})),new k.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(m.CallHierarchyItem.to))),new k.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[k.ApiCommandArgument.CallHierarchyItem],new k.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(m.CallHierarchyIncomingCall.to))),new k.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[k.ApiCommandArgument.CallHierarchyItem],new k.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(m.CallHierarchyOutgoingCall.to))),new k.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position,k.ApiCommandArgument.String.with("newName","The new symbol name")],new k.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",u=>{if(!!u){if(u.rejectReason)throw new Error(u.rejectReason);return m.WorkspaceEdit.to(u)}})),new k.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new k.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",u=>u.map(m.DocumentLink.to))),new k.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[k.ApiCommandArgument.Uri],new k.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",u=>{if(!!u)return new L.SemanticTokensLegend(u.tokenTypes,u.tokenModifiers)})),new k.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[k.ApiCommandArgument.Uri],new k.ApiCommandResult("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const f=(0,C.decodeSemanticTokensDto)(u);if(f.type==="full")return new L.SemanticTokens(f.data,void 0)})),new k.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[k.ApiCommandArgument.Uri],new k.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",u=>{if(!!u)return new L.SemanticTokensLegend(u.tokenTypes,u.tokenModifiers)})),new k.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Range],new k.ApiCommandResult("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const f=(0,C.decodeSemanticTokensDto)(u);if(f.type==="full")return new L.SemanticTokens(f.data,void 0)})),new k.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position,k.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),k.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new k.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(u,f,l)=>{if(!u)return new L.CompletionList([]);const v=u.suggestions.map(S=>m.CompletionItem.to(S,l));return new L.CompletionList(v,u.incomplete)})),new k.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position,k.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new k.ApiCommandResult("A promise that resolves to SignatureHelp.",u=>{if(u)return m.SignatureHelp.to(u)})),new k.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new k.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(u,f,l)=>n(v=>new L.CodeLens(m.Range.to(v.range),v.command&&l.fromInternal(v.command)))(u))),new k.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[k.ApiCommandArgument.Uri,new k.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",u=>L.Range.isRange(u),u=>L.Selection.isSelection(u)?m.Selection.from(u):m.Range.from(u)),k.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),k.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new k.ApiCommandResult("A promise that resolves to an array of Command-instances.",(u,f,l)=>n(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return l.fromInternal(v.command)}else{const S=new L.CodeAction(v.title,v.kind?new L.CodeActionKind(v.kind):void 0);return v.edit&&(S.edit=m.WorkspaceEdit.to(v.edit)),v.command&&(S.command=l.fromInternal(v.command)),S.isPreferred=v.isPreferred,S}})(u))),new k.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[k.ApiCommandArgument.Uri],new k.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",u=>u?u.map(f=>new L.ColorInformation(m.Range.to(f.range),m.Color.to(f.color))):[])),new k.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new k.ApiCommandArgument("color","The color to show and insert",u=>u instanceof L.Color,m.Color.from),new k.ApiCommandArgument("context","Context object with uri and range",u=>!0,u=>({uri:u.uri,range:m.Range.from(u.range)}))],new k.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",u=>u?u.map(m.ColorPresentation.to):[])),new k.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Range],new k.ApiCommandResult("A promise that resolves to an array of Inlay objects",u=>u.map(m.InlayHint.to))),new k.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new k.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",n(u=>({viewType:u.viewType,displayName:u.displayName,options:{transientOutputs:u.options.transientOutputs,transientCellMetadata:u.options.transientCellMetadata,transientDocumentMetadata:u.options.transientDocumentMetadata},filenamePattern:u.filenamePattern.map(f=>m.NotebookExclusiveDocumentPattern.to(f))})))),new k.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Range],new k.ApiCommandResult("A promise that resolves to an array of InlineValue objects",u=>u.map(m.InlineValue.to))),new k.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[k.ApiCommandArgument.Uri,new k.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[u,void 0]:[m.ViewColumn.from(u.viewColumn),m.TextEditorOpenOptions.from(u)])).optional(),k.ApiCommandArgument.String.with("label","").optional()],k.ApiCommandResult.Void),new k.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[k.ApiCommandArgument.Uri.with("resource","Resource to open"),k.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new k.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[u,void 0]:[m.ViewColumn.from(u.viewColumn),m.TextEditorOpenOptions.from(u)])).optional()],k.ApiCommandResult.Void),new k.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[k.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),k.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),k.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new k.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="object",u=>u&&[m.ViewColumn.from(u.viewColumn),m.TextEditorOpenOptions.from(u)]).optional()],k.ApiCommandResult.Void),new k.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A TypeHierarchyItem or undefined",u=>u.map(m.TypeHierarchyItem.to))),new k.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[k.ApiCommandArgument.TypeHierarchyItem],new k.ApiCommandResult("A TypeHierarchyItem or undefined",u=>u.map(m.TypeHierarchyItem.to))),new k.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[k.ApiCommandArgument.TypeHierarchyItem],new k.ApiCommandResult("A TypeHierarchyItem or undefined",u=>u.map(m.TypeHierarchyItem.to))),new k.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[k.ApiCommandArgument.TestItem],k.ApiCommandResult.Void)];class T{static register(f){D.forEach(f.registerApiCommand,f)}}e.ExtHostApiCommands=T;function n(u){return f=>{if(Array.isArray(f))return f.map(u)}}function A(u){if(!Array.isArray(u))return;const f=[];for(const l of u)I.isLocationLink(l)?f.push(m.DefinitionLink.to(l)):f.push(m.location.to(l));return f}}),define(me[234],ge([0,1,18,58,3,6,2,83,26,15,7,5]),function(J,e,m,L,I,k,R,C,D,T,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function u(f,l,v){const S=f.getProxy(A.MainContext.MainThreadComments);class P{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,l.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const h=this._commentControllers.get(i.handle);return h||i}else if(i&&i.$mid===7){const h=this._commentControllers.get(i.commentControlHandle);if(!h)return i;const c=h.getCommentThread(i.commentThreadHandle);return c||i}else if(i&&i.$mid===8){const h=this._commentControllers.get(i.thread.commentControlHandle);if(!h)return i;const c=h.getCommentThread(i.thread.commentThreadHandle);return c?{thread:c,text:i.text}:i}else if(i&&i.$mid===9){const h=this._commentControllers.get(i.thread.commentControlHandle);if(!h)return i;const c=h.getCommentThread(i.thread.commentThreadHandle);if(!c)return i;let d=i.commentUniqueId,b=c.getCommentByUniqueId(d);return b||i}else if(i&&i.$mid===10){const h=this._commentControllers.get(i.thread.commentControlHandle);if(!h)return i;const c=h.getCommentThread(i.thread.commentThreadHandle);if(!c)return i;let d=i.text,b=i.commentUniqueId,y=c.getCommentByUniqueId(b);return y?(y.body=d,y):i}return i}})}createCommentController(i,h,c){const d=P.handlePool++,b=new s(i,d,h,c);this._commentControllers.set(b.handle,b);const y=this._commentControllersByExtension.get(D.ExtensionIdentifier.toKey(i.identifier))||[];return y.push(b),this._commentControllersByExtension.set(D.ExtensionIdentifier.toKey(i.identifier),y),b.value}$createCommentThreadTemplate(i,h,c){const d=this._commentControllers.get(i);!d||d.$createCommentThreadTemplate(h,c)}async $updateCommentThreadTemplate(i,h,c){const d=this._commentControllers.get(i);!d||d.$updateCommentThreadTemplate(h,c)}$deleteCommentThread(i,h){const c=this._commentControllers.get(i);c&&c.$deleteCommentThread(h)}$provideCommentingRanges(i,h,c){const d=this._commentControllers.get(i);if(!d||!d.commentingRangeProvider)return Promise.resolve(void 0);const b=v.getDocument(R.URI.revive(h));return(0,m.asPromise)(()=>d.commentingRangeProvider.provideCommentingRanges(b,c)).then(y=>y?y.map(g=>T.Range.from(g)):void 0)}$toggleReaction(i,h,c,d,b){const y=this._commentControllers.get(i);return!y||!y.reactionHandler?Promise.resolve(void 0):(0,m.asPromise)(()=>{const g=y.getCommentThread(h);if(g){const _=g.getCommentByUniqueId(d.uniqueIdInThread);if(y!==void 0&&_&&y.reactionHandler)return y.reactionHandler(_,t(b))}return Promise.resolve(void 0)})}dispose(){}}P.handlePool=0;class E{constructor(i,h,c,d,b,y,g){this._commentControllerHandle=h,this._id=c,this._uri=d,this._range=b,this._comments=y,this.handle=E._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new I.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new k.MutableDisposable,this._acceptInputDisposables.value=new k.DisposableStore,this._id===void 0&&(this._id=`${i}.${this.handle}`),S.$createCommentThread(h,this.handle,this._id,this._uri,T.Range.from(this._range),g),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=y,this._localDisposables.push({dispose:()=>{S.$deleteCommentThread(h,this.handle)}});const _=this;this.value={get uri(){return _.uri},get range(){return _.range},set range(w){_.range=w},get comments(){return _.comments},set comments(w){_.comments=w},get collapsibleState(){return _.collapsibleState},set collapsibleState(w){_.collapsibleState=w},get canReply(){return _.canReply},set canReply(w){_.canReply=w},get contextValue(){return _.contextValue},set contextValue(w){_.contextValue=w},get label(){return _.label},set label(w){_.label=w},dispose:()=>{_.dispose()}}}set threadId(i){this._id=i}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(i){i.isEqual(this._range)||(this._range=i,this.modifications.range=i,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(i){this._canReply!==i&&(this._canReply=i,this.modifications.canReply=i,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(i){this._label=i,this.modifications.label=i,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(i){this._contextValue=i,this.modifications.contextValue=i,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(i){this._comments=i,this.modifications.comments=i,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(i){this._collapseState=i,this.modifications.collapsibleState=i,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new k.DisposableStore);const i=c=>Object.prototype.hasOwnProperty.call(this.modifications,c),h={};i("range")&&(h.range=T.Range.from(this._range)),i("label")&&(h.label=this.label),i("contextValue")&&(h.contextValue=this.contextValue),i("comments")&&(h.comments=this._comments.map(c=>a(this,c,this._commentsMap))),i("collapsibleState")&&(h.collapseState=o(this._collapseState)),i("canReply")&&(h.canReply=this.canReply),this.modifications={},S.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,h)}getCommentByUniqueId(i){for(let h of this._commentsMap){let c=h[0],d=h[1];if(i===d)return c}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(i=>i.dispose())}}E._handlePool=0,Ve([(0,L.debounce)(100)],E.prototype,"eventuallyUpdateCommentThread",null);class s{constructor(i,h,c,d){this._extension=i,this._handle=h,this._id=c,this._label=d,this._threads=new Map,S.$registerCommentController(this.handle,c,d);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(y){b.options=y},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(y){b.commentingRangeProvider=y},get reactionHandler(){return b.reactionHandler},set reactionHandler(y){b.reactionHandler=y},createCommentThread(y,g,_){return b.createCommentThread(y,g,_).value},dispose:()=>{b.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{S.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(i){this._reactionHandler=i,S.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!i})}get options(){return this._options}set options(i){this._options=i,S.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(i,h,c,d){if(typeof i=="string"){const b=new E(this.id,this.handle,i,h,c,d,this._extension.identifier);return this._threads.set(b.handle,b),b}else{const b=new E(this.id,this.handle,void 0,i,h,c,this._extension.identifier);return this._threads.set(b.handle,b),b}}$createCommentThreadTemplate(i,h){const c=new E(this.id,this.handle,void 0,R.URI.revive(i),T.Range.to(h),[],this._extension.identifier);return c.collapsibleState=C.CommentThreadCollapsibleState.Expanded,this._threads.set(c.handle,c),c}$updateCommentThreadTemplate(i,h){let c=this._threads.get(i);c&&(c.range=T.Range.to(h))}$deleteCommentThread(i){let h=this._threads.get(i);h&&h.dispose(),this._threads.delete(i)}getCommentThread(i){return this._threads.get(i)}dispose(){this._threads.forEach(i=>{i.dispose()}),this._localDisposables.forEach(i=>i.dispose())}}function a(r,i,h){let c=h.get(i);c||(c=++r.commentHandle,h.set(i,c));const d=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;return{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:c,body:T.MarkdownString.from(i.body),userName:i.author.name,userIconPath:d,label:i.label,commentReactions:i.reactions?i.reactions.map(b=>p(b)):void 0}}function p(r){return{label:r.label,iconPath:r.iconPath?T.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function t(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?R.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function o(r){if(r!==void 0)switch(r){case n.CommentThreadCollapsibleState.Expanded:return C.CommentThreadCollapsibleState.Expanded;case n.CommentThreadCollapsibleState.Collapsed:return C.CommentThreadCollapsibleState.Collapsed}return C.CommentThreadCollapsibleState.Collapsed}return new P}e.createExtHostComments=u}),define(me[131],ge([0,1,2,5,7,4,14,12,17,9,8]),function(J,e,m,L,I,k,R,C,D,T,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let A=class wn{constructor(f,l){this._logService=l,this._provider=new Map,this._proxy=f.getProxy(L.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,l){const v=wn._handlePool++;this._provider.set(v,{provider:f,extensionId:l}),this._proxy.$registerDecorationProvider(v,l.value);const S=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(P=>{if(!P){this._proxy.$onDidChange(v,null);return}let E=(0,D.asArray)(P);if(E.length<=wn._maxEventSize){this._proxy.$onDidChange(v,E);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",l.value,E.length);const s=E.map(t=>({uri:t,rank:(0,T.count)(t.path,"/")})),a=(0,D.groupBy)(s,(t,o)=>t.rank-o.rank||(0,T.compare)(t.uri.path,o.uri.path));let p=[];e:for(let t of a){let o;for(let r of t){let i=(0,n.dirname)(r.uri.path);if(o!==i&&(o=i,p.push(r.uri)>=wn._maxEventSize))break e}}this._proxy.$onDidChange(v,p)});return new I.Disposable(()=>{S?.dispose(),this._proxy.$unregisterDecorationProvider(v),this._provider.delete(v)})}async $provideDecorations(f,l,v){if(!this._provider.has(f))return Object.create(null);const S=Object.create(null),{provider:P,extensionId:E}=this._provider.get(f);return await Promise.all(l.map(async s=>{try{const{uri:a,id:p}=s,t=await Promise.resolve(P.provideFileDecoration(m.URI.revive(a),v));if(!t)return;try{I.FileDecoration.validate(t),S[p]=[t.propagate,t.tooltip,t.badge,t.color]}catch(o){this._logService.warn(`INVALID decoration from extension '${E.value}': ${o}`)}}catch(a){this._logService.error(a)}})),S}};A._handlePool=0,A._maxEventSize=250,A=Ve([We(0,R.IExtHostRpcService),We(1,C.ILogService)],A),e.ExtHostDecorations=A,e.IExtHostDecorations=(0,k.createDecorator)("IExtHostDecorations")});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(J,m):I?I.value=m:e.set(J,m),m},Oe=this&&this.__classPrivateFieldGet||function(J,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(J):L?L.value:e.get(J)};define(me[235],ge([0,1,163,117,2,5,7,15,3,12,24,52]),function(J,e,m,L,I,k,R,C,D,T,n,A){"use strict";var u,f,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class v{constructor(E,s,a,p,t,o){this._name=E,this._owner=s,this._maxDiagnosticsPerFile=a,u.set(this,void 0),f.set(this,void 0),l.set(this,void 0),this._isDisposed=!1,nt(this,l,new n.ResourceMap(r=>p.getComparisonKey(r)),"f"),nt(this,u,t,"f"),nt(this,f,o,"f")}dispose(){this._isDisposed||(Oe(this,f,"f").fire([...Oe(this,l,"f").keys()]),Oe(this,u,"f")&&Oe(this,u,"f").$clear(this._owner),Oe(this,l,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(E,s){if(!E){this.clear();return}this._checkDisposed();let a=[];if(I.URI.isUri(E)){if(!s){this.delete(E);return}Oe(this,l,"f").set(E,s.slice()),a=[E]}else if(Array.isArray(E)){a=[];let t;E=[...E].sort(v._compareIndexedTuplesByUri);for(const o of E){const[r,i]=o;if((!t||r.toString()!==t.toString())&&(t&&Oe(this,l,"f").get(t).length===0&&Oe(this,l,"f").delete(t),t=r,a.push(r),Oe(this,l,"f").set(r,[])),i){const h=Oe(this,l,"f").get(r);h&&h.push(...i)}else{const h=Oe(this,l,"f").get(r);h&&(h.length=0)}}}if(Oe(this,f,"f").fire(a),!Oe(this,u,"f"))return;const p=[];for(let t of a){let o=[];const r=Oe(this,l,"f").get(t);if(r)if(r.length>this._maxDiagnosticsPerFile){o=[];const i=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let h=0;h<4;h++)for(let c of r)if(c.severity===i[h]&&o.push(C.Diagnostic.from(c))===this._maxDiagnosticsPerFile)break e;o.push({severity:L.MarkerSeverity.Info,message:(0,m.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:o[o.length-1].startLineNumber,startColumn:o[o.length-1].startColumn,endLineNumber:o[o.length-1].endLineNumber,endColumn:o[o.length-1].endColumn})}else o=r.map(i=>C.Diagnostic.from(i));p.push([t,o])}Oe(this,u,"f").$changeMany(this._owner,p)}delete(E){this._checkDisposed(),Oe(this,f,"f").fire([E]),Oe(this,l,"f").delete(E),Oe(this,u,"f")&&Oe(this,u,"f").$changeMany(this._owner,[[E,void 0]])}clear(){this._checkDisposed(),Oe(this,f,"f").fire([...Oe(this,l,"f").keys()]),Oe(this,l,"f").clear(),Oe(this,u,"f")&&Oe(this,u,"f").$clear(this._owner)}forEach(E,s){this._checkDisposed();for(let a of Oe(this,l,"f").keys())E.apply(s,[a,this.get(a),this])}get(E){this._checkDisposed();const s=Oe(this,l,"f").get(E);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(E){return this._checkDisposed(),Array.isArray(Oe(this,l,"f").get(E))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(E,s){return E[0].toString()<s[0].toString()?-1:E[0].toString()>s[0].toString()?1:0}}e.DiagnosticCollection=v,u=new WeakMap,f=new WeakMap,l=new WeakMap;let S=class Yt{constructor(E,s,a){this._logService=s,this._fileSystemInfoService=a,this._collections=new Map,this._onDidChangeDiagnostics=new D.DebounceEmitter({merge:p=>p.flat(),delay:50}),this.onDidChangeDiagnostics=D.Event.map(this._onDidChangeDiagnostics.event,Yt._mapper),this._proxy=E.getProxy(k.MainContext.MainThreadDiagnostics)}static _mapper(E){const s=new n.ResourceMap;for(const a of E)s.set(a,a);return{uris:Object.freeze(Array.from(s.values()))}}createDiagnosticCollection(E,s){const{_collections:a,_proxy:p,_onDidChangeDiagnostics:t,_logService:o,_fileSystemInfoService:r}=this,i=new class{$changeMany(d,b){p.$changeMany(d,b),o.trace("[DiagnosticCollection] change many (extension, owner, uris)",E.value,d,b.length===0?"CLEARING":b)}$clear(d){p.$clear(d),o.trace("[DiagnosticCollection] remove all (extension, owner)",E.value,d)}dispose(){p.dispose()}};let h;if(!s)s="_generated_diagnostic_collection_name_#"+Yt._idPool++,h=s;else if(!a.has(s))h=s;else{this._logService.warn(`DiagnosticCollection with name '${s}' does already exist.`);do h=s+Yt._idPool++;while(a.has(h))}return new class extends v{constructor(){super(s,h,Yt._maxDiagnosticsPerFile,r.extUri,i,t);a.set(h,this)}dispose(){super.dispose(),a.delete(h)}}}getDiagnostics(E){if(E)return this._getDiagnostics(E);{const s=new Map,a=[];for(const p of this._collections.values())p.forEach((t,o)=>{let r=s.get(t.toString());typeof r=="undefined"&&(r=a.length,s.set(t.toString(),r),a.push([t,[]])),a[r][1]=a[r][1].concat(...o)});return a}}_getDiagnostics(E){let s=[];for(let a of this._collections.values())a.has(E)&&(s=s.concat(a.get(E)));return s}$acceptMarkersChange(E){if(!this._mirrorCollection){const s="_generated_mirror",a=new v(s,s,Yt._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(s,a),this._mirrorCollection=a}for(const[s,a]of E)this._mirrorCollection.set(I.URI.revive(s),a.map(C.Diagnostic.to))}};S._idPool=0,S._maxDiagnosticsPerFile=1e3,S=Ve([We(1,T.ILogService),We(2,A.IExtHostFileSystemInfo)],S),e.ExtHostDiagnostics=S}),define(me[236],ge([0,1,2,5]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class I{constructor(R){this._proxy=R.getProxy(L.MainContext.MainThreadDialogs)}showOpenDialog(R){return this._proxy.$showOpenDialog(R).then(C=>C?C.map(D=>m.URI.revive(D)):void 0)}showSaveDialog(R){return this._proxy.$showSaveDialog(R).then(C=>C?m.URI.revive(C):void 0)}}e.ExtHostDialogs=I}),define(me[237],ge([0,1,16,2,7,5,10,21,9]),function(J,e,m,L,I,k,R,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class T{constructor(A,u,f){this._documentsAndEditors=u,this._logService=f,this._documentContentProviders=new Map,this._proxy=A.getProxy(k.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(A,u){if(Object.keys(R.Schemas).indexOf(A)>=0)throw new Error(`scheme '${A}' already registered`);const f=T._handlePool++;this._documentContentProviders.set(f,u),this._proxy.$registerTextContentProvider(f,A);let l;return typeof u.onDidChange=="function"&&(l=u.onDidChange(v=>{if(v.scheme!==A){this._logService.warn(`Provider for scheme '${A}' is firing event for schema '${v.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(v)&&this.$provideTextDocumentContent(f,v).then(S=>{if(!S&&typeof S!="string")return;const P=this._documentsAndEditors.getDocument(v);if(!P)return;const E=(0,D.splitLines)(S);if(!P.equalLines(E))return this._proxy.$onVirtualDocumentChange(v,S)},m.onUnexpectedError)})),new I.Disposable(()=>{this._documentContentProviders.delete(f)&&this._proxy.$unregisterTextContentProvider(f),l&&(l.dispose(),l=void 0)})}$provideTextDocumentContent(A,u){const f=this._documentContentProviders.get(A);return f?Promise.resolve(f.provideTextDocumentContent(L.URI.revive(u),C.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.ExtHostDocumentContentProvider=T,T._handlePool=0}),define(me[238],ge([0,1,3,6,2,5,123,15,13,25,7]),function(J,e,m,L,I,k,R,C,D,T,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class A{constructor(f,l){this._onDidAddDocument=new m.Emitter,this._onDidRemoveDocument=new m.Emitter,this._onDidChangeDocument=new m.Emitter,this._onDidSaveDocument=new m.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new L.DisposableStore,this._documentLoader=new Map,this._proxy=f.getProxy(k.MainContext.MainThreadDocuments),this._documentsAndEditors=l,this._documentsAndEditors.onDidRemoveDocuments(v=>{for(const S of v)this._onDidRemoveDocument.fire(S.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(v=>{for(const S of v)this._onDidAddDocument.fire(S.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(f){if(!f)return;const l=this._documentsAndEditors.getDocument(f);if(l)return l}getDocument(f){const l=this.getDocumentData(f);if(!l?.document)throw new Error(`Unable to retrieve document from URI '${f}'`);return l.document}ensureDocumentData(f){const l=this._documentsAndEditors.getDocument(f);if(l)return Promise.resolve(l);let v=this._documentLoader.get(f.toString());return v||(v=this._proxy.$tryOpenDocument(f).then(S=>{this._documentLoader.delete(f.toString());const P=I.URI.revive(S);return(0,D.assertIsDefined)(this._documentsAndEditors.getDocument(P))},S=>(this._documentLoader.delete(f.toString()),Promise.reject(S))),this._documentLoader.set(f.toString(),v)),v}createDocumentData(f){return this._proxy.$tryCreateDocument(f).then(l=>I.URI.revive(l))}$acceptModelModeChanged(f,l){const v=I.URI.revive(f),S=this._documentsAndEditors.getDocument(v);if(!S)throw new Error("unknown document");this._onDidRemoveDocument.fire(S.document),S._acceptLanguageId(l),this._onDidAddDocument.fire(S.document)}$acceptModelSaved(f){const l=I.URI.revive(f),v=this._documentsAndEditors.getDocument(l);if(!v)throw new Error("unknown document");this.$acceptDirtyStateChanged(f,!1),this._onDidSaveDocument.fire(v.document)}$acceptDirtyStateChanged(f,l){const v=I.URI.revive(f),S=this._documentsAndEditors.getDocument(v);if(!S)throw new Error("unknown document");S._acceptIsDirty(l),this._onDidChangeDocument.fire({document:S.document,contentChanges:[],reason:void 0})}$acceptModelChanged(f,l,v){const S=I.URI.revive(f),P=this._documentsAndEditors.getDocument(S);if(!P)throw new Error("unknown document");P._acceptIsDirty(v),P.onEvents(l);let E;l.isUndoing?E=n.TextDocumentChangeReason.Undo:l.isRedoing&&(E=n.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,T.deepFreeze)({document:P.document,contentChanges:l.changes.map(s=>({range:C.Range.to(s.range),rangeOffset:s.rangeOffset,rangeLength:s.rangeLength,text:s.text})),reason:E}))}setWordDefinitionFor(f,l){(0,R.setWordDefinitionFor)(f,l)}}e.ExtHostDocuments=A}),define(me[45],ge([0,1,56,3,6,2,4,5,123,14,130,15,12,24,10,94,139]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,l,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class P{constructor(a){this.value=a,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let E=class{constructor(a,p){this._extHostRpc=a,this._logService=p,this._activeEditorId=null,this._editors=new Map,this._documents=new f.ResourceMap,this._onDidAddDocuments=new L.Emitter,this._onDidRemoveDocuments=new L.Emitter,this._onDidChangeVisibleTextEditors=new L.Emitter,this._onDidChangeActiveTextEditor=new L.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(a){this.acceptDocumentsAndEditorsDelta(a)}acceptDocumentsAndEditorsDelta(a){const p=[],t=[],o=[];if(a.removedDocuments)for(const r of a.removedDocuments){const i=k.URI.revive(r),h=this._documents.get(i);h?.unref()&&(this._documents.delete(i),p.push(h.value))}if(a.addedDocuments)for(const r of a.addedDocuments){const i=k.URI.revive(r.uri);let h=this._documents.get(i);if(h&&i.scheme!==l.Schemas.vscodeNotebookCell&&i.scheme!==l.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);h||(h=new P(new D.ExtHostDocumentData(this._extHostRpc.getProxy(C.MainContext.MainThreadDocuments),i,r.lines,r.EOL,r.versionId,r.modeId,r.isDirty,r.notebook)),this._documents.set(i,h),t.push(h.value)),h.ref()}if(a.removedEditors)for(const r of a.removedEditors){const i=this._editors.get(r);this._editors.delete(r),i&&o.push(i)}if(a.addedEditors)for(const r of a.addedEditors){const i=k.URI.revive(r.documentUri);m.ok(this._documents.has(i),`document '${i}' does not exist`),m.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const h=this._documents.get(i).value,c=new n.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(C.MainContext.MainThreadTextEditors),this._logService,new S.Lazy(()=>h.document),r.selections.map(A.Selection.to),r.options,r.visibleRanges.map(d=>A.Range.to(d)),typeof r.editorPosition=="number"?A.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,c)}a.newActiveEditor!==void 0&&(m.ok(a.newActiveEditor===null||this._editors.has(a.newActiveEditor),`active editor '${a.newActiveEditor}' does not exist`),this._activeEditorId=a.newActiveEditor),(0,I.dispose)(p),(0,I.dispose)(o),a.removedDocuments&&this._onDidRemoveDocuments.fire(p),a.addedDocuments&&this._onDidAddDocuments.fire(t),(a.removedEditors||a.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),a.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(a){return this._documents.get(a)?.value}allDocuments(){return v.Iterable.map(this._documents.values(),a=>a.value)}getEditor(a){return this._editors.get(a)}activeEditor(a){if(!this._activeEditorId)return;const p=this._editors.get(this._activeEditorId);return a?p:p?.value}allEditors(){return[...this._editors.values()]}};E=Ve([We(0,T.IExtHostRpcService),We(1,u.ILogService)],E),e.ExtHostDocumentsAndEditors=E,e.IExtHostDocumentsAndEditors=(0,R.createDecorator)("IExtHostDocumentsAndEditors")}),define(me[239],ge([0,1,2,5,6,7,15,147,9,23]),function(J,e,m,L,I,k,R,C,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class n{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const l=this._schemes.indexOf(f);l>=0&&(this._schemes.splice(l,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),l=[];let v,S,P=14,E=14;for(const s of f){let a=v?(0,D.commonPrefixLength)(v,s):0;for(a===0?S=1:S=E;a<s.length;a++)a+1===s.length?(P=E,E=9):E+=1,l.push([S,s.toUpperCase().charCodeAt(a),E]),l.push([S,s.toLowerCase().charCodeAt(a),E]),S=E;v=s,E=P}l.push([9,58,10]),l.push([10,47,12]),this._stateMachine=new C.StateMachine(l)}}provideDocumentLinks(f){this._initStateMachine();const l=[],v=C.LinkComputer.computeLinks({getLineContent(S){return f.lineAt(S-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const S of v){const P=R.DocumentLink.to(S);P.target&&l.push(P)}return l}}class A{constructor(f,l){this._extHostLanguageFeatures=l,this._linkProvider=new n,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(L.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(f,l,v,S={}){if(this._registeredSchemes.has(l))throw new Error(`a provider for the scheme '${l}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const P=this._handlePool++;this._linkProvider.add(l),this._registeredSchemes.add(l),this._fsProvider.set(P,v);let E=2;S.isCaseSensitive&&(E+=1024),S.isReadonly&&(E+=2048),typeof v.copy=="function"&&(E+=8),typeof v.open=="function"&&typeof v.close=="function"&&typeof v.read=="function"&&typeof v.write=="function"&&(E+=4),this._proxy.$registerFileSystemProvider(P,l,E).catch(a=>{console.error(`FAILED to register filesystem provider of ${f.value}-extension for the scheme ${l}`),console.error(a)});const s=v.onDidChangeFile(a=>{const p=[];for(const t of a){let{uri:o,type:r}=t;if(o.scheme!==l)continue;let i;switch(r){case k.FileChangeType.Changed:i=0;break;case k.FileChangeType.Created:i=1;break;case k.FileChangeType.Deleted:i=2;break;default:throw new Error("Unknown FileChangeType")}p.push({resource:o,type:i})}this._proxy.$onFileSystemChange(P,p)});return(0,I.toDisposable)(()=>{s.dispose(),this._linkProvider.delete(l),this._registeredSchemes.delete(l),this._fsProvider.delete(P),this._proxy.$unregisterProvider(P)})}static _asIStat(f){const{type:l,ctime:v,mtime:S,size:P,permissions:E}=f;return{type:l,ctime:v,mtime:S,size:P,permissions:E}}$stat(f,l){return Promise.resolve(this._getFsProvider(f).stat(m.URI.revive(l))).then(v=>A._asIStat(v))}$readdir(f,l){return Promise.resolve(this._getFsProvider(f).readDirectory(m.URI.revive(l)))}$readFile(f,l){return Promise.resolve(this._getFsProvider(f).readFile(m.URI.revive(l))).then(v=>T.VSBuffer.wrap(v))}$writeFile(f,l,v,S){return Promise.resolve(this._getFsProvider(f).writeFile(m.URI.revive(l),v.buffer,S))}$delete(f,l,v){return Promise.resolve(this._getFsProvider(f).delete(m.URI.revive(l),v))}$rename(f,l,v,S){return Promise.resolve(this._getFsProvider(f).rename(m.URI.revive(l),m.URI.revive(v),S))}$copy(f,l,v,S){const P=this._getFsProvider(f);if(!P.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(P.copy(m.URI.revive(l),m.URI.revive(v),S))}$mkdir(f,l){return Promise.resolve(this._getFsProvider(f).createDirectory(m.URI.revive(l)))}$watch(f,l,v,S){const P=this._getFsProvider(f).watch(m.URI.revive(v),S);this._watches.set(l,P)}$unwatch(f,l){const v=this._watches.get(l);v&&(v.dispose(),this._watches.delete(l))}$open(f,l,v){const S=this._getFsProvider(f);if(!S.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(S.open(m.URI.revive(l),v))}$close(f,l){const v=this._getFsProvider(f);if(!v.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(v.close(l))}$read(f,l,v,S){const P=this._getFsProvider(f);if(!P.read)throw new Error('FileSystemProvider does not implement "read"');const E=T.VSBuffer.alloc(S);return Promise.resolve(P.read(l,v,E.buffer,0,S)).then(s=>E.slice(0,s))}$write(f,l,v,S){const P=this._getFsProvider(f);if(!P.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(P.write(l,v,S.buffer,0,S.byteLength))}_getFsProvider(f){const l=this._fsProvider.get(f);if(!l){const v=new Error;throw v.name="ENOPRO",v.message="no provider",v}return l}}e.ExtHostFileSystem=A}),define(me[91],ge([0,1,5,42,7,23,4,14,52]),function(J,e,m,L,I,k,R,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let T=class xt{constructor(A,u){const f=A.getProxy(m.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(l){return f.$stat(l).catch(xt._handleError)},readDirectory(l){return f.$readdir(l).catch(xt._handleError)},createDirectory(l){return f.$mkdir(l).catch(xt._handleError)},async readFile(l){return f.$readFile(l).then(v=>v.buffer).catch(xt._handleError)},writeFile(l,v){return f.$writeFile(l,k.VSBuffer.wrap(v)).catch(xt._handleError)},delete(l,v){return f.$delete(l,{recursive:!1,useTrash:!1,...v}).catch(xt._handleError)},rename(l,v,S){return f.$rename(l,v,{overwrite:!1,...S}).catch(xt._handleError)},copy(l,v,S){return f.$copy(l,v,{overwrite:!1,...S}).catch(xt._handleError)},isWritableFileSystem(l){const v=u.getCapabilities(l);if(typeof v=="number")return!(v&2048)}})}static _handleError(A){if(!(A instanceof Error))throw new I.FileSystemError(String(A));if(A.name==="ENOPRO")throw I.FileSystemError.Unavailable(A.message);switch(A.name){case L.FileSystemProviderErrorCode.FileExists:throw I.FileSystemError.FileExists(A.message);case L.FileSystemProviderErrorCode.FileNotFound:throw I.FileSystemError.FileNotFound(A.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw I.FileSystemError.FileNotADirectory(A.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw I.FileSystemError.FileIsADirectory(A.message);case L.FileSystemProviderErrorCode.NoPermissions:throw I.FileSystemError.NoPermissions(A.message);case L.FileSystemProviderErrorCode.Unavailable:throw I.FileSystemError.Unavailable(A.message);default:throw new I.FileSystemError(A.message,A.name)}}};T=Ve([We(0,C.IExtHostRpcService),We(1,D.IExtHostFileSystemInfo)],T),e.ExtHostConsumerFileSystem=T,e.IExtHostConsumerFileSystem=(0,R.createDecorator)("IExtHostConsumerFileSystem")}),define(me[240],ge([0,1,2,44]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class I{constructor(R,C,D,T){this._extHostNotebooks=C,this._textDocumentsAndEditors=D,this._commands=T;const n=new L.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.ApiCommandArgument("showOptions","Show Options",A=>!0,A=>A),new L.ApiCommandArgument("resource","Interactive resource Uri",A=>!0,A=>A),new L.ApiCommandArgument("controllerId","Notebook controller Id",A=>!0,A=>A),new L.ApiCommandArgument("title","Interactive editor title",A=>!0,A=>A)],new L.ApiCommandResult("Notebook and input URI",A=>{if(A.notebookEditorId!==void 0){const u=this._extHostNotebooks.getEditorById(A.notebookEditorId);return{notebookUri:m.URI.revive(A.notebookUri),inputUri:m.URI.revive(A.inputUri),notebookEditor:u.apiEditor}}return{notebookUri:m.URI.revive(A.notebookUri),inputUri:m.URI.revive(A.inputUri)}}));this._commands.registerApiCommand(n)}$willAddInteractiveDocument(R,C,D,T){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:C,lines:[""],modeId:D,uri:R,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(m.URI.revive(T))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,C){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.ExtHostInteractive=I}),define(me[241],ge([0,1,6,5]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class I{constructor(R){this._handlePool=0,this._proxy=R.getProxy(L.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(R){const C=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(C,R),(0,m.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(C)})}}e.ExtHostLabelService=I}),define(me[242],ge([0,1,2,25,15,7,5,9,41,17,13,144,6,111,76,87,46,16,3]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,l,v,S,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class s{constructor(V,ee){this._documents=V,this._provider=ee}async provideDocumentSymbols(V,ee){const re=this._documents.getDocument(V),ae=await this._provider.provideDocumentSymbols(re,ee);if(!(0,T.isFalsyOrEmpty)(ae))return ae[0]instanceof k.DocumentSymbol?ae.map(I.DocumentSymbol.from):s._asDocumentSymbolTree(ae)}static _asDocumentSymbolTree(V){V=V.slice(0).sort((ae,Y)=>{let oe=ae.location.range.start.compareTo(Y.location.range.start);return oe===0&&(oe=Y.location.range.end.compareTo(ae.location.range.end)),oe});const ee=[],re=[];for(const ae of V){const Y={name:ae.name||"!!MISSING: name!!",kind:I.SymbolKind.from(ae.kind),tags:ae.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:ae.containerName,range:I.Range.from(ae.location.range),selectionRange:I.Range.from(ae.location.range),children:[]};for(;;){if(re.length===0){re.push(Y),ee.push(Y);break}const oe=re[re.length-1];if(D.Range.containsRange(oe.range,Y.range)&&!D.Range.equalsRange(oe.range,Y.range)){oe.children&&oe.children.push(Y),re.push(Y);break}re.pop()}}return ee}}class a{constructor(V,ee,re){this._documents=V,this._commands=ee,this._provider=re,this._cache=new v.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(V,ee){const re=this._documents.getDocument(V),ae=await this._provider.provideCodeLenses(re,ee);if(!ae||ee.isCancellationRequested)return;const Y=this._cache.add(ae),oe=new u.DisposableStore;this._disposables.set(Y,oe);const ve={cacheId:Y,lenses:[]};for(let Me=0;Me<ae.length;Me++)ve.lenses.push({cacheId:[Y,Me],range:I.Range.from(ae[Me].range),command:this._commands.toInternal(ae[Me].command,oe)});return ve}async resolveCodeLens(V,ee){const re=V.cacheId&&this._cache.get(...V.cacheId);if(!re)return;let ae;if(typeof this._provider.resolveCodeLens!="function"||re.isResolved?ae=re:ae=await this._provider.resolveCodeLens(re,ee),ae||(ae=re),ee.isCancellationRequested)return;const Y=V.cacheId&&this._disposables.get(V.cacheId[0]);if(!!Y)return V.command=this._commands.toInternal(ae.command??a._badCmd,Y),V}releaseCodeLenses(V){this._disposables.get(V)?.dispose(),this._disposables.delete(V),this._cache.delete(V)}}a._badCmd={command:"missing",title:"!!MISSING: command!!"};function p(je){return Array.isArray(je)?je.map(I.DefinitionLink.from):je?[I.DefinitionLink.from(je)]:[]}class t{constructor(V,ee){this._documents=V,this._provider=ee}async provideDefinition(V,ee,re){const ae=this._documents.getDocument(V),Y=I.Position.to(ee),oe=await this._provider.provideDefinition(ae,Y,re);return p(oe)}}class o{constructor(V,ee){this._documents=V,this._provider=ee}async provideDeclaration(V,ee,re){const ae=this._documents.getDocument(V),Y=I.Position.to(ee),oe=await this._provider.provideDeclaration(ae,Y,re);return p(oe)}}class r{constructor(V,ee){this._documents=V,this._provider=ee}async provideImplementation(V,ee,re){const ae=this._documents.getDocument(V),Y=I.Position.to(ee),oe=await this._provider.provideImplementation(ae,Y,re);return p(oe)}}class i{constructor(V,ee){this._documents=V,this._provider=ee}async provideTypeDefinition(V,ee,re){const ae=this._documents.getDocument(V),Y=I.Position.to(ee),oe=await this._provider.provideTypeDefinition(ae,Y,re);return p(oe)}}class h{constructor(V,ee){this._documents=V,this._provider=ee}async provideHover(V,ee,re){const ae=this._documents.getDocument(V),Y=I.Position.to(ee),oe=await this._provider.provideHover(ae,Y,re);if(!(!oe||(0,T.isFalsyOrEmpty)(oe.contents)))return oe.range||(oe.range=ae.getWordRangeAtPosition(Y)),oe.range||(oe.range=new k.Range(Y,Y)),I.Hover.from(oe)}}class c{constructor(V,ee){this._documents=V,this._provider=ee}async provideEvaluatableExpression(V,ee,re){const ae=this._documents.getDocument(V),Y=I.Position.to(ee),oe=await this._provider.provideEvaluatableExpression(ae,Y,re);if(oe)return I.EvaluatableExpression.from(oe)}}class d{constructor(V,ee){this._documents=V,this._provider=ee}async provideInlineValues(V,ee,re,ae){const Y=this._documents.getDocument(V),oe=await this._provider.provideInlineValues(Y,I.Range.to(ee),I.InlineValueContext.to(re),ae);if(Array.isArray(oe))return oe.map(ve=>I.InlineValue.from(ve))}}class b{constructor(V,ee){this._documents=V,this._provider=ee}async provideDocumentHighlights(V,ee,re){const ae=this._documents.getDocument(V),Y=I.Position.to(ee),oe=await this._provider.provideDocumentHighlights(ae,Y,re);if(Array.isArray(oe))return oe.map(I.DocumentHighlight.from)}}class y{constructor(V,ee){this._documents=V,this._provider=ee}async provideLinkedEditingRanges(V,ee,re){const ae=this._documents.getDocument(V),Y=I.Position.to(ee),oe=await this._provider.provideLinkedEditingRanges(ae,Y,re);if(oe&&Array.isArray(oe.ranges))return{ranges:(0,T.coalesce)(oe.ranges.map(I.Range.from)),wordPattern:oe.wordPattern}}}class g{constructor(V,ee){this._documents=V,this._provider=ee}async provideReferences(V,ee,re,ae){const Y=this._documents.getDocument(V),oe=I.Position.to(ee),ve=await this._provider.provideReferences(Y,oe,re,ae);if(Array.isArray(ve))return ve.map(I.location.from)}}class _{constructor(V,ee,re,ae,Y,oe,ve){this._documents=V,this._commands=ee,this._diagnostics=re,this._provider=ae,this._logService=Y,this._extension=oe,this._apiDeprecation=ve,this._cache=new v.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(V,ee,re,ae){const Y=this._documents.getDocument(V),oe=A.Selection.isISelection(ee)?I.Selection.to(ee):I.Range.to(ee),ve=[];for(const Z of this._diagnostics.getDiagnostics(V))if(oe.intersection(Z.range)&&ve.push(Z)>_._maxCodeActionsPerFile)break;const Me={diagnostics:ve,only:re.only?new k.CodeActionKind(re.only):void 0,triggerKind:I.CodeActionTriggerKind.to(re.trigger)},qe=await this._provider.provideCodeActions(Y,oe,Me,ae);if(!(0,T.isNonEmptyArray)(qe)||ae.isCancellationRequested)return;const Ke=this._cache.add(qe),Se=new u.DisposableStore;this._disposables.set(Ke,Se);const tt=[];for(let Z=0;Z<qe.length;Z++){const te=qe[Z];!te||(_._isCommand(te)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),tt.push({_isSynthetic:!0,title:te.title,command:this._commands.toInternal(te,Se)})):(Me.only&&(te.kind?Me.only.contains(te.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action is of kind '${te.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),tt.push({cacheId:[Ke,Z],title:te.title,command:te.command&&this._commands.toInternal(te.command,Se),diagnostics:te.diagnostics&&te.diagnostics.map(I.Diagnostic.from),edit:te.edit&&I.WorkspaceEdit.from(te.edit),kind:te.kind&&te.kind.value,isPreferred:te.isPreferred,disabled:te.disabled?.reason})))}return{cacheId:Ke,actions:tt}}async resolveCodeAction(V,ee){const[re,ae]=V,Y=this._cache.get(re,ae);if(!Y||_._isCommand(Y)||!this._provider.resolveCodeAction)return;const oe=await this._provider.resolveCodeAction(Y,ee)??Y;return oe?.edit?I.WorkspaceEdit.from(oe.edit):void 0}releaseCodeActions(V){this._disposables.get(V)?.dispose(),this._disposables.delete(V),this._cache.delete(V)}static _isCommand(V){return typeof V.command=="string"&&typeof V.title=="string"}}_._maxCodeActionsPerFile=1e3;class w{constructor(V,ee){this._documents=V,this._provider=ee}async provideDocumentFormattingEdits(V,ee,re){const ae=this._documents.getDocument(V),Y=await this._provider.provideDocumentFormattingEdits(ae,ee,re);if(Array.isArray(Y))return Y.map(I.TextEdit.from)}}class F{constructor(V,ee){this._documents=V,this._provider=ee}async provideDocumentRangeFormattingEdits(V,ee,re,ae){const Y=this._documents.getDocument(V),oe=I.Range.to(ee),ve=await this._provider.provideDocumentRangeFormattingEdits(Y,oe,re,ae);if(Array.isArray(ve))return ve.map(I.TextEdit.from)}}class N{constructor(V,ee){this._documents=V,this._provider=ee,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(V,ee,re,ae,Y){const oe=this._documents.getDocument(V),ve=I.Position.to(ee),Me=await this._provider.provideOnTypeFormattingEdits(oe,ve,re,ae,Y);if(Array.isArray(Me))return Me.map(I.TextEdit.from)}}class G{constructor(V,ee){this._provider=V,this._logService=ee,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(V,ee){const re=R.IdObject.mixin({symbols:[]}),ae=await this._provider.provideWorkspaceSymbols(V,ee);if((0,T.isNonEmptyArray)(ae))for(const Y of ae){if(!Y)continue;if(!Y.name){this._logService.warn("INVALID SymbolInformation, lacks name",Y);continue}const oe=R.IdObject.mixin(I.WorkspaceSymbol.from(Y));this._symbolCache.set(oe._id,Y),re.symbols.push(oe)}return re.symbols.length>0&&this._resultCache.set(re._id,[re.symbols[0]._id,re.symbols[re.symbols.length-1]._id]),re}async resolveWorkspaceSymbol(V,ee){if(typeof this._provider.resolveWorkspaceSymbol!="function")return V;const re=this._symbolCache.get(V._id);if(re){const ae=await this._provider.resolveWorkspaceSymbol(re,ee);return ae&&(0,L.mixin)(V,I.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols(V){const ee=this._resultCache.get(V);if(ee){for(let[re,ae]=ee;re<=ae;re++)this._symbolCache.delete(re);this._resultCache.delete(V)}}}class K{constructor(V,ee,re){this._documents=V,this._provider=ee,this._logService=re}static supportsResolving(V){return typeof V.prepareRename=="function"}async provideRenameEdits(V,ee,re,ae){const Y=this._documents.getDocument(V),oe=I.Position.to(ee);try{const ve=await this._provider.provideRenameEdits(Y,oe,re,ae);return ve?I.WorkspaceEdit.from(ve):void 0}catch(ve){const Me=K._asMessage(ve);return Me?{rejectReason:Me,edits:void 0}:Promise.reject(ve)}}async resolveRenameLocation(V,ee,re){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument(V),Y=I.Position.to(ee);try{const oe=await this._provider.prepareRename(ae,Y,re);let ve,Me;if(k.Range.isRange(oe)?(ve=oe,Me=ae.getText(oe)):(0,n.isObject)(oe)&&(ve=oe.range,Me=oe.placeholder),!ve||!Me)return;if(ve.start.line>Y.line||ve.end.line<Y.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(ve),text:Me}}catch(oe){const ve=K._asMessage(oe);return ve?{rejectReason:ve,range:void 0,text:void 0}:Promise.reject(oe)}}static _asMessage(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class U{constructor(V,ee){this.resultId=V,this.tokens=ee}}class z{constructor(V,ee){this._documents=V,this._provider=ee,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(V,ee,re){const ae=this._documents.getDocument(V),Y=ee!==0?this._previousResults.get(ee):null;let oe=typeof Y?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(ae,Y.resultId,re):await this._provider.provideDocumentSemanticTokens(ae,re);return Y&&this._previousResults.delete(ee),oe?(oe=z._fixProvidedSemanticTokens(oe),this._send(z._convertToEdits(Y,oe),oe)):null}async releaseDocumentSemanticColoring(V){this._previousResults.delete(V)}static _fixProvidedSemanticTokens(V){return z._isSemanticTokens(V)?z._isCorrectSemanticTokens(V)?V:new k.SemanticTokens(new Uint32Array(V.data),V.resultId):z._isSemanticTokensEdits(V)?z._isCorrectSemanticTokensEdits(V)?V:new k.SemanticTokensEdits(V.edits.map(ee=>new k.SemanticTokensEdit(ee.start,ee.deleteCount,ee.data?new Uint32Array(ee.data):ee.data)),V.resultId):V}static _isSemanticTokens(V){return V&&!!V.data}static _isCorrectSemanticTokens(V){return V.data instanceof Uint32Array}static _isSemanticTokensEdits(V){return V&&Array.isArray(V.edits)}static _isCorrectSemanticTokensEdits(V){for(const ee of V.edits)if(!(ee.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(V,ee){if(!z._isSemanticTokens(ee)||!V||!V.tokens)return ee;const re=V.tokens,ae=re.length,Y=ee.data,oe=Y.length;let ve=0;const Me=Math.min(ae,oe);for(;ve<Me&&re[ve]===Y[ve];)ve++;if(ve===ae&&ve===oe)return new k.SemanticTokensEdits([],ee.resultId);let qe=0;const Ke=Me-ve;for(;qe<Ke&&re[ae-qe-1]===Y[oe-qe-1];)qe++;return new k.SemanticTokensEdits([{start:ve,deleteCount:ae-ve-qe,data:Y.subarray(ve,oe-qe)}],ee.resultId)}_send(V,ee){if(z._isSemanticTokens(V)){const re=this._nextResultId++;return this._previousResults.set(re,new U(V.resultId,V.data)),(0,f.encodeSemanticTokensDto)({id:re,type:"full",data:V.data})}if(z._isSemanticTokensEdits(V)){const re=this._nextResultId++;return z._isSemanticTokens(ee)?this._previousResults.set(re,new U(ee.resultId,ee.data)):this._previousResults.set(re,new U(V.resultId)),(0,f.encodeSemanticTokensDto)({id:re,type:"delta",deltas:(V.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=z;class O{constructor(V,ee){this._documents=V,this._provider=ee}async provideDocumentRangeSemanticTokens(V,ee,re){const ae=this._documents.getDocument(V),Y=await this._provider.provideDocumentRangeSemanticTokens(ae,I.Range.to(ee),re);return Y?this._send(Y):null}_send(V){return(0,f.encodeSemanticTokensDto)({id:0,type:"full",data:V.data})}}e.DocumentRangeSemanticTokensAdapter=O;class B{constructor(V,ee,re,ae,Y){this._documents=V,this._commands=ee,this._provider=re,this._apiDeprecation=ae,this._extension=Y,this._cache=new v.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(V){return typeof V.resolveCompletionItem=="function"}async provideCompletionItems(V,ee,re,ae){const Y=this._documents.getDocument(V),oe=I.Position.to(ee),ve=Y.getWordRangeAtPosition(oe)||new k.Range(oe,oe),Me=ve.with({end:oe}),qe=new S.StopWatch(!0),Ke=await this._provider.provideCompletionItems(Y,oe,ae,I.CompletionContext.to(re));if(!Ke||ae.isCancellationRequested)return;const Se=Array.isArray(Ke)?new k.CompletionList(Ke):Ke,tt=B.supportsResolving(this._provider)?this._cache.add(Se.items):this._cache.add([]),Z=new u.DisposableStore;this._disposables.set(tt,Z);const te=[],pe={x:tt,b:te,a:{replace:I.Range.from(ve),insert:I.Range.from(Me)},c:Se.isIncomplete||void 0,d:qe.elapsed()};for(let xe=0;xe<Se.items.length;xe++){const Je=Se.items[xe],rt=this._convertCompletionItem(Je,[tt,xe],Me,ve);te.push(rt)}return pe}async resolveCompletionItem(V,ee){if(typeof this._provider.resolveCompletionItem!="function")return;const re=this._cache.get(...V);if(!re)return;const ae=await this._provider.resolveCompletionItem(re,ee);if(!!ae)return this._convertCompletionItem(ae,V)}releaseCompletionItems(V){this._disposables.get(V)?.dispose(),this._disposables.delete(V),this._cache.delete(V)}_convertCompletionItem(V,ee,re,ae){const Y=this._disposables.get(ee[0]);if(!Y)throw Error("DisposableStore is missing...");const oe={x:ee,a:V.label,b:V.kind!==void 0?I.CompletionItemKind.from(V.kind):void 0,n:V.tags&&V.tags.map(I.CompletionItemTag.from),c:V.detail,d:typeof V.documentation=="undefined"?void 0:I.MarkdownString.fromStrict(V.documentation),e:V.sortText!==V.label?V.sortText:void 0,f:V.filterText!==V.label?V.filterText:void 0,g:V.preselect||void 0,i:V.keepWhitespace?1:0,k:V.commitCharacters,l:V.additionalTextEdits&&V.additionalTextEdits.map(I.TextEdit.from),m:this._commands.toInternal(V.command,Y)};V.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),oe.h=V.textEdit.newText):typeof V.insertText=="string"?oe.h=V.insertText:V.insertText instanceof k.SnippetString&&(oe.h=V.insertText.value,oe.i|=4);let ve;return V.textEdit?ve=V.textEdit.range:V.range&&(ve=V.range),k.Range.isRange(ve)?oe.j=I.Range.from(ve):ve&&(!re?.isEqual(ve.inserting)||!ae?.isEqual(ve.replacing))&&(oe.j={insert:I.Range.from(ve.inserting),replace:I.Range.from(ve.replacing)}),oe}}class x{constructor(V,ee,re){this._documents=V,this._provider=ee,this._commands=re,this._cache=new v.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(V,ee,re,ae){const Y=this._documents.getDocument(V),oe=I.Position.to(ee),ve=await this._provider.provideInlineCompletionItems(Y,oe,{selectedCompletionInfo:re.selectedSuggestionInfo?{range:I.Range.to(re.selectedSuggestionInfo.range),text:re.selectedSuggestionInfo.text}:void 0,triggerKind:re.triggerKind},ae);if(!ve||ae.isCancellationRequested)return;const Me=(0,n.isArray)(ve)?{items:ve}:ve,qe=this._cache.add(Me.items);let Ke;return{pid:qe,items:Me.items.map((Se,tt)=>{let Z;return Se.command&&(Ke||(Ke=new u.DisposableStore,this._disposables.set(qe,Ke)),Z=this._commands.toInternal(Se.command,Ke)),{text:Se.text,range:Se.range?I.Range.from(Se.range):void 0,command:Z,idx:tt}})}}disposeCompletions(V){this._cache.delete(V);const ee=this._disposables.get(V);ee&&ee.clear(),this._disposables.delete(V)}handleDidShowCompletionItem(V,ee){const re=this._cache.get(V,ee);re&&M.get(this._provider).fireOnDidShowCompletionItem({completionItem:re})}}class M{constructor(){this._onDidShowCompletionItemEmitter=new E.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(V){let ee=M.map.get(V);return ee||(ee=new M,M.map.set(V,ee)),ee}fireOnDidShowCompletionItem(V){this._onDidShowCompletionItemEmitter.fire(V)}}e.InlineCompletionController=M,M.map=new WeakMap;class H{constructor(V,ee){this._documents=V,this._provider=ee,this._cache=new v.Cache("SignatureHelp")}async provideSignatureHelp(V,ee,re,ae){const Y=this._documents.getDocument(V),oe=I.Position.to(ee),ve=this.reviveContext(re),Me=await this._provider.provideSignatureHelp(Y,oe,ae,ve);if(Me){const qe=this._cache.add([Me]);return{...I.SignatureHelp.from(Me),id:qe}}}reviveContext(V){let ee;if(V.activeSignatureHelp){const re=I.SignatureHelp.to(V.activeSignatureHelp),ae=this._cache.get(V.activeSignatureHelp.id,0);ae?(ee=ae,ee.activeSignature=re.activeSignature,ee.activeParameter=re.activeParameter):ee=re}return{...V,activeSignatureHelp:ee}}releaseSignatureHelp(V){this._cache.delete(V)}}class W{constructor(V,ee){this._documents=V,this._provider=ee}async provideInlayHints(V,ee,re){const ae=this._documents.getDocument(V),Y=await this._provider.provideInlayHints(ae,I.Range.to(ee),re);return Y?{hints:Y.map(I.InlayHint.from)}:void 0}}class Q{constructor(V,ee){this._documents=V,this._provider=ee,this._cache=new v.Cache("DocumentLink")}async provideLinks(V,ee){const re=this._documents.getDocument(V),ae=await this._provider.provideDocumentLinks(re,ee);if(!(!Array.isArray(ae)||ae.length===0)&&!ee.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.filter(Q._validateLink).map(I.DocumentLink.from)};{const Y=this._cache.add(ae),oe={links:[],id:Y};for(let ve=0;ve<ae.length;ve++){if(!Q._validateLink(ae[ve]))continue;const Me=I.DocumentLink.from(ae[ve]);Me.cacheId=[Y,ve],oe.links.push(Me)}return oe}}}static _validateLink(V){return V.target&&V.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(V,ee){if(typeof this._provider.resolveDocumentLink!="function")return;const re=this._cache.get(...V);if(!re)return;const ae=await this._provider.resolveDocumentLink(re,ee);if(!(!ae||!Q._validateLink(ae)))return I.DocumentLink.from(ae)}releaseLinks(V){this._cache.delete(V)}}class X{constructor(V,ee){this._documents=V,this._provider=ee}async provideColors(V,ee){const re=this._documents.getDocument(V),ae=await this._provider.provideDocumentColors(re,ee);return Array.isArray(ae)?ae.map(oe=>({color:I.Color.from(oe.color),range:I.Range.from(oe.range)})):[]}async provideColorPresentations(V,ee,re){const ae=this._documents.getDocument(V),Y=I.Range.to(ee.range),oe=I.Color.to(ee.color),ve=await this._provider.provideColorPresentations(oe,{document:ae,range:Y},re);if(!!Array.isArray(ve))return ve.map(I.ColorPresentation.from)}}class he{constructor(V,ee){this._documents=V,this._provider=ee}async provideFoldingRanges(V,ee,re){const ae=this._documents.getDocument(V),Y=await this._provider.provideFoldingRanges(ae,ee,re);if(!!Array.isArray(Y))return Y.map(I.FoldingRange.from)}}class _e{constructor(V,ee,re){this._documents=V,this._provider=ee,this._logService=re}async provideSelectionRanges(V,ee,re){const ae=this._documents.getDocument(V),Y=ee.map(I.Position.to),oe=await this._provider.provideSelectionRanges(ae,Y,re);if(!(0,T.isNonEmptyArray)(oe))return[];if(oe.length!==Y.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ve=[];for(let Me=0;Me<Y.length;Me++){const qe=[];ve.push(qe);let Ke=Y[Me],Se=oe[Me];for(;;){if(!Se.range.contains(Ke))throw new Error("INVALID selection range, must contain the previous range");if(qe.push(I.SelectionRange.from(Se)),!Se.parent)break;Ke=Se.range,Se=Se.parent}}return ve}}class ye{constructor(V,ee){this._documents=V,this._provider=ee,this._idPool=new l.IdGenerator(""),this._cache=new Map}async prepareSession(V,ee,re){const ae=this._documents.getDocument(V),Y=I.Position.to(ee),oe=await this._provider.prepareCallHierarchy(ae,Y,re);if(!oe)return;const ve=this._idPool.nextId();return this._cache.set(ve,new Map),Array.isArray(oe)?oe.map(Me=>this._cacheAndConvertItem(ve,Me)):[this._cacheAndConvertItem(ve,oe)]}async provideCallsTo(V,ee,re){const ae=this._itemFromCache(V,ee);if(!ae)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyIncomingCalls(ae,re);if(!!Y)return Y.map(oe=>({from:this._cacheAndConvertItem(V,oe.from),fromRanges:oe.fromRanges.map(ve=>I.Range.from(ve))}))}async provideCallsFrom(V,ee,re){const ae=this._itemFromCache(V,ee);if(!ae)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyOutgoingCalls(ae,re);if(!!Y)return Y.map(oe=>({to:this._cacheAndConvertItem(V,oe.to),fromRanges:oe.fromRanges.map(ve=>I.Range.from(ve))}))}releaseSession(V){this._cache.delete(V)}_cacheAndConvertItem(V,ee){const re=this._cache.get(V),ae=I.CallHierarchyItem.from(ee,V,re.size.toString(36));return re.set(ae._itemId,ee),ae}_itemFromCache(V,ee){return this._cache.get(V)?.get(ee)}}class Re{constructor(V,ee){this._documents=V,this._provider=ee,this._idPool=new l.IdGenerator(""),this._cache=new Map}async prepareSession(V,ee,re){const ae=this._documents.getDocument(V),Y=I.Position.to(ee),oe=await this._provider.prepareTypeHierarchy(ae,Y,re);if(!oe)return;const ve=this._idPool.nextId();return this._cache.set(ve,new Map),Array.isArray(oe)?oe.map(Me=>this._cacheAndConvertItem(ve,Me)):[this._cacheAndConvertItem(ve,oe)]}async provideSupertypes(V,ee,re){const ae=this._itemFromCache(V,ee);if(!ae)throw new Error("missing type hierarchy item");const Y=await this._provider.provideTypeHierarchySupertypes(ae,re);if(!!Y)return Y.map(oe=>this._cacheAndConvertItem(V,oe))}async provideSubtypes(V,ee,re){const ae=this._itemFromCache(V,ee);if(!ae)throw new Error("missing type hierarchy item");const Y=await this._provider.provideTypeHierarchySubtypes(ae,re);if(!!Y)return Y.map(oe=>this._cacheAndConvertItem(V,oe))}releaseSession(V){this._cache.delete(V)}_cacheAndConvertItem(V,ee){const re=this._cache.get(V),ae=I.TypeHierarchyItem.from(ee,V,re.size.toString(36));return re.set(ae._itemId,ee),ae}_itemFromCache(V,ee){return this._cache.get(V)?.get(ee)}}class $e{constructor(V,ee){this.adapter=V,this.extension=ee}}class Be{constructor(V,ee,re,ae,Y,oe,ve){this._adapter=new Map,this._uriTransformer=ee,this._proxy=V.getProxy(R.MainContext.MainThreadLanguageFeatures),this._documents=re,this._commands=ae,this._diagnostics=Y,this._logService=oe,this._apiDeprecation=ve}_transformDocumentSelector(V){return(0,T.coalesce)((0,T.asArray)(V).map(ee=>this._doTransformDocumentSelector(ee)))}_doTransformDocumentSelector(V){if(typeof V=="string")return{$serialized:!0,language:V};if(V)return{$serialized:!0,language:V.language,scheme:this._transformScheme(V.scheme),pattern:typeof V.pattern=="undefined"?void 0:I.GlobPattern.from(V.pattern),exclusive:V.exclusive}}_transformScheme(V){return this._uriTransformer&&typeof V=="string"?this._uriTransformer.transformOutgoingScheme(V):V}_createDisposable(V){return new k.Disposable(()=>{this._adapter.delete(V),this._proxy.$unregister(V)})}_nextHandle(){return Be._handlePool++}_withAdapter(V,ee,re,ae,Y=!1){const oe=this._adapter.get(V);if(!oe)return Promise.resolve(ae);if(oe.adapter instanceof ee){let ve;oe.extension&&(ve=Date.now(),this._logService.trace(`[${oe.extension.identifier.value}] INVOKE provider '${ee.name}'`));const Me=re(oe.adapter,oe.extension),qe=oe.extension;return qe&&Promise.resolve(Me).then(()=>this._logService.trace(`[${qe.identifier.value}] provider DONE after ${Date.now()-ve}ms`),Ke=>{Y&&Ke instanceof P.CancellationError||(this._logService.error(`[${qe.identifier.value}] provider FAILED`),this._logService.error(Ke))}),Me}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(V,ee){const re=this._nextHandle();return this._adapter.set(re,new $e(V,ee)),re}static _extLabel(V){return V.displayName||V.name}registerDocumentSymbolProvider(V,ee,re,ae){const Y=this._addNewAdapter(new s(this._documents,re),V),oe=ae&&ae.label||Be._extLabel(V);return this._proxy.$registerDocumentSymbolProvider(Y,this._transformDocumentSelector(ee),oe),this._createDisposable(Y)}$provideDocumentSymbols(V,ee,re){return this._withAdapter(V,s,ae=>ae.provideDocumentSymbols(m.URI.revive(ee),re),void 0)}registerCodeLensProvider(V,ee,re){const ae=this._nextHandle(),Y=typeof re.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new $e(new a(this._documents,this._commands.converter,re),V)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(ee),Y);let oe=this._createDisposable(ae);if(Y!==void 0){const ve=re.onDidChangeCodeLenses(Me=>this._proxy.$emitCodeLensEvent(Y));oe=k.Disposable.from(oe,ve)}return oe}$provideCodeLenses(V,ee,re){return this._withAdapter(V,a,ae=>ae.provideCodeLenses(m.URI.revive(ee),re),void 0)}$resolveCodeLens(V,ee,re){return this._withAdapter(V,a,ae=>ae.resolveCodeLens(ee,re),void 0)}$releaseCodeLenses(V,ee){this._withAdapter(V,a,re=>Promise.resolve(re.releaseCodeLenses(ee)),void 0)}registerDefinitionProvider(V,ee,re){const ae=this._addNewAdapter(new t(this._documents,re),V);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$provideDefinition(V,ee,re,ae){return this._withAdapter(V,t,Y=>Y.provideDefinition(m.URI.revive(ee),re,ae),[])}registerDeclarationProvider(V,ee,re){const ae=this._addNewAdapter(new o(this._documents,re),V);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$provideDeclaration(V,ee,re,ae){return this._withAdapter(V,o,Y=>Y.provideDeclaration(m.URI.revive(ee),re,ae),[])}registerImplementationProvider(V,ee,re){const ae=this._addNewAdapter(new r(this._documents,re),V);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$provideImplementation(V,ee,re,ae){return this._withAdapter(V,r,Y=>Y.provideImplementation(m.URI.revive(ee),re,ae),[])}registerTypeDefinitionProvider(V,ee,re){const ae=this._addNewAdapter(new i(this._documents,re),V);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$provideTypeDefinition(V,ee,re,ae){return this._withAdapter(V,i,Y=>Y.provideTypeDefinition(m.URI.revive(ee),re,ae),[])}registerHoverProvider(V,ee,re,ae){const Y=this._addNewAdapter(new h(this._documents,re),V);return this._proxy.$registerHoverProvider(Y,this._transformDocumentSelector(ee)),this._createDisposable(Y)}$provideHover(V,ee,re,ae){return this._withAdapter(V,h,Y=>Y.provideHover(m.URI.revive(ee),re,ae),void 0)}registerEvaluatableExpressionProvider(V,ee,re,ae){const Y=this._addNewAdapter(new c(this._documents,re),V);return this._proxy.$registerEvaluatableExpressionProvider(Y,this._transformDocumentSelector(ee)),this._createDisposable(Y)}$provideEvaluatableExpression(V,ee,re,ae){return this._withAdapter(V,c,Y=>Y.provideEvaluatableExpression(m.URI.revive(ee),re,ae),void 0)}registerInlineValuesProvider(V,ee,re,ae){const Y=typeof re.onDidChangeInlineValues=="function"?this._nextHandle():void 0,oe=this._addNewAdapter(new d(this._documents,re),V);this._proxy.$registerInlineValuesProvider(oe,this._transformDocumentSelector(ee),Y);let ve=this._createDisposable(oe);if(Y!==void 0){const Me=re.onDidChangeInlineValues(qe=>this._proxy.$emitInlineValuesEvent(Y));ve=k.Disposable.from(ve,Me)}return ve}$provideInlineValues(V,ee,re,ae,Y){return this._withAdapter(V,d,oe=>oe.provideInlineValues(m.URI.revive(ee),re,ae,Y),void 0)}registerDocumentHighlightProvider(V,ee,re){const ae=this._addNewAdapter(new b(this._documents,re),V);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$provideDocumentHighlights(V,ee,re,ae){return this._withAdapter(V,b,Y=>Y.provideDocumentHighlights(m.URI.revive(ee),re,ae),void 0)}registerLinkedEditingRangeProvider(V,ee,re){const ae=this._addNewAdapter(new y(this._documents,re),V);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$provideLinkedEditingRanges(V,ee,re,ae){return this._withAdapter(V,y,async Y=>{const oe=await Y.provideLinkedEditingRanges(m.URI.revive(ee),re,ae);if(oe)return{ranges:oe.ranges,wordPattern:oe.wordPattern?Be._serializeRegExp(oe.wordPattern):void 0}},void 0)}registerReferenceProvider(V,ee,re){const ae=this._addNewAdapter(new g(this._documents,re),V);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$provideReferences(V,ee,re,ae,Y){return this._withAdapter(V,g,oe=>oe.provideReferences(m.URI.revive(ee),re,ae,Y),void 0)}registerCodeActionProvider(V,ee,re,ae){const Y=new u.DisposableStore,oe=this._addNewAdapter(new _(this._documents,this._commands.converter,this._diagnostics,re,this._logService,V,this._apiDeprecation),V);return this._proxy.$registerQuickFixSupport(oe,this._transformDocumentSelector(ee),{providedKinds:ae?.providedCodeActionKinds?.map(ve=>ve.value),documentation:ae?.documentation?.map(ve=>({kind:ve.kind.value,command:this._commands.converter.toInternal(ve.command,Y)}))},Be._extLabel(V),Boolean(re.resolveCodeAction)),Y.add(this._createDisposable(oe)),Y}$provideCodeActions(V,ee,re,ae,Y){return this._withAdapter(V,_,oe=>oe.provideCodeActions(m.URI.revive(ee),re,ae,Y),void 0)}$resolveCodeAction(V,ee,re){return this._withAdapter(V,_,ae=>ae.resolveCodeAction(ee,re),void 0)}$releaseCodeActions(V,ee){this._withAdapter(V,_,re=>Promise.resolve(re.releaseCodeActions(ee)),void 0)}registerDocumentFormattingEditProvider(V,ee,re){const ae=this._addNewAdapter(new w(this._documents,re),V);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(ee),V.identifier,V.displayName||V.name),this._createDisposable(ae)}$provideDocumentFormattingEdits(V,ee,re,ae){return this._withAdapter(V,w,Y=>Y.provideDocumentFormattingEdits(m.URI.revive(ee),re,ae),void 0)}registerDocumentRangeFormattingEditProvider(V,ee,re){const ae=this._addNewAdapter(new F(this._documents,re),V);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(ee),V.identifier,V.displayName||V.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits(V,ee,re,ae,Y){return this._withAdapter(V,F,oe=>oe.provideDocumentRangeFormattingEdits(m.URI.revive(ee),re,ae,Y),void 0)}registerOnTypeFormattingEditProvider(V,ee,re,ae){const Y=this._addNewAdapter(new N(this._documents,re),V);return this._proxy.$registerOnTypeFormattingSupport(Y,this._transformDocumentSelector(ee),ae,V.identifier),this._createDisposable(Y)}$provideOnTypeFormattingEdits(V,ee,re,ae,Y,oe){return this._withAdapter(V,N,ve=>ve.provideOnTypeFormattingEdits(m.URI.revive(ee),re,ae,Y,oe),void 0)}registerWorkspaceSymbolProvider(V,ee){const re=this._addNewAdapter(new G(ee,this._logService),V);return this._proxy.$registerNavigateTypeSupport(re),this._createDisposable(re)}$provideWorkspaceSymbols(V,ee,re){return this._withAdapter(V,G,ae=>ae.provideWorkspaceSymbols(ee,re),{symbols:[]})}$resolveWorkspaceSymbol(V,ee,re){return this._withAdapter(V,G,ae=>ae.resolveWorkspaceSymbol(ee,re),void 0)}$releaseWorkspaceSymbols(V,ee){this._withAdapter(V,G,re=>re.releaseWorkspaceSymbols(ee),void 0)}registerRenameProvider(V,ee,re){const ae=this._addNewAdapter(new K(this._documents,re,this._logService),V);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(ee),K.supportsResolving(re)),this._createDisposable(ae)}$provideRenameEdits(V,ee,re,ae,Y){return this._withAdapter(V,K,oe=>oe.provideRenameEdits(m.URI.revive(ee),re,ae,Y),void 0)}$resolveRenameLocation(V,ee,re,ae){return this._withAdapter(V,K,Y=>Y.resolveRenameLocation(m.URI.revive(ee),re,ae),void 0)}registerDocumentSemanticTokensProvider(V,ee,re,ae){const Y=this._nextHandle(),oe=typeof re.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(Y,new $e(new z(this._documents,re),V)),this._proxy.$registerDocumentSemanticTokensProvider(Y,this._transformDocumentSelector(ee),ae,oe);let ve=this._createDisposable(Y);if(oe){const Me=re.onDidChangeSemanticTokens(qe=>this._proxy.$emitDocumentSemanticTokensEvent(oe));ve=k.Disposable.from(ve,Me)}return ve}$provideDocumentSemanticTokens(V,ee,re,ae){return this._withAdapter(V,z,Y=>Y.provideDocumentSemanticTokens(m.URI.revive(ee),re,ae),null,!0)}$releaseDocumentSemanticTokens(V,ee){this._withAdapter(V,z,re=>re.releaseDocumentSemanticColoring(ee),void 0)}registerDocumentRangeSemanticTokensProvider(V,ee,re,ae){const Y=this._addNewAdapter(new O(this._documents,re),V);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Y,this._transformDocumentSelector(ee),ae),this._createDisposable(Y)}$provideDocumentRangeSemanticTokens(V,ee,re,ae){return this._withAdapter(V,O,Y=>Y.provideDocumentRangeSemanticTokens(m.URI.revive(ee),re,ae),null,!0)}registerCompletionItemProvider(V,ee,re,ae){const Y=this._addNewAdapter(new B(this._documents,this._commands.converter,re,this._apiDeprecation,V),V);return this._proxy.$registerSuggestSupport(Y,this._transformDocumentSelector(ee),ae,B.supportsResolving(re),`${V.identifier.value}(${ae.join("")})`),this._createDisposable(Y)}$provideCompletionItems(V,ee,re,ae,Y){return this._withAdapter(V,B,oe=>oe.provideCompletionItems(m.URI.revive(ee),re,ae,Y),void 0)}$resolveCompletionItem(V,ee,re){return this._withAdapter(V,B,ae=>ae.resolveCompletionItem(ee,re),void 0)}$releaseCompletionItems(V,ee){this._withAdapter(V,B,re=>re.releaseCompletionItems(ee),void 0)}registerInlineCompletionsProvider(V,ee,re){const ae=this._addNewAdapter(new x(this._documents,re,this._commands.converter),V);return this._proxy.$registerInlineCompletionsSupport(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$provideInlineCompletions(V,ee,re,ae,Y){return this._withAdapter(V,x,oe=>oe.provideInlineCompletions(m.URI.revive(ee),re,ae,Y),void 0)}$handleInlineCompletionDidShow(V,ee,re){this._withAdapter(V,x,async ae=>{ae.handleDidShowCompletionItem(ee,re)},void 0)}$freeInlineCompletionsList(V,ee){this._withAdapter(V,x,async re=>{re.disposeCompletions(ee)},void 0)}registerSignatureHelpProvider(V,ee,re,ae){const Y=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,oe=this._addNewAdapter(new H(this._documents,re),V);return this._proxy.$registerSignatureHelpProvider(oe,this._transformDocumentSelector(ee),Y),this._createDisposable(oe)}$provideSignatureHelp(V,ee,re,ae,Y){return this._withAdapter(V,H,oe=>oe.provideSignatureHelp(m.URI.revive(ee),re,ae,Y),void 0)}$releaseSignatureHelp(V,ee){this._withAdapter(V,H,re=>re.releaseSignatureHelp(ee),void 0)}registerInlayHintsProvider(V,ee,re){const ae=typeof re.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Y=this._addNewAdapter(new W(this._documents,re),V);this._proxy.$registerInlayHintsProvider(Y,this._transformDocumentSelector(ee),ae);let oe=this._createDisposable(Y);if(ae!==void 0){const ve=re.onDidChangeInlayHints(Me=>this._proxy.$emitInlayHintsEvent(ae));oe=k.Disposable.from(oe,ve)}return oe}$provideInlayHints(V,ee,re,ae){return this._withAdapter(V,W,Y=>Y.provideInlayHints(m.URI.revive(ee),re,ae),void 0)}registerDocumentLinkProvider(V,ee,re){const ae=this._addNewAdapter(new Q(this._documents,re),V);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(ee),typeof re.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks(V,ee,re){return this._withAdapter(V,Q,ae=>ae.provideLinks(m.URI.revive(ee),re),void 0)}$resolveDocumentLink(V,ee,re){return this._withAdapter(V,Q,ae=>ae.resolveLink(ee,re),void 0)}$releaseDocumentLinks(V,ee){this._withAdapter(V,Q,re=>re.releaseLinks(ee),void 0)}registerColorProvider(V,ee,re){const ae=this._addNewAdapter(new X(this._documents,re),V);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$provideDocumentColors(V,ee,re){return this._withAdapter(V,X,ae=>ae.provideColors(m.URI.revive(ee),re),[])}$provideColorPresentations(V,ee,re,ae){return this._withAdapter(V,X,Y=>Y.provideColorPresentations(m.URI.revive(ee),re,ae),void 0)}registerFoldingRangeProvider(V,ee,re){const ae=this._nextHandle(),Y=typeof re.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new $e(new he(this._documents,re),V)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(ee),Y);let oe=this._createDisposable(ae);if(Y!==void 0){const ve=re.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Y));oe=k.Disposable.from(oe,ve)}return oe}$provideFoldingRanges(V,ee,re,ae){return this._withAdapter(V,he,Y=>Y.provideFoldingRanges(m.URI.revive(ee),re,ae),void 0)}registerSelectionRangeProvider(V,ee,re){const ae=this._addNewAdapter(new _e(this._documents,re,this._logService),V);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$provideSelectionRanges(V,ee,re,ae){return this._withAdapter(V,_e,Y=>Y.provideSelectionRanges(m.URI.revive(ee),re,ae),[])}registerCallHierarchyProvider(V,ee,re){const ae=this._addNewAdapter(new ye(this._documents,re),V);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$prepareCallHierarchy(V,ee,re,ae){return this._withAdapter(V,ye,Y=>Promise.resolve(Y.prepareSession(m.URI.revive(ee),re,ae)),void 0)}$provideCallHierarchyIncomingCalls(V,ee,re,ae){return this._withAdapter(V,ye,Y=>Y.provideCallsTo(ee,re,ae),void 0)}$provideCallHierarchyOutgoingCalls(V,ee,re,ae){return this._withAdapter(V,ye,Y=>Y.provideCallsFrom(ee,re,ae),void 0)}$releaseCallHierarchy(V,ee){this._withAdapter(V,ye,re=>Promise.resolve(re.releaseSession(ee)),void 0)}registerTypeHierarchyProvider(V,ee,re){const ae=this._addNewAdapter(new Re(this._documents,re),V);return this._proxy.$registerTypeHierarchyProvider(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$prepareTypeHierarchy(V,ee,re,ae){return this._withAdapter(V,Re,Y=>Promise.resolve(Y.prepareSession(m.URI.revive(ee),re,ae)),void 0)}$provideTypeHierarchySupertypes(V,ee,re,ae){return this._withAdapter(V,Re,Y=>Y.provideSupertypes(ee,re,ae),void 0)}$provideTypeHierarchySubtypes(V,ee,re,ae){return this._withAdapter(V,Re,Y=>Y.provideSubtypes(ee,re,ae),void 0)}$releaseTypeHierarchy(V,ee){this._withAdapter(V,Re,re=>Promise.resolve(re.releaseSession(ee)),void 0)}static _serializeRegExp(V){return{pattern:V.source,flags:(0,C.regExpFlags)(V)}}static _serializeIndentationRule(V){return{decreaseIndentPattern:Be._serializeRegExp(V.decreaseIndentPattern),increaseIndentPattern:Be._serializeRegExp(V.increaseIndentPattern),indentNextLinePattern:V.indentNextLinePattern?Be._serializeRegExp(V.indentNextLinePattern):void 0,unIndentedLinePattern:V.unIndentedLinePattern?Be._serializeRegExp(V.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(V){return{beforeText:Be._serializeRegExp(V.beforeText),afterText:V.afterText?Be._serializeRegExp(V.afterText):void 0,previousLineText:V.previousLineText?Be._serializeRegExp(V.previousLineText):void 0,action:V.action}}static _serializeOnEnterRules(V){return V.map(Be._serializeOnEnterRule)}setLanguageConfiguration(V,ee,re){let{wordPattern:ae}=re;if(ae&&(0,C.regExpLeadsToEndlessLoop)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(ee,ae):this._documents.setWordDefinitionFor(ee,void 0),re.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",V,"Do not use."),re.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",V,"Do not use.");const Y=this._nextHandle(),oe={comments:re.comments,brackets:re.brackets,wordPattern:re.wordPattern?Be._serializeRegExp(re.wordPattern):void 0,indentationRules:re.indentationRules?Be._serializeIndentationRule(re.indentationRules):void 0,onEnterRules:re.onEnterRules?Be._serializeOnEnterRules(re.onEnterRules):void 0,__electricCharacterSupport:re.__electricCharacterSupport,__characterPairSupport:re.__characterPairSupport};return this._proxy.$setLanguageConfiguration(Y,ee,oe),this._createDisposable(Y)}$setWordDefinitions(V){for(const ee of V)this._documents.setWordDefinitionFor(ee.languageId,new RegExp(ee.regexSource,ee.regexFlags))}}e.ExtHostLanguageFeatures=Be,Be._handlePool=0}),define(me[243],ge([0,1,5,15,7,49,18,6]),function(J,e,m,L,I,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class D{constructor(n,A,u){this._documents=A,this._commands=u,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=n.getProxy(m.MainContext.MainThreadLanguages)}$acceptLanguageIds(n){this._languageIds=n}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(n,A){await this._proxy.$changeLanguage(n,A);const u=this._documents.getDocumentData(n);if(!u)throw new Error(`document '${n.toString}' NOT found`);return u.document}async tokenAtPosition(n,A){const u=n.version,f=L.Position.from(A),l=await this._proxy.$tokensAtPosition(n.uri,f),v={type:I.StandardTokenType.Other,range:n.getWordRangeAtPosition(A)??new I.Range(A.line,A.character,A.line,A.character)};if(!l)return v;const S={range:L.Range.to(l.range),type:L.TokenType.to(l.type)};return!S.range.contains(A)||u!==n.version?v:S}createLanguageStatusItem(n,A,u){const f=this._handlePool++,l=this._proxy,v=this._ids,S=`${n.identifier.value}/${A}`;if(v.has(S))throw new Error(`LanguageStatusItem with id '${A}' ALREADY exists`);v.add(S);const P={selector:u,id:A,name:n.displayName??n.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:""};let E,s=new C.DisposableStore;const a=()=>{E?.dispose(),E=(0,R.disposableTimeout)(()=>{s.clear(),this._proxy.$setLanguageStatus(f,{id:S,name:P.name??n.displayName??n.name,source:n.displayName??n.name,selector:P.selector,label:P.text,detail:P.detail??"",severity:P.severity===I.LanguageStatusSeverity.Error?k.default.Error:P.severity===I.LanguageStatusSeverity.Warning?k.default.Warning:k.default.Info,command:P.command&&this._commands.toInternal(P.command,s),accessibilityInfo:P.accessibilityInformation})},0)},p={dispose(){s.dispose(),E?.dispose(),l.$removeLanguageStatus(f),v.delete(S)},get id(){return P.id},get name(){return P.name},set name(t){P.name=t,a()},get selector(){return P.selector},set selector(t){P.selector=t,a()},get text(){return P.text},set text(t){P.text=t,a()},get detail(){return P.detail},set detail(t){P.detail=t,a()},get severity(){return P.severity},set severity(t){P.severity=t,a()},get accessibilityInformation(){return P.accessibilityInformation},set accessibilityInformation(t){P.accessibilityInformation=t,a()},get command(){return P.command},set command(t){P.command=t,a()}};return a(),p}}e.ExtHostLanguages=D}),define(me[244],ge([0,1,5,12,36]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function k(C){return C&&C.title}let R=class{constructor(D,T){this._logService=T,this._proxy=D.getProxy(m.MainContext.MainThreadMessageService)}showMessage(D,T,n,A,u){const f={extension:D};let l;typeof A=="string"||k(A)?l=[A,...u]:(f.modal=A?.modal,f.useCustom=A?.useCustom,f.detail=A?.detail,l=u),f.useCustom&&(0,I.checkProposedApiEnabled)(D);const v=[];for(let S=0;S<l.length;S++){const P=l[S];if(typeof P=="string")v.push({title:P,handle:S,isCloseAffordance:!1});else if(typeof P=="object"){let{title:E,isCloseAffordance:s}=P;v.push({title:E,isCloseAffordance:!!s,handle:S})}else this._logService.warn("Invalid message item:",P)}return this._proxy.$showMessage(T,n,f,v).then(S=>{if(typeof S=="number")return l[S]})}};R=Ve([We(1,L.ILogService)],R),e.ExtHostMessageService=R}),define(me[245],ge([0,1,23,3,48,6,24,9,13,2,87,5,15,7,66,220,129]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,l,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class P{constructor(s,a,p,t,o){this._textDocumentsAndEditors=p,this._textDocuments=t,this._extensionStoragePaths=o,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new R.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new L.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new L.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new L.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new L.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new L.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new L.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new L.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new n.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=s.getProxy(A.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=s.getProxy(A.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=s.getProxy(A.MainContext.MainThreadNotebookEditors),this._commandsConverter=a.converter,a.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const i=r.notebookEditor?.notebookUri,h=r.cell.handle,d=this._documents.get(i)?.getCell(h);if(d)return d.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(s=>s.apiEditor)}getEditorById(s){const a=this._editors.get(s);if(!a)throw new Error(`unknown text editor: ${s}. known editors: ${[...this._editors.keys()]} `);return a}getIdByEditor(s){for(const[a,p]of this._editors)if(p.apiEditor===s)return a}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(s,a){const p=this._documents.get(s);if(!p&&!a)throw new Error(`NO notebook document for '${s}'`);return p}_getProviderData(s){const a=this._notebookContentProviders.get(s);if(!a)throw new Error(`NO provider for '${s}'`);return a}registerNotebookContentProvider(s,a,p,t,o){if((0,C.isFalsyOrWhitespace)(a))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(a))throw new Error(`Notebook provider for '${a}' already registered`);this._notebookContentProviders.set(a,{extension:s,provider:p});let r;return p.onDidChangeNotebookContentOptions&&(r=p.onDidChangeNotebookContentOptions(()=>{const i=u.NotebookDocumentContentOptions.from(p.options);this._notebookProxy.$updateNotebookProviderOptions(a,i)})),this._notebookProxy.$registerNotebookProvider({id:s.identifier,location:s.extensionLocation},a,u.NotebookDocumentContentOptions.from(t),P._convertNotebookRegistrationData(s,o)),new f.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(a),this._notebookProxy.$unregisterNotebookProvider(a)})}static _convertNotebookRegistrationData(s,a){if(!a)return;const p=a.filenamePattern.map(t=>u.NotebookExclusiveDocumentPattern.from(t)).filter(t=>t!==void 0);if(a.filenamePattern&&!p){console.warn(`Notebook content provider view options file name pattern is invalid ${a.filenamePattern}`);return}return{extension:s.identifier,providerDisplayName:s.displayName||s.name,displayName:a.displayName,filenamePattern:p,exclusive:a.exclusive||!1}}registerNotebookCellStatusBarItemProvider(s,a,p){const t=P._notebookStatusBarItemProviderHandlePool++,o=typeof p.onDidChangeCellStatusBarItems=="function"?P._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(t,p),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(t,o,a);let r;return o!==void 0&&(r=p.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(o))),new f.Disposable(()=>{this._notebookStatusBarItemProviders.delete(t),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(t,o),r&&r.dispose()})}async createNotebookDocument(s){const a=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:s.viewType,content:s.content&&u.NotebookData.from(s.content)});return T.URI.revive(a)}async openNotebookDocument(s){const a=this._documents.get(s);if(a)return a.apiNotebook;const p=await this._notebookDocumentsProxy.$tryOpenNotebook(s),t=this._documents.get(T.URI.revive(p));return(0,D.assertIsDefined)(t?.apiNotebook)}async showNotebookDocument(s,a){T.URI.isUri(s)&&(s=await this.openNotebookDocument(s));let p;typeof a=="object"?p={position:u.ViewColumn.from(a.viewColumn),preserveFocus:a.preserveFocus,selections:a.selections&&a.selections.map(u.NotebookRange.from),pinned:typeof a.preview=="boolean"?!a.preview:void 0}:p={preserveFocus:!1};const t=await this._notebookEditorsProxy.$tryShowNotebookDocument(s.uri,s.notebookType,p),o=t&&this._editors.get(t)?.apiEditor;if(o)return o;throw t?new Error(`Could NOT open editor for "${s.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(s,a,p,t){const o=this._notebookStatusBarItemProviders.get(s),r=T.URI.revive(a),i=this._documents.get(r);if(!i||!o)return;const h=i.getCellFromIndex(p);if(!h)return;const c=await o.provideCellStatusBarItems(h.apiCell,t);if(!c)return;const d=new k.DisposableStore,b=this._statusBarCache.add([d]),g=(Array.isArray(c)?c:[c]).map(_=>u.NotebookStatusBarItem.from(_,this._commandsConverter,d));return{cacheId:b,items:g}}$releaseNotebookCellStatusBarItems(s){this._statusBarCache.delete(s)}registerNotebookSerializer(s,a,p,t,o){if((0,C.isFalsyOrWhitespace)(a))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,p),this._notebookProxy.$registerNotebookSerializer(r,{id:s.identifier,location:s.extensionLocation},a,u.NotebookDocumentContentOptions.from(t),P._convertNotebookRegistrationData(s,o)),(0,k.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(s,a,p){const t=this._notebookSerializer.get(s);if(!t)throw new Error("NO serializer found");const o=await t.deserializeNotebook(a.buffer,p);return new l.SerializableObjectWithBuffers(u.NotebookData.from(o))}async $notebookToData(s,a,p){const t=this._notebookSerializer.get(s);if(!t)throw new Error("NO serializer found");const o=await t.serializeNotebook(u.NotebookData.to(a.value),p);return m.VSBuffer.wrap(o)}async $openNotebook(s,a,p,t,o){const{provider:r}=this._getProviderData(s),i=await r.openNotebook(T.URI.revive(a),{backupId:p,untitledDocumentData:t?.buffer},o);return new l.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(u.NotebookCellData.from)})}async $saveNotebook(s,a,p){const t=this.getNotebookDocument(T.URI.revive(a)),{provider:o}=this._getProviderData(s);return await o.saveNotebook(t.apiNotebook,p),!0}async $saveNotebookAs(s,a,p,t){const o=this.getNotebookDocument(T.URI.revive(a)),{provider:r}=this._getProviderData(s);return await r.saveNotebookAs(T.URI.revive(p),o.apiNotebook,t),!0}async $backupNotebook(s,a,p){const t=this.getNotebookDocument(T.URI.revive(a)),o=this._getProviderData(s),r=this._extensionStoragePaths.workspaceValue(o.extension)??this._extensionStoragePaths.globalValue(o.extension),i=String((0,I.hash)([t.uri.toString(),this._backupIdPool++])),h=T.URI.joinPath(r,i),c=await o.provider.backupNotebook(t.apiNotebook,{destination:h},p);return t.updateBackup(c),c.id}_createExtHostEditor(s,a,p){if(this._editors.has(a))throw new Error(`editor with id ALREADY EXSIST: ${a}`);const t=new S.ExtHostNotebookEditor(a,this._notebookEditorsProxy,s,p.visibleRanges.map(u.NotebookRange.to),p.selections.map(u.NotebookRange.to),typeof p.viewColumn=="number"?u.ViewColumn.to(p.viewColumn):void 0);this._editors.set(a,t)}$acceptDocumentAndEditorsDelta(s){if(s.value.removedDocuments)for(const p of s.value.removedDocuments){const t=T.URI.revive(p),o=this._documents.get(t);o&&(o.dispose(),this._documents.delete(t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:o.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(o.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===t.toString()&&this._editors.delete(r.id)}if(s.value.addedDocuments){const p=[];for(const t of s.value.addedDocuments){const o=T.URI.revive(t.uri);if(this._documents.has(o))throw new Error(`adding EXISTING notebook ${o} `);const r=this,i=new v.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(h){r._onDidChangeNotebookCells.fire(h)},emitCellOutputsChange(h){r._onDidChangeCellOutputs.fire(h)},emitCellMetadataChange(h){r._onDidChangeCellMetadata.fire(h)},emitCellExecutionStateChange(h){r._onDidChangeCellExecutionState.fire(h)}},o,t);p.push(...t.cells.map(h=>v.ExtHostCell.asModelAddData(i.apiNotebook,h))),this._documents.get(o)?.dispose(),this._documents.set(o,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:p}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(s.value.addedEditors)for(const p of s.value.addedEditors){if(this._editors.has(p.id))return;const t=T.URI.revive(p.documentUri),o=this._documents.get(t);o&&this._createExtHostEditor(o,p.id,p)}const a=[];if(s.value.removedEditors)for(const p of s.value.removedEditors){const t=this._editors.get(p);t&&(this._editors.delete(p),this._activeNotebookEditor?.id===t.id&&(this._activeNotebookEditor=void 0),a.push(t))}if(s.value.visibleEditors){this._visibleNotebookEditors=s.value.visibleEditors.map(t=>this._editors.get(t)).filter(t=>!!t);const p=new Set;this._visibleNotebookEditors.forEach(t=>p.add(t.id));for(const t of this._editors.values()){const o=p.has(t.id);t._acceptVisibility(o)}this._visibleNotebookEditors=[...this._editors.values()].map(t=>t).filter(t=>t.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}s.value.newActiveEditor===null?this._activeNotebookEditor=void 0:s.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(s.value.newActiveEditor)),s.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=P,P._notebookStatusBarItemProviderHandlePool=0}),define(me[246],ge([0,1,3,76,12,5,14,15]),function(J,e,m,L,I,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class D{constructor(A,u){const f=D._Keys.nextId();A.$registerNotebookEditorDecorationType(f,C.NotebookDecorationRenderOptions.from(u)),this.value={key:f,dispose(){A.$removeNotebookEditorDecorationType(f)}}}}D._Keys=new L.IdGenerator("NotebookEditorDecorationType");let T=class{constructor(A,u,f){this._logService=A,this._extHostRpc=u,this._notebooksAndEditors=f,this._onDidChangeNotebookEditorSelection=new m.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new m.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(A){return new D(this._extHostRpc.getProxy(k.MainContext.MainThreadNotebookEditors),A).value}$acceptEditorPropertiesChanged(A,u){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",A,u);const f=this._notebooksAndEditors.getEditorById(A);u.visibleRanges&&f._acceptVisibleRanges(u.visibleRanges.ranges.map(C.NotebookRange.to)),u.selections&&f._acceptSelections(u.selections.selections.map(C.NotebookRange.to)),u.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:f.apiEditor,visibleRanges:f.apiEditor.visibleRanges}),u.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:f.apiEditor,selections:f.apiEditor.selections}))}$acceptEditorViewColumns(A){for(const u in A)this._notebooksAndEditors.getEditorById(u)._acceptViewColumn(C.ViewColumn.to(A[u]))}};T=Ve([We(0,I.ILogService),We(1,R.IExtHostRpcService)],T),e.ExtHostNotebookEditors=T}),define(me[247],ge([0,1,17,18,21,3,6,24,2,26,12,5,15,7,88,213,36,66]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,l,v,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let E=class{constructor(o,r,i,h){this._initData=r,this._extHostNotebook=i,this._logService=h,this._activeExecutions=new C.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=o.getProxy(A.MainContext.MainThreadNotebookKernels)}createNotebookController(o,r,i,h,c,d){for(let M of this._kernelData.values())if(M.controller.id===r&&T.ExtensionIdentifier.equals(o.identifier,M.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const b=this._handlePool++,y=this;this._logService.trace(`NotebookController[${b}], CREATED by ${o.identifier.value}, ${r}`);const g=()=>console.warn(`NO execute handler from notebook controller '${G.id}' of extension: '${o.identifier}'`);let _=!1;const w=new R.DisposableStore,F=new k.Emitter,N=new k.Emitter,G={id:`${o.identifier.value}/${r}`,notebookType:i,extensionId:o.identifier,extensionLocation:o.extensionLocation,label:h||o.identifier.value,preloads:d?d.map(u.NotebookRendererScript.from):[]};let K=c??g,U;this._proxy.$addKernel(b,G).catch(M=>{console.log(M),_=!0});let z=0;const O=()=>{if(_)return;const M=++z;Promise.resolve().then(()=>{M===z&&this._proxy.$updateKernel(b,G)})},B=new C.ResourceMap,x={get id(){return r},get notebookType(){return G.notebookType},onDidChangeSelectedNotebooks:F.event,get label(){return G.label},set label(M){G.label=M??o.displayName??o.name,O()},get detail(){return G.detail??""},set detail(M){G.detail=M,O()},get description(){return G.description??""},set description(M){G.description=M,O()},get supportedLanguages(){return G.supportedLanguages},set supportedLanguages(M){G.supportedLanguages=M,O()},get supportsExecutionOrder(){return G.supportsExecutionOrder??!1},set supportsExecutionOrder(M){G.supportsExecutionOrder=M,O()},get rendererScripts(){return G.preloads?G.preloads.map(u.NotebookRendererScript.to):[]},get executeHandler(){return K},set executeHandler(M){K=M??g},get interruptHandler(){return U},set interruptHandler(M){U=M,G.supportsInterrupt=Boolean(M),O()},createNotebookCellExecution(M){if(_)throw new Error("notebook controller is DISPOSED");if(!B.has(M.notebook.uri))throw y._logService.trace(`NotebookController[${b}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(B.keys()).map(H=>H.toString())),new Error(`notebook controller is NOT associated to notebook: ${M.notebook.uri.toString()}`);return y._createNotebookCellExecution(M)},dispose:()=>{_||(this._logService.trace(`NotebookController[${b}], DISPOSED`),_=!0,this._kernelData.delete(b),w.dispose(),F.dispose(),N.dispose(),this._proxy.$removeKernel(b))},updateNotebookAffinity(M,H){y._proxy.$updateNotebookPriority(b,M.uri,H)},onDidReceiveMessage:N.event,postMessage(M,H){return(0,S.checkProposedApiEnabled)(o),y._proxy.$postMessage(b,H&&y._extHostNotebook.getIdByEditor(H),M)},asWebviewUri(M){return(0,S.checkProposedApiEnabled)(o),(0,l.asWebviewUri)(M,y._initData.remote)}};return this._kernelData.set(b,{extensionId:o.identifier,controller:x,onDidReceiveMessage:N,onDidChangeSelection:F,associatedNotebooks:B}),x}$acceptNotebookAssociation(o,r,i){const h=this._kernelData.get(o);if(h){const c=this._extHostNotebook.getNotebookDocument(D.URI.revive(r));i?h.associatedNotebooks.set(c.uri,!0):h.associatedNotebooks.delete(c.uri),this._logService.trace(`NotebookController[${o}] ASSOCIATE notebook`,c.uri.toString(),i),h.onDidChangeSelection.fire({selected:i,notebook:c.apiNotebook})}}async $executeCells(o,r,i){const h=this._kernelData.get(o);if(!h)return;const c=this._extHostNotebook.getNotebookDocument(D.URI.revive(r)),d=[];for(let b of i){const y=c.getCell(b);y&&d.push(y.apiCell)}try{this._logService.trace(`NotebookController[${o}] EXECUTE cells`,c.uri.toString(),d.length),await h.controller.executeHandler.call(h.controller,d,c.apiNotebook,h.controller)}catch(b){this._logService.error(`NotebookController[${o}] execute cells FAILED`,b),console.error(b)}}async $cancelCells(o,r,i){const h=this._kernelData.get(o);if(!h)return;const c=this._extHostNotebook.getNotebookDocument(D.URI.revive(r));if(h.controller.interruptHandler)await h.controller.interruptHandler.call(h.controller,c.apiNotebook);else for(let d of i){const b=c.getCell(d);b&&this._activeExecutions.get(b.uri)?.cancel()}}$acceptKernelMessageFromRenderer(o,r,i){const h=this._kernelData.get(o);if(!h)return;const c=this._extHostNotebook.getEditorById(r);h.onDidReceiveMessage.fire(Object.freeze({editor:c.apiEditor,message:i}))}_createNotebookCellExecution(o){if(o.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const i=this._extHostNotebook.getNotebookDocument(o.notebook.uri).getCellFromApiCell(o);if(!i)throw new Error("invalid cell");if(this._activeExecutions.has(i.uri))throw new Error(`duplicate execution for ${i.uri}`);const h=new a(i.notebook,i,this._proxy);this._activeExecutions.set(i.uri,h);const c=h.onDidChangeState(()=>{h.state===s.Resolved&&(h.dispose(),c.dispose(),this._activeExecutions.delete(i.uri))});return h.asApiObject()}};E=Ve([We(3,n.ILogService)],E),e.ExtHostNotebookKernels=E;var s;(function(t){t[t.Init=0]="Init",t[t.Started=1]="Started",t[t.Resolved=2]="Resolved"})(s||(s={}));class a extends R.Disposable{constructor(o,r,i){super();this._document=o,this._cell=r,this._proxy=i,this._handle=a.HANDLE++,this._onDidChangeState=new k.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=s.Init,this._tokenSource=this._register(new I.CancellationTokenSource),this._collector=new p(10,h=>this.update(h)),this._executionOrder=r.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(o){await this._collector.addItem(o)}async update(o){const r=Array.isArray(o)?o:[o];return this._proxy.$updateExecutions(new P.SerializableObjectWithBuffers(r))}verifyStateForOutput(){if(this._state===s.Init)throw new Error("Must call start before modifying cell output");if(this._state===s.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(o){let r=this._cell;if(o&&(r=this._document.getCellFromApiCell(o)),!r)throw new Error("INVALID cell");return r.handle}validateAndConvertOutputs(o){return o.map(r=>{const i=f.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return i===r.items?u.NotebookCellOutput.from(r):u.NotebookCellOutput.from({items:i,id:r.id,metadata:r.metadata})})}async updateOutputs(o,r,i){const h=this.cellIndexToHandle(r),c=this.validateAndConvertOutputs((0,m.asArray)(o));return this.updateSoon({editType:v.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:h,append:i,outputs:c})}async updateOutputItems(o,r,i){return o=f.NotebookCellOutput.ensureUniqueMimeTypes((0,m.asArray)(o),!0),this.updateSoon({editType:v.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:o.map(u.NotebookCellOutputItem.from),outputId:r.id,append:i})}asApiObject(){const o=this;return Object.freeze({get token(){return o._tokenSource.token},get cell(){return o._cell.apiCell},get executionOrder(){return o._executionOrder},set executionOrder(i){o._executionOrder=i,o.update([{editType:v.CellExecutionUpdateType.ExecutionState,executionHandle:o._handle,executionOrder:o._executionOrder}])},start(i){if(o._state===s.Resolved||o._state===s.Started)throw new Error("Cannot call start again");o._state=s.Started,o._onDidChangeState.fire(),o.update({editType:v.CellExecutionUpdateType.ExecutionState,executionHandle:o._handle,runStartTime:i})},end(i,h){if(o._state===s.Resolved)throw new Error("Cannot call resolve twice");o._state=s.Resolved,o._onDidChangeState.fire(),o.updateSoon({editType:v.CellExecutionUpdateType.Complete,executionHandle:o._handle,runEndTime:h,lastRunSuccess:i}),o._collector.flush(),o._proxy.$removeExecution(o._handle)},clearOutput(i){return o.verifyStateForOutput(),o.updateOutputs([],i,!1)},appendOutput(i,h){return o.verifyStateForOutput(),o.updateOutputs(i,h,!0)},replaceOutput(i,h){return o.verifyStateForOutput(),o.updateOutputs(i,h,!1)},appendOutputItems(i,h){return o.verifyStateForOutput(),o.updateOutputItems(i,h,!0)},replaceOutputItems(i,h){return o.verifyStateForOutput(),o.updateOutputItems(i,h,!1)}})}}a.HANDLE=0;class p{constructor(o,r){this.delay=o,this.callback=r,this.batch=[],this.startedTimer=Date.now()}addItem(o){return this.batch.push(o),this.currentDeferred||(this.currentDeferred=new L.DeferredPromise,this.startedTimer=Date.now(),(0,L.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const o=this.currentDeferred;this.currentDeferred=void 0;const r=this.batch;return this.batch=[],this.callback(r).finally(()=>o.complete())}}}),define(me[248],ge([0,1,3,5,129]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class k{constructor(C,D){this._extHostNotebook=D,this._rendererMessageEmitters=new Map,this.proxy=C.getProxy(L.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(C,D,T){const n=this._extHostNotebook.getEditorById(C);this._rendererMessageEmitters.get(D)?.fire({editor:n.apiEditor,message:T})}createRendererMessaging(C,D){if(!C.contributes?.notebookRenderer?.some(u=>u.id===D))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${D})`);const T=!!C.enableProposedApi,n=new WeakMap;return{onDidReceiveMessage:(u,f,l)=>{const v=T?u:S=>{const P={};n.set(P,S.editor),u({editor:P,message:S.message})};return this.getOrCreateEmitterFor(D).event(v,f,l)},postMessage:(u,f)=>{I.ExtHostNotebookEditor.apiEditorsToExtHost.has(u)&&([u,f]=[f,u]);const l=T?f:n.get(f),v=l&&I.ExtHostNotebookEditor.apiEditorsToExtHost.get(l);return this.proxy.$postMessage(v?.id,D,u)}}}getOrCreateEmitterFor(C){let D=this._rendererMessageEmitters.get(C);return D||(D=new m.Emitter({onLastListenerRemove:()=>{D?.dispose(),this._rendererMessageEmitters.delete(C)}}),this._rendererMessageEmitters.set(C,D),D)}}e.ExtHostNotebookRenderers=k}),define(me[68],ge([0,1,5,3,6,23,4,14]),function(J,e,m,L,I,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class D extends I.Disposable{constructor(l,v,S,P,E){super();this._onDidAppend=this._register(new L.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=l,this._proxy=E,this._id=E.$register(this.name,v,S,P),this._disposed=!1,this._offset=0}get name(){return this._name}append(l){this.validate(),this._offset+=l?k.VSBuffer.fromString(l).byteLength:0}update(){this._id.then(l=>this._proxy.$update(l))}appendLine(l){this.validate(),this.append(l+`
`)}clear(){this.validate();const l=this._offset;this._id.then(v=>this._proxy.$clear(v,l))}show(l,v){this.validate(),this._id.then(S=>this._proxy.$reveal(S,!!(typeof l=="boolean"?l:v)))}hide(){this.validate(),this._id.then(l=>this._proxy.$close(l))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(l=>this._proxy.$dispose(l)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=D;class T extends D{constructor(l,v,S){super(l,!1,void 0,v,S)}append(l){super.append(l),this._id.then(v=>this._proxy.$append(v,l)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=T;class n extends D{constructor(l,v,S){super(l,!0,v,void 0,S)}append(l){throw new Error("Not supported")}}class A{constructor(l,v){this.name=l,this._channel=v}append(l){this._channel.then(v=>v.append(l))}appendLine(l){this._channel.then(v=>v.appendLine(l))}clear(){this._channel.then(l=>l.clear())}show(l,v){this._channel.then(S=>S.show(l,v))}hide(){this._channel.then(l=>l.hide())}dispose(){this._channel.then(l=>l.dispose())}}e.LazyOutputChannel=A;let u=class{constructor(l){this._proxy=l.getProxy(m.MainContext.MainThreadOutputService)}$setVisibleChannel(l){}createOutputChannel(l,v){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");return new T(l,v.identifier.value,this._proxy)}createOutputChannelFromLogFile(l,v){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");if(!v)throw new Error("illegal argument `file`. must not be falsy");return new n(l,v,this._proxy)}};u=Ve([We(0,C.IExtHostRpcService)],u),e.ExtHostOutputService=u,e.IExtHostOutputService=(0,R.createDecorator)("IExtHostOutputService")}),define(me[249],ge([0,1,18,21,3,6,5,2,7,16,17,49,63]),function(J,e,m,L,I,k,R,C,D,T,n,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function f(l,v,S){const P=l.getProxy(R.MainContext.MainThreadQuickOpen);class E{constructor(c,d){this._sessions=new Map,this._instances=0,this._workspace=c,this._commands=d}showQuickPick(c,d,b,y=L.CancellationToken.None){this._onDidSelectItem=void 0;const g=Promise.resolve(c),_=++this._instances,w=P.$show(_,{title:b?.title,placeHolder:b?.placeHolder,matchOnDescription:b?.matchOnDescription,matchOnDetail:b?.matchOnDetail,ignoreFocusLost:b?.ignoreFocusOut,canPickMany:b?.canPickMany},y),F={},N=w.then(()=>F);return Promise.race([N,g]).then(G=>{if(G!==F)return g.then(K=>{const U=[];for(let z=0;z<K.length;z++){const O=K[z];let B,x,M,H,W;typeof O=="string"?B=O:(B=O.label,x=O.description,M=O.detail,H=O.picked,W=O.alwaysShow),U.push({label:B,description:x,handle:z,detail:M,picked:H,alwaysShow:W})}return b&&typeof b.onDidSelectItem=="function"&&(this._onDidSelectItem=z=>{b.onDidSelectItem(K[z])}),P.$setItems(_,U),w.then(z=>{if(typeof z=="number")return K[z];if(Array.isArray(z))return z.map(O=>K[O])})})}).then(void 0,G=>{if(!(0,T.isPromiseCanceledError)(G))return P.$setError(_,G),Promise.reject(G)})}$onItemSelected(c){this._onDidSelectItem&&this._onDidSelectItem(c)}showInput(c,d=L.CancellationToken.None){return this._validateInput=c?c.validateInput:void 0,P.$input(c,typeof this._validateInput=="function",d).then(void 0,b=>{if(!(0,T.isPromiseCanceledError)(b))return Promise.reject(b)})}$validateInput(c){return this._validateInput?(0,m.asPromise)(()=>this._validateInput(c)):Promise.resolve(void 0)}async showWorkspaceFolderPick(c,d=L.CancellationToken.None){const b=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[c]);if(!b)return;const y=await this._workspace.getWorkspaceFolders2();if(!!y)return y.find(g=>g.uri.toString()===b.uri.toString())}createQuickPick(c,d){const b=new r(c,d,()=>this._sessions.delete(b._id));return this._sessions.set(b._id,b),b}createInputBox(c){const d=new i(c,()=>this._sessions.delete(d._id));return this._sessions.set(d._id,d),d}$onDidChangeValue(c,d){const b=this._sessions.get(c);b&&b._fireDidChangeValue(d)}$onDidAccept(c){const d=this._sessions.get(c);d&&d._fireDidAccept()}$onDidChangeActive(c,d){const b=this._sessions.get(c);b instanceof r&&b._fireDidChangeActive(d)}$onDidChangeSelection(c,d){const b=this._sessions.get(c);b instanceof r&&b._fireDidChangeSelection(d)}$onDidTriggerButton(c,d){const b=this._sessions.get(c);b&&b._fireDidTriggerButton(d)}$onDidTriggerItemButton(c,d,b){const y=this._sessions.get(c);y instanceof r&&y._fireDidTriggerItemButton(d,b)}$onDidHide(c){const d=this._sessions.get(c);d&&d._fireDidHide()}}class s{constructor(c,d){this._extensionId=c,this._onDidDispose=d,this._id=r._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new I.Emitter,this._onDidChangeValueEmitter=new I.Emitter,this._onDidTriggerButtonEmitter=new I.Emitter,this._onDidHideEmitter=new I.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(c){this._title=c,this.update({title:c})}get step(){return this._steps}set step(c){this._steps=c,this.update({step:c})}get totalSteps(){return this._totalSteps}set totalSteps(c){this._totalSteps=c,this.update({totalSteps:c})}get enabled(){return this._enabled}set enabled(c){this._enabled=c,this.update({enabled:c})}get busy(){return this._busy}set busy(c){this._busy=c,this.update({busy:c})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(c){this._ignoreFocusOut=c,this.update({ignoreFocusOut:c})}get value(){return this._value}set value(c){this._value=c,this.update({value:c})}get placeholder(){return this._placeholder}set placeholder(c){this._placeholder=c,this.update({placeholder:c})}get buttons(){return this._buttons}set buttons(c){this._buttons=c.slice(),this._handlesToButtons.clear(),c.forEach((d,b)=>{const y=d===D.QuickInputButtons.Back?-1:b;this._handlesToButtons.set(y,d)}),this.update({buttons:c.map((d,b)=>({...o(d),tooltip:d.tooltip,handle:d===D.QuickInputButtons.Back?-1:b}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(c){this._value=c,this._onDidChangeValueEmitter.fire(c)}_fireDidTriggerButton(c){const d=this._handlesToButtons.get(c);d&&this._onDidTriggerButtonEmitter.fire(d)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,k.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),P.$dispose(this._id))}update(c){if(!this._disposed){for(const d of Object.keys(c)){const b=c[d];this._pendingUpdate[d]=b===void 0?null:b}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){P.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}s._nextId=1;function a(h){if(h instanceof D.ThemeIcon)return{id:h.id};const c=t(h),d=p(h);return{dark:typeof c=="string"?C.URI.file(c):c,light:typeof d=="string"?C.URI.file(d):d}}function p(h){return typeof h=="object"&&"light"in h?h.light:h}function t(h){return typeof h=="object"&&"dark"in h?h.dark:h}function o(h){const c=a(h.iconPath);let d,b;return"id"in c?b=u.ThemeIcon.asClassName(c):d=c,{iconPath:d,iconClass:b}}class r extends s{constructor(c,d,b){super(c,b);this.enableProposedApi=d,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new I.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new I.Emitter,this._onDidTriggerItemButtonEmitter=new I.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(c){this._items=c.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),c.forEach((d,b)=>{this._handlesToItems.set(b,d),this._itemsToHandles.set(d,b)}),this.update({items:c.map((d,b)=>({label:d.label,description:d.description,handle:b,detail:d.detail,picked:d.picked,alwaysShow:d.alwaysShow,buttons:d.buttons&&this.enableProposedApi?d.buttons.map((y,g)=>({...o(y),tooltip:y.tooltip,handle:g})):void 0}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(c){this._canSelectMany=c,this.update({canSelectMany:c})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(c){this._matchOnDescription=c,this.update({matchOnDescription:c})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(c){this._matchOnDetail=c,this.update({matchOnDetail:c})}get sortByLabel(){return this._sortByLabel}set sortByLabel(c){this._sortByLabel=c,this.update({sortByLabel:c})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(c){this._keepScrollPosition=c,this.update({keepScrollPosition:c})}get activeItems(){return this._activeItems}set activeItems(c){this._activeItems=c.filter(d=>this._itemsToHandles.has(d)),this.update({activeItems:this._activeItems.map(d=>this._itemsToHandles.get(d))})}get selectedItems(){return this._selectedItems}set selectedItems(c){this._selectedItems=c.filter(d=>this._itemsToHandles.has(d)),this.update({selectedItems:this._selectedItems.map(d=>this._itemsToHandles.get(d))})}_fireDidChangeActive(c){const d=(0,n.coalesce)(c.map(b=>this._handlesToItems.get(b)));this._activeItems=d,this._onDidChangeActiveEmitter.fire(d)}_fireDidChangeSelection(c){const d=(0,n.coalesce)(c.map(b=>this._handlesToItems.get(b)));this._selectedItems=d,this._onDidChangeSelectionEmitter.fire(d)}_fireDidTriggerItemButton(c,d){const b=this._handlesToItems.get(c);if(!b||!b.buttons||!b.buttons.length)return;const y=b.buttons[d];y&&this._onDidTriggerItemButtonEmitter.fire({button:y,item:b})}}class i extends s{constructor(c,d){super(c,d);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(c){this._password=c,this.update({password:c})}get prompt(){return this._prompt}set prompt(c){this._prompt=c,this.update({prompt:c})}get validationMessage(){return this._validationMessage}set validationMessage(c){this._validationMessage=c,this.update({validationMessage:c,severity:c?A.default.Error:A.default.Ignore})}}return new E(v,S)}e.createExtHostQuickOpen=f}),define(me[250],ge([0,1,2,3,58,6,18,5,17,100,12,26,36,63,15]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function v(c){if(c)return typeof c.iconPath=="string"?m.URI.file(c.iconPath):m.URI.isUri(c.iconPath)||f.ThemeIcon.isThemeIcon(c.iconPath)?c.iconPath:void 0}function S(c,d){if(!c.iconPath&&!d.iconPath)return 0;if(c.iconPath){if(!d.iconPath)return 1}else return-1;const b=typeof c.iconPath=="string"?c.iconPath:m.URI.isUri(c.iconPath)?c.iconPath.fsPath:c.iconPath.id,y=typeof d.iconPath=="string"?d.iconPath:m.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id;return(0,T.comparePaths)(b,y)}function P(c,d){let b=0;if(c.strikeThrough!==d.strikeThrough)return c.strikeThrough?1:-1;if(c.faded!==d.faded)return c.faded?1:-1;if(c.tooltip!==d.tooltip)return(c.tooltip||"").localeCompare(d.tooltip||"");if(b=S(c,d),b!==0)return b;if(c.light&&d.light)b=S(c.light,d.light);else{if(c.light)return 1;if(d.light)return-1}if(b!==0)return b;if(c.dark&&d.dark)b=S(c.dark,d.dark);else{if(c.dark)return 1;if(d.dark)return-1}return b}function E(c,d){if(c.command!==d.command)return c.command<d.command?-1:1;if(c.title!==d.title)return c.title<d.title?-1:1;if(c.tooltip!==d.tooltip){if(c.tooltip!==void 0&&d.tooltip!==void 0)return c.tooltip<d.tooltip?-1:1;if(c.tooltip!==void 0)return 1;if(d.tooltip!==void 0)return-1}if(c.arguments===d.arguments)return 0;if(c.arguments)if(d.arguments){if(c.arguments.length!==d.arguments.length)return c.arguments.length-d.arguments.length}else return 1;else return-1;for(let b=0;b<c.arguments.length;b++){const y=c.arguments[b],g=d.arguments[b];if(y!==g)return y<g?-1:1}return 0}function s(c,d){let b=(0,T.comparePaths)(c.resourceUri.fsPath,d.resourceUri.fsPath,!0);if(b!==0)return b;if(c.command&&d.command)b=E(c.command,d.command);else{if(c.command)return 1;if(d.command)return-1}if(b!==0)return b;if(c.decorations&&d.decorations)b=P(c.decorations,d.decorations);else{if(c.decorations)return 1;if(d.decorations)return-1}return b}function a(c,d){for(let b=0;b<c.length;b++)if(c[b]!==d[b])return!1;return!0}function p(c,d){return c.command===d.command&&c.title===d.title&&c.tooltip===d.tooltip&&(c.arguments&&d.arguments?a(c.arguments,d.arguments):c.arguments===d.arguments)}function t(c,d){return(0,D.equals)(c,d,p)}class o{constructor(d,b,y){this._extension=d,this._proxy=b,this._sourceControlHandle=y,this._value="",this._onDidChange=new L.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(d){this._proxy.$setInputBoxValue(this._sourceControlHandle,d),this.updateValue(d)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(d){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,d),this._placeholder=d}get validateInput(){return(0,u.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(d){if((0,u.checkProposedApiEnabled)(this._extension),d&&typeof d!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=d,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!d)}get visible(){return this._visible}set visible(d){d=!!d,this._visible!==d&&(this._visible=d,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,d))}focus(){(0,u.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(d,b){(0,u.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,d,b)}$onInputBoxValueChange(d){this.updateValue(d)}updateValue(d){this._value=d,this._onDidChange.fire(d)}}e.ExtHostSCMInputBox=o;class r{constructor(d,b,y,g,_){this._proxy=d,this._commands=b,this._sourceControlHandle=y,this._id=g,this._label=_,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new L.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(d){this._label=d,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,d)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(d){this._hideWhenEmpty=d,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(d){this._resourceStates=[...d],this._onDidUpdateResourceStates.fire()}getResourceState(d){return this._resourceStatesMap.get(d)}$executeResourceCommand(d,b){const y=this._resourceStatesCommandsMap.get(d);return y?(0,R.asPromise)(()=>this._commands.executeCommand(y.command,...y.arguments||[],b)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const d=[...this._resourceStates].sort(s),y=(0,D.sortedDiff)(this._resourceSnapshot,d,s).map(w=>{const F=w.toInsert.map(N=>{const G=this._resourceHandlePool++;this._resourceStatesMap.set(G,N);const K=N.resourceUri;let U;if(N.command)if(N.command.command==="vscode.open"||N.command.command==="vscode.diff"){const he=new k.DisposableStore;U=this._commands.converter.toInternal(N.command,he),this._resourceStatesDisposablesMap.set(G,he)}else this._resourceStatesCommandsMap.set(G,N.command);const z=v(N.decorations),O=N.decorations&&v(N.decorations.light)||z,B=N.decorations&&v(N.decorations.dark)||z,x=[O,B],M=N.decorations&&N.decorations.tooltip||"",H=N.decorations&&!!N.decorations.strikeThrough,W=N.decorations&&!!N.decorations.faded,Q=N.contextValue||"";return{rawResource:[G,K,x,M,H,W,Q,U],handle:G}});return{start:w.start,deleteCount:w.deleteCount,toInsert:F}}),g=y.map(({start:w,deleteCount:F,toInsert:N})=>[w,F,N.map(G=>G.rawResource)]),_=y.reverse();for(const{start:w,deleteCount:F,toInsert:N}of _){const G=N.map(U=>U.handle),K=this._handlesSnapshot.splice(w,F,...G);for(const U of K)this._resourceStatesMap.delete(U),this._resourceStatesCommandsMap.delete(U),this._resourceStatesDisposablesMap.get(U)?.dispose(),this._resourceStatesDisposablesMap.delete(U)}return this._resourceSnapshot=d,g}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class i{constructor(d,b,y,g,_,w){this._proxy=b,this._commands=y,this._id=g,this._label=_,this._rootUri=w,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new k.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new k.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new L.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new o(d,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,g,_,w)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(d){this._count!==d&&(this._count=d,this._proxy.$updateSourceControl(this.handle,{count:d}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(d){this._quickDiffProvider=d,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!d})}get commitTemplate(){return this._commitTemplate}set commitTemplate(d){d!==this._commitTemplate&&(this._commitTemplate=d,this._proxy.$updateSourceControl(this.handle,{commitTemplate:d}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(d){this._acceptInputDisposables.value=new k.DisposableStore,this._acceptInputCommand=d;const b=this._commands.converter.toInternal(d,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:b})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(d){if(this._statusBarCommands&&d&&t(this._statusBarCommands,d))return;this._statusBarDisposables.value=new k.DisposableStore,this._statusBarCommands=d;const b=(d||[]).map(y=>this._commands.converter.toInternal(y,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:b})}get selected(){return this._selected}createResourceGroup(d,b){const y=new r(this._proxy,this._commands,this.handle,d,b),g=L.Event.once(y.onDidDispose)(()=>this.createdResourceGroups.delete(y));return this.createdResourceGroups.set(y,g),this.eventuallyAddResourceGroups(),y}eventuallyAddResourceGroups(){const d=[],b=[];for(const[y,g]of this.createdResourceGroups){g.dispose();const _=y.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(y),this.eventuallyUpdateResourceStates()});L.Event.once(y.onDidDispose)(()=>{this.updatedResourceGroups.delete(y),_.dispose(),this._groups.delete(y.handle),this._proxy.$unregisterGroup(this.handle,y.handle)}),d.push([y.handle,y.id,y.label,y.features]);const w=y._takeResourceStateSnapshot();w.length>0&&b.push([y.handle,w]),this._groups.set(y.handle,y)}this._proxy.$registerGroups(this.handle,d,b),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const d=[];this.updatedResourceGroups.forEach(b=>{const y=b._takeResourceStateSnapshot();y.length!==0&&d.push([b.handle,y])}),d.length>0&&this._proxy.$spliceResourceStates(this.handle,d),this.updatedResourceGroups.clear()}getResourceGroup(d){return this._groups.get(d)}setSelectionState(d){this._selected=d,this._onDidChangeSelection.fire(d)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(d=>d.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,Ve([(0,I.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),Ve([(0,I.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let h=class xn{constructor(d,b,y){this._commands=b,this.logService=y,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new L.Emitter,this._proxy=d.getProxy(C.MainContext.MainThreadSCM),this._telemetry=d.getProxy(C.MainContext.MainThreadTelemetry),b.registerArgumentProcessor({processArgument:g=>{if(g&&g.$mid===3){const _=this._sourceControls.get(g.sourceControlHandle);if(!_)return g;const w=_.getResourceGroup(g.groupHandle);return w?w.getResourceState(g.handle):g}else if(g&&g.$mid===4){const _=this._sourceControls.get(g.sourceControlHandle);return _?_.getResourceGroup(g.groupHandle):g}else if(g&&g.$mid===5){const _=this._sourceControls.get(g.handle);return _||g}return g}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(d,b,y,g){this.logService.trace("ExtHostSCM#createSourceControl",d.identifier.value,b,y,g),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:d.identifier.value});const _=xn._handlePool++,w=new i(d,this._proxy,this._commands,b,y,g);this._sourceControls.set(_,w);const F=this._sourceControlsByExtension.get(A.ExtensionIdentifier.toKey(d.identifier))||[];return F.push(w),this._sourceControlsByExtension.set(A.ExtensionIdentifier.toKey(d.identifier),F),w}getLastInputBox(d){this.logService.trace("ExtHostSCM#getLastInputBox",d.identifier.value);const b=this._sourceControlsByExtension.get(A.ExtensionIdentifier.toKey(d.identifier)),y=b&&b[b.length-1];return y&&y.inputBox}$provideOriginalResource(d,b,y){const g=m.URI.revive(b);this.logService.trace("ExtHostSCM#$provideOriginalResource",d,g.toString());const _=this._sourceControls.get(d);return!_||!_.quickDiffProvider||!_.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.asPromise)(()=>_.quickDiffProvider.provideOriginalResource(g,y)).then(w=>w||null)}$onInputBoxValueChange(d,b){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",d);const y=this._sourceControls.get(d);return y&&y.inputBox.$onInputBoxValueChange(b),Promise.resolve(void 0)}$executeResourceCommand(d,b,y,g){this.logService.trace("ExtHostSCM#$executeResourceCommand",d,b,y);const _=this._sourceControls.get(d);if(!_)return Promise.resolve(void 0);const w=_.getResourceGroup(b);return w?w.$executeResourceCommand(y,g):Promise.resolve(void 0)}$validateInput(d,b,y){this.logService.trace("ExtHostSCM#$validateInput",d);const g=this._sourceControls.get(d);return!g||!g.inputBox.validateInput?Promise.resolve(void 0):(0,R.asPromise)(()=>g.inputBox.validateInput(b,y)).then(_=>{if(!_)return Promise.resolve(void 0);const w=l.MarkdownString.fromStrict(_.message);return w?Promise.resolve([w,_.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(d){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",d),d!==void 0&&this._sourceControls.get(d)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=d,Promise.resolve(void 0)}};h._handlePool=0,h=Ve([We(2,n.ILogService)],h),e.ExtHostSCM=h});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(J,m):I?I.value=m:e.set(J,m),m},Oe=this&&this.__classPrivateFieldGet||function(J,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(J):L?L.value:e.get(J)};define(me[251],ge([0,1,7,5,166,6,15]),function(J,e,m,L,I,k,R){"use strict";var C,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class T{constructor(f,l,v,S,P=m.StatusBarAlignment.Left,E){C.set(this,void 0),D.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new k.DisposableStore,nt(this,C,f,"f"),nt(this,D,l,"f"),this._entryId=T.ID_GEN++,this._extension=v,this._id=S,this._alignment=P,this._priority=E}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(f){this._text=f,this.update()}set name(f){this._name=f,this.update()}set tooltip(f){this._tooltip=f,this.update()}set color(f){this._color=f,this.update()}set backgroundColor(f){f&&!T.ALLOWED_BACKGROUND_COLORS.has(f.id)&&(f=void 0),this._backgroundColor=f,this.update()}set command(f){this._command?.fromApi!==f&&(this._internalCommandRegistration.clear(),typeof f=="string"?this._command={fromApi:f,internal:Oe(this,D,"f").toInternal({title:"",command:f},this._internalCommandRegistration)}:f?this._command={fromApi:f,internal:Oe(this,D,"f").toInternal(f,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(f){this._accessibilityInformation=f,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Oe(this,C,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let f;this._extension?this._id?f=`${this._extension.identifier.value}.${this._id}`:f=this._extension.identifier.value:f=this._id;let l;this._name?l=this._name:l=(0,I.localize)(0,null,this._extension.displayName||this._extension.name);let v=this._color;this._backgroundColor&&(v=T.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const S=this._tooltip?R.MarkdownString.fromStrict(this._tooltip):void 0;Oe(this,C,"f").$setEntry(this._entryId,f,l,this._text,S,this._command?.internal,v,this._backgroundColor,this._alignment===m.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=T,C=new WeakMap,D=new WeakMap,T.ID_GEN=0,T.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new m.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new m.ThemeColor("statusBarItem.warningForeground")]]);class n{constructor(f){this._messages=[],this._item=f.createStatusBarEntry(void 0,"status.extensionMessage",m.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,I.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(f){const l={message:f};return this._messages.unshift(l),this._update(),new m.Disposable(()=>{const v=this._messages.indexOf(l);v>=0&&(this._messages.splice(v,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class A{constructor(f,l){this._proxy=f.getProxy(L.MainContext.MainThreadStatusBar),this._commands=l,this._statusMessage=new n(this)}createStatusBarEntry(f,l,v,S){return new T(this._proxy,this._commands,f,l,v,S)}setStatusBarMessage(f,l){const v=this._statusMessage.setMessage(f);let S;return typeof l=="number"?S=setTimeout(()=>v.dispose(),l):typeof l!="undefined"&&l.then(()=>v.dispose(),()=>v.dispose()),new m.Disposable(()=>{v.dispose(),clearTimeout(S)})}}e.ExtHostStatusBar=A}),define(me[92],ge([0,1,5,3,4]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class k{constructor(C){this._onDidChangeStorage=new L.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=C.getProxy(m.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(C,D){this._proxy.$registerExtensionStorageKeysToSync(C,D)}getValue(C,D,T){return this._proxy.$getValue(C,D).then(n=>n||T)}setValue(C,D,T){return this._proxy.$setValue(C,D,T)}$acceptValue(C,D,T){this._onDidChangeStorage.fire({shared:C,key:D,value:T})}}e.ExtHostStorage=k,e.IExtHostStorage=(0,I.createDecorator)("IExtHostStorage")}),define(me[69],ge([0,1,4,27,12,91,2]),function(J,e,m,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,m.createDecorator)("IExtensionStoragePaths");let C=class{constructor(T,n,A){this._logService=n,this._extHostFileSystem=A,this._workspace=T.workspace??void 0,this._environment=T.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(u=>this._value=u)}async _getWorkspaceStorageURI(T){return R.URI.joinPath(this._environment.workspaceStorageHome,T)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const T=this._workspace.id,n=await this._getWorkspaceStorageURI(T);try{return await this._extHostFileSystem.value.stat(n),this._logService.trace("[ExtHostStorage] storage dir already exists",n),n}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",n),await this._extHostFileSystem.value.createDirectory(n),await this._extHostFileSystem.value.writeFile(R.URI.joinPath(n,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:R.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),n}catch(A){this._logService.error("[ExtHostStorage]",A);return}}workspaceValue(T){if(this._value)return R.URI.joinPath(this._value,T.identifier.value)}globalValue(T){return R.URI.joinPath(this._environment.globalStorageHome,T.identifier.value.toLowerCase())}onWillDeactivateAll(){}};C=Ve([We(0,L.IExtHostInitDataService),We(1,I.ILogService),We(2,k.IExtHostConsumerFileSystem)],C),e.ExtensionStoragePaths=C}),define(me[33],ge([0,1,3,5,4,2,14,6,7,167,16,215,21,32,195,196,63,13]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,l,v,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,I.createDecorator)("IExtHostTerminalService");class E{constructor(c,d,b,y){this._proxy=c,this._id=d,this._creationOptions=b,this._name=y,this._disposed=!1,this._state={interactedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(_=>this._pidPromiseComplete=_);const g=this;this.value={get name(){return g._name||""},get processId(){return g._pidPromise},get creationOptions(){return g._creationOptions},get exitStatus(){return g._exitStatus},get state(){return g._state},sendText(_,w=!0){g._checkDisposed(),g._proxy.$sendText(g._id,_,w)},show(_){g._checkDisposed(),g._proxy.$show(g._id,_)},hide(){g._checkDisposed(),g._proxy.$hide(g._id)},dispose(){g._disposed||(g._disposed=!0,g._proxy.$dispose(g._id))},get dimensions(){if(!(g._cols===void 0||g._rows===void 0))return{columns:g._cols,rows:g._rows}}}}async create(c,d){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:c.name,shellPath:(0,P.withNullAsUndefined)(c.shellPath),shellArgs:(0,P.withNullAsUndefined)(c.shellArgs),cwd:(0,P.withNullAsUndefined)(c.cwd),env:(0,P.withNullAsUndefined)(c.env),icon:(0,P.withNullAsUndefined)(r(c.iconPath)),color:S.ThemeColor.isThemeColor(c.color)?c.color.id:void 0,initialText:(0,P.withNullAsUndefined)(c.message),strictEnv:(0,P.withNullAsUndefined)(c.strictEnv),hideFromUser:(0,P.withNullAsUndefined)(c.hideFromUser),isFeatureTerminal:(0,P.withNullAsUndefined)(d?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,P.withNullAsUndefined)(d?.useShellEnvironment),location:d?.location||this._serializeParentTerminal(c.location,d?.resolvedExtHostIdentifier,d?.location)})}async createExtensionTerminal(c,d,b,y){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:b,color:S.ThemeColor.isThemeColor(y)?y.id:void 0,location:this._serializeParentTerminal(c,d)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(c,d,b){return typeof c=="object"&&"parentTerminal"in c?d?{parentTerminal:d}:void 0:(b&&(c=b),c)}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(c){this._name=c}setExitCode(c){this._exitStatus=Object.freeze({code:c})}setDimensions(c,d){return c===this._cols&&d===this._rows||c===0||d===0?!1:(this._cols=c,this._rows=d,!0)}setInteractedWith(){return this._state.interactedWith?!1:(this._state={interactedWith:!0},!0)}_setProcessId(c){this._pidPromiseComplete?(this._pidPromiseComplete(c),this._pidPromiseComplete=void 0):this._pidPromise.then(d=>{d!==c&&(this._pidPromise=Promise.resolve(c))})}}e.ExtHostTerminal=E;class s{constructor(c){this._pty=c,this.id=0,this.shouldPersist=!1,this._onProcessData=new m.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new m.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new m.Emitter,this._onProcessTitleChanged=new m.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new m.Emitter,this._onProcessShellTypeChanged=new m.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(c){this._pty.handleInput&&this._pty.handleInput(c)}resize(c,d){this._pty.setDimensions&&this._pty.setDimensions({columns:c,rows:d})}async processBinary(c){}acknowledgeDataEvent(c){}async setUnicodeVersion(c){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(c){this._pty.onDidWrite(d=>this._onProcessData.fire(d)),this._pty.onDidClose&&this._pty.onDidClose((d=void 0)=>{this._onProcessExit.fire(d===void 0?void 0:d)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(d=>this._onProcessOverrideDimensions.fire(d&&{cols:d.columns,rows:d.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(d=>this._onProcessTitleChanged.fire(d)),this._pty.open(c||void 0),this._pty.setDimensions&&c&&this._pty.setDimensions(c),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=s;let a=1,p=class extends C.Disposable{constructor(c,d){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new m.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new m.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new m.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new m.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new m.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=d.getProxy(L.MainContext.MainThreadTerminalService),this._bufferer=new v.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new m.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(c),this._register({dispose:()=>{for(const[b,y]of this._terminalProcesses)y.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(c=>c.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(c){return(c?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(c){return(c?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(c,d){const b=new E(this._proxy,(0,f.generateUuid)(),c,c.name),y=new s(c.pty);return b.createExtensionTerminal(this._resolveLocation(c.location),d?.resolvedExtHostIdentifier,r(c.iconPath),i(c.color)).then(g=>{const _=this._setupExtHostProcessListeners(g,y);this._terminalProcessDisposables[g]=_}),this._terminals.push(b),b.value}_resolveLocation(c){return typeof c=="object"&&"viewColumn"in c&&c.viewColumn!==void 0?{viewColumn:c.viewColumn,preserveFocus:c.preserveFocus}:typeof c=="object"&&"parentTerminal"in c?void 0:(c===l.TerminalLocation.Editor||c===l.TerminalLocation.Panel,c)}attachPtyToTerminal(c,d){if(!this._getTerminalById(c))throw new Error(`Cannot resolve terminal with id ${c} for virtual process`);const y=new s(d),g=this._setupExtHostProcessListeners(c,y);this._terminalProcessDisposables[c]=g}async $acceptActiveTerminalChanged(c){const d=this._activeTerminal;if(c===null){this._activeTerminal=void 0,d!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const b=this._getTerminalById(c);b&&(this._activeTerminal=b,d!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(c,d){const b=this._getTerminalById(c);b&&this._onDidWriteTerminalData.fire({terminal:b.value,data:d})}async $acceptTerminalDimensions(c,d,b){const y=this._getTerminalById(c);y&&y.setDimensions(d,b)&&this._onDidChangeTerminalDimensions.fire({terminal:y.value,dimensions:y.value.dimensions})}async $acceptTerminalMaximumDimensions(c,d,b){this._terminalProcesses.get(c)?.resize(d,b)}async $acceptTerminalTitleChange(c,d){const b=this._getTerminalById(c);b&&(b.name=d)}async $acceptTerminalClosed(c,d){const b=this._getTerminalObjectIndexById(this._terminals,c);if(b!==null){const y=this._terminals.splice(b,1)[0];y.setExitCode(d),this._onDidCloseTerminal.fire(y.value)}}$acceptTerminalOpened(c,d,b,y){if(d){const w=this._getTerminalObjectIndexById(this._terminals,d);if(w!==null){this._terminals[w]._id=c,this._onDidOpenTerminal.fire(this.terminals[w]),this._terminals[w].isOpen=!0;return}}const g={name:y.name,shellPath:y.executable,shellArgs:y.args,cwd:typeof y.cwd=="string"?y.cwd:k.URI.revive(y.cwd),env:y.env,hideFromUser:y.hideFromUser},_=new E(this._proxy,c,g,b);this._terminals.push(_),this._onDidOpenTerminal.fire(_.value),_.isOpen=!0}async $acceptTerminalProcessId(c,d){const b=this._getTerminalById(c);b&&b._setProcessId(d)}async $startExtensionTerminal(c,d){const b=this._getTerminalById(c);if(!b)return{message:(0,T.localize)(0,null,c)};b.isOpen||await new Promise(g=>{const _=this.onDidOpenTerminal(async w=>{w===b.value&&(_.dispose(),g())})});const y=this._terminalProcesses.get(c);y?y.startSendingEvents(d):this._extensionTerminalAwaitingStart[c]={initialDimensions:d}}_setupExtHostProcessListeners(c,d){const b=new C.DisposableStore;b.add(d.onProcessReady(g=>this._proxy.$sendProcessReady(c,g.pid,g.cwd))),b.add(d.onProcessTitleChanged(g=>this._proxy.$sendProcessTitle(c,g))),this._bufferer.startBuffering(c,d.onProcessData),b.add(d.onProcessExit(g=>this._onProcessExit(c,g))),d.onProcessOverrideDimensions&&b.add(d.onProcessOverrideDimensions(g=>this._proxy.$sendOverrideDimensions(c,g))),this._terminalProcesses.set(c,d);const y=this._extensionTerminalAwaitingStart[c];return y&&d instanceof s&&(d.startSendingEvents(y.initialDimensions),delete this._extensionTerminalAwaitingStart[c]),b}$acceptProcessAckDataEvent(c,d){this._terminalProcesses.get(c)?.acknowledgeDataEvent(d)}$acceptProcessInput(c,d){this._terminalProcesses.get(c)?.input(d)}$acceptTerminalInteraction(c){const d=this._getTerminalById(c);d?.setInteractedWith()&&this._onDidChangeTerminalState.fire(d.value)}$acceptProcessResize(c,d,b){try{this._terminalProcesses.get(c)?.resize(d,b)}catch(y){if(y.code!=="EPIPE"&&y.code!=="ERR_IPC_CHANNEL_CLOSED")throw y}}$acceptProcessShutdown(c,d){this._terminalProcesses.get(c)?.shutdown(d)}$acceptProcessRequestInitialCwd(c){this._terminalProcesses.get(c)?.getInitialCwd().then(d=>this._proxy.$sendProcessInitialCwd(c,d))}$acceptProcessRequestCwd(c){this._terminalProcesses.get(c)?.getCwd().then(d=>this._proxy.$sendProcessCwd(c,d))}$acceptProcessRequestLatency(c){return c}registerLinkProvider(c){return this._linkProviders.add(c),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(c),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(c,d,b){if(this._profileProviders.has(d))throw new Error(`Terminal profile provider "${d}" already registered`);return this._profileProviders.set(d,b),this._proxy.$registerProfileProvider(d,c.identifier.value),new D.Disposable(()=>{this._profileProviders.delete(d),this._proxy.$unregisterProfileProvider(d)})}async $createContributedProfileTerminal(c,d){const b=new u.CancellationTokenSource().token,y=await this._profileProviders.get(c)?.provideTerminalProfile(b);if(!b.isCancellationRequested){if(!y||!("options"in y))throw new Error(`No terminal profile options provided for id "${c}"`);if("pty"in y.options){this.createExtensionTerminal(y.options,d);return}this.createTerminalFromOptions(y.options,d)}}async $provideLinks(c,d){const b=this._getTerminalById(c);if(!b)return[];this._terminalLinkCache.delete(c);const y=this._terminalLinkCancellationSource.get(c);y&&y.dispose(!0);const g=new u.CancellationTokenSource;this._terminalLinkCancellationSource.set(c,g);const _=[],w={terminal:b.value,line:d},F=[];for(const K of this._linkProviders)F.push(new Promise(async U=>{g.token.onCancellationRequested(()=>U({provider:K,links:[]}));const z=await K.provideTerminalLinks(w,g.token)||[];g.token.isCancellationRequested||U({provider:K,links:z})}));const N=await Promise.all(F);if(g.token.isCancellationRequested)return[];const G=new Map;for(const K of N)K&&K.links.length>0&&_.push(...K.links.map(U=>{const z={id:a++,startIndex:U.startIndex,length:U.length,label:U.tooltip};return G.set(z.id,{provider:K.provider,link:U}),z}));return this._terminalLinkCache.set(c,G),_}$activateLink(c,d){const b=this._terminalLinkCache.get(c)?.get(d);!b||b.provider.handleTerminalLink(b.link)}_onProcessExit(c,d){this._bufferer.stopBuffering(c),this._terminalProcesses.delete(c),delete this._extensionTerminalAwaitingStart[c];const b=this._terminalProcessDisposables[c];b&&(b.dispose(),delete this._terminalProcessDisposables[c]),this._proxy.$sendProcessExit(c,d)}_getTerminalById(c){return this._getTerminalObjectById(this._terminals,c)}_getTerminalObjectById(c,d){const b=this._getTerminalObjectIndexById(c,d);return b!==null?c[b]:null}_getTerminalObjectIndexById(c,d){let b=null;return c.some((y,g)=>y._id===d?(b=g,!0):!1),b}getEnvironmentVariableCollection(c){let d=this._environmentVariableCollections.get(c.identifier.value);return d||(d=new t,this._setEnvironmentVariableCollection(c.identifier.value,d)),d}_syncEnvironmentVariableCollection(c,d){const b=(0,A.serializeEnvironmentVariableCollection)(d.map);this._proxy.$setEnvironmentVariableCollection(c,d.persistent,b.length===0?void 0:b)}$initEnvironmentVariableCollections(c){c.forEach(d=>{const b=d[0],y=new t(d[1]);this._setEnvironmentVariableCollection(b,y)})}$acceptDefaultProfile(c,d){this._defaultProfile=c,this._defaultAutomationProfile=d}_setEnvironmentVariableCollection(c,d){this._environmentVariableCollections.set(c,d),d.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(c,d)})}};p=Ve([We(1,R.IExtHostRpcService)],p),e.BaseExtHostTerminalService=p;class t{constructor(c){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new m.Emitter,this.map=new Map(c)}get persistent(){return this._persistent}set persistent(c){this._persistent=c,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(c,d){this._setIfDiffers(c,{value:d,type:D.EnvironmentVariableMutatorType.Replace})}append(c,d){this._setIfDiffers(c,{value:d,type:D.EnvironmentVariableMutatorType.Append})}prepend(c,d){this._setIfDiffers(c,{value:d,type:D.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(c,d){const b=this.map.get(c);(!b||b.value!==d.value||b.type!==d.type)&&(this.map.set(c,d),this._onDidChangeCollection.fire())}get(c){return this.map.get(c)}forEach(c,d){this.map.forEach((b,y)=>c.call(d,y,b,this))}delete(c){this.map.delete(c),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=t;let o=class extends p{constructor(c){super(!1,c)}createTerminal(c,d,b){throw new n.NotSupportedError}createTerminalFromOptions(c,d){throw new n.NotSupportedError}};o=Ve([We(0,R.IExtHostRpcService)],o),e.WorkerExtHostTerminalService=o;function r(h){if(!(!h||typeof h=="string"))return"id"in h?{id:h.id,color:h.color}:h}function i(h){return S.ThemeColor.isThemeColor(h)?h:void 0}});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(J,m):I?I.value=m:e.set(J,m),m},Oe=this&&this.__classPrivateFieldGet||function(J,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(J):L?L.value:e.get(J)};define(me[252],ge([0,1,17,23,21,3,75,48,6,25,13,32,5,14,64,15,7,223,127,89]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,l,v,S,P,E,s){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let p=class{constructor(w,F){this.resultsChangedEmitter=new k.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=w.getProxy(u.MainContext.MainThreadTesting),this.observer=new b(this.proxy),this.runTracker=new o(this.proxy),F.registerArgumentProcessor({processArgument:N=>N?.$mid===13?v.TestItem.toItemFromContext(N):N})}createTestController(w,F){if(this.controllers.has(w))throw new Error(`Attempt to insert a duplicate controller with ID "${w}"`);const N=new D.DisposableStore,G=N.add(new P.SingleUseTestCollection(w));G.root.label=F;const K=new Map,U=this.proxy,z={items:G.root.children,get label(){return F},set label(B){F=B,G.root.label=B,U.$updateControllerLabel(w,F)},get id(){return w},createRunProfile:(B,x,M,H,W)=>{let Q=(0,C.hash)(B);for(;K.has(Q);)Q++;const X=new y(this.proxy,w,Q,B,x,M,H,W);return K.set(Q,X),X},createTestItem(B,x,M){return new l.TestItemImpl(w,B,x,M)},createTestRun:(B,x,M=!0)=>this.runTracker.createTestRun(w,G,B,x,M),set resolveHandler(B){G.resolveHandler=B},get resolveHandler(){return G.resolveHandler},dispose:()=>{N.dispose()}};z.createRunConfiguration=z.createRunProfile,U.$registerTestController(w,F),N.add((0,D.toDisposable)(()=>U.$unregisterTestController(w)));const O={controller:z,collection:G,profiles:K};return this.controllers.set(w,O),N.add((0,D.toDisposable)(()=>this.controllers.delete(w))),N.add(G.onDidGenerateDiff(B=>U.$publishDiff(w,B))),z}createTestObserver(){return this.observer.checkout()}async runTests(w,F=I.CancellationToken.None){const N=r(w);if(!N)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const G=this.controllers.get(N.controllerId);if(!G)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:w.include?.map(K=>K.id)??[G.collection.root.id],profileGroup:g[N.kind],profileId:N.profileId,controllerId:N.controllerId}],exclude:w.exclude?.map(K=>K.id)},F)}$provideFileCoverage(w,F,N){return(0,m.mapFind)(this.runTracker.trackers,K=>K.id===w?K.getCoverage(F):void 0)?.provideFileCoverage(N)??Promise.resolve([])}$resolveFileCoverage(w,F,N,G){return(0,m.mapFind)(this.runTracker.trackers,U=>U.id===w?U.getCoverage(F):void 0)?.resolveFileCoverage(N,G)??Promise.resolve([])}$configureRunProfile(w,F){this.controllers.get(w)?.profiles.get(F)?.configureHandler?.()}$publishTestResults(w){this.results=Object.freeze(w.map(F=>(0,T.deepFreeze)(v.TestResults.to(F))).concat(this.results).sort((F,N)=>N.completedAt-F.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(w,F){const N=this.controllers.get(s.TestId.fromString(w).controllerId)?.collection;N&&(await N.expand(w,F<0?Infinity:F),N.flushDiff())}$acceptDiff(w){this.observer.applyDiff(w)}async $runControllerTests(w,F){const N=this.controllers.get(w.controllerId);if(!N)return;const{collection:G,profiles:K}=N,U=K.get(w.profileId);if(!U)return;const z=w.testIds.map(M=>G.tree.get(M)).filter(n.isDefined),O=w.excludeExtIds.map(M=>N.collection.tree.get(M)).filter(n.isDefined).filter(M=>z.some(H=>H.fullId.compare(M.fullId)===2));if(!z.length)return;const B=new S.TestRunRequest(z.some(M=>M.actual instanceof l.TestItemRootImpl)?void 0:z.map(M=>M.actual),O.map(M=>M.actual),U),x=this.runTracker.prepareForMainThreadTestRun(B,i.fromInternal(w,N.collection),F);try{await U.runHandler(B,F)}finally{x.isRunning&&!F.isCancellationRequested&&await k.Event.toPromise(x.onEnd),x.dispose()}}$cancelExtensionTestRun(w){w===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(w)}};p=Ve([We(0,f.IExtHostRpcService)],p),e.ExtHostTesting=p;class t extends D.Disposable{constructor(w,F,N){super();this.dto=w,this.proxy=F,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new k.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new I.CancellationTokenSource(N)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:G}of this.tasks.values())G.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(w){return this.tasks.get(w)?.coverage}createRun(w){const F=this.dto.id,N=this.dto.controllerId,G=(0,A.generateUuid)(),K=new h(this.proxy,F,G),U=x=>(M,...H)=>{if(O){console.warn(`Setting the state of test "${M.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(M)||(this.ensureTestIsKnown(M),x(M,...H))},z=(x,M)=>{const H=M instanceof Array?M.map(v.TestMessage.from):[v.TestMessage.from(M)];if(x.uri&&x.range){const W={range:v.Range.from(x.range),uri:x.uri};for(const Q of H)Q.location=Q.location||W}this.proxy.$appendTestMessagesInRun(F,G,s.TestId.fromExtHostTestItem(x,N).toString(),H)};let O=!1;const B={isPersisted:this.dto.isPersisted,token:this.cts.token,name:w,get coverageProvider(){return K.coverageProvider},set coverageProvider(x){K.coverageProvider=x},enqueued:U(x=>{this.proxy.$updateTestStateInRun(F,G,s.TestId.fromExtHostTestItem(x,N).toString(),1)}),skipped:U(x=>{this.proxy.$updateTestStateInRun(F,G,s.TestId.fromExtHostTestItem(x,N).toString(),5)}),started:U(x=>{this.proxy.$updateTestStateInRun(F,G,s.TestId.fromExtHostTestItem(x,N).toString(),2)}),errored:U((x,M,H)=>{z(x,M),this.proxy.$updateTestStateInRun(F,G,s.TestId.fromExtHostTestItem(x,N).toString(),6,H)}),failed:U((x,M,H)=>{z(x,M),this.proxy.$updateTestStateInRun(F,G,s.TestId.fromExtHostTestItem(x,N).toString(),4,H)}),passed:U((x,M)=>{this.proxy.$updateTestStateInRun(F,G,s.TestId.fromExtHostTestItem(x,this.dto.controllerId).toString(),3,M)}),appendOutput:(x,M,H)=>{O||(H&&(this.dto.isIncluded(H)?this.ensureTestIsKnown(H):H=void 0),this.proxy.$appendOutputToRun(F,G,L.VSBuffer.fromString(x),M&&v.location.from(M),H&&s.TestId.fromExtHostTestItem(H,N).toString()))},end:()=>{O||(O=!0,this.proxy.$finishedTestRunTask(F,G),this.tasks.delete(G),this.isRunning||this.dispose())}};return this.tasks.set(G,{run:B,coverage:K}),this.proxy.$startedTestRunTask(F,{id:G,name:w,running:!0}),B}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(w){if(!(w instanceof l.TestItemImpl))throw new l.InvalidTestItemError(w.id);if(this.sharedTestIds.has(s.TestId.fromExtHostTestItem(w,this.dto.controllerId).toString()))return;const F=[],N=this.dto.colllection.root;for(;;){const G=v.TestItem.from(w);if(F.unshift(G),this.sharedTestIds.has(G.extId)||(this.sharedTestIds.add(G.extId),w===N))break;w=w.parent||N}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,F)}}class o{constructor(w){this.proxy=w,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(w,F,N){return this.getTracker(w,F,N)}cancelRunById(w){for(const F of this.tracked.values())if(F.id===w){F.dispose();return}}cancelAllRuns(){for(const w of this.tracked.values())w.dispose()}createTestRun(w,F,N,G,K){const U=this.tracked.get(N);if(U)return U.createRun(G);const z=i.fromPublic(w,F,N,K),O=r(N);this.proxy.$startedExtensionTestRun({controllerId:w,profile:O&&{group:g[O.kind],id:O.profileId},exclude:N.exclude?.map(x=>x.id)??[],id:z.id,include:N.include?.map(x=>x.id)??[F.root.id],persist:K});const B=this.getTracker(N,z);return B.onEnd(()=>this.proxy.$finishedExtensionTestRun(z.id)),B.createRun(G)}getTracker(w,F,N){const G=new t(F,this.proxy,N);return this.tracked.set(w,G),G.onEnd(()=>this.tracked.delete(w)),G}}e.TestRunCoordinator=o;const r=_=>{if(!!_.profile){if(!(_.profile instanceof y))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return _.profile}};class i{constructor(w,F,N,G,K,U){this.controllerId=w,this.id=F,this.isPersisted=K,this.colllection=U,this.includePrefix=N.map(z=>z+"\0"),this.excludePrefix=G.map(z=>z+"\0")}static fromPublic(w,F,N,G){return new i(w,(0,A.generateUuid)(),N.include?.map(K=>s.TestId.fromExtHostTestItem(K,w).toString())??[w],N.exclude?.map(K=>s.TestId.fromExtHostTestItem(K,w).toString())??[],G,F)}static fromInternal(w,F){return new i(w.controllerId,w.runId,w.testIds,w.excludeExtIds,!0,F)}isIncluded(w){const F=s.TestId.fromExtHostTestItem(w,this.controllerId).toString()+"\0";for(const N of this.excludePrefix)if(F===N||F.startsWith(N))return!1;for(const N of this.includePrefix)if(F===N||F.startsWith(N))return!0;return!1}}e.TestRunDto=i;class h{constructor(w,F,N){this.proxy=w,this.runId=F,this.taskId=N}set coverageProvider(w){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!w||(this._coverageProvider=w,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(w){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(w))());try{return(await this.fileCoverage)?.map(v.TestCoverage.fromFile)??[]}catch(F){throw this.fileCoverage=void 0,F}}async resolveFileCoverage(w,F){const N=await this.fileCoverage;let G=N?.[w];return!this._coverageProvider||!N||!G?[]:(G.detailedCoverage||(G=N[w]=await this._coverageProvider.resolveFileCoverage?.(G,F)??G),G.detailedCoverage?.map(v.TestCoverage.fromDetailed)??[])}}class c extends E.IncrementalChangeCollector{constructor(w){super();this.emitter=w,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(w){this.added.add(w)}update(w){Object.assign(w.revived,v.TestItem.toPlain(w.item)),this.added.has(w)||this.updated.add(w)}remove(w){if(this.added.has(w)){this.added.delete(w);return}if(this.updated.delete(w),w.parent&&this.alreadyRemoved.has(w.parent)){this.alreadyRemoved.add(w.item.extId);return}this.removed.add(w)}getChangeEvent(){const{added:w,updated:F,removed:N}=this;return{get added(){return[...w].map(G=>G.revived)},get updated(){return[...F].map(G=>G.revived)},get removed(){return[...N].map(G=>G.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class d extends E.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new k.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(w){return this.items.get(w)}getMirroredTestDataByReference(w){return this.items.get(w.id)}createItem(w,F){return{...w,revived:v.TestItem.toPlain(w.item),depth:F?F.depth+1:0,children:new Set}}createChangeCollector(){return new c(this.changeEmitter)}}e.MirroredTestCollection=d;class b{constructor(w){this.proxy=w}checkout(){this.current||(this.current=this.createObserverData());const w=this.current;return w.observers++,{onDidChangeTest:w.tests.onDidChangeTests,get tests(){return[...w.tests.rootTests].map(F=>F.revived)},dispose:(0,R.once)(()=>{--w.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(w){return this.current?.tests.getMirroredTestDataByReference(w)}applyDiff(w){this.current?.tests.apply(w)}createObserverData(){const w=new d;return this.proxy.$subscribeToDiffs(),{observers:0,tests:w}}}class y{constructor(w,F,N,G,K,U,z=!1,O=void 0){this.controllerId=F,this.profileId=N,this._label=G,this.kind=K,this.runHandler=U,this._isDefault=z,this._tag=O,a.set(this,void 0),nt(this,a,w,"f");const B=g[K];if(typeof B!="number")throw new Error(`Unknown TestRunProfile.group ${K}`);Oe(this,a,"f").$publishTestRunProfile({profileId:N,controllerId:F,tag:O?v.TestTag.namespace(this.controllerId,O.id):null,label:G,group:B,isDefault:z,hasConfigurationHandler:!1})}get label(){return this._label}set label(w){w!==this._label&&(this._label=w,Oe(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:w}))}get isDefault(){return this._isDefault}set isDefault(w){w!==this._isDefault&&(this._isDefault=w,Oe(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:w}))}get tag(){return this._tag}set tag(w){w?.id!==this._tag?.id&&(this._tag=w,Oe(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:w?v.TestTag.namespace(this.controllerId,w.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(w){w!==this._configureHandler&&(this._configureHandler=w,Oe(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!w}))}dispose(){Oe(this,a,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=y,a=new WeakMap;const g={[S.TestRunProfileKind.Coverage]:8,[S.TestRunProfileKind.Debug]:4,[S.TestRunProfileKind.Run]:2}}),define(me[253],ge([0,1,3,17,5,130,15,7]),function(J,e,m,L,I,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class D{constructor(n,A){this._extHostDocumentsAndEditors=A,this._onDidChangeTextEditorSelection=new m.Emitter,this._onDidChangeTextEditorOptions=new m.Emitter,this._onDidChangeTextEditorVisibleRanges=new m.Emitter,this._onDidChangeTextEditorViewColumn=new m.Emitter,this._onDidChangeActiveTextEditor=new m.Emitter,this._onDidChangeVisibleTextEditors=new m.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=n.getProxy(I.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(u=>this._onDidChangeVisibleTextEditors.fire(u)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(u=>this._onDidChangeActiveTextEditor.fire(u))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(n){const A=this._extHostDocumentsAndEditors.allEditors();return n?A:A.map(u=>u.value)}async showTextDocument(n,A,u){let f;typeof A=="number"?f={position:R.ViewColumn.from(A),preserveFocus:u}:typeof A=="object"?f={position:R.ViewColumn.from(A.viewColumn),preserveFocus:A.preserveFocus,selection:typeof A.selection=="object"?R.Range.from(A.selection):void 0,pinned:typeof A.preview=="boolean"?!A.preview:void 0}:f={preserveFocus:!1};const l=await this._proxy.$tryShowTextDocument(n.uri,f),v=l&&this._extHostDocumentsAndEditors.getEditor(l);if(v)return v.value;throw l?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}createTextEditorDecorationType(n,A){return new k.TextEditorDecorationType(this._proxy,n,A).value}$acceptEditorPropertiesChanged(n,A){const u=this._extHostDocumentsAndEditors.getEditor(n);if(!u)throw new Error("unknown text editor");if(A.options&&u._acceptOptions(A.options),A.selections){const f=A.selections.selections.map(R.Selection.to);u._acceptSelections(f)}if(A.visibleRanges){const f=L.coalesce(A.visibleRanges.map(R.Range.to));u._acceptVisibleRanges(f)}if(A.options&&this._onDidChangeTextEditorOptions.fire({textEditor:u.value,options:{...A.options,lineNumbers:R.TextEditorLineNumbersStyle.to(A.options.lineNumbers)}}),A.selections){const f=C.TextEditorSelectionChangeKind.fromValue(A.selections.source),l=A.selections.selections.map(R.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:u.value,selections:l,kind:f})}if(A.visibleRanges){const f=L.coalesce(A.visibleRanges.map(R.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:u.value,visibleRanges:f})}}$acceptEditorPositionData(n){for(const A in n){const u=this._extHostDocumentsAndEditors.getEditor(A);if(!u)throw new Error("Unknown text editor");const f=R.ViewColumn.to(n[A]);u.value.viewColumn!==f&&(u._acceptViewColumn(f),this._onDidChangeTextEditorViewColumn.fire({textEditor:u.value,viewColumn:f}))}}getDiffInformation(n){return Promise.resolve(this._proxy.$getDiffInformation(n))}}e.ExtHostEditors=D}),define(me[254],ge([0,1,2,4,5,6,7]),function(J,e,m,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,L.createDecorator)("IExtHostTimeline");class C{constructor(n,A){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=n.getProxy(I.MainContext.MainThreadTimeline),A.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===11){const f=u.uri===void 0?void 0:m.URI.revive(u.uri);return this._itemsBySourceAndUriMap.get(u.source)?.get(D(f))?.get(u.handle)}return u}})}async $getTimeline(n,A,u,f,l){return this._providers.get(n)?.provideTimeline(m.URI.revive(A),u,f,l)}registerTimelineProvider(n,A,u,f){const l=new k.DisposableStore,v=this.convertTimelineItem(A.id,f,l).bind(this);let S;A.onDidChange&&(S=A.onDidChange(E=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...E,id:A.id}),this));const P=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...A,scheme:n,onDidChange:void 0,async provideTimeline(E,s,a,p){p?.resetCache&&(l.clear(),P.get(A.id)?.clear());const t=await A.provideTimeline(E,s,a);if(t==null)return;const o=v(E,p);return{...t,source:A.id,items:t.items.map(o)}},dispose(){for(const E of P.values())E.get(A.id)?.clear();S?.dispose(),l.dispose()}})}convertTimelineItem(n,A,u){return(f,l)=>{let v;if(l?.cacheResults){let S=this._itemsBySourceAndUriMap.get(n);S===void 0&&(S=new Map,this._itemsBySourceAndUriMap.set(n,S));const P=D(f);v=S.get(P),v===void 0&&(v=new Map,S.set(P,v))}return S=>{const{iconPath:P,...E}=S,s=`${n}|${S.id??S.timestamp}`;v?.set(s,S);let a,p,t;return S.iconPath&&(P instanceof R.ThemeIcon?t={id:P.id,color:P.color}:m.URI.isUri(P)?(a=P,p=P):{light:a,dark:p}=P),{...E,id:E.id??void 0,handle:s,source:n,command:S.command?A.toInternal(S.command,u):void 0,icon:a,iconDark:p,themeIcon:t,accessibilityInformation:S.accessibilityInformation}}}}registerTimelineProviderCore(n){if(this._providers.get(n.id))throw new Error(`Timeline Provider ${n.id} already exists.`);return this._proxy.$registerTimelineProvider({id:n.id,label:n.label,scheme:n.scheme}),this._providers.set(n.id,n),(0,k.toDisposable)(()=>{for(const u of this._itemsBySourceAndUriMap.values())u.get(n.id)?.clear();this._providers.delete(n.id),this._proxy.$unregisterTimelineProvider(n.id),n.dispose()})}}e.ExtHostTimeline=C;function D(T){return T?.toString()}}),define(me[255],ge([0,1,6,10,2,5]),function(J,e,m,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class R{constructor(D){this._openers=new Map,this._proxy=D.getProxy(k.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,T,n,A){if(this._openers.has(T))throw new Error(`Opener with id '${T}' already registered`);const u=A.schemes.find(f=>!R.supportedSchemes.has(f));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this._openers.set(T,n),this._proxy.$registerUriOpener(T,A.schemes,D,A.label),(0,m.toDisposable)(()=>{this._openers.delete(T),this._proxy.$unregisterUriOpener(T)})}async $canOpenUri(D,T,n){const A=this._openers.get(D);if(!A)throw new Error(`Unknown opener with id: ${D}`);const u=I.URI.revive(T);return A.canOpenExternalUri(u,n)}async $openUri(D,T,n){const A=this._openers.get(D);if(!A)throw new Error(`Unknown opener id: '${D}'`);return A.openExternalUri(I.URI.revive(T.resolvedUri),{sourceUri:I.URI.revive(T.sourceUri)},n)}}e.ExtHostUriOpeners=R,R.supportedSchemes=new Set([L.Schemas.http,L.Schemas.https])}),define(me[256],ge([0,1,5,2,6,16,26]),function(J,e,m,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class C{constructor(T){this.handles=new Set,this.handlers=new Map,this._proxy=T.getProxy(m.MainContext.MainThreadUrls)}registerUriHandler(T,n){if(this.handles.has(R.ExtensionIdentifier.toKey(T)))throw new Error(`Protocol handler already registered for extension ${T}`);const A=C.HandlePool++;return this.handles.add(R.ExtensionIdentifier.toKey(T)),this.handlers.set(A,n),this._proxy.$registerUriHandler(A,T),(0,I.toDisposable)(()=>{this.handles.delete(R.ExtensionIdentifier.toKey(T)),this.handlers.delete(A),this._proxy.$unregisterUriHandler(A)})}$handleExternalUri(T,n){const A=this.handlers.get(T);if(!A)return Promise.resolve(void 0);try{A.handleUri(L.URI.revive(n))}catch(u){(0,k.onUnexpectedError)(u)}return Promise.resolve(void 0)}async createAppUri(T){return L.URI.revive(await this._proxy.$createAppUri(T))}}e.ExtHostUrls=C,C.HandlePool=0});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(J,m):I?I.value=m:e.set(J,m),m},Oe=this&&this.__classPrivateFieldGet||function(J,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(J):L?L.value:e.get(J)};define(me[70],ge([0,1,3,2,179,205,88,5]),function(J,e,m,L,I,k,R,C){"use strict";var D,T,n,A,u,f,l,v,S,P,E,s;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class a{constructor(d,b,y,g,_,w,F){D.set(this,void 0),T.set(this,void 0),n.set(this,void 0),A.set(this,void 0),u.set(this,void 0),f.set(this,void 0),l.set(this,""),v.set(this,void 0),S.set(this,!1),P.set(this,!1),E.set(this,!1),this._onMessageEmitter=new m.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,s.set(this,new m.Emitter),this._onDidDispose=Oe(this,s,"f").event,nt(this,D,d,"f"),nt(this,T,b,"f"),nt(this,v,y,"f"),nt(this,A,g,"f"),nt(this,u,_,"f"),nt(this,f,w,"f"),nt(this,E,p(w),"f"),nt(this,n,F,"f")}dispose(){nt(this,S,!0,"f"),Oe(this,s,"f").fire(),Oe(this,s,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(d){return nt(this,P,!0,"f"),(0,R.asWebviewUri)(d,Oe(this,A,"f").remote)}get cspSource(){return R.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Oe(this,l,"f")}set html(d){this.assertNotDisposed(),Oe(this,l,"f")!==d&&(nt(this,l,d,"f"),!Oe(this,P,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(d)&&(nt(this,P,!0,"f"),Oe(this,n,"f").report("Webview vscode-resource: uris",Oe(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,T,"f").$setHtml(Oe(this,D,"f"),d))}get options(){return this.assertNotDisposed(),Oe(this,v,"f")}set options(d){this.assertNotDisposed(),Oe(this,T,"f").$setOptions(Oe(this,D,"f"),r(Oe(this,f,"f"),Oe(this,u,"f"),d)),nt(this,v,d,"f")}async postMessage(d){if(Oe(this,S,"f"))return!1;const b=(0,k.serializeWebviewMessage)(d,{serializeBuffersForPostMessage:Oe(this,E,"f")});return Oe(this,T,"f").$postMessage(Oe(this,D,"f"),b.message,...b.buffers)}assertNotDisposed(){if(Oe(this,S,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=a,D=new WeakMap,T=new WeakMap,n=new WeakMap,A=new WeakMap,u=new WeakMap,f=new WeakMap,l=new WeakMap,v=new WeakMap,S=new WeakMap,P=new WeakMap,E=new WeakMap,s=new WeakMap;function p(c){try{const d=(0,I.normalizeVersion)((0,I.parseVersion)(c.engines.vscode));return!!d&&d.majorBase>=1&&d.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=p;class t{constructor(d,b,y,g,_){this.initData=b,this.workspace=y,this._logService=g,this._deprecationService=_,this._webviews=new Map,this._webviewProxy=d.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(d,b,...y){const g=this.getWebview(d);if(g){const{message:_}=(0,k.deserializeWebviewMessage)(b,y);g._onMessageEmitter.fire(_)}}$onMissingCsp(d,b){this._logService.warn(`${b} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(d,b,y){const g=new a(d,this._webviewProxy,i(b),this.initData,this.workspace,y,this._deprecationService);return this._webviews.set(d,g),g._onDidDispose(()=>{this._webviews.delete(d)}),g}deleteWebview(d){this._webviews.delete(d)}getWebview(d){return this._webviews.get(d)}}e.ExtHostWebviews=t;function o(c){return{id:c.identifier,location:c.extensionLocation}}e.toExtensionData=o;function r(c,d,b){return{enableCommandUris:b.enableCommandUris,enableScripts:b.enableScripts,enableForms:b.enableForms,portMapping:b.portMapping,localResourceRoots:b.localResourceRoots||h(c,d)}}e.serializeWebviewOptions=r;function i(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(d=>L.URI.from(d))}}e.reviveOptions=i;function h(c,d){return[...(d?.getWorkspaceFolders()||[]).map(b=>b.uri),c.extensionLocation]}}),define(me[257],ge([0,1,21,48,6,10,22,2,15,70,87,5,7]),function(J,e,m,L,I,k,R,C,D,T,n,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class f{constructor(t,o){this.document=t,this._storagePath=o,this._backupCounter=1,this._edits=new n.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,o){await this.getEdit(t).undo(),o||this.disposeBackup()}async redo(t,o){await this.getEdit(t).redo(),o||this.disposeBackup()}disposeEdits(t){for(const o of t)this._edits.delete(o)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=a(this.document.uri)+this._backupCounter++;return(0,R.joinPath)(this._storagePath,t)}updateBackup(t){this._backup?.delete(),this._backup=t}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(t){const o=this._edits.get(t,0);if(!o)throw new Error("No edit found");return o}}class l{constructor(){this._documents=new Map}get(t,o){return this._documents.get(this.key(t,o))}add(t,o,r){const i=this.key(t,o.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${t} resource:${o.uri}`);const h=new f(o,r);return this._documents.set(i,h),h}delete(t,o){const r=this.key(t,o.uri);this._documents.delete(r)}key(t,o){return`${t}@@@${o}`}}var v;(function(p){p[p.Text=0]="Text",p[p.Custom=1]="Custom"})(v||(v={}));class S{constructor(){this._providers=new Map}addTextProvider(t,o,r){return this.add(0,t,o,r)}addCustomProvider(t,o,r){return this.add(1,t,o,r)}get(t){return this._providers.get(t)}add(t,o,r,i){if(this._providers.has(o))throw new Error(`Provider for viewType:${o} already registered`);return this._providers.set(o,{type:t,extension:r,provider:i}),new u.Disposable(()=>this._providers.delete(o))}}class P{constructor(t,o,r,i,h){this._extHostDocuments=o,this._extensionStoragePaths=r,this._extHostWebview=i,this._extHostWebviewPanels=h,this._editorProviders=new S,this._documents=new l,this._proxy=t.getProxy(A.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,o,r,i){const h=new I.DisposableStore;return E(r)?(h.add(this._editorProviders.addTextProvider(o,t,r)),this._proxy.$registerTextEditorProvider((0,T.toExtensionData)(t),o,i.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,T.shouldSerializeBuffersForPostMessage)(t))):(h.add(this._editorProviders.addCustomProvider(o,t,r)),this.supportEditing(r)&&h.add(r.onDidChangeCustomDocument(c=>{const d=this.getCustomDocumentEntry(o,c.document.uri);if(s(c)){const b=d.addEdit(c);this._proxy.$onDidEdit(c.document.uri,o,b,c.label)}else this._proxy.$onContentChange(c.document.uri,o)})),this._proxy.$registerCustomEditorProvider((0,T.toExtensionData)(t),o,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,T.shouldSerializeBuffersForPostMessage)(t))),u.Disposable.from(h,new u.Disposable(()=>{this._proxy.$unregisterEditorProvider(o)}))}async $createCustomDocument(t,o,r,i,h){const c=this._editorProviders.get(o);if(!c)throw new Error(`No provider found for '${o}'`);if(c.type!==1)throw new Error(`Invalid provide type for '${o}'`);const d=C.URI.revive(t),b=await c.provider.openCustomDocument(d,{backupId:r,untitledDocumentData:i?.buffer},h);let y;return this.supportEditing(c.provider)&&this._extensionStoragePaths&&(y=this._extensionStoragePaths.workspaceValue(c.extension)??this._extensionStoragePaths.globalValue(c.extension)),this._documents.add(o,b,y),{editable:this.supportEditing(c.provider)}}async $disposeCustomDocument(t,o){const r=this._editorProviders.get(o);if(!r)throw new Error(`No provider found for '${o}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${o}'`);const i=C.URI.revive(t),{document:h}=this.getCustomDocumentEntry(o,i);this._documents.delete(o,h),h.dispose()}async $resolveWebviewEditor(t,o,r,i,h,c){const d=this._editorProviders.get(r);if(!d)throw new Error(`No provider found for '${r}'`);const b=D.ViewColumn.to(h),y=this._extHostWebview.createNewWebview(o,i.webviewOptions,d.extension),g=this._extHostWebviewPanels.createNewWebviewPanel(o,r,i.title,b,i.panelOptions,y),_=C.URI.revive(t);switch(d.type){case 1:{const{document:w}=this.getCustomDocumentEntry(r,_);return d.provider.resolveCustomEditor(w,g,c)}case 0:{const w=this._extHostDocuments.getDocument(_);return d.provider.resolveCustomTextEditor(w,g,c)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,o,r){this.getCustomDocumentEntry(o,t).disposeEdits(r)}async $onMoveCustomEditor(t,o,r){const i=this._editorProviders.get(r);if(!i)throw new Error(`No provider found for '${r}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const h=this._extHostWebviewPanels.getWebviewPanel(t);if(!h)throw new Error("No webview found");const c=C.URI.revive(o),d=this._extHostDocuments.getDocument(c);await i.provider.moveCustomTextEditor(d,h,m.CancellationToken.None)}async $undo(t,o,r,i){return this.getCustomDocumentEntry(o,t).undo(r,i)}async $redo(t,o,r,i){return this.getCustomDocumentEntry(o,t).redo(r,i)}async $revert(t,o,r){const i=this.getCustomDocumentEntry(o,t);await this.getCustomEditorProvider(o).revertCustomDocument(i.document,r),i.disposeBackup()}async $onSave(t,o,r){const i=this.getCustomDocumentEntry(o,t);await this.getCustomEditorProvider(o).saveCustomDocument(i.document,r),i.disposeBackup()}async $onSaveAs(t,o,r,i){const h=this.getCustomDocumentEntry(o,t);return this.getCustomEditorProvider(o).saveCustomDocumentAs(h.document,C.URI.revive(r),i)}async $backup(t,o,r){const i=this.getCustomDocumentEntry(o,t),c=await this.getCustomEditorProvider(o).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},r);return i.updateBackup(c),c.id}getCustomDocumentEntry(t,o){const r=this._documents.get(t,C.URI.revive(o));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(t){const r=this._editorProviders.get(t)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=P;function E(p){return typeof p.resolveCustomTextEditor=="function"}function s(p){return typeof p.undo=="function"&&typeof p.redo=="function"}function a(p){const t=p.scheme===k.Schemas.file||p.scheme===k.Schemas.untitled?p.fsPath:p.toString();return(0,L.hash)(t)+""}});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(J,m):I?I.value=m:e.set(J,m),m},Oe=this&&this.__classPrivateFieldGet||function(J,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(J):L?L.value:e.get(J)};define(me[258],ge([0,1,3,6,2,32,15,70,5,7]),function(J,e,m,L,I,k,R,C,D,T){"use strict";var n,A,u,f,l,v,S,P,E,s,a,p,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class o extends L.Disposable{constructor(c,d,b,y,g,_,w){super();n.set(this,void 0),A.set(this,void 0),u.set(this,void 0),f.set(this,void 0),l.set(this,void 0),v.set(this,void 0),S.set(this,void 0),P.set(this,void 0),E.set(this,!0),s.set(this,!0),a.set(this,!1),p.set(this,this._register(new m.Emitter)),this.onDidDispose=Oe(this,p,"f").event,t.set(this,this._register(new m.Emitter)),this.onDidChangeViewState=Oe(this,t,"f").event,nt(this,n,c,"f"),nt(this,A,d,"f"),nt(this,u,b,"f"),nt(this,l,_,"f"),nt(this,P,g,"f"),nt(this,v,y,"f"),nt(this,f,w,"f")}dispose(){Oe(this,a,"f")||(nt(this,a,!0,"f"),Oe(this,p,"f").fire(),Oe(this,A,"f").$disposeWebview(Oe(this,n,"f")),Oe(this,f,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Oe(this,f,"f")}get viewType(){return this.assertNotDisposed(),Oe(this,u,"f")}get title(){return this.assertNotDisposed(),Oe(this,v,"f")}set title(c){this.assertNotDisposed(),Oe(this,v,"f")!==c&&(nt(this,v,c,"f"),Oe(this,A,"f").$setTitle(Oe(this,n,"f"),c))}get iconPath(){return this.assertNotDisposed(),Oe(this,S,"f")}set iconPath(c){this.assertNotDisposed(),Oe(this,S,"f")!==c&&(nt(this,S,c,"f"),Oe(this,A,"f").$setIconPath(Oe(this,n,"f"),I.URI.isUri(c)?{light:c,dark:c}:c))}get options(){return Oe(this,l,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Oe(this,P,"f")=="number"&&Oe(this,P,"f")<0))return Oe(this,P,"f")}get active(){return this.assertNotDisposed(),Oe(this,s,"f")}get visible(){return this.assertNotDisposed(),Oe(this,E,"f")}_updateViewState(c){Oe(this,a,"f")||(this.active!==c.active||this.visible!==c.visible||this.viewColumn!==c.viewColumn)&&(nt(this,s,c.active,"f"),nt(this,E,c.visible,"f"),nt(this,P,c.viewColumn,"f"),Oe(this,t,"f").fire({webviewPanel:this}))}reveal(c,d){this.assertNotDisposed(),Oe(this,A,"f").$reveal(Oe(this,n,"f"),{viewColumn:c?R.ViewColumn.from(c):void 0,preserveFocus:!!d})}assertNotDisposed(){if(Oe(this,a,"f"))throw new Error("Webview is disposed")}}n=new WeakMap,A=new WeakMap,u=new WeakMap,f=new WeakMap,l=new WeakMap,v=new WeakMap,S=new WeakMap,P=new WeakMap,E=new WeakMap,s=new WeakMap,a=new WeakMap,p=new WeakMap,t=new WeakMap;class r{constructor(c,d,b){this.webviews=d,this.workspace=b,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=c.getProxy(D.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,k.generateUuid)()}createWebviewPanel(c,d,b,y,g={}){const _=typeof y=="object"?y.viewColumn:y,w={viewColumn:R.ViewColumn.from(_),preserveFocus:typeof y=="object"&&!!y.preserveFocus},F=(0,C.shouldSerializeBuffersForPostMessage)(c),N=r.newHandle();this._proxy.$createWebviewPanel((0,C.toExtensionData)(c),N,d,{title:b,panelOptions:i(g),webviewOptions:(0,C.serializeWebviewOptions)(c,this.workspace,g),serializeBuffersForPostMessage:F},w);const G=this.webviews.createNewWebview(N,g,c);return this.createNewWebviewPanel(N,d,b,_,g,G)}$onDidChangeWebviewPanelViewStates(c){const d=Object.keys(c);d.sort((b,y)=>{const g=c[b],_=c[y];return g.active?1:_.active?-1:+g.visible-+_.visible});for(const b of d){const y=this.getWebviewPanel(b);if(!y)continue;const g=c[b];y._updateViewState({active:g.active,visible:g.visible,viewColumn:R.ViewColumn.to(g.position)})}}async $onDidDisposeWebviewPanel(c){this.getWebviewPanel(c)?.dispose(),this._webviewPanels.delete(c),this.webviews.deleteWebview(c)}registerWebviewPanelSerializer(c,d,b){if(this._serializers.has(d))throw new Error(`Serializer for '${d}' already registered`);return this._serializers.set(d,{serializer:b,extension:c}),this._proxy.$registerSerializer(d,{serializeBuffersForPostMessage:(0,C.shouldSerializeBuffersForPostMessage)(c)}),new T.Disposable(()=>{this._serializers.delete(d),this._proxy.$unregisterSerializer(d)})}async $deserializeWebviewPanel(c,d,b,y){const g=this._serializers.get(d);if(!g)throw new Error(`No serializer found for '${d}'`);const{serializer:_,extension:w}=g,F=this.webviews.createNewWebview(c,b.webviewOptions,w),N=this.createNewWebviewPanel(c,d,b.title,y,b.panelOptions,F);await _.deserializeWebviewPanel(N,b.state)}createNewWebviewPanel(c,d,b,y,g,_){const w=new o(c,this._proxy,d,b,y,g,_);return this._webviewPanels.set(c,w),w}getWebviewPanel(c){return this._webviewPanels.get(c)}}e.ExtHostWebviewPanels=r;function i(h){return{enableFindWidget:h.enableFindWidget,retainContextWhenHidden:h.retainContextWhenHidden}}});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(J,m):I?I.value=m:e.set(J,m),m},Oe=this&&this.__classPrivateFieldGet||function(J,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(J):L?L.value:e.get(J)};define(me[259],ge([0,1,3,6,70,5,7]),function(J,e,m,L,I,k,R){"use strict";var C,D,T,n,A,u,f,l,v,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class P extends L.Disposable{constructor(a,p,t,o,r,i){super();C.set(this,void 0),D.set(this,void 0),T.set(this,void 0),n.set(this,void 0),A.set(this,!1),u.set(this,void 0),f.set(this,void 0),l.set(this,void 0),v.set(this,this._register(new m.Emitter)),this.onDidChangeVisibility=Oe(this,v,"f").event,S.set(this,this._register(new m.Emitter)),this.onDidDispose=Oe(this,S,"f").event,nt(this,T,t,"f"),nt(this,f,o,"f"),nt(this,C,a,"f"),nt(this,D,p,"f"),nt(this,n,r,"f"),nt(this,u,i,"f")}dispose(){Oe(this,A,"f")||(nt(this,A,!0,"f"),Oe(this,S,"f").fire(),Oe(this,n,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Oe(this,f,"f")}set title(a){this.assertNotDisposed(),Oe(this,f,"f")!==a&&(nt(this,f,a,"f"),Oe(this,D,"f").$setWebviewViewTitle(Oe(this,C,"f"),a))}get description(){return this.assertNotDisposed(),Oe(this,l,"f")}set description(a){this.assertNotDisposed(),Oe(this,l,"f")!==a&&(nt(this,l,a,"f"),Oe(this,D,"f").$setWebviewViewDescription(Oe(this,C,"f"),a))}get visible(){return Oe(this,u,"f")}get webview(){return Oe(this,n,"f")}get viewType(){return Oe(this,T,"f")}_setVisible(a){a===Oe(this,u,"f")||Oe(this,A,"f")||(nt(this,u,a,"f"),Oe(this,v,"f").fire())}show(a){this.assertNotDisposed(),Oe(this,D,"f").$show(Oe(this,C,"f"),!!a)}assertNotDisposed(){if(Oe(this,A,"f"))throw new Error("Webview is disposed")}}C=new WeakMap,D=new WeakMap,T=new WeakMap,n=new WeakMap,A=new WeakMap,u=new WeakMap,f=new WeakMap,l=new WeakMap,v=new WeakMap,S=new WeakMap;class E{constructor(a,p){this._extHostWebview=p,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=a.getProxy(k.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(a,p,t,o){if(this._viewProviders.has(p))throw new Error(`View provider for '${p}' already registered`);return this._viewProviders.set(p,{provider:t,extension:a}),this._proxy.$registerWebviewViewProvider((0,I.toExtensionData)(a),p,{retainContextWhenHidden:o?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new R.Disposable(()=>{this._viewProviders.delete(p),this._proxy.$unregisterWebviewViewProvider(p)})}async $resolveWebviewView(a,p,t,o,r){const i=this._viewProviders.get(p);if(!i)throw new Error(`No view provider found for '${p}'`);const{provider:h,extension:c}=i,d=this._extHostWebview.createNewWebview(a,{},c),b=new P(a,this._proxy,p,t,d,!0);this._webviewViews.set(a,b),await h.resolveWebviewView(b,{state:o},r)}async $onDidChangeWebviewViewVisibility(a,p){this.getWebviewView(a)._setVisible(p)}async $disposeWebviewView(a){const p=this.getWebviewView(a);this._webviewViews.delete(a),p.dispose(),this._extHostWebview.deleteWebview(a)}getWebviewView(a){const p=this._webviewViews.get(a);if(!p)throw new Error("No webview found");return p}}e.ExtHostWebviewViews=E}),define(me[132],ge([0,1,3,5,2,10,9,4,14]),function(J,e,m,L,I,k,R,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let T=class $n{constructor(A){this._onDidChangeWindowState=new m.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=$n.InitialState,this._proxy=A.getProxy(L.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(u=>this.$onDidChangeWindowFocus(u))}get state(){return this._state}$onDidChangeWindowFocus(A){A!==this._state.focused&&(this._state={...this._state,focused:A},this._onDidChangeWindowState.fire(this._state))}openUri(A,u){let f;if(typeof A=="string"){f=A;try{A=I.URI.parse(A)}catch(l){return Promise.reject(`Invalid uri - '${A}'`)}}return(0,R.isFalsyOrWhitespace)(A.scheme)?Promise.reject("Invalid scheme - cannot be empty"):A.scheme===k.Schemas.command?Promise.reject(`Invalid scheme '${A.scheme}'`):this._proxy.$openUri(A,f,u)}async asExternalUri(A,u){if((0,R.isFalsyOrWhitespace)(A.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this._proxy.$asExternalUri(A,u);return I.URI.from(f)}};T.InitialState={focused:!0},T=Ve([We(0,D.IExtHostRpcService)],T),e.ExtHostWindow=T,e.IExtHostWindow=(0,C.createDecorator)("IExtHostWindow")}),define(me[260],ge([0,1,8,80,32,44,6,5,2,14]),function(J,e,m,L,I,k,R,C,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let n=class extends R.Disposable{constructor(u,f){super();const l=u.getProxy(C.MainContext.MainThreadDownloadService);f.registerCommand(!1,"_workbench.downloadResource",async v=>{const S=D.URI.file((0,m.join)((0,L.tmpdir)(),(0,I.generateUuid)()));return await l.$download(v,S),S})}};n=Ve([We(0,T.IExtHostRpcService),We(1,k.IExtHostCommands)],n),e.ExtHostDownloadService=n}),define(me[261],ge([0,1,2,8,151,28,68,27,14,6,12,116,42]),function(J,e,m,L,I,k,R,C,D,T,n,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=void 0;class f{constructor(P,E,s){this.name=P,this.file=E,this.appender=s}static async create(P,E){const s=await(0,A.createRotatingLogger)(P,E,30*u.ByteSize.MB,1);return s.clearFormatters(),new f(P,E,s)}append(P){this.appender.critical(P)}flush(){this.appender.flush()}}class l extends R.AbstractExtHostOutputChannel{constructor(P,E,s,a){super(P,!1,m.URI.file(E.file),s,a);this._appender=E}append(P){super.append(P),this._appender.append(P),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(P,E){this._appender.flush(),super.show(P,E)}clear(){this._appender.flush(),super.clear()}}let v=class extends R.ExtHostOutputService{constructor(P,E,s){super(P);this.logService=E,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new T.MutableDisposable,this._logsLocation=s.logsLocation}$setVisibleChannel(P){if(P){const E=this._channels.get(P);E&&(this._visibleChannelDisposable.value=E.onDidAppend(()=>E.update()))}}createOutputChannel(P,E){if(P=P.trim(),!P)throw new Error("illegal argument `name`. must not be falsy");const s=this._doCreateOutChannel(P,E);return s.then(a=>a._id.then(p=>this._channels.set(p,a))),new R.LazyOutputChannel(P,s)}async _doCreateOutChannel(P,E){try{const s=(0,L.join)(this._logsLocation.fsPath,`output_logging_${(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await k.SymlinkSupport.existsDirectory(s)||await k.Promises.mkdir(s,{recursive:!0});const p=`${this._namePool++}-${P.replace(/[\\/:\*\?"<>\|]/g,"")}`,t=m.URI.file((0,L.join)(s,`${p}.log`)),o=await f.create(p,t.fsPath);return new l(P,o,E.identifier.value,this._proxy)}catch(s){return this.logService.error(s),new R.ExtHostPushOutputChannel(P,E.identifier.value,this._proxy)}}};v=Ve([We(0,D.IExtHostRpcService),We(1,n.ILogService),We(2,C.IExtHostInitDataService)],v),e.ExtHostOutputService2=v}),define(me[262],ge([0,1,50,293,2,69,6,10,18]),function(J,e,m,L,I,k,R,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class T extends k.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(p){const t=await super._getWorkspaceStorageURI(p);if(t.scheme!==C.Schemas.file)return t;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${t.fsPath}.`),t;const o=t.fsPath;let r=0;do{let i;r===0?i=o:i=/[/\\]$/.test(o)?`${o.substr(0,o.length-1)}-${r}`:`${o}-${r}`,await n(i);const h=L.join(i,"vscode.lock"),c=await l(this._logService,h,!1);if(c)return this._workspaceStorageLock=c,process.on("exit",()=>{c.dispose()}),I.URI.file(i);r++}while(r<10);return t}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=T;async function n(a){try{await m.promises.stat(a);return}catch{}try{await m.promises.mkdir(a,{recursive:!0})}catch{}}const A=1e3,u=10*60*1e3;class f extends R.Disposable{constructor(p,t){super();this.logService=p,this.filename=t,this._timer=this._register(new D.IntervalTimer),this._timer.cancelAndSet(async()=>{const o=await v(p,t);(!o||o.pid!==process.pid)&&(p.info(`Lock '${t}': The lock was lost unexpectedly.`),this._timer.cancel());try{await m.promises.utimes(t,new Date,new Date)}catch(r){p.error(r),p.info(`Lock '${t}': Could not update mtime.`)}},A)}dispose(){super.dispose();try{m.unlinkSync(this.filename)}catch(p){}}async setWillRelease(p){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${p} ms.`);try{const t={pid:process.pid,willReleaseAt:Date.now()+p};await m.promises.writeFile(this.filename,JSON.stringify(t),{flag:"w"})}catch(t){this.logService.error(t)}}}async function l(a,p,t){try{const r={pid:process.pid,willReleaseAt:0};await m.promises.writeFile(p,JSON.stringify(r),{flag:"wx"})}catch(r){a.error(r)}const o=await v(a,p);return!o||o.pid!==process.pid?t?(a.info(`Lock '${p}': Could not acquire lock, giving up.`),null):(a.info(`Lock '${p}': Could not acquire lock, checking if the file is stale.`),E(a,p)):(a.info(`Lock '${p}': Lock acquired.`),new f(a,p))}async function v(a,p){let t;try{t=await m.promises.readFile(p)}catch(o){return a.error(o),null}try{return JSON.parse(String(t))}catch(o){return a.error(o),null}}async function S(a,p){let t;try{t=await m.promises.stat(p)}catch(o){return a.error(o),0}return t.mtime.getTime()}function P(a){try{return process.kill(a,0),!0}catch(p){return!1}}async function E(a,p){const t=await v(a,p);if(!t)return a.info(`Lock '${p}': Could not read pid of lock holder.`),s(a,p);if(t.willReleaseAt){let c=t.willReleaseAt-Date.now();if(c<5e3){for(c>0?a.info(`Lock '${p}': The lockfile is scheduled to be released in ${c} ms.`):a.info(`Lock '${p}': The lockfile is scheduled to have been released.`);c>0;){if(await(0,D.timeout)(Math.min(100,c)),await S(a,p)===0)return s(a,p);c=t.willReleaseAt-Date.now()}return s(a,p)}}if(!P(t.pid))return a.info(`Lock '${p}': The pid ${t.pid} appears to be gone.`),s(a,p);const o=await S(a,p),r=Date.now()-o;if(r<=u)return a.info(`Lock '${p}': The lock does not look stale, elapsed: ${r} ms, giving up.`),null;a.info(`Lock '${p}': The lock looks stale, waiting for 2s.`),await(0,D.timeout)(2e3);const i=await S(a,p),h=Date.now()-i;return h<=u?(a.info(`Lock '${p}': The lock does not look stale, elapsed: ${h} ms, giving up.`),null):(a.info(`Lock '${p}': The lock looks stale even after waiting for 2s.`),s(a,p))}async function s(a,p){a.info(`Lock '${p}': Deleting a stale lock.`);try{await m.promises.unlink(p)}catch(t){}return l(a,p,!0)}}),define(me[263],ge([0,1,32,14,33]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let k=class extends I.BaseExtHostTerminalService{constructor(C){super(!0,C)}createTerminal(C,D,T){return this.createTerminalFromOptions({name:C,shellPath:D,shellArgs:T})}createTerminalFromOptions(C,D){const T=new I.ExtHostTerminal(this._proxy,(0,m.generateUuid)(),C,C.name);return this._terminals.push(T),T.create(C,this._serializeParentTerminal(C,D)),T.value}_serializeParentTerminal(C,D){if(D=D||{},C.location&&typeof C.location=="object"&&"parentTerminal"in C.location){const T=C.location.parentTerminal;if(T){const n=this._terminals.find(A=>A.value===T);n&&(D.resolvedExtHostIdentifier=n._id)}}else C.location&&typeof C.location!="object"?D.location=C.location:D.location&&typeof D.location=="object"&&"splitActiveTerminal"in D.location&&(D.location={splitActiveTerminal:!0});return D}};k=Ve([We(0,L.IExtHostRpcService)],k),e.ExtHostTerminalService=k}),define(me[264],ge([0,1,5,14,6,27,2,39,22,28,7,11,53,3,193,77,12]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,l,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class P{constructor(d,b,y){this.remoteAddress=d,this.localAddress=b,this._dispose=y,this._onDispose=new f.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function E(c){const d=c.trim().split(`
`),b=[];return d.forEach(g=>{const _=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(g);_&&_.length>=3&&b.push({pid:parseInt(_[1],10),socket:parseInt(_[2],10)})}),b.reduce((g,_)=>(g[_.socket]=_,g),{})}e.getSockets=E;function s(...c){const d=[].concat(...c.map(p));return[...new Map(d.filter(b=>b.st==="0A").map(b=>{const y=b.local_address.split(":");return{socket:parseInt(b.inode,10),ip:a(y[0]),port:parseInt(y[1],16)}}).map(b=>[b.ip+":"+b.port,b])).values()]}e.loadListeningPorts=s;function a(c){let d="";if(c.length===8)for(let b=c.length-2;b>=0;b-=2)d+=parseInt(c.substr(b,2),16),b!==0&&(d+=".");else for(let b=c.length-4;b>=0;b-=4)d+=parseInt(c.substr(b,4),16).toString(16),b!==0&&(d+=":");return d}e.parseIpAddress=a;function p(c){const d=c.trim().split(`
`),b=d.shift().trim().split(/\s+/).filter(g=>g!=="rx_queue"&&g!=="tm->when");return d.map(g=>g.trim().split(/\s+/).reduce((_,w,F)=>(_[b[F]||F]=w,_),{}))}e.loadConnectionTable=p;function t(c){return!!c.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||c.indexOf("out/vs/server/main.js")!==-1||c.indexOf("_productName=VSCode")!==-1}function o(c){const d=c.trim().split(`
`),b=[];return d.forEach(y=>{const g=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(y);g&&g.length>=4&&b.push({pid:parseInt(g[1],10),ppid:parseInt(g[2]),cmd:g[3]})}),b}e.getRootProcesses=o;async function r(c,d,b){const y=b.reduce((_,w)=>(_[w.pid]=w,_),{}),g=[];return c.forEach(({socket:_,ip:w,port:F})=>{const N=d[_]?d[_].pid:void 0,G=N?y[N]?.cmd:void 0;N&&G&&!t(G)&&g.push({host:w,port:F,detail:G,pid:N})}),g}e.findPorts=r;function i(c,d,b){const y=new Map,g=o(d);for(const _ of c){const w=b.get(_.port);if(w){y.set(_.port,w);continue}const F=g.find(N=>N.cmd.includes(`${_.port}`));if(F){let N=F,G;do G=g.find(K=>K.ppid===N.pid),G&&(N=G);while(G);y.set(_.port,{host:_.ip,port:_.port,pid:N.pid,detail:N.cmd,ppid:N.ppid})}else y.set(_.port,{host:_.ip,port:_.port,ppid:Number.MAX_VALUE})}return y}e.tryFindRootPorts=i;let h=class extends I.Disposable{constructor(d,b,y){super();this.logService=y,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new f.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=d.getProxy(m.MainContext.MainThreadTunnelService),A.isLinux&&b.remote.isRemote&&b.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(d,b){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${d.identifier.value} called openTunnel API for ${b.remoteAddress.host}:${b.remoteAddress.port}.`);const y=await this._proxy.$openTunnel(b,d.displayName);if(y){const g=new P(y.remoteAddress,y.localAddress,()=>this._proxy.$closeTunnel(y.remoteAddress));return this._register(g),g}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(d){return Math.max(d*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(d,b){const y=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(y,{selector:d,provider:b}),this._proxy.$registerPortsAttributesProvider(d,y),new n.Disposable(()=>{this._portAttributesProviders.delete(y),this._proxy.$unregisterPortsAttributesProvider(y)})}async $providePortAttributes(d,b,y,g,_){const w=[];for(const N of d){const G=this._portAttributesProviders.get(N);if(!G)return[];w.push(...await Promise.all(b.map(async K=>G.provider.providePortAttributes(K,y,g,_))))}const F=w.filter(N=>!!N);return F.length>0?F.map(N=>({autoForwardAction:N.autoForwardAction,port:N.port})):[]}async $registerCandidateFinder(d){if(d&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=d;let b=new v.MovingAverage,y;for(;this._candidateFindingEnabled;){const g=new Date().getTime(),_=(await this.findCandidatePorts()).filter(F=>(0,l.isLocalhost)(F.host)||(0,l.isAllInterfaces)(F.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${_.map(F=>F.port).join(", ")}`);const w=new Date().getTime()-g;b.update(w),(!y||JSON.stringify(y)!==JSON.stringify(_))&&(y=_,await this._proxy.$onFoundNewCandidates(y)),await new Promise(F=>setTimeout(()=>F(),this.calculateDelay(b.value)))}}async setTunnelExtensionFunctions(d){return d?(d.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(d.candidatePortSource),d.showCandidatePort&&(this._showCandidatePort=d.showCandidatePort,this._proxy.$setCandidateFilter()),d.tunnelFactory&&(this._forwardPortProvider=d.tunnelFactory,this._proxy.$setTunnelProvider(d.tunnelFeatures??{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,(0,I.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(d,b){if(this._extensionTunnels.has(d.host)){const y=this._extensionTunnels.get(d.host);y.has(d.port)&&(b&&y.get(d.port).disposeListener.dispose(),await y.get(d.port).tunnel.dispose(),y.delete(d.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(d,b){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const y=this._forwardPortProvider(d,b);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),y!==void 0){const g=await y;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(d.remoteAddress.host)||this._extensionTunnels.set(d.remoteAddress.host,new Map);const _=this._register(g.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(g.remoteAddress))));return this._extensionTunnels.get(d.remoteAddress.host).set(d.remoteAddress.port,{tunnel:g,disposeListener:_}),u.TunnelDto.fromApiTunnel(g)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(y){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(d){const b=await Promise.all(d.map(g=>this._showCandidatePort(g.host,g.port,g.detail??""))),y=d.filter((g,_)=>b[_]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${d.map(g=>g.port).join(", ")} to ${y.map(g=>g.port).join(", ")}`),y}async findCandidatePorts(){let d="",b="";try{d=await T.Promises.readFile("/proc/net/tcp","utf8"),b=await T.Promises.readFile("/proc/net/tcp6","utf8")}catch(z){}const y=s(d,b),g=await new Promise(z=>{(0,C.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(O,B,x)=>{z(B)})}),_=E(g),w=await T.Promises.readdir("/proc"),F=[];for(let z of w)try{const O=Number(z),B=D.joinPath(R.URI.file("/proc"),z);if((await T.Promises.stat(B.fsPath)).isDirectory()&&!isNaN(O)){const M=await T.Promises.readlink(D.joinPath(B,"cwd").fsPath),H=await T.Promises.readFile(D.joinPath(B,"cmdline").fsPath,"utf8");F.push({pid:O,cwd:M,cmd:H})}}catch(O){}const N=[],G=y.filter(z=>{const O=_[z.socket];return O||N.push(z),O}),K=r(G,_,F);let U;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${N.length}`),N.length>0){const z=await new Promise(O=>{(0,C.exec)("ps -F -A -l | grep root",(B,x,M)=>{O(x)})});this._foundRootPorts=i(N,z,this._foundRootPorts),U=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${U.join(", ")}`)}return K.then(z=>U?z.concat(U):z)}};h=Ve([We(0,L.IExtHostRpcService),We(1,k.IExtHostInitDataService),We(2,S.ILogService)],h),e.ExtHostTunnelService=h}),define(me[265],ge([0,1,18,23,21,16,3,6,103,229,66]),function(J,e,m,L,I,k,R,C,D,T,n){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function u(g,_){try{return JSON.stringify(g,_)}catch(w){return"null"}}const f="$$ref$$",l={[f]:-1};class v{constructor(_,w){this.jsonString=_,this.referencedBuffers=w}}function S(g,_=null,w=!1){const F=[];return{jsonString:(w?u:JSON.stringify)(g,(G,K)=>{if(typeof K=="undefined")return l;if(typeof K=="object"){if(K instanceof L.VSBuffer){const U=F.push(K)-1;return{[f]:U}}if(_)return _(G,K)}return K}),referencedBuffers:F}}e.stringifyJsonWithBufferRefs=S;function P(g,_,w){return JSON.parse(g,(F,N)=>{if(N){const G=N[f];if(typeof G=="number")return _[G];if(w&&N.$mid===1)return w.transformIncoming(N)}return N})}e.parseJsonAndRestoreBufferRefs=P;function E(g,_){return JSON.stringify(g,_)}function s(g){return g?(_,w)=>w&&w.$mid===1?g.transformOutgoing(w):w:null}var a;(function(g){g[g.LocalSide=0]="LocalSide",g[g.OtherSide=1]="OtherSide"})(a=e.RequestInitiator||(e.RequestInitiator={}));var p;(function(g){g[g.Responsive=0]="Responsive",g[g.Unresponsive=1]="Unresponsive"})(p=e.ResponsiveState||(e.ResponsiveState={}));const t=()=>{},o=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class i extends C.Disposable{constructor(_,w=null,F=null){super();this[A]=!0,this._onDidChangeResponsiveState=this._register(new R.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=_,this._logger=w,this._uriTransformer=F,this._uriReplacer=s(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let N=0,G=n.ProxyIdentifier.count;N<G;N++)this._locals[N]=null,this._proxies[N]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new m.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(N=>this._receiveOneMessage(N))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(_=>{this._pendingRPCReplies[_].resolveErr(k.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(_){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(_){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(_){this._responsiveState!==_&&(this._responsiveState=_,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(_){return this._uriTransformer?(0,D.transformIncomingURIs)(_,this._uriTransformer):_}getProxy(_){const{nid:w,sid:F}=_;return this._proxies[w]||(this._proxies[w]=this._createProxy(w,F)),this._proxies[w]}_createProxy(_,w){let F={get:(N,G)=>(typeof G=="string"&&!N[G]&&G.charCodeAt(0)===36&&(N[G]=(...K)=>this._remoteCall(_,G,K)),G===r?w:N[G])};return new Proxy(Object.create(null),F)}set(_,w){return this._locals[_.nid]=w,w}assertRegistered(_){for(let w=0,F=_.length;w<F;w++){const N=_[w];if(!this._locals[N.nid])throw new Error(`Missing actor ${N.sid} (isMain: ${N.isMain})`)}}_receiveOneMessage(_){if(this._isDisposed)return;const w=_.byteLength,F=h.read(_,0),N=F.readUInt8(),G=F.readUInt32();switch(N){case 1:case 2:{let{rpcId:K,method:U,args:z}=d.deserializeRequestJSONArgs(F);this._uriTransformer&&(z=(0,D.transformIncomingURIs)(z,this._uriTransformer)),this._receiveRequest(w,G,K,U,z,N===2);break}case 3:case 4:{let{rpcId:K,method:U,args:z}=d.deserializeRequestMixedArgs(F);this._uriTransformer&&(z=(0,D.transformIncomingURIs)(z,this._uriTransformer)),this._receiveRequest(w,G,K,U,z,N===4);break}case 5:{this._logger&&this._logger.logIncoming(w,G,0,"ack"),this._onDidReceiveAcknowledge(G);break}case 6:{this._receiveCancel(w,G);break}case 7:{this._receiveReply(w,G,void 0);break}case 9:{let K=d.deserializeReplyOKJSON(F);this._uriTransformer&&(K=(0,D.transformIncomingURIs)(K,this._uriTransformer)),this._receiveReply(w,G,K);break}case 10:{const K=d.deserializeReplyOKJSONWithBuffers(F,this._uriTransformer);this._receiveReply(w,G,K);break}case 8:{let K=d.deserializeReplyOKVSBuffer(F);this._receiveReply(w,G,K);break}case 11:{let K=d.deserializeReplyErrError(F);this._uriTransformer&&(K=(0,D.transformIncomingURIs)(K,this._uriTransformer)),this._receiveReplyErr(w,G,K);break}case 12:{this._receiveReplyErr(w,G,void 0);break}default:console.error("received unexpected message"),console.error(_)}}_receiveRequest(_,w,F,N,G,K){this._logger&&this._logger.logIncoming(_,w,1,`receiveRequest ${(0,n.getStringIdentifierForProxy)(F)}.${N}(`,G);const U=String(w);let z,O;if(K){const x=new I.CancellationTokenSource;G.push(x.token),z=this._invokeHandler(F,N,G),O=()=>x.cancel()}else z=this._invokeHandler(F,N,G),O=t;this._cancelInvokedHandlers[U]=O;const B=d.serializeAcknowledged(w);this._logger&&this._logger.logOutgoing(B.byteLength,w,1,"ack"),this._protocol.send(B),z.then(x=>{delete this._cancelInvokedHandlers[U];const M=d.serializeReplyOK(w,x,this._uriReplacer);this._logger&&this._logger.logOutgoing(M.byteLength,w,1,"reply:",x),this._protocol.send(M)},x=>{delete this._cancelInvokedHandlers[U];const M=d.serializeReplyErr(w,x);this._logger&&this._logger.logOutgoing(M.byteLength,w,1,"replyErr:",x),this._protocol.send(M)})}_receiveCancel(_,w){this._logger&&this._logger.logIncoming(_,w,1,"receiveCancel");const F=String(w);this._cancelInvokedHandlers[F]&&this._cancelInvokedHandlers[F]()}_receiveReply(_,w,F){this._logger&&this._logger.logIncoming(_,w,0,"receiveReply:",F);const N=String(w);if(!this._pendingRPCReplies.hasOwnProperty(N))return;const G=this._pendingRPCReplies[N];delete this._pendingRPCReplies[N],G.resolveOk(F)}_receiveReplyErr(_,w,F){this._logger&&this._logger.logIncoming(_,w,0,"receiveReplyErr:",F);const N=String(w);if(!this._pendingRPCReplies.hasOwnProperty(N))return;const G=this._pendingRPCReplies[N];delete this._pendingRPCReplies[N];let K;F&&(F.$isError?(K=new Error,K.name=F.name,K.message=F.message,K.stack=F.stack):K=F),G.resolveErr(K)}_invokeHandler(_,w,F){try{return Promise.resolve(this._doInvokeHandler(_,w,F))}catch(N){return Promise.reject(N)}}_doInvokeHandler(_,w,F){const N=this._locals[_];if(!N)throw new Error("Unknown actor "+(0,n.getStringIdentifierForProxy)(_));let G=N[w];if(typeof G!="function")throw new Error("Unknown method "+w+" on actor "+(0,n.getStringIdentifierForProxy)(_));return G.apply(N,F)}_remoteCall(_,w,F){if(this._isDisposed)return Promise.reject(k.canceled());let N=null;if(F.length>0&&I.CancellationToken.isCancellationToken(F[F.length-1])&&(N=F.pop()),N&&N.isCancellationRequested)return Promise.reject(k.canceled());const G=d.serializeRequestArguments(F,this._uriReplacer),K=++this._lastMessageId,U=String(K),z=new T.LazyPromise;N&&N.onCancellationRequested(()=>{const B=d.serializeCancel(K);this._logger&&this._logger.logOutgoing(B.byteLength,K,0,"cancel"),this._protocol.send(d.serializeCancel(K))}),this._pendingRPCReplies[U]=z,this._onWillSendRequest(K);const O=d.serializeRequest(K,_,w,G,!!N);return this._logger&&this._logger.logOutgoing(O.byteLength,K,0,`request: ${(0,n.getStringIdentifierForProxy)(_)}.${w}(`,F),this._protocol.send(O),z}}e.RPCProtocol=i,A=o,i.UNRESPONSIVE_TIME=3*1e3;class h{constructor(_,w){this._buff=_,this._offset=w}static alloc(_,w,F){let N=new h(L.VSBuffer.alloc(F+1+4),0);return N.writeUInt8(_),N.writeUInt32(w),N}static read(_,w){return new h(_,w)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(_){this._buff.writeUInt8(_,this._offset),this._offset+=1}readUInt8(){const _=this._buff.readUInt8(this._offset);return this._offset+=1,_}writeUInt32(_){this._buff.writeUInt32BE(_,this._offset),this._offset+=4}readUInt32(){const _=this._buff.readUInt32BE(this._offset);return this._offset+=4,_}static sizeShortString(_){return 1+_.byteLength}writeShortString(_){this._buff.writeUInt8(_.byteLength,this._offset),this._offset+=1,this._buff.set(_,this._offset),this._offset+=_.byteLength}readShortString(){const _=this._buff.readUInt8(this._offset);this._offset+=1;const F=this._buff.slice(this._offset,this._offset+_).toString();return this._offset+=_,F}static sizeLongString(_){return 4+_.byteLength}writeLongString(_){this._buff.writeUInt32BE(_.byteLength,this._offset),this._offset+=4,this._buff.set(_,this._offset),this._offset+=_.byteLength}readLongString(){const _=this._buff.readUInt32BE(this._offset);this._offset+=4;const F=this._buff.slice(this._offset,this._offset+_).toString();return this._offset+=_,F}writeBuffer(_){this._buff.writeUInt32BE(_.byteLength,this._offset),this._offset+=4,this._buff.set(_,this._offset),this._offset+=_.byteLength}static sizeVSBuffer(_){return 4+_.byteLength}writeVSBuffer(_){this._buff.writeUInt32BE(_.byteLength,this._offset),this._offset+=4,this._buff.set(_,this._offset),this._offset+=_.byteLength}readVSBuffer(){const _=this._buff.readUInt32BE(this._offset);this._offset+=4;const w=this._buff.slice(this._offset,this._offset+_);return this._offset+=_,w}static sizeMixedArray(_){let w=0;w+=1;for(let F=0,N=_.length;F<N;F++){const G=_[F];switch(w+=1,G.type){case 1:w+=this.sizeLongString(G.value);break;case 2:w+=this.sizeVSBuffer(G.value);break;case 3:w+=this.sizeUInt8(),w+=this.sizeLongString(G.value);for(let K=0;K<G.buffers.length;++K)w+=this.sizeVSBuffer(G.buffers[K]);break;case 4:break}}return w}writeMixedArray(_){this._buff.writeUInt8(_.length,this._offset),this._offset+=1;for(let w=0,F=_.length;w<F;w++){const N=_[w];switch(N.type){case 1:this.writeUInt8(1),this.writeLongString(N.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(N.value);break;case 3:this.writeUInt8(3),this.writeUInt8(N.buffers.length),this.writeLongString(N.value);for(let G=0;G<N.buffers.length;++G)this.writeBuffer(N.buffers[G]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const _=this._buff.readUInt8(this._offset);this._offset+=1;let w=new Array(_);for(let F=0;F<_;F++)switch(this.readUInt8()){case 1:w[F]=this.readLongString();break;case 2:w[F]=this.readVSBuffer();break;case 3:const G=this.readUInt8(),K=this.readLongString(),U=[];for(let z=0;z<G;++z)U.push(this.readVSBuffer());w[F]=new n.SerializableObjectWithBuffers(P(K,U,null));break;case 4:w[F]=void 0;break}return w}}var c;(function(g){g[g.Simple=0]="Simple",g[g.Mixed=1]="Mixed"})(c||(c={}));class d{static _useMixedArgSerialization(_){for(let w=0,F=_.length;w<F;w++)if(_[w]instanceof L.VSBuffer||_[w]instanceof n.SerializableObjectWithBuffers||typeof _[w]=="undefined")return!0;return!1}static serializeRequestArguments(_,w){if(this._useMixedArgSerialization(_)){const F=[];for(let N=0,G=_.length;N<G;N++){const K=_[N];if(K instanceof L.VSBuffer)F[N]={type:2,value:K};else if(typeof K=="undefined")F[N]={type:4};else if(K instanceof n.SerializableObjectWithBuffers){const{jsonString:U,referencedBuffers:z}=S(K.value,w);F[N]={type:3,value:L.VSBuffer.fromString(U),buffers:z}}else F[N]={type:1,value:L.VSBuffer.fromString(E(K,w))}}return{type:1,args:F}}return{type:0,args:E(_,w)}}static serializeRequest(_,w,F,N,G){switch(N.type){case 0:return this._requestJSONArgs(_,w,F,N.args,G);case 1:return this._requestMixedArgs(_,w,F,N.args,G)}}static _requestJSONArgs(_,w,F,N,G){const K=L.VSBuffer.fromString(F),U=L.VSBuffer.fromString(N);let z=0;z+=h.sizeUInt8(),z+=h.sizeShortString(K),z+=h.sizeLongString(U);let O=h.alloc(G?2:1,_,z);return O.writeUInt8(w),O.writeShortString(K),O.writeLongString(U),O.buffer}static deserializeRequestJSONArgs(_){const w=_.readUInt8(),F=_.readShortString(),N=_.readLongString();return{rpcId:w,method:F,args:JSON.parse(N)}}static _requestMixedArgs(_,w,F,N,G){const K=L.VSBuffer.fromString(F);let U=0;U+=h.sizeUInt8(),U+=h.sizeShortString(K),U+=h.sizeMixedArray(N);let z=h.alloc(G?4:3,_,U);return z.writeUInt8(w),z.writeShortString(K),z.writeMixedArray(N),z.buffer}static deserializeRequestMixedArgs(_){const w=_.readUInt8(),F=_.readShortString(),N=_.readMixedArray(),G=new Array(N.length);for(let K=0,U=N.length;K<U;K++){const z=N[K];typeof z=="string"?G[K]=JSON.parse(z):G[K]=z}return{rpcId:w,method:F,args:G}}static serializeAcknowledged(_){return h.alloc(5,_,0).buffer}static serializeCancel(_){return h.alloc(6,_,0).buffer}static serializeReplyOK(_,w,F){if(typeof w=="undefined")return this._serializeReplyOKEmpty(_);if(w instanceof L.VSBuffer)return this._serializeReplyOKVSBuffer(_,w);if(w instanceof n.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:G}=S(w.value,F,!0);return this._serializeReplyOKJSONWithBuffers(_,N,G)}else return this._serializeReplyOKJSON(_,u(w,F))}static _serializeReplyOKEmpty(_){return h.alloc(7,_,0).buffer}static _serializeReplyOKVSBuffer(_,w){let F=0;F+=h.sizeVSBuffer(w);let N=h.alloc(8,_,F);return N.writeVSBuffer(w),N.buffer}static deserializeReplyOKVSBuffer(_){return _.readVSBuffer()}static _serializeReplyOKJSON(_,w){const F=L.VSBuffer.fromString(w);let N=0;N+=h.sizeLongString(F);let G=h.alloc(9,_,N);return G.writeLongString(F),G.buffer}static _serializeReplyOKJSONWithBuffers(_,w,F){const N=L.VSBuffer.fromString(w);let G=0;G+=h.sizeUInt8(),G+=h.sizeLongString(N);for(const U of F)G+=h.sizeVSBuffer(U);let K=h.alloc(10,_,G);K.writeUInt8(F.length),K.writeLongString(N);for(const U of F)K.writeBuffer(U);return K.buffer}static deserializeReplyOKJSON(_){const w=_.readLongString();return JSON.parse(w)}static deserializeReplyOKJSONWithBuffers(_,w){const F=_.readUInt8(),N=_.readLongString(),G=[];for(let K=0;K<F;++K)G.push(_.readVSBuffer());return new n.SerializableObjectWithBuffers(P(N,G,w))}static serializeReplyErr(_,w){return w?this._serializeReplyErrEror(_,w):this._serializeReplyErrEmpty(_)}static _serializeReplyErrEror(_,w){const F=L.VSBuffer.fromString(u(k.transformErrorForSerialization(w),null));let N=0;N+=h.sizeLongString(F);let G=h.alloc(11,_,N);return G.writeLongString(F),G.buffer}static deserializeReplyErrError(_){const w=_.readLongString();return JSON.parse(w)}static _serializeReplyErrEmpty(_){return h.alloc(12,_,0).buffer}}var b;(function(g){g[g.RequestJSONArgs=1]="RequestJSONArgs",g[g.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",g[g.RequestMixedArgs=3]="RequestMixedArgs",g[g.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",g[g.Acknowledged=5]="Acknowledged",g[g.Cancel=6]="Cancel",g[g.ReplyOKEmpty=7]="ReplyOKEmpty",g[g.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",g[g.ReplyOKJSON=9]="ReplyOKJSON",g[g.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",g[g.ReplyErrError=11]="ReplyErrError",g[g.ReplyErrEmpty=12]="ReplyErrEmpty"})(b||(b={}));var y;(function(g){g[g.String=1]="String",g[g.VSBuffer=2]="VSBuffer",g[g.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",g[g.Undefined=4]="Undefined"})(y||(y={}))}),define(me[266],ge([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,m.createDecorator)("remoteAgentService")}),define(me[267],ge([0,1,10,8,11,2,4,86,43,224,266]),function(J,e,m,L,I,k,R,C,D,T,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,R.createDecorator)("pathService");let A=class Wn{constructor(f,l,v,S){this.localUserHome=f,this.remoteAgentService=l,this.environmentService=v,this.contextService=S,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||I.OS)(),this.resolveUserHome=(async()=>{const P=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=P?.userHome||f})()}get defaultUriScheme(){return Wn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(f,l){if(f.remoteAuthority)return m.Schemas.vscodeRemote;const v=(0,C.getVirtualWorkspaceScheme)(l.getWorkspace());if(v)return v;const S=l.getWorkspace().folders[0];if(S)return S.uri.scheme;const P=l.getWorkspace().configuration;return P?P.scheme:m.Schemas.file}async userHome(f){return f?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(f=>f===1?L.win32:L.posix)}async fileURI(f){let l="";if(await this.resolveOS===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const S=f.indexOf("/",2);S===-1?(l=f.substring(2),f="/"):(l=f.substring(2,S),f=f.substring(S)||"/")}return k.URI.from({scheme:m.Schemas.file,authority:l,path:f,query:"",fragment:""})}};A=Ve([We(1,n.IRemoteAgentService),We(2,T.IWorkbenchEnvironmentService),We(3,D.IWorkspaceContextService)],A),e.AbstractPathService=A}),define(me[71],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class m{constructor(R,C){this.line=R,this.character=C}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,C){return new m(0,0)}with(R){return new m(0,0)}}e.Position=m;class L{constructor(R,C,D,T){this.isEmpty=!1,this.isSingleLine=!1,this.start=new m(R,C),this.end=new m(D,T)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new L(0,0,0,0)}with(R){return new L(0,0,0,0)}}e.Range=L;var I;(function(k){k[k.Information=1]="Information",k[k.Warning=2]="Warning"})(I=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(me[31],ge([0,1,17,30,25,29,9,4,8,16,71,13]),function(J,e,m,L,I,k,R,C,D,T,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return n.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const u="\u27EA ",f=" characters skipped \u27EB",l=(u.length+f.length+5)*2;e.ISearchService=(0,C.createDecorator)("searchService");var v;(function(B){B[B.file=0]="file",B[B.text=1]="text"})(v=e.SearchProviderType||(e.SearchProviderType={}));var S;(function(B){B[B.File=1]="File",B[B.Text=2]="Text"})(S=e.QueryType||(e.QueryType={}));function P(B){return!!B.preview}e.resultIsMatch=P;function E(B){return!!B.resource}e.isFileMatch=E;function s(B){return!!B.message}e.isProgressMessage=s;var a;(function(B){B[B.Normal=0]="Normal",B[B.NewSearchStarted=1]="NewSearchStarted"})(a=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class p{constructor(x){this.resource=x,this.results=[]}}e.FileMatch=p;class t{constructor(x,M,H){this.ranges=M;const W=Array.isArray(M)?M:[M];if(H&&H.matchLines===1&&o(W)){x=(0,R.getNLines)(x,H.matchLines);let Q="",X=0,he=0;const _e=Math.floor(H.charsPerLine/5),ye=[];for(const Re of W){const $e=Math.max(Re.startColumn-_e,0),Be=Re.startColumn+H.charsPerLine;if($e>he+_e+l){const je=u+($e-he)+f;Q+=je+x.slice($e,Be),X+=$e-(he+je.length)}else Q+=x.slice(he,Be);ye.push(new i(0,Re.startColumn-X,Re.endColumn-X)),he=Be}this.preview={text:Q,matches:Array.isArray(this.ranges)?ye:ye[0]}}else{const Q=Array.isArray(M)?M[0].startLineNumber:M.startLineNumber;this.preview={text:x,matches:(0,m.mapArrayOrNot)(M,X=>new r(X.startLineNumber-Q,X.startColumn,X.endLineNumber-Q,X.endColumn))}}}}e.TextSearchMatch=t;function o(B){const x=B[0].startLineNumber;for(const M of B)if(M.startLineNumber!==x||M.endLineNumber!==x)return!1;return!0}class r{constructor(x,M,H,W){this.startLineNumber=x,this.startColumn=M,this.endLineNumber=H,this.endColumn=W}}e.SearchRange=r;class i extends r{constructor(x,M,H){super(x,M,x,H)}}e.OneLineRange=i;var h;(function(B){B.Default="default",B.FileNames="fileNames",B.Type="type",B.Modified="modified",B.CountDescending="countDescending",B.CountAscending="countAscending"})(h=e.SearchSortOrder||(e.SearchSortOrder={}));function c(B,x=!0){const M=B&&B.files&&B.files.exclude,H=x&&B&&B.search&&B.search.exclude;if(!M&&!H)return;if(!M||!H)return M||H;let W=Object.create(null);return W=I.mixin(W,I.deepClone(M)),W=I.mixin(W,I.deepClone(H),!0),W}e.getExcludes=c;function d(B,x){return B.excludePattern&&L.match(B.excludePattern,x)?!1:B.includePattern||B.usingSearchPaths?B.includePattern&&L.match(B.includePattern,x)?!0:B.usingSearchPaths?!!B.folderQueries&&B.folderQueries.some(M=>{const H=M.folder.fsPath;if(k.isEqualOrParent(x,H)){const W=D.relative(H,x);return!M.includePattern||!!L.match(M.includePattern,W)}else return!1}):!1:!0}e.pathIncludedInQuery=d;var b;(function(B){B[B.unknownEncoding=1]="unknownEncoding",B[B.regexParseError=2]="regexParseError",B[B.globParseError=3]="globParseError",B[B.invalidLiteral=4]="invalidLiteral",B[B.rgProcessError=5]="rgProcessError",B[B.other=6]="other",B[B.canceled=7]="canceled"})(b=e.SearchErrorCode||(e.SearchErrorCode={}));class y extends Error{constructor(x,M){super(x);this.code=M}}e.SearchError=y;function g(B){const x=B.message;if((0,T.isPromiseCanceledError)(B))return new y(x,b.canceled);try{const M=JSON.parse(x);return new y(M.message,M.code)}catch(M){return new y(x,b.other)}}e.deserializeSearchError=g;function _(B){const x={message:B.message,code:B.code};return new Error(JSON.stringify(x))}e.serializeSearchError=_;function w(B){return B.type==="error"?!0:B.type==="success"}e.isSerializedSearchComplete=w;function F(B){return B.type==="success"}e.isSerializedSearchSuccess=F;function N(B){return!!B.path}e.isSerializedFileMatch=N;function G(B,x){const M=B.searchPath?B.searchPath:B.relativePath;return(0,R.fuzzyContains)(M,x)}e.isFilePatternMatch=G;class K{constructor(x){this.path=x,this.results=[]}addMatch(x){this.results.push(x)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=K;function U(B,x){const M={...B||{},...x||{}};return Object.keys(M).filter(H=>{const W=M[H];return typeof W=="boolean"&&W})}e.resolvePatternsForProvider=U;class z{constructor(x,M){this._parsedIncludeExpression=null,this._excludeExpression={...x.excludePattern||{},...M.excludePattern||{}},this._parsedExcludeExpression=L.parse(this._excludeExpression);let H=x.includePattern;M.includePattern&&(H?H={...H,...M.includePattern}:H=M.includePattern),H&&(this._parsedIncludeExpression=L.parse(H))}includedInQuerySync(x,M,H){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(x,M,H)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(x,M,H))}includedInQuery(x,M,H){const W=this._parsedExcludeExpression(x,M,H),Q=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(x,M,H):!0;return(0,A.isPromise)(W)?W.then(X=>X?!1:Q()):Q()}hasSiblingExcludeClauses(){return O(this._excludeExpression)}}e.QueryGlobTester=z;function O(B){for(const x in B)if(typeof B[x]!="boolean")return!0;return!1}}),define(me[37],ge([0,1,17,18,21,3,24,10,77,22,9,13,2,169,4,12,189,43,52,27,14,7,31,5]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,l,v,S,P,E,s,a,p,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(_,w,F){return new T.ExtUri(N=>d(N,F)).isEqual(_,w)}function i(_,w,F){return r(_.uri,w.uri,F)?0:(0,n.compare)(_.uri.toString(),w.uri.toString())}function h(_,w,F){return _.index!==w.index?_.index<w.index?-1:1:r(_.uri,w.uri,F)?(0,n.compare)(_.name,w.name):(0,n.compare)(_.uri.toString(),w.uri.toString())}function c(_,w,F,N){const G=_.slice(0).sort((U,z)=>F(U,z,N)),K=w.slice(0).sort((U,z)=>F(U,z,N));return(0,m.delta)(G,K,(U,z)=>F(U,z,N))}function d(_,w){const F=w.getCapabilities(_.scheme);return!(F&&F&1024)}class b extends P.Workspace{constructor(w,F,N,G,K,U){super(w,N.map(z=>new P.WorkspaceFolder(z)),G,U);this._name=F,this._isUntitled=K,this._workspaceFolders=[],this._structure=R.TernarySearchTree.forUris(U),N.forEach(z=>{this._workspaceFolders.push(z),this._structure.set(z.uri,z)})}static toExtHostWorkspace(w,F,N,G){if(!w)return{workspace:null,added:[],removed:[]};const{id:K,name:U,folders:z,configuration:O,isUntitled:B}=w,x=[],M=F;F?z.forEach((X,he)=>{const _e=u.URI.revive(X.uri),ye=b._findFolder(N||F,_e,G);ye?(ye.name=X.name,ye.index=X.index,x.push(ye)):x.push({uri:_e,name:X.name,index:he})}):x.push(...z.map(({uri:X,name:he,index:_e})=>({uri:u.URI.revive(X),name:he,index:_e}))),x.sort((X,he)=>X.index<he.index?-1:1);const H=new b(K,U,x,O?u.URI.revive(O):null,!!B,X=>d(X,G)),{added:W,removed:Q}=c(M?M.workspaceFolders:[],H.workspaceFolders,i,G);return{workspace:H,added:W,removed:Q}}static _findFolder(w,F,N){for(let G=0;G<w.folders.length;G++){const K=w.workspaceFolders[G];if(r(K.uri,F,N))return K}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(w,F){return F&&this._structure.get(w)&&(w=(0,T.dirname)(w)),this._structure.findSubstr(w)}resolveWorkspaceFolder(w){return this._structure.get(w)}}let y=class{constructor(w,F,N,G){this._onDidChangeWorkspace=new k.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new k.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=G,this._extHostFileSystemInfo=N,this._requestIdProvider=new D.Counter,this._barrier=new L.Barrier,this._proxy=w.getProxy(o.MainContext.MainThreadWorkspace),this._messageService=w.getProxy(o.MainContext.MainThreadMessageService);const K=F.workspace;this._confirmedWorkspace=K?new b(K.id,K.name,[],K.configuration?u.URI.revive(K.configuration):null,!!K.isUntitled,U=>d(U,N)):void 0}$initializeWorkspace(w,F){this._trusted=F,this.$acceptWorkspaceData(w),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?u.URI.from({scheme:C.Schemas.untitled,path:(0,T.basename)((0,T.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(w,F,N,...G){const K=[];if(Array.isArray(G)&&G.forEach(x=>{u.URI.isUri(x.uri)&&!K.some(M=>r(M.uri,x.uri,this._extHostFileSystemInfo))&&K.push({uri:x.uri,name:x.name||(0,T.basenameOrAuthority)(x.uri)})}),this._unconfirmedWorkspace||[F,N].some(x=>typeof x!="number"||x<0)||N===0&&K.length===0)return!1;const U=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(F+N>U.length)return!1;const z=U.slice(0);z.splice(F,N,...K.map(x=>({uri:x.uri,name:x.name||(0,T.basenameOrAuthority)(x.uri),index:void 0})));for(let x=0;x<z.length;x++){const M=z[x];if(z.some((H,W)=>W!==x&&r(M.uri,H.uri,this._extHostFileSystemInfo)))return!1}z.forEach((x,M)=>x.index=M);const{added:O,removed:B}=c(U,z,h,this._extHostFileSystemInfo);if(O.length===0&&B.length===0)return!1;if(this._proxy){const x=w.displayName||w.name;this._proxy.$updateWorkspaceFolders(x,F,N,K).then(void 0,M=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(S.Severity.Error,(0,f.localize)(0,null,x,M.toString()),{extension:w},[])})}return this.trySetWorkspaceFolders(z),!0}getWorkspaceFolder(w,F){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(w,F)}async getWorkspaceFolder2(w,F){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(w,F)}async resolveWorkspaceFolder(w){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(w)}getPath(){if(!this._actualWorkspace)return;const{folders:w}=this._actualWorkspace;if(w.length!==0)return w[0].uri.fsPath}getRelativePath(w,F){let N,G="";if(typeof w=="string"?(N=u.URI.file(w),G=w):typeof w!="undefined"&&(N=w,G=w.fsPath),!N)return G;const K=this.getWorkspaceFolder(N,!0);if(!K)return G;typeof F=="undefined"&&this._actualWorkspace&&(F=this._actualWorkspace.folders.length>1);let U=(0,T.relativePath)(K.uri,N);return F&&K.name&&(U=`${K.name}/${U}`),U}trySetWorkspaceFolders(w){this._actualWorkspace&&(this._unconfirmedWorkspace=b.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:w,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(w){const{workspace:F,added:N,removed:G}=b.toExtHostWorkspace(w,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=F||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:N,removed:G}))}findFiles(w,F,N,G,K=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${G.value}, entryPoint: findFiles`);let U;if(F===null?U=!1:F&&(typeof F=="string"?U=F:U=F.pattern),K&&K.isCancellationRequested)return Promise.resolve([]);const{includePattern:z,folder:O}=g(w);return this._proxy.$startFileSearch((0,A.withUndefinedAsNull)(z),(0,A.withUndefinedAsNull)(O),(0,A.withUndefinedAsNull)(U),(0,A.withUndefinedAsNull)(N),K).then(B=>Array.isArray(B)?B.map(x=>u.URI.revive(x)):[])}async findTextInFiles(w,F,N,G,K=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${G.value}, entryPoint: findTextInFiles`);const U=this._requestIdProvider.getNext(),z=typeof F.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:F.previewOptions,{includePattern:O,folder:B}=g(F.include),x=typeof F.exclude=="string"?F.exclude:F.exclude?F.exclude.pattern:void 0,M={ignoreSymlinks:typeof F.followSymlinks=="boolean"?!F.followSymlinks:void 0,disregardIgnoreFiles:typeof F.useIgnoreFiles=="boolean"?!F.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof F.useGlobalIgnoreFiles=="boolean"?!F.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof F.useDefaultExcludes=="boolean"?!F.useDefaultExcludes:!0,fileEncoding:F.encoding,maxResults:F.maxResults,previewOptions:z,afterContext:F.afterContext,beforeContext:F.beforeContext,includePattern:O,excludePattern:x},H=!1;if(this._activeSearchCallbacks[U]=W=>{if(H)return;const Q=u.URI.revive(W.resource);W.results.forEach(X=>{(0,t.resultIsMatch)(X)?N({uri:Q,preview:{text:X.preview.text,matches:(0,m.mapArrayOrNot)(X.preview.matches,he=>new p.Range(he.startLineNumber,he.startColumn,he.endLineNumber,he.endColumn))},ranges:(0,m.mapArrayOrNot)(X.ranges,he=>new p.Range(he.startLineNumber,he.startColumn,he.endLineNumber,he.endColumn))}):N({uri:Q,text:X.text,lineNumber:X.lineNumber})})},K.isCancellationRequested)return{};try{const W=await this._proxy.$startTextSearch(w,(0,A.withUndefinedAsNull)(B),M,U,K);return delete this._activeSearchCallbacks[U],W||{}}catch(W){throw delete this._activeSearchCallbacks[U],W}}$handleTextSearchResult(w,F){this._activeSearchCallbacks[F]&&this._activeSearchCallbacks[F](w)}saveAll(w){return this._proxy.$saveAll(w)}resolveProxy(w){return this._proxy.$resolveProxy(w)}get trusted(){return this._trusted}requestWorkspaceTrust(w){return this._proxy.$requestWorkspaceTrust(w)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};y=Ve([We(0,a.IExtHostRpcService),We(1,s.IExtHostInitDataService),We(2,E.IExtHostFileSystemInfo),We(3,v.ILogService)],y),e.ExtHostWorkspace=y,e.IExtHostWorkspace=(0,l.createDecorator)("IExtHostWorkspace");function g(_){let w,F;return _&&(typeof _=="string"?w=_:(w=_.pattern,F=_.baseFolder||u.URI.file(_.base))),{includePattern:w,folder:F}}}),define(me[38],ge([0,1,25,3,37,5,7,192,85,13,18,4,14,12,2]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function v(o,r){if(r){const i=r.split(".");let h=o;for(let c=0;h&&c<i.length;c++)h=h[i[c]];return h}}function S(o){return o instanceof l.URI}function P(o){return o&&o.uri instanceof l.URI&&o.languageId&&typeof o.languageId=="string"}function E(o){return o&&!o.uri&&o.languageId&&typeof o.languageId=="string"}function s(o){return o&&o.uri instanceof l.URI&&(!o.name||typeof o.name=="string")&&(!o.index||typeof o.index=="number")}function a(o){if(S(o))return{resource:o};if(P(o))return{resource:o.uri,overrideIdentifier:o.languageId};if(E(o))return{overrideIdentifier:o.languageId};if(s(o))return{resource:o.uri};if(o===null)return{resource:null}}let p=class{constructor(r,i,h){this._proxy=r.getProxy(k.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=h,this._barrier=new n.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new t(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,i){this.getConfigProvider().then(h=>h.$acceptConfigurationChanged(r,i))}};p=Ve([We(0,u.IExtHostRpcService),We(1,I.IExtHostWorkspace),We(2,f.ILogService)],p),e.ExtHostConfiguration=p;class t{constructor(r,i,h,c){this._onDidChangeConfiguration=new L.Emitter,this._proxy=r,this._logService=c,this._extHostWorkspace=i,this._configuration=C.Configuration.parse(h),this._configurationScopes=this._toMap(h.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,i){const h={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=C.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,h))}getConfiguration(r,i,h){const c=a(i)||{},d=this._toReadonlyValue(r?v(this._configuration.getValue(void 0,c,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,c,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,c,h?.identifier);function b(g){if(g==null)return null;if(typeof g=="boolean")return g?1:4;switch(g){case R.ConfigurationTarget.Global:return 1;case R.ConfigurationTarget.Workspace:return 4;case R.ConfigurationTarget.WorkspaceFolder:return 5}}const y={has(g){return typeof v(d,g)!="undefined"},get:(g,_)=>{this._validateConfigurationAccess(r?`${r}.${g}`:g,c,h?.identifier);let w=v(d,g);if(typeof w=="undefined")w=_;else{let F;const N=(G,K)=>{let U;const z=()=>{F=F||(0,m.deepClone)(d),U=U||v(F,K)};return(0,T.isObject)(G)?new Proxy(G,{get:(O,B)=>{if(typeof B=="string"&&B.toLowerCase()==="tojson")return z(),()=>U;if(F)return U=U||v(F,K),U[B];const x=O[B];return typeof B=="string"?N(x,`${K}.${B}`):x},set:(O,B,x)=>(z(),U&&(U[B]=x),!0),deleteProperty:(O,B)=>(z(),U&&delete U[B],!0),defineProperty:(O,B,x)=>(z(),U&&Object.defineProperty(U,B,x),!0)}):G};w=N(w,g)}return w},update:(g,_,w,F)=>{g=r?`${r}.${g}`:g;const N=b(w);return _!==void 0?this._proxy.$updateConfigurationOption(N,g,_,c,F):this._proxy.$removeConfigurationOption(N,g,c,F)},inspect:g=>{g=r?`${r}.${g}`:g;const _=(0,m.deepClone)(this._configuration.inspect(g,c,this._extHostWorkspace.workspace));if(_)return{key:g,defaultValue:_.default?.value,globalValue:_.user?.value,workspaceValue:_.workspace?.value,workspaceFolderValue:_.workspaceFolder?.value,defaultLanguageValue:_.default?.override,globalLanguageValue:_.user?.override,workspaceLanguageValue:_.workspace?.override,workspaceFolderLanguageValue:_.workspaceFolder?.override,languageIds:_.overrideIdentifiers}}};return typeof d=="object"&&(0,m.mixin)(y,d,!1),Object.freeze(y)}_toReadonlyValue(r){const i=h=>(0,T.isObject)(h)?new Proxy(h,{get:(c,d)=>i(c[d]),set:(c,d,b)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(d)}' of object`)},deleteProperty:(c,d)=>{throw new Error(`TypeError: Cannot delete read only property '${String(d)}' of object`)},defineProperty:(c,d)=>{throw new Error(`TypeError: Cannot define property '${String(d)}' for a readonly object`)},setPrototypeOf:c=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):h;return i(r)}_validateConfigurationAccess(r,i,h){const c=D.OVERRIDE_PROPERTY_PATTERN.test(r)?4:this._configurationScopes.get(r),d=h?`[${h.value}] `:"";if(c===4){typeof i?.resource=="undefined"&&this._logService.warn(`${d}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(c===3){i?.resource&&this._logService.warn(`${d}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,i){const h=new C.ConfigurationChangeEvent(r,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(c,d)=>h.affectsConfiguration(c,a(d))})}_toMap(r){return r.reduce((i,h)=>(i.set(h[0],h[1]),i),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,A.createDecorator)("IExtHostConfiguration")});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(J,m):I?I.value=m:e.set(J,m),m},Oe=this&&this.__classPrivateFieldGet||function(J,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(J):L?L.value:e.get(J)};define(me[72],ge([0,1,2,18,3,5,7,37,45,38,21,33,14,27,4,10,11,12,67,214,16]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,l,v,S,P,E,s,a){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(K){function U(O){if(O!=null)return O}K.from=U;function z(O){if(O!=null)return O}K.to=z})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var o;(function(K){function U(O){if(O!=null)return O}K.from=U;function z(O){if(O!=null)return O}K.to=z})(o=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(K){function U(O){if(O!=null)return O}K.from=U;function z(O){if(O!=null)return O}K.to=z})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(K){function U(B){if(B){const x=B;return x&&!!x.process}else return!1}K.is=U;function z(B){if(B==null)return;const x={process:B.process,args:B.args};return B.options&&(x.options=r.from(B.options)),x}K.from=z;function O(B){if(B!=null)return new R.ProcessExecution(B.process,B.args,B.options)}K.to=O})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var h;(function(K){function U(O){if(O!=null)return O}K.from=U;function z(O){if(O!=null)return O}K.to=z})(h=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var c;(function(K){function U(B){if(B){const x=B;return x&&(!!x.commandLine||!!x.command)}else return!1}K.is=U;function z(B){if(B==null)return;const x={};return B.commandLine!==void 0?x.commandLine=B.commandLine:(x.command=B.command,x.args=B.args),B.options&&(x.options=h.from(B.options)),x}K.from=z;function O(B){if(!(B==null||B.command===void 0&&B.commandLine===void 0))return B.commandLine?new R.ShellExecution(B.commandLine,B.options):new R.ShellExecution(B.command,B.args?B.args:[],B.options)}K.to=O})(c=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var d;(function(K){function U(B){if(B){let x=B;return x&&x.customExecution==="customExecution"}else return!1}K.is=U;function z(B){return{customExecution:"customExecution"}}K.from=z;function O(B,x){return x.get(B)}K.to=O})(d=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var b;(function(K){function U(z,O){let B;return z.scope!==void 0&&typeof z.scope!="number"?B=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===R.TaskScope.Workspace&&O&&O.workspaceFile?B=O.workspaceFile:B=s.USER_TASKS_GROUP_KEY),{id:z._id,workspaceFolder:B}}K.from=U})(b=e.TaskHandleDTO||(e.TaskHandleDTO={}));var y;(function(K){function U(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}K.from=U})(y=e.TaskGroupDTO||(e.TaskGroupDTO={}));var g;(function(K){function U(B,x){if(B==null)return[];const M=[];for(let H of B){const W=z(H,x);W&&M.push(W)}return M}K.fromMany=U;function z(B,x){if(B==null)return;let M;B.execution instanceof R.ProcessExecution?M=i.from(B.execution):B.execution instanceof R.ShellExecution?M=c.from(B.execution):B.execution&&B.execution instanceof R.CustomExecution&&(M=d.from(B.execution));const H=t.from(B.definition);let W;return B.scope?typeof B.scope=="number"?W=B.scope:W=B.scope.uri:W=R.TaskScope.Workspace,!H||!W?void 0:{_id:B._id,definition:H,name:B.name,source:{extensionId:x.identifier.value,label:B.source,scope:W},execution:M,isBackground:B.isBackground,group:y.from(B.group),presentationOptions:o.from(B.presentationOptions),problemMatchers:B.problemMatchers,hasDefinedMatchers:B.hasDefinedMatchers,runOptions:B.runOptions?B.runOptions:{reevaluateOnRerun:!0},detail:B.detail}}K.from=z;async function O(B,x,M){if(B==null)return;let H;i.is(B.execution)?H=i.to(B.execution):c.is(B.execution)?H=c.to(B.execution):d.is(B.execution)&&(H=d.to(B._id,M));const W=t.to(B.definition);let Q;if(B.source&&(B.source.scope!==void 0?typeof B.source.scope=="number"?Q=B.source.scope:Q=await x.resolveWorkspaceFolder(m.URI.revive(B.source.scope)):Q=R.TaskScope.Workspace),!W||!Q)return;const X=new R.Task(W,Q,B.name,B.source.label,H,B.problemMatchers);return B.isBackground!==void 0&&(X.isBackground=B.isBackground),B.group!==void 0&&(X.group=R.TaskGroup.from(B.group._id),X.group&&(X.group=new R.TaskGroup(X.group.id,X.group.label),B.group.isDefault&&(X.group.isDefault=B.group.isDefault))),B.presentationOptions&&(X.presentationOptions=o.to(B.presentationOptions)),B._id&&(X._id=B._id),B.detail&&(X.detail=B.detail),X}K.to=O})(g=e.TaskDTO||(e.TaskDTO={}));var _;(function(K){function U(O){return O}K.from=U;function z(O){if(!!O)return Object.assign(Object.create(null),O)}K.to=z})(_=e.TaskFilterDTO||(e.TaskFilterDTO={}));class w{constructor(U,z,O){this._id=z,this._task=O,p.set(this,void 0),nt(this,p,U,"f")}get task(){return this._task}terminate(){Oe(this,p,"f").terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}p=new WeakMap;var F;(function(K){function U(z){return{id:z._id,task:void 0}}K.from=U})(F=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let N=class{constructor(U,z,O,B,x,M,H,W){this._onDidExecuteTask=new I.Emitter,this._onDidTerminateTask=new I.Emitter,this._onDidTaskProcessStarted=new I.Emitter,this._onDidTaskProcessEnded=new I.Emitter,this._proxy=U.getProxy(k.MainContext.MainThreadTask),this._workspaceProvider=O,this._editorService=B,this._configurationService=x,this._terminalService=M,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=H,this._deprecationService=W,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(U,z,O){if(!O)return new R.Disposable(()=>{});const B=this.nextHandle();return this._handlers.set(B,{type:z,provider:O,extension:U}),this._proxy.$registerTaskProvider(B,z),new R.Disposable(()=>{this._handlers.delete(B),this._proxy.$unregisterTaskProvider(B)})}registerTaskSystem(U,z){this._proxy.$registerTaskSystem(U,z)}fetchTasks(U){return this._proxy.$fetchTasks(_.from(U)).then(async z=>{const O=[];for(let B of z){const x=await g.to(B,this._workspaceProvider,this._providedCustomExecutions2);x&&O.push(x)}return O})}get taskExecutions(){const U=[];return this._taskExecutions.forEach(z=>U.push(z)),U}terminateTask(U){if(!(U instanceof w))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(U._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(U,z,O){const B=this._providedCustomExecutions2.get(U.id);if(B){if(this._activeCustomExecutions2.get(U.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(U.id,B),this._terminalService.attachPtyToTerminal(z,await B.callback(O))}this._lastStartedTask=U.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(U)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(U){const z=await this.getTaskExecution(U);this._taskExecutionPromises.delete(U.id),this._taskExecutions.delete(U.id),this.customExecutionComplete(U),this._onDidTerminateTask.fire({execution:z})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(U){const z=await this.getTaskExecution(U.id);this._onDidTaskProcessStarted.fire({execution:z,processId:U.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(U){const z=await this.getTaskExecution(U.id);this._onDidTaskProcessEnded.fire({execution:z,exitCode:U.exitCode})}$provideTasks(U,z){const O=this._handlers.get(U);if(!O)return Promise.reject(new Error("no handler found"));const B=[],x=(0,L.asPromise)(()=>O.provider.provideTasks(n.CancellationToken.None)).then(M=>this.provideTasksInternal(z,B,O,M));return new Promise(M=>{x.then(H=>{Promise.all(B).then(()=>{M(H)})})})}async $resolveTask(U,z){const O=this._handlers.get(U);if(!O)return Promise.reject(new Error("no handler found"));if(z.definition.type!==O.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${O.type}].`);const B=await g.to(z,this._workspaceProvider,this._providedCustomExecutions2);if(!B)throw new Error("Unexpected: Task cannot be resolved.");const x=await O.provider.resolveTask(B,n.CancellationToken.None);if(!x)return;this.checkDeprecation(x,O);const M=g.from(x,O.extension);if(!M)throw new Error("Unexpected: Task cannot be resolved.");if(x.definition!==B.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return d.is(M.execution)&&await this.addCustomExecution(M,x,!0),await this.resolveTaskInternal(M)}nextHandle(){return this._handleCounter++}async addCustomExecution(U,z,O){const B=await this._proxy.$createTaskId(U);!O&&!this._providedCustomExecutions2.has(B)&&this._notProvidedCustomExecutions.add(B),this._providedCustomExecutions2.set(B,z.execution)}async getTaskExecution(U,z){if(typeof U=="string"){const x=this._taskExecutionPromises.get(U);if(!x)throw new Error("Unexpected: The specified task is missing an execution");return x}let O=this._taskExecutionPromises.get(U.id);if(O)return O;const B=new Promise(async(x,M)=>{const H=z||await g.to(U.task,this._workspaceProvider,this._providedCustomExecutions2);H?x(new w(this,U.id,H)):M("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(U.id,B),B.then(x=>(this._taskExecutions.set(U.id,x),x),x=>Promise.reject(x))}checkDeprecation(U,z){U._deprecated&&this._deprecationService.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(U){this._activeCustomExecutions2.get(U.id)&&this._activeCustomExecutions2.delete(U.id),this._notProvidedCustomExecutions.has(U.id)&&this._lastStartedTask!==U.id&&(this._providedCustomExecutions2.delete(U.id),this._notProvidedCustomExecutions.delete(U.id));let O=this._notProvidedCustomExecutions.values(),B=O.next();for(;!B.done;)!this._activeCustomExecutions2.has(B.value)&&this._lastStartedTask!==B.value&&(this._providedCustomExecutions2.delete(B.value),this._notProvidedCustomExecutions.delete(B.value)),B=O.next()}};N=Ve([We(0,u.IExtHostRpcService),We(1,f.IExtHostInitDataService),We(2,C.IExtHostWorkspace),We(3,D.IExtHostDocumentsAndEditors),We(4,T.IExtHostConfiguration),We(5,A.IExtHostTerminalService),We(6,P.ILogService),We(7,E.IExtHostApiDeprecationService)],N),e.ExtHostTaskBase=N;let G=class extends N{constructor(U,z,O,B,x,M,H,W){super(U,z,O,B,x,M,H,W);this.registerTaskSystem(v.Schemas.vscodeRemote,{scheme:v.Schemas.vscodeRemote,authority:"",platform:S.PlatformToString(0)})}async executeTask(U,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const O=g.from(z,U);if(O===void 0)throw new Error("Task is not valid");if(d.is(O.execution))await this.addCustomExecution(O,z,!1);else throw new a.NotSupportedError;const B=await this.getTaskExecution(await this._proxy.$getTaskExecution(O),z);return this._proxy.$executeTask(O).catch(x=>{throw new Error(x)}),B}provideTasksInternal(U,z,O,B){const x=[];if(B)for(let M of B){this.checkDeprecation(M,O),(!M.definition||!U[M.definition.type])&&this._logService.warn(`The task [${M.source}, ${M.name}] uses an undefined task type. The task will be ignored in the future.`);const H=g.from(M,O.extension);H&&d.is(H.execution)?(x.push(H),z.push(this.addCustomExecution(H,M,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:x,extension:O.extension}}async resolveTaskInternal(U){if(d.is(U.execution))return U;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(U,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,z,O){}};G=Ve([We(0,u.IExtHostRpcService),We(1,f.IExtHostInitDataService),We(2,C.IExtHostWorkspace),We(3,D.IExtHostDocumentsAndEditors),We(4,T.IExtHostConfiguration),We(5,A.IExtHostTerminalService),We(6,P.ILogService),We(7,E.IExtHostApiDeprecationService)],G),e.WorkerExtHostTask=G,e.IExtHostTask=(0,l.createDecorator)("IExtHostTask")}),define(me[268],ge([0,1,17,57,30,79,24,10,8,22,9,13,2,145,175,120,43,128,267,31]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,l,v,S,P,E,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let a=class{constructor(b,y,g,_){this.configurationService=b,this.workspaceContextService=y,this.editorGroupsService=g,this.pathService=_}text(b,y,g={}){b=this.getContentPattern(b,g);const _=this.configurationService.getValue(),w=y&&y.some(N=>!this.configurationService.getValue({resource:N}).search.useRipgrep);return{...this.commonQuery(y?.map(S.toWorkspaceFolder),g),type:2,contentPattern:b,previewOptions:g.previewOptions,maxFileSize:g.maxFileSize,usePCRE2:_.search.usePCRE2||w||!1,beforeContext:g.beforeContext,afterContext:g.afterContext,userDisabledExcludesAndIgnoreFiles:g.disregardExcludeSettings&&g.disregardIgnoreFiles}}getContentPattern(b,y){const g=this.configurationService.getValue();b.isRegExp&&(b.pattern=b.pattern.replace(/\r?\n/g,"\\n"));const _={...b,wordSeparators:g.editor.wordSeparators};return this.isCaseSensitive(b,y)&&(_.isCaseSensitive=!0),this.isMultiline(b)&&(_.isMultiline=!0),_}file(b,y={}){return{...this.commonQuery(b,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey}}handleIncludeExclude(b,y){return b?(b=Array.isArray(b)?b.map(i):i(b),y?this.parseSearchPaths(b):{pattern:t(...Array.isArray(b)?b:[b])}):{}}commonQuery(b=[],y={}){const g=this.handleIncludeExclude(y.includePattern,y.expandPatterns),_=this.handleIncludeExclude(y.excludePattern,y.expandPatterns),w=b.length>1,F=(g.searchPaths&&g.searchPaths.length?g.searchPaths.map(K=>this.getFolderQueryForSearchPath(K,y,_)):b.map(K=>this.getFolderQueryForRoot(K,y,_,w))).filter(K=>!!K),N={_reason:y._reason,folderQueries:F,usingSearchPaths:!!(g.searchPaths&&g.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:_.pattern,includePattern:g.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const U=m.coalesce(m.flatten(this.editorGroupsService.groups.map(O=>O.editors.map(B=>B.resource)))).filter(O=>(0,s.pathIncludedInQuery)(N,O.fsPath)),z=this.commonQueryFromFileList(U);return{...N,...z}}const G=y.extraFileResources&&y.extraFileResources.filter(K=>(0,s.pathIncludedInQuery)(N,K.fsPath));return N.extraFileResources=G&&G.length?G:void 0,N}commonQueryFromFileList(b){const y=[],g=new R.ResourceMap,_={};let w=!1;return b.forEach(F=>{if(F.scheme===C.Schemas.walkThrough)return;if((0,T.isAbsolutePath)(F)){const G=this.workspaceContextService.getWorkspaceFolder(F)?.uri??F.with({path:D.dirname(F.fsPath)});let K=g.get(G);K||(w=!0,K={folder:G,includePattern:{}},y.push(K),g.set(G,K));const U=D.relative(G.fsPath,F.fsPath);(0,A.assertIsDefined)(K.includePattern)[U.replace(/\\/g,"/")]=!0}else F.fsPath&&(w=!0,_[F.fsPath]=!0)}),{folderQueries:y,includePattern:_,usingSearchPaths:!0,excludePattern:w?void 0:{"**/*":!0}}}isCaseSensitive(b,y){if(y.isSmartCase){if(b.isRegExp){if(n.containsUppercaseCharacter(b.pattern,!0))return!0}else if(n.containsUppercaseCharacter(b.pattern))return!0}return!!b.isCaseSensitive}isMultiline(b){return b.isMultiline||b.isRegExp&&(0,f.isMultilineRegexSource)(b.pattern)||b.pattern.indexOf(`
`)>=0?!0:!!b.isMultiline}parseSearchPaths(b){const y=z=>D.isAbsolute(z)||/^\.\.?([\/\\]|$)/.test(z),_=(Array.isArray(b)?b:o(b)).map(z=>{const O=this.pathService.resolvedUserHome;return O?(0,k.untildify)(z,O.scheme===C.Schemas.file?O.fsPath:O.path):z}),w=L.groupBy(_,z=>y(z)?"searchPaths":"exprSegments"),F=(w.exprSegments||[]).map(z=>n.rtrim(z,"/")).map(z=>n.rtrim(z,"\\")).map(z=>(z[0]==="."&&(z="*"+z),r(z))),N={},G=this.expandSearchPathPatterns(w.searchPaths||[]);G&&G.length&&(N.searchPaths=G);const K=m.flatten(F),U=t(...K);return U&&(N.pattern=U),N}getExcludesForFolder(b,y){return y.disregardExcludeSettings?void 0:(0,s.getExcludes)(b,!y.disregardSearchExcludeSettings)}expandSearchPathPatterns(b){if(!b||!b.length)return[];const y=m.flatten(b.map(_=>{let{pathPortion:w,globPortion:F}=p(_);F&&(F=h(F));const N=this.expandOneSearchPath(w);return m.flatten(N.map(G=>this.resolveOneSearchPathPattern(G,F)))})),g=new Map;return y.forEach(_=>{const w=_.searchPath.toString(),F=g.get(w);F?_.pattern&&(F.pattern=F.pattern||{},F.pattern[_.pattern]=!0):g.set(w,{searchPath:_.searchPath,pattern:_.pattern?t(_.pattern):void 0})}),Array.from(g.values())}expandOneSearchPath(b){if(D.isAbsolute(b)){const y=this.workspaceContextService.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==C.Schemas.file?[{searchPath:y[0].uri.with({path:b})}]:[{searchPath:u.URI.file(D.normalize(b))}]}if(this.workspaceContextService.getWorkbenchState()===2){const y=this.workspaceContextService.getWorkspace().folders[0].uri;if(b=i(b),b.startsWith("../")||b===".."){const _=D.posix.resolve(y.path,b);return[{searchPath:y.with({path:_})}]}const g=h(b);return[{searchPath:y,pattern:g}]}else{if(b==="./"||b===".\\")return[];{const y=b.replace(/^\.[\/\\]/,""),_=this.workspaceContextService.getWorkspace().folders.map(w=>{const F=y.match(new RegExp(`^${n.escapeRegExpCharacters(w.name)}(?:/(.*)|$)`));return F?{match:F,folder:w}:null}).filter(A.isDefined);if(_.length)return _.map(w=>{const F=w.match[1];return{searchPath:w.folder.uri,pattern:F&&h(F)}});{const w=b.match(/\.[\/\\](.+)[\/\\]?/),F=w?w[1]:b,N=l.localize(0,null,F);throw new Error(N)}}}}resolveOneSearchPathPattern(b,y){const g=b.pattern&&y?`${b.pattern}/${y}`:b.pattern||y,_=[{searchPath:b.searchPath,pattern:g}];return g&&!g.endsWith("**")&&_.push({searchPath:b.searchPath,pattern:g+"/**"}),_}getFolderQueryForSearchPath(b,y,g){const _=this.getFolderQueryForRoot((0,S.toWorkspaceFolder)(b.searchPath),y,g,!1);return _?{..._,includePattern:b.pattern}:null}getFolderQueryForRoot(b,y,g,_){let w;const F=u.URI.isUri(b)?b:b.uri;if(g.searchPaths){const z=g.searchPaths.filter(O=>(0,T.isEqual)(O.searchPath,F))[0];if(z&&!z.pattern)return null;z&&(w=z.pattern)}const N=this.configurationService.getValue({resource:F}),K={...this.getExcludesForFolder(N,y)||{},...w||{}},U=u.URI.isUri(b)?(0,T.basename)(b):b.name;return{folder:F,folderName:_?U:void 0,excludePattern:Object.keys(K).length>0?K:void 0,fileEncoding:N.files&&N.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!N.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!N.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!N.search.followSymlinks}}};a=Ve([We(0,v.IConfigurationService),We(1,S.IWorkspaceContextService),We(2,P.IEditorGroupsService),We(3,E.IPathService)],a),e.QueryBuilder=a;function p(d){const b=d.match(/[\*\{\}\(\)\[\]\?]/);if(b){const y=b.index,g=d.substr(0,y).match(/[/|\\][^/\\]*$/);if(g){let _=d.substr(0,g.index);return _.match(/[/\\]/)||(_+="/"),{pathPortion:_,globPortion:d.substr((g.index||0)+1)}}}return{pathPortion:d}}function t(...d){return d.length?d.reduce((b,y)=>(b[y]=!0,b),Object.create(null)):void 0}function o(d){return I.splitGlobAware(d,",").map(b=>b.trim()).filter(b=>!!b.length)}function r(d){return[`**/${d}/**`,`**/${d}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function i(d){return d.replace(/\\/g,"/")}function h(d){return i(d).replace(/^\.\//,"").replace(/\/+$/g,"")}function c(d,b){d=m.distinct(d,_=>_.toString());const y=[],g=b.getWorkspace();return d&&d.forEach(_=>{let w;if(b.getWorkbenchState()===2)w=(0,T.relativePath)(g.folders[0].uri,_),w&&w!=="."&&(w="./"+w);else{const F=b.getWorkspaceFolder(_);if(F){const N=F.name;if(g.folders.filter(K=>K.name===N).length===1){const K=(0,T.relativePath)(F.uri,_);K===""?w=`./${F.name}`:w=`./${F.name}/${K}`}else w=_.fsPath}}w&&y.push(w)}),y}e.resolveResourcesForSearchIncludes=c}),define(me[269],ge([0,1,22,2,21,16,4,268,31,43]),function(J,e,m,L,I,k,R,C,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const n=7e3;function A(v,S){const P=S.activationEvents;if(!P)return Promise.resolve(void 0);const E=[],s=[];for(const i of P)if(/^workspaceContains:/.test(i)){const h=i.substr("workspaceContains:".length);h.indexOf("*")>=0||h.indexOf("?")>=0||v.forceUsingSearch?s.push(h):E.push(h)}if(E.length===0&&s.length===0)return Promise.resolve(void 0);let a;const p=new Promise((i,h)=>{a=i}),t=i=>a({activationEvent:i}),o=Promise.all(E.map(i=>u(v,i,t))).then(()=>{}),r=f(v,S.identifier,s,t);return Promise.all([o,r]).then(()=>{a(void 0)}),p}e.checkActivateWorkspaceContainsExtension=A;async function u(v,S,P){for(const E of v.folders)if(await v.exists(m.joinPath(L.URI.revive(E),S))){P(`workspaceContains:${S}`);return}}async function f(v,S,P,E){if(P.length===0)return Promise.resolve(void 0);const s=new I.CancellationTokenSource,a=v.checkExists(v.folders,P,s.token),p=setTimeout(async()=>{s.cancel(),E(`workspaceContainsTimeout:${P.join(",")}`)},n);let t=!1;try{t=await a}catch(o){k.isPromiseCanceledError(o)||k.onUnexpectedError(o)}s.dispose(),clearTimeout(p),t&&E(`workspaceContains:${P.join(",")}`)}function l(v,S,P,E){const s=v.get(R.IInstantiationService),a=v.get(D.ISearchService),t=s.createInstance(C.QueryBuilder).file(S.map(o=>(0,T.toWorkspaceFolder)(L.URI.revive(o))),{_reason:"checkExists",includePattern:P,exists:!0});return a.fileSearch(t,E).then(o=>!!o.limitHit,o=>k.isPromiseCanceledError(o)?!1:Promise.reject(o))}e.checkGlobFileExists=l});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(J,m):I?I.value=m:e.set(J,m),m},Oe=this&&this.__classPrivateFieldGet||function(J,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(J):L?L.value:e.get(J)};define(me[40],ge([0,1,164,8,73,22,18,6,24,2,12,5,38,227,92,37,36,225,16,26,23,200,7,121,4,27,69,14,84,53,33,3,269,90,202]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,l,v,S,P,E,s,a,p,t,o,r,i,h,c,d,b,y,g,_,w,F){"use strict";var N,G,K;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let U=class Hn extends C.Disposable{constructor(x,M,H,W,Q,X,he,_e,ye,Re){super();this._onDidChangeRemoteConnectionData=this._register(new g.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=M,this._extHostContext=H,this._initData=he,this._extHostWorkspace=W,this._extHostConfiguration=Q,this._logService=X,this._extHostTunnelService=ye,this._extHostTerminalService=Re,this._disposables=new C.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(A.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(A.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(A.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new R.Barrier,this._readyToStartExtensionHost=new R.Barrier,this._readyToRunExtensions=new R.Barrier,this._eagerExtensionsActivated=new R.Barrier,this._registry=new P.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new l.ExtHostStorage(this._extHostContext),this._secretState=new w.ExtHostSecretState(this._extHostContext),this._storagePath=_e,this._instaService=x.createChild(new d.ServiceCollection([l.IExtHostStorage,this._storage],[w.IExtHostSecretState,this._secretState]));const $e=new Set;this._initData.hostExtensions.forEach(Be=>$e.add(s.ExtensionIdentifier.toKey(Be))),this._activator=new f.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Be,je,V)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Be,E.transformErrorForSerialization(je),V)},actualActivateExtension:async(Be,je)=>{if($e.has(s.ExtensionIdentifier.toKey(Be)))return await this._mainThreadExtensionsProxy.$activateExtension(Be,je),new f.HostExtension;const V=this._registry.getExtensionDescription(Be);return this._activateExtension(V,je)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),I.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(x){E.onUnexpectedError(x)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let x=[];try{x=this._registry.getAllExtensionDescriptions().map(Q=>Q.identifier).filter(Q=>this.isActivated(Q)).map(Q=>this._deactivate(Q))}catch(M){}await Promise.all(x)}isActivated(x){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(x):!1}_activateByEvent(x,M){return this._activator.activateByEvent(x,M)}_activateById(x,M){return this._activator.activateById(x,M)}activateByIdWithErrors(x,M){return this._activateById(x,M).then(()=>{const H=this._activator.getActivatedExtension(x);if(H.activationFailed)return Promise.reject(H.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(x=>this._registry)}getExtensionExports(x){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(x).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const x=D.TernarySearchTree.forPaths(),M=this._registry.getAllExtensionDescriptions().map(H=>{if(!!this._getEntryPoint(H))return this._hostUtils.realpath(H.extensionLocation.fsPath).then(W=>x.set(T.URI.file(W).fsPath,H))});this._extensionPathIndex=Promise.all(M).then(()=>x)}return this._extensionPathIndex}_deactivate(x){let M=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(x))return M;const H=this._activator.getActivatedExtension(x);if(!H)return M;try{typeof H.module.deactivate=="function"&&(M=Promise.resolve(H.module.deactivate()).then(void 0,W=>(this._logService.error(W),Promise.resolve(void 0))))}catch(W){this._logService.error(W)}try{(0,C.dispose)(H.subscriptions)}catch(W){this._logService.error(W)}return M}async _activateExtension(x,M){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(x.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(x.identifier),this._doActivateExtension(x,M).then(H=>{const W=H.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(x.identifier,W.codeLoadingTime,W.activateCallTime,W.activateResolvedTime,M),this._logExtensionActivationTimes(x,M,"success",W),H},H=>{throw this._logExtensionActivationTimes(x,M,"failure"),H})}_logExtensionActivationTimes(x,M,H,W){const Q=z(x,M);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Q,...W||{},outcome:H})}_doActivateExtension(x,M){const H=z(x,M);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",H);const W=this._getEntryPoint(x);if(!W)return Promise.resolve(new f.EmptyExtension(f.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${x.identifier.value} ${JSON.stringify(M)}`),this._logService.flush();const Q=new f.ExtensionActivationTimesBuilder(M.startup);return Promise.all([this._loadCommonJSModule(x.identifier,(0,k.joinPath)(x.extensionLocation,W),Q),this._loadExtensionContext(x)]).then(X=>(I.mark(`code/extHost/willActivateExtension/${x.identifier.value}`),Hn._callActivate(this._logService,x.identifier,X[0],X[1],Q))).then(X=>(I.mark(`code/extHost/didActivateExtension/${x.identifier.value}`),X))}_loadExtensionContext(x){const M=new p.ExtensionGlobalMemento(x,this._storage),H=new p.ExtensionMemento(x.identifier.value,!1,this._storage),W=new F.ExtensionSecrets(x,this._secretState),Q=x.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,X=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${x.identifier.value}`),Promise.all([M.whenReady,H.whenReady,this._storagePath.whenReady]).then(()=>{const he=this;let _e;return Object.freeze({globalState:M,workspaceState:H,secrets:W,subscriptions:[],get extensionUri(){return x.extensionLocation},get extensionPath(){return x.extensionLocation.fsPath},asAbsolutePath(ye){return L.join(x.extensionLocation.fsPath,ye)},get storagePath(){return he._storagePath.workspaceValue(x)?.fsPath},get globalStoragePath(){return he._storagePath.globalValue(x).fsPath},get logPath(){return L.join(he._initData.logsLocation.fsPath,x.identifier.value)},get logUri(){return T.URI.joinPath(he._initData.logsLocation,x.identifier.value)},get storageUri(){return he._storagePath.workspaceValue(x)},get globalStorageUri(){return he._storagePath.globalValue(x)},get extensionMode(){return Q},get extension(){return _e===void 0&&(_e=new O(he,x.identifier,x,X)),_e},get extensionRuntime(){return(0,S.checkProposedApiEnabled)(x),he.extensionRuntime},get environmentVariableCollection(){return he._extHostTerminalService.getEnvironmentVariableCollection(x)}})})}static _callActivate(x,M,H,W,Q){return H=H||{activate:void 0,deactivate:void 0},this._callActivateOptional(x,M,H,W,Q).then(X=>new f.ActivatedExtension(!1,null,Q.build(),H,X,W.subscriptions))}static _callActivateOptional(x,M,H,W,Q){if(typeof H.activate=="function")try{Q.activateCallStart(),x.trace(`ExtensionService#_callActivateOptional ${M.value}`);const X=typeof global=="object"?global:self,he=H.activate.apply(X,[W]);return Q.activateCallStop(),Q.activateResolveStart(),Promise.resolve(he).then(_e=>(Q.activateResolveStop(),_e))}catch(X){return Promise.reject(X)}else return Promise.resolve(H)}_activateOneStartupFinished(x,M){this._activateById(x.identifier,{startup:!1,extensionId:x.identifier,activationEvent:M}).then(void 0,H=>{this._logService.error(H)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(I.getMarks());for(const x of this._registry.getAllExtensionDescriptions())if(x.activationEvents)for(const M of x.activationEvents)M==="onStartupFinished"&&this._activateOneStartupFinished(x,M)}_handleEagerExtensions(){const x=this._activateByEvent("*",!0).then(void 0,Q=>{this._logService.error(Q)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(Q=>this._handleWorkspaceContainsEagerExtensions(Q.added)));const M=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],H=this._handleWorkspaceContainsEagerExtensions(M),W=Promise.all([x,H]).then(()=>{});return Promise.race([W,(0,R.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),W}_handleWorkspaceContainsEagerExtensions(x){return x.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(M=>this._handleWorkspaceContainsEagerExtension(x,M))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(x,M){if(this.isActivated(M.identifier))return;const H=!this._initData.remote.isRemote&&!!this._initData.remote.authority,W={folders:x.map(X=>X.uri),forceUsingSearch:H,exists:X=>this._hostUtils.exists(X.fsPath),checkExists:(X,he,_e)=>this._mainThreadWorkspaceProxy.$checkExists(X,he,_e)},Q=await(0,_.checkActivateWorkspaceContainsExtension)(W,M);if(!!Q)return this._activateById(M.identifier,{startup:!0,extensionId:M.identifier,activationEvent:Q.activationEvent}).then(void 0,X=>this._logService.error(X))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(x){throw console.error(x),x}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:x,extensionTestsLocationURI:M}=this._initData.environment;if(!x||!M)throw new Error(m.localize(0,null));const H=await this._loadCommonJSModule(null,M,new f.ExtensionActivationTimesBuilder(!1));if(!H||typeof H.run!="function")throw new Error(m.localize(1,null,M.toString()));return new Promise((W,Q)=>{const X=(ye,Re)=>{ye?Q(ye):W(typeof Re=="number"&&Re>0?1:0)},he=(0,k.originalFSPath)(M),_e=H.run(he,X);_e&&_e.then&&_e.then(()=>{W(0)}).catch(ye=>{Q(ye.toString())})})}async $extensionTestsExit(x){this._logService.info(`extension host terminating: test runner requested exit with code ${x}`),this._logService.info(`exiting with code ${x}`),this._logService.flush(),this._hostUtils.exit(x)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(x,M){return this._resolvers[x]=M,(0,C.toDisposable)(()=>{delete this._resolvers[x]})}async _activateAndGetResolver(x){const M=x.indexOf("+");if(M===-1)throw new Error("Not an authority that can be resolved!");const H=x.substr(0,M);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${H}`,!1),{authorityPrefix:H,resolver:this._resolvers[H]}}async $resolveAuthority(x,M){const{authorityPrefix:H,resolver:W}=await this._activateAndGetResolver(x);if(!W)return{type:"error",error:{code:o.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${H}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(W)),I.mark(`code/extHost/willResolveAuthority/${H}`);const Q=await W.resolve(x,{resolveAttempt:M});I.mark(`code/extHost/didResolveAuthorityOK/${H}`);const X={authority:x,host:Q.host,port:Q.port,connectionToken:Q.connectionToken},he={extensionHostEnv:Q.extensionHostEnv,isTrusted:Q.isTrusted};return{type:"ok",value:{authority:X,options:he,tunnelInformation:{environmentTunnels:Q.environmentTunnels}}}}catch(Q){if(I.mark(`code/extHost/didResolveAuthorityError/${H}`),Q instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:Q._code,message:Q._message,detail:Q._detail}};throw Q}}async $getCanonicalURI(x,M){const{authorityPrefix:H,resolver:W}=await this._activateAndGetResolver(x);if(!W)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${H}`);const Q=T.URI.revive(M);if(typeof W.getCanonicalURI=="undefined")return Q;const X=await(0,R.asPromise)(()=>W.getCanonicalURI(Q));return X||Q}$startExtensionHost(x){return this._registry.keepOnly(x),this._startExtensionHost()}$activateByEvent(x,M){return M===1?this._activateByEvent(x,!1):this._readyToRunExtensions.wait().then(H=>this._activateByEvent(x,!1))}async $activate(x,M){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(x)?(await this._activateById(x,M),!0):!1}async $deltaExtensions(x,M){x.forEach(W=>W.extensionLocation=T.URI.revive(W.extensionLocation));const H=await this.getExtensionPathIndex();return await Promise.all(M.map(async W=>{const Q=this._registry.getExtensionDescription(W);if(!Q)return;const X=await this._hostUtils.realpath(Q.extensionLocation.fsPath);H.delete(T.URI.file(X).fsPath)})),await Promise.all(x.map(async W=>{const Q=await this._hostUtils.realpath(W.extensionLocation.fsPath);H.set(T.URI.file(Q).fsPath,W)})),this._registry.deltaExtensions(x,M),Promise.resolve(void 0)}async $test_latency(x){return x}async $test_up(x){return x.byteLength}async $test_down(x){let M=a.VSBuffer.alloc(x),H=Math.random()%256;for(let W=0;W<x;W++)M.writeUInt8(H,W);return M}async $updateRemoteConnectionData(x){this._remoteConnectionData=x,this._onDidChangeRemoteConnectionData.fire()}};U=Ve([We(0,r.IInstantiationService),We(1,e.IHostUtils),We(2,c.IExtHostRpcService),We(3,v.IExtHostWorkspace),We(4,u.IExtHostConfiguration),We(5,n.ILogService),We(6,i.IExtHostInitDataService),We(7,h.IExtensionStoragePaths),We(8,b.IExtHostTunnelService),We(9,y.IExtHostTerminalService)],U),e.AbstractExtHostExtensionService=U;function z(B,x){return{id:B.identifier.value,name:B.name,extensionVersion:B.version,publisherDisplayName:B.publisher,activationEvents:B.activationEvents?B.activationEvents.join(","):null,isBuiltin:B.isBuiltin,reason:x.activationEvent,reasonId:x.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class O{constructor(x,M,H,W){N.set(this,void 0),G.set(this,void 0),K.set(this,void 0),nt(this,N,x,"f"),nt(this,G,M,"f"),nt(this,K,H.identifier,"f"),this.id=H.identifier.value,this.extensionUri=H.extensionLocation,this.extensionPath=L.normalize((0,k.originalFSPath)(H.extensionLocation)),this.packageJSON=H,this.extensionKind=W}get isActive(){return Oe(this,N,"f").isActivated(Oe(this,K,"f"))}get exports(){if(this.packageJSON.api!=="none")return Oe(this,N,"f").getExtensionExports(Oe(this,K,"f"))}activate(){return Oe(this,N,"f").activateByIdWithErrors(Oe(this,K,"f"),{startup:!1,extensionId:Oe(this,G,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=O,N=new WeakMap,G=new WeakMap,K=new WeakMap}),define(me[55],ge([0,1,8,2,3,18,5,7,124,37,40,45,216,38,210,14,4,13,34,54]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,l,v,S,P,E,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,S.createDecorator)("IExtHostDebugService");let a=class{constructor(d,b,y,g,_,w){this._workspaceService=b,this._extensionService=y,this._editorsService=g,this._configurationService=_,this._editorTabs=w,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new I.Emitter,this._onDidTerminateDebugSession=new I.Emitter,this._onDidChangeActiveDebugSession=new I.Emitter,this._onDidReceiveDebugSessionCustomEvent=new I.Emitter,this._debugServiceProxy=d.getProxy(R.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new I.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(F=>{F.onDidChange(N=>{this.registerAllDebugTypes(F)}),this.registerAllDebugTypes(F)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(d,b){const y=d;if(typeof y.sourceReference=="number"&&y.sourceReference>0){let g=`debug:${encodeURIComponent(y.path||"")}`,_="?";return b&&(g+=`${_}session=${encodeURIComponent(b.id)}`,_="&"),g+=`${_}ref=${y.sourceReference}`,L.URI.parse(g)}else{if(y.path)return L.URI.file(y.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(d){const b=[];for(const y of d.getAllExtensionDescriptions())if(y.contributes){const g=y.contributes.debuggers;if(g&&g.length>0)for(const _ of g)(0,l.isDebuggerMainContribution)(_)&&b.push(_.type)}this._debugServiceProxy.$registerDebugTypes(b)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const d=[];return this._breakpoints.forEach(b=>d.push(b)),d}addBreakpoints(d){this.startBreakpoints();const b=d.filter(_=>{const w=_.id;return this._breakpoints.has(w)?!1:(this._breakpoints.set(w,_),!0)});this.fireBreakpointChanges(b,[],[]);const y=[],g=new Map;for(const _ of b)if(_ instanceof C.SourceBreakpoint){let w=g.get(_.location.uri.toString());w||(w={type:"sourceMulti",uri:_.location.uri,lines:[]},g.set(_.location.uri.toString(),w),y.push(w)),w.lines.push({id:_.id,enabled:_.enabled,condition:_.condition,hitCondition:_.hitCondition,logMessage:_.logMessage,line:_.location.range.start.line,character:_.location.range.start.character})}else _ instanceof C.FunctionBreakpoint&&y.push({type:"function",id:_.id,enabled:_.enabled,hitCondition:_.hitCondition,logMessage:_.logMessage,condition:_.condition,functionName:_.functionName});return this._debugServiceProxy.$registerBreakpoints(y)}removeBreakpoints(d){this.startBreakpoints();const b=d.filter(w=>this._breakpoints.delete(w.id));this.fireBreakpointChanges([],b,[]);const y=b.filter(w=>w instanceof C.SourceBreakpoint).map(w=>w.id),g=b.filter(w=>w instanceof C.FunctionBreakpoint).map(w=>w.id),_=b.filter(w=>w instanceof C.DataBreakpoint).map(w=>w.id);return this._debugServiceProxy.$unregisterBreakpoints(y,g,_)}startDebugging(d,b,y){return this._debugServiceProxy.$startDebugging(d?d.uri:void 0,b,{parentSessionID:y.parentSession?y.parentSession.id:void 0,lifecycleManagedByParent:y.lifecycleManagedByParent,repl:y.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:y.noDebug,compact:y.compact,debugUI:y.debugUI,suppressSaveBeforeStart:y.suppressSaveBeforeStart})}stopDebugging(d){return this._debugServiceProxy.$stopDebugging(d?d.id:void 0)}registerDebugConfigurationProvider(d,b,y){if(!b)return new C.Disposable(()=>{});const g=this._configProviderHandleCounter++;return this._configProviders.push({type:d,handle:g,provider:b}),this._debugServiceProxy.$registerDebugConfigurationProvider(d,y,!!b.provideDebugConfigurations,!!b.resolveDebugConfiguration,!!b.resolveDebugConfigurationWithSubstitutedVariables,g),new C.Disposable(()=>{this._configProviders=this._configProviders.filter(_=>_.provider!==b),this._debugServiceProxy.$unregisterDebugConfigurationProvider(g)})}registerDebugAdapterDescriptorFactory(d,b,y){if(!y)return new C.Disposable(()=>{});if(!this.definesDebugType(d,b))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${b}' debugger.`);if(this.getAdapterDescriptorFactoryByType(b))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const g=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:b,handle:g,factory:y}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(b,g),new C.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(_=>_.factory!==y),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(g)})}registerDebugAdapterTrackerFactory(d,b){if(!b)return new C.Disposable(()=>{});const y=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:d,handle:y,factory:b}),new C.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(g=>g.factory!==b)})}async $runInTerminal(d,b){return Promise.resolve(void 0)}async $substituteVariables(d,b){if(!this._variableResolver){const[_,w]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(_||[],this._editorsService,w)}let y;const g=await this.getFolder(d);return g&&(y={uri:g.uri,name:g.name,index:g.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(y,b)}createDebugAdapter(d,b){if(d.type==="implementation")return new i(d.implementation)}createSignService(){}async $startDASession(d,b){const y=this,g=await this.getSession(b);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(g.type),g).then(_=>{if(!_)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}' (extension might have failed to activate)`);const w=this.convertToDto(_),F=this.createDebugAdapter(w,g);if(!F)throw new Error(`Couldn't create a debug adapter for type '${g.type}'.`);const N=F;return this._debugAdapters.set(d,N),this.getDebugAdapterTrackers(g).then(G=>(G&&this._debugAdaptersTrackers.set(d,G),N.onMessage(async K=>{if(K.type==="request"&&K.command==="handshake"){const U=K,z={type:"response",seq:0,command:U.command,request_seq:U.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const O=await this._signService.sign(U.arguments.value);z.body={signature:O},N.sendResponse(z)}else throw new Error("no signer")}catch(O){z.success=!1,z.message=O.message,N.sendResponse(z)}}else G&&G.onDidSendMessage&&G.onDidSendMessage(K),K=(0,l.convertToVSCPaths)(K,!0),y._debugServiceProxy.$acceptDAMessage(d,K)}),N.onError(K=>{G&&G.onError&&G.onError(K),this._debugServiceProxy.$acceptDAError(d,K.name,K.message,K.stack)}),N.onExit(K=>{G&&G.onExit&&G.onExit((0,P.withNullAsUndefined)(K),void 0),this._debugServiceProxy.$acceptDAExit(d,(0,P.withNullAsUndefined)(K),void 0)}),G&&G.onWillStartSession&&G.onWillStartSession(),N.startSession()))})}$sendDAMessage(d,b){b=(0,l.convertToDAPaths)(b,!1);const y=this._debugAdaptersTrackers.get(d);y&&y.onWillReceiveMessage&&y.onWillReceiveMessage(b);const g=this._debugAdapters.get(d);g&&g.sendMessage(b)}$stopDASession(d){const b=this._debugAdaptersTrackers.get(d);this._debugAdaptersTrackers.delete(d),b&&b.onWillStopSession&&b.onWillStopSession();const y=this._debugAdapters.get(d);return this._debugAdapters.delete(d),y?y.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(d){const b=[],y=[],g=[];if(d.added)for(const _ of d.added){const w=_.id;if(w&&!this._breakpoints.has(w)){let F;if(_.type==="function")F=new C.FunctionBreakpoint(_.functionName,_.enabled,_.condition,_.hitCondition,_.logMessage);else if(_.type==="data")F=new C.DataBreakpoint(_.label,_.dataId,_.canPersist,_.enabled,_.hitCondition,_.condition,_.logMessage);else{const N=L.URI.revive(_.uri);F=new C.SourceBreakpoint(new C.Location(N,new C.Position(_.line,_.character)),_.enabled,_.condition,_.hitCondition,_.logMessage)}F._id=w,this._breakpoints.set(w,F),b.push(F)}}if(d.removed)for(const _ of d.removed){const w=this._breakpoints.get(_);w&&(this._breakpoints.delete(_),y.push(w))}if(d.changed){for(const _ of d.changed)if(_.id){const w=this._breakpoints.get(_.id);if(w){if(w instanceof C.FunctionBreakpoint&&_.type==="function"){const F=w;F.enabled=_.enabled,F.condition=_.condition,F.hitCondition=_.hitCondition,F.logMessage=_.logMessage,F.functionName=_.functionName}else if(w instanceof C.SourceBreakpoint&&_.type==="source"){const F=w;F.enabled=_.enabled,F.condition=_.condition,F.hitCondition=_.hitCondition,F.logMessage=_.logMessage,F.location=new C.Location(L.URI.revive(_.uri),new C.Position(_.line,_.character))}g.push(w)}}}this.fireBreakpointChanges(b,y,g)}$provideDebugConfigurations(d,b,y){return(0,k.asPromise)(async()=>{const g=this.getConfigProviderByHandle(d);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const _=await this.getFolder(b);return g.provideDebugConfigurations(_,y)}).then(g=>{if(!g)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return g})}$resolveDebugConfiguration(d,b,y,g){return(0,k.asPromise)(async()=>{const _=this.getConfigProviderByHandle(d);if(!_)throw new Error("no DebugConfigurationProvider found");if(!_.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const w=await this.getFolder(b);return _.resolveDebugConfiguration(w,y,g)})}$resolveDebugConfigurationWithSubstitutedVariables(d,b,y,g){return(0,k.asPromise)(async()=>{const _=this.getConfigProviderByHandle(d);if(!_)throw new Error("no DebugConfigurationProvider found");if(!_.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const w=await this.getFolder(b);return _.resolveDebugConfigurationWithSubstitutedVariables(w,y,g)})}async $provideDebugAdapter(d,b){const y=this.getAdapterDescriptorFactoryByHandle(d);if(!y)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const g=await this.getSession(b);return this.getAdapterDescriptor(y,g).then(_=>{if(!_)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}'`);return this.convertToDto(_)})}async $acceptDebugSessionStarted(d){const b=await this.getSession(d);this._onDidStartDebugSession.fire(b)}async $acceptDebugSessionTerminated(d){const b=await this.getSession(d);b&&(this._onDidTerminateDebugSession.fire(b),this._debugSessions.delete(b.id))}async $acceptDebugSessionActiveChanged(d){this._activeDebugSession=d?await this.getSession(d):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(d,b){const y=await this.getSession(d);y&&y._acceptNameChanged(b)}async $acceptDebugSessionCustomEvent(d,b){const g={session:await this.getSession(d),event:b.event,body:b.body};this._onDidReceiveDebugSessionCustomEvent.fire(g)}convertToDto(d){if(d instanceof C.DebugAdapterExecutable)return{type:"executable",command:d.command,args:d.args,options:d.options};if(d instanceof C.DebugAdapterServer)return{type:"server",port:d.port,host:d.host};if(d instanceof C.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:d.path};if(d instanceof C.DebugAdapterInlineImplementation)return{type:"implementation",implementation:d.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(d){const b=this._adapterFactories.filter(y=>y.type===d);if(b.length>0)return b[0].factory}getAdapterDescriptorFactoryByHandle(d){const b=this._adapterFactories.filter(y=>y.handle===d);if(b.length>0)return b[0].factory}getConfigProviderByHandle(d){const b=this._configProviders.filter(y=>y.handle===d);if(b.length>0)return b[0].provider}definesDebugType(d,b){if(d.contributes){const y=d.contributes.debuggers;if(y&&y.length>0){for(const g of y)if(g.label&&g.type&&g.type===b)return!0}}return!1}getDebugAdapterTrackers(d){const y=d.configuration.type,g=this._trackerFactories.filter(_=>_.type===y||_.type==="*").map(_=>(0,k.asPromise)(()=>_.factory.createDebugAdapterTracker(d)).then(w=>w,w=>null));return Promise.race([Promise.all(g).then(_=>{const w=_.filter(F=>!!F);if(w.length>0)return new r(w)}),new Promise((_,w)=>{const F=setTimeout(()=>{clearTimeout(F),w(new Error("timeout"))},1e3)})]).catch(_=>{})}async getAdapterDescriptor(d,b){const y=b.configuration.debugServer;if(typeof y=="number")return Promise.resolve(new C.DebugAdapterServer(y));if(d){const _=await this._extensionService.getExtensionRegistry();return(0,k.asPromise)(()=>d.createDebugAdapterDescriptor(b,this.daExecutableFromPackage(b,_))).then(w=>{if(w)return w})}const g=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(b,g))}daExecutableFromPackage(d,b){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(d,b,y){(d.length>0||b.length>0||y.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:d,removed:b,changed:y}))}async getSession(d){if(d)if(typeof d=="string"){const b=this._debugSessions.get(d);if(b)return b}else{let b=this._debugSessions.get(d.id);if(!b){const y=await this.getFolder(d.folderUri),g=d.parent?this._debugSessions.get(d.parent):void 0;b=new p(this._debugServiceProxy,d.id,d.type,d.name,y,d.configuration,g),this._debugSessions.set(b.id,b),this._debugServiceProxy.$sessionCached(b.id)}return b}throw new Error("cannot find session")}getFolder(d){if(d){const b=L.URI.revive(d);return this._workspaceService.resolveWorkspaceFolder(b)}return Promise.resolve(void 0)}};a=Ve([We(0,v.IExtHostRpcService),We(1,T.IExtHostWorkspace),We(2,n.IExtHostExtensionService),We(3,A.IExtHostDocumentsAndEditors),We(4,f.IExtHostConfiguration),We(5,s.IExtHostEditorTabs)],a),e.ExtHostDebugServiceBase=a;class p{constructor(d,b,y,g,_,w,F){this._debugServiceProxy=d,this._id=b,this._type=y,this._name=g,this._workspaceFolder=_,this._configuration=w,this._parentSession=F}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(d){this._name=d,this._debugServiceProxy.$setDebugSessionName(this._id,d)}get parentSession(){return this._parentSession}_acceptNameChanged(d){this._name=d}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(d,b){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,d,b)}getDebugProtocolBreakpoint(d){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,d.id)}}e.ExtHostDebugSession=p;class t{constructor(d){this.value=Object.freeze({append(b){d.$appendDebugConsole(b)},appendLine(b){this.append(b+`
`)}})}}e.ExtHostDebugConsole=t;class o extends u.AbstractVariableResolverService{constructor(d,b,y,g,_){function w(){if(b){const F=b.activeEditor();if(F)return F.document.uri;const N=g.tabs.filter(G=>G.isActive);if(N.length>0){const G=N[0].resource;return G&&(G.primary||G.secondary)?G.primary??G.secondary:N[0].resource}}}super({getFolderUri:F=>{const N=d.filter(G=>G.name===F);if(N&&N.length>0)return N[0].uri},getWorkspaceFolderCount:()=>d.length,getConfigurationValue:(F,N)=>y.getConfiguration(void 0,F).get(N),getAppRoot:()=>E.cwd(),getExecPath:()=>E.env.VSCODE_EXEC_PATH,getFilePath:()=>{const F=w();if(F)return m.normalize(F.fsPath)},getWorkspaceFolderPathForFile:()=>{if(_){const F=w();if(F){const N=_.getWorkspaceFolder(F);if(N)return m.normalize(N.uri.fsPath)}}},getSelectedText:()=>{if(b){const F=b.activeEditor();if(F&&!F.selection.isEmpty)return F.document.getText(F.selection)}},getLineNumber:()=>{if(b){const F=b.activeEditor();if(F)return String(F.selection.end.line+1)}}},void 0,Promise.resolve(E.env))}}e.ExtHostVariableResolverService=o;class r{constructor(d){this.trackers=d}onWillStartSession(){this.trackers.forEach(d=>d.onWillStartSession?d.onWillStartSession():void 0)}onWillReceiveMessage(d){this.trackers.forEach(b=>b.onWillReceiveMessage?b.onWillReceiveMessage(d):void 0)}onDidSendMessage(d){this.trackers.forEach(b=>b.onDidSendMessage?b.onDidSendMessage(d):void 0)}onWillStopSession(){this.trackers.forEach(d=>d.onWillStopSession?d.onWillStopSession():void 0)}onError(d){this.trackers.forEach(b=>b.onError?b.onError(d):void 0)}onExit(d,b){this.trackers.forEach(y=>y.onExit?y.onExit(d,b):void 0)}}class i extends D.AbstractDebugAdapter{constructor(d){super();this.implementation=d,d.onDidSendMessage(b=>{this.acceptMessage(b)})}startSession(){return Promise.resolve(void 0)}sendMessage(d){this.implementation.handleMessage(d)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let h=class extends a{constructor(d,b,y,g,_,w){super(d,b,y,g,_,w)}createVariableResolver(d,b,y){return new o(d,b,y,this._editorTabs)}};h=Ve([We(0,v.IExtHostRpcService),We(1,T.IExtHostWorkspace),We(2,n.IExtHostExtensionService),We(3,A.IExtHostDocumentsAndEditors),We(4,f.IExtHostConfiguration),We(5,s.IExtHostEditorTabs)],h),e.WorkerExtHostDebugService=h}),define(me[270],ge([0,1,73,2,5,38,36,26,14,27,4,40,34,12]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let l=class{constructor(s,a,p,t,o,r,i){this._apiFactory=s,this._extensionRegistry=a,this._instaService=p,this._extHostConfiguration=t,this._extHostExtensionService=o,this._initData=r,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),m.mark("code/extHost/willWaitForConfig");const s=await this._extHostConfiguration.getConfigProvider();m.mark("code/extHost/didWaitForConfig");const a=await this._extHostExtensionService.getExtensionPathIndex();this.register(new v(this._apiFactory,a,this._extensionRegistry,s,this._logService)),this.register(this._instaService.createInstance(S)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(P,a,this._initData.environment.appUriScheme))}register(s){if(Array.isArray(s.nodeModuleName))for(let a of s.nodeModuleName)this._factories.set(a,s);else this._factories.set(s.nodeModuleName,s);typeof s.alternativeModuleName=="function"&&this._alternatives.push(a=>s.alternativeModuleName(a))}};l=Ve([We(2,n.IInstantiationService),We(3,k.IExtHostConfiguration),We(4,A.IExtHostExtensionService),We(5,T.IExtHostInitDataService),We(6,f.ILogService)],l),e.RequireInterceptor=l;class v{constructor(s,a,p,t,o){this._apiFactory=s,this._extensionPaths=a,this._extensionRegistry=p,this._configProvider=t,this._logService=o,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(s,a){const p=this._extensionPaths.findSubstr(a.fsPath);if(p){let t=this._extApiImpl.get(C.ExtensionIdentifier.toKey(p.identifier));return t||(t=this._apiFactory(p,this._extensionRegistry,this._configProvider),this._extApiImpl.set(C.ExtensionIdentifier.toKey(p.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((o,r)=>t+=`	${r} -> ${o.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${a.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(R.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let S=class{constructor(s,a){this.nodeModuleName="keytar";const{environment:p}=a,t=s.getProxy(I.MainContext.MainThreadKeytar);if(p.appRoot){let o=p.appRoot.fsPath;u.platform==="win32"&&(o=o.replace(/\\/g,"/")),o[o.length-1]==="/"&&(o=o.substr(0,o.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${o}/node_modules.asar/keytar`),this.alternativeNames.add(`${o}/node_modules/keytar`)}this._impl={getPassword:(o,r)=>t.$getPassword(o,r),setPassword:(o,r,i)=>t.$setPassword(o,r,i),deletePassword:(o,r)=>t.$deletePassword(o,r),findPassword:o=>t.$findPassword(o),findCredentials(o){return t.$findCredentials(o)}}}load(s,a){return this._impl}alternativeModuleName(s){const a=s.length;if(a<=7||!this.alternativeNames)return;const p=a-7;if((s.charAt(p)==="/"||s.charAt(p)==="\\")&&s.endsWith("keytar")&&(s=s.replace(/\\/g,"/"),this.alternativeNames.has(s)))return"keytar"}};S=Ve([We(0,D.IExtHostRpcService),We(1,T.IExtHostInitDataService)],S);let P=class{constructor(s,a,p){this._extensionPaths=s,this._appUriScheme=a,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=p.getProxy(I.MainContext.MainThreadTelemetry);const t=p.getProxy(I.MainContext.MainThreadWindow);this._impl=(o,r)=>{const i=L.URI.parse(o);return r?this.callOriginal(o,r):i.scheme==="http"||i.scheme==="https"?t.$openUri(i,o,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?t.$openUri(i,o,{}):this.callOriginal(o,r)}}load(s,a,p){const t=this._extensionPaths.findSubstr(a.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=p(s),this._impl}callOriginal(s,a){return this.sendNoForwardTelemetry(),this._original(s,a)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};P=Ve([We(2,D.IExtHostRpcService)],P)}),define(me[271],ge([0,1,170,11,7,211,37,40,45,38,33,14,55,194,18,212,54]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,l,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let P=class extends u.ExtHostDebugServiceBase{constructor(a,p,t,o,r,i,h){super(a,p,t,o,r,h);this._terminalService=i,this._integratedTerminalInstances=new E}createDebugAdapter(a,p){switch(a.type){case"server":return new k.SocketDebugAdapter(a);case"pipeServer":return new k.NamedPipeDebugAdapter(a);case"executable":return new k.ExecutableDebugAdapter(a,p.type)}return super.createDebugAdapter(a,p)}daExecutableFromPackage(a,p){const t=k.ExecutableDebugAdapter.platformAdapterExecutable(p.getAllExtensionDescriptions(),a.type);if(t)return new I.DebugAdapterExecutable(t.command,t.args,t.options)}createSignService(){return new f.SignService}async $runInTerminal(a,p){if(a.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(w=>{this._integratedTerminalInstances.onTerminalClosed(w)}));const t=await this._configurationService.getConfigProvider(),o=this._terminalService.getDefaultShell(!0),r=this._terminalService.getDefaultShellArgs(!0),i=a.title||m.localize(0,null),h=JSON.stringify({shell:o,shellArgs:r});let c=await this._integratedTerminalInstances.checkout(h,i),d,b=!1;if(c)d=a.cwd;else{const w={shellPath:o,shellArgs:r,cwd:a.cwd,name:i,iconPath:new I.ThemeIcon("debug")};b=!0,c=this._terminalService.createTerminalFromOptions(w,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(c,h)}c.show(!0);const y=await c.processId;b?await new Promise(w=>setTimeout(w,1e3)):t.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(o.indexOf("powershell")>=0||o.indexOf("pwsh")>=0||o.indexOf("cmd.exe")>=0?c.sendText("cls"):o.indexOf("bash")>=0?c.sendText("clear"):L.isWindows?c.sendText("cls"):c.sendText("clear"));const g=(0,v.prepareCommand)(o,a.args,d,a.env);c.sendText(g);const _=this.onDidTerminateDebugSession(w=>{w.id===p&&(this._integratedTerminalInstances.free(c),_.dispose())});return y}else if(a.kind==="external")return(0,v.runInExternalTerminal)(a,await this._configurationService.getConfigProvider());return super.$runInTerminal(a,p)}createVariableResolver(a,p,t){return new u.ExtHostVariableResolverService(a,p,t,this._editorTabs,this._workspaceService)}};P=Ve([We(0,A.IExtHostRpcService),We(1,R.IExtHostWorkspace),We(2,C.IExtHostExtensionService),We(3,D.IExtHostDocumentsAndEditors),We(4,T.IExtHostConfiguration),We(5,n.IExtHostTerminalService),We(6,S.IExtHostEditorTabs)],P),e.ExtHostDebugService=P;class E{constructor(){this._terminalInstances=new Map}async checkout(a,p){const o=[...this._terminalInstances.entries()].map(([r,i])=>(0,l.createCancelablePromise)(async h=>{if(r.name!==p||i.lastUsedAt!==-1&&await(0,v.hasChildProcesses)(await r.processId))return null;const c=Date.now();return i.lastUsedAt+E.minUseDelay>c||h.isCancellationRequested||i.config!==a?null:(i.lastUsedAt=c,r)}));return await(0,l.firstParallel)(o,r=>!!r)}insert(a,p){this._terminalInstances.set(a,{lastUsedAt:Date.now(),config:p})}free(a){const p=this._terminalInstances.get(a);p&&(p.lastUsedAt=-1)}onTerminalClosed(a){this._terminalInstances.delete(a)}}E.minUseDelay=1e3}),define(me[272],ge([0,1,8,2,113,37,55,45,38,43,33,14,27,72,10,12,67,54,22,80]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,l,v,S,P,E,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let a=class extends f.ExtHostTaskBase{constructor(t,o,r,i,h,c,d,b,y){super(t,o,r,i,h,c,d,b);this.workspaceService=r,this.editorTabs=y,o.remote.isRemote&&o.remote.authority?this.registerTaskSystem(l.Schemas.vscodeRemote,{scheme:l.Schemas.vscodeRemote,authority:o.remote.authority,platform:process.platform}):this.registerTaskSystem(l.Schemas.file,{scheme:l.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(t,o){const r=o;if(!o.execution&&r._id===void 0)throw new Error("Tasks to execute must include an execution");if(r._id!==void 0){const i=f.TaskHandleDTO.from(r,this.workspaceService),h=await this._proxy.$getTaskExecution(i);if(h.task===void 0)throw new Error("Task from execution DTO is undefined");const c=await this.getTaskExecution(h,o);return this._proxy.$executeTask(i).catch(()=>{}),c}else{const i=f.TaskDTO.from(o,t);if(i===void 0)return Promise.reject(new Error("Task is not valid"));f.CustomExecutionDTO.is(i.execution)&&await this.addCustomExecution(i,o,!1);const h=await this.getTaskExecution(await this._proxy.$getTaskExecution(i),o);return this._proxy.$executeTask(i).catch(()=>{}),h}}provideTasksInternal(t,o,r,i){const h=[];if(i)for(let c of i){this.checkDeprecation(c,r),(!c.definition||!t[c.definition.type])&&this._logService.warn(`The task [${c.source}, ${c.name}] uses an undefined task type. The task will be ignored in the future.`);const d=f.TaskDTO.from(c,r.extension);d&&(h.push(d),f.CustomExecutionDTO.is(d.execution)&&o.push(this.addCustomExecution(d,c,!0)))}return{tasks:h,extension:r.extension}}async resolveTaskInternal(t){return t}async getVariableResolver(t){if(this._variableResolver===void 0){const o=await this._configurationService.getConfigProvider();this._variableResolver=new R.ExtHostVariableResolverService(t,this._editorService,o,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(t){let o=t&&t.length>0?t[0]:void 0;if(!o){const r=L.URI.file((0,s.homedir)());o=new T.WorkspaceFolder({uri:r,name:E.basename(r),index:0})}return{uri:o.uri,name:o.name,index:o.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(t,o){const r=L.URI.revive(t),i={process:void 0,variables:Object.create(null)},h=await this._workspaceProvider.resolveWorkspaceFolder(r),c=await this._workspaceProvider.getWorkspaceFolders2()??[],d=await this.getVariableResolver(c),b=h?{uri:h.uri,name:h.name,index:h.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(c);for(let y of o.variables)i.variables[y]=await d.resolveAsync(b,y);if(o.process!==void 0){let y;if(o.process.path!==void 0){y=o.process.path.split(m.delimiter);for(let g=0;g<y.length;g++)y[g]=await d.resolveAsync(b,y[g])}i.process=await I.win32.findExecutable(await d.resolveAsync(b,o.process.name),o.process.cwd!==void 0?await d.resolveAsync(b,o.process.cwd):void 0,y)}return i}async $jsonTasksSupported(){return!0}async $findExecutable(t,o,r){return I.win32.findExecutable(t,o,r)}};a=Ve([We(0,A.IExtHostRpcService),We(1,u.IExtHostInitDataService),We(2,k.IExtHostWorkspace),We(3,C.IExtHostDocumentsAndEditors),We(4,D.IExtHostConfiguration),We(5,n.IExtHostTerminalService),We(6,v.ILogService),We(7,S.IExtHostApiDeprecationService),We(8,P.IExtHostEditorTabs)],a),e.ExtHostTask=a}),define(me[273],ge([0,1,18,16,73,6,2,5,265,12,82,84,27,188,14,65,40,33]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,l,v,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class E{constructor(a,p,t,o){this._disposables=new k.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new D.RPCProtocol(a,null,o),p=E._transform(p,this._rpcProtocol);const r=new A.ServiceCollection(...(0,n.getSingletonServiceDescriptors)());r.set(u.IExtHostInitDataService,{_serviceBrand:void 0,...p}),r.set(l.IExtHostRpcService,new l.ExtHostRpcService(this._rpcProtocol)),r.set(v.IURITransformerService,new v.URITransformerService(o)),r.set(S.IHostUtils,t);const i=new f.InstantiationService(r,!0),h=i.invokeFunction(y=>y.get(P.IExtHostTerminalService));this._disposables.add(h),this._logService=i.invokeFunction(y=>y.get(T.ILogService)),I.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",p),this._extensionService=i.invokeFunction(y=>y.get(S.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const c=new WeakMap;this._extensionService.getExtensionPathIndex().then(y=>{Error.prepareStackTrace=(g,_)=>{let w="",F,N;for(const G of _)w+=`
	at ${G.toString()}`,N=G.getFileName(),!F&&N&&(F=y.findSubstr(N));return c.set(g,F),`${g.name||"Error"}: ${g.message||""}${w}`}});const d=this._rpcProtocol.getProxy(C.MainContext.MainThreadExtensionService),b=this._rpcProtocol.getProxy(C.MainContext.MainThreadErrors);L.setUnexpectedErrorHandler(y=>{const g=L.transformErrorForSerialization(y),_=c.get(y);_?d.$onExtensionRuntimeError(_.identifier,g):b.$onUnexpectedError(g)})}terminate(a){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${a}`),this._logService.flush(),this._disposables.dispose(),L.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const p=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,m.timeout)(4e3),p]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(a,p){a.extensions.forEach(o=>o.extensionLocation=R.URI.revive(p.transformIncomingURIs(o.extensionLocation))),a.environment.appRoot=R.URI.revive(p.transformIncomingURIs(a.environment.appRoot));const t=a.environment.extensionDevelopmentLocationURI;return t&&(a.environment.extensionDevelopmentLocationURI=t.map(o=>R.URI.revive(p.transformIncomingURIs(o)))),a.environment.extensionTestsLocationURI=R.URI.revive(p.transformIncomingURIs(a.environment.extensionTestsLocationURI)),a.environment.globalStorageHome=R.URI.revive(p.transformIncomingURIs(a.environment.globalStorageHome)),a.environment.workspaceStorageHome=R.URI.revive(p.transformIncomingURIs(a.environment.workspaceStorageHome)),a.logsLocation=R.URI.revive(p.transformIncomingURIs(a.logsLocation)),a.logFile=R.URI.revive(p.transformIncomingURIs(a.logFile)),a.workspace=p.transformIncomingURIs(a.workspace),a}}e.ExtensionHostMain=E}),define(me[274],ge([0,1,8,21,61,30,22,46,31]),function(J,e,m,L,I,k,R,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class T{constructor(u,f,l){this.config=u,this.provider=f,this.sessionToken=l,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=u.filePattern,this.includePattern=u.includePattern&&k.parse(u.includePattern),this.maxResults=u.maxResults||void 0,this.exists=u.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=u.excludePattern&&k.parse(u.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(u=>u.cancel()),this.activeCancellationTokens=new Set}search(u){const f=this.config.folderQueries||[];return new Promise((l,v)=>{const S=P=>{this.resultCount++,u(P)};if(this.isCanceled)return l({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(P=>{const E=P.toString(),s=m.basename(E);this.globalExcludePattern&&this.globalExcludePattern(E,s)||this.matchFile(S,{base:P,basename:s})}),Promise.all(f.map(P=>this.searchInFolder(P,S))).then(P=>{l({limitHit:this.isLimitHit,stats:P[0]||void 0})},P=>{v(new Error((0,I.toErrorMessage)(P)))})})}async searchInFolder(u,f){const l=new L.CancellationTokenSource,v=this.getSearchOptionsForFolder(u),S=this.initDirectoryTree(),P=new D.QueryGlobTester(this.config,u),E=!P.hasSiblingExcludeClauses();let s;try{this.activeCancellationTokens.add(l),s=C.StopWatch.create();const a=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},v,l.token),p=s.elapsed(),t=C.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(a&&a.forEach(o=>{const r=m.posix.relative(u.folder.path,o.path);if(E){const i=m.basename(o.path);this.matchFile(f,{base:u.folder,relativePath:r,basename:i});return}this.addDirectoryEntries(S,u.folder,r,f)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(S,P,f),{providerTime:p,postProcessTime:t.elapsed()})}finally{l.dispose(),this.activeCancellationTokens.delete(l)}}getSearchOptionsForFolder(u){const f=(0,D.resolvePatternsForProvider)(this.config.includePattern,u.includePattern),l=(0,D.resolvePatternsForProvider)(this.config.excludePattern,u.excludePattern);return{folder:u.folder,excludes:l,includes:f,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}addDirectoryEntries({pathToEntries:u},f,l,v){if(l===this.filePattern){const P=m.basename(this.filePattern);this.matchFile(v,{base:f,relativePath:this.filePattern,basename:P})}function S(P){const E=m.basename(P),s=m.dirname(P);let a=u[s];a||(a=u[s]=[],S(s)),a.push({base:f,relativePath:P,basename:E})}S(l)}matchDirectoryTree({rootEntries:u,pathToEntries:f},l,v){const S=this,P=this.filePattern;function E(s){const a=k.hasSiblingFn(()=>s.map(p=>p.basename));for(let p=0,t=s.length;p<t;p++){const o=s[p],{relativePath:r,basename:i}=o;if(!l.includedInQuerySync(r,i,P!==i?a:void 0))continue;const h=f[r];if(h)E(h);else{if(r===P)continue;S.matchFile(v,o)}if(S.isLimitHit)break}}E(u)}matchFile(u,f){(!this.includePattern||f.relativePath&&this.includePattern(f.relativePath,f.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||u(f))}}class n{constructor(){this.sessions=new Map}fileSearch(u,f,l,v){const S=this.getSessionTokenSource(u.cacheKey),P=new T(u,f,S&&S.token);let E=0;const s=a=>{E+=a.length,l(a.map(p=>this.rawMatchToSearchItem(p)))};return this.doSearch(P,n.BATCH_SIZE,s,v).then(a=>({limitHit:a.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:E,detailStats:a.stats}}))}clearCache(u){const f=this.getSessionTokenSource(u);f&&f.cancel()}getSessionTokenSource(u){if(!!u)return this.sessions.has(u)||this.sessions.set(u,new L.CancellationTokenSource),this.sessions.get(u)}rawMatchToSearchItem(u){return u.relativePath?{resource:R.joinPath(u.base,u.relativePath)}:{resource:u.base}}doSearch(u,f,l,v){v.onCancellationRequested(()=>{u.cancel()});const S=E=>{E&&(P.push(E),f>0&&P.length>=f&&(l(P),P=[]))};let P=[];return u.search(S).then(E=>(P.length&&l(P),E),E=>(P.length&&l(P),Promise.reject(E)))}}e.FileSearchManager=n,n.BATCH_SIZE=512}),define(me[133],ge([0,1,17,21,61,30,10,8,22,13,2,31]),function(J,e,m,L,I,k,R,C,D,T,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class u{constructor(s,a,p,t){this.query=s,this.provider=a,this.fileUtils=p,this.processType=t,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(s,a){const p=this.query.folderQueries||[],t=new L.CancellationTokenSource;return a.onCancellationRequested(()=>t.cancel()),new Promise((o,r)=>{this.collector=new l(s);let i=!1;const h=(c,d)=>{if(!i&&!this.isLimitHit){const b=this.resultSize(c);S(c)&&typeof this.query.maxResults=="number"&&this.resultCount+b>this.query.maxResults&&(this.isLimitHit=!0,i=!0,t.cancel(),c=this.trimResultToSize(c,this.query.maxResults-this.resultCount));const y=this.resultSize(c);this.resultCount+=y,(y>0||!S(c))&&this.collector.add(c,d)}};Promise.all(p.map((c,d)=>this.searchInFolder(c,b=>h(b,d),t.token))).then(c=>{t.dispose(),this.collector.flush();const d=c.some(b=>!!b&&!!b.limitHit);o({limitHit:this.isLimitHit||d,messages:(0,m.flatten)(c.map(b=>b?.message?(0,T.isArray)(b.message)?b.message:[b.message]:[])),stats:{type:this.processType}})},c=>{t.dispose();const d=(0,I.toErrorMessage)(c);r(new Error(d))})})}resultSize(s){return S(s)?Array.isArray(s.ranges)?s.ranges.length:1:0}trimResultToSize(s,a){const p=Array.isArray(s.ranges)?s.ranges:[s.ranges],t=Array.isArray(s.preview.matches)?s.preview.matches:[s.preview.matches];return{ranges:p.slice(0,a),preview:{matches:t.slice(0,a),text:s.preview.text},uri:s.uri}}async searchInFolder(s,a,p){const t=new A.QueryGlobTester(this.query,s),o=[],r={report:c=>{if(!this.validateProviderResult(c))return;const d=s.folder.scheme===R.Schemas.file?k.hasSiblingPromiseFn(()=>this.fileUtils.readdir(D.dirname(c.uri))):void 0,b=D.relativePath(s.folder,c.uri);if(b){const y=t.includedInQuery(b,C.basename(b),d);(0,T.isPromise)(y)?o.push(y.then(g=>{g&&a(c)})):y&&a(c)}}},i=this.getSearchOptionsForFolder(s),h=await this.provider.provideTextSearchResults(f(this.query.contentPattern),i,r,p);return o.length&&await Promise.all(o),h}validateProviderResult(s){if(S(s)){if(Array.isArray(s.ranges)){if(!Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(s.preview.matches.length!==s.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(s){const a=(0,A.resolvePatternsForProvider)(this.query.includePattern,s.includePattern),p=(0,A.resolvePatternsForProvider)(this.query.excludePattern,s.excludePattern),t={folder:n.URI.from(s.folder),excludes:p,includes:a,useIgnoreFiles:!s.disregardIgnoreFiles,useGlobalIgnoreFiles:!s.disregardGlobalIgnoreFiles,followSymlinks:!s.ignoreSymlinks,encoding:s.fileEncoding&&this.fileUtils.toCanonicalName(s.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=u;function f(E){return{isCaseSensitive:E.isCaseSensitive||!1,isRegExp:E.isRegExp||!1,isWordMatch:E.isWordMatch||!1,isMultiline:E.isMultiline||!1,pattern:E.pattern}}class l{constructor(s){this._onResult=s,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new P(512,a=>this.sendItems(a))}add(s,a){this._currentFileMatch&&(this._currentFolderIdx!==a||!D.isEqual(this._currentUri,s.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=a,this._currentFileMatch={resource:s.uri,results:[]}),this._currentFileMatch.results.push(v(s))}pushToCollector(){const s=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,s)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(s){this._onResult(s)}}e.TextSearchResultsCollector=l;function v(E){return S(E)?{preview:{matches:(0,m.mapArrayOrNot)(E.preview.matches,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character})),text:E.preview.text},ranges:(0,m.mapArrayOrNot)(E.ranges,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character}))}:{text:E.text,lineNumber:E.lineNumber}}function S(E){return!!E.preview}e.extensionResultIsMatch=S;class P{constructor(s,a){this.maxBatchSize=s,this.cb=a,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(s,a){!s||this.addItemToBatch(s,a)}addItems(s,a){!s||this.addItemsToBatch(s,a)}addItemToBatch(s,a){this.batch.push(s),this.batchSize+=a,this.onUpdate()}addItemsToBatch(s,a){this.batch=this.batch.concat(s),this.batchSize+=a,this.onUpdate()}onUpdate(){this.totalNumberCompleted<P.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},P.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=P,P.TIMEOUT=4e3,P.START_BATCH_AFTER_COUNT=50}),define(me[74],ge([0,1,6,5,4,274,14,65,12,2,133]),function(J,e,m,L,I,k,R,C,D,T,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,I.createDecorator)("IExtHostSearch");let A=class{constructor(v,S,P){this.extHostRpc=v,this._uriTransformer=S,this._logService=P,this._proxy=this.extHostRpc.getProxy(L.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new k.FileSearchManager}_transformScheme(v){return this._uriTransformer.transformOutgoingScheme(v)}registerTextSearchProvider(v,S){if(this._textSearchUsedSchemes.has(v))throw new Error(`a text search provider for the scheme '${v}' is already registered`);this._textSearchUsedSchemes.add(v);const P=this._handlePool++;return this._textSearchProvider.set(P,S),this._proxy.$registerTextSearchProvider(P,this._transformScheme(v)),(0,m.toDisposable)(()=>{this._textSearchUsedSchemes.delete(v),this._textSearchProvider.delete(P),this._proxy.$unregisterProvider(P)})}registerFileSearchProvider(v,S){if(this._fileSearchUsedSchemes.has(v))throw new Error(`a file search provider for the scheme '${v}' is already registered`);this._fileSearchUsedSchemes.add(v);const P=this._handlePool++;return this._fileSearchProvider.set(P,S),this._proxy.$registerFileSearchProvider(P,this._transformScheme(v)),(0,m.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(v),this._fileSearchProvider.delete(P),this._proxy.$unregisterProvider(P)})}$provideFileSearchResults(v,S,P,E){const s=u(P),a=this._fileSearchProvider.get(v);if(a)return this._fileSearchManager.fileSearch(s,a,p=>{this._proxy.$handleFileMatch(v,S,p.map(t=>t.resource))},E);throw new Error("unknown provider: "+v)}$clearCache(v){return this._fileSearchManager.clearCache(v),Promise.resolve(void 0)}$provideTextSearchResults(v,S,P,E){const s=this._textSearchProvider.get(v);if(!s||!s.provideTextSearchResults)throw new Error(`Unknown provider ${v}`);const a=u(P);return this.createTextSearchManager(a,s).search(t=>this._proxy.$handleTextMatch(v,S,t),E)}$enableExtensionHostSearch(){}createTextSearchManager(v,S){return new n.TextSearchManager(v,S,{readdir:P=>Promise.resolve([]),toCanonicalName:P=>P},"textSearchProvider")}};A=Ve([We(0,R.IExtHostRpcService),We(1,C.IURITransformerService),We(2,D.ILogService)],A),e.ExtHostSearch=A;function u(l){return{...l,folderQueries:l.folderQueries&&l.folderQueries.map(f),extraFileResources:l.extraFileResources&&l.extraFileResources.map(v=>T.URI.revive(v))}}e.reviveQuery=u;function f(l){return{...l,folder:T.URI.revive(l.folder)}}}),define(me[275],ge([0,1,21,16,3,49,2,114,109,146,81,42,5,233,232,44,234,38,235,236,237,218,238,45,40,239,219,242,243,244,68,221,249,250,251,92,33,253,222,15,7,256,70,132,37,36,57,207,241,86,131,72,55,74,12,65,14,27,245,204,53,67,230,254,203,69,91,259,257,258,231,52,252,255,90,54,122,247,71,248,10,190,246,201,240]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,l,v,S,P,E,s,a,p,t,o,r,i,h,c,d,b,y,g,_,w,F,N,G,K,U,z,O,B,x,M,H,W,Q,X,he,_e,ye,Re,$e,Be,je,V,ee,re,ae,Y,oe,ve,Me,qe,Ke,Se,tt,Z,te,pe,xe,Je,rt,ft,pt,St,Ct,ue,Ie,Ue,Qe,ze,at,Le,De){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function ke(ne){const de=ne.get(re.IExtHostInitDataService),be=ne.get(Je.IExtHostFileSystemInfo),we=ne.get(tt.IExtHostConsumerFileSystem),Fe=ne.get(r.IExtHostExtensionService),Ge=ne.get(H.IExtHostWorkspace),He=ne.get(Ct.IExtHostTelemetry),Ye=ne.get(P.IExtHostConfiguration),it=ne.get(V.IURITransformerService),le=ne.get(ee.IExtHostRpcService),Ee=ne.get(N.IExtHostStorage),ce=ne.get(Se.IExtensionStoragePaths),q=ne.get(je.ILogService),Ae=ne.get(oe.IExtHostTunnelService),Pe=ne.get(ve.IExtHostApiDeprecationService),Ze=ne.get(M.IExtHostWindow),Xe=ne.get(pt.IExtHostSecretState),ot=ne.get(St.IExtHostEditorTabs);le.set(u.ExtHostContext.ExtHostFileSystemInfo,be),le.set(u.ExtHostContext.ExtHostLogService,q),le.set(u.ExtHostContext.ExtHostWorkspace,Ge),le.set(u.ExtHostContext.ExtHostConfiguration,Ye),le.set(u.ExtHostContext.ExtHostExtensionService,Fe),le.set(u.ExtHostContext.ExtHostStorage,Ee),le.set(u.ExtHostContext.ExtHostTunnelService,Ae),le.set(u.ExtHostContext.ExtHostWindow,Ze),le.set(u.ExtHostContext.ExtHostSecretState,Xe),le.set(u.ExtHostContext.ExtHostTelemetry,He),le.set(u.ExtHostContext.ExtHostEditorTabs,ot);const vt=le.set(u.ExtHostContext.ExtHostDecorations,ne.get(ye.IExtHostDecorations)),Et=le.set(u.ExtHostContext.ExtHostDocumentsAndEditors,ne.get(o.IExtHostDocumentsAndEditors)),lt=le.set(u.ExtHostContext.ExtHostCommands,ne.get(v.IExtHostCommands)),dt=le.set(u.ExtHostContext.ExtHostTerminalService,ne.get(G.IExtHostTerminalService)),mt=le.set(u.ExtHostContext.ExtHostDebugService,ne.get($e.IExtHostDebugService)),Rt=le.set(u.ExtHostContext.ExtHostSearch,ne.get(Be.IExtHostSearch)),yt=le.set(u.ExtHostContext.ExtHostTask,ne.get(Re.IExtHostTask)),Ot=le.set(u.ExtHostContext.ExtHostOutputService,ne.get(y.IExtHostOutputService)),hn=le.set(u.ExtHostContext.ExtHostUrls,new B.ExtHostUrls(le)),It=le.set(u.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(le,Et)),$t=le.set(u.ExtHostContext.ExtHostDocumentContentProviders,new a.ExtHostDocumentContentProvider(le,Et,q)),Zt=le.set(u.ExtHostContext.ExtHostDocumentSaveParticipant,new p.ExtHostDocumentSaveParticipant(q,It,le.getProxy(u.MainContext.MainThreadBulkEdits))),wt=le.set(u.ExtHostContext.ExtHostNotebook,new ae.ExtHostNotebookController(le,lt,Et,It,ce)),Kt=le.set(u.ExtHostContext.ExtHostNotebookDocuments,new Le.ExtHostNotebookDocuments(q,wt)),Vt=le.set(u.ExtHostContext.ExtHostNotebookEditors,new at.ExtHostNotebookEditors(q,le,wt)),en=le.set(u.ExtHostContext.ExtHostNotebookKernels,new ue.ExtHostNotebookKernels(le,de,wt,q)),tn=le.set(u.ExtHostContext.ExtHostNotebookRenderers,new Ue.ExtHostNotebookRenderers(le,wt)),Pt=le.set(u.ExtHostContext.ExtHostEditors,new K.ExtHostEditors(le,Et)),Qt=le.set(u.ExtHostContext.ExtHostTreeViews,new U.ExtHostTreeViews(le.getProxy(u.MainContext.MainThreadTreeViews),lt,q)),bn=le.set(u.ExtHostContext.ExtHostEditorInsets,new X.ExtHostEditorInsets(le.getProxy(u.MainContext.MainThreadEditorInsets),Pt,de)),Wt=le.set(u.ExtHostContext.ExtHostDiagnostics,new E.ExtHostDiagnostics(le,q,be)),Ht=le.set(u.ExtHostContext.ExtHostLanguages,new d.ExtHostLanguages(le,It,lt.converter)),gt=le.set(u.ExtHostContext.ExtHostLanguageFeatures,new c.ExtHostLanguageFeatures(le,it,It,lt,Wt,q,Pe)),nn=le.set(u.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(le,gt)),Nt=le.set(u.ExtHostContext.ExtHostFileSystemEventService,new h.ExtHostFileSystemEventService(le,q,Et)),Ut=le.set(u.ExtHostContext.ExtHostQuickOpen,(0,_.createExtHostQuickOpen)(le,Ge,lt)),Xt=le.set(u.ExtHostContext.ExtHostSCM,new w.ExtHostSCM(le,lt,q)),En=le.set(u.ExtHostContext.ExtHostComments,(0,S.createExtHostComments)(le,lt,It)),fn=le.set(u.ExtHostContext.ExtHostProgress,new g.ExtHostProgress(le.getProxy(u.MainContext.MainThreadProgress))),_n=le.set(u.ExtHostContext.ExtHosLabelService,new he.ExtHostLabelService(le)),mn=le.set(u.ExtHostContext.ExtHostTheming,new Y.ExtHostTheming(le)),rn=le.set(u.ExtHostContext.ExtHostAuthentication,new Me.ExtHostAuthentication(le)),sn=le.set(u.ExtHostContext.ExtHostTimeline,new qe.ExtHostTimeline(le,lt)),jt=le.set(u.ExtHostContext.ExtHostWebviews,new x.ExtHostWebviews(le,{remote:de.remote},Ge,q,Pe)),on=le.set(u.ExtHostContext.ExtHostWebviewPanels,new pe.ExtHostWebviewPanels(le,jt,Ge)),Sn=le.set(u.ExtHostContext.ExtHostCustomEditors,new te.ExtHostCustomEditors(le,It,ce,jt,on)),yn=le.set(u.ExtHostContext.ExtHostWebviewViews,new Z.ExtHostWebviewViews(le,jt)),qt=le.set(u.ExtHostContext.ExtHostTesting,new rt.ExtHostTesting(le,lt)),Jt=le.set(u.ExtHostContext.ExtHostUriOpeners,new ft.ExtHostUriOpeners(le));le.set(u.ExtHostContext.ExtHostInteractive,new De.ExtHostInteractive(le,wt,Et,lt));const Dn=(0,Q.values)(u.ExtHostContext);le.assertRegistered(Dn);const Cn=new xe.ExtHostBulkEdits(le,Et),an=new l.ExtHostClipboard(le),ln=new b.ExtHostMessageService(le,q),zt=new s.ExtHostDialogs(le),Ft=new F.ExtHostStatusBar(le,lt.converter);return f.ExtHostApiCommands.register(lt),function(Ne,Tt,Gt){const bt=function(){let ie=!Ne.isUnderDevelopment;function fe(Te){ie||(q.info(`Extension '${Ne.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ie=!0)}return function Te(ct){if(Array.isArray(ct))ct.forEach(Te);else if(typeof ct=="string")fe(ct);else{const _t=ct;typeof _t.scheme=="undefined"&&fe(ct),!Ne.enableProposedApi&&typeof _t.exclusive=="boolean"&&(0,W.throwProposedApiError)(Ne)}return ct}}(),kn={getSession(ie,fe,Te){return Te?.forceNewSession&&(0,W.checkProposedApiEnabled)(Ne),rn.getSession(Ne,ie,fe,Te)},get onDidChangeSessions(){return rn.onDidChangeSessions},registerAuthenticationProvider(ie,fe,Te,ct){return rn.registerAuthenticationProvider(ie,fe,Te,ct)}},In={registerCommand(ie,fe,Te){return lt.registerCommand(!0,ie,fe,Te)},registerTextEditorCommand(ie,fe,Te){return lt.registerCommand(!0,ie,(...ct)=>{const _t=Pt.getActiveTextEditor();if(!_t){q.warn("Cannot execute "+ie+" because there is no active text editor.");return}return _t.edit(kt=>{fe.apply(Te,[_t,kt,...ct])}).then(kt=>{kt||q.warn("Edits from command "+ie+" were not applied.")},kt=>{q.warn("An error occurred while running command "+ie,kt)})})},registerDiffInformationCommand:(ie,fe,Te)=>((0,W.checkProposedApiEnabled)(Ne),lt.registerCommand(!0,ie,async(...ct)=>{const _t=Et.activeEditor(!0);if(!_t){q.warn("Cannot execute "+ie+" because there is no active text editor.");return}const kt=await Pt.getDiffInformation(_t.id);fe.apply(Te,[kt,...ct])})),executeCommand(ie,...fe){return lt.executeCommand(ie,...fe)},getCommands(ie=!1){return lt.getCommands(ie)}},gn={get machineId(){return de.telemetryInfo.machineId},get sessionId(){return de.telemetryInfo.sessionId},get language(){return de.environment.appLanguage},get appName(){return de.environment.appName},get appRoot(){return de.environment.appRoot?.fsPath??""},get appHost(){return de.environment.appHost},get uriScheme(){return de.environment.appUriScheme},get clipboard(){return an.value},get shell(){return dt.getDefaultShell(!1)},get isTelemetryEnabled(){return He.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return He.onDidChangeTelemetryEnabled},get isNewAppInstall(){const ie=Date.now()-new Date(de.telemetryInfo.firstSessionDate).getTime();return isNaN(ie)?!1:ie<1e3*60*60*24},openExternal(ie,fe){return Ze.openUri(ie,{allowTunneling:!!de.remote.authority,allowContributedOpeners:fe?.allowContributedOpeners})},async asExternalUri(ie){if(ie.scheme===de.environment.appUriScheme)return hn.createAppUri(ie);try{return await Ze.asExternalUri(ie,{allowTunneling:!!de.remote.authority})}catch(fe){if((0,ze.matchesScheme)(ie,Qe.Schemas.http)||(0,ze.matchesScheme)(ie,Qe.Schemas.https))return ie;throw fe}},get remoteName(){return(0,_e.getRemoteName)(de.remote.authority)},get uiKind(){return de.uiKind}};de.environment.extensionTestsLocationURI||Object.freeze(gn);const pn=de.remote.isRemote?O.ExtensionKind.Workspace:O.ExtensionKind.UI,Pn={createTestController(ie,fe){return qt.createTestController(ie,fe)},createTestObserver(){return(0,W.checkProposedApiEnabled)(Ne),qt.createTestObserver()},runTests(ie){return(0,W.checkProposedApiEnabled)(Ne),qt.runTests(ie)},get onDidChangeTestResults(){return(0,W.checkProposedApiEnabled)(Ne),qt.onResultsChanged},get testResults(){return(0,W.checkProposedApiEnabled)(Ne),qt.results}},An={getExtension(ie){const fe=Tt.getExtensionDescription(ie);if(fe)return new r.Extension(Fe,Ne.identifier,fe,pn)},get all(){return Tt.getAllExtensionDescriptions().map(ie=>new r.Extension(Fe,Ne.identifier,ie,pn))},get onDidChange(){return Tt.onDidChange}},cn={createDiagnosticCollection(ie){return Wt.createDiagnosticCollection(Ne.identifier,ie)},get onDidChangeDiagnostics(){return Wt.onDidChangeDiagnostics},getDiagnostics:ie=>Wt.getDiagnostics(ie),getLanguages(){return Ht.getLanguages()},setTextDocumentLanguage(ie,fe){return Ht.changeLanguage(ie.uri,fe)},match(ie,fe){return(0,n.score)(z.LanguageSelector.from(ie),fe.uri,fe.languageId,!0)},registerCodeActionsProvider(ie,fe,Te){return gt.registerCodeActionProvider(Ne,bt(ie),fe,Te)},registerCodeLensProvider(ie,fe){return gt.registerCodeLensProvider(Ne,bt(ie),fe)},registerDefinitionProvider(ie,fe){return gt.registerDefinitionProvider(Ne,bt(ie),fe)},registerDeclarationProvider(ie,fe){return gt.registerDeclarationProvider(Ne,bt(ie),fe)},registerImplementationProvider(ie,fe){return gt.registerImplementationProvider(Ne,bt(ie),fe)},registerTypeDefinitionProvider(ie,fe){return gt.registerTypeDefinitionProvider(Ne,bt(ie),fe)},registerHoverProvider(ie,fe){return gt.registerHoverProvider(Ne,bt(ie),fe,Ne.identifier)},registerEvaluatableExpressionProvider(ie,fe){return gt.registerEvaluatableExpressionProvider(Ne,bt(ie),fe,Ne.identifier)},registerInlineValuesProvider(ie,fe){return gt.registerInlineValuesProvider(Ne,bt(ie),fe,Ne.identifier)},registerDocumentHighlightProvider(ie,fe){return gt.registerDocumentHighlightProvider(Ne,bt(ie),fe)},registerLinkedEditingRangeProvider(ie,fe){return gt.registerLinkedEditingRangeProvider(Ne,bt(ie),fe)},registerReferenceProvider(ie,fe){return gt.registerReferenceProvider(Ne,bt(ie),fe)},registerRenameProvider(ie,fe){return gt.registerRenameProvider(Ne,bt(ie),fe)},registerDocumentSymbolProvider(ie,fe,Te){return gt.registerDocumentSymbolProvider(Ne,bt(ie),fe,Te)},registerWorkspaceSymbolProvider(ie){return gt.registerWorkspaceSymbolProvider(Ne,ie)},registerDocumentFormattingEditProvider(ie,fe){return gt.registerDocumentFormattingEditProvider(Ne,bt(ie),fe)},registerDocumentRangeFormattingEditProvider(ie,fe){return gt.registerDocumentRangeFormattingEditProvider(Ne,bt(ie),fe)},registerOnTypeFormattingEditProvider(ie,fe,Te,...ct){return gt.registerOnTypeFormattingEditProvider(Ne,bt(ie),fe,[Te].concat(ct))},registerDocumentSemanticTokensProvider(ie,fe,Te){return gt.registerDocumentSemanticTokensProvider(Ne,bt(ie),fe,Te)},registerDocumentRangeSemanticTokensProvider(ie,fe,Te){return gt.registerDocumentRangeSemanticTokensProvider(Ne,bt(ie),fe,Te)},registerSignatureHelpProvider(ie,fe,Te,...ct){return typeof Te=="object"?gt.registerSignatureHelpProvider(Ne,bt(ie),fe,Te):gt.registerSignatureHelpProvider(Ne,bt(ie),fe,typeof Te=="undefined"?[]:[Te,...ct])},registerCompletionItemProvider(ie,fe,...Te){return gt.registerCompletionItemProvider(Ne,bt(ie),fe,Te)},registerInlineCompletionItemProvider(ie,fe){return(0,W.checkProposedApiEnabled)(Ne),gt.registerInlineCompletionsProvider(Ne,bt(ie),fe)},registerDocumentLinkProvider(ie,fe){return gt.registerDocumentLinkProvider(Ne,bt(ie),fe)},registerColorProvider(ie,fe){return gt.registerColorProvider(Ne,bt(ie),fe)},registerFoldingRangeProvider(ie,fe){return gt.registerFoldingRangeProvider(Ne,bt(ie),fe)},registerSelectionRangeProvider(ie,fe){return gt.registerSelectionRangeProvider(Ne,ie,fe)},registerCallHierarchyProvider(ie,fe){return gt.registerCallHierarchyProvider(Ne,ie,fe)},setLanguageConfiguration:(ie,fe)=>gt.setLanguageConfiguration(Ne,ie,fe),getTokenInformationAtPosition(ie,fe){return(0,W.checkProposedApiEnabled)(Ne),Ht.tokenAtPosition(ie,fe)},registerInlayHintsProvider(ie,fe){return(0,W.checkProposedApiEnabled)(Ne),gt.registerInlayHintsProvider(Ne,ie,fe)},registerTypeHierarchyProvider(ie,fe){return(0,W.checkProposedApiEnabled)(Ne),gt.registerTypeHierarchyProvider(Ne,ie,fe)},createLanguageStatusItem(ie,fe){return(0,W.checkProposedApiEnabled)(Ne),Ht.createLanguageStatusItem(Ne,ie,fe)}},Tn={get activeTextEditor(){return Pt.getActiveTextEditor()},get visibleTextEditors(){return Pt.getVisibleTextEditors()},get activeTerminal(){return dt.activeTerminal},get terminals(){return dt.terminals},async showTextDocument(ie,fe,Te){const ct=await(R.URI.isUri(ie)?Promise.resolve(vn.openTextDocument(ie)):Promise.resolve(ie));return Pt.showTextDocument(ct,fe,Te)},createTextEditorDecorationType(ie){return Pt.createTextEditorDecorationType(Ne,ie)},onDidChangeActiveTextEditor(ie,fe,Te){return Pt.onDidChangeActiveTextEditor(ie,fe,Te)},onDidChangeVisibleTextEditors(ie,fe,Te){return Pt.onDidChangeVisibleTextEditors(ie,fe,Te)},onDidChangeTextEditorSelection(ie,fe,Te){return Pt.onDidChangeTextEditorSelection(ie,fe,Te)},onDidChangeTextEditorOptions(ie,fe,Te){return Pt.onDidChangeTextEditorOptions(ie,fe,Te)},onDidChangeTextEditorVisibleRanges(ie,fe,Te){return Pt.onDidChangeTextEditorVisibleRanges(ie,fe,Te)},onDidChangeTextEditorViewColumn(ie,fe,Te){return Pt.onDidChangeTextEditorViewColumn(ie,fe,Te)},onDidCloseTerminal(ie,fe,Te){return dt.onDidCloseTerminal(ie,fe,Te)},onDidOpenTerminal(ie,fe,Te){return dt.onDidOpenTerminal(ie,fe,Te)},onDidChangeActiveTerminal(ie,fe,Te){return dt.onDidChangeActiveTerminal(ie,fe,Te)},onDidChangeTerminalDimensions(ie,fe,Te){return(0,W.checkProposedApiEnabled)(Ne),dt.onDidChangeTerminalDimensions(ie,fe,Te)},onDidChangeTerminalState(ie,fe,Te){return(0,W.checkProposedApiEnabled)(Ne),dt.onDidChangeTerminalState(ie,fe,Te)},onDidWriteTerminalData(ie,fe,Te){return(0,W.checkProposedApiEnabled)(Ne),dt.onDidWriteTerminalData(ie,fe,Te)},get state(){return Ze.state},onDidChangeWindowState(ie,fe,Te){return Ze.onDidChangeWindowState(ie,fe,Te)},showInformationMessage(ie,...fe){return ln.showMessage(Ne,k.default.Info,ie,fe[0],fe.slice(1))},showWarningMessage(ie,...fe){return ln.showMessage(Ne,k.default.Warning,ie,fe[0],fe.slice(1))},showErrorMessage(ie,...fe){return ln.showMessage(Ne,k.default.Error,ie,fe[0],fe.slice(1))},showQuickPick(ie,fe,Te){return Ut.showQuickPick(ie,!!Ne.enableProposedApi,fe,Te)},showWorkspaceFolderPick(ie){return Ut.showWorkspaceFolderPick(ie)},showInputBox(ie,fe){return Ut.showInput(ie,fe)},showOpenDialog(ie){return zt.showOpenDialog(ie)},showSaveDialog(ie){return zt.showSaveDialog(ie)},createStatusBarItem(ie,fe,Te){let ct,_t,kt;return typeof ie=="string"?(ct=ie,_t=fe,kt=Te):(_t=ie,kt=fe),Ft.createStatusBarEntry(Ne,ct,_t,kt)},setStatusBarMessage(ie,fe){return Ft.setStatusBarMessage(ie,fe)},withScmProgress(ie){return Pe.report("window.withScmProgress",Ne,"Use 'withProgress' instead."),fn.withProgress(Ne,{location:O.ProgressLocation.SourceControl},(fe,Te)=>ie({report(ct){}}))},withProgress(ie,fe){return fn.withProgress(Ne,ie,fe)},createOutputChannel(ie){return Ot.createOutputChannel(ie,Ne)},createWebviewPanel(ie,fe,Te,ct){return on.createWebviewPanel(Ne,ie,fe,Te,ct)},createWebviewTextEditorInset(ie,fe,Te,ct){return(0,W.checkProposedApiEnabled)(Ne),bn.createWebviewEditorInset(ie,fe,Te,ct,Ne)},createTerminal(ie,fe,Te){return typeof ie=="object"?("location"in ie&&(0,W.checkProposedApiEnabled)(Ne),"pty"in ie?dt.createExtensionTerminal(ie):dt.createTerminalFromOptions(ie)):dt.createTerminal(ie,fe,Te)},registerTerminalLinkProvider(ie){return dt.registerLinkProvider(ie)},registerTerminalProfileProvider(ie,fe){return dt.registerProfileProvider(Ne,ie,fe)},registerTreeDataProvider(ie,fe){return Qt.registerTreeDataProvider(ie,fe,Ne)},createTreeView(ie,fe){return Qt.createTreeView(ie,fe,Ne)},registerWebviewPanelSerializer:(ie,fe)=>on.registerWebviewPanelSerializer(Ne,ie,fe),registerCustomEditorProvider:(ie,fe,Te={})=>Sn.registerCustomEditorProvider(Ne,ie,fe,Te),registerFileDecorationProvider(ie){return vt.registerFileDecorationProvider(ie,Ne.identifier)},registerUriHandler(ie){return hn.registerUriHandler(Ne.identifier,ie)},createQuickPick(){return Ut.createQuickPick(Ne.identifier,!!Ne.enableProposedApi)},createInputBox(){return Ut.createInputBox(Ne.identifier)},get activeColorTheme(){return mn.activeColorTheme},onDidChangeActiveColorTheme(ie,fe,Te){return mn.onDidChangeActiveColorTheme(ie,fe,Te)},registerWebviewViewProvider(ie,fe,Te){return yn.registerWebviewViewProvider(Ne,ie,fe,Te?.webviewOptions)},get activeNotebookEditor(){return(0,W.checkProposedApiEnabled)(Ne),wt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ie,fe,Te){return(0,W.checkProposedApiEnabled)(Ne),wt.onDidChangeActiveNotebookEditor(ie,fe,Te)},get visibleNotebookEditors(){return(0,W.checkProposedApiEnabled)(Ne),wt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,W.checkProposedApiEnabled)(Ne),wt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ie,fe,Te){return(0,W.checkProposedApiEnabled)(Ne),Vt.onDidChangeNotebookEditorSelection(ie,fe,Te)},onDidChangeNotebookEditorVisibleRanges(ie,fe,Te){return(0,W.checkProposedApiEnabled)(Ne),Vt.onDidChangeNotebookEditorVisibleRanges(ie,fe,Te)},showNotebookDocument(ie,fe){return(0,W.checkProposedApiEnabled)(Ne),wt.showNotebookDocument(ie,fe)},registerExternalUriOpener(ie,fe,Te){return(0,W.checkProposedApiEnabled)(Ne),Jt.registerExternalUriOpener(Ne.identifier,ie,fe,Te)},get tabs(){return(0,W.checkProposedApiEnabled)(Ne),ot.tabs},get activeTab(){return(0,W.checkProposedApiEnabled)(Ne),ot.activeTab},get onDidChangeTabs(){return(0,W.checkProposedApiEnabled)(Ne),ot.onDidChangeTabs},get onDidChangeActiveTab(){return(0,W.checkProposedApiEnabled)(Ne),ot.onDidChangeActiveTab},getInlineCompletionItemController(ie){return(0,W.checkProposedApiEnabled)(Ne),c.InlineCompletionController.get(ie)}},vn={get rootPath(){return Pe.report("workspace.rootPath",Ne,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Ge.getPath()},set rootPath(ie){throw L.readonly()},getWorkspaceFolder(ie){return Ge.getWorkspaceFolder(ie)},get workspaceFolders(){return Ge.getWorkspaceFolders()},get name(){return Ge.name},set name(ie){throw L.readonly()},get workspaceFile(){return Ge.workspaceFile},set workspaceFile(ie){throw L.readonly()},updateWorkspaceFolders:(ie,fe,...Te)=>Ge.updateWorkspaceFolders(Ne,ie,fe||0,...Te),onDidChangeWorkspaceFolders:function(ie,fe,Te){return Ge.onDidChangeWorkspace(ie,fe,Te)},asRelativePath:(ie,fe)=>Ge.getRelativePath(ie,fe),findFiles:(ie,fe,Te,ct)=>Ge.findFiles(z.GlobPattern.from(ie),z.GlobPattern.from(fe),Te,Ne.identifier,ct),findTextInFiles:(ie,fe,Te,ct)=>{let _t,kt;return typeof fe=="object"?(_t=fe,kt=Te):(_t={},kt=fe,ct=Te),Ge.findTextInFiles(ie,_t||{},kt,Ne.identifier,ct)},saveAll:ie=>Ge.saveAll(ie),applyEdit(ie){return Cn.applyWorkspaceEdit(ie)},createFileSystemWatcher:(ie,fe,Te,ct)=>Nt.createFileSystemWatcher(z.GlobPattern.from(ie),fe,Te,ct),get textDocuments(){return It.getAllDocumentData().map(ie=>ie.document)},set textDocuments(ie){throw L.readonly()},openTextDocument(ie){let fe;const Te=ie;if(typeof ie=="string")fe=Promise.resolve(R.URI.file(ie));else if(R.URI.isUri(ie))fe=Promise.resolve(ie);else if(!Te||typeof Te=="object")fe=It.createDocumentData(Te);else throw new Error("illegal argument - uriOrFileNameOrOptions");return fe.then(ct=>It.ensureDocumentData(ct).then(_t=>_t.document))},onDidOpenTextDocument:(ie,fe,Te)=>It.onDidAddDocument(ie,fe,Te),onDidCloseTextDocument:(ie,fe,Te)=>It.onDidRemoveDocument(ie,fe,Te),onDidChangeTextDocument:(ie,fe,Te)=>It.onDidChangeDocument(ie,fe,Te),onDidSaveTextDocument:(ie,fe,Te)=>It.onDidSaveDocument(ie,fe,Te),onWillSaveTextDocument:(ie,fe,Te)=>Zt.getOnWillSaveTextDocumentEvent(Ne)(ie,fe,Te),get notebookDocuments(){return wt.notebookDocuments.map(ie=>ie.apiNotebook)},async openNotebookDocument(ie,fe){let Te;if(R.URI.isUri(ie))Te=ie,await wt.openNotebookDocument(ie);else if(typeof ie=="string")Te=R.URI.revive(await wt.createNotebookDocument({viewType:ie,content:fe}));else throw new Error("Invalid arguments");return wt.getNotebookDocument(Te).apiNotebook},get onDidOpenNotebookDocument(){return wt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return wt.onDidCloseNotebookDocument},registerNotebookSerializer(ie,fe,Te,ct){return wt.registerNotebookSerializer(Ne,ie,fe,Te,Ne.enableProposedApi?ct:void 0)},registerNotebookContentProvider:(ie,fe,Te,ct)=>((0,W.checkProposedApiEnabled)(Ne),wt.registerNotebookContentProvider(Ne,ie,fe,Te,Ne.enableProposedApi?ct:void 0)),onDidChangeConfiguration:(ie,fe,Te)=>Gt.onDidChangeConfiguration(ie,fe,Te),getConfiguration(ie,fe){return fe=arguments.length===1?void 0:fe,Gt.getConfiguration(ie,fe,Ne)},registerTextDocumentContentProvider(ie,fe){return $t.registerTextDocumentContentProvider(ie,fe)},registerTaskProvider:(ie,fe)=>(Pe.report("window.registerTaskProvider",Ne,"Use the corresponding function on the 'tasks' namespace instead"),yt.registerTaskProvider(Ne,ie,fe)),registerFileSystemProvider(ie,fe,Te){return nn.registerFileSystemProvider(Ne.identifier,ie,fe,Te)},get fs(){return we.value},registerFileSearchProvider:(ie,fe)=>((0,W.checkProposedApiEnabled)(Ne),Rt.registerFileSearchProvider(ie,fe)),registerTextSearchProvider:(ie,fe)=>((0,W.checkProposedApiEnabled)(Ne),Rt.registerTextSearchProvider(ie,fe)),registerRemoteAuthorityResolver:(ie,fe)=>((0,W.checkProposedApiEnabled)(Ne),Fe.registerRemoteAuthorityResolver(ie,fe)),registerResourceLabelFormatter:ie=>((0,W.checkProposedApiEnabled)(Ne),_n.$registerResourceLabelFormatter(ie)),onDidCreateFiles:(ie,fe,Te)=>Nt.onDidCreateFile(ie,fe,Te),onDidDeleteFiles:(ie,fe,Te)=>Nt.onDidDeleteFile(ie,fe,Te),onDidRenameFiles:(ie,fe,Te)=>Nt.onDidRenameFile(ie,fe,Te),onWillCreateFiles:(ie,fe,Te)=>Nt.getOnWillCreateFileEvent(Ne)(ie,fe,Te),onWillDeleteFiles:(ie,fe,Te)=>Nt.getOnWillDeleteFileEvent(Ne)(ie,fe,Te),onWillRenameFiles:(ie,fe,Te)=>Nt.getOnWillRenameFileEvent(Ne)(ie,fe,Te),openTunnel:ie=>((0,W.checkProposedApiEnabled)(Ne),Ae.openTunnel(Ne,ie).then(fe=>{if(!fe)throw new Error("cannot open tunnel");return fe})),get tunnels(){return(0,W.checkProposedApiEnabled)(Ne),Ae.getTunnels()},onDidChangeTunnels:(ie,fe,Te)=>((0,W.checkProposedApiEnabled)(Ne),Ae.onDidChangeTunnels(ie,fe,Te)),registerPortAttributesProvider:(ie,fe)=>((0,W.checkProposedApiEnabled)(Ne),Ae.registerPortsAttributesProvider(ie,fe)),registerTimelineProvider:(ie,fe)=>((0,W.checkProposedApiEnabled)(Ne),sn.registerTimelineProvider(ie,fe,Ne.identifier,lt.converter)),get isTrusted(){return Ge.trusted},requestWorkspaceTrust:ie=>((0,W.checkProposedApiEnabled)(Ne),Ge.requestWorkspaceTrust(ie)),onDidGrantWorkspaceTrust:(ie,fe,Te)=>Ge.onDidGrantWorkspaceTrust(ie,fe,Te)},Rn={get inputBox(){return Pe.report("scm.inputBox",Ne,"Use 'SourceControl.inputBox' instead"),Xt.getLastInputBox(Ne)},createSourceControl(ie,fe,Te){return Xt.createSourceControl(Ne,ie,fe,Te)}},Ln={createCommentController(ie,fe){return En.createCommentController(Ne,ie,fe)}},Fn={get activeDebugSession(){return mt.activeDebugSession},get activeDebugConsole(){return mt.activeDebugConsole},get breakpoints(){return mt.breakpoints},onDidStartDebugSession(ie,fe,Te){return mt.onDidStartDebugSession(ie,fe,Te)},onDidTerminateDebugSession(ie,fe,Te){return mt.onDidTerminateDebugSession(ie,fe,Te)},onDidChangeActiveDebugSession(ie,fe,Te){return mt.onDidChangeActiveDebugSession(ie,fe,Te)},onDidReceiveDebugSessionCustomEvent(ie,fe,Te){return mt.onDidReceiveDebugSessionCustomEvent(ie,fe,Te)},onDidChangeBreakpoints(ie,fe,Te){return mt.onDidChangeBreakpoints(ie,fe,Te)},registerDebugConfigurationProvider(ie,fe,Te){return mt.registerDebugConfigurationProvider(ie,fe,Te||O.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ie,fe){return mt.registerDebugAdapterDescriptorFactory(Ne,ie,fe)},registerDebugAdapterTrackerFactory(ie,fe){return mt.registerDebugAdapterTrackerFactory(ie,fe)},startDebugging(ie,fe,Te){return!Te||typeof Te=="object"&&"configuration"in Te?mt.startDebugging(ie,fe,{parentSession:Te}):mt.startDebugging(ie,fe,Te||{})},stopDebugging(ie){return mt.stopDebugging(ie)},addBreakpoints(ie){return mt.addBreakpoints(ie)},removeBreakpoints(ie){return mt.removeBreakpoints(ie)},asDebugSourceUri(ie,fe){return mt.asDebugSourceUri(ie,fe)}},Mn={registerTaskProvider:(ie,fe)=>yt.registerTaskProvider(Ne,ie,fe),fetchTasks:ie=>yt.fetchTasks(ie),executeTask:ie=>yt.executeTask(Ne,ie),get taskExecutions(){return yt.taskExecutions},onDidStartTask:(ie,fe,Te)=>yt.onDidStartTask(ie,fe,Te),onDidEndTask:(ie,fe,Te)=>yt.onDidEndTask(ie,fe,Te),onDidStartTaskProcess:(ie,fe,Te)=>yt.onDidStartTaskProcess(ie,fe,Te),onDidEndTaskProcess:(ie,fe,Te)=>yt.onDidEndTaskProcess(ie,fe,Te)},On={createNotebookController(ie,fe,Te,ct,_t){return en.createNotebookController(Ne,ie,fe,Te,ct,Ne.enableProposedApi?_t:void 0)},registerNotebookCellStatusBarItemProvider:(ie,fe)=>wt.registerNotebookCellStatusBarItemProvider(Ne,ie,fe),get onDidSaveNotebookDocument(){return(0,W.checkProposedApiEnabled)(Ne),Kt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(ie){return(0,W.checkProposedApiEnabled)(Ne),Vt.createNotebookEditorDecorationType(ie)},createRendererMessaging(ie){return tn.createRendererMessaging(Ne,ie)},onDidChangeNotebookDocumentMetadata(ie,fe,Te){return(0,W.checkProposedApiEnabled)(Ne),Kt.onDidChangeNotebookDocumentMetadata(ie,fe,Te)},onDidChangeNotebookCells(ie,fe,Te){return(0,W.checkProposedApiEnabled)(Ne),wt.onDidChangeNotebookCells(ie,fe,Te)},onDidChangeNotebookCellExecutionState(ie,fe,Te){return(0,W.checkProposedApiEnabled)(Ne),wt.onDidChangeNotebookCellExecutionState(ie,fe,Te)},onDidChangeCellOutputs(ie,fe,Te){return(0,W.checkProposedApiEnabled)(Ne),wt.onDidChangeCellOutputs(ie,fe,Te)},onDidChangeCellMetadata(ie,fe,Te){return(0,W.checkProposedApiEnabled)(Ne),wt.onDidChangeCellMetadata(ie,fe,Te)},createConcatTextDocument(ie,fe){return(0,W.checkProposedApiEnabled)(Ne),new Ke.ExtHostNotebookConcatDocument(wt,It,ie,fe)}};return{version:de.version,authentication:kn,commands:In,comments:Ln,debug:Fn,env:gn,extensions:An,languages:cn,notebooks:On,scm:Rn,tasks:Mn,tests:Pn,window:Tn,workspace:vn,Breakpoint:O.Breakpoint,CallHierarchyIncomingCall:O.CallHierarchyIncomingCall,CallHierarchyItem:O.CallHierarchyItem,CallHierarchyOutgoingCall:O.CallHierarchyOutgoingCall,CancellationError:L.CancellationError,CancellationTokenSource:m.CancellationTokenSource,CandidatePortSource:u.CandidatePortSource,CodeAction:O.CodeAction,CodeActionKind:O.CodeActionKind,CodeActionTriggerKind:O.CodeActionTriggerKind,CodeLens:O.CodeLens,Color:O.Color,ColorInformation:O.ColorInformation,ColorPresentation:O.ColorPresentation,ColorThemeKind:O.ColorThemeKind,CommentMode:O.CommentMode,CommentThreadCollapsibleState:O.CommentThreadCollapsibleState,CompletionItem:O.CompletionItem,CompletionItemKind:O.CompletionItemKind,CompletionItemTag:O.CompletionItemTag,CompletionList:O.CompletionList,CompletionTriggerKind:O.CompletionTriggerKind,ConfigurationTarget:O.ConfigurationTarget,CustomExecution:O.CustomExecution,DebugAdapterExecutable:O.DebugAdapterExecutable,DebugAdapterInlineImplementation:O.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:O.DebugAdapterNamedPipeServer,DebugAdapterServer:O.DebugAdapterServer,DebugConfigurationProviderTriggerKind:O.DebugConfigurationProviderTriggerKind,DebugConsoleMode:O.DebugConsoleMode,DecorationRangeBehavior:O.DecorationRangeBehavior,Diagnostic:O.Diagnostic,DiagnosticRelatedInformation:O.DiagnosticRelatedInformation,DiagnosticSeverity:O.DiagnosticSeverity,DiagnosticTag:O.DiagnosticTag,Disposable:O.Disposable,DocumentHighlight:O.DocumentHighlight,DocumentHighlightKind:O.DocumentHighlightKind,DocumentLink:O.DocumentLink,DocumentSymbol:O.DocumentSymbol,EndOfLine:O.EndOfLine,EnvironmentVariableMutatorType:O.EnvironmentVariableMutatorType,EvaluatableExpression:O.EvaluatableExpression,InlineValueText:O.InlineValueText,InlineValueVariableLookup:O.InlineValueVariableLookup,InlineValueEvaluatableExpression:O.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:O.InlineCompletionTriggerKind,EventEmitter:I.Emitter,ExtensionKind:O.ExtensionKind,ExtensionMode:O.ExtensionMode,ExternalUriOpenerPriority:O.ExternalUriOpenerPriority,FileChangeType:O.FileChangeType,FileDecoration:O.FileDecoration,FileSystemError:O.FileSystemError,FileType:A.FileType,FilePermission:A.FilePermission,FoldingRange:O.FoldingRange,FoldingRangeKind:O.FoldingRangeKind,FunctionBreakpoint:O.FunctionBreakpoint,InlineCompletionItem:O.InlineSuggestion,InlineCompletionList:O.InlineSuggestions,Hover:O.Hover,IndentAction:T.IndentAction,Location:O.Location,MarkdownString:O.MarkdownString,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:O.ParameterInformation,PortAutoForwardAction:O.PortAutoForwardAction,Position:O.Position,ProcessExecution:O.ProcessExecution,ProgressLocation:O.ProgressLocation,QuickInputButtons:O.QuickInputButtons,Range:O.Range,RelativePattern:O.RelativePattern,Selection:O.Selection,SelectionRange:O.SelectionRange,SemanticTokens:O.SemanticTokens,SemanticTokensBuilder:O.SemanticTokensBuilder,SemanticTokensEdit:O.SemanticTokensEdit,SemanticTokensEdits:O.SemanticTokensEdits,SemanticTokensLegend:O.SemanticTokensLegend,ShellExecution:O.ShellExecution,ShellQuoting:O.ShellQuoting,SignatureHelp:O.SignatureHelp,SignatureHelpTriggerKind:O.SignatureHelpTriggerKind,SignatureInformation:O.SignatureInformation,SnippetString:O.SnippetString,SourceBreakpoint:O.SourceBreakpoint,StandardTokenType:O.StandardTokenType,StatusBarAlignment:O.StatusBarAlignment,SymbolInformation:O.SymbolInformation,SymbolKind:O.SymbolKind,SymbolTag:O.SymbolTag,Task:O.Task,TaskGroup:O.TaskGroup,TaskPanelKind:O.TaskPanelKind,TaskRevealKind:O.TaskRevealKind,TaskScope:O.TaskScope,TerminalLink:O.TerminalLink,TerminalLocation:O.TerminalLocation,TerminalProfile:O.TerminalProfile,TextDocumentSaveReason:O.TextDocumentSaveReason,TextEdit:O.TextEdit,TextEditorCursorStyle:C.TextEditorCursorStyle,TextEditorLineNumbersStyle:O.TextEditorLineNumbersStyle,TextEditorRevealType:O.TextEditorRevealType,TextEditorSelectionChangeKind:O.TextEditorSelectionChangeKind,TextDocumentChangeReason:O.TextDocumentChangeReason,ThemeColor:O.ThemeColor,ThemeIcon:O.ThemeIcon,TreeItem:O.TreeItem,TreeItemCollapsibleState:O.TreeItemCollapsibleState,TypeHierarchyItem:O.TypeHierarchyItem,UIKind:u.UIKind,Uri:R.URI,ViewColumn:O.ViewColumn,WorkspaceEdit:O.WorkspaceEdit,InlayHint:O.InlayHint,InlayHintKind:O.InlayHintKind,RemoteAuthorityResolverError:O.RemoteAuthorityResolverError,ResolvedAuthority:O.ResolvedAuthority,SourceControlInputBoxValidationType:O.SourceControlInputBoxValidationType,ExtensionRuntime:O.ExtensionRuntime,TimelineItem:O.TimelineItem,NotebookRange:O.NotebookRange,NotebookCellKind:O.NotebookCellKind,NotebookCellExecutionState:O.NotebookCellExecutionState,NotebookCellData:O.NotebookCellData,NotebookData:O.NotebookData,NotebookRendererScript:O.NotebookRendererScript,NotebookCellStatusBarAlignment:O.NotebookCellStatusBarAlignment,NotebookEditorRevealType:O.NotebookEditorRevealType,NotebookCellOutput:O.NotebookCellOutput,NotebookCellOutputItem:O.NotebookCellOutputItem,NotebookCellStatusBarItem:O.NotebookCellStatusBarItem,NotebookControllerAffinity:O.NotebookControllerAffinity,PortAttributes:O.PortAttributes,LinkedEditingRanges:O.LinkedEditingRanges,TestResultState:O.TestResultState,TestRunRequest:O.TestRunRequest,TestMessage:O.TestMessage,TestTag:O.TestTag,TestRunProfileKind:O.TestRunProfileKind,TextSearchCompleteMessageType:Ie.TextSearchCompleteMessageType,CoveredCount:O.CoveredCount,FileCoverage:O.FileCoverage,StatementCoverage:O.StatementCoverage,BranchCoverage:O.BranchCoverage,FunctionCoverage:O.FunctionCoverage,WorkspaceTrustState:O.WorkspaceTrustState,LanguageStatusSeverity:O.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=ke}),define(me[276],ge([0,1,82,68,37,131,38,44,45,33,72,55,74,92,53,67,132,91,52,90,122,54]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,l,v,S,P,E,s,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.registerSingleton)(v.IExtHostApiDeprecationService,v.ExtHostApiDeprecationService),(0,m.registerSingleton)(C.IExtHostCommands,C.ExtHostCommands),(0,m.registerSingleton)(R.IExtHostConfiguration,R.ExtHostConfiguration),(0,m.registerSingleton)(P.IExtHostConsumerFileSystem,P.ExtHostConsumerFileSystem),(0,m.registerSingleton)(A.IExtHostDebugService,A.WorkerExtHostDebugService),(0,m.registerSingleton)(k.IExtHostDecorations,k.ExtHostDecorations),(0,m.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors),(0,m.registerSingleton)(E.IExtHostFileSystemInfo,E.ExtHostFileSystemInfo),(0,m.registerSingleton)(L.IExtHostOutputService,L.ExtHostOutputService),(0,m.registerSingleton)(u.IExtHostSearch,u.ExtHostSearch),(0,m.registerSingleton)(f.IExtHostStorage,f.ExtHostStorage),(0,m.registerSingleton)(n.IExtHostTask,n.WorkerExtHostTask),(0,m.registerSingleton)(T.IExtHostTerminalService,T.WorkerExtHostTerminalService),(0,m.registerSingleton)(l.IExtHostTunnelService,l.ExtHostTunnelService),(0,m.registerSingleton)(S.IExtHostWindow,S.ExtHostWindow),(0,m.registerSingleton)(I.IExtHostWorkspace,I.ExtHostWorkspace),(0,m.registerSingleton)(s.IExtHostSecretState,s.ExtHostSecretState),(0,m.registerSingleton)(a.IExtHostTelemetry,a.ExtHostTelemetry),(0,m.registerSingleton)(p.IExtHostEditorTabs,p.ExtHostEditorTabs)}),define(me[93],ge([0,1,17,12,31,71]),function(J,e,m,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function R(A){return A.startsWith("**")||A.startsWith("/")?A:`/${A}`}e.anchorGlob=R;function C(A,u,f,l){const v=(0,m.mapArrayOrNot)(f,D),S=new I.TextSearchMatch(u,v,l),P=S.preview.matches;return{ranges:(0,m.mapArrayOrNot)(v,T),uri:A,preview:{text:S.preview.text,matches:(0,m.mapArrayOrNot)(P,T)}}}e.createTextSearchResult=C;function D(A){return new I.SearchRange(A.start.line,A.start.character,A.end.line,A.end.character)}function T(A){return new k.Range(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn)}let n=class{constructor(u,f){this.prefix=u,this.logService=f}appendLine(u){this.logService.debug(`${this.prefix}#search`,u)}};n=Ve([We(1,L.ILogService)],n),e.OutputChannel=n}),define(me[277],ge([0,1,96,23]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function I(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(o=>o===t)}e.isUTFEncoding=I,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const k=512,R=512,C=512*8,D=512*128;class T{constructor(o){this.iconvLiteDecoder=o}static async create(o){let r;if(o!==e.UTF8)r=(await new Promise((h,c)=>{J(["iconv-lite-umd"],h,c)})).getDecoder(f(o));else{const i=new TextDecoder;r={write(h){return i.decode(h,{stream:!0})},end(){return i.decode()}}}return new T(r)}write(o){return this.iconvLiteDecoder.write(o)}end(){return this.iconvLiteDecoder.end()}}function n(t,o){const r=o.minBytesRequiredForDetection??o.guessEncoding?C:R;return new Promise((i,h)=>{const c=(0,m.newWriteableStream)(_=>_.join("")),d=[];let b=0,y;const g=async()=>{try{const _=await p({buffer:L.VSBuffer.concat(d),bytesRead:b},o.guessEncoding);_.encoding=await o.overwriteEncoding(_.encoding),y=await T.create(_.encoding);const w=y.write(L.VSBuffer.concat(d).buffer);c.write(w),d.length=0,b=0,i({stream:c,detected:_})}catch(_){h(_)}};(0,m.listenStream)(t,{onData:async _=>{y?c.write(y.write(_.buffer)):(d.push(_),b+=_.byteLength,b>=r&&(t.pause(),await g(),setTimeout(()=>t.resume())))},onError:_=>c.error(_),onEnd:async()=>{y||await g(),c.end(y?.end())}})})}e.toDecodeStream=n;async function A(t,o,r){const h=(await new Promise((b,y)=>{J(["iconv-lite-umd"],b,y)})).getEncoder(f(o),r);let c=!1,d=!1;return{read(){if(d)return null;const b=t.read();if(typeof b!="string"){if(d=!0,!c&&r?.addBOM)switch(o){case e.UTF8:case e.UTF8_with_bom:return L.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const y=h.end();return y&&y.length>0?(c=!0,L.VSBuffer.wrap(y)):null}return c=!0,L.VSBuffer.wrap(h.write(b))}}}e.toEncodeReadable=A;async function u(t){return(await new Promise((r,i)=>{J(["iconv-lite-umd"],r,i)})).encodingExists(f(t))}e.encodingExists=u;function f(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=f;function l(t,o){if(!t||o<e.UTF16be_BOM.length)return null;const r=t.readUInt8(0),i=t.readUInt8(1);if(r===e.UTF16be_BOM[0]&&i===e.UTF16be_BOM[1])return e.UTF16be;if(r===e.UTF16le_BOM[0]&&i===e.UTF16le_BOM[1])return e.UTF16le;if(o<e.UTF8_BOM.length)return null;const h=t.readUInt8(2);return r===e.UTF8_BOM[0]&&i===e.UTF8_BOM[1]&&h===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=l;const v=["ascii","utf-16","utf-32"];async function S(t){const o=await new Promise((d,b)=>{J(["jschardet"],d,b)}),r=t.slice(0,D),i=s(r.buffer),h=o.detect(i);if(!h||!h.encoding)return null;const c=h.encoding.toLowerCase();return 0<=v.indexOf(c)?null:E(h.encoding)}const P={ibm866:"cp866",big5:"cp950"};function E(t){const o=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return P[o]||o}function s(t){let o="";for(let r=0;r<t.length;r++)o+=String.fromCharCode(t[r]);return o}function a(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const o=t.match(/windows(\d+)/);return o?"windows-"+o[1]:t}}e.toCanonicalName=a;function p({buffer:t,bytesRead:o},r){let i=l(t,o),h=!1;if(i!==e.UTF16be&&i!==e.UTF16le&&t){let c=!0,d=!0,b=!1;for(let y=0;y<o&&y<k;y++){const g=y%2==1,_=t.readUInt8(y)===0;if(_&&(b=!0),c&&(g&&!_||!g&&_)&&(c=!1),d&&(g&&_||!g&&!_)&&(d=!1),_&&!c&&!d)break}b&&(c?i=e.UTF16le:d?i=e.UTF16be:h=!0)}return r&&!h&&!i&&t?S(t.slice(0,o)).then(c=>({seemsBinary:!1,encoding:c})):{seemsBinary:h,encoding:i}}e.detectEncodingFromBuffer=p,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(me[134],ge([0,1,277,28,133]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class k extends I.TextSearchManager{constructor(C,D,T=L,n="searchProcess"){super(C,D,{readdir:A=>T.Promises.readdir(A.fsPath),toCanonicalName:A=>(0,m.toCanonicalName)(A)},n)}}e.NativeTextSearchManager=k}),define(me[278],ge([0,1,279,294,295,2,296]),function(J,e,m,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function C(A,u,f,l,v,S){const P=S.environment.useHostProxy,E=typeof P=="boolean"?P:!S.remote.isRemote,s=(0,R.createProxyResolver)({resolveProxy:p=>A.resolveProxy(p),getHttpProxySetting:()=>u.getConfiguration("http").get("proxy"),log:(p,t,...o)=>{switch(p){case R.LogLevel.Trace:l.trace(t,...o);break;case R.LogLevel.Debug:l.debug(t,...o);break;case R.LogLevel.Info:l.info(t,...o);break;case R.LogLevel.Warning:l.warn(t,...o);break;case R.LogLevel.Error:l.error(t,...o);break;case R.LogLevel.Critical:l.critical(t,...o);break;case R.LogLevel.Off:break;default:r(p,t,o);break}function r(i,h,...c){l.error("Unknown log level",i),l.error(h,...c)}},getLogLevel:()=>l.getLevel(),proxyResolveTelemetry:p=>{v.$publicLog2("resolveProxy",p)},useHostProxy:E,env:process.env}),a=D(u,s);return n(f,a)}e.connectProxyResolver=C;function D(A,u){const f={config:A.getConfiguration("http").get("proxySupport")||"off"};A.onDidChangeConfiguration(v=>{f.config=A.getConfiguration("http").get("proxySupport")||"off"});const l={config:!!A.getConfiguration("http").get("systemCertificates")};return A.onDidChangeConfiguration(v=>{l.config=!!A.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},m,(0,R.createHttpPatch)(m,u,{config:"off"},l,!0)),on:Object.assign({},m,(0,R.createHttpPatch)(m,u,{config:"on"},l,!0)),override:Object.assign({},m,(0,R.createHttpPatch)(m,u,{config:"override"},l,!0)),onRequest:Object.assign({},m,(0,R.createHttpPatch)(m,u,f,l,!0)),default:Object.assign(m,(0,R.createHttpPatch)(m,u,f,l,!1))},https:{off:Object.assign({},L,(0,R.createHttpPatch)(L,u,{config:"off"},l,!0)),on:Object.assign({},L,(0,R.createHttpPatch)(L,u,{config:"on"},l,!0)),override:Object.assign({},L,(0,R.createHttpPatch)(L,u,{config:"override"},l,!0)),onRequest:Object.assign({},L,(0,R.createHttpPatch)(L,u,f,l,!0)),default:Object.assign(L,(0,R.createHttpPatch)(L,u,f,l,!1))},tls:Object.assign(I,(0,R.createTlsPatch)(I))}}const T=new Map;function n(A,u){return A.getExtensionPathIndex().then(f=>{const l=J.__$__nodeRequire("module"),v=l._load;l._load=function(P,E,s){if(P==="tls")return u.tls;if(P!=="http"&&P!=="https")return v.apply(this,arguments);const a=u[P],p=f.findSubstr(k.URI.file(E.filename).fsPath);let t=T.get(p);if(t||T.set(p,t={}),!t[P]){let o=a.default;p&&p.enableProposedApi&&(o=a[p.proxySupport]||a.onRequest),t[P]={...o}}return t[P]}})}}),define(me[280],ge([0,1,39,8,78,29,11,9,93,281]),function(J,e,m,L,I,k,R,C,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const n=T.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function A(s,a,p,t){const o=u(s,a,p,t),r=a.folder.fsPath;return{cmd:m.spawn(n,o.args,{cwd:r}),rgDiskPath:n,siblingClauses:o.siblingClauses,rgArgs:o,cwd:r}}e.spawnRipgrepCmd=A;function u(s,a,p,t){const o=["--files","--hidden","--case-sensitive"];l([a],p,!1).forEach(i=>{const h=(0,D.anchorGlob)(i);if(o.push("-g",h),R.isMacintosh){const c=(0,I.normalizeNFD)(h);c!==h&&o.push("-g",c)}});const r=f([a],t,void 0,!1);return r.globArgs.forEach(i=>{const h=`!${(0,D.anchorGlob)(i)}`;if(o.push("-g",h),R.isMacintosh){const c=(0,I.normalizeNFD)(h);c!==h&&o.push("-g",c)}}),a.disregardIgnoreFiles!==!1?o.push("--no-ignore"):o.push("--no-ignore-parent"),a.ignoreSymlinks||o.push("--follow"),s.exists&&o.push("--quiet"),o.push("--no-config"),a.disregardGlobalIgnoreFiles&&o.push("--no-ignore-global"),{args:o,siblingClauses:r.siblingClauses}}function f(s,a,p,t=!0){const o=[];let r={};return s.forEach(i=>{const h=Object.assign({},i.excludePattern||{},a||{}),c=v(h,t?i.folder.fsPath:void 0,p);o.push(...c.globArgs),c.siblingClauses&&(r=Object.assign(r,c.siblingClauses))}),{globArgs:o,siblingClauses:r}}e.foldersToRgExcludeGlobs=f;function l(s,a,p=!0){const t=[];return s.forEach(o=>{const r=Object.assign({},a||{},o.includePattern||{}),i=v(r,p?o.folder.fsPath:void 0);t.push(...i.globArgs)}),t}e.foldersToIncludeGlobs=l;function v(s,a,p){const t=[],o={};return Object.keys(s).forEach(r=>{if(p&&p.has(r)||!r)return;const i=s[r];r=P(a?S(a,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof i=="boolean"&&i?(r.startsWith("\\\\")&&(r+="**"),t.push(E(r))):i&&i.when&&(o[r]=i)}),{globArgs:t,siblingClauses:o}}function S(s,a){return L.isAbsolute(a)?a:L.join(s,a)}e.getAbsoluteGlob=S;function P(s){return s=C.rtrim(s,"\\"),C.rtrim(s,"/")}function E(s){return k.getRoot(s).toLowerCase()==="c:/"?s.replace(/^c:[/\\]/i,"/"):s}e.fixDriveC=E}),define(me[282],ge([0,1,39,50,8,104,17,61,30,78,29,11,46,9,13,28,31,280,101]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,l,v,S,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const s=new Set;process.on("exit",()=>{s.forEach(r=>r())});class a{constructor(i){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=i,this.filePattern=i.filePattern||"",this.includePattern=i.includePattern&&D.parse(i.includePattern),this.maxResults=i.maxResults||null,this.exists=!!i.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,E.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=i.excludePattern&&D.parse(i.excludePattern),this.folderExcludePatterns=new Map,i.folderQueries.forEach(h=>{const c=Object.assign({},h.excludePattern||{},this.config.excludePattern||{}),d=h.folder.fsPath;i.folderQueries.map(b=>b.folder.fsPath).filter(b=>b!==d).forEach(b=>{(0,n.isEqualOrParent)(b,d)&&(c[I.relative(d,b)]=!0)}),this.folderExcludePatterns.set(d,new t(c,d))})}cancel(){this.isCanceled=!0}walk(i,h,c,d,b){if(this.fileWalkSW=u.StopWatch.create(!1),this.isCanceled)return b(null,this.isLimitHit);h.forEach(y=>{const g=I.basename(y.fsPath);this.globalExcludePattern&&this.globalExcludePattern(y.fsPath,g)||this.matchFile(c,{relativePath:y.fsPath,searchPath:void 0})}),this.cmdSW=u.StopWatch.create(!1),this.parallel(i,(y,g)=>{this.call(this.cmdTraversal,this,y,c,d,_=>{if(_){const w=(0,C.toErrorMessage)(_);console.error(w),this.errors.push(w),g(_,void 0)}else g(null,void 0)})},(y,g)=>{this.fileWalkSW.stop();const _=y?R.coalesce(y)[0]:null;b(_,this.isLimitHit)})}parallel(i,h,c){const d=new Array(i.length),b=new Array(i.length);let y=!1,g=0;if(i.length===0)return c(null,[]);i.forEach((_,w)=>{h(_,(F,N)=>{if(F?(y=!0,d[w]=null,b[w]=F):(d[w]=N,b[w]=null),++g===i.length)return c(y?b:null,d)})})}call(i,h,...c){try{i.apply(h,c)}catch(d){c[c.length-1](d)}}cmdTraversal(i,h,c,d){const b=i.folder.fsPath,y=A.isMacintosh;let g;const _=()=>g&&g.kill();s.add(_);let w=O=>{s.delete(_),w=()=>{},d(O)},F="";const N=this.initDirectoryTree();let G;const K=(0,P.spawnRipgrepCmd)(this.config,i,this.config.includePattern,this.folderExcludePatterns.get(i.folder.fsPath).expression);g=K.cmd,G=!Object.keys(K.siblingClauses).length;const U=K.rgArgs.args.map(O=>O.match(/^-/)?O:`'${O}'`).join(" ");let z=`${K.rgDiskPath} ${U}
 - cwd: ${K.cwd}`;K.rgArgs.siblingClauses&&(z+=`
 - Sibling clauses: ${JSON.stringify(K.rgArgs.siblingClauses)}`),c({message:z}),this.cmdResultCount=0,this.collectStdout(g,"utf8",c,(O,B,x)=>{if(O){w(O);return}if(this.isLimitHit){w();return}const H=(F+(y?T.normalizeNFC(B||""):B)).split(`
`);if(x){const W=H.length;H[W-1]=H[W-1].trim(),H[W-1]||H.pop()}else F=H.pop()||"";if(H.length&&H[0].indexOf(`
`)!==-1){w(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=H.length,G){for(const W of H)if(this.matchFile(h,{base:b,relativePath:W,searchPath:this.getSearchPath(i,W)}),this.isLimitHit){_();break}(x||this.isLimitHit)&&w();return}this.addDirectoryEntries(i,N,b,H,h),x&&(this.matchDirectoryTree(N,b,h),w())})}spawnFindCmd(i){const h=this.folderExcludePatterns.get(i.folder.fsPath),c=h.getBasenameTerms(),d=h.getPathTerms(),b=["-L","."];if(c.length||d.length){b.push("-not","(","(");for(const y of c)b.push("-name",y),b.push("-o");for(const y of d)b.push("-path",y),b.push("-o");b.pop(),b.push(")","-prune",")")}return b.push("-type","f"),m.spawn("find",b,{cwd:i.folder.fsPath})}readStdout(i,h,c){let d="";this.collectStdout(i,h,()=>{},(b,y,g)=>{if(b){c(b);return}d+=y,g&&c(null,d)})}collectStdout(i,h,c,d){let b=(_,w,F)=>{(_||F)&&(b=()=>{},this.cmdSW&&this.cmdSW.stop()),d(_,w,F)},y=!1;i.stdout?(this.forwardData(i.stdout,h,b),i.stdout.once("data",()=>y=!0)):c({message:"stdout is null"});let g;i.stderr?g=this.collectData(i.stderr):c({message:"stderr is null"}),i.on("error",_=>{b(_)}),i.on("close",_=>{let w;!y&&(w=this.decodeData(g,h))&&o(w)?b(new Error(`command failed with error code ${_}: ${this.decodeData(g,h)}`)):(this.exists&&_===0&&(this.isLimitHit=!0),b(null,"",!0))})}forwardData(i,h,c){const d=new k.StringDecoder(h);return i.on("data",b=>{c(null,d.write(b))}),d}collectData(i){const h=[];return i.on("data",c=>{h.push(c)}),h}decodeData(i,h){const c=new k.StringDecoder(h);return i.map(d=>c.write(d)).join("")}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries(i,{pathToEntries:h},c,d,b){d.indexOf(this.filePattern)!==-1&&this.matchFile(b,{base:c,relativePath:this.filePattern,searchPath:this.getSearchPath(i,this.filePattern)});const y=g=>{const _=I.basename(g),w=I.dirname(g);let F=h[w];F||(F=h[w]=[],y(w)),F.push({base:c,relativePath:g,basename:_,searchPath:this.getSearchPath(i,g)})};d.forEach(y)}matchDirectoryTree({rootEntries:i,pathToEntries:h},c,d){const b=this,y=this.folderExcludePatterns.get(c),g=this.filePattern;function _(w){b.directoriesWalked++;const F=D.hasSiblingFn(()=>w.map(N=>N.basename));for(let N=0,G=w.length;N<G;N++){const K=w[N],{relativePath:U,basename:z}=K;if(y.test(U,z,g!==z?F:void 0))continue;const O=h[U];if(O)_(O);else{if(b.filesWalked++,U===g)continue;b.matchFile(d,K)}if(b.isLimitHit)break}}_(i)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(i,h,c,d,b){const y=i.folder,g=D.hasSiblingFn(()=>c);this.parallel(c,(_,w)=>{if(this.isCanceled||this.isLimitHit)return w(null);const F=h?[h,_].join(I.sep):_;if(this.folderExcludePatterns.get(i.folder.fsPath).test(F,_,this.config.filePattern!==_?g:void 0))return w(null);const N=[y.fsPath,F].join(I.sep);L.lstat(N,(G,K)=>{if(G||this.isCanceled||this.isLimitHit)return w(null);this.statLinkIfNeeded(N,K,(U,z)=>U||this.isCanceled||this.isLimitHit?w(null):z.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(N,K,(O,B)=>O||this.isCanceled||this.isLimitHit||(B=B||"",this.walkedPaths[B])?w(null):(this.walkedPaths[B]=!0,v.Promises.readdir(N).then(x=>{if(this.isCanceled||this.isLimitHit)return w(null);this.doWalk(i,F,x,d,M=>w(M||null))},x=>{w(null)})))):(this.filesWalked++,F===this.filePattern||this.maxFilesize&&l.isNumber(z.size)&&z.size>this.maxFilesize||this.matchFile(d,{base:y.fsPath,relativePath:F,searchPath:this.getSearchPath(i,F)}),w(null,void 0)))})},_=>{const w=_&&R.coalesce(_);return b(w&&w.length>0?w[0]:void 0)})}matchFile(i,h){this.isFileMatch(h)&&(!this.includePattern||this.includePattern(h.relativePath,I.basename(h.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||i(h))}isFileMatch(i){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,S.isFilePatternMatch)(i,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(i,h,c){return h.isSymbolicLink()?L.stat(i,c):c(null,h)}realPathIfNeeded(i,h,c){return h.isSymbolicLink()?L.realpath(i,(d,b)=>d?c(d):c(null,b)):c(null,i)}getSearchPath(i,h){return i.folderName?I.join(i.folderName,h):h}}e.FileWalker=a;class p{constructor(i){this.folderQueries=i.folderQueries,this.extraFiles=i.extraFileResources||[],this.walker=new a(i)}search(i,h,c){this.walker.walk(this.folderQueries,this.extraFiles,i,h,(d,b)=>{c(d,{limitHit:b,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=p;class t{constructor(i,h){this.expression=i,this.root=h,this.init(i)}init(i){let h,c;Object.keys(i).filter(d=>i[d]).forEach(d=>{I.isAbsolute(d)?(h=h||D.getEmptyExpression(),h[d]=i[d]):(c=c||D.getEmptyExpression(),c[d]=i[d])}),this.absoluteParsedExpr=h&&D.parse(h,{trimForExclusions:!0}),this.relativeParsedExpr=c&&D.parse(c,{trimForExclusions:!0})}test(i,h,c){return this.relativeParsedExpr&&this.relativeParsedExpr(i,h,c)||this.absoluteParsedExpr&&this.absoluteParsedExpr(I.join(this.root,i),h,c)}getBasenameTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...D.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...D.getBasenameTerms(this.relativeParsedExpr)),i}getPathTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...D.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...D.getPathTerms(this.relativeParsedExpr)),i}}function o(r){const i=r.trim().split(`
`),h=i[0].trim();if(h.startsWith("Error parsing regex"))return h;if(h.startsWith("regex parse error"))return f.uppercaseFirstLetter(i[i.length-1].trim());if(h.startsWith("error parsing glob")||h.startsWith("unsupported encoding"))return h.charAt(0).toUpperCase()+h.substr(1);if(h==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(h.startsWith("Literal "))return h}e.rgErrorMsgForDisplay=o}),define(me[135],ge([0,1,39,297,104,17,57,30,8,9,2,31,71,298,281,93]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const S=l.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class P{constructor(y){this.outputChannel=y}provideTextSearchResults(y,g,_,w){return this.outputChannel.appendLine(`provideTextSearchResults ${y.pattern}, ${JSON.stringify({...g,folder:g.folder.toString()})}`),new Promise((F,N)=>{w.onCancellationRequested(()=>M());const G=o(y,g),K=g.folder.fsPath,U=G.map(he=>he.match(/^-/)?he:`'${he}'`).join(" ");this.outputChannel.appendLine(`${S} ${U}
 - cwd: ${K}`);let z=m.spawn(S,G,{cwd:K});z.on("error",he=>{console.error(he),this.outputChannel.appendLine("Error: "+(he&&he.message)),N((0,A.serializeSearchError)(new A.SearchError(he&&he.message,A.SearchErrorCode.rgProcessError)))});let O=!1;const B=new a(g.maxResults,K,g.previewOptions);B.on("result",he=>{O=!0,W="",_.report(he)});let x=!1;const M=()=>{x=!0,z&&z.kill(),B&&B.cancel()};let H=!1;B.on("hitLimit",()=>{H=!0,M()});let W="";z.stdout.on("data",he=>{B.handleData(he),O||(W+=he)});let Q=!1;z.stdout.once("data",()=>Q=!0);let X="";z.stderr.on("data",he=>{const _e=he.toString();this.outputChannel.appendLine(_e),X+=_e}),z.on("close",()=>{if(this.outputChannel.appendLine(Q?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(O?"Got result from parser":"No result from parser"),W&&this.outputChannel.appendLine(`Got data without result: ${W}`),this.outputChannel.appendLine(""),x)F({limitHit:H});else{B.flush(),z=null;let he;X&&!Q&&(he=E(X))?N((0,A.serializeSearchError)(new A.SearchError(he.message,he.code))):F({limitHit:H})}})})}}e.RipgrepTextSearchEngine=P;function E(b){const y=b.split(`
`),g=y[0].trim();if(y.some(w=>w.startsWith("regex parse error")))return new A.SearchError(s(y),A.SearchErrorCode.regexParseError);const _=g.match(/grep config error: unknown encoding: (.*)/);if(_)return new A.SearchError(`Unknown encoding: ${_[1]}`,A.SearchErrorCode.unknownEncoding);if(g.startsWith("error parsing glob"))return new A.SearchError(g.charAt(0).toUpperCase()+g.substr(1),A.SearchErrorCode.globParseError);if(g.startsWith("the literal"))return new A.SearchError(g.charAt(0).toUpperCase()+g.substr(1),A.SearchErrorCode.invalidLiteral);if(g.startsWith("PCRE2: error compiling pattern"))return new A.SearchError(g,A.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=E;function s(b){const y=["Regex parse error"],g=b.filter(_=>_.startsWith("PCRE2:"));if(g.length>=1){const _=g[0].replace("PCRE2:","");if(_.indexOf(":")!==-1&&_.split(":").length>=2){const w=_.split(":")[1];y.push(":"+w)}}return y.join("")}e.buildRegexParseError=s;class a extends L.EventEmitter{constructor(y,g,_){super();this.maxResults=y,this.rootFolder=g,this.previewOptions=_,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new I.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(y,g){return super.on(y,g),this}handleData(y){if(this.isDone)return;const g=typeof y=="string"?y:this.stringDecoder.write(y);this.handleDecodedData(g)}handleDecodedData(y){let g=y.indexOf(`
`);const _=this.remainder+y;if(g>=0)g+=this.remainder.length;else{this.remainder=_;return}let w=0;for(;g>=0;)this.handleLine(_.substring(w,g).trim()),w=g+1,g=_.indexOf(`
`,w);this.remainder=_.substring(w)}handleLine(y){if(this.isDone||!y)return;let g;try{g=JSON.parse(y)}catch(_){throw new Error(`malformed line from rg: ${y}`)}if(g.type==="match"){const _=p(g.data.path),w=n.URI.file(D.join(this.rootFolder,_)),F=this.createTextSearchMatch(g.data,w);this.onResult(F),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(g.type==="context"){const _=p(g.data.path),w=n.URI.file(D.join(this.rootFolder,_));this.createTextSearchContext(g.data,w).forEach(N=>this.onResult(N))}}createTextSearchMatch(y,g){const _=y.line_number-1,w=p(y.lines),F=Buffer.from(w);let N=0,G=0,K=_;y.submatches.length===0&&y.submatches.push(w.length?{start:0,end:1,match:{text:w[0]}}:{start:0,end:0,match:{text:""}});const U=(0,k.coalesce)(y.submatches.map((z,O)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const B=p(z.match),x=F.slice(N,z.start).toString().length,M=G+x,H=t(B),W=K,Q=H.numLines+W,X=H.numLines>0?H.lastLineLength:H.lastLineLength+M;return N=z.end,G=X,K=Q,new u.Range(W,M,Q,X)}));return(0,v.createTextSearchResult)(g,w,U,this.previewOptions)}createTextSearchContext(y,g){const _=p(y.lines),w=y.line_number;return _.replace(/\r?\n$/,"").split(`
`).map((F,N)=>({text:F,uri:g,lineNumber:w+N}))}onResult(y){this.emit("result",y)}}e.RipgrepParser=a;function p(b){return b.bytes?Buffer.from(b.bytes,"base64").toString():b.text}function t(b){const y=/\n/g;let g=0,_=-1,w;for(;w=y.exec(b);)g++,_=w.index;const F=_>=0?b.length-_-1:b.length;return{numLines:g,lastLineLength:F}}function o(b,y){const g=["--hidden"];g.push(b.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:_,otherIncludes:w}=(0,R.groupBy)(y.includes,N=>N.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(w&&w.length){const N=new Set;w.forEach(G=>{N.add(G)}),g.push("-g","!*"),N.forEach(G=>{r(G).map(v.anchorGlob).forEach(K=>{g.push("-g",K)})})}_&&_.length&&_.forEach(N=>{g.push("-g",N)}),y.excludes.map(v.anchorGlob).forEach(N=>g.push("-g",`!${N}`)),y.maxFileSize&&g.push("--max-filesize",y.maxFileSize+""),y.useIgnoreFiles?g.push("--no-ignore-parent"):g.push("--no-ignore"),y.followSymlinks&&g.push("--follow"),y.encoding&&y.encoding!=="utf8"&&g.push("--encoding",y.encoding),b.pattern==="--"&&(b.isRegExp=!0,b.pattern="\\-\\-"),b.isMultiline&&!b.isRegExp&&(b.pattern=(0,T.escapeRegExpCharacters)(b.pattern),b.isRegExp=!0),y.usePCRE2&&g.push("--pcre2"),g.push("--crlf"),b.isRegExp&&(b.pattern=i(b.pattern),g.push("--auto-hybrid-regex"));let F;if(b.isWordMatch){const G=(0,T.createRegExp)(b.pattern,!!b.isRegExp,{wholeWord:b.isWordMatch}).source.replace(/\\\//g,"/");g.push("--regexp",G)}else if(b.isRegExp){let N=c(b.pattern);N=d(N),g.push("--regexp",N)}else F=b.pattern,g.push("--fixed-strings");return g.push("--no-config"),y.useGlobalIgnoreFiles||g.push("--no-ignore-global"),g.push("--json"),b.isMultiline&&g.push("--multiline"),y.beforeContext&&g.push("--before-context",y.beforeContext+""),y.afterContext&&g.push("--after-context",y.afterContext+""),g.push("--"),F&&g.push(F),g.push("."),g}function r(b){const y=(0,C.splitGlobAware)(b,"/");return y.map((g,_)=>y.slice(0,_+1).join("/"))}e.spreadGlobComponents=r;function i(b){const y=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;b.match(y);)b=b.replace(y,"$1\\x{$2}");const g=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;b.match(g);)b=b.replace(g,"$1\\x{$2}");return b}e.unicodeEscapesToPCRE2=i;const h=b=>b.type==="Assertion"&&b.kind==="lookbehind";function c(b){let y;try{y=new f.RegExpParser().parsePattern(b)}catch{return b}let g="",_=0;const w=(G,K,U)=>{g+=b.slice(_,G)+U,_=K},F=[];return new f.RegExpVisitor({onCharacterEnter(G){if(G.raw!=="\\n")return;const K=F[0];if(!K)w(G.start,G.end,"\\r?\\n");else if(!F.some(h))if(K.type==="CharacterClass")if(K.negate){const U=b.slice(K.start+2,G.start)+b.slice(G.end,K.end-1);w(K.start,K.end,"(?!\\r?\\n"+(U?`|[${U}]`:"")+")")}else{const U=b.slice(K.start+1,G.start)+b.slice(G.end,K.end-1);w(K.start,K.end,U===""?"\\r?\\n":`(?:[${U}]|\\r?\\n)`)}else K.type==="Quantifier"&&w(G.start,G.end,"(?:\\r?\\n)")},onQuantifierEnter(G){F.unshift(G)},onQuantifierLeave(){F.shift()},onCharacterClassRangeEnter(G){F.unshift(G)},onCharacterClassRangeLeave(){F.shift()},onCharacterClassEnter(G){F.unshift(G)},onCharacterClassLeave(){F.shift()},onAssertionEnter(G){h(G)&&F.push(G)},onAssertionLeave(G){F[0]===G&&F.shift()}}).visit(y),g+=b.slice(_),g}e.fixRegexNewline=c;function d(b){return b.replace(/\n/g,"\\r?\\n")}e.fixNewline=d}),define(me[283],ge([0,1,21,135,118,10]),function(J,e,m,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class R{constructor(T){this.outputChannel=T,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(T,n,A,u){const f=new L.RipgrepTextSearchEngine(this.outputChannel);if(n.folder.scheme===k.Schemas.userData){const l={...n,folder:n.folder.with({scheme:k.Schemas.file})},v=new I.Progress(S=>A.report({...S,uri:S.uri.with({scheme:n.folder.scheme})}));return this.withToken(u,S=>f.provideTextSearchResults(T,l,v,S))}else return this.withToken(u,l=>f.provideTextSearchResults(T,n,A,l))}async withToken(T,n){const A=C(T);this.inProgress.add(A);const u=await n(A.token);return this.inProgress.delete(A),u}dispose(){this.inProgress.forEach(T=>T.cancel())}}e.RipgrepSearchProvider=R;function C(D){const T=new m.CancellationTokenSource;return D.onCancellationRequested(()=>T.cancel()),T}}),define(me[284],ge([0,1,28,135,134]),function(J,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class k{constructor(D){this.query=D}search(D,T,n){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const A={appendLine(f){n({message:f})}},u=new I.NativeTextSearchManager(this.query,new L.RipgrepTextSearchEngine(A),m);return new Promise((f,l)=>u.search(v=>{T(v.map(R))},D).then(v=>f({limitHit:v.limitHit,type:"success",stats:v.stats}),l))}}e.TextSearchEngineAdapter=k;function R(C){return{path:C.resource&&C.resource.fsPath,results:C.results,numMatches:(C.results||[]).reduce((D,T)=>{if(T.ranges){const n=T;return D+(Array.isArray(n.ranges)?n.ranges.length:1)}else return D+1},0)}}}),define(me[285],ge([0,1,50,299,17,18,16,3,101,8,46,2,42,31,282,284]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,L.gracefulify(m);class S{constructor(t="searchProcess"){this.processType=t,this.caches=Object.create(null)}fileSearch(t){let o;const r=s(t),i=new C.Emitter({onFirstListenerDidAdd:()=>{o=(0,k.createCancelablePromise)(h=>this.doFileSearchWithEngine(l.Engine,r,c=>i.fire(c),h)),o.then(h=>i.fire(h),h=>i.fire({type:"error",error:{message:h.message,stack:h.stack}}))},onLastListenerRemove:()=>{o.cancel()}});return i.event}textSearch(t){let o;const r=s(t),i=new C.Emitter({onFirstListenerDidAdd:()=>{o=(0,k.createCancelablePromise)(h=>this.ripgrepTextSearch(r,c=>i.fire(c),h)),o.then(h=>i.fire(h),h=>i.fire({type:"error",error:{message:h.message,stack:h.stack}}))},onLastListenerRemove:()=>{o.cancel()}});return i.event}ripgrepTextSearch(t,o,r){return t.maxFileSize=(0,u.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new v.TextSearchEngineAdapter(t).search(r,o,o)}doFileSearch(t,o,r){return this.doFileSearchWithEngine(l.Engine,t,o,r)}doFileSearchWithEngine(t,o,r,i,h=S.BATCH_SIZE){let c=0;const d=y=>{Array.isArray(y)?(c+=y.length,r(y.map(g=>this.rawMatchToSearchItem(g)))):y.relativePath?(c++,r(this.rawMatchToSearchItem(y))):r(y)};if(o.sortByScore){let y=this.trySortedSearchFromCache(o,d,i);if(!y){const g=o.maxResults?Object.assign({},o,{maxResults:null}):o,_=new t(g);y=this.doSortedSearch(_,o,r,d,i)}return new Promise((g,_)=>{y.then(([w,F])=>{const N=F.map(G=>this.rawMatchToSearchItem(G));this.sendProgress(N,r,h),g(w)},_)})}const b=new t(o);return this.doSearch(b,d,h,i).then(y=>({limitHit:y.limitHit,type:"success",stats:{detailStats:y.stats,type:this.processType,fromCache:!1,resultCount:c,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,T.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,o,r,i,h){const c=new C.Emitter;let d=(0,k.createCancelablePromise)(y=>{let g=[];const _=w=>{Array.isArray(w)?g=w:(i(w),c.fire(w))};return this.doSearch(t,_,-1,y).then(w=>[w,g])}),b;if(o.cacheKey){b=this.getOrCreateCache(o.cacheKey);const y={promise:d,event:c.event,resolved:!1};b.resultsToSearchCache[o.filePattern||""]=y,d.then(()=>{y.resolved=!0},g=>{delete b.resultsToSearchCache[o.filePattern||""]}),d=this.preventCancellation(d)}return d.then(([y,g])=>{const _=b?b.scorerCache:Object.create(null),w=(typeof o.maxResults!="number"||o.maxResults>0)&&n.StopWatch.create(!1);return this.sortResults(o,g,_,h).then(F=>{const N=w?w.elapsed():-1;return[{type:"success",stats:{detailStats:y.stats,sortingTime:N,fromCache:!1,type:this.processType,workspaceFolderCount:o.folderQueries.length,resultCount:F.length},messages:y.messages,limitHit:y.limitHit||typeof o.maxResults=="number"&&g.length>o.maxResults},F]})})}getOrCreateCache(t){const o=this.caches[t];return o||(this.caches[t]=new P)}trySortedSearchFromCache(t,o,r){const i=t.cacheKey&&this.caches[t.cacheKey];if(!i)return;const h=this.getResultsFromCache(i,t.filePattern||"",o,r);if(h)return h.then(([c,d,b])=>{const y=n.StopWatch.create(!1);return this.sortResults(t,d,i.scorerCache,r).then(g=>{const _=y.elapsed(),w={fromCache:!0,detailStats:b,type:this.processType,resultCount:d.length,sortingTime:_};return[{type:"success",limitHit:c.limitHit||typeof t.maxResults=="number"&&d.length>t.maxResults,stats:w},g]})})}sortResults(t,o,r,i){const h=(0,D.prepareQuery)(t.filePattern||""),c=(b,y)=>(0,D.compareItemsByFuzzyScore)(b,y,h,!0,E,r),d=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return I.topAsync(o,c,d,1e4,i)}sendProgress(t,o,r){if(r&&r>0)for(let i=0;i<t.length;i+=r)o(t.slice(i,i+r));else o(t)}getResultsFromCache(t,o,r,i){const h=n.StopWatch.create(!1),c=o.indexOf(T.sep)>=0;let d;for(const _ in t.resultsToSearchCache)if(o.startsWith(_)){if(c&&_.indexOf(T.sep)<0&&_!=="")continue;const w=t.resultsToSearchCache[_];d={promise:this.preventCancellation(w.promise),event:w.event,resolved:w.resolved};break}if(!d)return null;const b=h.elapsed(),y=n.StopWatch.create(!1),g=d.event(r);return i&&i.onCancellationRequested(()=>{g.dispose()}),d.promise.then(([_,w])=>{if(i&&i.isCancellationRequested)throw(0,R.canceled)();const F=[],N=(0,D.prepareQuery)(o).normalizedLowercase;for(const G of w)!(0,f.isFilePatternMatch)(G,N)||F.push(G);return[_,F,{cacheWasResolved:d.resolved,cacheLookupTime:b,cacheFilterTime:y.elapsed(),cacheEntryCount:w.length}]})}doSearch(t,o,r,i){return new Promise((h,c)=>{let d=[];i&&i.onCancellationRequested(()=>t.cancel()),t.search(b=>{b&&(r?(d.push(b),r>0&&d.length>=r&&(o(d),d=[])):o(b))},b=>{o(b)},(b,y)=>{d.length&&o(d),b?c(b):h(y)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(o,r){return t.then(o,r)}catch(o){return this.then(void 0,o)}finally(o){return t.finally(o)}}}}e.SearchService=S,S.BATCH_SIZE=512;class P{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const E=new class{getItemLabel(p){return(0,T.basename)(p.relativePath)}getItemDescription(p){return(0,T.dirname)(p.relativePath)}getItemPath(p){return p.relativePath}};function s(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(a),extraFileResources:p.extraFileResources&&p.extraFileResources.map(t=>A.URI.revive(t))}}function a(p){return{...p,folder:A.URI.revive(p.folder)}}}),define(me[286],ge([0,1,6,10,2,28,12,27,14,74,65,31,285,283,93,134]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let S=class extends T.ExtHostSearch{constructor(E,s,a,p){super(E,a,p);this._pfs=k,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const t=new l.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(L.Schemas.userData,new f.RipgrepSearchProvider(t)),s.remote.isRemote&&s.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const E=new l.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(L.Schemas.file,new f.RipgrepSearchProvider(E)),this.registerInternalFileSearchProvider(L.Schemas.file,new u.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(E,s){const a=this._handlePool++;return this._internalFileSearchProvider=s,this._internalFileSearchHandle=a,this._proxy.$registerFileSearchProvider(a,this._transformScheme(E)),(0,m.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(a)})}$provideFileSearchResults(E,s,a,p){const t=(0,T.reviveQuery)(a);return E===this._internalFileSearchHandle?this.doInternalFileSearch(E,s,t,p):super.$provideFileSearchResults(E,s,a,p)}doInternalFileSearch(E,s,a,p){const t=o=>{if((0,A.isSerializedFileMatch)(o)&&(o=[o]),Array.isArray(o)){this._proxy.$handleFileMatch(E,s,o.map(r=>I.URI.file(r.path)));return}o.message&&this._logService.debug("ExtHostSearch",o.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(a,t,p)}$clearCache(E){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(E),super.$clearCache(E)}createTextSearchManager(E,s){return new v.NativeTextSearchManager(E,s,void 0,"textSearchProvider")}};S=Ve([We(0,D.IExtHostRpcService),We(1,C.IExtHostInitDataService),We(2,n.IURITransformerService),We(3,R.ILogService)],S),e.NativeExtHostSearch=S}),define(me[136],ge([0,1,300,125,80,23,16,3,6,8,11,32,106,107,301]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class v{constructor(d){this.socket=d,this._errorListener=b=>{if(b){if(b.code==="EPIPE")return;(0,R.onUnexpectedError)(b)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(d){const b=y=>d(k.VSBuffer.wrap(y));return this.socket.on("data",b),{dispose:()=>this.socket.off("data",b)}}onClose(d){const b=y=>{d({type:0,hadError:y,error:void 0})};return this.socket.on("close",b),{dispose:()=>this.socket.off("close",b)}}onEnd(d){return this.socket.on("end",d),{dispose:()=>this.socket.off("end",d)}}write(d){if(!this.socket.destroyed)try{this.socket.write(d.buffer,b=>{if(b){if(b.code==="EPIPE")return;(0,R.onUnexpectedError)(b)}})}catch(b){if(b.code==="EPIPE")return;(0,R.onUnexpectedError)(b)}}end(){this.socket.end()}drain(){return new Promise((d,b)=>{if(this.socket.bufferSize===0){d();return}const y=()=>{this.socket.off("close",y),this.socket.off("end",y),this.socket.off("error",y),this.socket.off("timeout",y),this.socket.off("drain",y),d()};this.socket.on("close",y),this.socket.on("end",y),this.socket.on("error",y),this.socket.on("timeout",y),this.socket.on("drain",y)})}}e.NodeSocket=v;var S;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(S||(S={}));var P;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(P||(P={}));class E extends D.Disposable{constructor(d,b,y,g){super();this._onDidZlibFlush=this._register(new C.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new C.Emitter),this._onClose=this._register(new C.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=d,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=b,this._recordInflateBytes=g,b?(this._zlibInflate=l.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",_=>{console.error(_),(0,R.onUnexpectedError)(_),this._onClose.fire({type:0,hadError:!0,error:_})}),this._zlibInflate.on("data",_=>{this._pendingInflateData.push(_)}),y&&(this._zlibInflate.write(y.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=l.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",_=>{console.error(_),(0,R.onUnexpectedError)(_),this._onClose.fire({type:0,hadError:!0,error:_})}),this._zlibDeflate.on("data",_=>{this._pendingDeflateData.push(_)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new f.ChunkStream,this._register(this.socket.onData(_=>this._acceptChunk(_))),this._register(this.socket.onClose(_=>this._onClose.fire(_)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?k.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):k.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(d){return this._onData.event(d)}onClose(d){return this._onClose.event(d)}onEnd(d){return this.socket.onEnd(d)}write(d){this._totalOutgoingDataBytes+=d.byteLength,this._zlibDeflate?(this._zlibDeflate.write(d.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let b=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,b=b.slice(0,b.length-4),this._isEnded||this._write(k.VSBuffer.wrap(b),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(d,!1)}_write(d,b){let y=2;d.byteLength<126?y+=0:d.byteLength<2**16?y+=2:y+=8;const g=k.VSBuffer.alloc(y);if(b?g.writeUInt8(194,0):g.writeUInt8(130,0),d.byteLength<126)g.writeUInt8(d.byteLength,1);else if(d.byteLength<2**16){g.writeUInt8(126,1);let _=1;g.writeUInt8(d.byteLength>>>8&255,++_),g.writeUInt8(d.byteLength>>>0&255,++_)}else{g.writeUInt8(127,1);let _=1;g.writeUInt8(0,++_),g.writeUInt8(0,++_),g.writeUInt8(0,++_),g.writeUInt8(0,++_),g.writeUInt8(d.byteLength>>>24&255,++_),g.writeUInt8(d.byteLength>>>16&255,++_),g.writeUInt8(d.byteLength>>>8&255,++_),g.writeUInt8(d.byteLength>>>0&255,++_)}this._totalOutgoingWireBytes+=g.byteLength+d.byteLength,this.socket.write(k.VSBuffer.concat([g,d]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(d){if(d.byteLength!==0){for(this._totalIncomingWireBytes+=d.byteLength,this._incomingData.acceptChunk(d);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const b=this._incomingData.peek(this._state.readLen),g=(b.readUInt8(0)&128)>>>7,_=b.readUInt8(1),w=(_&128)>>>7,F=_&127;this._state.state=2,this._state.readLen=2+(w?4:0)+(F===126?2:0)+(F===127?8:0),this._state.fin=g,this._state.mask=0}else if(this._state.state===2){const b=this._incomingData.read(this._state.readLen),y=b.readUInt8(1),g=(y&128)>>>7;let _=y&127,w=1;_===126?_=b.readUInt8(++w)*2**8+b.readUInt8(++w):_===127&&(_=b.readUInt8(++w)*0+b.readUInt8(++w)*0+b.readUInt8(++w)*0+b.readUInt8(++w)*0+b.readUInt8(++w)*2**24+b.readUInt8(++w)*2**16+b.readUInt8(++w)*2**8+b.readUInt8(++w));let F=0;g&&(F=b.readUInt8(++w)*2**24+b.readUInt8(++w)*2**16+b.readUInt8(++w)*2**8+b.readUInt8(++w)),this._state.state=3,this._state.readLen=_,this._state.mask=F}else if(this._state.state===3){const b=this._incomingData.read(this._state.readLen);s(b,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(b.buffer)),this._zlibInflate.write(b.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const y=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=y.length,this._onData.fire(k.VSBuffer.wrap(y))})):(this._totalIncomingDataBytes+=b.byteLength,this._onData.fire(b))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await C.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=E;function s(c,d){if(d===0)return;let b=c.byteLength>>>2;for(let N=0;N<b;N++){const G=c.readUInt32BE(N*4);c.writeUInt32BE(G^d,N*4)}let y=b*4,g=c.byteLength-y;const _=d>>>24&255,w=d>>>16&255,F=d>>>8&255;g>=1&&c.writeUInt8(c.readUInt8(y)^_,y),g>=2&&c.writeUInt8(c.readUInt8(y+1)^w,y+1),g>=3&&c.writeUInt8(c.readUInt8(y+2)^F,y+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function p(){const c=(0,A.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let d;return e.XDG_RUNTIME_DIR?d=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):d=(0,T.join)((0,I.tmpdir)(),`vscode-ipc-${c}.sock`),o(d),d}e.createRandomIPCHandle=p;function t(c,d,b){const y=(0,m.createHash)("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${y}-${b}-${d}-sock`;let g;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?g=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-${y.substr(0,8)}-${b}-${d}.sock`):g=(0,T.join)(c,`${b}-${d}.sock`),o(g),g}e.createStaticIPCHandle=t;function o(c){const d=a[n.platform];typeof d=="number"&&c.length>=d&&console.warn(`WARNING: IPC handle "${c}" is longer than ${d} chars, try a shorter --user-data-dir`)}class r extends u.IPCServer{constructor(d){super(r.toClientConnectionEvent(d));this.server=d}static toClientConnectionEvent(d){const b=C.Event.fromNodeEventEmitter(d,"connection");return C.Event.map(b,y=>({protocol:new f.Protocol(new v(y)),onDidClientDisconnect:C.Event.once(C.Event.fromNodeEventEmitter(y,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function i(c){return new Promise((d,b)=>{const y=(0,L.createServer)();y.on("error",b),y.listen(c,()=>{y.removeListener("error",b),d(new r(y))})})}e.serve=i;function h(c,d){return new Promise((b,y)=>{const g=(0,L.createConnection)(c,()=>{g.removeListener("error",y),b(f.Client.fromSocket(new v(g),d))});g.once("error",y)})}e.connect=h}),define(me[287],ge([0,1,136,279,50,44,2,199,12]),function(J,e,m,L,I,k,R,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class T{constructor(u,f,l){this._commands=u,this.logService=f,this._ipcHandlePath=l,this._server=L.createServer((v,S)=>this.onRequest(v,S)),this.setup().catch(v=>(f.error(v),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",u=>this.logService.error(u))}catch(u){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(u,f){const l=[];u.setEncoding("utf8"),u.on("data",v=>l.push(v)),u.on("end",()=>{const v=JSON.parse(l.join(""));switch(v.type){case"open":this.open(v,f);break;case"openExternal":this.openExternal(v,f);break;case"status":this.getStatus(v,f);break;case"extensionManagement":this.manageExtensions(v,f).catch(this.logService.error);break;default:f.writeHead(404),f.write(`Unknown message type: ${v.type}`,S=>{S&&this.logService.error(S)}),f.end();break}})}open(u,f){let{fileURIs:l,folderURIs:v,forceNewWindow:S,diffMode:P,addMode:E,forceReuseWindow:s,gotoLineMode:a,waitMarkerFilePath:p}=u;const t=[];if(Array.isArray(v))for(const o of v)try{t.push({folderUri:R.URI.parse(o)})}catch(r){}if(Array.isArray(l))for(const o of l)try{(0,C.hasWorkspaceFileExtension)(o)?t.push({workspaceUri:R.URI.parse(o)}):t.push({fileUri:R.URI.parse(o)})}catch(r){}if(t.length){const o=p?R.URI.file(p):void 0,i={forceNewWindow:S,diffMode:P,addMode:E,gotoLineMode:a,forceReuseWindow:s,preferNewWindow:!s&&!o&&!E,waitMarkerFileURI:o};this._commands.executeCommand("_remoteCLI.windowOpen",t,i)}f.writeHead(200),f.end()}async openExternal(u,f){for(const l of u.uris){const v=R.URI.parse(l),S=v.scheme==="file"?v:l;await this._commands.executeCommand("_remoteCLI.openExternal",S)}f.writeHead(200),f.end()}async manageExtensions(u,f){try{const l=P=>P?.map(E=>/\.vsix$/i.test(E)?R.URI.parse(E):E),v={list:u.list,install:l(u.install),uninstall:l(u.uninstall),force:u.force},S=await this._commands.executeCommand("_remoteCLI.manageExtensions",v);f.writeHead(200),f.write(S)}catch(l){f.writeHead(500),f.write(String(l),v=>{v&&this.logService.error(v)})}f.end()}async getStatus(u,f){try{const l=await this._commands.executeCommand("_remoteCLI.getSystemStatus");f.writeHead(200),f.write(l),f.end()}catch(l){f.writeHead(500),f.write(String(l),v=>{v&&this.logService.error(v)}),f.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&I.existsSync(this._ipcHandlePath)&&I.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=T;let n=class extends T{constructor(u,f){super(u,f,(0,m.createRandomIPCHandle)())}};n=Ve([We(0,k.IExtHostCommands),We(1,D.ILogService)],n),e.CLIServer=n}),define(me[288],ge([0,1,73,275,270,5,278,40,260,2,10,7,287,105]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class l extends I.RequireInterceptor{_installInterceptor(){const P=this,E=J.__$__nodeRequire("module"),s=E._load;E._load=function(p,t,o){for(let r of P._alternatives){let i=r(p);if(i){p=i;break}}return P._factories.has(p)?P._factories.get(p).load(p,T.URI.file((0,f.realpathSync)(t.filename)),r=>s.apply(this,[r,t,o])):s.apply(this,arguments)}}}class v extends C.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=A.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const P=this._instaService.invokeFunction(L.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(D.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(u.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(l,P,this._registry).install(),m.mark("code/extHost/didInitAPI");const s=await this._extHostConfiguration.getConfigProvider();await(0,R.connectProxyResolver)(this._extHostWorkspace,s,this,this._logService,this._mainThreadTelemetryProxy,this._initData),m.mark("code/extHost/didInitProxyResolver");const a=process.send,p=this._extHostContext.getProxy(k.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?a.apply(process,t):(p.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(P){return P.main}_loadCommonJSModule(P,E,s){if(E.scheme!==n.Schemas.file)throw new Error(`Cannot load URI: '${E}', must be of file-scheme`);let a=null;s.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${E.toString(!0)}`),this._logService.flush();try{P&&m.mark(`code/extHost/willLoadExtensionCode/${P.value}`),a=J.__$__nodeRequire(E.fsPath)}catch(p){return Promise.reject(p)}finally{P&&m.mark(`code/extHost/didLoadExtensionCode/${P.value}`),s.codeLoadingStop()}return Promise.resolve(a)}async $setRemoteEnvironment(P){if(!!this._initData.remote.isRemote)for(const E in P){const s=P[E];s===null?delete process.env[E]:process.env[E]=s}}}e.ExtHostExtensionService=v}),define(me[289],ge([0,1,82,261,263,272,271,286,288,228,264,55,40,68,74,72,33,53,12,69,262]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,l,v,S,P,E,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.registerSingleton)(u.IExtHostExtensionService,D.ExtHostExtensionService),(0,m.registerSingleton)(E.ILogService,T.ExtHostLogService),(0,m.registerSingleton)(s.IExtensionStoragePaths,a.ExtensionStoragePaths),(0,m.registerSingleton)(A.IExtHostDebugService,R.ExtHostDebugService),(0,m.registerSingleton)(f.IExtHostOutputService,L.ExtHostOutputService2),(0,m.registerSingleton)(l.IExtHostSearch,C.NativeExtHostSearch),(0,m.registerSingleton)(v.IExtHostTask,k.ExtHostTask),(0,m.registerSingleton)(S.IExtHostTerminalService,I.ExtHostTerminalService),(0,m.registerSingleton)(P.IExtHostTunnelService,n.ExtHostTunnelService)}),define(me[290],ge([0,1,125,302,73,16,107,136,191,226,273,23,103,28,105,18,114,276,289]),function(J,e,m,L,I,k,R,C,D,T,n,A,u,f,l,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let h=0;h<process.execArgv.length;h++)process.execArgv[h]==="--inspect-port=0"&&(process.execArgv.splice(h,1),h--)}();const P=L(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"],boolean:["skipWorkspaceStorageLock"]});(function(){const i=J.__$__nodeRequire("module"),h=i._load;i._load=function(c){if(c==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return h.apply(this,arguments)}})();const E=process.exit.bind(process);function s(i){process.exit=function(h){if(i)E(h);else{const c=new Error("An extension called process.exit() and this was prevented.");console.warn(c.stack)}},process.crash=function(){const h=new Error("An extension called process.crash() and this was prevented.");console.warn(h.stack)}}let a=function(i){E()};function p(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((i,h)=>{let c=null,d=setTimeout(()=>{a("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const b=108e5,y=3e5,g=new v.ProcessTimeRunOnceScheduler(()=>a("renderer disconnected for too long (1)"),b),_=new v.ProcessTimeRunOnceScheduler(()=>a("renderer disconnected for too long (2)"),y);process.on("message",(F,N)=>{if(F&&F.type==="VSCODE_EXTHOST_IPC_SOCKET"){const G=A.VSBuffer.wrap(Buffer.from(F.initialDataChunk,"base64"));let K;if(F.skipWebSocketFrames)K=new C.NodeSocket(N);else{const U=A.VSBuffer.wrap(Buffer.from(F.inflateBytes,"base64"));K=new C.WebSocketNodeSocket(new C.NodeSocket(N),F.permessageDeflate,U,!1)}c?(g.cancel(),_.cancel(),c.beginAcceptReconnection(K,G),c.endAcceptReconnection()):(clearTimeout(d),c=new R.PersistentProtocol(K,G),c.onDidDispose(()=>a("renderer disconnected")),i(c),c.onSocketClose(()=>{g.schedule()}))}if(F&&F.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(_.isScheduled())return;g.isScheduled()&&_.schedule()}});const w={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(w)});{const i=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((h,c)=>{const d=m.createConnection(i,()=>{d.removeListener("error",c),h(new R.PersistentProtocol(new C.NodeSocket(d)))});d.once("error",c),d.on("close",()=>{a("renderer closed the socket")})})}}async function t(){const i=await p();return new class{constructor(){this._onMessage=new R.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,i.onMessage(h=>{(0,T.isMessageOfType)(h,2)?(this._terminating=!0,a("received terminate message from renderer")):this._onMessage.fire(h)})}send(h){this._terminating||i.send(h)}drain(){return i.drain()}}}function o(i){return new Promise(h=>{const c=i.onMessage(d=>{c.dispose();const b=JSON.parse(d.toString()),y=b.commit,g=D.default.commit;y&&g&&y!==g&&E(55);const _=[];process.on("unhandledRejection",(N,G)=>{_.push(G),setTimeout(()=>{const K=_.indexOf(G);K>=0&&G.catch(U=>{_.splice(K,1),(0,k.isPromiseCanceledError)(U)||(console.warn(`rejected promise not handled within 1 second: ${U}`),U&&U.stack&&console.warn(`stack trace: ${U.stack}`),(0,k.onUnexpectedError)(N))})},1e3)}),process.on("rejectionHandled",N=>{const G=_.indexOf(N);G>=0&&_.splice(G,1)}),process.on("uncaughtException",function(N){(0,k.onUnexpectedError)(N)});let w=0;setInterval(function(){try{process.kill(b.parentPid,0),w=0}catch(N){N&&N.code==="EPERM"?(w++,w>=3&&a(`parent process ${b.parentPid} does not exist anymore (3 x EPERM): ${N.message} (code: ${N.code}) (errno: ${N.errno})`)):a(`parent process ${b.parentPid} does not exist anymore: ${N.message} (code: ${N.code}) (errno: ${N.errno})`)}},1e3);let F;try{F=J.__$__nodeRequire("native-watchdog"),F.start(b.parentPid)}catch(N){(0,k.onUnexpectedError)(N)}i.send((0,T.createMessageOfType)(0)),h({protocol:i,initData:b})});i.send((0,T.createMessageOfType)(1))})}async function r(){I.mark("code/extHost/willConnectToRenderer");const i=await t();I.mark("code/extHost/didConnectToRenderer");const h=await o(i);I.mark("code/extHost/didWaitForInitData");const{initData:c}=h;s(!!c.environment.extensionTestsLocationURI),c.environment.useHostProxy=P.useHostProxy!==void 0?P.useHostProxy!=="false":void 0,c.environment.skipWorkspaceStorageLock=(0,S.boolean)(P.skipWorkspaceStorageLock,!1);const d=new class{exit(_){E(_)}exists(_){return f.Promises.exists(_)}realpath(_){return(0,l.realpath)(_)}};let b=null;if(c.remote.authority&&P.uriTransformerPath)try{const _=J.__$__nodeRequire(P.uriTransformerPath)(c.remote.authority);b=new u.URITransformer(_)}catch(g){console.error(g)}const y=new n.ExtensionHostMain(h.protocol,c,d,b);a=g=>y.terminate(g)}e.startExtensionHostProcess=r}),define(me[303],ge([0,1,290]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.startExtensionHostProcess)().catch(L=>console.log(L))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/34861b8c8aa76b517f203743ad5b5d72ef5fcd81/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
